""" Cisco_IOS_XR_mpls_te_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR mpls\-te package operational data.

This module contains definitions
for the following management objects\:
  mpls\-te\: MPLS Traffic Engineering operational data
  mpls\-lcac\-standby\: mpls lcac standby
  mpls\-lcac\: mpls lcac
  mpls\-pce\: mpls pce
  mpls\-pce\-stdby\: mpls pce stdby
  mpls\-tp\: mpls tp
  mpls\-te\-standby\: mpls te standby

Copyright (c) 2013\-2018 by Cisco Systems, Inc.
All rights reserved.

"""
import sys
from collections import OrderedDict

from ydk.types import Entity as _Entity_
from ydk.types import EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YError, YModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error



class AdmissionPolicy(Enum):
    """
    AdmissionPolicy (Enum Class)

    Deprecated

    .. data:: reject_all = 0

    	Deprecated

    .. data:: allow_all = 1

    	Deprecated

    .. data:: reject_huge = 2

    	Deprecated

    .. data:: allow_if_room = 3

    	Deprecated

    """

    reject_all = Enum.YLeaf(0, "reject-all")

    allow_all = Enum.YLeaf(1, "allow-all")

    reject_huge = Enum.YLeaf(2, "reject-huge")

    allow_if_room = Enum.YLeaf(3, "allow-if-room")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['AdmissionPolicy']


class AutoBackupProtection(Enum):
    """
    AutoBackupProtection (Enum Class)

    Auto backup protection

    .. data:: protection_none = 0

    	No Autobackup Protection

    .. data:: protection_next_hop = 1

    	NHOP Autobackup Protection

    .. data:: protection_next_next_hop = 2

    	NNHOP Autobackup Protection

    """

    protection_none = Enum.YLeaf(0, "protection-none")

    protection_next_hop = Enum.YLeaf(1, "protection-next-hop")

    protection_next_next_hop = Enum.YLeaf(2, "protection-next-next-hop")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['AutoBackupProtection']


class AutoBackupSrlgMode(Enum):
    """
    AutoBackupSrlgMode (Enum Class)

    Auto backup srlg mode

    .. data:: srlg_not_set = 0

    	Autobackup SRLG type not set

    .. data:: srlg_strict = 1

    	Autobackup SRLG Strict

    .. data:: srlg_preferred = 2

    	Autobackup SRLG Preferred

    .. data:: srlg_weighted = 3

    	Autobackup Weighted SRLG

    """

    srlg_not_set = Enum.YLeaf(0, "srlg-not-set")

    srlg_strict = Enum.YLeaf(1, "srlg-strict")

    srlg_preferred = Enum.YLeaf(2, "srlg-preferred")

    srlg_weighted = Enum.YLeaf(3, "srlg-weighted")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['AutoBackupSrlgMode']


class BandwidthAccountingCollection(Enum):
    """
    BandwidthAccountingCollection (Enum Class)

    Types of bandwidth accounting collection

    .. data:: rsvp_te = 0

    	RSVP TE

    .. data:: segment_routing = 1

    	Segment Routing

    """

    rsvp_te = Enum.YLeaf(0, "rsvp-te")

    segment_routing = Enum.YLeaf(1, "segment-routing")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['BandwidthAccountingCollection']


class BandwidthStateEnum(Enum):
    """
    BandwidthStateEnum (Enum Class)

    Types of bandwidth states

    .. data:: bandwidth_held = 0

    	Bandwidth is held, is not guaranteed when it is

    	time to reserve

    .. data:: bandwidth_reserved = 1

    	Bandwidth is reserved and can be used for

    	forwarding

    .. data:: bandwidth_unknown = 2

    	Bandwidth is unknown

    """

    bandwidth_held = Enum.YLeaf(0, "bandwidth-held")

    bandwidth_reserved = Enum.YLeaf(1, "bandwidth-reserved")

    bandwidth_unknown = Enum.YLeaf(2, "bandwidth-unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['BandwidthStateEnum']


class BandwidthTypeEnum(Enum):
    """
    BandwidthTypeEnum (Enum Class)

    Types of bandwidth pools

    .. data:: pool0 = 0

    	Bandwidth from the pool0

    .. data:: pool1 = 1

    	Pool1 bandwidth

    .. data:: unknown = 2

    	Unknown Bandwidth

    """

    pool0 = Enum.YLeaf(0, "pool0")

    pool1 = Enum.YLeaf(1, "pool1")

    unknown = Enum.YLeaf(2, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['BandwidthTypeEnum']


class BandwidthUnitEnum(Enum):
    """
    BandwidthUnitEnum (Enum Class)

    Types of bandwidth units

    .. data:: kilo_bits_per_second = 0

    	kilobits per second

    .. data:: kilo_bytes_per_second = 1

    	kilobytes per second

    """

    kilo_bits_per_second = Enum.YLeaf(0, "kilo-bits-per-second")

    kilo_bytes_per_second = Enum.YLeaf(1, "kilo-bytes-per-second")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['BandwidthUnitEnum']


class Ctype(Enum):
    """
    Ctype (Enum Class)

    Ctype

    .. data:: ctype_null = 0

    	CTYPE NULL

    .. data:: ctype_ipv4 = 1

    	CTYPE IPV4

    .. data:: ctype_ipv4_p2p_tunnel = 7

    	CTYPE IPV4 P2P TUNNEL

    .. data:: ctype_ipv6_p2p_tunnel = 8

    	CTYPE IPV6 P2P TUNNEL

    .. data:: ctype_ipv4_uni = 9

    	CTYPE IPV4 UNI

    .. data:: ctype_ipv4_p2mp_tunnel = 13

    	CTYPE IPV4 P2MP TUNNEL

    .. data:: ctype_ipv6_p2mp_tunnel = 14

    	CTYPE IPV6 P2MP TUNNEL

    """

    ctype_null = Enum.YLeaf(0, "ctype-null")

    ctype_ipv4 = Enum.YLeaf(1, "ctype-ipv4")

    ctype_ipv4_p2p_tunnel = Enum.YLeaf(7, "ctype-ipv4-p2p-tunnel")

    ctype_ipv6_p2p_tunnel = Enum.YLeaf(8, "ctype-ipv6-p2p-tunnel")

    ctype_ipv4_uni = Enum.YLeaf(9, "ctype-ipv4-uni")

    ctype_ipv4_p2mp_tunnel = Enum.YLeaf(13, "ctype-ipv4-p2mp-tunnel")

    ctype_ipv6_p2mp_tunnel = Enum.YLeaf(14, "ctype-ipv6-p2mp-tunnel")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['Ctype']


class FlexLspLockoutOrigination(Enum):
    """
    FlexLspLockoutOrigination (Enum Class)

    TE Flex LSP Lockout Origination

    .. data:: lockout_origination_none = 0

    	Flex LSP Lockout Origination None

    .. data:: lockout_origination_local = 1

    	Flex LSP Lockout Originated From Local

    .. data:: lockout_origination_remote = 2

    	Flex LSP Lockout Originated From Remote

    """

    lockout_origination_none = Enum.YLeaf(0, "lockout-origination-none")

    lockout_origination_local = Enum.YLeaf(1, "lockout-origination-local")

    lockout_origination_remote = Enum.YLeaf(2, "lockout-origination-remote")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['FlexLspLockoutOrigination']


class FloodingTrigger(Enum):
    """
    FloodingTrigger (Enum Class)

    Types of flooding triggers

    .. data:: flooding_reason_unknown = 0

    	Not known what caused flooding

    .. data:: link_up = 1

    	TE link came Up

    .. data:: link_down = 2

    	TE link went Down

    .. data:: threshold_up = 3

    	Up threshold crossed in pool0

    .. data:: threshold_down = 4

    	Down threshold crossed in pool0

    .. data:: threshold_up_pool1 = 5

    	Up threshold crossed in pool1

    .. data:: threshold_down_pool1 = 6

    	Down threshold crossed in pool1

    .. data:: timer_expired = 7

    	Periodic timer expired

    .. data:: bandwidth_change = 8

    	Link BW changed

    .. data:: user = 9

    	User triggered flooding

    .. data:: rsvp_timeout = 10

    	RSVP timed out

    .. data:: rsvp_reconnect = 11

    	RSVP reconnected

    .. data:: te_exited = 12

    	TE-control process exited

    .. data:: srlg_change = 13

    	Link SRLG changed

    .. data:: hw_oor_green = 14

    	HW resources are green

    .. data:: hw_oor_yellow = 15

    	HW resources are yellow

    .. data:: hw_oor_red = 16

    	HW resources are red

    .. data:: hw_oor_recovery_duration_expired = 17

    	HW Resources are back to normal and the

    	transition period is over

    .. data:: lsp_oor_green = 18

    	LSP resources are green

    .. data:: lsp_oor_yellow = 19

    	LSP resources are yellow

    .. data:: lsp_oor_red = 20

    	LSP resources are red

    .. data:: lsp_oor_recovery_duration_expired = 21

    	LSP resources are back to normal and the

    	transition period is over

    .. data:: max_res_bandwidth_threshold_up = 22

    	Max reservable bandwidth up threshold crossed

    .. data:: max_res_bandwidth_threshold_down = 23

    	Max reservable bandwidth down threshold crossed

    """

    flooding_reason_unknown = Enum.YLeaf(0, "flooding-reason-unknown")

    link_up = Enum.YLeaf(1, "link-up")

    link_down = Enum.YLeaf(2, "link-down")

    threshold_up = Enum.YLeaf(3, "threshold-up")

    threshold_down = Enum.YLeaf(4, "threshold-down")

    threshold_up_pool1 = Enum.YLeaf(5, "threshold-up-pool1")

    threshold_down_pool1 = Enum.YLeaf(6, "threshold-down-pool1")

    timer_expired = Enum.YLeaf(7, "timer-expired")

    bandwidth_change = Enum.YLeaf(8, "bandwidth-change")

    user = Enum.YLeaf(9, "user")

    rsvp_timeout = Enum.YLeaf(10, "rsvp-timeout")

    rsvp_reconnect = Enum.YLeaf(11, "rsvp-reconnect")

    te_exited = Enum.YLeaf(12, "te-exited")

    srlg_change = Enum.YLeaf(13, "srlg-change")

    hw_oor_green = Enum.YLeaf(14, "hw-oor-green")

    hw_oor_yellow = Enum.YLeaf(15, "hw-oor-yellow")

    hw_oor_red = Enum.YLeaf(16, "hw-oor-red")

    hw_oor_recovery_duration_expired = Enum.YLeaf(17, "hw-oor-recovery-duration-expired")

    lsp_oor_green = Enum.YLeaf(18, "lsp-oor-green")

    lsp_oor_yellow = Enum.YLeaf(19, "lsp-oor-yellow")

    lsp_oor_red = Enum.YLeaf(20, "lsp-oor-red")

    lsp_oor_recovery_duration_expired = Enum.YLeaf(21, "lsp-oor-recovery-duration-expired")

    max_res_bandwidth_threshold_up = Enum.YLeaf(22, "max-res-bandwidth-threshold-up")

    max_res_bandwidth_threshold_down = Enum.YLeaf(23, "max-res-bandwidth-threshold-down")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['FloodingTrigger']


class GmplsUniMgmtDwdmCs(Enum):
    """
    GmplsUniMgmtDwdmCs (Enum Class)

    GMPLS\-UNI DWDM channel spacings

    .. data:: not_set = 0

    	Not Set

    .. data:: dwdm100g_hz = 1

    	100GHz

    .. data:: dwdm50g_hz = 2

    	50GHz

    .. data:: dwdm25g_hz = 3

    	25GHz

    .. data:: dwdm12g_hz = 4

    	12.5GHz

    .. data:: dwdm6g_hz = 5

    	6.25GHz

    """

    not_set = Enum.YLeaf(0, "not-set")

    dwdm100g_hz = Enum.YLeaf(1, "dwdm100g-hz")

    dwdm50g_hz = Enum.YLeaf(2, "dwdm50g-hz")

    dwdm25g_hz = Enum.YLeaf(3, "dwdm25g-hz")

    dwdm12g_hz = Enum.YLeaf(4, "dwdm12g-hz")

    dwdm6g_hz = Enum.YLeaf(5, "dwdm6g-hz")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['GmplsUniMgmtDwdmCs']


class GmplsUniMgmtWdmGrid(Enum):
    """
    GmplsUniMgmtWdmGrid (Enum Class)

    GMPLS\-UNI WDM grid

    .. data:: not_set = 0

    	Not Set

    .. data:: dwdm = 1

    	DWDM

    .. data:: cwdm = 2

    	CWDM

    """

    not_set = Enum.YLeaf(0, "not-set")

    dwdm = Enum.YLeaf(1, "dwdm")

    cwdm = Enum.YLeaf(2, "cwdm")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['GmplsUniMgmtWdmGrid']


class HwOorState(Enum):
    """
    HwOorState (Enum Class)

    NPU resources states

    .. data:: oor_green = 0

    	NPU resources are in normal state

    .. data:: oor_yellow = 1

    	NPU resources are in minor state

    .. data:: oor_red = 2

    	NPU resources are in Major state

    """

    oor_green = Enum.YLeaf(0, "oor-green")

    oor_yellow = Enum.YLeaf(1, "oor-yellow")

    oor_red = Enum.YLeaf(2, "oor-red")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['HwOorState']


class IgpOspfAreaFormat(Enum):
    """
    IgpOspfAreaFormat (Enum Class)

    OSPF area format

    .. data:: igp_area_format_number = 0

    	Numbered area format

    .. data:: igp_area_format_ip_addr = 1

    	IP address area format

    """

    igp_area_format_number = Enum.YLeaf(0, "igp-area-format-number")

    igp_area_format_ip_addr = Enum.YLeaf(1, "igp-area-format-ip-addr")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpOspfAreaFormat']


class IgpProtocol(Enum):
    """
    IgpProtocol (Enum Class)

    IGP type

    .. data:: none = 0

    	No IGP protocol specified

    .. data:: isis = 1

    	IS IS

    .. data:: ospf = 2

    	OSPF

    """

    none = Enum.YLeaf(0, "none")

    isis = Enum.YLeaf(1, "isis")

    ospf = Enum.YLeaf(2, "ospf")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpProtocol']


class IgpSubnet(Enum):
    """
    IgpSubnet (Enum Class)

    Subnet type

    .. data:: igp_subnet_type_none = 0

    	No subnet type specified

    .. data:: p2p = 1

    	Point-to-point subnet

    .. data:: broadcast = 2

    	Broadcast subnet

    .. data:: non_broadcast_multiaccess = 3

    	Non-broadcast multi-access subnet

    .. data:: p2mp = 4

    	Point-to-multipoint subnet

    .. data:: loopback = 5

    	Loopback subnet

    """

    igp_subnet_type_none = Enum.YLeaf(0, "igp-subnet-type-none")

    p2p = Enum.YLeaf(1, "p2p")

    broadcast = Enum.YLeaf(2, "broadcast")

    non_broadcast_multiaccess = Enum.YLeaf(3, "non-broadcast-multiaccess")

    p2mp = Enum.YLeaf(4, "p2mp")

    loopback = Enum.YLeaf(5, "loopback")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpSubnet']


class IgpteAaMetricMode(Enum):
    """
    IgpteAaMetricMode (Enum Class)

    Autoroute\-announce metric type

    .. data:: metric_mode_none = 0

    	No metric type specified

    .. data:: relative = 1

    	Relative metric

    .. data:: absolute = 2

    	Absolute metric

    .. data:: constant = 3

    	Constant metric

    """

    metric_mode_none = Enum.YLeaf(0, "metric-mode-none")

    relative = Enum.YLeaf(1, "relative")

    absolute = Enum.YLeaf(2, "absolute")

    constant = Enum.YLeaf(3, "constant")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpteAaMetricMode']


class IgpteLibBwModel(Enum):
    """
    IgpteLibBwModel (Enum Class)

    Bandwidth model

    .. data:: rdm = 0

    	Russian Dolls Model

    .. data:: mam = 1

    	Maximum Allocation Model

    .. data:: not_set = 2

    	No model set

    """

    rdm = Enum.YLeaf(0, "rdm")

    mam = Enum.YLeaf(1, "mam")

    not_set = Enum.YLeaf(2, "not-set")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpteLibBwModel']


class IgpteLinkEncodingProtocol(Enum):
    """
    IgpteLinkEncodingProtocol (Enum Class)

    Link protocol switching capabilities

    .. data:: link_encoding_protocol_none = 0

    	None

    .. data:: link_encoding_protocol_p_acket = 1

    	Packet

    .. data:: link_encoding_protocol_ethernet = 2

    	Ethernet

    .. data:: link_encoding_protocol_ansi_etsi_pdh = 3

    	ANSI ETSI PDH

    .. data:: link_encoding_protocol_reserved4 = 4

    	Reserved

    .. data:: link_encoding_protocol_sdh_sonet = 5

    	SDH SONET

    .. data:: link_encoding_protocol_reserved6 = 6

    	Reserved

    .. data:: link_encoding_protocol_digital_wrapper = 7

    	Digital Wrapper

    .. data:: link_encoding_protocol_lambda_photonic = 8

    	Lambda Photonic

    .. data:: link_encoding_protocol_fiber = 9

    	Fiber

    .. data:: link_encoding_protocol_reserved10 = 10

    	Reserved

    .. data:: link_encoding_protocol_fiber_channel = 11

    	Fiber Channel

    .. data:: link_encoding_protocol_g709otn = 12

    	G709 OTN

    .. data:: link_encoding_protocol_passive_internal = 200

    	Derived from ingress node

    """

    link_encoding_protocol_none = Enum.YLeaf(0, "link-encoding-protocol-none")

    link_encoding_protocol_p_acket = Enum.YLeaf(1, "link-encoding-protocol-p-acket")

    link_encoding_protocol_ethernet = Enum.YLeaf(2, "link-encoding-protocol-ethernet")

    link_encoding_protocol_ansi_etsi_pdh = Enum.YLeaf(3, "link-encoding-protocol-ansi-etsi-pdh")

    link_encoding_protocol_reserved4 = Enum.YLeaf(4, "link-encoding-protocol-reserved4")

    link_encoding_protocol_sdh_sonet = Enum.YLeaf(5, "link-encoding-protocol-sdh-sonet")

    link_encoding_protocol_reserved6 = Enum.YLeaf(6, "link-encoding-protocol-reserved6")

    link_encoding_protocol_digital_wrapper = Enum.YLeaf(7, "link-encoding-protocol-digital-wrapper")

    link_encoding_protocol_lambda_photonic = Enum.YLeaf(8, "link-encoding-protocol-lambda-photonic")

    link_encoding_protocol_fiber = Enum.YLeaf(9, "link-encoding-protocol-fiber")

    link_encoding_protocol_reserved10 = Enum.YLeaf(10, "link-encoding-protocol-reserved10")

    link_encoding_protocol_fiber_channel = Enum.YLeaf(11, "link-encoding-protocol-fiber-channel")

    link_encoding_protocol_g709otn = Enum.YLeaf(12, "link-encoding-protocol-g709otn")

    link_encoding_protocol_passive_internal = Enum.YLeaf(200, "link-encoding-protocol-passive-internal")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpteLinkEncodingProtocol']


class IgpteLinkSwitchCapability(Enum):
    """
    IgpteLinkSwitchCapability (Enum Class)

    Link protocol switching capabilities

    .. data:: link_switching_capability_none = 0

    	None

    .. data:: link_switching_capability_psc1 = 1

    	Packet (level 1)

    .. data:: link_switching_capability_psc2 = 2

    	Packet (level 2)

    .. data:: link_switching_capability_psc3 = 3

    	Packet (level 3)

    .. data:: link_switching_capability_psc4 = 4

    	Packet (level 4)

    .. data:: link_switching_capability_l2sc = 51

    	Layer 2

    .. data:: link_switching_capability_tdm = 100

    	TDM

    .. data:: link_switching_capability_otn_tdm = 110

    	OTN TDM

    .. data:: link_switching_capability_lsc = 150

    	LSC

    .. data:: link_switching_capability_fsc = 200

    	FSC

    """

    link_switching_capability_none = Enum.YLeaf(0, "link-switching-capability-none")

    link_switching_capability_psc1 = Enum.YLeaf(1, "link-switching-capability-psc1")

    link_switching_capability_psc2 = Enum.YLeaf(2, "link-switching-capability-psc2")

    link_switching_capability_psc3 = Enum.YLeaf(3, "link-switching-capability-psc3")

    link_switching_capability_psc4 = Enum.YLeaf(4, "link-switching-capability-psc4")

    link_switching_capability_l2sc = Enum.YLeaf(51, "link-switching-capability-l2sc")

    link_switching_capability_tdm = Enum.YLeaf(100, "link-switching-capability-tdm")

    link_switching_capability_otn_tdm = Enum.YLeaf(110, "link-switching-capability-otn-tdm")

    link_switching_capability_lsc = Enum.YLeaf(150, "link-switching-capability-lsc")

    link_switching_capability_fsc = Enum.YLeaf(200, "link-switching-capability-fsc")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['IgpteLinkSwitchCapability']


class ImStateEnum(Enum):
    """
    ImStateEnum (Enum Class)

    Im state enum

    .. data:: im_state_not_ready = 0

    	im state not ready

    .. data:: im_state_admin_down = 1

    	im state admin down

    .. data:: im_state_down = 2

    	im state down

    .. data:: im_state_up = 3

    	im state up

    .. data:: im_state_shutdown = 4

    	im state shutdown

    .. data:: im_state_err_disable = 5

    	im state err disable

    .. data:: im_state_down_immediate = 6

    	im state down immediate

    .. data:: im_state_down_immediate_admin = 7

    	im state down immediate admin

    .. data:: im_state_down_graceful = 8

    	im state down graceful

    .. data:: im_state_begin_shutdown = 9

    	im state begin shutdown

    .. data:: im_state_end_shutdown = 10

    	im state end shutdown

    .. data:: im_state_begin_error_disable = 11

    	im state begin error disable

    .. data:: im_state_end_error_disable = 12

    	im state end error disable

    .. data:: im_state_begin_down_graceful = 13

    	im state begin down graceful

    .. data:: im_state_reset = 14

    	im state reset

    .. data:: im_state_operational = 15

    	im state operational

    .. data:: im_state_not_operational = 16

    	im state not operational

    .. data:: im_state_unknown = 17

    	im state unknown

    .. data:: im_state_last = 18

    	im state last

    """

    im_state_not_ready = Enum.YLeaf(0, "im-state-not-ready")

    im_state_admin_down = Enum.YLeaf(1, "im-state-admin-down")

    im_state_down = Enum.YLeaf(2, "im-state-down")

    im_state_up = Enum.YLeaf(3, "im-state-up")

    im_state_shutdown = Enum.YLeaf(4, "im-state-shutdown")

    im_state_err_disable = Enum.YLeaf(5, "im-state-err-disable")

    im_state_down_immediate = Enum.YLeaf(6, "im-state-down-immediate")

    im_state_down_immediate_admin = Enum.YLeaf(7, "im-state-down-immediate-admin")

    im_state_down_graceful = Enum.YLeaf(8, "im-state-down-graceful")

    im_state_begin_shutdown = Enum.YLeaf(9, "im-state-begin-shutdown")

    im_state_end_shutdown = Enum.YLeaf(10, "im-state-end-shutdown")

    im_state_begin_error_disable = Enum.YLeaf(11, "im-state-begin-error-disable")

    im_state_end_error_disable = Enum.YLeaf(12, "im-state-end-error-disable")

    im_state_begin_down_graceful = Enum.YLeaf(13, "im-state-begin-down-graceful")

    im_state_reset = Enum.YLeaf(14, "im-state-reset")

    im_state_operational = Enum.YLeaf(15, "im-state-operational")

    im_state_not_operational = Enum.YLeaf(16, "im-state-not-operational")

    im_state_unknown = Enum.YLeaf(17, "im-state-unknown")

    im_state_last = Enum.YLeaf(18, "im-state-last")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['ImStateEnum']


class LinkDirectionEnum(Enum):
    """
    LinkDirectionEnum (Enum Class)

    Link direction types

    .. data:: link_direction_up_stream = 0

    	Upstream direction, Tail to Head

    .. data:: link_direction_down_stream = 1

    	Upstream direction, Head to Tail

    .. data:: link_direction_unknown = 2

    	Unknown direction

    """

    link_direction_up_stream = Enum.YLeaf(0, "link-direction-up-stream")

    link_direction_down_stream = Enum.YLeaf(1, "link-direction-down-stream")

    link_direction_unknown = Enum.YLeaf(2, "link-direction-unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['LinkDirectionEnum']


class LspOorState(Enum):
    """
    LspOorState (Enum Class)

    LSP OOR states

    .. data:: lsp_oor_green = 0

    	LSP numbers are in normal state

    .. data:: lsp_oor_yellow = 1

    	LSP numbers exceed the minor threshold

    .. data:: lsp_oor_red = 2

    	LSP numbers exceed the major threshold

    """

    lsp_oor_green = Enum.YLeaf(0, "lsp-oor-green")

    lsp_oor_yellow = Enum.YLeaf(1, "lsp-oor-yellow")

    lsp_oor_red = Enum.YLeaf(2, "lsp-oor-red")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['LspOorState']


class MplsLibC(Enum):
    """
    MplsLibC (Enum Class)

    Mpls lib c

    .. data:: mpls_lib_c_type_null = 0

    	NULL Ctype

    .. data:: mpls_lib_c_type_ipv4 = 1

    	IPv4 UDP

    .. data:: mpls_lib_c_type_ipv4_p2p_tunnel = 7

    	IPv4 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv6_p2p_tunnel = 8

    	IPv6 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv4_uni = 9

    	IPv4 unicast

    .. data:: mpls_lib_c_type_ipv4_p2mp_tunnel = 13

    	IPv4 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv6_p2mp_tunnel = 14

    	IPv6 point-to-point TE tunnel

    .. data:: mpls_lib_c_type_ipv4_tp_tunnel = 15

    	IPv4 transport protocol tunnel

    .. data:: mpls_lib_c_type_ipv6_tp_tunnel = 16

    	IPv6 transport protocol tunnel

    .. data:: mpls_lib_c_type_p2p_binding_label = 17

    	P2P transport tunnel binding label

    """

    mpls_lib_c_type_null = Enum.YLeaf(0, "mpls-lib-c-type-null")

    mpls_lib_c_type_ipv4 = Enum.YLeaf(1, "mpls-lib-c-type-ipv4")

    mpls_lib_c_type_ipv4_p2p_tunnel = Enum.YLeaf(7, "mpls-lib-c-type-ipv4-p2p-tunnel")

    mpls_lib_c_type_ipv6_p2p_tunnel = Enum.YLeaf(8, "mpls-lib-c-type-ipv6-p2p-tunnel")

    mpls_lib_c_type_ipv4_uni = Enum.YLeaf(9, "mpls-lib-c-type-ipv4-uni")

    mpls_lib_c_type_ipv4_p2mp_tunnel = Enum.YLeaf(13, "mpls-lib-c-type-ipv4-p2mp-tunnel")

    mpls_lib_c_type_ipv6_p2mp_tunnel = Enum.YLeaf(14, "mpls-lib-c-type-ipv6-p2mp-tunnel")

    mpls_lib_c_type_ipv4_tp_tunnel = Enum.YLeaf(15, "mpls-lib-c-type-ipv4-tp-tunnel")

    mpls_lib_c_type_ipv6_tp_tunnel = Enum.YLeaf(16, "mpls-lib-c-type-ipv6-tp-tunnel")

    mpls_lib_c_type_p2p_binding_label = Enum.YLeaf(17, "mpls-lib-c-type-p2p-binding-label")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsLibC']


class MplsMteTunnelFailReason(Enum):
    """
    MplsMteTunnelFailReason (Enum Class)

    Reason for tunnel being down

    .. data:: mtunnel_fail_reason_unapplicable = 0

    	None of the reasons below is valid

    .. data:: mtunnel_fail_reason_shutdown = 1

    	Tunnel interface is shutdown

    .. data:: mtunnel_fail_reason_no_destination = 2

    	No destination is configured

    .. data:: mtunnel_fail_reason_no_path_option = 3

    	No path option is configured

    .. data:: mtunnel_fail_reason_no_source = 4

    	No ip source address is configured

    .. data:: mtunnel_fail_reason_collaborator_disc = 5

    	Collaborator not connected

    .. data:: mtunnel_fail_reason_unmatched_class_type_priority = 6

    	The class type and priority do not match any of

    	the TE-classes

    .. data:: mtunnel_fail_reason_invalid_bidir_cfg = 7

    	Configured bidirectional, incomplete switching

    	capability config

    .. data:: mtunnel_fail_reason_po_switchover = 8

    	Manual path-option switchover failed due to

    	destination(s) down

    .. data:: mtunnel_fail_reason_no_tunnel_id = 9

    	No tunnel-id is configured

    .. data:: mtunnel_fail_reason_no_link = 10

    	Tunnel's egress link doesn't exist

    .. data:: mtunnel_fail_reason_link_shutdown = 11

    	Tunnel's egress link is shut down

    .. data:: mtunnel_fail_reason_link_lmp_down = 12

    	LMP is down on the tunnel's egress link

    .. data:: mtunnel_fail_reason_source_destination_same = 13

    	Tunnel source and destination addresses are the

    	same

    .. data:: mtunnel_fail_reason_otn_no_odu_level = 14

    	OTN tunnel does not have odu-level set

    .. data:: mtunnel_fail_reason_bidir_assoc_id_missing = 15

    	Bidirectional is configured without Association

    	ID

    .. data:: mtunnel_fail_reason_bfdgal_on_unidirectional = 16

    	BFD GAL mode is supported on bidirectional

    	tunnels only

    .. data:: mtunnel_fail_reason_destination_invalid = 17

    	Termination is supported with unnumbered

    	destination only

    .. data:: mtunnel_fail_reason_termination_bandwidth_mismatch = 18

    	Termination bandwidth should match signalled

    	bandwidth

    .. data:: mtunnel_fail_reason_termination_has_protection = 19

    	Termination supports only working path-option

    .. data:: mtunnel_fail_reason_termination_has_invalid_src_dest_ifindex = 20

    	Termination case must have source and

    	destination valid ifindex

    .. data:: mtunnel_fail_reason_termination_has_invalid_payload_type = 21

    	Termination payload type has to be valid for

    	configured bandwidth

    """

    mtunnel_fail_reason_unapplicable = Enum.YLeaf(0, "mtunnel-fail-reason-unapplicable")

    mtunnel_fail_reason_shutdown = Enum.YLeaf(1, "mtunnel-fail-reason-shutdown")

    mtunnel_fail_reason_no_destination = Enum.YLeaf(2, "mtunnel-fail-reason-no-destination")

    mtunnel_fail_reason_no_path_option = Enum.YLeaf(3, "mtunnel-fail-reason-no-path-option")

    mtunnel_fail_reason_no_source = Enum.YLeaf(4, "mtunnel-fail-reason-no-source")

    mtunnel_fail_reason_collaborator_disc = Enum.YLeaf(5, "mtunnel-fail-reason-collaborator-disc")

    mtunnel_fail_reason_unmatched_class_type_priority = Enum.YLeaf(6, "mtunnel-fail-reason-unmatched-class-type-priority")

    mtunnel_fail_reason_invalid_bidir_cfg = Enum.YLeaf(7, "mtunnel-fail-reason-invalid-bidir-cfg")

    mtunnel_fail_reason_po_switchover = Enum.YLeaf(8, "mtunnel-fail-reason-po-switchover")

    mtunnel_fail_reason_no_tunnel_id = Enum.YLeaf(9, "mtunnel-fail-reason-no-tunnel-id")

    mtunnel_fail_reason_no_link = Enum.YLeaf(10, "mtunnel-fail-reason-no-link")

    mtunnel_fail_reason_link_shutdown = Enum.YLeaf(11, "mtunnel-fail-reason-link-shutdown")

    mtunnel_fail_reason_link_lmp_down = Enum.YLeaf(12, "mtunnel-fail-reason-link-lmp-down")

    mtunnel_fail_reason_source_destination_same = Enum.YLeaf(13, "mtunnel-fail-reason-source-destination-same")

    mtunnel_fail_reason_otn_no_odu_level = Enum.YLeaf(14, "mtunnel-fail-reason-otn-no-odu-level")

    mtunnel_fail_reason_bidir_assoc_id_missing = Enum.YLeaf(15, "mtunnel-fail-reason-bidir-assoc-id-missing")

    mtunnel_fail_reason_bfdgal_on_unidirectional = Enum.YLeaf(16, "mtunnel-fail-reason-bfdgal-on-unidirectional")

    mtunnel_fail_reason_destination_invalid = Enum.YLeaf(17, "mtunnel-fail-reason-destination-invalid")

    mtunnel_fail_reason_termination_bandwidth_mismatch = Enum.YLeaf(18, "mtunnel-fail-reason-termination-bandwidth-mismatch")

    mtunnel_fail_reason_termination_has_protection = Enum.YLeaf(19, "mtunnel-fail-reason-termination-has-protection")

    mtunnel_fail_reason_termination_has_invalid_src_dest_ifindex = Enum.YLeaf(20, "mtunnel-fail-reason-termination-has-invalid-src-dest-ifindex")

    mtunnel_fail_reason_termination_has_invalid_payload_type = Enum.YLeaf(21, "mtunnel-fail-reason-termination-has-invalid-payload-type")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsMteTunnelFailReason']


class MplsTeAfi(Enum):
    """
    MplsTeAfi (Enum Class)

    Mpls te afi

    .. data:: ipv4_unicast = 0

    	MPLS TE IPv4 unicast

    .. data:: ipv4_multicast = 1

    	MPLS TE IPv4 multicast

    .. data:: ipv6_unicast = 2

    	MPLS TE IPv6 unicast

    .. data:: ipv6_multicast = 3

    	MPLS TE IPv6 multicast

    """

    ipv4_unicast = Enum.YLeaf(0, "ipv4-unicast")

    ipv4_multicast = Enum.YLeaf(1, "ipv4-multicast")

    ipv6_unicast = Enum.YLeaf(2, "ipv6-unicast")

    ipv6_multicast = Enum.YLeaf(3, "ipv6-multicast")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeAfi']


class MplsTeAttrSet(Enum):
    """
    MplsTeAttrSet (Enum Class)

    Mpls te attr set

    .. data:: not_used = 0

    	Not used

    .. data:: static = 1

    	Static

    .. data:: lsp = 2

    	LSP

    .. data:: unassigned = 3

    	Unassigned

    .. data:: auto_backup = 4

    	Auto backup

    .. data:: auto_mesh = 5

    	Auto mesh

    .. data:: xro = 6

    	XRO

    .. data:: p2mp_te = 7

    	P2MP TE

    .. data:: otn_pp = 8

    	OTN Path Protection

    .. data:: p2p_te = 9

    	P2P TE

    """

    not_used = Enum.YLeaf(0, "not-used")

    static = Enum.YLeaf(1, "static")

    lsp = Enum.YLeaf(2, "lsp")

    unassigned = Enum.YLeaf(3, "unassigned")

    auto_backup = Enum.YLeaf(4, "auto-backup")

    auto_mesh = Enum.YLeaf(5, "auto-mesh")

    xro = Enum.YLeaf(6, "xro")

    p2mp_te = Enum.YLeaf(7, "p2mp-te")

    otn_pp = Enum.YLeaf(8, "otn-pp")

    p2p_te = Enum.YLeaf(9, "p2p-te")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeAttrSet']


class MplsTeBackup(Enum):
    """
    MplsTeBackup (Enum Class)

    FRR backup tunnel type

    .. data:: backup_static = 0

    	Backup type is static

    .. data:: backup_auto = 1

    	Backup type is auto-tunnel

    """

    backup_static = Enum.YLeaf(0, "backup-static")

    backup_auto = Enum.YLeaf(1, "backup-auto")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBackup']


class MplsTeBackupStatus(Enum):
    """
    MplsTeBackupStatus (Enum Class)

    FRR backup status

    .. data:: backup_none = 0

    	Backup not found

    .. data:: backup_unused = 1

    	Backup status undefined

    .. data:: backup_next_next_hop = 2

    	Backup is next next hop safe (node protection)

    .. data:: backup_next_hop = 3

    	Backup is next hop safe (link protection)

    .. data:: backup_next_next_hop_srlg = 4

    	Backup is next next hop and SRLG safe (node

    	protection)

    .. data:: backup_next_hop_srlg = 5

    	Backup is next hop and SRLG safe (link

    	protection)

    """

    backup_none = Enum.YLeaf(0, "backup-none")

    backup_unused = Enum.YLeaf(1, "backup-unused")

    backup_next_next_hop = Enum.YLeaf(2, "backup-next-next-hop")

    backup_next_hop = Enum.YLeaf(3, "backup-next-hop")

    backup_next_next_hop_srlg = Enum.YLeaf(4, "backup-next-next-hop-srlg")

    backup_next_hop_srlg = Enum.YLeaf(5, "backup-next-hop-srlg")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBackupStatus']


class MplsTeBackupUsage(Enum):
    """
    MplsTeBackupUsage (Enum Class)

    FRR backup tunnel usage status

    .. data:: backup_not_protecting = 0

    	Backup is not protecting any LSP

    .. data:: backup_protecting = 1

    	Backup is protecting at least one LSP

    """

    backup_not_protecting = Enum.YLeaf(0, "backup-not-protecting")

    backup_protecting = Enum.YLeaf(1, "backup-protecting")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBackupUsage']


class MplsTeBfdSessionDownAction1(Enum):
    """
    MplsTeBfdSessionDownAction1 (Enum Class)

    BFD session down action

    .. data:: reopt = 0

    	BFD session down action reoptimization

    .. data:: re_setup = 1

    	BFD session down action tear down and resetup

    """

    reopt = Enum.YLeaf(0, "reopt")

    re_setup = Enum.YLeaf(1, "re-setup")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBfdSessionDownAction1']


class MplsTeBwLimit(Enum):
    """
    MplsTeBwLimit (Enum Class)

    Bandwidth limit type

    .. data:: bandwidth_limited = 0

    	Bandwidth is limited

    .. data:: bandwidth_unlimited = 1

    	Bandwidth is unlimited

    .. data:: bandwidth_none = 2

    	Bandwidth is None

    """

    bandwidth_limited = Enum.YLeaf(0, "bandwidth-limited")

    bandwidth_unlimited = Enum.YLeaf(1, "bandwidth-unlimited")

    bandwidth_none = Enum.YLeaf(2, "bandwidth-none")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBwLimit']


class MplsTeBwPool(Enum):
    """
    MplsTeBwPool (Enum Class)

    Bandwidth pool type

    .. data:: te_bandwidth_pool0 = 0

    	Bandwidth pool type is pool0

    .. data:: te_bandwidth_pool1 = 1

    	Bandwidth pool type is pool1

    .. data:: te_bandwidth_any_pool = 2

    	Bandwidth pool type is any pool

    """

    te_bandwidth_pool0 = Enum.YLeaf(0, "te-bandwidth-pool0")

    te_bandwidth_pool1 = Enum.YLeaf(1, "te-bandwidth-pool1")

    te_bandwidth_any_pool = Enum.YLeaf(2, "te-bandwidth-any-pool")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeBwPool']


class MplsTeDsteClassStatus(Enum):
    """
    MplsTeDsteClassStatus (Enum Class)

    DSTE class status

    .. data:: configured = 0

    	The TE class is explicitely configured

    .. data:: default = 1

    	The TE class is a default

    .. data:: unused = 2

    	The TE class is unused due to a configuration

    	conflict

    """

    configured = Enum.YLeaf(0, "configured")

    default = Enum.YLeaf(1, "default")

    unused = Enum.YLeaf(2, "unused")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeDsteClassStatus']


class MplsTeFrrSharing(Enum):
    """
    MplsTeFrrSharing (Enum Class)

    FRR sharing type

    .. data:: sharing_none = 0

    	No Fate Sharing

    .. data:: sharing_pri_oi_backup_oi_parent = 1

    	Primary Sharing outgoing interface with the

    	Parent of the backup outgoing interface

    .. data:: sharing_pri_oi_parent_backup_oi = 2

    	Primary Sharing Parent of the outgoing

    	interface with the backup outgoing interface

    .. data:: sharing_pri_oi_parent_backup_oi_parent = 3

    	Primary Sharing Parent of the outgoing

    	interface with the Parent of the backup

    	outgoing interface

    """

    sharing_none = Enum.YLeaf(0, "sharing-none")

    sharing_pri_oi_backup_oi_parent = Enum.YLeaf(1, "sharing-pri-oi-backup-oi-parent")

    sharing_pri_oi_parent_backup_oi = Enum.YLeaf(2, "sharing-pri-oi-parent-backup-oi")

    sharing_pri_oi_parent_backup_oi_parent = Enum.YLeaf(3, "sharing-pri-oi-parent-backup-oi-parent")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeFrrSharing']


class MplsTeFrrState(Enum):
    """
    MplsTeFrrState (Enum Class)

    FRR state

    .. data:: frr_inactive = 0

    	FRR state is inactive

    .. data:: frr_active = 1

    	FRR state is active

    .. data:: frr_ready = 2

    	FRR state is ready

    """

    frr_inactive = Enum.YLeaf(0, "frr-inactive")

    frr_active = Enum.YLeaf(1, "frr-active")

    frr_ready = Enum.YLeaf(2, "frr-ready")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeFrrState']


class MplsTeIepHop(Enum):
    """
    MplsTeIepHop (Enum Class)

    Explicit path hop type

    .. data:: iep_hop_type_unknown = 0

    	Unknown IEP hop type

    .. data:: iep_hop_type_strict_next = 1

    	Strict next IEP hop type

    .. data:: iep_hop_type_exclude = 2

    	Exclude IEP hop type

    .. data:: iep_hop_type_exclude_node = 3

    	Exclude Node IEP hop type

    .. data:: iep_hop_type_exclude_srlg = 4

    	Exclude SRLG IEP hop type

    .. data:: iep_hop_type_loose_next = 5

    	Loose next IEP hop type

    .. data:: iep_hop_type_next = 6

    	Next IEP hop type

    .. data:: iep_hop_type_share_srlg = 7

    	Weighted SRLG IEP hop type

    """

    iep_hop_type_unknown = Enum.YLeaf(0, "iep-hop-type-unknown")

    iep_hop_type_strict_next = Enum.YLeaf(1, "iep-hop-type-strict-next")

    iep_hop_type_exclude = Enum.YLeaf(2, "iep-hop-type-exclude")

    iep_hop_type_exclude_node = Enum.YLeaf(3, "iep-hop-type-exclude-node")

    iep_hop_type_exclude_srlg = Enum.YLeaf(4, "iep-hop-type-exclude-srlg")

    iep_hop_type_loose_next = Enum.YLeaf(5, "iep-hop-type-loose-next")

    iep_hop_type_next = Enum.YLeaf(6, "iep-hop-type-next")

    iep_hop_type_share_srlg = Enum.YLeaf(7, "iep-hop-type-share-srlg")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeIepHop']


class MplsTeIgpProtocol(Enum):
    """
    MplsTeIgpProtocol (Enum Class)

    Mpls te igp protocol

    .. data:: none = 0

    	Not set

    .. data:: isis = 1

    	IS IS

    .. data:: ospf = 2

    	OSPF

    """

    none = Enum.YLeaf(0, "none")

    isis = Enum.YLeaf(1, "isis")

    ospf = Enum.YLeaf(2, "ospf")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeIgpProtocol']


class MplsTeLoadshare(Enum):
    """
    MplsTeLoadshare (Enum Class)

    load\-share type

    .. data:: loadshare_equal = 0

    	Equal load-sharing on this tunnel

    .. data:: loadshare_bandwidth_based = 1

    	Loadshare inferred from bandwidth configuration

    .. data:: loadshare_configured = 2

    	Loadshare determined from explicit

    	configuration

    """

    loadshare_equal = Enum.YLeaf(0, "loadshare-equal")

    loadshare_bandwidth_based = Enum.YLeaf(1, "loadshare-bandwidth-based")

    loadshare_configured = Enum.YLeaf(2, "loadshare-configured")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeLoadshare']


class MplsTeLsp(Enum):
    """
    MplsTeLsp (Enum Class)

    LSP Types

    .. data:: mpls_te_lsp_type_not_set = 0

    	Tunnel type not set

    .. data:: mpls_te_lsp_type_p2p = 1

    	Point-to-point packet TE tunnel

    .. data:: mpls_te_lsp_type_p2mp = 2

    	Point-to-multipoint tunnel

    .. data:: mpls_te_lsp_type_gmpls_ouni = 3

    	Bidirectional GMPLS UNI tunnel

    .. data:: mpls_te_lsp_type_gmpls_nni = 4

    	Bidirectional GMPLS NNI tunnel

    .. data:: mpls_te_lsp_type_p2p_bidir = 5

    	Bidirectional packet point-to-point tunnel

    .. data:: mpls_te_lsp_type_gmpls_tp = 6

    	Bidirectional GMPLS TP tunnel

    .. data:: mpls_te_lsp_type_gmpls_nni_otn = 7

    	Bidirectional GMPLS OTN NNI tunnel

    .. data:: mpls_te_lsp_type_segment_routing_p2p = 8

    	Point-to-point segment-routing packet TE tunnel

    """

    mpls_te_lsp_type_not_set = Enum.YLeaf(0, "mpls-te-lsp-type-not-set")

    mpls_te_lsp_type_p2p = Enum.YLeaf(1, "mpls-te-lsp-type-p2p")

    mpls_te_lsp_type_p2mp = Enum.YLeaf(2, "mpls-te-lsp-type-p2mp")

    mpls_te_lsp_type_gmpls_ouni = Enum.YLeaf(3, "mpls-te-lsp-type-gmpls-ouni")

    mpls_te_lsp_type_gmpls_nni = Enum.YLeaf(4, "mpls-te-lsp-type-gmpls-nni")

    mpls_te_lsp_type_p2p_bidir = Enum.YLeaf(5, "mpls-te-lsp-type-p2p-bidir")

    mpls_te_lsp_type_gmpls_tp = Enum.YLeaf(6, "mpls-te-lsp-type-gmpls-tp")

    mpls_te_lsp_type_gmpls_nni_otn = Enum.YLeaf(7, "mpls-te-lsp-type-gmpls-nni-otn")

    mpls_te_lsp_type_segment_routing_p2p = Enum.YLeaf(8, "mpls-te-lsp-type-segment-routing-p2p")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeLsp']


class MplsTeLspMode(Enum):
    """
    MplsTeLspMode (Enum Class)

    Mpls te lsp mode

    .. data:: mpls_te_lsp_mode_not_set = 0

    	LSP mode not set

    .. data:: mpls_te_lsp_mode_current = 1

    	Current LSP

    .. data:: mpls_te_lsp_mode_reopt = 2

    	Reoptimized LSP

    .. data:: mpls_te_lsp_mode_clean = 3

    	Cleaned LSP

    .. data:: mpls_te_lsp_mode_standby = 4

    	Standby LSP

    .. data:: mpls_te_lsp_mode_pp_clean = 5

    	Delay PP Clean LSP

    .. data:: mpls_te_lsp_mode_restore = 6

    	Restore LSP

    .. data:: mpls_te_lsp_mode_reopt_standby = 7

    	Reopt Standby LSP

    """

    mpls_te_lsp_mode_not_set = Enum.YLeaf(0, "mpls-te-lsp-mode-not-set")

    mpls_te_lsp_mode_current = Enum.YLeaf(1, "mpls-te-lsp-mode-current")

    mpls_te_lsp_mode_reopt = Enum.YLeaf(2, "mpls-te-lsp-mode-reopt")

    mpls_te_lsp_mode_clean = Enum.YLeaf(3, "mpls-te-lsp-mode-clean")

    mpls_te_lsp_mode_standby = Enum.YLeaf(4, "mpls-te-lsp-mode-standby")

    mpls_te_lsp_mode_pp_clean = Enum.YLeaf(5, "mpls-te-lsp-mode-pp-clean")

    mpls_te_lsp_mode_restore = Enum.YLeaf(6, "mpls-te-lsp-mode-restore")

    mpls_te_lsp_mode_reopt_standby = Enum.YLeaf(7, "mpls-te-lsp-mode-reopt-standby")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeLspMode']


class MplsTeLspWrapState(Enum):
    """
    MplsTeLspWrapState (Enum Class)

    LSP Wrap state

    .. data:: lsp_wrap_not_ready = 0

    	LSP Wrap state is not ready

    .. data:: lsp_wrap_active = 1

    	LSP Wrap state is active

    .. data:: lsp_wrap_ready = 2

    	LSP Wrap state is ready

    """

    lsp_wrap_not_ready = Enum.YLeaf(0, "lsp-wrap-not-ready")

    lsp_wrap_active = Enum.YLeaf(1, "lsp-wrap-active")

    lsp_wrap_ready = Enum.YLeaf(2, "lsp-wrap-ready")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeLspWrapState']


class MplsTeMetric(Enum):
    """
    MplsTeMetric (Enum Class)

    Metric type

    .. data:: metric_not_set = 0

    	Metric type not set

    .. data:: metric_igp = 1

    	Metric for IGP routes

    .. data:: metric_te = 2

    	Metric for MPLS traffic engineering tunnels

    .. data:: metric_delay = 3

    	Delay Metric

    """

    metric_not_set = Enum.YLeaf(0, "metric-not-set")

    metric_igp = Enum.YLeaf(1, "metric-igp")

    metric_te = Enum.YLeaf(2, "metric-te")

    metric_delay = Enum.YLeaf(3, "metric-delay")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeMetric']


class MplsTeMetricQualifier(Enum):
    """
    MplsTeMetricQualifier (Enum Class)

    Metric qualifier

    .. data:: metric_default = 0

    	Default metric

    .. data:: metric_global = 1

    	This metric was specified globally

    .. data:: metric_interface = 2

    	This metric was specified on this particular

    	tunnel

    """

    metric_default = Enum.YLeaf(0, "metric-default")

    metric_global = Enum.YLeaf(1, "metric-global")

    metric_interface = Enum.YLeaf(2, "metric-interface")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeMetricQualifier']


class MplsTeMgmtGmplsLabel(Enum):
    """
    MplsTeMgmtGmplsLabel (Enum Class)

    GMPLS label type

    .. data:: not_set = 0

    	Not Set

    .. data:: fixed_wdm = 1

    	Fixed-grid WDM

    .. data:: fixed_g709otn = 2

    	Fixed-size G709 OTN

    """

    not_set = Enum.YLeaf(0, "not-set")

    fixed_wdm = Enum.YLeaf(1, "fixed-wdm")

    fixed_g709otn = Enum.YLeaf(2, "fixed-g709otn")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeMgmtGmplsLabel']


class MplsTeMgmtGmplsLabelOrigin(Enum):
    """
    MplsTeMgmtGmplsLabelOrigin (Enum Class)

    GMPLS label source

    .. data:: not_set = 0

    	Not set

    .. data:: uni_c = 1

    	UNI C

    .. data:: uni_n = 2

    	UNI N

    """

    not_set = Enum.YLeaf(0, "not-set")

    uni_c = Enum.YLeaf(1, "uni-c")

    uni_n = Enum.YLeaf(2, "uni-n")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeMgmtGmplsLabelOrigin']


class MplsTeNextHop(Enum):
    """
    MplsTeNextHop (Enum Class)

    Mpls te next hop

    .. data:: egress_resolve = 0

    	Egress Resolve

    .. data:: autoroute_dest = 1

    	Autoroute Dest

    """

    egress_resolve = Enum.YLeaf(0, "egress-resolve")

    autoroute_dest = Enum.YLeaf(1, "autoroute-dest")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeNextHop']


class MplsTeNode(Enum):
    """
    MplsTeNode (Enum Class)

    Mpls te node

    .. data:: router = 1

    	Router

    .. data:: network = 2

    	Network

    """

    router = Enum.YLeaf(1, "router")

    network = Enum.YLeaf(2, "network")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeNode']


class MplsTeP2mpTimer(Enum):
    """
    MplsTeP2mpTimer (Enum Class)

    P2MP timer types

    .. data:: lmrib_restart = 0

    	P2MP Local Multicast RIB restart

    .. data:: lmrib_recovery = 1

    	P2MP LMRIB recovery

    .. data:: rsvp_restart = 2

    	P2MP RSVP restart

    .. data:: lsd_restart = 3

    	LSD restart

    .. data:: lsd_recovery = 4

    	LSD recovery

    .. data:: clear_in_progress_bandwidth = 5

    	Timer to clear the inprogress bandwidth for all

    	the nodes in the topology

    .. data:: rsi_restart = 6

    	RSI restart

    .. data:: rsi_recovery = 7

    	RSI recovery

    .. data:: ipv4_caps_replay = 8

    	Timer to timeout the replay of IPv4 Caps after

    	a TE or IM restart

    .. data:: retry_acl_registration_timer = 9

    	Timer to retry ACL registration

    .. data:: mpls_te_exit = 10

    	MPLS TE Exit

    .. data:: mpls_te_nsr_peer_restart = 11

    	MPLS TE NSR Peer Restart

    .. data:: mpls_te_issu_peer_restart = 12

    	MPLS TE ISSU Peer Restart

    .. data:: bfd_restart = 13

    	BFD restart

    .. data:: bfd_recovery = 14

    	BFD recovery

    .. data:: im_oc_restart = 15

    	IM Optical Connection restart

    .. data:: im_oc_recovery = 16

    	IM Optical Connection recovery

    .. data:: rib_restart = 17

    	RIB restart

    .. data:: rib_recovery = 18

    	RIB recovery

    .. data:: rib_next_hop_route_cleanup = 19

    	RIB next-hop route cleanup

    .. data:: rsi_srlg_producer_retry = 20

    	RSI SRLG-producer connection retry

    .. data:: eoc_reg_retry = 21

    	End-of-Config registration retry

    .. data:: fib_restart = 22

    	FIB restart

    .. data:: fib_recovery = 23

    	FIB recovery

    .. data:: fib_next_hop_route_cleanup = 24

    	FIB next-hop route cleanup

    .. data:: fib_next_hop_register_retry = 25

    	FIB next-hop register retry

    .. data:: tun_backend_scan_retry = 26

    	Tunnel Backend Scan Retry

    .. data:: tunnel_checkpoint_list_service = 27

    	Tunnel Checkpoint list service

    .. data:: tunnel_service_binding_sid_allocation_retry = 28

    	Tunnel Service Binding SID Allocation Retry

    .. data:: im_sync_delay = 29

    	IM sync delay

    .. data:: timer_not_used = 30

    	Do not use

    """

    lmrib_restart = Enum.YLeaf(0, "lmrib-restart")

    lmrib_recovery = Enum.YLeaf(1, "lmrib-recovery")

    rsvp_restart = Enum.YLeaf(2, "rsvp-restart")

    lsd_restart = Enum.YLeaf(3, "lsd-restart")

    lsd_recovery = Enum.YLeaf(4, "lsd-recovery")

    clear_in_progress_bandwidth = Enum.YLeaf(5, "clear-in-progress-bandwidth")

    rsi_restart = Enum.YLeaf(6, "rsi-restart")

    rsi_recovery = Enum.YLeaf(7, "rsi-recovery")

    ipv4_caps_replay = Enum.YLeaf(8, "ipv4-caps-replay")

    retry_acl_registration_timer = Enum.YLeaf(9, "retry-acl-registration-timer")

    mpls_te_exit = Enum.YLeaf(10, "mpls-te-exit")

    mpls_te_nsr_peer_restart = Enum.YLeaf(11, "mpls-te-nsr-peer-restart")

    mpls_te_issu_peer_restart = Enum.YLeaf(12, "mpls-te-issu-peer-restart")

    bfd_restart = Enum.YLeaf(13, "bfd-restart")

    bfd_recovery = Enum.YLeaf(14, "bfd-recovery")

    im_oc_restart = Enum.YLeaf(15, "im-oc-restart")

    im_oc_recovery = Enum.YLeaf(16, "im-oc-recovery")

    rib_restart = Enum.YLeaf(17, "rib-restart")

    rib_recovery = Enum.YLeaf(18, "rib-recovery")

    rib_next_hop_route_cleanup = Enum.YLeaf(19, "rib-next-hop-route-cleanup")

    rsi_srlg_producer_retry = Enum.YLeaf(20, "rsi-srlg-producer-retry")

    eoc_reg_retry = Enum.YLeaf(21, "eoc-reg-retry")

    fib_restart = Enum.YLeaf(22, "fib-restart")

    fib_recovery = Enum.YLeaf(23, "fib-recovery")

    fib_next_hop_route_cleanup = Enum.YLeaf(24, "fib-next-hop-route-cleanup")

    fib_next_hop_register_retry = Enum.YLeaf(25, "fib-next-hop-register-retry")

    tun_backend_scan_retry = Enum.YLeaf(26, "tun-backend-scan-retry")

    tunnel_checkpoint_list_service = Enum.YLeaf(27, "tunnel-checkpoint-list-service")

    tunnel_service_binding_sid_allocation_retry = Enum.YLeaf(28, "tunnel-service-binding-sid-allocation-retry")

    im_sync_delay = Enum.YLeaf(29, "im-sync-delay")

    timer_not_used = Enum.YLeaf(30, "timer-not-used")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeP2mpTimer']


class MplsTePath(Enum):
    """
    MplsTePath (Enum Class)

    Mpls te path

    .. data:: not_set = 0

    	Not set

    .. data:: dynamic = 1

    	Dynamic

    .. data:: explicit_name = 3

    	Explicit name

    .. data:: explicit_id = 4

    	Explicit ID

    .. data:: no_ero = 5

    	No ERO

    .. data:: segment_routing = 6

    	Segment Routing

    """

    not_set = Enum.YLeaf(0, "not-set")

    dynamic = Enum.YLeaf(1, "dynamic")

    explicit_name = Enum.YLeaf(3, "explicit-name")

    explicit_id = Enum.YLeaf(4, "explicit-id")

    no_ero = Enum.YLeaf(5, "no-ero")

    segment_routing = Enum.YLeaf(6, "segment-routing")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTePath']


class MplsTePathSelectionMetric(Enum):
    """
    MplsTePathSelectionMetric (Enum Class)

    Mpls te path selection metric

    .. data:: igp = 1

    	IGP Metric

    .. data:: te = 2

    	TE Metric

    .. data:: delay = 4

    	DELAY Metric

    """

    igp = Enum.YLeaf(1, "igp")

    te = Enum.YLeaf(2, "te")

    delay = Enum.YLeaf(4, "delay")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTePathSelectionMetric']


class MplsTePathoption(Enum):
    """
    MplsTePathoption (Enum Class)

    Path\-option type

    .. data:: path_option_unknown = 0

    	Unknown Path Option

    .. data:: path_option_dynamic = 1

    	Dynamic Path Option

    .. data:: path_option_explicit_name = 2

    	Explicit name Path Option

    .. data:: path_option_explicit_id = 3

    	Explicit Identifier Path Option

    .. data:: path_option_pce = 4

    	PCE Path Option

    .. data:: path_option_no_ero = 5

    	No-ERO Path Option

    .. data:: path_option_segment_routing = 6

    	Segment-Routing Path Option

    """

    path_option_unknown = Enum.YLeaf(0, "path-option-unknown")

    path_option_dynamic = Enum.YLeaf(1, "path-option-dynamic")

    path_option_explicit_name = Enum.YLeaf(2, "path-option-explicit-name")

    path_option_explicit_id = Enum.YLeaf(3, "path-option-explicit-id")

    path_option_pce = Enum.YLeaf(4, "path-option-pce")

    path_option_no_ero = Enum.YLeaf(5, "path-option-no-ero")

    path_option_segment_routing = Enum.YLeaf(6, "path-option-segment-routing")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTePathoption']


class MplsTePceFailReasons(Enum):
    """
    MplsTePceFailReasons (Enum Class)

    PCE failure reasons

    .. data:: te_pce_fail_no_reason = 0

    	No reason

    .. data:: te_pce_fail_no_pce = 1

    	No PCE to send request

    .. data:: te_pce_fail_sub_pool = 2

    	Sub pool bandwidth tunnel

    .. data:: te_pce_fail_intra_area = 3

    	Intra Area Tunnel

    .. data:: te_pce_fail_gmpls = 4

    	GMPLS Tunnel

    .. data:: te_pce_fail_pending = 5

    	Pending request

    .. data:: te_pce_fail_oor = 6

    	OOR condition

    .. data:: te_pce_fail_bidirectional = 7

    	Bi directional

    .. data:: te_pce_fail_no_path = 8

    	No Path received from PCE

    .. data:: te_pce_fail_request_timeout = 9

    	Request Timeout

    """

    te_pce_fail_no_reason = Enum.YLeaf(0, "te-pce-fail-no-reason")

    te_pce_fail_no_pce = Enum.YLeaf(1, "te-pce-fail-no-pce")

    te_pce_fail_sub_pool = Enum.YLeaf(2, "te-pce-fail-sub-pool")

    te_pce_fail_intra_area = Enum.YLeaf(3, "te-pce-fail-intra-area")

    te_pce_fail_gmpls = Enum.YLeaf(4, "te-pce-fail-gmpls")

    te_pce_fail_pending = Enum.YLeaf(5, "te-pce-fail-pending")

    te_pce_fail_oor = Enum.YLeaf(6, "te-pce-fail-oor")

    te_pce_fail_bidirectional = Enum.YLeaf(7, "te-pce-fail-bidirectional")

    te_pce_fail_no_path = Enum.YLeaf(8, "te-pce-fail-no-path")

    te_pce_fail_request_timeout = Enum.YLeaf(9, "te-pce-fail-request-timeout")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTePceFailReasons']


class MplsTeReasonNotFlooded(Enum):
    """
    MplsTeReasonNotFlooded (Enum Class)

    Reason why TE link is not flooded

    .. data:: not_flooded_reason_not_set = 0

    	reason not set

    .. data:: controller_not_configured = 1

    	Controller not configured

    .. data:: controller_not_up = 2

    	Controller not up

    .. data:: no_local_link_id = 3

    	Valid local link id is not populated

    .. data:: no_remote_link_id = 4

    	Valid remote link id is not populated

    .. data:: odu_capabilities_not_set = 5

    	ODU capabilities of link not set

    .. data:: tti_not_enabled = 6

    	TTI info for link is enabled

    .. data:: link_not_supported = 7

    	This type of link is not suported

    .. data:: te_proc_fsm_disabled = 8

    	Flooding disabled by TE process fsm

    .. data:: graceful_shutdown = 9

    	Flooding diabled due to graceful shutdown

    .. data:: flooding_disabled = 10

    	Flooding is disabled

    .. data:: label_switch_fabric_disabled = 11

    	Label switching fabric is disabled

    .. data:: no_igp_area_config = 12

    	No IGP area is configured

    .. data:: area_not_configured = 13

    	Area is not configured

    .. data:: area_not_ready = 14

    	Area is not ready for flood

    .. data:: lsa_error = 15

    	Failure occured while building LSA

    .. data:: igp_failed = 16

    	IGP failed

    .. data:: flooding_requested = 17

    	Link is ready to flood and requested for

    	flooding

    .. data:: link_flooded = 18

    	Link is flooded

    """

    not_flooded_reason_not_set = Enum.YLeaf(0, "not-flooded-reason-not-set")

    controller_not_configured = Enum.YLeaf(1, "controller-not-configured")

    controller_not_up = Enum.YLeaf(2, "controller-not-up")

    no_local_link_id = Enum.YLeaf(3, "no-local-link-id")

    no_remote_link_id = Enum.YLeaf(4, "no-remote-link-id")

    odu_capabilities_not_set = Enum.YLeaf(5, "odu-capabilities-not-set")

    tti_not_enabled = Enum.YLeaf(6, "tti-not-enabled")

    link_not_supported = Enum.YLeaf(7, "link-not-supported")

    te_proc_fsm_disabled = Enum.YLeaf(8, "te-proc-fsm-disabled")

    graceful_shutdown = Enum.YLeaf(9, "graceful-shutdown")

    flooding_disabled = Enum.YLeaf(10, "flooding-disabled")

    label_switch_fabric_disabled = Enum.YLeaf(11, "label-switch-fabric-disabled")

    no_igp_area_config = Enum.YLeaf(12, "no-igp-area-config")

    area_not_configured = Enum.YLeaf(13, "area-not-configured")

    area_not_ready = Enum.YLeaf(14, "area-not-ready")

    lsa_error = Enum.YLeaf(15, "lsa-error")

    igp_failed = Enum.YLeaf(16, "igp-failed")

    flooding_requested = Enum.YLeaf(17, "flooding-requested")

    link_flooded = Enum.YLeaf(18, "link-flooded")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeReasonNotFlooded']


class MplsTeReoptDecisionReason(Enum):
    """
    MplsTeReoptDecisionReason (Enum Class)

    Reoptimization decision

    .. data:: decision_reason_none = 0

    	No reason

    .. data:: not_superset = 1

    	Reopt LSP not signalled because it is not a

    	superset of the current LSP

    .. data:: superset = 2

    	Reopt LSP is signalled because it is a superset

    	of the current LSP

    .. data:: lsp_frr_active = 3

    	Reopt LSP is signalled because the current LSP

    	is in FRR

    .. data:: bandwidth_change = 4

    	Reopt LSP is signalled  because there is a

    	bandwidth change

    .. data:: metric_type_change = 5

    	Reopt LSP is signalled because there is a

    	metric type change

    .. data:: better_path_option_indexes = 6

    	Reopt LSP is signalled because it has better

    	path option indexes than the current LSP

    .. data:: inter_area_preferred_path_exists = 7

    	Reopt LSP is signalled because an inter-area

    	preferred path exists

    .. data:: inter_area_preferred_tree_exists = 8

    	Reopt LSP is signalled because an inter-area

    	preferred tree exists

    .. data:: worse_path_option_indexes = 9

    	Reopt LSP is not signalled because it has worse

    	path option indexes than the current LSP

    .. data:: better_cumulative_metric = 10

    	Reopt LSP is signalled because it has better

    	path option indexes than the current LSP

    .. data:: worse_cumulative_metric = 11

    	Reopt LSP is not signalled because it has worse

    	cumulative metric than the current LSP

    .. data:: identical = 12

    	Reopt LSP is not signalled because it is

    	identical to the current LSP

    .. data:: no_s2_ls = 13

    	Reopt LSP is not signalled because it has no

    	S2Ls

    .. data:: no_current_lsp = 14

    	Reopt LSP not signalled, no current LSP

    .. data:: user_path_option_switchover = 15

    	Reopt LSP signalled due to user requested

    	path-option switchover

    .. data:: better_hops = 16

    	Reopt LSP is signalled because it has more S2Ls

    	with less hops than the current LSP

    .. data:: worse_hops = 17

    	Reopt LSP is not signalled because it has less

    	S2Ls with less hops than the current LSP

    .. data:: pce_force = 18

    	PCE based reoptimization triggered by CLI with

    	force option than the current LSP

    .. data:: affinity_changed = 19

    	Reopt LSP is signalled  because there is an

    	affinity change

    .. data:: cost_limit = 20

    	Reopt LSP is signalled  because the path cost

    	limit is crossed

    .. data:: sig_timeout = 21

    	Re-opt LSP could not be signalled within

    	signalling timeout

    .. data:: not_superset_inst_timer_expired = 22

    	Re-opt LSP is not a superset when the install

    	timer expired

    .. data:: path_verifiction_failed = 23

    	Re-opt LSP path verification failed

    .. data:: soft_preemption_recovery = 24

    	Re-opt LSP is signalled because of soft

    	preemption recovery

    .. data:: iep_changed = 25

    	Re-opt LSP is signalled because the inuse

    	explicit-path has changed

    .. data:: po_changed = 26

    	Re-opt LSP is signalled because the inuse

    	path-option has changed

    .. data:: dest_changed = 27

    	Re-opt LSP is signalled because the destination

    	has changed

    .. data:: better_igp_area = 28

    	Reopt LSP is signalled because its path was

    	calculated in a preferred IGP-area to the

    	current LSP

    .. data:: worse_igp_area = 29

    	Reopt LSP is not signalled because its path was

    	calculated in a worse IGP-area than the current

    	LSP

    .. data:: better_bandwidth_load_balancing = 30

    	Reopt LSP is signalled because it gives better

    	bandwidth load balancing than the current LSP

    .. data:: worse_bandwidth_load_balancing = 31

    	Reopt LSP is not signalled because it gives

    	worse bandwidth load balancing than the current

    	LSP

    .. data:: bfd_session_down = 32

    	Reopt LSP is signaled because BFD sesssion went

    	down

    .. data:: auto_pcc_reopt = 33

    	Re-opt LSP is signalled because it was

    	triggered by a PCE

    .. data:: sr_egress_path_changed = 34

    	Reopt LSP is signaled because the egress

    	path(s) changed

    .. data:: overload_bit_set = 35

    	Reopt LSP is signalled because the current LSP

    	uses an OL node

    .. data:: better_diversity = 36

    	Reopt LSP is signalled because it has better

    	diversity than the current LSP

    .. data:: worse_diversity = 37

    	Reopt LSP is not signalled because it has worse

    	diversity than the current lsp

    .. data:: bfd_session_type_changed = 38

    	Reopt LSP is signalled because BFD sesssion

    	tyep is changed

    .. data:: lsp_drop_mode = 39

    	Reopt LSP is signalled because current LSP is

    	in drop mode

    .. data:: strict_spf = 40

    	Reopt LSP is signalled because it uses strict

    	SPF while current doesn't

    .. data:: delay_limit = 41

    	Reopt LSP is signalled  because the path delay

    	limit is crossed

    .. data:: lockout_metric = 42

    	Reopt LSP is signalled  because one of the

    	links is locked out

    .. data:: intra_area = 43

    	Reopt LSP is signalled because it has better

    	intra-areaness

    .. data:: clear_sticky = 44

    	Reopt LSP is signalled because clear sticky

    	command

    .. data:: not_used = 45

    	Not used, must be last entry

    """

    decision_reason_none = Enum.YLeaf(0, "decision-reason-none")

    not_superset = Enum.YLeaf(1, "not-superset")

    superset = Enum.YLeaf(2, "superset")

    lsp_frr_active = Enum.YLeaf(3, "lsp-frr-active")

    bandwidth_change = Enum.YLeaf(4, "bandwidth-change")

    metric_type_change = Enum.YLeaf(5, "metric-type-change")

    better_path_option_indexes = Enum.YLeaf(6, "better-path-option-indexes")

    inter_area_preferred_path_exists = Enum.YLeaf(7, "inter-area-preferred-path-exists")

    inter_area_preferred_tree_exists = Enum.YLeaf(8, "inter-area-preferred-tree-exists")

    worse_path_option_indexes = Enum.YLeaf(9, "worse-path-option-indexes")

    better_cumulative_metric = Enum.YLeaf(10, "better-cumulative-metric")

    worse_cumulative_metric = Enum.YLeaf(11, "worse-cumulative-metric")

    identical = Enum.YLeaf(12, "identical")

    no_s2_ls = Enum.YLeaf(13, "no-s2-ls")

    no_current_lsp = Enum.YLeaf(14, "no-current-lsp")

    user_path_option_switchover = Enum.YLeaf(15, "user-path-option-switchover")

    better_hops = Enum.YLeaf(16, "better-hops")

    worse_hops = Enum.YLeaf(17, "worse-hops")

    pce_force = Enum.YLeaf(18, "pce-force")

    affinity_changed = Enum.YLeaf(19, "affinity-changed")

    cost_limit = Enum.YLeaf(20, "cost-limit")

    sig_timeout = Enum.YLeaf(21, "sig-timeout")

    not_superset_inst_timer_expired = Enum.YLeaf(22, "not-superset-inst-timer-expired")

    path_verifiction_failed = Enum.YLeaf(23, "path-verifiction-failed")

    soft_preemption_recovery = Enum.YLeaf(24, "soft-preemption-recovery")

    iep_changed = Enum.YLeaf(25, "iep-changed")

    po_changed = Enum.YLeaf(26, "po-changed")

    dest_changed = Enum.YLeaf(27, "dest-changed")

    better_igp_area = Enum.YLeaf(28, "better-igp-area")

    worse_igp_area = Enum.YLeaf(29, "worse-igp-area")

    better_bandwidth_load_balancing = Enum.YLeaf(30, "better-bandwidth-load-balancing")

    worse_bandwidth_load_balancing = Enum.YLeaf(31, "worse-bandwidth-load-balancing")

    bfd_session_down = Enum.YLeaf(32, "bfd-session-down")

    auto_pcc_reopt = Enum.YLeaf(33, "auto-pcc-reopt")

    sr_egress_path_changed = Enum.YLeaf(34, "sr-egress-path-changed")

    overload_bit_set = Enum.YLeaf(35, "overload-bit-set")

    better_diversity = Enum.YLeaf(36, "better-diversity")

    worse_diversity = Enum.YLeaf(37, "worse-diversity")

    bfd_session_type_changed = Enum.YLeaf(38, "bfd-session-type-changed")

    lsp_drop_mode = Enum.YLeaf(39, "lsp-drop-mode")

    strict_spf = Enum.YLeaf(40, "strict-spf")

    delay_limit = Enum.YLeaf(41, "delay-limit")

    lockout_metric = Enum.YLeaf(42, "lockout-metric")

    intra_area = Enum.YLeaf(43, "intra-area")

    clear_sticky = Enum.YLeaf(44, "clear-sticky")

    not_used = Enum.YLeaf(45, "not-used")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeReoptDecisionReason']


class MplsTeSoftPreemptionResolution(Enum):
    """
    MplsTeSoftPreemptionResolution (Enum Class)

    The possible ways for soft preemption to end

    .. data:: soft_preemption_resolution_none = 0

    	No Soft Preemption Resolution

    .. data:: soft_preemption_resolution_pending = 1

    	Soft Preemption has no resolution since it is

    	still pending

    .. data:: soft_preemption_resolution_reopt_completed = 2

    	The soft preempted LSP has been reoptimized

    .. data:: soft_preemption_resolution_teardown = 3

    	The soft preempted LSP has been torn

    .. data:: soft_preemption_resolution_frr_triggered = 4

    	The soft preempted LSP has been fast rerouted

    .. data:: soft_preemption_resolution_path_protetion_switchover = 5

    	The soft preempted LSP was switched with the

    	protection LSP

    """

    soft_preemption_resolution_none = Enum.YLeaf(0, "soft-preemption-resolution-none")

    soft_preemption_resolution_pending = Enum.YLeaf(1, "soft-preemption-resolution-pending")

    soft_preemption_resolution_reopt_completed = Enum.YLeaf(2, "soft-preemption-resolution-reopt-completed")

    soft_preemption_resolution_teardown = Enum.YLeaf(3, "soft-preemption-resolution-teardown")

    soft_preemption_resolution_frr_triggered = Enum.YLeaf(4, "soft-preemption-resolution-frr-triggered")

    soft_preemption_resolution_path_protetion_switchover = Enum.YLeaf(5, "soft-preemption-resolution-path-protetion-switchover")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeSoftPreemptionResolution']


class MplsTeSoftPreemptionState(Enum):
    """
    MplsTeSoftPreemptionState (Enum Class)

    The possible states for soft preemption

    .. data:: soft_preemption_not_pending = 0

    	Soft Preemption has not been triggered and is

    	not pending

    .. data:: soft_preemption_pending = 1

    	Soft Preemption has been triggered and is

    	pending

    """

    soft_preemption_not_pending = Enum.YLeaf(0, "soft-preemption-not-pending")

    soft_preemption_pending = Enum.YLeaf(1, "soft-preemption-pending")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeSoftPreemptionState']


class MplsTeTermination(Enum):
    """
    MplsTeTermination (Enum Class)

    Termination type

    .. data:: none = 0

    	Local termination none

    .. data:: ether = 1

    	Local termination type Ether

    """

    none = Enum.YLeaf(0, "none")

    ether = Enum.YLeaf(1, "ether")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTermination']


class MplsTeTunnelAnnounce(Enum):
    """
    MplsTeTunnelAnnounce (Enum Class)

    Type of TE tunnel announcement to IGP

    .. data:: announce_type_not_set = 0

    	Tunnel announcement type not set

    .. data:: autoroute = 1

    	Autoroute-announced tunnel

    .. data:: forward_adjacency = 2

    	Forwarding-adjacency tunnel

    """

    announce_type_not_set = Enum.YLeaf(0, "announce-type-not-set")

    autoroute = Enum.YLeaf(1, "autoroute")

    forward_adjacency = Enum.YLeaf(2, "forward-adjacency")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTunnelAnnounce']


class MplsTeTunnelRole(Enum):
    """
    MplsTeTunnelRole (Enum Class)

    Mpls te tunnel role

    .. data:: tunnel_unknown = 0

    	Undefined tunnel role

    .. data:: tunnel_head = 1

    	Tunnel role is head

    .. data:: tunnel_mid = 2

    	Tunnel role is midpoint

    .. data:: tunnel_tail = 3

    	Tunnel role is tail

    """

    tunnel_unknown = Enum.YLeaf(0, "tunnel-unknown")

    tunnel_head = Enum.YLeaf(1, "tunnel-head")

    tunnel_mid = Enum.YLeaf(2, "tunnel-mid")

    tunnel_tail = Enum.YLeaf(3, "tunnel-tail")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTunnelRole']


class MplsTeTunnelState(Enum):
    """
    MplsTeTunnelState (Enum Class)

    Tunnel state

    .. data:: state_down = 0

    	Tunnel state is down

    .. data:: state_up = 1

    	Tunnel state is up

    .. data:: state_down_policy = 2

    	Tunnel state is down as it has been deactivated

    	administratively

    .. data:: state_lockout = 3

    	Tunnel state is lockout

    """

    state_down = Enum.YLeaf(0, "state-down")

    state_up = Enum.YLeaf(1, "state-up")

    state_down_policy = Enum.YLeaf(2, "state-down-policy")

    state_lockout = Enum.YLeaf(3, "state-lockout")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTunnelState']


class MplsTeTunnelsProcessStatus(Enum):
    """
    MplsTeTunnelsProcessStatus (Enum Class)

    Mpls te tunnels process status

    .. data:: not_running = 0

    	MPLS TE process is not running

    .. data:: running = 1

    	MPLS TE process is running

    .. data:: not_registered_with_rsvp = 2

    	MPLS TE process has not registered with RSVP

    """

    not_running = Enum.YLeaf(0, "not-running")

    running = Enum.YLeaf(1, "running")

    not_registered_with_rsvp = Enum.YLeaf(2, "not-registered-with-rsvp")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTunnelsProcessStatus']


class MplsTeTunnelsSignalingStatus(Enum):
    """
    MplsTeTunnelsSignalingStatus (Enum Class)

    Tunnel signalling status

    .. data:: down = 0

    	The tunnel is down

    .. data:: recovering = 1

    	The tunnel is recovering

    .. data:: recovered = 2

    	The tunnel is recovered

    .. data:: connected = 3

    	The tunnel is connected

    .. data:: disabled = 4

    	The tunnel signalling is disabled

    .. data:: proceeding = 5

    	The tunnel signalling is proceeding

    .. data:: wait_bfd_session_up = 6

    	The tunnel is waiting for BFD session up

    .. data:: wait_sr_segment_path_up = 7

    	The tunnel is waiting for SR segment path

    .. data:: wait_local_label = 8

    	The tunnel is waiting for a local label

    .. data:: wait_local_label_rewrite = 9

    	The tunnel is waiting for a local label rewrite

    """

    down = Enum.YLeaf(0, "down")

    recovering = Enum.YLeaf(1, "recovering")

    recovered = Enum.YLeaf(2, "recovered")

    connected = Enum.YLeaf(3, "connected")

    disabled = Enum.YLeaf(4, "disabled")

    proceeding = Enum.YLeaf(5, "proceeding")

    wait_bfd_session_up = Enum.YLeaf(6, "wait-bfd-session-up")

    wait_sr_segment_path_up = Enum.YLeaf(7, "wait-sr-segment-path-up")

    wait_local_label = Enum.YLeaf(8, "wait-local-label")

    wait_local_label_rewrite = Enum.YLeaf(9, "wait-local-label-rewrite")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeTunnelsSignalingStatus']


class MplsTeUni(Enum):
    """
    MplsTeUni (Enum Class)

    Uni\-Type type

    .. data:: none = 0

    	Uni-Type none

    .. data:: xc = 1

    	Uni-Type type XC

    .. data:: term = 2

    	Uni-Type Termination

    """

    none = Enum.YLeaf(0, "none")

    xc = Enum.YLeaf(1, "xc")

    term = Enum.YLeaf(2, "term")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeUni']


class MplsTpLspBfdState(Enum):
    """
    MplsTpLspBfdState (Enum Class)

    Deprecated

    .. data:: down = 0

    	Deprecated

    .. data:: up = 1

    	Deprecated

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpLspBfdState']


class MplsTpLspOamState(Enum):
    """
    MplsTpLspOamState (Enum Class)

    Deprecated

    .. data:: none = 0

    	Deprecated

    .. data:: ldi = 1

    	Deprecated

    .. data:: lkr = 2

    	Deprecated

    .. data:: ais = 3

    	Deprecated

    """

    none = Enum.YLeaf(0, "none")

    ldi = Enum.YLeaf(1, "ldi")

    lkr = Enum.YLeaf(2, "lkr")

    ais = Enum.YLeaf(3, "ais")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpLspOamState']


class MplsTpLspState(Enum):
    """
    MplsTpLspState (Enum Class)

    Deprecated

    .. data:: down = 0

    	Deprecated

    .. data:: up = 1

    	Deprecated

    .. data:: active = 2

    	Deprecated

    .. data:: unknown = 3

    	Deprecated

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")

    active = Enum.YLeaf(2, "active")

    unknown = Enum.YLeaf(3, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpLspState']


class MplsTpTunnelActiveLsp(Enum):
    """
    MplsTpTunnelActiveLsp (Enum Class)

    Deprecated

    .. data:: working = 0

    	Deprecated

    .. data:: protect = 1

    	Deprecated

    .. data:: none = 2

    	Deprecated

    """

    working = Enum.YLeaf(0, "working")

    protect = Enum.YLeaf(1, "protect")

    none = Enum.YLeaf(2, "none")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpTunnelActiveLsp']


class MplsTpTunnelState(Enum):
    """
    MplsTpTunnelState (Enum Class)

    Deprecated

    .. data:: admin_down = 0

    	Deprecated

    .. data:: admin_up = 1

    	Deprecated

    .. data:: oper_up = 2

    	Deprecated

    .. data:: oper_down = 3

    	Deprecated

    """

    admin_down = Enum.YLeaf(0, "admin-down")

    admin_up = Enum.YLeaf(1, "admin-up")

    oper_up = Enum.YLeaf(2, "oper-up")

    oper_down = Enum.YLeaf(3, "oper-down")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpTunnelState']


class MplsTpTunnelSwitchoverTrig(Enum):
    """
    MplsTpTunnelSwitchoverTrig (Enum Class)

    Deprecated

    .. data:: none = 0

    	Deprecated

    .. data:: bfd = 1

    	Deprecated

    .. data:: local_lockout = 2

    	Deprecated

    .. data:: remote_lockout = 3

    	Deprecated

    .. data:: ais = 4

    	Deprecated

    .. data:: ldi = 5

    	Deprecated

    .. data:: lkr = 6

    	Deprecated

    .. data:: link_down = 7

    	Deprecated

    """

    none = Enum.YLeaf(0, "none")

    bfd = Enum.YLeaf(1, "bfd")

    local_lockout = Enum.YLeaf(2, "local-lockout")

    remote_lockout = Enum.YLeaf(3, "remote-lockout")

    ais = Enum.YLeaf(4, "ais")

    ldi = Enum.YLeaf(5, "ldi")

    lkr = Enum.YLeaf(6, "lkr")

    link_down = Enum.YLeaf(7, "link-down")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTpTunnelSwitchoverTrig']


class MtePathOption(Enum):
    """
    MtePathOption (Enum Class)

    Path Option Type

    .. data:: none = 0

    	No Path Option type

    .. data:: dynamic = 1

    	Dynamic Path Option type

    .. data:: explicit = 2

    	Explicit Path Option type

    .. data:: no_ero = 3

    	No ERO Path Option type

    .. data:: segment_routing = 4

    	One SID SegmentRouting Path Option type

    .. data:: po_count = 5

    	Number of Path option types

    """

    none = Enum.YLeaf(0, "none")

    dynamic = Enum.YLeaf(1, "dynamic")

    explicit = Enum.YLeaf(2, "explicit")

    no_ero = Enum.YLeaf(3, "no-ero")

    segment_routing = Enum.YLeaf(4, "segment-routing")

    po_count = Enum.YLeaf(5, "po-count")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MtePathOption']


class MteReoptTrigger(Enum):
    """
    MteReoptTrigger (Enum Class)

    Reoptimization trigger

    .. data:: no_trigger = 0

    	No trigger

    .. data:: timer_trigger = 1

    	Timer Trigger

    .. data:: bandwidth_change_trigger = 2

    	Bandwidth Change Trigger

    .. data:: auto_bandwidth_overflow_trigger = 3

    	Auto Bandwidth Overflow Trigger

    .. data:: auto_bandwidth_underflow_trigger = 4

    	Auto Bandwidth Underflow Trigger

    .. data:: auto_bandwidth_adjustment_trigger = 5

    	Auto Bandwidth Adjustment Trigger

    .. data:: metric_type_change_trigger = 6

    	Metric Type Change Trigger

    .. data:: user_trigger = 7

    	User Trigger

    .. data:: frr_trigger = 8

    	FRR Trigger

    .. data:: remerge_error_trigger = 9

    	Remerge Error Trigger

    .. data:: preferred_path_trigger = 10

    	Reception of the preferred path exists path

    	error

    .. data:: preferred_tree_trigger = 11

    	Reception of the preferred tree exists path

    	error

    .. data:: due_to_maximum_metric = 12

    	Reoptimization triggered due to receiving an

    	LSA with MAX metric

    .. data:: path_option_switchover_trigger = 13

    	Path option switchover

    .. data:: path_protection_switchover_trigger = 14

    	Path Protection Switchover Trigger

    .. data:: reroute_sticky_path_trigger = 15

    	Reroute Sticky Path trigger

    .. data:: iep_enable_reoptimization_trigger = 16

    	IEP Enable Reoptimization Trigger

    .. data:: affinity_path_verification_fail_trigger = 17

    	Affinity path verification failure trigger

    .. data:: cost_limit_path_verification_fail_trigger = 18

    	Cost limit path verification failure trigger

    .. data:: delay_limit_path_verification_fail_trigger = 19

    	Delay limit path verification failure trigger

    .. data:: soft_preemption_trigger = 20

    	Soft preemption trigger

    .. data:: iep_changed = 21

    	Explicit path has changed

    .. data:: po_changed = 22

    	Path-option has changed

    .. data:: dest_changed = 23

    	Destination has changed

    .. data:: reopt_try_to_force_it = 24

    	Reoptimization with try-to-force-it option

    .. data:: topology_change_trigger = 25

    	Topology change trigger

    .. data:: reopt_link_up_event = 26

    	Topology link-up event trigger

    .. data:: bfd_session_down_trigger = 27

    	FRR enabled and BFD session down trigger

    .. data:: reverse_assoc_s2l_received_trigger = 28

    	Reverse associated S2L received trigger

    .. data:: gmpls_uni_multilayer_trigger = 29

    	Multilayer recovery for GMPLS-UNI

    .. data:: gmpls_uni_user_trigger = 30

    	User-triggered GMPLS-UNI reopt request

    .. data:: path_selection_tiebreaker_change_trigger = 31

    	Path Selection Tiebreaker Change Trigger

    .. data:: sr_egress_path_change_trigger = 32

    	Segment-Routing Egress Path Change Trigger

    .. data:: overload_bit_trigger = 33

    	Overload-bit set on current path

    .. data:: pce_trigger = 34

    	PCE Trigger

    .. data:: lockout_metric_trigger = 35

    	Reoptimization triggered due to receiving an

    	LSA with Lockout metric

    .. data:: bfd_session_config_change_trigger = 36

    	BFD session configuration change

    .. data:: higher_priority_po_change_trigger = 37

    	Higher priority path option changed

    .. data:: sr_area_spf_support_change_trigger = 38

    	Segment-Routing IGP Area SPF Support Change

    	Trigger

    .. data:: trigger_not_used = 39

    	Not used

    """

    no_trigger = Enum.YLeaf(0, "no-trigger")

    timer_trigger = Enum.YLeaf(1, "timer-trigger")

    bandwidth_change_trigger = Enum.YLeaf(2, "bandwidth-change-trigger")

    auto_bandwidth_overflow_trigger = Enum.YLeaf(3, "auto-bandwidth-overflow-trigger")

    auto_bandwidth_underflow_trigger = Enum.YLeaf(4, "auto-bandwidth-underflow-trigger")

    auto_bandwidth_adjustment_trigger = Enum.YLeaf(5, "auto-bandwidth-adjustment-trigger")

    metric_type_change_trigger = Enum.YLeaf(6, "metric-type-change-trigger")

    user_trigger = Enum.YLeaf(7, "user-trigger")

    frr_trigger = Enum.YLeaf(8, "frr-trigger")

    remerge_error_trigger = Enum.YLeaf(9, "remerge-error-trigger")

    preferred_path_trigger = Enum.YLeaf(10, "preferred-path-trigger")

    preferred_tree_trigger = Enum.YLeaf(11, "preferred-tree-trigger")

    due_to_maximum_metric = Enum.YLeaf(12, "due-to-maximum-metric")

    path_option_switchover_trigger = Enum.YLeaf(13, "path-option-switchover-trigger")

    path_protection_switchover_trigger = Enum.YLeaf(14, "path-protection-switchover-trigger")

    reroute_sticky_path_trigger = Enum.YLeaf(15, "reroute-sticky-path-trigger")

    iep_enable_reoptimization_trigger = Enum.YLeaf(16, "iep-enable-reoptimization-trigger")

    affinity_path_verification_fail_trigger = Enum.YLeaf(17, "affinity-path-verification-fail-trigger")

    cost_limit_path_verification_fail_trigger = Enum.YLeaf(18, "cost-limit-path-verification-fail-trigger")

    delay_limit_path_verification_fail_trigger = Enum.YLeaf(19, "delay-limit-path-verification-fail-trigger")

    soft_preemption_trigger = Enum.YLeaf(20, "soft-preemption-trigger")

    iep_changed = Enum.YLeaf(21, "iep-changed")

    po_changed = Enum.YLeaf(22, "po-changed")

    dest_changed = Enum.YLeaf(23, "dest-changed")

    reopt_try_to_force_it = Enum.YLeaf(24, "reopt-try-to-force-it")

    topology_change_trigger = Enum.YLeaf(25, "topology-change-trigger")

    reopt_link_up_event = Enum.YLeaf(26, "reopt-link-up-event")

    bfd_session_down_trigger = Enum.YLeaf(27, "bfd-session-down-trigger")

    reverse_assoc_s2l_received_trigger = Enum.YLeaf(28, "reverse-assoc-s2l-received-trigger")

    gmpls_uni_multilayer_trigger = Enum.YLeaf(29, "gmpls-uni-multilayer-trigger")

    gmpls_uni_user_trigger = Enum.YLeaf(30, "gmpls-uni-user-trigger")

    path_selection_tiebreaker_change_trigger = Enum.YLeaf(31, "path-selection-tiebreaker-change-trigger")

    sr_egress_path_change_trigger = Enum.YLeaf(32, "sr-egress-path-change-trigger")

    overload_bit_trigger = Enum.YLeaf(33, "overload-bit-trigger")

    pce_trigger = Enum.YLeaf(34, "pce-trigger")

    lockout_metric_trigger = Enum.YLeaf(35, "lockout-metric-trigger")

    bfd_session_config_change_trigger = Enum.YLeaf(36, "bfd-session-config-change-trigger")

    higher_priority_po_change_trigger = Enum.YLeaf(37, "higher-priority-po-change-trigger")

    sr_area_spf_support_change_trigger = Enum.YLeaf(38, "sr-area-spf-support-change-trigger")

    trigger_not_used = Enum.YLeaf(39, "trigger-not-used")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MteReoptTrigger']


class MteTunnelAdminState(Enum):
    """
    MteTunnelAdminState (Enum Class)

    Tunnel admin state

    .. data:: tunnel_state_admin_unknown = 0

    	Tunnel is in unknown state

    .. data:: admin_shutdown = 1

    	Tunnel is in admin shutdown state

    .. data:: admin_up = 2

    	Tunnel is in admin up state

    """

    tunnel_state_admin_unknown = Enum.YLeaf(0, "tunnel-state-admin-unknown")

    admin_shutdown = Enum.YLeaf(1, "admin-shutdown")

    admin_up = Enum.YLeaf(2, "admin-up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MteTunnelAdminState']


class MteTunnelOperState(Enum):
    """
    MteTunnelOperState (Enum Class)

    Tunnel operational state

    .. data:: tunnel_state_oper_unknown = 0

    	Tunnel is in unknown state

    .. data:: operational_down = 1

    	Tunnel is in operational down state

    .. data:: operational_up = 2

    	Tunnel is in operational up state

    """

    tunnel_state_oper_unknown = Enum.YLeaf(0, "tunnel-state-oper-unknown")

    operational_down = Enum.YLeaf(1, "operational-down")

    operational_up = Enum.YLeaf(2, "operational-up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MteTunnelOperState']


class Otu(Enum):
    """
    Otu (Enum Class)

    OTU types

    .. data:: non_otu = 0

    	Type Non OTU

    .. data:: otu1 = 1

    	Type OTU1

    .. data:: otu1e = 2

    	Type OTU1E

    .. data:: otu1f = 3

    	Type OTU1F

    .. data:: otu2 = 4

    	Type OTU2

    .. data:: otu3 = 5

    	Type 0TU3

    .. data:: otu4 = 6

    	Type OTU4

    .. data:: otu2e = 7

    	Type OTU2E

    .. data:: otu2f = 8

    	Type OTU2F

    .. data:: otu3e1 = 9

    	Type OTU3E1

    .. data:: otu3e2 = 10

    	Type OTU3E2

    .. data:: otuc2 = 11

    	Type OTUC2

    .. data:: otuc4 = 12

    	Type OTUC4

    """

    non_otu = Enum.YLeaf(0, "non-otu")

    otu1 = Enum.YLeaf(1, "otu1")

    otu1e = Enum.YLeaf(2, "otu1e")

    otu1f = Enum.YLeaf(3, "otu1f")

    otu2 = Enum.YLeaf(4, "otu2")

    otu3 = Enum.YLeaf(5, "otu3")

    otu4 = Enum.YLeaf(6, "otu4")

    otu2e = Enum.YLeaf(7, "otu2e")

    otu2f = Enum.YLeaf(8, "otu2f")

    otu3e1 = Enum.YLeaf(9, "otu3e1")

    otu3e2 = Enum.YLeaf(10, "otu3e2")

    otuc2 = Enum.YLeaf(11, "otuc2")

    otuc4 = Enum.YLeaf(12, "otuc4")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['Otu']


class PceLspAutorouteMetric(Enum):
    """
    PceLspAutorouteMetric (Enum Class)

    Autoroute Metric Type

    .. data:: none = 0

    	None

    .. data:: relative = 1

    	Relative

    .. data:: absolute = 2

    	Absolute

    """

    none = Enum.YLeaf(0, "none")

    relative = Enum.YLeaf(1, "relative")

    absolute = Enum.YLeaf(2, "absolute")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceLspAutorouteMetric']


class PceLspOperState(Enum):
    """
    PceLspOperState (Enum Class)

    LSP Operational state

    .. data:: down = 0

    	Down

    .. data:: up = 1

    	Up

    .. data:: active = 2

    	Active

    .. data:: going_down = 3

    	Going down

    .. data:: going_up = 4

    	Going Up

    """

    down = Enum.YLeaf(0, "down")

    up = Enum.YLeaf(1, "up")

    active = Enum.YLeaf(2, "active")

    going_down = Enum.YLeaf(3, "going-down")

    going_up = Enum.YLeaf(4, "going-up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceLspOperState']


class PceSrSid(Enum):
    """
    PceSrSid (Enum Class)

    PCE SID type

    .. data:: unknown_segment_id = 0

    	Unknown type

    .. data:: ipv4_node_segment_id = 1

    	IPv4 Node ID

    .. data:: ipv4_adjacency_segment_id = 2

    	IPv4 Adjacency ID

    """

    unknown_segment_id = Enum.YLeaf(0, "unknown-segment-id")

    ipv4_node_segment_id = Enum.YLeaf(1, "ipv4-node-segment-id")

    ipv4_adjacency_segment_id = Enum.YLeaf(2, "ipv4-adjacency-segment-id")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceSrSid']


class PceState(Enum):
    """
    PceState (Enum Class)

    PCE State

    .. data:: tcp_close = 0

    	TCP close

    .. data:: tcp_listen = 1

    	TCP listen

    .. data:: tcp_connect = 2

    	TCP connect

    .. data:: pcep_closed = 3

    	PCEP closed

    .. data:: pcep_opening = 4

    	PCEP opening

    .. data:: pcep_open = 5

    	PCEP open

    """

    tcp_close = Enum.YLeaf(0, "tcp-close")

    tcp_listen = Enum.YLeaf(1, "tcp-listen")

    tcp_connect = Enum.YLeaf(2, "tcp-connect")

    pcep_closed = Enum.YLeaf(3, "pcep-closed")

    pcep_opening = Enum.YLeaf(4, "pcep-opening")

    pcep_open = Enum.YLeaf(5, "pcep-open")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceState']


class PceTunPathState(Enum):
    """
    PceTunPathState (Enum Class)

    PCE Request State

    .. data:: state_none = 0

    	None

    .. data:: state_pending = 1

    	Request Pending

    .. data:: state_received_path = 2

    	Path Received

    .. data:: state_no_peer = 3

    	No peer to forward

    .. data:: state_pcep_down = 4

    	PCEP to the peer is down

    .. data:: state_received_no_path = 5

    	Path Received No Path

    """

    state_none = Enum.YLeaf(0, "state-none")

    state_pending = Enum.YLeaf(1, "state-pending")

    state_received_path = Enum.YLeaf(2, "state-received-path")

    state_no_peer = Enum.YLeaf(3, "state-no-peer")

    state_pcep_down = Enum.YLeaf(4, "state-pcep-down")

    state_received_no_path = Enum.YLeaf(5, "state-received-no-path")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceTunPathState']


class PceTunnelState(Enum):
    """
    PceTunnelState (Enum Class)

    PCE Tunnel State

    .. data:: tunnel_state_none = 0

    	None

    .. data:: tunnel_state_admin_down = 1

    	AdminDown

    .. data:: tunnel_state_down = 2

    	Down

    .. data:: tunnel_state_up = 3

    	Up

    """

    tunnel_state_none = Enum.YLeaf(0, "tunnel-state-none")

    tunnel_state_admin_down = Enum.YLeaf(1, "tunnel-state-admin-down")

    tunnel_state_down = Enum.YLeaf(2, "tunnel-state-down")

    tunnel_state_up = Enum.YLeaf(3, "tunnel-state-up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['PceTunnelState']


class ResourceProvider(Enum):
    """
    ResourceProvider (Enum Class)

    The resource provider type

    .. data:: resource_provider_none = 0

    	Unknown

    .. data:: packet_switch_capable = 1

    	Packet Switch Capable

    .. data:: time_division_multiplex = 2

    	TDM - SONET/SDH

    .. data:: lambda_switch_capable = 3

    	Lambda Switch Capable

    .. data:: fiber_switch_capable = 4

    	Fiber Switch Capable

    .. data:: g709odu_capable = 5

    	Resource provider of type G709-ODU

    """

    resource_provider_none = Enum.YLeaf(0, "resource-provider-none")

    packet_switch_capable = Enum.YLeaf(1, "packet-switch-capable")

    time_division_multiplex = Enum.YLeaf(2, "time-division-multiplex")

    lambda_switch_capable = Enum.YLeaf(3, "lambda-switch-capable")

    fiber_switch_capable = Enum.YLeaf(4, "fiber-switch-capable")

    g709odu_capable = Enum.YLeaf(5, "g709odu-capable")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['ResourceProvider']


class RrrDsteMigrationMode(Enum):
    """
    RrrDsteMigrationMode (Enum Class)

    DS\-TE migration mode

    .. data:: rrr_dste_mode_none = 0

    	No DSTE mode set

    .. data:: rrr_dste_mode_prestandard = 1

    	Pre-standard DSTE

    .. data:: rrr_dste_mode_standard = 3

    	IETF-standard DSTE

    """

    rrr_dste_mode_none = Enum.YLeaf(0, "rrr-dste-mode-none")

    rrr_dste_mode_prestandard = Enum.YLeaf(1, "rrr-dste-mode-prestandard")

    rrr_dste_mode_standard = Enum.YLeaf(3, "rrr-dste-mode-standard")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['RrrDsteMigrationMode']


class RsvpMgmtEroSubobj(Enum):
    """
    RsvpMgmtEroSubobj (Enum Class)

    RSVP ERO Types

    .. data:: rsvp_mgmt_ero_type_ipv4 = 1

    	IPv4 ERO Type

    .. data:: rsvp_mgmt_ero_type_un_num = 4

    	Unnumbered ERO Type

    """

    rsvp_mgmt_ero_type_ipv4 = Enum.YLeaf(1, "rsvp-mgmt-ero-type-ipv4")

    rsvp_mgmt_ero_type_un_num = Enum.YLeaf(4, "rsvp-mgmt-ero-type-un-num")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['RsvpMgmtEroSubobj']


class RsvpMgmtEroSubobjStatus(Enum):
    """
    RsvpMgmtEroSubobjStatus (Enum Class)

    RSVP ERO Status

    .. data:: rsvp_mgmt_ero_status_not_available = 0

    	ERO is not available in topology

    .. data:: rsvp_mgmt_ero_status_available = 1

    	ERO is available in topology

    .. data:: rsvp_mgmt_ero_status_bw_not_available = 2

    	ERO doesn't have bw available in topology

    """

    rsvp_mgmt_ero_status_not_available = Enum.YLeaf(0, "rsvp-mgmt-ero-status-not-available")

    rsvp_mgmt_ero_status_available = Enum.YLeaf(1, "rsvp-mgmt-ero-status-available")

    rsvp_mgmt_ero_status_bw_not_available = Enum.YLeaf(2, "rsvp-mgmt-ero-status-bw-not-available")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['RsvpMgmtEroSubobjStatus']


class RsvpMgmtRroSubobj(Enum):
    """
    RsvpMgmtRroSubobj (Enum Class)

    RSVP RRO Types

    .. data:: ipv4rro_type = 1

    	IPv4 RRO Type

    .. data:: label_rro_type = 3

    	Label RRO Type

    .. data:: unnumbered_rro_type = 4

    	Unnumbered RRO Type

    .. data:: srlg_rro_type = 34

    	SRLG RRO Type

    """

    ipv4rro_type = Enum.YLeaf(1, "ipv4rro-type")

    label_rro_type = Enum.YLeaf(3, "label-rro-type")

    unnumbered_rro_type = Enum.YLeaf(4, "unnumbered-rro-type")

    srlg_rro_type = Enum.YLeaf(34, "srlg-rro-type")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['RsvpMgmtRroSubobj']


class SignalingAgentEnum(Enum):
    """
    SignalingAgentEnum (Enum Class)

    Deprecated \- Signaling Agent

    .. data:: no_signaling = 0

    	Deprecated - No signaling protocol configured

    .. data:: rsvp_signaling = 1

    	Deprecated - RSVP is the signaling protocol

    """

    no_signaling = Enum.YLeaf(0, "no-signaling")

    rsvp_signaling = Enum.YLeaf(1, "rsvp-signaling")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['SignalingAgentEnum']


class TeAcl(Enum):
    """
    TeAcl (Enum Class)

    Te acl

    .. data:: acl_type_unknown = 0

    	Unknown type of ACL

    .. data:: acl_type_access_list = 1

    	Access-list type of ACL

    .. data:: acl_type_prefix_list = 2

    	Prefix-list type of ACL

    .. data:: acl_type_unregistered = 3

    	ACL failed to register to ACL infra

    """

    acl_type_unknown = Enum.YLeaf(0, "acl-type-unknown")

    acl_type_access_list = Enum.YLeaf(1, "acl-type-access-list")

    acl_type_prefix_list = Enum.YLeaf(2, "acl-type-prefix-list")

    acl_type_unregistered = Enum.YLeaf(3, "acl-type-unregistered")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAcl']


class TeAddr(Enum):
    """
    TeAddr (Enum Class)

    TE Address Types

    .. data:: not_set = 0

    	Address not set

    .. data:: ipv4 = 1

    	IPv4

    .. data:: ipv4_unnumbered = 2

    	IPv4 Unnumbered

    """

    not_set = Enum.YLeaf(0, "not-set")

    ipv4 = Enum.YLeaf(1, "ipv4")

    ipv4_unnumbered = Enum.YLeaf(2, "ipv4-unnumbered")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAddr']


class TeAffinityTable(Enum):
    """
    TeAffinityTable (Enum Class)

    Affinity Table IDs

    .. data:: affinity_table_mapping = 0

    	Mapping affinity table

    .. data:: affinity_table_forward_reference = 1

    	Forward reference affinity table

    .. data:: affinity_table_count = 2

    	Number of affinity tables

    """

    affinity_table_mapping = Enum.YLeaf(0, "affinity-table-mapping")

    affinity_table_forward_reference = Enum.YLeaf(1, "affinity-table-forward-reference")

    affinity_table_count = Enum.YLeaf(2, "affinity-table-count")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAffinityTable']


class TeApsSncMode(Enum):
    """
    TeApsSncMode (Enum Class)

    APS ANC Modes

    .. data:: snc_mode_not_set = 0

    	TE OTN Subnetwork Connection Mode Not Set

    .. data:: snc_mode_n = 1

    	TE OTN Subnetwork Connection Mode N

    .. data:: snc_mode_i = 2

    	TE OTN Subnetwork Connection Mode I

    .. data:: snc_mode_s = 3

    	TE OTN Subnetwork Connection Mode S

    """

    snc_mode_not_set = Enum.YLeaf(0, "snc-mode-not-set")

    snc_mode_n = Enum.YLeaf(1, "snc-mode-n")

    snc_mode_i = Enum.YLeaf(2, "snc-mode-i")

    snc_mode_s = Enum.YLeaf(3, "snc-mode-s")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeApsSncMode']


class TeAssociationTieRole(Enum):
    """
    TeAssociationTieRole (Enum Class)

    TE Association Tie Breaker Role

    .. data:: none = 0

    	Association Role None

    .. data:: master = 1

    	Association Role Master

    .. data:: slave = 2

    	Association Role Slave

    """

    none = Enum.YLeaf(0, "none")

    master = Enum.YLeaf(1, "master")

    slave = Enum.YLeaf(2, "slave")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAssociationTieRole']


class TeAttributeSetSrPrepend(Enum):
    """
    TeAttributeSetSrPrepend (Enum Class)

    Attribute Set SR prepend type

    .. data:: te_attribute_set_sr_prepend_not_set = 0

    	Not set

    .. data:: te_attribute_set_sr_prepend_next_label = 1

    	Next label

    .. data:: te_attribute_set_sr_prepend_bgp_nhop = 2

    	BGP NHOP

    """

    te_attribute_set_sr_prepend_not_set = Enum.YLeaf(0, "te-attribute-set-sr-prepend-not-set")

    te_attribute_set_sr_prepend_next_label = Enum.YLeaf(1, "te-attribute-set-sr-prepend-next-label")

    te_attribute_set_sr_prepend_bgp_nhop = Enum.YLeaf(2, "te-attribute-set-sr-prepend-bgp-nhop")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAttributeSetSrPrepend']


class TeAutoTunExpPathHop(Enum):
    """
    TeAutoTunExpPathHop (Enum Class)

    Auto tunnel hop type

    .. data:: ipv4_address_type = 0

    	IPv4 Address Type

    .. data:: mpls_label_type = 1

    	MPLS Label Type

    .. data:: ipv4_and_label_type = 2

    	IPv4 Address and MPLS Label Type

    """

    ipv4_address_type = Enum.YLeaf(0, "ipv4-address-type")

    mpls_label_type = Enum.YLeaf(1, "mpls-label-type")

    ipv4_and_label_type = Enum.YLeaf(2, "ipv4-and-label-type")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAutoTunExpPathHop']


class TeAutobwAppRej(Enum):
    """
    TeAutobwAppRej (Enum Class)

    Reason for auto\-bandwidth application rejection

    .. data:: application_allowed = 0

    	Application allowed

    .. data:: auto_bw_disabled = 1

    	Auto-bw disabled

    .. data:: tunnel_is_down = 2

    	TunnelIsDown

    .. data:: tunnel_is_frr = 3

    	TunnelIsFRRActive

    .. data:: tunnel_is_backup = 4

    	TunnelIsBackup

    .. data:: tunnel_is_lock_down = 5

    	TunnelIsLockdown

    """

    application_allowed = Enum.YLeaf(0, "application-allowed")

    auto_bw_disabled = Enum.YLeaf(1, "auto-bw-disabled")

    tunnel_is_down = Enum.YLeaf(2, "tunnel-is-down")

    tunnel_is_frr = Enum.YLeaf(3, "tunnel-is-frr")

    tunnel_is_backup = Enum.YLeaf(4, "tunnel-is-backup")

    tunnel_is_lock_down = Enum.YLeaf(5, "tunnel-is-lock-down")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAutobwAppRej']


class TeAutobwAppTrigger(Enum):
    """
    TeAutobwAppTrigger (Enum Class)

    Auto\-bandwidth application trigger

    .. data:: application_none = 0

    	No BW Application

    .. data:: application_periodic = 1

    	BW Application Periodic

    .. data:: application_manual = 2

    	BW Application Manual

    .. data:: application_overflow = 3

    	BW Application Overflow

    .. data:: application_underflow = 4

    	BW Application Underflow

    """

    application_none = Enum.YLeaf(0, "application-none")

    application_periodic = Enum.YLeaf(1, "application-periodic")

    application_manual = Enum.YLeaf(2, "application-manual")

    application_overflow = Enum.YLeaf(3, "application-overflow")

    application_underflow = Enum.YLeaf(4, "application-underflow")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeAutobwAppTrigger']


class TeBfdLspSessionState(Enum):
    """
    TeBfdLspSessionState (Enum Class)

    TE BFDOverLSP Session State

    .. data:: bfd_over_lsp_session_state_none = 0

    	BFDOverLSP session state none

    .. data:: bfd_over_lsp_session_state_created = 1

    	BFDOverLSP session state created

    .. data:: bfd_over_lsp_session_state_up = 2

    	BFDOverLSP session state up

    .. data:: bfd_over_lsp_session_state_down = 3

    	BFDOverLSP session state down

    .. data:: bfd_over_lsp_session_state_admin_down = 4

    	BFDOverLSP session state admin down

    .. data:: bfd_over_lsp_session_state_deleted = 5

    	BFDOverLSP sesssion state deleted

    .. data:: bfd_over_lsp_session_state_create_failed = 6

    	BFDOverLSP session state create failed

    """

    bfd_over_lsp_session_state_none = Enum.YLeaf(0, "bfd-over-lsp-session-state-none")

    bfd_over_lsp_session_state_created = Enum.YLeaf(1, "bfd-over-lsp-session-state-created")

    bfd_over_lsp_session_state_up = Enum.YLeaf(2, "bfd-over-lsp-session-state-up")

    bfd_over_lsp_session_state_down = Enum.YLeaf(3, "bfd-over-lsp-session-state-down")

    bfd_over_lsp_session_state_admin_down = Enum.YLeaf(4, "bfd-over-lsp-session-state-admin-down")

    bfd_over_lsp_session_state_deleted = Enum.YLeaf(5, "bfd-over-lsp-session-state-deleted")

    bfd_over_lsp_session_state_create_failed = Enum.YLeaf(6, "bfd-over-lsp-session-state-create-failed")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeBfdLspSessionState']


class TeBfdReversePath(Enum):
    """
    TeBfdReversePath (Enum Class)

    BFD Reverse Path Type

    .. data:: bfd_reverse_path_none = 0

    	BFD reverse path not enabled

    .. data:: bfd_reverse_path_binding_label = 1

    	BFD reverse path binding label

    """

    bfd_reverse_path_none = Enum.YLeaf(0, "bfd-reverse-path-none")

    bfd_reverse_path_binding_label = Enum.YLeaf(1, "bfd-reverse-path-binding-label")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeBfdReversePath']


class TeControllerState(Enum):
    """
    TeControllerState (Enum Class)

    Controller States

    .. data:: notready = 0

    	Controller not ready

    .. data:: admin_down = 1

    	Controller is admin down

    .. data:: down = 2

    	Controller is operationally down

    .. data:: shutdown = 3

    	Controller is shutdown

    .. data:: error_disabled = 4

    	Controller is disabled due to error

    .. data:: up = 5

    	Controller is operationally up

    .. data:: unknown = 6

    	Controller state unknown

    """

    notready = Enum.YLeaf(0, "notready")

    admin_down = Enum.YLeaf(1, "admin-down")

    down = Enum.YLeaf(2, "down")

    shutdown = Enum.YLeaf(3, "shutdown")

    error_disabled = Enum.YLeaf(4, "error-disabled")

    up = Enum.YLeaf(5, "up")

    unknown = Enum.YLeaf(6, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeControllerState']


class TeDestinationState(Enum):
    """
    TeDestinationState (Enum Class)

    P2MP destination state

    .. data:: destination_disabled = 0

    	The destination is disabled in configuration

    .. data:: destination_down = 1

    	The destination is down

    .. data:: destination_up = 2

    	The destination is up

    """

    destination_disabled = Enum.YLeaf(0, "destination-disabled")

    destination_down = Enum.YLeaf(1, "destination-down")

    destination_up = Enum.YLeaf(2, "destination-up")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeDestinationState']


class TeHopLimitIgnore(Enum):
    """
    TeHopLimitIgnore (Enum Class)

    Te hop limit ignore

    .. data:: ignore_unknown = 0

    	Ignore for an unknown reason

    .. data:: ignore_explicit = 1

    	Ignore due to explicit path option

    .. data:: ignore_pce = 2

    	Ignore due to PCE path option

    """

    ignore_unknown = Enum.YLeaf(0, "ignore-unknown")

    ignore_explicit = Enum.YLeaf(1, "ignore-explicit")

    ignore_pce = Enum.YLeaf(2, "ignore-pce")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeHopLimitIgnore']


class TeLspPathProtectionRole(Enum):
    """
    TeLspPathProtectionRole (Enum Class)

    Protection Role

    .. data:: protection_role_not_set = 0

    	Protection role not set

    .. data:: protection_role_working = 1

    	Working

    .. data:: protection_role_protecting = 2

    	Protecting

    .. data:: protection_role_pending = 3

    	Pending

    """

    protection_role_not_set = Enum.YLeaf(0, "protection-role-not-set")

    protection_role_working = Enum.YLeaf(1, "protection-role-working")

    protection_role_protecting = Enum.YLeaf(2, "protection-role-protecting")

    protection_role_pending = Enum.YLeaf(3, "protection-role-pending")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeLspPathProtectionRole']


class TeMeshgroup(Enum):
    """
    TeMeshgroup (Enum Class)

    Te meshgroup

    .. data:: meshgroup_type_automesh = 0

    	automesh type of Meshgroup

    .. data:: meshgroup_type_onehop = 1

    	onehop type of Meshgroup

    """

    meshgroup_type_automesh = Enum.YLeaf(0, "meshgroup-type-automesh")

    meshgroup_type_onehop = Enum.YLeaf(1, "meshgroup-type-onehop")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeMeshgroup']


class TeMgmtGenericFspec(Enum):
    """
    TeMgmtGenericFspec (Enum Class)

    TE generic FSpec types

    .. data:: te_generic_fspec_type_g709otn = 0

    	TE G709 OTN FSpec type

    """

    te_generic_fspec_type_g709otn = Enum.YLeaf(0, "te-generic-fspec-type-g709otn")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeMgmtGenericFspec']


class TeMgmtGenericTspec(Enum):
    """
    TeMgmtGenericTspec (Enum Class)

    TE generic TSpec types

    .. data:: te_generic_tspec_type_g709otn = 0

    	TE G709 OTN TSpec type

    """

    te_generic_tspec_type_g709otn = Enum.YLeaf(0, "te-generic-tspec-type-g709otn")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeMgmtGenericTspec']


class TeOduCapability(Enum):
    """
    TeOduCapability (Enum Class)

    Te ODU Capability Types

    .. data:: not_set = 0

    	Odu capability Type Not Set

    .. data:: fixed = 1

    	Fixed ODUs

    .. data:: flex = 2

    	Flex ODUs

    """

    not_set = Enum.YLeaf(0, "not-set")

    fixed = Enum.YLeaf(1, "fixed")

    flex = Enum.YLeaf(2, "flex")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeOduCapability']


class TeOduLevel(Enum):
    """
    TeOduLevel (Enum Class)

    G.709 OTN ODU levels

    .. data:: te_odu_level_not_set = 0

    	Not set

    .. data:: te_odu_level_one = 1

    	ODU 1

    .. data:: te_odu_level_two = 2

    	ODU 2

    .. data:: te_odu_level_three = 3

    	ODU 3

    .. data:: te_odu_level_four = 4

    	ODU 4

    .. data:: te_odu_zero = 10

    	ODU 0

    .. data:: te_odu_level_two_e = 11

    	ODU 2E

    .. data:: te_odu_level_flex_cbr = 20

    	ODU Flex CBR

    .. data:: te_odu_level_flex_gfpf_resizeable = 21

    	ODU Flex GFP-F resizable

    .. data:: te_odu_level_flex_gfpf_non_resizable = 22

    	ODU Flex GFP-F non resizable

    .. data:: te_odu_level_one_e = 23

    	ODU 1E

    .. data:: te_odu_level_one_f = 24

    	ODU 1F

    .. data:: te_odu_level_two_f = 25

    	ODU 2F

    .. data:: te_odu_level_three_e_one = 26

    	ODU 3E1

    .. data:: te_odu_level_three_e_two = 27

    	ODU 3E2

    .. data:: te_odu_level_c_two = 38

    	ODU C2

    .. data:: te_odu_level_c_three = 39

    	ODU C3

    .. data:: te_odu_level_c_four = 40

    	ODU C4

    """

    te_odu_level_not_set = Enum.YLeaf(0, "te-odu-level-not-set")

    te_odu_level_one = Enum.YLeaf(1, "te-odu-level-one")

    te_odu_level_two = Enum.YLeaf(2, "te-odu-level-two")

    te_odu_level_three = Enum.YLeaf(3, "te-odu-level-three")

    te_odu_level_four = Enum.YLeaf(4, "te-odu-level-four")

    te_odu_zero = Enum.YLeaf(10, "te-odu-zero")

    te_odu_level_two_e = Enum.YLeaf(11, "te-odu-level-two-e")

    te_odu_level_flex_cbr = Enum.YLeaf(20, "te-odu-level-flex-cbr")

    te_odu_level_flex_gfpf_resizeable = Enum.YLeaf(21, "te-odu-level-flex-gfpf-resizeable")

    te_odu_level_flex_gfpf_non_resizable = Enum.YLeaf(22, "te-odu-level-flex-gfpf-non-resizable")

    te_odu_level_one_e = Enum.YLeaf(23, "te-odu-level-one-e")

    te_odu_level_one_f = Enum.YLeaf(24, "te-odu-level-one-f")

    te_odu_level_two_f = Enum.YLeaf(25, "te-odu-level-two-f")

    te_odu_level_three_e_one = Enum.YLeaf(26, "te-odu-level-three-e-one")

    te_odu_level_three_e_two = Enum.YLeaf(27, "te-odu-level-three-e-two")

    te_odu_level_c_two = Enum.YLeaf(38, "te-odu-level-c-two")

    te_odu_level_c_three = Enum.YLeaf(39, "te-odu-level-c-three")

    te_odu_level_c_four = Enum.YLeaf(40, "te-odu-level-c-four")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeOduLevel']


class TeP2mpS2lDeletionCause(Enum):
    """
    TeP2mpS2lDeletionCause (Enum Class)

    S2L Deletion location

    .. data:: no_cause = 0

    	No cause recorded

    .. data:: hpath_cr_err = 1

    	Head Path creation

    .. data:: hpath_chg_setup = 2

    	Head Path change setup

    .. data:: hpath_chg_up_err = 3

    	Head Path change while up

    .. data:: hresv_cr_err = 4

    	Head RESV creation

    .. data:: hresv_chg_err = 5

    	Head RESV change

    .. data:: hresv_chg_err_up = 6

    	Head RESV change while up

    .. data:: hlbl_avail_err = 7

    	Head Label available

    .. data:: hup_lbl_avail_err = 8

    	Head upstream Label available

    .. data:: hfrr_act_err = 9

    	Head FRR active

    .. data:: hbkup_ch_err = 10

    	Head Backup change

    .. data:: hpath_ch_frr_err = 11

    	Head Path change FRR

    .. data:: hcleanup = 12

    	Head Cleanup handling

    .. data:: hlingering_cleanup = 13

    	Head lingering cleanup

    .. data:: hpat_err = 14

    	Head Path error

    .. data:: hresv_err = 15

    	Head Resv error

    .. data:: hresv_del = 16

    	Head Resv delete

    .. data:: hrw_fail = 17

    	Head rewrite failure

    .. data:: hup_rw_fail = 18

    	Head upstream rewrite failure

    .. data:: ha_failure = 19

    	HA failure

    .. data:: rw_del = 20

    	Rewrite Delete

    .. data:: up_rw_del = 21

    	Upstream Rewrite Delete

    .. data:: mpath_cr = 22

    	Mid path creation

    .. data:: mpath_chg_setup_err = 23

    	Mid Path change setup

    .. data:: mpath_chg_up_err = 24

    	Mid Path change while up

    .. data:: mresv_cr_err = 25

    	Mid Resv creation

    .. data:: mresv_chg_err = 26

    	Mid Resv change

    .. data:: mresv_chg_err_up = 27

    	Mid Resv change while up

    .. data:: mlbl_avail_err = 28

    	Mid: cannot get local label

    .. data:: mlbl_rel_err = 29

    	Mid: cannot release local label

    .. data:: mup_lbl_avail_err = 30

    	Mid: cannot get upstream label

    .. data:: mup_lbl_rel_err = 31

    	Mid: cannot release upstream label

    .. data:: mfrr_act_err = 32

    	Mid FRR active

    .. data:: mbkup_ch_err = 33

    	Mid Backup change

    .. data:: mpath_ch_frr_err = 34

    	Mid Path change FRR

    .. data:: mresv_del = 35

    	Mid Resv Delete handling

    .. data:: mresv_err = 36

    	Mid Resv Error handling

    .. data:: mpreempt = 37

    	Mid Premption

    .. data:: mcleanup = 38

    	Mid Cleanup handling

    .. data:: mlingering_cleanup = 39

    	Mid lingering cleanup

    .. data:: mrw_fail = 40

    	mid rewrite failure

    .. data:: mup_rw_fail = 41

    	mid upstream rewrite failure

    .. data:: tpath_cr_err = 42

    	Tail Path creation

    .. data:: tpath_chg_err = 43

    	Tail Path change

    .. data:: tresv_cr_err = 44

    	Tail RESV creation

    .. data:: tlbl_avail_err = 45

    	Tail: cannot release local label

    .. data:: tcleanup = 46

    	Tail Cleanup

    .. data:: tlingering_cleanup = 47

    	Tail lingering cleanup

    .. data:: lbl_err = 48

    	Local label related error

    .. data:: qfailure = 49

    	FSM Queueing failure

    .. data:: rsvp_recovery = 50

    	RSVP Recovery

    .. data:: lsd_recovery = 51

    	LSD Recovery

    .. data:: lmrib_recovery = 52

    	LMRIB Recovery

    .. data:: te_restart = 53

    	TE Restart

    .. data:: switchover = 54

    	Switchover

    .. data:: master_te_recovery = 55

    	Master TE recovery

    .. data:: optical_r_mgr_recovery = 56

    	Optical Resource Manager Recovery

    .. data:: te_exit = 57

    	TE Exited

    .. data:: bkup_assign_fail = 58

    	RSVP Backup Assign Failed

    .. data:: bfd_fail = 59

    	BFD Session Failure

    .. data:: bfd_recovery = 60

    	BFD Recovery

    .. data:: lsp_wrap_act_err = 61

    	Mid LSP Wrap active

    .. data:: lsp_wrap_rw_err = 62

    	Mid LSP Wrap Rewrite

    .. data:: fsm_cause_must_be_last = 63

    	Not used, must be last entry

    """

    no_cause = Enum.YLeaf(0, "no-cause")

    hpath_cr_err = Enum.YLeaf(1, "hpath-cr-err")

    hpath_chg_setup = Enum.YLeaf(2, "hpath-chg-setup")

    hpath_chg_up_err = Enum.YLeaf(3, "hpath-chg-up-err")

    hresv_cr_err = Enum.YLeaf(4, "hresv-cr-err")

    hresv_chg_err = Enum.YLeaf(5, "hresv-chg-err")

    hresv_chg_err_up = Enum.YLeaf(6, "hresv-chg-err-up")

    hlbl_avail_err = Enum.YLeaf(7, "hlbl-avail-err")

    hup_lbl_avail_err = Enum.YLeaf(8, "hup-lbl-avail-err")

    hfrr_act_err = Enum.YLeaf(9, "hfrr-act-err")

    hbkup_ch_err = Enum.YLeaf(10, "hbkup-ch-err")

    hpath_ch_frr_err = Enum.YLeaf(11, "hpath-ch-frr-err")

    hcleanup = Enum.YLeaf(12, "hcleanup")

    hlingering_cleanup = Enum.YLeaf(13, "hlingering-cleanup")

    hpat_err = Enum.YLeaf(14, "hpat-err")

    hresv_err = Enum.YLeaf(15, "hresv-err")

    hresv_del = Enum.YLeaf(16, "hresv-del")

    hrw_fail = Enum.YLeaf(17, "hrw-fail")

    hup_rw_fail = Enum.YLeaf(18, "hup-rw-fail")

    ha_failure = Enum.YLeaf(19, "ha-failure")

    rw_del = Enum.YLeaf(20, "rw-del")

    up_rw_del = Enum.YLeaf(21, "up-rw-del")

    mpath_cr = Enum.YLeaf(22, "mpath-cr")

    mpath_chg_setup_err = Enum.YLeaf(23, "mpath-chg-setup-err")

    mpath_chg_up_err = Enum.YLeaf(24, "mpath-chg-up-err")

    mresv_cr_err = Enum.YLeaf(25, "mresv-cr-err")

    mresv_chg_err = Enum.YLeaf(26, "mresv-chg-err")

    mresv_chg_err_up = Enum.YLeaf(27, "mresv-chg-err-up")

    mlbl_avail_err = Enum.YLeaf(28, "mlbl-avail-err")

    mlbl_rel_err = Enum.YLeaf(29, "mlbl-rel-err")

    mup_lbl_avail_err = Enum.YLeaf(30, "mup-lbl-avail-err")

    mup_lbl_rel_err = Enum.YLeaf(31, "mup-lbl-rel-err")

    mfrr_act_err = Enum.YLeaf(32, "mfrr-act-err")

    mbkup_ch_err = Enum.YLeaf(33, "mbkup-ch-err")

    mpath_ch_frr_err = Enum.YLeaf(34, "mpath-ch-frr-err")

    mresv_del = Enum.YLeaf(35, "mresv-del")

    mresv_err = Enum.YLeaf(36, "mresv-err")

    mpreempt = Enum.YLeaf(37, "mpreempt")

    mcleanup = Enum.YLeaf(38, "mcleanup")

    mlingering_cleanup = Enum.YLeaf(39, "mlingering-cleanup")

    mrw_fail = Enum.YLeaf(40, "mrw-fail")

    mup_rw_fail = Enum.YLeaf(41, "mup-rw-fail")

    tpath_cr_err = Enum.YLeaf(42, "tpath-cr-err")

    tpath_chg_err = Enum.YLeaf(43, "tpath-chg-err")

    tresv_cr_err = Enum.YLeaf(44, "tresv-cr-err")

    tlbl_avail_err = Enum.YLeaf(45, "tlbl-avail-err")

    tcleanup = Enum.YLeaf(46, "tcleanup")

    tlingering_cleanup = Enum.YLeaf(47, "tlingering-cleanup")

    lbl_err = Enum.YLeaf(48, "lbl-err")

    qfailure = Enum.YLeaf(49, "qfailure")

    rsvp_recovery = Enum.YLeaf(50, "rsvp-recovery")

    lsd_recovery = Enum.YLeaf(51, "lsd-recovery")

    lmrib_recovery = Enum.YLeaf(52, "lmrib-recovery")

    te_restart = Enum.YLeaf(53, "te-restart")

    switchover = Enum.YLeaf(54, "switchover")

    master_te_recovery = Enum.YLeaf(55, "master-te-recovery")

    optical_r_mgr_recovery = Enum.YLeaf(56, "optical-r-mgr-recovery")

    te_exit = Enum.YLeaf(57, "te-exit")

    bkup_assign_fail = Enum.YLeaf(58, "bkup-assign-fail")

    bfd_fail = Enum.YLeaf(59, "bfd-fail")

    bfd_recovery = Enum.YLeaf(60, "bfd-recovery")

    lsp_wrap_act_err = Enum.YLeaf(61, "lsp-wrap-act-err")

    lsp_wrap_rw_err = Enum.YLeaf(62, "lsp-wrap-rw-err")

    fsm_cause_must_be_last = Enum.YLeaf(63, "fsm-cause-must-be-last")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeP2mpS2lDeletionCause']


class TeP2mpS2lDeletionSubcause(Enum):
    """
    TeP2mpS2lDeletionSubcause (Enum Class)

    S2L deletion subcause

    .. data:: no_subcause = 0

    	No subcause recorded

    .. data:: cleanup_req = 1

    	Normal cleanup requested

    .. data:: invalid_data = 2

    	Invalid Data passed

    .. data:: fsm_inv_ctxt = 3

    	Invalid FSM context passed in

    .. data:: fsm_inv_ctxt_data = 4

    	Invalid data passed in FSM context

    .. data:: fsm_inv_role = 5

    	Failed due to Invalid Role

    .. data:: ll_failure = 6

    	Local Label get failed

    .. data:: ll_rel_fail = 7

    	Local Label release failed

    .. data:: ll_mismatch = 8

    	Local label mismatch detected

    .. data:: ll_invalid = 9

    	Local label invalid

    .. data:: ll_set_failure = 10

    	Local Label set failed

    .. data:: bad_out_label = 11

    	Bad label received from neighbor

    .. data:: sl_err = 12

    	Failed to process suggested label received from

    	neighbor

    .. data:: rl_mismatch = 13

    	Incorrect recovery label received from neighbor

    .. data:: sl_alloc_err = 14

    	Failed to allocate suggested/ acceptable label

    .. data:: upstream_downstream_label_mismatch = 15

    	Upstream label does not match downstream label

    .. data:: upstream_label_failure = 16

    	Upstream Label get failed

    .. data:: upstream_label_rel_fail = 17

    	Upstream Label release failed

    .. data:: upstream_label_mismatch = 18

    	Upstream label mismatch detected

    .. data:: upstream_label_invalid = 19

    	Upstream label invalid

    .. data:: bad_upstream_label = 20

    	Bad Upstream label

    .. data:: ul_set_failure = 21

    	Upstream Label set failed

    .. data:: gmpls_label_alloc_err = 22

    	Failed to allocate GMPLS Label

    .. data:: gmpls_label_clone_err = 23

    	Failed to clone GMPLS Label

    .. data:: rw_err = 24

    	Unable to perform RW operation

    .. data:: up_rw_err = 25

    	Unable to perform upstream RW operation

    .. data:: path_admit = 26

    	Path admission failure

    .. data:: bw = 27

    	BW allocation failure

    .. data:: admit_resv = 28

    	Reservation admission failure

    .. data:: rrrm_err = 29

    	Resource Reservation removal error

    .. data:: hardware_out_of_resources = 30

    	NPU HW-OOR

    .. data:: comp_rid = 31

    	Failure to compute RID

    .. data:: comp_lcl_rid = 32

    	Failure to compute local RID

    .. data:: comp_up_rid = 33

    	Failure to compute upstream RID

    .. data:: comp_down_rid = 34

    	Failure to compute downstream RID

    .. data:: rest_if_hop = 35

    	Failure to reset IF or HOP

    .. data:: inv_in_if = 36

    	Invalid Ingress IF

    .. data:: nh_err = 37

    	Outgoing IF or Next Hop failure

    .. data:: inv_in_ero = 38

    	Invalid incoming ERO

    .. data:: out_ero_fail = 39

    	Outcoming ERO failure

    .. data:: frr_bk_asssign = 40

    	Frr backup assignment failure

    .. data:: frr_bk_rm = 41

    	Frr backup removal failure

    .. data:: frr_bk_send = 42

    	Frr backup send to RSVP failed

    .. data:: frr_needs_del = 43

    	FRR deletion required

    .. data:: frr_reopt_lsp = 44

    	FRR not allowed on reopt LSP

    .. data:: rsvp_api_h = 45

    	RSVP API Handler Failure

    .. data:: insane_path = 46

    	Invalid Path message

    .. data:: remerge_chk_fail = 47

    	Failed in finding remerge

    .. data:: remerge_detected = 48

    	Remerge detected

    .. data:: xro = 49

    	XRO processing failed

    .. data:: resv_bw_set = 50

    	Failed to set Resv Bandwidth

    .. data:: resv_prep_fail = 51

    	Failed to prepare out Resv

    .. data:: path_ch_proc = 52

    	Failure in path change Processing

    .. data:: path_ch_frr = 53

    	Failure in path change for FRR

    .. data:: path_ch_sess_attri_fl = 54

    	Failure in path change for session attribute

    	flags

    .. data:: path_ch_bw_ch = 55

    	Failure in path change: Bandwidth change not

    	allowed

    .. data:: path_err_proc = 56

    	Failure in path Error Processing

    .. data:: path_err = 57

    	Path Error Rcvd

    .. data:: path_err_wpsr = 58

    	Path Error with PSR flag Rcvd

    .. data:: path_del = 59

    	Path Delete request

    .. data:: resv_ch_proc = 60

    	Failure in Resv change processing

    .. data:: resv_ch_rro = 61

    	Failure in Resv change RRO

    .. data:: resv_del = 62

    	Resv Delete processing

    .. data:: resv_err = 63

    	Resv Error processing

    .. data:: perr_send_fail = 64

    	Failed to send Path Error

    .. data:: perr_proc_fail = 65

    	Failed to process Path Error

    .. data:: perr_rcv = 66

    	Received Path Error

    .. data:: resv_err_rcv = 67

    	Received Resv Error

    .. data:: flowspec = 68

    	Flowspec failure

    .. data:: setup_conn_api_fail = 69

    	S2L State set API failed

    .. data:: path_not_replayed = 70

    	RSVP did not replay the path

    .. data:: resv_not_replayed = 71

    	RSVP did not replay the resv

    .. data:: rewrite_not_replayed = 72

    	LMRIB did not replay rewrite

    .. data:: label_not_replayed = 73

    	RW mgr did not replay rewrite

    .. data:: connection_not_ready = 74

    	TE connection is not ready with LSD/LMRIB/RSVP

    .. data:: master_did_not_replay = 75

    	The master TE did not replay this S2L

    .. data:: head_s2l_has_no_vif = 76

    	S2L head has no associated tunnel VIF

    .. data:: frr_assigned_s2l_has_no_backup = 77

    	FRR-assigned S2L has no backup

    .. data:: frr_assigned_s2l_has_down_backup = 78

    	FRR-assigned S2L has down backup

    .. data:: out_link_down_and_no_frr = 79

    	Outgoing link is down and there is no FRR

    .. data:: collaborator_timeout_rsvp = 80

    	RSVP connection timed out

    .. data:: collaborator_timeout_lsd = 81

    	LSD connection timed out

    .. data:: collaborator_timeout_lmrib = 82

    	LMRIB connection time dout

    .. data:: collaborator_timeout_im = 83

    	IM connection timed out

    .. data:: collaborator_timeout_error = 84

    	Error in processing connection timeout

    .. data:: topo_flush = 85

    	Topology Failure

    .. data:: area_shut = 86

    	IGP Area Shutdown

    .. data:: active_po_del = 87

    	active pathoption deleted

    .. data:: path_verify_failed = 88

    	Path verification failed

    .. data:: srlg_path_verify_failed = 89

    	Srlg Path verification failed

    .. data:: affinity_path_verify_failed = 90

    	Affinity Path verification failed

    .. data:: aff_fail_delayed_tear_timeout_failed = 91

    	Affinity Failure Delayed Tear timeout failed

    .. data:: cost_limit_verify_failed = 92

    	Cost Limit verification failed

    .. data:: delay_limit_verify_failed = 93

    	Delay Limit verification failed

    .. data:: lockout_metric_verify_failed = 94

    	Lockout metric verification failed

    .. data:: path_setup_timeout = 95

    	Path Setup Timed out

    .. data:: vif_destroyed = 96

    	tunnel IF destroyed

    .. data:: vif_shut = 97

    	tunnel IF shutdown

    .. data:: lsp_shut = 98

    	LSP shutdown

    .. data:: gmpls_uni_head = 99

    	link configured to run as GMPLS-UNI head

    .. data:: head_resetup = 100

    	tunnel is to be resetup

    .. data:: none_head_resetup = 101

    	mid or tail tunnel is to be resetup

    .. data:: dest_disabled = 102

    	Destination disabled

    .. data:: iep_ch_act_po = 103

    	Explicit Path changed for inuse path-option

    .. data:: iep_ch_reopt = 104

    	Reopt LSP affected by Explicit Path change

    .. data:: iep_ch_standby = 105

    	Standby LSP affected by Explicit Path change

    .. data:: dste_mode_ch = 106

    	DSTE mode change

    .. data:: reopt_del_frr_act = 107

    	Deleting reopt LSP on FRR active

    .. data:: new_reopt_tear_old = 108

    	New Reopt is in progress, tearing old reopt LSP

    .. data:: reopt_failed_verify = 109

    	Reopt LSP failed verification

    .. data:: reopt_failed_install = 110

    	Reopt LSP failed at install time

    .. data:: reopt_failed_rw = 111

    	Rewrite failed for Reopt LSP

    .. data:: reopt_failed_not_superset = 112

    	Reopt LSP has less number of destinations Up

    	than the current LSP.

    .. data:: dclean_at_install_time = 113

    	Tear delayed clean LSP at install time

    .. data:: dclean_at_clean_timer = 114

    	Tear delayed clean LSP at cleanup timer expiry

    .. data:: dclean_at_reopt_active = 115

    	Tear delayed clean LSP at Reopt Activation

    .. data:: lcl_notif_head = 116

    	Local Link Failure

    .. data:: in_if_fail = 117

    	Failure of ingress IF

    .. data:: out_if_fail = 118

    	Failure of egress IF

    .. data:: if_fail_lc_oir = 119

    	Failure of IF on LC OIR

    .. data:: te_rid_rm = 120

    	TE RID removed

    .. data:: te_rsvp_oos_bkup = 121

    	TE and RSVP are OOS for backup assignment

    .. data:: in_if_fail_exp_null_cfg_ch = 122

    	Explicit null config changed

    .. data:: new_curr_lsp_sig = 123

    	Signaling new current LSP, cleanup old LSP

    .. data:: new_reopt_lsp_sig = 124

    	Signaling new reopt LSP, cleanup old LSP

    .. data:: new_stdby_lsp_sig = 125

    	Signaling new standby LSP, cleanup old LSP

    .. data:: new_restore_lsp_sig = 126

    	Signaling new restore LSP, cleanup old LSP

    .. data:: new_cl_pp_lsp_sig = 127

    	Signaling new clean path-protect LSP, cleanup

    	old LSP

    .. data:: chkpt_recovery_failed = 128

    	Failed to recover LSP from check-point

    .. data:: stdby_cr_failed = 129

    	Failed to create standby LSP

    .. data:: reopt_lsp_rej = 130

    	Reopt LSP is rejected

    .. data:: reopt_po_sw_failed = 131

    	Reopt Path-option switchover failed

    .. data:: failed_to_find_path = 132

    	Failed to find a Path

    .. data:: sig_rcv_fail_path_cr_ch = 133

    	Signaling API failed to proc Path change or

    	create

    .. data:: lsp_db_shut = 134

    	LSP database shutdown

    .. data:: reopt_hold_start = 135

    	Starting holddown for Reopt LSP

    .. data:: vif_lspid_mismatch = 136

    	VIF has no LSP with this ID

    .. data:: s2l_has_no_vif = 137

    	Headend S2L with no associated VIF

    .. data:: overload_reopt_timeout = 138

    	Reoptimization timeout with OL-bit set at

    	midpoint

    .. data:: hop_limit_exceeded = 139

    	Hop Limit Exceeded

    .. data:: lingering_current_lsp = 140

    	Cleanup lingering current LSP

    .. data:: lingering_standby_lsp = 141

    	Cleanup lingering standby LSP

    .. data:: lingering_restore_lsp = 142

    	Cleanup lingering restore LSP

    .. data:: double_lockout = 143

    	Double lock out on the tunnel

    .. data:: lockout_no_protection = 144

    	Lock out on the tunnel with no protection

    	available

    .. data:: lockout_cleanup = 145

    	Lock out on reopt or delayed clean lsp

    .. data:: te_ppsw_lsp_mismatch = 146

    	LSP id of the current mismatched with the PP

    	LSP id in standby

    .. data:: te_stdbyup_no_curr_lsp = 147

    	Standby LSP up but current LSP not found

    .. data:: stdby_failed_rw = 148

    	Rewrite failed for Standby LSP

    .. data:: reopt_lsp_tear_ppsw = 149

    	Reopt LSP teardown because of path protection

    	switchover

    .. data:: delay_pp_lsp_tear_ppsw = 150

    	Delay PP LSP teardown on rew results of path

    	protection switchover

    .. data:: stdby_failed_verify = 151

    	Stdby LSP failed verification

    .. data:: stdby_not_needed_due_to_restore = 152

    	Stdby is not needed since the restore LSP is

    	installed

    .. data:: restore_failed_verify = 153

    	Restore LSP failed verification

    .. data:: restore_failed_install = 154

    	Restore LSP failed at install time

    .. data:: restore_failed_rewrite = 155

    	Restore LSP failed at rewrite

    .. data:: te_ppsw_cfg_rmvd = 156

    	Path protection configuration remove under the

    	tunnel I/F

    .. data:: te_ppsw_manual_ppsw = 157

    	Manual Path protection switchover

    .. data:: te_ppsw_bidir_p_chg_ppsw = 158

    	Bidirectional Path Change protection switchover

    .. data:: te_ppsw_bidir_lockout_ppsw = 159

    	Flex LSP lockout metric protection switchover

    .. data:: dclean_at_pp_clean_timer = 160

    	Tear delayed pp clean LSP at pp cleanup timer

    	expiry

    .. data:: reopt_standby_failed = 161

    	Creating the reopt standby failed

    .. data:: standby_reoptimized = 162

    	Tear down old standby LSP because standby

    	reoptimized

    .. data:: standby_reoptimize_aborted = 163

    	Tear down new standby LSP because switchover is

    	underway

    .. data:: te_reoptup_no_curr_lsp = 164

    	Reopt LSP up but current LSP not found

    .. data:: te_reopt_curr_lsp_down = 165

    	destroying reopt as current LSP torn

    .. data:: te_cleanedt_curr_lsp_down = 166

    	Destroying cleaned as current LSP torn

    .. data:: te_delay_lsp_up = 167

    	Delay clean or pp clean LSP came up

    .. data:: no_route_due_to_affinity = 168

    	No route, no RIB due to affinity

    .. data:: no_rib_lkup_bad_ero_gmpls = 169

    	Skipping RIB Lookup, Bad GMPLS ERO

    .. data:: cleanup_lingering = 170

    	Cleanup in lingering state

    .. data:: te_s2l_del_sc_soft_preemption_timeout = 171

    	Soft preemption timed out

    .. data:: te_s2l_del_sc_soft_preempted_non_current = 172

    	The head S2L was soft preempted while it is not

    	current

    .. data:: te_s2l_del_sc_vif_sync_lsp_del = 173

    	The head S2L was deleted due to LSP deleted in

    	VIF Sync

    .. data:: rsvp_api_cleanup_req = 174

    	RSVP API cleanup requested

    .. data:: te_s2l_del_sc_frr_wrong_backup = 175

    	TE and RSVP FRR active on different backups

    .. data:: te_s2l_del_sc_bfd_session_create_failed = 176

    	The BFD session create failed

    .. data:: te_s2l_del_sc_bfd_session_bringup_timeout = 177

    	The BFD session failed to up before bringup

    	timer timeout

    .. data:: te_s2l_del_sc_bfd_session_down = 178

    	The BFD session went down

    .. data:: te_s2l_del_sc_bfd_session_not_replayed = 179

    	BFD did not replay the session

    .. data:: te_s2l_del_sc_reopt_p2mp_egress_info_fail = 180

    	P2MP egress information programming failed for

    	reoptimized LSP

    .. data:: non_curr_frr_lcl_notif_event = 181

    	FRR local notification event on non-current LSP

    .. data:: unsupported_encoding = 182

    	The encoding type is not supported

    .. data:: unsupported_gpid = 183

    	The GPID is not supported

    .. data:: unsupported_switching_type = 184

    	The switching type is not supported

    .. data:: upstream_label_change_not_permitted = 185

    	Upstream label change is not allowed

    .. data:: encoding_type_change_not_permitted = 186

    	Encoding Type change is not allowed

    .. data:: aps_protect_info_change_failed = 187

    	Failed to process APS Protect info change

    .. data:: incorrect_lsp_type = 188

    	Incorrect or unsupported connection type

    .. data:: local_hop_error = 189

    	Failed to compute local hop

    .. data:: unsupported_gmpls_attributes = 190

    	Incorrect or unsupported GMPLS attributes

    .. data:: gmpls_uni_reopt_triggered = 191

    	GMPLS-UNI reoptimization triggered from network

    .. data:: maximum_acceptable_label_retries = 192

    	Maxed out acceptable upstream label retries

    .. data:: invalid_direction = 193

    	Invalid direction for GMPLS LSP

    .. data:: invalid_rewrite_context = 194

    	Invalid RW context in callback

    .. data:: invalid_label_context = 195

    	Invalid Label context in callback

    .. data:: dwdm_capability_changed = 196

    	DWDM Capability for TE link changed

    .. data:: dwdm_capability_removed = 197

    	DWDM Capability for TE link removed

    .. data:: dwdm_wavelength_removed = 198

    	DWDM wavelength channel attribute for TE link

    	removed

    .. data:: gmpls_uni_multilayer_restoration = 199

    	GMPLS-UNI multilayer restoration

    .. data:: gmpls_uni_user_triggered_reoptimization = 200

    	User-triggered GMPLS-UNI reoptimization

    .. data:: gmpls_uni_active_path_change_triggered_reopt = 201

    	GMPLS-UNI reoptimization triggered by Active

    	Path change

    .. data:: passive_match_err = 202

    	Failed in finding a matching passive vif

    .. data:: egress_control_err = 203

    	Failed in egress control

    .. data:: egress_control_map_err = 204

    	Could not resolve egress control

    .. data:: restore_not_needed_for_current = 205

    	Restore not needed now for current LSP

    .. data:: restore_not_needed_for_standby = 206

    	Restore not needed now for standby LSP

    .. data:: restore_dp_down = 207

    	Restore down in data plane

    .. data:: current_not_needed_dp_down = 208

    	Current not needed now as down in data plane

    .. data:: bad_protct_obj = 209

    	Bad protection object

    .. data:: head_flexi_cap_change = 210

    	Flexi-capability changed at Head node

    .. data:: tail_flexi_cap_change = 211

    	Flexi-capability changed at Tail node

    .. data:: optical_link_down = 212

    	TE optical link down

    .. data:: optical_link_lsp_out_of_sync = 213

    	TE optical link and LSP out of sync

    .. data:: optical_link_owner_out_of_sync = 214

    	TE optical link owner type out of sync

    .. data:: optical_link_interface_handle_out_of_sync = 215

    	TE optical link interface handle out of sync

    .. data:: optical_link_hop_out_of_sync = 216

    	TE optical link next/prev hop out of sync

    .. data:: optical_link_role_out_of_sync = 217

    	TE optical link role out of sync

    .. data:: optical_link_downstream_router_id_out_of_sync = 218

    	TE optical link downstream router-ID out of

    	sync

    .. data:: optical_link_upstream_router_id_out_of_sync = 219

    	TE optical link upstream router-ID out of sync

    .. data:: optical_link_encoding_type_out_of_sync = 220

    	TE optical link encoding type out of sync

    .. data:: optical_link_switching_type_out_of_sync = 221

    	TE optical link switching type out of sync

    .. data:: optical_link_gpid_out_of_sync = 222

    	TE optical link GPID out of sync

    .. data:: egress_optical_link_not_found = 223

    	Egress optical TE link (head) not found

    .. data:: ingress_optical_link_not_found = 224

    	Ingress optical TE link (tail) not found

    .. data:: sync_dest_state = 225

    	Syncing of the destination state change

    .. data:: prot_object_err = 226

    	Protection Object Error

    .. data:: reverse_s2l_deleted = 227

    	Reverse Associated S2L Deleted

    .. data:: cancel_inprogress_by_slave = 228

    	In-progress S2L cancelled by slave

    .. data:: invalid_reverse_ero = 229

    	Bad Reverse ERO

    .. data:: reverse_lsp_not_found = 230

    	Switchover Reverse LSP Not Found

    .. data:: reverse_lsp_not_present = 231

    	Switchover Reverse LSP Not Present

    .. data:: associated_vif_down = 232

    	Associated VIF moved to Down

    .. data:: vif_sync_processing = 233

    	Tunnel interface sync processing caused

    	deletion

    .. data:: incoming_interface_lockout = 234

    	Incoming interface locked out

    .. data:: sr_egress_path_changed = 235

    	SR egress path changed on non-current S2L

    .. data:: in_if_fail_imp_null_cfg_ch = 236

    	Implicit null config changed

    .. data:: reverse_lsp_failure = 237

    	Reverse LSP Failure

    .. data:: lsp_wrap_label_error = 238

    	LSP Wrap Label Error

    .. data:: lsp_wrap_rewrite_error = 239

    	LSP Wrap Rewrite Error

    .. data:: transit_lsp_out_of_resources = 240

    	LSP OOR

    .. data:: path_protection_configuration_change = 241

    	Path protection configuration changed under the

    	tunnel I/F

    .. data:: better_standby_path = 242

    	Better standby path exists

    .. data:: path_option_config_change = 243

    	Path-option configuration change

    .. data:: path_protection_non_revertive_config_changed = 244

    	Path protection non-revertive config changed

    	under the tunnel I/F

    .. data:: manually_triggered_non_revertive_recovery = 245

    	Manually triggered non-revertive recovery

    .. data:: remote_node_triggered_non_revertive_recovery = 246

    	Received non-revertive recovery notification

    	from remote node

    .. data:: fsm_sc_must_be_last = 247

    	Not used, must be last entry

    """

    no_subcause = Enum.YLeaf(0, "no-subcause")

    cleanup_req = Enum.YLeaf(1, "cleanup-req")

    invalid_data = Enum.YLeaf(2, "invalid-data")

    fsm_inv_ctxt = Enum.YLeaf(3, "fsm-inv-ctxt")

    fsm_inv_ctxt_data = Enum.YLeaf(4, "fsm-inv-ctxt-data")

    fsm_inv_role = Enum.YLeaf(5, "fsm-inv-role")

    ll_failure = Enum.YLeaf(6, "ll-failure")

    ll_rel_fail = Enum.YLeaf(7, "ll-rel-fail")

    ll_mismatch = Enum.YLeaf(8, "ll-mismatch")

    ll_invalid = Enum.YLeaf(9, "ll-invalid")

    ll_set_failure = Enum.YLeaf(10, "ll-set-failure")

    bad_out_label = Enum.YLeaf(11, "bad-out-label")

    sl_err = Enum.YLeaf(12, "sl-err")

    rl_mismatch = Enum.YLeaf(13, "rl-mismatch")

    sl_alloc_err = Enum.YLeaf(14, "sl-alloc-err")

    upstream_downstream_label_mismatch = Enum.YLeaf(15, "upstream-downstream-label-mismatch")

    upstream_label_failure = Enum.YLeaf(16, "upstream-label-failure")

    upstream_label_rel_fail = Enum.YLeaf(17, "upstream-label-rel-fail")

    upstream_label_mismatch = Enum.YLeaf(18, "upstream-label-mismatch")

    upstream_label_invalid = Enum.YLeaf(19, "upstream-label-invalid")

    bad_upstream_label = Enum.YLeaf(20, "bad-upstream-label")

    ul_set_failure = Enum.YLeaf(21, "ul-set-failure")

    gmpls_label_alloc_err = Enum.YLeaf(22, "gmpls-label-alloc-err")

    gmpls_label_clone_err = Enum.YLeaf(23, "gmpls-label-clone-err")

    rw_err = Enum.YLeaf(24, "rw-err")

    up_rw_err = Enum.YLeaf(25, "up-rw-err")

    path_admit = Enum.YLeaf(26, "path-admit")

    bw = Enum.YLeaf(27, "bw")

    admit_resv = Enum.YLeaf(28, "admit-resv")

    rrrm_err = Enum.YLeaf(29, "rrrm-err")

    hardware_out_of_resources = Enum.YLeaf(30, "hardware-out-of-resources")

    comp_rid = Enum.YLeaf(31, "comp-rid")

    comp_lcl_rid = Enum.YLeaf(32, "comp-lcl-rid")

    comp_up_rid = Enum.YLeaf(33, "comp-up-rid")

    comp_down_rid = Enum.YLeaf(34, "comp-down-rid")

    rest_if_hop = Enum.YLeaf(35, "rest-if-hop")

    inv_in_if = Enum.YLeaf(36, "inv-in-if")

    nh_err = Enum.YLeaf(37, "nh-err")

    inv_in_ero = Enum.YLeaf(38, "inv-in-ero")

    out_ero_fail = Enum.YLeaf(39, "out-ero-fail")

    frr_bk_asssign = Enum.YLeaf(40, "frr-bk-asssign")

    frr_bk_rm = Enum.YLeaf(41, "frr-bk-rm")

    frr_bk_send = Enum.YLeaf(42, "frr-bk-send")

    frr_needs_del = Enum.YLeaf(43, "frr-needs-del")

    frr_reopt_lsp = Enum.YLeaf(44, "frr-reopt-lsp")

    rsvp_api_h = Enum.YLeaf(45, "rsvp-api-h")

    insane_path = Enum.YLeaf(46, "insane-path")

    remerge_chk_fail = Enum.YLeaf(47, "remerge-chk-fail")

    remerge_detected = Enum.YLeaf(48, "remerge-detected")

    xro = Enum.YLeaf(49, "xro")

    resv_bw_set = Enum.YLeaf(50, "resv-bw-set")

    resv_prep_fail = Enum.YLeaf(51, "resv-prep-fail")

    path_ch_proc = Enum.YLeaf(52, "path-ch-proc")

    path_ch_frr = Enum.YLeaf(53, "path-ch-frr")

    path_ch_sess_attri_fl = Enum.YLeaf(54, "path-ch-sess-attri-fl")

    path_ch_bw_ch = Enum.YLeaf(55, "path-ch-bw-ch")

    path_err_proc = Enum.YLeaf(56, "path-err-proc")

    path_err = Enum.YLeaf(57, "path-err")

    path_err_wpsr = Enum.YLeaf(58, "path-err-wpsr")

    path_del = Enum.YLeaf(59, "path-del")

    resv_ch_proc = Enum.YLeaf(60, "resv-ch-proc")

    resv_ch_rro = Enum.YLeaf(61, "resv-ch-rro")

    resv_del = Enum.YLeaf(62, "resv-del")

    resv_err = Enum.YLeaf(63, "resv-err")

    perr_send_fail = Enum.YLeaf(64, "perr-send-fail")

    perr_proc_fail = Enum.YLeaf(65, "perr-proc-fail")

    perr_rcv = Enum.YLeaf(66, "perr-rcv")

    resv_err_rcv = Enum.YLeaf(67, "resv-err-rcv")

    flowspec = Enum.YLeaf(68, "flowspec")

    setup_conn_api_fail = Enum.YLeaf(69, "setup-conn-api-fail")

    path_not_replayed = Enum.YLeaf(70, "path-not-replayed")

    resv_not_replayed = Enum.YLeaf(71, "resv-not-replayed")

    rewrite_not_replayed = Enum.YLeaf(72, "rewrite-not-replayed")

    label_not_replayed = Enum.YLeaf(73, "label-not-replayed")

    connection_not_ready = Enum.YLeaf(74, "connection-not-ready")

    master_did_not_replay = Enum.YLeaf(75, "master-did-not-replay")

    head_s2l_has_no_vif = Enum.YLeaf(76, "head-s2l-has-no-vif")

    frr_assigned_s2l_has_no_backup = Enum.YLeaf(77, "frr-assigned-s2l-has-no-backup")

    frr_assigned_s2l_has_down_backup = Enum.YLeaf(78, "frr-assigned-s2l-has-down-backup")

    out_link_down_and_no_frr = Enum.YLeaf(79, "out-link-down-and-no-frr")

    collaborator_timeout_rsvp = Enum.YLeaf(80, "collaborator-timeout-rsvp")

    collaborator_timeout_lsd = Enum.YLeaf(81, "collaborator-timeout-lsd")

    collaborator_timeout_lmrib = Enum.YLeaf(82, "collaborator-timeout-lmrib")

    collaborator_timeout_im = Enum.YLeaf(83, "collaborator-timeout-im")

    collaborator_timeout_error = Enum.YLeaf(84, "collaborator-timeout-error")

    topo_flush = Enum.YLeaf(85, "topo-flush")

    area_shut = Enum.YLeaf(86, "area-shut")

    active_po_del = Enum.YLeaf(87, "active-po-del")

    path_verify_failed = Enum.YLeaf(88, "path-verify-failed")

    srlg_path_verify_failed = Enum.YLeaf(89, "srlg-path-verify-failed")

    affinity_path_verify_failed = Enum.YLeaf(90, "affinity-path-verify-failed")

    aff_fail_delayed_tear_timeout_failed = Enum.YLeaf(91, "aff-fail-delayed-tear-timeout-failed")

    cost_limit_verify_failed = Enum.YLeaf(92, "cost-limit-verify-failed")

    delay_limit_verify_failed = Enum.YLeaf(93, "delay-limit-verify-failed")

    lockout_metric_verify_failed = Enum.YLeaf(94, "lockout-metric-verify-failed")

    path_setup_timeout = Enum.YLeaf(95, "path-setup-timeout")

    vif_destroyed = Enum.YLeaf(96, "vif-destroyed")

    vif_shut = Enum.YLeaf(97, "vif-shut")

    lsp_shut = Enum.YLeaf(98, "lsp-shut")

    gmpls_uni_head = Enum.YLeaf(99, "gmpls-uni-head")

    head_resetup = Enum.YLeaf(100, "head-resetup")

    none_head_resetup = Enum.YLeaf(101, "none-head-resetup")

    dest_disabled = Enum.YLeaf(102, "dest-disabled")

    iep_ch_act_po = Enum.YLeaf(103, "iep-ch-act-po")

    iep_ch_reopt = Enum.YLeaf(104, "iep-ch-reopt")

    iep_ch_standby = Enum.YLeaf(105, "iep-ch-standby")

    dste_mode_ch = Enum.YLeaf(106, "dste-mode-ch")

    reopt_del_frr_act = Enum.YLeaf(107, "reopt-del-frr-act")

    new_reopt_tear_old = Enum.YLeaf(108, "new-reopt-tear-old")

    reopt_failed_verify = Enum.YLeaf(109, "reopt-failed-verify")

    reopt_failed_install = Enum.YLeaf(110, "reopt-failed-install")

    reopt_failed_rw = Enum.YLeaf(111, "reopt-failed-rw")

    reopt_failed_not_superset = Enum.YLeaf(112, "reopt-failed-not-superset")

    dclean_at_install_time = Enum.YLeaf(113, "dclean-at-install-time")

    dclean_at_clean_timer = Enum.YLeaf(114, "dclean-at-clean-timer")

    dclean_at_reopt_active = Enum.YLeaf(115, "dclean-at-reopt-active")

    lcl_notif_head = Enum.YLeaf(116, "lcl-notif-head")

    in_if_fail = Enum.YLeaf(117, "in-if-fail")

    out_if_fail = Enum.YLeaf(118, "out-if-fail")

    if_fail_lc_oir = Enum.YLeaf(119, "if-fail-lc-oir")

    te_rid_rm = Enum.YLeaf(120, "te-rid-rm")

    te_rsvp_oos_bkup = Enum.YLeaf(121, "te-rsvp-oos-bkup")

    in_if_fail_exp_null_cfg_ch = Enum.YLeaf(122, "in-if-fail-exp-null-cfg-ch")

    new_curr_lsp_sig = Enum.YLeaf(123, "new-curr-lsp-sig")

    new_reopt_lsp_sig = Enum.YLeaf(124, "new-reopt-lsp-sig")

    new_stdby_lsp_sig = Enum.YLeaf(125, "new-stdby-lsp-sig")

    new_restore_lsp_sig = Enum.YLeaf(126, "new-restore-lsp-sig")

    new_cl_pp_lsp_sig = Enum.YLeaf(127, "new-cl-pp-lsp-sig")

    chkpt_recovery_failed = Enum.YLeaf(128, "chkpt-recovery-failed")

    stdby_cr_failed = Enum.YLeaf(129, "stdby-cr-failed")

    reopt_lsp_rej = Enum.YLeaf(130, "reopt-lsp-rej")

    reopt_po_sw_failed = Enum.YLeaf(131, "reopt-po-sw-failed")

    failed_to_find_path = Enum.YLeaf(132, "failed-to-find-path")

    sig_rcv_fail_path_cr_ch = Enum.YLeaf(133, "sig-rcv-fail-path-cr-ch")

    lsp_db_shut = Enum.YLeaf(134, "lsp-db-shut")

    reopt_hold_start = Enum.YLeaf(135, "reopt-hold-start")

    vif_lspid_mismatch = Enum.YLeaf(136, "vif-lspid-mismatch")

    s2l_has_no_vif = Enum.YLeaf(137, "s2l-has-no-vif")

    overload_reopt_timeout = Enum.YLeaf(138, "overload-reopt-timeout")

    hop_limit_exceeded = Enum.YLeaf(139, "hop-limit-exceeded")

    lingering_current_lsp = Enum.YLeaf(140, "lingering-current-lsp")

    lingering_standby_lsp = Enum.YLeaf(141, "lingering-standby-lsp")

    lingering_restore_lsp = Enum.YLeaf(142, "lingering-restore-lsp")

    double_lockout = Enum.YLeaf(143, "double-lockout")

    lockout_no_protection = Enum.YLeaf(144, "lockout-no-protection")

    lockout_cleanup = Enum.YLeaf(145, "lockout-cleanup")

    te_ppsw_lsp_mismatch = Enum.YLeaf(146, "te-ppsw-lsp-mismatch")

    te_stdbyup_no_curr_lsp = Enum.YLeaf(147, "te-stdbyup-no-curr-lsp")

    stdby_failed_rw = Enum.YLeaf(148, "stdby-failed-rw")

    reopt_lsp_tear_ppsw = Enum.YLeaf(149, "reopt-lsp-tear-ppsw")

    delay_pp_lsp_tear_ppsw = Enum.YLeaf(150, "delay-pp-lsp-tear-ppsw")

    stdby_failed_verify = Enum.YLeaf(151, "stdby-failed-verify")

    stdby_not_needed_due_to_restore = Enum.YLeaf(152, "stdby-not-needed-due-to-restore")

    restore_failed_verify = Enum.YLeaf(153, "restore-failed-verify")

    restore_failed_install = Enum.YLeaf(154, "restore-failed-install")

    restore_failed_rewrite = Enum.YLeaf(155, "restore-failed-rewrite")

    te_ppsw_cfg_rmvd = Enum.YLeaf(156, "te-ppsw-cfg-rmvd")

    te_ppsw_manual_ppsw = Enum.YLeaf(157, "te-ppsw-manual-ppsw")

    te_ppsw_bidir_p_chg_ppsw = Enum.YLeaf(158, "te-ppsw-bidir-p-chg-ppsw")

    te_ppsw_bidir_lockout_ppsw = Enum.YLeaf(159, "te-ppsw-bidir-lockout-ppsw")

    dclean_at_pp_clean_timer = Enum.YLeaf(160, "dclean-at-pp-clean-timer")

    reopt_standby_failed = Enum.YLeaf(161, "reopt-standby-failed")

    standby_reoptimized = Enum.YLeaf(162, "standby-reoptimized")

    standby_reoptimize_aborted = Enum.YLeaf(163, "standby-reoptimize-aborted")

    te_reoptup_no_curr_lsp = Enum.YLeaf(164, "te-reoptup-no-curr-lsp")

    te_reopt_curr_lsp_down = Enum.YLeaf(165, "te-reopt-curr-lsp-down")

    te_cleanedt_curr_lsp_down = Enum.YLeaf(166, "te-cleanedt-curr-lsp-down")

    te_delay_lsp_up = Enum.YLeaf(167, "te-delay-lsp-up")

    no_route_due_to_affinity = Enum.YLeaf(168, "no-route-due-to-affinity")

    no_rib_lkup_bad_ero_gmpls = Enum.YLeaf(169, "no-rib-lkup-bad-ero-gmpls")

    cleanup_lingering = Enum.YLeaf(170, "cleanup-lingering")

    te_s2l_del_sc_soft_preemption_timeout = Enum.YLeaf(171, "te-s2l-del-sc-soft-preemption-timeout")

    te_s2l_del_sc_soft_preempted_non_current = Enum.YLeaf(172, "te-s2l-del-sc-soft-preempted-non-current")

    te_s2l_del_sc_vif_sync_lsp_del = Enum.YLeaf(173, "te-s2l-del-sc-vif-sync-lsp-del")

    rsvp_api_cleanup_req = Enum.YLeaf(174, "rsvp-api-cleanup-req")

    te_s2l_del_sc_frr_wrong_backup = Enum.YLeaf(175, "te-s2l-del-sc-frr-wrong-backup")

    te_s2l_del_sc_bfd_session_create_failed = Enum.YLeaf(176, "te-s2l-del-sc-bfd-session-create-failed")

    te_s2l_del_sc_bfd_session_bringup_timeout = Enum.YLeaf(177, "te-s2l-del-sc-bfd-session-bringup-timeout")

    te_s2l_del_sc_bfd_session_down = Enum.YLeaf(178, "te-s2l-del-sc-bfd-session-down")

    te_s2l_del_sc_bfd_session_not_replayed = Enum.YLeaf(179, "te-s2l-del-sc-bfd-session-not-replayed")

    te_s2l_del_sc_reopt_p2mp_egress_info_fail = Enum.YLeaf(180, "te-s2l-del-sc-reopt-p2mp-egress-info-fail")

    non_curr_frr_lcl_notif_event = Enum.YLeaf(181, "non-curr-frr-lcl-notif-event")

    unsupported_encoding = Enum.YLeaf(182, "unsupported-encoding")

    unsupported_gpid = Enum.YLeaf(183, "unsupported-gpid")

    unsupported_switching_type = Enum.YLeaf(184, "unsupported-switching-type")

    upstream_label_change_not_permitted = Enum.YLeaf(185, "upstream-label-change-not-permitted")

    encoding_type_change_not_permitted = Enum.YLeaf(186, "encoding-type-change-not-permitted")

    aps_protect_info_change_failed = Enum.YLeaf(187, "aps-protect-info-change-failed")

    incorrect_lsp_type = Enum.YLeaf(188, "incorrect-lsp-type")

    local_hop_error = Enum.YLeaf(189, "local-hop-error")

    unsupported_gmpls_attributes = Enum.YLeaf(190, "unsupported-gmpls-attributes")

    gmpls_uni_reopt_triggered = Enum.YLeaf(191, "gmpls-uni-reopt-triggered")

    maximum_acceptable_label_retries = Enum.YLeaf(192, "maximum-acceptable-label-retries")

    invalid_direction = Enum.YLeaf(193, "invalid-direction")

    invalid_rewrite_context = Enum.YLeaf(194, "invalid-rewrite-context")

    invalid_label_context = Enum.YLeaf(195, "invalid-label-context")

    dwdm_capability_changed = Enum.YLeaf(196, "dwdm-capability-changed")

    dwdm_capability_removed = Enum.YLeaf(197, "dwdm-capability-removed")

    dwdm_wavelength_removed = Enum.YLeaf(198, "dwdm-wavelength-removed")

    gmpls_uni_multilayer_restoration = Enum.YLeaf(199, "gmpls-uni-multilayer-restoration")

    gmpls_uni_user_triggered_reoptimization = Enum.YLeaf(200, "gmpls-uni-user-triggered-reoptimization")

    gmpls_uni_active_path_change_triggered_reopt = Enum.YLeaf(201, "gmpls-uni-active-path-change-triggered-reopt")

    passive_match_err = Enum.YLeaf(202, "passive-match-err")

    egress_control_err = Enum.YLeaf(203, "egress-control-err")

    egress_control_map_err = Enum.YLeaf(204, "egress-control-map-err")

    restore_not_needed_for_current = Enum.YLeaf(205, "restore-not-needed-for-current")

    restore_not_needed_for_standby = Enum.YLeaf(206, "restore-not-needed-for-standby")

    restore_dp_down = Enum.YLeaf(207, "restore-dp-down")

    current_not_needed_dp_down = Enum.YLeaf(208, "current-not-needed-dp-down")

    bad_protct_obj = Enum.YLeaf(209, "bad-protct-obj")

    head_flexi_cap_change = Enum.YLeaf(210, "head-flexi-cap-change")

    tail_flexi_cap_change = Enum.YLeaf(211, "tail-flexi-cap-change")

    optical_link_down = Enum.YLeaf(212, "optical-link-down")

    optical_link_lsp_out_of_sync = Enum.YLeaf(213, "optical-link-lsp-out-of-sync")

    optical_link_owner_out_of_sync = Enum.YLeaf(214, "optical-link-owner-out-of-sync")

    optical_link_interface_handle_out_of_sync = Enum.YLeaf(215, "optical-link-interface-handle-out-of-sync")

    optical_link_hop_out_of_sync = Enum.YLeaf(216, "optical-link-hop-out-of-sync")

    optical_link_role_out_of_sync = Enum.YLeaf(217, "optical-link-role-out-of-sync")

    optical_link_downstream_router_id_out_of_sync = Enum.YLeaf(218, "optical-link-downstream-router-id-out-of-sync")

    optical_link_upstream_router_id_out_of_sync = Enum.YLeaf(219, "optical-link-upstream-router-id-out-of-sync")

    optical_link_encoding_type_out_of_sync = Enum.YLeaf(220, "optical-link-encoding-type-out-of-sync")

    optical_link_switching_type_out_of_sync = Enum.YLeaf(221, "optical-link-switching-type-out-of-sync")

    optical_link_gpid_out_of_sync = Enum.YLeaf(222, "optical-link-gpid-out-of-sync")

    egress_optical_link_not_found = Enum.YLeaf(223, "egress-optical-link-not-found")

    ingress_optical_link_not_found = Enum.YLeaf(224, "ingress-optical-link-not-found")

    sync_dest_state = Enum.YLeaf(225, "sync-dest-state")

    prot_object_err = Enum.YLeaf(226, "prot-object-err")

    reverse_s2l_deleted = Enum.YLeaf(227, "reverse-s2l-deleted")

    cancel_inprogress_by_slave = Enum.YLeaf(228, "cancel-inprogress-by-slave")

    invalid_reverse_ero = Enum.YLeaf(229, "invalid-reverse-ero")

    reverse_lsp_not_found = Enum.YLeaf(230, "reverse-lsp-not-found")

    reverse_lsp_not_present = Enum.YLeaf(231, "reverse-lsp-not-present")

    associated_vif_down = Enum.YLeaf(232, "associated-vif-down")

    vif_sync_processing = Enum.YLeaf(233, "vif-sync-processing")

    incoming_interface_lockout = Enum.YLeaf(234, "incoming-interface-lockout")

    sr_egress_path_changed = Enum.YLeaf(235, "sr-egress-path-changed")

    in_if_fail_imp_null_cfg_ch = Enum.YLeaf(236, "in-if-fail-imp-null-cfg-ch")

    reverse_lsp_failure = Enum.YLeaf(237, "reverse-lsp-failure")

    lsp_wrap_label_error = Enum.YLeaf(238, "lsp-wrap-label-error")

    lsp_wrap_rewrite_error = Enum.YLeaf(239, "lsp-wrap-rewrite-error")

    transit_lsp_out_of_resources = Enum.YLeaf(240, "transit-lsp-out-of-resources")

    path_protection_configuration_change = Enum.YLeaf(241, "path-protection-configuration-change")

    better_standby_path = Enum.YLeaf(242, "better-standby-path")

    path_option_config_change = Enum.YLeaf(243, "path-option-config-change")

    path_protection_non_revertive_config_changed = Enum.YLeaf(244, "path-protection-non-revertive-config-changed")

    manually_triggered_non_revertive_recovery = Enum.YLeaf(245, "manually-triggered-non-revertive-recovery")

    remote_node_triggered_non_revertive_recovery = Enum.YLeaf(246, "remote-node-triggered-non-revertive-recovery")

    fsm_sc_must_be_last = Enum.YLeaf(247, "fsm-sc-must-be-last")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeP2mpS2lDeletionSubcause']


class TePathInvalAction(Enum):
    """
    TePathInvalAction (Enum Class)

    Path selection invalidation action type

    .. data:: none = 0

    	TE path selection invalidation action none

    .. data:: tear = 1

    	TE path selection invalidation action tear

    .. data:: drop = 2

    	TE path selection invalidation action drop

    """

    none = Enum.YLeaf(0, "none")

    tear = Enum.YLeaf(1, "tear")

    drop = Enum.YLeaf(2, "drop")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePathInvalAction']


class TePathProtProfile(Enum):
    """
    TePathProtProfile (Enum Class)

    Path Protection Profile Type

    .. data:: path_prot_profile_type1_plus0 = 0

    	TE Path Option 1PLUS0

    .. data:: path_prot_profile_type1_plus_r = 1

    	TE Path Option 1PLUSR

    .. data:: path_prot_profile_type1_plus1 = 16

    	TE Path Option 1PLUS1

    .. data:: path_prot_profile_type1_plus1_plus_r = 32

    	TE Path Option 1PLUS1PLUSR

    .. data:: path_prot_profile_type_invalid = 255

    	TE Path Option Invalid

    """

    path_prot_profile_type1_plus0 = Enum.YLeaf(0, "path-prot-profile-type1-plus0")

    path_prot_profile_type1_plus_r = Enum.YLeaf(1, "path-prot-profile-type1-plus-r")

    path_prot_profile_type1_plus1 = Enum.YLeaf(16, "path-prot-profile-type1-plus1")

    path_prot_profile_type1_plus1_plus_r = Enum.YLeaf(32, "path-prot-profile-type1-plus1-plus-r")

    path_prot_profile_type_invalid = Enum.YLeaf(255, "path-prot-profile-type-invalid")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePathProtProfile']


class TePathSelectionTiebreaker(Enum):
    """
    TePathSelectionTiebreaker (Enum Class)

    Path selection tiebreaker type

    .. data:: min_fill = 1

    	Min Fill

    .. data:: max_fill = 2

    	Max Fill

    .. data:: random = 3

    	Random

    """

    min_fill = Enum.YLeaf(1, "min-fill")

    max_fill = Enum.YLeaf(2, "max-fill")

    random = Enum.YLeaf(3, "random")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePathSelectionTiebreaker']


class TePceDisjoint(Enum):
    """
    TePceDisjoint (Enum Class)

    PCE Disjoint Path type

    .. data:: none = 0

    	PCE Disjoint Type none

    .. data:: link = 1

    	PCE Disjoint Type link

    .. data:: node = 2

    	PCE Disjoint Type node

    .. data:: srlg = 3

    	PCE Disjoint Type srlg

    """

    none = Enum.YLeaf(0, "none")

    link = Enum.YLeaf(1, "link")

    node = Enum.YLeaf(2, "node")

    srlg = Enum.YLeaf(3, "srlg")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePceDisjoint']


class TePnrRevertOptions(Enum):
    """
    TePnrRevertOptions (Enum Class)

    PNR Options

    .. data:: pnr_optionnot_set = 0

    	TE Protection Restore Option Not Set

    .. data:: pnr_option_revertive = 1

    	TE Protection Restore Option Revertive

    .. data:: pnr_option_non_revertive = 2

    	TE Protection Restore Option Non-revertive

    """

    pnr_optionnot_set = Enum.YLeaf(0, "pnr-optionnot-set")

    pnr_option_revertive = Enum.YLeaf(1, "pnr-option-revertive")

    pnr_option_non_revertive = Enum.YLeaf(2, "pnr-option-non-revertive")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePnrRevertOptions']


class TePpDiversity(Enum):
    """
    TePpDiversity (Enum Class)

    Diversity of Protection or Restoration Path from

    Protected Path

    .. data:: diversity_none = 0

    	Standby LSP not diverse

    .. data:: link = 1

    	Standby LSP link diverse

    .. data:: node = 2

    	Standby LSP node diverse

    .. data:: node_link = 3

    	Standby LSP node and link diverse

    .. data:: srlg = 4

    	Standby SRLG diverse

    .. data:: node_srlg = 5

    	Standby LSP node and SRLG diverse

    .. data:: node_link_srlg = 6

    	Standby LSP node and link and SRLG diverse

    .. data:: diversity_sticky = 7

    	Standby LSP using sticky explicit path

    .. data:: diversity_user = 8

    	Standby LSP using user defined explicit path

    .. data:: diversity_reverse_ero = 9

    	Standby LSP using Reverse ERO

    """

    diversity_none = Enum.YLeaf(0, "diversity-none")

    link = Enum.YLeaf(1, "link")

    node = Enum.YLeaf(2, "node")

    node_link = Enum.YLeaf(3, "node-link")

    srlg = Enum.YLeaf(4, "srlg")

    node_srlg = Enum.YLeaf(5, "node-srlg")

    node_link_srlg = Enum.YLeaf(6, "node-link-srlg")

    diversity_sticky = Enum.YLeaf(7, "diversity-sticky")

    diversity_user = Enum.YLeaf(8, "diversity-user")

    diversity_reverse_ero = Enum.YLeaf(9, "diversity-reverse-ero")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TePpDiversity']


class TeProcRole(Enum):
    """
    TeProcRole (Enum Class)

    TE Process Role

    .. data:: unknown = 0

    	Unknown

    .. data:: v1_active = 1

    	V1 Active

    .. data:: v2_active = 2

    	V2 Active

    .. data:: v1_standby = 3

    	V1 Standby

    .. data:: v2_standby = 4

    	V2 Standby

    .. data:: v1_active_post_big_bang = 5

    	V1 Active post big bang

    .. data:: v1_standby_post_big_bang = 6

    	V1 Standby post big bang

    .. data:: number_of_role = 7

    	Number of role

    """

    unknown = Enum.YLeaf(0, "unknown")

    v1_active = Enum.YLeaf(1, "v1-active")

    v2_active = Enum.YLeaf(2, "v2-active")

    v1_standby = Enum.YLeaf(3, "v1-standby")

    v2_standby = Enum.YLeaf(4, "v2-standby")

    v1_active_post_big_bang = Enum.YLeaf(5, "v1-active-post-big-bang")

    v1_standby_post_big_bang = Enum.YLeaf(6, "v1-standby-post-big-bang")

    number_of_role = Enum.YLeaf(7, "number-of-role")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeProcRole']


class TeProtect(Enum):
    """
    TeProtect (Enum Class)

    Protection Types

    .. data:: protect_type1_plus1_unidir_no_aps = 4

    	Protection Type Uni-directional No APS

    .. data:: protect_type1_plus1_unidir_aps = 8

    	Protection Type Uni-directional APS

    .. data:: protect_type1_plus1_bidir_aps = 16

    	Protection Type Bi-directional APS

    .. data:: protect_type_not_set = 255

    	Protection Type Not Set

    """

    protect_type1_plus1_unidir_no_aps = Enum.YLeaf(4, "protect-type1-plus1-unidir-no-aps")

    protect_type1_plus1_unidir_aps = Enum.YLeaf(8, "protect-type1-plus1-unidir-aps")

    protect_type1_plus1_bidir_aps = Enum.YLeaf(16, "protect-type1-plus1-bidir-aps")

    protect_type_not_set = Enum.YLeaf(255, "protect-type-not-set")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeProtect']


class TeRestorationStyle(Enum):
    """
    TeRestorationStyle (Enum Class)

    PNR Options

    .. data:: restoration_style_not_set = 0

    	TE Restoration Style Not Set

    .. data:: restoration_style_keep_failed_lsp = 1

    	TE Restoration Style is to Keep Failed Lsp

    .. data:: restoration_style_delete_failed_lsp = 2

    	TE Restoration Style is to Delete Failed Lsp

    """

    restoration_style_not_set = Enum.YLeaf(0, "restoration-style-not-set")

    restoration_style_keep_failed_lsp = Enum.YLeaf(1, "restoration-style-keep-failed-lsp")

    restoration_style_delete_failed_lsp = Enum.YLeaf(2, "restoration-style-delete-failed-lsp")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeRestorationStyle']


class TeRevEroRejectReasons(Enum):
    """
    TeRevEroRejectReasons (Enum Class)

    TE Reverse ERO Reject Reasons

    .. data:: none = 0

    	None

    .. data:: bad_reverse_ero = 1

    	Bad Reverse ERO

    .. data:: tie_rejected = 2

    	Tie Rejected

    .. data:: standby_not_required = 3

    	Standby Not Required

    .. data:: admin_state = 4

    	Admin State

    .. data:: priority = 5

    	Priority

    .. data:: class_type = 6

    	Class Type

    .. data:: bad_association = 7

    	Bad Associated Tunnel

    """

    none = Enum.YLeaf(0, "none")

    bad_reverse_ero = Enum.YLeaf(1, "bad-reverse-ero")

    tie_rejected = Enum.YLeaf(2, "tie-rejected")

    standby_not_required = Enum.YLeaf(3, "standby-not-required")

    admin_state = Enum.YLeaf(4, "admin-state")

    priority = Enum.YLeaf(5, "priority")

    class_type = Enum.YLeaf(6, "class-type")

    bad_association = Enum.YLeaf(7, "bad-association")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeRevEroRejectReasons']


class TeS2lOutputRwExplicitNull(Enum):
    """
    TeS2lOutputRwExplicitNull (Enum Class)

    Explicit\-null type

    .. data:: tes2l_output_rw_exp_null = 0

    	No explicit null imposed

    .. data:: tes2l_output_rw_exp_null_v4 = 1

    	IPv4 explicit null imposed

    .. data:: tes2l_output_rw_exp_null_v6 = 2

    	IPv6 explicit null imposed

    """

    tes2l_output_rw_exp_null = Enum.YLeaf(0, "tes2l-output-rw-exp-null")

    tes2l_output_rw_exp_null_v4 = Enum.YLeaf(1, "tes2l-output-rw-exp-null-v4")

    tes2l_output_rw_exp_null_v6 = Enum.YLeaf(2, "tes2l-output-rw-exp-null-v6")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeS2lOutputRwExplicitNull']


class TeS2lSrPathSelection(Enum):
    """
    TeS2lSrPathSelection (Enum Class)

    Segment\-routing path selection type

    .. data:: te_s2l_sr_path_selection_any = 0

    	TE S2L Segment-Routing Path Selection type Any

    .. data:: te_s2l_sr_path_selection_adj_unprotected = 1

    	TE S2L Segment-Routing Path Selection type

    	Adjacency Unprotected

    .. data:: te_s2l_sr_path_selection_adj_protected = 2

    	TE S2L Segment-Routing Path Selection type

    	Adjacency Protected

    """

    te_s2l_sr_path_selection_any = Enum.YLeaf(0, "te-s2l-sr-path-selection-any")

    te_s2l_sr_path_selection_adj_unprotected = Enum.YLeaf(1, "te-s2l-sr-path-selection-adj-unprotected")

    te_s2l_sr_path_selection_adj_protected = Enum.YLeaf(2, "te-s2l-sr-path-selection-adj-protected")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeS2lSrPathSelection']


class TeSchFreq(Enum):
    """
    TeSchFreq (Enum Class)

    Te sch freq

    .. data:: sch_freq_not_set = 0

    	Schedule reversion frequency not set

    .. data:: sch_freq_set_once = 1

    	Schedule reversion frequency set only once

    .. data:: sch_freq_set_daily = 2

    	Schedule reversion frequency set daily

    .. data:: sch_freq_set_weekly = 3

    	Schedule reversion frequency set weekly

    """

    sch_freq_not_set = Enum.YLeaf(0, "sch-freq-not-set")

    sch_freq_set_once = Enum.YLeaf(1, "sch-freq-set-once")

    sch_freq_set_daily = Enum.YLeaf(2, "sch-freq-set-daily")

    sch_freq_set_weekly = Enum.YLeaf(3, "sch-freq-set-weekly")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSchFreq']


class TeServTunClient(Enum):
    """
    TeServTunClient (Enum Class)

    Te serv tun client

    .. data:: te_serv_auto_tun_client_invalid = 0

    	te serv auto tun client invalid

    .. data:: te_serv_p2mp_tun_client_mvpn = 1

    	te serv p2mp tun client mvpn

    .. data:: te_serv_p2mp_tun_client_vpls = 2

    	te serv p2mp tun client vpls

    .. data:: te_serv_p2mp_tun_client_mvpn6 = 3

    	te serv p2mp tun client mvpn6

    .. data:: te_serv_p2p_tun_client_bgp = 4

    	te serv p2p tun client bgp

    .. data:: te_serv_p2p_tun_client_staticv4 = 5

    	te serv p2p tun client staticv4

    .. data:: te_serv_p2p_tun_client_staticv6 = 6

    	te serv p2p tun client staticv6

    .. data:: te_serv_p2p_tun_client_isis = 7

    	te serv p2p tun client isis

    .. data:: te_serv_p2p_tun_client_ospf = 8

    	te serv p2p tun client ospf

    .. data:: te_serv_auto_tun_client_count = 9

    	te serv auto tun client count

    """

    te_serv_auto_tun_client_invalid = Enum.YLeaf(0, "te-serv-auto-tun-client-invalid")

    te_serv_p2mp_tun_client_mvpn = Enum.YLeaf(1, "te-serv-p2mp-tun-client-mvpn")

    te_serv_p2mp_tun_client_vpls = Enum.YLeaf(2, "te-serv-p2mp-tun-client-vpls")

    te_serv_p2mp_tun_client_mvpn6 = Enum.YLeaf(3, "te-serv-p2mp-tun-client-mvpn6")

    te_serv_p2p_tun_client_bgp = Enum.YLeaf(4, "te-serv-p2p-tun-client-bgp")

    te_serv_p2p_tun_client_staticv4 = Enum.YLeaf(5, "te-serv-p2p-tun-client-staticv4")

    te_serv_p2p_tun_client_staticv6 = Enum.YLeaf(6, "te-serv-p2p-tun-client-staticv6")

    te_serv_p2p_tun_client_isis = Enum.YLeaf(7, "te-serv-p2p-tun-client-isis")

    te_serv_p2p_tun_client_ospf = Enum.YLeaf(8, "te-serv-p2p-tun-client-ospf")

    te_serv_auto_tun_client_count = Enum.YLeaf(9, "te-serv-auto-tun-client-count")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeServTunClient']


class TeSigNameAppend(Enum):
    """
    TeSigNameAppend (Enum Class)

    Te sig name append

    .. data:: none = 0

    	Option is Not Set for appending to

    	signalled-name

    .. data:: address = 1

    	Option is to append Address to signalled-name

    .. data:: name = 2

    	Option is to append Name to signalled-name

    """

    none = Enum.YLeaf(0, "none")

    address = Enum.YLeaf(1, "address")

    name = Enum.YLeaf(2, "name")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSigNameAppend']


class TeSrSid(Enum):
    """
    TeSrSid (Enum Class)

    Segment\-Routing SID types

    .. data:: srsid_not_set = 0

    	Type not set

    .. data:: srsid_node = 1

    	Segment-Routing Node

    .. data:: srsid_adj = 2

    	Segment-Routing Link

    .. data:: srsid_unknown = 3

    	Segment-Routing Unknown

    """

    srsid_not_set = Enum.YLeaf(0, "srsid-not-set")

    srsid_node = Enum.YLeaf(1, "srsid-node")

    srsid_adj = Enum.YLeaf(2, "srsid-adj")

    srsid_unknown = Enum.YLeaf(3, "srsid-unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSrSid']


class TeSrlgCollectRequest(Enum):
    """
    TeSrlgCollectRequest (Enum Class)

    SRLG\-collection request machansim

    .. data:: none = 0

    	No SRLG-collection request

    .. data:: mandatory = 1

    	Mandatory SRLG-collection request

    .. data:: optional = 2

    	Optional SRLG-collection request

    """

    none = Enum.YLeaf(0, "none")

    mandatory = Enum.YLeaf(1, "mandatory")

    optional = Enum.YLeaf(2, "optional")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSrlgCollectRequest']


class TeStatsSigFilter(Enum):
    """
    TeStatsSigFilter (Enum Class)

    TE Signaling Filter types

    .. data:: te_stat_sig_filter_vif = 0

    	te stat sig filter vif

    .. data:: te_stat_sig_filter_lsp = 1

    	te stat sig filter lsp

    """

    te_stat_sig_filter_vif = Enum.YLeaf(0, "te-stat-sig-filter-vif")

    te_stat_sig_filter_lsp = Enum.YLeaf(1, "te-stat-sig-filter-lsp")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeStatsSigFilter']


class TeSyncNotReadyReason(Enum):
    """
    TeSyncNotReadyReason (Enum Class)

    Te sync not ready reason

    .. data:: idt_in_progress = 0

    	IDT in progress

    .. data:: standby_not_connected = 1

    	Standby not connected

    .. data:: collaborator_disconnected = 2

    	Collaborator disconnected

    .. data:: collaborator_timeout = 3

    	Collaborator timeout

    .. data:: unknown = 4

    	Unknown

    """

    idt_in_progress = Enum.YLeaf(0, "idt-in-progress")

    standby_not_connected = Enum.YLeaf(1, "standby-not-connected")

    collaborator_disconnected = Enum.YLeaf(2, "collaborator-disconnected")

    collaborator_timeout = Enum.YLeaf(3, "collaborator-timeout")

    unknown = Enum.YLeaf(4, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSyncNotReadyReason']


class TeSyncPendingReason(Enum):
    """
    TeSyncPendingReason (Enum Class)

    Te sync pending reason

    .. data:: current_lspoos = 0

    	Current LSP OOS

    .. data:: reopt_lspoos = 1

    	Reopt LSP OOS

    .. data:: standby_lspoos = 2

    	Standby LSP OOS

    .. data:: standby_reopt_lspoos = 3

    	Standby Reopt LSP OOS

    .. data:: restore_lspoos = 4

    	Restore LSP OOS

    .. data:: invalid_sync_id = 5

    	Invalid internal ID

    .. data:: null_pointer = 6

    	Null pointer

    .. data:: pending_flag = 7

    	Pending flag set

    .. data:: del_from_act_flag = 8

    	Deleted by Active set

    .. data:: oos_from_act_flag = 9

    	OOS with Active set

    .. data:: unknown = 10

    	Unknown

    """

    current_lspoos = Enum.YLeaf(0, "current-lspoos")

    reopt_lspoos = Enum.YLeaf(1, "reopt-lspoos")

    standby_lspoos = Enum.YLeaf(2, "standby-lspoos")

    standby_reopt_lspoos = Enum.YLeaf(3, "standby-reopt-lspoos")

    restore_lspoos = Enum.YLeaf(4, "restore-lspoos")

    invalid_sync_id = Enum.YLeaf(5, "invalid-sync-id")

    null_pointer = Enum.YLeaf(6, "null-pointer")

    pending_flag = Enum.YLeaf(7, "pending-flag")

    del_from_act_flag = Enum.YLeaf(8, "del-from-act-flag")

    oos_from_act_flag = Enum.YLeaf(9, "oos-from-act-flag")

    unknown = Enum.YLeaf(10, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSyncPendingReason']


class TeSyncStatusShow(Enum):
    """
    TeSyncStatusShow (Enum Class)

    Te sync status show

    .. data:: master_sync_status_show = 0

    	Master sync status information

    .. data:: slave_sync_status_show = 1

    	Slave sync status information

    """

    master_sync_status_show = Enum.YLeaf(0, "master-sync-status-show")

    slave_sync_status_show = Enum.YLeaf(1, "slave-sync-status-show")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeSyncStatusShow']


class TeTargetAddr(Enum):
    """
    TeTargetAddr (Enum Class)

    TE Target Address Type

    .. data:: invalid_te_target_type = 0

    	Invalid TE Target Type

    .. data:: te_target_type_ipv4 = 1

    	TE Target IPv4 Type

    .. data:: te_target_type_label = 2

    	TE Target Label Type

    """

    invalid_te_target_type = Enum.YLeaf(0, "invalid-te-target-type")

    te_target_type_ipv4 = Enum.YLeaf(1, "te-target-type-ipv4")

    te_target_type_label = Enum.YLeaf(2, "te-target-type-label")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeTargetAddr']


class TeVifBfd(Enum):
    """
    TeVifBfd (Enum Class)

    BFD Type

    .. data:: bfd_disabled = 0

    	BFD Fast Detect Not Enabled

    .. data:: bfd_enabled = 1

    	Regular BFD Enabled

    .. data:: sbfd_enabled = 2

    	SBFD Enabled

    """

    bfd_disabled = Enum.YLeaf(0, "bfd-disabled")

    bfd_enabled = Enum.YLeaf(1, "bfd-enabled")

    sbfd_enabled = Enum.YLeaf(2, "sbfd-enabled")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeVifBfd']


class TeVifBfdEncapMode(Enum):
    """
    TeVifBfdEncapMode (Enum Class)

    BFD Encap Mode

    .. data:: ip = 0

    	BFD Encap Mode IP

    .. data:: gal = 1

    	BFD Encap Mode GAL

    """

    ip = Enum.YLeaf(0, "ip")

    gal = Enum.YLeaf(1, "gal")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeVifBfdEncapMode']


class TeXroAttribute(Enum):
    """
    TeXroAttribute (Enum Class)

    XRO exclusion type

    .. data:: interface = 0

    	Exclude the interface specified

    .. data:: node = 1

    	Exclude the node specified

    .. data:: srl_gs = 2

    	Exclude all SRLGs related to the data specified

    """

    interface = Enum.YLeaf(0, "interface")

    node = Enum.YLeaf(1, "node")

    srl_gs = Enum.YLeaf(2, "srl-gs")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeXroAttribute']


class TeXroExclusion(Enum):
    """
    TeXroExclusion (Enum Class)

    XRO exclusion type

    .. data:: mandatory = 0

    	Mandatory exclusion

    .. data:: best_effort = 1

    	Best-effort exclusion

    """

    mandatory = Enum.YLeaf(0, "mandatory")

    best_effort = Enum.YLeaf(1, "best-effort")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeXroExclusion']


class TeXroSubobj(Enum):
    """
    TeXroSubobj (Enum Class)

    XRO sub\-object type

    .. data:: ipv4 = 1

    	IPv4 prefix

    .. data:: ipv6 = 2

    	IPv6 prefix

    .. data:: unnumbered = 6

    	Unnumbered

    .. data:: as_ = 32

    	Autonomous System

    .. data:: srlg = 34

    	SRLG

    .. data:: p2p_lsp = 36

    	P2P LSP

    """

    ipv4 = Enum.YLeaf(1, "ipv4")

    ipv6 = Enum.YLeaf(2, "ipv6")

    unnumbered = Enum.YLeaf(6, "unnumbered")

    as_ = Enum.YLeaf(32, "as")

    srlg = Enum.YLeaf(34, "srlg")

    p2p_lsp = Enum.YLeaf(36, "p2p-lsp")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TeXroSubobj']


class TpLinkState(Enum):
    """
    TpLinkState (Enum Class)

    Deprecated

    .. data:: down = 0

    	Deprecated

    .. data:: admin_down = 1

    	Deprecated

    .. data:: up = 2

    	Deprecated

    .. data:: unknown = 3

    	Deprecated

    """

    down = Enum.YLeaf(0, "down")

    admin_down = Enum.YLeaf(1, "admin-down")

    up = Enum.YLeaf(2, "up")

    unknown = Enum.YLeaf(3, "unknown")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TpLinkState']


class TpMidLspStatus(Enum):
    """
    TpMidLspStatus (Enum Class)

    Deprecated

    .. data:: up = 0

    	Deprecated

    .. data:: down = 1

    	Deprecated

    """

    up = Enum.YLeaf(0, "up")

    down = Enum.YLeaf(1, "down")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TpMidLspStatus']


class TtiMode(Enum):
    """
    TtiMode (Enum Class)

    GMPLS TTI Mode for controller

    .. data:: none = 0

    	None

    .. data:: otu_secion_monitoring = 1

    	Section Monitoring

    .. data:: odu_path_monitoring = 2

    	Path Monitoring

    .. data:: odu_tandem_connection_monitoring = 3

    	Tandem Connection

    """

    none = Enum.YLeaf(0, "none")

    otu_secion_monitoring = Enum.YLeaf(1, "otu-secion-monitoring")

    odu_path_monitoring = Enum.YLeaf(2, "odu-path-monitoring")

    odu_tandem_connection_monitoring = Enum.YLeaf(3, "odu-tandem-connection-monitoring")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TtiMode']


class TunnelAttributeSet(Enum):
    """
    TunnelAttributeSet (Enum Class)

    Tunnel attribute set

    .. data:: tunnel_attribute_set_none = 0

    	No Tunnel AttributeSet configured

    .. data:: tunnel_attribute_set_static = 1

    	Tunnel AttributeSet Type is Static

    .. data:: tunnel_attribute_set_path_option = 2

    	Tunnel AttributeSet Type is Path Option

    .. data:: tunnel_attribute_set_not_used = 3

    	None

    .. data:: tunnel_attribute_set_auto_backup = 4

    	Tunnel AttributeSet Type is AutoBackup

    .. data:: tunnel_attribute_set_auto_mesh = 5

    	Tunnel AttributeSet Type is AutoMesh

    .. data:: tunnel_attribute_set_xro = 6

    	Tunnel AttributeSet Type is XRO

    .. data:: tunnel_attribute_set_p2mpte = 7

    	Tunnel AttributeSet Type is P2MP TE

    .. data:: tunnel_attribute_aps_pp = 8

    	Tunnel AttributeSet Type is APS Path Protection

    .. data:: tunnel_attribute_set_p2p_te = 9

    	Tunnel AttributeSet Type is P2P TE

    """

    tunnel_attribute_set_none = Enum.YLeaf(0, "tunnel-attribute-set-none")

    tunnel_attribute_set_static = Enum.YLeaf(1, "tunnel-attribute-set-static")

    tunnel_attribute_set_path_option = Enum.YLeaf(2, "tunnel-attribute-set-path-option")

    tunnel_attribute_set_not_used = Enum.YLeaf(3, "tunnel-attribute-set-not-used")

    tunnel_attribute_set_auto_backup = Enum.YLeaf(4, "tunnel-attribute-set-auto-backup")

    tunnel_attribute_set_auto_mesh = Enum.YLeaf(5, "tunnel-attribute-set-auto-mesh")

    tunnel_attribute_set_xro = Enum.YLeaf(6, "tunnel-attribute-set-xro")

    tunnel_attribute_set_p2mpte = Enum.YLeaf(7, "tunnel-attribute-set-p2mpte")

    tunnel_attribute_aps_pp = Enum.YLeaf(8, "tunnel-attribute-aps-pp")

    tunnel_attribute_set_p2p_te = Enum.YLeaf(9, "tunnel-attribute-set-p2p-te")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TunnelAttributeSet']


class TunnelStateEnum(Enum):
    """
    TunnelStateEnum (Enum Class)

    Types of tunnel admission states

    .. data:: tunnel_state_unknown = 0

    	No known state

    .. data:: new = 1

    	Tunnel is new

    .. data:: preempting = 2

    	Tunnel is being preempted

    .. data:: admitting = 3

    	Path being admitted

    .. data:: half_admitted = 4

    	Path was admitted partially and was then

    	rejected

    .. data:: admitted = 5

    	Path is already admitted successfully

    .. data:: reservation_admitting = 6

    	Reservation being admitted

    .. data:: reservation_half_admitted = 7

    	Reservation was admitted partially and was then

    	rejected

    .. data:: reservation_admitted = 8

    	Reservation is already admitted successfully

    """

    tunnel_state_unknown = Enum.YLeaf(0, "tunnel-state-unknown")

    new = Enum.YLeaf(1, "new")

    preempting = Enum.YLeaf(2, "preempting")

    admitting = Enum.YLeaf(3, "admitting")

    half_admitted = Enum.YLeaf(4, "half-admitted")

    admitted = Enum.YLeaf(5, "admitted")

    reservation_admitting = Enum.YLeaf(6, "reservation-admitting")

    reservation_half_admitted = Enum.YLeaf(7, "reservation-half-admitted")

    reservation_admitted = Enum.YLeaf(8, "reservation-admitted")


    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['TunnelStateEnum']



class MplsTe(_Entity_):
    """
    MPLS Traffic Engineering operational data
    
    .. attribute:: segment_routing
    
    	Deprecated
    	**type**\:  :py:class:`SegmentRouting <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting>`
    
    	**config**\: False
    
    .. attribute:: fib_next_hop_routes
    
    	MPLS TE FIB nexthop route database
    	**type**\:  :py:class:`FibNextHopRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes>`
    
    	**config**\: False
    
    .. attribute:: next_hop_routes
    
    	MPLS TE nexthop route database
    	**type**\:  :py:class:`NextHopRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes>`
    
    	**config**\: False
    
    .. attribute:: te_mib
    
    	TE MIB information
    	**type**\:  :py:class:`TeMib <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TeMib>`
    
    	**config**\: False
    
    .. attribute:: hardware_out_of_resources
    
    	NPU Hardware OOR Information
    	**type**\:  :py:class:`HardwareOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources>`
    
    	**config**\: False
    
    .. attribute:: p2p_p2mp_tunnel
    
    	P2P or P2MP tunnels
    	**type**\:  :py:class:`P2pP2mpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel>`
    
    	**config**\: False
    
    .. attribute:: topology_nodes
    
    	A node in the MPLS\-TE topology
    	**type**\:  :py:class:`TopologyNodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes>`
    
    	**config**\: False
    
    .. attribute:: announce_tunnels_info
    
    	Announced tunnels (forwarding adjacency and autoroute annonce)
    	**type**\:  :py:class:`AnnounceTunnelsInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo>`
    
    	**config**\: False
    
    .. attribute:: collaborator_timers
    
    	TE Collaborator timer status
    	**type**\:  :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.CollaboratorTimers>`
    
    	**config**\: False
    
    .. attribute:: auto_tunnel
    
    	Auto tunnel information
    	**type**\:  :py:class:`AutoTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel>`
    
    	**config**\: False
    
    .. attribute:: soft_preemption
    
    	Soft Preemption information
    	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SoftPreemption>`
    
    	**config**\: False
    
    .. attribute:: forwarding_adjacency_destinations
    
    	Announced Destination tunnel
    	**type**\:  :py:class:`ForwardingAdjacencyDestinations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations>`
    
    	**config**\: False
    
    .. attribute:: igp_areas
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:  :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas>`
    
    	**config**\: False
    
    .. attribute:: wrap_protection
    
    	Represent all the LSP Wrap Protection info in MPLS\-TE
    	**type**\:  :py:class:`WrapProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection>`
    
    	**config**\: False
    
    .. attribute:: topology
    
    	The topology information in MPLS\-TE
    	**type**\:  :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology>`
    
    	**config**\: False
    
    .. attribute:: signalling_counters
    
    	TE counters
    	**type**\:  :py:class:`SignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters>`
    
    	**config**\: False
    
    .. attribute:: diff_serv_te_classes
    
    	The configured Diff Serv TE classes
    	**type**\:  :py:class:`DiffServTeClasses <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.DiffServTeClasses>`
    
    	**config**\: False
    
    .. attribute:: issu
    
    	MPLS TE ISSU information
    	**type**\:  :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu>`
    
    	**config**\: False
    
    .. attribute:: auto_route_destination_entries
    
    	MPLS TE autoroute destination table indexed by tunnel
    	**type**\:  :py:class:`AutoRouteDestinationEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries>`
    
    	**config**\: False
    
    .. attribute:: fast_reroute
    
    	Represent all the fastreroute info in MPLS\-TE
    	**type**\:  :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute>`
    
    	**config**\: False
    
    .. attribute:: attribute_sets
    
    	AttributeSet information
    	**type**\:  :py:class:`AttributeSets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets>`
    
    	**config**\: False
    
    .. attribute:: igp_area_briefs
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:  :py:class:`IgpAreaBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_accounting_counters
    
    	Bandwidth accounting counters
    	**type**\:  :py:class:`BandwidthAccountingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.BandwidthAccountingCounters>`
    
    	**config**\: False
    
    .. attribute:: tunnels
    
    	Failure protection provided for tunnels
    	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels>`
    
    	**config**\: False
    
    .. attribute:: maximum_tunnels
    
    	MPLS Traffic Engineering Tunnels
    	**type**\:  :py:class:`MaximumTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.MaximumTunnels>`
    
    	**config**\: False
    
    .. attribute:: path_protection
    
    	MPLS TE path protection info
    	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection>`
    
    	**config**\: False
    
    .. attribute:: fib_next_hop_label_routes
    
    	MPLS TE FIB nexthop label route database
    	**type**\:  :py:class:`FibNextHopLabelRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes>`
    
    	**config**\: False
    
    .. attribute:: p2mp
    
    	P2MP Information
    	**type**\:  :py:class:`P2mp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp>`
    
    	**config**\: False
    
    .. attribute:: lsp_out_of_resources
    
    	LSP OOR information
    	**type**\:  :py:class:`LspOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources>`
    
    	**config**\: False
    
    .. attribute:: bfd
    
    	MPLS TE BFD Oper Info
    	**type**\:  :py:class:`Bfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd>`
    
    	**config**\: False
    
    .. attribute:: nsr
    
    	MPLS TE NSR information
    	**type**\:  :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr>`
    
    	**config**\: False
    
    .. attribute:: auto_tunnel_services
    
    	MPLS TE Auto Tunnel Services
    	**type**\:  :py:class:`AutoTunnelServices <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices>`
    
    	**config**\: False
    
    .. attribute:: affinity_map
    
    	Affinity name to value mapping
    	**type**\:  :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap>`
    
    	**config**\: False
    
    .. attribute:: topology_briefs
    
    	MPLS\-TE topology brief table
    	**type**\:  :py:class:`TopologyBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsTe, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-te"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("segment-routing", ("segment_routing", MplsTe.SegmentRouting)), ("fib-next-hop-routes", ("fib_next_hop_routes", MplsTe.FibNextHopRoutes)), ("next-hop-routes", ("next_hop_routes", MplsTe.NextHopRoutes)), ("te-mib", ("te_mib", MplsTe.TeMib)), ("hardware-out-of-resources", ("hardware_out_of_resources", MplsTe.HardwareOutOfResources)), ("p2p-p2mp-tunnel", ("p2p_p2mp_tunnel", MplsTe.P2pP2mpTunnel)), ("topology-nodes", ("topology_nodes", MplsTe.TopologyNodes)), ("announce-tunnels-info", ("announce_tunnels_info", MplsTe.AnnounceTunnelsInfo)), ("collaborator-timers", ("collaborator_timers", MplsTe.CollaboratorTimers)), ("auto-tunnel", ("auto_tunnel", MplsTe.AutoTunnel)), ("soft-preemption", ("soft_preemption", MplsTe.SoftPreemption)), ("forwarding-adjacency-destinations", ("forwarding_adjacency_destinations", MplsTe.ForwardingAdjacencyDestinations)), ("igp-areas", ("igp_areas", MplsTe.IgpAreas)), ("wrap-protection", ("wrap_protection", MplsTe.WrapProtection)), ("topology", ("topology", MplsTe.Topology)), ("signalling-counters", ("signalling_counters", MplsTe.SignallingCounters)), ("diff-serv-te-classes", ("diff_serv_te_classes", MplsTe.DiffServTeClasses)), ("issu", ("issu", MplsTe.Issu)), ("auto-route-destination-entries", ("auto_route_destination_entries", MplsTe.AutoRouteDestinationEntries)), ("fast-reroute", ("fast_reroute", MplsTe.FastReroute)), ("attribute-sets", ("attribute_sets", MplsTe.AttributeSets)), ("igp-area-briefs", ("igp_area_briefs", MplsTe.IgpAreaBriefs)), ("bandwidth-accounting-counters", ("bandwidth_accounting_counters", MplsTe.BandwidthAccountingCounters)), ("tunnels", ("tunnels", MplsTe.Tunnels)), ("maximum-tunnels", ("maximum_tunnels", MplsTe.MaximumTunnels)), ("path-protection", ("path_protection", MplsTe.PathProtection)), ("fib-next-hop-label-routes", ("fib_next_hop_label_routes", MplsTe.FibNextHopLabelRoutes)), ("p2mp", ("p2mp", MplsTe.P2mp)), ("lsp-out-of-resources", ("lsp_out_of_resources", MplsTe.LspOutOfResources)), ("bfd", ("bfd", MplsTe.Bfd)), ("nsr", ("nsr", MplsTe.Nsr)), ("auto-tunnel-services", ("auto_tunnel_services", MplsTe.AutoTunnelServices)), ("affinity-map", ("affinity_map", MplsTe.AffinityMap)), ("topology-briefs", ("topology_briefs", MplsTe.TopologyBriefs))])
        self._leafs = OrderedDict()

        self.segment_routing = MplsTe.SegmentRouting()
        self.segment_routing.parent = self
        self._children_name_map["segment_routing"] = "segment-routing"

        self.fib_next_hop_routes = MplsTe.FibNextHopRoutes()
        self.fib_next_hop_routes.parent = self
        self._children_name_map["fib_next_hop_routes"] = "fib-next-hop-routes"

        self.next_hop_routes = MplsTe.NextHopRoutes()
        self.next_hop_routes.parent = self
        self._children_name_map["next_hop_routes"] = "next-hop-routes"

        self.te_mib = MplsTe.TeMib()
        self.te_mib.parent = self
        self._children_name_map["te_mib"] = "te-mib"

        self.hardware_out_of_resources = MplsTe.HardwareOutOfResources()
        self.hardware_out_of_resources.parent = self
        self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"

        self.p2p_p2mp_tunnel = MplsTe.P2pP2mpTunnel()
        self.p2p_p2mp_tunnel.parent = self
        self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"

        self.topology_nodes = MplsTe.TopologyNodes()
        self.topology_nodes.parent = self
        self._children_name_map["topology_nodes"] = "topology-nodes"

        self.announce_tunnels_info = MplsTe.AnnounceTunnelsInfo()
        self.announce_tunnels_info.parent = self
        self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"

        self.collaborator_timers = MplsTe.CollaboratorTimers()
        self.collaborator_timers.parent = self
        self._children_name_map["collaborator_timers"] = "collaborator-timers"

        self.auto_tunnel = MplsTe.AutoTunnel()
        self.auto_tunnel.parent = self
        self._children_name_map["auto_tunnel"] = "auto-tunnel"

        self.soft_preemption = MplsTe.SoftPreemption()
        self.soft_preemption.parent = self
        self._children_name_map["soft_preemption"] = "soft-preemption"

        self.forwarding_adjacency_destinations = MplsTe.ForwardingAdjacencyDestinations()
        self.forwarding_adjacency_destinations.parent = self
        self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"

        self.igp_areas = MplsTe.IgpAreas()
        self.igp_areas.parent = self
        self._children_name_map["igp_areas"] = "igp-areas"

        self.wrap_protection = MplsTe.WrapProtection()
        self.wrap_protection.parent = self
        self._children_name_map["wrap_protection"] = "wrap-protection"

        self.topology = MplsTe.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"

        self.signalling_counters = MplsTe.SignallingCounters()
        self.signalling_counters.parent = self
        self._children_name_map["signalling_counters"] = "signalling-counters"

        self.diff_serv_te_classes = MplsTe.DiffServTeClasses()
        self.diff_serv_te_classes.parent = self
        self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"

        self.issu = MplsTe.Issu()
        self.issu.parent = self
        self._children_name_map["issu"] = "issu"

        self.auto_route_destination_entries = MplsTe.AutoRouteDestinationEntries()
        self.auto_route_destination_entries.parent = self
        self._children_name_map["auto_route_destination_entries"] = "auto-route-destination-entries"

        self.fast_reroute = MplsTe.FastReroute()
        self.fast_reroute.parent = self
        self._children_name_map["fast_reroute"] = "fast-reroute"

        self.attribute_sets = MplsTe.AttributeSets()
        self.attribute_sets.parent = self
        self._children_name_map["attribute_sets"] = "attribute-sets"

        self.igp_area_briefs = MplsTe.IgpAreaBriefs()
        self.igp_area_briefs.parent = self
        self._children_name_map["igp_area_briefs"] = "igp-area-briefs"

        self.bandwidth_accounting_counters = MplsTe.BandwidthAccountingCounters()
        self.bandwidth_accounting_counters.parent = self
        self._children_name_map["bandwidth_accounting_counters"] = "bandwidth-accounting-counters"

        self.tunnels = MplsTe.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"

        self.maximum_tunnels = MplsTe.MaximumTunnels()
        self.maximum_tunnels.parent = self
        self._children_name_map["maximum_tunnels"] = "maximum-tunnels"

        self.path_protection = MplsTe.PathProtection()
        self.path_protection.parent = self
        self._children_name_map["path_protection"] = "path-protection"

        self.fib_next_hop_label_routes = MplsTe.FibNextHopLabelRoutes()
        self.fib_next_hop_label_routes.parent = self
        self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"

        self.p2mp = MplsTe.P2mp()
        self.p2mp.parent = self
        self._children_name_map["p2mp"] = "p2mp"

        self.lsp_out_of_resources = MplsTe.LspOutOfResources()
        self.lsp_out_of_resources.parent = self
        self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"

        self.bfd = MplsTe.Bfd()
        self.bfd.parent = self
        self._children_name_map["bfd"] = "bfd"

        self.nsr = MplsTe.Nsr()
        self.nsr.parent = self
        self._children_name_map["nsr"] = "nsr"

        self.auto_tunnel_services = MplsTe.AutoTunnelServices()
        self.auto_tunnel_services.parent = self
        self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"

        self.affinity_map = MplsTe.AffinityMap()
        self.affinity_map.parent = self
        self._children_name_map["affinity_map"] = "affinity-map"

        self.topology_briefs = MplsTe.TopologyBriefs()
        self.topology_briefs.parent = self
        self._children_name_map["topology_briefs"] = "topology-briefs"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsTe, [], name, value)


    class SegmentRouting(_Entity_):
        """
        Deprecated
        
        .. attribute:: srigp_area_infos
        
        	Segment\-Routing information about IGP areas
        	**type**\:  :py:class:`SrigpAreaInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrigpAreaInfos>`
        
        	**config**\: False
        
        .. attribute:: sr_node_infos
        
        	Segment\-Routing nodes database in MPLS\-TE
        	**type**\:  :py:class:`SrNodeInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos>`
        
        	**config**\: False
        
        .. attribute:: sr_prefix_infos
        
        	Segment\-Routing prefixes database in MPLS\-TE
        	**type**\:  :py:class:`SrPrefixInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.SegmentRouting, self).__init__()

            self.yang_name = "segment-routing"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("srigp-area-infos", ("srigp_area_infos", MplsTe.SegmentRouting.SrigpAreaInfos)), ("sr-node-infos", ("sr_node_infos", MplsTe.SegmentRouting.SrNodeInfos)), ("sr-prefix-infos", ("sr_prefix_infos", MplsTe.SegmentRouting.SrPrefixInfos))])
            self._leafs = OrderedDict()

            self.srigp_area_infos = MplsTe.SegmentRouting.SrigpAreaInfos()
            self.srigp_area_infos.parent = self
            self._children_name_map["srigp_area_infos"] = "srigp-area-infos"

            self.sr_node_infos = MplsTe.SegmentRouting.SrNodeInfos()
            self.sr_node_infos.parent = self
            self._children_name_map["sr_node_infos"] = "sr-node-infos"

            self.sr_prefix_infos = MplsTe.SegmentRouting.SrPrefixInfos()
            self.sr_prefix_infos.parent = self
            self._children_name_map["sr_prefix_infos"] = "sr-prefix-infos"
            self._segment_path = lambda: "segment-routing"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.SegmentRouting, [], name, value)


        class SrigpAreaInfos(_Entity_):
            """
            Segment\-Routing information about IGP areas
            
            .. attribute:: srigp_area_info
            
            	A Segment\-Routing IGP area information
            	**type**\: list of  		 :py:class:`SrigpAreaInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SegmentRouting.SrigpAreaInfos, self).__init__()

                self.yang_name = "srigp-area-infos"
                self.yang_parent_name = "segment-routing"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("srigp-area-info", ("srigp_area_info", MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo))])
                self._leafs = OrderedDict()

                self.srigp_area_info = YList(self)
                self._segment_path = lambda: "srigp-area-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SegmentRouting.SrigpAreaInfos, [], name, value)


            class SrigpAreaInfo(_Entity_):
                """
                A Segment\-Routing IGP area information
                
                .. attribute:: protocol  (key)
                
                	IGP protocol type
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance  (key)
                
                	IGP instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	IGP area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: segment_routing_enabled
                
                	True if the Segment\-Routing is enabled in this area
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: strict_spf_enabled
                
                	True if the strict SPF is enabled in this area
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance_xr
                
                	IGP Instance name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_area_format
                
                	IGP\-area format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo, self).__init__()

                    self.yang_name = "srigp-area-info"
                    self.yang_parent_name = "srigp-area-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['protocol','igp_instance','area']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('segment_routing_enabled', (YLeaf(YType.boolean, 'segment-routing-enabled'), ['bool'])),
                        ('strict_spf_enabled', (YLeaf(YType.boolean, 'strict-spf-enabled'), ['bool'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance_xr', (YLeaf(YType.str, 'igp-instance-xr'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                    ])
                    self.protocol = None
                    self.igp_instance = None
                    self.area = None
                    self.segment_routing_enabled = None
                    self.strict_spf_enabled = None
                    self.igp_type = None
                    self.igp_instance_xr = None
                    self.igp_area = None
                    self.igp_area_format = None
                    self._segment_path = lambda: "srigp-area-info" + "[protocol='" + str(self.protocol) + "']" + "[igp-instance='" + str(self.igp_instance) + "']" + "[area='" + str(self.area) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/srigp-area-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo, ['protocol', 'igp_instance', 'area', 'segment_routing_enabled', 'strict_spf_enabled', 'igp_type', 'igp_instance_xr', 'igp_area', 'igp_area_format'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SegmentRouting.SrigpAreaInfos.SrigpAreaInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SegmentRouting.SrigpAreaInfos']['meta_info']


        class SrNodeInfos(_Entity_):
            """
            Segment\-Routing nodes database in MPLS\-TE
            
            .. attribute:: sr_node_info
            
            	A Segment\-Routing node information
            	**type**\: list of  		 :py:class:`SrNodeInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SegmentRouting.SrNodeInfos, self).__init__()

                self.yang_name = "sr-node-infos"
                self.yang_parent_name = "segment-routing"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sr-node-info", ("sr_node_info", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo))])
                self._leafs = OrderedDict()

                self.sr_node_info = YList(self)
                self._segment_path = lambda: "sr-node-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos, [], name, value)


            class SrNodeInfo(_Entity_):
                """
                A Segment\-Routing node information
                
                .. attribute:: protocol  (key)
                
                	IGP protocol type
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance  (key)
                
                	IGP instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	IGP area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_node_id  (key)
                
                	Node's IGP ID
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP area which this node belongs to
                	**type**\:  :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea>`
                
                	**config**\: False
                
                .. attribute:: sr_node_info
                
                	Segment\-Routing Node information
                	**type**\:  :py:class:`SrNodeInfo_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_>`
                
                	**config**\: False
                
                .. attribute:: local_node_igp_id
                
                	The local node's IGP id formatted as string
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: topology_node_is_router
                
                	TRUE if this is a router node; FALSE if it's a network node
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: local_node_te_router_id
                
                	The local node's TE router\-id
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_node_overloaded
                
                	Flag to indicate whether this node is overloaded
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: node_link
                
                	This node's link information
                	**type**\: list of  		 :py:class:`NodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo, self).__init__()

                    self.yang_name = "sr-node-info"
                    self.yang_parent_name = "sr-node-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['protocol','igp_instance','area','igp_node_id']
                    self._child_classes = OrderedDict([("igp-area", ("igp_area", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea)), ("sr-node-info", ("sr_node_info", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_)), ("node-link", ("node_link", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink))])
                    self._leafs = OrderedDict([
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('igp_node_id', (YLeaf(YType.str, 'igp-node-id'), ['str'])),
                        ('local_node_igp_id', (YLeaf(YType.str, 'local-node-igp-id'), ['str'])),
                        ('topology_node_is_router', (YLeaf(YType.boolean, 'topology-node-is-router'), ['bool'])),
                        ('local_node_te_router_id', (YLeaf(YType.str, 'local-node-te-router-id'), ['str'])),
                        ('topology_node_overloaded', (YLeaf(YType.boolean, 'topology-node-overloaded'), ['bool'])),
                    ])
                    self.protocol = None
                    self.igp_instance = None
                    self.area = None
                    self.igp_node_id = None
                    self.local_node_igp_id = None
                    self.topology_node_is_router = None
                    self.local_node_te_router_id = None
                    self.topology_node_overloaded = None

                    self.igp_area = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea()
                    self.igp_area.parent = self
                    self._children_name_map["igp_area"] = "igp-area"

                    self.sr_node_info = MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_()
                    self.sr_node_info.parent = self
                    self._children_name_map["sr_node_info"] = "sr-node-info"

                    self.node_link = YList(self)
                    self._segment_path = lambda: "sr-node-info" + "[protocol='" + str(self.protocol) + "']" + "[igp-instance='" + str(self.igp_instance) + "']" + "[area='" + str(self.area) + "']" + "[igp-node-id='" + str(self.igp_node_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/sr-node-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo, ['protocol', 'igp_instance', 'area', 'igp_node_id', 'local_node_igp_id', 'topology_node_is_router', 'local_node_te_router_id', 'topology_node_overloaded'], name, value)


                class IgpArea(_Entity_):
                    """
                    IGP area which this node belongs to
                    
                    .. attribute:: segment_routing_enabled
                    
                    	True if the Segment\-Routing is enabled in this area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: strict_spf_enabled
                    
                    	True if the strict SPF is enabled in this area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_instance_xr
                    
                    	IGP Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea, self).__init__()

                        self.yang_name = "igp-area"
                        self.yang_parent_name = "sr-node-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('segment_routing_enabled', (YLeaf(YType.boolean, 'segment-routing-enabled'), ['bool'])),
                            ('strict_spf_enabled', (YLeaf(YType.boolean, 'strict-spf-enabled'), ['bool'])),
                            ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                            ('igp_instance_xr', (YLeaf(YType.str, 'igp-instance-xr'), ['str'])),
                            ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                            ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ])
                        self.segment_routing_enabled = None
                        self.strict_spf_enabled = None
                        self.igp_type = None
                        self.igp_instance_xr = None
                        self.igp_area = None
                        self.igp_area_format = None
                        self._segment_path = lambda: "igp-area"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea, ['segment_routing_enabled', 'strict_spf_enabled', 'igp_type', 'igp_instance_xr', 'igp_area', 'igp_area_format'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.IgpArea']['meta_info']


                class SrNodeInfo_(_Entity_):
                    """
                    Segment\-Routing Node information
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_, self).__init__()

                        self.yang_name = "sr-node-info"
                        self.yang_parent_name = "sr-node-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                            ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                            ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                            ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                        ])
                        self.segment_id = None
                        self.segment_id_local_absolute_value = None
                        self.srgb_start = None
                        self.srgb_size = None
                        self._segment_path = lambda: "sr-node-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.SrNodeInfo_']['meta_info']


                class NodeLink(_Entity_):
                    """
                    This node's link information
                    
                    .. attribute:: topology_link_type
                    
                    	Link type
                    	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_interface_address
                    
                    	Link's local interface address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_interface_id
                    
                    	Link's local interface ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_neighbor_address
                    
                    	Link's neighbor interface address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_neighbor_id
                    
                    	Link's neighbor interface ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_neighbor_system_id
                    
                    	System id of neighbor
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_neighbor_node_id
                    
                    	Node id of neighbor
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_neighbor_generation
                    
                    	Neighbor's link version counter
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_fragment_id
                    
                    	Neighbor's link version counter
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_te_metric
                    
                    	The link's TE metric
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_igp_metric
                    
                    	The link's IGP metric
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_extended_affinity_bit
                    
                    	The link's affinity bits (colors)
                    	**type**\: list of  		 :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit>`
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: adjacency_sids
                    
                    	Adjacency SIDs assigned for adjacency nodes
                    	**type**\: list of  		 :py:class:`AdjacencySids <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink, self).__init__()

                        self.yang_name = "node-link"
                        self.yang_parent_name = "sr-node-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("topology-link-extended-affinity-bit", ("topology_link_extended_affinity_bit", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup)), ("adjacency-sids", ("adjacency_sids", MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids))])
                        self._leafs = OrderedDict([
                            ('topology_link_type', (YLeaf(YType.enumeration, 'topology-link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                            ('topology_link_interface_address', (YLeaf(YType.str, 'topology-link-interface-address'), ['str'])),
                            ('topology_link_interface_id', (YLeaf(YType.uint32, 'topology-link-interface-id'), ['int'])),
                            ('topology_link_neighbor_address', (YLeaf(YType.str, 'topology-link-neighbor-address'), ['str'])),
                            ('topology_link_neighbor_id', (YLeaf(YType.uint32, 'topology-link-neighbor-id'), ['int'])),
                            ('topology_link_neighbor_system_id', (YLeaf(YType.str, 'topology-link-neighbor-system-id'), ['str'])),
                            ('topology_link_neighbor_node_id', (YLeaf(YType.uint32, 'topology-link-neighbor-node-id'), ['int'])),
                            ('topology_link_neighbor_generation', (YLeaf(YType.uint32, 'topology-link-neighbor-generation'), ['int'])),
                            ('topology_link_fragment_id', (YLeaf(YType.uint32, 'topology-link-fragment-id'), ['int'])),
                            ('topology_link_te_metric', (YLeaf(YType.uint32, 'topology-link-te-metric'), ['int'])),
                            ('topology_link_igp_metric', (YLeaf(YType.uint32, 'topology-link-igp-metric'), ['int'])),
                        ])
                        self.topology_link_type = None
                        self.topology_link_interface_address = None
                        self.topology_link_interface_id = None
                        self.topology_link_neighbor_address = None
                        self.topology_link_neighbor_id = None
                        self.topology_link_neighbor_system_id = None
                        self.topology_link_neighbor_node_id = None
                        self.topology_link_neighbor_generation = None
                        self.topology_link_fragment_id = None
                        self.topology_link_te_metric = None
                        self.topology_link_igp_metric = None

                        self.topology_link_extended_affinity_bit = YList(self)
                        self.shared_risk_link_group = YList(self)
                        self.adjacency_sids = YList(self)
                        self._segment_path = lambda: "node-link"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink, ['topology_link_type', 'topology_link_interface_address', 'topology_link_interface_id', 'topology_link_neighbor_address', 'topology_link_neighbor_id', 'topology_link_neighbor_system_id', 'topology_link_neighbor_node_id', 'topology_link_neighbor_generation', 'topology_link_fragment_id', 'topology_link_te_metric', 'topology_link_igp_metric'], name, value)


                    class TopologyLinkExtendedAffinityBit(_Entity_):
                        """
                        The link's affinity bits (colors)
                        
                        .. attribute:: entry
                        
                        	The link's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                            self.yang_name = "topology-link-extended-affinity-bit"
                            self.yang_parent_name = "node-link"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "topology-link-extended-affinity-bit"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.TopologyLinkExtendedAffinityBit']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "node-link"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.SharedRiskLinkGroup']['meta_info']


                    class AdjacencySids(_Entity_):
                        """
                        Adjacency SIDs assigned for adjacency nodes
                        
                        .. attribute:: adjacency_sid
                        
                        	The adjacency SID assigned for the topology node
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: link_type
                        
                        	Link Type
                        	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_addr
                        
                        	Local Address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_addr
                        
                        	Remote Address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: nbr_node_igpid
                        
                        	The neighbor node's IGP ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: nbr_node_te_router_id
                        
                        	The neigbor node's TE router\-id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: flag_f
                        
                        	IGP Flag F
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: flag_b
                        
                        	IGP Flag B
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: flag_v
                        
                        	IGP Flag V
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: flag_l
                        
                        	IGP Flag L
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: flag_s
                        
                        	IGP Flag S
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids, self).__init__()

                            self.yang_name = "adjacency-sids"
                            self.yang_parent_name = "node-link"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('adjacency_sid', (YLeaf(YType.uint32, 'adjacency-sid'), ['int'])),
                                ('link_type', (YLeaf(YType.enumeration, 'link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                                ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                ('nbr_node_igpid', (YLeaf(YType.str, 'nbr-node-igpid'), ['str'])),
                                ('nbr_node_te_router_id', (YLeaf(YType.str, 'nbr-node-te-router-id'), ['str'])),
                                ('flag_f', (YLeaf(YType.boolean, 'flag-f'), ['bool'])),
                                ('flag_b', (YLeaf(YType.boolean, 'flag-b'), ['bool'])),
                                ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                                ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                                ('flag_s', (YLeaf(YType.boolean, 'flag-s'), ['bool'])),
                            ])
                            self.adjacency_sid = None
                            self.link_type = None
                            self.local_addr = None
                            self.remote_addr = None
                            self.nbr_node_igpid = None
                            self.nbr_node_te_router_id = None
                            self.flag_f = None
                            self.flag_b = None
                            self.flag_v = None
                            self.flag_l = None
                            self.flag_s = None
                            self._segment_path = lambda: "adjacency-sids"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids, ['adjacency_sid', 'link_type', 'local_addr', 'remote_addr', 'nbr_node_igpid', 'nbr_node_te_router_id', 'flag_f', 'flag_b', 'flag_v', 'flag_l', 'flag_s'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink.AdjacencySids']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo.NodeLink']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos.SrNodeInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SegmentRouting.SrNodeInfos']['meta_info']


        class SrPrefixInfos(_Entity_):
            """
            Segment\-Routing prefixes database in MPLS\-TE
            
            .. attribute:: sr_prefix_info
            
            	A Segment\-Routing prefix information
            	**type**\: list of  		 :py:class:`SrPrefixInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SegmentRouting.SrPrefixInfos, self).__init__()

                self.yang_name = "sr-prefix-infos"
                self.yang_parent_name = "segment-routing"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sr-prefix-info", ("sr_prefix_info", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo))])
                self._leafs = OrderedDict()

                self.sr_prefix_info = YList(self)
                self._segment_path = lambda: "sr-prefix-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos, [], name, value)


            class SrPrefixInfo(_Entity_):
                """
                A Segment\-Routing prefix information
                
                .. attribute:: protocol  (key)
                
                	IGP protocol type
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance  (key)
                
                	IGP instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	IGP area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: prefix  (key)
                
                	Segment\-Routing prefix
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: prefix_length  (key)
                
                	Prefix' length
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	An IGP area where the prefix belongs to
                	**type**\:  :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea>`
                
                	**config**\: False
                
                .. attribute:: prefix_xr
                
                	Prefix
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: prefix_length_xr
                
                	Length of the prefix
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: prefix_sid
                
                	Segment\-Routing prefix SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: prefix_strict_sid
                
                	Segment\-Routing prefix Strict SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: flag_r
                
                	Prefix\-SID subTLV R\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flag_n
                
                	Prefix\-SID subTLV N\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flag_p
                
                	Prefix\-SID subTLV P\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flag_e
                
                	Prefix\-SID subTLV E\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flag_v
                
                	Prefix\-SID subTLV V\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flag_l
                
                	Prefix\-SID subTLV L\-flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: strict_flag_p
                
                	Prefix\-SID subTLV P\-flag for strict SID
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: strict_flag_e
                
                	Prefix\-SID subTLV E\-flag for strict SID
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: strict_flag_v
                
                	Prefix\-SID subTLV V\-flag for strict SID
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: strict_flag_l
                
                	Prefix\-SID subTLV L\-flag for strict SID
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: sr_path
                
                	Segment\-Routing paths to prefix
                	**type**\: list of  		 :py:class:`SrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath>`
                
                	**config**\: False
                
                .. attribute:: advertizing_node
                
                	Advertizing nodes
                	**type**\: list of  		 :py:class:`AdvertizingNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode>`
                
                	**config**\: False
                
                .. attribute:: strict_advertizing_node
                
                	Advertizing nodes for Strict SPF
                	**type**\: list of  		 :py:class:`StrictAdvertizingNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo, self).__init__()

                    self.yang_name = "sr-prefix-info"
                    self.yang_parent_name = "sr-prefix-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['protocol','igp_instance','area','prefix','prefix_length']
                    self._child_classes = OrderedDict([("igp-area", ("igp_area", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea)), ("sr-path", ("sr_path", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath)), ("advertizing-node", ("advertizing_node", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode)), ("strict-advertizing-node", ("strict_advertizing_node", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode))])
                    self._leafs = OrderedDict([
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('prefix', (YLeaf(YType.str, 'prefix'), ['str'])),
                        ('prefix_length', (YLeaf(YType.uint32, 'prefix-length'), ['int'])),
                        ('prefix_xr', (YLeaf(YType.str, 'prefix-xr'), ['str'])),
                        ('prefix_length_xr', (YLeaf(YType.uint8, 'prefix-length-xr'), ['int'])),
                        ('prefix_sid', (YLeaf(YType.uint32, 'prefix-sid'), ['int'])),
                        ('prefix_strict_sid', (YLeaf(YType.uint32, 'prefix-strict-sid'), ['int'])),
                        ('flag_r', (YLeaf(YType.boolean, 'flag-r'), ['bool'])),
                        ('flag_n', (YLeaf(YType.boolean, 'flag-n'), ['bool'])),
                        ('flag_p', (YLeaf(YType.boolean, 'flag-p'), ['bool'])),
                        ('flag_e', (YLeaf(YType.boolean, 'flag-e'), ['bool'])),
                        ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                        ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                        ('strict_flag_p', (YLeaf(YType.boolean, 'strict-flag-p'), ['bool'])),
                        ('strict_flag_e', (YLeaf(YType.boolean, 'strict-flag-e'), ['bool'])),
                        ('strict_flag_v', (YLeaf(YType.boolean, 'strict-flag-v'), ['bool'])),
                        ('strict_flag_l', (YLeaf(YType.boolean, 'strict-flag-l'), ['bool'])),
                    ])
                    self.protocol = None
                    self.igp_instance = None
                    self.area = None
                    self.prefix = None
                    self.prefix_length = None
                    self.prefix_xr = None
                    self.prefix_length_xr = None
                    self.prefix_sid = None
                    self.prefix_strict_sid = None
                    self.flag_r = None
                    self.flag_n = None
                    self.flag_p = None
                    self.flag_e = None
                    self.flag_v = None
                    self.flag_l = None
                    self.strict_flag_p = None
                    self.strict_flag_e = None
                    self.strict_flag_v = None
                    self.strict_flag_l = None

                    self.igp_area = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea()
                    self.igp_area.parent = self
                    self._children_name_map["igp_area"] = "igp-area"

                    self.sr_path = YList(self)
                    self.advertizing_node = YList(self)
                    self.strict_advertizing_node = YList(self)
                    self._segment_path = lambda: "sr-prefix-info" + "[protocol='" + str(self.protocol) + "']" + "[igp-instance='" + str(self.igp_instance) + "']" + "[area='" + str(self.area) + "']" + "[prefix='" + str(self.prefix) + "']" + "[prefix-length='" + str(self.prefix_length) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/segment-routing/sr-prefix-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo, ['protocol', 'igp_instance', 'area', 'prefix', 'prefix_length', 'prefix_xr', 'prefix_length_xr', 'prefix_sid', 'prefix_strict_sid', 'flag_r', 'flag_n', 'flag_p', 'flag_e', 'flag_v', 'flag_l', 'strict_flag_p', 'strict_flag_e', 'strict_flag_v', 'strict_flag_l'], name, value)


                class IgpArea(_Entity_):
                    """
                    An IGP area where the prefix belongs to
                    
                    .. attribute:: segment_routing_enabled
                    
                    	True if the Segment\-Routing is enabled in this area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: strict_spf_enabled
                    
                    	True if the strict SPF is enabled in this area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_instance_xr
                    
                    	IGP Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea, self).__init__()

                        self.yang_name = "igp-area"
                        self.yang_parent_name = "sr-prefix-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('segment_routing_enabled', (YLeaf(YType.boolean, 'segment-routing-enabled'), ['bool'])),
                            ('strict_spf_enabled', (YLeaf(YType.boolean, 'strict-spf-enabled'), ['bool'])),
                            ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                            ('igp_instance_xr', (YLeaf(YType.str, 'igp-instance-xr'), ['str'])),
                            ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                            ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ])
                        self.segment_routing_enabled = None
                        self.strict_spf_enabled = None
                        self.igp_type = None
                        self.igp_instance_xr = None
                        self.igp_area = None
                        self.igp_area_format = None
                        self._segment_path = lambda: "igp-area"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea, ['segment_routing_enabled', 'strict_spf_enabled', 'igp_type', 'igp_instance_xr', 'igp_area', 'igp_area_format'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.IgpArea']['meta_info']


                class SrPath(_Entity_):
                    """
                    Segment\-Routing paths to prefix
                    
                    .. attribute:: primary_path
                    
                    	Primary Segment\-Routing Path
                    	**type**\:  :py:class:`PrimaryPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath>`
                    
                    	**config**\: False
                    
                    .. attribute:: backup_path
                    
                    	Backup Segment\-Routing Path
                    	**type**\:  :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath>`
                    
                    	**config**\: False
                    
                    .. attribute:: has_backup_path
                    
                    	Backup Path is available
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath, self).__init__()

                        self.yang_name = "sr-path"
                        self.yang_parent_name = "sr-prefix-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("primary-path", ("primary_path", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath)), ("backup-path", ("backup_path", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath))])
                        self._leafs = OrderedDict([
                            ('has_backup_path', (YLeaf(YType.boolean, 'has-backup-path'), ['bool'])),
                        ])
                        self.has_backup_path = None

                        self.primary_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath()
                        self.primary_path.parent = self
                        self._children_name_map["primary_path"] = "primary-path"

                        self.backup_path = MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath()
                        self.backup_path.parent = self
                        self._children_name_map["backup_path"] = "backup-path"
                        self._segment_path = lambda: "sr-path"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath, ['has_backup_path'], name, value)


                    class PrimaryPath(_Entity_):
                        """
                        Primary Segment\-Routing Path
                        
                        .. attribute:: outgoing_interface
                        
                        	Outgoing Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: outgoing_label
                        
                        	Outgoing Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outgoing_strict_label
                        
                        	Outgoing Label for Strict SPF
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop
                        
                        	Next hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_id
                        
                        	Path Identifier
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_path_id
                        
                        	Backup Path Identifier
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath, self).__init__()

                            self.yang_name = "primary-path"
                            self.yang_parent_name = "sr-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                                ('outgoing_label', (YLeaf(YType.uint32, 'outgoing-label'), ['int'])),
                                ('outgoing_strict_label', (YLeaf(YType.uint32, 'outgoing-strict-label'), ['int'])),
                                ('next_hop', (YLeaf(YType.str, 'next-hop'), ['str'])),
                                ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                                ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                            ])
                            self.outgoing_interface = None
                            self.outgoing_label = None
                            self.outgoing_strict_label = None
                            self.next_hop = None
                            self.path_id = None
                            self.backup_path_id = None
                            self._segment_path = lambda: "primary-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath, ['outgoing_interface', 'outgoing_label', 'outgoing_strict_label', 'next_hop', 'path_id', 'backup_path_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.PrimaryPath']['meta_info']


                    class BackupPath(_Entity_):
                        """
                        Backup Segment\-Routing Path
                        
                        .. attribute:: outgoing_interface
                        
                        	Outgoing Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop
                        
                        	Next hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: outgoing_labels_stack
                        
                        	Outgoing Labels Stack
                        	**type**\: list of  		 :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack>`
                        
                        	**config**\: False
                        
                        .. attribute:: outgoing_strict_labels_stack
                        
                        	Outgoing Labels Stack for Strict SPF
                        	**type**\: list of  		 :py:class:`OutgoingStrictLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath, self).__init__()

                            self.yang_name = "backup-path"
                            self.yang_parent_name = "sr-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("outgoing-labels-stack", ("outgoing_labels_stack", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack)), ("outgoing-strict-labels-stack", ("outgoing_strict_labels_stack", MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack))])
                            self._leafs = OrderedDict([
                                ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                                ('next_hop', (YLeaf(YType.str, 'next-hop'), ['str'])),
                            ])
                            self.outgoing_interface = None
                            self.next_hop = None

                            self.outgoing_labels_stack = YList(self)
                            self.outgoing_strict_labels_stack = YList(self)
                            self._segment_path = lambda: "backup-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath, ['outgoing_interface', 'next_hop'], name, value)


                        class OutgoingLabelsStack(_Entity_):
                            """
                            Outgoing Labels Stack
                            
                            .. attribute:: entry
                            
                            	Outgoing Labels Stack
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack, self).__init__()

                                self.yang_name = "outgoing-labels-stack"
                                self.yang_parent_name = "backup-path"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "outgoing-labels-stack"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingLabelsStack']['meta_info']


                        class OutgoingStrictLabelsStack(_Entity_):
                            """
                            Outgoing Labels Stack for Strict SPF
                            
                            .. attribute:: entry
                            
                            	Outgoing Labels Stack for Strict SPF
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack, self).__init__()

                                self.yang_name = "outgoing-strict-labels-stack"
                                self.yang_parent_name = "backup-path"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "outgoing-strict-labels-stack"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath.OutgoingStrictLabelsStack']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath.BackupPath']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.SrPath']['meta_info']


                class AdvertizingNode(_Entity_):
                    """
                    Advertizing nodes
                    
                    .. attribute:: node_id
                    
                    	Node Identifier
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode, self).__init__()

                        self.yang_name = "advertizing-node"
                        self.yang_parent_name = "sr-prefix-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ])
                        self.node_id = None
                        self._segment_path = lambda: "advertizing-node"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode, ['node_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.AdvertizingNode']['meta_info']


                class StrictAdvertizingNode(_Entity_):
                    """
                    Advertizing nodes for Strict SPF
                    
                    .. attribute:: node_id
                    
                    	Node Identifier
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode, self).__init__()

                        self.yang_name = "strict-advertizing-node"
                        self.yang_parent_name = "sr-prefix-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ])
                        self.node_id = None
                        self._segment_path = lambda: "strict-advertizing-node"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode, ['node_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo.StrictAdvertizingNode']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos.SrPrefixInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SegmentRouting.SrPrefixInfos']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.SegmentRouting']['meta_info']


    class FibNextHopRoutes(_Entity_):
        """
        MPLS TE FIB nexthop route database
        
        .. attribute:: fib_next_hop_route
        
        	MPLS TE FIB nexthop route
        	**type**\: list of  		 :py:class:`FibNextHopRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.FibNextHopRoutes, self).__init__()

            self.yang_name = "fib-next-hop-routes"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("fib-next-hop-route", ("fib_next_hop_route", MplsTe.FibNextHopRoutes.FibNextHopRoute))])
            self._leafs = OrderedDict()

            self.fib_next_hop_route = YList(self)
            self._segment_path = lambda: "fib-next-hop-routes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.FibNextHopRoutes, [], name, value)


        class FibNextHopRoute(_Entity_):
            """
            MPLS TE FIB nexthop route
            
            .. attribute:: prefix_address  (key)
            
            	Prefix Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:  :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress>`
            
            	**config**\: False
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: route_version
            
            	Route version
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of  		 :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FibNextHopRoutes.FibNextHopRoute, self).__init__()

                self.yang_name = "fib-next-hop-route"
                self.yang_parent_name = "fib-next-hop-routes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['prefix_address']
                self._child_classes = OrderedDict([("target-address", ("target_address", MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress)), ("next-hop-path", ("next_hop_path", MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath))])
                self._leafs = OrderedDict([
                    ('prefix_address', (YLeaf(YType.str, 'prefix-address'), ['str'])),
                    ('prefix_addr', (YLeaf(YType.str, 'prefix-addr'), ['str'])),
                    ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                    ('last_used_time', (YLeaf(YType.uint32, 'last-used-time'), ['int'])),
                    ('last_update_time', (YLeaf(YType.uint32, 'last-update-time'), ['int'])),
                    ('expire_time', (YLeaf(YType.uint32, 'expire-time'), ['int'])),
                    ('is_registered', (YLeaf(YType.boolean, 'is-registered'), ['bool'])),
                    ('is_notified', (YLeaf(YType.boolean, 'is-notified'), ['bool'])),
                    ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                    ('route_version', (YLeaf(YType.uint64, 'route-version'), ['int'])),
                ])
                self.prefix_address = None
                self.prefix_addr = None
                self.create_time = None
                self.last_used_time = None
                self.last_update_time = None
                self.expire_time = None
                self.is_registered = None
                self.is_notified = None
                self.is_stale = None
                self.route_version = None

                self.target_address = MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"

                self.next_hop_path = YList(self)
                self._segment_path = lambda: "fib-next-hop-route" + "[prefix-address='" + str(self.prefix_address) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fib-next-hop-routes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FibNextHopRoutes.FibNextHopRoute, ['prefix_address', 'prefix_addr', 'create_time', 'last_used_time', 'last_update_time', 'expire_time', 'is_registered', 'is_notified', 'is_stale', 'route_version'], name, value)


            class TargetAddress(_Entity_):
                """
                Next Hop Target Address
                
                .. attribute:: type
                
                	type
                	**type**\:  :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                	**config**\: False
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeTargetAddr', '')])),
                        ('ip_address', (YLeaf(YType.str, 'ip-address'), ['str'])),
                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                    ])
                    self.type = None
                    self.ip_address = None
                    self.label = None
                    self._segment_path = lambda: "target-address"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress, ['type', 'ip_address', 'label'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FibNextHopRoutes.FibNextHopRoute.TargetAddress']['meta_info']


            class NextHopPath(_Entity_):
                """
                Next Hop Paths
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of  		 :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("label-stack", ("label_stack", MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack))])
                    self._leafs = OrderedDict([
                        ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                        ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                        ('pure_backup', (YLeaf(YType.boolean, 'pure-backup'), ['bool'])),
                    ])
                    self.interface = None
                    self.next_hop_address = None
                    self.path_id = None
                    self.backup_path_id = None
                    self.pure_backup = None

                    self.label_stack = YList(self)
                    self._segment_path = lambda: "next-hop-path"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath, ['interface', 'next_hop_address', 'path_id', 'backup_path_id', 'pure_backup'], name, value)


                class LabelStack(_Entity_):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	Outgoing Label Stack
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "label-stack"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath.LabelStack']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FibNextHopRoutes.FibNextHopRoute.NextHopPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FibNextHopRoutes.FibNextHopRoute']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.FibNextHopRoutes']['meta_info']


    class NextHopRoutes(_Entity_):
        """
        MPLS TE nexthop route database
        
        .. attribute:: next_hop_route
        
        	MPLS TE nexthop route
        	**type**\: list of  		 :py:class:`NextHopRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.NextHopRoutes, self).__init__()

            self.yang_name = "next-hop-routes"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("next-hop-route", ("next_hop_route", MplsTe.NextHopRoutes.NextHopRoute))])
            self._leafs = OrderedDict()

            self.next_hop_route = YList(self)
            self._segment_path = lambda: "next-hop-routes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.NextHopRoutes, [], name, value)


        class NextHopRoute(_Entity_):
            """
            MPLS TE nexthop route
            
            .. attribute:: prefix_address
            
            	Prefix Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: prefix_length
            
            	Prefix Length
            	**type**\: int
            
            	**range:** 0..32
            
            	**config**\: False
            
            .. attribute:: next_hop_type
            
            	Next\-hop Route Type
            	**type**\:  :py:class:`MplsTeNextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNextHop>`
            
            	**config**\: False
            
            .. attribute:: active_route
            
            	active route
            	**type**\:  :py:class:`ActiveRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute>`
            
            	**config**\: False
            
            .. attribute:: backup_route
            
            	backup route
            	**type**\:  :py:class:`BackupRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.BackupRoute>`
            
            	**config**\: False
            
            .. attribute:: prefix_address_xr
            
            	prefix address xr
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: prefix_length_xr
            
            	prefix length xr
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: exact_match
            
            	ExactMatch
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: create_time
            
            	CreateTime
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_used_time
            
            	LastUsedTime
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: expire_time
            
            	ExpireTime
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: installed_tunnel_path_num
            
            	InstalledTunnelPathNum
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tunnel_path
            
            	tunnel path
            	**type**\: list of  		 :py:class:`TunnelPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.TunnelPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.NextHopRoutes.NextHopRoute, self).__init__()

                self.yang_name = "next-hop-route"
                self.yang_parent_name = "next-hop-routes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("active-route", ("active_route", MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute)), ("backup-route", ("backup_route", MplsTe.NextHopRoutes.NextHopRoute.BackupRoute)), ("tunnel-path", ("tunnel_path", MplsTe.NextHopRoutes.NextHopRoute.TunnelPath))])
                self._leafs = OrderedDict([
                    ('prefix_address', (YLeaf(YType.str, 'prefix-address'), ['str'])),
                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                    ('next_hop_type', (YLeaf(YType.enumeration, 'next-hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeNextHop', '')])),
                    ('prefix_address_xr', (YLeaf(YType.str, 'prefix-address-xr'), ['str'])),
                    ('prefix_length_xr', (YLeaf(YType.uint32, 'prefix-length-xr'), ['int'])),
                    ('exact_match', (YLeaf(YType.boolean, 'exact-match'), ['bool'])),
                    ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                    ('last_used_time', (YLeaf(YType.uint32, 'last-used-time'), ['int'])),
                    ('expire_time', (YLeaf(YType.uint32, 'expire-time'), ['int'])),
                    ('installed_tunnel_path_num', (YLeaf(YType.uint32, 'installed-tunnel-path-num'), ['int'])),
                ])
                self.prefix_address = None
                self.prefix_length = None
                self.next_hop_type = None
                self.prefix_address_xr = None
                self.prefix_length_xr = None
                self.exact_match = None
                self.create_time = None
                self.last_used_time = None
                self.expire_time = None
                self.installed_tunnel_path_num = None

                self.active_route = MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute()
                self.active_route.parent = self
                self._children_name_map["active_route"] = "active-route"

                self.backup_route = MplsTe.NextHopRoutes.NextHopRoute.BackupRoute()
                self.backup_route.parent = self
                self._children_name_map["backup_route"] = "backup-route"

                self.tunnel_path = YList(self)
                self._segment_path = lambda: "next-hop-route"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute, ['prefix_address', 'prefix_length', 'next_hop_type', 'prefix_address_xr', 'prefix_length_xr', 'exact_match', 'create_time', 'last_used_time', 'expire_time', 'installed_tunnel_path_num'], name, value)


            class ActiveRoute(_Entity_):
                """
                active route
                
                .. attribute:: route_protocol_name
                
                	RouteProtocolName
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: route_distance
                
                	RouteDistance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: route_metric
                
                	RouteMetric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_update_time
                
                	LastUpdateTime
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_registered
                
                	IsRegistered
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_stale
                
                	IsStale
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_default
                
                	IsDefault
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_connected
                
                	IsConnected
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_populated
                
                	IsPopulated
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: route_type
                
                	RouteType
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: next_hop_path
                
                	next hop path
                	**type**\: list of  		 :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute, self).__init__()

                    self.yang_name = "active-route"
                    self.yang_parent_name = "next-hop-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("next-hop-path", ("next_hop_path", MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath))])
                    self._leafs = OrderedDict([
                        ('route_protocol_name', (YLeaf(YType.str, 'route-protocol-name'), ['str'])),
                        ('route_distance', (YLeaf(YType.uint32, 'route-distance'), ['int'])),
                        ('route_metric', (YLeaf(YType.uint32, 'route-metric'), ['int'])),
                        ('last_update_time', (YLeaf(YType.uint32, 'last-update-time'), ['int'])),
                        ('is_registered', (YLeaf(YType.boolean, 'is-registered'), ['bool'])),
                        ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                        ('is_populated', (YLeaf(YType.boolean, 'is-populated'), ['bool'])),
                        ('route_type', (YLeaf(YType.uint16, 'route-type'), ['int'])),
                    ])
                    self.route_protocol_name = None
                    self.route_distance = None
                    self.route_metric = None
                    self.last_update_time = None
                    self.is_registered = None
                    self.is_stale = None
                    self.is_default = None
                    self.is_connected = None
                    self.is_populated = None
                    self.route_type = None

                    self.next_hop_path = YList(self)
                    self._segment_path = lambda: "active-route"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute, ['route_protocol_name', 'route_distance', 'route_metric', 'last_update_time', 'is_registered', 'is_stale', 'is_default', 'is_connected', 'is_populated', 'route_type'], name, value)


                class NextHopPath(_Entity_):
                    """
                    next hop path
                    
                    .. attribute:: interface
                    
                    	Interface
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: abr_address
                    
                    	ABRAddress
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath, self).__init__()

                        self.yang_name = "next-hop-path"
                        self.yang_parent_name = "active-route"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                            ('abr_address', (YLeaf(YType.str, 'abr-address'), ['str'])),
                        ])
                        self.interface = None
                        self.address = None
                        self.abr_address = None
                        self._segment_path = lambda: "next-hop-path"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/active-route/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath, ['interface', 'address', 'abr_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute.NextHopPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute.ActiveRoute']['meta_info']


            class BackupRoute(_Entity_):
                """
                backup route
                
                .. attribute:: route_protocol_name
                
                	RouteProtocolName
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: route_distance
                
                	RouteDistance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: route_metric
                
                	RouteMetric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_update_time
                
                	LastUpdateTime
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_registered
                
                	IsRegistered
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_stale
                
                	IsStale
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_default
                
                	IsDefault
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_connected
                
                	IsConnected
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_populated
                
                	IsPopulated
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: route_type
                
                	RouteType
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: next_hop_path
                
                	next hop path
                	**type**\: list of  		 :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute, self).__init__()

                    self.yang_name = "backup-route"
                    self.yang_parent_name = "next-hop-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("next-hop-path", ("next_hop_path", MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath))])
                    self._leafs = OrderedDict([
                        ('route_protocol_name', (YLeaf(YType.str, 'route-protocol-name'), ['str'])),
                        ('route_distance', (YLeaf(YType.uint32, 'route-distance'), ['int'])),
                        ('route_metric', (YLeaf(YType.uint32, 'route-metric'), ['int'])),
                        ('last_update_time', (YLeaf(YType.uint32, 'last-update-time'), ['int'])),
                        ('is_registered', (YLeaf(YType.boolean, 'is-registered'), ['bool'])),
                        ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                        ('is_populated', (YLeaf(YType.boolean, 'is-populated'), ['bool'])),
                        ('route_type', (YLeaf(YType.uint16, 'route-type'), ['int'])),
                    ])
                    self.route_protocol_name = None
                    self.route_distance = None
                    self.route_metric = None
                    self.last_update_time = None
                    self.is_registered = None
                    self.is_stale = None
                    self.is_default = None
                    self.is_connected = None
                    self.is_populated = None
                    self.route_type = None

                    self.next_hop_path = YList(self)
                    self._segment_path = lambda: "backup-route"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute, ['route_protocol_name', 'route_distance', 'route_metric', 'last_update_time', 'is_registered', 'is_stale', 'is_default', 'is_connected', 'is_populated', 'route_type'], name, value)


                class NextHopPath(_Entity_):
                    """
                    next hop path
                    
                    .. attribute:: interface
                    
                    	Interface
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: abr_address
                    
                    	ABRAddress
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath, self).__init__()

                        self.yang_name = "next-hop-path"
                        self.yang_parent_name = "backup-route"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                            ('abr_address', (YLeaf(YType.str, 'abr-address'), ['str'])),
                        ])
                        self.interface = None
                        self.address = None
                        self.abr_address = None
                        self._segment_path = lambda: "next-hop-path"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/backup-route/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath, ['interface', 'address', 'abr_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute.BackupRoute.NextHopPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute.BackupRoute']['meta_info']


            class TunnelPath(_Entity_):
                """
                tunnel path
                
                .. attribute:: tunnel_id
                
                	TunnelID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: interface_handle
                
                	InterfaceHandle
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: install_time
                
                	InstallTime
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: installed_metric
                
                	InstalledMetric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.NextHopRoutes.NextHopRoute.TunnelPath, self).__init__()

                    self.yang_name = "tunnel-path"
                    self.yang_parent_name = "next-hop-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('interface_handle', (YLeaf(YType.str, 'interface-handle'), ['str'])),
                        ('install_time', (YLeaf(YType.uint32, 'install-time'), ['int'])),
                        ('installed_metric', (YLeaf(YType.uint32, 'installed-metric'), ['int'])),
                    ])
                    self.tunnel_id = None
                    self.interface_handle = None
                    self.install_time = None
                    self.installed_metric = None
                    self._segment_path = lambda: "tunnel-path"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/next-hop-routes/next-hop-route/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.NextHopRoutes.NextHopRoute.TunnelPath, ['tunnel_id', 'interface_handle', 'install_time', 'installed_metric'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute.TunnelPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.NextHopRoutes.NextHopRoute']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.NextHopRoutes']['meta_info']


    class TeMib(_Entity_):
        """
        TE MIB information
        
        .. attribute:: scalars
        
        	MIB Scalar information
        	**type**\:  :py:class:`Scalars <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TeMib.Scalars>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.TeMib, self).__init__()

            self.yang_name = "te-mib"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("scalars", ("scalars", MplsTe.TeMib.Scalars))])
            self._leafs = OrderedDict()

            self.scalars = MplsTe.TeMib.Scalars()
            self.scalars.parent = self
            self._children_name_map["scalars"] = "scalars"
            self._segment_path = lambda: "te-mib"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.TeMib, [], name, value)


        class Scalars(_Entity_):
            """
            MIB Scalar information
            
            .. attribute:: mpls_tunnel_configured
            
            	mpls tunnel configured
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: mpls_tunnel_active
            
            	mpls tunnel active
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: mpls_tunnel_te_dist_proto
            
            	mpls tunnel te dist proto
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: mpls_tunnel_max_hops
            
            	mpls tunnel max hops
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: mpls_tunnel_notification_max_rate
            
            	mpls tunnel notification max rate
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.TeMib.Scalars, self).__init__()

                self.yang_name = "scalars"
                self.yang_parent_name = "te-mib"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('mpls_tunnel_configured', (YLeaf(YType.uint32, 'mpls-tunnel-configured'), ['int'])),
                    ('mpls_tunnel_active', (YLeaf(YType.uint32, 'mpls-tunnel-active'), ['int'])),
                    ('mpls_tunnel_te_dist_proto', (YLeaf(YType.uint8, 'mpls-tunnel-te-dist-proto'), ['int'])),
                    ('mpls_tunnel_max_hops', (YLeaf(YType.uint32, 'mpls-tunnel-max-hops'), ['int'])),
                    ('mpls_tunnel_notification_max_rate', (YLeaf(YType.uint32, 'mpls-tunnel-notification-max-rate'), ['int'])),
                ])
                self.mpls_tunnel_configured = None
                self.mpls_tunnel_active = None
                self.mpls_tunnel_te_dist_proto = None
                self.mpls_tunnel_max_hops = None
                self.mpls_tunnel_notification_max_rate = None
                self._segment_path = lambda: "scalars"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/te-mib/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.TeMib.Scalars, ['mpls_tunnel_configured', 'mpls_tunnel_active', 'mpls_tunnel_te_dist_proto', 'mpls_tunnel_max_hops', 'mpls_tunnel_notification_max_rate'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.TeMib.Scalars']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.TeMib']['meta_info']


    class HardwareOutOfResources(_Entity_):
        """
        NPU Hardware OOR Information
        
        .. attribute:: summary
        
        	HW OOR Summary information
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.HardwareOutOfResources, self).__init__()

            self.yang_name = "hardware-out-of-resources"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsTe.HardwareOutOfResources.Summary))])
            self._leafs = OrderedDict()

            self.summary = MplsTe.HardwareOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._segment_path = lambda: "hardware-out-of-resources"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.HardwareOutOfResources, [], name, value)


        class Summary(_Entity_):
            """
            HW OOR Summary information
            
            .. attribute:: hardware_out_of_resources_state
            
            	Array of NPU HW OOR info per state
            	**type**\: list of  		 :py:class:`HardwareOutOfResourcesState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.HardwareOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "hardware-out-of-resources"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("hardware-out-of-resources-state", ("hardware_out_of_resources_state", MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState))])
                self._leafs = OrderedDict()

                self.hardware_out_of_resources_state = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.HardwareOutOfResources.Summary, [], name, value)


            class HardwareOutOfResourcesState(_Entity_):
                """
                Array of NPU HW OOR info per state
                
                .. attribute:: statistics
                
                	NPU HW OOR Statistics per state
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics>`
                
                	**config**\: False
                
                .. attribute:: hw_oor_state
                
                	The HW\-OOR state that this information belong to
                	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                
                	**config**\: False
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this  NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: percentage
                
                .. attribute:: node_protection_disable
                
                	Disable FRR node protection when the link is in this NPU HW OOR state
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green OOR state is entered
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: minute
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the NPU HW OOR state
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__init__()

                    self.yang_name = "hardware-out-of-resources-state"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics))])
                    self._leafs = OrderedDict([
                        ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                        ('te_metric_penalty', (YLeaf(YType.uint32, 'te-metric-penalty'), ['int'])),
                        ('available_bw_percentage', (YLeaf(YType.uint32, 'available-bw-percentage'), ['int'])),
                        ('node_protection_disable', (YLeaf(YType.boolean, 'node-protection-disable'), ['bool'])),
                        ('transition_duration', (YLeaf(YType.uint32, 'transition-duration'), ['int'])),
                        ('minimum_lsp_bandwidth', (YLeaf(YType.uint32, 'minimum-lsp-bandwidth'), ['int'])),
                        ('accept_reopt', (YLeaf(YType.boolean, 'accept-reopt'), ['bool'])),
                    ])
                    self.hw_oor_state = None
                    self.te_metric_penalty = None
                    self.available_bw_percentage = None
                    self.node_protection_disable = None
                    self.transition_duration = None
                    self.minimum_lsp_bandwidth = None
                    self.accept_reopt = None

                    self.statistics = MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._segment_path = lambda: "hardware-out-of-resources-state"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, ['hw_oor_state', 'te_metric_penalty', 'available_bw_percentage', 'node_protection_disable', 'transition_duration', 'minimum_lsp_bandwidth', 'accept_reopt'], name, value)


                class Statistics(_Entity_):
                    """
                    NPU HW OOR Statistics per state
                    
                    .. attribute:: hw_oor_state
                    
                    	The HW\-OOR state that these statistics belong to
                    	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    	**config**\: False
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_protection_disable_number
                    
                    	Number of times this OOR state disabled node protection assignment
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "hardware-out-of-resources-state"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                            ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                            ('node_protection_disable_number', (YLeaf(YType.uint32, 'node-protection-disable-number'), ['int'])),
                            ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                            ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                            ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                            ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                        ])
                        self.hw_oor_state = None
                        self.transitions = None
                        self.node_protection_disable_number = None
                        self.rejected_ls_ps_number = None
                        self.accepted_ls_ps_number = None
                        self.accepted_reopt_ls_ps_number = None
                        self.rejected_reopt_ls_ps_number = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/hardware-out-of-resources/summary/hardware-out-of-resources-state/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, ['hw_oor_state', 'transitions', 'node_protection_disable_number', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.HardwareOutOfResources.Summary.HardwareOutOfResourcesState']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.HardwareOutOfResources.Summary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.HardwareOutOfResources']['meta_info']


    class P2pP2mpTunnel(_Entity_):
        """
        P2P or P2MP tunnels
        
        .. attribute:: tunnel_remote_briefs
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:  :py:class:`TunnelRemoteBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs>`
        
        	**config**\: False
        
        .. attribute:: tunnel_remotes
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:  :py:class:`TunnelRemotes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes>`
        
        	**config**\: False
        
        .. attribute:: nni_tunnels
        
        	GMPLS NNI tunnels
        	**type**\:  :py:class:`NniTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels>`
        
        	**config**\: False
        
        .. attribute:: tunnel_heads
        
        	Restrict display to P2P or P2MP head tunnels
        	**type**\:  :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.P2pP2mpTunnel, self).__init__()

            self.yang_name = "p2p-p2mp-tunnel"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-remote-briefs", ("tunnel_remote_briefs", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs)), ("tunnel-remotes", ("tunnel_remotes", MplsTe.P2pP2mpTunnel.TunnelRemotes)), ("nni-tunnels", ("nni_tunnels", MplsTe.P2pP2mpTunnel.NniTunnels)), ("tunnel-heads", ("tunnel_heads", MplsTe.P2pP2mpTunnel.TunnelHeads))])
            self._leafs = OrderedDict()

            self.tunnel_remote_briefs = MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs()
            self.tunnel_remote_briefs.parent = self
            self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"

            self.tunnel_remotes = MplsTe.P2pP2mpTunnel.TunnelRemotes()
            self.tunnel_remotes.parent = self
            self._children_name_map["tunnel_remotes"] = "tunnel-remotes"

            self.nni_tunnels = MplsTe.P2pP2mpTunnel.NniTunnels()
            self.nni_tunnels.parent = self
            self._children_name_map["nni_tunnels"] = "nni-tunnels"

            self.tunnel_heads = MplsTe.P2pP2mpTunnel.TunnelHeads()
            self.tunnel_heads.parent = self
            self._children_name_map["tunnel_heads"] = "tunnel-heads"
            self._segment_path = lambda: "p2p-p2mp-tunnel"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.P2pP2mpTunnel, [], name, value)


        class TunnelRemoteBriefs(_Entity_):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote_brief
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of  		 :py:class:`TunnelRemoteBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs, self).__init__()

                self.yang_name = "tunnel-remote-briefs"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-remote-brief", ("tunnel_remote_brief", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief))])
                self._leafs = OrderedDict()

                self.tunnel_remote_brief = YList(self)
                self._segment_path = lambda: "tunnel-remote-briefs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs, [], name, value)


            class TunnelRemoteBrief(_Entity_):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the LSP was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__init__()

                    self.yang_name = "tunnel-remote-brief"
                    self.yang_parent_name = "tunnel-remote-briefs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['lsp_id','tunnel_id','extended_tunnel_id','source_address','ctype','destination_address','p2mp_id']
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l))])
                    self._leafs = OrderedDict([
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                    ])
                    self.lsp_id = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.ctype = None
                    self.destination_address = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.uptime = None

                    self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"

                    self.s2l = YList(self)
                    self._segment_path = lambda: "tunnel-remote-brief" + "[lsp-id='" + str(self.lsp_id) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-remote-briefs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, ['lsp_id', 'tunnel_id', 'extended_tunnel_id', 'source_address', 'ctype', 'destination_address', 'p2mp_id', 'signaled_name', 'uptime'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote-brief"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec']['meta_info']


                class S2l(_Entity_):
                    """
                    array of S2L structures
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the S2L was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: oper_state
                    
                    	Oper state of S2L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote-brief"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec))])
                        self._leafs = OrderedDict([
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                            ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                            ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('oper_state', (YLeaf(YType.boolean, 'oper-state'), ['bool'])),
                        ])
                        self.uptime = None
                        self.egress_interface = None
                        self.ingress_interface = None
                        self.role = None
                        self.oper_state = None

                        self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l, ['uptime', 'egress_interface', 'ingress_interface', 'role', 'oper_state'], name, value)


                    class S2lFec(_Entity_):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                            ])
                            self.s2l_fec_subgroup_id = None
                            self.s2l_fec_lsp_id = None
                            self.s2l_fec_tunnel_id = None
                            self.s2l_fec_extended_tunnel_id = None
                            self.s2l_fec_source = None
                            self.s2l_fec_dest = None
                            self.s2l_fec_p2mp_id = None
                            self.s2l_fec_subgroup_originator = None
                            self.s2l_fec_ctype = None
                            self.s2l_fec_vrf = None
                            self._segment_path = lambda: "s2l-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemoteBriefs']['meta_info']


        class TunnelRemotes(_Entity_):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of  		 :py:class:`TunnelRemote <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes, self).__init__()

                self.yang_name = "tunnel-remotes"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-remote", ("tunnel_remote", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote))])
                self._leafs = OrderedDict()

                self.tunnel_remote = YList(self)
                self._segment_path = lambda: "tunnel-remotes"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes, [], name, value)


            class TunnelRemote(_Entity_):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_frr_failed
                
                	P2MP LSP has FRR Failed
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: frr_active_reason
                
                	P2MP LSP FRR active reason
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth
                
                	P2MP LSP Bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_setup_priority
                
                	LSP setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lsp_hold_priority
                
                	LSP hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth_type
                
                	The LSP bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: dste_class_match
                
                	Do the class type and priority match a DSTE class
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: dste_class_index
                
                	Matching DSTE class index
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: type
                
                	The type of this LSP
                	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: s2_ls_up
                
                	Number of connected S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls_proceeding
                
                	Number of proceeding S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls_down
                
                	Number of down S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reoptimize_reason
                
                	Reason for re\-optimization
                	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                
                	**config**\: False
                
                .. attribute:: reoptimize_trigger
                
                	Re\-optimize trigger
                	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                
                	**config**\: False
                
                .. attribute:: timer_left
                
                	Time in seconds left to take next action if any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: protection_role
                
                	Path Protection Role
                	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                
                	**config**\: False
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote, self).__init__()

                    self.yang_name = "tunnel-remote"
                    self.yang_parent_name = "tunnel-remotes"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['lsp_id','tunnel_id','extended_tunnel_id','source_address','ctype','destination_address','p2mp_id']
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l))])
                    self._leafs = OrderedDict([
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                        ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                        ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                        ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                        ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                        ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                        ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                        ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                        ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                        ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                        ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                        ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                    ])
                    self.lsp_id = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.ctype = None
                    self.destination_address = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.is_frr_failed = None
                    self.frr_active_reason = None
                    self.lsp_bandwidth = None
                    self.lsp_setup_priority = None
                    self.lsp_hold_priority = None
                    self.lsp_bandwidth_type = None
                    self.dste_class_match = None
                    self.dste_class_index = None
                    self.type = None
                    self.uptime = None
                    self.s2_ls_up = None
                    self.s2_ls_proceeding = None
                    self.s2_ls_down = None
                    self.reoptimize_reason = None
                    self.reoptimize_trigger = None
                    self.timer_left = None
                    self.is_passive = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.protection_role = None

                    self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"

                    self.s2l = YList(self)
                    self._segment_path = lambda: "tunnel-remote" + "[lsp-id='" + str(self.lsp_id) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-remotes/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote, ['lsp_id', 'tunnel_id', 'extended_tunnel_id', 'source_address', 'ctype', 'destination_address', 'p2mp_id', 'signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec']['meta_info']


                class S2l(_Entity_):
                    """
                    array of S2L structures
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option
                    
                    	The path option used to find the path for this S2L
                    	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption>`
                    
                    	**config**\: False
                    
                    .. attribute:: out_xro
                    
                    	Outgoing XRO for this S2L
                    	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro>`
                    
                    	**config**\: False
                    
                    .. attribute:: in_xro
                    
                    	Incoming XRO for this S2L
                    	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro>`
                    
                    	**config**\: False
                    
                    .. attribute:: tspec
                    
                    	The T spec info
                    	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: generic_tspec
                    
                    	Generic TSpec
                    	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: fspec
                    
                    	The F spec info
                    	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: generic_fspec
                    
                    	Generic FSpec
                    	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address_generic
                    
                    	Next hop address
                    	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_hop_address_generic
                    
                    	Previous hop address
                    	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_address_generic
                    
                    	Incoming interface address
                    	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_convergence
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption
                    
                    	The soft preemption info for this LSP
                    	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_labels
                    
                    	GMPLS labels
                    	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels>`
                    
                    	**config**\: False
                    
                    .. attribute:: otn_s2l
                    
                    	Otn S2L Information
                    	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l>`
                    
                    	**config**\: False
                    
                    .. attribute:: head_end_bfd_info
                    
                    	The Head\-end BFD info
                    	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: tail_end_bfd_info
                    
                    	The Tail\-end BFD info
                    	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_collection
                    
                    	SRLG\-collection data
                    	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_fec
                    
                    	Reverse Associated Bidir LSP FEC
                    	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_tspec
                    
                    	The Reverse T spec info
                    	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: flex_info
                    
                    	FlexLSP S2L Information
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_wrap_info
                    
                    	Lsp Wrap  Related information
                    	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	S2L Diversity Information
                    	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: accumulated_path_metrics
                    
                    	Accumulated Path Metrics
                    	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics>`
                    
                    	**config**\: False
                    
                    .. attribute:: accumulated_reverse_path_metrics
                    
                    	Accumulated Reverse Path Metrics
                    	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_area
                    
                    	IGP\-area in which the S2L path was calculated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_expanded_ero
                    
                    	TRUE if this LSR expanded a loose path
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_reeval_query_mid
                    
                    	Loose path reevaluation query received at mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_query_received_mid
                    
                    	Time since last reevaluation query received at mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_preferred_path_exists_send_mid
                    
                    	Time since last preferred path exists msg send from mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_preferred_tree_exists_send_mid
                    
                    	Time since last preferred tree exists msg send from mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_area_id
                    
                    	Indicates the protocol and area used to find Outgoing ERO
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_affinity_bits
                    
                    	The Outgoing ERO's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_affinity_mask
                    
                    	The Outgoing ERO's affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_metric_type
                    
                    	The Outgoing ERO's selection metric
                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_metric
                    
                    	The metric value of the expanded path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: abr_auto_discovered
                    
                    	Next ABR auto discovered
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_enabled
                    
                    	FRR Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_node_protected
                    
                    	Node Protection Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_protect
                    
                    	BW Protection Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_rro_enabled
                    
                    	Path RRO Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: weight
                    
                    	The path's weight
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_weight
                    
                    	The reverse path weight
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: egress_interface_state
                    
                    	State of Outgoing Interface
                    	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_interface_brief
                    
                    	Egress Interface in brief format
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface_state
                    
                    	State of Incoming Interface
                    	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface_brief
                    
                    	Ingress Interface in brief format
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_local_label
                    
                    	Local label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_out_label
                    
                    	Outgoing label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_frr_state
                    
                    	Indicates outbound FRR state
                    	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                    
                    	**config**\: False
                    
                    .. attribute:: frr_out_tunnel_interface
                    
                    	FRR out tunnel intface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: signalling_status
                    
                    	Signaling status
                    	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_router_id
                    
                    	Local router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: upstream_router_id
                    
                    	Upstream router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: downstream_router_id
                    
                    	Downstream router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	Next hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_address
                    
                    	Next next hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: previous_hop_address
                    
                    	Previous hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_address
                    
                    	Incoming interface address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: backup_tunnel_interface
                    
                    	Interface handle of the backup tunnel
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    	**config**\: False
                    
                    .. attribute:: node_hop_count
                    
                    	Hop count
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_optical
                    
                    	Is Optical
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_ero_obj_present
                    
                    	 S2l Reverse ERO Object Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_present
                    
                    	Reverse Associated Bidir LSP Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_connected
                    
                    	Reverse Associated Bidir LSP Connected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_name
                    
                    	Reverse Associated Bidir LSP Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_tspec_obj_present
                    
                    	 S2L Reverse TSpec Object Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_using_strict_spf
                    
                    	Path is using Strict SPF
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_lsp_sub_obj
                    
                    	Reverse LSP Sub Objects
                    	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj>`
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The S2L's excluded srlg groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: out_ero
                    
                    	Outgoing ERO for this S2L
                    	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: in_ero
                    
                    	Incoming ERO for this S2L
                    	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_rro
                    
                    	Path RRO for this S2L
                    	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro>`
                    
                    	**config**\: False
                    
                    .. attribute:: resv_rro
                    
                    	Resv RRO for this S2L
                    	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_affinity_array
                    
                    	Tunnel's Path hops with affinity
                    	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_in
                    
                    	 Reverse Incoming ERO for this S2L
                    	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_segment_routing_path
                    
                    	Segment\-Routing S2L path info
                    	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath))])
                        self._leafs = OrderedDict([
                            ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                            ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                            ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                            ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                            ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                            ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                            ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                            ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                            ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                            ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                            ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                            ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                            ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                            ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                            ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                            ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                            ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                            ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                            ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                            ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                            ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                            ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                            ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                            ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                            ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                            ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                            ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                            ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                            ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                            ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                            ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                            ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                            ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                            ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                            ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                            ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                            ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                            ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                            ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                            ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                            ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                        ])
                        self.pcalc_area = None
                        self.is_expanded_ero = None
                        self.path_reeval_query_mid = None
                        self.time_since_last_query_received_mid = None
                        self.time_since_last_preferred_path_exists_send_mid = None
                        self.time_since_last_preferred_tree_exists_send_mid = None
                        self.expanded_ero_area_id = None
                        self.expanded_ero_affinity_bits = None
                        self.expanded_ero_affinity_mask = None
                        self.expanded_ero_metric_type = None
                        self.expanded_ero_metric = None
                        self.abr_auto_discovered = None
                        self.is_frr_enabled = None
                        self.is_node_protected = None
                        self.is_bandwidth_protect = None
                        self.path_rro_enabled = None
                        self.weight = None
                        self.reverse_weight = None
                        self.uptime = None
                        self.egress_interface = None
                        self.egress_interface_state = None
                        self.egress_interface_brief = None
                        self.ingress_interface = None
                        self.ingress_interface_state = None
                        self.ingress_interface_brief = None
                        self.s2l_local_label = None
                        self.s2l_out_label = None
                        self.outbound_frr_state = None
                        self.frr_out_tunnel_interface = None
                        self.role = None
                        self.signalling_status = None
                        self.local_router_id = None
                        self.upstream_router_id = None
                        self.downstream_router_id = None
                        self.next_hop_address = None
                        self.next_next_hop_address = None
                        self.previous_hop_address = None
                        self.incoming_address = None
                        self.backup_tunnel_interface = None
                        self.node_hop_count = None
                        self.is_optical = None
                        self.s2l_reverse_ero_obj_present = None
                        self.reverse_lsp_present = None
                        self.reverse_lsp_connected = None
                        self.reverse_lsp_name = None
                        self.s2l_reverse_tspec_obj_present = None
                        self.path_using_strict_spf = None

                        self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"

                        self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption()
                        self.active_path_option.parent = self
                        self._children_name_map["active_path_option"] = "active-path-option"

                        self.out_xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro()
                        self.out_xro.parent = self
                        self._children_name_map["out_xro"] = "out-xro"

                        self.in_xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro()
                        self.in_xro.parent = self
                        self._children_name_map["in_xro"] = "in-xro"

                        self.tspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec()
                        self.tspec.parent = self
                        self._children_name_map["tspec"] = "tspec"

                        self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec()
                        self.generic_tspec.parent = self
                        self._children_name_map["generic_tspec"] = "generic-tspec"

                        self.fspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec()
                        self.fspec.parent = self
                        self._children_name_map["fspec"] = "fspec"

                        self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec()
                        self.generic_fspec.parent = self
                        self._children_name_map["generic_fspec"] = "generic-fspec"

                        self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric()
                        self.next_hop_address_generic.parent = self
                        self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                        self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric()
                        self.previous_hop_address_generic.parent = self
                        self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                        self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric()
                        self.incoming_address_generic.parent = self
                        self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                        self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence()
                        self.s2l_convergence.parent = self
                        self._children_name_map["s2l_convergence"] = "s2l-convergence"

                        self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption()
                        self.soft_preemption.parent = self
                        self._children_name_map["soft_preemption"] = "soft-preemption"

                        self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels()
                        self.gmpls_labels.parent = self
                        self._children_name_map["gmpls_labels"] = "gmpls-labels"

                        self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l()
                        self.otn_s2l.parent = self
                        self._children_name_map["otn_s2l"] = "otn-s2l"

                        self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo()
                        self.head_end_bfd_info.parent = self
                        self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                        self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo()
                        self.tail_end_bfd_info.parent = self
                        self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                        self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection()
                        self.srlg_collection.parent = self
                        self._children_name_map["srlg_collection"] = "srlg-collection"

                        self.association = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec()
                        self.reverse_lsp_fec.parent = self
                        self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                        self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec()
                        self.reverse_tspec.parent = self
                        self._children_name_map["reverse_tspec"] = "reverse-tspec"

                        self.flex_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo()
                        self.lsp_wrap_info.parent = self
                        self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                        self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo()
                        self.diversity_info.parent = self
                        self._children_name_map["diversity_info"] = "diversity-info"

                        self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics()
                        self.accumulated_path_metrics.parent = self
                        self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                        self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics()
                        self.accumulated_reverse_path_metrics.parent = self
                        self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                        self.s2l_reverse_lsp_sub_obj = YList(self)
                        self.shared_risk_link_group = YList(self)
                        self.out_ero = YList(self)
                        self.in_ero = YList(self)
                        self.path_rro = YList(self)
                        self.resv_rro = YList(self)
                        self.path_affinity_array = YList(self)
                        self.reverse_ero_in = YList(self)
                        self.s2l_segment_routing_path = YList(self)
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                    class S2lFec(_Entity_):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                            ])
                            self.s2l_fec_subgroup_id = None
                            self.s2l_fec_lsp_id = None
                            self.s2l_fec_tunnel_id = None
                            self.s2l_fec_extended_tunnel_id = None
                            self.s2l_fec_source = None
                            self.s2l_fec_dest = None
                            self.s2l_fec_p2mp_id = None
                            self.s2l_fec_subgroup_originator = None
                            self.s2l_fec_ctype = None
                            self.s2l_fec_vrf = None
                            self._segment_path = lambda: "s2l-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec']['meta_info']


                    class ActivePathOption(_Entity_):
                        """
                        The path option used to find the path for this
                        S2L
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption, self).__init__()

                            self.yang_name = "active-path-option"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "active-path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption']['meta_info']


                    class OutXro(_Entity_):
                        """
                        Outgoing XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro, self).__init__()

                            self.yang_name = "out-xro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "out-xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "out-xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro']['meta_info']


                    class InXro(_Entity_):
                        """
                        Incoming XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro, self).__init__()

                            self.yang_name = "in-xro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "in-xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "in-xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro']['meta_info']


                    class Tspec(_Entity_):
                        """
                        The T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec, self).__init__()

                            self.yang_name = "tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec']['meta_info']


                    class GenericTspec(_Entity_):
                        """
                        Generic TSpec
                        
                        .. attribute:: otntspec
                        
                        	TE TSpec for G709 OTN
                        	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec_type
                        
                        	TSpecType
                        	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec, self).__init__()

                            self.yang_name = "generic-tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec))])
                            self._leafs = OrderedDict([
                                ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                            ])
                            self.tspec_type = None

                            self.otntspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec()
                            self.otntspec.parent = self
                            self._children_name_map["otntspec"] = "otntspec"
                            self._segment_path = lambda: "generic-tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec, ['tspec_type'], name, value)


                        class Otntspec(_Entity_):
                            """
                            TE TSpec for G709 OTN
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec, self).__init__()

                                self.yang_name = "otntspec"
                                self.yang_parent_name = "generic-tspec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                    ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                    ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                    ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                    ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                ])
                                self.signal_type = None
                                self.nmc_or_tolerance = None
                                self.nvc = None
                                self.multiplier = None
                                self.bit_rate = None
                                self._segment_path = lambda: "otntspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec']['meta_info']


                    class Fspec(_Entity_):
                        """
                        The F spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec, self).__init__()

                            self.yang_name = "fspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "fspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec']['meta_info']


                    class GenericFspec(_Entity_):
                        """
                        Generic FSpec
                        
                        .. attribute:: otnfspec
                        
                        	TE FSpec for G709 OTN
                        	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec_type
                        
                        	FSpecType
                        	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec, self).__init__()

                            self.yang_name = "generic-fspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec))])
                            self._leafs = OrderedDict([
                                ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                            ])
                            self.fspec_type = None

                            self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec()
                            self.otnfspec.parent = self
                            self._children_name_map["otnfspec"] = "otnfspec"
                            self._segment_path = lambda: "generic-fspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec, ['fspec_type'], name, value)


                        class Otnfspec(_Entity_):
                            """
                            TE FSpec for G709 OTN
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec, self).__init__()

                                self.yang_name = "otnfspec"
                                self.yang_parent_name = "generic-fspec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                    ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                    ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                    ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                    ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                ])
                                self.signal_type = None
                                self.nmc_or_tolerance = None
                                self.nvc = None
                                self.multiplier = None
                                self.bit_rate = None
                                self._segment_path = lambda: "otnfspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec']['meta_info']


                    class NextHopAddressGeneric(_Entity_):
                        """
                        Next hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric, self).__init__()

                            self.yang_name = "next-hop-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "next-hop-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "next-hop-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric']['meta_info']


                    class PreviousHopAddressGeneric(_Entity_):
                        """
                        Previous hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric, self).__init__()

                            self.yang_name = "previous-hop-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "previous-hop-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "previous-hop-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric']['meta_info']


                    class IncomingAddressGeneric(_Entity_):
                        """
                        Incoming interface address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric, self).__init__()

                            self.yang_name = "incoming-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "incoming-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "incoming-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric']['meta_info']


                    class S2lConvergence(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence, self).__init__()

                            self.yang_name = "s2l-convergence"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "s2l-convergence"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence']['meta_info']


                    class SoftPreemption(_Entity_):
                        """
                        The soft preemption info for this LSP.
                        
                        .. attribute:: status
                        
                        	The current state of the soft preemption operation
                        	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption_timestamp
                        
                        	The POSIX timestamp when the soft preemption occurred
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption_link
                        
                        	Name of the link where the soft preemption occurred
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: time_to_hard_preemption
                        
                        	The number of seconds until hard preemption is triggered
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: fr_rrewrite
                        
                        	FRR\-rewrite during soft preemption
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fr_rrewrite_tunnel_name
                        
                        	The tunnel name of the backup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption, self).__init__()

                            self.yang_name = "soft-preemption"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                            ])
                            self.status = None
                            self.soft_preemption_timestamp = None
                            self.soft_preemption_link = None
                            self.preempting_link_address = None
                            self.time_to_hard_preemption = None
                            self.fr_rrewrite = None
                            self.fr_rrewrite_tunnel_name = None
                            self._segment_path = lambda: "soft-preemption"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption']['meta_info']


                    class GmplsLabels(_Entity_):
                        """
                        GMPLS labels
                        
                        .. attribute:: path_ingress_label
                        
                        	Path message (upstream) ingress label
                        	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_egress_label
                        
                        	Path message (upstream) egress label
                        	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_ingress_label
                        
                        	Resv message (downstream) ingress label
                        	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_egress_label
                        
                        	Resv message (downstream) egress label
                        	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels, self).__init__()

                            self.yang_name = "gmpls-labels"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel))])
                            self._leafs = OrderedDict()

                            self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel()
                            self.path_ingress_label.parent = self
                            self._children_name_map["path_ingress_label"] = "path-ingress-label"

                            self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel()
                            self.path_egress_label.parent = self
                            self._children_name_map["path_egress_label"] = "path-egress-label"

                            self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel()
                            self.resv_ingress_label.parent = self
                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                            self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel()
                            self.resv_egress_label.parent = self
                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                            self._segment_path = lambda: "gmpls-labels"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels, [], name, value)


                        class PathIngressLabel(_Entity_):
                            """
                            Path message (upstream) ingress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                self.yang_name = "path-ingress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "path-ingress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                        class PathEgressLabel(_Entity_):
                            """
                            Path message (upstream) egress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                self.yang_name = "path-egress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "path-egress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                        class ResvIngressLabel(_Entity_):
                            """
                            Resv message (downstream) ingress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                self.yang_name = "resv-ingress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "resv-ingress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                        class ResvEgressLabel(_Entity_):
                            """
                            Resv message (downstream) egress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                self.yang_name = "resv-egress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "resv-egress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels']['meta_info']


                    class OtnS2l(_Entity_):
                        """
                        Otn S2L Information
                        
                        .. attribute:: otn
                        
                        	Info Related to OTN technology in S2L
                        	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn>`
                        
                        	**config**\: False
                        
                        .. attribute:: aps
                        
                        	APS Info for OTN S2L
                        	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l, self).__init__()

                            self.yang_name = "otn-s2l"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps))])
                            self._leafs = OrderedDict()

                            self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn()
                            self.otn.parent = self
                            self._children_name_map["otn"] = "otn"

                            self.aps = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps()
                            self.aps.parent = self
                            self._children_name_map["aps"] = "aps"
                            self._segment_path = lambda: "otn-s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l, [], name, value)


                        class Otn(_Entity_):
                            """
                            Info Related to OTN technology in S2L
                            
                            .. attribute:: bandwidth
                            
                            	OTN Bandwidth for s2l
                            	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: labels
                            
                            	Labels
                            	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels>`
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller
                            
                            	Incoming Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller_state
                            
                            	State of Incoming Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller
                            
                            	Incoming Sub Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller_state
                            
                            	State of Incoming Sub Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller
                            
                            	Outgoing Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller_state
                            
                            	State of Outgoing Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller
                            
                            	Outgoing Sub Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller_state
                            
                            	State of Outgoing Sub Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: cross_connect_id
                            
                            	Cross connect id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_connected
                            
                            	True if subcontrollers are connected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: uptime
                            
                            	XC Uptime
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller_ifhandle
                            
                            	Outgoing Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller_ifhandle
                            
                            	Outgoing Sub Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller_ifhandle
                            
                            	Incoming Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller_ifhandle
                            
                            	Incoming Sub Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: gpid
                            
                            	Gpid Payload
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn, self).__init__()

                                self.yang_name = "otn"
                                self.yang_parent_name = "otn-s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels))])
                                self._leafs = OrderedDict([
                                    ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                    ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                    ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                    ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                    ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                    ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                    ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                    ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                    ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                    ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                    ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                    ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                ])
                                self.incoming_controller = None
                                self.incoming_controller_state = None
                                self.incoming_sub_controller = None
                                self.incoming_sub_controller_state = None
                                self.outgoing_controller = None
                                self.outgoing_controller_state = None
                                self.outgoing_sub_controller = None
                                self.outgoing_sub_controller_state = None
                                self.cross_connect_id = None
                                self.is_connected = None
                                self.uptime = None
                                self.outgoing_controller_ifhandle = None
                                self.outgoing_sub_controller_ifhandle = None
                                self.incoming_controller_ifhandle = None
                                self.incoming_sub_controller_ifhandle = None
                                self.gpid = None

                                self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth()
                                self.bandwidth.parent = self
                                self._children_name_map["bandwidth"] = "bandwidth"

                                self.labels = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels()
                                self.labels.parent = self
                                self._children_name_map["labels"] = "labels"
                                self._segment_path = lambda: "otn"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                            class Bandwidth(_Entity_):
                                """
                                OTN Bandwidth for s2l
                                
                                .. attribute:: odu_flex_cbr
                                
                                	Odu flex CBR info
                                	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_flex_gfp_f_res
                                
                                	Odu flex GFP\-F resizable info
                                	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_flex_gfp_f_non_res
                                
                                	Odu flex GFP\-F non\-resizable info
                                	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_level
                                
                                	ODULevel
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                    self.yang_name = "bandwidth"
                                    self.yang_parent_name = "otn"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                    self._leafs = OrderedDict([
                                        ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                    ])
                                    self.odu_level = None

                                    self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                    self.odu_flex_cbr.parent = self
                                    self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                    self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                    self.odu_flex_gfp_f_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                    self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                    self.odu_flex_gfp_f_non_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    self._segment_path = lambda: "bandwidth"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                class OduFlexCbr(_Entity_):
                                    """
                                    Odu flex CBR info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tolerance
                                    
                                    	Tolerance
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                        self.yang_name = "odu-flex-cbr"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self.tolerance = None
                                        self._segment_path = lambda: "odu-flex-cbr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                class OduFlexGfpFRes(_Entity_):
                                    """
                                    Odu flex GFP\-F resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-res"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self._segment_path = lambda: "odu-flex-gfp-f-res"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                class OduFlexGfpFNonRes(_Entity_):
                                    """
                                    Odu flex GFP\-F non\-resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-non-res"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                            class Labels(_Entity_):
                                """
                                Labels
                                
                                .. attribute:: path_ingress_label
                                
                                	Path message (upstream) ingress label
                                	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_egress_label
                                
                                	Path message (upstream) egress label
                                	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: resv_ingress_label
                                
                                	Resv message (downstream) ingress label
                                	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: resv_egress_label
                                
                                	Resv message (downstream) egress label
                                	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels, self).__init__()

                                    self.yang_name = "labels"
                                    self.yang_parent_name = "otn"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                    self._leafs = OrderedDict()

                                    self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                    self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"

                                    self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                    self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    self._segment_path = lambda: "labels"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels, [], name, value)


                                class PathIngressLabel(_Entity_):
                                    """
                                    Path message (upstream) ingress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                        self.yang_name = "path-ingress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "path-ingress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                class PathEgressLabel(_Entity_):
                                    """
                                    Path message (upstream) egress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                        self.yang_name = "path-egress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "path-egress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                class ResvIngressLabel(_Entity_):
                                    """
                                    Resv message (downstream) ingress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                        self.yang_name = "resv-ingress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "resv-ingress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                class ResvEgressLabel(_Entity_):
                                    """
                                    Resv message (downstream) egress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                        self.yang_name = "resv-egress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "resv-egress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn']['meta_info']


                        class Aps(_Entity_):
                            """
                            APS Info for OTN S2L
                            
                            .. attribute:: protection_info
                            
                            	Protection Info
                            	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps, self).__init__()

                                self.yang_name = "aps"
                                self.yang_parent_name = "otn-s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo))])
                                self._leafs = OrderedDict()

                                self.protection_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo()
                                self.protection_info.parent = self
                                self._children_name_map["protection_info"] = "protection-info"
                                self._segment_path = lambda: "aps"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps, [], name, value)


                            class ProtectionInfo(_Entity_):
                                """
                                Protection Info
                                
                                .. attribute:: sbit
                                
                                	Secondary bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: pbit
                                
                                	Protecting bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: nbit
                                
                                	Notification bit 
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: obit
                                
                                	Operational bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: protect_type
                                
                                	LSP Protect Type
                                	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_wtr_present
                                
                                	Is Wait\-to\-Restore timeout present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: wtr_timeout
                                
                                	Wait\-to\-Restore timeout
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_hopresent
                                
                                	Is Hold\-Off timeout present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ho_timeout
                                
                                	Hold\-Off timeout
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_snc_mode_present
                                
                                	Is SNC mode present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: snc_mode
                                
                                	SNC mode
                                	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: tcm_id
                                
                                	TCM ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: path_prot_profile_type
                                
                                	Path protection profile type
                                	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                    self.yang_name = "protection-info"
                                    self.yang_parent_name = "aps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                        ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                        ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                        ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                        ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                        ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                        ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                        ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                        ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                        ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                        ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                        ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                        ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ])
                                    self.sbit = None
                                    self.pbit = None
                                    self.nbit = None
                                    self.obit = None
                                    self.protect_type = None
                                    self.is_wtr_present = None
                                    self.wtr_timeout = None
                                    self.is_hopresent = None
                                    self.ho_timeout = None
                                    self.is_snc_mode_present = None
                                    self.snc_mode = None
                                    self.tcm_id = None
                                    self.path_prot_profile_type = None
                                    self._segment_path = lambda: "protection-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l']['meta_info']


                    class HeadEndBfdInfo(_Entity_):
                        """
                        The Head\-end BFD info
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: deletion_history
                        
                        	BFD Session Deletion History
                        	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory>`
                        
                        	**config**\: False
                        
                        .. attribute:: creation_time
                        
                        	Time in seconds since the BFD session created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: lspbfd_type
                        
                        	LSP BFD type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_redundant
                        
                        	sBFD session is redundant
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_reverse_path_stale
                        
                        	The BFD reverse path is stale compared to configuration
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_reverse_path_label
                        
                        	BFD reverse path labels
                        	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo, self).__init__()

                            self.yang_name = "head-end-bfd-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                            self._leafs = OrderedDict([
                                ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                            ])
                            self.creation_time = None
                            self.lspbfd_type = None
                            self.is_redundant = None
                            self.bfd_reverse_path_stale = None

                            self.session_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"

                            self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory()
                            self.deletion_history.parent = self
                            self._children_name_map["deletion_history"] = "deletion-history"

                            self.bfd_reverse_path_label = YList(self)
                            self._segment_path = lambda: "head-end-bfd-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                        class SessionInfo(_Entity_):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                    ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                ])
                                self.state = None
                                self.state_change_time = None
                                self._segment_path = lambda: "session-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                        class DeletionHistory(_Entity_):
                            """
                            BFD Session Deletion History
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID of the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_time
                            
                            	Time stamp of the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_reason
                            
                            	Reason for the BFD session get deleted
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_diagnostic_code
                            
                            	Diagnostic Code for the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                self.yang_name = "deletion-history"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                    ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                    ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                    ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                ])
                                self.lsp_id = None
                                self.deletion_time = None
                                self.deletion_reason = None
                                self.deletion_diagnostic_code = None
                                self._segment_path = lambda: "deletion-history"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                        class BfdReversePathLabel(_Entity_):
                            """
                            BFD reverse path labels
                            
                            .. attribute:: entry
                            
                            	BFD reverse path labels
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                self.yang_name = "bfd-reverse-path-label"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "bfd-reverse-path-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo']['meta_info']


                    class TailEndBfdInfo(_Entity_):
                        """
                        The Tail\-end BFD info
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: failure_diagnostic_code
                        
                        	BFD session failure diagnostic code
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: failure_reason
                        
                        	BFD session failure reason
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: local_discriminator
                        
                        	BFD Local Discriminator
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remote_discriminator
                        
                        	BFD Remote Discrminator
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in mini second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo, self).__init__()

                            self.yang_name = "tail-end-bfd-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo))])
                            self._leafs = OrderedDict([
                                ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                            ])
                            self.failure_diagnostic_code = None
                            self.failure_reason = None
                            self.local_discriminator = None
                            self.remote_discriminator = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None

                            self.session_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._segment_path = lambda: "tail-end-bfd-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                        class SessionInfo(_Entity_):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "tail-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                    ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                ])
                                self.state = None
                                self.state_change_time = None
                                self._segment_path = lambda: "session-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo']['meta_info']


                    class SrlgCollection(_Entity_):
                        """
                        SRLG\-collection data
                        
                        .. attribute:: srlg_collect_type
                        
                        	SRLG\-collection mechanism
                        	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                        
                        	**config**\: False
                        
                        .. attribute:: discovered_srlg
                        
                        	Discovered SRLGs
                        	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection, self).__init__()

                            self.yang_name = "srlg-collection"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg))])
                            self._leafs = OrderedDict([
                                ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                            ])
                            self.srlg_collect_type = None

                            self.discovered_srlg = YList(self)
                            self._segment_path = lambda: "srlg-collection"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                        class DiscoveredSrlg(_Entity_):
                            """
                            Discovered SRLGs
                            
                            .. attribute:: entry
                            
                            	Discovered SRLGs
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                self.yang_name = "discovered-srlg"
                                self.yang_parent_name = "srlg-collection"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "discovered-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection']['meta_info']


                    class ReverseLspFec(_Entity_):
                        """
                        Reverse Associated Bidir LSP FEC
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec, self).__init__()

                            self.yang_name = "reverse-lsp-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "reverse-lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "reverse-lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec']['meta_info']


                    class ReverseTspec(_Entity_):
                        """
                        The Reverse T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec, self).__init__()

                            self.yang_name = "reverse-tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "reverse-tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec']['meta_info']


                    class FlexInfo(_Entity_):
                        """
                        FlexLSP S2L Information
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo']['meta_info']


                    class LspWrapInfo(_Entity_):
                        """
                        Lsp Wrap  Related information
                        
                        .. attribute:: lsp_wrap_protection_enable
                        
                        	LSP Wrap protection enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_protection_label
                        
                        	LSP Wrap Merge Point Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_egress_interface
                        
                        	Reverse Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_label
                        
                        	Reverse LSP label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_protection_state
                        
                        	LSP wrap protection state
                        	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo, self).__init__()

                            self.yang_name = "lsp-wrap-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                            ])
                            self.lsp_wrap_protection_enable = None
                            self.lsp_wrap_protection_label = None
                            self.reverse_egress_interface = None
                            self.reverse_lsp_label = None
                            self.lsp_wrap_protection_state = None
                            self._segment_path = lambda: "lsp-wrap-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        S2L Diversity Information
                        
                        .. attribute:: diversity_type
                        
                        	S2L path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.diversity_type = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo, ['diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo']['meta_info']


                    class AccumulatedPathMetrics(_Entity_):
                        """
                        Accumulated Path Metrics
                        
                        .. attribute:: te_metric
                        
                        	Path TE Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: igp_metric
                        
                        	Path IGP Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: delay_metric
                        
                        	Path Delay Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics, self).__init__()

                            self.yang_name = "accumulated-path-metrics"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                            ])
                            self.te_metric = None
                            self.igp_metric = None
                            self.delay_metric = None
                            self._segment_path = lambda: "accumulated-path-metrics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics']['meta_info']


                    class AccumulatedReversePathMetrics(_Entity_):
                        """
                        Accumulated Reverse Path Metrics
                        
                        .. attribute:: te_metric
                        
                        	Path TE Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: igp_metric
                        
                        	Path IGP Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: delay_metric
                        
                        	Path Delay Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics, self).__init__()

                            self.yang_name = "accumulated-reverse-path-metrics"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                            ])
                            self.te_metric = None
                            self.igp_metric = None
                            self.delay_metric = None
                            self._segment_path = lambda: "accumulated-reverse-path-metrics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics']['meta_info']


                    class S2lReverseLspSubObj(_Entity_):
                        """
                        Reverse LSP Sub Objects
                        
                        .. attribute:: entry
                        
                        	Reverse LSP Sub Objects
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj, self).__init__()

                            self.yang_name = "s2l-reverse-lsp-sub-obj"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The S2L's excluded srlg groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup']['meta_info']


                    class OutEro(_Entity_):
                        """
                        Outgoing ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro, self).__init__()

                            self.yang_name = "out-ero"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "out-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "out-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "out-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro']['meta_info']


                    class InEro(_Entity_):
                        """
                        Incoming ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro, self).__init__()

                            self.yang_name = "in-ero"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "in-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "in-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "in-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro']['meta_info']


                    class PathRro(_Entity_):
                        """
                        Path RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro, self).__init__()

                            self.yang_name = "path-rro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject))])
                            self._leafs = OrderedDict([
                                ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                            ])
                            self.rro_type = None

                            self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                            self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                            self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                            self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._segment_path = lambda: "path-rro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro, ['rro_type'], name, value)


                        class Ipv4rroSubObject(_Entity_):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                ])
                                self.rro_address = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "ipv4rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                        class LabelRroSubObject(_Entity_):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                self._leafs = OrderedDict([
                                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                    ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                ])
                                self.label = None
                                self.is_label_variable_length = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"

                                self.variable_length_label = YList(self)
                                self._segment_path = lambda: "label-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                    ])
                                    self.is_global_label = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                            class VariableLengthLabel(_Entity_):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "variable-length-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject']['meta_info']


                        class UnnumberedRroSubObject(_Entity_):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                    ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                ])
                                self.interface_address = None
                                self.interface_id = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "unnumbered-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                        class SrlgRroSubObject(_Entity_):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                self._leafs = OrderedDict()

                                self.srl_gs = YList(self)
                                self._segment_path = lambda: "srlg-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject, [], name, value)


                            class SrlGs(_Entity_):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "srl-gs"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro']['meta_info']


                    class ResvRro(_Entity_):
                        """
                        Resv RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro, self).__init__()

                            self.yang_name = "resv-rro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject))])
                            self._leafs = OrderedDict([
                                ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                            ])
                            self.rro_type = None

                            self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                            self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                            self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                            self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._segment_path = lambda: "resv-rro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro, ['rro_type'], name, value)


                        class Ipv4rroSubObject(_Entity_):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                ])
                                self.rro_address = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "ipv4rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                        class LabelRroSubObject(_Entity_):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                self._leafs = OrderedDict([
                                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                    ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                ])
                                self.label = None
                                self.is_label_variable_length = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"

                                self.variable_length_label = YList(self)
                                self._segment_path = lambda: "label-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                    ])
                                    self.is_global_label = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                            class VariableLengthLabel(_Entity_):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "variable-length-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject']['meta_info']


                        class UnnumberedRroSubObject(_Entity_):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                    ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                ])
                                self.interface_address = None
                                self.interface_id = None

                                self.flags = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "unnumbered-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                        class SrlgRroSubObject(_Entity_):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                self._leafs = OrderedDict()

                                self.srl_gs = YList(self)
                                self._segment_path = lambda: "srlg-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                            class SrlGs(_Entity_):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "srl-gs"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro']['meta_info']


                    class PathAffinityArray(_Entity_):
                        """
                        Tunnel's Path hops with affinity
                        
                        .. attribute:: hop_address
                        
                        	Hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: hop_affinity
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hop_extended_affinity
                        
                        	Hop affinity
                        	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray, self).__init__()

                            self.yang_name = "path-affinity-array"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity))])
                            self._leafs = OrderedDict([
                                ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                            ])
                            self.hop_address = None
                            self.hop_affinity = None

                            self.hop_extended_affinity = YList(self)
                            self._segment_path = lambda: "path-affinity-array"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                        class HopExtendedAffinity(_Entity_):
                            """
                            Hop affinity
                            
                            .. attribute:: entry
                            
                            	Hop affinity
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                self.yang_name = "hop-extended-affinity"
                                self.yang_parent_name = "path-affinity-array"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "hop-extended-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray']['meta_info']


                    class ReverseEroIn(_Entity_):
                        """
                         Reverse Incoming ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn, self).__init__()

                            self.yang_name = "reverse-ero-in"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "reverse-ero-in"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn']['meta_info']


                    class S2lSegmentRoutingPath(_Entity_):
                        """
                        Segment\-Routing S2L path info
                        
                        .. attribute:: sid_type
                        
                        	Type of the SID
                        	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: has_ip_addresses
                        
                        	Node has IP addresses specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: local_addr
                        
                        	Local IP address of adjacency or Node ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_addr
                        
                        	Remote IP address of adjacency
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: has_mpls_label
                        
                        	Hop has MPLS label specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label_value
                        
                        	The MPLS label value
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: has_entropy_label
                        
                        	Hop has EL specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath, self).__init__()

                            self.yang_name = "s2l-segment-routing-path"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                            ])
                            self.sid_type = None
                            self.has_ip_addresses = None
                            self.local_addr = None
                            self.remote_addr = None
                            self.has_mpls_label = None
                            self.mpls_label_value = None
                            self.has_entropy_label = None
                            self._segment_path = lambda: "s2l-segment-routing-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes.TunnelRemote']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelRemotes']['meta_info']


        class NniTunnels(_Entity_):
            """
            GMPLS NNI tunnels
            
            .. attribute:: nni_tunnel
            
            	GMPLS\-NNI tail tunnel
            	**type**\: list of  		 :py:class:`NniTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2pP2mpTunnel.NniTunnels, self).__init__()

                self.yang_name = "nni-tunnels"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nni-tunnel", ("nni_tunnel", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel))])
                self._leafs = OrderedDict()

                self.nni_tunnel = YList(self)
                self._segment_path = lambda: "nni-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels, [], name, value)


            class NniTunnel(_Entity_):
                """
                GMPLS\-NNI tail tunnel
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config>`
                
                	**config**\: False
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:  :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:  :py:class:`ReoptimizedP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:  :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:  :py:class:`ReoptimizedStandbyP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:  :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp>`
                
                	**config**\: False
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:  :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp>`
                
                	**config**\: False
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:  :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp>`
                
                	**config**\: False
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo>`
                
                	**config**\: False
                
                .. attribute:: auto_capacity
                
                	Auto\-capacity Info
                	**type**\:  :py:class:`AutoCapacity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity>`
                
                	**config**\: False
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:  :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History>`
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:  :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup>`
                
                	**config**\: False
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:  :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh>`
                
                	**config**\: False
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:  :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc>`
                
                	**config**\: False
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:  :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation>`
                
                	**config**\: False
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption>`
                
                	**config**\: False
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:  :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel>`
                
                	**config**\: False
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:  :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo>`
                
                	**config**\: False
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:  :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo>`
                
                	**config**\: False
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:  :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir>`
                
                	**config**\: False
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:  :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:  :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence>`
                
                	**config**\: False
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo>`
                
                	**config**\: False
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:  :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                	**config**\: False
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                	**config**\: False
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:  :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                	**config**\: False
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:  :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                	**config**\: False
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                	**config**\: False
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                	**config**\: False
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:  :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:  :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                	**config**\: False
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_working_lsp_id
                
                	LSP\-id of last working LSP
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel, self).__init__()

                    self.yang_name = "nni-tunnel"
                    self.yang_parent_name = "nni-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','source_address','destination_address']
                    self._child_classes = OrderedDict([("config", ("config", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config)), ("tunnel-current-lsp", ("tunnel_current_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp)), ("reoptimized-p2mp-lsp", ("reoptimized_p2mp_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp)), ("tunnel-standby-lsp", ("tunnel_standby_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp)), ("reoptimized-standby-p2mp-lsp", ("reoptimized_standby_p2mp_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp)), ("tunnel-restoration-lsp", ("tunnel_restoration_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp)), ("delay-clean-pp-lsp", ("delay_clean_pp_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp)), ("cleaned-lsp", ("cleaned_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp)), ("p2p-info", ("p2p_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo)), ("auto-capacity", ("auto_capacity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity)), ("history", ("history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History)), ("path-protection", ("path_protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection)), ("auto-backup", ("auto_backup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup)), ("auto-mesh", ("auto_mesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh)), ("auto-pcc", ("auto_pcc", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc)), ("pce-delegation", ("pce_delegation", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption)), ("wdm-unitunnel", ("wdm_unitunnel", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel)), ("transport-tunnel-info", ("transport_tunnel_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo)), ("bfd-info", ("bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo)), ("otn-bidir", ("otn_bidir", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir)), ("bidir", ("bidir", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet)), ("te-tunnel-convergence", ("te_tunnel_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo)), ("destination", ("destination", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('role_standby', (YLeaf(YType.boolean, 'role-standby'), ['bool'])),
                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                        ('admin_state', (YLeaf(YType.enumeration, 'admin-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelAdminState', '')])),
                        ('operational_state', (YLeaf(YType.enumeration, 'operational-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                        ('operational_state_changes', (YLeaf(YType.uint32, 'operational-state-changes'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('fail_reason', (YLeaf(YType.enumeration, 'fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsMteTunnelFailReason', '')])),
                        ('destination_up_count', (YLeaf(YType.uint32, 'destination-up-count'), ['int'])),
                        ('destination_disabled_count', (YLeaf(YType.uint32, 'destination-disabled-count'), ['int'])),
                        ('destination_down_count', (YLeaf(YType.uint32, 'destination-down-count'), ['int'])),
                        ('re_opt_hold_down_timer_remaining', (YLeaf(YType.uint32, 're-opt-hold-down-timer-remaining'), ['int'])),
                        ('bandwidth_requested', (YLeaf(YType.uint32, 'bandwidth-requested'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                        ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                        ('tunnel_recovering', (YLeaf(YType.boolean, 'tunnel-recovering'), ['bool'])),
                        ('reroute_pending', (YLeaf(YType.boolean, 'reroute-pending'), ['bool'])),
                        ('explicit_path_change', (YLeaf(YType.boolean, 'explicit-path-change'), ['bool'])),
                        ('path_option_change', (YLeaf(YType.boolean, 'path-option-change'), ['bool'])),
                        ('affinity_failure_reopt_disabled', (YLeaf(YType.boolean, 'affinity-failure-reopt-disabled'), ['bool'])),
                        ('affinity_failure_reopt_time_remained', (YLeaf(YType.uint32, 'affinity-failure-reopt-time-remained'), ['int'])),
                        ('affinity_failure_delayed_tear_time_remained', (YLeaf(YType.uint32, 'affinity-failure-delayed-tear-time-remained'), ['int'])),
                        ('invalidation_time_remained', (YLeaf(YType.uint32, 'invalidation-time-remained'), ['int'])),
                        ('drop_mode', (YLeaf(YType.boolean, 'drop-mode'), ['bool'])),
                        ('auto_route', (YLeaf(YType.boolean, 'auto-route'), ['bool'])),
                        ('forwarding_adjacency', (YLeaf(YType.boolean, 'forwarding-adjacency'), ['bool'])),
                        ('load_share_factor', (YLeaf(YType.uint32, 'load-share-factor'), ['int'])),
                        ('load_share_type', (YLeaf(YType.enumeration, 'load-share-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLoadshare', '')])),
                        ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                        ('tie_breaker', (YLeaf(YType.enumeration, 'tie-breaker'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                        ('tiebreaker_type', (YLeaf(YType.uint32, 'tiebreaker-type'), ['int'])),
                        ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('metric_qualifier', (YLeaf(YType.enumeration, 'metric-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('is_hop_limit_ignore', (YLeaf(YType.boolean, 'is-hop-limit-ignore'), ['bool'])),
                        ('hop_limit_ignored_reason', (YLeaf(YType.enumeration, 'hop-limit-ignored-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeHopLimitIgnore', '')])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('pce_fail_reason', (YLeaf(YType.enumeration, 'pce-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePceFailReasons', '')])),
                        ('snmp_index', (YLeaf(YType.uint32, 'snmp-index'), ['int'])),
                        ('is_inter_area_tunnel', (YLeaf(YType.boolean, 'is-inter-area-tunnel'), ['bool'])),
                        ('is_auto_backup', (YLeaf(YType.boolean, 'is-auto-backup'), ['bool'])),
                        ('is_auto_pcc', (YLeaf(YType.boolean, 'is-auto-pcc'), ['bool'])),
                        ('is_pce_delegated', (YLeaf(YType.boolean, 'is-pce-delegated'), ['bool'])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                        ('xro_attribute_set_name', (YLeaf(YType.str, 'xro-attribute-set-name'), ['str'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('passive_tunnel_name', (YLeaf(YType.str, 'passive-tunnel-name'), ['str'])),
                        ('binding_label_exists', (YLeaf(YType.boolean, 'binding-label-exists'), ['bool'])),
                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                        ('last_hop_ifindex', (YLeaf(YType.uint32, 'last-hop-ifindex'), ['int'])),
                        ('is_named', (YLeaf(YType.boolean, 'is-named'), ['bool'])),
                        ('lsp_wrap_protection_enabled', (YLeaf(YType.boolean, 'lsp-wrap-protection-enabled'), ['bool'])),
                        ('lsp_wrap_label', (YLeaf(YType.uint32, 'lsp-wrap-label'), ['int'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('autoroute_announce_exclude_segment_routing', (YLeaf(YType.boolean, 'autoroute-announce-exclude-segment-routing'), ['bool'])),
                        ('last_working_lsp_id', (YLeaf(YType.uint16, 'last-working-lsp-id'), ['int'])),
                    ])
                    self.tunnel_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.role_standby = None
                    self.tunnel_interface_name = None
                    self.admin_state = None
                    self.operational_state = None
                    self.operational_state_changes = None
                    self.signaled_name = None
                    self.fail_reason = None
                    self.destination_up_count = None
                    self.destination_disabled_count = None
                    self.destination_down_count = None
                    self.re_opt_hold_down_timer_remaining = None
                    self.bandwidth_requested = None
                    self.bandwidth_type = None
                    self.is_node_protected = None
                    self.is_bandwidth_protect = None
                    self.tunnel_recovering = None
                    self.reroute_pending = None
                    self.explicit_path_change = None
                    self.path_option_change = None
                    self.affinity_failure_reopt_disabled = None
                    self.affinity_failure_reopt_time_remained = None
                    self.affinity_failure_delayed_tear_time_remained = None
                    self.invalidation_time_remained = None
                    self.drop_mode = None
                    self.auto_route = None
                    self.forwarding_adjacency = None
                    self.load_share_factor = None
                    self.load_share_type = None
                    self.create_time = None
                    self.uptime = None
                    self.metric_type = None
                    self.tie_breaker = None
                    self.tiebreaker_type = None
                    self.tiebreaker_qualifier = None
                    self.metric_qualifier = None
                    self.is_hop_limit_ignore = None
                    self.hop_limit_ignored_reason = None
                    self.outbound_frr_state = None
                    self.area_id = None
                    self.pce_fail_reason = None
                    self.snmp_index = None
                    self.is_inter_area_tunnel = None
                    self.is_auto_backup = None
                    self.is_auto_pcc = None
                    self.is_pce_delegated = None
                    self.tunnel_attribute_set_name = None
                    self.tunnel_attribute_set_type = None
                    self.xro_attribute_set_name = None
                    self.is_passive = None
                    self.passive_tunnel_name = None
                    self.binding_label_exists = None
                    self.binding_label = None
                    self.last_hop_ifindex = None
                    self.is_named = None
                    self.lsp_wrap_protection_enabled = None
                    self.lsp_wrap_label = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.autoroute_announce_exclude_segment_routing = None
                    self.last_working_lsp_id = None

                    self.config = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"

                    self.tunnel_current_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"

                    self.reoptimized_p2mp_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"

                    self.tunnel_standby_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"

                    self.reoptimized_standby_p2mp_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"

                    self.tunnel_restoration_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"

                    self.delay_clean_pp_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"

                    self.cleaned_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"

                    self.p2p_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"

                    self.auto_capacity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity()
                    self.auto_capacity.parent = self
                    self._children_name_map["auto_capacity"] = "auto-capacity"

                    self.history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"

                    self.path_protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.auto_backup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"

                    self.auto_mesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"

                    self.auto_pcc = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"

                    self.pce_delegation = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"

                    self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"

                    self.wdm_unitunnel = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"

                    self.transport_tunnel_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"

                    self.bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"

                    self.otn_bidir = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"

                    self.bidir = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"

                    self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                    self.te_tunnel_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"

                    self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"

                    self.destination = YList(self)
                    self._segment_path = lambda: "nni-tunnel" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/nni-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel, ['tunnel_id', 'source_address', 'destination_address', 'role_standby', 'tunnel_interface_name', 'admin_state', 'operational_state', 'operational_state_changes', 'signaled_name', 'fail_reason', 'destination_up_count', 'destination_disabled_count', 'destination_down_count', 're_opt_hold_down_timer_remaining', 'bandwidth_requested', 'bandwidth_type', 'is_node_protected', 'is_bandwidth_protect', 'tunnel_recovering', 'reroute_pending', 'explicit_path_change', 'path_option_change', 'affinity_failure_reopt_disabled', 'affinity_failure_reopt_time_remained', 'affinity_failure_delayed_tear_time_remained', 'invalidation_time_remained', 'drop_mode', 'auto_route', 'forwarding_adjacency', 'load_share_factor', 'load_share_type', 'create_time', 'uptime', 'metric_type', 'tie_breaker', 'tiebreaker_type', 'tiebreaker_qualifier', 'metric_qualifier', 'is_hop_limit_ignore', 'hop_limit_ignored_reason', 'outbound_frr_state', 'area_id', 'pce_fail_reason', 'snmp_index', 'is_inter_area_tunnel', 'is_auto_backup', 'is_auto_pcc', 'is_pce_delegated', 'tunnel_attribute_set_name', 'tunnel_attribute_set_type', 'xro_attribute_set_name', 'is_passive', 'passive_tunnel_name', 'binding_label_exists', 'binding_label', 'last_hop_ifindex', 'is_named', 'lsp_wrap_protection_enabled', 'lsp_wrap_label', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'autoroute_announce_exclude_segment_routing', 'last_working_lsp_id'], name, value)


                class Config(_Entity_):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:  :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:  :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging configuration
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if Forward class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit_global
                    
                    	Global Delay Limit (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of  		 :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity)), ("bidirectional-config", ("bidirectional_config", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig)), ("bfd-config", ("bfd_config", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry)), ("autoroute-destination", ("autoroute_destination", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                            ('is_p2mp', (YLeaf(YType.boolean, 'is-p2mp'), ['bool'])),
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('interface_configured_bandwidth', (YLeaf(YType.uint32, 'interface-configured-bandwidth'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                            ('backup_bandwidth_flags', (YLeaf(YType.uint8, 'backup-bandwidth-flags'), ['int'])),
                            ('config_load_share', (YLeaf(YType.uint32, 'config-load-share'), ['int'])),
                            ('payload_type', (YLeaf(YType.uint16, 'payload-type'), ['int'])),
                            ('is_in_config', (YLeaf(YType.boolean, 'is-in-config'), ['bool'])),
                            ('explicit_null_imposition', (YLeaf(YType.boolean, 'explicit-null-imposition'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('is_backup_tunnel', (YLeaf(YType.boolean, 'is-backup-tunnel'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                            ('path_protection_enabled', (YLeaf(YType.boolean, 'path-protection-enabled'), ['bool'])),
                            ('hop_limit', (YLeaf(YType.uint8, 'hop-limit'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('cost_limit_global', (YLeaf(YType.uint32, 'cost-limit-global'), ['int'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                            ('delay_limit_global', (YLeaf(YType.uint32, 'delay-limit-global'), ['int'])),
                            ('path_invalidation_timeout_source', (YLeaf(YType.uint32, 'path-invalidation-timeout-source'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action_source', (YLeaf(YType.uint32, 'path-invalidation-action-source'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('soft_preempt', (YLeaf(YType.boolean, 'soft-preempt'), ['bool'])),
                            ('disable_affinity_failure_reopt', (YLeaf(YType.boolean, 'disable-affinity-failure-reopt'), ['bool'])),
                            ('affinity_failure_reopt_timer', (YLeaf(YType.uint32, 'affinity-failure-reopt-timer'), ['int'])),
                            ('segment_routing_path_selection', (YLeaf(YType.enumeration, 'segment-routing-path-selection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_id = None
                        self.is_p2mp = None
                        self.signaled_name = None
                        self.configured_bandwidth = None
                        self.interface_configured_bandwidth = None
                        self.bandwidth_type = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.policy_class = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.backup_bandwidth = None
                        self.backup_bandwidth_flags = None
                        self.config_load_share = None
                        self.payload_type = None
                        self.is_in_config = None
                        self.explicit_null_imposition = None
                        self.fast_reroute = None
                        self.is_backup_tunnel = None
                        self.record_route = None
                        self.srlg_discovery = None
                        self.path_protection_enabled = None
                        self.hop_limit = None
                        self.cost_limit = None
                        self.cost_limit_global = None
                        self.delay_limit = None
                        self.delay_limit_global = None
                        self.path_invalidation_timeout_source = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action_source = None
                        self.path_invalidation_action = None
                        self.soft_preempt = None
                        self.disable_affinity_failure_reopt = None
                        self.affinity_failure_reopt_timer = None
                        self.segment_routing_path_selection = None

                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bidirectional_config = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"

                        self.bfd_config = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"

                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.autoroute_destination = YList(self)
                        self._segment_path = lambda: "config"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config, ['tunnel_name', 'tunnel_id', 'is_p2mp', 'signaled_name', 'configured_bandwidth', 'interface_configured_bandwidth', 'bandwidth_type', 'setup_priority', 'hold_priority', 'policy_class', 'forward_class', 'is_forward_class_configured', 'backup_bandwidth', 'backup_bandwidth_flags', 'config_load_share', 'payload_type', 'is_in_config', 'explicit_null_imposition', 'fast_reroute', 'is_backup_tunnel', 'record_route', 'srlg_discovery', 'path_protection_enabled', 'hop_limit', 'cost_limit', 'cost_limit_global', 'delay_limit', 'delay_limit_global', 'path_invalidation_timeout_source', 'path_invalidation_timeout', 'path_invalidation_action_source', 'path_invalidation_action', 'soft_preempt', 'disable_affinity_failure_reopt', 'affinity_failure_reopt_timer', 'segment_routing_path_selection'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity']['meta_info']


                    class BidirectionalConfig(_Entity_):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_type
                        
                        	Association Type (RFC 7751)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('association_type', (YLeaf(YType.uint16, 'association-type'), ['int'])),
                                ('association_id', (YLeaf(YType.uint16, 'association-id'), ['int'])),
                                ('association_source', (YLeaf(YType.str, 'association-source'), ['str'])),
                                ('association_global_id', (YLeaf(YType.uint32, 'association-global-id'), ['int'])),
                                ('association_corouted', (YLeaf(YType.boolean, 'association-corouted'), ['bool'])),
                            ])
                            self.association_type = None
                            self.association_id = None
                            self.association_source = None
                            self.association_global_id = None
                            self.association_corouted = None
                            self._segment_path = lambda: "bidirectional-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, ['association_type', 'association_id', 'association_source', 'association_global_id', 'association_corouted'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig']['meta_info']


                    class BfdConfig(_Entity_):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:  :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:  :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('bfd_fast_detecting_enabled', (YLeaf(YType.boolean, 'bfd-fast-detecting-enabled'), ['bool'])),
                                ('bfd_type', (YLeaf(YType.enumeration, 'bfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ('bring_up_timeout', (YLeaf(YType.uint16, 'bring-up-timeout'), ['int'])),
                                ('bring_up_timeout_default', (YLeaf(YType.boolean, 'bring-up-timeout-default'), ['bool'])),
                                ('dampening_initial_wait', (YLeaf(YType.uint32, 'dampening-initial-wait'), ['int'])),
                                ('dampening_initial_wait_default', (YLeaf(YType.boolean, 'dampening-initial-wait-default'), ['bool'])),
                                ('dampening_max_wait', (YLeaf(YType.uint32, 'dampening-max-wait'), ['int'])),
                                ('dampening_max_wait_default', (YLeaf(YType.boolean, 'dampening-max-wait-default'), ['bool'])),
                                ('dampening_secondary_wait', (YLeaf(YType.uint32, 'dampening-secondary-wait'), ['int'])),
                                ('dampening_secondary_wait_default', (YLeaf(YType.boolean, 'dampening-secondary-wait-default'), ['bool'])),
                                ('periodic_lsp_ping_disabled', (YLeaf(YType.boolean, 'periodic-lsp-ping-disabled'), ['bool'])),
                                ('periodic_lsp_ping_interval', (YLeaf(YType.uint32, 'periodic-lsp-ping-interval'), ['int'])),
                                ('periodic_lsp_ping_interval_default', (YLeaf(YType.boolean, 'periodic-lsp-ping-interval-default'), ['bool'])),
                                ('bfd_session_down_action', (YLeaf(YType.enumeration, 'bfd-session-down-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBfdSessionDownAction1', '')])),
                                ('bfd_session_down_reopt_timeout', (YLeaf(YType.uint32, 'bfd-session-down-reopt-timeout'), ['int'])),
                                ('bfd_encap_mode', (YLeaf(YType.enumeration, 'bfd-encap-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfdEncapMode', '')])),
                                ('sbfd_target_id', (YLeaf(YType.str, 'sbfd-target-id'), ['str'])),
                            ])
                            self.bfd_fast_detecting_enabled = None
                            self.bfd_type = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None
                            self.bring_up_timeout = None
                            self.bring_up_timeout_default = None
                            self.dampening_initial_wait = None
                            self.dampening_initial_wait_default = None
                            self.dampening_max_wait = None
                            self.dampening_max_wait_default = None
                            self.dampening_secondary_wait = None
                            self.dampening_secondary_wait_default = None
                            self.periodic_lsp_ping_disabled = None
                            self.periodic_lsp_ping_interval = None
                            self.periodic_lsp_ping_interval_default = None
                            self.bfd_session_down_action = None
                            self.bfd_session_down_reopt_timeout = None
                            self.bfd_encap_mode = None
                            self.sbfd_target_id = None
                            self._segment_path = lambda: "bfd-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, ['bfd_fast_detecting_enabled', 'bfd_type', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default', 'bring_up_timeout', 'bring_up_timeout_default', 'dampening_initial_wait', 'dampening_initial_wait_default', 'dampening_max_wait', 'dampening_max_wait_default', 'dampening_secondary_wait', 'dampening_secondary_wait_default', 'periodic_lsp_ping_disabled', 'periodic_lsp_ping_interval', 'periodic_lsp_ping_interval_default', 'bfd_session_down_action', 'bfd_session_down_reopt_timeout', 'bfd_encap_mode', 'sbfd_target_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging configuration
                        
                        .. attribute:: all
                        
                        	All tunnel logging enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimize
                        
                        	Reoptimization Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	State Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reroute
                        
                        	Reroute logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_change
                        
                        	Bandwidth change logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchover
                        
                        	Path protection switchover logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: record_route
                        
                        	Record route logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_failure
                        
                        	Path calculation failure logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimization_attempt
                        
                        	Reoptimization attempt logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: insufficient_bandwidth
                        
                        	Insufficient bandwidth logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('all', (YLeaf(YType.boolean, 'all'), ['bool'])),
                                ('reoptimize', (YLeaf(YType.boolean, 'reoptimize'), ['bool'])),
                                ('state', (YLeaf(YType.boolean, 'state'), ['bool'])),
                                ('reroute', (YLeaf(YType.boolean, 'reroute'), ['bool'])),
                                ('bandwidth_change', (YLeaf(YType.boolean, 'bandwidth-change'), ['bool'])),
                                ('switchover', (YLeaf(YType.boolean, 'switchover'), ['bool'])),
                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ('path_calculation_failure', (YLeaf(YType.boolean, 'path-calculation-failure'), ['bool'])),
                                ('reoptimization_attempt', (YLeaf(YType.boolean, 'reoptimization-attempt'), ['bool'])),
                                ('insufficient_bandwidth', (YLeaf(YType.boolean, 'insufficient-bandwidth'), ['bool'])),
                            ])
                            self.all = None
                            self.reoptimize = None
                            self.state = None
                            self.reroute = None
                            self.bandwidth_change = None
                            self.switchover = None
                            self.record_route = None
                            self.path_calculation_failure = None
                            self.reoptimization_attempt = None
                            self.insufficient_bandwidth = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging, ['all', 'reoptimize', 'state', 'reroute', 'bandwidth_change', 'switchover', 'record_route', 'path_calculation_failure', 'reoptimization_attempt', 'insufficient_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry']['meta_info']


                    class AutorouteDestination(_Entity_):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('prefix_length', (YLeaf(YType.uint16, 'prefix-length'), ['int'])),
                            ])
                            self.destination_address = None
                            self.prefix_length = None
                            self._segment_path = lambda: "autoroute-destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, ['destination_address', 'prefix_length'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Config']['meta_info']


                class TunnelCurrentLsp(_Entity_):
                    """
                    Current LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-current-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp']['meta_info']


                class ReoptimizedP2mpLsp(_Entity_):
                    """
                    Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp']['meta_info']


                class TunnelStandbyLsp(_Entity_):
                    """
                    Standby LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-standby-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp']['meta_info']


                class ReoptimizedStandbyP2mpLsp(_Entity_):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-standby-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp']['meta_info']


                class TunnelRestorationLsp(_Entity_):
                    """
                    Restoration LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-restoration-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp']['meta_info']


                class DelayCleanPpLsp(_Entity_):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "delay-clean-pp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp']['meta_info']


                class CleanedLsp(_Entity_):
                    """
                    Cleaned LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "cleaned-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp']['meta_info']


                class P2pInfo(_Entity_):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:  :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:  :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus)), ("auto-bandwidth-config", ("auto_bandwidth_config", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig)), ("auto-bandwidth-oper", ("auto_bandwidth_oper", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper))])
                        self._leafs = OrderedDict([
                            ('is_bidirectional', (YLeaf(YType.boolean, 'is-bidirectional'), ['bool'])),
                        ])
                        self.is_bidirectional = None

                        self.auto_bandwidth_status = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"

                        self.auto_bandwidth_config = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"

                        self.auto_bandwidth_oper = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._segment_path = lambda: "p2p-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo, ['is_bidirectional'], name, value)


                    class AutoBandwidthStatus(_Entity_):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                                ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                            ])
                            self.is_auto_bandwidth_enabled = None
                            self.reactivation_time = None
                            self._segment_path = lambda: "auto-bandwidth-status"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus']['meta_info']


                    class AutoBandwidthConfig(_Entity_):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_enabled
                        
                        	TRUE if resignal last bandwidth is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_timeout
                        
                        	The configured time\-out value in seconds for resignal  last bandwidth after tunnel down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_collect_only', (YLeaf(YType.boolean, 'is-auto-bandwidth-collect-only'), ['bool'])),
                                ('minimum_bandwidth', (YLeaf(YType.uint32, 'minimum-bandwidth'), ['int'])),
                                ('maximum_bandwidth', (YLeaf(YType.uint32, 'maximum-bandwidth'), ['int'])),
                                ('application_frequency', (YLeaf(YType.uint32, 'application-frequency'), ['int'])),
                                ('collection_frequency', (YLeaf(YType.uint32, 'collection-frequency'), ['int'])),
                                ('adjustment_threshold_percent', (YLeaf(YType.uint32, 'adjustment-threshold-percent'), ['int'])),
                                ('adjustment_threshold_value', (YLeaf(YType.uint32, 'adjustment-threshold-value'), ['int'])),
                                ('overflow_threshold_percent', (YLeaf(YType.uint32, 'overflow-threshold-percent'), ['int'])),
                                ('overflow_threshold_value', (YLeaf(YType.uint32, 'overflow-threshold-value'), ['int'])),
                                ('overflow_threshold_limit', (YLeaf(YType.uint32, 'overflow-threshold-limit'), ['int'])),
                                ('underflow_threshold_percent', (YLeaf(YType.uint32, 'underflow-threshold-percent'), ['int'])),
                                ('underflow_threshold_value', (YLeaf(YType.uint32, 'underflow-threshold-value'), ['int'])),
                                ('underflow_threshold_limit', (YLeaf(YType.uint32, 'underflow-threshold-limit'), ['int'])),
                                ('resignal_last_bandwidth_enabled', (YLeaf(YType.boolean, 'resignal-last-bandwidth-enabled'), ['bool'])),
                                ('resignal_last_bandwidth_timeout', (YLeaf(YType.uint32, 'resignal-last-bandwidth-timeout'), ['int'])),
                            ])
                            self.is_auto_bandwidth_collect_only = None
                            self.minimum_bandwidth = None
                            self.maximum_bandwidth = None
                            self.application_frequency = None
                            self.collection_frequency = None
                            self.adjustment_threshold_percent = None
                            self.adjustment_threshold_value = None
                            self.overflow_threshold_percent = None
                            self.overflow_threshold_value = None
                            self.overflow_threshold_limit = None
                            self.underflow_threshold_percent = None
                            self.underflow_threshold_value = None
                            self.underflow_threshold_limit = None
                            self.resignal_last_bandwidth_enabled = None
                            self.resignal_last_bandwidth_timeout = None
                            self._segment_path = lambda: "auto-bandwidth-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig, ['is_auto_bandwidth_collect_only', 'minimum_bandwidth', 'maximum_bandwidth', 'application_frequency', 'collection_frequency', 'adjustment_threshold_percent', 'adjustment_threshold_value', 'overflow_threshold_percent', 'overflow_threshold_value', 'overflow_threshold_limit', 'underflow_threshold_percent', 'underflow_threshold_value', 'underflow_threshold_limit', 'resignal_last_bandwidth_enabled', 'resignal_last_bandwidth_timeout'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig']['meta_info']


                    class AutoBandwidthOper(_Entity_):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:  :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        	**config**\: False
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:  :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_expire_time
                        
                        	Timestamp when the resignal last bandwidth will expire and tunnel will use configured bandwidth to setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                                ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                                ('last_application_trigger', (YLeaf(YType.enumeration, 'last-application-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppTrigger', '')])),
                                ('application_jitter', (YLeaf(YType.uint32, 'application-jitter'), ['int'])),
                                ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                                ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                                ('time_left_collection', (YLeaf(YType.uint32, 'time-left-collection'), ['int'])),
                                ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                                ('underflow_highest_bandwidth', (YLeaf(YType.uint32, 'underflow-highest-bandwidth'), ['int'])),
                                ('threshold_overflows', (YLeaf(YType.uint32, 'threshold-overflows'), ['int'])),
                                ('overflow_early_bw_applications', (YLeaf(YType.uint32, 'overflow-early-bw-applications'), ['int'])),
                                ('threshold_underflows', (YLeaf(YType.uint32, 'threshold-underflows'), ['int'])),
                                ('underflow_early_bw_applications', (YLeaf(YType.uint32, 'underflow-early-bw-applications'), ['int'])),
                                ('collect_only_requested_bandwidth', (YLeaf(YType.uint32, 'collect-only-requested-bandwidth'), ['int'])),
                                ('application_reject_reason', (YLeaf(YType.enumeration, 'application-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppRej', '')])),
                                ('resignal_last_bandwidth_expire_time', (YLeaf(YType.uint32, 'resignal-last-bandwidth-expire-time'), ['int'])),
                            ])
                            self.last_bandwidth_applied = None
                            self.bandwidth_pool_type = None
                            self.bandwidth_applications = None
                            self.last_application_trigger = None
                            self.application_jitter = None
                            self.time_left_application = None
                            self.samples_collected = None
                            self.time_left_collection = None
                            self.highest_bandwidth = None
                            self.underflow_highest_bandwidth = None
                            self.threshold_overflows = None
                            self.overflow_early_bw_applications = None
                            self.threshold_underflows = None
                            self.underflow_early_bw_applications = None
                            self.collect_only_requested_bandwidth = None
                            self.application_reject_reason = None
                            self.resignal_last_bandwidth_expire_time = None
                            self._segment_path = lambda: "auto-bandwidth-oper"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper, ['last_bandwidth_applied', 'bandwidth_pool_type', 'bandwidth_applications', 'last_application_trigger', 'application_jitter', 'time_left_application', 'samples_collected', 'time_left_collection', 'highest_bandwidth', 'underflow_highest_bandwidth', 'threshold_overflows', 'overflow_early_bw_applications', 'threshold_underflows', 'underflow_early_bw_applications', 'collect_only_requested_bandwidth', 'application_reject_reason', 'resignal_last_bandwidth_expire_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo']['meta_info']


                class AutoCapacity(_Entity_):
                    """
                    Auto\-capacity Info
                    
                    .. attribute:: auto_capacity_configuration
                    
                    	The configured properties of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityConfiguration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_capacity_stats
                    
                    	The statistic of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats>`
                    
                    	**config**\: False
                    
                    .. attribute:: clone
                    
                    	Table of clones
                    	**type**\: list of  		 :py:class:`Clone <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity, self).__init__()

                        self.yang_name = "auto-capacity"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-capacity-configuration", ("auto_capacity_configuration", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration)), ("auto-capacity-stats", ("auto_capacity_stats", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats)), ("clone", ("clone", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone))])
                        self._leafs = OrderedDict()

                        self.auto_capacity_configuration = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration()
                        self.auto_capacity_configuration.parent = self
                        self._children_name_map["auto_capacity_configuration"] = "auto-capacity-configuration"

                        self.auto_capacity_stats = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats()
                        self.auto_capacity_stats.parent = self
                        self._children_name_map["auto_capacity_stats"] = "auto-capacity-stats"

                        self.clone = YList(self)
                        self._segment_path = lambda: "auto-capacity"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity, [], name, value)


                    class AutoCapacityConfiguration(_Entity_):
                        """
                        The configured properties of auto\-capacity
                        
                        .. attribute:: minimum_clones
                        
                        	The minimum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_clones
                        
                        	The maximum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merge_bandwidth
                        
                        	The merge bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: split_bandwidth
                        
                        	The split bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: nominal_bandwidth
                        
                        	The optimal or nominal bandwidth for the clones in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration, self).__init__()

                            self.yang_name = "auto-capacity-configuration"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('minimum_clones', (YLeaf(YType.uint32, 'minimum-clones'), ['int'])),
                                ('maximum_clones', (YLeaf(YType.uint32, 'maximum-clones'), ['int'])),
                                ('merge_bandwidth', (YLeaf(YType.uint32, 'merge-bandwidth'), ['int'])),
                                ('split_bandwidth', (YLeaf(YType.uint32, 'split-bandwidth'), ['int'])),
                                ('nominal_bandwidth', (YLeaf(YType.uint32, 'nominal-bandwidth'), ['int'])),
                            ])
                            self.minimum_clones = None
                            self.maximum_clones = None
                            self.merge_bandwidth = None
                            self.split_bandwidth = None
                            self.nominal_bandwidth = None
                            self._segment_path = lambda: "auto-capacity-configuration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration, ['minimum_clones', 'maximum_clones', 'merge_bandwidth', 'split_bandwidth', 'nominal_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration']['meta_info']


                    class AutoCapacityStats(_Entity_):
                        """
                        The statistic of auto\-capacity
                        
                        .. attribute:: splits
                        
                        	Count of splits events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merges
                        
                        	Count of merges events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_created
                        
                        	Total clones created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_deleted
                        
                        	Total clones deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_watermark_clones
                        
                        	Highest number of clones reached at any point in time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats, self).__init__()

                            self.yang_name = "auto-capacity-stats"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('splits', (YLeaf(YType.uint32, 'splits'), ['int'])),
                                ('merges', (YLeaf(YType.uint32, 'merges'), ['int'])),
                                ('total_clones_created', (YLeaf(YType.uint32, 'total-clones-created'), ['int'])),
                                ('total_clones_deleted', (YLeaf(YType.uint32, 'total-clones-deleted'), ['int'])),
                                ('high_watermark_clones', (YLeaf(YType.uint32, 'high-watermark-clones'), ['int'])),
                            ])
                            self.splits = None
                            self.merges = None
                            self.total_clones_created = None
                            self.total_clones_deleted = None
                            self.high_watermark_clones = None
                            self._segment_path = lambda: "auto-capacity-stats"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats, ['splits', 'merges', 'total_clones_created', 'total_clones_deleted', 'high_watermark_clones'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats']['meta_info']


                    class Clone(_Entity_):
                        """
                        Table of clones
                        
                        .. attribute:: name
                        
                        	Name of the clone
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: creation_timestamp
                        
                        	The timestamp when this clone was created relative to Jan 1, 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	The interface state of the cloned tunnel
                        	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_bandwidth
                        
                        	The signaled bandwidth (kbps) of the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: current_bandwidth_demand
                        
                        	The current demand (kbps) read from the traffic stats for the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone, self).__init__()

                            self.yang_name = "clone"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('creation_timestamp', (YLeaf(YType.uint32, 'creation-timestamp'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                                ('signaled_bandwidth', (YLeaf(YType.uint32, 'signaled-bandwidth'), ['int'])),
                                ('current_bandwidth_demand', (YLeaf(YType.uint32, 'current-bandwidth-demand'), ['int'])),
                            ])
                            self.name = None
                            self.creation_timestamp = None
                            self.state = None
                            self.signaled_bandwidth = None
                            self.current_bandwidth_demand = None
                            self._segment_path = lambda: "clone"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone, ['name', 'creation_timestamp', 'state', 'signaled_bandwidth', 'current_bandwidth_demand'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity']['meta_info']


                class History(_Entity_):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:  :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:  :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:  :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:  :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:  :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:  :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:  :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:  :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:  :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:  :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:  :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("current-setup", ("current_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup)), ("reopt-setup", ("reopt_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup)), ("gmpls-path-protect-setup", ("gmpls_path_protect_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup)), ("previous-setup", ("previous_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup)), ("previous-gmpls-path-protect-setup", ("previous_gmpls_path_protect_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup)), ("gmpls-other-setup", ("gmpls_other_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup)), ("gmpls-other-protect-setup", ("gmpls_other_protect_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup)), ("standby-setup", ("standby_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup)), ("standby-reopt-setup", ("standby_reopt_setup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup)), ("last-re-opt-fail", ("last_re_opt_fail", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail)), ("last-stdby-re-opt-fail", ("last_stdby_re_opt_fail", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail))])
                        self._leafs = OrderedDict()

                        self.current_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"

                        self.reopt_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"

                        self.gmpls_path_protect_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"

                        self.previous_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"

                        self.previous_gmpls_path_protect_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"

                        self.gmpls_other_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"

                        self.gmpls_other_protect_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"

                        self.standby_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"

                        self.standby_reopt_setup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"

                        self.last_re_opt_fail = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"

                        self.last_stdby_re_opt_fail = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._segment_path = lambda: "history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History, [], name, value)


                    class CurrentSetup(_Entity_):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:  :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes>`
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("connected-uptimes", ("connected_uptimes", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes))])
                            self._leafs = OrderedDict([
                                ('current_setup_timer', (YLeaf(YType.uint32, 'current-setup-timer'), ['int'])),
                                ('selection_reason', (YLeaf(YType.str, 'selection-reason'), ['str'])),
                                ('current_setup_last_error', (YLeaf(YType.str, 'current-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.current_setup_timer = None
                            self.selection_reason = None
                            self.current_setup_last_error = None
                            self.protection_role = None

                            self.connected_uptimes = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._segment_path = lambda: "current-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, ['current_setup_timer', 'selection_reason', 'current_setup_last_error', 'protection_role'], name, value)


                        class ConnectedUptimes(_Entity_):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('current_lsp_uptime', (YLeaf(YType.uint32, 'current-lsp-uptime'), ['int'])),
                                    ('current_uptime', (YLeaf(YType.uint32, 'current-uptime'), ['int'])),
                                ])
                                self.current_lsp_uptime = None
                                self.current_uptime = None
                                self._segment_path = lambda: "connected-uptimes"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, ['current_lsp_uptime', 'current_uptime'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup']['meta_info']


                    class ReoptSetup(_Entity_):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup']['meta_info']


                    class GmplsPathProtectSetup(_Entity_):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protecting_setup_uptime', (YLeaf(YType.uint32, 'protecting-setup-uptime'), ['int'])),
                                ('protecting_setup_timer', (YLeaf(YType.uint32, 'protecting-setup-timer'), ['int'])),
                                ('protecting_setup_last_error', (YLeaf(YType.str, 'protecting-setup-last-error'), ['str'])),
                            ])
                            self.protecting_setup_uptime = None
                            self.protecting_setup_timer = None
                            self.protecting_setup_last_error = None
                            self._segment_path = lambda: "gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, ['protecting_setup_uptime', 'protecting_setup_timer', 'protecting_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup']['meta_info']


                    class PreviousSetup(_Entity_):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_path_option', (YLeaf(YType.str, 'previous-path-option'), ['str'])),
                                ('previous_tunnel_instance', (YLeaf(YType.uint32, 'previous-tunnel-instance'), ['int'])),
                                ('previous_fail_reason', (YLeaf(YType.str, 'previous-fail-reason'), ['str'])),
                                ('previous_setup_last_error', (YLeaf(YType.str, 'previous-setup-last-error'), ['str'])),
                            ])
                            self.previous_path_option = None
                            self.previous_tunnel_instance = None
                            self.previous_fail_reason = None
                            self.previous_setup_last_error = None
                            self._segment_path = lambda: "previous-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, ['previous_path_option', 'previous_tunnel_instance', 'previous_fail_reason', 'previous_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup']['meta_info']


                    class PreviousGmplsPathProtectSetup(_Entity_):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_protect_path_option', (YLeaf(YType.str, 'previous-protect-path-option'), ['str'])),
                                ('previous_protect_tunnel_instance', (YLeaf(YType.uint32, 'previous-protect-tunnel-instance'), ['int'])),
                                ('previous_protect_fail_reason', (YLeaf(YType.str, 'previous-protect-fail-reason'), ['str'])),
                                ('previous_protect_setup_last_error', (YLeaf(YType.str, 'previous-protect-setup-last-error'), ['str'])),
                            ])
                            self.previous_protect_path_option = None
                            self.previous_protect_tunnel_instance = None
                            self.previous_protect_fail_reason = None
                            self.previous_protect_setup_last_error = None
                            self._segment_path = lambda: "previous-gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, ['previous_protect_path_option', 'previous_protect_tunnel_instance', 'previous_protect_fail_reason', 'previous_protect_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup']['meta_info']


                    class GmplsOtherSetup(_Entity_):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup']['meta_info']


                    class GmplsOtherProtectSetup(_Entity_):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup']['meta_info']


                    class StandbySetup(_Entity_):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('standby_lsp_uptime', (YLeaf(YType.uint32, 'standby-lsp-uptime'), ['int'])),
                                ('standby_setup_timer', (YLeaf(YType.uint32, 'standby-setup-timer'), ['int'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.standby_lsp_uptime = None
                            self.standby_setup_timer = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup, ['standby_lsp_uptime', 'standby_setup_timer', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup']['meta_info']


                    class StandbyReoptSetup(_Entity_):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup']['meta_info']


                    class LastReOptFail(_Entity_):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail']['meta_info']


                    class LastStdbyReOptFail(_Entity_):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-stdby-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.History']['meta_info']


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection']['meta_info']


                class AutoBackup(_Entity_):
                    """
                    Autobackup Information
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:  :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of  		 :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("weighted-srlg-info", ("weighted_srlg_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo)), ("iep", ("iep", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep))])
                        self._leafs = OrderedDict([
                            ('protected_ls_ps', (YLeaf(YType.uint32, 'protected-ls-ps'), ['int'])),
                            ('protected_s2_ls', (YLeaf(YType.uint32, 'protected-s2-ls'), ['int'])),
                            ('sharing_families', (YLeaf(YType.uint32, 'sharing-families'), ['int'])),
                            ('ab_protection_type', (YLeaf(YType.enumeration, 'ab-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('is_using_srlg', (YLeaf(YType.boolean, 'is-using-srlg'), ['bool'])),
                            ('srlg_prot_type', (YLeaf(YType.enumeration, 'srlg-prot-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('ab_protected_interface', (YLeaf(YType.str, 'ab-protected-interface'), ['str'])),
                            ('protected_address', (YLeaf(YType.str, 'protected-address'), ['str'])),
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('is_unused_removal_timer_running', (YLeaf(YType.boolean, 'is-unused-removal-timer-running'), ['bool'])),
                            ('unused_removal_remaining_time', (YLeaf(YType.uint32, 'unused-removal-remaining-time'), ['int'])),
                        ])
                        self.protected_ls_ps = None
                        self.protected_s2_ls = None
                        self.sharing_families = None
                        self.ab_protection_type = None
                        self.is_using_srlg = None
                        self.srlg_prot_type = None
                        self.ab_protected_interface = None
                        self.protected_address = None
                        self.tunnel_attribute_set_name = None
                        self.is_unused_removal_timer_running = None
                        self.unused_removal_remaining_time = None

                        self.weighted_srlg_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"

                        self.iep = YList(self)
                        self._segment_path = lambda: "auto-backup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup, ['protected_ls_ps', 'protected_s2_ls', 'sharing_families', 'ab_protection_type', 'is_using_srlg', 'srlg_prot_type', 'ab_protected_interface', 'protected_address', 'tunnel_attribute_set_name', 'is_unused_removal_timer_running', 'unused_removal_remaining_time'], name, value)


                    class WeightedSrlgInfo(_Entity_):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of  		 :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of  		 :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protected-interface-srlg", ("protected_interface_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg)), ("weighted-srlg-hop", ("weighted_srlg_hop", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop))])
                            self._leafs = OrderedDict()

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)
                            self._segment_path = lambda: "weighted-srlg-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, [], name, value)


                        class ProtectedInterfaceSrlg(_Entity_):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('srlg', (YLeaf(YType.uint32, 'srlg'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                                ])
                                self.srlg = None
                                self.srlg_name = None
                                self.admin_weight = None
                                self._segment_path = lambda: "protected-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, ['srlg', 'srlg_name', 'admin_weight'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg']['meta_info']


                        class WeightedSrlgHop(_Entity_):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of  		 :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("common-srlg", ("common_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg))])
                                self._leafs = OrderedDict([
                                    ('from_address', (YLeaf(YType.str, 'from-address'), ['str'])),
                                    ('to_address', (YLeaf(YType.str, 'to-address'), ['str'])),
                                    ('aggregate_admin_weight', (YLeaf(YType.uint64, 'aggregate-admin-weight'), ['int'])),
                                ])
                                self.from_address = None
                                self.to_address = None
                                self.aggregate_admin_weight = None

                                self.common_srlg = YList(self)
                                self._segment_path = lambda: "weighted-srlg-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, ['from_address', 'to_address', 'aggregate_admin_weight'], name, value)


                            class CommonSrlg(_Entity_):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	Common SRLG between this hop and the protected  interface
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "common-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo']['meta_info']


                    class Iep(_Entity_):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of  		 :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("iep-hop", ("iep_hop", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop))])
                            self._leafs = OrderedDict([
                                ('path_option_id', (YLeaf(YType.uint32, 'path-option-id'), ['int'])),
                            ])
                            self.path_option_id = None

                            self.iep_hop = YList(self)
                            self._segment_path = lambda: "iep"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, ['path_option_id'], name, value)


                        class IepHop(_Entity_):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:  :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('hop_index', (YLeaf(YType.uint32, 'hop-index'), ['int'])),
                                    ('iep_hop_type', (YLeaf(YType.enumeration, 'iep-hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIepHop', '')])),
                                    ('iep_hop_address', (YLeaf(YType.str, 'iep-hop-address'), ['str'])),
                                ])
                                self.hop_index = None
                                self.iep_hop_type = None
                                self.iep_hop_address = None
                                self._segment_path = lambda: "iep-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, ['hop_index', 'iep_hop_type', 'iep_hop_address'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup']['meta_info']


                class AutoMesh(_Entity_):
                    """
                    Automesh Information
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('tunnel_destination_list_name', (YLeaf(YType.str, 'tunnel-destination-list-name'), ['str'])),
                            ('is_tunnel_unused_timer_running', (YLeaf(YType.boolean, 'is-tunnel-unused-timer-running'), ['bool'])),
                            ('remaining_unused_time', (YLeaf(YType.uint32, 'remaining-unused-time'), ['int'])),
                            ('mesh_group_type', (YLeaf(YType.enumeration, 'mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.tunnel_destination_list_name = None
                        self.is_tunnel_unused_timer_running = None
                        self.remaining_unused_time = None
                        self.mesh_group_type = None
                        self._segment_path = lambda: "auto-mesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh, ['mesh_group_id', 'tunnel_destination_list_name', 'is_tunnel_unused_timer_running', 'remaining_unused_time', 'mesh_group_type'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh']['meta_info']


                class AutoPcc(_Entity_):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('creator_address', (YLeaf(YType.str, 'creator-address'), ['str'])),
                            ('has_creator_id', (YLeaf(YType.boolean, 'has-creator-id'), ['bool'])),
                            ('creator_id', (YLeaf(YType.str, 'creator-id'), ['str'])),
                            ('plspid', (YLeaf(YType.uint32, 'plspid'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.owner_address = None
                        self.creator_address = None
                        self.has_creator_id = None
                        self.creator_id = None
                        self.plspid = None
                        self.symbolic_name = None
                        self.operationally_up = None
                        self._segment_path = lambda: "auto-pcc"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc, ['owner_address', 'creator_address', 'has_creator_id', 'creator_id', 'plspid', 'symbolic_name', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc']['meta_info']


                class PceDelegation(_Entity_):
                    """
                    PCE Delegation information
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('plsp_id', (YLeaf(YType.uint32, 'plsp-id'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.plsp_id = None
                        self.symbolic_name = None
                        self.owner_address = None
                        self.operationally_up = None
                        self._segment_path = lambda: "pce-delegation"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation, ['plsp_id', 'symbolic_name', 'owner_address', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation']['meta_info']


                class SoftPreemption(_Entity_):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:  :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:  :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of  		 :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("soft-preemption-counters", ("soft_preemption_counters", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters)), ("soft-preemption-path-error", ("soft_preemption_path_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError))])
                        self._leafs = OrderedDict([
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                            ('time_in_preemption_pending', (YLeaf(YType.uint16, 'time-in-preemption-pending'), ['int'])),
                            ('preemption_pending_resolution', (YLeaf(YType.enumeration, 'preemption-pending-resolution'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionResolution', '')])),
                        ])
                        self.status = None
                        self.time_in_preemption_pending = None
                        self.preemption_pending_resolution = None

                        self.soft_preemption_counters = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"

                        self.soft_preemption_path_error = YList(self)
                        self._segment_path = lambda: "soft-preemption"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption, ['status', 'time_in_preemption_pending', 'preemption_pending_resolution'], name, value)


                    class SoftPreemptionCounters(_Entity_):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                                ('reopt_completed_ls_ps', (YLeaf(YType.uint32, 'reopt-completed-ls-ps'), ['int'])),
                                ('torn_down_ls_ps', (YLeaf(YType.uint32, 'torn-down-ls-ps'), ['int'])),
                                ('path_protection_switchover_ls_ps', (YLeaf(YType.uint32, 'path-protection-switchover-ls-ps'), ['int'])),
                                ('frr_triggered_ls_ps', (YLeaf(YType.uint32, 'frr-triggered-ls-ps'), ['int'])),
                                ('time_in_preemption_pending_min', (YLeaf(YType.uint16, 'time-in-preemption-pending-min'), ['int'])),
                                ('time_in_preemption_pending_max', (YLeaf(YType.uint16, 'time-in-preemption-pending-max'), ['int'])),
                                ('time_in_preemption_pending_avg', (YLeaf(YType.uint16, 'time-in-preemption-pending-avg'), ['int'])),
                            ])
                            self.soft_preemption_events = None
                            self.reopt_completed_ls_ps = None
                            self.torn_down_ls_ps = None
                            self.path_protection_switchover_ls_ps = None
                            self.frr_triggered_ls_ps = None
                            self.time_in_preemption_pending_min = None
                            self.time_in_preemption_pending_max = None
                            self.time_in_preemption_pending_avg = None
                            self._segment_path = lambda: "soft-preemption-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, ['soft_preemption_events', 'reopt_completed_ls_ps', 'torn_down_ls_ps', 'path_protection_switchover_ls_ps', 'frr_triggered_ls_ps', 'time_in_preemption_pending_min', 'time_in_preemption_pending_max', 'time_in_preemption_pending_avg'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters']['meta_info']


                    class SoftPreemptionPathError(_Entity_):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                            ])
                            self.timestamp = None
                            self.preempting_link_address = None
                            self._segment_path = lambda: "soft-preemption-path-error"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, ['timestamp', 'preempting_link_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption']['meta_info']


                class WdmUnitunnel(_Entity_):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                            ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                            ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                            ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                            ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                        ])
                        self.tunnel_state = None
                        self.tunnel_role = None
                        self.tunnel_id = None
                        self.lsp_id = None
                        self.local_optical_router_id = None
                        self.remote_optical_router_id = None
                        self.controlled_interface = None
                        self.source_address = None
                        self.destination_address = None
                        self.extended_tunnel_id = None
                        self.label_origin = None
                        self.srlg_discovery = None
                        self._segment_path = lambda: "wdm-unitunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel']['meta_info']


                class TransportTunnelInfo(_Entity_):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn>`
                    
                    	**config**\: False
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:  :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:  :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of  		 :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of  		 :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn)), ("static-uni", ("static_uni", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni)), ("egress-static-uni", ("egress_static_uni", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni)), ("homepath-ero", ("homepath_ero", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo))])
                        self._leafs = OrderedDict([
                            ('status_homepath_working', (YLeaf(YType.boolean, 'status-homepath-working'), ['bool'])),
                        ])
                        self.status_homepath_working = None

                        self.otn = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"

                        self.static_uni = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"

                        self.egress_static_uni = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"

                        self.homepath_ero = YList(self)
                        self.diversity_info = YList(self)
                        self._segment_path = lambda: "transport-tunnel-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, ['status_homepath_working'], name, value)


                    class Otn(_Entity_):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:  :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        	**config**\: False
                        
                        .. attribute:: config_bit_rate
                        
                        	Configured OTN Bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-cfg", ("bandwidth_cfg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg))])
                            self._leafs = OrderedDict([
                                ('config_bit_rate', (YLeaf(YType.uint32, 'config-bit-rate'), ['int'])),
                            ])
                            self.config_bit_rate = None

                            self.bandwidth_cfg = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._segment_path = lambda: "otn"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, ['config_bit_rate'], name, value)


                        class BandwidthCfg(_Entity_):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes))])
                                self._leafs = OrderedDict([
                                    ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ])
                                self.odu_level = None

                                self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._segment_path = lambda: "bandwidth-cfg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, ['odu_level'], name, value)


                            class OduFlexCbr(_Entity_):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self.tolerance = None
                                    self._segment_path = lambda: "odu-flex-cbr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr']['meta_info']


                            class OduFlexGfpFRes(_Entity_):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes']['meta_info']


                            class OduFlexGfpFNonRes(_Entity_):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn']['meta_info']


                    class StaticUni(_Entity_):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: term_interface_srlg
                        
                        	Termination Interface SRLG
                        	**type**\:  :py:class:`TermInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("term-interface-srlg", ("term_interface_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg))])
                            self._leafs = OrderedDict([
                                ('client_port', (YLeaf(YType.str, 'client-port'), ['str'])),
                                ('client_if_handle', (YLeaf(YType.str, 'client-if-handle'), ['str'])),
                                ('client_odu_name', (YLeaf(YType.str, 'client-odu-name'), ['str'])),
                                ('client_odu_if_handle', (YLeaf(YType.str, 'client-odu-if-handle'), ['str'])),
                                ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('static_uni_type', (YLeaf(YType.enumeration, 'static-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                                ('term_client_port', (YLeaf(YType.str, 'term-client-port'), ['str'])),
                                ('term_client_if_handle', (YLeaf(YType.str, 'term-client-if-handle'), ['str'])),
                            ])
                            self.client_port = None
                            self.client_if_handle = None
                            self.client_odu_name = None
                            self.client_odu_if_handle = None
                            self.cross_connect_id = None
                            self.is_connected = None
                            self.uptime = None
                            self.local_termination = None
                            self.static_uni_type = None
                            self.term_client_port = None
                            self.term_client_if_handle = None

                            self.term_interface_srlg = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg()
                            self.term_interface_srlg.parent = self
                            self._children_name_map["term_interface_srlg"] = "term-interface-srlg"
                            self._segment_path = lambda: "static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, ['client_port', 'client_if_handle', 'client_odu_name', 'client_odu_if_handle', 'cross_connect_id', 'is_connected', 'uptime', 'local_termination', 'static_uni_type', 'term_client_port', 'term_client_if_handle'], name, value)


                        class TermInterfaceSrlg(_Entity_):
                            """
                            Termination Interface SRLG
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLG
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, self).__init__()

                                self.yang_name = "term-interface-srlg"
                                self.yang_parent_name = "static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg))])
                                self._leafs = OrderedDict()

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "term-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, [], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLG
                                
                                .. attribute:: entry
                                
                                	Discovered SRLG
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "term-interface-srlg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni']['meta_info']


                    class EgressStaticUni(_Entity_):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:  :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:  :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("egress-port", ("egress_port", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort)), ("term-egress-port", ("term_egress_port", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort))])
                            self._leafs = OrderedDict([
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('remote_uni_type', (YLeaf(YType.enumeration, 'remote-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                            ])
                            self.local_termination = None
                            self.remote_uni_type = None

                            self.egress_port = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"

                            self.term_egress_port = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._segment_path = lambda: "egress-static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, ['local_termination', 'remote_uni_type'], name, value)


                        class EgressPort(_Entity_):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort']['meta_info']


                        class TermEgressPort(_Entity_):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "term-egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni']['meta_info']


                    class HomepathEro(_Entity_):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "homepath-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ])
                            self.tunnel_id = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, ['tunnel_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo']['meta_info']


                class BfdInfo(_Entity_):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:  :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of  		 :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("event-counters", ("event_counters", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters)), ("dampening-info", ("dampening_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo))])
                        self._leafs = OrderedDict([
                            ('bfd_session_up', (YLeaf(YType.boolean, 'bfd-session-up'), ['bool'])),
                            ('session_up_time', (YLeaf(YType.uint32, 'session-up-time'), ['int'])),
                            ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                            ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                            ('minimum_session_up_interval', (YLeaf(YType.uint32, 'minimum-session-up-interval'), ['int'])),
                            ('maximum_session_up_interval', (YLeaf(YType.uint32, 'maximum-session-up-interval'), ['int'])),
                        ])
                        self.bfd_session_up = None
                        self.session_up_time = None
                        self.failure_diagnostic_code = None
                        self.failure_reason = None
                        self.minimum_session_up_interval = None
                        self.maximum_session_up_interval = None

                        self.event_counters = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"

                        self.dampening_info = YList(self)
                        self._segment_path = lambda: "bfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo, ['bfd_session_up', 'session_up_time', 'failure_diagnostic_code', 'failure_reason', 'minimum_session_up_interval', 'maximum_session_up_interval'], name, value)


                    class EventCounters(_Entity_):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                                ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                                ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                                ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                                ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                                ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                                ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                                ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                                ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                            ])
                            self.session_create_events = None
                            self.session_up_events = None
                            self.session_creation_failed_events = None
                            self.session_down_events = None
                            self.session_admin_down_events = None
                            self.session_gracefully_delete_events = None
                            self.session_non_gracefully_delete_events = None
                            self.session_create_timeout_events = None
                            self.session_replay_events = None
                            self._segment_path = lambda: "event-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters']['meta_info']


                    class DampeningInfo(_Entity_):
                        """
                        Path option dampening info
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('hold_down_time', (YLeaf(YType.uint32, 'hold-down-time'), ['int'])),
                                ('remained_time', (YLeaf(YType.uint32, 'remained-time'), ['int'])),
                                ('backoff_count', (YLeaf(YType.uint32, 'backoff-count'), ['int'])),
                            ])
                            self.option_index = None
                            self.hold_down_time = None
                            self.remained_time = None
                            self.backoff_count = None
                            self._segment_path = lambda: "dampening-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, ['option_index', 'hold_down_time', 'remained_time', 'backoff_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo']['meta_info']


                class OtnBidir(_Entity_):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:  :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("aps", ("aps", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps)), ("restoration", ("restoration", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration))])
                        self._leafs = OrderedDict()

                        self.aps = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"

                        self.restoration = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._segment_path = lambda: "otn-bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir, [], name, value)


                    class Aps(_Entity_):
                        """
                        APS Protection Info
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:  :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protection-profile", ("protection_profile", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile))])
                            self._leafs = OrderedDict([
                                ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.active_lsp = None
                            self.diversity_type = None

                            self.protection_profile = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._segment_path = lambda: "aps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, ['active_lsp', 'diversity_type'], name, value)


                        class ProtectionProfile(_Entity_):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "protection-profile"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps']['meta_info']


                    class Restoration(_Entity_):
                        """
                        Restoration Info
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        	**config**\: False
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('revert_option', (YLeaf(YType.enumeration, 'revert-option'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                ('diverse_lsp', (YLeaf(YType.enumeration, 'diverse-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.revert_option = None
                            self.diverse_lsp = None
                            self.diversity_type = None
                            self._segment_path = lambda: "restoration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, ['revert_option', 'diverse_lsp', 'diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir']['meta_info']


                class Bidir(_Entity_):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:  :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reverse-ero-error-current", ("reverse_ero_error_current", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent)), ("reverse-ero-error-reopt", ("reverse_ero_error_reopt", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt)), ("reverse-ero-error-standby", ("reverse_ero_error_standby", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby)), ("reverse-ero-error-standby-reopt", ("reverse_ero_error_standby_reopt", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt))])
                        self._leafs = OrderedDict([
                            ('reverse_bandwidth', (YLeaf(YType.uint32, 'reverse-bandwidth'), ['int'])),
                            ('reverse_bandwidth_standby', (YLeaf(YType.uint32, 'reverse-bandwidth-standby'), ['int'])),
                        ])
                        self.reverse_bandwidth = None
                        self.reverse_bandwidth_standby = None

                        self.reverse_ero_error_current = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"

                        self.reverse_ero_error_reopt = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"

                        self.reverse_ero_error_standby = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"

                        self.reverse_ero_error_standby_reopt = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._segment_path = lambda: "bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir, ['reverse_bandwidth', 'reverse_bandwidth_standby'], name, value)


                    class ReverseEroErrorCurrent(_Entity_):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-current"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent']['meta_info']


                    class ReverseEroErrorReopt(_Entity_):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt']['meta_info']


                    class ReverseEroErrorStandby(_Entity_):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby']['meta_info']


                    class ReverseEroErrorStandbyReopt(_Entity_):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir']['meta_info']


                class XroAttributeSet(_Entity_):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion))])
                        self._leafs = OrderedDict([
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                        ])
                        self.tunnel_attribute_set_name = None
                        self.tunnel_attribute_set_name_crc32 = None

                        self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._segment_path = lambda: "xro-attribute-set"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                    class AttributeSetUnion(_Entity_):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                            self._leafs = OrderedDict([
                                ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                            ])
                            self.tunnel_attribute_set_type = None

                            self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                            self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                            self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                            self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                            self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                            self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                            self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._segment_path = lambda: "attribute-set-union"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                        class AttributeSetPathOption(_Entity_):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_delay_limit_configured
                            
                            	Is Delay Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: delay_limit
                            
                            	Delay limit on the tunnel path (usec) When delay limit is configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                    ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                    ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                    ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                    ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                ])
                                self.configured_bandwidth = None
                                self.cost_limit = None
                                self.dste_class_type = None
                                self.bandwidth_type = None
                                self.is_bandwidth_configured = None
                                self.is_cost_limit_configured = None
                                self.is_affinity_configured = None
                                self.generation = None
                                self.path_invalidation_timeout = None
                                self.path_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.exclude_list_name = None
                                self.is_exclude_list_name_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None
                                self.is_bfd_reverse_pat_configured = None
                                self.is_delay_limit_configured = None
                                self.delay_limit = None

                                self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)
                                self._segment_path = lambda: "attribute-set-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                            class BfdReversePath(_Entity_):
                                """
                                BFD reverse path
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                	**config**\: False
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                    ])
                                    self.path_type = None
                                    self.binding_label = None
                                    self._segment_path = lambda: "bfd-reverse-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                            class VersionInfo(_Entity_):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                        ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                    ])
                                    self.attribute_type = None
                                    self.generation = None
                                    self.is_default = None
                                    self._segment_path = lambda: "version-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                        class AttributeSetAutobackup(_Entity_):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                self._leafs = OrderedDict([
                                    ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ])
                                self.is_signalled_name_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.is_affinity_configured = None
                                self.record_route = None

                                self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"

                                self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)
                                self.protected_interface = YList(self)
                                self._segment_path = lambda: "attribute-set-autobackup"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                            class SignalledName(_Entity_):
                                """
                                Signalled name
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                    ])
                                    self.name = None
                                    self.source_type = None
                                    self.protected_interface_type = None
                                    self.is_mp_addresses = None
                                    self._segment_path = lambda: "signalled-name"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                            class ProtectedInterface(_Entity_):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                    ])
                                    self.protected_interface = None
                                    self._segment_path = lambda: "protected-interface"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                        class AttributeSetAutomesh(_Entity_):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_forward_class_configured
                            
                            	True if forward\-class is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                    ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                    ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                    ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                    ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                    ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                    ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                ])
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.forward_class = None
                                self.is_forward_class_configured = None
                                self.is_affinity_configured = None
                                self.fast_reroute = None
                                self.frr_node_protection = None
                                self.frr_bandwidth_protection = None
                                self.record_route = None
                                self.auto_bandwidth_collect = None
                                self.auto_route_announce = None
                                self.soft_preemption_configured = None
                                self.bandwidth = None
                                self.load_share = None
                                self.is_interface_bw_configured = None

                                self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.mesh_group_id = YList(self)
                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-automesh"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                            class MeshGroupId(_Entity_):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	Meshgroup ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "mesh-group-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                        class AttributeSetXro(_Entity_):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                self._leafs = OrderedDict()

                                self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._segment_path = lambda: "attribute-set-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                            class Xro(_Entity_):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                    self._leafs = OrderedDict([
                                        ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                    ])
                                    self.mutual_diversity_flag = None

                                    self.xro_subobject = YList(self)
                                    self._segment_path = lambda: "xro"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                class XroSubobject(_Entity_):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                        ])
                                        self.type = None

                                        self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                        self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                        self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                        self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"

                                        self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                        self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._segment_path = lambda: "xro-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                    class Ipv4Subobject(_Entity_):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv4-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                    class Ipv6Subobject(_Entity_):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\: str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv6-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                    class UnnumberedSubobject(_Entity_):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.te_router_id = None
                                            self.interface_id = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "unnumbered-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                    class AsSubobject(_Entity_):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                            ])
                                            self.as_number = None
                                            self._segment_path = lambda: "as-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                    class SrlgSubobject(_Entity_):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.srlg_id = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "srlg-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                    class LspSubobject(_Entity_):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                            self._leafs = OrderedDict([
                                                ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.ignore_lsp_id = None
                                            self.processing_node_exception = None
                                            self.penultimate_node_exception = None
                                            self.destination_node_exception = None
                                            self.exclusion_type = None

                                            self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._segment_path = lambda: "lsp-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                        class Fec(_Entity_):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                self._leafs = OrderedDict([
                                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                ])
                                                self.fec_lsp_id = None
                                                self.fec_tunnel_id = None
                                                self.fec_extended_tunnel_id = None
                                                self.fec_source = None
                                                self.fec_vrf = None

                                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._segment_path = lambda: "fec"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                            class FecDestinationInfo(_Entity_):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                    ])
                                                    self.fec_ctype = None
                                                    self.p2p_lsp_destination = None
                                                    self.fec_destination_p2mp_id = None
                                                    self._segment_path = lambda: "fec-destination-info"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                        class AttributeSetP2mpte(_Entity_):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                ])
                                self.fast_reroute = None
                                self.frr_bandwidth_protection = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.is_affinity_configured = None

                                self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2mpte"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                        class AttributeSetApsPp(_Entity_):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "attribute-set-aps-pp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                        class AttributeSetP2pTe(_Entity_):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                    ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                    ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                    ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                    ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                    ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                    ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                    ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                    ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                    ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                ])
                                self.is_affinity_configured = None
                                self.path_selection_segment_routing_adjacency_protection = None
                                self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                self.path_invalidation_timeout = None
                                self.path_selection_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.path_selection_metric = None
                                self.is_path_selection_metric_configured = None
                                self.path_selection_segment_routing_margin = None
                                self.is_path_selection_segment_routing_margin_relative = None
                                self.is_path_selection_segment_routing_margin_configured = None
                                self.path_selection_segment_routing_segment_limit = None
                                self.is_path_selection_segment_routing_segment_limit_configured = None
                                self.is_path_select_configured = None
                                self.is_prepend_list_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None

                                self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2p-te"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                            class PrependList(_Entity_):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                    self._leafs = OrderedDict()

                                    self.prepend_entry = YList(self)
                                    self._segment_path = lambda: "prepend-list"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                class PrependEntry(_Entity_):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                            ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                            ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                        ])
                                        self.type = None
                                        self.index = None
                                        self.next_label = None
                                        self._segment_path = lambda: "prepend-entry"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet']['meta_info']


                class TeTunnelConvergence(_Entity_):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("convergence-lsp", ("convergence_lsp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp))])
                        self._leafs = OrderedDict([
                            ('is_convergence_in_progress', (YLeaf(YType.boolean, 'is-convergence-in-progress'), ['bool'])),
                            ('frr_trigger_time', (YLeaf(YType.uint64, 'frr-trigger-time'), ['int'])),
                            ('pcalc_complete_time', (YLeaf(YType.uint64, 'pcalc-complete-time'), ['int'])),
                            ('convergence_complete_time', (YLeaf(YType.uint64, 'convergence-complete-time'), ['int'])),
                            ('binding_label_rewrite_time', (YLeaf(YType.uint64, 'binding-label-rewrite-time'), ['int'])),
                            ('vif_creation_time', (YLeaf(YType.uint64, 'vif-creation-time'), ['int'])),
                        ])
                        self.is_convergence_in_progress = None
                        self.frr_trigger_time = None
                        self.pcalc_complete_time = None
                        self.convergence_complete_time = None
                        self.binding_label_rewrite_time = None
                        self.vif_creation_time = None

                        self.convergence_lsp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._segment_path = lambda: "te-tunnel-convergence"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, ['is_convergence_in_progress', 'frr_trigger_time', 'pcalc_complete_time', 'convergence_complete_time', 'binding_label_rewrite_time', 'vif_creation_time'], name, value)


                    class ConvergenceLsp(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "convergence-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence']['meta_info']


                class FlexInfo(_Entity_):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:  :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                            ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                            ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                            ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                            ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ('fault_in_label', (YLeaf(YType.uint32, 'fault-in-label'), ['int'])),
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_timestamp', (YLeaf(YType.uint32, 'lockout-timestamp'), ['int'])),
                            ('lockout_lsp_id', (YLeaf(YType.uint16, 'lockout-lsp-id'), ['int'])),
                            ('origination', (YLeaf(YType.enumeration, 'origination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FlexLspLockoutOrigination', '')])),
                        ])
                        self.fault_ldi_lockout = None
                        self.fault_ldi = None
                        self.fault_lkr = None
                        self.fault_ais = None
                        self.fault_time = None
                        self.fault_in_label = None
                        self.is_lockout = None
                        self.lockout_timestamp = None
                        self.lockout_lsp_id = None
                        self.origination = None
                        self._segment_path = lambda: "flex-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo, ['fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time', 'fault_in_label', 'is_lockout', 'lockout_timestamp', 'lockout_lsp_id', 'origination'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo']['meta_info']


                class Destination(_Entity_):
                    """
                    Destinations array
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:  :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:  :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionCause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of  		 :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of  		 :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("inter-area-reoptimization", ("inter_area_reoptimization", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization)), ("path-option-entry", ("path_option_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry)), ("path-option", ("path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('destination_state', (YLeaf(YType.enumeration, 'destination-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeDestinationState', '')])),
                            ('active_path_option_index', (YLeaf(YType.uint32, 'active-path-option-index'), ['int'])),
                            ('path_option_exhausted', (YLeaf(YType.boolean, 'path-option-exhausted'), ['bool'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('path_change_time', (YLeaf(YType.uint32, 'path-change-time'), ['int'])),
                            ('total_uptime', (YLeaf(YType.uint32, 'total-uptime'), ['int'])),
                            ('s2l_exist', (YLeaf(YType.boolean, 's2l-exist'), ['bool'])),
                            ('destination_deletion_cause', (YLeaf(YType.enumeration, 'destination-deletion-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionCause', '')])),
                            ('destination_deletion_sub_cause', (YLeaf(YType.enumeration, 'destination-deletion-sub-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ('destination_deletion_timestamp', (YLeaf(YType.uint32, 'destination-deletion-timestamp'), ['int'])),
                            ('is_inter_area', (YLeaf(YType.boolean, 'is-inter-area'), ['bool'])),
                        ])
                        self.destination_address = None
                        self.destination_state = None
                        self.active_path_option_index = None
                        self.path_option_exhausted = None
                        self.uptime = None
                        self.path_change_time = None
                        self.total_uptime = None
                        self.s2l_exist = None
                        self.destination_deletion_cause = None
                        self.destination_deletion_sub_cause = None
                        self.destination_deletion_timestamp = None
                        self.is_inter_area = None

                        self.inter_area_reoptimization = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"

                        self.path_option_entry = YList(self)
                        self.path_option = YList(self)
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination, ['destination_address', 'destination_state', 'active_path_option_index', 'path_option_exhausted', 'uptime', 'path_change_time', 'total_uptime', 's2l_exist', 'destination_deletion_cause', 'destination_deletion_sub_cause', 'destination_deletion_timestamp', 'is_inter_area'], name, value)


                    class InterAreaReoptimization(_Entity_):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sent_path_queries', (YLeaf(YType.uint16, 'sent-path-queries'), ['int'])),
                                ('time_since_last_query_sent', (YLeaf(YType.uint32, 'time-since-last-query-sent'), ['int'])),
                                ('received_preferred_path_errors', (YLeaf(YType.uint16, 'received-preferred-path-errors'), ['int'])),
                                ('time_since_last_preferred_path_error', (YLeaf(YType.uint32, 'time-since-last-preferred-path-error'), ['int'])),
                                ('received_preferred_tree_errors', (YLeaf(YType.uint16, 'received-preferred-tree-errors'), ['int'])),
                                ('time_since_last_preferred_tree_error', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-error'), ['int'])),
                                ('preferred_path_error_node', (YLeaf(YType.str, 'preferred-path-error-node'), ['str'])),
                                ('preferred_tree_error_node', (YLeaf(YType.str, 'preferred-tree-error-node'), ['str'])),
                            ])
                            self.sent_path_queries = None
                            self.time_since_last_query_sent = None
                            self.received_preferred_path_errors = None
                            self.time_since_last_preferred_path_error = None
                            self.received_preferred_tree_errors = None
                            self.time_since_last_preferred_tree_error = None
                            self.preferred_path_error_node = None
                            self.preferred_tree_error_node = None
                            self._segment_path = lambda: "inter-area-reoptimization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, ['sent_path_queries', 'time_since_last_query_sent', 'received_preferred_path_errors', 'time_since_last_preferred_path_error', 'received_preferred_tree_errors', 'time_since_last_preferred_tree_error', 'preferred_path_error_node', 'preferred_tree_error_node'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization']['meta_info']


                    class PathOptionEntry(_Entity_):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry']['meta_info']


                    class PathOption(_Entity_):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels.NniTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2pP2mpTunnel.NniTunnels']['meta_info']


        class TunnelHeads(_Entity_):
            """
            Restrict display to P2P or P2MP head tunnels
            
            .. attribute:: tunnel_head
            
            	mpls te p2p or p2mp tunnels
            	**type**\: list of  		 :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2pP2mpTunnel.TunnelHeads, self).__init__()

                self.yang_name = "tunnel-heads"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-head", ("tunnel_head", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead))])
                self._leafs = OrderedDict()

                self.tunnel_head = YList(self)
                self._segment_path = lambda: "tunnel-heads"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads, [], name, value)


            class TunnelHead(_Entity_):
                """
                mpls te p2p or p2mp tunnels
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config>`
                
                	**config**\: False
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:  :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:  :py:class:`ReoptimizedP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:  :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:  :py:class:`ReoptimizedStandbyP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:  :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp>`
                
                	**config**\: False
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:  :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp>`
                
                	**config**\: False
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:  :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp>`
                
                	**config**\: False
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo>`
                
                	**config**\: False
                
                .. attribute:: auto_capacity
                
                	Auto\-capacity Info
                	**type**\:  :py:class:`AutoCapacity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity>`
                
                	**config**\: False
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:  :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History>`
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:  :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup>`
                
                	**config**\: False
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:  :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh>`
                
                	**config**\: False
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:  :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc>`
                
                	**config**\: False
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:  :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation>`
                
                	**config**\: False
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption>`
                
                	**config**\: False
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:  :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel>`
                
                	**config**\: False
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:  :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo>`
                
                	**config**\: False
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:  :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo>`
                
                	**config**\: False
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:  :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir>`
                
                	**config**\: False
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:  :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:  :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence>`
                
                	**config**\: False
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo>`
                
                	**config**\: False
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:  :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                	**config**\: False
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                	**config**\: False
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:  :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                	**config**\: False
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:  :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                	**config**\: False
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                	**config**\: False
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                	**config**\: False
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:  :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:  :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                	**config**\: False
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_working_lsp_id
                
                	LSP\-id of last working LSP
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead, self).__init__()

                    self.yang_name = "tunnel-head"
                    self.yang_parent_name = "tunnel-heads"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("config", ("config", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config)), ("tunnel-current-lsp", ("tunnel_current_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp)), ("reoptimized-p2mp-lsp", ("reoptimized_p2mp_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp)), ("tunnel-standby-lsp", ("tunnel_standby_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp)), ("reoptimized-standby-p2mp-lsp", ("reoptimized_standby_p2mp_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp)), ("tunnel-restoration-lsp", ("tunnel_restoration_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp)), ("delay-clean-pp-lsp", ("delay_clean_pp_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp)), ("cleaned-lsp", ("cleaned_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp)), ("p2p-info", ("p2p_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo)), ("auto-capacity", ("auto_capacity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity)), ("history", ("history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History)), ("path-protection", ("path_protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection)), ("auto-backup", ("auto_backup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup)), ("auto-mesh", ("auto_mesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh)), ("auto-pcc", ("auto_pcc", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc)), ("pce-delegation", ("pce_delegation", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption)), ("wdm-unitunnel", ("wdm_unitunnel", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel)), ("transport-tunnel-info", ("transport_tunnel_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo)), ("bfd-info", ("bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo)), ("otn-bidir", ("otn_bidir", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir)), ("bidir", ("bidir", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet)), ("te-tunnel-convergence", ("te_tunnel_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo)), ("destination", ("destination", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('role_standby', (YLeaf(YType.boolean, 'role-standby'), ['bool'])),
                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                        ('admin_state', (YLeaf(YType.enumeration, 'admin-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelAdminState', '')])),
                        ('operational_state', (YLeaf(YType.enumeration, 'operational-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                        ('operational_state_changes', (YLeaf(YType.uint32, 'operational-state-changes'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('fail_reason', (YLeaf(YType.enumeration, 'fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsMteTunnelFailReason', '')])),
                        ('destination_up_count', (YLeaf(YType.uint32, 'destination-up-count'), ['int'])),
                        ('destination_disabled_count', (YLeaf(YType.uint32, 'destination-disabled-count'), ['int'])),
                        ('destination_down_count', (YLeaf(YType.uint32, 'destination-down-count'), ['int'])),
                        ('re_opt_hold_down_timer_remaining', (YLeaf(YType.uint32, 're-opt-hold-down-timer-remaining'), ['int'])),
                        ('bandwidth_requested', (YLeaf(YType.uint32, 'bandwidth-requested'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                        ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                        ('tunnel_recovering', (YLeaf(YType.boolean, 'tunnel-recovering'), ['bool'])),
                        ('reroute_pending', (YLeaf(YType.boolean, 'reroute-pending'), ['bool'])),
                        ('explicit_path_change', (YLeaf(YType.boolean, 'explicit-path-change'), ['bool'])),
                        ('path_option_change', (YLeaf(YType.boolean, 'path-option-change'), ['bool'])),
                        ('affinity_failure_reopt_disabled', (YLeaf(YType.boolean, 'affinity-failure-reopt-disabled'), ['bool'])),
                        ('affinity_failure_reopt_time_remained', (YLeaf(YType.uint32, 'affinity-failure-reopt-time-remained'), ['int'])),
                        ('affinity_failure_delayed_tear_time_remained', (YLeaf(YType.uint32, 'affinity-failure-delayed-tear-time-remained'), ['int'])),
                        ('invalidation_time_remained', (YLeaf(YType.uint32, 'invalidation-time-remained'), ['int'])),
                        ('drop_mode', (YLeaf(YType.boolean, 'drop-mode'), ['bool'])),
                        ('auto_route', (YLeaf(YType.boolean, 'auto-route'), ['bool'])),
                        ('forwarding_adjacency', (YLeaf(YType.boolean, 'forwarding-adjacency'), ['bool'])),
                        ('load_share_factor', (YLeaf(YType.uint32, 'load-share-factor'), ['int'])),
                        ('load_share_type', (YLeaf(YType.enumeration, 'load-share-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLoadshare', '')])),
                        ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                        ('tie_breaker', (YLeaf(YType.enumeration, 'tie-breaker'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                        ('tiebreaker_type', (YLeaf(YType.uint32, 'tiebreaker-type'), ['int'])),
                        ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('metric_qualifier', (YLeaf(YType.enumeration, 'metric-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('is_hop_limit_ignore', (YLeaf(YType.boolean, 'is-hop-limit-ignore'), ['bool'])),
                        ('hop_limit_ignored_reason', (YLeaf(YType.enumeration, 'hop-limit-ignored-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeHopLimitIgnore', '')])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('pce_fail_reason', (YLeaf(YType.enumeration, 'pce-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePceFailReasons', '')])),
                        ('snmp_index', (YLeaf(YType.uint32, 'snmp-index'), ['int'])),
                        ('is_inter_area_tunnel', (YLeaf(YType.boolean, 'is-inter-area-tunnel'), ['bool'])),
                        ('is_auto_backup', (YLeaf(YType.boolean, 'is-auto-backup'), ['bool'])),
                        ('is_auto_pcc', (YLeaf(YType.boolean, 'is-auto-pcc'), ['bool'])),
                        ('is_pce_delegated', (YLeaf(YType.boolean, 'is-pce-delegated'), ['bool'])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                        ('xro_attribute_set_name', (YLeaf(YType.str, 'xro-attribute-set-name'), ['str'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('passive_tunnel_name', (YLeaf(YType.str, 'passive-tunnel-name'), ['str'])),
                        ('binding_label_exists', (YLeaf(YType.boolean, 'binding-label-exists'), ['bool'])),
                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                        ('last_hop_ifindex', (YLeaf(YType.uint32, 'last-hop-ifindex'), ['int'])),
                        ('is_named', (YLeaf(YType.boolean, 'is-named'), ['bool'])),
                        ('lsp_wrap_protection_enabled', (YLeaf(YType.boolean, 'lsp-wrap-protection-enabled'), ['bool'])),
                        ('lsp_wrap_label', (YLeaf(YType.uint32, 'lsp-wrap-label'), ['int'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('autoroute_announce_exclude_segment_routing', (YLeaf(YType.boolean, 'autoroute-announce-exclude-segment-routing'), ['bool'])),
                        ('last_working_lsp_id', (YLeaf(YType.uint16, 'last-working-lsp-id'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.role_standby = None
                    self.tunnel_interface_name = None
                    self.admin_state = None
                    self.operational_state = None
                    self.operational_state_changes = None
                    self.signaled_name = None
                    self.fail_reason = None
                    self.destination_up_count = None
                    self.destination_disabled_count = None
                    self.destination_down_count = None
                    self.re_opt_hold_down_timer_remaining = None
                    self.bandwidth_requested = None
                    self.bandwidth_type = None
                    self.is_node_protected = None
                    self.is_bandwidth_protect = None
                    self.tunnel_recovering = None
                    self.reroute_pending = None
                    self.explicit_path_change = None
                    self.path_option_change = None
                    self.affinity_failure_reopt_disabled = None
                    self.affinity_failure_reopt_time_remained = None
                    self.affinity_failure_delayed_tear_time_remained = None
                    self.invalidation_time_remained = None
                    self.drop_mode = None
                    self.auto_route = None
                    self.forwarding_adjacency = None
                    self.load_share_factor = None
                    self.load_share_type = None
                    self.create_time = None
                    self.uptime = None
                    self.metric_type = None
                    self.tie_breaker = None
                    self.tiebreaker_type = None
                    self.tiebreaker_qualifier = None
                    self.metric_qualifier = None
                    self.is_hop_limit_ignore = None
                    self.hop_limit_ignored_reason = None
                    self.outbound_frr_state = None
                    self.area_id = None
                    self.pce_fail_reason = None
                    self.snmp_index = None
                    self.is_inter_area_tunnel = None
                    self.is_auto_backup = None
                    self.is_auto_pcc = None
                    self.is_pce_delegated = None
                    self.tunnel_attribute_set_name = None
                    self.tunnel_attribute_set_type = None
                    self.xro_attribute_set_name = None
                    self.is_passive = None
                    self.passive_tunnel_name = None
                    self.binding_label_exists = None
                    self.binding_label = None
                    self.last_hop_ifindex = None
                    self.is_named = None
                    self.lsp_wrap_protection_enabled = None
                    self.lsp_wrap_label = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.autoroute_announce_exclude_segment_routing = None
                    self.last_working_lsp_id = None

                    self.config = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"

                    self.tunnel_current_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"

                    self.reoptimized_p2mp_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"

                    self.tunnel_standby_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"

                    self.reoptimized_standby_p2mp_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"

                    self.tunnel_restoration_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"

                    self.delay_clean_pp_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"

                    self.cleaned_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"

                    self.p2p_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"

                    self.auto_capacity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity()
                    self.auto_capacity.parent = self
                    self._children_name_map["auto_capacity"] = "auto-capacity"

                    self.history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"

                    self.path_protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.auto_backup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"

                    self.auto_mesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"

                    self.auto_pcc = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"

                    self.pce_delegation = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"

                    self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"

                    self.wdm_unitunnel = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"

                    self.transport_tunnel_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"

                    self.bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"

                    self.otn_bidir = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"

                    self.bidir = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"

                    self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                    self.te_tunnel_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"

                    self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"

                    self.destination = YList(self)
                    self._segment_path = lambda: "tunnel-head" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2p-p2mp-tunnel/tunnel-heads/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead, ['tunnel_name', 'role_standby', 'tunnel_interface_name', 'admin_state', 'operational_state', 'operational_state_changes', 'signaled_name', 'fail_reason', 'destination_up_count', 'destination_disabled_count', 'destination_down_count', 're_opt_hold_down_timer_remaining', 'bandwidth_requested', 'bandwidth_type', 'is_node_protected', 'is_bandwidth_protect', 'tunnel_recovering', 'reroute_pending', 'explicit_path_change', 'path_option_change', 'affinity_failure_reopt_disabled', 'affinity_failure_reopt_time_remained', 'affinity_failure_delayed_tear_time_remained', 'invalidation_time_remained', 'drop_mode', 'auto_route', 'forwarding_adjacency', 'load_share_factor', 'load_share_type', 'create_time', 'uptime', 'metric_type', 'tie_breaker', 'tiebreaker_type', 'tiebreaker_qualifier', 'metric_qualifier', 'is_hop_limit_ignore', 'hop_limit_ignored_reason', 'outbound_frr_state', 'area_id', 'pce_fail_reason', 'snmp_index', 'is_inter_area_tunnel', 'is_auto_backup', 'is_auto_pcc', 'is_pce_delegated', 'tunnel_attribute_set_name', 'tunnel_attribute_set_type', 'xro_attribute_set_name', 'is_passive', 'passive_tunnel_name', 'binding_label_exists', 'binding_label', 'last_hop_ifindex', 'is_named', 'lsp_wrap_protection_enabled', 'lsp_wrap_label', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'autoroute_announce_exclude_segment_routing', 'last_working_lsp_id'], name, value)


                class Config(_Entity_):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:  :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:  :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging configuration
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if Forward class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit_global
                    
                    	Global Delay Limit (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of  		 :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity)), ("bidirectional-config", ("bidirectional_config", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig)), ("bfd-config", ("bfd_config", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry)), ("autoroute-destination", ("autoroute_destination", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                            ('is_p2mp', (YLeaf(YType.boolean, 'is-p2mp'), ['bool'])),
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('interface_configured_bandwidth', (YLeaf(YType.uint32, 'interface-configured-bandwidth'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                            ('backup_bandwidth_flags', (YLeaf(YType.uint8, 'backup-bandwidth-flags'), ['int'])),
                            ('config_load_share', (YLeaf(YType.uint32, 'config-load-share'), ['int'])),
                            ('payload_type', (YLeaf(YType.uint16, 'payload-type'), ['int'])),
                            ('is_in_config', (YLeaf(YType.boolean, 'is-in-config'), ['bool'])),
                            ('explicit_null_imposition', (YLeaf(YType.boolean, 'explicit-null-imposition'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('is_backup_tunnel', (YLeaf(YType.boolean, 'is-backup-tunnel'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                            ('path_protection_enabled', (YLeaf(YType.boolean, 'path-protection-enabled'), ['bool'])),
                            ('hop_limit', (YLeaf(YType.uint8, 'hop-limit'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('cost_limit_global', (YLeaf(YType.uint32, 'cost-limit-global'), ['int'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                            ('delay_limit_global', (YLeaf(YType.uint32, 'delay-limit-global'), ['int'])),
                            ('path_invalidation_timeout_source', (YLeaf(YType.uint32, 'path-invalidation-timeout-source'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action_source', (YLeaf(YType.uint32, 'path-invalidation-action-source'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('soft_preempt', (YLeaf(YType.boolean, 'soft-preempt'), ['bool'])),
                            ('disable_affinity_failure_reopt', (YLeaf(YType.boolean, 'disable-affinity-failure-reopt'), ['bool'])),
                            ('affinity_failure_reopt_timer', (YLeaf(YType.uint32, 'affinity-failure-reopt-timer'), ['int'])),
                            ('segment_routing_path_selection', (YLeaf(YType.enumeration, 'segment-routing-path-selection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_id = None
                        self.is_p2mp = None
                        self.signaled_name = None
                        self.configured_bandwidth = None
                        self.interface_configured_bandwidth = None
                        self.bandwidth_type = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.policy_class = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.backup_bandwidth = None
                        self.backup_bandwidth_flags = None
                        self.config_load_share = None
                        self.payload_type = None
                        self.is_in_config = None
                        self.explicit_null_imposition = None
                        self.fast_reroute = None
                        self.is_backup_tunnel = None
                        self.record_route = None
                        self.srlg_discovery = None
                        self.path_protection_enabled = None
                        self.hop_limit = None
                        self.cost_limit = None
                        self.cost_limit_global = None
                        self.delay_limit = None
                        self.delay_limit_global = None
                        self.path_invalidation_timeout_source = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action_source = None
                        self.path_invalidation_action = None
                        self.soft_preempt = None
                        self.disable_affinity_failure_reopt = None
                        self.affinity_failure_reopt_timer = None
                        self.segment_routing_path_selection = None

                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bidirectional_config = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"

                        self.bfd_config = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"

                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.autoroute_destination = YList(self)
                        self._segment_path = lambda: "config"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config, ['tunnel_name', 'tunnel_id', 'is_p2mp', 'signaled_name', 'configured_bandwidth', 'interface_configured_bandwidth', 'bandwidth_type', 'setup_priority', 'hold_priority', 'policy_class', 'forward_class', 'is_forward_class_configured', 'backup_bandwidth', 'backup_bandwidth_flags', 'config_load_share', 'payload_type', 'is_in_config', 'explicit_null_imposition', 'fast_reroute', 'is_backup_tunnel', 'record_route', 'srlg_discovery', 'path_protection_enabled', 'hop_limit', 'cost_limit', 'cost_limit_global', 'delay_limit', 'delay_limit_global', 'path_invalidation_timeout_source', 'path_invalidation_timeout', 'path_invalidation_action_source', 'path_invalidation_action', 'soft_preempt', 'disable_affinity_failure_reopt', 'affinity_failure_reopt_timer', 'segment_routing_path_selection'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity']['meta_info']


                    class BidirectionalConfig(_Entity_):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_type
                        
                        	Association Type (RFC 7751)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('association_type', (YLeaf(YType.uint16, 'association-type'), ['int'])),
                                ('association_id', (YLeaf(YType.uint16, 'association-id'), ['int'])),
                                ('association_source', (YLeaf(YType.str, 'association-source'), ['str'])),
                                ('association_global_id', (YLeaf(YType.uint32, 'association-global-id'), ['int'])),
                                ('association_corouted', (YLeaf(YType.boolean, 'association-corouted'), ['bool'])),
                            ])
                            self.association_type = None
                            self.association_id = None
                            self.association_source = None
                            self.association_global_id = None
                            self.association_corouted = None
                            self._segment_path = lambda: "bidirectional-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, ['association_type', 'association_id', 'association_source', 'association_global_id', 'association_corouted'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig']['meta_info']


                    class BfdConfig(_Entity_):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:  :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:  :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('bfd_fast_detecting_enabled', (YLeaf(YType.boolean, 'bfd-fast-detecting-enabled'), ['bool'])),
                                ('bfd_type', (YLeaf(YType.enumeration, 'bfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ('bring_up_timeout', (YLeaf(YType.uint16, 'bring-up-timeout'), ['int'])),
                                ('bring_up_timeout_default', (YLeaf(YType.boolean, 'bring-up-timeout-default'), ['bool'])),
                                ('dampening_initial_wait', (YLeaf(YType.uint32, 'dampening-initial-wait'), ['int'])),
                                ('dampening_initial_wait_default', (YLeaf(YType.boolean, 'dampening-initial-wait-default'), ['bool'])),
                                ('dampening_max_wait', (YLeaf(YType.uint32, 'dampening-max-wait'), ['int'])),
                                ('dampening_max_wait_default', (YLeaf(YType.boolean, 'dampening-max-wait-default'), ['bool'])),
                                ('dampening_secondary_wait', (YLeaf(YType.uint32, 'dampening-secondary-wait'), ['int'])),
                                ('dampening_secondary_wait_default', (YLeaf(YType.boolean, 'dampening-secondary-wait-default'), ['bool'])),
                                ('periodic_lsp_ping_disabled', (YLeaf(YType.boolean, 'periodic-lsp-ping-disabled'), ['bool'])),
                                ('periodic_lsp_ping_interval', (YLeaf(YType.uint32, 'periodic-lsp-ping-interval'), ['int'])),
                                ('periodic_lsp_ping_interval_default', (YLeaf(YType.boolean, 'periodic-lsp-ping-interval-default'), ['bool'])),
                                ('bfd_session_down_action', (YLeaf(YType.enumeration, 'bfd-session-down-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBfdSessionDownAction1', '')])),
                                ('bfd_session_down_reopt_timeout', (YLeaf(YType.uint32, 'bfd-session-down-reopt-timeout'), ['int'])),
                                ('bfd_encap_mode', (YLeaf(YType.enumeration, 'bfd-encap-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfdEncapMode', '')])),
                                ('sbfd_target_id', (YLeaf(YType.str, 'sbfd-target-id'), ['str'])),
                            ])
                            self.bfd_fast_detecting_enabled = None
                            self.bfd_type = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None
                            self.bring_up_timeout = None
                            self.bring_up_timeout_default = None
                            self.dampening_initial_wait = None
                            self.dampening_initial_wait_default = None
                            self.dampening_max_wait = None
                            self.dampening_max_wait_default = None
                            self.dampening_secondary_wait = None
                            self.dampening_secondary_wait_default = None
                            self.periodic_lsp_ping_disabled = None
                            self.periodic_lsp_ping_interval = None
                            self.periodic_lsp_ping_interval_default = None
                            self.bfd_session_down_action = None
                            self.bfd_session_down_reopt_timeout = None
                            self.bfd_encap_mode = None
                            self.sbfd_target_id = None
                            self._segment_path = lambda: "bfd-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, ['bfd_fast_detecting_enabled', 'bfd_type', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default', 'bring_up_timeout', 'bring_up_timeout_default', 'dampening_initial_wait', 'dampening_initial_wait_default', 'dampening_max_wait', 'dampening_max_wait_default', 'dampening_secondary_wait', 'dampening_secondary_wait_default', 'periodic_lsp_ping_disabled', 'periodic_lsp_ping_interval', 'periodic_lsp_ping_interval_default', 'bfd_session_down_action', 'bfd_session_down_reopt_timeout', 'bfd_encap_mode', 'sbfd_target_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging configuration
                        
                        .. attribute:: all
                        
                        	All tunnel logging enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimize
                        
                        	Reoptimization Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	State Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reroute
                        
                        	Reroute logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_change
                        
                        	Bandwidth change logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchover
                        
                        	Path protection switchover logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: record_route
                        
                        	Record route logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_failure
                        
                        	Path calculation failure logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimization_attempt
                        
                        	Reoptimization attempt logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: insufficient_bandwidth
                        
                        	Insufficient bandwidth logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('all', (YLeaf(YType.boolean, 'all'), ['bool'])),
                                ('reoptimize', (YLeaf(YType.boolean, 'reoptimize'), ['bool'])),
                                ('state', (YLeaf(YType.boolean, 'state'), ['bool'])),
                                ('reroute', (YLeaf(YType.boolean, 'reroute'), ['bool'])),
                                ('bandwidth_change', (YLeaf(YType.boolean, 'bandwidth-change'), ['bool'])),
                                ('switchover', (YLeaf(YType.boolean, 'switchover'), ['bool'])),
                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ('path_calculation_failure', (YLeaf(YType.boolean, 'path-calculation-failure'), ['bool'])),
                                ('reoptimization_attempt', (YLeaf(YType.boolean, 'reoptimization-attempt'), ['bool'])),
                                ('insufficient_bandwidth', (YLeaf(YType.boolean, 'insufficient-bandwidth'), ['bool'])),
                            ])
                            self.all = None
                            self.reoptimize = None
                            self.state = None
                            self.reroute = None
                            self.bandwidth_change = None
                            self.switchover = None
                            self.record_route = None
                            self.path_calculation_failure = None
                            self.reoptimization_attempt = None
                            self.insufficient_bandwidth = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging, ['all', 'reoptimize', 'state', 'reroute', 'bandwidth_change', 'switchover', 'record_route', 'path_calculation_failure', 'reoptimization_attempt', 'insufficient_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry']['meta_info']


                    class AutorouteDestination(_Entity_):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('prefix_length', (YLeaf(YType.uint16, 'prefix-length'), ['int'])),
                            ])
                            self.destination_address = None
                            self.prefix_length = None
                            self._segment_path = lambda: "autoroute-destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, ['destination_address', 'prefix_length'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config']['meta_info']


                class TunnelCurrentLsp(_Entity_):
                    """
                    Current LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-current-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp']['meta_info']


                class ReoptimizedP2mpLsp(_Entity_):
                    """
                    Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp']['meta_info']


                class TunnelStandbyLsp(_Entity_):
                    """
                    Standby LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-standby-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp']['meta_info']


                class ReoptimizedStandbyP2mpLsp(_Entity_):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-standby-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp']['meta_info']


                class TunnelRestorationLsp(_Entity_):
                    """
                    Restoration LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-restoration-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp']['meta_info']


                class DelayCleanPpLsp(_Entity_):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "delay-clean-pp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp']['meta_info']


                class CleanedLsp(_Entity_):
                    """
                    Cleaned LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec)), ("s2l", ("s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "cleaned-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro)), ("tspec", ("tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection)), ("association", ("association", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association)), ("protection", ("protection", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp']['meta_info']


                class P2pInfo(_Entity_):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:  :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:  :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus)), ("auto-bandwidth-config", ("auto_bandwidth_config", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig)), ("auto-bandwidth-oper", ("auto_bandwidth_oper", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper))])
                        self._leafs = OrderedDict([
                            ('is_bidirectional', (YLeaf(YType.boolean, 'is-bidirectional'), ['bool'])),
                        ])
                        self.is_bidirectional = None

                        self.auto_bandwidth_status = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"

                        self.auto_bandwidth_config = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"

                        self.auto_bandwidth_oper = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._segment_path = lambda: "p2p-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo, ['is_bidirectional'], name, value)


                    class AutoBandwidthStatus(_Entity_):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                                ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                            ])
                            self.is_auto_bandwidth_enabled = None
                            self.reactivation_time = None
                            self._segment_path = lambda: "auto-bandwidth-status"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus']['meta_info']


                    class AutoBandwidthConfig(_Entity_):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_enabled
                        
                        	TRUE if resignal last bandwidth is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_timeout
                        
                        	The configured time\-out value in seconds for resignal  last bandwidth after tunnel down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_collect_only', (YLeaf(YType.boolean, 'is-auto-bandwidth-collect-only'), ['bool'])),
                                ('minimum_bandwidth', (YLeaf(YType.uint32, 'minimum-bandwidth'), ['int'])),
                                ('maximum_bandwidth', (YLeaf(YType.uint32, 'maximum-bandwidth'), ['int'])),
                                ('application_frequency', (YLeaf(YType.uint32, 'application-frequency'), ['int'])),
                                ('collection_frequency', (YLeaf(YType.uint32, 'collection-frequency'), ['int'])),
                                ('adjustment_threshold_percent', (YLeaf(YType.uint32, 'adjustment-threshold-percent'), ['int'])),
                                ('adjustment_threshold_value', (YLeaf(YType.uint32, 'adjustment-threshold-value'), ['int'])),
                                ('overflow_threshold_percent', (YLeaf(YType.uint32, 'overflow-threshold-percent'), ['int'])),
                                ('overflow_threshold_value', (YLeaf(YType.uint32, 'overflow-threshold-value'), ['int'])),
                                ('overflow_threshold_limit', (YLeaf(YType.uint32, 'overflow-threshold-limit'), ['int'])),
                                ('underflow_threshold_percent', (YLeaf(YType.uint32, 'underflow-threshold-percent'), ['int'])),
                                ('underflow_threshold_value', (YLeaf(YType.uint32, 'underflow-threshold-value'), ['int'])),
                                ('underflow_threshold_limit', (YLeaf(YType.uint32, 'underflow-threshold-limit'), ['int'])),
                                ('resignal_last_bandwidth_enabled', (YLeaf(YType.boolean, 'resignal-last-bandwidth-enabled'), ['bool'])),
                                ('resignal_last_bandwidth_timeout', (YLeaf(YType.uint32, 'resignal-last-bandwidth-timeout'), ['int'])),
                            ])
                            self.is_auto_bandwidth_collect_only = None
                            self.minimum_bandwidth = None
                            self.maximum_bandwidth = None
                            self.application_frequency = None
                            self.collection_frequency = None
                            self.adjustment_threshold_percent = None
                            self.adjustment_threshold_value = None
                            self.overflow_threshold_percent = None
                            self.overflow_threshold_value = None
                            self.overflow_threshold_limit = None
                            self.underflow_threshold_percent = None
                            self.underflow_threshold_value = None
                            self.underflow_threshold_limit = None
                            self.resignal_last_bandwidth_enabled = None
                            self.resignal_last_bandwidth_timeout = None
                            self._segment_path = lambda: "auto-bandwidth-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig, ['is_auto_bandwidth_collect_only', 'minimum_bandwidth', 'maximum_bandwidth', 'application_frequency', 'collection_frequency', 'adjustment_threshold_percent', 'adjustment_threshold_value', 'overflow_threshold_percent', 'overflow_threshold_value', 'overflow_threshold_limit', 'underflow_threshold_percent', 'underflow_threshold_value', 'underflow_threshold_limit', 'resignal_last_bandwidth_enabled', 'resignal_last_bandwidth_timeout'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig']['meta_info']


                    class AutoBandwidthOper(_Entity_):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:  :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        	**config**\: False
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:  :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_expire_time
                        
                        	Timestamp when the resignal last bandwidth will expire and tunnel will use configured bandwidth to setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                                ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                                ('last_application_trigger', (YLeaf(YType.enumeration, 'last-application-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppTrigger', '')])),
                                ('application_jitter', (YLeaf(YType.uint32, 'application-jitter'), ['int'])),
                                ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                                ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                                ('time_left_collection', (YLeaf(YType.uint32, 'time-left-collection'), ['int'])),
                                ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                                ('underflow_highest_bandwidth', (YLeaf(YType.uint32, 'underflow-highest-bandwidth'), ['int'])),
                                ('threshold_overflows', (YLeaf(YType.uint32, 'threshold-overflows'), ['int'])),
                                ('overflow_early_bw_applications', (YLeaf(YType.uint32, 'overflow-early-bw-applications'), ['int'])),
                                ('threshold_underflows', (YLeaf(YType.uint32, 'threshold-underflows'), ['int'])),
                                ('underflow_early_bw_applications', (YLeaf(YType.uint32, 'underflow-early-bw-applications'), ['int'])),
                                ('collect_only_requested_bandwidth', (YLeaf(YType.uint32, 'collect-only-requested-bandwidth'), ['int'])),
                                ('application_reject_reason', (YLeaf(YType.enumeration, 'application-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppRej', '')])),
                                ('resignal_last_bandwidth_expire_time', (YLeaf(YType.uint32, 'resignal-last-bandwidth-expire-time'), ['int'])),
                            ])
                            self.last_bandwidth_applied = None
                            self.bandwidth_pool_type = None
                            self.bandwidth_applications = None
                            self.last_application_trigger = None
                            self.application_jitter = None
                            self.time_left_application = None
                            self.samples_collected = None
                            self.time_left_collection = None
                            self.highest_bandwidth = None
                            self.underflow_highest_bandwidth = None
                            self.threshold_overflows = None
                            self.overflow_early_bw_applications = None
                            self.threshold_underflows = None
                            self.underflow_early_bw_applications = None
                            self.collect_only_requested_bandwidth = None
                            self.application_reject_reason = None
                            self.resignal_last_bandwidth_expire_time = None
                            self._segment_path = lambda: "auto-bandwidth-oper"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper, ['last_bandwidth_applied', 'bandwidth_pool_type', 'bandwidth_applications', 'last_application_trigger', 'application_jitter', 'time_left_application', 'samples_collected', 'time_left_collection', 'highest_bandwidth', 'underflow_highest_bandwidth', 'threshold_overflows', 'overflow_early_bw_applications', 'threshold_underflows', 'underflow_early_bw_applications', 'collect_only_requested_bandwidth', 'application_reject_reason', 'resignal_last_bandwidth_expire_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo']['meta_info']


                class AutoCapacity(_Entity_):
                    """
                    Auto\-capacity Info
                    
                    .. attribute:: auto_capacity_configuration
                    
                    	The configured properties of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityConfiguration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_capacity_stats
                    
                    	The statistic of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats>`
                    
                    	**config**\: False
                    
                    .. attribute:: clone
                    
                    	Table of clones
                    	**type**\: list of  		 :py:class:`Clone <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity, self).__init__()

                        self.yang_name = "auto-capacity"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-capacity-configuration", ("auto_capacity_configuration", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration)), ("auto-capacity-stats", ("auto_capacity_stats", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats)), ("clone", ("clone", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone))])
                        self._leafs = OrderedDict()

                        self.auto_capacity_configuration = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration()
                        self.auto_capacity_configuration.parent = self
                        self._children_name_map["auto_capacity_configuration"] = "auto-capacity-configuration"

                        self.auto_capacity_stats = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats()
                        self.auto_capacity_stats.parent = self
                        self._children_name_map["auto_capacity_stats"] = "auto-capacity-stats"

                        self.clone = YList(self)
                        self._segment_path = lambda: "auto-capacity"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity, [], name, value)


                    class AutoCapacityConfiguration(_Entity_):
                        """
                        The configured properties of auto\-capacity
                        
                        .. attribute:: minimum_clones
                        
                        	The minimum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_clones
                        
                        	The maximum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merge_bandwidth
                        
                        	The merge bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: split_bandwidth
                        
                        	The split bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: nominal_bandwidth
                        
                        	The optimal or nominal bandwidth for the clones in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration, self).__init__()

                            self.yang_name = "auto-capacity-configuration"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('minimum_clones', (YLeaf(YType.uint32, 'minimum-clones'), ['int'])),
                                ('maximum_clones', (YLeaf(YType.uint32, 'maximum-clones'), ['int'])),
                                ('merge_bandwidth', (YLeaf(YType.uint32, 'merge-bandwidth'), ['int'])),
                                ('split_bandwidth', (YLeaf(YType.uint32, 'split-bandwidth'), ['int'])),
                                ('nominal_bandwidth', (YLeaf(YType.uint32, 'nominal-bandwidth'), ['int'])),
                            ])
                            self.minimum_clones = None
                            self.maximum_clones = None
                            self.merge_bandwidth = None
                            self.split_bandwidth = None
                            self.nominal_bandwidth = None
                            self._segment_path = lambda: "auto-capacity-configuration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration, ['minimum_clones', 'maximum_clones', 'merge_bandwidth', 'split_bandwidth', 'nominal_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration']['meta_info']


                    class AutoCapacityStats(_Entity_):
                        """
                        The statistic of auto\-capacity
                        
                        .. attribute:: splits
                        
                        	Count of splits events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merges
                        
                        	Count of merges events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_created
                        
                        	Total clones created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_deleted
                        
                        	Total clones deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_watermark_clones
                        
                        	Highest number of clones reached at any point in time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats, self).__init__()

                            self.yang_name = "auto-capacity-stats"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('splits', (YLeaf(YType.uint32, 'splits'), ['int'])),
                                ('merges', (YLeaf(YType.uint32, 'merges'), ['int'])),
                                ('total_clones_created', (YLeaf(YType.uint32, 'total-clones-created'), ['int'])),
                                ('total_clones_deleted', (YLeaf(YType.uint32, 'total-clones-deleted'), ['int'])),
                                ('high_watermark_clones', (YLeaf(YType.uint32, 'high-watermark-clones'), ['int'])),
                            ])
                            self.splits = None
                            self.merges = None
                            self.total_clones_created = None
                            self.total_clones_deleted = None
                            self.high_watermark_clones = None
                            self._segment_path = lambda: "auto-capacity-stats"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats, ['splits', 'merges', 'total_clones_created', 'total_clones_deleted', 'high_watermark_clones'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats']['meta_info']


                    class Clone(_Entity_):
                        """
                        Table of clones
                        
                        .. attribute:: name
                        
                        	Name of the clone
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: creation_timestamp
                        
                        	The timestamp when this clone was created relative to Jan 1, 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	The interface state of the cloned tunnel
                        	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_bandwidth
                        
                        	The signaled bandwidth (kbps) of the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: current_bandwidth_demand
                        
                        	The current demand (kbps) read from the traffic stats for the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone, self).__init__()

                            self.yang_name = "clone"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('creation_timestamp', (YLeaf(YType.uint32, 'creation-timestamp'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                                ('signaled_bandwidth', (YLeaf(YType.uint32, 'signaled-bandwidth'), ['int'])),
                                ('current_bandwidth_demand', (YLeaf(YType.uint32, 'current-bandwidth-demand'), ['int'])),
                            ])
                            self.name = None
                            self.creation_timestamp = None
                            self.state = None
                            self.signaled_bandwidth = None
                            self.current_bandwidth_demand = None
                            self._segment_path = lambda: "clone"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone, ['name', 'creation_timestamp', 'state', 'signaled_bandwidth', 'current_bandwidth_demand'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity']['meta_info']


                class History(_Entity_):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:  :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:  :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:  :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:  :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:  :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:  :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:  :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:  :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:  :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:  :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:  :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("current-setup", ("current_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup)), ("reopt-setup", ("reopt_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup)), ("gmpls-path-protect-setup", ("gmpls_path_protect_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup)), ("previous-setup", ("previous_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup)), ("previous-gmpls-path-protect-setup", ("previous_gmpls_path_protect_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup)), ("gmpls-other-setup", ("gmpls_other_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup)), ("gmpls-other-protect-setup", ("gmpls_other_protect_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup)), ("standby-setup", ("standby_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup)), ("standby-reopt-setup", ("standby_reopt_setup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup)), ("last-re-opt-fail", ("last_re_opt_fail", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail)), ("last-stdby-re-opt-fail", ("last_stdby_re_opt_fail", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail))])
                        self._leafs = OrderedDict()

                        self.current_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"

                        self.reopt_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"

                        self.gmpls_path_protect_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"

                        self.previous_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"

                        self.previous_gmpls_path_protect_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"

                        self.gmpls_other_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"

                        self.gmpls_other_protect_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"

                        self.standby_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"

                        self.standby_reopt_setup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"

                        self.last_re_opt_fail = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"

                        self.last_stdby_re_opt_fail = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._segment_path = lambda: "history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History, [], name, value)


                    class CurrentSetup(_Entity_):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:  :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes>`
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("connected-uptimes", ("connected_uptimes", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes))])
                            self._leafs = OrderedDict([
                                ('current_setup_timer', (YLeaf(YType.uint32, 'current-setup-timer'), ['int'])),
                                ('selection_reason', (YLeaf(YType.str, 'selection-reason'), ['str'])),
                                ('current_setup_last_error', (YLeaf(YType.str, 'current-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.current_setup_timer = None
                            self.selection_reason = None
                            self.current_setup_last_error = None
                            self.protection_role = None

                            self.connected_uptimes = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._segment_path = lambda: "current-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, ['current_setup_timer', 'selection_reason', 'current_setup_last_error', 'protection_role'], name, value)


                        class ConnectedUptimes(_Entity_):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('current_lsp_uptime', (YLeaf(YType.uint32, 'current-lsp-uptime'), ['int'])),
                                    ('current_uptime', (YLeaf(YType.uint32, 'current-uptime'), ['int'])),
                                ])
                                self.current_lsp_uptime = None
                                self.current_uptime = None
                                self._segment_path = lambda: "connected-uptimes"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, ['current_lsp_uptime', 'current_uptime'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup']['meta_info']


                    class ReoptSetup(_Entity_):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup']['meta_info']


                    class GmplsPathProtectSetup(_Entity_):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protecting_setup_uptime', (YLeaf(YType.uint32, 'protecting-setup-uptime'), ['int'])),
                                ('protecting_setup_timer', (YLeaf(YType.uint32, 'protecting-setup-timer'), ['int'])),
                                ('protecting_setup_last_error', (YLeaf(YType.str, 'protecting-setup-last-error'), ['str'])),
                            ])
                            self.protecting_setup_uptime = None
                            self.protecting_setup_timer = None
                            self.protecting_setup_last_error = None
                            self._segment_path = lambda: "gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, ['protecting_setup_uptime', 'protecting_setup_timer', 'protecting_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup']['meta_info']


                    class PreviousSetup(_Entity_):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_path_option', (YLeaf(YType.str, 'previous-path-option'), ['str'])),
                                ('previous_tunnel_instance', (YLeaf(YType.uint32, 'previous-tunnel-instance'), ['int'])),
                                ('previous_fail_reason', (YLeaf(YType.str, 'previous-fail-reason'), ['str'])),
                                ('previous_setup_last_error', (YLeaf(YType.str, 'previous-setup-last-error'), ['str'])),
                            ])
                            self.previous_path_option = None
                            self.previous_tunnel_instance = None
                            self.previous_fail_reason = None
                            self.previous_setup_last_error = None
                            self._segment_path = lambda: "previous-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, ['previous_path_option', 'previous_tunnel_instance', 'previous_fail_reason', 'previous_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup']['meta_info']


                    class PreviousGmplsPathProtectSetup(_Entity_):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_protect_path_option', (YLeaf(YType.str, 'previous-protect-path-option'), ['str'])),
                                ('previous_protect_tunnel_instance', (YLeaf(YType.uint32, 'previous-protect-tunnel-instance'), ['int'])),
                                ('previous_protect_fail_reason', (YLeaf(YType.str, 'previous-protect-fail-reason'), ['str'])),
                                ('previous_protect_setup_last_error', (YLeaf(YType.str, 'previous-protect-setup-last-error'), ['str'])),
                            ])
                            self.previous_protect_path_option = None
                            self.previous_protect_tunnel_instance = None
                            self.previous_protect_fail_reason = None
                            self.previous_protect_setup_last_error = None
                            self._segment_path = lambda: "previous-gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, ['previous_protect_path_option', 'previous_protect_tunnel_instance', 'previous_protect_fail_reason', 'previous_protect_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup']['meta_info']


                    class GmplsOtherSetup(_Entity_):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup']['meta_info']


                    class GmplsOtherProtectSetup(_Entity_):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup']['meta_info']


                    class StandbySetup(_Entity_):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('standby_lsp_uptime', (YLeaf(YType.uint32, 'standby-lsp-uptime'), ['int'])),
                                ('standby_setup_timer', (YLeaf(YType.uint32, 'standby-setup-timer'), ['int'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.standby_lsp_uptime = None
                            self.standby_setup_timer = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, ['standby_lsp_uptime', 'standby_setup_timer', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup']['meta_info']


                    class StandbyReoptSetup(_Entity_):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup']['meta_info']


                    class LastReOptFail(_Entity_):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail']['meta_info']


                    class LastStdbyReOptFail(_Entity_):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-stdby-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.History']['meta_info']


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection']['meta_info']


                class AutoBackup(_Entity_):
                    """
                    Autobackup Information
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:  :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of  		 :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("weighted-srlg-info", ("weighted_srlg_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo)), ("iep", ("iep", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep))])
                        self._leafs = OrderedDict([
                            ('protected_ls_ps', (YLeaf(YType.uint32, 'protected-ls-ps'), ['int'])),
                            ('protected_s2_ls', (YLeaf(YType.uint32, 'protected-s2-ls'), ['int'])),
                            ('sharing_families', (YLeaf(YType.uint32, 'sharing-families'), ['int'])),
                            ('ab_protection_type', (YLeaf(YType.enumeration, 'ab-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('is_using_srlg', (YLeaf(YType.boolean, 'is-using-srlg'), ['bool'])),
                            ('srlg_prot_type', (YLeaf(YType.enumeration, 'srlg-prot-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('ab_protected_interface', (YLeaf(YType.str, 'ab-protected-interface'), ['str'])),
                            ('protected_address', (YLeaf(YType.str, 'protected-address'), ['str'])),
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('is_unused_removal_timer_running', (YLeaf(YType.boolean, 'is-unused-removal-timer-running'), ['bool'])),
                            ('unused_removal_remaining_time', (YLeaf(YType.uint32, 'unused-removal-remaining-time'), ['int'])),
                        ])
                        self.protected_ls_ps = None
                        self.protected_s2_ls = None
                        self.sharing_families = None
                        self.ab_protection_type = None
                        self.is_using_srlg = None
                        self.srlg_prot_type = None
                        self.ab_protected_interface = None
                        self.protected_address = None
                        self.tunnel_attribute_set_name = None
                        self.is_unused_removal_timer_running = None
                        self.unused_removal_remaining_time = None

                        self.weighted_srlg_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"

                        self.iep = YList(self)
                        self._segment_path = lambda: "auto-backup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup, ['protected_ls_ps', 'protected_s2_ls', 'sharing_families', 'ab_protection_type', 'is_using_srlg', 'srlg_prot_type', 'ab_protected_interface', 'protected_address', 'tunnel_attribute_set_name', 'is_unused_removal_timer_running', 'unused_removal_remaining_time'], name, value)


                    class WeightedSrlgInfo(_Entity_):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of  		 :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of  		 :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protected-interface-srlg", ("protected_interface_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg)), ("weighted-srlg-hop", ("weighted_srlg_hop", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop))])
                            self._leafs = OrderedDict()

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)
                            self._segment_path = lambda: "weighted-srlg-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, [], name, value)


                        class ProtectedInterfaceSrlg(_Entity_):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('srlg', (YLeaf(YType.uint32, 'srlg'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                                ])
                                self.srlg = None
                                self.srlg_name = None
                                self.admin_weight = None
                                self._segment_path = lambda: "protected-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, ['srlg', 'srlg_name', 'admin_weight'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg']['meta_info']


                        class WeightedSrlgHop(_Entity_):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of  		 :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("common-srlg", ("common_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg))])
                                self._leafs = OrderedDict([
                                    ('from_address', (YLeaf(YType.str, 'from-address'), ['str'])),
                                    ('to_address', (YLeaf(YType.str, 'to-address'), ['str'])),
                                    ('aggregate_admin_weight', (YLeaf(YType.uint64, 'aggregate-admin-weight'), ['int'])),
                                ])
                                self.from_address = None
                                self.to_address = None
                                self.aggregate_admin_weight = None

                                self.common_srlg = YList(self)
                                self._segment_path = lambda: "weighted-srlg-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, ['from_address', 'to_address', 'aggregate_admin_weight'], name, value)


                            class CommonSrlg(_Entity_):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	Common SRLG between this hop and the protected  interface
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "common-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo']['meta_info']


                    class Iep(_Entity_):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of  		 :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("iep-hop", ("iep_hop", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop))])
                            self._leafs = OrderedDict([
                                ('path_option_id', (YLeaf(YType.uint32, 'path-option-id'), ['int'])),
                            ])
                            self.path_option_id = None

                            self.iep_hop = YList(self)
                            self._segment_path = lambda: "iep"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, ['path_option_id'], name, value)


                        class IepHop(_Entity_):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:  :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('hop_index', (YLeaf(YType.uint32, 'hop-index'), ['int'])),
                                    ('iep_hop_type', (YLeaf(YType.enumeration, 'iep-hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIepHop', '')])),
                                    ('iep_hop_address', (YLeaf(YType.str, 'iep-hop-address'), ['str'])),
                                ])
                                self.hop_index = None
                                self.iep_hop_type = None
                                self.iep_hop_address = None
                                self._segment_path = lambda: "iep-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, ['hop_index', 'iep_hop_type', 'iep_hop_address'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup']['meta_info']


                class AutoMesh(_Entity_):
                    """
                    Automesh Information
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('tunnel_destination_list_name', (YLeaf(YType.str, 'tunnel-destination-list-name'), ['str'])),
                            ('is_tunnel_unused_timer_running', (YLeaf(YType.boolean, 'is-tunnel-unused-timer-running'), ['bool'])),
                            ('remaining_unused_time', (YLeaf(YType.uint32, 'remaining-unused-time'), ['int'])),
                            ('mesh_group_type', (YLeaf(YType.enumeration, 'mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.tunnel_destination_list_name = None
                        self.is_tunnel_unused_timer_running = None
                        self.remaining_unused_time = None
                        self.mesh_group_type = None
                        self._segment_path = lambda: "auto-mesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh, ['mesh_group_id', 'tunnel_destination_list_name', 'is_tunnel_unused_timer_running', 'remaining_unused_time', 'mesh_group_type'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh']['meta_info']


                class AutoPcc(_Entity_):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('creator_address', (YLeaf(YType.str, 'creator-address'), ['str'])),
                            ('has_creator_id', (YLeaf(YType.boolean, 'has-creator-id'), ['bool'])),
                            ('creator_id', (YLeaf(YType.str, 'creator-id'), ['str'])),
                            ('plspid', (YLeaf(YType.uint32, 'plspid'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.owner_address = None
                        self.creator_address = None
                        self.has_creator_id = None
                        self.creator_id = None
                        self.plspid = None
                        self.symbolic_name = None
                        self.operationally_up = None
                        self._segment_path = lambda: "auto-pcc"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc, ['owner_address', 'creator_address', 'has_creator_id', 'creator_id', 'plspid', 'symbolic_name', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc']['meta_info']


                class PceDelegation(_Entity_):
                    """
                    PCE Delegation information
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('plsp_id', (YLeaf(YType.uint32, 'plsp-id'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.plsp_id = None
                        self.symbolic_name = None
                        self.owner_address = None
                        self.operationally_up = None
                        self._segment_path = lambda: "pce-delegation"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation, ['plsp_id', 'symbolic_name', 'owner_address', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation']['meta_info']


                class SoftPreemption(_Entity_):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:  :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:  :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of  		 :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("soft-preemption-counters", ("soft_preemption_counters", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters)), ("soft-preemption-path-error", ("soft_preemption_path_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError))])
                        self._leafs = OrderedDict([
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                            ('time_in_preemption_pending', (YLeaf(YType.uint16, 'time-in-preemption-pending'), ['int'])),
                            ('preemption_pending_resolution', (YLeaf(YType.enumeration, 'preemption-pending-resolution'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionResolution', '')])),
                        ])
                        self.status = None
                        self.time_in_preemption_pending = None
                        self.preemption_pending_resolution = None

                        self.soft_preemption_counters = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"

                        self.soft_preemption_path_error = YList(self)
                        self._segment_path = lambda: "soft-preemption"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption, ['status', 'time_in_preemption_pending', 'preemption_pending_resolution'], name, value)


                    class SoftPreemptionCounters(_Entity_):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                                ('reopt_completed_ls_ps', (YLeaf(YType.uint32, 'reopt-completed-ls-ps'), ['int'])),
                                ('torn_down_ls_ps', (YLeaf(YType.uint32, 'torn-down-ls-ps'), ['int'])),
                                ('path_protection_switchover_ls_ps', (YLeaf(YType.uint32, 'path-protection-switchover-ls-ps'), ['int'])),
                                ('frr_triggered_ls_ps', (YLeaf(YType.uint32, 'frr-triggered-ls-ps'), ['int'])),
                                ('time_in_preemption_pending_min', (YLeaf(YType.uint16, 'time-in-preemption-pending-min'), ['int'])),
                                ('time_in_preemption_pending_max', (YLeaf(YType.uint16, 'time-in-preemption-pending-max'), ['int'])),
                                ('time_in_preemption_pending_avg', (YLeaf(YType.uint16, 'time-in-preemption-pending-avg'), ['int'])),
                            ])
                            self.soft_preemption_events = None
                            self.reopt_completed_ls_ps = None
                            self.torn_down_ls_ps = None
                            self.path_protection_switchover_ls_ps = None
                            self.frr_triggered_ls_ps = None
                            self.time_in_preemption_pending_min = None
                            self.time_in_preemption_pending_max = None
                            self.time_in_preemption_pending_avg = None
                            self._segment_path = lambda: "soft-preemption-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, ['soft_preemption_events', 'reopt_completed_ls_ps', 'torn_down_ls_ps', 'path_protection_switchover_ls_ps', 'frr_triggered_ls_ps', 'time_in_preemption_pending_min', 'time_in_preemption_pending_max', 'time_in_preemption_pending_avg'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters']['meta_info']


                    class SoftPreemptionPathError(_Entity_):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                            ])
                            self.timestamp = None
                            self.preempting_link_address = None
                            self._segment_path = lambda: "soft-preemption-path-error"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, ['timestamp', 'preempting_link_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption']['meta_info']


                class WdmUnitunnel(_Entity_):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                            ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                            ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                            ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                            ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                        ])
                        self.tunnel_state = None
                        self.tunnel_role = None
                        self.tunnel_id = None
                        self.lsp_id = None
                        self.local_optical_router_id = None
                        self.remote_optical_router_id = None
                        self.controlled_interface = None
                        self.source_address = None
                        self.destination_address = None
                        self.extended_tunnel_id = None
                        self.label_origin = None
                        self.srlg_discovery = None
                        self._segment_path = lambda: "wdm-unitunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel']['meta_info']


                class TransportTunnelInfo(_Entity_):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn>`
                    
                    	**config**\: False
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:  :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:  :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of  		 :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of  		 :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("otn", ("otn", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn)), ("static-uni", ("static_uni", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni)), ("egress-static-uni", ("egress_static_uni", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni)), ("homepath-ero", ("homepath_ero", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro)), ("diversity-info", ("diversity_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo))])
                        self._leafs = OrderedDict([
                            ('status_homepath_working', (YLeaf(YType.boolean, 'status-homepath-working'), ['bool'])),
                        ])
                        self.status_homepath_working = None

                        self.otn = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"

                        self.static_uni = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"

                        self.egress_static_uni = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"

                        self.homepath_ero = YList(self)
                        self.diversity_info = YList(self)
                        self._segment_path = lambda: "transport-tunnel-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, ['status_homepath_working'], name, value)


                    class Otn(_Entity_):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:  :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        	**config**\: False
                        
                        .. attribute:: config_bit_rate
                        
                        	Configured OTN Bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-cfg", ("bandwidth_cfg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg))])
                            self._leafs = OrderedDict([
                                ('config_bit_rate', (YLeaf(YType.uint32, 'config-bit-rate'), ['int'])),
                            ])
                            self.config_bit_rate = None

                            self.bandwidth_cfg = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._segment_path = lambda: "otn"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, ['config_bit_rate'], name, value)


                        class BandwidthCfg(_Entity_):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes))])
                                self._leafs = OrderedDict([
                                    ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ])
                                self.odu_level = None

                                self.odu_flex_cbr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                self.odu_flex_gfp_f_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                self.odu_flex_gfp_f_non_res = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._segment_path = lambda: "bandwidth-cfg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, ['odu_level'], name, value)


                            class OduFlexCbr(_Entity_):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self.tolerance = None
                                    self._segment_path = lambda: "odu-flex-cbr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr']['meta_info']


                            class OduFlexGfpFRes(_Entity_):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes']['meta_info']


                            class OduFlexGfpFNonRes(_Entity_):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn']['meta_info']


                    class StaticUni(_Entity_):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: term_interface_srlg
                        
                        	Termination Interface SRLG
                        	**type**\:  :py:class:`TermInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("term-interface-srlg", ("term_interface_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg))])
                            self._leafs = OrderedDict([
                                ('client_port', (YLeaf(YType.str, 'client-port'), ['str'])),
                                ('client_if_handle', (YLeaf(YType.str, 'client-if-handle'), ['str'])),
                                ('client_odu_name', (YLeaf(YType.str, 'client-odu-name'), ['str'])),
                                ('client_odu_if_handle', (YLeaf(YType.str, 'client-odu-if-handle'), ['str'])),
                                ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('static_uni_type', (YLeaf(YType.enumeration, 'static-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                                ('term_client_port', (YLeaf(YType.str, 'term-client-port'), ['str'])),
                                ('term_client_if_handle', (YLeaf(YType.str, 'term-client-if-handle'), ['str'])),
                            ])
                            self.client_port = None
                            self.client_if_handle = None
                            self.client_odu_name = None
                            self.client_odu_if_handle = None
                            self.cross_connect_id = None
                            self.is_connected = None
                            self.uptime = None
                            self.local_termination = None
                            self.static_uni_type = None
                            self.term_client_port = None
                            self.term_client_if_handle = None

                            self.term_interface_srlg = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg()
                            self.term_interface_srlg.parent = self
                            self._children_name_map["term_interface_srlg"] = "term-interface-srlg"
                            self._segment_path = lambda: "static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, ['client_port', 'client_if_handle', 'client_odu_name', 'client_odu_if_handle', 'cross_connect_id', 'is_connected', 'uptime', 'local_termination', 'static_uni_type', 'term_client_port', 'term_client_if_handle'], name, value)


                        class TermInterfaceSrlg(_Entity_):
                            """
                            Termination Interface SRLG
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLG
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, self).__init__()

                                self.yang_name = "term-interface-srlg"
                                self.yang_parent_name = "static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg))])
                                self._leafs = OrderedDict()

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "term-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, [], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLG
                                
                                .. attribute:: entry
                                
                                	Discovered SRLG
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "term-interface-srlg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni']['meta_info']


                    class EgressStaticUni(_Entity_):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:  :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:  :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("egress-port", ("egress_port", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort)), ("term-egress-port", ("term_egress_port", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort))])
                            self._leafs = OrderedDict([
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('remote_uni_type', (YLeaf(YType.enumeration, 'remote-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                            ])
                            self.local_termination = None
                            self.remote_uni_type = None

                            self.egress_port = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"

                            self.term_egress_port = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._segment_path = lambda: "egress-static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, ['local_termination', 'remote_uni_type'], name, value)


                        class EgressPort(_Entity_):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort']['meta_info']


                        class TermEgressPort(_Entity_):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "term-egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni']['meta_info']


                    class HomepathEro(_Entity_):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "homepath-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ])
                            self.tunnel_id = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, ['tunnel_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo']['meta_info']


                class BfdInfo(_Entity_):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:  :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of  		 :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("event-counters", ("event_counters", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters)), ("dampening-info", ("dampening_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo))])
                        self._leafs = OrderedDict([
                            ('bfd_session_up', (YLeaf(YType.boolean, 'bfd-session-up'), ['bool'])),
                            ('session_up_time', (YLeaf(YType.uint32, 'session-up-time'), ['int'])),
                            ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                            ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                            ('minimum_session_up_interval', (YLeaf(YType.uint32, 'minimum-session-up-interval'), ['int'])),
                            ('maximum_session_up_interval', (YLeaf(YType.uint32, 'maximum-session-up-interval'), ['int'])),
                        ])
                        self.bfd_session_up = None
                        self.session_up_time = None
                        self.failure_diagnostic_code = None
                        self.failure_reason = None
                        self.minimum_session_up_interval = None
                        self.maximum_session_up_interval = None

                        self.event_counters = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"

                        self.dampening_info = YList(self)
                        self._segment_path = lambda: "bfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo, ['bfd_session_up', 'session_up_time', 'failure_diagnostic_code', 'failure_reason', 'minimum_session_up_interval', 'maximum_session_up_interval'], name, value)


                    class EventCounters(_Entity_):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                                ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                                ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                                ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                                ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                                ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                                ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                                ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                                ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                            ])
                            self.session_create_events = None
                            self.session_up_events = None
                            self.session_creation_failed_events = None
                            self.session_down_events = None
                            self.session_admin_down_events = None
                            self.session_gracefully_delete_events = None
                            self.session_non_gracefully_delete_events = None
                            self.session_create_timeout_events = None
                            self.session_replay_events = None
                            self._segment_path = lambda: "event-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters']['meta_info']


                    class DampeningInfo(_Entity_):
                        """
                        Path option dampening info
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('hold_down_time', (YLeaf(YType.uint32, 'hold-down-time'), ['int'])),
                                ('remained_time', (YLeaf(YType.uint32, 'remained-time'), ['int'])),
                                ('backoff_count', (YLeaf(YType.uint32, 'backoff-count'), ['int'])),
                            ])
                            self.option_index = None
                            self.hold_down_time = None
                            self.remained_time = None
                            self.backoff_count = None
                            self._segment_path = lambda: "dampening-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, ['option_index', 'hold_down_time', 'remained_time', 'backoff_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo']['meta_info']


                class OtnBidir(_Entity_):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:  :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("aps", ("aps", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps)), ("restoration", ("restoration", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration))])
                        self._leafs = OrderedDict()

                        self.aps = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"

                        self.restoration = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._segment_path = lambda: "otn-bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir, [], name, value)


                    class Aps(_Entity_):
                        """
                        APS Protection Info
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:  :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protection-profile", ("protection_profile", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile))])
                            self._leafs = OrderedDict([
                                ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.active_lsp = None
                            self.diversity_type = None

                            self.protection_profile = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._segment_path = lambda: "aps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, ['active_lsp', 'diversity_type'], name, value)


                        class ProtectionProfile(_Entity_):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "protection-profile"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps']['meta_info']


                    class Restoration(_Entity_):
                        """
                        Restoration Info
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        	**config**\: False
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('revert_option', (YLeaf(YType.enumeration, 'revert-option'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                ('diverse_lsp', (YLeaf(YType.enumeration, 'diverse-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.revert_option = None
                            self.diverse_lsp = None
                            self.diversity_type = None
                            self._segment_path = lambda: "restoration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, ['revert_option', 'diverse_lsp', 'diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir']['meta_info']


                class Bidir(_Entity_):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:  :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reverse-ero-error-current", ("reverse_ero_error_current", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent)), ("reverse-ero-error-reopt", ("reverse_ero_error_reopt", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt)), ("reverse-ero-error-standby", ("reverse_ero_error_standby", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby)), ("reverse-ero-error-standby-reopt", ("reverse_ero_error_standby_reopt", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt))])
                        self._leafs = OrderedDict([
                            ('reverse_bandwidth', (YLeaf(YType.uint32, 'reverse-bandwidth'), ['int'])),
                            ('reverse_bandwidth_standby', (YLeaf(YType.uint32, 'reverse-bandwidth-standby'), ['int'])),
                        ])
                        self.reverse_bandwidth = None
                        self.reverse_bandwidth_standby = None

                        self.reverse_ero_error_current = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"

                        self.reverse_ero_error_reopt = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"

                        self.reverse_ero_error_standby = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"

                        self.reverse_ero_error_standby_reopt = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._segment_path = lambda: "bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir, ['reverse_bandwidth', 'reverse_bandwidth_standby'], name, value)


                    class ReverseEroErrorCurrent(_Entity_):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-current"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent']['meta_info']


                    class ReverseEroErrorReopt(_Entity_):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt']['meta_info']


                    class ReverseEroErrorStandby(_Entity_):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby']['meta_info']


                    class ReverseEroErrorStandbyReopt(_Entity_):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir']['meta_info']


                class XroAttributeSet(_Entity_):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion))])
                        self._leafs = OrderedDict([
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                        ])
                        self.tunnel_attribute_set_name = None
                        self.tunnel_attribute_set_name_crc32 = None

                        self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._segment_path = lambda: "xro-attribute-set"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                    class AttributeSetUnion(_Entity_):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                            self._leafs = OrderedDict([
                                ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                            ])
                            self.tunnel_attribute_set_type = None

                            self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                            self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                            self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                            self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                            self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                            self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                            self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._segment_path = lambda: "attribute-set-union"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                        class AttributeSetPathOption(_Entity_):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_delay_limit_configured
                            
                            	Is Delay Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: delay_limit
                            
                            	Delay limit on the tunnel path (usec) When delay limit is configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                    ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                    ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                    ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                    ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                ])
                                self.configured_bandwidth = None
                                self.cost_limit = None
                                self.dste_class_type = None
                                self.bandwidth_type = None
                                self.is_bandwidth_configured = None
                                self.is_cost_limit_configured = None
                                self.is_affinity_configured = None
                                self.generation = None
                                self.path_invalidation_timeout = None
                                self.path_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.exclude_list_name = None
                                self.is_exclude_list_name_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None
                                self.is_bfd_reverse_pat_configured = None
                                self.is_delay_limit_configured = None
                                self.delay_limit = None

                                self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)
                                self._segment_path = lambda: "attribute-set-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                            class BfdReversePath(_Entity_):
                                """
                                BFD reverse path
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                	**config**\: False
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                    ])
                                    self.path_type = None
                                    self.binding_label = None
                                    self._segment_path = lambda: "bfd-reverse-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                            class VersionInfo(_Entity_):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                        ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                    ])
                                    self.attribute_type = None
                                    self.generation = None
                                    self.is_default = None
                                    self._segment_path = lambda: "version-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                        class AttributeSetAutobackup(_Entity_):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                self._leafs = OrderedDict([
                                    ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ])
                                self.is_signalled_name_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.is_affinity_configured = None
                                self.record_route = None

                                self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"

                                self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)
                                self.protected_interface = YList(self)
                                self._segment_path = lambda: "attribute-set-autobackup"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                            class SignalledName(_Entity_):
                                """
                                Signalled name
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                    ])
                                    self.name = None
                                    self.source_type = None
                                    self.protected_interface_type = None
                                    self.is_mp_addresses = None
                                    self._segment_path = lambda: "signalled-name"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                            class ProtectedInterface(_Entity_):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                    ])
                                    self.protected_interface = None
                                    self._segment_path = lambda: "protected-interface"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                        class AttributeSetAutomesh(_Entity_):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_forward_class_configured
                            
                            	True if forward\-class is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                    ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                    ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                    ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                    ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                    ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                    ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                ])
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.forward_class = None
                                self.is_forward_class_configured = None
                                self.is_affinity_configured = None
                                self.fast_reroute = None
                                self.frr_node_protection = None
                                self.frr_bandwidth_protection = None
                                self.record_route = None
                                self.auto_bandwidth_collect = None
                                self.auto_route_announce = None
                                self.soft_preemption_configured = None
                                self.bandwidth = None
                                self.load_share = None
                                self.is_interface_bw_configured = None

                                self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.mesh_group_id = YList(self)
                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-automesh"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                            class MeshGroupId(_Entity_):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	Meshgroup ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "mesh-group-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                        class AttributeSetXro(_Entity_):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                self._leafs = OrderedDict()

                                self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._segment_path = lambda: "attribute-set-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                            class Xro(_Entity_):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                    self._leafs = OrderedDict([
                                        ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                    ])
                                    self.mutual_diversity_flag = None

                                    self.xro_subobject = YList(self)
                                    self._segment_path = lambda: "xro"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                class XroSubobject(_Entity_):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                        ])
                                        self.type = None

                                        self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                        self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                        self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                        self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"

                                        self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                        self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._segment_path = lambda: "xro-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                    class Ipv4Subobject(_Entity_):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv4-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                    class Ipv6Subobject(_Entity_):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\: str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv6-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                    class UnnumberedSubobject(_Entity_):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.te_router_id = None
                                            self.interface_id = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "unnumbered-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                    class AsSubobject(_Entity_):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                            ])
                                            self.as_number = None
                                            self._segment_path = lambda: "as-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                    class SrlgSubobject(_Entity_):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.srlg_id = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "srlg-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                    class LspSubobject(_Entity_):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                            self._leafs = OrderedDict([
                                                ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.ignore_lsp_id = None
                                            self.processing_node_exception = None
                                            self.penultimate_node_exception = None
                                            self.destination_node_exception = None
                                            self.exclusion_type = None

                                            self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._segment_path = lambda: "lsp-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                        class Fec(_Entity_):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                self._leafs = OrderedDict([
                                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                ])
                                                self.fec_lsp_id = None
                                                self.fec_tunnel_id = None
                                                self.fec_extended_tunnel_id = None
                                                self.fec_source = None
                                                self.fec_vrf = None

                                                self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._segment_path = lambda: "fec"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                            class FecDestinationInfo(_Entity_):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                    ])
                                                    self.fec_ctype = None
                                                    self.p2p_lsp_destination = None
                                                    self.fec_destination_p2mp_id = None
                                                    self._segment_path = lambda: "fec-destination-info"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                        class AttributeSetP2mpte(_Entity_):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                ])
                                self.fast_reroute = None
                                self.frr_bandwidth_protection = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.is_affinity_configured = None

                                self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2mpte"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                        class AttributeSetApsPp(_Entity_):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "attribute-set-aps-pp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                        class AttributeSetP2pTe(_Entity_):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                    ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                    ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                    ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                    ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                    ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                    ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                    ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                    ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                    ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                ])
                                self.is_affinity_configured = None
                                self.path_selection_segment_routing_adjacency_protection = None
                                self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                self.path_invalidation_timeout = None
                                self.path_selection_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.path_selection_metric = None
                                self.is_path_selection_metric_configured = None
                                self.path_selection_segment_routing_margin = None
                                self.is_path_selection_segment_routing_margin_relative = None
                                self.is_path_selection_segment_routing_margin_configured = None
                                self.path_selection_segment_routing_segment_limit = None
                                self.is_path_selection_segment_routing_segment_limit_configured = None
                                self.is_path_select_configured = None
                                self.is_prepend_list_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None

                                self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2p-te"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                            class PrependList(_Entity_):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                    self._leafs = OrderedDict()

                                    self.prepend_entry = YList(self)
                                    self._segment_path = lambda: "prepend-list"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                class PrependEntry(_Entity_):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                            ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                            ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                        ])
                                        self.type = None
                                        self.index = None
                                        self.next_label = None
                                        self._segment_path = lambda: "prepend-entry"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet']['meta_info']


                class TeTunnelConvergence(_Entity_):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("convergence-lsp", ("convergence_lsp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp))])
                        self._leafs = OrderedDict([
                            ('is_convergence_in_progress', (YLeaf(YType.boolean, 'is-convergence-in-progress'), ['bool'])),
                            ('frr_trigger_time', (YLeaf(YType.uint64, 'frr-trigger-time'), ['int'])),
                            ('pcalc_complete_time', (YLeaf(YType.uint64, 'pcalc-complete-time'), ['int'])),
                            ('convergence_complete_time', (YLeaf(YType.uint64, 'convergence-complete-time'), ['int'])),
                            ('binding_label_rewrite_time', (YLeaf(YType.uint64, 'binding-label-rewrite-time'), ['int'])),
                            ('vif_creation_time', (YLeaf(YType.uint64, 'vif-creation-time'), ['int'])),
                        ])
                        self.is_convergence_in_progress = None
                        self.frr_trigger_time = None
                        self.pcalc_complete_time = None
                        self.convergence_complete_time = None
                        self.binding_label_rewrite_time = None
                        self.vif_creation_time = None

                        self.convergence_lsp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._segment_path = lambda: "te-tunnel-convergence"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, ['is_convergence_in_progress', 'frr_trigger_time', 'pcalc_complete_time', 'convergence_complete_time', 'binding_label_rewrite_time', 'vif_creation_time'], name, value)


                    class ConvergenceLsp(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "convergence-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence']['meta_info']


                class FlexInfo(_Entity_):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:  :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                            ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                            ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                            ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                            ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ('fault_in_label', (YLeaf(YType.uint32, 'fault-in-label'), ['int'])),
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_timestamp', (YLeaf(YType.uint32, 'lockout-timestamp'), ['int'])),
                            ('lockout_lsp_id', (YLeaf(YType.uint16, 'lockout-lsp-id'), ['int'])),
                            ('origination', (YLeaf(YType.enumeration, 'origination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FlexLspLockoutOrigination', '')])),
                        ])
                        self.fault_ldi_lockout = None
                        self.fault_ldi = None
                        self.fault_lkr = None
                        self.fault_ais = None
                        self.fault_time = None
                        self.fault_in_label = None
                        self.is_lockout = None
                        self.lockout_timestamp = None
                        self.lockout_lsp_id = None
                        self.origination = None
                        self._segment_path = lambda: "flex-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo, ['fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time', 'fault_in_label', 'is_lockout', 'lockout_timestamp', 'lockout_lsp_id', 'origination'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo']['meta_info']


                class Destination(_Entity_):
                    """
                    Destinations array
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:  :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:  :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionCause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of  		 :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of  		 :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("inter-area-reoptimization", ("inter_area_reoptimization", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization)), ("path-option-entry", ("path_option_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry)), ("path-option", ("path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('destination_state', (YLeaf(YType.enumeration, 'destination-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeDestinationState', '')])),
                            ('active_path_option_index', (YLeaf(YType.uint32, 'active-path-option-index'), ['int'])),
                            ('path_option_exhausted', (YLeaf(YType.boolean, 'path-option-exhausted'), ['bool'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('path_change_time', (YLeaf(YType.uint32, 'path-change-time'), ['int'])),
                            ('total_uptime', (YLeaf(YType.uint32, 'total-uptime'), ['int'])),
                            ('s2l_exist', (YLeaf(YType.boolean, 's2l-exist'), ['bool'])),
                            ('destination_deletion_cause', (YLeaf(YType.enumeration, 'destination-deletion-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionCause', '')])),
                            ('destination_deletion_sub_cause', (YLeaf(YType.enumeration, 'destination-deletion-sub-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ('destination_deletion_timestamp', (YLeaf(YType.uint32, 'destination-deletion-timestamp'), ['int'])),
                            ('is_inter_area', (YLeaf(YType.boolean, 'is-inter-area'), ['bool'])),
                        ])
                        self.destination_address = None
                        self.destination_state = None
                        self.active_path_option_index = None
                        self.path_option_exhausted = None
                        self.uptime = None
                        self.path_change_time = None
                        self.total_uptime = None
                        self.s2l_exist = None
                        self.destination_deletion_cause = None
                        self.destination_deletion_sub_cause = None
                        self.destination_deletion_timestamp = None
                        self.is_inter_area = None

                        self.inter_area_reoptimization = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"

                        self.path_option_entry = YList(self)
                        self.path_option = YList(self)
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination, ['destination_address', 'destination_state', 'active_path_option_index', 'path_option_exhausted', 'uptime', 'path_change_time', 'total_uptime', 's2l_exist', 'destination_deletion_cause', 'destination_deletion_sub_cause', 'destination_deletion_timestamp', 'is_inter_area'], name, value)


                    class InterAreaReoptimization(_Entity_):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sent_path_queries', (YLeaf(YType.uint16, 'sent-path-queries'), ['int'])),
                                ('time_since_last_query_sent', (YLeaf(YType.uint32, 'time-since-last-query-sent'), ['int'])),
                                ('received_preferred_path_errors', (YLeaf(YType.uint16, 'received-preferred-path-errors'), ['int'])),
                                ('time_since_last_preferred_path_error', (YLeaf(YType.uint32, 'time-since-last-preferred-path-error'), ['int'])),
                                ('received_preferred_tree_errors', (YLeaf(YType.uint16, 'received-preferred-tree-errors'), ['int'])),
                                ('time_since_last_preferred_tree_error', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-error'), ['int'])),
                                ('preferred_path_error_node', (YLeaf(YType.str, 'preferred-path-error-node'), ['str'])),
                                ('preferred_tree_error_node', (YLeaf(YType.str, 'preferred-tree-error-node'), ['str'])),
                            ])
                            self.sent_path_queries = None
                            self.time_since_last_query_sent = None
                            self.received_preferred_path_errors = None
                            self.time_since_last_preferred_path_error = None
                            self.received_preferred_tree_errors = None
                            self.time_since_last_preferred_tree_error = None
                            self.preferred_path_error_node = None
                            self.preferred_tree_error_node = None
                            self._segment_path = lambda: "inter-area-reoptimization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, ['sent_path_queries', 'time_since_last_query_sent', 'received_preferred_path_errors', 'time_since_last_preferred_path_error', 'received_preferred_tree_errors', 'time_since_last_preferred_tree_error', 'preferred_path_error_node', 'preferred_tree_error_node'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization']['meta_info']


                    class PathOptionEntry(_Entity_):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry']['meta_info']


                    class PathOption(_Entity_):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads.TunnelHead']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2pP2mpTunnel.TunnelHeads']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.P2pP2mpTunnel']['meta_info']


    class TopologyNodes(_Entity_):
        """
        A node in the MPLS\-TE topology
        
        .. attribute:: topology_node
        
        	A node in the MPLS\-TE topology
        	**type**\: list of  		 :py:class:`TopologyNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.TopologyNodes, self).__init__()

            self.yang_name = "topology-nodes"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("topology-node", ("topology_node", MplsTe.TopologyNodes.TopologyNode))])
            self._leafs = OrderedDict()

            self.topology_node = YList(self)
            self._segment_path = lambda: "topology-nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.TopologyNodes, [], name, value)


        class TopologyNode(_Entity_):
            """
            A node in the MPLS\-TE topology
            
            .. attribute:: protocol  (key)
            
            	IGP protocol type
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: igp_id  (key)
            
            	IGP instance
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: area  (key)
            
            	IGP area
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: topology_node_type  (key)
            
            	Node type
            	**type**\:  :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            	**config**\: False
            
            .. attribute:: igp_node_id  (key)
            
            	IGP Node ID
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:  :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg>`
            
            	**config**\: False
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of  		 :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.TopologyNodes.TopologyNode, self).__init__()

                self.yang_name = "topology-node"
                self.yang_parent_name = "topology-nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','igp_id','area','topology_node_type','igp_node_id']
                self._child_classes = OrderedDict([("topology-node-sid-and-srbg", ("topology_node_sid_and_srbg", MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg)), ("topology-node-link", ("topology_node_link", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                    ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                    ('topology_node_type', (YLeaf(YType.enumeration, 'topology-node-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeNode', '')])),
                    ('igp_node_id', (YLeaf(YType.str, 'igp-node-id'), ['str'])),
                    ('topology_node_te_router_id', (YLeaf(YType.str, 'topology-node-te-router-id'), ['str'])),
                    ('topology_node_overloaded', (YLeaf(YType.boolean, 'topology-node-overloaded'), ['bool'])),
                ])
                self.protocol = None
                self.igp_id = None
                self.area = None
                self.topology_node_type = None
                self.igp_node_id = None
                self.topology_node_te_router_id = None
                self.topology_node_overloaded = None

                self.topology_node_sid_and_srbg = MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"

                self.topology_node_link = YList(self)
                self._segment_path = lambda: "topology-node" + "[protocol='" + str(self.protocol) + "']" + "[igp-id='" + str(self.igp_id) + "']" + "[area='" + str(self.area) + "']" + "[topology-node-type='" + str(self.topology_node_type) + "']" + "[igp-node-id='" + str(self.igp_node_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology-nodes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.TopologyNodes.TopologyNode, ['protocol', 'igp_id', 'area', 'topology_node_type', 'igp_node_id', 'topology_node_te_router_id', 'topology_node_overloaded'], name, value)


            class TopologyNodeSidAndSrbg(_Entity_):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                        ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                        ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                        ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                    ])
                    self.segment_id = None
                    self.segment_id_local_absolute_value = None
                    self.srgb_start = None
                    self.srgb_size = None
                    self._segment_path = lambda: "topology-node-sid-and-srbg"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg']['meta_info']


            class TopologyNodeLink(_Entity_):
                """
                This node's link information
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:  :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth>`
                
                	**config**\: False
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: min_max_delay
                
                	Minimum and maximum measured link delay
                	**type**\:  :py:class:`MinMaxDelay <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay>`
                
                	**config**\: False
                
                .. attribute:: loss
                
                	Link Loss
                	**type**\:  :py:class:`Loss <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss>`
                
                	**config**\: False
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:  :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                	**config**\: False
                
                .. attribute:: delay_variation
                
                	Delay Variation
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: residual_bandwidth
                
                	Residual Bandwidth (kbytes per seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Available Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: utilized_bandwidth
                
                	Utilized Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of  		 :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of  		 :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("topology-link-bandwidth", ("topology_link_bandwidth", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth)), ("odu-link-capabilities", ("odu_link_capabilities", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities)), ("min-max-delay", ("min_max_delay", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay)), ("loss", ("loss", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss)), ("topology-link-extended-affinity-bit", ("topology_link_extended_affinity_bit", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup)), ("adjacency-sid", ("adjacency_sid", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid))])
                    self._leafs = OrderedDict([
                        ('topology_link_type', (YLeaf(YType.enumeration, 'topology-link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('topology_link_interface_address', (YLeaf(YType.str, 'topology-link-interface-address'), ['str'])),
                        ('topology_link_interface_id', (YLeaf(YType.uint32, 'topology-link-interface-id'), ['int'])),
                        ('topology_link_neighbor_address', (YLeaf(YType.str, 'topology-link-neighbor-address'), ['str'])),
                        ('topology_link_neighbor_id', (YLeaf(YType.uint32, 'topology-link-neighbor-id'), ['int'])),
                        ('topology_link_neighbor_system_id', (YLeaf(YType.str, 'topology-link-neighbor-system-id'), ['str'])),
                        ('topology_link_neighbor_node_id', (YLeaf(YType.uint32, 'topology-link-neighbor-node-id'), ['int'])),
                        ('topology_link_neighbor_generation', (YLeaf(YType.uint32, 'topology-link-neighbor-generation'), ['int'])),
                        ('topology_link_fragment_id', (YLeaf(YType.uint32, 'topology-link-fragment-id'), ['int'])),
                        ('topology_link_te_metric', (YLeaf(YType.uint32, 'topology-link-te-metric'), ['int'])),
                        ('topology_link_igp_metric', (YLeaf(YType.uint32, 'topology-link-igp-metric'), ['int'])),
                        ('topology_link_uni_delay', (YLeaf(YType.uint32, 'topology-link-uni-delay'), ['int'])),
                        ('topology_link_affinity_bits', (YLeaf(YType.uint32, 'topology-link-affinity-bits'), ['int'])),
                        ('topology_link_switching_capability', (YLeaf(YType.uint8, 'topology-link-switching-capability'), ['int'])),
                        ('topology_link_encoding', (YLeaf(YType.uint8, 'topology-link-encoding'), ['int'])),
                        ('topology_link_bandwidth_model', (YLeaf(YType.enumeration, 'topology-link-bandwidth-model'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLibBwModel', '')])),
                        ('delay_variation', (YLeaf(YType.uint32, 'delay-variation'), ['int'])),
                        ('residual_bandwidth', (YLeaf(YType.uint32, 'residual-bandwidth'), ['int'])),
                        ('available_bandwidth', (YLeaf(YType.uint32, 'available-bandwidth'), ['int'])),
                        ('utilized_bandwidth', (YLeaf(YType.uint32, 'utilized-bandwidth'), ['int'])),
                    ])
                    self.topology_link_type = None
                    self.topology_link_interface_address = None
                    self.topology_link_interface_id = None
                    self.topology_link_neighbor_address = None
                    self.topology_link_neighbor_id = None
                    self.topology_link_neighbor_system_id = None
                    self.topology_link_neighbor_node_id = None
                    self.topology_link_neighbor_generation = None
                    self.topology_link_fragment_id = None
                    self.topology_link_te_metric = None
                    self.topology_link_igp_metric = None
                    self.topology_link_uni_delay = None
                    self.topology_link_affinity_bits = None
                    self.topology_link_switching_capability = None
                    self.topology_link_encoding = None
                    self.topology_link_bandwidth_model = None
                    self.delay_variation = None
                    self.residual_bandwidth = None
                    self.available_bandwidth = None
                    self.utilized_bandwidth = None

                    self.topology_link_bandwidth = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"

                    self.odu_link_capabilities = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.min_max_delay = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay()
                    self.min_max_delay.parent = self
                    self._children_name_map["min_max_delay"] = "min-max-delay"

                    self.loss = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss()
                    self.loss.parent = self
                    self._children_name_map["loss"] = "loss"

                    self.topology_link_extended_affinity_bit = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.adjacency_sid = YList(self)
                    self._segment_path = lambda: "topology-node-link"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink, ['topology_link_type', 'topology_link_interface_address', 'topology_link_interface_id', 'topology_link_neighbor_address', 'topology_link_neighbor_id', 'topology_link_neighbor_system_id', 'topology_link_neighbor_node_id', 'topology_link_neighbor_generation', 'topology_link_fragment_id', 'topology_link_te_metric', 'topology_link_igp_metric', 'topology_link_uni_delay', 'topology_link_affinity_bits', 'topology_link_switching_capability', 'topology_link_encoding', 'topology_link_bandwidth_model', 'delay_variation', 'residual_bandwidth', 'available_bandwidth', 'utilized_bandwidth'], name, value)


                class TopologyLinkBandwidth(_Entity_):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("topology-link-bandwidth-prestandard", ("topology_link_bandwidth_prestandard", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard)), ("topology-link-bandwidth-standard", ("topology_link_bandwidth_standard", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard))])
                        self._leafs = OrderedDict([
                            ('bandwidth_migration_mode', (YLeaf(YType.enumeration, 'bandwidth-migration-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.bandwidth_migration_mode = None

                        self.topology_link_bandwidth_prestandard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"

                        self.topology_link_bandwidth_standard = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._segment_path = lambda: "topology-link-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, ['bandwidth_migration_mode'], name, value)


                    class TopologyLinkBandwidthPrestandard(_Entity_):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-detail", ("topology_link_prestandard_bandwidth_detail", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail))])
                            self._leafs = OrderedDict([
                                ('topology_link_prestandard_bandwidth_physical', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-physical'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_global', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-global'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_subpool', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-subpool'), ['int'])),
                            ])
                            self.topology_link_prestandard_bandwidth_physical = None
                            self.topology_link_prestandard_bandwidth_reservation_global = None
                            self.topology_link_prestandard_bandwidth_reservation_subpool = None

                            self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-prestandard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, ['topology_link_prestandard_bandwidth_physical', 'topology_link_prestandard_bandwidth_reservation_global', 'topology_link_prestandard_bandwidth_reservation_subpool'], name, value)


                        class TopologyLinkPrestandardBandwidthDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-allocated", ("topology_link_prestandard_bandwidth_allocated", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated)), ("topology-link-prestandard-bandwidth-available-global", ("topology_link_prestandard_bandwidth_available_global", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal)), ("topology-link-prestandard-bandwidth-available-subpool", ("topology_link_prestandard_bandwidth_available_subpool", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool))])
                                self._leafs = OrderedDict()

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)
                                self._segment_path = lambda: "topology-link-prestandard-bandwidth-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, [], name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(_Entity_):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(_Entity_):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-global"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(_Entity_):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-subpool"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard']['meta_info']


                    class TopologyLinkBandwidthStandard(_Entity_):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topo-link-std-bw-detail", ("topo_link_std_bw_detail", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail))])
                            self._leafs = OrderedDict([
                                ('topo_link_std_bw_physical', (YLeaf(YType.uint32, 'topo-link-std-bw-physical'), ['int'])),
                                ('topo_link_std_bw_res_max', (YLeaf(YType.uint32, 'topo-link-std-bw-res-max'), ['int'])),
                                ('topo_link_std_bw_res_pool0', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool0'), ['int'])),
                                ('topo_link_std_bw_res_pool1', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool1'), ['int'])),
                            ])
                            self.topo_link_std_bw_physical = None
                            self.topo_link_std_bw_res_max = None
                            self.topo_link_std_bw_res_pool0 = None
                            self.topo_link_std_bw_res_pool1 = None

                            self.topo_link_std_bw_detail = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-standard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, ['topo_link_std_bw_physical', 'topo_link_std_bw_res_max', 'topo_link_std_bw_res_pool0', 'topo_link_std_bw_res_pool1'], name, value)


                        class TopoLinkStdBwDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topo-link-std-bw-allocated", ("topo_link_std_bw_allocated", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated)), ("topo-link-std-bw-available", ("topo_link_std_bw_available", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable))])
                                self._leafs = OrderedDict()

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)
                                self._segment_path = lambda: "topo-link-std-bw-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, [], name, value)


                            class TopoLinkStdBwAllocated(_Entity_):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated']['meta_info']


                            class TopoLinkStdBwAvailable(_Entity_):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's available bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-available"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth']['meta_info']


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities']['meta_info']


                class MinMaxDelay(_Entity_):
                    """
                    Minimum and maximum measured link delay
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_delay
                    
                    	Mimimum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_delay
                    
                    	Maximum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay, self).__init__()

                        self.yang_name = "min-max-delay"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('minimum_delay', (YLeaf(YType.uint32, 'minimum-delay'), ['int'])),
                            ('maximum_delay', (YLeaf(YType.uint32, 'maximum-delay'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.minimum_delay = None
                        self.maximum_delay = None
                        self._segment_path = lambda: "min-max-delay"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay, ['anomalous_bit', 'minimum_delay', 'maximum_delay'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay']['meta_info']


                class Loss(_Entity_):
                    """
                    Link Loss
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: loss_value
                    
                    	Loss Value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss, self).__init__()

                        self.yang_name = "loss"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('loss_value', (YLeaf(YType.uint32, 'loss-value'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.loss_value = None
                        self._segment_path = lambda: "loss"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss, ['anomalous_bit', 'loss_value'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.Loss']['meta_info']


                class TopologyLinkExtendedAffinityBit(_Entity_):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	The link's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "topology-link-extended-affinity-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup']['meta_info']


                class AdjacencySid(_Entity_):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('adjacency_sid', (YLeaf(YType.uint32, 'adjacency-sid'), ['int'])),
                            ('link_type', (YLeaf(YType.enumeration, 'link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('nbr_node_igpid', (YLeaf(YType.str, 'nbr-node-igpid'), ['str'])),
                            ('nbr_node_te_router_id', (YLeaf(YType.str, 'nbr-node-te-router-id'), ['str'])),
                            ('flag_f', (YLeaf(YType.boolean, 'flag-f'), ['bool'])),
                            ('flag_b', (YLeaf(YType.boolean, 'flag-b'), ['bool'])),
                            ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                            ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                            ('flag_s', (YLeaf(YType.boolean, 'flag-s'), ['bool'])),
                        ])
                        self.adjacency_sid = None
                        self.link_type = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.nbr_node_igpid = None
                        self.nbr_node_te_router_id = None
                        self.flag_f = None
                        self.flag_b = None
                        self.flag_v = None
                        self.flag_l = None
                        self.flag_s = None
                        self._segment_path = lambda: "adjacency-sid"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, ['adjacency_sid', 'link_type', 'local_addr', 'remote_addr', 'nbr_node_igpid', 'nbr_node_te_router_id', 'flag_f', 'flag_b', 'flag_v', 'flag_l', 'flag_s'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.TopologyNodes.TopologyNode.TopologyNodeLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.TopologyNodes.TopologyNode']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.TopologyNodes']['meta_info']


    class AnnounceTunnelsInfo(_Entity_):
        """
        Announced tunnels (forwarding adjacency and
        autoroute annonce)
        
        .. attribute:: autoroute_announce_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:  :py:class:`AutorouteAnnounceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable>`
        
        	**config**\: False
        
        .. attribute:: all_autoroute_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:  :py:class:`AllAutorouteTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AnnounceTunnelsInfo, self).__init__()

            self.yang_name = "announce-tunnels-info"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("autoroute-announce-table", ("autoroute_announce_table", MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable)), ("all-autoroute-table", ("all_autoroute_table", MplsTe.AnnounceTunnelsInfo.AllAutorouteTable))])
            self._leafs = OrderedDict()

            self.autoroute_announce_table = MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable()
            self.autoroute_announce_table.parent = self
            self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"

            self.all_autoroute_table = MplsTe.AnnounceTunnelsInfo.AllAutorouteTable()
            self.all_autoroute_table.parent = self
            self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
            self._segment_path = lambda: "announce-tunnels-info"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AnnounceTunnelsInfo, [], name, value)


        class AutorouteAnnounceTable(_Entity_):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of  		 :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__init__()

                self.yang_name = "autoroute-announce-table"
                self.yang_parent_name = "announce-tunnels-info"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("announce-dest", ("announce_dest", MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest))])
                self._leafs = OrderedDict()

                self.announce_dest = YList(self)
                self._segment_path = lambda: "autoroute-announce-table"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable, [], name, value)


            class AnnounceDest(_Entity_):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: protocol  (key)
                
                	The IGP protocol used by the tunnel
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_id  (key)
                
                	IGP Instance ID
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of  		 :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "autoroute-announce-table"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['destination_address','protocol','area','igp_id']
                    self._child_classes = OrderedDict([("total-tunnel", ("total_tunnel", MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('destination', (YLeaf(YType.str, 'destination'), ['str'])),
                        ('announced_tunnels_count', (YLeaf(YType.uint16, 'announced-tunnels-count'), ['int'])),
                        ('autorouted_tunnels_count', (YLeaf(YType.uint16, 'autorouted-tunnels-count'), ['int'])),
                        ('forwarding_adjacency_tunnels_count', (YLeaf(YType.uint16, 'forwarding-adjacency-tunnels-count'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                    ])
                    self.destination_address = None
                    self.protocol = None
                    self.area = None
                    self.igp_id = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.destination = None
                    self.announced_tunnels_count = None
                    self.autorouted_tunnels_count = None
                    self.forwarding_adjacency_tunnels_count = None
                    self.area_format = None

                    self.total_tunnel = YList(self)
                    self._segment_path = lambda: "announce-dest" + "[destination-address='" + str(self.destination_address) + "']" + "[protocol='" + str(self.protocol) + "']" + "[area='" + str(self.area) + "']" + "[igp-id='" + str(self.igp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/autoroute-announce-table/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, ['destination_address', 'protocol', 'area', 'igp_id', 'igp_type', 'igp_instance', 'igp_area', 'destination', 'announced_tunnels_count', 'autorouted_tunnels_count', 'forwarding_adjacency_tunnels_count', 'area_format'], name, value)


                class TotalTunnel(_Entity_):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:  :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:  :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                            ('tunnel_loadshare', (YLeaf(YType.uint32, 'tunnel-loadshare'), ['int'])),
                            ('announce_type', (YLeaf(YType.enumeration, 'announce-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelAnnounce', '')])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteAaMetricMode', '')])),
                            ('igp_metric', (YLeaf(YType.int32, 'igp-metric'), ['int'])),
                            ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                            ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                            ('is_auto_mesh_aa', (YLeaf(YType.boolean, 'is-auto-mesh-aa'), ['bool'])),
                            ('is_sr', (YLeaf(YType.boolean, 'is-sr'), ['bool'])),
                            ('is_sr_strict', (YLeaf(YType.boolean, 'is-sr-strict'), ['bool'])),
                            ('mesh_group_idaa', (YLeaf(YType.uint32, 'mesh-group-idaa'), ['int'])),
                            ('is_exclude_segment_routing', (YLeaf(YType.boolean, 'is-exclude-segment-routing'), ['bool'])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_sig_name = None
                        self.tunnel_loadshare = None
                        self.announce_type = None
                        self.next_hop_address = None
                        self.mode = None
                        self.igp_metric = None
                        self.hold_time = None
                        self.area_format = None
                        self.is_auto_mesh_aa = None
                        self.is_sr = None
                        self.is_sr_strict = None
                        self.mesh_group_idaa = None
                        self.is_exclude_segment_routing = None

                        self.ig_ps = YList(self)
                        self._segment_path = lambda: "total-tunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, ['tunnel_name', 'tunnel_sig_name', 'tunnel_loadshare', 'announce_type', 'next_hop_address', 'mode', 'igp_metric', 'hold_time', 'area_format', 'is_auto_mesh_aa', 'is_sr', 'is_sr_strict', 'mesh_group_idaa', 'is_exclude_segment_routing'], name, value)


                    class IgPs(_Entity_):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ])
                            self.igp_area_id = None
                            self.afi = None
                            self._segment_path = lambda: "ig-ps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, ['igp_area_id', 'afi'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AutorouteAnnounceTable']['meta_info']


        class AllAutorouteTable(_Entity_):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of  		 :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable, self).__init__()

                self.yang_name = "all-autoroute-table"
                self.yang_parent_name = "announce-tunnels-info"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("announce-dest", ("announce_dest", MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest))])
                self._leafs = OrderedDict()

                self.announce_dest = YList(self)
                self._segment_path = lambda: "all-autoroute-table"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable, [], name, value)


            class AnnounceDest(_Entity_):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: protocol  (key)
                
                	The IGP protocol used by the tunnel
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_id  (key)
                
                	IGP Instance ID
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of  		 :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "all-autoroute-table"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['destination_address','protocol','area','igp_id']
                    self._child_classes = OrderedDict([("total-tunnel", ("total_tunnel", MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('destination', (YLeaf(YType.str, 'destination'), ['str'])),
                        ('announced_tunnels_count', (YLeaf(YType.uint16, 'announced-tunnels-count'), ['int'])),
                        ('autorouted_tunnels_count', (YLeaf(YType.uint16, 'autorouted-tunnels-count'), ['int'])),
                        ('forwarding_adjacency_tunnels_count', (YLeaf(YType.uint16, 'forwarding-adjacency-tunnels-count'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                    ])
                    self.destination_address = None
                    self.protocol = None
                    self.area = None
                    self.igp_id = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.destination = None
                    self.announced_tunnels_count = None
                    self.autorouted_tunnels_count = None
                    self.forwarding_adjacency_tunnels_count = None
                    self.area_format = None

                    self.total_tunnel = YList(self)
                    self._segment_path = lambda: "announce-dest" + "[destination-address='" + str(self.destination_address) + "']" + "[protocol='" + str(self.protocol) + "']" + "[area='" + str(self.area) + "']" + "[igp-id='" + str(self.igp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/announce-tunnels-info/all-autoroute-table/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, ['destination_address', 'protocol', 'area', 'igp_id', 'igp_type', 'igp_instance', 'igp_area', 'destination', 'announced_tunnels_count', 'autorouted_tunnels_count', 'forwarding_adjacency_tunnels_count', 'area_format'], name, value)


                class TotalTunnel(_Entity_):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:  :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:  :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                            ('tunnel_loadshare', (YLeaf(YType.uint32, 'tunnel-loadshare'), ['int'])),
                            ('announce_type', (YLeaf(YType.enumeration, 'announce-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelAnnounce', '')])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteAaMetricMode', '')])),
                            ('igp_metric', (YLeaf(YType.int32, 'igp-metric'), ['int'])),
                            ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                            ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                            ('is_auto_mesh_aa', (YLeaf(YType.boolean, 'is-auto-mesh-aa'), ['bool'])),
                            ('is_sr', (YLeaf(YType.boolean, 'is-sr'), ['bool'])),
                            ('is_sr_strict', (YLeaf(YType.boolean, 'is-sr-strict'), ['bool'])),
                            ('mesh_group_idaa', (YLeaf(YType.uint32, 'mesh-group-idaa'), ['int'])),
                            ('is_exclude_segment_routing', (YLeaf(YType.boolean, 'is-exclude-segment-routing'), ['bool'])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_sig_name = None
                        self.tunnel_loadshare = None
                        self.announce_type = None
                        self.next_hop_address = None
                        self.mode = None
                        self.igp_metric = None
                        self.hold_time = None
                        self.area_format = None
                        self.is_auto_mesh_aa = None
                        self.is_sr = None
                        self.is_sr_strict = None
                        self.mesh_group_idaa = None
                        self.is_exclude_segment_routing = None

                        self.ig_ps = YList(self)
                        self._segment_path = lambda: "total-tunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, ['tunnel_name', 'tunnel_sig_name', 'tunnel_loadshare', 'announce_type', 'next_hop_address', 'mode', 'igp_metric', 'hold_time', 'area_format', 'is_auto_mesh_aa', 'is_sr', 'is_sr_strict', 'mesh_group_idaa', 'is_exclude_segment_routing'], name, value)


                    class IgPs(_Entity_):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ])
                            self.igp_area_id = None
                            self.afi = None
                            self._segment_path = lambda: "ig-ps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, ['igp_area_id', 'afi'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AnnounceTunnelsInfo.AllAutorouteTable']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AnnounceTunnelsInfo']['meta_info']


    class CollaboratorTimers(_Entity_):
        """
        TE Collaborator timer status
        
        .. attribute:: p2mp_timer
        
        	Description of all P2MP timers
        	**type**\: list of  		 :py:class:`P2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.CollaboratorTimers.P2mpTimer>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.CollaboratorTimers, self).__init__()

            self.yang_name = "collaborator-timers"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("p2mp-timer", ("p2mp_timer", MplsTe.CollaboratorTimers.P2mpTimer))])
            self._leafs = OrderedDict()

            self.p2mp_timer = YList(self)
            self._segment_path = lambda: "collaborator-timers"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.CollaboratorTimers, [], name, value)


        class P2mpTimer(_Entity_):
            """
            Description of all P2MP timers
            
            .. attribute:: timer_type
            
            	Timer Type
            	**type**\:  :py:class:`MplsTeP2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2mpTimer>`
            
            	**config**\: False
            
            .. attribute:: timer_name
            
            	Timer Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: start_time
            
            	Date when timer was last started in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: expiry_time
            
            	Date when the timer last expired in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: stop_time
            
            	Date when the timer was last stopped in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: duration
            
            	The expiry delay in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: is_running
            
            	True if the timer is running
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.CollaboratorTimers.P2mpTimer, self).__init__()

                self.yang_name = "p2mp-timer"
                self.yang_parent_name = "collaborator-timers"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('timer_type', (YLeaf(YType.enumeration, 'timer-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeP2mpTimer', '')])),
                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                    ('start_time', (YLeaf(YType.uint32, 'start-time'), ['int'])),
                    ('expiry_time', (YLeaf(YType.uint32, 'expiry-time'), ['int'])),
                    ('stop_time', (YLeaf(YType.uint32, 'stop-time'), ['int'])),
                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                    ('is_running', (YLeaf(YType.boolean, 'is-running'), ['bool'])),
                ])
                self.timer_type = None
                self.timer_name = None
                self.start_time = None
                self.expiry_time = None
                self.stop_time = None
                self.duration = None
                self.is_running = None
                self._segment_path = lambda: "p2mp-timer"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/collaborator-timers/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.CollaboratorTimers.P2mpTimer, ['timer_type', 'timer_name', 'start_time', 'expiry_time', 'stop_time', 'duration', 'is_running'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.CollaboratorTimers.P2mpTimer']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.CollaboratorTimers']['meta_info']


    class AutoTunnel(_Entity_):
        """
        Auto tunnel information.
        
        .. attribute:: pcc
        
        	Auto tunnel PCC (Path Computation Client) information
        	**type**\:  :py:class:`Pcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Pcc>`
        
        	**config**\: False
        
        .. attribute:: mesh
        
        	Auto tunnel mesh information
        	**type**\:  :py:class:`Mesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh>`
        
        	**config**\: False
        
        .. attribute:: backup
        
        	Auto tunnel backup information
        	**type**\:  :py:class:`Backup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AutoTunnel, self).__init__()

            self.yang_name = "auto-tunnel"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("pcc", ("pcc", MplsTe.AutoTunnel.Pcc)), ("mesh", ("mesh", MplsTe.AutoTunnel.Mesh)), ("backup", ("backup", MplsTe.AutoTunnel.Backup))])
            self._leafs = OrderedDict()

            self.pcc = MplsTe.AutoTunnel.Pcc()
            self.pcc.parent = self
            self._children_name_map["pcc"] = "pcc"

            self.mesh = MplsTe.AutoTunnel.Mesh()
            self.mesh.parent = self
            self._children_name_map["mesh"] = "mesh"

            self.backup = MplsTe.AutoTunnel.Backup()
            self.backup.parent = self
            self._children_name_map["backup"] = "backup"
            self._segment_path = lambda: "auto-tunnel"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AutoTunnel, [], name, value)


        class Pcc(_Entity_):
            """
            Auto tunnel PCC (Path Computation Client)
            information.
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel pcc summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Pcc.Summary>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AutoTunnel.Pcc, self).__init__()

                self.yang_name = "pcc"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("summary", ("summary", MplsTe.AutoTunnel.Pcc.Summary))])
                self._leafs = OrderedDict()

                self.summary = MplsTe.AutoTunnel.Pcc.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._segment_path = lambda: "pcc"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AutoTunnel.Pcc, [], name, value)


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel pcc summary information
                
                .. attribute:: pcc_auto_tunnel
                
                	Total number of stateful PCE client auto\-tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Pcc.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "pcc"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pcc_auto_tunnel', (YLeaf(YType.uint32, 'pcc-auto-tunnel'), ['int'])),
                        ('up_pcc_auto_tunnels', (YLeaf(YType.uint32, 'up-pcc-auto-tunnels'), ['int'])),
                        ('down_pcc_auto_tunnels', (YLeaf(YType.uint32, 'down-pcc-auto-tunnels'), ['int'])),
                    ])
                    self.pcc_auto_tunnel = None
                    self.up_pcc_auto_tunnels = None
                    self.down_pcc_auto_tunnels = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/pcc/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Pcc.Summary, ['pcc_auto_tunnel', 'up_pcc_auto_tunnels', 'down_pcc_auto_tunnels'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Pcc.Summary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AutoTunnel.Pcc']['meta_info']


        class Mesh(_Entity_):
            """
            Auto tunnel mesh information.
            
            .. attribute:: mesh_groups
            
            	Display auto\-tunnel mesh group
            	**type**\:  :py:class:`MeshGroups <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups>`
            
            	**config**\: False
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel mesh counters (stats) information
            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Statistics>`
            
            	**config**\: False
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel mesh summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Summary>`
            
            	**config**\: False
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel mesh configuration information
            	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.Config>`
            
            	**config**\: False
            
            .. attribute:: one_hop
            
            	MPLS TE auto\-tunnel mesh onehop information
            	**type**\:  :py:class:`OneHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AutoTunnel.Mesh, self).__init__()

                self.yang_name = "mesh"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("mesh-groups", ("mesh_groups", MplsTe.AutoTunnel.Mesh.MeshGroups)), ("statistics", ("statistics", MplsTe.AutoTunnel.Mesh.Statistics)), ("summary", ("summary", MplsTe.AutoTunnel.Mesh.Summary)), ("config", ("config", MplsTe.AutoTunnel.Mesh.Config)), ("one-hop", ("one_hop", MplsTe.AutoTunnel.Mesh.OneHop))])
                self._leafs = OrderedDict()

                self.mesh_groups = MplsTe.AutoTunnel.Mesh.MeshGroups()
                self.mesh_groups.parent = self
                self._children_name_map["mesh_groups"] = "mesh-groups"

                self.statistics = MplsTe.AutoTunnel.Mesh.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"

                self.summary = MplsTe.AutoTunnel.Mesh.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"

                self.config = MplsTe.AutoTunnel.Mesh.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"

                self.one_hop = MplsTe.AutoTunnel.Mesh.OneHop()
                self.one_hop.parent = self
                self._children_name_map["one_hop"] = "one-hop"
                self._segment_path = lambda: "mesh"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AutoTunnel.Mesh, [], name, value)


            class MeshGroups(_Entity_):
                """
                Display auto\-tunnel mesh group
                
                .. attribute:: mesh_group
                
                	Display auto\-tunnel mesh group information
                	**type**\: list of  		 :py:class:`MeshGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Mesh.MeshGroups, self).__init__()

                    self.yang_name = "mesh-groups"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("mesh-group", ("mesh_group", MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup))])
                    self._leafs = OrderedDict()

                    self.mesh_group = YList(self)
                    self._segment_path = lambda: "mesh-groups"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Mesh.MeshGroups, [], name, value)


                class MeshGroup(_Entity_):
                    """
                    Display auto\-tunnel mesh group information
                    
                    .. attribute:: mesh_group_id  (key)
                    
                    	Mesh group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_id_xr
                    
                    	Meshgroup ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_meshgroup_disabled
                    
                    	Is the meshgroup disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: attribute_set_name
                    
                    	Attribute set name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_attribute_set_configured
                    
                    	Is any attribute\-set associated to this meshgroup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_attribute_set_in_db
                    
                    	Flag to indicate the existence of attribute set found in database
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_destination_list_configured
                    
                    	Is any destiantion\-list associated to this meshgroup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_list_type
                    
                    	Type of the  destlist
                    	**type**\:  :py:class:`TeAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAcl>`
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_time
                    
                    	Remaining time for recreate timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: auto_mesh_tunnels
                    
                    	Total number of automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_total_destinations
                    
                    	Total number of destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_group_type
                    
                    	Meshgroup Type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination
                    
                    	List of destinations for this meshgroup
                    	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__init__()

                        self.yang_name = "mesh-group"
                        self.yang_parent_name = "mesh-groups"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['mesh_group_id']
                        self._child_classes = OrderedDict([("destination", ("destination", MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination))])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('mesh_group_id_xr', (YLeaf(YType.uint32, 'mesh-group-id-xr'), ['int'])),
                            ('is_meshgroup_disabled', (YLeaf(YType.boolean, 'is-meshgroup-disabled'), ['bool'])),
                            ('attribute_set_name', (YLeaf(YType.str, 'attribute-set-name'), ['str'])),
                            ('is_attribute_set_configured', (YLeaf(YType.boolean, 'is-attribute-set-configured'), ['bool'])),
                            ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                            ('destination_list_name', (YLeaf(YType.str, 'destination-list-name'), ['str'])),
                            ('is_destination_list_configured', (YLeaf(YType.boolean, 'is-destination-list-configured'), ['bool'])),
                            ('destination_list_type', (YLeaf(YType.enumeration, 'destination-list-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAcl', '')])),
                            ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                            ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_total_destinations', (YLeaf(YType.uint32, 'auto-mesh-total-destinations'), ['int'])),
                            ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                            ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                            ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_group_type', (YLeaf(YType.enumeration, 'auto-mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.mesh_group_id_xr = None
                        self.is_meshgroup_disabled = None
                        self.attribute_set_name = None
                        self.is_attribute_set_configured = None
                        self.is_attribute_set_in_db = None
                        self.destination_list_name = None
                        self.is_destination_list_configured = None
                        self.destination_list_type = None
                        self.remaining_time = None
                        self.auto_mesh_tunnels = None
                        self.auto_mesh_total_destinations = None
                        self.up_auto_mesh_tunnels = None
                        self.down_auto_mesh_tunnels = None
                        self.frr_auto_mesh_tunnels = None
                        self.auto_mesh_group_type = None

                        self.destination = YList(self)
                        self._segment_path = lambda: "mesh-group" + "[mesh-group-id='" + str(self.mesh_group_id) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/mesh-groups/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup, ['mesh_group_id', 'mesh_group_id_xr', 'is_meshgroup_disabled', 'attribute_set_name', 'is_attribute_set_configured', 'is_attribute_set_in_db', 'destination_list_name', 'is_destination_list_configured', 'destination_list_type', 'remaining_time', 'auto_mesh_tunnels', 'auto_mesh_total_destinations', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_group_type'], name, value)


                    class Destination(_Entity_):
                        """
                        List of destinations for this meshgroup
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: operational_status
                        
                        	Tunnel operational status
                        	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                        
                        	**config**\: False
                        
                        .. attribute:: remaining_time
                        
                        	Remaining time for unused timer in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__init__()

                            self.yang_name = "destination"
                            self.yang_parent_name = "mesh-group"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                ('operational_status', (YLeaf(YType.enumeration, 'operational-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                            ])
                            self.destination_address = None
                            self.tunnel_id = None
                            self.operational_status = None
                            self.remaining_time = None
                            self._segment_path = lambda: "destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, ['destination_address', 'tunnel_id', 'operational_status', 'remaining_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Mesh.MeshGroups.MeshGroup']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Mesh.MeshGroups']['meta_info']


            class Statistics(_Entity_):
                """
                MPLS TE auto\-tunnel mesh counters (stats)
                information
                
                .. attribute:: created
                
                	Number of connected automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: connected
                
                	Number of connected automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_unused
                
                	Number of automesh tunnels removed while unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_in_use
                
                	Number of automesh tunnels removed while up and in use
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_range_exceeded
                
                	Number of automesh tunnel attempts rejected because the total number exceeds the range
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_cleared_time
                
                	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Mesh.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('created', (YLeaf(YType.uint32, 'created'), ['int'])),
                        ('connected', (YLeaf(YType.uint32, 'connected'), ['int'])),
                        ('removed_unused', (YLeaf(YType.uint32, 'removed-unused'), ['int'])),
                        ('removed_in_use', (YLeaf(YType.uint32, 'removed-in-use'), ['int'])),
                        ('removed_range_exceeded', (YLeaf(YType.uint32, 'removed-range-exceeded'), ['int'])),
                        ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ])
                    self.created = None
                    self.connected = None
                    self.removed_unused = None
                    self.removed_in_use = None
                    self.removed_range_exceeded = None
                    self.last_cleared_time = None
                    self._segment_path = lambda: "statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Mesh.Statistics, ['created', 'connected', 'removed_unused', 'removed_in_use', 'removed_range_exceeded', 'last_cleared_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Mesh.Statistics']['meta_info']


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel mesh summary information
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Mesh.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                        ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                        ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_groups', (YLeaf(YType.uint32, 'auto-mesh-groups'), ['int'])),
                        ('auto_mesh_destinations', (YLeaf(YType.uint32, 'auto-mesh-destinations'), ['int'])),
                    ])
                    self.auto_mesh_tunnels = None
                    self.up_auto_mesh_tunnels = None
                    self.down_auto_mesh_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_groups = None
                    self.auto_mesh_destinations = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Mesh.Summary, ['auto_mesh_tunnels', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_groups', 'auto_mesh_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Mesh.Summary']['meta_info']


            class Config(_Entity_):
                """
                MPLS TE auto\-tunnel mesh configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel mesh feature is configured 
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Mesh.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                        ('unused_removal_timeout_configured', (YLeaf(YType.uint32, 'unused-removal-timeout-configured'), ['int'])),
                        ('min_tunnel_id', (YLeaf(YType.uint16, 'min-tunnel-id'), ['int'])),
                        ('max_tunnel_id', (YLeaf(YType.uint16, 'max-tunnel-id'), ['int'])),
                    ])
                    self.is_configured = None
                    self.unused_removal_timeout_configured = None
                    self.min_tunnel_id = None
                    self.max_tunnel_id = None
                    self._segment_path = lambda: "config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Mesh.Config, ['is_configured', 'unused_removal_timeout_configured', 'min_tunnel_id', 'max_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Mesh.Config']['meta_info']


            class OneHop(_Entity_):
                """
                MPLS TE auto\-tunnel mesh onehop information
                
                .. attribute:: interfaces
                
                	Display auto\-tunnel onehop interfaces
                	**type**\:  :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces>`
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	MPLS TE auto\-tunnel mesh onehop counters (stats) information
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Statistics>`
                
                	**config**\: False
                
                .. attribute:: summary
                
                	MPLS TE auto\-tunnel mesh onehop summary information
                	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Summary>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Mesh.OneHop, self).__init__()

                    self.yang_name = "one-hop"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("interfaces", ("interfaces", MplsTe.AutoTunnel.Mesh.OneHop.Interfaces)), ("statistics", ("statistics", MplsTe.AutoTunnel.Mesh.OneHop.Statistics)), ("summary", ("summary", MplsTe.AutoTunnel.Mesh.OneHop.Summary))])
                    self._leafs = OrderedDict()

                    self.interfaces = MplsTe.AutoTunnel.Mesh.OneHop.Interfaces()
                    self.interfaces.parent = self
                    self._children_name_map["interfaces"] = "interfaces"

                    self.statistics = MplsTe.AutoTunnel.Mesh.OneHop.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.summary = MplsTe.AutoTunnel.Mesh.OneHop.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._segment_path = lambda: "one-hop"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop, [], name, value)


                class Interfaces(_Entity_):
                    """
                    Display auto\-tunnel onehop interfaces
                    
                    .. attribute:: interface
                    
                    	Display auto\-tunnel mesh onehop interface information
                    	**type**\: list of  		 :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces, self).__init__()

                        self.yang_name = "interfaces"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("interface", ("interface", MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface))])
                        self._leafs = OrderedDict()

                        self.interface = YList(self)
                        self._segment_path = lambda: "interfaces"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces, [], name, value)


                    class Interface(_Entity_):
                        """
                        Display auto\-tunnel mesh onehop interface
                        information
                        
                        .. attribute:: interface_name  (key)
                        
                        	Interface Name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: interface_name_xr
                        
                        	Interface name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel
                        
                        	Onehop tunnels created for this interface
                        	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interfaces"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                ('interface_name_xr', (YLeaf(YType.str, 'interface-name-xr'), ['str'])),
                            ])
                            self.interface_name = None
                            self.interface_name_xr = None

                            self.tunnel = YList(self)
                            self._segment_path = lambda: "interface" + "[interface-name='" + str(self.interface_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/interfaces/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface, ['interface_name', 'interface_name_xr'], name, value)


                        class Tunnel(_Entity_):
                            """
                            Onehop tunnels created for this interface
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_lspid
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('tunnel_lspid', (YLeaf(YType.uint16, 'tunnel-lspid'), ['int'])),
                                    ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                ])
                                self.tunnel_id = None
                                self.destination_address = None
                                self.tunnel_lspid = None
                                self.mesh_group_id = None
                                self.tunnel_state = None
                                self._segment_path = lambda: "tunnel"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, ['tunnel_id', 'destination_address', 'tunnel_lspid', 'mesh_group_id', 'tunnel_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop.Interfaces.Interface']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop.Interfaces']['meta_info']


                class Statistics(_Entity_):
                    """
                    MPLS TE auto\-tunnel mesh onehop counters
                    (stats) information
                    
                    .. attribute:: created
                    
                    	Number of connected automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: connected
                    
                    	Number of connected automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_unused
                    
                    	Number of automesh tunnels removed while unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_in_use
                    
                    	Number of automesh tunnels removed while up and in use
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_range_exceeded
                    
                    	Number of automesh tunnel attempts rejected because the total number exceeds the range
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: last_cleared_time
                    
                    	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Mesh.OneHop.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('created', (YLeaf(YType.uint32, 'created'), ['int'])),
                            ('connected', (YLeaf(YType.uint32, 'connected'), ['int'])),
                            ('removed_unused', (YLeaf(YType.uint32, 'removed-unused'), ['int'])),
                            ('removed_in_use', (YLeaf(YType.uint32, 'removed-in-use'), ['int'])),
                            ('removed_range_exceeded', (YLeaf(YType.uint32, 'removed-range-exceeded'), ['int'])),
                            ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                        ])
                        self.created = None
                        self.connected = None
                        self.removed_unused = None
                        self.removed_in_use = None
                        self.removed_range_exceeded = None
                        self.last_cleared_time = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop.Statistics, ['created', 'connected', 'removed_unused', 'removed_in_use', 'removed_range_exceeded', 'last_cleared_time'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop.Statistics']['meta_info']


                class Summary(_Entity_):
                    """
                    MPLS TE auto\-tunnel mesh onehop summary
                    information
                    
                    .. attribute:: auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh onehop tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_one_hop_groups
                    
                    	Total number of automesh onehop mesh\-groups
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_one_hop_destinations
                    
                    	Total number of automesh onehop destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Mesh.OneHop.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'auto-mesh-one-hop-tunnels'), ['int'])),
                            ('up_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-one-hop-tunnels'), ['int'])),
                            ('down_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-one-hop-tunnels'), ['int'])),
                            ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_one_hop_groups', (YLeaf(YType.uint32, 'auto-mesh-one-hop-groups'), ['int'])),
                            ('auto_mesh_one_hop_destinations', (YLeaf(YType.uint32, 'auto-mesh-one-hop-destinations'), ['int'])),
                        ])
                        self.auto_mesh_one_hop_tunnels = None
                        self.up_auto_mesh_one_hop_tunnels = None
                        self.down_auto_mesh_one_hop_tunnels = None
                        self.frr_auto_mesh_tunnels = None
                        self.auto_mesh_one_hop_groups = None
                        self.auto_mesh_one_hop_destinations = None
                        self._segment_path = lambda: "summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Mesh.OneHop.Summary, ['auto_mesh_one_hop_tunnels', 'up_auto_mesh_one_hop_tunnels', 'down_auto_mesh_one_hop_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_one_hop_groups', 'auto_mesh_one_hop_destinations'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop.Summary']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Mesh.OneHop']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AutoTunnel.Mesh']['meta_info']


        class Backup(_Entity_):
            """
            Auto tunnel backup information.
            
            .. attribute:: tunnels
            
            	auto\-tunnel backup information
            	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Tunnels>`
            
            	**config**\: False
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel backup counters (stats) information
            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics>`
            
            	**config**\: False
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel backup summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Summary>`
            
            	**config**\: False
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel backup configuration information
            	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Config>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AutoTunnel.Backup, self).__init__()

                self.yang_name = "backup"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnels", ("tunnels", MplsTe.AutoTunnel.Backup.Tunnels)), ("statistics", ("statistics", MplsTe.AutoTunnel.Backup.Statistics)), ("summary", ("summary", MplsTe.AutoTunnel.Backup.Summary)), ("config", ("config", MplsTe.AutoTunnel.Backup.Config))])
                self._leafs = OrderedDict()

                self.tunnels = MplsTe.AutoTunnel.Backup.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"

                self.statistics = MplsTe.AutoTunnel.Backup.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"

                self.summary = MplsTe.AutoTunnel.Backup.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"

                self.config = MplsTe.AutoTunnel.Backup.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._segment_path = lambda: "backup"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AutoTunnel.Backup, [], name, value)


            class Tunnels(_Entity_):
                """
                auto\-tunnel backup information
                
                .. attribute:: tunnel
                
                	Display auto tunnel backup tunnel information
                	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Tunnels.Tunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Backup.Tunnels, self).__init__()

                    self.yang_name = "tunnels"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsTe.AutoTunnel.Backup.Tunnels.Tunnel))])
                    self._leafs = OrderedDict()

                    self.tunnel = YList(self)
                    self._segment_path = lambda: "tunnels"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Backup.Tunnels, [], name, value)


                class Tunnel(_Entity_):
                    """
                    Display auto tunnel backup tunnel information
                    
                    .. attribute:: backup_tunnel_name  (key)
                    
                    	Backup tunnel name
                    	**type**\: str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operational_status
                    
                    	Tunnel operational status
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_mode
                    
                    	SRLG exclude mode for this auto\-tunnel backup
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: atb_protection_type
                    
                    	Type of protection offered by this auto\-tunnel backup
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_flows
                    
                    	Number of protected flows
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_interface_name
                    
                    	Interface protected by this auto\-tunnel backup
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_router_id
                    
                    	Router ID of node protected by this auto\-tunnel backup
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Tunnels.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tunnels"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['backup_tunnel_name']
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('operational_status', (YLeaf(YType.enumeration, 'operational-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('srlg_mode', (YLeaf(YType.enumeration, 'srlg-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('atb_protection_type', (YLeaf(YType.enumeration, 'atb-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('protected_flows', (YLeaf(YType.uint32, 'protected-flows'), ['int'])),
                            ('protected_interface_name', (YLeaf(YType.str, 'protected-interface-name'), ['str'])),
                            ('protected_router_id', (YLeaf(YType.str, 'protected-router-id'), ['str'])),
                        ])
                        self.backup_tunnel_name = None
                        self.tunnel_name = None
                        self.operational_status = None
                        self.srlg_mode = None
                        self.atb_protection_type = None
                        self.protected_flows = None
                        self.protected_interface_name = None
                        self.protected_router_id = None
                        self._segment_path = lambda: "tunnel" + "[backup-tunnel-name='" + str(self.backup_tunnel_name) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/tunnels/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Tunnels.Tunnel, ['backup_tunnel_name', 'tunnel_name', 'operational_status', 'srlg_mode', 'atb_protection_type', 'protected_flows', 'protected_interface_name', 'protected_router_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Tunnels.Tunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Backup.Tunnels']['meta_info']


            class Statistics(_Entity_):
                """
                MPLS TE auto\-tunnel backup counters (stats)
                information
                
                .. attribute:: created
                
                	Number of connected auto backup tunnels
                	**type**\:  :py:class:`Created <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.Created>`
                
                	**config**\: False
                
                .. attribute:: connected
                
                	Number of connected auto backup tunnels
                	**type**\:  :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.Connected>`
                
                	**config**\: False
                
                .. attribute:: removed_down
                
                	Number of NNHOP auto backup tunnels removed while down
                	**type**\:  :py:class:`RemovedDown <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedDown>`
                
                	**config**\: False
                
                .. attribute:: removed_unused
                
                	Number of auto backup tunnels removed while unused
                	**type**\:  :py:class:`RemovedUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused>`
                
                	**config**\: False
                
                .. attribute:: removed_in_use
                
                	Number of auto backup tunnels removed while up and in use
                	**type**\:  :py:class:`RemovedInUse <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse>`
                
                	**config**\: False
                
                .. attribute:: removed_range_exceeded
                
                	Number of auto backup tunnel attempts rejected because the total number exceeds the range
                	**type**\:  :py:class:`RemovedRangeExceeded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded>`
                
                	**config**\: False
                
                .. attribute:: last_cleared_time
                
                	Timestamp when the stat has been cleared
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Backup.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("created", ("created", MplsTe.AutoTunnel.Backup.Statistics.Created)), ("connected", ("connected", MplsTe.AutoTunnel.Backup.Statistics.Connected)), ("removed-down", ("removed_down", MplsTe.AutoTunnel.Backup.Statistics.RemovedDown)), ("removed-unused", ("removed_unused", MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused)), ("removed-in-use", ("removed_in_use", MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse)), ("removed-range-exceeded", ("removed_range_exceeded", MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded))])
                    self._leafs = OrderedDict([
                        ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ])
                    self.last_cleared_time = None

                    self.created = MplsTe.AutoTunnel.Backup.Statistics.Created()
                    self.created.parent = self
                    self._children_name_map["created"] = "created"

                    self.connected = MplsTe.AutoTunnel.Backup.Statistics.Connected()
                    self.connected.parent = self
                    self._children_name_map["connected"] = "connected"

                    self.removed_down = MplsTe.AutoTunnel.Backup.Statistics.RemovedDown()
                    self.removed_down.parent = self
                    self._children_name_map["removed_down"] = "removed-down"

                    self.removed_unused = MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused()
                    self.removed_unused.parent = self
                    self._children_name_map["removed_unused"] = "removed-unused"

                    self.removed_in_use = MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse()
                    self.removed_in_use.parent = self
                    self._children_name_map["removed_in_use"] = "removed-in-use"

                    self.removed_range_exceeded = MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                    self.removed_range_exceeded.parent = self
                    self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                    self._segment_path = lambda: "statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics, ['last_cleared_time'], name, value)


                class Created(_Entity_):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.Created, self).__init__()

                        self.yang_name = "created"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "created"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.Created, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.Created']['meta_info']


                class Connected(_Entity_):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.Connected, self).__init__()

                        self.yang_name = "connected"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "connected"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.Connected, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.Connected']['meta_info']


                class RemovedDown(_Entity_):
                    """
                    Number of NNHOP auto backup tunnels removed
                    while down
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.RemovedDown, self).__init__()

                        self.yang_name = "removed-down"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-down"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.RemovedDown, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.RemovedDown']['meta_info']


                class RemovedUnused(_Entity_):
                    """
                    Number of auto backup tunnels removed while
                    unused
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused, self).__init__()

                        self.yang_name = "removed-unused"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-unused"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.RemovedUnused']['meta_info']


                class RemovedInUse(_Entity_):
                    """
                    Number of auto backup tunnels removed while up
                    and in use
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse, self).__init__()

                        self.yang_name = "removed-in-use"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-in-use"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.RemovedInUse']['meta_info']


                class RemovedRangeExceeded(_Entity_):
                    """
                    Number of auto backup tunnel attempts rejected
                    because the total number exceeds the range
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__init__()

                        self.yang_name = "removed-range-exceeded"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-range-exceeded"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics.RemovedRangeExceeded']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Backup.Statistics']['meta_info']


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel backup summary information
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Backup.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('autobackups', (YLeaf(YType.uint32, 'autobackups'), ['int'])),
                        ('up_autobackups', (YLeaf(YType.uint32, 'up-autobackups'), ['int'])),
                        ('down_autobackups', (YLeaf(YType.uint32, 'down-autobackups'), ['int'])),
                        ('unused_autobackups', (YLeaf(YType.uint32, 'unused-autobackups'), ['int'])),
                        ('next_hop_autobackups', (YLeaf(YType.uint32, 'next-hop-autobackups'), ['int'])),
                        ('next_next_hop_autobackups', (YLeaf(YType.uint32, 'next-next-hop-autobackups'), ['int'])),
                        ('srlg_strict_autobackups', (YLeaf(YType.uint32, 'srlg-strict-autobackups'), ['int'])),
                        ('srlg_preferred_autobackups', (YLeaf(YType.uint32, 'srlg-preferred-autobackups'), ['int'])),
                        ('srlg_weighted_autobackups', (YLeaf(YType.uint32, 'srlg-weighted-autobackups'), ['int'])),
                        ('next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                    ])
                    self.autobackups = None
                    self.up_autobackups = None
                    self.down_autobackups = None
                    self.unused_autobackups = None
                    self.next_hop_autobackups = None
                    self.next_next_hop_autobackups = None
                    self.srlg_strict_autobackups = None
                    self.srlg_preferred_autobackups = None
                    self.srlg_weighted_autobackups = None
                    self.next_hop_autobackup_protected_ls_ps = None
                    self.next_next_hop_autobackup_protected_ls_ps = None
                    self.next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_hop_autobackup_protected_s2l_families = None
                    self.next_next_hop_autobackup_protected_s2l_families = None
                    self.next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_hop_autobackup_protected_s2_ls = None
                    self.next_next_hop_autobackup_protected_s2_ls = None
                    self.next_hop_srlg_autobackup_protected_s2_ls = None
                    self.next_next_hop_srlg_autobackup_protected_s2_ls = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Backup.Summary, ['autobackups', 'up_autobackups', 'down_autobackups', 'unused_autobackups', 'next_hop_autobackups', 'next_next_hop_autobackups', 'srlg_strict_autobackups', 'srlg_preferred_autobackups', 'srlg_weighted_autobackups', 'next_hop_autobackup_protected_ls_ps', 'next_next_hop_autobackup_protected_ls_ps', 'next_hop_srlg_autobackup_protected_ls_ps', 'next_next_hop_srlg_autobackup_protected_ls_ps', 'next_hop_autobackup_protected_s2l_families', 'next_next_hop_autobackup_protected_s2l_families', 'next_hop_srlg_autobackup_protected_s2l_families', 'next_next_hop_srlg_autobackup_protected_s2l_families', 'next_hop_autobackup_protected_s2_ls', 'next_next_hop_autobackup_protected_s2_ls', 'next_hop_srlg_autobackup_protected_s2_ls', 'next_next_hop_srlg_autobackup_protected_s2_ls'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Backup.Summary']['meta_info']


            class Config(_Entity_):
                """
                MPLS TE auto\-tunnel backup configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel bacukp feature is configured 
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: interface_count
                
                	Number of TE link interfaces with auto\-tunnel backup configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnel.Backup.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                        ('interface_count', (YLeaf(YType.uint32, 'interface-count'), ['int'])),
                        ('unused_removal_timeout_configured', (YLeaf(YType.uint32, 'unused-removal-timeout-configured'), ['int'])),
                        ('min_tunnel_id', (YLeaf(YType.uint16, 'min-tunnel-id'), ['int'])),
                        ('max_tunnel_id', (YLeaf(YType.uint16, 'max-tunnel-id'), ['int'])),
                    ])
                    self.is_configured = None
                    self.interface_count = None
                    self.unused_removal_timeout_configured = None
                    self.min_tunnel_id = None
                    self.max_tunnel_id = None
                    self._segment_path = lambda: "config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnel.Backup.Config, ['is_configured', 'interface_count', 'unused_removal_timeout_configured', 'min_tunnel_id', 'max_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnel.Backup.Config']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AutoTunnel.Backup']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AutoTunnel']['meta_info']


    class SoftPreemption(_Entity_):
        """
        Soft Preemption information.
        
        .. attribute:: statistics
        
        	MPLS TE soft preemption stats information
        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SoftPreemption.Statistics>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.SoftPreemption, self).__init__()

            self.yang_name = "soft-preemption"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SoftPreemption.Statistics))])
            self._leafs = OrderedDict()

            self.statistics = MplsTe.SoftPreemption.Statistics()
            self.statistics.parent = self
            self._children_name_map["statistics"] = "statistics"
            self._segment_path = lambda: "soft-preemption"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.SoftPreemption, [], name, value)


        class Statistics(_Entity_):
            """
            MPLS TE soft preemption stats information
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: soft_preemption_events
            
            	The number of soft preemption events triggered
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: timed_out_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and timed out at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: torn_down_soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node and torn down before timing out
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_triggered_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and then fast rerouted at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: minimum_time_in_soft_preempted_state
            
            	The minimum number of seconds an LSP remained in the soft preempted state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_max
            
            	The maximum number of seconds an LSP remained in the soft preempted state without being hard preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_avg
            
            	The average number of seconds an LSP remained in the soft preempted state. This excludes the timed out LSPs
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: soft_preempted_head_ls_ps
            
            	Number of soft preempted LSPs at the headend. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: reoptimized_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are reoptimized. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: torndown_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are torn down instead of being reoptimized. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_protected_switchover_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are replaced with the path protection LSP. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SoftPreemption.Statistics, self).__init__()

                self.yang_name = "statistics"
                self.yang_parent_name = "soft-preemption"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                    ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                    ('soft_preempted_ls_ps', (YLeaf(YType.uint32, 'soft-preempted-ls-ps'), ['int'])),
                    ('timed_out_soft_preempted_lsp_ss', (YLeaf(YType.uint32, 'timed-out-soft-preempted-lsp-ss'), ['int'])),
                    ('torn_down_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'torn-down-soft-preempted-ls-ps'), ['int'])),
                    ('frr_triggered_soft_preempted_lsp_ss', (YLeaf(YType.uint32, 'frr-triggered-soft-preempted-lsp-ss'), ['int'])),
                    ('minimum_time_in_soft_preempted_state', (YLeaf(YType.uint16, 'minimum-time-in-soft-preempted-state'), ['int'])),
                    ('time_in_soft_preempted_state_max', (YLeaf(YType.uint16, 'time-in-soft-preempted-state-max'), ['int'])),
                    ('time_in_soft_preempted_state_avg', (YLeaf(YType.uint16, 'time-in-soft-preempted-state-avg'), ['int'])),
                    ('soft_preempted_head_ls_ps', (YLeaf(YType.uint32, 'soft-preempted-head-ls-ps'), ['int'])),
                    ('reoptimized_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'reoptimized-soft-preempted-ls-ps'), ['int'])),
                    ('torndown_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'torndown-soft-preempted-ls-ps'), ['int'])),
                    ('path_protected_switchover_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'path-protected-switchover-soft-preempted-ls-ps'), ['int'])),
                ])
                self.last_cleared_timestamp = None
                self.soft_preemption_events = None
                self.soft_preempted_ls_ps = None
                self.timed_out_soft_preempted_lsp_ss = None
                self.torn_down_soft_preempted_ls_ps = None
                self.frr_triggered_soft_preempted_lsp_ss = None
                self.minimum_time_in_soft_preempted_state = None
                self.time_in_soft_preempted_state_max = None
                self.time_in_soft_preempted_state_avg = None
                self.soft_preempted_head_ls_ps = None
                self.reoptimized_soft_preempted_ls_ps = None
                self.torndown_soft_preempted_ls_ps = None
                self.path_protected_switchover_soft_preempted_ls_ps = None
                self._segment_path = lambda: "statistics"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/soft-preemption/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SoftPreemption.Statistics, ['last_cleared_timestamp', 'soft_preemption_events', 'soft_preempted_ls_ps', 'timed_out_soft_preempted_lsp_ss', 'torn_down_soft_preempted_ls_ps', 'frr_triggered_soft_preempted_lsp_ss', 'minimum_time_in_soft_preempted_state', 'time_in_soft_preempted_state_max', 'time_in_soft_preempted_state_avg', 'soft_preempted_head_ls_ps', 'reoptimized_soft_preempted_ls_ps', 'torndown_soft_preempted_ls_ps', 'path_protected_switchover_soft_preempted_ls_ps'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SoftPreemption.Statistics']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.SoftPreemption']['meta_info']


    class ForwardingAdjacencyDestinations(_Entity_):
        """
        Announced Destination tunnel
        
        .. attribute:: forwarding_adjacency_destination
        
        	Forwarding Adjacencies for a destination
        	**type**\: list of  		 :py:class:`ForwardingAdjacencyDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.ForwardingAdjacencyDestinations, self).__init__()

            self.yang_name = "forwarding-adjacency-destinations"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("forwarding-adjacency-destination", ("forwarding_adjacency_destination", MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination))])
            self._leafs = OrderedDict()

            self.forwarding_adjacency_destination = YList(self)
            self._segment_path = lambda: "forwarding-adjacency-destinations"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.ForwardingAdjacencyDestinations, [], name, value)


        class ForwardingAdjacencyDestination(_Entity_):
            """
            Forwarding Adjacencies for a destination
            
            .. attribute:: destination_address  (key)
            
            	Destination address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: adjacencies
            
            	Number of Forwarding Adjacencies
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: ipv6_adjacencies
            
            	Number of IPv6 Forwarding Adjacencies
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: destination_address_xr
            
            	The tunnel destination
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: forward_adjacency
            
            	Forwarding\-adjacency list
            	**type**\: list of  		 :py:class:`ForwardAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__init__()

                self.yang_name = "forwarding-adjacency-destination"
                self.yang_parent_name = "forwarding-adjacency-destinations"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['destination_address']
                self._child_classes = OrderedDict([("forward-adjacency", ("forward_adjacency", MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency))])
                self._leafs = OrderedDict([
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('adjacencies', (YLeaf(YType.uint32, 'adjacencies'), ['int'])),
                    ('ipv6_adjacencies', (YLeaf(YType.uint32, 'ipv6-adjacencies'), ['int'])),
                    ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                ])
                self.destination_address = None
                self.adjacencies = None
                self.ipv6_adjacencies = None
                self.destination_address_xr = None

                self.forward_adjacency = YList(self)
                self._segment_path = lambda: "forwarding-adjacency-destination" + "[destination-address='" + str(self.destination_address) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/forwarding-adjacency-destinations/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, ['destination_address', 'adjacencies', 'ipv6_adjacencies', 'destination_address_xr'], name, value)


            class ForwardAdjacency(_Entity_):
                """
                Forwarding\-adjacency list
                
                .. attribute:: tunnel_name
                
                	The tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: traffic_share
                
                	Traffic Share
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_time
                
                	Hold time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_adjacency_up
                
                	True if adj is up
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: ig_ps
                
                	List of IGPs to which it is announced
                	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__init__()

                    self.yang_name = "forward-adjacency"
                    self.yang_parent_name = "forwarding-adjacency-destination"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('traffic_share', (YLeaf(YType.uint32, 'traffic-share'), ['int'])),
                        ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                        ('is_adjacency_up', (YLeaf(YType.boolean, 'is-adjacency-up'), ['bool'])),
                    ])
                    self.tunnel_name = None
                    self.traffic_share = None
                    self.hold_time = None
                    self.is_adjacency_up = None

                    self.ig_ps = YList(self)
                    self._segment_path = lambda: "forward-adjacency"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, ['tunnel_name', 'traffic_share', 'hold_time', 'is_adjacency_up'], name, value)


                class IgPs(_Entity_):
                    """
                    List of IGPs to which it is announced
                    
                    .. attribute:: igp_area_id
                    
                    	The IGP Instance and Area ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: afi
                    
                    	AFI
                    	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__init__()

                        self.yang_name = "ig-ps"
                        self.yang_parent_name = "forward-adjacency"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                            ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                        ])
                        self.igp_area_id = None
                        self.afi = None
                        self._segment_path = lambda: "ig-ps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, ['igp_area_id', 'afi'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.ForwardingAdjacencyDestinations']['meta_info']


    class IgpAreas(_Entity_):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area
        
        	An IGP instance
        	**type**\: list of  		 :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.IgpAreas, self).__init__()

            self.yang_name = "igp-areas"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-area", ("igp_area", MplsTe.IgpAreas.IgpArea))])
            self._leafs = OrderedDict()

            self.igp_area = YList(self)
            self._segment_path = lambda: "igp-areas"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.IgpAreas, [], name, value)


        class IgpArea(_Entity_):
            """
            An IGP instance
            
            .. attribute:: protocol  (key)
            
            	The IGP protocol
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: process_tag  (key)
            
            	IGP Process Tag
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of  		 :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.SecondaryRouterId>`
            
            	**config**\: False
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of  		 :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.IgpAreas.IgpArea, self).__init__()

                self.yang_name = "igp-area"
                self.yang_parent_name = "igp-areas"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','process_tag']
                self._child_classes = OrderedDict([("secondary-router-id", ("secondary_router_id", MplsTe.IgpAreas.IgpArea.SecondaryRouterId)), ("area", ("area", MplsTe.IgpAreas.IgpArea.Area))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('process_tag', (YLeaf(YType.str, 'process-tag'), ['str'])),
                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ('igp_system_id', (YLeaf(YType.str, 'igp-system-id'), ['str'])),
                    ('configured_te_router_id', (YLeaf(YType.str, 'configured-te-router-id'), ['str'])),
                    ('global_router_id', (YLeaf(YType.str, 'global-router-id'), ['str'])),
                    ('globall_router_id_optical', (YLeaf(YType.str, 'globall-router-id-optical'), ['str'])),
                    ('in_use_te_router_id', (YLeaf(YType.str, 'in-use-te-router-id'), ['str'])),
                    ('is_connection_up', (YLeaf(YType.boolean, 'is-connection-up'), ['bool'])),
                    ('connection_up_count', (YLeaf(YType.uint32, 'connection-up-count'), ['int'])),
                    ('connection_down_count', (YLeaf(YType.uint32, 'connection-down-count'), ['int'])),
                ])
                self.protocol = None
                self.process_tag = None
                self.igp_type = None
                self.instance_name = None
                self.igp_system_id = None
                self.configured_te_router_id = None
                self.global_router_id = None
                self.globall_router_id_optical = None
                self.in_use_te_router_id = None
                self.is_connection_up = None
                self.connection_up_count = None
                self.connection_down_count = None

                self.secondary_router_id = YList(self)
                self.area = YList(self)
                self._segment_path = lambda: "igp-area" + "[protocol='" + str(self.protocol) + "']" + "[process-tag='" + str(self.process_tag) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/igp-areas/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.IgpAreas.IgpArea, ['protocol', 'process_tag', 'igp_type', 'instance_name', 'igp_system_id', 'configured_te_router_id', 'global_router_id', 'globall_router_id_optical', 'in_use_te_router_id', 'is_connection_up', 'connection_up_count', 'connection_down_count'], name, value)


            class SecondaryRouterId(_Entity_):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	Secondary router\-ids
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.IgpAreas.IgpArea.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "secondary-router-id"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.IgpAreas.IgpArea.SecondaryRouterId, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.IgpAreas.IgpArea.SecondaryRouterId']['meta_info']


            class Area(_Entity_):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:  :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area.ActiveData>`
                
                	**config**\: False
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_number
                
                	Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.IgpAreas.IgpArea.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("active-data", ("active_data", MplsTe.IgpAreas.IgpArea.Area.ActiveData))])
                    self._leafs = OrderedDict([
                        ('area_index', (YLeaf(YType.uint32, 'area-index'), ['int'])),
                        ('area_number', (YLeaf(YType.uint32, 'area-number'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('is_config_ready', (YLeaf(YType.boolean, 'is-config-ready'), ['bool'])),
                    ])
                    self.area_index = None
                    self.area_number = None
                    self.area_format = None
                    self.is_config_ready = None

                    self.active_data = MplsTe.IgpAreas.IgpArea.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._segment_path = lambda: "area"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.IgpAreas.IgpArea.Area, ['area_index', 'area_number', 'area_format', 'is_config_ready'], name, value)


                class ActiveData(_Entity_):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:  :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.IgpAreas.IgpArea.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("area-statistics", ("area_statistics", MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics))])
                        self._leafs = OrderedDict([
                            ('interfaces_count', (YLeaf(YType.uint32, 'interfaces-count'), ['int'])),
                            ('link_idt_received', (YLeaf(YType.boolean, 'link-idt-received'), ['bool'])),
                            ('topology_idt_received', (YLeaf(YType.boolean, 'topology-idt-received'), ['bool'])),
                            ('sr_strict', (YLeaf(YType.boolean, 'sr-strict'), ['bool'])),
                            ('p2p_heads_count', (YLeaf(YType.uint32, 'p2p-heads-count'), ['int'])),
                            ('p2p_autoroute_announced_count', (YLeaf(YType.uint32, 'p2p-autoroute-announced-count'), ['int'])),
                            ('p2p_forwarding_adjacency_count', (YLeaf(YType.uint32, 'p2p-forwarding-adjacency-count'), ['int'])),
                            ('p2mp_destination_count', (YLeaf(YType.uint32, 'p2mp-destination-count'), ['int'])),
                            ('tunnel_loose_hops', (YLeaf(YType.uint32, 'tunnel-loose-hops'), ['int'])),
                        ])
                        self.interfaces_count = None
                        self.link_idt_received = None
                        self.topology_idt_received = None
                        self.sr_strict = None
                        self.p2p_heads_count = None
                        self.p2p_autoroute_announced_count = None
                        self.p2p_forwarding_adjacency_count = None
                        self.p2mp_destination_count = None
                        self.tunnel_loose_hops = None

                        self.area_statistics = MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._segment_path = lambda: "active-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.IgpAreas.IgpArea.Area.ActiveData, ['interfaces_count', 'link_idt_received', 'topology_idt_received', 'sr_strict', 'p2p_heads_count', 'p2p_autoroute_announced_count', 'p2p_forwarding_adjacency_count', 'p2mp_destination_count', 'tunnel_loose_hops'], name, value)


                    class AreaStatistics(_Entity_):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('area_adjacency_request_messages', (YLeaf(YType.uint32, 'area-adjacency-request-messages'), ['int'])),
                                ('area_adjacency_announce_messages', (YLeaf(YType.uint32, 'area-adjacency-announce-messages'), ['int'])),
                                ('area_flood_messages', (YLeaf(YType.uint32, 'area-flood-messages'), ['int'])),
                                ('area_lsa_announce_messages', (YLeaf(YType.uint32, 'area-lsa-announce-messages'), ['int'])),
                                ('area_lsa_fragment_announce_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-announce-messages'), ['int'])),
                                ('area_lsa_delete_messages', (YLeaf(YType.uint32, 'area-lsa-delete-messages'), ['int'])),
                                ('area_lsa_fragment_delete_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-delete-messages'), ['int'])),
                                ('area_tunnel_announce_messages', (YLeaf(YType.uint32, 'area-tunnel-announce-messages'), ['int'])),
                            ])
                            self.area_adjacency_request_messages = None
                            self.area_adjacency_announce_messages = None
                            self.area_flood_messages = None
                            self.area_lsa_announce_messages = None
                            self.area_lsa_fragment_announce_messages = None
                            self.area_lsa_delete_messages = None
                            self.area_lsa_fragment_delete_messages = None
                            self.area_tunnel_announce_messages = None
                            self._segment_path = lambda: "area-statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, ['area_adjacency_request_messages', 'area_adjacency_announce_messages', 'area_flood_messages', 'area_lsa_announce_messages', 'area_lsa_fragment_announce_messages', 'area_lsa_delete_messages', 'area_lsa_fragment_delete_messages', 'area_tunnel_announce_messages'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.IgpAreas.IgpArea.Area.ActiveData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.IgpAreas.IgpArea.Area']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.IgpAreas.IgpArea']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.IgpAreas']['meta_info']


    class WrapProtection(_Entity_):
        """
        Represent all the LSP Wrap Protection info in
        MPLS\-TE
        
        .. attribute:: protected_lsps
        
        	The set of wrap protected LSPs available in MPLS\-TE
        	**type**\:  :py:class:`ProtectedLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection.ProtectedLsps>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.WrapProtection, self).__init__()

            self.yang_name = "wrap-protection"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("protected-lsps", ("protected_lsps", MplsTe.WrapProtection.ProtectedLsps))])
            self._leafs = OrderedDict()

            self.protected_lsps = MplsTe.WrapProtection.ProtectedLsps()
            self.protected_lsps.parent = self
            self._children_name_map["protected_lsps"] = "protected-lsps"
            self._segment_path = lambda: "wrap-protection"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.WrapProtection, [], name, value)


        class ProtectedLsps(_Entity_):
            """
            The set of wrap protected LSPs available in
            MPLS\-TE
            
            .. attribute:: protected_lsp
            
            	Wrap protection info for a given protected LSP
            	**type**\: list of  		 :py:class:`ProtectedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.WrapProtection.ProtectedLsps, self).__init__()

                self.yang_name = "protected-lsps"
                self.yang_parent_name = "wrap-protection"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protected-lsp", ("protected_lsp", MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp))])
                self._leafs = OrderedDict()

                self.protected_lsp = YList(self)
                self._segment_path = lambda: "protected-lsps"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/wrap-protection/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.WrapProtection.ProtectedLsps, [], name, value)


            class ProtectedLsp(_Entity_):
                """
                Wrap protection info for a given protected LSP
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup Orig ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_type  (key)
                
                	Session Type
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enable
                
                	LSP Wrap protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_label
                
                	LSP Wrap Merge Point Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reverse_egress_interface
                
                	Reverse Egress Interface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: reverse_lsp_label
                
                	Reverse LSP label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_state
                
                	LSP wrap protection state
                	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                
                	**config**\: False
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp, self).__init__()

                    self.yang_name = "protected-lsp"
                    self.yang_parent_name = "protected-lsps"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_address','tunnel_id','extended_tunnel_id','lsp_id','sub_group_id','sub_group_originator','p2mp_id','session_type']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('session_type', (YLeaf(YType.enumeration, 'session-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('source_address_xr', (YLeaf(YType.str, 'source-address-xr'), ['str'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint16, 'tunnel-id-xr'), ['int'])),
                        ('extended_tunnel_id_xr', (YLeaf(YType.str, 'extended-tunnel-id-xr'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                        ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                        ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                        ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                        ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                        ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ('sub_group_id_xr', (YLeaf(YType.uint16, 'sub-group-id-xr'), ['int'])),
                        ('p2mp_id_xr', (YLeaf(YType.uint32, 'p2mp-id-xr'), ['int'])),
                    ])
                    self.source_address = None
                    self.destination_address = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.lsp_id = None
                    self.sub_group_id = None
                    self.sub_group_originator = None
                    self.p2mp_id = None
                    self.session_type = None
                    self.source_address_xr = None
                    self.destination_address_xr = None
                    self.tunnel_id_xr = None
                    self.extended_tunnel_id_xr = None
                    self.tunnel_name = None
                    self.tunnel_instance = None
                    self.lsp_wrap_protection_enable = None
                    self.lsp_wrap_protection_label = None
                    self.reverse_egress_interface = None
                    self.reverse_lsp_label = None
                    self.lsp_wrap_protection_state = None
                    self.sub_group_original_id = None
                    self.sub_group_id_xr = None
                    self.p2mp_id_xr = None
                    self._segment_path = lambda: "protected-lsp" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[session-type='" + str(self.session_type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/wrap-protection/protected-lsps/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp, ['source_address', 'destination_address', 'tunnel_id', 'extended_tunnel_id', 'lsp_id', 'sub_group_id', 'sub_group_originator', 'p2mp_id', 'session_type', 'source_address_xr', 'destination_address_xr', 'tunnel_id_xr', 'extended_tunnel_id_xr', 'tunnel_name', 'tunnel_instance', 'lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state', 'sub_group_original_id', 'sub_group_id_xr', 'p2mp_id_xr'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.WrapProtection.ProtectedLsps.ProtectedLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.WrapProtection.ProtectedLsps']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.WrapProtection']['meta_info']


    class Topology(_Entity_):
        """
        The topology information in MPLS\-TE
        
        .. attribute:: global_
        
        	Global information about the overall MPLS\-TE topology
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global>`
        
        	**config**\: False
        
        .. attribute:: destination_paths
        
        	This table models the path calculation capabilities in MPLS\-TE.A GET operation for the complete table will return no entries.See the class DestinationPath for more details
        	**type**\:  :py:class:`DestinationPaths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths>`
        
        	**config**\: False
        
        .. attribute:: configured_srlgs
        
        	Set of configured SRLG
        	**type**\:  :py:class:`ConfiguredSrlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs>`
        
        	**config**\: False
        
        .. attribute:: srlgs
        
        	Set of SRLG operational value for the overall MPLS\-TE topology
        	**type**\:  :py:class:`Srlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs>`
        
        	**config**\: False
        
        .. attribute:: path_tunnels
        
        	MPLS\-Te topology path info
        	**type**\:  :py:class:`PathTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsTe.Topology.Global)), ("destination-paths", ("destination_paths", MplsTe.Topology.DestinationPaths)), ("configured-srlgs", ("configured_srlgs", MplsTe.Topology.ConfiguredSrlgs)), ("srlgs", ("srlgs", MplsTe.Topology.Srlgs)), ("path-tunnels", ("path_tunnels", MplsTe.Topology.PathTunnels))])
            self._leafs = OrderedDict()

            self.global_ = MplsTe.Topology.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.destination_paths = MplsTe.Topology.DestinationPaths()
            self.destination_paths.parent = self
            self._children_name_map["destination_paths"] = "destination-paths"

            self.configured_srlgs = MplsTe.Topology.ConfiguredSrlgs()
            self.configured_srlgs.parent = self
            self._children_name_map["configured_srlgs"] = "configured-srlgs"

            self.srlgs = MplsTe.Topology.Srlgs()
            self.srlgs.parent = self
            self._children_name_map["srlgs"] = "srlgs"

            self.path_tunnels = MplsTe.Topology.PathTunnels()
            self.path_tunnels.parent = self
            self._children_name_map["path_tunnels"] = "path-tunnels"
            self._segment_path = lambda: "topology"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.Topology, [], name, value)


        class Global(_Entity_):
            """
            Global information about the overall MPLS\-TE
            topology
            
            .. attribute:: hold_down_interval
            
            	Interval in seconds to hold down a neighbor after a signalling error
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: link_add_remove_count
            
            	Link add/remove counter
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: local_model_id
            
            	Local BC Model ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: areas
            
            	Information for areas
            	**type**\: list of  		 :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global.Areas>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Topology.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("areas", ("areas", MplsTe.Topology.Global.Areas))])
                self._leafs = OrderedDict([
                    ('hold_down_interval', (YLeaf(YType.uint32, 'hold-down-interval'), ['int'])),
                    ('link_add_remove_count', (YLeaf(YType.uint32, 'link-add-remove-count'), ['int'])),
                    ('local_model_id', (YLeaf(YType.uint32, 'local-model-id'), ['int'])),
                ])
                self.hold_down_interval = None
                self.link_add_remove_count = None
                self.local_model_id = None

                self.areas = YList(self)
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Topology.Global, ['hold_down_interval', 'link_add_remove_count', 'local_model_id'], name, value)


            class Areas(_Entity_):
                """
                Information for areas
                
                .. attribute:: local_sid_and_srbg
                
                	Local SID and SRBG
                	**type**\:  :py:class:`LocalSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Global.Areas.LocalSidAndSrbg>`
                
                	**config**\: False
                
                .. attribute:: protocol
                
                	Protocol used
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: node_id
                
                	The node's IGP id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	The area's id
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Topology.Global.Areas, self).__init__()

                    self.yang_name = "areas"
                    self.yang_parent_name = "global"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("local-sid-and-srbg", ("local_sid_and_srbg", MplsTe.Topology.Global.Areas.LocalSidAndSrbg))])
                    self._leafs = OrderedDict([
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                    ])
                    self.protocol = None
                    self.node_id = None
                    self.area_id = None

                    self.local_sid_and_srbg = MplsTe.Topology.Global.Areas.LocalSidAndSrbg()
                    self.local_sid_and_srbg.parent = self
                    self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                    self._segment_path = lambda: "areas"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/global/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Topology.Global.Areas, ['protocol', 'node_id', 'area_id'], name, value)


                class LocalSidAndSrbg(_Entity_):
                    """
                    Local SID and SRBG
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.Global.Areas.LocalSidAndSrbg, self).__init__()

                        self.yang_name = "local-sid-and-srbg"
                        self.yang_parent_name = "areas"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                            ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                            ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                            ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                        ])
                        self.segment_id = None
                        self.segment_id_local_absolute_value = None
                        self.srgb_start = None
                        self.srgb_size = None
                        self._segment_path = lambda: "local-sid-and-srbg"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/global/areas/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.Global.Areas.LocalSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.Global.Areas.LocalSidAndSrbg']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Topology.Global.Areas']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Topology.Global']['meta_info']


        class DestinationPaths(_Entity_):
            """
            This table models the path calculation
            capabilities in MPLS\-TE.A GET operation for the
            complete table will return no entries.See the
            class DestinationPath for more details.
            
            .. attribute:: destination_path
            
            	A GET operation on this class returns the best available path in the TE topology to reach the specified destination while satisfying the specified constraints
            	**type**\: list of  		 :py:class:`DestinationPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Topology.DestinationPaths, self).__init__()

                self.yang_name = "destination-paths"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("destination-path", ("destination_path", MplsTe.Topology.DestinationPaths.DestinationPath))])
                self._leafs = OrderedDict()

                self.destination_path = YList(self)
                self._segment_path = lambda: "destination-paths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Topology.DestinationPaths, [], name, value)


            class DestinationPath(_Entity_):
                """
                A GET operation on this class returns the best
                available path in the TE topology to reach the
                specified destination while satisfying the
                specified constraints.
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: affinity_bits
                
                	Affinity Bits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_mask
                
                	Affinity Mask
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	Setup Priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	Hold Priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth in kbps
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: igp_type
                
                	IGP Type
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hop_limit
                
                	Hop Limit
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_ip_address
                
                	Exclude SRLG IP Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: path_type
                
                	Path Type
                	**type**\:  :py:class:`MplsTePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePath>`
                
                	**config**\: False
                
                .. attribute:: path_id
                
                	This is the ID of the explicit path to be used for this path calculation query
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: path_name
                
                	This is the name of the explicit path to be used for this path calculation query
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: cost_limit
                
                	Cost Limit
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:  :py:class:`MplsTePathSelectionMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathSelectionMetric>`
                
                	**config**\: False
                
                .. attribute:: delay_limit
                
                	Delay Limit in usec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of  		 :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Hop>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of  		 :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Topology.DestinationPaths.DestinationPath, self).__init__()

                    self.yang_name = "destination-path"
                    self.yang_parent_name = "destination-paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.Topology.DestinationPaths.DestinationPath.Affinity)), ("hop", ("hop", MplsTe.Topology.DestinationPaths.DestinationPath.Hop)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup)), ("sr-segment", ("sr_segment", MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint32, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint32, 'hold-priority'), ['int'])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('hop_limit', (YLeaf(YType.uint32, 'hop-limit'), ['int'])),
                        ('exclude_srlg_ip_address', (YLeaf(YType.str, 'exclude-srlg-ip-address'), ['str'])),
                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePath', '')])),
                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                        ('path_name', (YLeaf(YType.str, 'path-name'), ['str'])),
                        ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathSelectionMetric', '')])),
                        ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('is_partial_path', (YLeaf(YType.boolean, 'is-partial-path'), ['bool'])),
                        ('is_full_path', (YLeaf(YType.boolean, 'is-full-path'), ['bool'])),
                        ('is_topology_checked', (YLeaf(YType.boolean, 'is-topology-checked'), ['bool'])),
                        ('is_segment_routing_db_checked', (YLeaf(YType.boolean, 'is-segment-routing-db-checked'), ['bool'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint64, 'bandwidth-type'), ['int'])),
                        ('mininum_bandwidth', (YLeaf(YType.uint64, 'mininum-bandwidth'), ['int'])),
                        ('accumulated_admin_weight', (YLeaf(YType.uint64, 'accumulated-admin-weight'), ['int'])),
                        ('setup_priority_xr', (YLeaf(YType.uint32, 'setup-priority-xr'), ['int'])),
                        ('hold_priority_xr', (YLeaf(YType.uint32, 'hold-priority-xr'), ['int'])),
                        ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                        ('exclude_srlg_address', (YLeaf(YType.str, 'exclude-srlg-address'), ['str'])),
                    ])
                    self.destination_address = None
                    self.affinity_bits = None
                    self.affinity_mask = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.hop_limit = None
                    self.exclude_srlg_ip_address = None
                    self.path_type = None
                    self.path_id = None
                    self.path_name = None
                    self.cost_limit = None
                    self.metric_type = None
                    self.delay_limit = None
                    self.tunnel_id_xr = None
                    self.destination_address_xr = None
                    self.is_partial_path = None
                    self.is_full_path = None
                    self.is_topology_checked = None
                    self.is_segment_routing_db_checked = None
                    self.requested_bandwidth = None
                    self.bandwidth_type = None
                    self.mininum_bandwidth = None
                    self.accumulated_admin_weight = None
                    self.setup_priority_xr = None
                    self.hold_priority_xr = None
                    self.node_hop_count = None
                    self.exclude_srlg_address = None

                    self.affinity = MplsTe.Topology.DestinationPaths.DestinationPath.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)
                    self._segment_path = lambda: "destination-path"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath, ['destination_address', 'affinity_bits', 'affinity_mask', 'setup_priority', 'hold_priority', 'bandwidth', 'igp_type', 'igp_instance', 'igp_area', 'hop_limit', 'exclude_srlg_ip_address', 'path_type', 'path_id', 'path_name', 'cost_limit', 'metric_type', 'delay_limit', 'tunnel_id_xr', 'destination_address_xr', 'is_partial_path', 'is_full_path', 'is_topology_checked', 'is_segment_routing_db_checked', 'requested_bandwidth', 'bandwidth_type', 'mininum_bandwidth', 'accumulated_admin_weight', 'setup_priority_xr', 'hold_priority_xr', 'node_hop_count', 'exclude_srlg_address'], name, value)


                class Affinity(_Entity_):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity))])
                        self._leafs = OrderedDict([
                            ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                            ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ])
                        self.affinity_bits = None
                        self.affinity_mask = None

                        self.named_affinity = YList(self)
                        self._segment_path = lambda: "affinity"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                    class NamedAffinity(_Entity_):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                            self._leafs = OrderedDict([
                                ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                            ])
                            self.constraint_type = None
                            self.constraint_value = None
                            self.forward_ref_value = None

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)
                            self._segment_path = lambda: "named-affinity"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                        class ConstraintExtendedValue(_Entity_):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	Constraint value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "constraint-extended-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                        class ExtendedForwardRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "extended-forward-ref-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.Affinity']['meta_info']


                class Hop(_Entity_):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	The path's array of hops
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.DestinationPaths.DestinationPath.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "hop"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.Hop, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.Hop']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup']['meta_info']


                class SrSegment(_Entity_):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                            ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                            ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                            ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                        ])
                        self.sid_type = None
                        self.has_ip_addresses = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.has_mpls_label = None
                        self.mpls_label_value = None
                        self.has_entropy_label = None
                        self._segment_path = lambda: "sr-segment"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath.SrSegment']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Topology.DestinationPaths.DestinationPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Topology.DestinationPaths']['meta_info']


        class ConfiguredSrlgs(_Entity_):
            """
            Set of configured SRLG
            
            .. attribute:: configured_srlg
            
            	Configured SRLG value and the addresses using it
            	**type**\: list of  		 :py:class:`ConfiguredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Topology.ConfiguredSrlgs, self).__init__()

                self.yang_name = "configured-srlgs"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("configured-srlg", ("configured_srlg", MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg))])
                self._leafs = OrderedDict()

                self.configured_srlg = YList(self)
                self._segment_path = lambda: "configured-srlgs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Topology.ConfiguredSrlgs, [], name, value)


            class ConfiguredSrlg(_Entity_):
                """
                Configured SRLG value and the addresses using
                it
                
                .. attribute:: srlg_number  (key)
                
                	SRLG Number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_number_xr
                
                	SRLG number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_admin_weight_configured
                
                	Set to TRUE if the admin weight is explicitely configured
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: srlg_link
                
                	Link associated with the SRLG
                	**type**\: list of  		 :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__init__()

                    self.yang_name = "configured-srlg"
                    self.yang_parent_name = "configured-srlgs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['srlg_number']
                    self._child_classes = OrderedDict([("srlg-link", ("srlg_link", MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink))])
                    self._leafs = OrderedDict([
                        ('srlg_number', (YLeaf(YType.uint32, 'srlg-number'), ['int'])),
                        ('srlg_number_xr', (YLeaf(YType.uint32, 'srlg-number-xr'), ['int'])),
                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                        ('is_admin_weight_configured', (YLeaf(YType.boolean, 'is-admin-weight-configured'), ['bool'])),
                    ])
                    self.srlg_number = None
                    self.srlg_number_xr = None
                    self.srlg_name = None
                    self.admin_weight = None
                    self.is_admin_weight_configured = None

                    self.srlg_link = YList(self)
                    self._segment_path = lambda: "configured-srlg" + "[srlg-number='" + str(self.srlg_number) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/configured-srlgs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg, ['srlg_number', 'srlg_number_xr', 'srlg_name', 'admin_weight', 'is_admin_weight_configured'], name, value)


                class SrlgLink(_Entity_):
                    """
                    Link associated with the SRLG
                    
                    .. attribute:: local_address
                    
                    	Local address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Remote address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__init__()

                        self.yang_name = "srlg-link"
                        self.yang_parent_name = "configured-srlg"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "srlg-link"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, ['local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Topology.ConfiguredSrlgs.ConfiguredSrlg']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Topology.ConfiguredSrlgs']['meta_info']


        class Srlgs(_Entity_):
            """
            Set of SRLG operational value for the overall
            MPLS\-TE topology
            
            .. attribute:: srlg
            
            	SRLG operational value for the overall MPLS\-TE topology
            	**type**\: list of  		 :py:class:`Srlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Topology.Srlgs, self).__init__()

                self.yang_name = "srlgs"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("srlg", ("srlg", MplsTe.Topology.Srlgs.Srlg))])
                self._leafs = OrderedDict()

                self.srlg = YList(self)
                self._segment_path = lambda: "srlgs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Topology.Srlgs, [], name, value)


            class Srlg(_Entity_):
                """
                SRLG operational value for the overall MPLS\-TE
                topology
                
                .. attribute:: srlg_number  (key)
                
                	SRLG Number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_areas
                
                	Topology areas in this SRLG
                	**type**\: list of  		 :py:class:`SrlgAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Topology.Srlgs.Srlg, self).__init__()

                    self.yang_name = "srlg"
                    self.yang_parent_name = "srlgs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['srlg_number']
                    self._child_classes = OrderedDict([("srlg-areas", ("srlg_areas", MplsTe.Topology.Srlgs.Srlg.SrlgAreas))])
                    self._leafs = OrderedDict([
                        ('srlg_number', (YLeaf(YType.uint32, 'srlg-number'), ['int'])),
                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                    ])
                    self.srlg_number = None
                    self.srlg_name = None
                    self.admin_weight = None

                    self.srlg_areas = YList(self)
                    self._segment_path = lambda: "srlg" + "[srlg-number='" + str(self.srlg_number) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/srlgs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Topology.Srlgs.Srlg, ['srlg_number', 'srlg_name', 'admin_weight'], name, value)


                class SrlgAreas(_Entity_):
                    """
                    Topology areas in this SRLG
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_instance
                    
                    	IGP Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_link
                    
                    	Links in this SRLG/area
                    	**type**\: list of  		 :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas, self).__init__()

                        self.yang_name = "srlg-areas"
                        self.yang_parent_name = "srlg"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlg-link", ("srlg_link", MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink))])
                        self._leafs = OrderedDict([
                            ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                            ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                            ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                            ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ])
                        self.igp_type = None
                        self.igp_instance = None
                        self.igp_area = None
                        self.igp_area_format = None

                        self.srlg_link = YList(self)
                        self._segment_path = lambda: "srlg-areas"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.Srlgs.Srlg.SrlgAreas, ['igp_type', 'igp_instance', 'igp_area', 'igp_area_format'], name, value)


                    class SrlgLink(_Entity_):
                        """
                        Links in this SRLG/area
                        
                        .. attribute:: link_address_generic
                        
                        	Link address
                        	**type**\:  :py:class:`LinkAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_address
                        
                        	Link address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: te_router_id
                        
                        	Link TE router\-id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__init__()

                            self.yang_name = "srlg-link"
                            self.yang_parent_name = "srlg-areas"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("link-address-generic", ("link_address_generic", MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric))])
                            self._leafs = OrderedDict([
                                ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                            ])
                            self.link_address = None
                            self.te_router_id = None

                            self.link_address_generic = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                            self.link_address_generic.parent = self
                            self._children_name_map["link_address_generic"] = "link-address-generic"
                            self._segment_path = lambda: "srlg-link"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, ['link_address', 'te_router_id'], name, value)


                        class LinkAddressGeneric(_Entity_):
                            """
                            Link address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, self).__init__()

                                self.yang_name = "link-address-generic"
                                self.yang_parent_name = "srlg-link"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "link-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "link-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.Srlgs.Srlg.SrlgAreas']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Topology.Srlgs.Srlg']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Topology.Srlgs']['meta_info']


        class PathTunnels(_Entity_):
            """
            MPLS\-Te topology path info
            
            .. attribute:: path_tunnel
            
            	MPLS\-TE topology path taken by the specified tunnel
            	**type**\: list of  		 :py:class:`PathTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Topology.PathTunnels, self).__init__()

                self.yang_name = "path-tunnels"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-tunnel", ("path_tunnel", MplsTe.Topology.PathTunnels.PathTunnel))])
                self._leafs = OrderedDict()

                self.path_tunnel = YList(self)
                self._segment_path = lambda: "path-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Topology.PathTunnels, [], name, value)


            class PathTunnel(_Entity_):
                """
                MPLS\-TE topology path taken by the specified
                tunnel
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of  		 :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Hop>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of  		 :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.SrSegment>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Topology.PathTunnels.PathTunnel, self).__init__()

                    self.yang_name = "path-tunnel"
                    self.yang_parent_name = "path-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.Topology.PathTunnels.PathTunnel.Affinity)), ("hop", ("hop", MplsTe.Topology.PathTunnels.PathTunnel.Hop)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup)), ("sr-segment", ("sr_segment", MplsTe.Topology.PathTunnels.PathTunnel.SrSegment))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('is_partial_path', (YLeaf(YType.boolean, 'is-partial-path'), ['bool'])),
                        ('is_full_path', (YLeaf(YType.boolean, 'is-full-path'), ['bool'])),
                        ('is_topology_checked', (YLeaf(YType.boolean, 'is-topology-checked'), ['bool'])),
                        ('is_segment_routing_db_checked', (YLeaf(YType.boolean, 'is-segment-routing-db-checked'), ['bool'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint64, 'bandwidth-type'), ['int'])),
                        ('mininum_bandwidth', (YLeaf(YType.uint64, 'mininum-bandwidth'), ['int'])),
                        ('accumulated_admin_weight', (YLeaf(YType.uint64, 'accumulated-admin-weight'), ['int'])),
                        ('setup_priority_xr', (YLeaf(YType.uint32, 'setup-priority-xr'), ['int'])),
                        ('hold_priority_xr', (YLeaf(YType.uint32, 'hold-priority-xr'), ['int'])),
                        ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                        ('exclude_srlg_address', (YLeaf(YType.str, 'exclude-srlg-address'), ['str'])),
                    ])
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.tunnel_id_xr = None
                    self.destination_address_xr = None
                    self.is_partial_path = None
                    self.is_full_path = None
                    self.is_topology_checked = None
                    self.is_segment_routing_db_checked = None
                    self.requested_bandwidth = None
                    self.bandwidth_type = None
                    self.mininum_bandwidth = None
                    self.accumulated_admin_weight = None
                    self.setup_priority_xr = None
                    self.hold_priority_xr = None
                    self.node_hop_count = None
                    self.exclude_srlg_address = None

                    self.affinity = MplsTe.Topology.PathTunnels.PathTunnel.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)
                    self._segment_path = lambda: "path-tunnel"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel, ['tunnel_id', 'tunnel_name', 'tunnel_id_xr', 'destination_address_xr', 'is_partial_path', 'is_full_path', 'is_topology_checked', 'is_segment_routing_db_checked', 'requested_bandwidth', 'bandwidth_type', 'mininum_bandwidth', 'accumulated_admin_weight', 'setup_priority_xr', 'hold_priority_xr', 'node_hop_count', 'exclude_srlg_address'], name, value)


                class Affinity(_Entity_):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity))])
                        self._leafs = OrderedDict([
                            ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                            ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ])
                        self.affinity_bits = None
                        self.affinity_mask = None

                        self.named_affinity = YList(self)
                        self._segment_path = lambda: "affinity"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                    class NamedAffinity(_Entity_):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                            self._leafs = OrderedDict([
                                ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                            ])
                            self.constraint_type = None
                            self.constraint_value = None
                            self.forward_ref_value = None

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)
                            self._segment_path = lambda: "named-affinity"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                        class ConstraintExtendedValue(_Entity_):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	Constraint value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "constraint-extended-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                        class ExtendedForwardRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "extended-forward-ref-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.Affinity']['meta_info']


                class Hop(_Entity_):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	The path's array of hops
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.PathTunnels.PathTunnel.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "hop"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.Hop, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.Hop']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup']['meta_info']


                class SrSegment(_Entity_):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Topology.PathTunnels.PathTunnel.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                            ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                            ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                            ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                        ])
                        self.sid_type = None
                        self.has_ip_addresses = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.has_mpls_label = None
                        self.mpls_label_value = None
                        self.has_entropy_label = None
                        self._segment_path = lambda: "sr-segment"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Topology.PathTunnels.PathTunnel.SrSegment, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel.SrSegment']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Topology.PathTunnels.PathTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Topology.PathTunnels']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.Topology']['meta_info']


    class SignallingCounters(_Entity_):
        """
        TE counters
        
        .. attribute:: issu
        
        	MPLS TE ISSU counters
        	**type**\:  :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Issu>`
        
        	**config**\: False
        
        .. attribute:: fsm_unexpected_event_stats
        
        	TE S2L FSM unexpected event stats
        	**type**\:  :py:class:`FsmUnexpectedEventStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats>`
        
        	**config**\: False
        
        .. attribute:: head_signalling_counters
        
        	Sig Head Table TE counters
        	**type**\:  :py:class:`HeadSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters>`
        
        	**config**\: False
        
        .. attribute:: remote_signalling_counters
        
        	Sig mid tail Table TE counters
        	**type**\:  :py:class:`RemoteSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters>`
        
        	**config**\: False
        
        .. attribute:: signallings
        
        	TE counters
        	**type**\:  :py:class:`Signallings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings>`
        
        	**config**\: False
        
        .. attribute:: signalling_summary
        
        	Send\-Recv count summary for TE Signaling
        	**type**\:  :py:class:`SignallingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.SignallingSummary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.SignallingCounters, self).__init__()

            self.yang_name = "signalling-counters"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("issu", ("issu", MplsTe.SignallingCounters.Issu)), ("fsm-unexpected-event-stats", ("fsm_unexpected_event_stats", MplsTe.SignallingCounters.FsmUnexpectedEventStats)), ("head-signalling-counters", ("head_signalling_counters", MplsTe.SignallingCounters.HeadSignallingCounters)), ("remote-signalling-counters", ("remote_signalling_counters", MplsTe.SignallingCounters.RemoteSignallingCounters)), ("signallings", ("signallings", MplsTe.SignallingCounters.Signallings)), ("signalling-summary", ("signalling_summary", MplsTe.SignallingCounters.SignallingSummary))])
            self._leafs = OrderedDict()

            self.issu = MplsTe.SignallingCounters.Issu()
            self.issu.parent = self
            self._children_name_map["issu"] = "issu"

            self.fsm_unexpected_event_stats = MplsTe.SignallingCounters.FsmUnexpectedEventStats()
            self.fsm_unexpected_event_stats.parent = self
            self._children_name_map["fsm_unexpected_event_stats"] = "fsm-unexpected-event-stats"

            self.head_signalling_counters = MplsTe.SignallingCounters.HeadSignallingCounters()
            self.head_signalling_counters.parent = self
            self._children_name_map["head_signalling_counters"] = "head-signalling-counters"

            self.remote_signalling_counters = MplsTe.SignallingCounters.RemoteSignallingCounters()
            self.remote_signalling_counters.parent = self
            self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"

            self.signallings = MplsTe.SignallingCounters.Signallings()
            self.signallings.parent = self
            self._children_name_map["signallings"] = "signallings"

            self.signalling_summary = MplsTe.SignallingCounters.SignallingSummary()
            self.signalling_summary.parent = self
            self._children_name_map["signalling_summary"] = "signalling-summary"
            self._segment_path = lambda: "signalling-counters"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.SignallingCounters, [], name, value)


        class Issu(_Entity_):
            """
            MPLS TE ISSU counters
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp, in seconds, when these statistics are cleared              since 00\:00\:00 UTC, January 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            .. attribute:: last_idt_states
            
            	Last IDT States
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_states
            
            	Total states
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_deletions
            
            	Total deletions
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_nac_ks
            
            	Total NACKs
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_id_ts
            
            	Total IDTs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.Issu, self).__init__()

                self.yang_name = "issu"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                    ('last_idt_states', (YLeaf(YType.uint32, 'last-idt-states'), ['int'])),
                    ('total_states', (YLeaf(YType.uint32, 'total-states'), ['int'])),
                    ('total_deletions', (YLeaf(YType.uint32, 'total-deletions'), ['int'])),
                    ('total_nac_ks', (YLeaf(YType.uint64, 'total-nac-ks'), ['int'])),
                    ('total_id_ts', (YLeaf(YType.uint32, 'total-id-ts'), ['int'])),
                ])
                self.last_cleared_timestamp = None
                self.role = None
                self.last_idt_states = None
                self.total_states = None
                self.total_deletions = None
                self.total_nac_ks = None
                self.total_id_ts = None
                self._segment_path = lambda: "issu"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.Issu, ['last_cleared_timestamp', 'role', 'last_idt_states', 'total_states', 'total_deletions', 'total_nac_ks', 'total_id_ts'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.Issu']['meta_info']


        class FsmUnexpectedEventStats(_Entity_):
            """
            TE S2L FSM unexpected event stats
            
            .. attribute:: head_fsm_events
            
            	FSM unexpected event stats for headend S2Ls
            	**type**\:  :py:class:`HeadFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: mid_fsm_events
            
            	FSM unexpected event stats for midpoint S2Ls
            	**type**\:  :py:class:`MidFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: tail_fsm_events
            
            	FSM unexpected event stats for tailend S2Ls
            	**type**\:  :py:class:`TailFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: last_cleared_time
            
            	Timestamp when the stat has been cleared
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: unexpected_event_num
            
            	Total number of unexpected events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.FsmUnexpectedEventStats, self).__init__()

                self.yang_name = "fsm-unexpected-event-stats"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-fsm-events", ("head_fsm_events", MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents)), ("mid-fsm-events", ("mid_fsm_events", MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents)), ("tail-fsm-events", ("tail_fsm_events", MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents))])
                self._leafs = OrderedDict([
                    ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ('unexpected_event_num', (YLeaf(YType.uint32, 'unexpected-event-num'), ['int'])),
                ])
                self.last_cleared_time = None
                self.unexpected_event_num = None

                self.head_fsm_events = MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents()
                self.head_fsm_events.parent = self
                self._children_name_map["head_fsm_events"] = "head-fsm-events"

                self.mid_fsm_events = MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents()
                self.mid_fsm_events.parent = self
                self._children_name_map["mid_fsm_events"] = "mid-fsm-events"

                self.tail_fsm_events = MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents()
                self.tail_fsm_events.parent = self
                self._children_name_map["tail_fsm_events"] = "tail-fsm-events"
                self._segment_path = lambda: "fsm-unexpected-event-stats"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats, ['last_cleared_time', 'unexpected_event_num'], name, value)


            class HeadFsmEvents(_Entity_):
                """
                FSM unexpected event stats for headend S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents, self).__init__()

                    self.yang_name = "head-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "head-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "head-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/head-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents']['meta_info']


            class MidFsmEvents(_Entity_):
                """
                FSM unexpected event stats for midpoint S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents, self).__init__()

                    self.yang_name = "mid-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "mid-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "mid-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/mid-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents']['meta_info']


            class TailFsmEvents(_Entity_):
                """
                FSM unexpected event stats for tailend S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents, self).__init__()

                    self.yang_name = "tail-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "tail-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "tail-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/fsm-unexpected-event-stats/tail-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.FsmUnexpectedEventStats']['meta_info']


        class HeadSignallingCounters(_Entity_):
            """
            Sig Head Table TE counters
            
            .. attribute:: head_signalling_counter
            
            	TE stats
            	**type**\: list of  		 :py:class:`HeadSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.HeadSignallingCounters, self).__init__()

                self.yang_name = "head-signalling-counters"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-signalling-counter", ("head_signalling_counter", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter))])
                self._leafs = OrderedDict()

                self.head_signalling_counter = YList(self)
                self._segment_path = lambda: "head-signalling-counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters, [], name, value)


            class HeadSignallingCounter(_Entity_):
                """
                TE stats
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of  		 :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__init__()

                    self.yang_name = "head-signalling-counter"
                    self.yang_parent_name = "head-signalling-counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id']
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics)), ("destination-statistic", ("destination_statistic", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.tunnel_sig_name = None
                    self.lsp_id = None

                    self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.destination_statistic = YList(self)
                    self._segment_path = lambda: "head-signalling-counter" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/head-signalling-counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, ['ctype', 'tunnel_id', 'tunnel_name', 'tunnel_sig_name', 'lsp_id'], name, value)


                class Statistics(_Entity_):
                    """
                    VIF stats
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "head-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                        ])
                        self.tx_event_unknown = None
                        self.tx_path_create_event = None
                        self.tx_path_change_event = None
                        self.tx_path_delete_event = None
                        self.tx_path_error_event = None
                        self.tx_resv_create_event = None
                        self.tx_resv_change_event = None
                        self.tx_resv_delete_event = None
                        self.tx_resv_error_event = None
                        self.tx_path_reeval_query_event = None
                        self.rx_event_unknown = None
                        self.rx_path_create_event = None
                        self.rx_path_change_event = None
                        self.rx_path_delete_event = None
                        self.rx_path_error_event = None
                        self.rx_resv_create_event = None
                        self.rx_resv_change_event = None
                        self.rx_resv_delete_event = None
                        self.rx_resv_error_event = None
                        self.rx_path_reeval_query_event = None
                        self.tx_backup_assign_event = None
                        self.rx_backup_assign_err_event = None
                        self.events_total_count = None
                        self.events_count = None
                        self._segment_path = lambda: "statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics']['meta_info']


                class DestinationStatistic(_Entity_):
                    """
                    List of Destination Stats
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "head-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ])
                        self.destination_address = None

                        self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"

                        self.s2l_statistic = YList(self)
                        self._segment_path = lambda: "destination-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, ['destination_address'], name, value)


                    class Statistics(_Entity_):
                        """
                        Destination stats
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                            ])
                            self.tx_event_unknown = None
                            self.tx_path_create_event = None
                            self.tx_path_change_event = None
                            self.tx_path_delete_event = None
                            self.tx_path_error_event = None
                            self.tx_resv_create_event = None
                            self.tx_resv_change_event = None
                            self.tx_resv_delete_event = None
                            self.tx_resv_error_event = None
                            self.tx_path_reeval_query_event = None
                            self.rx_event_unknown = None
                            self.rx_path_create_event = None
                            self.rx_path_change_event = None
                            self.rx_path_delete_event = None
                            self.rx_path_error_event = None
                            self.rx_resv_create_event = None
                            self.rx_resv_change_event = None
                            self.rx_resv_delete_event = None
                            self.rx_resv_error_event = None
                            self.rx_path_reeval_query_event = None
                            self.tx_backup_assign_event = None
                            self.rx_backup_assign_err_event = None
                            self.events_total_count = None
                            self.events_count = None
                            self._segment_path = lambda: "statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics']['meta_info']


                    class S2lStatistic(_Entity_):
                        """
                        List of S2L Stats
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics))])
                            self._leafs = OrderedDict([
                                ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ])
                            self.sub_group_originator = None
                            self.sub_group_id = None
                            self.destination_address = None

                            self.statistics = MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "s2l-statistic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                        class Statistics(_Entity_):
                            """
                            S2L stats
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.HeadSignallingCounters']['meta_info']


        class RemoteSignallingCounters(_Entity_):
            """
            Sig mid tail Table TE counters
            
            .. attribute:: remote_signalling_counter
            
            	TE stats
            	**type**\: list of  		 :py:class:`RemoteSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.RemoteSignallingCounters, self).__init__()

                self.yang_name = "remote-signalling-counters"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("remote-signalling-counter", ("remote_signalling_counter", MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter))])
                self._leafs = OrderedDict()

                self.remote_signalling_counter = YList(self)
                self._segment_path = lambda: "remote-signalling-counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.RemoteSignallingCounters, [], name, value)


            class RemoteSignallingCounter(_Entity_):
                """
                TE stats
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup originator
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__init__()

                    self.yang_name = "remote-signalling-counter"
                    self.yang_parent_name = "remote-signalling-counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id','extended_tunnel_id','p2mp_id','lsp_id','source_address','destination_address','sub_group_originator','sub_group_id']
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.p2mp_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.sub_group_originator = None
                    self.sub_group_id = None
                    self.tunnel_name = None

                    self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.s2l_statistic = YList(self)
                    self._segment_path = lambda: "remote-signalling-counter" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/remote-signalling-counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, ['ctype', 'tunnel_id', 'extended_tunnel_id', 'p2mp_id', 'lsp_id', 'source_address', 'destination_address', 'sub_group_originator', 'sub_group_id', 'tunnel_name'], name, value)


                class Statistics(_Entity_):
                    """
                    LSP statistics
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "remote-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                        ])
                        self.tx_event_unknown = None
                        self.tx_path_create_event = None
                        self.tx_path_change_event = None
                        self.tx_path_delete_event = None
                        self.tx_path_error_event = None
                        self.tx_resv_create_event = None
                        self.tx_resv_change_event = None
                        self.tx_resv_delete_event = None
                        self.tx_resv_error_event = None
                        self.tx_path_reeval_query_event = None
                        self.rx_event_unknown = None
                        self.rx_path_create_event = None
                        self.rx_path_change_event = None
                        self.rx_path_delete_event = None
                        self.rx_path_error_event = None
                        self.rx_resv_create_event = None
                        self.rx_resv_change_event = None
                        self.rx_resv_delete_event = None
                        self.rx_resv_error_event = None
                        self.rx_path_reeval_query_event = None
                        self.tx_backup_assign_event = None
                        self.rx_backup_assign_err_event = None
                        self.events_total_count = None
                        self.events_count = None
                        self._segment_path = lambda: "statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics']['meta_info']


                class S2lStatistic(_Entity_):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "remote-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics))])
                        self._leafs = OrderedDict([
                            ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                            ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ])
                        self.sub_group_originator = None
                        self.sub_group_id = None
                        self.destination_address = None

                        self.statistics = MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._segment_path = lambda: "s2l-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                    class Statistics(_Entity_):
                        """
                        S2L stats
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                            ])
                            self.tx_event_unknown = None
                            self.tx_path_create_event = None
                            self.tx_path_change_event = None
                            self.tx_path_delete_event = None
                            self.tx_path_error_event = None
                            self.tx_resv_create_event = None
                            self.tx_resv_change_event = None
                            self.tx_resv_delete_event = None
                            self.tx_resv_error_event = None
                            self.tx_path_reeval_query_event = None
                            self.rx_event_unknown = None
                            self.rx_path_create_event = None
                            self.rx_path_change_event = None
                            self.rx_path_delete_event = None
                            self.rx_path_error_event = None
                            self.rx_resv_create_event = None
                            self.rx_resv_change_event = None
                            self.rx_resv_delete_event = None
                            self.rx_resv_error_event = None
                            self.rx_path_reeval_query_event = None
                            self.tx_backup_assign_event = None
                            self.rx_backup_assign_err_event = None
                            self.events_total_count = None
                            self.events_count = None
                            self._segment_path = lambda: "statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.RemoteSignallingCounters']['meta_info']


        class Signallings(_Entity_):
            """
            TE counters
            
            .. attribute:: signalling
            
            	TE Sig
            	**type**\: list of  		 :py:class:`Signalling <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.Signallings, self).__init__()

                self.yang_name = "signallings"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("signalling", ("signalling", MplsTe.SignallingCounters.Signallings.Signalling))])
                self._leafs = OrderedDict()

                self.signalling = YList(self)
                self._segment_path = lambda: "signallings"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.Signallings, [], name, value)


            class Signalling(_Entity_):
                """
                TE Sig
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup originator
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_signalling_filter_data
                
                	TE Signaling Filter data
                	**type**\:  :py:class:`TeSignallingFilterData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.SignallingCounters.Signallings.Signalling, self).__init__()

                    self.yang_name = "signalling"
                    self.yang_parent_name = "signallings"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id','extended_tunnel_id','p2mp_id','lsp_id','source_address','destination_address','sub_group_originator','sub_group_id']
                    self._child_classes = OrderedDict([("te-signalling-filter-data", ("te_signalling_filter_data", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.p2mp_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.sub_group_originator = None
                    self.sub_group_id = None

                    self.te_signalling_filter_data = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                    self.te_signalling_filter_data.parent = self
                    self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                    self._segment_path = lambda: "signalling" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/signallings/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling, ['ctype', 'tunnel_id', 'extended_tunnel_id', 'p2mp_id', 'lsp_id', 'source_address', 'destination_address', 'sub_group_originator', 'sub_group_id'], name, value)


                class TeSignallingFilterData(_Entity_):
                    """
                    TE Signaling Filter data
                    
                    .. attribute:: te_signalling_filter_vif
                    
                    	VIF data
                    	**type**\:  :py:class:`TeSignallingFilterVif <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif>`
                    
                    	**config**\: False
                    
                    .. attribute:: te_signalling_filter_lsp
                    
                    	LSP data
                    	**type**\:  :py:class:`TeSignallingFilterLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: statistics_filter
                    
                    	StatisticsFilter
                    	**type**\:  :py:class:`TeStatsSigFilter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeStatsSigFilter>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__init__()

                        self.yang_name = "te-signalling-filter-data"
                        self.yang_parent_name = "signalling"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("te-signalling-filter-vif", ("te_signalling_filter_vif", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif)), ("te-signalling-filter-lsp", ("te_signalling_filter_lsp", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp))])
                        self._leafs = OrderedDict([
                            ('statistics_filter', (YLeaf(YType.enumeration, 'statistics-filter'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeStatsSigFilter', '')])),
                        ])
                        self.statistics_filter = None

                        self.te_signalling_filter_vif = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                        self.te_signalling_filter_vif.parent = self
                        self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"

                        self.te_signalling_filter_lsp = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                        self.te_signalling_filter_lsp.parent = self
                        self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                        self._segment_path = lambda: "te-signalling-filter-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, ['statistics_filter'], name, value)


                    class TeSignallingFilterVif(_Entity_):
                        """
                        VIF data
                        
                        .. attribute:: statistics
                        
                        	VIF stats
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_sig_name
                        
                        	Tunnel Signalled\-Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: destination_statistic
                        
                        	List of Destination Stats
                        	**type**\: list of  		 :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__init__()

                            self.yang_name = "te-signalling-filter-vif"
                            self.yang_parent_name = "te-signalling-filter-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics)), ("destination-statistic", ("destination_statistic", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic))])
                            self._leafs = OrderedDict([
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                                ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                                ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ])
                            self.tunnel_name = None
                            self.tunnel_sig_name = None
                            self.lsp_id = None

                            self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"

                            self.destination_statistic = YList(self)
                            self._segment_path = lambda: "te-signalling-filter-vif"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, ['tunnel_name', 'tunnel_sig_name', 'lsp_id'], name, value)


                        class Statistics(_Entity_):
                            """
                            VIF stats
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-vif"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics']['meta_info']


                        class DestinationStatistic(_Entity_):
                            """
                            List of Destination Stats
                            
                            .. attribute:: statistics
                            
                            	Destination stats
                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_statistic
                            
                            	List of S2L Stats
                            	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__init__()

                                self.yang_name = "destination-statistic"
                                self.yang_parent_name = "te-signalling-filter-vif"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic))])
                                self._leafs = OrderedDict([
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ])
                                self.destination_address = None

                                self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"

                                self.s2l_statistic = YList(self)
                                self._segment_path = lambda: "destination-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, ['destination_address'], name, value)


                            class Statistics(_Entity_):
                                """
                                Destination stats
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "destination-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                        ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                        ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                        ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                        ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                        ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                        ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                        ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                        ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                        ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                        ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                        ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                        ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                        ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                        ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                        ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                        ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                        ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                        ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                        ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                        ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                        ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                        ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                        ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                    ])
                                    self.tx_event_unknown = None
                                    self.tx_path_create_event = None
                                    self.tx_path_change_event = None
                                    self.tx_path_delete_event = None
                                    self.tx_path_error_event = None
                                    self.tx_resv_create_event = None
                                    self.tx_resv_change_event = None
                                    self.tx_resv_delete_event = None
                                    self.tx_resv_error_event = None
                                    self.tx_path_reeval_query_event = None
                                    self.rx_event_unknown = None
                                    self.rx_path_create_event = None
                                    self.rx_path_change_event = None
                                    self.rx_path_delete_event = None
                                    self.rx_path_error_event = None
                                    self.rx_resv_create_event = None
                                    self.rx_resv_change_event = None
                                    self.rx_resv_delete_event = None
                                    self.rx_resv_error_event = None
                                    self.rx_path_reeval_query_event = None
                                    self.tx_backup_assign_event = None
                                    self.rx_backup_assign_err_event = None
                                    self.events_total_count = None
                                    self.events_count = None
                                    self._segment_path = lambda: "statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics']['meta_info']


                            class S2lStatistic(_Entity_):
                                """
                                List of S2L Stats
                                
                                .. attribute:: statistics
                                
                                	S2L stats
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: sub_group_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sub_group_id
                                
                                	subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: destination_address
                                
                                	Destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic, self).__init__()

                                    self.yang_name = "s2l-statistic"
                                    self.yang_parent_name = "destination-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                        ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ])
                                    self.sub_group_originator = None
                                    self.sub_group_id = None
                                    self.destination_address = None

                                    self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "s2l-statistic"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                                class Statistics(_Entity_):
                                    """
                                    S2L stats
                                    
                                    .. attribute:: tx_event_unknown
                                    
                                    	Unknown TX events
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_create_event
                                    
                                    	TX Path Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_change_event
                                    
                                    	TX Path Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_delete_event
                                    
                                    	TX Path Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_error_event
                                    
                                    	TX Path Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_create_event
                                    
                                    	TX Resv Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_change_event
                                    
                                    	TX Resv Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_delete_event
                                    
                                    	TX Resv Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_error_event
                                    
                                    	TX Resv Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_reeval_query_event
                                    
                                    	TX Path Reeval Query event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_event_unknown
                                    
                                    	RX Unknown events
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_create_event
                                    
                                    	RX Path Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_change_event
                                    
                                    	RX Path Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_delete_event
                                    
                                    	RX Path Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_error_event
                                    
                                    	RX Path Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_create_event
                                    
                                    	RX Resv Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_change_event
                                    
                                    	RX Resv Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_delete_event
                                    
                                    	RX Resv Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_error_event
                                    
                                    	RX Resv Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_reeval_query_event
                                    
                                    	RX Path Reeval Query event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_backup_assign_event
                                    
                                    	Backup Assign event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_backup_assign_err_event
                                    
                                    	Error on Backup Assign event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: events_total_count
                                    
                                    	Total TE Signalling event count
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: events_count
                                    
                                    	TE Signaling event count
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "s2l-statistic"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                        ])
                                        self.tx_event_unknown = None
                                        self.tx_path_create_event = None
                                        self.tx_path_change_event = None
                                        self.tx_path_delete_event = None
                                        self.tx_path_error_event = None
                                        self.tx_resv_create_event = None
                                        self.tx_resv_change_event = None
                                        self.tx_resv_delete_event = None
                                        self.tx_resv_error_event = None
                                        self.tx_path_reeval_query_event = None
                                        self.rx_event_unknown = None
                                        self.rx_path_create_event = None
                                        self.rx_path_change_event = None
                                        self.rx_path_delete_event = None
                                        self.rx_path_error_event = None
                                        self.rx_resv_create_event = None
                                        self.rx_resv_change_event = None
                                        self.rx_resv_delete_event = None
                                        self.rx_resv_error_event = None
                                        self.rx_path_reeval_query_event = None
                                        self.tx_backup_assign_event = None
                                        self.rx_backup_assign_err_event = None
                                        self.events_total_count = None
                                        self.events_count = None
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif']['meta_info']


                    class TeSignallingFilterLsp(_Entity_):
                        """
                        LSP data
                        
                        .. attribute:: statistics
                        
                        	LSP statistics
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_statistic
                        
                        	List of S2L Statistics
                        	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__init__()

                            self.yang_name = "te-signalling-filter-lsp"
                            self.yang_parent_name = "te-signalling-filter-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic))])
                            self._leafs = OrderedDict([
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.tunnel_name = None

                            self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"

                            self.s2l_statistic = YList(self)
                            self._segment_path = lambda: "te-signalling-filter-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, ['tunnel_name'], name, value)


                        class Statistics(_Entity_):
                            """
                            LSP statistics
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics']['meta_info']


                        class S2lStatistic(_Entity_):
                            """
                            List of S2L Statistics
                            
                            .. attribute:: statistics
                            
                            	S2L stats
                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: sub_group_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sub_group_id
                            
                            	subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic, self).__init__()

                                self.yang_name = "s2l-statistic"
                                self.yang_parent_name = "te-signalling-filter-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics))])
                                self._leafs = OrderedDict([
                                    ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                    ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ])
                                self.sub_group_originator = None
                                self.sub_group_id = None
                                self.destination_address = None

                                self.statistics = MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._segment_path = lambda: "s2l-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                            class Statistics(_Entity_):
                                """
                                S2L stats
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "s2l-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                        ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                        ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                        ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                        ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                        ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                        ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                        ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                        ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                        ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                        ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                        ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                        ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                        ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                        ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                        ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                        ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                        ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                        ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                        ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                        ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                        ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                        ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                        ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                    ])
                                    self.tx_event_unknown = None
                                    self.tx_path_create_event = None
                                    self.tx_path_change_event = None
                                    self.tx_path_delete_event = None
                                    self.tx_path_error_event = None
                                    self.tx_resv_create_event = None
                                    self.tx_resv_change_event = None
                                    self.tx_resv_delete_event = None
                                    self.tx_resv_error_event = None
                                    self.tx_path_reeval_query_event = None
                                    self.rx_event_unknown = None
                                    self.rx_path_create_event = None
                                    self.rx_path_change_event = None
                                    self.rx_path_delete_event = None
                                    self.rx_path_error_event = None
                                    self.rx_resv_create_event = None
                                    self.rx_resv_change_event = None
                                    self.rx_resv_delete_event = None
                                    self.rx_resv_error_event = None
                                    self.rx_path_reeval_query_event = None
                                    self.tx_backup_assign_event = None
                                    self.rx_backup_assign_err_event = None
                                    self.events_total_count = None
                                    self.events_count = None
                                    self._segment_path = lambda: "statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling.TeSignallingFilterData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.SignallingCounters.Signallings.Signalling']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.Signallings']['meta_info']


        class SignallingSummary(_Entity_):
            """
            Send\-Recv count summary for TE Signaling
            
            .. attribute:: tx_event_unknown
            
            	Unknown TX events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_create_event
            
            	TX Path Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_change_event
            
            	TX Path Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_delete_event
            
            	TX Path Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_error_event
            
            	TX Path Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_create_event
            
            	TX Resv Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_change_event
            
            	TX Resv Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_delete_event
            
            	TX Resv Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_error_event
            
            	TX Resv Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_reeval_query_event
            
            	TX Path Reeval Query event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_event_unknown
            
            	RX Unknown events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_create_event
            
            	RX Path Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_change_event
            
            	RX Path Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_delete_event
            
            	RX Path Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_error_event
            
            	RX Path Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_create_event
            
            	RX Resv Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_change_event
            
            	RX Resv Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_delete_event
            
            	RX Resv Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_error_event
            
            	RX Resv Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_reeval_query_event
            
            	RX Path Reeval Query event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_backup_assign_event
            
            	Backup Assign event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_backup_assign_err_event
            
            	Error on Backup Assign event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: events_total_count
            
            	Total TE Signalling event count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: events_count
            
            	TE Signaling event count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.SignallingCounters.SignallingSummary, self).__init__()

                self.yang_name = "signalling-summary"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                ])
                self.tx_event_unknown = None
                self.tx_path_create_event = None
                self.tx_path_change_event = None
                self.tx_path_delete_event = None
                self.tx_path_error_event = None
                self.tx_resv_create_event = None
                self.tx_resv_change_event = None
                self.tx_resv_delete_event = None
                self.tx_resv_error_event = None
                self.tx_path_reeval_query_event = None
                self.rx_event_unknown = None
                self.rx_path_create_event = None
                self.rx_path_change_event = None
                self.rx_path_delete_event = None
                self.rx_path_error_event = None
                self.rx_resv_create_event = None
                self.rx_resv_change_event = None
                self.rx_resv_delete_event = None
                self.rx_resv_error_event = None
                self.rx_path_reeval_query_event = None
                self.tx_backup_assign_event = None
                self.rx_backup_assign_err_event = None
                self.events_total_count = None
                self.events_count = None
                self._segment_path = lambda: "signalling-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.SignallingCounters.SignallingSummary, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.SignallingCounters.SignallingSummary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.SignallingCounters']['meta_info']


    class DiffServTeClasses(_Entity_):
        """
        The configured Diff Serv TE classes
        
        .. attribute:: te_class
        
        	te class
        	**type**\: list of  		 :py:class:`TeClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.DiffServTeClasses.TeClass>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.DiffServTeClasses, self).__init__()

            self.yang_name = "diff-serv-te-classes"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("te-class", ("te_class", MplsTe.DiffServTeClasses.TeClass))])
            self._leafs = OrderedDict()

            self.te_class = YList(self)
            self._segment_path = lambda: "diff-serv-te-classes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.DiffServTeClasses, [], name, value)


        class TeClass(_Entity_):
            """
            te class
            
            .. attribute:: class_number
            
            	The DS\-TE class number from 0 to 7
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: class_type
            
            	The class type of the TE class
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: priority
            
            	The priority of the TE class
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: class_status
            
            	The status of the TE class
            	**type**\:  :py:class:`MplsTeDsteClassStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeDsteClassStatus>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.DiffServTeClasses.TeClass, self).__init__()

                self.yang_name = "te-class"
                self.yang_parent_name = "diff-serv-te-classes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('class_number', (YLeaf(YType.uint8, 'class-number'), ['int'])),
                    ('class_type', (YLeaf(YType.uint8, 'class-type'), ['int'])),
                    ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                    ('class_status', (YLeaf(YType.enumeration, 'class-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeDsteClassStatus', '')])),
                ])
                self.class_number = None
                self.class_type = None
                self.priority = None
                self.class_status = None
                self._segment_path = lambda: "te-class"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/diff-serv-te-classes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.DiffServTeClasses.TeClass, ['class_number', 'class_type', 'priority', 'class_status'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.DiffServTeClasses.TeClass']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.DiffServTeClasses']['meta_info']


    class Issu(_Entity_):
        """
        MPLS TE ISSU information
        
        .. attribute:: status
        
        	MPLS TE ISSU Status information
        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status>`
        
        	**config**\: False
        
        .. attribute:: detail
        
        	MPLS TE ISSU Status information
        	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.Issu, self).__init__()

            self.yang_name = "issu"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("status", ("status", MplsTe.Issu.Status)), ("detail", ("detail", MplsTe.Issu.Detail))])
            self._leafs = OrderedDict()

            self.status = MplsTe.Issu.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"

            self.detail = MplsTe.Issu.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._segment_path = lambda: "issu"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.Issu, [], name, value)


        class Status(_Entity_):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Issu.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "issu"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTe.Issu.Status.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTe.Issu.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "status"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Issu.Status, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Issu.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Issu.Status.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Issu.Status']['meta_info']


        class Detail(_Entity_):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Issu.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "issu"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTe.Issu.Detail.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTe.Issu.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "detail"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Issu.Detail, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Issu.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/issu/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Issu.Detail.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Issu.Detail']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.Issu']['meta_info']


    class AutoRouteDestinationEntries(_Entity_):
        """
        MPLS TE autoroute destination table indexed by
        tunnel
        
        .. attribute:: auto_route_destination_entry
        
        	MPLS TE autoroute destination info for one tunnel
        	**type**\: list of  		 :py:class:`AutoRouteDestinationEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AutoRouteDestinationEntries, self).__init__()

            self.yang_name = "auto-route-destination-entries"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("auto-route-destination-entry", ("auto_route_destination_entry", MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry))])
            self._leafs = OrderedDict()

            self.auto_route_destination_entry = YList(self)
            self._segment_path = lambda: "auto-route-destination-entries"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AutoRouteDestinationEntries, [], name, value)


        class AutoRouteDestinationEntry(_Entity_):
            """
            MPLS TE autoroute destination info for one
            tunnel
            
            .. attribute:: tunnel_id  (key)
            
            	Tunnel ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tunnel_id_xr
            
            	tunnel id xr
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_name
            
            	Tunnel name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: tunnel_autoroute_dest
            
            	tunnel autoroute dest
            	**type**\: list of  		 :py:class:`TunnelAutorouteDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry, self).__init__()

                self.yang_name = "auto-route-destination-entry"
                self.yang_parent_name = "auto-route-destination-entries"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['tunnel_id']
                self._child_classes = OrderedDict([("tunnel-autoroute-dest", ("tunnel_autoroute_dest", MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest))])
                self._leafs = OrderedDict([
                    ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                    ('tunnel_id_xr', (YLeaf(YType.uint16, 'tunnel-id-xr'), ['int'])),
                    ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                ])
                self.tunnel_id = None
                self.tunnel_id_xr = None
                self.tunnel_name = None

                self.tunnel_autoroute_dest = YList(self)
                self._segment_path = lambda: "auto-route-destination-entry" + "[tunnel-id='" + str(self.tunnel_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-route-destination-entries/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry, ['tunnel_id', 'tunnel_id_xr', 'tunnel_name'], name, value)


            class TunnelAutorouteDest(_Entity_):
                """
                tunnel autoroute dest
                
                .. attribute:: prefix_address
                
                	PrefixAddress
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: prefix_length
                
                	PrefixLength
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: metric
                
                	Metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: install_time
                
                	InstallTime
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: interface_handle
                
                	InterfaceHandle
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, self).__init__()

                    self.yang_name = "tunnel-autoroute-dest"
                    self.yang_parent_name = "auto-route-destination-entry"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('prefix_address', (YLeaf(YType.str, 'prefix-address'), ['str'])),
                        ('prefix_length', (YLeaf(YType.uint32, 'prefix-length'), ['int'])),
                        ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                        ('install_time', (YLeaf(YType.uint32, 'install-time'), ['int'])),
                        ('interface_handle', (YLeaf(YType.str, 'interface-handle'), ['str'])),
                    ])
                    self.prefix_address = None
                    self.prefix_length = None
                    self.metric = None
                    self.install_time = None
                    self.interface_handle = None
                    self._segment_path = lambda: "tunnel-autoroute-dest"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, ['prefix_address', 'prefix_length', 'metric', 'install_time', 'interface_handle'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AutoRouteDestinationEntries.AutoRouteDestinationEntry']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AutoRouteDestinationEntries']['meta_info']


    class FastReroute(_Entity_):
        """
        Represent all the fastreroute info in MPLS\-TE
        
        .. attribute:: backup_tunnels
        
        	The set of fastreroute backup tunnels available in MPLS\-TE
        	**type**\:  :py:class:`BackupTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.BackupTunnels>`
        
        	**config**\: False
        
        .. attribute:: protected_interfaces
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:  :py:class:`ProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.ProtectedInterfaces>`
        
        	**config**\: False
        
        .. attribute:: protections
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:  :py:class:`Protections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Protections>`
        
        	**config**\: False
        
        .. attribute:: promotion
        
        	The info about the promotion timer of backup tunnels
        	**type**\:  :py:class:`Promotion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Promotion>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.FastReroute, self).__init__()

            self.yang_name = "fast-reroute"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("backup-tunnels", ("backup_tunnels", MplsTe.FastReroute.BackupTunnels)), ("protected-interfaces", ("protected_interfaces", MplsTe.FastReroute.ProtectedInterfaces)), ("protections", ("protections", MplsTe.FastReroute.Protections)), ("promotion", ("promotion", MplsTe.FastReroute.Promotion))])
            self._leafs = OrderedDict()

            self.backup_tunnels = MplsTe.FastReroute.BackupTunnels()
            self.backup_tunnels.parent = self
            self._children_name_map["backup_tunnels"] = "backup-tunnels"

            self.protected_interfaces = MplsTe.FastReroute.ProtectedInterfaces()
            self.protected_interfaces.parent = self
            self._children_name_map["protected_interfaces"] = "protected-interfaces"

            self.protections = MplsTe.FastReroute.Protections()
            self.protections.parent = self
            self._children_name_map["protections"] = "protections"

            self.promotion = MplsTe.FastReroute.Promotion()
            self.promotion.parent = self
            self._children_name_map["promotion"] = "promotion"
            self._segment_path = lambda: "fast-reroute"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.FastReroute, [], name, value)


        class BackupTunnels(_Entity_):
            """
            The set of fastreroute backup tunnels available
            in MPLS\-TE
            
            .. attribute:: backup_tunnel
            
            	Fastreroute info for a given backup tunnel
            	**type**\: list of  		 :py:class:`BackupTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.BackupTunnels.BackupTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FastReroute.BackupTunnels, self).__init__()

                self.yang_name = "backup-tunnels"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("backup-tunnel", ("backup_tunnel", MplsTe.FastReroute.BackupTunnels.BackupTunnel))])
                self._leafs = OrderedDict()

                self.backup_tunnel = YList(self)
                self._segment_path = lambda: "backup-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FastReroute.BackupTunnels, [], name, value)


            class BackupTunnel(_Entity_):
                """
                Fastreroute info for a given backup tunnel
                
                .. attribute:: tunnel_name  (key)
                
                	Backup tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: interface_name  (key)
                
                	Protected interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:  :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                	**config**\: False
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:  :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FastReroute.BackupTunnels.BackupTunnel, self).__init__()

                    self.yang_name = "backup-tunnel"
                    self.yang_parent_name = "backup-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name','interface_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('backup_tunnel_id', (YLeaf(YType.uint32, 'backup-tunnel-id'), ['int'])),
                        ('backup_tunnel_name_xr', (YLeaf(YType.str, 'backup-tunnel-name-xr'), ['str'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('backup_type', (YLeaf(YType.enumeration, 'backup-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackup', '')])),
                        ('backup_usage', (YLeaf(YType.enumeration, 'backup-usage'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupUsage', '')])),
                        ('prot_interface_autobackup_config', (YLeaf(YType.enumeration, 'prot-interface-autobackup-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                        ('prot_interface_srlg_config', (YLeaf(YType.enumeration, 'prot-interface-srlg-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                        ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                        ('recreate_timer_is_running', (YLeaf(YType.boolean, 'recreate-timer-is-running'), ['bool'])),
                        ('recreate_remaining_time', (YLeaf(YType.uint32, 'recreate-remaining-time'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('general_status', (YLeaf(YType.enumeration, 'general-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('connection_status', (YLeaf(YType.enumeration, 'connection-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('in_use_bandwidth', (YLeaf(YType.uint32, 'in-use-bandwidth'), ['int'])),
                        ('soft_preempted_in_use_bandwidth', (YLeaf(YType.uint32, 'soft-preempted-in-use-bandwidth'), ['int'])),
                        ('ls_ps', (YLeaf(YType.uint32, 'ls-ps'), ['int'])),
                        ('s2l_families', (YLeaf(YType.uint32, 's2l-families'), ['int'])),
                        ('s2_ls', (YLeaf(YType.uint32, 's2-ls'), ['int'])),
                        ('frr_active_ls_ps', (YLeaf(YType.uint32, 'frr-active-ls-ps'), ['int'])),
                        ('frr_active_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'frr-active-soft-preempted-ls-ps'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.interface_name = None
                    self.backup_tunnel_id = None
                    self.backup_tunnel_name_xr = None
                    self.backup_status = None
                    self.backup_type = None
                    self.backup_usage = None
                    self.prot_interface_autobackup_config = None
                    self.prot_interface_srlg_config = None
                    self.tunnel_attribute_set_name = None
                    self.has_attribute_set = None
                    self.is_attribute_set_in_db = None
                    self.recreate_timer_is_running = None
                    self.recreate_remaining_time = None
                    self.source_address = None
                    self.destination_address = None
                    self.general_status = None
                    self.connection_status = None
                    self.output_interface_name = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.bandwidth = None
                    self.tunnel_instance = None
                    self.in_use_bandwidth = None
                    self.soft_preempted_in_use_bandwidth = None
                    self.ls_ps = None
                    self.s2l_families = None
                    self.s2_ls = None
                    self.frr_active_ls_ps = None
                    self.frr_active_soft_preempted_ls_ps = None
                    self._segment_path = lambda: "backup-tunnel" + "[tunnel-name='" + str(self.tunnel_name) + "']" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/backup-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FastReroute.BackupTunnels.BackupTunnel, ['tunnel_name', 'interface_name', 'backup_tunnel_id', 'backup_tunnel_name_xr', 'backup_status', 'backup_type', 'backup_usage', 'prot_interface_autobackup_config', 'prot_interface_srlg_config', 'tunnel_attribute_set_name', 'has_attribute_set', 'is_attribute_set_in_db', 'recreate_timer_is_running', 'recreate_remaining_time', 'source_address', 'destination_address', 'general_status', 'connection_status', 'output_interface_name', 'bandwidth_pool_type', 'bandwidth_limit_type', 'bandwidth', 'tunnel_instance', 'in_use_bandwidth', 'soft_preempted_in_use_bandwidth', 'ls_ps', 's2l_families', 's2_ls', 'frr_active_ls_ps', 'frr_active_soft_preempted_ls_ps'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FastReroute.BackupTunnels.BackupTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FastReroute.BackupTunnels']['meta_info']


        class ProtectedInterfaces(_Entity_):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protected_interface
            
            	Fastreroute info for a given protected interface
            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FastReroute.ProtectedInterfaces, self).__init__()

                self.yang_name = "protected-interfaces"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protected-interface", ("protected_interface", MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface))])
                self._leafs = OrderedDict()

                self.protected_interface = YList(self)
                self._segment_path = lambda: "protected-interfaces"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FastReroute.ProtectedInterfaces, [], name, value)


            class ProtectedInterface(_Entity_):
                """
                Fastreroute info for a given protected
                interface
                
                .. attribute:: interface_name  (key)
                
                	Protected interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name  (key)
                
                	Backup tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:  :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                	**config**\: False
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:  :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__init__()

                    self.yang_name = "protected-interface"
                    self.yang_parent_name = "protected-interfaces"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name','backup_tunnel_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                        ('backup_tunnel_id', (YLeaf(YType.uint32, 'backup-tunnel-id'), ['int'])),
                        ('backup_tunnel_name_xr', (YLeaf(YType.str, 'backup-tunnel-name-xr'), ['str'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('backup_type', (YLeaf(YType.enumeration, 'backup-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackup', '')])),
                        ('backup_usage', (YLeaf(YType.enumeration, 'backup-usage'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupUsage', '')])),
                        ('prot_interface_autobackup_config', (YLeaf(YType.enumeration, 'prot-interface-autobackup-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                        ('prot_interface_srlg_config', (YLeaf(YType.enumeration, 'prot-interface-srlg-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                        ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                        ('recreate_timer_is_running', (YLeaf(YType.boolean, 'recreate-timer-is-running'), ['bool'])),
                        ('recreate_remaining_time', (YLeaf(YType.uint32, 'recreate-remaining-time'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('general_status', (YLeaf(YType.enumeration, 'general-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('connection_status', (YLeaf(YType.enumeration, 'connection-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('in_use_bandwidth', (YLeaf(YType.uint32, 'in-use-bandwidth'), ['int'])),
                        ('soft_preempted_in_use_bandwidth', (YLeaf(YType.uint32, 'soft-preempted-in-use-bandwidth'), ['int'])),
                        ('ls_ps', (YLeaf(YType.uint32, 'ls-ps'), ['int'])),
                        ('s2l_families', (YLeaf(YType.uint32, 's2l-families'), ['int'])),
                        ('s2_ls', (YLeaf(YType.uint32, 's2-ls'), ['int'])),
                        ('frr_active_ls_ps', (YLeaf(YType.uint32, 'frr-active-ls-ps'), ['int'])),
                        ('frr_active_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'frr-active-soft-preempted-ls-ps'), ['int'])),
                    ])
                    self.interface_name = None
                    self.backup_tunnel_name = None
                    self.backup_tunnel_id = None
                    self.backup_tunnel_name_xr = None
                    self.backup_status = None
                    self.backup_type = None
                    self.backup_usage = None
                    self.prot_interface_autobackup_config = None
                    self.prot_interface_srlg_config = None
                    self.tunnel_attribute_set_name = None
                    self.has_attribute_set = None
                    self.is_attribute_set_in_db = None
                    self.recreate_timer_is_running = None
                    self.recreate_remaining_time = None
                    self.source_address = None
                    self.destination_address = None
                    self.general_status = None
                    self.connection_status = None
                    self.output_interface_name = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.bandwidth = None
                    self.tunnel_instance = None
                    self.in_use_bandwidth = None
                    self.soft_preempted_in_use_bandwidth = None
                    self.ls_ps = None
                    self.s2l_families = None
                    self.s2_ls = None
                    self.frr_active_ls_ps = None
                    self.frr_active_soft_preempted_ls_ps = None
                    self._segment_path = lambda: "protected-interface" + "[interface-name='" + str(self.interface_name) + "']" + "[backup-tunnel-name='" + str(self.backup_tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/protected-interfaces/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface, ['interface_name', 'backup_tunnel_name', 'backup_tunnel_id', 'backup_tunnel_name_xr', 'backup_status', 'backup_type', 'backup_usage', 'prot_interface_autobackup_config', 'prot_interface_srlg_config', 'tunnel_attribute_set_name', 'has_attribute_set', 'is_attribute_set_in_db', 'recreate_timer_is_running', 'recreate_remaining_time', 'source_address', 'destination_address', 'general_status', 'connection_status', 'output_interface_name', 'bandwidth_pool_type', 'bandwidth_limit_type', 'bandwidth', 'tunnel_instance', 'in_use_bandwidth', 'soft_preempted_in_use_bandwidth', 'ls_ps', 's2l_families', 's2_ls', 'frr_active_ls_ps', 'frr_active_soft_preempted_ls_ps'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FastReroute.ProtectedInterfaces.ProtectedInterface']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FastReroute.ProtectedInterfaces']['meta_info']


        class Protections(_Entity_):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protection
            
            	Fastreroute info for a given protection interface
            	**type**\: list of  		 :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FastReroute.Protections.Protection>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FastReroute.Protections, self).__init__()

                self.yang_name = "protections"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protection", ("protection", MplsTe.FastReroute.Protections.Protection))])
                self._leafs = OrderedDict()

                self.protection = YList(self)
                self._segment_path = lambda: "protections"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FastReroute.Protections, [], name, value)


            class Protection(_Entity_):
                """
                Fastreroute info for a given protection
                interface
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup Orig ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_type  (key)
                
                	Session Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: role
                
                	Role of LSP
                	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                
                	**config**\: False
                
                .. attribute:: admin_status
                
                	Tunnel Admin status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: operation_status
                
                	Tunnel operational status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: is_signalled
                
                	Indicates whether signalled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_frr_requested
                
                	TRUE if frr protection is on
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: inbound_frr_state
                
                	Indicates inbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_lsp
                
                	Output intface of the LSP
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: output_label
                
                	Output label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Next hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: frr_output_tunnel_interface
                
                	FRR output tunnel intface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: frr_output_label
                
                	FRR output label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup status
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: original_input_interface
                
                	Input intface of the LSP
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: input_label
                
                	Input label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: previous_hop_address
                
                	Previous hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: backup_bandwidth
                
                	Backup bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_output_interface
                
                	Output interface of bkup tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_next_hop_address
                
                	S2L Nexthop of the backup tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth_type
                
                	LSP bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: sharing_type
                
                	Outgoing i/f Sharing type
                	**type**\:  :py:class:`MplsTeFrrSharing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrSharing>`
                
                	**config**\: False
                
                .. attribute:: is_p2mp_tunnel
                
                	Is P2P or P2MP Tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FastReroute.Protections.Protection, self).__init__()

                    self.yang_name = "protection"
                    self.yang_parent_name = "protections"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_address','tunnel_id','extended_tunnel_id','lsp_id','sub_group_id','sub_group_originator','p2mp_id','session_type']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('session_type', (YLeaf(YType.uint32, 'session-type'), ['int'])),
                        ('source_address_xr', (YLeaf(YType.str, 'source-address-xr'), ['str'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('extended_tunnel_id_xr', (YLeaf(YType.str, 'extended-tunnel-id-xr'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                        ('admin_status', (YLeaf(YType.enumeration, 'admin-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('operation_status', (YLeaf(YType.enumeration, 'operation-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('is_signalled', (YLeaf(YType.boolean, 'is-signalled'), ['bool'])),
                        ('is_frr_requested', (YLeaf(YType.boolean, 'is-frr-requested'), ['bool'])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('inbound_frr_state', (YLeaf(YType.enumeration, 'inbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('output_interface_lsp', (YLeaf(YType.str, 'output-interface-lsp'), ['str'])),
                        ('output_label', (YLeaf(YType.uint32, 'output-label'), ['int'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('frr_output_tunnel_interface', (YLeaf(YType.str, 'frr-output-tunnel-interface'), ['str'])),
                        ('frr_output_label', (YLeaf(YType.uint32, 'frr-output-label'), ['int'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                        ('input_label', (YLeaf(YType.uint32, 'input-label'), ['int'])),
                        ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                        ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                        ('frr_output_interface', (YLeaf(YType.str, 'frr-output-interface'), ['str'])),
                        ('backup_next_hop_address', (YLeaf(YType.str, 'backup-next-hop-address'), ['str'])),
                        ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('sharing_type', (YLeaf(YType.enumeration, 'sharing-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrSharing', '')])),
                        ('is_p2mp_tunnel', (YLeaf(YType.boolean, 'is-p2mp-tunnel'), ['bool'])),
                        ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ('sub_group_id_xr', (YLeaf(YType.uint16, 'sub-group-id-xr'), ['int'])),
                        ('p2mp_id_xr', (YLeaf(YType.uint32, 'p2mp-id-xr'), ['int'])),
                    ])
                    self.source_address = None
                    self.destination_address = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.lsp_id = None
                    self.sub_group_id = None
                    self.sub_group_originator = None
                    self.p2mp_id = None
                    self.session_type = None
                    self.source_address_xr = None
                    self.destination_address_xr = None
                    self.tunnel_id_xr = None
                    self.extended_tunnel_id_xr = None
                    self.tunnel_name = None
                    self.tunnel_instance = None
                    self.role = None
                    self.admin_status = None
                    self.operation_status = None
                    self.is_signalled = None
                    self.is_frr_requested = None
                    self.outbound_frr_state = None
                    self.inbound_frr_state = None
                    self.output_interface_lsp = None
                    self.output_label = None
                    self.next_hop_address = None
                    self.frr_output_tunnel_interface = None
                    self.frr_output_label = None
                    self.backup_status = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.original_input_interface = None
                    self.input_label = None
                    self.previous_hop_address = None
                    self.backup_bandwidth = None
                    self.frr_output_interface = None
                    self.backup_next_hop_address = None
                    self.lsp_bandwidth_type = None
                    self.sharing_type = None
                    self.is_p2mp_tunnel = None
                    self.sub_group_original_id = None
                    self.sub_group_id_xr = None
                    self.p2mp_id_xr = None
                    self._segment_path = lambda: "protection" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[session-type='" + str(self.session_type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/protections/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FastReroute.Protections.Protection, ['source_address', 'destination_address', 'tunnel_id', 'extended_tunnel_id', 'lsp_id', 'sub_group_id', 'sub_group_originator', 'p2mp_id', 'session_type', 'source_address_xr', 'destination_address_xr', 'tunnel_id_xr', 'extended_tunnel_id_xr', 'tunnel_name', 'tunnel_instance', 'role', 'admin_status', 'operation_status', 'is_signalled', 'is_frr_requested', 'outbound_frr_state', 'inbound_frr_state', 'output_interface_lsp', 'output_label', 'next_hop_address', 'frr_output_tunnel_interface', 'frr_output_label', 'backup_status', 'bandwidth_pool_type', 'bandwidth_limit_type', 'original_input_interface', 'input_label', 'previous_hop_address', 'backup_bandwidth', 'frr_output_interface', 'backup_next_hop_address', 'lsp_bandwidth_type', 'sharing_type', 'is_p2mp_tunnel', 'sub_group_original_id', 'sub_group_id_xr', 'p2mp_id_xr'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FastReroute.Protections.Protection']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FastReroute.Protections']['meta_info']


        class Promotion(_Entity_):
            """
            The info about the promotion timer of backup
            tunnels
            
            .. attribute:: promotion_period
            
            	Promotion period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: remaining_time
            
            	Remaining time for next promotion in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: is_configured
            
            	Indicate if periodic promotion is configured 
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FastReroute.Promotion, self).__init__()

                self.yang_name = "promotion"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('promotion_period', (YLeaf(YType.uint32, 'promotion-period'), ['int'])),
                    ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                    ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                ])
                self.promotion_period = None
                self.remaining_time = None
                self.is_configured = None
                self._segment_path = lambda: "promotion"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FastReroute.Promotion, ['promotion_period', 'remaining_time', 'is_configured'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FastReroute.Promotion']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.FastReroute']['meta_info']


    class AttributeSets(_Entity_):
        """
        AttributeSet information.
        
        .. attribute:: attribute_set
        
        	MPLS TE attribute\-set information
        	**type**\: list of  		 :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AttributeSets, self).__init__()

            self.yang_name = "attribute-sets"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTe.AttributeSets.AttributeSet))])
            self._leafs = OrderedDict()

            self.attribute_set = YList(self)
            self._segment_path = lambda: "attribute-sets"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AttributeSets, [], name, value)


        class AttributeSet(_Entity_):
            """
            MPLS TE attribute\-set information
            
            .. attribute:: attribute_set_type  (key)
            
            	Attribute Set Type
            	**type**\:  :py:class:`MplsTeAttrSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAttrSet>`
            
            	**config**\: False
            
            .. attribute:: attribute_set_name  (key)
            
            	Attribute Set Name
            	**type**\: str
            
            	**length:** 1..64
            
            	**config**\: False
            
            .. attribute:: attribute_set_union
            
            	Union of Attribute Sets
            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion>`
            
            	**config**\: False
            
            .. attribute:: tunnel_attribute_set_name
            
            	Attribute Set Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: tunnel_attribute_set_name_crc32
            
            	Attribute Set name CRC32 value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AttributeSets.AttributeSet, self).__init__()

                self.yang_name = "attribute-set"
                self.yang_parent_name = "attribute-sets"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['attribute_set_type','attribute_set_name']
                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion))])
                self._leafs = OrderedDict([
                    ('attribute_set_type', (YLeaf(YType.enumeration, 'attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAttrSet', '')])),
                    ('attribute_set_name', (YLeaf(YType.str, 'attribute-set-name'), ['str'])),
                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                ])
                self.attribute_set_type = None
                self.attribute_set_name = None
                self.tunnel_attribute_set_name = None
                self.tunnel_attribute_set_name_crc32 = None

                self.attribute_set_union = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion()
                self.attribute_set_union.parent = self
                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                self._segment_path = lambda: "attribute-set" + "[attribute-set-type='" + str(self.attribute_set_type) + "']" + "[attribute-set-name='" + str(self.attribute_set_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/attribute-sets/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AttributeSets.AttributeSet, ['attribute_set_type', 'attribute_set_name', 'tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


            class AttributeSetUnion(_Entity_):
                """
                Union of Attribute Sets
                
                .. attribute:: attribute_set_path_option
                
                	MPLS TE Path Option Attribute Set
                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_autobackup
                
                	MPLS TE Auto\-backup Attribute Set
                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_automesh
                
                	MPLS TE Auto\-mesh Attribute Set
                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_xro
                
                	Attribute Set XRO
                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_p2mpte
                
                	MPLS TE P2MP\-TE Attribute Set
                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_aps_pp
                
                	Attribute Set OTN APS Path Protection
                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_p2p_te
                
                	MPLS TE P2P\-TE Attribute Set
                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	TunnelAttributeSetType
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion, self).__init__()

                    self.yang_name = "attribute-set-union"
                    self.yang_parent_name = "attribute-set"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                    self._leafs = OrderedDict([
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                    ])
                    self.tunnel_attribute_set_type = None

                    self.attribute_set_path_option = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                    self.attribute_set_path_option.parent = self
                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                    self.attribute_set_autobackup = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                    self.attribute_set_autobackup.parent = self
                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                    self.attribute_set_automesh = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                    self.attribute_set_automesh.parent = self
                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                    self.attribute_set_xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                    self.attribute_set_xro.parent = self
                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                    self.attribute_set_p2mpte = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                    self.attribute_set_p2mpte.parent = self
                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                    self.attribute_set_aps_pp = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                    self.attribute_set_aps_pp.parent = self
                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                    self.attribute_set_p2p_te = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                    self.attribute_set_p2p_te.parent = self
                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                    self._segment_path = lambda: "attribute-set-union"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                class AttributeSetPathOption(_Entity_):
                    """
                    MPLS TE Path Option Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_reverse_path
                    
                    	BFD reverse path
                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_cost_limit_configured
                    
                    	Is Cost Limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: generation
                    
                    	Generation
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is path invalidation timeout configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is path invalidation action configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: exclude_list_name
                    
                    	Exclude list name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_list_name_configured
                    
                    	Is exclude list name configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_bfd_reverse_pat_configured
                    
                    	Is BFD reverse path configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_delay_limit_configured
                    
                    	Is Delay Limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec) When delay limit is configured
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                    
                    	**config**\: False
                    
                    .. attribute:: version_info
                    
                    	Version Info
                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                        self.yang_name = "attribute-set-path-option"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                        self._leafs = OrderedDict([
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                        ])
                        self.configured_bandwidth = None
                        self.cost_limit = None
                        self.dste_class_type = None
                        self.bandwidth_type = None
                        self.is_bandwidth_configured = None
                        self.is_cost_limit_configured = None
                        self.is_affinity_configured = None
                        self.generation = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action = None
                        self.is_path_invalidation_timeout_configured = None
                        self.is_path_invalidation_action_configured = None
                        self.exclude_list_name = None
                        self.is_exclude_list_name_configured = None
                        self.is_pce_configured = None
                        self.is_pce_disj_source_configured = None
                        self.is_pce_disj_type_configured = None
                        self.is_pce_disj_group_id_configured = None
                        self.pcedp_source_address = None
                        self.pcedp_type = None
                        self.pcedp_group_id = None
                        self.is_pceb_dj_source_configured = None
                        self.is_pcebd_group_id_configured = None
                        self.pcebd_source_address = None
                        self.pcebd_group_id = None
                        self.is_bfd_reverse_pat_configured = None
                        self.is_delay_limit_configured = None
                        self.delay_limit = None

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bfd_reverse_path = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                        self.bfd_reverse_path.parent = self
                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                        self.tunnel_id = YList(self)
                        self.version_info = YList(self)
                        self._segment_path = lambda: "attribute-set-path-option"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                    class BfdReversePath(_Entity_):
                        """
                        BFD reverse path
                        
                        .. attribute:: path_type
                        
                        	BFD reverse path type
                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                        
                        	**config**\: False
                        
                        .. attribute:: binding_label
                        
                        	BFD reverse path binding label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                            self.yang_name = "bfd-reverse-path"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                            ])
                            self.path_type = None
                            self.binding_label = None
                            self._segment_path = lambda: "bfd-reverse-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                    class VersionInfo(_Entity_):
                        """
                        Version Info
                        
                        .. attribute:: attribute_type
                        
                        	Attribute Type
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: generation
                        
                        	Generation
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_default
                        
                        	Is default
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                            self.yang_name = "version-info"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                            ])
                            self.attribute_type = None
                            self.generation = None
                            self.is_default = None
                            self._segment_path = lambda: "version-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                class AttributeSetAutobackup(_Entity_):
                    """
                    MPLS TE Auto\-backup Attribute Set
                    
                    .. attribute:: signalled_name
                    
                    	Signalled name
                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                    
                    	**config**\: False
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_signalled_name_configured
                    
                    	Is signalled name configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_interface
                    
                    	Array of Protected Interface Names
                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                        self.yang_name = "attribute-set-autobackup"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                        self._leafs = OrderedDict([
                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                        ])
                        self.is_signalled_name_configured = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.policy_class = None
                        self.is_policyclass_configured = None
                        self.is_affinity_configured = None
                        self.record_route = None

                        self.signalled_name = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                        self.signalled_name.parent = self
                        self._children_name_map["signalled_name"] = "signalled-name"

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.tunnel_id = YList(self)
                        self.protected_interface = YList(self)
                        self._segment_path = lambda: "attribute-set-autobackup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                    class SignalledName(_Entity_):
                        """
                        Signalled name
                        
                        .. attribute:: name
                        
                        	Signalled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: source_type
                        
                        	Source address or name
                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        	**config**\: False
                        
                        .. attribute:: protected_interface_type
                        
                        	Protected interface address or name
                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_mp_addresses
                        
                        	MP address appended
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                            self.yang_name = "signalled-name"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                            ])
                            self.name = None
                            self.source_type = None
                            self.protected_interface_type = None
                            self.is_mp_addresses = None
                            self._segment_path = lambda: "signalled-name"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                    class ProtectedInterface(_Entity_):
                        """
                        Array of Protected Interface Names
                        
                        .. attribute:: protected_interface
                        
                        	Protected Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                            self.yang_name = "protected-interface"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                            ])
                            self.protected_interface = None
                            self._segment_path = lambda: "protected-interface"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                class AttributeSetAutomesh(_Entity_):
                    """
                    MPLS TE Auto\-mesh Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if forward\-class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_node_protection
                    
                    	FRR Node protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_collect
                    
                    	Auto bandwidth collect only
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: auto_route_announce
                    
                    	Announce auto route to IGP
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_configured
                    
                    	Soft preemption is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth
                    
                    	IM bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: load_share
                    
                    	Load Share
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface_bw_configured
                    
                    	Is Interface BW configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_id
                    
                    	Meshgroup ID
                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                        self.yang_name = "attribute-set-automesh"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                        self._leafs = OrderedDict([
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                        ])
                        self.configured_bandwidth = None
                        self.dste_class_type = None
                        self.is_bandwidth_configured = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.policy_class = None
                        self.is_policyclass_configured = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.is_affinity_configured = None
                        self.fast_reroute = None
                        self.frr_node_protection = None
                        self.frr_bandwidth_protection = None
                        self.record_route = None
                        self.auto_bandwidth_collect = None
                        self.auto_route_announce = None
                        self.soft_preemption_configured = None
                        self.bandwidth = None
                        self.load_share = None
                        self.is_interface_bw_configured = None

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.mesh_group_id = YList(self)
                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-automesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                    class MeshGroupId(_Entity_):
                        """
                        Meshgroup ID
                        
                        .. attribute:: entry
                        
                        	Meshgroup ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                            self.yang_name = "mesh-group-id"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "mesh-group-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                class AttributeSetXro(_Entity_):
                    """
                    Attribute Set XRO
                    
                    .. attribute:: xro
                    
                    	The XRO specified by this attribute\-set
                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                        self.yang_name = "attribute-set-xro"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("xro", ("xro", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                        self._leafs = OrderedDict()

                        self.xro = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                        self.xro.parent = self
                        self._children_name_map["xro"] = "xro"
                        self._segment_path = lambda: "attribute-set-xro"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                    class Xro(_Entity_):
                        """
                        The XRO specified by this attribute\-set
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                            self.yang_name = "xro"
                            self.yang_parent_name = "attribute-set-xro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                class AttributeSetP2mpte(_Entity_):
                    """
                    MPLS TE P2MP\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                        self.yang_name = "attribute-set-p2mpte"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                        self._leafs = OrderedDict([
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                        ])
                        self.fast_reroute = None
                        self.frr_bandwidth_protection = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.configured_bandwidth = None
                        self.dste_class_type = None
                        self.is_bandwidth_configured = None
                        self.is_affinity_configured = None

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-p2mpte"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2mpte"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2mpte"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                class AttributeSetApsPp(_Entity_):
                    """
                    Attribute Set OTN APS Path Protection
                    
                    .. attribute:: revert_schedule
                    
                    	Revert Schedule
                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                    
                    	**config**\: False
                    
                    .. attribute:: snc_mode
                    
                    	Sub\-network Connection Mode
                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: tcm_id
                    
                    	Sub\-network Connection Monitoring Mode
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protection_type
                    
                    	Protection Type
                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection_mode
                    
                    	Protection Restoration Mode
                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                    
                    	**config**\: False
                    
                    .. attribute:: wait_to_restore_time
                    
                    	Wait to restore time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: hold_off_time
                    
                    	Hold\-off time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_prot_profile_type
                    
                    	Path Protection Profile Type
                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration_style
                    
                    	Restoration Style
                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                        self.yang_name = "attribute-set-aps-pp"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                        self._leafs = OrderedDict([
                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                        ])
                        self.snc_mode = None
                        self.tcm_id = None
                        self.protection_type = None
                        self.protection_mode = None
                        self.wait_to_restore_time = None
                        self.hold_off_time = None
                        self.path_prot_profile_type = None
                        self.restoration_style = None

                        self.revert_schedule = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                        self.revert_schedule.parent = self
                        self._children_name_map["revert_schedule"] = "revert-schedule"
                        self._segment_path = lambda: "attribute-set-aps-pp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                    class RevertSchedule(_Entity_):
                        """
                        Revert Schedule
                        
                        .. attribute:: schedulename
                        
                        	Schedule name identifier
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: schedule_date
                        
                        	Schedule time for reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: schedule_frequency
                        
                        	Schedule frequency for reversion
                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                        
                        	**config**\: False
                        
                        .. attribute:: duration
                        
                        	Duration for scheduled reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: max_tries
                        
                        	Max tries for scheduled reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                            self.yang_name = "revert-schedule"
                            self.yang_parent_name = "attribute-set-aps-pp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                            ])
                            self.schedulename = None
                            self.schedule_date = None
                            self.schedule_frequency = None
                            self.duration = None
                            self.max_tries = None
                            self._segment_path = lambda: "revert-schedule"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                class AttributeSetP2pTe(_Entity_):
                    """
                    MPLS TE P2P\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: prepend_list
                    
                    	SR prepend list
                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_adjacency_protection
                    
                    	Path selection segment\-routing type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                    
                    	Is path selection segment routing configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is Path Invalidation timeout configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is Path Invalidation action configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_metric
                    
                    	Path selection metric type
                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_metric_configured
                    
                    	Is path selection metric configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_margin
                    
                    	Path selection margin
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_margin_relative
                    
                    	Path selection margin is\_relative
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_margin_configured
                    
                    	Is path selection margin configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_segment_limit
                    
                    	Is path selection segment limit configured
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                    
                    	Is path selection segment limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_select_configured
                    
                    	Is any of the path selection parameters configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_prepend_list_configured
                    
                    	Is SR prepend list configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                        self.yang_name = "attribute-set-p2p-te"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                        self._leafs = OrderedDict([
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                        ])
                        self.is_affinity_configured = None
                        self.path_selection_segment_routing_adjacency_protection = None
                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                        self.path_invalidation_timeout = None
                        self.path_selection_invalidation_action = None
                        self.is_path_invalidation_timeout_configured = None
                        self.is_path_invalidation_action_configured = None
                        self.path_selection_metric = None
                        self.is_path_selection_metric_configured = None
                        self.path_selection_segment_routing_margin = None
                        self.is_path_selection_segment_routing_margin_relative = None
                        self.is_path_selection_segment_routing_margin_configured = None
                        self.path_selection_segment_routing_segment_limit = None
                        self.is_path_selection_segment_routing_segment_limit_configured = None
                        self.is_path_select_configured = None
                        self.is_prepend_list_configured = None
                        self.is_pce_configured = None
                        self.is_pce_disj_source_configured = None
                        self.is_pce_disj_type_configured = None
                        self.is_pce_disj_group_id_configured = None
                        self.pcedp_source_address = None
                        self.pcedp_type = None
                        self.pcedp_group_id = None
                        self.is_pceb_dj_source_configured = None
                        self.is_pcebd_group_id_configured = None
                        self.pcebd_source_address = None
                        self.pcebd_group_id = None

                        self.affinity = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.prepend_list = MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                        self.prepend_list.parent = self
                        self._children_name_map["prepend_list"] = "prepend-list"

                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-p2p-te"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                    class PrependList(_Entity_):
                        """
                        SR prepend list
                        
                        .. attribute:: prepend_entry
                        
                        	List of prepend entries
                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                            self.yang_name = "prepend-list"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                            self._leafs = OrderedDict()

                            self.prepend_entry = YList(self)
                            self._segment_path = lambda: "prepend-list"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                        class PrependEntry(_Entity_):
                            """
                            List of prepend entries
                            
                            .. attribute:: type
                            
                            	Prepend Type
                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                            
                            	**config**\: False
                            
                            .. attribute:: index
                            
                            	Prepend index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: next_label
                            
                            	Prepend next label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                self.yang_name = "prepend-entry"
                                self.yang_parent_name = "prepend-list"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                ])
                                self.type = None
                                self.index = None
                                self.next_label = None
                                self._segment_path = lambda: "prepend-entry"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AttributeSets.AttributeSet.AttributeSetUnion']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AttributeSets.AttributeSet']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AttributeSets']['meta_info']


    class IgpAreaBriefs(_Entity_):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area_brief
        
        	An IGP instance Brief info
        	**type**\: list of  		 :py:class:`IgpAreaBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.IgpAreaBriefs, self).__init__()

            self.yang_name = "igp-area-briefs"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-area-brief", ("igp_area_brief", MplsTe.IgpAreaBriefs.IgpAreaBrief))])
            self._leafs = OrderedDict()

            self.igp_area_brief = YList(self)
            self._segment_path = lambda: "igp-area-briefs"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.IgpAreaBriefs, [], name, value)


        class IgpAreaBrief(_Entity_):
            """
            An IGP instance Brief info
            
            .. attribute:: protocol  (key)
            
            	The IGP protocol
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: process_tag  (key)
            
            	IGP Process Tag
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of  		 :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId>`
            
            	**config**\: False
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of  		 :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.IgpAreaBriefs.IgpAreaBrief, self).__init__()

                self.yang_name = "igp-area-brief"
                self.yang_parent_name = "igp-area-briefs"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','process_tag']
                self._child_classes = OrderedDict([("secondary-router-id", ("secondary_router_id", MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId)), ("area", ("area", MplsTe.IgpAreaBriefs.IgpAreaBrief.Area))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('process_tag', (YLeaf(YType.str, 'process-tag'), ['str'])),
                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ('igp_system_id', (YLeaf(YType.str, 'igp-system-id'), ['str'])),
                    ('configured_te_router_id', (YLeaf(YType.str, 'configured-te-router-id'), ['str'])),
                    ('global_router_id', (YLeaf(YType.str, 'global-router-id'), ['str'])),
                    ('globall_router_id_optical', (YLeaf(YType.str, 'globall-router-id-optical'), ['str'])),
                    ('in_use_te_router_id', (YLeaf(YType.str, 'in-use-te-router-id'), ['str'])),
                    ('is_connection_up', (YLeaf(YType.boolean, 'is-connection-up'), ['bool'])),
                    ('connection_up_count', (YLeaf(YType.uint32, 'connection-up-count'), ['int'])),
                    ('connection_down_count', (YLeaf(YType.uint32, 'connection-down-count'), ['int'])),
                ])
                self.protocol = None
                self.process_tag = None
                self.igp_type = None
                self.instance_name = None
                self.igp_system_id = None
                self.configured_te_router_id = None
                self.global_router_id = None
                self.globall_router_id_optical = None
                self.in_use_te_router_id = None
                self.is_connection_up = None
                self.connection_up_count = None
                self.connection_down_count = None

                self.secondary_router_id = YList(self)
                self.area = YList(self)
                self._segment_path = lambda: "igp-area-brief" + "[protocol='" + str(self.protocol) + "']" + "[process-tag='" + str(self.process_tag) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/igp-area-briefs/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.IgpAreaBriefs.IgpAreaBrief, ['protocol', 'process_tag', 'igp_type', 'instance_name', 'igp_system_id', 'configured_te_router_id', 'global_router_id', 'globall_router_id_optical', 'in_use_te_router_id', 'is_connection_up', 'connection_up_count', 'connection_down_count'], name, value)


            class SecondaryRouterId(_Entity_):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	Secondary router\-ids
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "secondary-router-id"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId']['meta_info']


            class Area(_Entity_):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:  :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData>`
                
                	**config**\: False
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_number
                
                	Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("active-data", ("active_data", MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData))])
                    self._leafs = OrderedDict([
                        ('area_index', (YLeaf(YType.uint32, 'area-index'), ['int'])),
                        ('area_number', (YLeaf(YType.uint32, 'area-number'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('is_config_ready', (YLeaf(YType.boolean, 'is-config-ready'), ['bool'])),
                    ])
                    self.area_index = None
                    self.area_number = None
                    self.area_format = None
                    self.is_config_ready = None

                    self.active_data = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._segment_path = lambda: "area"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area, ['area_index', 'area_number', 'area_format', 'is_config_ready'], name, value)


                class ActiveData(_Entity_):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:  :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("area-statistics", ("area_statistics", MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics))])
                        self._leafs = OrderedDict([
                            ('interfaces_count', (YLeaf(YType.uint32, 'interfaces-count'), ['int'])),
                            ('link_idt_received', (YLeaf(YType.boolean, 'link-idt-received'), ['bool'])),
                            ('topology_idt_received', (YLeaf(YType.boolean, 'topology-idt-received'), ['bool'])),
                            ('sr_strict', (YLeaf(YType.boolean, 'sr-strict'), ['bool'])),
                            ('p2p_heads_count', (YLeaf(YType.uint32, 'p2p-heads-count'), ['int'])),
                            ('p2p_autoroute_announced_count', (YLeaf(YType.uint32, 'p2p-autoroute-announced-count'), ['int'])),
                            ('p2p_forwarding_adjacency_count', (YLeaf(YType.uint32, 'p2p-forwarding-adjacency-count'), ['int'])),
                            ('p2mp_destination_count', (YLeaf(YType.uint32, 'p2mp-destination-count'), ['int'])),
                            ('tunnel_loose_hops', (YLeaf(YType.uint32, 'tunnel-loose-hops'), ['int'])),
                        ])
                        self.interfaces_count = None
                        self.link_idt_received = None
                        self.topology_idt_received = None
                        self.sr_strict = None
                        self.p2p_heads_count = None
                        self.p2p_autoroute_announced_count = None
                        self.p2p_forwarding_adjacency_count = None
                        self.p2mp_destination_count = None
                        self.tunnel_loose_hops = None

                        self.area_statistics = MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._segment_path = lambda: "active-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, ['interfaces_count', 'link_idt_received', 'topology_idt_received', 'sr_strict', 'p2p_heads_count', 'p2p_autoroute_announced_count', 'p2p_forwarding_adjacency_count', 'p2mp_destination_count', 'tunnel_loose_hops'], name, value)


                    class AreaStatistics(_Entity_):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('area_adjacency_request_messages', (YLeaf(YType.uint32, 'area-adjacency-request-messages'), ['int'])),
                                ('area_adjacency_announce_messages', (YLeaf(YType.uint32, 'area-adjacency-announce-messages'), ['int'])),
                                ('area_flood_messages', (YLeaf(YType.uint32, 'area-flood-messages'), ['int'])),
                                ('area_lsa_announce_messages', (YLeaf(YType.uint32, 'area-lsa-announce-messages'), ['int'])),
                                ('area_lsa_fragment_announce_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-announce-messages'), ['int'])),
                                ('area_lsa_delete_messages', (YLeaf(YType.uint32, 'area-lsa-delete-messages'), ['int'])),
                                ('area_lsa_fragment_delete_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-delete-messages'), ['int'])),
                                ('area_tunnel_announce_messages', (YLeaf(YType.uint32, 'area-tunnel-announce-messages'), ['int'])),
                            ])
                            self.area_adjacency_request_messages = None
                            self.area_adjacency_announce_messages = None
                            self.area_flood_messages = None
                            self.area_lsa_announce_messages = None
                            self.area_lsa_fragment_announce_messages = None
                            self.area_lsa_delete_messages = None
                            self.area_lsa_fragment_delete_messages = None
                            self.area_tunnel_announce_messages = None
                            self._segment_path = lambda: "area-statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, ['area_adjacency_request_messages', 'area_adjacency_announce_messages', 'area_flood_messages', 'area_lsa_announce_messages', 'area_lsa_fragment_announce_messages', 'area_lsa_delete_messages', 'area_lsa_fragment_delete_messages', 'area_tunnel_announce_messages'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.IgpAreaBriefs.IgpAreaBrief.Area']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.IgpAreaBriefs.IgpAreaBrief']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.IgpAreaBriefs']['meta_info']


    class BandwidthAccountingCounters(_Entity_):
        """
        Bandwidth accounting counters
        
        .. attribute:: last_cleared_timestamp
        
        	The timestamp when these stats are cleared relative to Jan 1, 1970
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bandwidth_application_count
        
        	Number of bandwidth accounting applications
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bandwidth_sample_count
        
        	Number of bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: invalid_sample_count
        
        	Number of invalid bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: skipped_application_count
        
        	Number of skipped bandwidth accounting applications
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: capped_sample_count
        
        	Number of capped bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: high_latency_count
        
        	Number of statsd requests that returned with high latency
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.BandwidthAccountingCounters, self).__init__()

            self.yang_name = "bandwidth-accounting-counters"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                ('bandwidth_application_count', (YLeaf(YType.uint32, 'bandwidth-application-count'), ['int'])),
                ('bandwidth_sample_count', (YLeaf(YType.uint32, 'bandwidth-sample-count'), ['int'])),
                ('invalid_sample_count', (YLeaf(YType.uint32, 'invalid-sample-count'), ['int'])),
                ('skipped_application_count', (YLeaf(YType.uint32, 'skipped-application-count'), ['int'])),
                ('capped_sample_count', (YLeaf(YType.uint32, 'capped-sample-count'), ['int'])),
                ('high_latency_count', (YLeaf(YType.uint32, 'high-latency-count'), ['int'])),
            ])
            self.last_cleared_timestamp = None
            self.bandwidth_application_count = None
            self.bandwidth_sample_count = None
            self.invalid_sample_count = None
            self.skipped_application_count = None
            self.capped_sample_count = None
            self.high_latency_count = None
            self._segment_path = lambda: "bandwidth-accounting-counters"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.BandwidthAccountingCounters, ['last_cleared_timestamp', 'bandwidth_application_count', 'bandwidth_sample_count', 'invalid_sample_count', 'skipped_application_count', 'capped_sample_count', 'high_latency_count'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.BandwidthAccountingCounters']['meta_info']


    class Tunnels(_Entity_):
        """
        Failure protection provided for tunnels
        
        .. attribute:: tunnel_flex_lsps
        
        	Flex LSP
        	**type**\:  :py:class:`TunnelFlexLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps>`
        
        	**config**\: False
        
        .. attribute:: tunnel_auto_bandwidths
        
        	Auto Bandwidth Brief Table
        	**type**\:  :py:class:`TunnelAutoBandwidths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths>`
        
        	**config**\: False
        
        .. attribute:: summary
        
        	Summary of tunnel info
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary>`
        
        	**config**\: False
        
        .. attribute:: tunnel_path_protections
        
        	Path protection
        	**type**\:  :py:class:`TunnelPathProtections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-flex-lsps", ("tunnel_flex_lsps", MplsTe.Tunnels.TunnelFlexLsps)), ("tunnel-auto-bandwidths", ("tunnel_auto_bandwidths", MplsTe.Tunnels.TunnelAutoBandwidths)), ("summary", ("summary", MplsTe.Tunnels.Summary)), ("tunnel-path-protections", ("tunnel_path_protections", MplsTe.Tunnels.TunnelPathProtections))])
            self._leafs = OrderedDict()

            self.tunnel_flex_lsps = MplsTe.Tunnels.TunnelFlexLsps()
            self.tunnel_flex_lsps.parent = self
            self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"

            self.tunnel_auto_bandwidths = MplsTe.Tunnels.TunnelAutoBandwidths()
            self.tunnel_auto_bandwidths.parent = self
            self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"

            self.summary = MplsTe.Tunnels.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.tunnel_path_protections = MplsTe.Tunnels.TunnelPathProtections()
            self.tunnel_path_protections.parent = self
            self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
            self._segment_path = lambda: "tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.Tunnels, [], name, value)


        class TunnelFlexLsps(_Entity_):
            """
            Flex LSP
            
            .. attribute:: tunnel_flex_lsp
            
            	Flex LSP
            	**type**\: list of  		 :py:class:`TunnelFlexLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Tunnels.TunnelFlexLsps, self).__init__()

                self.yang_name = "tunnel-flex-lsps"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-flex-lsp", ("tunnel_flex_lsp", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp))])
                self._leafs = OrderedDict()

                self.tunnel_flex_lsp = YList(self)
                self._segment_path = lambda: "tunnel-flex-lsps"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps, [], name, value)


            class TunnelFlexLsp(_Entity_):
                """
                Flex LSP
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: working_lsp
                
                	 Working LSP info
                	**type**\:  :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp>`
                
                	**config**\: False
                
                .. attribute:: protect_lsp
                
                	 Protect LSP info
                	**type**\:  :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp>`
                
                	**config**\: False
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tun_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__init__()

                    self.yang_name = "tunnel-flex-lsp"
                    self.yang_parent_name = "tunnel-flex-lsps"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("working-lsp", ("working_lsp", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp)), ("protect-lsp", ("protect_lsp", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('is_tunnel_up', (YLeaf(YType.boolean, 'is-tunnel-up'), ['bool'])),
                        ('tun_id', (YLeaf(YType.uint16, 'tun-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.is_tunnel_up = None
                    self.tun_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.extended_tunnel_id = None

                    self.working_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"

                    self.protect_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._segment_path = lambda: "tunnel-flex-lsp"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp, ['ctype', 'tunnel_id', 'tunnel_name', 'is_tunnel_up', 'tun_id', 'source_address', 'destination_address', 'extended_tunnel_id'], name, value)


                class WorkingLsp(_Entity_):
                    """
                     Working LSP info
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:  :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("flex-info", ("flex_info", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo)), ("association", ("association", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association)), ("protection", ("protection", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection)), ("reverse-lsp", ("reverse_lsp", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp)), ("lsp-hop", ("lsp_hop", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('is_operational', (YLeaf(YType.boolean, 'is-operational'), ['bool'])),
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.is_operational = None
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_mode = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"

                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "working-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, ['is_operational', 'lsp_uptime', 'path_protection_lsp_id', 'lsp_mode', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class FlexInfo(_Entity_):
                        """
                        Flex Info
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/flex-info/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/association/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection']['meta_info']


                    class ReverseLsp(_Entity_):
                        """
                        Reverse LSP information
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec)), ("association", ("association", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association)), ("protection", ("protection", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ])
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None

                            self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._segment_path = lambda: "reverse-lsp"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, ['reverse_lsp_present', 'reverse_lsp_connected'], name, value)


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/reverse-lsp-fec/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/association/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp']['meta_info']


                class ProtectLsp(_Entity_):
                    """
                     Protect LSP info
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:  :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("flex-info", ("flex_info", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo)), ("association", ("association", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association)), ("protection", ("protection", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection)), ("reverse-lsp", ("reverse_lsp", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp)), ("lsp-hop", ("lsp_hop", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('is_operational', (YLeaf(YType.boolean, 'is-operational'), ['bool'])),
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.is_operational = None
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_mode = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.flex_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"

                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "protect-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, ['is_operational', 'lsp_uptime', 'path_protection_lsp_id', 'lsp_mode', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class FlexInfo(_Entity_):
                        """
                        Flex Info
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/flex-info/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/association/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection']['meta_info']


                    class ReverseLsp(_Entity_):
                        """
                        Reverse LSP information
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("reverse-lsp-fec", ("reverse_lsp_fec", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec)), ("association", ("association", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association)), ("protection", ("protection", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ])
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None

                            self.reverse_lsp_fec = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.association = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._segment_path = lambda: "reverse-lsp"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, ['reverse_lsp_present', 'reverse_lsp_connected'], name, value)


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/reverse-lsp-fec/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/association/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps.TunnelFlexLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Tunnels.TunnelFlexLsps']['meta_info']


        class TunnelAutoBandwidths(_Entity_):
            """
            Auto Bandwidth Brief Table
            
            .. attribute:: tunnel_auto_bandwidth
            
            	Auto Bandwidth info bag
            	**type**\: list of  		 :py:class:`TunnelAutoBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Tunnels.TunnelAutoBandwidths, self).__init__()

                self.yang_name = "tunnel-auto-bandwidths"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-auto-bandwidth", ("tunnel_auto_bandwidth", MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth))])
                self._leafs = OrderedDict()

                self.tunnel_auto_bandwidth = YList(self)
                self._segment_path = lambda: "tunnel-auto-bandwidths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Tunnels.TunnelAutoBandwidths, [], name, value)


            class TunnelAutoBandwidth(_Entity_):
                """
                Auto Bandwidth info bag
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: auto_bandwidth_status
                
                	Tunnels's AutoBandwidth Status information
                	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Tunnel signaled name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_lsp_id
                
                	Tunnel Lsp Id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_applications
                
                	Total number of bandwidth applications requested by auto\-bw
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_bandwidth_applied
                
                	Last bandwidth requested by auto\-bw for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_requested_bandwidth
                
                	Requested Bandwidth for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signalled_bandwidth
                
                	Signalled bandwidth for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: highest_bandwidth
                
                	Highest bandwidth registered within current application period
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_sample_bandwidth
                
                	Last sample bandwidth collected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: samples_collected
                
                	Number of samples collected within current application period
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: time_left_application
                
                	Time left until next auto\-bw application algorithm is performed
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__init__()

                    self.yang_name = "tunnel-auto-bandwidth"
                    self.yang_parent_name = "tunnel-auto-bandwidths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_name_xr', (YLeaf(YType.str, 'tunnel-name-xr'), ['str'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('tunnel_lsp_id', (YLeaf(YType.uint32, 'tunnel-lsp-id'), ['int'])),
                        ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                        ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                        ('tunnel_requested_bandwidth', (YLeaf(YType.uint32, 'tunnel-requested-bandwidth'), ['int'])),
                        ('signalled_bandwidth', (YLeaf(YType.uint32, 'signalled-bandwidth'), ['int'])),
                        ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                        ('last_sample_bandwidth', (YLeaf(YType.uint32, 'last-sample-bandwidth'), ['int'])),
                        ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                        ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.tunnel_name_xr = None
                    self.signaled_name = None
                    self.tunnel_lsp_id = None
                    self.bandwidth_applications = None
                    self.last_bandwidth_applied = None
                    self.tunnel_requested_bandwidth = None
                    self.signalled_bandwidth = None
                    self.highest_bandwidth = None
                    self.last_sample_bandwidth = None
                    self.samples_collected = None
                    self.time_left_application = None

                    self.auto_bandwidth_status = MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                    self.auto_bandwidth_status.parent = self
                    self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                    self._segment_path = lambda: "tunnel-auto-bandwidth" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-auto-bandwidths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, ['tunnel_name', 'tunnel_name_xr', 'signaled_name', 'tunnel_lsp_id', 'bandwidth_applications', 'last_bandwidth_applied', 'tunnel_requested_bandwidth', 'signalled_bandwidth', 'highest_bandwidth', 'last_sample_bandwidth', 'samples_collected', 'time_left_application'], name, value)


                class AutoBandwidthStatus(_Entity_):
                    """
                    Tunnels's AutoBandwidth Status information
                    
                    .. attribute:: is_auto_bandwidth_enabled
                    
                    	TRUE if auto\-bw is enabled for the tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reactivation_time
                    
                    	Time until auto\-bw gets activated if activation has been delayed due to failover
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__init__()

                        self.yang_name = "auto-bandwidth-status"
                        self.yang_parent_name = "tunnel-auto-bandwidth"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                            ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                        ])
                        self.is_auto_bandwidth_enabled = None
                        self.reactivation_time = None
                        self._segment_path = lambda: "auto-bandwidth-status"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Tunnels.TunnelAutoBandwidths']['meta_info']


        class Summary(_Entity_):
            """
            Summary of tunnel info
            
            .. attribute:: autobackup_summary
            
            	Autobackup summary
            	**type**\:  :py:class:`AutobackupSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutobackupSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_mesh_summary
            
            	Automesh summary
            	**type**\:  :py:class:`AutoMeshSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoMeshSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_mesh_one_hop_summary
            
            	Automesh Onehop summary
            	**type**\:  :py:class:`AutoMeshOneHopSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoMeshOneHopSummary>`
            
            	**config**\: False
            
            .. attribute:: gmpls_uni_summary
            
            	GMPLS\-UNI summary
            	**type**\:  :py:class:`GmplsUniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.GmplsUniSummary>`
            
            	**config**\: False
            
            .. attribute:: gmpls_nni_summary
            
            	GMPLS\-NNI summary
            	**type**\:  :py:class:`GmplsNniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.GmplsNniSummary>`
            
            	**config**\: False
            
            .. attribute:: current_tunnel_convergence_summary
            
            	Current Tunnel convergemce summary information
            	**type**\:  :py:class:`CurrentTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary>`
            
            	**config**\: False
            
            .. attribute:: last_tunnel_convergence_summary
            
            	Last Tunnel convergemce summary information
            	**type**\:  :py:class:`LastTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_tun_server_summary
            
            	Auto\-tunnel server tunnel summary
            	**type**\:  :py:class:`AutoTunServerSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary>`
            
            	**config**\: False
            
            .. attribute:: pcalc_tie_breaker_type
            
            	PCALC tiebreaker type
            	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
            
            	**config**\: False
            
            .. attribute:: pcalc_tiebreaker
            
            	Deprecated \- replaced by PCALCTiebreakerType
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tiebreaker_qualifier
            
            	Describes how the path selection tiebreaker was specified\:default, or globally set
            	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
            
            	**config**\: False
            
            .. attribute:: te_process_status
            
            	Status of te\_control
            	**type**\:  :py:class:`MplsTeTunnelsProcessStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsProcessStatus>`
            
            	**config**\: False
            
            .. attribute:: is_rsvp_process_enabled
            
            	Status of rsvp
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_forwarding_enabled
            
            	TRUE if forwarding is enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: activated_heads
            
            	Total tunnel heads activated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: deactivated_heads
            
            	Total tunnel heads deactivated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: recovered_heads
            
            	Number of heads recovered
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_periodic_reoptimization_on
            
            	TRUE if periodic reoptimization is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: reoptimization_period
            
            	Reoptimization period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_reoptimization_timer
            
            	Time left till next reoptimization (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: auto_bandwidth_tunnels
            
            	Counter with number of auto\-bw enabled tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: auto_bandwidth_collection_period
            
            	Collection period in minutes
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: minute
            
            .. attribute:: is_promotion_on
            
            	TRUE if periodic frr promotion is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: promotion_period
            
            	FRR promotion period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_promotion_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: tunnel_check_period
            
            	Tunnel head check period (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_check_time
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: tunnel_verify_period
            
            	Tunnel head verify period (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_verify_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: frr_head_tunnels
            
            	FRR tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_head_tunnels
            
            	FRR protected tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_head_tunnels
            
            	FRR rerouted tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_mid_point_tunnels
            
            	FRR tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_mid_point_tunnels
            
            	FRR protected tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_mid_point_tunnels
            
            	FRR rerouted tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_tunnels
            
            	FRR link protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_protected_tunnels
            
            	FRR node protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_tunnels
            
            	FRR BW protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_head_tunnels
            
            	P2P FRR tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_head_tunnels
            
            	P2P FRR protected tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_head_tunnels
            
            	P2P FRR rerouted tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_mid_point_tunnels
            
            	P2P FRR tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_mid_point_tunnels
            
            	P2P FRR protected tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_mid_point_tunnels
            
            	P2P FRR rerouted tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2p_tunnels
            
            	P2P FRR link protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_protected_p2p_tunnels
            
            	P2P FRR node protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2p_tunnels
            
            	P2P FRR BW protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backup_tunnels
            
            	FRR backup tunnels in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backups_assigned
            
            	FRR backup tunnels assigned
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_protected_interfaces
            
            	FRR Protected Interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_interfaces
            
            	FRR Rerouted Interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_tunnels
            
            	p2p Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_head_tunnels
            
            	p2p Tunnel interfaces in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: dynamic_up_p2p_head_tunnels
            
            	p2p Tunnel up via a dynamic path
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_config_p2p_head_tunnels
            
            	p2p Tunnel interfaces with FRR configuration
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_destinations
            
            	p2p Destinations at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_destinations_up
            
            	p2p Destinations in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2p_s2_ls
            
            	p2p S2Ls BW Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2p_s2_ls
            
            	p2p S2Ls Link Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_head_s2_ls
            
            	p2p S2Ls in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2p_head_s2_ls
            
            	p2p S2Ls in signalling\-proceeding state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: recovering_p2p_head_s2_ls
            
            	p2p S2Ls recovering at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_head_s2_ls
            
            	p2p S2Ls with FRR requested at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_head_s2_ls
            
            	p2p S2Ls FRR Protected at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_head_s2_ls
            
            	p2p S2Ls FRR Rerouted at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_mid_point_s2_ls
            
            	p2p S2Ls at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_mid_point_s2_ls
            
            	p2p S2Ls in Up state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2p_mid_point_s2_ls
            
            	p2p S2Ls in signalling=proceeding state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_mid_point_s2_ls
            
            	p2p S2Ls with FRR requested at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Protected at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Rerouted at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_tail_s2_ls
            
            	p2p S2Ls at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_tail_s2_ls
            
            	p2p S2Ls in Up state at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_tail_tunnels
            
            	p2p Tunnel tail interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels
            
            	Tunnels configured with Path Protect
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels_up
            
            	Path Protect configured tunnels connected/up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels_standby_up
            
            	Tunnels with standby LSP up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_diverse_paths
            
            	Link diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: node_diverse_paths
            
            	Node diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_and_node_diverse_paths
            
            	Link and Node diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: user_defined_paths
            
            	User defined paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: p2mp_head_tunnels
            
            	P2MP Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_config_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces with FRR configuration
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_head_destinations
            
            	P2MP Destinations at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_destinations
            
            	P2MP Destinations in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2mp_s2_ls
            
            	P2MP S2Ls BW Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2mp_s2_ls
            
            	P2MP S2Ls Link Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_s2_ls
            
            	P2MP S2Ls in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2mp_head_s2_ls
            
            	P2MP S2Ls in signalling\-proceeding state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2mp_head_s2_ls
            
            	P2MP S2Ls with FRR requested at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Protected at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_mid_point_s2_ls
            
            	P2MP S2Ls at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in Up state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in signalling=proceeding state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls with FRR requested at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Protected at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_tail_s2_ls
            
            	P2MP S2Ls at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_tail_s2_ls
            
            	P2MP S2Ls in Up state at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels
            
            	Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_associated
            
            	Associated Bidirectional Head Tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_corouted
            
            	Corouted Bidirectional Head Tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_proceeding
            
            	Proceeding Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_associated
            
            	Associated Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_standby
            
            	Standby Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_tunnels
            
            	Bidirectional Mid Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_tunnels_up
            
            	Connected Bidirectional Mid Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_proceeding
            
            	Proceeding Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_associated
            
            	Associated Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_standby
            
            	Standby Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps
            
            	Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_up
            
            	Connected Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_proceeding
            
            	Proceeding Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_associated
            
            	Associated Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_standby
            
            	Standby Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_corouted
            
            	Corouted Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Tunnels.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("autobackup-summary", ("autobackup_summary", MplsTe.Tunnels.Summary.AutobackupSummary)), ("auto-mesh-summary", ("auto_mesh_summary", MplsTe.Tunnels.Summary.AutoMeshSummary)), ("auto-mesh-one-hop-summary", ("auto_mesh_one_hop_summary", MplsTe.Tunnels.Summary.AutoMeshOneHopSummary)), ("gmpls-uni-summary", ("gmpls_uni_summary", MplsTe.Tunnels.Summary.GmplsUniSummary)), ("gmpls-nni-summary", ("gmpls_nni_summary", MplsTe.Tunnels.Summary.GmplsNniSummary)), ("current-tunnel-convergence-summary", ("current_tunnel_convergence_summary", MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary)), ("last-tunnel-convergence-summary", ("last_tunnel_convergence_summary", MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary)), ("auto-tun-server-summary", ("auto_tun_server_summary", MplsTe.Tunnels.Summary.AutoTunServerSummary))])
                self._leafs = OrderedDict([
                    ('pcalc_tie_breaker_type', (YLeaf(YType.enumeration, 'pcalc-tie-breaker-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                    ('pcalc_tiebreaker', (YLeaf(YType.uint32, 'pcalc-tiebreaker'), ['int'])),
                    ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                    ('te_process_status', (YLeaf(YType.enumeration, 'te-process-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsProcessStatus', '')])),
                    ('is_rsvp_process_enabled', (YLeaf(YType.boolean, 'is-rsvp-process-enabled'), ['bool'])),
                    ('is_forwarding_enabled', (YLeaf(YType.boolean, 'is-forwarding-enabled'), ['bool'])),
                    ('activated_heads', (YLeaf(YType.uint32, 'activated-heads'), ['int'])),
                    ('deactivated_heads', (YLeaf(YType.uint32, 'deactivated-heads'), ['int'])),
                    ('recovered_heads', (YLeaf(YType.uint32, 'recovered-heads'), ['int'])),
                    ('is_periodic_reoptimization_on', (YLeaf(YType.boolean, 'is-periodic-reoptimization-on'), ['bool'])),
                    ('reoptimization_period', (YLeaf(YType.uint32, 'reoptimization-period'), ['int'])),
                    ('next_reoptimization_timer', (YLeaf(YType.uint32, 'next-reoptimization-timer'), ['int'])),
                    ('auto_bandwidth_tunnels', (YLeaf(YType.uint32, 'auto-bandwidth-tunnels'), ['int'])),
                    ('auto_bandwidth_collection_period', (YLeaf(YType.uint32, 'auto-bandwidth-collection-period'), ['int'])),
                    ('is_promotion_on', (YLeaf(YType.boolean, 'is-promotion-on'), ['bool'])),
                    ('promotion_period', (YLeaf(YType.uint32, 'promotion-period'), ['int'])),
                    ('next_promotion_timer', (YLeaf(YType.uint32, 'next-promotion-timer'), ['int'])),
                    ('tunnel_check_period', (YLeaf(YType.uint32, 'tunnel-check-period'), ['int'])),
                    ('next_check_time', (YLeaf(YType.uint32, 'next-check-time'), ['int'])),
                    ('tunnel_verify_period', (YLeaf(YType.uint32, 'tunnel-verify-period'), ['int'])),
                    ('next_verify_timer', (YLeaf(YType.uint32, 'next-verify-timer'), ['int'])),
                    ('frr_head_tunnels', (YLeaf(YType.uint32, 'frr-head-tunnels'), ['int'])),
                    ('protected_head_tunnels', (YLeaf(YType.uint32, 'protected-head-tunnels'), ['int'])),
                    ('rerouted_head_tunnels', (YLeaf(YType.uint32, 'rerouted-head-tunnels'), ['int'])),
                    ('frr_mid_point_tunnels', (YLeaf(YType.uint32, 'frr-mid-point-tunnels'), ['int'])),
                    ('protected_mid_point_tunnels', (YLeaf(YType.uint32, 'protected-mid-point-tunnels'), ['int'])),
                    ('rerouted_mid_point_tunnels', (YLeaf(YType.uint32, 'rerouted-mid-point-tunnels'), ['int'])),
                    ('link_protected_tunnels', (YLeaf(YType.uint32, 'link-protected-tunnels'), ['int'])),
                    ('node_protected_tunnels', (YLeaf(YType.uint32, 'node-protected-tunnels'), ['int'])),
                    ('bw_protected_tunnels', (YLeaf(YType.uint32, 'bw-protected-tunnels'), ['int'])),
                    ('frr_p2p_head_tunnels', (YLeaf(YType.uint32, 'frr-p2p-head-tunnels'), ['int'])),
                    ('protected_p2p_head_tunnels', (YLeaf(YType.uint32, 'protected-p2p-head-tunnels'), ['int'])),
                    ('rerouted_p2p_head_tunnels', (YLeaf(YType.uint32, 'rerouted-p2p-head-tunnels'), ['int'])),
                    ('frr_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'frr-p2p-mid-point-tunnels'), ['int'])),
                    ('protected_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'protected-p2p-mid-point-tunnels'), ['int'])),
                    ('rerouted_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'rerouted-p2p-mid-point-tunnels'), ['int'])),
                    ('link_protected_p2p_tunnels', (YLeaf(YType.uint32, 'link-protected-p2p-tunnels'), ['int'])),
                    ('node_protected_p2p_tunnels', (YLeaf(YType.uint32, 'node-protected-p2p-tunnels'), ['int'])),
                    ('bw_protected_p2p_tunnels', (YLeaf(YType.uint32, 'bw-protected-p2p-tunnels'), ['int'])),
                    ('backup_tunnels', (YLeaf(YType.uint32, 'backup-tunnels'), ['int'])),
                    ('backups_assigned', (YLeaf(YType.uint32, 'backups-assigned'), ['int'])),
                    ('frr_protected_interfaces', (YLeaf(YType.uint32, 'frr-protected-interfaces'), ['int'])),
                    ('rerouted_interfaces', (YLeaf(YType.uint32, 'rerouted-interfaces'), ['int'])),
                    ('p2p_head_tunnels', (YLeaf(YType.uint32, 'p2p-head-tunnels'), ['int'])),
                    ('up_p2p_head_tunnels', (YLeaf(YType.uint32, 'up-p2p-head-tunnels'), ['int'])),
                    ('dynamic_up_p2p_head_tunnels', (YLeaf(YType.uint32, 'dynamic-up-p2p-head-tunnels'), ['int'])),
                    ('frr_config_p2p_head_tunnels', (YLeaf(YType.uint32, 'frr-config-p2p-head-tunnels'), ['int'])),
                    ('p2p_head_destinations', (YLeaf(YType.uint32, 'p2p-head-destinations'), ['int'])),
                    ('p2p_head_destinations_up', (YLeaf(YType.uint32, 'p2p-head-destinations-up'), ['int'])),
                    ('bw_protected_p2p_s2_ls', (YLeaf(YType.uint32, 'bw-protected-p2p-s2-ls'), ['int'])),
                    ('link_protected_p2p_s2_ls', (YLeaf(YType.uint32, 'link-protected-p2p-s2-ls'), ['int'])),
                    ('up_p2p_head_s2_ls', (YLeaf(YType.uint32, 'up-p2p-head-s2-ls'), ['int'])),
                    ('proceeding_p2p_head_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2p-head-s2-ls'), ['int'])),
                    ('recovering_p2p_head_s2_ls', (YLeaf(YType.uint32, 'recovering-p2p-head-s2-ls'), ['int'])),
                    ('frr_p2p_head_s2_ls', (YLeaf(YType.uint32, 'frr-p2p-head-s2-ls'), ['int'])),
                    ('protected_p2p_head_s2_ls', (YLeaf(YType.uint32, 'protected-p2p-head-s2-ls'), ['int'])),
                    ('rerouted_p2p_head_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2p-head-s2-ls'), ['int'])),
                    ('p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'p2p-mid-point-s2-ls'), ['int'])),
                    ('up_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'up-p2p-mid-point-s2-ls'), ['int'])),
                    ('proceeding_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2p-mid-point-s2-ls'), ['int'])),
                    ('frr_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'frr-p2p-mid-point-s2-ls'), ['int'])),
                    ('protected_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'protected-p2p-mid-point-s2-ls'), ['int'])),
                    ('rerouted_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2p-mid-point-s2-ls'), ['int'])),
                    ('p2p_tail_s2_ls', (YLeaf(YType.uint32, 'p2p-tail-s2-ls'), ['int'])),
                    ('up_p2p_tail_s2_ls', (YLeaf(YType.uint32, 'up-p2p-tail-s2-ls'), ['int'])),
                    ('p2p_tail_tunnels', (YLeaf(YType.uint32, 'p2p-tail-tunnels'), ['int'])),
                    ('path_protect_configured_tunnels', (YLeaf(YType.uint16, 'path-protect-configured-tunnels'), ['int'])),
                    ('path_protect_configured_tunnels_up', (YLeaf(YType.uint16, 'path-protect-configured-tunnels-up'), ['int'])),
                    ('path_protect_configured_tunnels_standby_up', (YLeaf(YType.uint16, 'path-protect-configured-tunnels-standby-up'), ['int'])),
                    ('link_diverse_paths', (YLeaf(YType.uint16, 'link-diverse-paths'), ['int'])),
                    ('node_diverse_paths', (YLeaf(YType.uint16, 'node-diverse-paths'), ['int'])),
                    ('link_and_node_diverse_paths', (YLeaf(YType.uint16, 'link-and-node-diverse-paths'), ['int'])),
                    ('user_defined_paths', (YLeaf(YType.uint16, 'user-defined-paths'), ['int'])),
                    ('p2mp_head_tunnels', (YLeaf(YType.uint32, 'p2mp-head-tunnels'), ['int'])),
                    ('up_p2mp_head_tunnels', (YLeaf(YType.uint32, 'up-p2mp-head-tunnels'), ['int'])),
                    ('frr_config_p2mp_head_tunnels', (YLeaf(YType.uint32, 'frr-config-p2mp-head-tunnels'), ['int'])),
                    ('p2mp_head_destinations', (YLeaf(YType.uint32, 'p2mp-head-destinations'), ['int'])),
                    ('up_p2mp_head_destinations', (YLeaf(YType.uint32, 'up-p2mp-head-destinations'), ['int'])),
                    ('bw_protected_p2mp_s2_ls', (YLeaf(YType.uint32, 'bw-protected-p2mp-s2-ls'), ['int'])),
                    ('link_protected_p2mp_s2_ls', (YLeaf(YType.uint32, 'link-protected-p2mp-s2-ls'), ['int'])),
                    ('up_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-head-s2-ls'), ['int'])),
                    ('proceeding_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2mp-head-s2-ls'), ['int'])),
                    ('frr_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'frr-p2mp-head-s2-ls'), ['int'])),
                    ('protected_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'protected-p2mp-head-s2-ls'), ['int'])),
                    ('rerouted_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2mp-head-s2-ls'), ['int'])),
                    ('p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'p2mp-mid-point-s2-ls'), ['int'])),
                    ('up_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-mid-point-s2-ls'), ['int'])),
                    ('proceeding_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2mp-mid-point-s2-ls'), ['int'])),
                    ('frr_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'frr-p2mp-mid-point-s2-ls'), ['int'])),
                    ('protected_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'protected-p2mp-mid-point-s2-ls'), ['int'])),
                    ('rerouted_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2mp-mid-point-s2-ls'), ['int'])),
                    ('p2mp_tail_s2_ls', (YLeaf(YType.uint32, 'p2mp-tail-s2-ls'), ['int'])),
                    ('up_p2mp_tail_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-tail-s2-ls'), ['int'])),
                    ('bidir_head_tunnels', (YLeaf(YType.uint32, 'bidir-head-tunnels'), ['int'])),
                    ('bidir_head_tunnels_up', (YLeaf(YType.uint32, 'bidir-head-tunnels-up'), ['int'])),
                    ('bidir_head_tunnels_associated', (YLeaf(YType.uint32, 'bidir-head-tunnels-associated'), ['int'])),
                    ('bidir_head_tunnels_corouted', (YLeaf(YType.uint32, 'bidir-head-tunnels-corouted'), ['int'])),
                    ('bidir_head_ls_ps_up', (YLeaf(YType.uint32, 'bidir-head-ls-ps-up'), ['int'])),
                    ('bidir_head_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-head-ls-ps-proceeding'), ['int'])),
                    ('bidir_head_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-head-ls-ps-associated'), ['int'])),
                    ('bidir_head_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-head-ls-ps-standby'), ['int'])),
                    ('bidir_mid_tunnels', (YLeaf(YType.uint32, 'bidir-mid-tunnels'), ['int'])),
                    ('bidir_mid_tunnels_up', (YLeaf(YType.uint32, 'bidir-mid-tunnels-up'), ['int'])),
                    ('bidir_mid_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-proceeding'), ['int'])),
                    ('bidir_mid_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-associated'), ['int'])),
                    ('bidir_mid_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-standby'), ['int'])),
                    ('bidir_tail_ls_ps', (YLeaf(YType.uint32, 'bidir-tail-ls-ps'), ['int'])),
                    ('bidir_tail_ls_ps_up', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-up'), ['int'])),
                    ('bidir_tail_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-proceeding'), ['int'])),
                    ('bidir_tail_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-associated'), ['int'])),
                    ('bidir_tail_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-standby'), ['int'])),
                    ('bidir_tail_ls_ps_corouted', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-corouted'), ['int'])),
                ])
                self.pcalc_tie_breaker_type = None
                self.pcalc_tiebreaker = None
                self.tiebreaker_qualifier = None
                self.te_process_status = None
                self.is_rsvp_process_enabled = None
                self.is_forwarding_enabled = None
                self.activated_heads = None
                self.deactivated_heads = None
                self.recovered_heads = None
                self.is_periodic_reoptimization_on = None
                self.reoptimization_period = None
                self.next_reoptimization_timer = None
                self.auto_bandwidth_tunnels = None
                self.auto_bandwidth_collection_period = None
                self.is_promotion_on = None
                self.promotion_period = None
                self.next_promotion_timer = None
                self.tunnel_check_period = None
                self.next_check_time = None
                self.tunnel_verify_period = None
                self.next_verify_timer = None
                self.frr_head_tunnels = None
                self.protected_head_tunnels = None
                self.rerouted_head_tunnels = None
                self.frr_mid_point_tunnels = None
                self.protected_mid_point_tunnels = None
                self.rerouted_mid_point_tunnels = None
                self.link_protected_tunnels = None
                self.node_protected_tunnels = None
                self.bw_protected_tunnels = None
                self.frr_p2p_head_tunnels = None
                self.protected_p2p_head_tunnels = None
                self.rerouted_p2p_head_tunnels = None
                self.frr_p2p_mid_point_tunnels = None
                self.protected_p2p_mid_point_tunnels = None
                self.rerouted_p2p_mid_point_tunnels = None
                self.link_protected_p2p_tunnels = None
                self.node_protected_p2p_tunnels = None
                self.bw_protected_p2p_tunnels = None
                self.backup_tunnels = None
                self.backups_assigned = None
                self.frr_protected_interfaces = None
                self.rerouted_interfaces = None
                self.p2p_head_tunnels = None
                self.up_p2p_head_tunnels = None
                self.dynamic_up_p2p_head_tunnels = None
                self.frr_config_p2p_head_tunnels = None
                self.p2p_head_destinations = None
                self.p2p_head_destinations_up = None
                self.bw_protected_p2p_s2_ls = None
                self.link_protected_p2p_s2_ls = None
                self.up_p2p_head_s2_ls = None
                self.proceeding_p2p_head_s2_ls = None
                self.recovering_p2p_head_s2_ls = None
                self.frr_p2p_head_s2_ls = None
                self.protected_p2p_head_s2_ls = None
                self.rerouted_p2p_head_s2_ls = None
                self.p2p_mid_point_s2_ls = None
                self.up_p2p_mid_point_s2_ls = None
                self.proceeding_p2p_mid_point_s2_ls = None
                self.frr_p2p_mid_point_s2_ls = None
                self.protected_p2p_mid_point_s2_ls = None
                self.rerouted_p2p_mid_point_s2_ls = None
                self.p2p_tail_s2_ls = None
                self.up_p2p_tail_s2_ls = None
                self.p2p_tail_tunnels = None
                self.path_protect_configured_tunnels = None
                self.path_protect_configured_tunnels_up = None
                self.path_protect_configured_tunnels_standby_up = None
                self.link_diverse_paths = None
                self.node_diverse_paths = None
                self.link_and_node_diverse_paths = None
                self.user_defined_paths = None
                self.p2mp_head_tunnels = None
                self.up_p2mp_head_tunnels = None
                self.frr_config_p2mp_head_tunnels = None
                self.p2mp_head_destinations = None
                self.up_p2mp_head_destinations = None
                self.bw_protected_p2mp_s2_ls = None
                self.link_protected_p2mp_s2_ls = None
                self.up_p2mp_head_s2_ls = None
                self.proceeding_p2mp_head_s2_ls = None
                self.frr_p2mp_head_s2_ls = None
                self.protected_p2mp_head_s2_ls = None
                self.rerouted_p2mp_head_s2_ls = None
                self.p2mp_mid_point_s2_ls = None
                self.up_p2mp_mid_point_s2_ls = None
                self.proceeding_p2mp_mid_point_s2_ls = None
                self.frr_p2mp_mid_point_s2_ls = None
                self.protected_p2mp_mid_point_s2_ls = None
                self.rerouted_p2mp_mid_point_s2_ls = None
                self.p2mp_tail_s2_ls = None
                self.up_p2mp_tail_s2_ls = None
                self.bidir_head_tunnels = None
                self.bidir_head_tunnels_up = None
                self.bidir_head_tunnels_associated = None
                self.bidir_head_tunnels_corouted = None
                self.bidir_head_ls_ps_up = None
                self.bidir_head_ls_ps_proceeding = None
                self.bidir_head_ls_ps_associated = None
                self.bidir_head_ls_ps_standby = None
                self.bidir_mid_tunnels = None
                self.bidir_mid_tunnels_up = None
                self.bidir_mid_ls_ps_proceeding = None
                self.bidir_mid_ls_ps_associated = None
                self.bidir_mid_ls_ps_standby = None
                self.bidir_tail_ls_ps = None
                self.bidir_tail_ls_ps_up = None
                self.bidir_tail_ls_ps_proceeding = None
                self.bidir_tail_ls_ps_associated = None
                self.bidir_tail_ls_ps_standby = None
                self.bidir_tail_ls_ps_corouted = None

                self.autobackup_summary = MplsTe.Tunnels.Summary.AutobackupSummary()
                self.autobackup_summary.parent = self
                self._children_name_map["autobackup_summary"] = "autobackup-summary"

                self.auto_mesh_summary = MplsTe.Tunnels.Summary.AutoMeshSummary()
                self.auto_mesh_summary.parent = self
                self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"

                self.auto_mesh_one_hop_summary = MplsTe.Tunnels.Summary.AutoMeshOneHopSummary()
                self.auto_mesh_one_hop_summary.parent = self
                self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"

                self.gmpls_uni_summary = MplsTe.Tunnels.Summary.GmplsUniSummary()
                self.gmpls_uni_summary.parent = self
                self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"

                self.gmpls_nni_summary = MplsTe.Tunnels.Summary.GmplsNniSummary()
                self.gmpls_nni_summary.parent = self
                self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"

                self.current_tunnel_convergence_summary = MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                self.current_tunnel_convergence_summary.parent = self
                self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"

                self.last_tunnel_convergence_summary = MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary()
                self.last_tunnel_convergence_summary.parent = self
                self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"

                self.auto_tun_server_summary = MplsTe.Tunnels.Summary.AutoTunServerSummary()
                self.auto_tun_server_summary.parent = self
                self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Tunnels.Summary, ['pcalc_tie_breaker_type', 'pcalc_tiebreaker', 'tiebreaker_qualifier', 'te_process_status', 'is_rsvp_process_enabled', 'is_forwarding_enabled', 'activated_heads', 'deactivated_heads', 'recovered_heads', 'is_periodic_reoptimization_on', 'reoptimization_period', 'next_reoptimization_timer', 'auto_bandwidth_tunnels', 'auto_bandwidth_collection_period', 'is_promotion_on', 'promotion_period', 'next_promotion_timer', 'tunnel_check_period', 'next_check_time', 'tunnel_verify_period', 'next_verify_timer', 'frr_head_tunnels', 'protected_head_tunnels', 'rerouted_head_tunnels', 'frr_mid_point_tunnels', 'protected_mid_point_tunnels', 'rerouted_mid_point_tunnels', 'link_protected_tunnels', 'node_protected_tunnels', 'bw_protected_tunnels', 'frr_p2p_head_tunnels', 'protected_p2p_head_tunnels', 'rerouted_p2p_head_tunnels', 'frr_p2p_mid_point_tunnels', 'protected_p2p_mid_point_tunnels', 'rerouted_p2p_mid_point_tunnels', 'link_protected_p2p_tunnels', 'node_protected_p2p_tunnels', 'bw_protected_p2p_tunnels', 'backup_tunnels', 'backups_assigned', 'frr_protected_interfaces', 'rerouted_interfaces', 'p2p_head_tunnels', 'up_p2p_head_tunnels', 'dynamic_up_p2p_head_tunnels', 'frr_config_p2p_head_tunnels', 'p2p_head_destinations', 'p2p_head_destinations_up', 'bw_protected_p2p_s2_ls', 'link_protected_p2p_s2_ls', 'up_p2p_head_s2_ls', 'proceeding_p2p_head_s2_ls', 'recovering_p2p_head_s2_ls', 'frr_p2p_head_s2_ls', 'protected_p2p_head_s2_ls', 'rerouted_p2p_head_s2_ls', 'p2p_mid_point_s2_ls', 'up_p2p_mid_point_s2_ls', 'proceeding_p2p_mid_point_s2_ls', 'frr_p2p_mid_point_s2_ls', 'protected_p2p_mid_point_s2_ls', 'rerouted_p2p_mid_point_s2_ls', 'p2p_tail_s2_ls', 'up_p2p_tail_s2_ls', 'p2p_tail_tunnels', 'path_protect_configured_tunnels', 'path_protect_configured_tunnels_up', 'path_protect_configured_tunnels_standby_up', 'link_diverse_paths', 'node_diverse_paths', 'link_and_node_diverse_paths', 'user_defined_paths', 'p2mp_head_tunnels', 'up_p2mp_head_tunnels', 'frr_config_p2mp_head_tunnels', 'p2mp_head_destinations', 'up_p2mp_head_destinations', 'bw_protected_p2mp_s2_ls', 'link_protected_p2mp_s2_ls', 'up_p2mp_head_s2_ls', 'proceeding_p2mp_head_s2_ls', 'frr_p2mp_head_s2_ls', 'protected_p2mp_head_s2_ls', 'rerouted_p2mp_head_s2_ls', 'p2mp_mid_point_s2_ls', 'up_p2mp_mid_point_s2_ls', 'proceeding_p2mp_mid_point_s2_ls', 'frr_p2mp_mid_point_s2_ls', 'protected_p2mp_mid_point_s2_ls', 'rerouted_p2mp_mid_point_s2_ls', 'p2mp_tail_s2_ls', 'up_p2mp_tail_s2_ls', 'bidir_head_tunnels', 'bidir_head_tunnels_up', 'bidir_head_tunnels_associated', 'bidir_head_tunnels_corouted', 'bidir_head_ls_ps_up', 'bidir_head_ls_ps_proceeding', 'bidir_head_ls_ps_associated', 'bidir_head_ls_ps_standby', 'bidir_mid_tunnels', 'bidir_mid_tunnels_up', 'bidir_mid_ls_ps_proceeding', 'bidir_mid_ls_ps_associated', 'bidir_mid_ls_ps_standby', 'bidir_tail_ls_ps', 'bidir_tail_ls_ps_up', 'bidir_tail_ls_ps_proceeding', 'bidir_tail_ls_ps_associated', 'bidir_tail_ls_ps_standby', 'bidir_tail_ls_ps_corouted'], name, value)


            class AutobackupSummary(_Entity_):
                """
                Autobackup summary
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.AutobackupSummary, self).__init__()

                    self.yang_name = "autobackup-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('autobackups', (YLeaf(YType.uint32, 'autobackups'), ['int'])),
                        ('up_autobackups', (YLeaf(YType.uint32, 'up-autobackups'), ['int'])),
                        ('down_autobackups', (YLeaf(YType.uint32, 'down-autobackups'), ['int'])),
                        ('unused_autobackups', (YLeaf(YType.uint32, 'unused-autobackups'), ['int'])),
                        ('next_hop_autobackups', (YLeaf(YType.uint32, 'next-hop-autobackups'), ['int'])),
                        ('next_next_hop_autobackups', (YLeaf(YType.uint32, 'next-next-hop-autobackups'), ['int'])),
                        ('srlg_strict_autobackups', (YLeaf(YType.uint32, 'srlg-strict-autobackups'), ['int'])),
                        ('srlg_preferred_autobackups', (YLeaf(YType.uint32, 'srlg-preferred-autobackups'), ['int'])),
                        ('srlg_weighted_autobackups', (YLeaf(YType.uint32, 'srlg-weighted-autobackups'), ['int'])),
                        ('next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                    ])
                    self.autobackups = None
                    self.up_autobackups = None
                    self.down_autobackups = None
                    self.unused_autobackups = None
                    self.next_hop_autobackups = None
                    self.next_next_hop_autobackups = None
                    self.srlg_strict_autobackups = None
                    self.srlg_preferred_autobackups = None
                    self.srlg_weighted_autobackups = None
                    self.next_hop_autobackup_protected_ls_ps = None
                    self.next_next_hop_autobackup_protected_ls_ps = None
                    self.next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_hop_autobackup_protected_s2l_families = None
                    self.next_next_hop_autobackup_protected_s2l_families = None
                    self.next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_hop_autobackup_protected_s2_ls = None
                    self.next_next_hop_autobackup_protected_s2_ls = None
                    self.next_hop_srlg_autobackup_protected_s2_ls = None
                    self.next_next_hop_srlg_autobackup_protected_s2_ls = None
                    self._segment_path = lambda: "autobackup-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.AutobackupSummary, ['autobackups', 'up_autobackups', 'down_autobackups', 'unused_autobackups', 'next_hop_autobackups', 'next_next_hop_autobackups', 'srlg_strict_autobackups', 'srlg_preferred_autobackups', 'srlg_weighted_autobackups', 'next_hop_autobackup_protected_ls_ps', 'next_next_hop_autobackup_protected_ls_ps', 'next_hop_srlg_autobackup_protected_ls_ps', 'next_next_hop_srlg_autobackup_protected_ls_ps', 'next_hop_autobackup_protected_s2l_families', 'next_next_hop_autobackup_protected_s2l_families', 'next_hop_srlg_autobackup_protected_s2l_families', 'next_next_hop_srlg_autobackup_protected_s2l_families', 'next_hop_autobackup_protected_s2_ls', 'next_next_hop_autobackup_protected_s2_ls', 'next_hop_srlg_autobackup_protected_s2_ls', 'next_next_hop_srlg_autobackup_protected_s2_ls'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.AutobackupSummary']['meta_info']


            class AutoMeshSummary(_Entity_):
                """
                Automesh summary
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.AutoMeshSummary, self).__init__()

                    self.yang_name = "auto-mesh-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                        ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                        ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_groups', (YLeaf(YType.uint32, 'auto-mesh-groups'), ['int'])),
                        ('auto_mesh_destinations', (YLeaf(YType.uint32, 'auto-mesh-destinations'), ['int'])),
                    ])
                    self.auto_mesh_tunnels = None
                    self.up_auto_mesh_tunnels = None
                    self.down_auto_mesh_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_groups = None
                    self.auto_mesh_destinations = None
                    self._segment_path = lambda: "auto-mesh-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.AutoMeshSummary, ['auto_mesh_tunnels', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_groups', 'auto_mesh_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.AutoMeshSummary']['meta_info']


            class AutoMeshOneHopSummary(_Entity_):
                """
                Automesh Onehop summary
                
                .. attribute:: auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh onehop tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_one_hop_groups
                
                	Total number of automesh onehop mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_one_hop_destinations
                
                	Total number of automesh onehop destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.AutoMeshOneHopSummary, self).__init__()

                    self.yang_name = "auto-mesh-one-hop-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'auto-mesh-one-hop-tunnels'), ['int'])),
                        ('up_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-one-hop-tunnels'), ['int'])),
                        ('down_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-one-hop-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_one_hop_groups', (YLeaf(YType.uint32, 'auto-mesh-one-hop-groups'), ['int'])),
                        ('auto_mesh_one_hop_destinations', (YLeaf(YType.uint32, 'auto-mesh-one-hop-destinations'), ['int'])),
                    ])
                    self.auto_mesh_one_hop_tunnels = None
                    self.up_auto_mesh_one_hop_tunnels = None
                    self.down_auto_mesh_one_hop_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_one_hop_groups = None
                    self.auto_mesh_one_hop_destinations = None
                    self._segment_path = lambda: "auto-mesh-one-hop-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.AutoMeshOneHopSummary, ['auto_mesh_one_hop_tunnels', 'up_auto_mesh_one_hop_tunnels', 'down_auto_mesh_one_hop_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_one_hop_groups', 'auto_mesh_one_hop_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.AutoMeshOneHopSummary']['meta_info']


            class GmplsUniSummary(_Entity_):
                """
                GMPLS\-UNI summary
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.GmplsUniSummary, self).__init__()

                    self.yang_name = "gmpls-uni-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('heads_up', (YLeaf(YType.uint32, 'heads-up'), ['int'])),
                        ('heads_down', (YLeaf(YType.uint32, 'heads-down'), ['int'])),
                        ('tails_up', (YLeaf(YType.uint32, 'tails-up'), ['int'])),
                        ('tails_down', (YLeaf(YType.uint32, 'tails-down'), ['int'])),
                    ])
                    self.heads_up = None
                    self.heads_down = None
                    self.tails_up = None
                    self.tails_down = None
                    self._segment_path = lambda: "gmpls-uni-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.GmplsUniSummary, ['heads_up', 'heads_down', 'tails_up', 'tails_down'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.GmplsUniSummary']['meta_info']


            class GmplsNniSummary(_Entity_):
                """
                GMPLS\-NNI summary
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: mids_up
                
                	Tunnel mids in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: mids_down
                
                	Tunnel mids in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.GmplsNniSummary, self).__init__()

                    self.yang_name = "gmpls-nni-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('heads_up', (YLeaf(YType.uint32, 'heads-up'), ['int'])),
                        ('heads_down', (YLeaf(YType.uint32, 'heads-down'), ['int'])),
                        ('mids_up', (YLeaf(YType.uint32, 'mids-up'), ['int'])),
                        ('mids_down', (YLeaf(YType.uint32, 'mids-down'), ['int'])),
                        ('tails_up', (YLeaf(YType.uint32, 'tails-up'), ['int'])),
                        ('tails_down', (YLeaf(YType.uint32, 'tails-down'), ['int'])),
                    ])
                    self.heads_up = None
                    self.heads_down = None
                    self.mids_up = None
                    self.mids_down = None
                    self.tails_up = None
                    self.tails_down = None
                    self._segment_path = lambda: "gmpls-nni-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.GmplsNniSummary, ['heads_up', 'heads_down', 'mids_up', 'mids_down', 'tails_up', 'tails_down'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.GmplsNniSummary']['meta_info']


            class CurrentTunnelConvergenceSummary(_Entity_):
                """
                Current Tunnel convergemce summary information
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "current-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_frr_active_count', (YLeaf(YType.uint32, 'tunnel-frr-active-count'), ['int'])),
                        ('tunnel_frr_total_count', (YLeaf(YType.uint32, 'tunnel-frr-total-count'), ['int'])),
                        ('tunnel_converged_count', (YLeaf(YType.uint32, 'tunnel-converged-count'), ['int'])),
                        ('tunnel_total_convergence_complete_time', (YLeaf(YType.uint64, 'tunnel-total-convergence-complete-time'), ['int'])),
                    ])
                    self.tunnel_frr_active_count = None
                    self.tunnel_frr_total_count = None
                    self.tunnel_converged_count = None
                    self.tunnel_total_convergence_complete_time = None
                    self._segment_path = lambda: "current-tunnel-convergence-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary, ['tunnel_frr_active_count', 'tunnel_frr_total_count', 'tunnel_converged_count', 'tunnel_total_convergence_complete_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.CurrentTunnelConvergenceSummary']['meta_info']


            class LastTunnelConvergenceSummary(_Entity_):
                """
                Last Tunnel convergemce summary information
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "last-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_frr_active_count', (YLeaf(YType.uint32, 'tunnel-frr-active-count'), ['int'])),
                        ('tunnel_frr_total_count', (YLeaf(YType.uint32, 'tunnel-frr-total-count'), ['int'])),
                        ('tunnel_converged_count', (YLeaf(YType.uint32, 'tunnel-converged-count'), ['int'])),
                        ('tunnel_total_convergence_complete_time', (YLeaf(YType.uint64, 'tunnel-total-convergence-complete-time'), ['int'])),
                    ])
                    self.tunnel_frr_active_count = None
                    self.tunnel_frr_total_count = None
                    self.tunnel_converged_count = None
                    self.tunnel_total_convergence_complete_time = None
                    self._segment_path = lambda: "last-tunnel-convergence-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary, ['tunnel_frr_active_count', 'tunnel_frr_total_count', 'tunnel_converged_count', 'tunnel_total_convergence_complete_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.LastTunnelConvergenceSummary']['meta_info']


            class AutoTunServerSummary(_Entity_):
                """
                Auto\-tunnel server tunnel summary
                
                .. attribute:: total_auto_p2mp_tunnels
                
                	Total number of P2MP auto\-tunnels
                	**type**\:  :py:class:`TotalAutoP2mpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels>`
                
                	**config**\: False
                
                .. attribute:: total_auto_p2p_tunnels
                
                	Total number of P2P auto\-tunnels
                	**type**\:  :py:class:`TotalAutoP2pTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels>`
                
                	**config**\: False
                
                .. attribute:: clients_summary
                
                	List of auto\-tunnel server clients
                	**type**\: list of  		 :py:class:`ClientsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.Summary.AutoTunServerSummary, self).__init__()

                    self.yang_name = "auto-tun-server-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("total-auto-p2mp-tunnels", ("total_auto_p2mp_tunnels", MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels)), ("total-auto-p2p-tunnels", ("total_auto_p2p_tunnels", MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels)), ("clients-summary", ("clients_summary", MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary))])
                    self._leafs = OrderedDict()

                    self.total_auto_p2mp_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels()
                    self.total_auto_p2mp_tunnels.parent = self
                    self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"

                    self.total_auto_p2p_tunnels = MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels()
                    self.total_auto_p2p_tunnels.parent = self
                    self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"

                    self.clients_summary = YList(self)
                    self._segment_path = lambda: "auto-tun-server-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary, [], name, value)


                class TotalAutoP2mpTunnels(_Entity_):
                    """
                    Total number of P2MP auto\-tunnels
                    
                    .. attribute:: auto_p2mp_tunnel
                    
                    	Total number of client P2MP auto\-tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels, self).__init__()

                        self.yang_name = "total-auto-p2mp-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_p2mp_tunnel', (YLeaf(YType.uint32, 'auto-p2mp-tunnel'), ['int'])),
                            ('auto_p2mp_destinations', (YLeaf(YType.uint32, 'auto-p2mp-destinations'), ['int'])),
                            ('up_auto_p2mp_destinations', (YLeaf(YType.uint32, 'up-auto-p2mp-destinations'), ['int'])),
                            ('down_auto_p2mp_destinations', (YLeaf(YType.uint32, 'down-auto-p2mp-destinations'), ['int'])),
                            ('up_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'up-auto-p2mp-tunnels'), ['int'])),
                            ('down_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'down-auto-p2mp-tunnels'), ['int'])),
                            ('frr_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'frr-auto-p2mp-tunnels'), ['int'])),
                        ])
                        self.auto_p2mp_tunnel = None
                        self.auto_p2mp_destinations = None
                        self.up_auto_p2mp_destinations = None
                        self.down_auto_p2mp_destinations = None
                        self.up_auto_p2mp_tunnels = None
                        self.down_auto_p2mp_tunnels = None
                        self.frr_auto_p2mp_tunnels = None
                        self._segment_path = lambda: "total-auto-p2mp-tunnels"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels, ['auto_p2mp_tunnel', 'auto_p2mp_destinations', 'up_auto_p2mp_destinations', 'down_auto_p2mp_destinations', 'up_auto_p2mp_tunnels', 'down_auto_p2mp_tunnels', 'frr_auto_p2mp_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels']['meta_info']


                class TotalAutoP2pTunnels(_Entity_):
                    """
                    Total number of P2P auto\-tunnels
                    
                    .. attribute:: auto_p2p_tunnel
                    
                    	Total number of client P2P auto\-tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels, self).__init__()

                        self.yang_name = "total-auto-p2p-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_p2p_tunnel', (YLeaf(YType.uint32, 'auto-p2p-tunnel'), ['int'])),
                            ('up_auto_p2p_tunnels', (YLeaf(YType.uint32, 'up-auto-p2p-tunnels'), ['int'])),
                            ('down_auto_p2p_tunnels', (YLeaf(YType.uint32, 'down-auto-p2p-tunnels'), ['int'])),
                        ])
                        self.auto_p2p_tunnel = None
                        self.up_auto_p2p_tunnels = None
                        self.down_auto_p2p_tunnels = None
                        self._segment_path = lambda: "total-auto-p2p-tunnels"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels, ['auto_p2p_tunnel', 'up_auto_p2p_tunnels', 'down_auto_p2p_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels']['meta_info']


                class ClientsSummary(_Entity_):
                    """
                    List of auto\-tunnel server clients
                    
                    .. attribute:: p2mp_info
                    
                    	P2MP info for a client
                    	**type**\:  :py:class:`P2mpInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_info
                    
                    	P2P info for a client
                    	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protocol_type
                    
                    	Client's protocol type
                    	**type**\:  :py:class:`TeServTunClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeServTunClient>`
                    
                    	**config**\: False
                    
                    .. attribute:: client_instance_name
                    
                    	Client Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: client_id
                    
                    	Client ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__init__()

                        self.yang_name = "clients-summary"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("p2mp-info", ("p2mp_info", MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo)), ("p2p-info", ("p2p_info", MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo))])
                        self._leafs = OrderedDict([
                            ('protocol_type', (YLeaf(YType.enumeration, 'protocol-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeServTunClient', '')])),
                            ('client_instance_name', (YLeaf(YType.str, 'client-instance-name'), ['str'])),
                            ('client_id', (YLeaf(YType.uint32, 'client-id'), ['int'])),
                        ])
                        self.protocol_type = None
                        self.client_instance_name = None
                        self.client_id = None

                        self.p2mp_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo()
                        self.p2mp_info.parent = self
                        self._children_name_map["p2mp_info"] = "p2mp-info"

                        self.p2p_info = MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo()
                        self.p2p_info.parent = self
                        self._children_name_map["p2p_info"] = "p2p-info"
                        self._segment_path = lambda: "clients-summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, ['protocol_type', 'client_instance_name', 'client_id'], name, value)


                    class P2mpInfo(_Entity_):
                        """
                        P2MP info for a client
                        
                        .. attribute:: auto_p2mp_tunnel
                        
                        	Total number of client P2MP auto\-tunnels
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are FRR enabled
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo, self).__init__()

                            self.yang_name = "p2mp-info"
                            self.yang_parent_name = "clients-summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('auto_p2mp_tunnel', (YLeaf(YType.uint32, 'auto-p2mp-tunnel'), ['int'])),
                                ('auto_p2mp_destinations', (YLeaf(YType.uint32, 'auto-p2mp-destinations'), ['int'])),
                                ('up_auto_p2mp_destinations', (YLeaf(YType.uint32, 'up-auto-p2mp-destinations'), ['int'])),
                                ('down_auto_p2mp_destinations', (YLeaf(YType.uint32, 'down-auto-p2mp-destinations'), ['int'])),
                                ('up_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'up-auto-p2mp-tunnels'), ['int'])),
                                ('down_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'down-auto-p2mp-tunnels'), ['int'])),
                                ('frr_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'frr-auto-p2mp-tunnels'), ['int'])),
                            ])
                            self.auto_p2mp_tunnel = None
                            self.auto_p2mp_destinations = None
                            self.up_auto_p2mp_destinations = None
                            self.down_auto_p2mp_destinations = None
                            self.up_auto_p2mp_tunnels = None
                            self.down_auto_p2mp_tunnels = None
                            self.frr_auto_p2mp_tunnels = None
                            self._segment_path = lambda: "p2mp-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo, ['auto_p2mp_tunnel', 'auto_p2mp_destinations', 'up_auto_p2mp_destinations', 'down_auto_p2mp_destinations', 'up_auto_p2mp_tunnels', 'down_auto_p2mp_tunnels', 'frr_auto_p2mp_tunnels'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo']['meta_info']


                    class P2pInfo(_Entity_):
                        """
                        P2P info for a client
                        
                        .. attribute:: auto_p2p_tunnel
                        
                        	Total number of client P2P auto\-tunnels
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo, self).__init__()

                            self.yang_name = "p2p-info"
                            self.yang_parent_name = "clients-summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('auto_p2p_tunnel', (YLeaf(YType.uint32, 'auto-p2p-tunnel'), ['int'])),
                                ('up_auto_p2p_tunnels', (YLeaf(YType.uint32, 'up-auto-p2p-tunnels'), ['int'])),
                                ('down_auto_p2p_tunnels', (YLeaf(YType.uint32, 'down-auto-p2p-tunnels'), ['int'])),
                            ])
                            self.auto_p2p_tunnel = None
                            self.up_auto_p2p_tunnels = None
                            self.down_auto_p2p_tunnels = None
                            self._segment_path = lambda: "p2p-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo, ['auto_p2p_tunnel', 'up_auto_p2p_tunnels', 'down_auto_p2p_tunnels'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary.ClientsSummary']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.Summary.AutoTunServerSummary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Tunnels.Summary']['meta_info']


        class TunnelPathProtections(_Entity_):
            """
            Path protection
            
            .. attribute:: tunnel_path_protection
            
            	Path Protection
            	**type**\: list of  		 :py:class:`TunnelPathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Tunnels.TunnelPathProtections, self).__init__()

                self.yang_name = "tunnel-path-protections"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-path-protection", ("tunnel_path_protection", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection))])
                self._leafs = OrderedDict()

                self.tunnel_path_protection = YList(self)
                self._segment_path = lambda: "tunnel-path-protections"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections, [], name, value)


            class TunnelPathProtection(_Entity_):
                """
                Path Protection
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: current_lsp
                
                	 Current LSP info
                	**type**\:  :py:class:`CurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: standby_lsp
                
                	 Standby LSP info
                	**type**\:  :py:class:`StandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__init__()

                    self.yang_name = "tunnel-path-protection"
                    self.yang_parent_name = "tunnel-path-protections"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("path-protection", ("path_protection", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection)), ("current-lsp", ("current_lsp", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp)), ("standby-lsp", ("standby_lsp", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('is_tunnel_up', (YLeaf(YType.boolean, 'is-tunnel-up'), ['bool'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.is_tunnel_up = None
                    self.source_address = None
                    self.destination_address = None
                    self.extended_tunnel_id = None

                    self.path_protection = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.current_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                    self.current_lsp.parent = self
                    self._children_name_map["current_lsp"] = "current-lsp"

                    self.standby_lsp = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                    self.standby_lsp.parent = self
                    self._children_name_map["standby_lsp"] = "standby-lsp"
                    self._segment_path = lambda: "tunnel-path-protection"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection, ['ctype', 'tunnel_id', 'tunnel_name', 'is_tunnel_up', 'source_address', 'destination_address', 'extended_tunnel_id'], name, value)


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/path-protection/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection']['meta_info']


                class CurrentLsp(_Entity_):
                    """
                     Current LSP info
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of  		 :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__init__()

                        self.yang_name = "current-lsp"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlsp-outgoing-info", ("srlsp_outgoing_info", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo)), ("lsp-hop", ("lsp_hop", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.srlsp_outgoing_info = YList(self)
                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "current-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, ['lsp_uptime', 'path_protection_lsp_id', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class SrlspOutgoingInfo(_Entity_):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                                ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ])
                            self.lsp_output_interface = None
                            self.lsp_output_label = None
                            self._segment_path = lambda: "srlsp-outgoing-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, ['lsp_output_interface', 'lsp_output_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp']['meta_info']


                class StandbyLsp(_Entity_):
                    """
                     Standby LSP info
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of  		 :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__init__()

                        self.yang_name = "standby-lsp"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlsp-outgoing-info", ("srlsp_outgoing_info", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo)), ("lsp-hop", ("lsp_hop", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.srlsp_outgoing_info = YList(self)
                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "standby-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, ['lsp_uptime', 'path_protection_lsp_id', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class SrlspOutgoingInfo(_Entity_):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                                ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ])
                            self.lsp_output_interface = None
                            self.lsp_output_label = None
                            self._segment_path = lambda: "srlsp-outgoing-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, ['lsp_output_interface', 'lsp_output_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections.TunnelPathProtection']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Tunnels.TunnelPathProtections']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.Tunnels']['meta_info']


    class MaximumTunnels(_Entity_):
        """
        MPLS Traffic Engineering Tunnels
        
        .. attribute:: current_maximum_tunnels
        
        	Current Maximum Tunnels
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_destinations
        
        	Current Maximum Destinations
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_p2mp_tunnels
        
        	Current Maximum P2MP Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_p2mp_destnation_per_tunnel
        
        	Current Maximum P2MP Destinations Per Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: absolute_maximum
        
        	Absolute Maximum
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_autobackups
        
        	Current Maximum Autotunnel Backups Allowed
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_auto_mesh
        
        	Current Maximum Autotunnel Mesh Allowed
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_tunnel_count
        
        	Current tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_destination_count
        
        	Current Destination Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_p2mp_tunnel_count
        
        	Current P2MP tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_p2mp_destnation_per_tunnel_count
        
        	Current P2MP Destination per tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: is_autobackup_range_configured
        
        	TRUE if the autobackup range is configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: current_autobackups
        
        	Current Autotunnel Backup count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: is_auto_mesh_range_configured
        
        	TRUE if the automesh range is configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: current_auto_mesh
        
        	Current Autotunnel Mesh count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_gmpls_unitunnels
        
        	Current Maximum GMPLS\-UNI Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_gmpls_uni
        
        	Current GMPLS\-UNI tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.MaximumTunnels, self).__init__()

            self.yang_name = "maximum-tunnels"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('current_maximum_tunnels', (YLeaf(YType.uint32, 'current-maximum-tunnels'), ['int'])),
                ('current_maximum_destinations', (YLeaf(YType.uint32, 'current-maximum-destinations'), ['int'])),
                ('current_maximum_p2mp_tunnels', (YLeaf(YType.uint32, 'current-maximum-p2mp-tunnels'), ['int'])),
                ('current_maximum_p2mp_destnation_per_tunnel', (YLeaf(YType.uint32, 'current-maximum-p2mp-destnation-per-tunnel'), ['int'])),
                ('absolute_maximum', (YLeaf(YType.uint32, 'absolute-maximum'), ['int'])),
                ('current_maximum_autobackups', (YLeaf(YType.uint32, 'current-maximum-autobackups'), ['int'])),
                ('current_maximum_auto_mesh', (YLeaf(YType.uint32, 'current-maximum-auto-mesh'), ['int'])),
                ('current_tunnel_count', (YLeaf(YType.uint32, 'current-tunnel-count'), ['int'])),
                ('current_destination_count', (YLeaf(YType.uint32, 'current-destination-count'), ['int'])),
                ('current_p2mp_tunnel_count', (YLeaf(YType.uint32, 'current-p2mp-tunnel-count'), ['int'])),
                ('current_p2mp_destnation_per_tunnel_count', (YLeaf(YType.uint32, 'current-p2mp-destnation-per-tunnel-count'), ['int'])),
                ('is_autobackup_range_configured', (YLeaf(YType.boolean, 'is-autobackup-range-configured'), ['bool'])),
                ('current_autobackups', (YLeaf(YType.uint32, 'current-autobackups'), ['int'])),
                ('is_auto_mesh_range_configured', (YLeaf(YType.boolean, 'is-auto-mesh-range-configured'), ['bool'])),
                ('current_auto_mesh', (YLeaf(YType.uint32, 'current-auto-mesh'), ['int'])),
                ('current_maximum_gmpls_unitunnels', (YLeaf(YType.uint32, 'current-maximum-gmpls-unitunnels'), ['int'])),
                ('current_gmpls_uni', (YLeaf(YType.uint32, 'current-gmpls-uni'), ['int'])),
            ])
            self.current_maximum_tunnels = None
            self.current_maximum_destinations = None
            self.current_maximum_p2mp_tunnels = None
            self.current_maximum_p2mp_destnation_per_tunnel = None
            self.absolute_maximum = None
            self.current_maximum_autobackups = None
            self.current_maximum_auto_mesh = None
            self.current_tunnel_count = None
            self.current_destination_count = None
            self.current_p2mp_tunnel_count = None
            self.current_p2mp_destnation_per_tunnel_count = None
            self.is_autobackup_range_configured = None
            self.current_autobackups = None
            self.is_auto_mesh_range_configured = None
            self.current_auto_mesh = None
            self.current_maximum_gmpls_unitunnels = None
            self.current_gmpls_uni = None
            self._segment_path = lambda: "maximum-tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.MaximumTunnels, ['current_maximum_tunnels', 'current_maximum_destinations', 'current_maximum_p2mp_tunnels', 'current_maximum_p2mp_destnation_per_tunnel', 'absolute_maximum', 'current_maximum_autobackups', 'current_maximum_auto_mesh', 'current_tunnel_count', 'current_destination_count', 'current_p2mp_tunnel_count', 'current_p2mp_destnation_per_tunnel_count', 'is_autobackup_range_configured', 'current_autobackups', 'is_auto_mesh_range_configured', 'current_auto_mesh', 'current_maximum_gmpls_unitunnels', 'current_gmpls_uni'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.MaximumTunnels']['meta_info']


    class PathProtection(_Entity_):
        """
        MPLS TE path protection info
        
        .. attribute:: switchover_log
        
        	MPLS TE path protection info
        	**type**\:  :py:class:`SwitchoverLog <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection.SwitchoverLog>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.PathProtection, self).__init__()

            self.yang_name = "path-protection"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("switchover-log", ("switchover_log", MplsTe.PathProtection.SwitchoverLog))])
            self._leafs = OrderedDict()

            self.switchover_log = MplsTe.PathProtection.SwitchoverLog()
            self.switchover_log.parent = self
            self._children_name_map["switchover_log"] = "switchover-log"
            self._segment_path = lambda: "path-protection"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.PathProtection, [], name, value)


        class SwitchoverLog(_Entity_):
            """
            MPLS TE path protection info
            
            .. attribute:: path_protection_switchovers
            
            	Total number of path protection switchover events. This could be more than the entries in the array
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: maximum_switchover_millisec
            
            	The maximum delay for a switchover in milliseconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: millisecond
            
            .. attribute:: average_switchover_millisec
            
            	The average delay for a switchover in milliseconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: millisecond
            
            .. attribute:: path_protection_switchover_entry
            
            	The array of path protection switchover entries
            	**type**\: list of  		 :py:class:`PathProtectionSwitchoverEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.PathProtection.SwitchoverLog, self).__init__()

                self.yang_name = "switchover-log"
                self.yang_parent_name = "path-protection"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-protection-switchover-entry", ("path_protection_switchover_entry", MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry))])
                self._leafs = OrderedDict([
                    ('path_protection_switchovers', (YLeaf(YType.uint32, 'path-protection-switchovers'), ['int'])),
                    ('maximum_switchover_millisec', (YLeaf(YType.uint32, 'maximum-switchover-millisec'), ['int'])),
                    ('average_switchover_millisec', (YLeaf(YType.uint32, 'average-switchover-millisec'), ['int'])),
                ])
                self.path_protection_switchovers = None
                self.maximum_switchover_millisec = None
                self.average_switchover_millisec = None

                self.path_protection_switchover_entry = YList(self)
                self._segment_path = lambda: "switchover-log"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/path-protection/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.PathProtection.SwitchoverLog, ['path_protection_switchovers', 'maximum_switchover_millisec', 'average_switchover_millisec'], name, value)


            class PathProtectionSwitchoverEntry(_Entity_):
                """
                The array of path protection switchover entries
                
                .. attribute:: path_protection_switchover_event_index
                
                	The index number of the path protection switch over event
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: path_protection_tunnel_id
                
                	The ID of the tunnel that experienced switchover
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: from_lsp_id
                
                	The LSP ID from which the traffic was switched over
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: to_lsp_id
                
                	The LSP ID to which the traffic was switched over
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: date_of_error_detection
                
                	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: date_of_error_detection_millisec
                
                	The milliseconds offset of the date when the error that caused  the switchover was detected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: millisecond
                
                .. attribute:: switchover_duration_millisec
                
                	The time in milliseconds between the detection of the error and switching the traffic
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: millisecond
                
                .. attribute:: path_protection_switchover_reason
                
                	The reason that caused the path protection switchover
                	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__init__()

                    self.yang_name = "path-protection-switchover-entry"
                    self.yang_parent_name = "switchover-log"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                        ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                        ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                        ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                        ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                        ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                        ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                        ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                    ])
                    self.path_protection_switchover_event_index = None
                    self.path_protection_tunnel_id = None
                    self.from_lsp_id = None
                    self.to_lsp_id = None
                    self.date_of_error_detection = None
                    self.date_of_error_detection_millisec = None
                    self.switchover_duration_millisec = None
                    self.path_protection_switchover_reason = None
                    self._segment_path = lambda: "path-protection-switchover-entry"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/path-protection/switchover-log/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.PathProtection.SwitchoverLog']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.PathProtection']['meta_info']


    class FibNextHopLabelRoutes(_Entity_):
        """
        MPLS TE FIB nexthop label route database
        
        .. attribute:: fib_next_hop_label_route
        
        	MPLS TE FIB nexthop label route
        	**type**\: list of  		 :py:class:`FibNextHopLabelRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.FibNextHopLabelRoutes, self).__init__()

            self.yang_name = "fib-next-hop-label-routes"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("fib-next-hop-label-route", ("fib_next_hop_label_route", MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute))])
            self._leafs = OrderedDict()

            self.fib_next_hop_label_route = YList(self)
            self._segment_path = lambda: "fib-next-hop-label-routes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.FibNextHopLabelRoutes, [], name, value)


        class FibNextHopLabelRoute(_Entity_):
            """
            MPLS TE FIB nexthop label route
            
            .. attribute:: label  (key)
            
            	MPLS Label
            	**type**\: int
            
            	**range:** 0..1048575
            
            	**config**\: False
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:  :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress>`
            
            	**config**\: False
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: route_version
            
            	Route version
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of  		 :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__init__()

                self.yang_name = "fib-next-hop-label-route"
                self.yang_parent_name = "fib-next-hop-label-routes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['label']
                self._child_classes = OrderedDict([("target-address", ("target_address", MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress)), ("next-hop-path", ("next_hop_path", MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath))])
                self._leafs = OrderedDict([
                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                    ('prefix_addr', (YLeaf(YType.str, 'prefix-addr'), ['str'])),
                    ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                    ('last_used_time', (YLeaf(YType.uint32, 'last-used-time'), ['int'])),
                    ('last_update_time', (YLeaf(YType.uint32, 'last-update-time'), ['int'])),
                    ('expire_time', (YLeaf(YType.uint32, 'expire-time'), ['int'])),
                    ('is_registered', (YLeaf(YType.boolean, 'is-registered'), ['bool'])),
                    ('is_notified', (YLeaf(YType.boolean, 'is-notified'), ['bool'])),
                    ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                    ('route_version', (YLeaf(YType.uint64, 'route-version'), ['int'])),
                ])
                self.label = None
                self.prefix_addr = None
                self.create_time = None
                self.last_used_time = None
                self.last_update_time = None
                self.expire_time = None
                self.is_registered = None
                self.is_notified = None
                self.is_stale = None
                self.route_version = None

                self.target_address = MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"

                self.next_hop_path = YList(self)
                self._segment_path = lambda: "fib-next-hop-label-route" + "[label='" + str(self.label) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/fib-next-hop-label-routes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute, ['label', 'prefix_addr', 'create_time', 'last_used_time', 'last_update_time', 'expire_time', 'is_registered', 'is_notified', 'is_stale', 'route_version'], name, value)


            class TargetAddress(_Entity_):
                """
                Next Hop Target Address
                
                .. attribute:: type
                
                	type
                	**type**\:  :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                	**config**\: False
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-label-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeTargetAddr', '')])),
                        ('ip_address', (YLeaf(YType.str, 'ip-address'), ['str'])),
                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                    ])
                    self.type = None
                    self.ip_address = None
                    self.label = None
                    self._segment_path = lambda: "target-address"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, ['type', 'ip_address', 'label'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress']['meta_info']


            class NextHopPath(_Entity_):
                """
                Next Hop Paths
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of  		 :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-label-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("label-stack", ("label_stack", MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack))])
                    self._leafs = OrderedDict([
                        ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                        ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                        ('pure_backup', (YLeaf(YType.boolean, 'pure-backup'), ['bool'])),
                    ])
                    self.interface = None
                    self.next_hop_address = None
                    self.path_id = None
                    self.backup_path_id = None
                    self.pure_backup = None

                    self.label_stack = YList(self)
                    self._segment_path = lambda: "next-hop-path"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, ['interface', 'next_hop_address', 'path_id', 'backup_path_id', 'pure_backup'], name, value)


                class LabelStack(_Entity_):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	Outgoing Label Stack
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "label-stack"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.FibNextHopLabelRoutes.FibNextHopLabelRoute']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.FibNextHopLabelRoutes']['meta_info']


    class P2mp(_Entity_):
        """
        P2MP Information
        
        .. attribute:: tunnel_rewrites
        
        	forwarding\-adjacency P2MP Tunnel RW
        	**type**\:  :py:class:`TunnelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites>`
        
        	**config**\: False
        
        .. attribute:: collaborator_timers
        
        	TE Collaborator timer status
        	**type**\:  :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.CollaboratorTimers>`
        
        	**config**\: False
        
        .. attribute:: forwarding_output_label_rewrites
        
        	forwarding\-adjacency P2MP Information
        	**type**\:  :py:class:`ForwardingOutputLabelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.P2mp, self).__init__()

            self.yang_name = "p2mp"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-rewrites", ("tunnel_rewrites", MplsTe.P2mp.TunnelRewrites)), ("collaborator-timers", ("collaborator_timers", MplsTe.P2mp.CollaboratorTimers)), ("forwarding-output-label-rewrites", ("forwarding_output_label_rewrites", MplsTe.P2mp.ForwardingOutputLabelRewrites))])
            self._leafs = OrderedDict()

            self.tunnel_rewrites = MplsTe.P2mp.TunnelRewrites()
            self.tunnel_rewrites.parent = self
            self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"

            self.collaborator_timers = MplsTe.P2mp.CollaboratorTimers()
            self.collaborator_timers.parent = self
            self._children_name_map["collaborator_timers"] = "collaborator-timers"

            self.forwarding_output_label_rewrites = MplsTe.P2mp.ForwardingOutputLabelRewrites()
            self.forwarding_output_label_rewrites.parent = self
            self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
            self._segment_path = lambda: "p2mp"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.P2mp, [], name, value)


        class TunnelRewrites(_Entity_):
            """
            forwarding\-adjacency P2MP Tunnel RW
            
            .. attribute:: tunnel_rewrite
            
            	Display only P2MP Information
            	**type**\: list of  		 :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2mp.TunnelRewrites, self).__init__()

                self.yang_name = "tunnel-rewrites"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite))])
                self._leafs = OrderedDict()

                self.tunnel_rewrite = YList(self)
                self._segment_path = lambda: "tunnel-rewrites"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2mp.TunnelRewrites, [], name, value)


            class TunnelRewrite(_Entity_):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: successful_rewrite
                
                	Successful rewrite details
                	**type**\:  :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite>`
                
                	**config**\: False
                
                .. attribute:: failed_rewrite
                
                	Failed rewrite details
                	**type**\:  :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite>`
                
                	**config**\: False
                
                .. attribute:: pending_rewrite
                
                	Pending rewrite details
                	**type**\:  :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite>`
                
                	**config**\: False
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_signal_name
                
                	Tunnel signaled\-name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite, self).__init__()

                    self.yang_name = "tunnel-rewrite"
                    self.yang_parent_name = "tunnel-rewrites"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','lsp_id','ctype']
                    self._child_classes = OrderedDict([("successful-rewrite", ("successful_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite)), ("failed-rewrite", ("failed_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite)), ("pending-rewrite", ("pending_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_interface', (YLeaf(YType.str, 'tunnel-interface'), ['str'])),
                        ('tunnel_signal_name', (YLeaf(YType.str, 'tunnel-signal-name'), ['str'])),
                        ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.ctype = None
                    self.tunnel_interface = None
                    self.tunnel_signal_name = None
                    self.is_segment_routing = None

                    self.successful_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                    self.successful_rewrite.parent = self
                    self._children_name_map["successful_rewrite"] = "successful-rewrite"

                    self.failed_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                    self.failed_rewrite.parent = self
                    self._children_name_map["failed_rewrite"] = "failed-rewrite"

                    self.pending_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                    self.pending_rewrite.parent = self
                    self._children_name_map["pending_rewrite"] = "pending-rewrite"
                    self._segment_path = lambda: "tunnel-rewrite" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[ctype='" + str(self.ctype) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/tunnel-rewrites/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite, ['tunnel_id', 'lsp_id', 'ctype', 'tunnel_interface', 'tunnel_signal_name', 'is_segment_routing'], name, value)


                class SuccessfulRewrite(_Entity_):
                    """
                    Successful rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__init__()

                        self.yang_name = "successful-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "successful-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "successful-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite']['meta_info']


                class FailedRewrite(_Entity_):
                    """
                    Failed rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__init__()

                        self.yang_name = "failed-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "failed-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "failed-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite']['meta_info']


                class PendingRewrite(_Entity_):
                    """
                    Pending rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__init__()

                        self.yang_name = "pending-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "pending-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "pending-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2mp.TunnelRewrites.TunnelRewrite']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2mp.TunnelRewrites']['meta_info']


        class CollaboratorTimers(_Entity_):
            """
            TE Collaborator timer status
            
            .. attribute:: p2mp_timer
            
            	Description of all P2MP timers
            	**type**\: list of  		 :py:class:`P2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.CollaboratorTimers.P2mpTimer>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2mp.CollaboratorTimers, self).__init__()

                self.yang_name = "collaborator-timers"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("p2mp-timer", ("p2mp_timer", MplsTe.P2mp.CollaboratorTimers.P2mpTimer))])
                self._leafs = OrderedDict()

                self.p2mp_timer = YList(self)
                self._segment_path = lambda: "collaborator-timers"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2mp.CollaboratorTimers, [], name, value)


            class P2mpTimer(_Entity_):
                """
                Description of all P2MP timers
                
                .. attribute:: timer_type
                
                	Timer Type
                	**type**\:  :py:class:`MplsTeP2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2mpTimer>`
                
                	**config**\: False
                
                .. attribute:: timer_name
                
                	Timer Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: start_time
                
                	Date when timer was last started in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: expiry_time
                
                	Date when the timer last expired in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: stop_time
                
                	Date when the timer was last stopped in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: duration
                
                	The expiry delay in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_running
                
                	True if the timer is running
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2mp.CollaboratorTimers.P2mpTimer, self).__init__()

                    self.yang_name = "p2mp-timer"
                    self.yang_parent_name = "collaborator-timers"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('timer_type', (YLeaf(YType.enumeration, 'timer-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeP2mpTimer', '')])),
                        ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                        ('start_time', (YLeaf(YType.uint32, 'start-time'), ['int'])),
                        ('expiry_time', (YLeaf(YType.uint32, 'expiry-time'), ['int'])),
                        ('stop_time', (YLeaf(YType.uint32, 'stop-time'), ['int'])),
                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                        ('is_running', (YLeaf(YType.boolean, 'is-running'), ['bool'])),
                    ])
                    self.timer_type = None
                    self.timer_name = None
                    self.start_time = None
                    self.expiry_time = None
                    self.stop_time = None
                    self.duration = None
                    self.is_running = None
                    self._segment_path = lambda: "p2mp-timer"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/collaborator-timers/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2mp.CollaboratorTimers.P2mpTimer, ['timer_type', 'timer_name', 'start_time', 'expiry_time', 'stop_time', 'duration', 'is_running'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2mp.CollaboratorTimers.P2mpTimer']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2mp.CollaboratorTimers']['meta_info']


        class ForwardingOutputLabelRewrites(_Entity_):
            """
            forwarding\-adjacency P2MP Information
            
            .. attribute:: forwarding_output_label_rewrite
            
            	Display only P2MP Information
            	**type**\: list of  		 :py:class:`ForwardingOutputLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites, self).__init__()

                self.yang_name = "forwarding-output-label-rewrites"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("forwarding-output-label-rewrite", ("forwarding_output_label_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite))])
                self._leafs = OrderedDict()

                self.forwarding_output_label_rewrite = YList(self)
                self._segment_path = lambda: "forwarding-output-label-rewrites"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites, [], name, value)


            class ForwardingOutputLabelRewrite(_Entity_):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	extended tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: next_hop_address  (key)
                
                	Next Hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: previous_hop_address  (key)
                
                	Prev Hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: s2l_output_rewrite
                
                	Output rewrite shared between S2Ls
                	**type**\:  :py:class:`S2lOutputRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite>`
                
                	**config**\: False
                
                .. attribute:: original_input_interface
                
                	Input interface of the S2Ls
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output interface of the S2Ls
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: s2l
                
                	Unique identifiers for the S2L sharing the rewrite
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l>`
                
                	**config**\: False
                
                .. attribute:: s2lsr_path
                
                	Segment\-Routing Paths
                	**type**\: list of  		 :py:class:`S2lsrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__init__()

                    self.yang_name = "forwarding-output-label-rewrite"
                    self.yang_parent_name = "forwarding-output-label-rewrites"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','lsp_id','extended_tunnel_id','source_address','p2mp_id','destination_address','next_hop_address','previous_hop_address','ctype']
                    self._child_classes = OrderedDict([("s2l-output-rewrite", ("s2l_output_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite)), ("s2l", ("s2l", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l)), ("s2lsr-path", ("s2lsr_path", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                        ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.p2mp_id = None
                    self.destination_address = None
                    self.next_hop_address = None
                    self.previous_hop_address = None
                    self.ctype = None
                    self.original_input_interface = None
                    self.output_interface_name = None
                    self.backup_tunnel_name = None
                    self.is_segment_routing = None

                    self.s2l_output_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite()
                    self.s2l_output_rewrite.parent = self
                    self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"

                    self.s2l = YList(self)
                    self.s2lsr_path = YList(self)
                    self._segment_path = lambda: "forwarding-output-label-rewrite" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[next-hop-address='" + str(self.next_hop_address) + "']" + "[previous-hop-address='" + str(self.previous_hop_address) + "']" + "[ctype='" + str(self.ctype) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/p2mp/forwarding-output-label-rewrites/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, ['tunnel_id', 'lsp_id', 'extended_tunnel_id', 'source_address', 'p2mp_id', 'destination_address', 'next_hop_address', 'previous_hop_address', 'ctype', 'original_input_interface', 'output_interface_name', 'backup_tunnel_name', 'is_segment_routing'], name, value)


                class S2lOutputRewrite(_Entity_):
                    """
                    Output rewrite shared between S2Ls
                    
                    .. attribute:: subfamily
                    
                    	Subfamily identifiers
                    	**type**\:  :py:class:`Subfamily <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily>`
                    
                    	**config**\: False
                    
                    .. attribute:: successful_rewrite
                    
                    	Successful rewrite details
                    	**type**\:  :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite>`
                    
                    	**config**\: False
                    
                    .. attribute:: failed_rewrite
                    
                    	Failed rewrite details
                    	**type**\:  :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite>`
                    
                    	**config**\: False
                    
                    .. attribute:: pending_rewrite
                    
                    	Pending rewrite details
                    	**type**\:  :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite, self).__init__()

                        self.yang_name = "s2l-output-rewrite"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("subfamily", ("subfamily", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily)), ("successful-rewrite", ("successful_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite)), ("failed-rewrite", ("failed_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite)), ("pending-rewrite", ("pending_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite))])
                        self._leafs = OrderedDict()

                        self.subfamily = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily()
                        self.subfamily.parent = self
                        self._children_name_map["subfamily"] = "subfamily"

                        self.successful_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite()
                        self.successful_rewrite.parent = self
                        self._children_name_map["successful_rewrite"] = "successful-rewrite"

                        self.failed_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite()
                        self.failed_rewrite.parent = self
                        self._children_name_map["failed_rewrite"] = "failed-rewrite"

                        self.pending_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite()
                        self.pending_rewrite.parent = self
                        self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        self._segment_path = lambda: "s2l-output-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite, [], name, value)


                    class Subfamily(_Entity_):
                        """
                        Subfamily identifiers
                        
                        .. attribute:: lsp_fec
                        
                        	LSP FEC
                        	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily, self).__init__()

                            self.yang_name = "subfamily"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec))])
                            self._leafs = OrderedDict([
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                            ])
                            self.next_hop_address = None
                            self.previous_hop_address = None
                            self.next_next_hop_address = None

                            self.lsp_fec = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                            self._segment_path = lambda: "subfamily"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily, ['next_hop_address', 'previous_hop_address', 'next_next_hop_address'], name, value)


                        class LspFec(_Entity_):
                            """
                            LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec, self).__init__()

                                self.yang_name = "lsp-fec"
                                self.yang_parent_name = "subfamily"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily']['meta_info']


                    class SuccessfulRewrite(_Entity_):
                        """
                        Successful rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite, self).__init__()

                            self.yang_name = "successful-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "successful-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "successful-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "successful-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite']['meta_info']


                    class FailedRewrite(_Entity_):
                        """
                        Failed rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite, self).__init__()

                            self.yang_name = "failed-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "failed-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "failed-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "failed-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite']['meta_info']


                    class PendingRewrite(_Entity_):
                        """
                        Pending rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite, self).__init__()

                            self.yang_name = "pending-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "pending-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "pending-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "pending-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite']['meta_info']


                class S2l(_Entity_):
                    """
                    Unique identifiers for the S2L sharing the
                    rewrite
                    
                    .. attribute:: destination_address
                    
                    	Destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_id
                    
                    	S2L Sub\-Group ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_original_id
                    
                    	S2L Sub\-Group Originator ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                            ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ])
                        self.destination_address = None
                        self.sub_group_id = None
                        self.sub_group_original_id = None
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l, ['destination_address', 'sub_group_id', 'sub_group_original_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l']['meta_info']


                class S2lsrPath(_Entity_):
                    """
                    Segment\-Routing Paths
                    
                    .. attribute:: is_primary
                    
                    	True if path is primary
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup
                    
                    	True if path is backup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing Interface Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: path_id
                    
                    	Path Identifier
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_path_id
                    
                    	Backup Path Identifier
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop
                    
                    	Next hop
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_labels_stack
                    
                    	Outgoing Labels Stack
                    	**type**\: list of  		 :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath, self).__init__()

                        self.yang_name = "s2lsr-path"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("outgoing-labels-stack", ("outgoing_labels_stack", MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack))])
                        self._leafs = OrderedDict([
                            ('is_primary', (YLeaf(YType.boolean, 'is-primary'), ['bool'])),
                            ('is_backup', (YLeaf(YType.boolean, 'is-backup'), ['bool'])),
                            ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                            ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                            ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                            ('next_hop', (YLeaf(YType.str, 'next-hop'), ['str'])),
                        ])
                        self.is_primary = None
                        self.is_backup = None
                        self.outgoing_interface = None
                        self.path_id = None
                        self.backup_path_id = None
                        self.next_hop = None

                        self.outgoing_labels_stack = YList(self)
                        self._segment_path = lambda: "s2lsr-path"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath, ['is_primary', 'is_backup', 'outgoing_interface', 'path_id', 'backup_path_id', 'next_hop'], name, value)


                    class OutgoingLabelsStack(_Entity_):
                        """
                        Outgoing Labels Stack
                        
                        .. attribute:: entry
                        
                        	Outgoing Labels Stack
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack, self).__init__()

                            self.yang_name = "outgoing-labels-stack"
                            self.yang_parent_name = "s2lsr-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "outgoing-labels-stack"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.P2mp.ForwardingOutputLabelRewrites']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.P2mp']['meta_info']


    class LspOutOfResources(_Entity_):
        """
        LSP OOR information
        
        .. attribute:: summary
        
        	LSP OOR Summary information
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.LspOutOfResources, self).__init__()

            self.yang_name = "lsp-out-of-resources"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsTe.LspOutOfResources.Summary))])
            self._leafs = OrderedDict()

            self.summary = MplsTe.LspOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._segment_path = lambda: "lsp-out-of-resources"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.LspOutOfResources, [], name, value)


        class Summary(_Entity_):
            """
            LSP OOR Summary information
            
            .. attribute:: transit_lsp_total_count
            
            	Number of all transit LSPs on the router
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: transit_lsp_unprotected_count
            
            	Number of unprotected transit LSPs on the router
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: lsp_oor_state
            
            	The current LSP OOR state
            	**type**\:  :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
            
            	**config**\: False
            
            .. attribute:: lsp_oor_timestamp
            
            	Timestamp when the OOR state last changed
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: lsp_oor_green_recovery_time
            
            	Time Remaining in Green Recovery State (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: lsp_oor_state_xr
            
            	Array of LSP OOR info per state
            	**type**\: list of  		 :py:class:`LspOorStateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary.LspOorStateXr>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.LspOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "lsp-out-of-resources"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("lsp-oor-state-xr", ("lsp_oor_state_xr", MplsTe.LspOutOfResources.Summary.LspOorStateXr))])
                self._leafs = OrderedDict([
                    ('transit_lsp_total_count', (YLeaf(YType.uint32, 'transit-lsp-total-count'), ['int'])),
                    ('transit_lsp_unprotected_count', (YLeaf(YType.uint32, 'transit-lsp-unprotected-count'), ['int'])),
                    ('lsp_oor_state', (YLeaf(YType.enumeration, 'lsp-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LspOorState', '')])),
                    ('lsp_oor_timestamp', (YLeaf(YType.uint32, 'lsp-oor-timestamp'), ['int'])),
                    ('lsp_oor_green_recovery_time', (YLeaf(YType.uint32, 'lsp-oor-green-recovery-time'), ['int'])),
                ])
                self.transit_lsp_total_count = None
                self.transit_lsp_unprotected_count = None
                self.lsp_oor_state = None
                self.lsp_oor_timestamp = None
                self.lsp_oor_green_recovery_time = None

                self.lsp_oor_state_xr = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.LspOutOfResources.Summary, ['transit_lsp_total_count', 'transit_lsp_unprotected_count', 'lsp_oor_state', 'lsp_oor_timestamp', 'lsp_oor_green_recovery_time'], name, value)


            class LspOorStateXr(_Entity_):
                """
                Array of LSP OOR info per state
                
                .. attribute:: statistics
                
                	LSP OOR Statistics
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics>`
                
                	**config**\: False
                
                .. attribute:: lsp_oor_state
                
                	The LSP\-OOR state that this information belongs to
                	**type**\:  :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
                
                	**config**\: False
                
                .. attribute:: threshold_transit_all
                
                	The number of transit LSPs that triggers OOR state transition
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: threshold_transit_unprotected
                
                	The number of unprotected transit LSPs that triggers OOR state transition
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: percentage
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green LSP OOR state is entered
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: minute
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the LSP OOR state
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.LspOutOfResources.Summary.LspOorStateXr, self).__init__()

                    self.yang_name = "lsp-oor-state-xr"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics))])
                    self._leafs = OrderedDict([
                        ('lsp_oor_state', (YLeaf(YType.enumeration, 'lsp-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LspOorState', '')])),
                        ('threshold_transit_all', (YLeaf(YType.uint32, 'threshold-transit-all'), ['int'])),
                        ('threshold_transit_unprotected', (YLeaf(YType.uint32, 'threshold-transit-unprotected'), ['int'])),
                        ('te_metric_penalty', (YLeaf(YType.uint32, 'te-metric-penalty'), ['int'])),
                        ('available_bw_percentage', (YLeaf(YType.uint32, 'available-bw-percentage'), ['int'])),
                        ('transition_duration', (YLeaf(YType.uint32, 'transition-duration'), ['int'])),
                        ('minimum_lsp_bandwidth', (YLeaf(YType.uint32, 'minimum-lsp-bandwidth'), ['int'])),
                        ('accept_reopt', (YLeaf(YType.boolean, 'accept-reopt'), ['bool'])),
                    ])
                    self.lsp_oor_state = None
                    self.threshold_transit_all = None
                    self.threshold_transit_unprotected = None
                    self.te_metric_penalty = None
                    self.available_bw_percentage = None
                    self.transition_duration = None
                    self.minimum_lsp_bandwidth = None
                    self.accept_reopt = None

                    self.statistics = MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._segment_path = lambda: "lsp-oor-state-xr"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.LspOutOfResources.Summary.LspOorStateXr, ['lsp_oor_state', 'threshold_transit_all', 'threshold_transit_unprotected', 'te_metric_penalty', 'available_bw_percentage', 'transition_duration', 'minimum_lsp_bandwidth', 'accept_reopt'], name, value)


                class Statistics(_Entity_):
                    """
                    LSP OOR Statistics
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "lsp-oor-state-xr"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                            ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                            ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                            ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                            ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                        ])
                        self.transitions = None
                        self.rejected_ls_ps_number = None
                        self.accepted_ls_ps_number = None
                        self.accepted_reopt_ls_ps_number = None
                        self.rejected_reopt_ls_ps_number = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/lsp-out-of-resources/summary/lsp-oor-state-xr/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics, ['transitions', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.LspOutOfResources.Summary.LspOorStateXr.Statistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.LspOutOfResources.Summary.LspOorStateXr']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.LspOutOfResources.Summary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.LspOutOfResources']['meta_info']


    class Bfd(_Entity_):
        """
        MPLS TE BFD Oper Info
        
        .. attribute:: head_infos
        
        	MPLS TE Head BFD Over LSP Table
        	**type**\:  :py:class:`HeadInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos>`
        
        	**config**\: False
        
        .. attribute:: links
        
        	MPLS TE BFD Info
        	**type**\:  :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links>`
        
        	**config**\: False
        
        .. attribute:: tail_infos
        
        	MPLS TE Tail BFD Over LSP Table
        	**type**\:  :py:class:`TailInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos>`
        
        	**config**\: False
        
        .. attribute:: summary
        
        	MPLS TE BFD Summary
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Summary>`
        
        	**config**\: False
        
        .. attribute:: counters
        
        	MPLS TE BFD Counters
        	**type**\:  :py:class:`Counters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.Bfd, self).__init__()

            self.yang_name = "bfd"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("head-infos", ("head_infos", MplsTe.Bfd.HeadInfos)), ("links", ("links", MplsTe.Bfd.Links)), ("tail-infos", ("tail_infos", MplsTe.Bfd.TailInfos)), ("summary", ("summary", MplsTe.Bfd.Summary)), ("counters", ("counters", MplsTe.Bfd.Counters))])
            self._leafs = OrderedDict()

            self.head_infos = MplsTe.Bfd.HeadInfos()
            self.head_infos.parent = self
            self._children_name_map["head_infos"] = "head-infos"

            self.links = MplsTe.Bfd.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"

            self.tail_infos = MplsTe.Bfd.TailInfos()
            self.tail_infos.parent = self
            self._children_name_map["tail_infos"] = "tail-infos"

            self.summary = MplsTe.Bfd.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.counters = MplsTe.Bfd.Counters()
            self.counters.parent = self
            self._children_name_map["counters"] = "counters"
            self._segment_path = lambda: "bfd"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.Bfd, [], name, value)


        class HeadInfos(_Entity_):
            """
            MPLS TE Head BFD Over LSP Table
            
            .. attribute:: head_info
            
            	MPLS TE Head End BFD Over LSP Info
            	**type**\: list of  		 :py:class:`HeadInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Bfd.HeadInfos, self).__init__()

                self.yang_name = "head-infos"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-info", ("head_info", MplsTe.Bfd.HeadInfos.HeadInfo))])
                self._leafs = OrderedDict()

                self.head_info = YList(self)
                self._segment_path = lambda: "head-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Bfd.HeadInfos, [], name, value)


            class HeadInfo(_Entity_):
                """
                MPLS TE Head End BFD Over LSP Info
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: current_lspbfd_info
                
                	Current LSP BFD Info
                	**type**\:  :py:class:`CurrentLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: standby_lspbfd_info
                
                	Standby LSP BFD Info
                	**type**\:  :py:class:`StandbyLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_lspbfd_info
                
                	Reoptimized LSP BFD Info
                	**type**\:  :py:class:`ReoptimizedLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lspbfd_type
                
                	LSP BFD type
                	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.HeadInfos.HeadInfo, self).__init__()

                    self.yang_name = "head-info"
                    self.yang_parent_name = "head-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("current-lspbfd-info", ("current_lspbfd_info", MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo)), ("standby-lspbfd-info", ("standby_lspbfd_info", MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo)), ("reoptimized-lspbfd-info", ("reoptimized_lspbfd_info", MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_name_xr', (YLeaf(YType.str, 'tunnel-name-xr'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                    ])
                    self.tunnel_name = None
                    self.tunnel_name_xr = None
                    self.destination_address = None
                    self.lspbfd_type = None

                    self.current_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                    self.current_lspbfd_info.parent = self
                    self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"

                    self.standby_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                    self.standby_lspbfd_info.parent = self
                    self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"

                    self.reoptimized_lspbfd_info = MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                    self.reoptimized_lspbfd_info.parent = self
                    self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                    self._segment_path = lambda: "head-info" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/head-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.HeadInfos.HeadInfo, ['tunnel_name', 'tunnel_name_xr', 'destination_address', 'lspbfd_type'], name, value)


                class CurrentLspbfdInfo(_Entity_):
                    """
                    Current LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__init__()

                        self.yang_name = "current-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "current-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo']['meta_info']


                class StandbyLspbfdInfo(_Entity_):
                    """
                    Standby LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__init__()

                        self.yang_name = "standby-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "standby-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo']['meta_info']


                class ReoptimizedLspbfdInfo(_Entity_):
                    """
                    Reoptimized LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__init__()

                        self.yang_name = "reoptimized-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "reoptimized-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.HeadInfos.HeadInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Bfd.HeadInfos']['meta_info']


        class Links(_Entity_):
            """
            MPLS TE BFD Info
            
            .. attribute:: link
            
            	MPLS TE BFD Info
            	**type**\: list of  		 :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links.Link>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Bfd.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link", ("link", MplsTe.Bfd.Links.Link))])
                self._leafs = OrderedDict()

                self.link = YList(self)
                self._segment_path = lambda: "links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Bfd.Links, [], name, value)


            class Link(_Entity_):
                """
                MPLS TE BFD Info
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: neighbor
                
                	Neighbors of the specified link id
                	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Links.Link.Neighbor>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsTe.Bfd.Links.Link.Neighbor))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ])
                    self.interface_name = None

                    self.neighbor = YList(self)
                    self._segment_path = lambda: "link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.Links.Link, ['interface_name'], name, value)


                class Neighbor(_Entity_):
                    """
                    Neighbors of the specified link id
                    
                    .. attribute:: neighbor_address
                    
                    	The neighbor's IP address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_bfd_up
                    
                    	TRUE if the BFD session is Up on this link
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Bfd.Links.Link.Neighbor, self).__init__()

                        self.yang_name = "neighbor"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                            ('is_bfd_up', (YLeaf(YType.boolean, 'is-bfd-up'), ['bool'])),
                        ])
                        self.neighbor_address = None
                        self.is_bfd_up = None
                        self._segment_path = lambda: "neighbor"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Bfd.Links.Link.Neighbor, ['neighbor_address', 'is_bfd_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Bfd.Links.Link.Neighbor']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.Links.Link']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Bfd.Links']['meta_info']


        class TailInfos(_Entity_):
            """
            MPLS TE Tail BFD Over LSP Table
            
            .. attribute:: tail_info
            
            	MPLS TE Tail End BFD Over LSP Info
            	**type**\: list of  		 :py:class:`TailInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Bfd.TailInfos, self).__init__()

                self.yang_name = "tail-infos"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tail-info", ("tail_info", MplsTe.Bfd.TailInfos.TailInfo))])
                self._leafs = OrderedDict()

                self.tail_info = YList(self)
                self._segment_path = lambda: "tail-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Bfd.TailInfos, [], name, value)


            class TailInfo(_Entity_):
                """
                MPLS TE Tail End BFD Over LSP Info
                
                .. attribute:: source_address
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: p2mp_id
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bfd_session_state
                
                	BFD Session State
                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.TailInfos.TailInfo, self).__init__()

                    self.yang_name = "tail-info"
                    self.yang_parent_name = "tail-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTe.Bfd.TailInfos.TailInfo.LspFec))])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                    ])
                    self.source_address = None
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.destination_address = None
                    self.extended_tunnel_id = None
                    self.ctype = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.bfd_session_state = None

                    self.lsp_fec = MplsTe.Bfd.TailInfos.TailInfo.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._segment_path = lambda: "tail-info"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.TailInfos.TailInfo, ['source_address', 'tunnel_id', 'lsp_id', 'destination_address', 'extended_tunnel_id', 'ctype', 'p2mp_id', 'signaled_name', 'bfd_session_state'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Bfd.TailInfos.TailInfo.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tail-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/tail-info/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Bfd.TailInfos.TailInfo.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/tail-infos/tail-info/lsp-fec/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Bfd.TailInfos.TailInfo.LspFec']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.TailInfos.TailInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Bfd.TailInfos']['meta_info']


        class Summary(_Entity_):
            """
            MPLS TE BFD Summary
            
            .. attribute:: tunnel_count_total
            
            	Total number of tunnel interface
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_bfd_enabled
            
            	Number of tunnel interface with BFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_session_up
            
            	Number of tunnel with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_sbfd_enabled
            
            	Number of tunnel interface with SBFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_sbfd_session_up
            
            	Number of tunnel with SBFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_session_created
            
            	Number of head end LSP with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_up
            
            	Number of head end LSP with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tail_lsp_count_session_created
            
            	Number of tail end LSP with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tail_lsp_count_session_up
            
            	Number of tail end LSP with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_sbfd_session_created
            
            	Number of head end LSP with SBFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_sbfd_up
            
            	Number of head end LSP with SBFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_bfd_enabled
            
            	Number of link with BFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_session_created
            
            	Number of link with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_session_up
            
            	Number of link with BFD session in state Up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Bfd.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tunnel_count_total', (YLeaf(YType.uint16, 'tunnel-count-total'), ['int'])),
                    ('tunnel_count_bfd_enabled', (YLeaf(YType.uint16, 'tunnel-count-bfd-enabled'), ['int'])),
                    ('tunnel_count_session_up', (YLeaf(YType.uint16, 'tunnel-count-session-up'), ['int'])),
                    ('tunnel_count_sbfd_enabled', (YLeaf(YType.uint16, 'tunnel-count-sbfd-enabled'), ['int'])),
                    ('tunnel_count_sbfd_session_up', (YLeaf(YType.uint16, 'tunnel-count-sbfd-session-up'), ['int'])),
                    ('head_lsp_count_session_created', (YLeaf(YType.uint16, 'head-lsp-count-session-created'), ['int'])),
                    ('head_lsp_count_up', (YLeaf(YType.uint16, 'head-lsp-count-up'), ['int'])),
                    ('tail_lsp_count_session_created', (YLeaf(YType.uint16, 'tail-lsp-count-session-created'), ['int'])),
                    ('tail_lsp_count_session_up', (YLeaf(YType.uint16, 'tail-lsp-count-session-up'), ['int'])),
                    ('head_lsp_count_sbfd_session_created', (YLeaf(YType.uint16, 'head-lsp-count-sbfd-session-created'), ['int'])),
                    ('head_lsp_count_sbfd_up', (YLeaf(YType.uint16, 'head-lsp-count-sbfd-up'), ['int'])),
                    ('link_count_bfd_enabled', (YLeaf(YType.uint16, 'link-count-bfd-enabled'), ['int'])),
                    ('link_count_session_created', (YLeaf(YType.uint16, 'link-count-session-created'), ['int'])),
                    ('link_count_session_up', (YLeaf(YType.uint16, 'link-count-session-up'), ['int'])),
                ])
                self.tunnel_count_total = None
                self.tunnel_count_bfd_enabled = None
                self.tunnel_count_session_up = None
                self.tunnel_count_sbfd_enabled = None
                self.tunnel_count_sbfd_session_up = None
                self.head_lsp_count_session_created = None
                self.head_lsp_count_up = None
                self.tail_lsp_count_session_created = None
                self.tail_lsp_count_session_up = None
                self.head_lsp_count_sbfd_session_created = None
                self.head_lsp_count_sbfd_up = None
                self.link_count_bfd_enabled = None
                self.link_count_session_created = None
                self.link_count_session_up = None
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Bfd.Summary, ['tunnel_count_total', 'tunnel_count_bfd_enabled', 'tunnel_count_session_up', 'tunnel_count_sbfd_enabled', 'tunnel_count_sbfd_session_up', 'head_lsp_count_session_created', 'head_lsp_count_up', 'tail_lsp_count_session_created', 'tail_lsp_count_session_up', 'head_lsp_count_sbfd_session_created', 'head_lsp_count_sbfd_up', 'link_count_bfd_enabled', 'link_count_session_created', 'link_count_session_up'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Bfd.Summary']['meta_info']


        class Counters(_Entity_):
            """
            MPLS TE BFD Counters
            
            .. attribute:: bfd_over_lsp_head_counters
            
            	BFD over Head\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`BfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfdOverLspHeadCounters>`
            
            	**config**\: False
            
            .. attribute:: sbfd_over_lsp_head_counters
            
            	SBFD over Head\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`SbfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.SbfdOverLspHeadCounters>`
            
            	**config**\: False
            
            .. attribute:: bfd_over_lsp_tail_counters
            
            	BFD over Tail\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`BfdOverLspTailCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfdOverLspTailCounters>`
            
            	**config**\: False
            
            .. attribute:: bf_do_lm_counters
            
            	BFD over Links Cumulative Counters
            	**type**\:  :py:class:`BfDoLmCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Bfd.Counters.BfDoLmCounters>`
            
            	**config**\: False
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Bfd.Counters, self).__init__()

                self.yang_name = "counters"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bfd-over-lsp-head-counters", ("bfd_over_lsp_head_counters", MplsTe.Bfd.Counters.BfdOverLspHeadCounters)), ("sbfd-over-lsp-head-counters", ("sbfd_over_lsp_head_counters", MplsTe.Bfd.Counters.SbfdOverLspHeadCounters)), ("bfd-over-lsp-tail-counters", ("bfd_over_lsp_tail_counters", MplsTe.Bfd.Counters.BfdOverLspTailCounters)), ("bf-do-lm-counters", ("bf_do_lm_counters", MplsTe.Bfd.Counters.BfDoLmCounters))])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                ])
                self.last_cleared_timestamp = None

                self.bfd_over_lsp_head_counters = MplsTe.Bfd.Counters.BfdOverLspHeadCounters()
                self.bfd_over_lsp_head_counters.parent = self
                self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"

                self.sbfd_over_lsp_head_counters = MplsTe.Bfd.Counters.SbfdOverLspHeadCounters()
                self.sbfd_over_lsp_head_counters.parent = self
                self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"

                self.bfd_over_lsp_tail_counters = MplsTe.Bfd.Counters.BfdOverLspTailCounters()
                self.bfd_over_lsp_tail_counters.parent = self
                self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"

                self.bf_do_lm_counters = MplsTe.Bfd.Counters.BfDoLmCounters()
                self.bf_do_lm_counters.parent = self
                self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                self._segment_path = lambda: "counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Bfd.Counters, ['last_cleared_timestamp'], name, value)


            class BfdOverLspHeadCounters(_Entity_):
                """
                BFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.Counters.BfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_create_timeout_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bfd-over-lsp-head-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.Counters.BfdOverLspHeadCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.Counters.BfdOverLspHeadCounters']['meta_info']


            class SbfdOverLspHeadCounters(_Entity_):
                """
                SBFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.Counters.SbfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "sbfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_create_timeout_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "sbfd-over-lsp-head-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.Counters.SbfdOverLspHeadCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.Counters.SbfdOverLspHeadCounters']['meta_info']


            class BfdOverLspTailCounters(_Entity_):
                """
                BFD over Tail\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.Counters.BfdOverLspTailCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-tail-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bfd-over-lsp-tail-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.Counters.BfdOverLspTailCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.Counters.BfdOverLspTailCounters']['meta_info']


            class BfDoLmCounters(_Entity_):
                """
                BFD over Links Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Bfd.Counters.BfDoLmCounters, self).__init__()

                    self.yang_name = "bf-do-lm-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bf-do-lm-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Bfd.Counters.BfDoLmCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Bfd.Counters.BfDoLmCounters']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Bfd.Counters']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.Bfd']['meta_info']


    class Nsr(_Entity_):
        """
        MPLS TE NSR information
        
        .. attribute:: status
        
        	MPLS TE NSR Status information
        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status>`
        
        	**config**\: False
        
        .. attribute:: detail
        
        	MPLS TE NSR Status information
        	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.Nsr, self).__init__()

            self.yang_name = "nsr"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("status", ("status", MplsTe.Nsr.Status)), ("detail", ("detail", MplsTe.Nsr.Detail))])
            self._leafs = OrderedDict()

            self.status = MplsTe.Nsr.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"

            self.detail = MplsTe.Nsr.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._segment_path = lambda: "nsr"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.Nsr, [], name, value)


        class Status(_Entity_):
            """
            MPLS TE NSR Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Nsr.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "nsr"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTe.Nsr.Status.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTe.Nsr.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "status"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Nsr.Status, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Nsr.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Nsr.Status.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Nsr.Status']['meta_info']


        class Detail(_Entity_):
            """
            MPLS TE NSR Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.Nsr.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "nsr"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTe.Nsr.Detail.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTe.Nsr.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "detail"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.Nsr.Detail, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.Nsr.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.Nsr.Detail.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.Nsr.Detail']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.Nsr']['meta_info']


    class AutoTunnelServices(_Entity_):
        """
        MPLS TE Auto Tunnel Services
        
        .. attribute:: sr_policy_entries
        
        	MPLS TE SR Policy Context table 
        	**type**\:  :py:class:`SrPolicyEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AutoTunnelServices, self).__init__()

            self.yang_name = "auto-tunnel-services"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("sr-policy-entries", ("sr_policy_entries", MplsTe.AutoTunnelServices.SrPolicyEntries))])
            self._leafs = OrderedDict()

            self.sr_policy_entries = MplsTe.AutoTunnelServices.SrPolicyEntries()
            self.sr_policy_entries.parent = self
            self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
            self._segment_path = lambda: "auto-tunnel-services"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AutoTunnelServices, [], name, value)


        class SrPolicyEntries(_Entity_):
            """
            MPLS TE SR Policy Context table 
            
            .. attribute:: sr_policy_entry
            
            	MPLS TE SR Policy information
            	**type**\: list of  		 :py:class:`SrPolicyEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AutoTunnelServices.SrPolicyEntries, self).__init__()

                self.yang_name = "sr-policy-entries"
                self.yang_parent_name = "auto-tunnel-services"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sr-policy-entry", ("sr_policy_entry", MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry))])
                self._leafs = OrderedDict()

                self.sr_policy_entry = YList(self)
                self._segment_path = lambda: "sr-policy-entries"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel-services/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries, [], name, value)


            class SrPolicyEntry(_Entity_):
                """
                MPLS TE SR Policy information
                
                .. attribute:: client_id  (key)
                
                	Client ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: color  (key)
                
                	Color
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_point  (key)
                
                	End Point
                	**type**\: union of the below types:
                
                		**type**\: str
                
                			**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                		**type**\: str
                
                			**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: distinguisher  (key)
                
                	SR Policy Distinguisher Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_point_xr
                
                	End Point
                	**type**\:  :py:class:`EndPointXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr>`
                
                	**config**\: False
                
                .. attribute:: sr_policy_id
                
                	SR Policy ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: policy_active
                
                	Policy Active
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: client_id_xr
                
                	Client ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: client_name
                
                	Client Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: color_xr
                
                	Color
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: distinguisher_xr
                
                	SR Policy Distinguisher value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: ipv6_caps
                
                	IPv6 Capsulation
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_sid_context_id
                
                	Binding SID Context ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: requested_binding_sid
                
                	Requested Binding SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: binding_sid_request_pending
                
                	Binding SID Request Pending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: allocated_binding_sid
                
                	Allocated Binding SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: rewrite_request_pending
                
                	Rewrite Requeste Pending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rewrite_done
                
                	Rewrite Done
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_stale
                
                	Is Stale
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_synced
                
                	Is Synced
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: notify_time
                
                	Notify Time
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: notify_state_is_active
                
                	Notify State Is Active
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: creation_time
                
                	SR policy structure creation timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                .. attribute:: explicit_path
                
                	Explicit Paths
                	**type**\: list of  		 :py:class:`ExplicitPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__init__()

                    self.yang_name = "sr-policy-entry"
                    self.yang_parent_name = "sr-policy-entries"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['client_id','color','end_point','distinguisher']
                    self._child_classes = OrderedDict([("end-point-xr", ("end_point_xr", MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr)), ("explicit-path", ("explicit_path", MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath))])
                    self._leafs = OrderedDict([
                        ('client_id', (YLeaf(YType.uint32, 'client-id'), ['int'])),
                        ('color', (YLeaf(YType.uint32, 'color'), ['int'])),
                        ('end_point', (YLeaf(YType.str, 'end-point'), ['str','str'])),
                        ('distinguisher', (YLeaf(YType.uint32, 'distinguisher'), ['int'])),
                        ('sr_policy_id', (YLeaf(YType.uint32, 'sr-policy-id'), ['int'])),
                        ('policy_active', (YLeaf(YType.boolean, 'policy-active'), ['bool'])),
                        ('client_id_xr', (YLeaf(YType.uint32, 'client-id-xr'), ['int'])),
                        ('client_name', (YLeaf(YType.str, 'client-name'), ['str'])),
                        ('color_xr', (YLeaf(YType.uint32, 'color-xr'), ['int'])),
                        ('distinguisher_xr', (YLeaf(YType.uint32, 'distinguisher-xr'), ['int'])),
                        ('ipv6_caps', (YLeaf(YType.boolean, 'ipv6-caps'), ['bool'])),
                        ('binding_sid_context_id', (YLeaf(YType.uint32, 'binding-sid-context-id'), ['int'])),
                        ('requested_binding_sid', (YLeaf(YType.uint32, 'requested-binding-sid'), ['int'])),
                        ('binding_sid_request_pending', (YLeaf(YType.boolean, 'binding-sid-request-pending'), ['bool'])),
                        ('allocated_binding_sid', (YLeaf(YType.uint32, 'allocated-binding-sid'), ['int'])),
                        ('rewrite_request_pending', (YLeaf(YType.boolean, 'rewrite-request-pending'), ['bool'])),
                        ('rewrite_done', (YLeaf(YType.boolean, 'rewrite-done'), ['bool'])),
                        ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                        ('is_synced', (YLeaf(YType.boolean, 'is-synced'), ['bool'])),
                        ('notify_time', (YLeaf(YType.uint32, 'notify-time'), ['int'])),
                        ('notify_state_is_active', (YLeaf(YType.boolean, 'notify-state-is-active'), ['bool'])),
                        ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                    ])
                    self.client_id = None
                    self.color = None
                    self.end_point = None
                    self.distinguisher = None
                    self.sr_policy_id = None
                    self.policy_active = None
                    self.client_id_xr = None
                    self.client_name = None
                    self.color_xr = None
                    self.distinguisher_xr = None
                    self.ipv6_caps = None
                    self.binding_sid_context_id = None
                    self.requested_binding_sid = None
                    self.binding_sid_request_pending = None
                    self.allocated_binding_sid = None
                    self.rewrite_request_pending = None
                    self.rewrite_done = None
                    self.is_stale = None
                    self.is_synced = None
                    self.notify_time = None
                    self.notify_state_is_active = None
                    self.creation_time = None

                    self.end_point_xr = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                    self.end_point_xr.parent = self
                    self._children_name_map["end_point_xr"] = "end-point-xr"

                    self.explicit_path = YList(self)
                    self._segment_path = lambda: "sr-policy-entry" + "[client-id='" + str(self.client_id) + "']" + "[color='" + str(self.color) + "']" + "[end-point='" + str(self.end_point) + "']" + "[distinguisher='" + str(self.distinguisher) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/auto-tunnel-services/sr-policy-entries/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, ['client_id', 'color', 'end_point', 'distinguisher', 'sr_policy_id', 'policy_active', 'client_id_xr', 'client_name', 'color_xr', 'distinguisher_xr', 'ipv6_caps', 'binding_sid_context_id', 'requested_binding_sid', 'binding_sid_request_pending', 'allocated_binding_sid', 'rewrite_request_pending', 'rewrite_done', 'is_stale', 'is_synced', 'notify_time', 'notify_state_is_active', 'creation_time'], name, value)


                class EndPointXr(_Entity_):
                    """
                    End Point
                    
                    .. attribute:: address_family_type
                    
                    	AddressFamilyType
                    	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv6_address
                    
                    	IPv6 Address
                    	**type**\: str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__init__()

                        self.yang_name = "end-point-xr"
                        self.yang_parent_name = "sr-policy-entry"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('address_family_type', (YLeaf(YType.enumeration, 'address-family-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv6_address', (YLeaf(YType.str, 'ipv6-address'), ['str'])),
                        ])
                        self.address_family_type = None
                        self.ipv4_address = None
                        self.ipv6_address = None
                        self._segment_path = lambda: "end-point-xr"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, ['address_family_type', 'ipv4_address', 'ipv6_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr']['meta_info']


                class ExplicitPath(_Entity_):
                    """
                    Explicit Paths
                    
                    .. attribute:: tunnel_info
                    
                    	Auto tunnel info
                    	**type**\:  :py:class:`TunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: context_id
                    
                    	Explicit Path Context ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_weight
                    
                    	Path Weight
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_stale
                    
                    	Is Stale
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_synced
                    
                    	Is Synced
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: programmed_in_fib
                    
                    	Programmed in FIB
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hops
                    
                    	Path Hops
                    	**type**\: list of  		 :py:class:`Hops <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__init__()

                        self.yang_name = "explicit-path"
                        self.yang_parent_name = "sr-policy-entry"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-info", ("tunnel_info", MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo)), ("hops", ("hops", MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops))])
                        self._leafs = OrderedDict([
                            ('context_id', (YLeaf(YType.uint32, 'context-id'), ['int'])),
                            ('path_weight', (YLeaf(YType.uint32, 'path-weight'), ['int'])),
                            ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                            ('is_synced', (YLeaf(YType.boolean, 'is-synced'), ['bool'])),
                            ('programmed_in_fib', (YLeaf(YType.boolean, 'programmed-in-fib'), ['bool'])),
                        ])
                        self.context_id = None
                        self.path_weight = None
                        self.is_stale = None
                        self.is_synced = None
                        self.programmed_in_fib = None

                        self.tunnel_info = MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                        self.tunnel_info.parent = self
                        self._children_name_map["tunnel_info"] = "tunnel-info"

                        self.hops = YList(self)
                        self._segment_path = lambda: "explicit-path"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, ['context_id', 'path_weight', 'is_stale', 'is_synced', 'programmed_in_fib'], name, value)


                    class TunnelInfo(_Entity_):
                        """
                        Auto tunnel info
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_up
                        
                        	Tunnel Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ipv6_caps
                        
                        	IPv6 Capsulation
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__init__()

                            self.yang_name = "tunnel-info"
                            self.yang_parent_name = "explicit-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                                ('tunnel_up', (YLeaf(YType.boolean, 'tunnel-up'), ['bool'])),
                                ('ipv6_caps', (YLeaf(YType.boolean, 'ipv6-caps'), ['bool'])),
                            ])
                            self.tunnel_id = None
                            self.tunnel_up = None
                            self.ipv6_caps = None
                            self._segment_path = lambda: "tunnel-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, ['tunnel_id', 'tunnel_up', 'ipv6_caps'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo']['meta_info']


                    class Hops(_Entity_):
                        """
                        Path Hops
                        
                        .. attribute:: hop_type
                        
                        	Hop Type
                        	**type**\:  :py:class:`TeAutoTunExpPathHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutoTunExpPathHop>`
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 Address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__init__()

                            self.yang_name = "hops"
                            self.yang_parent_name = "explicit-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hop_type', (YLeaf(YType.enumeration, 'hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutoTunExpPathHop', '')])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ])
                            self.hop_type = None
                            self.ipv4_address = None
                            self.mpls_label = None
                            self._segment_path = lambda: "hops"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, ['hop_type', 'ipv4_address', 'mpls_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AutoTunnelServices.SrPolicyEntries']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AutoTunnelServices']['meta_info']


    class AffinityMap(_Entity_):
        """
        Affinity name to value mapping
        
        .. attribute:: affinity_map_array
        
        	Affinity map array
        	**type**\: list of  		 :py:class:`AffinityMapArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap.AffinityMapArray>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.AffinityMap, self).__init__()

            self.yang_name = "affinity-map"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("affinity-map-array", ("affinity_map_array", MplsTe.AffinityMap.AffinityMapArray))])
            self._leafs = OrderedDict()

            self.affinity_map_array = YList(self)
            self._segment_path = lambda: "affinity-map"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.AffinityMap, [], name, value)


        class AffinityMapArray(_Entity_):
            """
            Affinity map array
            
            .. attribute:: affinity_name
            
            	Affinity name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: affinity_value
            
            	Affinity value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: affinity_bit_position
            
            	Affinity bit position
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: affinity_table_id
            
            	Affinity table id
            	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
            
            	**config**\: False
            
            .. attribute:: affinity_extended_value
            
            	EAG value
            	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.AffinityMap.AffinityMapArray, self).__init__()

                self.yang_name = "affinity-map-array"
                self.yang_parent_name = "affinity-map"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue))])
                self._leafs = OrderedDict([
                    ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                    ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                    ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                    ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                ])
                self.affinity_name = None
                self.affinity_value = None
                self.affinity_bit_position = None
                self.affinity_table_id = None

                self.affinity_extended_value = YList(self)
                self._segment_path = lambda: "affinity-map-array"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/affinity-map/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.AffinityMap.AffinityMapArray, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


            class AffinityExtendedValue(_Entity_):
                """
                EAG value
                
                .. attribute:: entry
                
                	EAG value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__init__()

                    self.yang_name = "affinity-extended-value"
                    self.yang_parent_name = "affinity-map-array"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "affinity-extended-value"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/affinity-map/affinity-map-array/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.AffinityMap.AffinityMapArray.AffinityExtendedValue']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.AffinityMap.AffinityMapArray']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.AffinityMap']['meta_info']


    class TopologyBriefs(_Entity_):
        """
        MPLS\-TE topology brief table
        
        .. attribute:: topology_brief
        
        	A node in MPLS\-TE topoogy brief table
        	**type**\: list of  		 :py:class:`TopologyBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTe.TopologyBriefs, self).__init__()

            self.yang_name = "topology-briefs"
            self.yang_parent_name = "mpls-te"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("topology-brief", ("topology_brief", MplsTe.TopologyBriefs.TopologyBrief))])
            self._leafs = OrderedDict()

            self.topology_brief = YList(self)
            self._segment_path = lambda: "topology-briefs"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTe.TopologyBriefs, [], name, value)


        class TopologyBrief(_Entity_):
            """
            A node in MPLS\-TE topoogy brief table
            
            .. attribute:: protocol  (key)
            
            	IGP protocol type
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: igp_id  (key)
            
            	IGP instance
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: area  (key)
            
            	IGP area
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: topology_node_type  (key)
            
            	Node type
            	**type**\:  :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            	**config**\: False
            
            .. attribute:: igp_node_id  (key)
            
            	IGP Node ID
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:  :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg>`
            
            	**config**\: False
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of  		 :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTe.TopologyBriefs.TopologyBrief, self).__init__()

                self.yang_name = "topology-brief"
                self.yang_parent_name = "topology-briefs"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','igp_id','area','topology_node_type','igp_node_id']
                self._child_classes = OrderedDict([("topology-node-sid-and-srbg", ("topology_node_sid_and_srbg", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg)), ("topology-node-link", ("topology_node_link", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                    ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                    ('topology_node_type', (YLeaf(YType.enumeration, 'topology-node-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeNode', '')])),
                    ('igp_node_id', (YLeaf(YType.str, 'igp-node-id'), ['str'])),
                    ('topology_node_te_router_id', (YLeaf(YType.str, 'topology-node-te-router-id'), ['str'])),
                    ('topology_node_overloaded', (YLeaf(YType.boolean, 'topology-node-overloaded'), ['bool'])),
                ])
                self.protocol = None
                self.igp_id = None
                self.area = None
                self.topology_node_type = None
                self.igp_node_id = None
                self.topology_node_te_router_id = None
                self.topology_node_overloaded = None

                self.topology_node_sid_and_srbg = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"

                self.topology_node_link = YList(self)
                self._segment_path = lambda: "topology-brief" + "[protocol='" + str(self.protocol) + "']" + "[igp-id='" + str(self.igp_id) + "']" + "[area='" + str(self.area) + "']" + "[topology-node-type='" + str(self.topology_node_type) + "']" + "[igp-node-id='" + str(self.igp_node_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te/topology-briefs/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief, ['protocol', 'igp_id', 'area', 'topology_node_type', 'igp_node_id', 'topology_node_te_router_id', 'topology_node_overloaded'], name, value)


            class TopologyNodeSidAndSrbg(_Entity_):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                        ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                        ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                        ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                    ])
                    self.segment_id = None
                    self.segment_id_local_absolute_value = None
                    self.srgb_start = None
                    self.srgb_size = None
                    self._segment_path = lambda: "topology-node-sid-and-srbg"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg']['meta_info']


            class TopologyNodeLink(_Entity_):
                """
                This node's link information
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:  :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth>`
                
                	**config**\: False
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: min_max_delay
                
                	Minimum and maximum measured link delay
                	**type**\:  :py:class:`MinMaxDelay <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay>`
                
                	**config**\: False
                
                .. attribute:: loss
                
                	Link Loss
                	**type**\:  :py:class:`Loss <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss>`
                
                	**config**\: False
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:  :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                	**config**\: False
                
                .. attribute:: delay_variation
                
                	Delay Variation
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: residual_bandwidth
                
                	Residual Bandwidth (kbytes per seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Available Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: utilized_bandwidth
                
                	Utilized Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of  		 :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of  		 :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("topology-link-bandwidth", ("topology_link_bandwidth", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth)), ("odu-link-capabilities", ("odu_link_capabilities", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities)), ("min-max-delay", ("min_max_delay", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay)), ("loss", ("loss", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss)), ("topology-link-extended-affinity-bit", ("topology_link_extended_affinity_bit", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup)), ("adjacency-sid", ("adjacency_sid", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid))])
                    self._leafs = OrderedDict([
                        ('topology_link_type', (YLeaf(YType.enumeration, 'topology-link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('topology_link_interface_address', (YLeaf(YType.str, 'topology-link-interface-address'), ['str'])),
                        ('topology_link_interface_id', (YLeaf(YType.uint32, 'topology-link-interface-id'), ['int'])),
                        ('topology_link_neighbor_address', (YLeaf(YType.str, 'topology-link-neighbor-address'), ['str'])),
                        ('topology_link_neighbor_id', (YLeaf(YType.uint32, 'topology-link-neighbor-id'), ['int'])),
                        ('topology_link_neighbor_system_id', (YLeaf(YType.str, 'topology-link-neighbor-system-id'), ['str'])),
                        ('topology_link_neighbor_node_id', (YLeaf(YType.uint32, 'topology-link-neighbor-node-id'), ['int'])),
                        ('topology_link_neighbor_generation', (YLeaf(YType.uint32, 'topology-link-neighbor-generation'), ['int'])),
                        ('topology_link_fragment_id', (YLeaf(YType.uint32, 'topology-link-fragment-id'), ['int'])),
                        ('topology_link_te_metric', (YLeaf(YType.uint32, 'topology-link-te-metric'), ['int'])),
                        ('topology_link_igp_metric', (YLeaf(YType.uint32, 'topology-link-igp-metric'), ['int'])),
                        ('topology_link_uni_delay', (YLeaf(YType.uint32, 'topology-link-uni-delay'), ['int'])),
                        ('topology_link_affinity_bits', (YLeaf(YType.uint32, 'topology-link-affinity-bits'), ['int'])),
                        ('topology_link_switching_capability', (YLeaf(YType.uint8, 'topology-link-switching-capability'), ['int'])),
                        ('topology_link_encoding', (YLeaf(YType.uint8, 'topology-link-encoding'), ['int'])),
                        ('topology_link_bandwidth_model', (YLeaf(YType.enumeration, 'topology-link-bandwidth-model'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLibBwModel', '')])),
                        ('delay_variation', (YLeaf(YType.uint32, 'delay-variation'), ['int'])),
                        ('residual_bandwidth', (YLeaf(YType.uint32, 'residual-bandwidth'), ['int'])),
                        ('available_bandwidth', (YLeaf(YType.uint32, 'available-bandwidth'), ['int'])),
                        ('utilized_bandwidth', (YLeaf(YType.uint32, 'utilized-bandwidth'), ['int'])),
                    ])
                    self.topology_link_type = None
                    self.topology_link_interface_address = None
                    self.topology_link_interface_id = None
                    self.topology_link_neighbor_address = None
                    self.topology_link_neighbor_id = None
                    self.topology_link_neighbor_system_id = None
                    self.topology_link_neighbor_node_id = None
                    self.topology_link_neighbor_generation = None
                    self.topology_link_fragment_id = None
                    self.topology_link_te_metric = None
                    self.topology_link_igp_metric = None
                    self.topology_link_uni_delay = None
                    self.topology_link_affinity_bits = None
                    self.topology_link_switching_capability = None
                    self.topology_link_encoding = None
                    self.topology_link_bandwidth_model = None
                    self.delay_variation = None
                    self.residual_bandwidth = None
                    self.available_bandwidth = None
                    self.utilized_bandwidth = None

                    self.topology_link_bandwidth = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"

                    self.odu_link_capabilities = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.min_max_delay = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay()
                    self.min_max_delay.parent = self
                    self._children_name_map["min_max_delay"] = "min-max-delay"

                    self.loss = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss()
                    self.loss.parent = self
                    self._children_name_map["loss"] = "loss"

                    self.topology_link_extended_affinity_bit = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.adjacency_sid = YList(self)
                    self._segment_path = lambda: "topology-node-link"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink, ['topology_link_type', 'topology_link_interface_address', 'topology_link_interface_id', 'topology_link_neighbor_address', 'topology_link_neighbor_id', 'topology_link_neighbor_system_id', 'topology_link_neighbor_node_id', 'topology_link_neighbor_generation', 'topology_link_fragment_id', 'topology_link_te_metric', 'topology_link_igp_metric', 'topology_link_uni_delay', 'topology_link_affinity_bits', 'topology_link_switching_capability', 'topology_link_encoding', 'topology_link_bandwidth_model', 'delay_variation', 'residual_bandwidth', 'available_bandwidth', 'utilized_bandwidth'], name, value)


                class TopologyLinkBandwidth(_Entity_):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("topology-link-bandwidth-prestandard", ("topology_link_bandwidth_prestandard", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard)), ("topology-link-bandwidth-standard", ("topology_link_bandwidth_standard", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard))])
                        self._leafs = OrderedDict([
                            ('bandwidth_migration_mode', (YLeaf(YType.enumeration, 'bandwidth-migration-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.bandwidth_migration_mode = None

                        self.topology_link_bandwidth_prestandard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"

                        self.topology_link_bandwidth_standard = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._segment_path = lambda: "topology-link-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, ['bandwidth_migration_mode'], name, value)


                    class TopologyLinkBandwidthPrestandard(_Entity_):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-detail", ("topology_link_prestandard_bandwidth_detail", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail))])
                            self._leafs = OrderedDict([
                                ('topology_link_prestandard_bandwidth_physical', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-physical'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_global', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-global'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_subpool', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-subpool'), ['int'])),
                            ])
                            self.topology_link_prestandard_bandwidth_physical = None
                            self.topology_link_prestandard_bandwidth_reservation_global = None
                            self.topology_link_prestandard_bandwidth_reservation_subpool = None

                            self.topology_link_prestandard_bandwidth_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-prestandard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, ['topology_link_prestandard_bandwidth_physical', 'topology_link_prestandard_bandwidth_reservation_global', 'topology_link_prestandard_bandwidth_reservation_subpool'], name, value)


                        class TopologyLinkPrestandardBandwidthDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-allocated", ("topology_link_prestandard_bandwidth_allocated", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated)), ("topology-link-prestandard-bandwidth-available-global", ("topology_link_prestandard_bandwidth_available_global", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal)), ("topology-link-prestandard-bandwidth-available-subpool", ("topology_link_prestandard_bandwidth_available_subpool", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool))])
                                self._leafs = OrderedDict()

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)
                                self._segment_path = lambda: "topology-link-prestandard-bandwidth-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, [], name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(_Entity_):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(_Entity_):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-global"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(_Entity_):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-subpool"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard']['meta_info']


                    class TopologyLinkBandwidthStandard(_Entity_):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topo-link-std-bw-detail", ("topo_link_std_bw_detail", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail))])
                            self._leafs = OrderedDict([
                                ('topo_link_std_bw_physical', (YLeaf(YType.uint32, 'topo-link-std-bw-physical'), ['int'])),
                                ('topo_link_std_bw_res_max', (YLeaf(YType.uint32, 'topo-link-std-bw-res-max'), ['int'])),
                                ('topo_link_std_bw_res_pool0', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool0'), ['int'])),
                                ('topo_link_std_bw_res_pool1', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool1'), ['int'])),
                            ])
                            self.topo_link_std_bw_physical = None
                            self.topo_link_std_bw_res_max = None
                            self.topo_link_std_bw_res_pool0 = None
                            self.topo_link_std_bw_res_pool1 = None

                            self.topo_link_std_bw_detail = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-standard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, ['topo_link_std_bw_physical', 'topo_link_std_bw_res_max', 'topo_link_std_bw_res_pool0', 'topo_link_std_bw_res_pool1'], name, value)


                        class TopoLinkStdBwDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topo-link-std-bw-allocated", ("topo_link_std_bw_allocated", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated)), ("topo-link-std-bw-available", ("topo_link_std_bw_available", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable))])
                                self._leafs = OrderedDict()

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)
                                self._segment_path = lambda: "topo-link-std-bw-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, [], name, value)


                            class TopoLinkStdBwAllocated(_Entity_):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated']['meta_info']


                            class TopoLinkStdBwAvailable(_Entity_):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's available bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-available"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth']['meta_info']


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities']['meta_info']


                class MinMaxDelay(_Entity_):
                    """
                    Minimum and maximum measured link delay
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_delay
                    
                    	Mimimum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_delay
                    
                    	Maximum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay, self).__init__()

                        self.yang_name = "min-max-delay"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('minimum_delay', (YLeaf(YType.uint32, 'minimum-delay'), ['int'])),
                            ('maximum_delay', (YLeaf(YType.uint32, 'maximum-delay'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.minimum_delay = None
                        self.maximum_delay = None
                        self._segment_path = lambda: "min-max-delay"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay, ['anomalous_bit', 'minimum_delay', 'maximum_delay'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay']['meta_info']


                class Loss(_Entity_):
                    """
                    Link Loss
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: loss_value
                    
                    	Loss Value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss, self).__init__()

                        self.yang_name = "loss"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('loss_value', (YLeaf(YType.uint32, 'loss-value'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.loss_value = None
                        self._segment_path = lambda: "loss"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss, ['anomalous_bit', 'loss_value'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss']['meta_info']


                class TopologyLinkExtendedAffinityBit(_Entity_):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	The link's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "topology-link-extended-affinity-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup']['meta_info']


                class AdjacencySid(_Entity_):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('adjacency_sid', (YLeaf(YType.uint32, 'adjacency-sid'), ['int'])),
                            ('link_type', (YLeaf(YType.enumeration, 'link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('nbr_node_igpid', (YLeaf(YType.str, 'nbr-node-igpid'), ['str'])),
                            ('nbr_node_te_router_id', (YLeaf(YType.str, 'nbr-node-te-router-id'), ['str'])),
                            ('flag_f', (YLeaf(YType.boolean, 'flag-f'), ['bool'])),
                            ('flag_b', (YLeaf(YType.boolean, 'flag-b'), ['bool'])),
                            ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                            ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                            ('flag_s', (YLeaf(YType.boolean, 'flag-s'), ['bool'])),
                        ])
                        self.adjacency_sid = None
                        self.link_type = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.nbr_node_igpid = None
                        self.nbr_node_te_router_id = None
                        self.flag_f = None
                        self.flag_b = None
                        self.flag_v = None
                        self.flag_l = None
                        self.flag_s = None
                        self._segment_path = lambda: "adjacency-sid"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, ['adjacency_sid', 'link_type', 'local_addr', 'remote_addr', 'nbr_node_igpid', 'nbr_node_te_router_id', 'flag_f', 'flag_b', 'flag_v', 'flag_l', 'flag_s'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief.TopologyNodeLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTe.TopologyBriefs.TopologyBrief']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTe.TopologyBriefs']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsTe()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTe']['meta_info']


class MplsLcacStandby(_Entity_):
    """
    mpls lcac standby
    
    .. attribute:: neighbors
    
    	The neighbor information for the local router
    	**type**\:  :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors>`
    
    	**config**\: False
    
    .. attribute:: preemption_events
    
    	Preemption event log in MPLS\-LCAC
    	**type**\:  :py:class:`PreemptionEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents>`
    
    	**config**\: False
    
    .. attribute:: advertisements
    
    	The advertisement information in MPLS\-LCAC
    	**type**\:  :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements>`
    
    	**config**\: False
    
    .. attribute:: statistics
    
    	The interface statistics information in MPLS\-LCAC
    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_allocation
    
    	The bandwidth allocation information in MPLS\-LCAC
    	**type**\:  :py:class:`BandwidthAllocation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation>`
    
    	**config**\: False
    
    .. attribute:: gmpls
    
    	GMPLS data
    	**type**\:  :py:class:`Gmpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls>`
    
    	**config**\: False
    
    .. attribute:: bfd_neighbors
    
    	BFD Neighbors
    	**type**\:  :py:class:`BfdNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_account
    
    	The bandwidth accounting information in MPLS\-LCAC
    	**type**\:  :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount>`
    
    	**config**\: False
    
    .. attribute:: link_summary
    
    	The global summary for all the interfaces
    	**type**\:  :py:class:`LinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary>`
    
    	**config**\: False
    
    .. attribute:: link_information
    
    	The interface information in MPLS\-LCAC
    	**type**\:  :py:class:`LinkInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation>`
    
    	**config**\: False
    
    .. attribute:: admission_control
    
    	The admission control information in MPLS\-LCAC
    	**type**\:  :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl>`
    
    	**config**\: False
    
    .. attribute:: soft_preemption_global_info
    
    	The global soft\-preemption information
    	**type**\:  :py:class:`SoftPreemptionGlobalInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptionGlobalInfo>`
    
    	**config**\: False
    
    .. attribute:: soft_preemptions
    
    	The soft preemption information for the TE\-links
    	**type**\:  :py:class:`SoftPreemptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsLcacStandby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lcac-standby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("neighbors", ("neighbors", MplsLcacStandby.Neighbors)), ("preemption-events", ("preemption_events", MplsLcacStandby.PreemptionEvents)), ("advertisements", ("advertisements", MplsLcacStandby.Advertisements)), ("statistics", ("statistics", MplsLcacStandby.Statistics)), ("bandwidth-allocation", ("bandwidth_allocation", MplsLcacStandby.BandwidthAllocation)), ("gmpls", ("gmpls", MplsLcacStandby.Gmpls)), ("bfd-neighbors", ("bfd_neighbors", MplsLcacStandby.BfdNeighbors)), ("bandwidth-account", ("bandwidth_account", MplsLcacStandby.BandwidthAccount)), ("link-summary", ("link_summary", MplsLcacStandby.LinkSummary)), ("link-information", ("link_information", MplsLcacStandby.LinkInformation)), ("admission-control", ("admission_control", MplsLcacStandby.AdmissionControl)), ("soft-preemption-global-info", ("soft_preemption_global_info", MplsLcacStandby.SoftPreemptionGlobalInfo)), ("soft-preemptions", ("soft_preemptions", MplsLcacStandby.SoftPreemptions))])
        self._leafs = OrderedDict()

        self.neighbors = MplsLcacStandby.Neighbors()
        self.neighbors.parent = self
        self._children_name_map["neighbors"] = "neighbors"

        self.preemption_events = MplsLcacStandby.PreemptionEvents()
        self.preemption_events.parent = self
        self._children_name_map["preemption_events"] = "preemption-events"

        self.advertisements = MplsLcacStandby.Advertisements()
        self.advertisements.parent = self
        self._children_name_map["advertisements"] = "advertisements"

        self.statistics = MplsLcacStandby.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"

        self.bandwidth_allocation = MplsLcacStandby.BandwidthAllocation()
        self.bandwidth_allocation.parent = self
        self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"

        self.gmpls = MplsLcacStandby.Gmpls()
        self.gmpls.parent = self
        self._children_name_map["gmpls"] = "gmpls"

        self.bfd_neighbors = MplsLcacStandby.BfdNeighbors()
        self.bfd_neighbors.parent = self
        self._children_name_map["bfd_neighbors"] = "bfd-neighbors"

        self.bandwidth_account = MplsLcacStandby.BandwidthAccount()
        self.bandwidth_account.parent = self
        self._children_name_map["bandwidth_account"] = "bandwidth-account"

        self.link_summary = MplsLcacStandby.LinkSummary()
        self.link_summary.parent = self
        self._children_name_map["link_summary"] = "link-summary"

        self.link_information = MplsLcacStandby.LinkInformation()
        self.link_information.parent = self
        self._children_name_map["link_information"] = "link-information"

        self.admission_control = MplsLcacStandby.AdmissionControl()
        self.admission_control.parent = self
        self._children_name_map["admission_control"] = "admission-control"

        self.soft_preemption_global_info = MplsLcacStandby.SoftPreemptionGlobalInfo()
        self.soft_preemption_global_info.parent = self
        self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"

        self.soft_preemptions = MplsLcacStandby.SoftPreemptions()
        self.soft_preemptions.parent = self
        self._children_name_map["soft_preemptions"] = "soft-preemptions"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsLcacStandby, [], name, value)


    class Neighbors(_Entity_):
        """
        The neighbor information for the local router
        
        .. attribute:: neighbor
        
        	The neighbors connected to a particular interface
        	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors.Neighbor>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.Neighbors, self).__init__()

            self.yang_name = "neighbors"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcacStandby.Neighbors.Neighbor))])
            self._leafs = OrderedDict()

            self.neighbor = YList(self)
            self._segment_path = lambda: "neighbors"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.Neighbors, [], name, value)


        class Neighbor(_Entity_):
            """
            The neighbors connected to a particular
            interface
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of  		 :py:class:`Neighbor_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Neighbors.Neighbor.Neighbor_>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Neighbors.Neighbor, self).__init__()

                self.yang_name = "neighbor"
                self.yang_parent_name = "neighbors"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcacStandby.Neighbors.Neighbor.Neighbor_))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.neighbor = YList(self)
                self._segment_path = lambda: "neighbor" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/neighbors/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Neighbors.Neighbor, ['interface_name'], name, value)


            class Neighbor_(_Entity_):
                """
                Neighbors of the specified link id
                
                .. attribute:: interface_name
                
                	The interface on which this neighbor is discovered
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_id
                
                	The neighbor's id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	The area id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Neighbors.Neighbor.Neighbor_, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "neighbor"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('neighbor_id', (YLeaf(YType.str, 'neighbor-id'), ['str'])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                    ])
                    self.interface_name = None
                    self.neighbor_id = None
                    self.area_id = None
                    self.neighbor_address = None
                    self._segment_path = lambda: "neighbor"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Neighbors.Neighbor.Neighbor_, ['interface_name', 'neighbor_id', 'area_id', 'neighbor_address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Neighbors.Neighbor.Neighbor_']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Neighbors.Neighbor']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.Neighbors']['meta_info']


    class PreemptionEvents(_Entity_):
        """
        Preemption event log in MPLS\-LCAC
        
        .. attribute:: preemption_event
        
        	Preemption event
        	**type**\: list of  		 :py:class:`PreemptionEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents.PreemptionEvent>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.PreemptionEvents, self).__init__()

            self.yang_name = "preemption-events"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("preemption-event", ("preemption_event", MplsLcacStandby.PreemptionEvents.PreemptionEvent))])
            self._leafs = OrderedDict()

            self.preemption_event = YList(self)
            self._segment_path = lambda: "preemption-events"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.PreemptionEvents, [], name, value)


        class PreemptionEvent(_Entity_):
            """
            Preemption event
            
            .. attribute:: event_index  (key)
            
            	Event index
            	**type**\: int
            
            	**range:** 0..1999
            
            	**config**\: False
            
            .. attribute:: tunnel_id
            
            	Tunnel ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: lsp_id
            
            	LSP ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: requested_bandwidth
            
            	The path's requested bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: setup_priority
            
            	The path's setup priority
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: hold_priority
            
            	The path's hold priority
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: bandwidth_type
            
            	The path's bandwidth type; 0\:CT0, 1\:CT1, so on
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: old_bandwidth_bc0
            
            	Old BW for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: old_bandwidth_bc1
            
            	Old BW for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: new_bandwidth_bc0
            
            	New BW for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: new_bandwidth_bc1
            
            	New BW for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: bandwidth_overshoot0
            
            	BW Overshoot for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: bandwidth_overshoot1
            
            	BW Overshoot for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: interface_name
            
            	Interface name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: event_time
            
            	Event time; seconds elapsed since January 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: ls_ps
            
            	Number of LSPs (not all may be present in the list)
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps
            
            	Number of LSPs softly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps_fr_rrewrite
            
            	Number of LSPs softly preempted with traffic switched to backup
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: hard_preempted_ls_ps
            
            	Number of LSPs hardly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: total_preempted_bandwidth_bc0
            
            	Total amount of preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_preempted_bandwidth_bc1
            
            	Total amount of preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: softly_preempted_bandwidth_bc0
            
            	Amount of softly preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: softly_preempted_bandwidth_bc1
            
            	Amount of softly preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc0
            
            	Amount of softly preempted FRR RW class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc1
            
            	Amount of softly preempted FRR RW class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: hard_preempted_bandwidth_bc0
            
            	Amount of hard preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: hard_preempted_bandwidth_bc1
            
            	Amount of hard preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: tunnels
            
            	Number of Tunnels
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_tunnels
            
            	Number of Tunnels softly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_tunnels_fr_rrewrite
            
            	Number of Tunnels softly preempted with traffic switched to backup
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: hard_preempted_tunnels
            
            	Number of Tunnels hardly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: lsp
            
            	List of preempted LSPs
            	**type**\: list of  		 :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.PreemptionEvents.PreemptionEvent, self).__init__()

                self.yang_name = "preemption-event"
                self.yang_parent_name = "preemption-events"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['event_index']
                self._child_classes = OrderedDict([("lsp", ("lsp", MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp))])
                self._leafs = OrderedDict([
                    ('event_index', (YLeaf(YType.uint32, 'event-index'), ['int'])),
                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                    ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                    ('old_bandwidth_bc0', (YLeaf(YType.uint64, 'old-bandwidth-bc0'), ['int'])),
                    ('old_bandwidth_bc1', (YLeaf(YType.uint64, 'old-bandwidth-bc1'), ['int'])),
                    ('new_bandwidth_bc0', (YLeaf(YType.uint64, 'new-bandwidth-bc0'), ['int'])),
                    ('new_bandwidth_bc1', (YLeaf(YType.uint64, 'new-bandwidth-bc1'), ['int'])),
                    ('bandwidth_overshoot0', (YLeaf(YType.uint64, 'bandwidth-overshoot0'), ['int'])),
                    ('bandwidth_overshoot1', (YLeaf(YType.uint64, 'bandwidth-overshoot1'), ['int'])),
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ('event_time', (YLeaf(YType.uint32, 'event-time'), ['int'])),
                    ('ls_ps', (YLeaf(YType.uint16, 'ls-ps'), ['int'])),
                    ('soft_preempted_ls_ps', (YLeaf(YType.uint16, 'soft-preempted-ls-ps'), ['int'])),
                    ('soft_preempted_ls_ps_fr_rrewrite', (YLeaf(YType.uint16, 'soft-preempted-ls-ps-fr-rrewrite'), ['int'])),
                    ('hard_preempted_ls_ps', (YLeaf(YType.uint16, 'hard-preempted-ls-ps'), ['int'])),
                    ('total_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'total-preempted-bandwidth-bc0'), ['int'])),
                    ('total_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'total-preempted-bandwidth-bc1'), ['int'])),
                    ('softly_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'softly-preempted-bandwidth-bc0'), ['int'])),
                    ('softly_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'softly-preempted-bandwidth-bc1'), ['int'])),
                    ('soft_preempted_fr_rrewrite_bandwidth_bc0', (YLeaf(YType.uint64, 'soft-preempted-fr-rrewrite-bandwidth-bc0'), ['int'])),
                    ('soft_preempted_fr_rrewrite_bandwidth_bc1', (YLeaf(YType.uint64, 'soft-preempted-fr-rrewrite-bandwidth-bc1'), ['int'])),
                    ('hard_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'hard-preempted-bandwidth-bc0'), ['int'])),
                    ('hard_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'hard-preempted-bandwidth-bc1'), ['int'])),
                    ('tunnels', (YLeaf(YType.uint16, 'tunnels'), ['int'])),
                    ('soft_preempted_tunnels', (YLeaf(YType.uint16, 'soft-preempted-tunnels'), ['int'])),
                    ('soft_preempted_tunnels_fr_rrewrite', (YLeaf(YType.uint16, 'soft-preempted-tunnels-fr-rrewrite'), ['int'])),
                    ('hard_preempted_tunnels', (YLeaf(YType.uint16, 'hard-preempted-tunnels'), ['int'])),
                ])
                self.event_index = None
                self.tunnel_id = None
                self.lsp_id = None
                self.source_address = None
                self.destination_address = None
                self.requested_bandwidth = None
                self.setup_priority = None
                self.hold_priority = None
                self.bandwidth_type = None
                self.old_bandwidth_bc0 = None
                self.old_bandwidth_bc1 = None
                self.new_bandwidth_bc0 = None
                self.new_bandwidth_bc1 = None
                self.bandwidth_overshoot0 = None
                self.bandwidth_overshoot1 = None
                self.interface_name = None
                self.event_time = None
                self.ls_ps = None
                self.soft_preempted_ls_ps = None
                self.soft_preempted_ls_ps_fr_rrewrite = None
                self.hard_preempted_ls_ps = None
                self.total_preempted_bandwidth_bc0 = None
                self.total_preempted_bandwidth_bc1 = None
                self.softly_preempted_bandwidth_bc0 = None
                self.softly_preempted_bandwidth_bc1 = None
                self.soft_preempted_fr_rrewrite_bandwidth_bc0 = None
                self.soft_preempted_fr_rrewrite_bandwidth_bc1 = None
                self.hard_preempted_bandwidth_bc0 = None
                self.hard_preempted_bandwidth_bc1 = None
                self.tunnels = None
                self.soft_preempted_tunnels = None
                self.soft_preempted_tunnels_fr_rrewrite = None
                self.hard_preempted_tunnels = None

                self.lsp = YList(self)
                self._segment_path = lambda: "preemption-event" + "[event-index='" + str(self.event_index) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/preemption-events/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.PreemptionEvents.PreemptionEvent, ['event_index', 'tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'old_bandwidth_bc0', 'old_bandwidth_bc1', 'new_bandwidth_bc0', 'new_bandwidth_bc1', 'bandwidth_overshoot0', 'bandwidth_overshoot1', 'interface_name', 'event_time', 'ls_ps', 'soft_preempted_ls_ps', 'soft_preempted_ls_ps_fr_rrewrite', 'hard_preempted_ls_ps', 'total_preempted_bandwidth_bc0', 'total_preempted_bandwidth_bc1', 'softly_preempted_bandwidth_bc0', 'softly_preempted_bandwidth_bc1', 'soft_preempted_fr_rrewrite_bandwidth_bc0', 'soft_preempted_fr_rrewrite_bandwidth_bc1', 'hard_preempted_bandwidth_bc0', 'hard_preempted_bandwidth_bc1', 'tunnels', 'soft_preempted_tunnels', 'soft_preempted_tunnels_fr_rrewrite', 'hard_preempted_tunnels'], name, value)


            class Lsp(_Entity_):
                """
                List of preempted LSPs
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp, self).__init__()

                    self.yang_name = "lsp"
                    self.yang_parent_name = "preemption-event"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                        ('soft_preempted', (YLeaf(YType.boolean, 'soft-preempted'), ['bool'])),
                        ('soft_preemption_timeout', (YLeaf(YType.uint16, 'soft-preemption-timeout'), ['int'])),
                        ('bandwidth_preempted', (YLeaf(YType.boolean, 'bandwidth-preempted'), ['bool'])),
                        ('soft_preempted_fr_rrewrite', (YLeaf(YType.boolean, 'soft-preempted-fr-rrewrite'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.requested_bandwidth = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth_type = None
                    self.soft_preempted = None
                    self.soft_preemption_timeout = None
                    self.bandwidth_preempted = None
                    self.soft_preempted_fr_rrewrite = None
                    self._segment_path = lambda: "lsp"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp, ['tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'soft_preempted', 'soft_preemption_timeout', 'bandwidth_preempted', 'soft_preempted_fr_rrewrite'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.PreemptionEvents.PreemptionEvent.Lsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.PreemptionEvents.PreemptionEvent']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.PreemptionEvents']['meta_info']


    class Advertisements(_Entity_):
        """
        The advertisement information in MPLS\-LCAC
        
        .. attribute:: flooding_status_message
        
        	Flooding status\: ready or reason
        	**type**\: str
        
        	**config**\: False
        
        .. attribute:: last_flooding_time
        
        	Time elapsed since last flooding in seconds
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        	**units**\: second
        
        .. attribute:: last_flooding_trigger
        
        	Trigger for last flooding
        	**type**\:  :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
        
        	**config**\: False
        
        .. attribute:: next_flooding_time
        
        	Time remained for next flooding in seconds
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        	**units**\: second
        
        .. attribute:: ds_te_mode
        
        	DS\-TE Mode
        	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
        
        	**config**\: False
        
        .. attribute:: advertized_areas
        
        	Advertising info for all the IGP areas
        	**type**\: list of  		 :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.Advertisements, self).__init__()

            self.yang_name = "advertisements"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("advertized-areas", ("advertized_areas", MplsLcacStandby.Advertisements.AdvertizedAreas))])
            self._leafs = OrderedDict([
                ('flooding_status_message', (YLeaf(YType.str, 'flooding-status-message'), ['str'])),
                ('last_flooding_time', (YLeaf(YType.uint32, 'last-flooding-time'), ['int'])),
                ('last_flooding_trigger', (YLeaf(YType.enumeration, 'last-flooding-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FloodingTrigger', '')])),
                ('next_flooding_time', (YLeaf(YType.uint32, 'next-flooding-time'), ['int'])),
                ('ds_te_mode', (YLeaf(YType.enumeration, 'ds-te-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
            ])
            self.flooding_status_message = None
            self.last_flooding_time = None
            self.last_flooding_trigger = None
            self.next_flooding_time = None
            self.ds_te_mode = None

            self.advertized_areas = YList(self)
            self._segment_path = lambda: "advertisements"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.Advertisements, ['flooding_status_message', 'last_flooding_time', 'last_flooding_trigger', 'next_flooding_time', 'ds_te_mode'], name, value)


        class AdvertizedAreas(_Entity_):
            """
            Advertising info for all the IGP areas
            
            .. attribute:: igp_area_id
            
            	The area id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol
            
            	The IGP protocol running over this area
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: system_id
            
            	The node's system id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: router_id
            
            	The node's router ID
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: flooded_link
            
            	The array of flooded links in this area
            	**type**\: list of  		 :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Advertisements.AdvertizedAreas, self).__init__()

                self.yang_name = "advertized-areas"
                self.yang_parent_name = "advertisements"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("flooded-link", ("flooded_link", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink))])
                self._leafs = OrderedDict([
                    ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                    ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                ])
                self.igp_area_id = None
                self.protocol = None
                self.system_id = None
                self.router_id = None

                self.flooded_link = YList(self)
                self._segment_path = lambda: "advertized-areas"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas, ['igp_area_id', 'protocol', 'system_id', 'router_id'], name, value)


            class FloodedLink(_Entity_):
                """
                The array of flooded links in this area
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	The link's id
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: interface_name
                
                	The link's interface name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: link_address
                
                	The link's IPv4 address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: subnet_type
                
                	The link's subnet type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: outgoing_interface_id
                
                	The link's outgoing interface's id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_designated_router
                
                	TRUE if the link belongs to a desig. router
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: designated_router_igp_id
                
                	IGP id of the designated router
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_igp_id
                
                	The neighbor's IGP id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_neighbor_address
                
                	The neighbor's ip address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: incoming_interface_id
                
                	The link's incoming interface's id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uni_link_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_units
                
                	The link's bandwidth units
                	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                	**config**\: False
                
                .. attribute:: physical_bandwidth
                
                	The link's physical BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bcm_id
                
                	Bandwidth Constraints Model ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: link_maximum_reservable_bandwidth
                
                	The link's maximum reservable BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth
                
                	The link's reservable pool0 BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth
                
                	The link's reservable pool1 BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_receiving_reservable_bandwidth_enabled
                
                	TRUE if receiving reservable BW is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: receiving_direction
                
                	Upstream or Downstream
                	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                	**config**\: False
                
                .. attribute:: is_transmitting_reservable_bandwidth_enabled
                
                	TRUE if transmitting reservable BW is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: transmitting_direction
                
                	Upstream or Downstream
                	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                	**config**\: False
                
                .. attribute:: affinity_attribute_flags
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_affinity_attribute_flag
                
                	The link's extended affinity bits
                	**type**\: list of  		 :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: receiving_reservable_bandwidth
                
                	Receiving reservable BW at each priority level(priority 0 to priority 7)
                	**type**\: list of  		 :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                
                	**config**\: False
                
                .. attribute:: transmitting_reservable_bandwidth
                
                	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                	**type**\: list of  		 :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                    self.yang_name = "flooded-link"
                    self.yang_parent_name = "advertized-areas"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("odu-link-capabilities", ("odu_link_capabilities", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities)), ("extended-affinity-attribute-flag", ("extended_affinity_attribute_flag", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup)), ("receiving-reservable-bandwidth", ("receiving_reservable_bandwidth", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth)), ("transmitting-reservable-bandwidth", ("transmitting_reservable_bandwidth", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth))])
                    self._leafs = OrderedDict([
                        ('link_id', (YLeaf(YType.uint16, 'link-id'), ['int'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                        ('subnet_type', (YLeaf(YType.enumeration, 'subnet-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('outgoing_interface_id', (YLeaf(YType.uint32, 'outgoing-interface-id'), ['int'])),
                        ('is_designated_router', (YLeaf(YType.boolean, 'is-designated-router'), ['bool'])),
                        ('designated_router_igp_id', (YLeaf(YType.str, 'designated-router-igp-id'), ['str'])),
                        ('neighbor_igp_id', (YLeaf(YType.str, 'neighbor-igp-id'), ['str'])),
                        ('igp_neighbor_address', (YLeaf(YType.str, 'igp-neighbor-address'), ['str'])),
                        ('incoming_interface_id', (YLeaf(YType.uint32, 'incoming-interface-id'), ['int'])),
                        ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                        ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                        ('uni_link_delay', (YLeaf(YType.uint32, 'uni-link-delay'), ['int'])),
                        ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ('physical_bandwidth', (YLeaf(YType.uint32, 'physical-bandwidth'), ['int'])),
                        ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                        ('link_maximum_reservable_bandwidth', (YLeaf(YType.uint32, 'link-maximum-reservable-bandwidth'), ['int'])),
                        ('reservable_pool0_bandwidth', (YLeaf(YType.uint32, 'reservable-pool0-bandwidth'), ['int'])),
                        ('reservable_pool1_bandwidth', (YLeaf(YType.uint32, 'reservable-pool1-bandwidth'), ['int'])),
                        ('is_receiving_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-receiving-reservable-bandwidth-enabled'), ['bool'])),
                        ('receiving_direction', (YLeaf(YType.enumeration, 'receiving-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                        ('is_transmitting_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-transmitting-reservable-bandwidth-enabled'), ['bool'])),
                        ('transmitting_direction', (YLeaf(YType.enumeration, 'transmitting-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                        ('affinity_attribute_flags', (YLeaf(YType.uint32, 'affinity-attribute-flags'), ['int'])),
                    ])
                    self.link_id = None
                    self.interface_name = None
                    self.link_address = None
                    self.subnet_type = None
                    self.outgoing_interface_id = None
                    self.is_designated_router = None
                    self.designated_router_igp_id = None
                    self.neighbor_igp_id = None
                    self.igp_neighbor_address = None
                    self.incoming_interface_id = None
                    self.te_metric = None
                    self.igp_metric = None
                    self.uni_link_delay = None
                    self.bandwidth_units = None
                    self.physical_bandwidth = None
                    self.bcm_id = None
                    self.link_maximum_reservable_bandwidth = None
                    self.reservable_pool0_bandwidth = None
                    self.reservable_pool1_bandwidth = None
                    self.is_receiving_reservable_bandwidth_enabled = None
                    self.receiving_direction = None
                    self.is_transmitting_reservable_bandwidth_enabled = None
                    self.transmitting_direction = None
                    self.affinity_attribute_flags = None

                    self.odu_link_capabilities = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.extended_affinity_attribute_flag = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.receiving_reservable_bandwidth = YList(self)
                    self.transmitting_reservable_bandwidth = YList(self)
                    self._segment_path = lambda: "flooded-link"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink, ['link_id', 'interface_name', 'link_address', 'subnet_type', 'outgoing_interface_id', 'is_designated_router', 'designated_router_igp_id', 'neighbor_igp_id', 'igp_neighbor_address', 'incoming_interface_id', 'te_metric', 'igp_metric', 'uni_link_delay', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'link_maximum_reservable_bandwidth', 'reservable_pool0_bandwidth', 'reservable_pool1_bandwidth', 'is_receiving_reservable_bandwidth_enabled', 'receiving_direction', 'is_transmitting_reservable_bandwidth_enabled', 'transmitting_direction', 'affinity_attribute_flags'], name, value)


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities']['meta_info']


                class ExtendedAffinityAttributeFlag(_Entity_):
                    """
                    The link's extended affinity bits
                    
                    .. attribute:: entry
                    
                    	The link's extended affinity bits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                        self.yang_name = "extended-affinity-attribute-flag"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "extended-affinity-attribute-flag"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup']['meta_info']


                class ReceivingReservableBandwidth(_Entity_):
                    """
                    Receiving reservable BW at each priority
                    level(priority 0 to priority 7)
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                        self.yang_name = "receiving-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                            ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                            ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                        ])
                        self.priority = None
                        self.pool0_bandwidth = None
                        self.pool1_bandwidth = None
                        self._segment_path = lambda: "receiving-reservable-bandwidth"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth']['meta_info']


                class TransmittingReservableBandwidth(_Entity_):
                    """
                    Transmitting reservable BW at each priority
                    level (priority 0 to priority 7)
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                        self.yang_name = "transmitting-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                            ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                            ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                        ])
                        self.priority = None
                        self.pool0_bandwidth = None
                        self.pool1_bandwidth = None
                        self._segment_path = lambda: "transmitting-reservable-bandwidth"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas.FloodedLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Advertisements.AdvertizedAreas']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.Advertisements']['meta_info']


    class Statistics(_Entity_):
        """
        The interface statistics information in
        MPLS\-LCAC
        
        .. attribute:: summary
        
        	The statistics summary for all interfaces
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary>`
        
        	**config**\: False
        
        .. attribute:: statstics_links
        
        	The table of statistics interfaces in MPLS\-LCAC
        	**type**\:  :py:class:`StatsticsLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsLcacStandby.Statistics.Summary)), ("statstics-links", ("statstics_links", MplsLcacStandby.Statistics.StatsticsLinks))])
            self._leafs = OrderedDict()

            self.summary = MplsLcacStandby.Statistics.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.statstics_links = MplsLcacStandby.Statistics.StatsticsLinks()
            self.statstics_links.parent = self
            self._children_name_map["statstics_links"] = "statstics-links"
            self._segment_path = lambda: "statistics"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.Statistics, [], name, value)


        class Summary(_Entity_):
            """
            The statistics summary for all interfaces
            
            .. attribute:: path_statistics
            
            	Deprecated
            	**type**\:  :py:class:`PathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.PathStatistics>`
            
            	**config**\: False
            
            .. attribute:: reservation_statistics
            
            	Deprecated
            	**type**\:  :py:class:`ReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.ReservationStatistics>`
            
            	**config**\: False
            
            .. attribute:: path_statistics32_bit
            
            	Path counters (32\-bit)
            	**type**\:  :py:class:`PathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.PathStatistics32Bit>`
            
            	**config**\: False
            
            .. attribute:: reservation_statistics32_bit
            
            	Reservation counters (32\-bit)
            	**type**\:  :py:class:`ReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit>`
            
            	**config**\: False
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Statistics.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-statistics", ("path_statistics", MplsLcacStandby.Statistics.Summary.PathStatistics)), ("reservation-statistics", ("reservation_statistics", MplsLcacStandby.Statistics.Summary.ReservationStatistics)), ("path-statistics32-bit", ("path_statistics32_bit", MplsLcacStandby.Statistics.Summary.PathStatistics32Bit)), ("reservation-statistics32-bit", ("reservation_statistics32_bit", MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit))])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                ])
                self.is_role_standby = None

                self.path_statistics = MplsLcacStandby.Statistics.Summary.PathStatistics()
                self.path_statistics.parent = self
                self._children_name_map["path_statistics"] = "path-statistics"

                self.reservation_statistics = MplsLcacStandby.Statistics.Summary.ReservationStatistics()
                self.reservation_statistics.parent = self
                self._children_name_map["reservation_statistics"] = "reservation-statistics"

                self.path_statistics32_bit = MplsLcacStandby.Statistics.Summary.PathStatistics32Bit()
                self.path_statistics32_bit.parent = self
                self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"

                self.reservation_statistics32_bit = MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit()
                self.reservation_statistics32_bit.parent = self
                self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Statistics.Summary, ['is_role_standby'], name, value)


            class PathStatistics(_Entity_):
                """
                Deprecated
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Statistics.Summary.PathStatistics, self).__init__()

                    self.yang_name = "path-statistics"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "path-statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Statistics.Summary.PathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Statistics.Summary.PathStatistics']['meta_info']


            class ReservationStatistics(_Entity_):
                """
                Deprecated
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Statistics.Summary.ReservationStatistics, self).__init__()

                    self.yang_name = "reservation-statistics"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "reservation-statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Statistics.Summary.ReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Statistics.Summary.ReservationStatistics']['meta_info']


            class PathStatistics32Bit(_Entity_):
                """
                Path counters (32\-bit)
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Statistics.Summary.PathStatistics32Bit, self).__init__()

                    self.yang_name = "path-statistics32-bit"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "path-statistics32-bit"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Statistics.Summary.PathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Statistics.Summary.PathStatistics32Bit']['meta_info']


            class ReservationStatistics32Bit(_Entity_):
                """
                Reservation counters (32\-bit)
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit, self).__init__()

                    self.yang_name = "reservation-statistics32-bit"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "reservation-statistics32-bit"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Statistics.Summary.ReservationStatistics32Bit']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Statistics.Summary']['meta_info']


        class StatsticsLinks(_Entity_):
            """
            The table of statistics interfaces in MPLS\-LCAC
            
            .. attribute:: statstics_link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of  		 :py:class:`StatsticsLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Statistics.StatsticsLinks, self).__init__()

                self.yang_name = "statstics-links"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("statstics-link", ("statstics_link", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink))])
                self._leafs = OrderedDict()

                self.statstics_link = YList(self)
                self._segment_path = lambda: "statstics-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks, [], name, value)


            class StatsticsLink(_Entity_):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: incoming_path_statistics
                
                	Deprecated
                	**type**\:  :py:class:`IncomingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics>`
                
                	**config**\: False
                
                .. attribute:: incoming_reservation_statistics
                
                	Deprecated
                	**type**\:  :py:class:`IncomingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics>`
                
                	**config**\: False
                
                .. attribute:: outgoing_path_statistics
                
                	Deprecated
                	**type**\:  :py:class:`OutgoingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics>`
                
                	**config**\: False
                
                .. attribute:: outgoing_reservation_statistics
                
                	Deprecated
                	**type**\:  :py:class:`OutgoingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics>`
                
                	**config**\: False
                
                .. attribute:: incoming_path_statistics32_bit
                
                	Incoming PATH counters
                	**type**\:  :py:class:`IncomingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: incoming_reservation_statistics32_bit
                
                	Incoming RESV counters
                	**type**\:  :py:class:`IncomingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: outgoing_path_statistics32_bit
                
                	Outgoing PATH counters
                	**type**\:  :py:class:`OutgoingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: outgoing_reservation_statistics32_bit
                
                	Outgoing RESV counters
                	**type**\:  :py:class:`OutgoingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: interface_name_xr
                
                	Link name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: link_address
                
                	Link's ip address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink, self).__init__()

                    self.yang_name = "statstics-link"
                    self.yang_parent_name = "statstics-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("incoming-path-statistics", ("incoming_path_statistics", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics)), ("incoming-reservation-statistics", ("incoming_reservation_statistics", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics)), ("outgoing-path-statistics", ("outgoing_path_statistics", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics)), ("outgoing-reservation-statistics", ("outgoing_reservation_statistics", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics)), ("incoming-path-statistics32-bit", ("incoming_path_statistics32_bit", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit)), ("incoming-reservation-statistics32-bit", ("incoming_reservation_statistics32_bit", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit)), ("outgoing-path-statistics32-bit", ("outgoing_path_statistics32_bit", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit)), ("outgoing-reservation-statistics32-bit", ("outgoing_reservation_statistics32_bit", MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('interface_name_xr', (YLeaf(YType.str, 'interface-name-xr'), ['str'])),
                        ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                    ])
                    self.interface_name = None
                    self.interface_name_xr = None
                    self.link_address = None

                    self.incoming_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                    self.incoming_path_statistics.parent = self
                    self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"

                    self.incoming_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                    self.incoming_reservation_statistics.parent = self
                    self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"

                    self.outgoing_path_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                    self.outgoing_path_statistics.parent = self
                    self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"

                    self.outgoing_reservation_statistics = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                    self.outgoing_reservation_statistics.parent = self
                    self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"

                    self.incoming_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                    self.incoming_path_statistics32_bit.parent = self
                    self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"

                    self.incoming_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                    self.incoming_reservation_statistics32_bit.parent = self
                    self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"

                    self.outgoing_path_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                    self.outgoing_path_statistics32_bit.parent = self
                    self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"

                    self.outgoing_reservation_statistics32_bit = MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                    self.outgoing_reservation_statistics32_bit.parent = self
                    self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                    self._segment_path = lambda: "statstics-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/statistics/statstics-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink, ['interface_name', 'interface_name_xr', 'link_address'], name, value)


                class IncomingPathStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__init__()

                        self.yang_name = "incoming-path-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-path-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics']['meta_info']


                class IncomingReservationStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__init__()

                        self.yang_name = "incoming-reservation-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-reservation-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics']['meta_info']


                class OutgoingPathStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__init__()

                        self.yang_name = "outgoing-path-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-path-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics']['meta_info']


                class OutgoingReservationStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-reservation-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics']['meta_info']


                class IncomingPathStatistics32Bit(_Entity_):
                    """
                    Incoming PATH counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-path-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit']['meta_info']


                class IncomingReservationStatistics32Bit(_Entity_):
                    """
                    Incoming RESV counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-reservation-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit']['meta_info']


                class OutgoingPathStatistics32Bit(_Entity_):
                    """
                    Outgoing PATH counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-path-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit']['meta_info']


                class OutgoingReservationStatistics32Bit(_Entity_):
                    """
                    Outgoing RESV counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-reservation-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks.StatsticsLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Statistics.StatsticsLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.Statistics']['meta_info']


    class BandwidthAllocation(_Entity_):
        """
        The bandwidth allocation information in
        MPLS\-LCAC
        
        .. attribute:: global_
        
        	Global bandwidth allocation information for all interfaces
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.Global>`
        
        	**config**\: False
        
        .. attribute:: bandwidth_allocation_links
        
        	Per\-link bandwidth allocation information in MPLS\-LCAC
        	**type**\:  :py:class:`BandwidthAllocationLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.BandwidthAllocation, self).__init__()

            self.yang_name = "bandwidth-allocation"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcacStandby.BandwidthAllocation.Global)), ("bandwidth-allocation-links", ("bandwidth_allocation_links", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcacStandby.BandwidthAllocation.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.bandwidth_allocation_links = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks()
            self.bandwidth_allocation_links.parent = self
            self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
            self._segment_path = lambda: "bandwidth-allocation"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.BandwidthAllocation, [], name, value)


        class Global(_Entity_):
            """
            Global bandwidth allocation information for all
            interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: links
            
            	Number of links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: bandwidth_hold_time
            
            	How long to hold the bandwidth (seconds)
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.BandwidthAllocation.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "bandwidth-allocation"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                    ('bandwidth_hold_time', (YLeaf(YType.uint16, 'bandwidth-hold-time'), ['int'])),
                ])
                self.is_role_standby = None
                self.links = None
                self.bandwidth_hold_time = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.BandwidthAllocation.Global, ['is_role_standby', 'links', 'bandwidth_hold_time'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.BandwidthAllocation.Global']['meta_info']


        class BandwidthAllocationLinks(_Entity_):
            """
            Per\-link bandwidth allocation information in
            MPLS\-LCAC
            
            .. attribute:: bandwidth_allocation_link
            
            	The bandwidth allocation for a given interface
            	**type**\: list of  		 :py:class:`BandwidthAllocationLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks, self).__init__()

                self.yang_name = "bandwidth-allocation-links"
                self.yang_parent_name = "bandwidth-allocation"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bandwidth-allocation-link", ("bandwidth_allocation_link", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink))])
                self._leafs = OrderedDict()

                self.bandwidth_allocation_link = YList(self)
                self._segment_path = lambda: "bandwidth-allocation-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks, [], name, value)


            class BandwidthAllocationLink(_Entity_):
                """
                The bandwidth allocation for a given interface
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:  :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon>`
                
                	**config**\: False
                
                .. attribute:: upstream_bandwidth
                
                	BW info in the upstream direction
                	**type**\:  :py:class:`UpstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth>`
                
                	**config**\: False
                
                .. attribute:: downstream_bandwidth
                
                	BW info in the dnstream direction
                	**type**\:  :py:class:`DownstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth>`
                
                	**config**\: False
                
                .. attribute:: total_bandwidth_descriptors
                
                	Number of total BW descriptors
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: bandwidth_descriptors
                
                	Number of BW descriptor for the given pool
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool
                
                	type of the BW pool
                	**type**\:  :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                	**config**\: False
                
                .. attribute:: flooding_up_thresholds_are_default
                
                	TRUE if the up\-threshold are default
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_down_thresholds_are_default
                
                	TRUE if the down\-threshold are default
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_up_thresholds_are_global
                
                	TRUE if the up\-threshold are global
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_down_thresholds_are_global
                
                	TRUE if the down\-threshold are global
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_up_threshold
                
                	Flooding up\-thresholds
                	**type**\: list of  		 :py:class:`FloodingUpThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold>`
                
                	**config**\: False
                
                .. attribute:: flooding_down_threshold
                
                	Flooding down\-thresholds
                	**type**\: list of  		 :py:class:`FloodingDownThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__init__()

                    self.yang_name = "bandwidth-allocation-link"
                    self.yang_parent_name = "bandwidth-allocation-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("link-common", ("link_common", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon)), ("upstream-bandwidth", ("upstream_bandwidth", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth)), ("downstream-bandwidth", ("downstream_bandwidth", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth)), ("flooding-up-threshold", ("flooding_up_threshold", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold)), ("flooding-down-threshold", ("flooding_down_threshold", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('total_bandwidth_descriptors', (YLeaf(YType.uint16, 'total-bandwidth-descriptors'), ['int'])),
                        ('bandwidth_descriptors', (YLeaf(YType.uint16, 'bandwidth-descriptors'), ['int'])),
                        ('bandwidth_pool', (YLeaf(YType.enumeration, 'bandwidth-pool'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthTypeEnum', '')])),
                        ('flooding_up_thresholds_are_default', (YLeaf(YType.boolean, 'flooding-up-thresholds-are-default'), ['bool'])),
                        ('flooding_down_thresholds_are_default', (YLeaf(YType.boolean, 'flooding-down-thresholds-are-default'), ['bool'])),
                        ('flooding_up_thresholds_are_global', (YLeaf(YType.boolean, 'flooding-up-thresholds-are-global'), ['bool'])),
                        ('flooding_down_thresholds_are_global', (YLeaf(YType.boolean, 'flooding-down-thresholds-are-global'), ['bool'])),
                    ])
                    self.interface_name = None
                    self.total_bandwidth_descriptors = None
                    self.bandwidth_descriptors = None
                    self.bandwidth_pool = None
                    self.flooding_up_thresholds_are_default = None
                    self.flooding_down_thresholds_are_default = None
                    self.flooding_up_thresholds_are_global = None
                    self.flooding_down_thresholds_are_global = None

                    self.link_common = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"

                    self.upstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                    self.upstream_bandwidth.parent = self
                    self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"

                    self.downstream_bandwidth = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                    self.downstream_bandwidth.parent = self
                    self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"

                    self.flooding_up_threshold = YList(self)
                    self.flooding_down_threshold = YList(self)
                    self._segment_path = lambda: "bandwidth-allocation-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-allocation/bandwidth-allocation-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, ['interface_name', 'total_bandwidth_descriptors', 'bandwidth_descriptors', 'bandwidth_pool', 'flooding_up_thresholds_are_default', 'flooding_down_thresholds_are_default', 'flooding_up_thresholds_are_global', 'flooding_down_thresholds_are_global'], name, value)


                class LinkCommon(_Entity_):
                    """
                    The link's common info
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:  :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags>`
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of  		 :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    	**config**\: False
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of  		 :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("link-flags", ("link_flags", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup)), ("interface-switching-capability-descriptor", ("interface_switching_capability_descriptor", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor)), ("flooded-areas", ("flooded_areas", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas))])
                        self._leafs = OrderedDict([
                            ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                            ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                            ('is_unnumbered', (YLeaf(YType.boolean, 'is-unnumbered'), ['bool'])),
                            ('has_protection', (YLeaf(YType.boolean, 'has-protection'), ['bool'])),
                            ('capability', (YLeaf(YType.uint32, 'capability'), ['int'])),
                            ('working_priority', (YLeaf(YType.uint32, 'working-priority'), ['int'])),
                            ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                            ('is_resource_provider_installed', (YLeaf(YType.boolean, 'is-resource-provider-installed'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                            ('physical_bandwidth', (YLeaf(YType.uint64, 'physical-bandwidth'), ['int'])),
                            ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                            ('maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-bandwidth'), ['int'])),
                            ('last_flooded_effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'last-flooded-effective-maximum-reservable-bandwidth'), ['int'])),
                            ('incoming_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool0_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool0-bandwidth'), ['int'])),
                            ('incoming_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool1_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool1-bandwidth'), ['int'])),
                            ('incoming_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('inbound_admission_method', (YLeaf(YType.enumeration, 'inbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('outbound_admission_method', (YLeaf(YType.enumeration, 'outbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                        ])
                        self.link_id = None
                        self.link_address = None
                        self.is_unnumbered = None
                        self.has_protection = None
                        self.capability = None
                        self.working_priority = None
                        self.resource_provider = None
                        self.is_resource_provider_installed = None
                        self.bandwidth_units = None
                        self.physical_bandwidth = None
                        self.bcm_id = None
                        self.maximum_reservable_bandwidth = None
                        self.last_flooded_effective_maximum_reservable_bandwidth = None
                        self.incoming_reservable_bandwidth_percentage = None
                        self.outgoing_reservable_bandwidth_percentage = None
                        self.maximum_reservable_pool0_bandwidth = None
                        self.incoming_reservable_pool0_bandwidth_percentage = None
                        self.outgoing_reservable_pool0_bandwidth_percentage = None
                        self.maximum_reservable_pool1_bandwidth = None
                        self.incoming_reservable_pool1_bandwidth_percentage = None
                        self.outgoing_reservable_pool1_bandwidth_percentage = None
                        self.inbound_admission_method = None
                        self.outbound_admission_method = None
                        self.igp_neighbors = None

                        self.link_flags = MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"

                        self.shared_risk_link_group = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.flooded_areas = YList(self)
                        self._segment_path = lambda: "link-common"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, ['link_id', 'link_address', 'is_unnumbered', 'has_protection', 'capability', 'working_priority', 'resource_provider', 'is_resource_provider_installed', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'maximum_reservable_bandwidth', 'last_flooded_effective_maximum_reservable_bandwidth', 'incoming_reservable_bandwidth_percentage', 'outgoing_reservable_bandwidth_percentage', 'maximum_reservable_pool0_bandwidth', 'incoming_reservable_pool0_bandwidth_percentage', 'outgoing_reservable_pool0_bandwidth_percentage', 'maximum_reservable_pool1_bandwidth', 'incoming_reservable_pool1_bandwidth_percentage', 'outgoing_reservable_pool1_bandwidth_percentage', 'inbound_admission_method', 'outbound_admission_method', 'igp_neighbors'], name, value)


                    class LinkFlags(_Entity_):
                        """
                        The link's flags
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:  :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_mpls_te_on', (YLeaf(YType.boolean, 'is-mpls-te-on'), ['bool'])),
                                ('signaling_agent', (YLeaf(YType.enumeration, 'signaling-agent'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'SignalingAgentEnum', '')])),
                                ('is_admin_up', (YLeaf(YType.boolean, 'is-admin-up'), ['bool'])),
                            ])
                            self.is_mpls_te_on = None
                            self.signaling_agent = None
                            self.is_admin_up = None
                            self._segment_path = lambda: "link-flags"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, ['is_mpls_te_on', 'signaling_agent', 'is_admin_up'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup']['meta_info']


                    class InterfaceSwitchingCapabilityDescriptor(_Entity_):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('key', (YLeaf(YType.uint8, 'key'), ['int'])),
                                ('switching_capability', (YLeaf(YType.uint8, 'switching-capability'), ['int'])),
                                ('encoding', (YLeaf(YType.uint8, 'encoding'), ['int'])),
                            ])
                            self.key = None
                            self.switching_capability = None
                            self.encoding = None
                            self._segment_path = lambda: "interface-switching-capability-descriptor"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, ['key', 'switching_capability', 'encoding'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor']['meta_info']


                    class FloodedAreas(_Entity_):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('flooded_area', (YLeaf(YType.str, 'flooded-area'), ['str'])),
                            ])
                            self.flooded_area = None
                            self._segment_path = lambda: "flooded-areas"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, ['flooded_area'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon']['meta_info']


                class UpstreamBandwidth(_Entity_):
                    """
                    BW info in the upstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__init__()

                        self.yang_name = "upstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-pool0", ("bandwidth_pool0", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0)), ("bandwidth-pool1", ("bandwidth_pool1", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1))])
                        self._leafs = OrderedDict([
                            ('bandwidth_direction', (YLeaf(YType.enumeration, 'bandwidth-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                            ('is_admission_method_allocated_bandwidth', (YLeaf(YType.boolean, 'is-admission-method-allocated-bandwidth'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ])
                        self.bandwidth_direction = None
                        self.is_admission_method_allocated_bandwidth = None
                        self.bandwidth_units = None

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)
                        self._segment_path = lambda: "upstream-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, ['bandwidth_direction', 'is_admission_method_allocated_bandwidth', 'bandwidth_units'], name, value)


                    class BandwidthPool0(_Entity_):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "upstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool0"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0']['meta_info']


                    class BandwidthPool1(_Entity_):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "upstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool1"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth']['meta_info']


                class DownstreamBandwidth(_Entity_):
                    """
                    BW info in the dnstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__init__()

                        self.yang_name = "downstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-pool0", ("bandwidth_pool0", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0)), ("bandwidth-pool1", ("bandwidth_pool1", MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1))])
                        self._leafs = OrderedDict([
                            ('bandwidth_direction', (YLeaf(YType.enumeration, 'bandwidth-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                            ('is_admission_method_allocated_bandwidth', (YLeaf(YType.boolean, 'is-admission-method-allocated-bandwidth'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ])
                        self.bandwidth_direction = None
                        self.is_admission_method_allocated_bandwidth = None
                        self.bandwidth_units = None

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)
                        self._segment_path = lambda: "downstream-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, ['bandwidth_direction', 'is_admission_method_allocated_bandwidth', 'bandwidth_units'], name, value)


                    class BandwidthPool0(_Entity_):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "downstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool0"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0']['meta_info']


                    class BandwidthPool1(_Entity_):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "downstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool1"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth']['meta_info']


                class FloodingUpThreshold(_Entity_):
                    """
                    Flooding up\-thresholds
                    
                    .. attribute:: entry
                    
                    	Flooding up\-thresholds
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__init__()

                        self.yang_name = "flooding-up-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "flooding-up-threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold']['meta_info']


                class FloodingDownThreshold(_Entity_):
                    """
                    Flooding down\-thresholds
                    
                    .. attribute:: entry
                    
                    	Flooding down\-thresholds
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__init__()

                        self.yang_name = "flooding-down-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "flooding-down-threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.BandwidthAllocation.BandwidthAllocationLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.BandwidthAllocation']['meta_info']


    class Gmpls(_Entity_):
        """
        GMPLS data
        
        .. attribute:: nni
        
        	GMPLS NNI data
        	**type**\:  :py:class:`Nni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni>`
        
        	**config**\: False
        
        .. attribute:: uni
        
        	GMPLS UNI data
        	**type**\:  :py:class:`Uni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.Gmpls, self).__init__()

            self.yang_name = "gmpls"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("nni", ("nni", MplsLcacStandby.Gmpls.Nni)), ("uni", ("uni", MplsLcacStandby.Gmpls.Uni))])
            self._leafs = OrderedDict()

            self.nni = MplsLcacStandby.Gmpls.Nni()
            self.nni.parent = self
            self._children_name_map["nni"] = "nni"

            self.uni = MplsLcacStandby.Gmpls.Uni()
            self.uni.parent = self
            self._children_name_map["uni"] = "uni"
            self._segment_path = lambda: "gmpls"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.Gmpls, [], name, value)


        class Nni(_Entity_):
            """
            GMPLS NNI data
            
            .. attribute:: otn
            
            	GMPLS OTN\-NNI data
            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Gmpls.Nni, self).__init__()

                self.yang_name = "nni"
                self.yang_parent_name = "gmpls"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("otn", ("otn", MplsLcacStandby.Gmpls.Nni.Otn))])
                self._leafs = OrderedDict()

                self.otn = MplsLcacStandby.Gmpls.Nni.Otn()
                self.otn.parent = self
                self._children_name_map["otn"] = "otn"
                self._segment_path = lambda: "nni"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Gmpls.Nni, [], name, value)


            class Otn(_Entity_):
                """
                GMPLS OTN\-NNI data
                
                .. attribute:: advertisements
                
                	GMPLS OTN\-NNI advertisement information
                	**type**\:  :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements>`
                
                	**config**\: False
                
                .. attribute:: summary
                
                	GMPLS NNI OTN summary information
                	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Summary>`
                
                	**config**\: False
                
                .. attribute:: controllers
                
                	GMPLS OTN\-NNI controllers
                	**type**\:  :py:class:`Controllers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers>`
                
                	**config**\: False
                
                .. attribute:: admission_controls
                
                	GMPLS OTN\-NNI admission control table
                	**type**\:  :py:class:`AdmissionControls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Gmpls.Nni.Otn, self).__init__()

                    self.yang_name = "otn"
                    self.yang_parent_name = "nni"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("advertisements", ("advertisements", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements)), ("summary", ("summary", MplsLcacStandby.Gmpls.Nni.Otn.Summary)), ("controllers", ("controllers", MplsLcacStandby.Gmpls.Nni.Otn.Controllers)), ("admission-controls", ("admission_controls", MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls))])
                    self._leafs = OrderedDict()

                    self.advertisements = MplsLcacStandby.Gmpls.Nni.Otn.Advertisements()
                    self.advertisements.parent = self
                    self._children_name_map["advertisements"] = "advertisements"

                    self.summary = MplsLcacStandby.Gmpls.Nni.Otn.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"

                    self.controllers = MplsLcacStandby.Gmpls.Nni.Otn.Controllers()
                    self.controllers.parent = self
                    self._children_name_map["controllers"] = "controllers"

                    self.admission_controls = MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls()
                    self.admission_controls.parent = self
                    self._children_name_map["admission_controls"] = "admission-controls"
                    self._segment_path = lambda: "otn"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn, [], name, value)


                class Advertisements(_Entity_):
                    """
                    GMPLS OTN\-NNI advertisement information
                    
                    .. attribute:: flooding_status_message
                    
                    	Flooding status\: ready or reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooding_time
                    
                    	Time elapsed since last flooding in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: last_flooding_trigger
                    
                    	Trigger for last flooding
                    	**type**\:  :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_flooding_time
                    
                    	Time remained for next flooding in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: ds_te_mode
                    
                    	DS\-TE Mode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: advertized_areas
                    
                    	Advertising info for all the IGP areas
                    	**type**\: list of  		 :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements, self).__init__()

                        self.yang_name = "advertisements"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("advertized-areas", ("advertized_areas", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas))])
                        self._leafs = OrderedDict([
                            ('flooding_status_message', (YLeaf(YType.str, 'flooding-status-message'), ['str'])),
                            ('last_flooding_time', (YLeaf(YType.uint32, 'last-flooding-time'), ['int'])),
                            ('last_flooding_trigger', (YLeaf(YType.enumeration, 'last-flooding-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FloodingTrigger', '')])),
                            ('next_flooding_time', (YLeaf(YType.uint32, 'next-flooding-time'), ['int'])),
                            ('ds_te_mode', (YLeaf(YType.enumeration, 'ds-te-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.flooding_status_message = None
                        self.last_flooding_time = None
                        self.last_flooding_trigger = None
                        self.next_flooding_time = None
                        self.ds_te_mode = None

                        self.advertized_areas = YList(self)
                        self._segment_path = lambda: "advertisements"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements, ['flooding_status_message', 'last_flooding_time', 'last_flooding_trigger', 'next_flooding_time', 'ds_te_mode'], name, value)


                    class AdvertizedAreas(_Entity_):
                        """
                        Advertising info for all the IGP areas
                        
                        .. attribute:: igp_area_id
                        
                        	The area id
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protocol
                        
                        	The IGP protocol running over this area
                        	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                        
                        	**config**\: False
                        
                        .. attribute:: system_id
                        
                        	The node's system id
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: router_id
                        
                        	The node's router ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: flooded_link
                        
                        	The array of flooded links in this area
                        	**type**\: list of  		 :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas, self).__init__()

                            self.yang_name = "advertized-areas"
                            self.yang_parent_name = "advertisements"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flooded-link", ("flooded_link", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink))])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                                ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                                ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                            ])
                            self.igp_area_id = None
                            self.protocol = None
                            self.system_id = None
                            self.router_id = None

                            self.flooded_link = YList(self)
                            self._segment_path = lambda: "advertized-areas"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas, ['igp_area_id', 'protocol', 'system_id', 'router_id'], name, value)


                        class FloodedLink(_Entity_):
                            """
                            The array of flooded links in this area
                            
                            .. attribute:: odu_link_capabilities
                            
                            	ODU Link Capabilities
                            	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                            
                            	**config**\: False
                            
                            .. attribute:: link_id
                            
                            	The link's id
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	The link's interface name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: link_address
                            
                            	The link's IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: subnet_type
                            
                            	The link's subnet type
                            	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_interface_id
                            
                            	The link's outgoing interface's id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_designated_router
                            
                            	TRUE if the link belongs to a desig. router
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: designated_router_igp_id
                            
                            	IGP id of the designated router
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbor_igp_id
                            
                            	The neighbor's IGP id
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: igp_neighbor_address
                            
                            	The neighbor's ip address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_interface_id
                            
                            	The link's incoming interface's id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: te_metric
                            
                            	The link's TE metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	The link's IGP metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay
                            
                            	Unidirectional Link Delay in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_units
                            
                            	The link's bandwidth units
                            	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: physical_bandwidth
                            
                            	The link's physical BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bcm_id
                            
                            	Bandwidth Constraints Model ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: link_maximum_reservable_bandwidth
                            
                            	The link's maximum reservable BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reservable_pool0_bandwidth
                            
                            	The link's reservable pool0 BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reservable_pool1_bandwidth
                            
                            	The link's reservable pool1 BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_receiving_reservable_bandwidth_enabled
                            
                            	TRUE if receiving reservable BW is enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: receiving_direction
                            
                            	Upstream or Downstream
                            	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_transmitting_reservable_bandwidth_enabled
                            
                            	TRUE if transmitting reservable BW is enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: transmitting_direction
                            
                            	Upstream or Downstream
                            	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_attribute_flags
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: extended_affinity_attribute_flag
                            
                            	The link's extended affinity bits
                            	**type**\: list of  		 :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                            
                            	**config**\: False
                            
                            .. attribute:: shared_risk_link_group
                            
                            	The link's shared risk link groups
                            	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                            
                            	**config**\: False
                            
                            .. attribute:: receiving_reservable_bandwidth
                            
                            	Receiving reservable BW at each priority level(priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: transmitting_reservable_bandwidth
                            
                            	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                                self.yang_name = "flooded-link"
                                self.yang_parent_name = "advertized-areas"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-link-capabilities", ("odu_link_capabilities", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities)), ("extended-affinity-attribute-flag", ("extended_affinity_attribute_flag", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup)), ("receiving-reservable-bandwidth", ("receiving_reservable_bandwidth", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth)), ("transmitting-reservable-bandwidth", ("transmitting_reservable_bandwidth", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth))])
                                self._leafs = OrderedDict([
                                    ('link_id', (YLeaf(YType.uint16, 'link-id'), ['int'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                                    ('subnet_type', (YLeaf(YType.enumeration, 'subnet-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                                    ('outgoing_interface_id', (YLeaf(YType.uint32, 'outgoing-interface-id'), ['int'])),
                                    ('is_designated_router', (YLeaf(YType.boolean, 'is-designated-router'), ['bool'])),
                                    ('designated_router_igp_id', (YLeaf(YType.str, 'designated-router-igp-id'), ['str'])),
                                    ('neighbor_igp_id', (YLeaf(YType.str, 'neighbor-igp-id'), ['str'])),
                                    ('igp_neighbor_address', (YLeaf(YType.str, 'igp-neighbor-address'), ['str'])),
                                    ('incoming_interface_id', (YLeaf(YType.uint32, 'incoming-interface-id'), ['int'])),
                                    ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                                    ('uni_link_delay', (YLeaf(YType.uint32, 'uni-link-delay'), ['int'])),
                                    ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                                    ('physical_bandwidth', (YLeaf(YType.uint32, 'physical-bandwidth'), ['int'])),
                                    ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                                    ('link_maximum_reservable_bandwidth', (YLeaf(YType.uint32, 'link-maximum-reservable-bandwidth'), ['int'])),
                                    ('reservable_pool0_bandwidth', (YLeaf(YType.uint32, 'reservable-pool0-bandwidth'), ['int'])),
                                    ('reservable_pool1_bandwidth', (YLeaf(YType.uint32, 'reservable-pool1-bandwidth'), ['int'])),
                                    ('is_receiving_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-receiving-reservable-bandwidth-enabled'), ['bool'])),
                                    ('receiving_direction', (YLeaf(YType.enumeration, 'receiving-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                                    ('is_transmitting_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-transmitting-reservable-bandwidth-enabled'), ['bool'])),
                                    ('transmitting_direction', (YLeaf(YType.enumeration, 'transmitting-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                                    ('affinity_attribute_flags', (YLeaf(YType.uint32, 'affinity-attribute-flags'), ['int'])),
                                ])
                                self.link_id = None
                                self.interface_name = None
                                self.link_address = None
                                self.subnet_type = None
                                self.outgoing_interface_id = None
                                self.is_designated_router = None
                                self.designated_router_igp_id = None
                                self.neighbor_igp_id = None
                                self.igp_neighbor_address = None
                                self.incoming_interface_id = None
                                self.te_metric = None
                                self.igp_metric = None
                                self.uni_link_delay = None
                                self.bandwidth_units = None
                                self.physical_bandwidth = None
                                self.bcm_id = None
                                self.link_maximum_reservable_bandwidth = None
                                self.reservable_pool0_bandwidth = None
                                self.reservable_pool1_bandwidth = None
                                self.is_receiving_reservable_bandwidth_enabled = None
                                self.receiving_direction = None
                                self.is_transmitting_reservable_bandwidth_enabled = None
                                self.transmitting_direction = None
                                self.affinity_attribute_flags = None

                                self.odu_link_capabilities = MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                                self.odu_link_capabilities.parent = self
                                self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                                self.extended_affinity_attribute_flag = YList(self)
                                self.shared_risk_link_group = YList(self)
                                self.receiving_reservable_bandwidth = YList(self)
                                self.transmitting_reservable_bandwidth = YList(self)
                                self._segment_path = lambda: "flooded-link"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink, ['link_id', 'interface_name', 'link_address', 'subnet_type', 'outgoing_interface_id', 'is_designated_router', 'designated_router_igp_id', 'neighbor_igp_id', 'igp_neighbor_address', 'incoming_interface_id', 'te_metric', 'igp_metric', 'uni_link_delay', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'link_maximum_reservable_bandwidth', 'reservable_pool0_bandwidth', 'reservable_pool1_bandwidth', 'is_receiving_reservable_bandwidth_enabled', 'receiving_direction', 'is_transmitting_reservable_bandwidth_enabled', 'transmitting_direction', 'affinity_attribute_flags'], name, value)


                            class OduLinkCapabilities(_Entity_):
                                """
                                ODU Link Capabilities
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Max LSP Bandwidth per priority in kbit/s
                                	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_capability
                                
                                	ODU Capabilities of Link
                                	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                                    self.yang_name = "odu-link-capabilities"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability))])
                                    self._leafs = OrderedDict()

                                    self.max_lsp_bandwidth = YList(self)
                                    self.odu_capability = YList(self)
                                    self._segment_path = lambda: "odu-link-capabilities"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, [], name, value)


                                class MaxLspBandwidth(_Entity_):
                                    """
                                    Max LSP Bandwidth per priority in kbit/s
                                    
                                    .. attribute:: entry
                                    
                                    	Max LSP Bandwidth per priority in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                                        self.yang_name = "max-lsp-bandwidth"
                                        self.yang_parent_name = "odu-link-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = False
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "max-lsp-bandwidth"
                                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                                class OduCapability(_Entity_):
                                    """
                                    ODU Capabilities of Link
                                    
                                    .. attribute:: bandwidth_info
                                    
                                    	Bandwidth related info for this ODU level
                                    	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: signal_type
                                    
                                    	Signal Type
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage1
                                    
                                    	ODU Type at stage 1, Not Set for HO ODU
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage2
                                    
                                    	ODU Type at stage 2, Not Set for single stage mulitplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage3
                                    
                                    	ODU Type at stage 3, Not set up to two levels of multiplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage4
                                    
                                    	ODU Type at stage 4, Not set up to three levels of multiplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: terminable
                                    
                                    	True if link is terminable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: switchable
                                    
                                    	True if link is switchable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsg1p25
                                    
                                    	True if link supports 1.25G TSG for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsg2p5
                                    
                                    	True if link supports 2.5G TSG for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: vcat_capable
                                    
                                    	True if link VCAT capable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lcas_capable
                                    
                                    	True if link LCAS capable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                                        self.yang_name = "odu-capability"
                                        self.yang_parent_name = "odu-link-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = False
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                                        self._leafs = OrderedDict([
                                            ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                            ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                            ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                            ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                            ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                            ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                                        ])
                                        self.signal_type = None
                                        self.stage1 = None
                                        self.stage2 = None
                                        self.stage3 = None
                                        self.stage4 = None
                                        self.terminable = None
                                        self.switchable = None
                                        self.tsg1p25 = None
                                        self.tsg2p5 = None
                                        self.vcat_capable = None
                                        self.lcas_capable = None

                                        self.bandwidth_info = MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                        self.bandwidth_info.parent = self
                                        self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                        self._segment_path = lambda: "odu-capability"
                                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                                    class BandwidthInfo(_Entity_):
                                        """
                                        Bandwidth related info for this ODU level
                                        
                                        .. attribute:: fixed
                                        
                                        	ODU capability for Fixed ODUs
                                        	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: flex
                                        
                                        	ODU capability for Flex ODUs
                                        	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                            self.yang_name = "bandwidth-info"
                                            self.yang_parent_name = "odu-capability"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = False
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                            ])
                                            self.type = None

                                            self.fixed = MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                            self.fixed.parent = self
                                            self._children_name_map["fixed"] = "fixed"

                                            self.flex = MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                            self.flex.parent = self
                                            self._children_name_map["flex"] = "flex"
                                            self._segment_path = lambda: "bandwidth-info"
                                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self._segment_path()
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                                        class Fixed(_Entity_):
                                            """
                                            ODU capability for Fixed ODUs
                                            
                                            .. attribute:: maximum_od_us
                                            
                                            	Maximum Number of ODUs of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unreserved_od_us
                                            
                                            	Maximum Number of ODUs of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                                self.yang_name = "fixed"
                                                self.yang_parent_name = "bandwidth-info"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = False
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                                    ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                                ])
                                                self.maximum_od_us = None
                                                self.unreserved_od_us = None
                                                self._segment_path = lambda: "fixed"
                                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                                        class Flex(_Entity_):
                                            """
                                            ODU capability for Flex ODUs
                                            
                                            .. attribute:: max_bandwidth
                                            
                                            	Max kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: unreserved_bandwidth
                                            
                                            	Unreserved kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: max_lsp_bandwidth
                                            
                                            	Per LSP Max kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                                self.yang_name = "flex"
                                                self.yang_parent_name = "bandwidth-info"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = False
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                                    ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                                    ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                                ])
                                                self.max_bandwidth = None
                                                self.unreserved_bandwidth = None
                                                self.max_lsp_bandwidth = None
                                                self._segment_path = lambda: "flex"
                                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities']['meta_info']


                            class ExtendedAffinityAttributeFlag(_Entity_):
                                """
                                The link's extended affinity bits
                                
                                .. attribute:: entry
                                
                                	The link's extended affinity bits
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                                    self.yang_name = "extended-affinity-attribute-flag"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-affinity-attribute-flag"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag']['meta_info']


                            class SharedRiskLinkGroup(_Entity_):
                                """
                                The link's shared risk link groups
                                
                                .. attribute:: shared_risk_group
                                
                                	SRLG number
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_name
                                
                                	SRLG name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                                    self.yang_name = "shared-risk-link-group"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ])
                                    self.shared_risk_group = None
                                    self.srlg_name = None
                                    self._segment_path = lambda: "shared-risk-link-group"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup']['meta_info']


                            class ReceivingReservableBandwidth(_Entity_):
                                """
                                Receiving reservable BW at each priority
                                level(priority 0 to priority 7)
                                
                                .. attribute:: priority
                                
                                	The priority level of this bandwidth
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pool0_bandwidth
                                
                                	The reservable pool0 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: pool1_bandwidth
                                
                                	The reservable pool1 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                                    self.yang_name = "receiving-reservable-bandwidth"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                                        ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                                        ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                                    ])
                                    self.priority = None
                                    self.pool0_bandwidth = None
                                    self.pool1_bandwidth = None
                                    self._segment_path = lambda: "receiving-reservable-bandwidth"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth']['meta_info']


                            class TransmittingReservableBandwidth(_Entity_):
                                """
                                Transmitting reservable BW at each priority
                                level (priority 0 to priority 7)
                                
                                .. attribute:: priority
                                
                                	The priority level of this bandwidth
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pool0_bandwidth
                                
                                	The reservable pool0 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: pool1_bandwidth
                                
                                	The reservable pool1 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                                    self.yang_name = "transmitting-reservable-bandwidth"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                                        ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                                        ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                                    ])
                                    self.priority = None
                                    self.pool0_bandwidth = None
                                    self.pool1_bandwidth = None
                                    self._segment_path = lambda: "transmitting-reservable-bandwidth"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Advertisements']['meta_info']


                class Summary(_Entity_):
                    """
                    GMPLS NNI OTN summary information
                    
                    .. attribute:: is_role_standby
                    
                    	TRUE if Role is Standby, False if Active
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: nni_otn_links
                    
                    	The number of NNI OTN links
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: nni_otn_links_max
                    
                    	Maximum number of NNI links supported
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Gmpls.Nni.Otn.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                            ('nni_otn_links', (YLeaf(YType.uint16, 'nni-otn-links'), ['int'])),
                            ('nni_otn_links_max', (YLeaf(YType.uint16, 'nni-otn-links-max'), ['int'])),
                        ])
                        self.is_role_standby = None
                        self.nni_otn_links = None
                        self.nni_otn_links_max = None
                        self._segment_path = lambda: "summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Summary, ['is_role_standby', 'nni_otn_links', 'nni_otn_links_max'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Summary']['meta_info']


                class Controllers(_Entity_):
                    """
                    GMPLS OTN\-NNI controllers
                    
                    .. attribute:: controller
                    
                    	A GMPLS OTN\-NNI link
                    	**type**\: list of  		 :py:class:`Controller <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers, self).__init__()

                        self.yang_name = "controllers"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("controller", ("controller", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller))])
                        self._leafs = OrderedDict()

                        self.controller = YList(self)
                        self._segment_path = lambda: "controllers"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers, [], name, value)


                    class Controller(_Entity_):
                        """
                        A GMPLS OTN\-NNI link
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: local_link_id
                        
                        	Local TE link ID
                        	**type**\:  :py:class:`LocalLinkId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId>`
                        
                        	**config**\: False
                        
                        .. attribute:: odu_link_capabilities
                        
                        	ODU capabilities of Link
                        	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_name
                        
                        	The link's name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: interface_handle
                        
                        	Link interface handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link_state
                        
                        	Link state
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: resource_provider
                        
                        	The link's resource provider
                        	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                        
                        	**config**\: False
                        
                        .. attribute:: physical_bandwidth
                        
                        	The link's physical bandwidth
                        	**type**\:  :py:class:`Otu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Otu>`
                        
                        	**config**\: False
                        
                        .. attribute:: tti_mode
                        
                        	SM,PM or TCM mode for controller
                        	**type**\:  :py:class:`TtiMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TtiMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: tandem_connection_monitoring
                        
                        	Tandem connection monitoring to carry link id, 0 if PM
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: igp_neighbors_count
                        
                        	The link's neighbor count
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: link_attributes
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_attribute_incomplete
                        
                        	TRUE if one or more affinity definition(s) is/are         unknown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_name_based_attribute
                        
                        	TRUE, if name based attribute style is in effect
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_extended_attribute
                        
                        	The link's extended attribute bit map
                        	**type**\: list of  		 :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_forwad_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: srl_gs
                        
                        	The link's shared risk link groups
                        	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.SrlGs>`
                        
                        	**config**\: False
                        
                        .. attribute:: igp_areas
                        
                        	Per\-IGP area data
                        	**type**\: list of  		 :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas>`
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_map
                        
                        	Affinity map array
                        	**type**\: list of  		 :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller, self).__init__()

                            self.yang_name = "controller"
                            self.yang_parent_name = "controllers"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("local-link-id", ("local_link_id", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId)), ("odu-link-capabilities", ("odu_link_capabilities", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities)), ("link-extended-attribute", ("link_extended_attribute", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute)), ("link-forwad-ref-value", ("link_forwad_ref_value", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue)), ("srl-gs", ("srl_gs", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.SrlGs)), ("igp-areas", ("igp_areas", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas)), ("affinity-map", ("affinity_map", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('link_name', (YLeaf(YType.str, 'link-name'), ['str'])),
                                ('interface_handle', (YLeaf(YType.str, 'interface-handle'), ['str'])),
                                ('link_state', (YLeaf(YType.enumeration, 'link-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                                ('physical_bandwidth', (YLeaf(YType.enumeration, 'physical-bandwidth'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Otu', '')])),
                                ('tti_mode', (YLeaf(YType.enumeration, 'tti-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TtiMode', '')])),
                                ('tandem_connection_monitoring', (YLeaf(YType.uint8, 'tandem-connection-monitoring'), ['int'])),
                                ('igp_neighbors_count', (YLeaf(YType.uint16, 'igp-neighbors-count'), ['int'])),
                                ('link_attributes', (YLeaf(YType.uint32, 'link-attributes'), ['int'])),
                                ('is_attribute_incomplete', (YLeaf(YType.boolean, 'is-attribute-incomplete'), ['bool'])),
                                ('is_name_based_attribute', (YLeaf(YType.boolean, 'is-name-based-attribute'), ['bool'])),
                            ])
                            self.controller_name = None
                            self.link_name = None
                            self.interface_handle = None
                            self.link_state = None
                            self.resource_provider = None
                            self.physical_bandwidth = None
                            self.tti_mode = None
                            self.tandem_connection_monitoring = None
                            self.igp_neighbors_count = None
                            self.link_attributes = None
                            self.is_attribute_incomplete = None
                            self.is_name_based_attribute = None

                            self.local_link_id = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId()
                            self.local_link_id.parent = self
                            self._children_name_map["local_link_id"] = "local-link-id"

                            self.odu_link_capabilities = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                            self.link_extended_attribute = YList(self)
                            self.link_forwad_ref_value = YList(self)
                            self.srl_gs = YList(self)
                            self.igp_areas = YList(self)
                            self.affinity_map = YList(self)
                            self._segment_path = lambda: "controller" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/controllers/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller, ['controller_name', 'link_name', 'interface_handle', 'link_state', 'resource_provider', 'physical_bandwidth', 'tti_mode', 'tandem_connection_monitoring', 'igp_neighbors_count', 'link_attributes', 'is_attribute_incomplete', 'is_name_based_attribute'], name, value)


                        class LocalLinkId(_Entity_):
                            """
                            Local TE link ID
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId, self).__init__()

                                self.yang_name = "local-link-id"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "local-link-id"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "local-link-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId']['meta_info']


                        class OduLinkCapabilities(_Entity_):
                            """
                            ODU capabilities of Link
                            
                            .. attribute:: max_lsp_bandwidth
                            
                            	Max LSP Bandwidth per priority in kbit/s
                            	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_capability
                            
                            	ODU Capabilities of Link
                            	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities, self).__init__()

                                self.yang_name = "odu-link-capabilities"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability))])
                                self._leafs = OrderedDict()

                                self.max_lsp_bandwidth = YList(self)
                                self.odu_capability = YList(self)
                                self._segment_path = lambda: "odu-link-capabilities"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities, [], name, value)


                            class MaxLspBandwidth(_Entity_):
                                """
                                Max LSP Bandwidth per priority in kbit/s
                                
                                .. attribute:: entry
                                
                                	Max LSP Bandwidth per priority in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                                    self.yang_name = "max-lsp-bandwidth"
                                    self.yang_parent_name = "odu-link-capabilities"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "max-lsp-bandwidth"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                            class OduCapability(_Entity_):
                                """
                                ODU Capabilities of Link
                                
                                .. attribute:: bandwidth_info
                                
                                	Bandwidth related info for this ODU level
                                	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage1
                                
                                	ODU Type at stage 1, Not Set for HO ODU
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage2
                                
                                	ODU Type at stage 2, Not Set for single stage mulitplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage3
                                
                                	ODU Type at stage 3, Not set up to two levels of multiplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage4
                                
                                	ODU Type at stage 4, Not set up to three levels of multiplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: terminable
                                
                                	True if link is terminable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: switchable
                                
                                	True if link is switchable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: tsg1p25
                                
                                	True if link supports 1.25G TSG for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: tsg2p5
                                
                                	True if link supports 2.5G TSG for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: vcat_capable
                                
                                	True if link VCAT capable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lcas_capable
                                
                                	True if link LCAS capable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability, self).__init__()

                                    self.yang_name = "odu-capability"
                                    self.yang_parent_name = "odu-link-capabilities"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                        ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                        ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                        ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                        ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                        ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                                    ])
                                    self.signal_type = None
                                    self.stage1 = None
                                    self.stage2 = None
                                    self.stage3 = None
                                    self.stage4 = None
                                    self.terminable = None
                                    self.switchable = None
                                    self.tsg1p25 = None
                                    self.tsg2p5 = None
                                    self.vcat_capable = None
                                    self.lcas_capable = None

                                    self.bandwidth_info = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                    self._segment_path = lambda: "odu-capability"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                                class BandwidthInfo(_Entity_):
                                    """
                                    Bandwidth related info for this ODU level
                                    
                                    .. attribute:: fixed
                                    
                                    	ODU capability for Fixed ODUs
                                    	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: flex
                                    
                                    	ODU capability for Flex ODUs
                                    	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                        self.yang_name = "bandwidth-info"
                                        self.yang_parent_name = "odu-capability"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                        ])
                                        self.type = None

                                        self.fixed = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"

                                        self.flex = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                        self._segment_path = lambda: "bandwidth-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                                    class Fixed(_Entity_):
                                        """
                                        ODU capability for Fixed ODUs
                                        
                                        .. attribute:: maximum_od_us
                                        
                                        	Maximum Number of ODUs of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreserved_od_us
                                        
                                        	Maximum Number of ODUs of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                            self.yang_name = "fixed"
                                            self.yang_parent_name = "bandwidth-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                                ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                            ])
                                            self.maximum_od_us = None
                                            self.unreserved_od_us = None
                                            self._segment_path = lambda: "fixed"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                                    class Flex(_Entity_):
                                        """
                                        ODU capability for Flex ODUs
                                        
                                        .. attribute:: max_bandwidth
                                        
                                        	Max kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: unreserved_bandwidth
                                        
                                        	Unreserved kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: max_lsp_bandwidth
                                        
                                        	Per LSP Max kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                            self.yang_name = "flex"
                                            self.yang_parent_name = "bandwidth-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                                ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                                ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                            ])
                                            self.max_bandwidth = None
                                            self.unreserved_bandwidth = None
                                            self.max_lsp_bandwidth = None
                                            self._segment_path = lambda: "flex"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities']['meta_info']


                        class LinkExtendedAttribute(_Entity_):
                            """
                            The link's extended attribute bit map
                            
                            .. attribute:: entry
                            
                            	The link's extended attribute bit map
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute, self).__init__()

                                self.yang_name = "link-extended-attribute"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "link-extended-attribute"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute']['meta_info']


                        class LinkForwadRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue, self).__init__()

                                self.yang_name = "link-forwad-ref-value"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "link-forwad-ref-value"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue']['meta_info']


                        class SrlGs(_Entity_):
                            """
                            The link's shared risk link groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.SrlGs, self).__init__()

                                self.yang_name = "srl-gs"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "srl-gs"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.SrlGs, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.SrlGs']['meta_info']


                        class IgpAreas(_Entity_):
                            """
                            Per\-IGP area data
                            
                            .. attribute:: remote_te_link_id
                            
                            	Remote link id in this topology instance
                            	**type**\:  :py:class:`RemoteTeLinkId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_type
                            
                            	IGP type
                            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_instance_id
                            
                            	Igp instance ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_id_format
                            
                            	Igp area id format
                            	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_id
                            
                            	Igp area id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: te_metric
                            
                            	The link's TE metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_configured
                            
                            	Unidirectional Link Delay configured in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_computed
                            
                            	Unidirectional Link Delay computed in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_to_flood
                            
                            	Unidirectional Link Delay to flood in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reason_not_flooded
                            
                            	Reason why link is not flooded
                            	**type**\:  :py:class:`MplsTeReasonNotFlooded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReasonNotFlooded>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_address
                            
                            	IGP's area IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas, self).__init__()

                                self.yang_name = "igp-areas"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("remote-te-link-id", ("remote_te_link_id", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId))])
                                self._leafs = OrderedDict([
                                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                                    ('igp_instance_id', (YLeaf(YType.str, 'igp-instance-id'), ['str'])),
                                    ('igp_area_id_format', (YLeaf(YType.enumeration, 'igp-area-id-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                                    ('igp_area_id', (YLeaf(YType.uint32, 'igp-area-id'), ['int'])),
                                    ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                                    ('uni_link_delay_configured', (YLeaf(YType.uint32, 'uni-link-delay-configured'), ['int'])),
                                    ('uni_link_delay_computed', (YLeaf(YType.uint32, 'uni-link-delay-computed'), ['int'])),
                                    ('uni_link_delay_to_flood', (YLeaf(YType.uint32, 'uni-link-delay-to-flood'), ['int'])),
                                    ('reason_not_flooded', (YLeaf(YType.enumeration, 'reason-not-flooded'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReasonNotFlooded', '')])),
                                    ('igp_area_address', (YLeaf(YType.str, 'igp-area-address'), ['str'])),
                                ])
                                self.igp_type = None
                                self.igp_instance_id = None
                                self.igp_area_id_format = None
                                self.igp_area_id = None
                                self.te_metric = None
                                self.uni_link_delay_configured = None
                                self.uni_link_delay_computed = None
                                self.uni_link_delay_to_flood = None
                                self.reason_not_flooded = None
                                self.igp_area_address = None

                                self.remote_te_link_id = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId()
                                self.remote_te_link_id.parent = self
                                self._children_name_map["remote_te_link_id"] = "remote-te-link-id"
                                self._segment_path = lambda: "igp-areas"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas, ['igp_type', 'igp_instance_id', 'igp_area_id_format', 'igp_area_id', 'te_metric', 'uni_link_delay_configured', 'uni_link_delay_computed', 'uni_link_delay_to_flood', 'reason_not_flooded', 'igp_area_address'], name, value)


                            class RemoteTeLinkId(_Entity_):
                                """
                                Remote link id in this topology instance
                                
                                .. attribute:: te_addr
                                
                                	TE Address
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId, self).__init__()

                                    self.yang_name = "remote-te-link-id"
                                    self.yang_parent_name = "igp-areas"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr))])
                                    self._leafs = OrderedDict()

                                    self.te_addr = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                    self._segment_path = lambda: "remote-te-link-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId, [], name, value)


                                class TeAddr(_Entity_):
                                    """
                                    TE Address
                                    
                                    .. attribute:: ipv4_unnumbered_address
                                    
                                    	IPv4 unnumbered address
                                    	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv4_address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr, self).__init__()

                                        self.yang_name = "te-addr"
                                        self.yang_parent_name = "remote-te-link-id"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                        ])
                                        self.type = None
                                        self.ipv4_address = None

                                        self.ipv4_unnumbered_address = MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        self._segment_path = lambda: "te-addr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr, ['type', 'ipv4_address'], name, value)


                                    class Ipv4UnnumberedAddress(_Entity_):
                                        """
                                        IPv4 unnumbered address
                                        
                                        .. attribute:: router_id
                                        
                                        	IPv4 router ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_index
                                        
                                        	Interface index
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                            self.yang_name = "ipv4-unnumbered-address"
                                            self.yang_parent_name = "te-addr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                                ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                            ])
                                            self.router_id = None
                                            self.interface_index = None
                                            self._segment_path = lambda: "ipv4-unnumbered-address"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas']['meta_info']


                        class AffinityMap(_Entity_):
                            """
                            Affinity map array
                            
                            .. attribute:: affinity_name
                            
                            	Affinity name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_value
                            
                            	Affinity value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_bit_position
                            
                            	Affinity bit position
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_table_id
                            
                            	Affinity table id
                            	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_extended_value
                            
                            	EAG value
                            	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap, self).__init__()

                                self.yang_name = "affinity-map"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue))])
                                self._leafs = OrderedDict([
                                    ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                                    ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                                    ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                                    ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                                ])
                                self.affinity_name = None
                                self.affinity_value = None
                                self.affinity_bit_position = None
                                self.affinity_table_id = None

                                self.affinity_extended_value = YList(self)
                                self._segment_path = lambda: "affinity-map"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


                            class AffinityExtendedValue(_Entity_):
                                """
                                EAG value
                                
                                .. attribute:: entry
                                
                                	EAG value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue, self).__init__()

                                    self.yang_name = "affinity-extended-value"
                                    self.yang_parent_name = "affinity-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "affinity-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers.Controller']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.Controllers']['meta_info']


                class AdmissionControls(_Entity_):
                    """
                    GMPLS OTN\-NNI admission control table
                    
                    .. attribute:: admission_control
                    
                    	GMPLS OTN\-NNI admitted tunnels for a given controller
                    	**type**\: list of  		 :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls, self).__init__()

                        self.yang_name = "admission-controls"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("admission-control", ("admission_control", MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl))])
                        self._leafs = OrderedDict()

                        self.admission_control = YList(self)
                        self._segment_path = lambda: "admission-controls"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls, [], name, value)


                    class AdmissionControl(_Entity_):
                        """
                        GMPLS OTN\-NNI admitted tunnels for a given
                        controller
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link_name
                        
                        	The link's name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: admitted_s2l
                        
                        	Admitted S2Ls
                        	**type**\: list of  		 :py:class:`AdmittedS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl, self).__init__()

                            self.yang_name = "admission-control"
                            self.yang_parent_name = "admission-controls"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("admitted-s2l", ("admitted_s2l", MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('link_name', (YLeaf(YType.str, 'link-name'), ['str'])),
                            ])
                            self.controller_name = None
                            self.link_name = None

                            self.admitted_s2l = YList(self)
                            self._segment_path = lambda: "admission-control" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/nni/otn/admission-controls/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl, ['controller_name', 'link_name'], name, value)


                        class AdmittedS2l(_Entity_):
                            """
                            Admitted S2Ls
                            
                            .. attribute:: s2l_fec
                            
                            	S2L FEC
                            	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l, self).__init__()

                                self.yang_name = "admitted-s2l"
                                self.yang_parent_name = "admission-control"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec))])
                                self._leafs = OrderedDict()

                                self.s2l_fec = MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                                self._segment_path = lambda: "admitted-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l, [], name, value)


                            class S2lFec(_Entity_):
                                """
                                S2L FEC
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec, self).__init__()

                                    self.yang_name = "s2l-fec"
                                    self.yang_parent_name = "admitted-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "s2l-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn.AdmissionControls']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Gmpls.Nni.Otn']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Gmpls.Nni']['meta_info']


        class Uni(_Entity_):
            """
            GMPLS UNI data
            
            .. attribute:: wdm
            
            	GMPLS WDM\-UNI data
            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.Gmpls.Uni, self).__init__()

                self.yang_name = "uni"
                self.yang_parent_name = "gmpls"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcacStandby.Gmpls.Uni.Wdm))])
                self._leafs = OrderedDict()

                self.wdm = MplsLcacStandby.Gmpls.Uni.Wdm()
                self.wdm.parent = self
                self._children_name_map["wdm"] = "wdm"
                self._segment_path = lambda: "uni"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.Gmpls.Uni, [], name, value)


            class Wdm(_Entity_):
                """
                GMPLS WDM\-UNI data
                
                .. attribute:: controllers
                
                	GMPLS WDM\-UNI controllers
                	**type**\:  :py:class:`Controllers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.Gmpls.Uni.Wdm, self).__init__()

                    self.yang_name = "wdm"
                    self.yang_parent_name = "uni"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("controllers", ("controllers", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers))])
                    self._leafs = OrderedDict()

                    self.controllers = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers()
                    self.controllers.parent = self
                    self._children_name_map["controllers"] = "controllers"
                    self._segment_path = lambda: "wdm"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/uni/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm, [], name, value)


                class Controllers(_Entity_):
                    """
                    GMPLS WDM\-UNI controllers
                    
                    .. attribute:: controller
                    
                    	A TE GMPLS\-UNI WDM controller
                    	**type**\: list of  		 :py:class:`Controller <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers, self).__init__()

                        self.yang_name = "controllers"
                        self.yang_parent_name = "wdm"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("controller", ("controller", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller))])
                        self._leafs = OrderedDict()

                        self.controller = YList(self)
                        self._segment_path = lambda: "controllers"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/uni/wdm/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers, [], name, value)


                    class Controller(_Entity_):
                        """
                        A TE GMPLS\-UNI WDM controller
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link
                        
                        	Link properties
                        	**type**\:  :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link>`
                        
                        	**config**\: False
                        
                        .. attribute:: labels
                        
                        	Labels
                        	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel
                        
                        	Tunnel info
                        	**type**\:  :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel>`
                        
                        	**config**\: False
                        
                        .. attribute:: controller_name_xr
                        
                        	Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: controller_name_brief
                        
                        	Brief Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: child_interface_name
                        
                        	Child interface name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: child_interface_state
                        
                        	Child Interface State
                        	**type**\:  :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ImStateEnum>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller, self).__init__()

                            self.yang_name = "controller"
                            self.yang_parent_name = "controllers"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("link", ("link", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link)), ("labels", ("labels", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels)), ("tunnel", ("tunnel", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('controller_name_xr', (YLeaf(YType.str, 'controller-name-xr'), ['str'])),
                                ('controller_name_brief', (YLeaf(YType.str, 'controller-name-brief'), ['str'])),
                                ('child_interface_name', (YLeaf(YType.str, 'child-interface-name'), ['str'])),
                                ('child_interface_state', (YLeaf(YType.enumeration, 'child-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ImStateEnum', '')])),
                            ])
                            self.controller_name = None
                            self.controller_name_xr = None
                            self.controller_name_brief = None
                            self.child_interface_name = None
                            self.child_interface_state = None

                            self.link = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link()
                            self.link.parent = self
                            self._children_name_map["link"] = "link"

                            self.labels = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels()
                            self.labels.parent = self
                            self._children_name_map["labels"] = "labels"

                            self.tunnel = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel()
                            self.tunnel.parent = self
                            self._children_name_map["tunnel"] = "tunnel"
                            self._segment_path = lambda: "controller" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/gmpls/uni/wdm/controllers/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller, ['controller_name', 'controller_name_xr', 'controller_name_brief', 'child_interface_name', 'child_interface_state'], name, value)


                        class Link(_Entity_):
                            """
                            Link properties
                            
                            .. attribute:: wdm_capabilities
                            
                            	WDM capabilities
                            	**type**\:  :py:class:`WdmCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities>`
                            
                            	**config**\: False
                            
                            .. attribute:: link_exists
                            
                            	Flag to indicate whether the link exists in the system
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: admin_state_up
                            
                            	Is the interface administratively UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oper_state_up
                            
                            	Is the interface operationally UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bw_locked_upstream
                            
                            	Is the interface bandwidth locked in the upstream direction
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bw_locked_downstream
                            
                            	Is the interface bandwidth locked in the downstream direction
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: admitted_lsp_id
                            
                            	LSP\-ID admitted on this optical link. Not valid if neither the upstream nor downstream bandwidth is locked
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_router_id
                            
                            	LMP GMPLS Optical\-UNI router\-id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_adj_state_up
                            
                            	Is the LMP optical adjacency UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lmpipcc_state_up
                            
                            	If the LMP IP control channel up ?
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_name
                            
                            	LMP neighbor Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_router_id
                            
                            	LMP neighbor router ID addres
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_ipcc_address
                            
                            	The LMP neighbor's IPCC address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_ipcc_address
                            
                            	The LMP local IPCC address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_interface_id
                            
                            	The LMP local interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_interface_id
                            
                            	The LMP neighbor interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_link_id
                            
                            	The LMP local Link ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_link_id
                            
                            	The LMP neighbor Link ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_switching_capability
                            
                            	The LMP local link switching capability
                            	**type**\:  :py:class:`IgpteLinkSwitchCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkSwitchCapability>`
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_switching_capability
                            
                            	The LMP neighbor link switching capability
                            	**type**\:  :py:class:`IgpteLinkSwitchCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkSwitchCapability>`
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_encoding
                            
                            	The LMP local link encoding type
                            	**type**\:  :py:class:`IgpteLinkEncodingProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkEncodingProtocol>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_link_gpid
                            
                            	The GPID of the local link
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: srl_gs_announced
                            
                            	TRUE if discovered SRLGs are announced to L3 interface
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_announced_interface
                            
                            	The L3 interface that discovered SRLGs are announced to
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_srlg
                            
                            	Locally\-configured SRLGs on this link
                            	**type**\: list of  		 :py:class:`LocalSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link, self).__init__()

                                self.yang_name = "link"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm-capabilities", ("wdm_capabilities", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities)), ("local-srlg", ("local_srlg", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg))])
                                self._leafs = OrderedDict([
                                    ('link_exists', (YLeaf(YType.boolean, 'link-exists'), ['bool'])),
                                    ('admin_state_up', (YLeaf(YType.boolean, 'admin-state-up'), ['bool'])),
                                    ('oper_state_up', (YLeaf(YType.boolean, 'oper-state-up'), ['bool'])),
                                    ('bw_locked_upstream', (YLeaf(YType.boolean, 'bw-locked-upstream'), ['bool'])),
                                    ('bw_locked_downstream', (YLeaf(YType.boolean, 'bw-locked-downstream'), ['bool'])),
                                    ('admitted_lsp_id', (YLeaf(YType.uint16, 'admitted-lsp-id'), ['int'])),
                                    ('lmp_router_id', (YLeaf(YType.str, 'lmp-router-id'), ['str'])),
                                    ('lmp_adj_state_up', (YLeaf(YType.boolean, 'lmp-adj-state-up'), ['bool'])),
                                    ('lmpipcc_state_up', (YLeaf(YType.boolean, 'lmpipcc-state-up'), ['bool'])),
                                    ('lmp_neighbor_name', (YLeaf(YType.str, 'lmp-neighbor-name'), ['str'])),
                                    ('lmp_neighbor_router_id', (YLeaf(YType.str, 'lmp-neighbor-router-id'), ['str'])),
                                    ('lmp_neighbor_ipcc_address', (YLeaf(YType.str, 'lmp-neighbor-ipcc-address'), ['str'])),
                                    ('lmp_local_ipcc_address', (YLeaf(YType.str, 'lmp-local-ipcc-address'), ['str'])),
                                    ('lmp_local_interface_id', (YLeaf(YType.uint32, 'lmp-local-interface-id'), ['int'])),
                                    ('lmp_neighbor_interface_id', (YLeaf(YType.uint32, 'lmp-neighbor-interface-id'), ['int'])),
                                    ('lmp_local_link_id', (YLeaf(YType.str, 'lmp-local-link-id'), ['str'])),
                                    ('lmp_neighbor_link_id', (YLeaf(YType.str, 'lmp-neighbor-link-id'), ['str'])),
                                    ('lmp_local_switching_capability', (YLeaf(YType.enumeration, 'lmp-local-switching-capability'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkSwitchCapability', '')])),
                                    ('lmp_neighbor_switching_capability', (YLeaf(YType.enumeration, 'lmp-neighbor-switching-capability'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkSwitchCapability', '')])),
                                    ('lmp_local_encoding', (YLeaf(YType.enumeration, 'lmp-local-encoding'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkEncodingProtocol', '')])),
                                    ('local_link_gpid', (YLeaf(YType.uint16, 'local-link-gpid'), ['int'])),
                                    ('srl_gs_announced', (YLeaf(YType.boolean, 'srl-gs-announced'), ['bool'])),
                                    ('srlg_announced_interface', (YLeaf(YType.str, 'srlg-announced-interface'), ['str'])),
                                ])
                                self.link_exists = None
                                self.admin_state_up = None
                                self.oper_state_up = None
                                self.bw_locked_upstream = None
                                self.bw_locked_downstream = None
                                self.admitted_lsp_id = None
                                self.lmp_router_id = None
                                self.lmp_adj_state_up = None
                                self.lmpipcc_state_up = None
                                self.lmp_neighbor_name = None
                                self.lmp_neighbor_router_id = None
                                self.lmp_neighbor_ipcc_address = None
                                self.lmp_local_ipcc_address = None
                                self.lmp_local_interface_id = None
                                self.lmp_neighbor_interface_id = None
                                self.lmp_local_link_id = None
                                self.lmp_neighbor_link_id = None
                                self.lmp_local_switching_capability = None
                                self.lmp_neighbor_switching_capability = None
                                self.lmp_local_encoding = None
                                self.local_link_gpid = None
                                self.srl_gs_announced = None
                                self.srlg_announced_interface = None

                                self.wdm_capabilities = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities()
                                self.wdm_capabilities.parent = self
                                self._children_name_map["wdm_capabilities"] = "wdm-capabilities"

                                self.local_srlg = YList(self)
                                self._segment_path = lambda: "link"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link, ['link_exists', 'admin_state_up', 'oper_state_up', 'bw_locked_upstream', 'bw_locked_downstream', 'admitted_lsp_id', 'lmp_router_id', 'lmp_adj_state_up', 'lmpipcc_state_up', 'lmp_neighbor_name', 'lmp_neighbor_router_id', 'lmp_neighbor_ipcc_address', 'lmp_local_ipcc_address', 'lmp_local_interface_id', 'lmp_neighbor_interface_id', 'lmp_local_link_id', 'lmp_neighbor_link_id', 'lmp_local_switching_capability', 'lmp_neighbor_switching_capability', 'lmp_local_encoding', 'local_link_gpid', 'srl_gs_announced', 'srlg_announced_interface'], name, value)


                            class WdmCapabilities(_Entity_):
                                """
                                WDM capabilities
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: default_channel
                                
                                	Default channel number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                .. attribute:: usable_channel
                                
                                	List of usable channels
                                	**type**\: list of  		 :py:class:`UsableChannel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities, self).__init__()

                                    self.yang_name = "wdm-capabilities"
                                    self.yang_parent_name = "link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("usable-channel", ("usable_channel", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel))])
                                    self._leafs = OrderedDict([
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('default_channel', (YLeaf(YType.int16, 'default-channel'), ['int'])),
                                    ])
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.default_channel = None

                                    self.usable_channel = YList(self)
                                    self._segment_path = lambda: "wdm-capabilities"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities, ['grid', 'channel_spacing', 'default_channel'], name, value)


                                class UsableChannel(_Entity_):
                                    """
                                    List of usable channels
                                    
                                    .. attribute:: entry
                                    
                                    	List of usable channels
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel, self).__init__()

                                        self.yang_name = "usable-channel"
                                        self.yang_parent_name = "wdm-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.int16, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "usable-channel"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities']['meta_info']


                            class LocalSrlg(_Entity_):
                                """
                                Locally\-configured SRLGs on this link
                                
                                .. attribute:: entry
                                
                                	Locally\-configured SRLGs on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg, self).__init__()

                                    self.yang_name = "local-srlg"
                                    self.yang_parent_name = "link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "local-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Link']['meta_info']


                        class Labels(_Entity_):
                            """
                            Labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels, self).__init__()

                                self.yang_name = "labels"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_)), ("otn", ("otn", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_)), ("otn", ("otn", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_)), ("otn", ("otn", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_)), ("otn", ("otn", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Labels']['meta_info']


                        class Tunnel(_Entity_):
                            """
                            Tunnel info
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_role
                            
                            	Tunnel Role
                            	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: local_optical_router_id
                            
                            	Local optical router id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_optical_router_id
                            
                            	Remote optical router id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: controlled_interface
                            
                            	Interface being controlled
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: source_address
                            
                            	Source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended tunnel\-id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: label_origin
                            
                            	Label origin
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_discovery
                            
                            	SRLG\-discovery enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                    ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                    ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                                    ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                                    ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                                    ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                                ])
                                self.tunnel_state = None
                                self.tunnel_role = None
                                self.tunnel_id = None
                                self.lsp_id = None
                                self.local_optical_router_id = None
                                self.remote_optical_router_id = None
                                self.controlled_interface = None
                                self.source_address = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.label_origin = None
                                self.srlg_discovery = None
                                self._segment_path = lambda: "tunnel"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers.Controller']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm.Controllers']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.Gmpls.Uni.Wdm']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.Gmpls.Uni']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.Gmpls']['meta_info']


    class BfdNeighbors(_Entity_):
        """
        BFD Neighbors
        
        .. attribute:: bfd_neighbor
        
        	A BFD Neighbor
        	**type**\: list of  		 :py:class:`BfdNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors.BfdNeighbor>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.BfdNeighbors, self).__init__()

            self.yang_name = "bfd-neighbors"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bfd-neighbor", ("bfd_neighbor", MplsLcacStandby.BfdNeighbors.BfdNeighbor))])
            self._leafs = OrderedDict()

            self.bfd_neighbor = YList(self)
            self._segment_path = lambda: "bfd-neighbors"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.BfdNeighbors, [], name, value)


        class BfdNeighbor(_Entity_):
            """
            A BFD Neighbor
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.BfdNeighbors.BfdNeighbor, self).__init__()

                self.yang_name = "bfd-neighbor"
                self.yang_parent_name = "bfd-neighbors"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.neighbor = YList(self)
                self._segment_path = lambda: "bfd-neighbor" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bfd-neighbors/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.BfdNeighbors.BfdNeighbor, ['interface_name'], name, value)


            class Neighbor(_Entity_):
                """
                Neighbors of the specified link id
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_bfd_up
                
                	TRUE if the BFD session is Up on this link
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "bfd-neighbor"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                        ('is_bfd_up', (YLeaf(YType.boolean, 'is-bfd-up'), ['bool'])),
                    ])
                    self.neighbor_address = None
                    self.is_bfd_up = None
                    self._segment_path = lambda: "neighbor"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor, ['neighbor_address', 'is_bfd_up'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.BfdNeighbors.BfdNeighbor.Neighbor']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.BfdNeighbors.BfdNeighbor']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.BfdNeighbors']['meta_info']


    class BandwidthAccount(_Entity_):
        """
        The bandwidth accounting information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_account_links
        
        	The interface bandwidth accounting information table
        	**type**\:  :py:class:`BandwidthAccountLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.BandwidthAccount, self).__init__()

            self.yang_name = "bandwidth-account"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bandwidth-account-links", ("bandwidth_account_links", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks))])
            self._leafs = OrderedDict()

            self.bandwidth_account_links = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks()
            self.bandwidth_account_links.parent = self
            self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
            self._segment_path = lambda: "bandwidth-account"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.BandwidthAccount, [], name, value)


        class BandwidthAccountLinks(_Entity_):
            """
            The interface bandwidth accounting information
            table
            
            .. attribute:: bandwidth_account_link
            
            	An interface in bandwidth accounting table
            	**type**\: list of  		 :py:class:`BandwidthAccountLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks, self).__init__()

                self.yang_name = "bandwidth-account-links"
                self.yang_parent_name = "bandwidth-account"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bandwidth-account-link", ("bandwidth_account_link", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink))])
                self._leafs = OrderedDict()

                self.bandwidth_account_link = YList(self)
                self._segment_path = lambda: "bandwidth-account-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-account/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks, [], name, value)


            class BandwidthAccountLink(_Entity_):
                """
                An interface in bandwidth accounting table
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: common_info
                
                	Information for bandwidth accounting telemetry
                	**type**\:  :py:class:`CommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo>`
                
                	**config**\: False
                
                .. attribute:: rsvp_te_sample_history
                
                	History of bandwidth accounting RSVP\-TE samples
                	**type**\:  :py:class:`RsvpTeSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory>`
                
                	**config**\: False
                
                .. attribute:: sr_sample_history
                
                	History of bandwidth accounting Segment Routing samples
                	**type**\:  :py:class:`SrSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory>`
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	The link's ID
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__init__()

                    self.yang_name = "bandwidth-account-link"
                    self.yang_parent_name = "bandwidth-account-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("common-info", ("common_info", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo)), ("rsvp-te-sample-history", ("rsvp_te_sample_history", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory)), ("sr-sample-history", ("sr_sample_history", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                    ])
                    self.interface_name = None
                    self.link_id = None

                    self.common_info = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                    self.common_info.parent = self
                    self._children_name_map["common_info"] = "common-info"

                    self.rsvp_te_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                    self.rsvp_te_sample_history.parent = self
                    self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"

                    self.sr_sample_history = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                    self.sr_sample_history.parent = self
                    self._children_name_map["sr_sample_history"] = "sr-sample-history"
                    self._segment_path = lambda: "bandwidth-account-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/bandwidth-account/bandwidth-account-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, ['interface_name', 'link_id'], name, value)


                class CommonInfo(_Entity_):
                    """
                    Information for bandwidth accounting telemetry
                    
                    .. attribute:: rsvp_te_bandwidth_utilization
                    
                    	RSVP\-TE bandwidth utilization information
                    	**type**\:  :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_bandwidth_utilization
                    
                    	Segment Routing bandwidth utilization information
                    	**type**\:  :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_account_enabled
                    
                    	TRUE if bandwidth accounting is enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: application_enforced
                    
                    	TRUE if application is enforced
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: collection_type
                    
                    	The type of traffic collected for bandwidth accounting
                    	**type**\:  :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                    
                    	**config**\: False
                    
                    .. attribute:: sample_time_remaining_timestamp_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next sampling
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_sample_collection_timestamp_nanosec
                    
                    	Timestamp for the last sample collection in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_sample_collection_nanosec
                    
                    	Timestamp for the next sample collection in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: application_time_remaining_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next application
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_application_timestamp_nanosec
                    
                    	Timestamp for the last application in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_application_timestamp_nanosec
                    
                    	Timestamp for the next application in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: effective_maximum_reservable_bandwidth
                    
                    	Maximum reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__init__()

                        self.yang_name = "common-info"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("rsvp-te-bandwidth-utilization", ("rsvp_te_bandwidth_utilization", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization)), ("sr-bandwidth-utilization", ("sr_bandwidth_utilization", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization))])
                        self._leafs = OrderedDict([
                            ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                            ('application_enforced', (YLeaf(YType.boolean, 'application-enforced'), ['bool'])),
                            ('collection_type', (YLeaf(YType.enumeration, 'collection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthAccountingCollection', '')])),
                            ('sample_time_remaining_timestamp_nanosec', (YLeaf(YType.uint64, 'sample-time-remaining-timestamp-nanosec'), ['int'])),
                            ('last_sample_collection_timestamp_nanosec', (YLeaf(YType.uint64, 'last-sample-collection-timestamp-nanosec'), ['int'])),
                            ('next_sample_collection_nanosec', (YLeaf(YType.uint64, 'next-sample-collection-nanosec'), ['int'])),
                            ('application_time_remaining_nanosec', (YLeaf(YType.uint64, 'application-time-remaining-nanosec'), ['int'])),
                            ('last_application_timestamp_nanosec', (YLeaf(YType.uint64, 'last-application-timestamp-nanosec'), ['int'])),
                            ('next_application_timestamp_nanosec', (YLeaf(YType.uint64, 'next-application-timestamp-nanosec'), ['int'])),
                            ('effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'effective-maximum-reservable-bandwidth'), ['int'])),
                        ])
                        self.is_bandwidth_account_enabled = None
                        self.application_enforced = None
                        self.collection_type = None
                        self.sample_time_remaining_timestamp_nanosec = None
                        self.last_sample_collection_timestamp_nanosec = None
                        self.next_sample_collection_nanosec = None
                        self.application_time_remaining_nanosec = None
                        self.last_application_timestamp_nanosec = None
                        self.next_application_timestamp_nanosec = None
                        self.effective_maximum_reservable_bandwidth = None

                        self.rsvp_te_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                        self.rsvp_te_bandwidth_utilization.parent = self
                        self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"

                        self.sr_bandwidth_utilization = MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                        self.sr_bandwidth_utilization.parent = self
                        self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                        self._segment_path = lambda: "common-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, ['is_bandwidth_account_enabled', 'application_enforced', 'collection_type', 'sample_time_remaining_timestamp_nanosec', 'last_sample_collection_timestamp_nanosec', 'next_sample_collection_nanosec', 'application_time_remaining_nanosec', 'last_application_timestamp_nanosec', 'next_application_timestamp_nanosec', 'effective_maximum_reservable_bandwidth'], name, value)


                    class RsvpTeBandwidthUtilization(_Entity_):
                        """
                        RSVP\-TE bandwidth utilization information
                        
                        .. attribute:: total_link_bandwidth_utilization
                        
                        	Total bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_bandwidth_utilization
                        
                        	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                        
                        	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_enforced_bandwidth_utilization
                        
                        	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-utilization"
                            self.yang_parent_name = "common-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('total_link_bandwidth_utilization', (YLeaf(YType.uint64, 'total-link-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-bandwidth-utilization'), ['int'])),
                                ('non_rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'non-rsvp-te-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-adjusted-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-enforced-bandwidth-utilization'), ['int'])),
                            ])
                            self.total_link_bandwidth_utilization = None
                            self.rsvp_te_bandwidth_utilization = None
                            self.non_rsvp_te_bandwidth_utilization = None
                            self.rsvp_te_adjusted_bandwidth_utilization = None
                            self.rsvp_te_enforced_bandwidth_utilization = None
                            self._segment_path = lambda: "rsvp-te-bandwidth-utilization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, ['total_link_bandwidth_utilization', 'rsvp_te_bandwidth_utilization', 'non_rsvp_te_bandwidth_utilization', 'rsvp_te_adjusted_bandwidth_utilization', 'rsvp_te_enforced_bandwidth_utilization'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization']['meta_info']


                    class SrBandwidthUtilization(_Entity_):
                        """
                        Segment Routing bandwidth utilization
                        information
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_adjusted_bandwidth_utilization
                        
                        	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_enforced_bandwidth_utilization
                        
                        	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__init__()

                            self.yang_name = "sr-bandwidth-utilization"
                            self.yang_parent_name = "common-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sr_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-bandwidth-utilization'), ['int'])),
                                ('sr_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-adjusted-bandwidth-utilization'), ['int'])),
                                ('sr_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-enforced-bandwidth-utilization'), ['int'])),
                            ])
                            self.sr_bandwidth_utilization = None
                            self.sr_adjusted_bandwidth_utilization = None
                            self.sr_enforced_bandwidth_utilization = None
                            self._segment_path = lambda: "sr-bandwidth-utilization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, ['sr_bandwidth_utilization', 'sr_adjusted_bandwidth_utilization', 'sr_enforced_bandwidth_utilization'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo']['meta_info']


                class RsvpTeSampleHistory(_Entity_):
                    """
                    History of bandwidth accounting RSVP\-TE samples
                    
                    .. attribute:: rsvp_te_active_interval_sample
                    
                    	RSVP\-TE samples in the current application interval
                    	**type**\: list of  		 :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample>`
                    
                    	**config**\: False
                    
                    .. attribute:: rsvp_te_previous_interval_sample
                    
                    	RSVP\-TE samples in the previous application interval
                    	**type**\: list of  		 :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__init__()

                        self.yang_name = "rsvp-te-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("rsvp-te-active-interval-sample", ("rsvp_te_active_interval_sample", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample)), ("rsvp-te-previous-interval-sample", ("rsvp_te_previous_interval_sample", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample))])
                        self._leafs = OrderedDict()

                        self.rsvp_te_active_interval_sample = YList(self)
                        self.rsvp_te_previous_interval_sample = YList(self)
                        self._segment_path = lambda: "rsvp-te-sample-history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, [], name, value)


                    class RsvpTeActiveIntervalSample(_Entity_):
                        """
                        RSVP\-TE samples in the current application
                        interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-active-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                ('total_packet_rate', (YLeaf(YType.uint64, 'total-packet-rate'), ['int'])),
                                ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                ('rsvp_te_packet_rate', (YLeaf(YType.uint64, 'rsvp-te-packet-rate'), ['int'])),
                                ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ('non_rsvp_te_packet_rate', (YLeaf(YType.uint64, 'non-rsvp-te-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.total_rate = None
                            self.total_packet_rate = None
                            self.rsvp_te_rate = None
                            self.rsvp_te_packet_rate = None
                            self.non_rsvp_te_rate = None
                            self.non_rsvp_te_packet_rate = None
                            self._segment_path = lambda: "rsvp-te-active-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, ['timestamp_nanosec', 'total_rate', 'total_packet_rate', 'rsvp_te_rate', 'rsvp_te_packet_rate', 'non_rsvp_te_rate', 'non_rsvp_te_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample']['meta_info']


                    class RsvpTePreviousIntervalSample(_Entity_):
                        """
                        RSVP\-TE samples in the previous application
                        interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-previous-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                ('total_packet_rate', (YLeaf(YType.uint64, 'total-packet-rate'), ['int'])),
                                ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                ('rsvp_te_packet_rate', (YLeaf(YType.uint64, 'rsvp-te-packet-rate'), ['int'])),
                                ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ('non_rsvp_te_packet_rate', (YLeaf(YType.uint64, 'non-rsvp-te-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.total_rate = None
                            self.total_packet_rate = None
                            self.rsvp_te_rate = None
                            self.rsvp_te_packet_rate = None
                            self.non_rsvp_te_rate = None
                            self.non_rsvp_te_packet_rate = None
                            self._segment_path = lambda: "rsvp-te-previous-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, ['timestamp_nanosec', 'total_rate', 'total_packet_rate', 'rsvp_te_rate', 'rsvp_te_packet_rate', 'non_rsvp_te_rate', 'non_rsvp_te_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory']['meta_info']


                class SrSampleHistory(_Entity_):
                    """
                    History of bandwidth accounting Segment Routing
                    samples
                    
                    .. attribute:: sr_active_interval_sample
                    
                    	Segment Routing samples in the current application interval
                    	**type**\: list of  		 :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_previous_interval_sample
                    
                    	Segment Routing samples in the previous application interval
                    	**type**\: list of  		 :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__init__()

                        self.yang_name = "sr-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("sr-active-interval-sample", ("sr_active_interval_sample", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample)), ("sr-previous-interval-sample", ("sr_previous_interval_sample", MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample))])
                        self._leafs = OrderedDict()

                        self.sr_active_interval_sample = YList(self)
                        self.sr_previous_interval_sample = YList(self)
                        self._segment_path = lambda: "sr-sample-history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, [], name, value)


                    class SrActiveIntervalSample(_Entity_):
                        """
                        Segment Routing samples in the current
                        application interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__init__()

                            self.yang_name = "sr-active-interval-sample"
                            self.yang_parent_name = "sr-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ('sr_packet_rate', (YLeaf(YType.uint64, 'sr-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.sr_rate = None
                            self.sr_packet_rate = None
                            self._segment_path = lambda: "sr-active-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, ['timestamp_nanosec', 'sr_rate', 'sr_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample']['meta_info']


                    class SrPreviousIntervalSample(_Entity_):
                        """
                        Segment Routing samples in the previous
                        application interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__init__()

                            self.yang_name = "sr-previous-interval-sample"
                            self.yang_parent_name = "sr-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ('sr_packet_rate', (YLeaf(YType.uint64, 'sr-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.sr_rate = None
                            self.sr_packet_rate = None
                            self._segment_path = lambda: "sr-previous-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, ['timestamp_nanosec', 'sr_rate', 'sr_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.BandwidthAccount.BandwidthAccountLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.BandwidthAccount']['meta_info']


    class LinkSummary(_Entity_):
        """
        The global summary for all the interfaces
        
        .. attribute:: bandwidth_account_summary
        
        	Bandwidth account summary
        	**type**\:  :py:class:`BandwidthAccountSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary.BandwidthAccountSummary>`
        
        	**config**\: False
        
        .. attribute:: is_role_standby
        
        	TRUE if Role is Standby, Active otherwise
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: links
        
        	Total number of links
        	**type**\: int
        
        	**range:** 0..65535
        
        	**config**\: False
        
        .. attribute:: maximum_links
        
        	Maximum number of links supported
        	**type**\: int
        
        	**range:** 0..65535
        
        	**config**\: False
        
        .. attribute:: is_flooding_enabled
        
        	TRUE if flooding is enabled
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: areas_summary
        
        	Summary info for the areas
        	**type**\: list of  		 :py:class:`AreasSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkSummary.AreasSummary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.LinkSummary, self).__init__()

            self.yang_name = "link-summary"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bandwidth-account-summary", ("bandwidth_account_summary", MplsLcacStandby.LinkSummary.BandwidthAccountSummary)), ("areas-summary", ("areas_summary", MplsLcacStandby.LinkSummary.AreasSummary))])
            self._leafs = OrderedDict([
                ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                ('maximum_links', (YLeaf(YType.uint16, 'maximum-links'), ['int'])),
                ('is_flooding_enabled', (YLeaf(YType.boolean, 'is-flooding-enabled'), ['bool'])),
            ])
            self.is_role_standby = None
            self.links = None
            self.maximum_links = None
            self.is_flooding_enabled = None

            self.bandwidth_account_summary = MplsLcacStandby.LinkSummary.BandwidthAccountSummary()
            self.bandwidth_account_summary.parent = self
            self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"

            self.areas_summary = YList(self)
            self._segment_path = lambda: "link-summary"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.LinkSummary, ['is_role_standby', 'links', 'maximum_links', 'is_flooding_enabled'], name, value)


        class BandwidthAccountSummary(_Entity_):
            """
            Bandwidth account summary
            
            .. attribute:: is_bandwidth_account_enabled
            
            	TRUE if bandwidth accounting is enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: sample_interval
            
            	Sample interval for bandwidth accounting stats
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: sample_time_remaining
            
            	This value indicates the number of seconds until the next sample collection
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: application_interval
            
            	Application interval for bandwidth accounting stats
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: application_time_remaining
            
            	This value indicates the number of seconds until the next application
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: links_count
            
            	Total number of links
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.LinkSummary.BandwidthAccountSummary, self).__init__()

                self.yang_name = "bandwidth-account-summary"
                self.yang_parent_name = "link-summary"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                    ('sample_interval', (YLeaf(YType.uint32, 'sample-interval'), ['int'])),
                    ('sample_time_remaining', (YLeaf(YType.uint32, 'sample-time-remaining'), ['int'])),
                    ('application_interval', (YLeaf(YType.uint32, 'application-interval'), ['int'])),
                    ('application_time_remaining', (YLeaf(YType.uint32, 'application-time-remaining'), ['int'])),
                    ('links_count', (YLeaf(YType.uint32, 'links-count'), ['int'])),
                    ('maximum_links', (YLeaf(YType.uint32, 'maximum-links'), ['int'])),
                ])
                self.is_bandwidth_account_enabled = None
                self.sample_interval = None
                self.sample_time_remaining = None
                self.application_interval = None
                self.application_time_remaining = None
                self.links_count = None
                self.maximum_links = None
                self._segment_path = lambda: "bandwidth-account-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-summary/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.LinkSummary.BandwidthAccountSummary, ['is_bandwidth_account_enabled', 'sample_interval', 'sample_time_remaining', 'application_interval', 'application_time_remaining', 'links_count', 'maximum_links'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.LinkSummary.BandwidthAccountSummary']['meta_info']


        class AreasSummary(_Entity_):
            """
            Summary info for the areas
            
            .. attribute:: area_id
            
            	Area id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol
            
            	Protocol running over the area
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: is_flooded
            
            	TRUE if flooding occurred in this area
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_periodic_flooding_on
            
            	TRUE if periodic flooding is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: periodic_flooding_interval
            
            	Flooding period in seconds
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: links_flooded
            
            	Number of flooded links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: system_id
            
            	IGP id of local node
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: local_node_router_id
            
            	Local router id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: igp_neighbors
            
            	Number of IGP neighbors
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.LinkSummary.AreasSummary, self).__init__()

                self.yang_name = "areas-summary"
                self.yang_parent_name = "link-summary"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('is_flooded', (YLeaf(YType.boolean, 'is-flooded'), ['bool'])),
                    ('is_periodic_flooding_on', (YLeaf(YType.boolean, 'is-periodic-flooding-on'), ['bool'])),
                    ('periodic_flooding_interval', (YLeaf(YType.uint16, 'periodic-flooding-interval'), ['int'])),
                    ('links_flooded', (YLeaf(YType.uint16, 'links-flooded'), ['int'])),
                    ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                    ('local_node_router_id', (YLeaf(YType.str, 'local-node-router-id'), ['str'])),
                    ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                ])
                self.area_id = None
                self.protocol = None
                self.is_flooded = None
                self.is_periodic_flooding_on = None
                self.periodic_flooding_interval = None
                self.links_flooded = None
                self.system_id = None
                self.local_node_router_id = None
                self.igp_neighbors = None
                self._segment_path = lambda: "areas-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-summary/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.LinkSummary.AreasSummary, ['area_id', 'protocol', 'is_flooded', 'is_periodic_flooding_on', 'periodic_flooding_interval', 'links_flooded', 'system_id', 'local_node_router_id', 'igp_neighbors'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.LinkSummary.AreasSummary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.LinkSummary']['meta_info']


    class LinkInformation(_Entity_):
        """
        The interface information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global information for all the interfaces
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Global>`
        
        	**config**\: False
        
        .. attribute:: links
        
        	The table of interfaces in MPLS\-LCAC
        	**type**\:  :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.LinkInformation, self).__init__()

            self.yang_name = "link-information"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcacStandby.LinkInformation.Global)), ("links", ("links", MplsLcacStandby.LinkInformation.Links))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcacStandby.LinkInformation.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.links = MplsLcacStandby.LinkInformation.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._segment_path = lambda: "link-information"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.LinkInformation, [], name, value)


        class Global(_Entity_):
            """
            The global information for all the interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: links
            
            	The number of links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.LinkInformation.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "link-information"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                    ('maximum_links', (YLeaf(YType.uint16, 'maximum-links'), ['int'])),
                ])
                self.is_role_standby = None
                self.links = None
                self.maximum_links = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.LinkInformation.Global, ['is_role_standby', 'links', 'maximum_links'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.LinkInformation.Global']['meta_info']


        class Links(_Entity_):
            """
            The table of interfaces in MPLS\-LCAC
            
            .. attribute:: link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of  		 :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.LinkInformation.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "link-information"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link", ("link", MplsLcacStandby.LinkInformation.Links.Link))])
                self._leafs = OrderedDict()

                self.link = YList(self)
                self._segment_path = lambda: "links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.LinkInformation.Links, [], name, value)


            class Link(_Entity_):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:  :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_account
                
                	Bandwidth Account info
                	**type**\:  :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount>`
                
                	**config**\: False
                
                .. attribute:: hw_oor
                
                	The link's NPU OOR info. This field is NULL for platforms that do not support HW\-OOR notifications
                	**type**\:  :py:class:`HwOor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.HwOor>`
                
                	**config**\: False
                
                .. attribute:: reason_not_flooded
                
                	Reason why link is not flooded (area\-independent)
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: maximum_reservation_bandwidth_rdm
                
                	The link's maximum reservable BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth_rdm
                
                	The link's reservable pool0 BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth_rdm
                
                	The link's reservable pool1 BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: maximum_reservation_bandwidth_mam
                
                	The link's maximum reservable BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth_mam
                
                	The link's reservable pool0 BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth_mam
                
                	The link's reservable pool1 BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: link_attributes
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_attribute_incomplete
                
                	TRUE if one or more affinity definition(s) is/are unknown
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_name_based_attribute
                
                	TRUE, if name based attribute style is in effect
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_te_metric_valid
                
                	Flag to indicate whether the link's TE metric is a valid value
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: link_extended_attribute
                
                	The link's extended attribute bit map
                	**type**\: list of  		 :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute>`
                
                	**config**\: False
                
                .. attribute:: link_forwad_ref_value
                
                	Reference bits for undefined affinity names
                	**type**\: list of  		 :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue>`
                
                	**config**\: False
                
                .. attribute:: affinity_map
                
                	Affinity map array
                	**type**\: list of  		 :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.AffinityMap>`
                
                	**config**\: False
                
                .. attribute:: areas
                
                	Per\-area data
                	**type**\: list of  		 :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.Areas>`
                
                	**config**\: False
                
                .. attribute:: lockout
                
                	Flex LSP Lockout info
                	**type**\: list of  		 :py:class:`Lockout <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.Lockout>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.LinkInformation.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("link-common", ("link_common", MplsLcacStandby.LinkInformation.Links.Link.LinkCommon)), ("bandwidth-account", ("bandwidth_account", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount)), ("hw-oor", ("hw_oor", MplsLcacStandby.LinkInformation.Links.Link.HwOor)), ("link-extended-attribute", ("link_extended_attribute", MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute)), ("link-forwad-ref-value", ("link_forwad_ref_value", MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue)), ("affinity-map", ("affinity_map", MplsLcacStandby.LinkInformation.Links.Link.AffinityMap)), ("areas", ("areas", MplsLcacStandby.LinkInformation.Links.Link.Areas)), ("lockout", ("lockout", MplsLcacStandby.LinkInformation.Links.Link.Lockout))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('reason_not_flooded', (YLeaf(YType.str, 'reason-not-flooded'), ['str'])),
                        ('maximum_reservation_bandwidth_rdm', (YLeaf(YType.uint64, 'maximum-reservation-bandwidth-rdm'), ['int'])),
                        ('reservable_pool0_bandwidth_rdm', (YLeaf(YType.uint64, 'reservable-pool0-bandwidth-rdm'), ['int'])),
                        ('reservable_pool1_bandwidth_rdm', (YLeaf(YType.uint64, 'reservable-pool1-bandwidth-rdm'), ['int'])),
                        ('maximum_reservation_bandwidth_mam', (YLeaf(YType.uint64, 'maximum-reservation-bandwidth-mam'), ['int'])),
                        ('reservable_pool0_bandwidth_mam', (YLeaf(YType.uint64, 'reservable-pool0-bandwidth-mam'), ['int'])),
                        ('reservable_pool1_bandwidth_mam', (YLeaf(YType.uint64, 'reservable-pool1-bandwidth-mam'), ['int'])),
                        ('link_attributes', (YLeaf(YType.uint32, 'link-attributes'), ['int'])),
                        ('is_attribute_incomplete', (YLeaf(YType.boolean, 'is-attribute-incomplete'), ['bool'])),
                        ('is_name_based_attribute', (YLeaf(YType.boolean, 'is-name-based-attribute'), ['bool'])),
                        ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                        ('is_te_metric_valid', (YLeaf(YType.boolean, 'is-te-metric-valid'), ['bool'])),
                    ])
                    self.interface_name = None
                    self.reason_not_flooded = None
                    self.maximum_reservation_bandwidth_rdm = None
                    self.reservable_pool0_bandwidth_rdm = None
                    self.reservable_pool1_bandwidth_rdm = None
                    self.maximum_reservation_bandwidth_mam = None
                    self.reservable_pool0_bandwidth_mam = None
                    self.reservable_pool1_bandwidth_mam = None
                    self.link_attributes = None
                    self.is_attribute_incomplete = None
                    self.is_name_based_attribute = None
                    self.te_metric = None
                    self.is_te_metric_valid = None

                    self.link_common = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"

                    self.bandwidth_account = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount()
                    self.bandwidth_account.parent = self
                    self._children_name_map["bandwidth_account"] = "bandwidth-account"

                    self.hw_oor = MplsLcacStandby.LinkInformation.Links.Link.HwOor()
                    self.hw_oor.parent = self
                    self._children_name_map["hw_oor"] = "hw-oor"

                    self.link_extended_attribute = YList(self)
                    self.link_forwad_ref_value = YList(self)
                    self.affinity_map = YList(self)
                    self.areas = YList(self)
                    self.lockout = YList(self)
                    self._segment_path = lambda: "link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/link-information/links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link, ['interface_name', 'reason_not_flooded', 'maximum_reservation_bandwidth_rdm', 'reservable_pool0_bandwidth_rdm', 'reservable_pool1_bandwidth_rdm', 'maximum_reservation_bandwidth_mam', 'reservable_pool0_bandwidth_mam', 'reservable_pool1_bandwidth_mam', 'link_attributes', 'is_attribute_incomplete', 'is_name_based_attribute', 'te_metric', 'is_te_metric_valid'], name, value)


                class LinkCommon(_Entity_):
                    """
                    The link's common info
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:  :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags>`
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of  		 :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    	**config**\: False
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of  		 :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("link-flags", ("link_flags", MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup)), ("interface-switching-capability-descriptor", ("interface_switching_capability_descriptor", MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor)), ("flooded-areas", ("flooded_areas", MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas))])
                        self._leafs = OrderedDict([
                            ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                            ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                            ('is_unnumbered', (YLeaf(YType.boolean, 'is-unnumbered'), ['bool'])),
                            ('has_protection', (YLeaf(YType.boolean, 'has-protection'), ['bool'])),
                            ('capability', (YLeaf(YType.uint32, 'capability'), ['int'])),
                            ('working_priority', (YLeaf(YType.uint32, 'working-priority'), ['int'])),
                            ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                            ('is_resource_provider_installed', (YLeaf(YType.boolean, 'is-resource-provider-installed'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                            ('physical_bandwidth', (YLeaf(YType.uint64, 'physical-bandwidth'), ['int'])),
                            ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                            ('maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-bandwidth'), ['int'])),
                            ('last_flooded_effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'last-flooded-effective-maximum-reservable-bandwidth'), ['int'])),
                            ('incoming_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool0_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool0-bandwidth'), ['int'])),
                            ('incoming_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool1_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool1-bandwidth'), ['int'])),
                            ('incoming_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('inbound_admission_method', (YLeaf(YType.enumeration, 'inbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('outbound_admission_method', (YLeaf(YType.enumeration, 'outbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                        ])
                        self.link_id = None
                        self.link_address = None
                        self.is_unnumbered = None
                        self.has_protection = None
                        self.capability = None
                        self.working_priority = None
                        self.resource_provider = None
                        self.is_resource_provider_installed = None
                        self.bandwidth_units = None
                        self.physical_bandwidth = None
                        self.bcm_id = None
                        self.maximum_reservable_bandwidth = None
                        self.last_flooded_effective_maximum_reservable_bandwidth = None
                        self.incoming_reservable_bandwidth_percentage = None
                        self.outgoing_reservable_bandwidth_percentage = None
                        self.maximum_reservable_pool0_bandwidth = None
                        self.incoming_reservable_pool0_bandwidth_percentage = None
                        self.outgoing_reservable_pool0_bandwidth_percentage = None
                        self.maximum_reservable_pool1_bandwidth = None
                        self.incoming_reservable_pool1_bandwidth_percentage = None
                        self.outgoing_reservable_pool1_bandwidth_percentage = None
                        self.inbound_admission_method = None
                        self.outbound_admission_method = None
                        self.igp_neighbors = None

                        self.link_flags = MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"

                        self.shared_risk_link_group = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.flooded_areas = YList(self)
                        self._segment_path = lambda: "link-common"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon, ['link_id', 'link_address', 'is_unnumbered', 'has_protection', 'capability', 'working_priority', 'resource_provider', 'is_resource_provider_installed', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'maximum_reservable_bandwidth', 'last_flooded_effective_maximum_reservable_bandwidth', 'incoming_reservable_bandwidth_percentage', 'outgoing_reservable_bandwidth_percentage', 'maximum_reservable_pool0_bandwidth', 'incoming_reservable_pool0_bandwidth_percentage', 'outgoing_reservable_pool0_bandwidth_percentage', 'maximum_reservable_pool1_bandwidth', 'incoming_reservable_pool1_bandwidth_percentage', 'outgoing_reservable_pool1_bandwidth_percentage', 'inbound_admission_method', 'outbound_admission_method', 'igp_neighbors'], name, value)


                    class LinkFlags(_Entity_):
                        """
                        The link's flags
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:  :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_mpls_te_on', (YLeaf(YType.boolean, 'is-mpls-te-on'), ['bool'])),
                                ('signaling_agent', (YLeaf(YType.enumeration, 'signaling-agent'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'SignalingAgentEnum', '')])),
                                ('is_admin_up', (YLeaf(YType.boolean, 'is-admin-up'), ['bool'])),
                            ])
                            self.is_mpls_te_on = None
                            self.signaling_agent = None
                            self.is_admin_up = None
                            self._segment_path = lambda: "link-flags"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags, ['is_mpls_te_on', 'signaling_agent', 'is_admin_up'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.LinkFlags']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup']['meta_info']


                    class InterfaceSwitchingCapabilityDescriptor(_Entity_):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('key', (YLeaf(YType.uint8, 'key'), ['int'])),
                                ('switching_capability', (YLeaf(YType.uint8, 'switching-capability'), ['int'])),
                                ('encoding', (YLeaf(YType.uint8, 'encoding'), ['int'])),
                            ])
                            self.key = None
                            self.switching_capability = None
                            self.encoding = None
                            self._segment_path = lambda: "interface-switching-capability-descriptor"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, ['key', 'switching_capability', 'encoding'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor']['meta_info']


                    class FloodedAreas(_Entity_):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('flooded_area', (YLeaf(YType.str, 'flooded-area'), ['str'])),
                            ])
                            self.flooded_area = None
                            self._segment_path = lambda: "flooded-areas"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas, ['flooded_area'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkCommon.FloodedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkCommon']['meta_info']


                class BandwidthAccount(_Entity_):
                    """
                    Bandwidth Account info
                    
                    .. attribute:: bandwidth_account_common_info
                    
                    	Common info for bandwidth accounting
                    	**type**\:  :py:class:`BandwidthAccountCommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: rsvp_te_bandwidth_sample_history
                    
                    	RSVP\-TE Bandwidth samples history
                    	**type**\:  :py:class:`RsvpTeBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_bandwidth_sample_history
                    
                    	Segment Routing Bandwidth samples history
                    	**type**\:  :py:class:`SrBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount, self).__init__()

                        self.yang_name = "bandwidth-account"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-account-common-info", ("bandwidth_account_common_info", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo)), ("rsvp-te-bandwidth-sample-history", ("rsvp_te_bandwidth_sample_history", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory)), ("sr-bandwidth-sample-history", ("sr_bandwidth_sample_history", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory))])
                        self._leafs = OrderedDict()

                        self.bandwidth_account_common_info = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                        self.bandwidth_account_common_info.parent = self
                        self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"

                        self.rsvp_te_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                        self.rsvp_te_bandwidth_sample_history.parent = self
                        self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"

                        self.sr_bandwidth_sample_history = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                        self.sr_bandwidth_sample_history.parent = self
                        self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                        self._segment_path = lambda: "bandwidth-account"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount, [], name, value)


                    class BandwidthAccountCommonInfo(_Entity_):
                        """
                        Common info for bandwidth accounting
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE Bandwidth utilization information
                        	**type**\:  :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization>`
                        
                        	**config**\: False
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing Bandwidth utilization information
                        	**type**\:  :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_account_enabled
                        
                        	TRUE if bandwidth accounting is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: application_enforced
                        
                        	TRUE if bandwidth accounting application is enforced
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: collection_type
                        
                        	The type of traffic collected for bandwidth accounting
                        	**type**\:  :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: sample_interval
                        
                        	Sampling interval in seconds for bandwidth accounting stats
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: sample_time_remaining
                        
                        	This value indicates the number of seconds until the next sampling
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: last_sample_collection_timestamp
                        
                        	Timestamp for the last sample collection
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: next_sample_collection
                        
                        	Timestamp for the next sample collection
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_interval
                        
                        	Application interval in seconds for bandwidth accounting stats
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: application_time_remaining
                        
                        	This value indicates the number of seconds until the next application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: last_application_timestamp
                        
                        	Timestamp for the last application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: next_application
                        
                        	Timestamp for the next application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_factor
                        
                        	This value indicates the adjustment factor applied to measured non RSVP\-TE bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: max_reservable_bandwidth_threshold_are_default
                        
                        	TRUE if the maximum reservable bandwidth flooding thresholds are default
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: up_threshold_max_reservable_bandwidth
                        
                        	The up threshold for flooding the maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: down_threshold_max_reservable_bandwidth
                        
                        	The down threshold for flooding the maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__init__()

                            self.yang_name = "bandwidth-account-common-info"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rsvp-te-bandwidth-utilization", ("rsvp_te_bandwidth_utilization", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization)), ("sr-bandwidth-utilization", ("sr_bandwidth_utilization", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization))])
                            self._leafs = OrderedDict([
                                ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                                ('application_enforced', (YLeaf(YType.boolean, 'application-enforced'), ['bool'])),
                                ('collection_type', (YLeaf(YType.enumeration, 'collection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthAccountingCollection', '')])),
                                ('sample_interval', (YLeaf(YType.uint32, 'sample-interval'), ['int'])),
                                ('sample_time_remaining', (YLeaf(YType.uint32, 'sample-time-remaining'), ['int'])),
                                ('last_sample_collection_timestamp', (YLeaf(YType.uint32, 'last-sample-collection-timestamp'), ['int'])),
                                ('next_sample_collection', (YLeaf(YType.uint32, 'next-sample-collection'), ['int'])),
                                ('application_interval', (YLeaf(YType.uint32, 'application-interval'), ['int'])),
                                ('application_time_remaining', (YLeaf(YType.uint32, 'application-time-remaining'), ['int'])),
                                ('last_application_timestamp', (YLeaf(YType.uint32, 'last-application-timestamp'), ['int'])),
                                ('next_application', (YLeaf(YType.uint32, 'next-application'), ['int'])),
                                ('adjustment_factor', (YLeaf(YType.uint32, 'adjustment-factor'), ['int'])),
                                ('max_reservable_bandwidth_threshold_are_default', (YLeaf(YType.boolean, 'max-reservable-bandwidth-threshold-are-default'), ['bool'])),
                                ('up_threshold_max_reservable_bandwidth', (YLeaf(YType.uint8, 'up-threshold-max-reservable-bandwidth'), ['int'])),
                                ('down_threshold_max_reservable_bandwidth', (YLeaf(YType.uint8, 'down-threshold-max-reservable-bandwidth'), ['int'])),
                            ])
                            self.is_bandwidth_account_enabled = None
                            self.application_enforced = None
                            self.collection_type = None
                            self.sample_interval = None
                            self.sample_time_remaining = None
                            self.last_sample_collection_timestamp = None
                            self.next_sample_collection = None
                            self.application_interval = None
                            self.application_time_remaining = None
                            self.last_application_timestamp = None
                            self.next_application = None
                            self.adjustment_factor = None
                            self.max_reservable_bandwidth_threshold_are_default = None
                            self.up_threshold_max_reservable_bandwidth = None
                            self.down_threshold_max_reservable_bandwidth = None

                            self.rsvp_te_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                            self.rsvp_te_bandwidth_utilization.parent = self
                            self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"

                            self.sr_bandwidth_utilization = MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                            self.sr_bandwidth_utilization.parent = self
                            self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            self._segment_path = lambda: "bandwidth-account-common-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, ['is_bandwidth_account_enabled', 'application_enforced', 'collection_type', 'sample_interval', 'sample_time_remaining', 'last_sample_collection_timestamp', 'next_sample_collection', 'application_interval', 'application_time_remaining', 'last_application_timestamp', 'next_application', 'adjustment_factor', 'max_reservable_bandwidth_threshold_are_default', 'up_threshold_max_reservable_bandwidth', 'down_threshold_max_reservable_bandwidth'], name, value)


                        class RsvpTeBandwidthUtilization(_Entity_):
                            """
                            RSVP\-TE Bandwidth utilization information
                            
                            .. attribute:: total_link_bandwidth_utilization
                            
                            	Total bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_bandwidth_utilization
                            
                            	RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_bandwidth_utilization
                            
                            	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                            
                            	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_enforced_bandwidth_utilization
                            
                            	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                                self.yang_name = "rsvp-te-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('total_link_bandwidth_utilization', (YLeaf(YType.uint64, 'total-link-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-bandwidth-utilization'), ['int'])),
                                    ('non_rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'non-rsvp-te-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-adjusted-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-enforced-bandwidth-utilization'), ['int'])),
                                ])
                                self.total_link_bandwidth_utilization = None
                                self.rsvp_te_bandwidth_utilization = None
                                self.non_rsvp_te_bandwidth_utilization = None
                                self.rsvp_te_adjusted_bandwidth_utilization = None
                                self.rsvp_te_enforced_bandwidth_utilization = None
                                self._segment_path = lambda: "rsvp-te-bandwidth-utilization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, ['total_link_bandwidth_utilization', 'rsvp_te_bandwidth_utilization', 'non_rsvp_te_bandwidth_utilization', 'rsvp_te_adjusted_bandwidth_utilization', 'rsvp_te_enforced_bandwidth_utilization'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization']['meta_info']


                        class SrBandwidthUtilization(_Entity_):
                            """
                            Segment Routing Bandwidth utilization
                            information
                            
                            .. attribute:: sr_bandwidth_utilization
                            
                            	Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_adjusted_bandwidth_utilization
                            
                            	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_enforced_bandwidth_utilization
                            
                            	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__init__()

                                self.yang_name = "sr-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sr_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-bandwidth-utilization'), ['int'])),
                                    ('sr_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-adjusted-bandwidth-utilization'), ['int'])),
                                    ('sr_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-enforced-bandwidth-utilization'), ['int'])),
                                ])
                                self.sr_bandwidth_utilization = None
                                self.sr_adjusted_bandwidth_utilization = None
                                self.sr_enforced_bandwidth_utilization = None
                                self._segment_path = lambda: "sr-bandwidth-utilization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, ['sr_bandwidth_utilization', 'sr_adjusted_bandwidth_utilization', 'sr_enforced_bandwidth_utilization'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo']['meta_info']


                    class RsvpTeBandwidthSampleHistory(_Entity_):
                        """
                        RSVP\-TE Bandwidth samples history
                        
                        .. attribute:: rsvp_te_active_interval_sample
                        
                        	RSVP\-TE samples in the current application interval
                        	**type**\: list of  		 :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample>`
                        
                        	**config**\: False
                        
                        .. attribute:: rsvp_te_previous_interval_sample
                        
                        	RSVP\-TE samples in the previous application interval
                        	**type**\: list of  		 :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rsvp-te-active-interval-sample", ("rsvp_te_active_interval_sample", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample)), ("rsvp-te-previous-interval-sample", ("rsvp_te_previous_interval_sample", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample))])
                            self._leafs = OrderedDict()

                            self.rsvp_te_active_interval_sample = YList(self)
                            self.rsvp_te_previous_interval_sample = YList(self)
                            self._segment_path = lambda: "rsvp-te-bandwidth-sample-history"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, [], name, value)


                        class RsvpTeActiveIntervalSample(_Entity_):
                            """
                            RSVP\-TE samples in the current application
                            interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-active-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                    ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                    ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.total_rate = None
                                self.rsvp_te_rate = None
                                self.non_rsvp_te_rate = None
                                self._segment_path = lambda: "rsvp-te-active-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, ['timestamp', 'total_rate', 'rsvp_te_rate', 'non_rsvp_te_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample']['meta_info']


                        class RsvpTePreviousIntervalSample(_Entity_):
                            """
                            RSVP\-TE samples in the previous application
                            interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-previous-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                    ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                    ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.total_rate = None
                                self.rsvp_te_rate = None
                                self.non_rsvp_te_rate = None
                                self._segment_path = lambda: "rsvp-te-previous-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, ['timestamp', 'total_rate', 'rsvp_te_rate', 'non_rsvp_te_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory']['meta_info']


                    class SrBandwidthSampleHistory(_Entity_):
                        """
                        Segment Routing Bandwidth samples history
                        
                        .. attribute:: sr_active_interval_sample
                        
                        	Segment Routing samples in the current application interval
                        	**type**\: list of  		 :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample>`
                        
                        	**config**\: False
                        
                        .. attribute:: sr_previous_interval_sample
                        
                        	Segment Routing samples in the previous application interval
                        	**type**\: list of  		 :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__init__()

                            self.yang_name = "sr-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("sr-active-interval-sample", ("sr_active_interval_sample", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample)), ("sr-previous-interval-sample", ("sr_previous_interval_sample", MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample))])
                            self._leafs = OrderedDict()

                            self.sr_active_interval_sample = YList(self)
                            self.sr_previous_interval_sample = YList(self)
                            self._segment_path = lambda: "sr-bandwidth-sample-history"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, [], name, value)


                        class SrActiveIntervalSample(_Entity_):
                            """
                            Segment Routing samples in the current
                            application interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__init__()

                                self.yang_name = "sr-active-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.sr_rate = None
                                self._segment_path = lambda: "sr-active-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, ['timestamp', 'sr_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample']['meta_info']


                        class SrPreviousIntervalSample(_Entity_):
                            """
                            Segment Routing samples in the previous
                            application interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__init__()

                                self.yang_name = "sr-previous-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.sr_rate = None
                                self._segment_path = lambda: "sr-previous-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, ['timestamp', 'sr_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.BandwidthAccount']['meta_info']


                class HwOor(_Entity_):
                    """
                    The link's NPU OOR info. This field is NULL for
                    platforms that do not support HW\-OOR
                    notifications
                    
                    .. attribute:: hw_oor_state
                    
                    	The NPU (Network Processor Unit) HW resource state
                    	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    	**config**\: False
                    
                    .. attribute:: hw_oor_timestamp
                    
                    	Timestamp when the OOR state last changed
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: hw_o_or_green_recovery_time
                    
                    	Time Remaining in Green Recovery State (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: hw_o_or_link_statistic
                    
                    	HW OOR statistics for the link
                    	**type**\: list of  		 :py:class:`HwOOrLinkStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.HwOor, self).__init__()

                        self.yang_name = "hw-oor"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("hw-o-or-link-statistic", ("hw_o_or_link_statistic", MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic))])
                        self._leafs = OrderedDict([
                            ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                            ('hw_oor_timestamp', (YLeaf(YType.uint32, 'hw-oor-timestamp'), ['int'])),
                            ('hw_o_or_green_recovery_time', (YLeaf(YType.uint32, 'hw-o-or-green-recovery-time'), ['int'])),
                        ])
                        self.hw_oor_state = None
                        self.hw_oor_timestamp = None
                        self.hw_o_or_green_recovery_time = None

                        self.hw_o_or_link_statistic = YList(self)
                        self._segment_path = lambda: "hw-oor"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.HwOor, ['hw_oor_state', 'hw_oor_timestamp', 'hw_o_or_green_recovery_time'], name, value)


                    class HwOOrLinkStatistic(_Entity_):
                        """
                        HW OOR statistics for the link
                        
                        .. attribute:: hw_oor_state
                        
                        	The HW\-OOR state that these statistics belong to
                        	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                        
                        	**config**\: False
                        
                        .. attribute:: transitions
                        
                        	Number of transitions to this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_protection_disable_number
                        
                        	Number of times this OOR state disabled node protection assignment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rejected_ls_ps_number
                        
                        	Number of LSPs that were rejected in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: accepted_ls_ps_number
                        
                        	Number of LSPs that were accepted in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: accepted_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were accepted in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rejected_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were rejected in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__init__()

                            self.yang_name = "hw-o-or-link-statistic"
                            self.yang_parent_name = "hw-oor"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                                ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                                ('node_protection_disable_number', (YLeaf(YType.uint32, 'node-protection-disable-number'), ['int'])),
                                ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                                ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                                ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                                ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                            ])
                            self.hw_oor_state = None
                            self.transitions = None
                            self.node_protection_disable_number = None
                            self.rejected_ls_ps_number = None
                            self.accepted_ls_ps_number = None
                            self.accepted_reopt_ls_ps_number = None
                            self.rejected_reopt_ls_ps_number = None
                            self._segment_path = lambda: "hw-o-or-link-statistic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, ['hw_oor_state', 'transitions', 'node_protection_disable_number', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.HwOor']['meta_info']


                class LinkExtendedAttribute(_Entity_):
                    """
                    The link's extended attribute bit map
                    
                    .. attribute:: entry
                    
                    	The link's extended attribute bit map
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute, self).__init__()

                        self.yang_name = "link-extended-attribute"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "link-extended-attribute"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkExtendedAttribute']['meta_info']


                class LinkForwadRefValue(_Entity_):
                    """
                    Reference bits for undefined affinity names
                    
                    .. attribute:: entry
                    
                    	Reference bits for undefined affinity names
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue, self).__init__()

                        self.yang_name = "link-forwad-ref-value"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "link-forwad-ref-value"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.LinkForwadRefValue']['meta_info']


                class AffinityMap(_Entity_):
                    """
                    Affinity map array
                    
                    .. attribute:: affinity_name
                    
                    	Affinity name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_value
                    
                    	Affinity value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_bit_position
                    
                    	Affinity bit position
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_table_id
                    
                    	Affinity table id
                    	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_extended_value
                    
                    	EAG value
                    	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap, self).__init__()

                        self.yang_name = "affinity-map"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue))])
                        self._leafs = OrderedDict([
                            ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                            ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                            ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                            ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                        ])
                        self.affinity_name = None
                        self.affinity_value = None
                        self.affinity_bit_position = None
                        self.affinity_table_id = None

                        self.affinity_extended_value = YList(self)
                        self._segment_path = lambda: "affinity-map"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


                    class AffinityExtendedValue(_Entity_):
                        """
                        EAG value
                        
                        .. attribute:: entry
                        
                        	EAG value
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__init__()

                            self.yang_name = "affinity-extended-value"
                            self.yang_parent_name = "affinity-map"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "affinity-extended-value"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.AffinityMap']['meta_info']


                class Areas(_Entity_):
                    """
                    Per\-area data
                    
                    .. attribute:: area_id
                    
                    	Area id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: neighbor_id
                    
                    	The interface neighbor id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: neighbor_address
                    
                    	The interface's neighbor's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_neighbor_up
                    
                    	TRUE if the neighbor is up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	The link's IGP metric
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.Areas, self).__init__()

                        self.yang_name = "areas"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                            ('neighbor_id', (YLeaf(YType.str, 'neighbor-id'), ['str'])),
                            ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                            ('is_neighbor_up', (YLeaf(YType.boolean, 'is-neighbor-up'), ['bool'])),
                            ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                        ])
                        self.area_id = None
                        self.neighbor_id = None
                        self.neighbor_address = None
                        self.is_neighbor_up = None
                        self.igp_metric = None
                        self._segment_path = lambda: "areas"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.Areas, ['area_id', 'neighbor_id', 'neighbor_address', 'is_neighbor_up', 'igp_metric'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.Areas']['meta_info']


                class Lockout(_Entity_):
                    """
                    Flex LSP Lockout info
                    
                    .. attribute:: is_lockout
                    
                    	True if link is locked out
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_on_timestamp
                    
                    	Timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_off_timestamp
                    
                    	Timestamp when the lockout is cleared
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcacStandby.LinkInformation.Links.Link.Lockout, self).__init__()

                        self.yang_name = "lockout"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_on_timestamp', (YLeaf(YType.uint32, 'lockout-on-timestamp'), ['int'])),
                            ('lockout_off_timestamp', (YLeaf(YType.uint32, 'lockout-off-timestamp'), ['int'])),
                        ])
                        self.is_lockout = None
                        self.lockout_on_timestamp = None
                        self.lockout_off_timestamp = None
                        self._segment_path = lambda: "lockout"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcacStandby.LinkInformation.Links.Link.Lockout, ['is_lockout', 'lockout_on_timestamp', 'lockout_off_timestamp'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link.Lockout']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.LinkInformation.Links.Link']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.LinkInformation.Links']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.LinkInformation']['meta_info']


    class AdmissionControl(_Entity_):
        """
        The admission control information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global admission control information
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.Global>`
        
        	**config**\: False
        
        .. attribute:: admitted_tunnels
        
        	The table of admitted tunnels information in MPLS\-LCAC
        	**type**\:  :py:class:`AdmittedTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.AdmittedTunnels>`
        
        	**config**\: False
        
        .. attribute:: link_interfaces
        
        	The global admission control information on Interfaces
        	**type**\:  :py:class:`LinkInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.LinkInterfaces>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.AdmissionControl, self).__init__()

            self.yang_name = "admission-control"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcacStandby.AdmissionControl.Global)), ("admitted-tunnels", ("admitted_tunnels", MplsLcacStandby.AdmissionControl.AdmittedTunnels)), ("link-interfaces", ("link_interfaces", MplsLcacStandby.AdmissionControl.LinkInterfaces))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcacStandby.AdmissionControl.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.admitted_tunnels = MplsLcacStandby.AdmissionControl.AdmittedTunnels()
            self.admitted_tunnels.parent = self
            self._children_name_map["admitted_tunnels"] = "admitted-tunnels"

            self.link_interfaces = MplsLcacStandby.AdmissionControl.LinkInterfaces()
            self.link_interfaces.parent = self
            self._children_name_map["link_interfaces"] = "link-interfaces"
            self._segment_path = lambda: "admission-control"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.AdmissionControl, [], name, value)


        class Global(_Entity_):
            """
            The global admission control information
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: total_tunnels
            
            	Total p2p tunnels admitted
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_p2mp_tunnels
            
            	Total p2mp tunnels admitted
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: selected_tunnels
            
            	Number of tunnels selected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bandwidth_units
            
            	Bandwidth units
            	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.AdmissionControl.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                    ('total_p2mp_tunnels', (YLeaf(YType.uint32, 'total-p2mp-tunnels'), ['int'])),
                    ('selected_tunnels', (YLeaf(YType.uint32, 'selected-tunnels'), ['int'])),
                    ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                ])
                self.is_role_standby = None
                self.total_tunnels = None
                self.total_p2mp_tunnels = None
                self.selected_tunnels = None
                self.bandwidth_units = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.AdmissionControl.Global, ['is_role_standby', 'total_tunnels', 'total_p2mp_tunnels', 'selected_tunnels', 'bandwidth_units'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.AdmissionControl.Global']['meta_info']


        class AdmittedTunnels(_Entity_):
            """
            The table of admitted tunnels information in
            MPLS\-LCAC
            
            .. attribute:: admitted_tunnel
            
            	The information for a specific admitted tunnel
            	**type**\: list of  		 :py:class:`AdmittedTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.AdmissionControl.AdmittedTunnels, self).__init__()

                self.yang_name = "admitted-tunnels"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("admitted-tunnel", ("admitted_tunnel", MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel))])
                self._leafs = OrderedDict()

                self.admitted_tunnel = YList(self)
                self._segment_path = lambda: "admitted-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.AdmissionControl.AdmittedTunnels, [], name, value)


            class AdmittedTunnel(_Entity_):
                """
                The information for a specific admitted tunnel
                
                .. attribute:: source_address  (key)
                
                	The source IP address of the tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_port  (key)
                
                	The tunnel number at the head
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_port  (key)
                
                	The signaling instance number of the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	The destination IP address of the tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended tunnel id
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: next_hop_address  (key)
                
                	The Next hop IP
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	C type
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	The admitted tunnel's name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_state
                
                	The bandwidth state
                	**type**\:  :py:class:`BandwidthStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthStateEnum>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool
                
                	The bandwidth pool
                	**type**\:  :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The tunnel's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The tunnel's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: up_link_name
                
                	The uplink's name for this tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: down_link_name
                
                	The downlink's name for this tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_state
                
                	The tunnel's state
                	**type**\:  :py:class:`TunnelStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelStateEnum>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	The bandwidth used by this tunnel
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: local_label
                
                	The local label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: outgoing_label
                
                	The outgoing label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_interface
                
                	The backup Interface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_rerouted
                
                	TRUE if the tunnel is currently rerouted
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__init__()

                    self.yang_name = "admitted-tunnel"
                    self.yang_parent_name = "admitted-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_port','source_port','destination_address','extended_tunnel_id','next_hop_address','ctype','p2mp_id']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_port', (YLeaf(YType.uint32, 'destination-port'), ['int'])),
                        ('source_port', (YLeaf(YType.uint32, 'source-port'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('bandwidth_state', (YLeaf(YType.enumeration, 'bandwidth-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthStateEnum', '')])),
                        ('bandwidth_pool', (YLeaf(YType.enumeration, 'bandwidth-pool'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthTypeEnum', '')])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('up_link_name', (YLeaf(YType.str, 'up-link-name'), ['str'])),
                        ('down_link_name', (YLeaf(YType.str, 'down-link-name'), ['str'])),
                        ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelStateEnum', '')])),
                        ('bandwidth', (YLeaf(YType.uint64, 'bandwidth'), ['int'])),
                        ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                        ('outgoing_label', (YLeaf(YType.uint32, 'outgoing-label'), ['int'])),
                        ('backup_interface', (YLeaf(YType.str, 'backup-interface'), ['str'])),
                        ('is_rerouted', (YLeaf(YType.boolean, 'is-rerouted'), ['bool'])),
                    ])
                    self.source_address = None
                    self.destination_port = None
                    self.source_port = None
                    self.destination_address = None
                    self.extended_tunnel_id = None
                    self.next_hop_address = None
                    self.ctype = None
                    self.p2mp_id = None
                    self.tunnel_name = None
                    self.bandwidth_state = None
                    self.bandwidth_pool = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.up_link_name = None
                    self.down_link_name = None
                    self.tunnel_state = None
                    self.bandwidth = None
                    self.local_label = None
                    self.outgoing_label = None
                    self.backup_interface = None
                    self.is_rerouted = None
                    self._segment_path = lambda: "admitted-tunnel" + "[source-address='" + str(self.source_address) + "']" + "[destination-port='" + str(self.destination_port) + "']" + "[source-port='" + str(self.source_port) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[next-hop-address='" + str(self.next_hop_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/admitted-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel, ['source_address', 'destination_port', 'source_port', 'destination_address', 'extended_tunnel_id', 'next_hop_address', 'ctype', 'p2mp_id', 'tunnel_name', 'bandwidth_state', 'bandwidth_pool', 'setup_priority', 'hold_priority', 'up_link_name', 'down_link_name', 'tunnel_state', 'bandwidth', 'local_label', 'outgoing_label', 'backup_interface', 'is_rerouted'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.AdmissionControl.AdmittedTunnels.AdmittedTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.AdmissionControl.AdmittedTunnels']['meta_info']


        class LinkInterfaces(_Entity_):
            """
            The global admission control information on
            Interfaces
            
            .. attribute:: link_interface
            
            	The global admission control information on an interface
            	**type**\: list of  		 :py:class:`LinkInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.AdmissionControl.LinkInterfaces, self).__init__()

                self.yang_name = "link-interfaces"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link-interface", ("link_interface", MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface))])
                self._leafs = OrderedDict()

                self.link_interface = YList(self)
                self._segment_path = lambda: "link-interfaces"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.AdmissionControl.LinkInterfaces, [], name, value)


            class LinkInterface(_Entity_):
                """
                The global admission control information on an
                interface
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: is_role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: total_tunnels
                
                	Total p2p tunnels admitted
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: total_p2mp_tunnels
                
                	Total p2mp tunnels admitted
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: selected_tunnels
                
                	Number of tunnels selected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_units
                
                	Bandwidth units
                	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface, self).__init__()

                    self.yang_name = "link-interface"
                    self.yang_parent_name = "link-interfaces"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                        ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                        ('total_p2mp_tunnels', (YLeaf(YType.uint32, 'total-p2mp-tunnels'), ['int'])),
                        ('selected_tunnels', (YLeaf(YType.uint32, 'selected-tunnels'), ['int'])),
                        ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                    ])
                    self.interface_name = None
                    self.is_role_standby = None
                    self.total_tunnels = None
                    self.total_p2mp_tunnels = None
                    self.selected_tunnels = None
                    self.bandwidth_units = None
                    self._segment_path = lambda: "link-interface" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/admission-control/link-interfaces/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface, ['interface_name', 'is_role_standby', 'total_tunnels', 'total_p2mp_tunnels', 'selected_tunnels', 'bandwidth_units'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.AdmissionControl.LinkInterfaces.LinkInterface']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.AdmissionControl.LinkInterfaces']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.AdmissionControl']['meta_info']


    class SoftPreemptionGlobalInfo(_Entity_):
        """
        The global soft\-preemption information
        
        .. attribute:: is_configured
        
        	Is global soft\-preemption configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: is_timeout_interval_configured
        
        	Is global soft\-preemption timeout interval configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: timeout_interval
        
        	Global soft\-preemption timeout interval
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.SoftPreemptionGlobalInfo, self).__init__()

            self.yang_name = "soft-preemption-global-info"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                ('is_timeout_interval_configured', (YLeaf(YType.boolean, 'is-timeout-interval-configured'), ['bool'])),
                ('timeout_interval', (YLeaf(YType.uint32, 'timeout-interval'), ['int'])),
            ])
            self.is_configured = None
            self.is_timeout_interval_configured = None
            self.timeout_interval = None
            self._segment_path = lambda: "soft-preemption-global-info"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.SoftPreemptionGlobalInfo, ['is_configured', 'is_timeout_interval_configured', 'timeout_interval'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.SoftPreemptionGlobalInfo']['meta_info']


    class SoftPreemptions(_Entity_):
        """
        The soft preemption information for the TE\-links
        
        .. attribute:: soft_preemption
        
        	The soft preemption info for a TE\-link
        	**type**\: list of  		 :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions.SoftPreemption>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcacStandby.SoftPreemptions, self).__init__()

            self.yang_name = "soft-preemptions"
            self.yang_parent_name = "mpls-lcac-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("soft-preemption", ("soft_preemption", MplsLcacStandby.SoftPreemptions.SoftPreemption))])
            self._leafs = OrderedDict()

            self.soft_preemption = YList(self)
            self._segment_path = lambda: "soft-preemptions"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcacStandby.SoftPreemptions, [], name, value)


        class SoftPreemption(_Entity_):
            """
            The soft preemption info for a TE\-link
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: link_address
            
            	The link's IPv4 address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: total_soft_preempted_bandwidth_bc0
            
            	The total BC0 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_soft_preempted_bandwidth_bc1
            
            	The total BC1 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preempted_bandwidth_bc0
            
            	The current BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preempted_bandwidth_bc1
            
            	The current BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: release_soft_preempted_bandwidth_bc0
            
            	The total released BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: release_soft_preempted_bandwidth_bc1
            
            	The total released BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_over_subscribed_bandwidth_bc0
            
            	The BC0 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC0 BW on the link and the sum of the currently reserved BC0 bandwidth and the currently soft preempted BC0 BW
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_over_subscribed_bandwidth_bc1
            
            	The BC1 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC1 BW on the link and the sum of the currently reserved BC1 bandwidth and the currently soft preempted BC1 BW
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preemption_lsp
            
            	List of the soft preempted LSPs that are not yet cleaned up
            	**type**\: list of  		 :py:class:`CurrentSoftPreemptionLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcacStandby.SoftPreemptions.SoftPreemption, self).__init__()

                self.yang_name = "soft-preemption"
                self.yang_parent_name = "soft-preemptions"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("current-soft-preemption-lsp", ("current_soft_preemption_lsp", MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                    ('total_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'total-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('total_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'total-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('current_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'current-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('current_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'current-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('release_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'release-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('release_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'release-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('current_over_subscribed_bandwidth_bc0', (YLeaf(YType.uint64, 'current-over-subscribed-bandwidth-bc0'), ['int'])),
                    ('current_over_subscribed_bandwidth_bc1', (YLeaf(YType.uint64, 'current-over-subscribed-bandwidth-bc1'), ['int'])),
                ])
                self.interface_name = None
                self.link_address = None
                self.total_soft_preempted_bandwidth_bc0 = None
                self.total_soft_preempted_bandwidth_bc1 = None
                self.current_soft_preempted_bandwidth_bc0 = None
                self.current_soft_preempted_bandwidth_bc1 = None
                self.release_soft_preempted_bandwidth_bc0 = None
                self.release_soft_preempted_bandwidth_bc1 = None
                self.current_over_subscribed_bandwidth_bc0 = None
                self.current_over_subscribed_bandwidth_bc1 = None

                self.current_soft_preemption_lsp = YList(self)
                self._segment_path = lambda: "soft-preemption" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac-standby/soft-preemptions/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcacStandby.SoftPreemptions.SoftPreemption, ['interface_name', 'link_address', 'total_soft_preempted_bandwidth_bc0', 'total_soft_preempted_bandwidth_bc1', 'current_soft_preempted_bandwidth_bc0', 'current_soft_preempted_bandwidth_bc1', 'release_soft_preempted_bandwidth_bc0', 'release_soft_preempted_bandwidth_bc1', 'current_over_subscribed_bandwidth_bc0', 'current_over_subscribed_bandwidth_bc1'], name, value)


            class CurrentSoftPreemptionLsp(_Entity_):
                """
                List of the soft preempted LSPs that are not yet
                cleaned up
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__init__()

                    self.yang_name = "current-soft-preemption-lsp"
                    self.yang_parent_name = "soft-preemption"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                        ('soft_preempted', (YLeaf(YType.boolean, 'soft-preempted'), ['bool'])),
                        ('soft_preemption_timeout', (YLeaf(YType.uint16, 'soft-preemption-timeout'), ['int'])),
                        ('bandwidth_preempted', (YLeaf(YType.boolean, 'bandwidth-preempted'), ['bool'])),
                        ('soft_preempted_fr_rrewrite', (YLeaf(YType.boolean, 'soft-preempted-fr-rrewrite'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.requested_bandwidth = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth_type = None
                    self.soft_preempted = None
                    self.soft_preemption_timeout = None
                    self.bandwidth_preempted = None
                    self.soft_preempted_fr_rrewrite = None
                    self._segment_path = lambda: "current-soft-preemption-lsp"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, ['tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'soft_preempted', 'soft_preemption_timeout', 'bandwidth_preempted', 'soft_preempted_fr_rrewrite'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcacStandby.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcacStandby.SoftPreemptions.SoftPreemption']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcacStandby.SoftPreemptions']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsLcacStandby()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsLcacStandby']['meta_info']


class MplsLcac(_Entity_):
    """
    mpls lcac
    
    .. attribute:: neighbors
    
    	The neighbor information for the local router
    	**type**\:  :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors>`
    
    	**config**\: False
    
    .. attribute:: preemption_events
    
    	Preemption event log in MPLS\-LCAC
    	**type**\:  :py:class:`PreemptionEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents>`
    
    	**config**\: False
    
    .. attribute:: advertisements
    
    	The advertisement information in MPLS\-LCAC
    	**type**\:  :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements>`
    
    	**config**\: False
    
    .. attribute:: statistics
    
    	The interface statistics information in MPLS\-LCAC
    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_allocation
    
    	The bandwidth allocation information in MPLS\-LCAC
    	**type**\:  :py:class:`BandwidthAllocation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation>`
    
    	**config**\: False
    
    .. attribute:: gmpls
    
    	GMPLS data
    	**type**\:  :py:class:`Gmpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls>`
    
    	**config**\: False
    
    .. attribute:: bfd_neighbors
    
    	BFD Neighbors
    	**type**\:  :py:class:`BfdNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_account
    
    	The bandwidth accounting information in MPLS\-LCAC
    	**type**\:  :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount>`
    
    	**config**\: False
    
    .. attribute:: link_summary
    
    	The global summary for all the interfaces
    	**type**\:  :py:class:`LinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary>`
    
    	**config**\: False
    
    .. attribute:: link_information
    
    	The interface information in MPLS\-LCAC
    	**type**\:  :py:class:`LinkInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation>`
    
    	**config**\: False
    
    .. attribute:: admission_control
    
    	The admission control information in MPLS\-LCAC
    	**type**\:  :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl>`
    
    	**config**\: False
    
    .. attribute:: soft_preemption_global_info
    
    	The global soft\-preemption information
    	**type**\:  :py:class:`SoftPreemptionGlobalInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptionGlobalInfo>`
    
    	**config**\: False
    
    .. attribute:: soft_preemptions
    
    	The soft preemption information for the TE\-links
    	**type**\:  :py:class:`SoftPreemptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsLcac, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-lcac"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("neighbors", ("neighbors", MplsLcac.Neighbors)), ("preemption-events", ("preemption_events", MplsLcac.PreemptionEvents)), ("advertisements", ("advertisements", MplsLcac.Advertisements)), ("statistics", ("statistics", MplsLcac.Statistics)), ("bandwidth-allocation", ("bandwidth_allocation", MplsLcac.BandwidthAllocation)), ("gmpls", ("gmpls", MplsLcac.Gmpls)), ("bfd-neighbors", ("bfd_neighbors", MplsLcac.BfdNeighbors)), ("bandwidth-account", ("bandwidth_account", MplsLcac.BandwidthAccount)), ("link-summary", ("link_summary", MplsLcac.LinkSummary)), ("link-information", ("link_information", MplsLcac.LinkInformation)), ("admission-control", ("admission_control", MplsLcac.AdmissionControl)), ("soft-preemption-global-info", ("soft_preemption_global_info", MplsLcac.SoftPreemptionGlobalInfo)), ("soft-preemptions", ("soft_preemptions", MplsLcac.SoftPreemptions))])
        self._leafs = OrderedDict()

        self.neighbors = MplsLcac.Neighbors()
        self.neighbors.parent = self
        self._children_name_map["neighbors"] = "neighbors"

        self.preemption_events = MplsLcac.PreemptionEvents()
        self.preemption_events.parent = self
        self._children_name_map["preemption_events"] = "preemption-events"

        self.advertisements = MplsLcac.Advertisements()
        self.advertisements.parent = self
        self._children_name_map["advertisements"] = "advertisements"

        self.statistics = MplsLcac.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"

        self.bandwidth_allocation = MplsLcac.BandwidthAllocation()
        self.bandwidth_allocation.parent = self
        self._children_name_map["bandwidth_allocation"] = "bandwidth-allocation"

        self.gmpls = MplsLcac.Gmpls()
        self.gmpls.parent = self
        self._children_name_map["gmpls"] = "gmpls"

        self.bfd_neighbors = MplsLcac.BfdNeighbors()
        self.bfd_neighbors.parent = self
        self._children_name_map["bfd_neighbors"] = "bfd-neighbors"

        self.bandwidth_account = MplsLcac.BandwidthAccount()
        self.bandwidth_account.parent = self
        self._children_name_map["bandwidth_account"] = "bandwidth-account"

        self.link_summary = MplsLcac.LinkSummary()
        self.link_summary.parent = self
        self._children_name_map["link_summary"] = "link-summary"

        self.link_information = MplsLcac.LinkInformation()
        self.link_information.parent = self
        self._children_name_map["link_information"] = "link-information"

        self.admission_control = MplsLcac.AdmissionControl()
        self.admission_control.parent = self
        self._children_name_map["admission_control"] = "admission-control"

        self.soft_preemption_global_info = MplsLcac.SoftPreemptionGlobalInfo()
        self.soft_preemption_global_info.parent = self
        self._children_name_map["soft_preemption_global_info"] = "soft-preemption-global-info"

        self.soft_preemptions = MplsLcac.SoftPreemptions()
        self.soft_preemptions.parent = self
        self._children_name_map["soft_preemptions"] = "soft-preemptions"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsLcac, [], name, value)


    class Neighbors(_Entity_):
        """
        The neighbor information for the local router
        
        .. attribute:: neighbor
        
        	The neighbors connected to a particular interface
        	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors.Neighbor>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.Neighbors, self).__init__()

            self.yang_name = "neighbors"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcac.Neighbors.Neighbor))])
            self._leafs = OrderedDict()

            self.neighbor = YList(self)
            self._segment_path = lambda: "neighbors"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.Neighbors, [], name, value)


        class Neighbor(_Entity_):
            """
            The neighbors connected to a particular
            interface
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of  		 :py:class:`Neighbor_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Neighbors.Neighbor.Neighbor_>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Neighbors.Neighbor, self).__init__()

                self.yang_name = "neighbor"
                self.yang_parent_name = "neighbors"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcac.Neighbors.Neighbor.Neighbor_))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.neighbor = YList(self)
                self._segment_path = lambda: "neighbor" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/neighbors/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Neighbors.Neighbor, ['interface_name'], name, value)


            class Neighbor_(_Entity_):
                """
                Neighbors of the specified link id
                
                .. attribute:: interface_name
                
                	The interface on which this neighbor is discovered
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_id
                
                	The neighbor's id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	The area id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Neighbors.Neighbor.Neighbor_, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "neighbor"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('neighbor_id', (YLeaf(YType.str, 'neighbor-id'), ['str'])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                    ])
                    self.interface_name = None
                    self.neighbor_id = None
                    self.area_id = None
                    self.neighbor_address = None
                    self._segment_path = lambda: "neighbor"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Neighbors.Neighbor.Neighbor_, ['interface_name', 'neighbor_id', 'area_id', 'neighbor_address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Neighbors.Neighbor.Neighbor_']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Neighbors.Neighbor']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.Neighbors']['meta_info']


    class PreemptionEvents(_Entity_):
        """
        Preemption event log in MPLS\-LCAC
        
        .. attribute:: preemption_event
        
        	Preemption event
        	**type**\: list of  		 :py:class:`PreemptionEvent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents.PreemptionEvent>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.PreemptionEvents, self).__init__()

            self.yang_name = "preemption-events"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("preemption-event", ("preemption_event", MplsLcac.PreemptionEvents.PreemptionEvent))])
            self._leafs = OrderedDict()

            self.preemption_event = YList(self)
            self._segment_path = lambda: "preemption-events"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.PreemptionEvents, [], name, value)


        class PreemptionEvent(_Entity_):
            """
            Preemption event
            
            .. attribute:: event_index  (key)
            
            	Event index
            	**type**\: int
            
            	**range:** 0..1999
            
            	**config**\: False
            
            .. attribute:: tunnel_id
            
            	Tunnel ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: lsp_id
            
            	LSP ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: requested_bandwidth
            
            	The path's requested bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: setup_priority
            
            	The path's setup priority
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: hold_priority
            
            	The path's hold priority
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: bandwidth_type
            
            	The path's bandwidth type; 0\:CT0, 1\:CT1, so on
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: old_bandwidth_bc0
            
            	Old BW for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: old_bandwidth_bc1
            
            	Old BW for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: new_bandwidth_bc0
            
            	New BW for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: new_bandwidth_bc1
            
            	New BW for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: bandwidth_overshoot0
            
            	BW Overshoot for BC0
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: bandwidth_overshoot1
            
            	BW Overshoot for BC1
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: interface_name
            
            	Interface name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: event_time
            
            	Event time; seconds elapsed since January 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: ls_ps
            
            	Number of LSPs (not all may be present in the list)
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps
            
            	Number of LSPs softly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps_fr_rrewrite
            
            	Number of LSPs softly preempted with traffic switched to backup
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: hard_preempted_ls_ps
            
            	Number of LSPs hardly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: total_preempted_bandwidth_bc0
            
            	Total amount of preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_preempted_bandwidth_bc1
            
            	Total amount of preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: softly_preempted_bandwidth_bc0
            
            	Amount of softly preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: softly_preempted_bandwidth_bc1
            
            	Amount of softly preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc0
            
            	Amount of softly preempted FRR RW class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: soft_preempted_fr_rrewrite_bandwidth_bc1
            
            	Amount of softly preempted FRR RW class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: hard_preempted_bandwidth_bc0
            
            	Amount of hard preempted class 0 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: hard_preempted_bandwidth_bc1
            
            	Amount of hard preempted class 1 bandwidth
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: tunnels
            
            	Number of Tunnels
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_tunnels
            
            	Number of Tunnels softly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: soft_preempted_tunnels_fr_rrewrite
            
            	Number of Tunnels softly preempted with traffic switched to backup
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: hard_preempted_tunnels
            
            	Number of Tunnels hardly preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: lsp
            
            	List of preempted LSPs
            	**type**\: list of  		 :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.PreemptionEvents.PreemptionEvent.Lsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.PreemptionEvents.PreemptionEvent, self).__init__()

                self.yang_name = "preemption-event"
                self.yang_parent_name = "preemption-events"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['event_index']
                self._child_classes = OrderedDict([("lsp", ("lsp", MplsLcac.PreemptionEvents.PreemptionEvent.Lsp))])
                self._leafs = OrderedDict([
                    ('event_index', (YLeaf(YType.uint32, 'event-index'), ['int'])),
                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                    ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                    ('old_bandwidth_bc0', (YLeaf(YType.uint64, 'old-bandwidth-bc0'), ['int'])),
                    ('old_bandwidth_bc1', (YLeaf(YType.uint64, 'old-bandwidth-bc1'), ['int'])),
                    ('new_bandwidth_bc0', (YLeaf(YType.uint64, 'new-bandwidth-bc0'), ['int'])),
                    ('new_bandwidth_bc1', (YLeaf(YType.uint64, 'new-bandwidth-bc1'), ['int'])),
                    ('bandwidth_overshoot0', (YLeaf(YType.uint64, 'bandwidth-overshoot0'), ['int'])),
                    ('bandwidth_overshoot1', (YLeaf(YType.uint64, 'bandwidth-overshoot1'), ['int'])),
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ('event_time', (YLeaf(YType.uint32, 'event-time'), ['int'])),
                    ('ls_ps', (YLeaf(YType.uint16, 'ls-ps'), ['int'])),
                    ('soft_preempted_ls_ps', (YLeaf(YType.uint16, 'soft-preempted-ls-ps'), ['int'])),
                    ('soft_preempted_ls_ps_fr_rrewrite', (YLeaf(YType.uint16, 'soft-preempted-ls-ps-fr-rrewrite'), ['int'])),
                    ('hard_preempted_ls_ps', (YLeaf(YType.uint16, 'hard-preempted-ls-ps'), ['int'])),
                    ('total_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'total-preempted-bandwidth-bc0'), ['int'])),
                    ('total_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'total-preempted-bandwidth-bc1'), ['int'])),
                    ('softly_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'softly-preempted-bandwidth-bc0'), ['int'])),
                    ('softly_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'softly-preempted-bandwidth-bc1'), ['int'])),
                    ('soft_preempted_fr_rrewrite_bandwidth_bc0', (YLeaf(YType.uint64, 'soft-preempted-fr-rrewrite-bandwidth-bc0'), ['int'])),
                    ('soft_preempted_fr_rrewrite_bandwidth_bc1', (YLeaf(YType.uint64, 'soft-preempted-fr-rrewrite-bandwidth-bc1'), ['int'])),
                    ('hard_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'hard-preempted-bandwidth-bc0'), ['int'])),
                    ('hard_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'hard-preempted-bandwidth-bc1'), ['int'])),
                    ('tunnels', (YLeaf(YType.uint16, 'tunnels'), ['int'])),
                    ('soft_preempted_tunnels', (YLeaf(YType.uint16, 'soft-preempted-tunnels'), ['int'])),
                    ('soft_preempted_tunnels_fr_rrewrite', (YLeaf(YType.uint16, 'soft-preempted-tunnels-fr-rrewrite'), ['int'])),
                    ('hard_preempted_tunnels', (YLeaf(YType.uint16, 'hard-preempted-tunnels'), ['int'])),
                ])
                self.event_index = None
                self.tunnel_id = None
                self.lsp_id = None
                self.source_address = None
                self.destination_address = None
                self.requested_bandwidth = None
                self.setup_priority = None
                self.hold_priority = None
                self.bandwidth_type = None
                self.old_bandwidth_bc0 = None
                self.old_bandwidth_bc1 = None
                self.new_bandwidth_bc0 = None
                self.new_bandwidth_bc1 = None
                self.bandwidth_overshoot0 = None
                self.bandwidth_overshoot1 = None
                self.interface_name = None
                self.event_time = None
                self.ls_ps = None
                self.soft_preempted_ls_ps = None
                self.soft_preempted_ls_ps_fr_rrewrite = None
                self.hard_preempted_ls_ps = None
                self.total_preempted_bandwidth_bc0 = None
                self.total_preempted_bandwidth_bc1 = None
                self.softly_preempted_bandwidth_bc0 = None
                self.softly_preempted_bandwidth_bc1 = None
                self.soft_preempted_fr_rrewrite_bandwidth_bc0 = None
                self.soft_preempted_fr_rrewrite_bandwidth_bc1 = None
                self.hard_preempted_bandwidth_bc0 = None
                self.hard_preempted_bandwidth_bc1 = None
                self.tunnels = None
                self.soft_preempted_tunnels = None
                self.soft_preempted_tunnels_fr_rrewrite = None
                self.hard_preempted_tunnels = None

                self.lsp = YList(self)
                self._segment_path = lambda: "preemption-event" + "[event-index='" + str(self.event_index) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/preemption-events/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.PreemptionEvents.PreemptionEvent, ['event_index', 'tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'old_bandwidth_bc0', 'old_bandwidth_bc1', 'new_bandwidth_bc0', 'new_bandwidth_bc1', 'bandwidth_overshoot0', 'bandwidth_overshoot1', 'interface_name', 'event_time', 'ls_ps', 'soft_preempted_ls_ps', 'soft_preempted_ls_ps_fr_rrewrite', 'hard_preempted_ls_ps', 'total_preempted_bandwidth_bc0', 'total_preempted_bandwidth_bc1', 'softly_preempted_bandwidth_bc0', 'softly_preempted_bandwidth_bc1', 'soft_preempted_fr_rrewrite_bandwidth_bc0', 'soft_preempted_fr_rrewrite_bandwidth_bc1', 'hard_preempted_bandwidth_bc0', 'hard_preempted_bandwidth_bc1', 'tunnels', 'soft_preempted_tunnels', 'soft_preempted_tunnels_fr_rrewrite', 'hard_preempted_tunnels'], name, value)


            class Lsp(_Entity_):
                """
                List of preempted LSPs
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.PreemptionEvents.PreemptionEvent.Lsp, self).__init__()

                    self.yang_name = "lsp"
                    self.yang_parent_name = "preemption-event"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                        ('soft_preempted', (YLeaf(YType.boolean, 'soft-preempted'), ['bool'])),
                        ('soft_preemption_timeout', (YLeaf(YType.uint16, 'soft-preemption-timeout'), ['int'])),
                        ('bandwidth_preempted', (YLeaf(YType.boolean, 'bandwidth-preempted'), ['bool'])),
                        ('soft_preempted_fr_rrewrite', (YLeaf(YType.boolean, 'soft-preempted-fr-rrewrite'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.requested_bandwidth = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth_type = None
                    self.soft_preempted = None
                    self.soft_preemption_timeout = None
                    self.bandwidth_preempted = None
                    self.soft_preempted_fr_rrewrite = None
                    self._segment_path = lambda: "lsp"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.PreemptionEvents.PreemptionEvent.Lsp, ['tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'soft_preempted', 'soft_preemption_timeout', 'bandwidth_preempted', 'soft_preempted_fr_rrewrite'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.PreemptionEvents.PreemptionEvent.Lsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.PreemptionEvents.PreemptionEvent']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.PreemptionEvents']['meta_info']


    class Advertisements(_Entity_):
        """
        The advertisement information in MPLS\-LCAC
        
        .. attribute:: flooding_status_message
        
        	Flooding status\: ready or reason
        	**type**\: str
        
        	**config**\: False
        
        .. attribute:: last_flooding_time
        
        	Time elapsed since last flooding in seconds
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        	**units**\: second
        
        .. attribute:: last_flooding_trigger
        
        	Trigger for last flooding
        	**type**\:  :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
        
        	**config**\: False
        
        .. attribute:: next_flooding_time
        
        	Time remained for next flooding in seconds
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        	**units**\: second
        
        .. attribute:: ds_te_mode
        
        	DS\-TE Mode
        	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
        
        	**config**\: False
        
        .. attribute:: advertized_areas
        
        	Advertising info for all the IGP areas
        	**type**\: list of  		 :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.Advertisements, self).__init__()

            self.yang_name = "advertisements"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("advertized-areas", ("advertized_areas", MplsLcac.Advertisements.AdvertizedAreas))])
            self._leafs = OrderedDict([
                ('flooding_status_message', (YLeaf(YType.str, 'flooding-status-message'), ['str'])),
                ('last_flooding_time', (YLeaf(YType.uint32, 'last-flooding-time'), ['int'])),
                ('last_flooding_trigger', (YLeaf(YType.enumeration, 'last-flooding-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FloodingTrigger', '')])),
                ('next_flooding_time', (YLeaf(YType.uint32, 'next-flooding-time'), ['int'])),
                ('ds_te_mode', (YLeaf(YType.enumeration, 'ds-te-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
            ])
            self.flooding_status_message = None
            self.last_flooding_time = None
            self.last_flooding_trigger = None
            self.next_flooding_time = None
            self.ds_te_mode = None

            self.advertized_areas = YList(self)
            self._segment_path = lambda: "advertisements"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.Advertisements, ['flooding_status_message', 'last_flooding_time', 'last_flooding_trigger', 'next_flooding_time', 'ds_te_mode'], name, value)


        class AdvertizedAreas(_Entity_):
            """
            Advertising info for all the IGP areas
            
            .. attribute:: igp_area_id
            
            	The area id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol
            
            	The IGP protocol running over this area
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: system_id
            
            	The node's system id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: router_id
            
            	The node's router ID
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: flooded_link
            
            	The array of flooded links in this area
            	**type**\: list of  		 :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Advertisements.AdvertizedAreas, self).__init__()

                self.yang_name = "advertized-areas"
                self.yang_parent_name = "advertisements"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("flooded-link", ("flooded_link", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink))])
                self._leafs = OrderedDict([
                    ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                    ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                ])
                self.igp_area_id = None
                self.protocol = None
                self.system_id = None
                self.router_id = None

                self.flooded_link = YList(self)
                self._segment_path = lambda: "advertized-areas"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas, ['igp_area_id', 'protocol', 'system_id', 'router_id'], name, value)


            class FloodedLink(_Entity_):
                """
                The array of flooded links in this area
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	The link's id
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: interface_name
                
                	The link's interface name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: link_address
                
                	The link's IPv4 address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: subnet_type
                
                	The link's subnet type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: outgoing_interface_id
                
                	The link's outgoing interface's id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_designated_router
                
                	TRUE if the link belongs to a desig. router
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: designated_router_igp_id
                
                	IGP id of the designated router
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: neighbor_igp_id
                
                	The neighbor's IGP id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_neighbor_address
                
                	The neighbor's ip address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: incoming_interface_id
                
                	The link's incoming interface's id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uni_link_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_units
                
                	The link's bandwidth units
                	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                	**config**\: False
                
                .. attribute:: physical_bandwidth
                
                	The link's physical BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bcm_id
                
                	Bandwidth Constraints Model ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: link_maximum_reservable_bandwidth
                
                	The link's maximum reservable BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth
                
                	The link's reservable pool0 BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth
                
                	The link's reservable pool1 BW
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_receiving_reservable_bandwidth_enabled
                
                	TRUE if receiving reservable BW is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: receiving_direction
                
                	Upstream or Downstream
                	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                	**config**\: False
                
                .. attribute:: is_transmitting_reservable_bandwidth_enabled
                
                	TRUE if transmitting reservable BW is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: transmitting_direction
                
                	Upstream or Downstream
                	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                
                	**config**\: False
                
                .. attribute:: affinity_attribute_flags
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_affinity_attribute_flag
                
                	The link's extended affinity bits
                	**type**\: list of  		 :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: receiving_reservable_bandwidth
                
                	Receiving reservable BW at each priority level(priority 0 to priority 7)
                	**type**\: list of  		 :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                
                	**config**\: False
                
                .. attribute:: transmitting_reservable_bandwidth
                
                	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                	**type**\: list of  		 :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                    self.yang_name = "flooded-link"
                    self.yang_parent_name = "advertized-areas"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("odu-link-capabilities", ("odu_link_capabilities", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities)), ("extended-affinity-attribute-flag", ("extended_affinity_attribute_flag", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup)), ("receiving-reservable-bandwidth", ("receiving_reservable_bandwidth", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth)), ("transmitting-reservable-bandwidth", ("transmitting_reservable_bandwidth", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth))])
                    self._leafs = OrderedDict([
                        ('link_id', (YLeaf(YType.uint16, 'link-id'), ['int'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                        ('subnet_type', (YLeaf(YType.enumeration, 'subnet-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('outgoing_interface_id', (YLeaf(YType.uint32, 'outgoing-interface-id'), ['int'])),
                        ('is_designated_router', (YLeaf(YType.boolean, 'is-designated-router'), ['bool'])),
                        ('designated_router_igp_id', (YLeaf(YType.str, 'designated-router-igp-id'), ['str'])),
                        ('neighbor_igp_id', (YLeaf(YType.str, 'neighbor-igp-id'), ['str'])),
                        ('igp_neighbor_address', (YLeaf(YType.str, 'igp-neighbor-address'), ['str'])),
                        ('incoming_interface_id', (YLeaf(YType.uint32, 'incoming-interface-id'), ['int'])),
                        ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                        ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                        ('uni_link_delay', (YLeaf(YType.uint32, 'uni-link-delay'), ['int'])),
                        ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ('physical_bandwidth', (YLeaf(YType.uint32, 'physical-bandwidth'), ['int'])),
                        ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                        ('link_maximum_reservable_bandwidth', (YLeaf(YType.uint32, 'link-maximum-reservable-bandwidth'), ['int'])),
                        ('reservable_pool0_bandwidth', (YLeaf(YType.uint32, 'reservable-pool0-bandwidth'), ['int'])),
                        ('reservable_pool1_bandwidth', (YLeaf(YType.uint32, 'reservable-pool1-bandwidth'), ['int'])),
                        ('is_receiving_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-receiving-reservable-bandwidth-enabled'), ['bool'])),
                        ('receiving_direction', (YLeaf(YType.enumeration, 'receiving-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                        ('is_transmitting_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-transmitting-reservable-bandwidth-enabled'), ['bool'])),
                        ('transmitting_direction', (YLeaf(YType.enumeration, 'transmitting-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                        ('affinity_attribute_flags', (YLeaf(YType.uint32, 'affinity-attribute-flags'), ['int'])),
                    ])
                    self.link_id = None
                    self.interface_name = None
                    self.link_address = None
                    self.subnet_type = None
                    self.outgoing_interface_id = None
                    self.is_designated_router = None
                    self.designated_router_igp_id = None
                    self.neighbor_igp_id = None
                    self.igp_neighbor_address = None
                    self.incoming_interface_id = None
                    self.te_metric = None
                    self.igp_metric = None
                    self.uni_link_delay = None
                    self.bandwidth_units = None
                    self.physical_bandwidth = None
                    self.bcm_id = None
                    self.link_maximum_reservable_bandwidth = None
                    self.reservable_pool0_bandwidth = None
                    self.reservable_pool1_bandwidth = None
                    self.is_receiving_reservable_bandwidth_enabled = None
                    self.receiving_direction = None
                    self.is_transmitting_reservable_bandwidth_enabled = None
                    self.transmitting_direction = None
                    self.affinity_attribute_flags = None

                    self.odu_link_capabilities = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.extended_affinity_attribute_flag = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.receiving_reservable_bandwidth = YList(self)
                    self.transmitting_reservable_bandwidth = YList(self)
                    self._segment_path = lambda: "flooded-link"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink, ['link_id', 'interface_name', 'link_address', 'subnet_type', 'outgoing_interface_id', 'is_designated_router', 'designated_router_igp_id', 'neighbor_igp_id', 'igp_neighbor_address', 'incoming_interface_id', 'te_metric', 'igp_metric', 'uni_link_delay', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'link_maximum_reservable_bandwidth', 'reservable_pool0_bandwidth', 'reservable_pool1_bandwidth', 'is_receiving_reservable_bandwidth_enabled', 'receiving_direction', 'is_transmitting_reservable_bandwidth_enabled', 'transmitting_direction', 'affinity_attribute_flags'], name, value)


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities']['meta_info']


                class ExtendedAffinityAttributeFlag(_Entity_):
                    """
                    The link's extended affinity bits
                    
                    .. attribute:: entry
                    
                    	The link's extended affinity bits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                        self.yang_name = "extended-affinity-attribute-flag"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "extended-affinity-attribute-flag"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup']['meta_info']


                class ReceivingReservableBandwidth(_Entity_):
                    """
                    Receiving reservable BW at each priority
                    level(priority 0 to priority 7)
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                        self.yang_name = "receiving-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                            ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                            ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                        ])
                        self.priority = None
                        self.pool0_bandwidth = None
                        self.pool1_bandwidth = None
                        self._segment_path = lambda: "receiving-reservable-bandwidth"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth']['meta_info']


                class TransmittingReservableBandwidth(_Entity_):
                    """
                    Transmitting reservable BW at each priority
                    level (priority 0 to priority 7)
                    
                    .. attribute:: priority
                    
                    	The priority level of this bandwidth
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: pool0_bandwidth
                    
                    	The reservable pool0 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pool1_bandwidth
                    
                    	The reservable pool1 BW at this priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                        self.yang_name = "transmitting-reservable-bandwidth"
                        self.yang_parent_name = "flooded-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                            ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                            ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                        ])
                        self.priority = None
                        self.pool0_bandwidth = None
                        self.pool1_bandwidth = None
                        self._segment_path = lambda: "transmitting-reservable-bandwidth"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas.FloodedLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Advertisements.AdvertizedAreas']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.Advertisements']['meta_info']


    class Statistics(_Entity_):
        """
        The interface statistics information in
        MPLS\-LCAC
        
        .. attribute:: summary
        
        	The statistics summary for all interfaces
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary>`
        
        	**config**\: False
        
        .. attribute:: statstics_links
        
        	The table of statistics interfaces in MPLS\-LCAC
        	**type**\:  :py:class:`StatsticsLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsLcac.Statistics.Summary)), ("statstics-links", ("statstics_links", MplsLcac.Statistics.StatsticsLinks))])
            self._leafs = OrderedDict()

            self.summary = MplsLcac.Statistics.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.statstics_links = MplsLcac.Statistics.StatsticsLinks()
            self.statstics_links.parent = self
            self._children_name_map["statstics_links"] = "statstics-links"
            self._segment_path = lambda: "statistics"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.Statistics, [], name, value)


        class Summary(_Entity_):
            """
            The statistics summary for all interfaces
            
            .. attribute:: path_statistics
            
            	Deprecated
            	**type**\:  :py:class:`PathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.PathStatistics>`
            
            	**config**\: False
            
            .. attribute:: reservation_statistics
            
            	Deprecated
            	**type**\:  :py:class:`ReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.ReservationStatistics>`
            
            	**config**\: False
            
            .. attribute:: path_statistics32_bit
            
            	Path counters (32\-bit)
            	**type**\:  :py:class:`PathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.PathStatistics32Bit>`
            
            	**config**\: False
            
            .. attribute:: reservation_statistics32_bit
            
            	Reservation counters (32\-bit)
            	**type**\:  :py:class:`ReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.Summary.ReservationStatistics32Bit>`
            
            	**config**\: False
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Statistics.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-statistics", ("path_statistics", MplsLcac.Statistics.Summary.PathStatistics)), ("reservation-statistics", ("reservation_statistics", MplsLcac.Statistics.Summary.ReservationStatistics)), ("path-statistics32-bit", ("path_statistics32_bit", MplsLcac.Statistics.Summary.PathStatistics32Bit)), ("reservation-statistics32-bit", ("reservation_statistics32_bit", MplsLcac.Statistics.Summary.ReservationStatistics32Bit))])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                ])
                self.is_role_standby = None

                self.path_statistics = MplsLcac.Statistics.Summary.PathStatistics()
                self.path_statistics.parent = self
                self._children_name_map["path_statistics"] = "path-statistics"

                self.reservation_statistics = MplsLcac.Statistics.Summary.ReservationStatistics()
                self.reservation_statistics.parent = self
                self._children_name_map["reservation_statistics"] = "reservation-statistics"

                self.path_statistics32_bit = MplsLcac.Statistics.Summary.PathStatistics32Bit()
                self.path_statistics32_bit.parent = self
                self._children_name_map["path_statistics32_bit"] = "path-statistics32-bit"

                self.reservation_statistics32_bit = MplsLcac.Statistics.Summary.ReservationStatistics32Bit()
                self.reservation_statistics32_bit.parent = self
                self._children_name_map["reservation_statistics32_bit"] = "reservation-statistics32-bit"
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Statistics.Summary, ['is_role_standby'], name, value)


            class PathStatistics(_Entity_):
                """
                Deprecated
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Statistics.Summary.PathStatistics, self).__init__()

                    self.yang_name = "path-statistics"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "path-statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Statistics.Summary.PathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Statistics.Summary.PathStatistics']['meta_info']


            class ReservationStatistics(_Entity_):
                """
                Deprecated
                
                .. attribute:: setup_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Statistics.Summary.ReservationStatistics, self).__init__()

                    self.yang_name = "reservation-statistics"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "reservation-statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Statistics.Summary.ReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Statistics.Summary.ReservationStatistics']['meta_info']


            class PathStatistics32Bit(_Entity_):
                """
                Path counters (32\-bit)
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Statistics.Summary.PathStatistics32Bit, self).__init__()

                    self.yang_name = "path-statistics32-bit"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "path-statistics32-bit"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Statistics.Summary.PathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Statistics.Summary.PathStatistics32Bit']['meta_info']


            class ReservationStatistics32Bit(_Entity_):
                """
                Reservation counters (32\-bit)
                
                .. attribute:: setup_requests
                
                	Setup requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_errors
                
                	Setup errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_admits
                
                	Setup admits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_rejects
                
                	Setup rejects
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_requests
                
                	Tear requests
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_errors
                
                	Tear errors
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tear_preempts
                
                	Tear preempts
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Statistics.Summary.ReservationStatistics32Bit, self).__init__()

                    self.yang_name = "reservation-statistics32-bit"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                        ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                        ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                        ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                        ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                        ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                        ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                    ])
                    self.setup_requests = None
                    self.setup_errors = None
                    self.setup_admits = None
                    self.setup_rejects = None
                    self.tear_requests = None
                    self.tear_errors = None
                    self.tear_preempts = None
                    self._segment_path = lambda: "reservation-statistics32-bit"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Statistics.Summary.ReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Statistics.Summary.ReservationStatistics32Bit']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Statistics.Summary']['meta_info']


        class StatsticsLinks(_Entity_):
            """
            The table of statistics interfaces in MPLS\-LCAC
            
            .. attribute:: statstics_link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of  		 :py:class:`StatsticsLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Statistics.StatsticsLinks, self).__init__()

                self.yang_name = "statstics-links"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("statstics-link", ("statstics_link", MplsLcac.Statistics.StatsticsLinks.StatsticsLink))])
                self._leafs = OrderedDict()

                self.statstics_link = YList(self)
                self._segment_path = lambda: "statstics-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Statistics.StatsticsLinks, [], name, value)


            class StatsticsLink(_Entity_):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: incoming_path_statistics
                
                	Deprecated
                	**type**\:  :py:class:`IncomingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics>`
                
                	**config**\: False
                
                .. attribute:: incoming_reservation_statistics
                
                	Deprecated
                	**type**\:  :py:class:`IncomingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics>`
                
                	**config**\: False
                
                .. attribute:: outgoing_path_statistics
                
                	Deprecated
                	**type**\:  :py:class:`OutgoingPathStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics>`
                
                	**config**\: False
                
                .. attribute:: outgoing_reservation_statistics
                
                	Deprecated
                	**type**\:  :py:class:`OutgoingReservationStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics>`
                
                	**config**\: False
                
                .. attribute:: incoming_path_statistics32_bit
                
                	Incoming PATH counters
                	**type**\:  :py:class:`IncomingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: incoming_reservation_statistics32_bit
                
                	Incoming RESV counters
                	**type**\:  :py:class:`IncomingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: outgoing_path_statistics32_bit
                
                	Outgoing PATH counters
                	**type**\:  :py:class:`OutgoingPathStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: outgoing_reservation_statistics32_bit
                
                	Outgoing RESV counters
                	**type**\:  :py:class:`OutgoingReservationStatistics32Bit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit>`
                
                	**config**\: False
                
                .. attribute:: interface_name_xr
                
                	Link name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: link_address
                
                	Link's ip address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink, self).__init__()

                    self.yang_name = "statstics-link"
                    self.yang_parent_name = "statstics-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("incoming-path-statistics", ("incoming_path_statistics", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics)), ("incoming-reservation-statistics", ("incoming_reservation_statistics", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics)), ("outgoing-path-statistics", ("outgoing_path_statistics", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics)), ("outgoing-reservation-statistics", ("outgoing_reservation_statistics", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics)), ("incoming-path-statistics32-bit", ("incoming_path_statistics32_bit", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit)), ("incoming-reservation-statistics32-bit", ("incoming_reservation_statistics32_bit", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit)), ("outgoing-path-statistics32-bit", ("outgoing_path_statistics32_bit", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit)), ("outgoing-reservation-statistics32-bit", ("outgoing_reservation_statistics32_bit", MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('interface_name_xr', (YLeaf(YType.str, 'interface-name-xr'), ['str'])),
                        ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                    ])
                    self.interface_name = None
                    self.interface_name_xr = None
                    self.link_address = None

                    self.incoming_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics()
                    self.incoming_path_statistics.parent = self
                    self._children_name_map["incoming_path_statistics"] = "incoming-path-statistics"

                    self.incoming_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics()
                    self.incoming_reservation_statistics.parent = self
                    self._children_name_map["incoming_reservation_statistics"] = "incoming-reservation-statistics"

                    self.outgoing_path_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics()
                    self.outgoing_path_statistics.parent = self
                    self._children_name_map["outgoing_path_statistics"] = "outgoing-path-statistics"

                    self.outgoing_reservation_statistics = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics()
                    self.outgoing_reservation_statistics.parent = self
                    self._children_name_map["outgoing_reservation_statistics"] = "outgoing-reservation-statistics"

                    self.incoming_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit()
                    self.incoming_path_statistics32_bit.parent = self
                    self._children_name_map["incoming_path_statistics32_bit"] = "incoming-path-statistics32-bit"

                    self.incoming_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit()
                    self.incoming_reservation_statistics32_bit.parent = self
                    self._children_name_map["incoming_reservation_statistics32_bit"] = "incoming-reservation-statistics32-bit"

                    self.outgoing_path_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit()
                    self.outgoing_path_statistics32_bit.parent = self
                    self._children_name_map["outgoing_path_statistics32_bit"] = "outgoing-path-statistics32-bit"

                    self.outgoing_reservation_statistics32_bit = MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit()
                    self.outgoing_reservation_statistics32_bit.parent = self
                    self._children_name_map["outgoing_reservation_statistics32_bit"] = "outgoing-reservation-statistics32-bit"
                    self._segment_path = lambda: "statstics-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/statistics/statstics-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink, ['interface_name', 'interface_name_xr', 'link_address'], name, value)


                class IncomingPathStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, self).__init__()

                        self.yang_name = "incoming-path-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-path-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics']['meta_info']


                class IncomingReservationStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, self).__init__()

                        self.yang_name = "incoming-reservation-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-reservation-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics']['meta_info']


                class OutgoingPathStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, self).__init__()

                        self.yang_name = "outgoing-path-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-path-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics']['meta_info']


                class OutgoingReservationStatistics(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: setup_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint16, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint16, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint16, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint16, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint16, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint16, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint16, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-reservation-statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics']['meta_info']


                class IncomingPathStatistics32Bit(_Entity_):
                    """
                    Incoming PATH counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-path-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingPathStatistics32Bit']['meta_info']


                class IncomingReservationStatistics32Bit(_Entity_):
                    """
                    Incoming RESV counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "incoming-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "incoming-reservation-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.IncomingReservationStatistics32Bit']['meta_info']


                class OutgoingPathStatistics32Bit(_Entity_):
                    """
                    Outgoing PATH counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-path-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-path-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingPathStatistics32Bit']['meta_info']


                class OutgoingReservationStatistics32Bit(_Entity_):
                    """
                    Outgoing RESV counters
                    
                    .. attribute:: setup_requests
                    
                    	Setup requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_errors
                    
                    	Setup errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_admits
                    
                    	Setup admits
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup_rejects
                    
                    	Setup rejects
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_requests
                    
                    	Tear requests
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_errors
                    
                    	Tear errors
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tear_preempts
                    
                    	Tear preempts
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, self).__init__()

                        self.yang_name = "outgoing-reservation-statistics32-bit"
                        self.yang_parent_name = "statstics-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('setup_requests', (YLeaf(YType.uint32, 'setup-requests'), ['int'])),
                            ('setup_errors', (YLeaf(YType.uint32, 'setup-errors'), ['int'])),
                            ('setup_admits', (YLeaf(YType.uint32, 'setup-admits'), ['int'])),
                            ('setup_rejects', (YLeaf(YType.uint32, 'setup-rejects'), ['int'])),
                            ('tear_requests', (YLeaf(YType.uint32, 'tear-requests'), ['int'])),
                            ('tear_errors', (YLeaf(YType.uint32, 'tear-errors'), ['int'])),
                            ('tear_preempts', (YLeaf(YType.uint32, 'tear-preempts'), ['int'])),
                        ])
                        self.setup_requests = None
                        self.setup_errors = None
                        self.setup_admits = None
                        self.setup_rejects = None
                        self.tear_requests = None
                        self.tear_errors = None
                        self.tear_preempts = None
                        self._segment_path = lambda: "outgoing-reservation-statistics32-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit, ['setup_requests', 'setup_errors', 'setup_admits', 'setup_rejects', 'tear_requests', 'tear_errors', 'tear_preempts'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink.OutgoingReservationStatistics32Bit']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Statistics.StatsticsLinks.StatsticsLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Statistics.StatsticsLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.Statistics']['meta_info']


    class BandwidthAllocation(_Entity_):
        """
        The bandwidth allocation information in
        MPLS\-LCAC
        
        .. attribute:: global_
        
        	Global bandwidth allocation information for all interfaces
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.Global>`
        
        	**config**\: False
        
        .. attribute:: bandwidth_allocation_links
        
        	Per\-link bandwidth allocation information in MPLS\-LCAC
        	**type**\:  :py:class:`BandwidthAllocationLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.BandwidthAllocation, self).__init__()

            self.yang_name = "bandwidth-allocation"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcac.BandwidthAllocation.Global)), ("bandwidth-allocation-links", ("bandwidth_allocation_links", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcac.BandwidthAllocation.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.bandwidth_allocation_links = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks()
            self.bandwidth_allocation_links.parent = self
            self._children_name_map["bandwidth_allocation_links"] = "bandwidth-allocation-links"
            self._segment_path = lambda: "bandwidth-allocation"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.BandwidthAllocation, [], name, value)


        class Global(_Entity_):
            """
            Global bandwidth allocation information for all
            interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: links
            
            	Number of links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: bandwidth_hold_time
            
            	How long to hold the bandwidth (seconds)
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.BandwidthAllocation.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "bandwidth-allocation"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                    ('bandwidth_hold_time', (YLeaf(YType.uint16, 'bandwidth-hold-time'), ['int'])),
                ])
                self.is_role_standby = None
                self.links = None
                self.bandwidth_hold_time = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.BandwidthAllocation.Global, ['is_role_standby', 'links', 'bandwidth_hold_time'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.BandwidthAllocation.Global']['meta_info']


        class BandwidthAllocationLinks(_Entity_):
            """
            Per\-link bandwidth allocation information in
            MPLS\-LCAC
            
            .. attribute:: bandwidth_allocation_link
            
            	The bandwidth allocation for a given interface
            	**type**\: list of  		 :py:class:`BandwidthAllocationLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks, self).__init__()

                self.yang_name = "bandwidth-allocation-links"
                self.yang_parent_name = "bandwidth-allocation"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bandwidth-allocation-link", ("bandwidth_allocation_link", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink))])
                self._leafs = OrderedDict()

                self.bandwidth_allocation_link = YList(self)
                self._segment_path = lambda: "bandwidth-allocation-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks, [], name, value)


            class BandwidthAllocationLink(_Entity_):
                """
                The bandwidth allocation for a given interface
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:  :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon>`
                
                	**config**\: False
                
                .. attribute:: upstream_bandwidth
                
                	BW info in the upstream direction
                	**type**\:  :py:class:`UpstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth>`
                
                	**config**\: False
                
                .. attribute:: downstream_bandwidth
                
                	BW info in the dnstream direction
                	**type**\:  :py:class:`DownstreamBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth>`
                
                	**config**\: False
                
                .. attribute:: total_bandwidth_descriptors
                
                	Number of total BW descriptors
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: bandwidth_descriptors
                
                	Number of BW descriptor for the given pool
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool
                
                	type of the BW pool
                	**type**\:  :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                	**config**\: False
                
                .. attribute:: flooding_up_thresholds_are_default
                
                	TRUE if the up\-threshold are default
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_down_thresholds_are_default
                
                	TRUE if the down\-threshold are default
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_up_thresholds_are_global
                
                	TRUE if the up\-threshold are global
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_down_thresholds_are_global
                
                	TRUE if the down\-threshold are global
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: flooding_up_threshold
                
                	Flooding up\-thresholds
                	**type**\: list of  		 :py:class:`FloodingUpThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold>`
                
                	**config**\: False
                
                .. attribute:: flooding_down_threshold
                
                	Flooding down\-thresholds
                	**type**\: list of  		 :py:class:`FloodingDownThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, self).__init__()

                    self.yang_name = "bandwidth-allocation-link"
                    self.yang_parent_name = "bandwidth-allocation-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("link-common", ("link_common", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon)), ("upstream-bandwidth", ("upstream_bandwidth", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth)), ("downstream-bandwidth", ("downstream_bandwidth", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth)), ("flooding-up-threshold", ("flooding_up_threshold", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold)), ("flooding-down-threshold", ("flooding_down_threshold", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('total_bandwidth_descriptors', (YLeaf(YType.uint16, 'total-bandwidth-descriptors'), ['int'])),
                        ('bandwidth_descriptors', (YLeaf(YType.uint16, 'bandwidth-descriptors'), ['int'])),
                        ('bandwidth_pool', (YLeaf(YType.enumeration, 'bandwidth-pool'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthTypeEnum', '')])),
                        ('flooding_up_thresholds_are_default', (YLeaf(YType.boolean, 'flooding-up-thresholds-are-default'), ['bool'])),
                        ('flooding_down_thresholds_are_default', (YLeaf(YType.boolean, 'flooding-down-thresholds-are-default'), ['bool'])),
                        ('flooding_up_thresholds_are_global', (YLeaf(YType.boolean, 'flooding-up-thresholds-are-global'), ['bool'])),
                        ('flooding_down_thresholds_are_global', (YLeaf(YType.boolean, 'flooding-down-thresholds-are-global'), ['bool'])),
                    ])
                    self.interface_name = None
                    self.total_bandwidth_descriptors = None
                    self.bandwidth_descriptors = None
                    self.bandwidth_pool = None
                    self.flooding_up_thresholds_are_default = None
                    self.flooding_down_thresholds_are_default = None
                    self.flooding_up_thresholds_are_global = None
                    self.flooding_down_thresholds_are_global = None

                    self.link_common = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"

                    self.upstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth()
                    self.upstream_bandwidth.parent = self
                    self._children_name_map["upstream_bandwidth"] = "upstream-bandwidth"

                    self.downstream_bandwidth = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth()
                    self.downstream_bandwidth.parent = self
                    self._children_name_map["downstream_bandwidth"] = "downstream-bandwidth"

                    self.flooding_up_threshold = YList(self)
                    self.flooding_down_threshold = YList(self)
                    self._segment_path = lambda: "bandwidth-allocation-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-allocation/bandwidth-allocation-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink, ['interface_name', 'total_bandwidth_descriptors', 'bandwidth_descriptors', 'bandwidth_pool', 'flooding_up_thresholds_are_default', 'flooding_down_thresholds_are_default', 'flooding_up_thresholds_are_global', 'flooding_down_thresholds_are_global'], name, value)


                class LinkCommon(_Entity_):
                    """
                    The link's common info
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:  :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags>`
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of  		 :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    	**config**\: False
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of  		 :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("link-flags", ("link_flags", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup)), ("interface-switching-capability-descriptor", ("interface_switching_capability_descriptor", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor)), ("flooded-areas", ("flooded_areas", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas))])
                        self._leafs = OrderedDict([
                            ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                            ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                            ('is_unnumbered', (YLeaf(YType.boolean, 'is-unnumbered'), ['bool'])),
                            ('has_protection', (YLeaf(YType.boolean, 'has-protection'), ['bool'])),
                            ('capability', (YLeaf(YType.uint32, 'capability'), ['int'])),
                            ('working_priority', (YLeaf(YType.uint32, 'working-priority'), ['int'])),
                            ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                            ('is_resource_provider_installed', (YLeaf(YType.boolean, 'is-resource-provider-installed'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                            ('physical_bandwidth', (YLeaf(YType.uint64, 'physical-bandwidth'), ['int'])),
                            ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                            ('maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-bandwidth'), ['int'])),
                            ('last_flooded_effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'last-flooded-effective-maximum-reservable-bandwidth'), ['int'])),
                            ('incoming_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool0_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool0-bandwidth'), ['int'])),
                            ('incoming_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool1_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool1-bandwidth'), ['int'])),
                            ('incoming_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('inbound_admission_method', (YLeaf(YType.enumeration, 'inbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('outbound_admission_method', (YLeaf(YType.enumeration, 'outbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                        ])
                        self.link_id = None
                        self.link_address = None
                        self.is_unnumbered = None
                        self.has_protection = None
                        self.capability = None
                        self.working_priority = None
                        self.resource_provider = None
                        self.is_resource_provider_installed = None
                        self.bandwidth_units = None
                        self.physical_bandwidth = None
                        self.bcm_id = None
                        self.maximum_reservable_bandwidth = None
                        self.last_flooded_effective_maximum_reservable_bandwidth = None
                        self.incoming_reservable_bandwidth_percentage = None
                        self.outgoing_reservable_bandwidth_percentage = None
                        self.maximum_reservable_pool0_bandwidth = None
                        self.incoming_reservable_pool0_bandwidth_percentage = None
                        self.outgoing_reservable_pool0_bandwidth_percentage = None
                        self.maximum_reservable_pool1_bandwidth = None
                        self.incoming_reservable_pool1_bandwidth_percentage = None
                        self.outgoing_reservable_pool1_bandwidth_percentage = None
                        self.inbound_admission_method = None
                        self.outbound_admission_method = None
                        self.igp_neighbors = None

                        self.link_flags = MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"

                        self.shared_risk_link_group = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.flooded_areas = YList(self)
                        self._segment_path = lambda: "link-common"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon, ['link_id', 'link_address', 'is_unnumbered', 'has_protection', 'capability', 'working_priority', 'resource_provider', 'is_resource_provider_installed', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'maximum_reservable_bandwidth', 'last_flooded_effective_maximum_reservable_bandwidth', 'incoming_reservable_bandwidth_percentage', 'outgoing_reservable_bandwidth_percentage', 'maximum_reservable_pool0_bandwidth', 'incoming_reservable_pool0_bandwidth_percentage', 'outgoing_reservable_pool0_bandwidth_percentage', 'maximum_reservable_pool1_bandwidth', 'incoming_reservable_pool1_bandwidth_percentage', 'outgoing_reservable_pool1_bandwidth_percentage', 'inbound_admission_method', 'outbound_admission_method', 'igp_neighbors'], name, value)


                    class LinkFlags(_Entity_):
                        """
                        The link's flags
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:  :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_mpls_te_on', (YLeaf(YType.boolean, 'is-mpls-te-on'), ['bool'])),
                                ('signaling_agent', (YLeaf(YType.enumeration, 'signaling-agent'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'SignalingAgentEnum', '')])),
                                ('is_admin_up', (YLeaf(YType.boolean, 'is-admin-up'), ['bool'])),
                            ])
                            self.is_mpls_te_on = None
                            self.signaling_agent = None
                            self.is_admin_up = None
                            self._segment_path = lambda: "link-flags"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags, ['is_mpls_te_on', 'signaling_agent', 'is_admin_up'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.LinkFlags']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.SharedRiskLinkGroup']['meta_info']


                    class InterfaceSwitchingCapabilityDescriptor(_Entity_):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('key', (YLeaf(YType.uint8, 'key'), ['int'])),
                                ('switching_capability', (YLeaf(YType.uint8, 'switching-capability'), ['int'])),
                                ('encoding', (YLeaf(YType.uint8, 'encoding'), ['int'])),
                            ])
                            self.key = None
                            self.switching_capability = None
                            self.encoding = None
                            self._segment_path = lambda: "interface-switching-capability-descriptor"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor, ['key', 'switching_capability', 'encoding'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.InterfaceSwitchingCapabilityDescriptor']['meta_info']


                    class FloodedAreas(_Entity_):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('flooded_area', (YLeaf(YType.str, 'flooded-area'), ['str'])),
                            ])
                            self.flooded_area = None
                            self._segment_path = lambda: "flooded-areas"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas, ['flooded_area'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon.FloodedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.LinkCommon']['meta_info']


                class UpstreamBandwidth(_Entity_):
                    """
                    BW info in the upstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, self).__init__()

                        self.yang_name = "upstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-pool0", ("bandwidth_pool0", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0)), ("bandwidth-pool1", ("bandwidth_pool1", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1))])
                        self._leafs = OrderedDict([
                            ('bandwidth_direction', (YLeaf(YType.enumeration, 'bandwidth-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                            ('is_admission_method_allocated_bandwidth', (YLeaf(YType.boolean, 'is-admission-method-allocated-bandwidth'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ])
                        self.bandwidth_direction = None
                        self.is_admission_method_allocated_bandwidth = None
                        self.bandwidth_units = None

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)
                        self._segment_path = lambda: "upstream-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth, ['bandwidth_direction', 'is_admission_method_allocated_bandwidth', 'bandwidth_units'], name, value)


                    class BandwidthPool0(_Entity_):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "upstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool0"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool0']['meta_info']


                    class BandwidthPool1(_Entity_):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "upstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool1"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth.BandwidthPool1']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.UpstreamBandwidth']['meta_info']


                class DownstreamBandwidth(_Entity_):
                    """
                    BW info in the dnstream direction
                    
                    .. attribute:: bandwidth_direction
                    
                    	BW Direction
                    	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_admission_method_allocated_bandwidth
                    
                    	True if the link's admit method is based on Allocated BW
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	Bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool0
                    
                    	Pool0 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool0 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_pool1
                    
                    	Pool1 BW info for the different priority levels
                    	**type**\: list of  		 :py:class:`BandwidthPool1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, self).__init__()

                        self.yang_name = "downstream-bandwidth"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-pool0", ("bandwidth_pool0", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0)), ("bandwidth-pool1", ("bandwidth_pool1", MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1))])
                        self._leafs = OrderedDict([
                            ('bandwidth_direction', (YLeaf(YType.enumeration, 'bandwidth-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                            ('is_admission_method_allocated_bandwidth', (YLeaf(YType.boolean, 'is-admission-method-allocated-bandwidth'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                        ])
                        self.bandwidth_direction = None
                        self.is_admission_method_allocated_bandwidth = None
                        self.bandwidth_units = None

                        self.bandwidth_pool0 = YList(self)
                        self.bandwidth_pool1 = YList(self)
                        self._segment_path = lambda: "downstream-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth, ['bandwidth_direction', 'is_admission_method_allocated_bandwidth', 'bandwidth_units'], name, value)


                    class BandwidthPool0(_Entity_):
                        """
                        Pool0 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, self).__init__()

                            self.yang_name = "bandwidth-pool0"
                            self.yang_parent_name = "downstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool0"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool0']['meta_info']


                    class BandwidthPool1(_Entity_):
                        """
                        Pool1 BW info for the different priority levels
                        
                        .. attribute:: hold_priority
                        
                        	The BW priority
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: held_amount
                        
                        	The held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_held_amount
                        
                        	The total held bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: locked_amount
                        
                        	The locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_locked_amount
                        
                        	The total locked bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, self).__init__()

                            self.yang_name = "bandwidth-pool1"
                            self.yang_parent_name = "downstream-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                ('held_amount', (YLeaf(YType.uint32, 'held-amount'), ['int'])),
                                ('total_held_amount', (YLeaf(YType.uint32, 'total-held-amount'), ['int'])),
                                ('locked_amount', (YLeaf(YType.uint32, 'locked-amount'), ['int'])),
                                ('total_locked_amount', (YLeaf(YType.uint32, 'total-locked-amount'), ['int'])),
                            ])
                            self.hold_priority = None
                            self.held_amount = None
                            self.total_held_amount = None
                            self.locked_amount = None
                            self.total_locked_amount = None
                            self._segment_path = lambda: "bandwidth-pool1"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1, ['hold_priority', 'held_amount', 'total_held_amount', 'locked_amount', 'total_locked_amount'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth.BandwidthPool1']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.DownstreamBandwidth']['meta_info']


                class FloodingUpThreshold(_Entity_):
                    """
                    Flooding up\-thresholds
                    
                    .. attribute:: entry
                    
                    	Flooding up\-thresholds
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, self).__init__()

                        self.yang_name = "flooding-up-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "flooding-up-threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingUpThreshold']['meta_info']


                class FloodingDownThreshold(_Entity_):
                    """
                    Flooding down\-thresholds
                    
                    .. attribute:: entry
                    
                    	Flooding down\-thresholds
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, self).__init__()

                        self.yang_name = "flooding-down-threshold"
                        self.yang_parent_name = "bandwidth-allocation-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "flooding-down-threshold"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink.FloodingDownThreshold']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks.BandwidthAllocationLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.BandwidthAllocation.BandwidthAllocationLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.BandwidthAllocation']['meta_info']


    class Gmpls(_Entity_):
        """
        GMPLS data
        
        .. attribute:: nni
        
        	GMPLS NNI data
        	**type**\:  :py:class:`Nni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni>`
        
        	**config**\: False
        
        .. attribute:: uni
        
        	GMPLS UNI data
        	**type**\:  :py:class:`Uni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.Gmpls, self).__init__()

            self.yang_name = "gmpls"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("nni", ("nni", MplsLcac.Gmpls.Nni)), ("uni", ("uni", MplsLcac.Gmpls.Uni))])
            self._leafs = OrderedDict()

            self.nni = MplsLcac.Gmpls.Nni()
            self.nni.parent = self
            self._children_name_map["nni"] = "nni"

            self.uni = MplsLcac.Gmpls.Uni()
            self.uni.parent = self
            self._children_name_map["uni"] = "uni"
            self._segment_path = lambda: "gmpls"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.Gmpls, [], name, value)


        class Nni(_Entity_):
            """
            GMPLS NNI data
            
            .. attribute:: otn
            
            	GMPLS OTN\-NNI data
            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Gmpls.Nni, self).__init__()

                self.yang_name = "nni"
                self.yang_parent_name = "gmpls"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("otn", ("otn", MplsLcac.Gmpls.Nni.Otn))])
                self._leafs = OrderedDict()

                self.otn = MplsLcac.Gmpls.Nni.Otn()
                self.otn.parent = self
                self._children_name_map["otn"] = "otn"
                self._segment_path = lambda: "nni"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Gmpls.Nni, [], name, value)


            class Otn(_Entity_):
                """
                GMPLS OTN\-NNI data
                
                .. attribute:: advertisements
                
                	GMPLS OTN\-NNI advertisement information
                	**type**\:  :py:class:`Advertisements <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements>`
                
                	**config**\: False
                
                .. attribute:: summary
                
                	GMPLS NNI OTN summary information
                	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Summary>`
                
                	**config**\: False
                
                .. attribute:: controllers
                
                	GMPLS OTN\-NNI controllers
                	**type**\:  :py:class:`Controllers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers>`
                
                	**config**\: False
                
                .. attribute:: admission_controls
                
                	GMPLS OTN\-NNI admission control table
                	**type**\:  :py:class:`AdmissionControls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.AdmissionControls>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Gmpls.Nni.Otn, self).__init__()

                    self.yang_name = "otn"
                    self.yang_parent_name = "nni"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("advertisements", ("advertisements", MplsLcac.Gmpls.Nni.Otn.Advertisements)), ("summary", ("summary", MplsLcac.Gmpls.Nni.Otn.Summary)), ("controllers", ("controllers", MplsLcac.Gmpls.Nni.Otn.Controllers)), ("admission-controls", ("admission_controls", MplsLcac.Gmpls.Nni.Otn.AdmissionControls))])
                    self._leafs = OrderedDict()

                    self.advertisements = MplsLcac.Gmpls.Nni.Otn.Advertisements()
                    self.advertisements.parent = self
                    self._children_name_map["advertisements"] = "advertisements"

                    self.summary = MplsLcac.Gmpls.Nni.Otn.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"

                    self.controllers = MplsLcac.Gmpls.Nni.Otn.Controllers()
                    self.controllers.parent = self
                    self._children_name_map["controllers"] = "controllers"

                    self.admission_controls = MplsLcac.Gmpls.Nni.Otn.AdmissionControls()
                    self.admission_controls.parent = self
                    self._children_name_map["admission_controls"] = "admission-controls"
                    self._segment_path = lambda: "otn"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn, [], name, value)


                class Advertisements(_Entity_):
                    """
                    GMPLS OTN\-NNI advertisement information
                    
                    .. attribute:: flooding_status_message
                    
                    	Flooding status\: ready or reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooding_time
                    
                    	Time elapsed since last flooding in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: last_flooding_trigger
                    
                    	Trigger for last flooding
                    	**type**\:  :py:class:`FloodingTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FloodingTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_flooding_time
                    
                    	Time remained for next flooding in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: ds_te_mode
                    
                    	DS\-TE Mode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: advertized_areas
                    
                    	Advertising info for all the IGP areas
                    	**type**\: list of  		 :py:class:`AdvertizedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Gmpls.Nni.Otn.Advertisements, self).__init__()

                        self.yang_name = "advertisements"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("advertized-areas", ("advertized_areas", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas))])
                        self._leafs = OrderedDict([
                            ('flooding_status_message', (YLeaf(YType.str, 'flooding-status-message'), ['str'])),
                            ('last_flooding_time', (YLeaf(YType.uint32, 'last-flooding-time'), ['int'])),
                            ('last_flooding_trigger', (YLeaf(YType.enumeration, 'last-flooding-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FloodingTrigger', '')])),
                            ('next_flooding_time', (YLeaf(YType.uint32, 'next-flooding-time'), ['int'])),
                            ('ds_te_mode', (YLeaf(YType.enumeration, 'ds-te-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.flooding_status_message = None
                        self.last_flooding_time = None
                        self.last_flooding_trigger = None
                        self.next_flooding_time = None
                        self.ds_te_mode = None

                        self.advertized_areas = YList(self)
                        self._segment_path = lambda: "advertisements"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements, ['flooding_status_message', 'last_flooding_time', 'last_flooding_trigger', 'next_flooding_time', 'ds_te_mode'], name, value)


                    class AdvertizedAreas(_Entity_):
                        """
                        Advertising info for all the IGP areas
                        
                        .. attribute:: igp_area_id
                        
                        	The area id
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protocol
                        
                        	The IGP protocol running over this area
                        	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                        
                        	**config**\: False
                        
                        .. attribute:: system_id
                        
                        	The node's system id
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: router_id
                        
                        	The node's router ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: flooded_link
                        
                        	The array of flooded links in this area
                        	**type**\: list of  		 :py:class:`FloodedLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas, self).__init__()

                            self.yang_name = "advertized-areas"
                            self.yang_parent_name = "advertisements"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flooded-link", ("flooded_link", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink))])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                                ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                                ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                            ])
                            self.igp_area_id = None
                            self.protocol = None
                            self.system_id = None
                            self.router_id = None

                            self.flooded_link = YList(self)
                            self._segment_path = lambda: "advertized-areas"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas, ['igp_area_id', 'protocol', 'system_id', 'router_id'], name, value)


                        class FloodedLink(_Entity_):
                            """
                            The array of flooded links in this area
                            
                            .. attribute:: odu_link_capabilities
                            
                            	ODU Link Capabilities
                            	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities>`
                            
                            	**config**\: False
                            
                            .. attribute:: link_id
                            
                            	The link's id
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: interface_name
                            
                            	The link's interface name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: link_address
                            
                            	The link's IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: subnet_type
                            
                            	The link's subnet type
                            	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_interface_id
                            
                            	The link's outgoing interface's id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_designated_router
                            
                            	TRUE if the link belongs to a desig. router
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: designated_router_igp_id
                            
                            	IGP id of the designated router
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: neighbor_igp_id
                            
                            	The neighbor's IGP id
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: igp_neighbor_address
                            
                            	The neighbor's ip address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_interface_id
                            
                            	The link's incoming interface's id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: te_metric
                            
                            	The link's TE metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	The link's IGP metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay
                            
                            	Unidirectional Link Delay in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_units
                            
                            	The link's bandwidth units
                            	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: physical_bandwidth
                            
                            	The link's physical BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bcm_id
                            
                            	Bandwidth Constraints Model ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: link_maximum_reservable_bandwidth
                            
                            	The link's maximum reservable BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reservable_pool0_bandwidth
                            
                            	The link's reservable pool0 BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reservable_pool1_bandwidth
                            
                            	The link's reservable pool1 BW
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_receiving_reservable_bandwidth_enabled
                            
                            	TRUE if receiving reservable BW is enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: receiving_direction
                            
                            	Upstream or Downstream
                            	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_transmitting_reservable_bandwidth_enabled
                            
                            	TRUE if transmitting reservable BW is enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: transmitting_direction
                            
                            	Upstream or Downstream
                            	**type**\:  :py:class:`LinkDirectionEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LinkDirectionEnum>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_attribute_flags
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: extended_affinity_attribute_flag
                            
                            	The link's extended affinity bits
                            	**type**\: list of  		 :py:class:`ExtendedAffinityAttributeFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag>`
                            
                            	**config**\: False
                            
                            .. attribute:: shared_risk_link_group
                            
                            	The link's shared risk link groups
                            	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup>`
                            
                            	**config**\: False
                            
                            .. attribute:: receiving_reservable_bandwidth
                            
                            	Receiving reservable BW at each priority level(priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`ReceivingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: transmitting_reservable_bandwidth
                            
                            	Transmitting reservable BW at each priority level (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TransmittingReservableBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink, self).__init__()

                                self.yang_name = "flooded-link"
                                self.yang_parent_name = "advertized-areas"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-link-capabilities", ("odu_link_capabilities", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities)), ("extended-affinity-attribute-flag", ("extended_affinity_attribute_flag", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup)), ("receiving-reservable-bandwidth", ("receiving_reservable_bandwidth", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth)), ("transmitting-reservable-bandwidth", ("transmitting_reservable_bandwidth", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth))])
                                self._leafs = OrderedDict([
                                    ('link_id', (YLeaf(YType.uint16, 'link-id'), ['int'])),
                                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                    ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                                    ('subnet_type', (YLeaf(YType.enumeration, 'subnet-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                                    ('outgoing_interface_id', (YLeaf(YType.uint32, 'outgoing-interface-id'), ['int'])),
                                    ('is_designated_router', (YLeaf(YType.boolean, 'is-designated-router'), ['bool'])),
                                    ('designated_router_igp_id', (YLeaf(YType.str, 'designated-router-igp-id'), ['str'])),
                                    ('neighbor_igp_id', (YLeaf(YType.str, 'neighbor-igp-id'), ['str'])),
                                    ('igp_neighbor_address', (YLeaf(YType.str, 'igp-neighbor-address'), ['str'])),
                                    ('incoming_interface_id', (YLeaf(YType.uint32, 'incoming-interface-id'), ['int'])),
                                    ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                                    ('uni_link_delay', (YLeaf(YType.uint32, 'uni-link-delay'), ['int'])),
                                    ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                                    ('physical_bandwidth', (YLeaf(YType.uint32, 'physical-bandwidth'), ['int'])),
                                    ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                                    ('link_maximum_reservable_bandwidth', (YLeaf(YType.uint32, 'link-maximum-reservable-bandwidth'), ['int'])),
                                    ('reservable_pool0_bandwidth', (YLeaf(YType.uint32, 'reservable-pool0-bandwidth'), ['int'])),
                                    ('reservable_pool1_bandwidth', (YLeaf(YType.uint32, 'reservable-pool1-bandwidth'), ['int'])),
                                    ('is_receiving_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-receiving-reservable-bandwidth-enabled'), ['bool'])),
                                    ('receiving_direction', (YLeaf(YType.enumeration, 'receiving-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                                    ('is_transmitting_reservable_bandwidth_enabled', (YLeaf(YType.boolean, 'is-transmitting-reservable-bandwidth-enabled'), ['bool'])),
                                    ('transmitting_direction', (YLeaf(YType.enumeration, 'transmitting-direction'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LinkDirectionEnum', '')])),
                                    ('affinity_attribute_flags', (YLeaf(YType.uint32, 'affinity-attribute-flags'), ['int'])),
                                ])
                                self.link_id = None
                                self.interface_name = None
                                self.link_address = None
                                self.subnet_type = None
                                self.outgoing_interface_id = None
                                self.is_designated_router = None
                                self.designated_router_igp_id = None
                                self.neighbor_igp_id = None
                                self.igp_neighbor_address = None
                                self.incoming_interface_id = None
                                self.te_metric = None
                                self.igp_metric = None
                                self.uni_link_delay = None
                                self.bandwidth_units = None
                                self.physical_bandwidth = None
                                self.bcm_id = None
                                self.link_maximum_reservable_bandwidth = None
                                self.reservable_pool0_bandwidth = None
                                self.reservable_pool1_bandwidth = None
                                self.is_receiving_reservable_bandwidth_enabled = None
                                self.receiving_direction = None
                                self.is_transmitting_reservable_bandwidth_enabled = None
                                self.transmitting_direction = None
                                self.affinity_attribute_flags = None

                                self.odu_link_capabilities = MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities()
                                self.odu_link_capabilities.parent = self
                                self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                                self.extended_affinity_attribute_flag = YList(self)
                                self.shared_risk_link_group = YList(self)
                                self.receiving_reservable_bandwidth = YList(self)
                                self.transmitting_reservable_bandwidth = YList(self)
                                self._segment_path = lambda: "flooded-link"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink, ['link_id', 'interface_name', 'link_address', 'subnet_type', 'outgoing_interface_id', 'is_designated_router', 'designated_router_igp_id', 'neighbor_igp_id', 'igp_neighbor_address', 'incoming_interface_id', 'te_metric', 'igp_metric', 'uni_link_delay', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'link_maximum_reservable_bandwidth', 'reservable_pool0_bandwidth', 'reservable_pool1_bandwidth', 'is_receiving_reservable_bandwidth_enabled', 'receiving_direction', 'is_transmitting_reservable_bandwidth_enabled', 'transmitting_direction', 'affinity_attribute_flags'], name, value)


                            class OduLinkCapabilities(_Entity_):
                                """
                                ODU Link Capabilities
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Max LSP Bandwidth per priority in kbit/s
                                	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_capability
                                
                                	ODU Capabilities of Link
                                	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, self).__init__()

                                    self.yang_name = "odu-link-capabilities"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability))])
                                    self._leafs = OrderedDict()

                                    self.max_lsp_bandwidth = YList(self)
                                    self.odu_capability = YList(self)
                                    self._segment_path = lambda: "odu-link-capabilities"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities, [], name, value)


                                class MaxLspBandwidth(_Entity_):
                                    """
                                    Max LSP Bandwidth per priority in kbit/s
                                    
                                    .. attribute:: entry
                                    
                                    	Max LSP Bandwidth per priority in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                                        self.yang_name = "max-lsp-bandwidth"
                                        self.yang_parent_name = "odu-link-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = False
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "max-lsp-bandwidth"
                                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                                class OduCapability(_Entity_):
                                    """
                                    ODU Capabilities of Link
                                    
                                    .. attribute:: bandwidth_info
                                    
                                    	Bandwidth related info for this ODU level
                                    	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: signal_type
                                    
                                    	Signal Type
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage1
                                    
                                    	ODU Type at stage 1, Not Set for HO ODU
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage2
                                    
                                    	ODU Type at stage 2, Not Set for single stage mulitplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage3
                                    
                                    	ODU Type at stage 3, Not set up to two levels of multiplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: stage4
                                    
                                    	ODU Type at stage 4, Not set up to three levels of multiplexing
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: terminable
                                    
                                    	True if link is terminable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: switchable
                                    
                                    	True if link is switchable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsg1p25
                                    
                                    	True if link supports 1.25G TSG for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tsg2p5
                                    
                                    	True if link supports 2.5G TSG for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: vcat_capable
                                    
                                    	True if link VCAT capable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lcas_capable
                                    
                                    	True if link LCAS capable for this ODU level
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, self).__init__()

                                        self.yang_name = "odu-capability"
                                        self.yang_parent_name = "odu-link-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = False
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                                        self._leafs = OrderedDict([
                                            ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                            ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                            ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                            ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                            ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                            ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                            ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                                        ])
                                        self.signal_type = None
                                        self.stage1 = None
                                        self.stage2 = None
                                        self.stage3 = None
                                        self.stage4 = None
                                        self.terminable = None
                                        self.switchable = None
                                        self.tsg1p25 = None
                                        self.tsg2p5 = None
                                        self.vcat_capable = None
                                        self.lcas_capable = None

                                        self.bandwidth_info = MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                        self.bandwidth_info.parent = self
                                        self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                        self._segment_path = lambda: "odu-capability"
                                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/%s" % self._segment_path()
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                                    class BandwidthInfo(_Entity_):
                                        """
                                        Bandwidth related info for this ODU level
                                        
                                        .. attribute:: fixed
                                        
                                        	ODU capability for Fixed ODUs
                                        	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: flex
                                        
                                        	ODU capability for Flex ODUs
                                        	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                            self.yang_name = "bandwidth-info"
                                            self.yang_parent_name = "odu-capability"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = False
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                            self._leafs = OrderedDict([
                                                ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                            ])
                                            self.type = None

                                            self.fixed = MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                            self.fixed.parent = self
                                            self._children_name_map["fixed"] = "fixed"

                                            self.flex = MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                            self.flex.parent = self
                                            self._children_name_map["flex"] = "flex"
                                            self._segment_path = lambda: "bandwidth-info"
                                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/%s" % self._segment_path()
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                                        class Fixed(_Entity_):
                                            """
                                            ODU capability for Fixed ODUs
                                            
                                            .. attribute:: maximum_od_us
                                            
                                            	Maximum Number of ODUs of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unreserved_od_us
                                            
                                            	Maximum Number of ODUs of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                                self.yang_name = "fixed"
                                                self.yang_parent_name = "bandwidth-info"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = False
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                                    ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                                ])
                                                self.maximum_od_us = None
                                                self.unreserved_od_us = None
                                                self._segment_path = lambda: "fixed"
                                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                                        class Flex(_Entity_):
                                            """
                                            ODU capability for Flex ODUs
                                            
                                            .. attribute:: max_bandwidth
                                            
                                            	Max kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: unreserved_bandwidth
                                            
                                            	Unreserved kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: max_lsp_bandwidth
                                            
                                            	Per LSP Max kbps Bandwidth of this level possible on this link
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                                self.yang_name = "flex"
                                                self.yang_parent_name = "bandwidth-info"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = False
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                                    ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                                    ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                                ])
                                                self.max_bandwidth = None
                                                self.unreserved_bandwidth = None
                                                self.max_lsp_bandwidth = None
                                                self._segment_path = lambda: "flex"
                                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/odu-link-capabilities/odu-capability/bandwidth-info/%s" % self._segment_path()
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities.OduCapability']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.OduLinkCapabilities']['meta_info']


                            class ExtendedAffinityAttributeFlag(_Entity_):
                                """
                                The link's extended affinity bits
                                
                                .. attribute:: entry
                                
                                	The link's extended affinity bits
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, self).__init__()

                                    self.yang_name = "extended-affinity-attribute-flag"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-affinity-attribute-flag"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ExtendedAffinityAttributeFlag']['meta_info']


                            class SharedRiskLinkGroup(_Entity_):
                                """
                                The link's shared risk link groups
                                
                                .. attribute:: shared_risk_group
                                
                                	SRLG number
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_name
                                
                                	SRLG name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, self).__init__()

                                    self.yang_name = "shared-risk-link-group"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ])
                                    self.shared_risk_group = None
                                    self.srlg_name = None
                                    self._segment_path = lambda: "shared-risk-link-group"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.SharedRiskLinkGroup']['meta_info']


                            class ReceivingReservableBandwidth(_Entity_):
                                """
                                Receiving reservable BW at each priority
                                level(priority 0 to priority 7)
                                
                                .. attribute:: priority
                                
                                	The priority level of this bandwidth
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pool0_bandwidth
                                
                                	The reservable pool0 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: pool1_bandwidth
                                
                                	The reservable pool1 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, self).__init__()

                                    self.yang_name = "receiving-reservable-bandwidth"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                                        ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                                        ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                                    ])
                                    self.priority = None
                                    self.pool0_bandwidth = None
                                    self.pool1_bandwidth = None
                                    self._segment_path = lambda: "receiving-reservable-bandwidth"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.ReceivingReservableBandwidth']['meta_info']


                            class TransmittingReservableBandwidth(_Entity_):
                                """
                                Transmitting reservable BW at each priority
                                level (priority 0 to priority 7)
                                
                                .. attribute:: priority
                                
                                	The priority level of this bandwidth
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: pool0_bandwidth
                                
                                	The reservable pool0 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: pool1_bandwidth
                                
                                	The reservable pool1 BW at this priority
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, self).__init__()

                                    self.yang_name = "transmitting-reservable-bandwidth"
                                    self.yang_parent_name = "flooded-link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                                        ('pool0_bandwidth', (YLeaf(YType.uint32, 'pool0-bandwidth'), ['int'])),
                                        ('pool1_bandwidth', (YLeaf(YType.uint32, 'pool1-bandwidth'), ['int'])),
                                    ])
                                    self.priority = None
                                    self.pool0_bandwidth = None
                                    self.pool1_bandwidth = None
                                    self._segment_path = lambda: "transmitting-reservable-bandwidth"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/advertisements/advertized-areas/flooded-link/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth, ['priority', 'pool0_bandwidth', 'pool1_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink.TransmittingReservableBandwidth']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas.FloodedLink']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements.AdvertizedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Advertisements']['meta_info']


                class Summary(_Entity_):
                    """
                    GMPLS NNI OTN summary information
                    
                    .. attribute:: is_role_standby
                    
                    	TRUE if Role is Standby, False if Active
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: nni_otn_links
                    
                    	The number of NNI OTN links
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: nni_otn_links_max
                    
                    	Maximum number of NNI links supported
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Gmpls.Nni.Otn.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                            ('nni_otn_links', (YLeaf(YType.uint16, 'nni-otn-links'), ['int'])),
                            ('nni_otn_links_max', (YLeaf(YType.uint16, 'nni-otn-links-max'), ['int'])),
                        ])
                        self.is_role_standby = None
                        self.nni_otn_links = None
                        self.nni_otn_links_max = None
                        self._segment_path = lambda: "summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Summary, ['is_role_standby', 'nni_otn_links', 'nni_otn_links_max'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Summary']['meta_info']


                class Controllers(_Entity_):
                    """
                    GMPLS OTN\-NNI controllers
                    
                    .. attribute:: controller
                    
                    	A GMPLS OTN\-NNI link
                    	**type**\: list of  		 :py:class:`Controller <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Gmpls.Nni.Otn.Controllers, self).__init__()

                        self.yang_name = "controllers"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("controller", ("controller", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller))])
                        self._leafs = OrderedDict()

                        self.controller = YList(self)
                        self._segment_path = lambda: "controllers"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers, [], name, value)


                    class Controller(_Entity_):
                        """
                        A GMPLS OTN\-NNI link
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: local_link_id
                        
                        	Local TE link ID
                        	**type**\:  :py:class:`LocalLinkId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId>`
                        
                        	**config**\: False
                        
                        .. attribute:: odu_link_capabilities
                        
                        	ODU capabilities of Link
                        	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_name
                        
                        	The link's name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: interface_handle
                        
                        	Link interface handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link_state
                        
                        	Link state
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: resource_provider
                        
                        	The link's resource provider
                        	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                        
                        	**config**\: False
                        
                        .. attribute:: physical_bandwidth
                        
                        	The link's physical bandwidth
                        	**type**\:  :py:class:`Otu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Otu>`
                        
                        	**config**\: False
                        
                        .. attribute:: tti_mode
                        
                        	SM,PM or TCM mode for controller
                        	**type**\:  :py:class:`TtiMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TtiMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: tandem_connection_monitoring
                        
                        	Tandem connection monitoring to carry link id, 0 if PM
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: igp_neighbors_count
                        
                        	The link's neighbor count
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: link_attributes
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_attribute_incomplete
                        
                        	TRUE if one or more affinity definition(s) is/are         unknown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_name_based_attribute
                        
                        	TRUE, if name based attribute style is in effect
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_extended_attribute
                        
                        	The link's extended attribute bit map
                        	**type**\: list of  		 :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_forwad_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: srl_gs
                        
                        	The link's shared risk link groups
                        	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.SrlGs>`
                        
                        	**config**\: False
                        
                        .. attribute:: igp_areas
                        
                        	Per\-IGP area data
                        	**type**\: list of  		 :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas>`
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_map
                        
                        	Affinity map array
                        	**type**\: list of  		 :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller, self).__init__()

                            self.yang_name = "controller"
                            self.yang_parent_name = "controllers"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("local-link-id", ("local_link_id", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId)), ("odu-link-capabilities", ("odu_link_capabilities", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities)), ("link-extended-attribute", ("link_extended_attribute", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute)), ("link-forwad-ref-value", ("link_forwad_ref_value", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue)), ("srl-gs", ("srl_gs", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.SrlGs)), ("igp-areas", ("igp_areas", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas)), ("affinity-map", ("affinity_map", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('link_name', (YLeaf(YType.str, 'link-name'), ['str'])),
                                ('interface_handle', (YLeaf(YType.str, 'interface-handle'), ['str'])),
                                ('link_state', (YLeaf(YType.enumeration, 'link-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                                ('physical_bandwidth', (YLeaf(YType.enumeration, 'physical-bandwidth'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Otu', '')])),
                                ('tti_mode', (YLeaf(YType.enumeration, 'tti-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TtiMode', '')])),
                                ('tandem_connection_monitoring', (YLeaf(YType.uint8, 'tandem-connection-monitoring'), ['int'])),
                                ('igp_neighbors_count', (YLeaf(YType.uint16, 'igp-neighbors-count'), ['int'])),
                                ('link_attributes', (YLeaf(YType.uint32, 'link-attributes'), ['int'])),
                                ('is_attribute_incomplete', (YLeaf(YType.boolean, 'is-attribute-incomplete'), ['bool'])),
                                ('is_name_based_attribute', (YLeaf(YType.boolean, 'is-name-based-attribute'), ['bool'])),
                            ])
                            self.controller_name = None
                            self.link_name = None
                            self.interface_handle = None
                            self.link_state = None
                            self.resource_provider = None
                            self.physical_bandwidth = None
                            self.tti_mode = None
                            self.tandem_connection_monitoring = None
                            self.igp_neighbors_count = None
                            self.link_attributes = None
                            self.is_attribute_incomplete = None
                            self.is_name_based_attribute = None

                            self.local_link_id = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId()
                            self.local_link_id.parent = self
                            self._children_name_map["local_link_id"] = "local-link-id"

                            self.odu_link_capabilities = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                            self.link_extended_attribute = YList(self)
                            self.link_forwad_ref_value = YList(self)
                            self.srl_gs = YList(self)
                            self.igp_areas = YList(self)
                            self.affinity_map = YList(self)
                            self._segment_path = lambda: "controller" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/controllers/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller, ['controller_name', 'link_name', 'interface_handle', 'link_state', 'resource_provider', 'physical_bandwidth', 'tti_mode', 'tandem_connection_monitoring', 'igp_neighbors_count', 'link_attributes', 'is_attribute_incomplete', 'is_name_based_attribute'], name, value)


                        class LocalLinkId(_Entity_):
                            """
                            Local TE link ID
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId, self).__init__()

                                self.yang_name = "local-link-id"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "local-link-id"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "local-link-id"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LocalLinkId']['meta_info']


                        class OduLinkCapabilities(_Entity_):
                            """
                            ODU capabilities of Link
                            
                            .. attribute:: max_lsp_bandwidth
                            
                            	Max LSP Bandwidth per priority in kbit/s
                            	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_capability
                            
                            	ODU Capabilities of Link
                            	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities, self).__init__()

                                self.yang_name = "odu-link-capabilities"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability))])
                                self._leafs = OrderedDict()

                                self.max_lsp_bandwidth = YList(self)
                                self.odu_capability = YList(self)
                                self._segment_path = lambda: "odu-link-capabilities"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities, [], name, value)


                            class MaxLspBandwidth(_Entity_):
                                """
                                Max LSP Bandwidth per priority in kbit/s
                                
                                .. attribute:: entry
                                
                                	Max LSP Bandwidth per priority in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                                    self.yang_name = "max-lsp-bandwidth"
                                    self.yang_parent_name = "odu-link-capabilities"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "max-lsp-bandwidth"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                            class OduCapability(_Entity_):
                                """
                                ODU Capabilities of Link
                                
                                .. attribute:: bandwidth_info
                                
                                	Bandwidth related info for this ODU level
                                	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                                
                                	**config**\: False
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage1
                                
                                	ODU Type at stage 1, Not Set for HO ODU
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage2
                                
                                	ODU Type at stage 2, Not Set for single stage mulitplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage3
                                
                                	ODU Type at stage 3, Not set up to two levels of multiplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: stage4
                                
                                	ODU Type at stage 4, Not set up to three levels of multiplexing
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                .. attribute:: terminable
                                
                                	True if link is terminable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: switchable
                                
                                	True if link is switchable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: tsg1p25
                                
                                	True if link supports 1.25G TSG for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: tsg2p5
                                
                                	True if link supports 2.5G TSG for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: vcat_capable
                                
                                	True if link VCAT capable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lcas_capable
                                
                                	True if link LCAS capable for this ODU level
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability, self).__init__()

                                    self.yang_name = "odu-capability"
                                    self.yang_parent_name = "odu-link-capabilities"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                        ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                        ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                        ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                        ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                        ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                                    ])
                                    self.signal_type = None
                                    self.stage1 = None
                                    self.stage2 = None
                                    self.stage3 = None
                                    self.stage4 = None
                                    self.terminable = None
                                    self.switchable = None
                                    self.tsg1p25 = None
                                    self.tsg2p5 = None
                                    self.vcat_capable = None
                                    self.lcas_capable = None

                                    self.bandwidth_info = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                    self._segment_path = lambda: "odu-capability"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                                class BandwidthInfo(_Entity_):
                                    """
                                    Bandwidth related info for this ODU level
                                    
                                    .. attribute:: fixed
                                    
                                    	ODU capability for Fixed ODUs
                                    	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: flex
                                    
                                    	ODU capability for Flex ODUs
                                    	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                        self.yang_name = "bandwidth-info"
                                        self.yang_parent_name = "odu-capability"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fixed", ("fixed", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                        ])
                                        self.type = None

                                        self.fixed = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"

                                        self.flex = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                        self._segment_path = lambda: "bandwidth-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                                    class Fixed(_Entity_):
                                        """
                                        ODU capability for Fixed ODUs
                                        
                                        .. attribute:: maximum_od_us
                                        
                                        	Maximum Number of ODUs of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: unreserved_od_us
                                        
                                        	Maximum Number of ODUs of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                            self.yang_name = "fixed"
                                            self.yang_parent_name = "bandwidth-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                                ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                            ])
                                            self.maximum_od_us = None
                                            self.unreserved_od_us = None
                                            self._segment_path = lambda: "fixed"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                                    class Flex(_Entity_):
                                        """
                                        ODU capability for Flex ODUs
                                        
                                        .. attribute:: max_bandwidth
                                        
                                        	Max kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: unreserved_bandwidth
                                        
                                        	Unreserved kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: max_lsp_bandwidth
                                        
                                        	Per LSP Max kbps Bandwidth of this level possible on this link
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                            self.yang_name = "flex"
                                            self.yang_parent_name = "bandwidth-info"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                                ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                                ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                            ])
                                            self.max_bandwidth = None
                                            self.unreserved_bandwidth = None
                                            self.max_lsp_bandwidth = None
                                            self._segment_path = lambda: "flex"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities.OduCapability']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.OduLinkCapabilities']['meta_info']


                        class LinkExtendedAttribute(_Entity_):
                            """
                            The link's extended attribute bit map
                            
                            .. attribute:: entry
                            
                            	The link's extended attribute bit map
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute, self).__init__()

                                self.yang_name = "link-extended-attribute"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "link-extended-attribute"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkExtendedAttribute']['meta_info']


                        class LinkForwadRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue, self).__init__()

                                self.yang_name = "link-forwad-ref-value"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "link-forwad-ref-value"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.LinkForwadRefValue']['meta_info']


                        class SrlGs(_Entity_):
                            """
                            The link's shared risk link groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.SrlGs, self).__init__()

                                self.yang_name = "srl-gs"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "srl-gs"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.SrlGs, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.SrlGs']['meta_info']


                        class IgpAreas(_Entity_):
                            """
                            Per\-IGP area data
                            
                            .. attribute:: remote_te_link_id
                            
                            	Remote link id in this topology instance
                            	**type**\:  :py:class:`RemoteTeLinkId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_type
                            
                            	IGP type
                            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_instance_id
                            
                            	Igp instance ID
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_id_format
                            
                            	Igp area id format
                            	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_id
                            
                            	Igp area id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: te_metric
                            
                            	The link's TE metric
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_configured
                            
                            	Unidirectional Link Delay configured in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_computed
                            
                            	Unidirectional Link Delay computed in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: uni_link_delay_to_flood
                            
                            	Unidirectional Link Delay to flood in micro\-sec
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reason_not_flooded
                            
                            	Reason why link is not flooded
                            	**type**\:  :py:class:`MplsTeReasonNotFlooded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReasonNotFlooded>`
                            
                            	**config**\: False
                            
                            .. attribute:: igp_area_address
                            
                            	IGP's area IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas, self).__init__()

                                self.yang_name = "igp-areas"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("remote-te-link-id", ("remote_te_link_id", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId))])
                                self._leafs = OrderedDict([
                                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                                    ('igp_instance_id', (YLeaf(YType.str, 'igp-instance-id'), ['str'])),
                                    ('igp_area_id_format', (YLeaf(YType.enumeration, 'igp-area-id-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                                    ('igp_area_id', (YLeaf(YType.uint32, 'igp-area-id'), ['int'])),
                                    ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                                    ('uni_link_delay_configured', (YLeaf(YType.uint32, 'uni-link-delay-configured'), ['int'])),
                                    ('uni_link_delay_computed', (YLeaf(YType.uint32, 'uni-link-delay-computed'), ['int'])),
                                    ('uni_link_delay_to_flood', (YLeaf(YType.uint32, 'uni-link-delay-to-flood'), ['int'])),
                                    ('reason_not_flooded', (YLeaf(YType.enumeration, 'reason-not-flooded'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReasonNotFlooded', '')])),
                                    ('igp_area_address', (YLeaf(YType.str, 'igp-area-address'), ['str'])),
                                ])
                                self.igp_type = None
                                self.igp_instance_id = None
                                self.igp_area_id_format = None
                                self.igp_area_id = None
                                self.te_metric = None
                                self.uni_link_delay_configured = None
                                self.uni_link_delay_computed = None
                                self.uni_link_delay_to_flood = None
                                self.reason_not_flooded = None
                                self.igp_area_address = None

                                self.remote_te_link_id = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId()
                                self.remote_te_link_id.parent = self
                                self._children_name_map["remote_te_link_id"] = "remote-te-link-id"
                                self._segment_path = lambda: "igp-areas"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas, ['igp_type', 'igp_instance_id', 'igp_area_id_format', 'igp_area_id', 'te_metric', 'uni_link_delay_configured', 'uni_link_delay_computed', 'uni_link_delay_to_flood', 'reason_not_flooded', 'igp_area_address'], name, value)


                            class RemoteTeLinkId(_Entity_):
                                """
                                Remote link id in this topology instance
                                
                                .. attribute:: te_addr
                                
                                	TE Address
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId, self).__init__()

                                    self.yang_name = "remote-te-link-id"
                                    self.yang_parent_name = "igp-areas"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr))])
                                    self._leafs = OrderedDict()

                                    self.te_addr = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr()
                                    self.te_addr.parent = self
                                    self._children_name_map["te_addr"] = "te-addr"
                                    self._segment_path = lambda: "remote-te-link-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId, [], name, value)


                                class TeAddr(_Entity_):
                                    """
                                    TE Address
                                    
                                    .. attribute:: ipv4_unnumbered_address
                                    
                                    	IPv4 unnumbered address
                                    	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv4_address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr, self).__init__()

                                        self.yang_name = "te-addr"
                                        self.yang_parent_name = "remote-te-link-id"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                        ])
                                        self.type = None
                                        self.ipv4_address = None

                                        self.ipv4_unnumbered_address = MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress()
                                        self.ipv4_unnumbered_address.parent = self
                                        self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        self._segment_path = lambda: "te-addr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr, ['type', 'ipv4_address'], name, value)


                                    class Ipv4UnnumberedAddress(_Entity_):
                                        """
                                        IPv4 unnumbered address
                                        
                                        .. attribute:: router_id
                                        
                                        	IPv4 router ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_index
                                        
                                        	Interface index
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                            self.yang_name = "ipv4-unnumbered-address"
                                            self.yang_parent_name = "te-addr"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                                ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                            ])
                                            self.router_id = None
                                            self.interface_index = None
                                            self._segment_path = lambda: "ipv4-unnumbered-address"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId.TeAddr']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas.RemoteTeLinkId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.IgpAreas']['meta_info']


                        class AffinityMap(_Entity_):
                            """
                            Affinity map array
                            
                            .. attribute:: affinity_name
                            
                            	Affinity name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_value
                            
                            	Affinity value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_bit_position
                            
                            	Affinity bit position
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_table_id
                            
                            	Affinity table id
                            	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity_extended_value
                            
                            	EAG value
                            	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap, self).__init__()

                                self.yang_name = "affinity-map"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue))])
                                self._leafs = OrderedDict([
                                    ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                                    ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                                    ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                                    ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                                ])
                                self.affinity_name = None
                                self.affinity_value = None
                                self.affinity_bit_position = None
                                self.affinity_table_id = None

                                self.affinity_extended_value = YList(self)
                                self._segment_path = lambda: "affinity-map"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


                            class AffinityExtendedValue(_Entity_):
                                """
                                EAG value
                                
                                .. attribute:: entry
                                
                                	EAG value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue, self).__init__()

                                    self.yang_name = "affinity-extended-value"
                                    self.yang_parent_name = "affinity-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "affinity-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap.AffinityExtendedValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller.AffinityMap']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers.Controller']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.Controllers']['meta_info']


                class AdmissionControls(_Entity_):
                    """
                    GMPLS OTN\-NNI admission control table
                    
                    .. attribute:: admission_control
                    
                    	GMPLS OTN\-NNI admitted tunnels for a given controller
                    	**type**\: list of  		 :py:class:`AdmissionControl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Gmpls.Nni.Otn.AdmissionControls, self).__init__()

                        self.yang_name = "admission-controls"
                        self.yang_parent_name = "otn"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("admission-control", ("admission_control", MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl))])
                        self._leafs = OrderedDict()

                        self.admission_control = YList(self)
                        self._segment_path = lambda: "admission-controls"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.AdmissionControls, [], name, value)


                    class AdmissionControl(_Entity_):
                        """
                        GMPLS OTN\-NNI admitted tunnels for a given
                        controller
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link_name
                        
                        	The link's name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: admitted_s2l
                        
                        	Admitted S2Ls
                        	**type**\: list of  		 :py:class:`AdmittedS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl, self).__init__()

                            self.yang_name = "admission-control"
                            self.yang_parent_name = "admission-controls"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("admitted-s2l", ("admitted_s2l", MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('link_name', (YLeaf(YType.str, 'link-name'), ['str'])),
                            ])
                            self.controller_name = None
                            self.link_name = None

                            self.admitted_s2l = YList(self)
                            self._segment_path = lambda: "admission-control" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/nni/otn/admission-controls/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl, ['controller_name', 'link_name'], name, value)


                        class AdmittedS2l(_Entity_):
                            """
                            Admitted S2Ls
                            
                            .. attribute:: s2l_fec
                            
                            	S2L FEC
                            	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l, self).__init__()

                                self.yang_name = "admitted-s2l"
                                self.yang_parent_name = "admission-control"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec))])
                                self._leafs = OrderedDict()

                                self.s2l_fec = MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec()
                                self.s2l_fec.parent = self
                                self._children_name_map["s2l_fec"] = "s2l-fec"
                                self._segment_path = lambda: "admitted-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l, [], name, value)


                            class S2lFec(_Entity_):
                                """
                                S2L FEC
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec, self).__init__()

                                    self.yang_name = "s2l-fec"
                                    self.yang_parent_name = "admitted-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "s2l-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l.S2lFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl.AdmittedS2l']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.AdmissionControls.AdmissionControl']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Gmpls.Nni.Otn.AdmissionControls']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Gmpls.Nni.Otn']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Gmpls.Nni']['meta_info']


        class Uni(_Entity_):
            """
            GMPLS UNI data
            
            .. attribute:: wdm
            
            	GMPLS WDM\-UNI data
            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.Gmpls.Uni, self).__init__()

                self.yang_name = "uni"
                self.yang_parent_name = "gmpls"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcac.Gmpls.Uni.Wdm))])
                self._leafs = OrderedDict()

                self.wdm = MplsLcac.Gmpls.Uni.Wdm()
                self.wdm.parent = self
                self._children_name_map["wdm"] = "wdm"
                self._segment_path = lambda: "uni"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.Gmpls.Uni, [], name, value)


            class Wdm(_Entity_):
                """
                GMPLS WDM\-UNI data
                
                .. attribute:: controllers
                
                	GMPLS WDM\-UNI controllers
                	**type**\:  :py:class:`Controllers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.Gmpls.Uni.Wdm, self).__init__()

                    self.yang_name = "wdm"
                    self.yang_parent_name = "uni"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("controllers", ("controllers", MplsLcac.Gmpls.Uni.Wdm.Controllers))])
                    self._leafs = OrderedDict()

                    self.controllers = MplsLcac.Gmpls.Uni.Wdm.Controllers()
                    self.controllers.parent = self
                    self._children_name_map["controllers"] = "controllers"
                    self._segment_path = lambda: "wdm"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/uni/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm, [], name, value)


                class Controllers(_Entity_):
                    """
                    GMPLS WDM\-UNI controllers
                    
                    .. attribute:: controller
                    
                    	A TE GMPLS\-UNI WDM controller
                    	**type**\: list of  		 :py:class:`Controller <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers, self).__init__()

                        self.yang_name = "controllers"
                        self.yang_parent_name = "wdm"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("controller", ("controller", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller))])
                        self._leafs = OrderedDict()

                        self.controller = YList(self)
                        self._segment_path = lambda: "controllers"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/uni/wdm/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers, [], name, value)


                    class Controller(_Entity_):
                        """
                        A TE GMPLS\-UNI WDM controller
                        
                        .. attribute:: controller_name  (key)
                        
                        	Controller name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: link
                        
                        	Link properties
                        	**type**\:  :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link>`
                        
                        	**config**\: False
                        
                        .. attribute:: labels
                        
                        	Labels
                        	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel
                        
                        	Tunnel info
                        	**type**\:  :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel>`
                        
                        	**config**\: False
                        
                        .. attribute:: controller_name_xr
                        
                        	Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: controller_name_brief
                        
                        	Brief Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: child_interface_name
                        
                        	Child interface name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: child_interface_state
                        
                        	Child Interface State
                        	**type**\:  :py:class:`ImStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ImStateEnum>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller, self).__init__()

                            self.yang_name = "controller"
                            self.yang_parent_name = "controllers"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['controller_name']
                            self._child_classes = OrderedDict([("link", ("link", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link)), ("labels", ("labels", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels)), ("tunnel", ("tunnel", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel))])
                            self._leafs = OrderedDict([
                                ('controller_name', (YLeaf(YType.str, 'controller-name'), ['str'])),
                                ('controller_name_xr', (YLeaf(YType.str, 'controller-name-xr'), ['str'])),
                                ('controller_name_brief', (YLeaf(YType.str, 'controller-name-brief'), ['str'])),
                                ('child_interface_name', (YLeaf(YType.str, 'child-interface-name'), ['str'])),
                                ('child_interface_state', (YLeaf(YType.enumeration, 'child-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ImStateEnum', '')])),
                            ])
                            self.controller_name = None
                            self.controller_name_xr = None
                            self.controller_name_brief = None
                            self.child_interface_name = None
                            self.child_interface_state = None

                            self.link = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link()
                            self.link.parent = self
                            self._children_name_map["link"] = "link"

                            self.labels = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels()
                            self.labels.parent = self
                            self._children_name_map["labels"] = "labels"

                            self.tunnel = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel()
                            self.tunnel.parent = self
                            self._children_name_map["tunnel"] = "tunnel"
                            self._segment_path = lambda: "controller" + "[controller-name='" + str(self.controller_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/gmpls/uni/wdm/controllers/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller, ['controller_name', 'controller_name_xr', 'controller_name_brief', 'child_interface_name', 'child_interface_state'], name, value)


                        class Link(_Entity_):
                            """
                            Link properties
                            
                            .. attribute:: wdm_capabilities
                            
                            	WDM capabilities
                            	**type**\:  :py:class:`WdmCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities>`
                            
                            	**config**\: False
                            
                            .. attribute:: link_exists
                            
                            	Flag to indicate whether the link exists in the system
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: admin_state_up
                            
                            	Is the interface administratively UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oper_state_up
                            
                            	Is the interface operationally UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bw_locked_upstream
                            
                            	Is the interface bandwidth locked in the upstream direction
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bw_locked_downstream
                            
                            	Is the interface bandwidth locked in the downstream direction
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: admitted_lsp_id
                            
                            	LSP\-ID admitted on this optical link. Not valid if neither the upstream nor downstream bandwidth is locked
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_router_id
                            
                            	LMP GMPLS Optical\-UNI router\-id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_adj_state_up
                            
                            	Is the LMP optical adjacency UP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lmpipcc_state_up
                            
                            	If the LMP IP control channel up ?
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_name
                            
                            	LMP neighbor Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_router_id
                            
                            	LMP neighbor router ID addres
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_ipcc_address
                            
                            	The LMP neighbor's IPCC address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_ipcc_address
                            
                            	The LMP local IPCC address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_interface_id
                            
                            	The LMP local interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_interface_id
                            
                            	The LMP neighbor interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_link_id
                            
                            	The LMP local Link ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_link_id
                            
                            	The LMP neighbor Link ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_switching_capability
                            
                            	The LMP local link switching capability
                            	**type**\:  :py:class:`IgpteLinkSwitchCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkSwitchCapability>`
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_neighbor_switching_capability
                            
                            	The LMP neighbor link switching capability
                            	**type**\:  :py:class:`IgpteLinkSwitchCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkSwitchCapability>`
                            
                            	**config**\: False
                            
                            .. attribute:: lmp_local_encoding
                            
                            	The LMP local link encoding type
                            	**type**\:  :py:class:`IgpteLinkEncodingProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLinkEncodingProtocol>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_link_gpid
                            
                            	The GPID of the local link
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: srl_gs_announced
                            
                            	TRUE if discovered SRLGs are announced to L3 interface
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_announced_interface
                            
                            	The L3 interface that discovered SRLGs are announced to
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_srlg
                            
                            	Locally\-configured SRLGs on this link
                            	**type**\: list of  		 :py:class:`LocalSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link, self).__init__()

                                self.yang_name = "link"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm-capabilities", ("wdm_capabilities", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities)), ("local-srlg", ("local_srlg", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg))])
                                self._leafs = OrderedDict([
                                    ('link_exists', (YLeaf(YType.boolean, 'link-exists'), ['bool'])),
                                    ('admin_state_up', (YLeaf(YType.boolean, 'admin-state-up'), ['bool'])),
                                    ('oper_state_up', (YLeaf(YType.boolean, 'oper-state-up'), ['bool'])),
                                    ('bw_locked_upstream', (YLeaf(YType.boolean, 'bw-locked-upstream'), ['bool'])),
                                    ('bw_locked_downstream', (YLeaf(YType.boolean, 'bw-locked-downstream'), ['bool'])),
                                    ('admitted_lsp_id', (YLeaf(YType.uint16, 'admitted-lsp-id'), ['int'])),
                                    ('lmp_router_id', (YLeaf(YType.str, 'lmp-router-id'), ['str'])),
                                    ('lmp_adj_state_up', (YLeaf(YType.boolean, 'lmp-adj-state-up'), ['bool'])),
                                    ('lmpipcc_state_up', (YLeaf(YType.boolean, 'lmpipcc-state-up'), ['bool'])),
                                    ('lmp_neighbor_name', (YLeaf(YType.str, 'lmp-neighbor-name'), ['str'])),
                                    ('lmp_neighbor_router_id', (YLeaf(YType.str, 'lmp-neighbor-router-id'), ['str'])),
                                    ('lmp_neighbor_ipcc_address', (YLeaf(YType.str, 'lmp-neighbor-ipcc-address'), ['str'])),
                                    ('lmp_local_ipcc_address', (YLeaf(YType.str, 'lmp-local-ipcc-address'), ['str'])),
                                    ('lmp_local_interface_id', (YLeaf(YType.uint32, 'lmp-local-interface-id'), ['int'])),
                                    ('lmp_neighbor_interface_id', (YLeaf(YType.uint32, 'lmp-neighbor-interface-id'), ['int'])),
                                    ('lmp_local_link_id', (YLeaf(YType.str, 'lmp-local-link-id'), ['str'])),
                                    ('lmp_neighbor_link_id', (YLeaf(YType.str, 'lmp-neighbor-link-id'), ['str'])),
                                    ('lmp_local_switching_capability', (YLeaf(YType.enumeration, 'lmp-local-switching-capability'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkSwitchCapability', '')])),
                                    ('lmp_neighbor_switching_capability', (YLeaf(YType.enumeration, 'lmp-neighbor-switching-capability'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkSwitchCapability', '')])),
                                    ('lmp_local_encoding', (YLeaf(YType.enumeration, 'lmp-local-encoding'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLinkEncodingProtocol', '')])),
                                    ('local_link_gpid', (YLeaf(YType.uint16, 'local-link-gpid'), ['int'])),
                                    ('srl_gs_announced', (YLeaf(YType.boolean, 'srl-gs-announced'), ['bool'])),
                                    ('srlg_announced_interface', (YLeaf(YType.str, 'srlg-announced-interface'), ['str'])),
                                ])
                                self.link_exists = None
                                self.admin_state_up = None
                                self.oper_state_up = None
                                self.bw_locked_upstream = None
                                self.bw_locked_downstream = None
                                self.admitted_lsp_id = None
                                self.lmp_router_id = None
                                self.lmp_adj_state_up = None
                                self.lmpipcc_state_up = None
                                self.lmp_neighbor_name = None
                                self.lmp_neighbor_router_id = None
                                self.lmp_neighbor_ipcc_address = None
                                self.lmp_local_ipcc_address = None
                                self.lmp_local_interface_id = None
                                self.lmp_neighbor_interface_id = None
                                self.lmp_local_link_id = None
                                self.lmp_neighbor_link_id = None
                                self.lmp_local_switching_capability = None
                                self.lmp_neighbor_switching_capability = None
                                self.lmp_local_encoding = None
                                self.local_link_gpid = None
                                self.srl_gs_announced = None
                                self.srlg_announced_interface = None

                                self.wdm_capabilities = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities()
                                self.wdm_capabilities.parent = self
                                self._children_name_map["wdm_capabilities"] = "wdm-capabilities"

                                self.local_srlg = YList(self)
                                self._segment_path = lambda: "link"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link, ['link_exists', 'admin_state_up', 'oper_state_up', 'bw_locked_upstream', 'bw_locked_downstream', 'admitted_lsp_id', 'lmp_router_id', 'lmp_adj_state_up', 'lmpipcc_state_up', 'lmp_neighbor_name', 'lmp_neighbor_router_id', 'lmp_neighbor_ipcc_address', 'lmp_local_ipcc_address', 'lmp_local_interface_id', 'lmp_neighbor_interface_id', 'lmp_local_link_id', 'lmp_neighbor_link_id', 'lmp_local_switching_capability', 'lmp_neighbor_switching_capability', 'lmp_local_encoding', 'local_link_gpid', 'srl_gs_announced', 'srlg_announced_interface'], name, value)


                            class WdmCapabilities(_Entity_):
                                """
                                WDM capabilities
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: default_channel
                                
                                	Default channel number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                .. attribute:: usable_channel
                                
                                	List of usable channels
                                	**type**\: list of  		 :py:class:`UsableChannel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities, self).__init__()

                                    self.yang_name = "wdm-capabilities"
                                    self.yang_parent_name = "link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("usable-channel", ("usable_channel", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel))])
                                    self._leafs = OrderedDict([
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('default_channel', (YLeaf(YType.int16, 'default-channel'), ['int'])),
                                    ])
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.default_channel = None

                                    self.usable_channel = YList(self)
                                    self._segment_path = lambda: "wdm-capabilities"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities, ['grid', 'channel_spacing', 'default_channel'], name, value)


                                class UsableChannel(_Entity_):
                                    """
                                    List of usable channels
                                    
                                    .. attribute:: entry
                                    
                                    	List of usable channels
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel, self).__init__()

                                        self.yang_name = "usable-channel"
                                        self.yang_parent_name = "wdm-capabilities"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.int16, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "usable-channel"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities.UsableChannel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.WdmCapabilities']['meta_info']


                            class LocalSrlg(_Entity_):
                                """
                                Locally\-configured SRLGs on this link
                                
                                .. attribute:: entry
                                
                                	Locally\-configured SRLGs on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg, self).__init__()

                                    self.yang_name = "local-srlg"
                                    self.yang_parent_name = "link"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "local-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link.LocalSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Link']['meta_info']


                        class Labels(_Entity_):
                            """
                            Labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels, self).__init__()

                                self.yang_name = "labels"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_)), ("otn", ("otn", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_)), ("otn", ("otn", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_)), ("otn", ("otn", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_)), ("otn", ("otn", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm_(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Wdm_']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Labels']['meta_info']


                        class Tunnel(_Entity_):
                            """
                            Tunnel info
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_role
                            
                            	Tunnel Role
                            	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: local_optical_router_id
                            
                            	Local optical router id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_optical_router_id
                            
                            	Remote optical router id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: controlled_interface
                            
                            	Interface being controlled
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: source_address
                            
                            	Source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended tunnel\-id
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: label_origin
                            
                            	Label origin
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_discovery
                            
                            	SRLG\-discovery enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "controller"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                    ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                    ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                                    ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                                    ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                                    ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                                ])
                                self.tunnel_state = None
                                self.tunnel_role = None
                                self.tunnel_id = None
                                self.lsp_id = None
                                self.local_optical_router_id = None
                                self.remote_optical_router_id = None
                                self.controlled_interface = None
                                self.source_address = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.label_origin = None
                                self.srlg_discovery = None
                                self._segment_path = lambda: "tunnel"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller.Tunnel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers.Controller']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm.Controllers']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.Gmpls.Uni.Wdm']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.Gmpls.Uni']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.Gmpls']['meta_info']


    class BfdNeighbors(_Entity_):
        """
        BFD Neighbors
        
        .. attribute:: bfd_neighbor
        
        	A BFD Neighbor
        	**type**\: list of  		 :py:class:`BfdNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors.BfdNeighbor>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.BfdNeighbors, self).__init__()

            self.yang_name = "bfd-neighbors"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bfd-neighbor", ("bfd_neighbor", MplsLcac.BfdNeighbors.BfdNeighbor))])
            self._leafs = OrderedDict()

            self.bfd_neighbor = YList(self)
            self._segment_path = lambda: "bfd-neighbors"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.BfdNeighbors, [], name, value)


        class BfdNeighbor(_Entity_):
            """
            A BFD Neighbor
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: neighbor
            
            	Neighbors of the specified link id
            	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.BfdNeighbors.BfdNeighbor, self).__init__()

                self.yang_name = "bfd-neighbor"
                self.yang_parent_name = "bfd-neighbors"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                ])
                self.interface_name = None

                self.neighbor = YList(self)
                self._segment_path = lambda: "bfd-neighbor" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bfd-neighbors/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.BfdNeighbors.BfdNeighbor, ['interface_name'], name, value)


            class Neighbor(_Entity_):
                """
                Neighbors of the specified link id
                
                .. attribute:: neighbor_address
                
                	The neighbor's IP address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_bfd_up
                
                	TRUE if the BFD session is Up on this link
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor, self).__init__()

                    self.yang_name = "neighbor"
                    self.yang_parent_name = "bfd-neighbor"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                        ('is_bfd_up', (YLeaf(YType.boolean, 'is-bfd-up'), ['bool'])),
                    ])
                    self.neighbor_address = None
                    self.is_bfd_up = None
                    self._segment_path = lambda: "neighbor"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor, ['neighbor_address', 'is_bfd_up'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.BfdNeighbors.BfdNeighbor.Neighbor']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.BfdNeighbors.BfdNeighbor']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.BfdNeighbors']['meta_info']


    class BandwidthAccount(_Entity_):
        """
        The bandwidth accounting information in
        MPLS\-LCAC
        
        .. attribute:: bandwidth_account_links
        
        	The interface bandwidth accounting information table
        	**type**\:  :py:class:`BandwidthAccountLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.BandwidthAccount, self).__init__()

            self.yang_name = "bandwidth-account"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bandwidth-account-links", ("bandwidth_account_links", MplsLcac.BandwidthAccount.BandwidthAccountLinks))])
            self._leafs = OrderedDict()

            self.bandwidth_account_links = MplsLcac.BandwidthAccount.BandwidthAccountLinks()
            self.bandwidth_account_links.parent = self
            self._children_name_map["bandwidth_account_links"] = "bandwidth-account-links"
            self._segment_path = lambda: "bandwidth-account"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.BandwidthAccount, [], name, value)


        class BandwidthAccountLinks(_Entity_):
            """
            The interface bandwidth accounting information
            table
            
            .. attribute:: bandwidth_account_link
            
            	An interface in bandwidth accounting table
            	**type**\: list of  		 :py:class:`BandwidthAccountLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.BandwidthAccount.BandwidthAccountLinks, self).__init__()

                self.yang_name = "bandwidth-account-links"
                self.yang_parent_name = "bandwidth-account"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bandwidth-account-link", ("bandwidth_account_link", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink))])
                self._leafs = OrderedDict()

                self.bandwidth_account_link = YList(self)
                self._segment_path = lambda: "bandwidth-account-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-account/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks, [], name, value)


            class BandwidthAccountLink(_Entity_):
                """
                An interface in bandwidth accounting table
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: common_info
                
                	Information for bandwidth accounting telemetry
                	**type**\:  :py:class:`CommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo>`
                
                	**config**\: False
                
                .. attribute:: rsvp_te_sample_history
                
                	History of bandwidth accounting RSVP\-TE samples
                	**type**\:  :py:class:`RsvpTeSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory>`
                
                	**config**\: False
                
                .. attribute:: sr_sample_history
                
                	History of bandwidth accounting Segment Routing samples
                	**type**\:  :py:class:`SrSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory>`
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	The link's ID
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, self).__init__()

                    self.yang_name = "bandwidth-account-link"
                    self.yang_parent_name = "bandwidth-account-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("common-info", ("common_info", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo)), ("rsvp-te-sample-history", ("rsvp_te_sample_history", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory)), ("sr-sample-history", ("sr_sample_history", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                    ])
                    self.interface_name = None
                    self.link_id = None

                    self.common_info = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo()
                    self.common_info.parent = self
                    self._children_name_map["common_info"] = "common-info"

                    self.rsvp_te_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory()
                    self.rsvp_te_sample_history.parent = self
                    self._children_name_map["rsvp_te_sample_history"] = "rsvp-te-sample-history"

                    self.sr_sample_history = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory()
                    self.sr_sample_history.parent = self
                    self._children_name_map["sr_sample_history"] = "sr-sample-history"
                    self._segment_path = lambda: "bandwidth-account-link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/bandwidth-account/bandwidth-account-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink, ['interface_name', 'link_id'], name, value)


                class CommonInfo(_Entity_):
                    """
                    Information for bandwidth accounting telemetry
                    
                    .. attribute:: rsvp_te_bandwidth_utilization
                    
                    	RSVP\-TE bandwidth utilization information
                    	**type**\:  :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_bandwidth_utilization
                    
                    	Segment Routing bandwidth utilization information
                    	**type**\:  :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_account_enabled
                    
                    	TRUE if bandwidth accounting is enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: application_enforced
                    
                    	TRUE if application is enforced
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: collection_type
                    
                    	The type of traffic collected for bandwidth accounting
                    	**type**\:  :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                    
                    	**config**\: False
                    
                    .. attribute:: sample_time_remaining_timestamp_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next sampling
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_sample_collection_timestamp_nanosec
                    
                    	Timestamp for the last sample collection in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_sample_collection_nanosec
                    
                    	Timestamp for the next sample collection in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: application_time_remaining_nanosec
                    
                    	This value indicates the number of nano\-seconds until the next application
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: last_application_timestamp_nanosec
                    
                    	Timestamp for the last application in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: next_application_timestamp_nanosec
                    
                    	Timestamp for the next application in nano\-seconds
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: effective_maximum_reservable_bandwidth
                    
                    	Maximum reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, self).__init__()

                        self.yang_name = "common-info"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("rsvp-te-bandwidth-utilization", ("rsvp_te_bandwidth_utilization", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization)), ("sr-bandwidth-utilization", ("sr_bandwidth_utilization", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization))])
                        self._leafs = OrderedDict([
                            ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                            ('application_enforced', (YLeaf(YType.boolean, 'application-enforced'), ['bool'])),
                            ('collection_type', (YLeaf(YType.enumeration, 'collection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthAccountingCollection', '')])),
                            ('sample_time_remaining_timestamp_nanosec', (YLeaf(YType.uint64, 'sample-time-remaining-timestamp-nanosec'), ['int'])),
                            ('last_sample_collection_timestamp_nanosec', (YLeaf(YType.uint64, 'last-sample-collection-timestamp-nanosec'), ['int'])),
                            ('next_sample_collection_nanosec', (YLeaf(YType.uint64, 'next-sample-collection-nanosec'), ['int'])),
                            ('application_time_remaining_nanosec', (YLeaf(YType.uint64, 'application-time-remaining-nanosec'), ['int'])),
                            ('last_application_timestamp_nanosec', (YLeaf(YType.uint64, 'last-application-timestamp-nanosec'), ['int'])),
                            ('next_application_timestamp_nanosec', (YLeaf(YType.uint64, 'next-application-timestamp-nanosec'), ['int'])),
                            ('effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'effective-maximum-reservable-bandwidth'), ['int'])),
                        ])
                        self.is_bandwidth_account_enabled = None
                        self.application_enforced = None
                        self.collection_type = None
                        self.sample_time_remaining_timestamp_nanosec = None
                        self.last_sample_collection_timestamp_nanosec = None
                        self.next_sample_collection_nanosec = None
                        self.application_time_remaining_nanosec = None
                        self.last_application_timestamp_nanosec = None
                        self.next_application_timestamp_nanosec = None
                        self.effective_maximum_reservable_bandwidth = None

                        self.rsvp_te_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization()
                        self.rsvp_te_bandwidth_utilization.parent = self
                        self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"

                        self.sr_bandwidth_utilization = MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization()
                        self.sr_bandwidth_utilization.parent = self
                        self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                        self._segment_path = lambda: "common-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo, ['is_bandwidth_account_enabled', 'application_enforced', 'collection_type', 'sample_time_remaining_timestamp_nanosec', 'last_sample_collection_timestamp_nanosec', 'next_sample_collection_nanosec', 'application_time_remaining_nanosec', 'last_application_timestamp_nanosec', 'next_application_timestamp_nanosec', 'effective_maximum_reservable_bandwidth'], name, value)


                    class RsvpTeBandwidthUtilization(_Entity_):
                        """
                        RSVP\-TE bandwidth utilization information
                        
                        .. attribute:: total_link_bandwidth_utilization
                        
                        	Total bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_bandwidth_utilization
                        
                        	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                        
                        	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_enforced_bandwidth_utilization
                        
                        	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-utilization"
                            self.yang_parent_name = "common-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('total_link_bandwidth_utilization', (YLeaf(YType.uint64, 'total-link-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-bandwidth-utilization'), ['int'])),
                                ('non_rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'non-rsvp-te-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-adjusted-bandwidth-utilization'), ['int'])),
                                ('rsvp_te_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-enforced-bandwidth-utilization'), ['int'])),
                            ])
                            self.total_link_bandwidth_utilization = None
                            self.rsvp_te_bandwidth_utilization = None
                            self.non_rsvp_te_bandwidth_utilization = None
                            self.rsvp_te_adjusted_bandwidth_utilization = None
                            self.rsvp_te_enforced_bandwidth_utilization = None
                            self._segment_path = lambda: "rsvp-te-bandwidth-utilization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization, ['total_link_bandwidth_utilization', 'rsvp_te_bandwidth_utilization', 'non_rsvp_te_bandwidth_utilization', 'rsvp_te_adjusted_bandwidth_utilization', 'rsvp_te_enforced_bandwidth_utilization'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.RsvpTeBandwidthUtilization']['meta_info']


                    class SrBandwidthUtilization(_Entity_):
                        """
                        Segment Routing bandwidth utilization
                        information
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_adjusted_bandwidth_utilization
                        
                        	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_enforced_bandwidth_utilization
                        
                        	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, self).__init__()

                            self.yang_name = "sr-bandwidth-utilization"
                            self.yang_parent_name = "common-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sr_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-bandwidth-utilization'), ['int'])),
                                ('sr_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-adjusted-bandwidth-utilization'), ['int'])),
                                ('sr_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-enforced-bandwidth-utilization'), ['int'])),
                            ])
                            self.sr_bandwidth_utilization = None
                            self.sr_adjusted_bandwidth_utilization = None
                            self.sr_enforced_bandwidth_utilization = None
                            self._segment_path = lambda: "sr-bandwidth-utilization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization, ['sr_bandwidth_utilization', 'sr_adjusted_bandwidth_utilization', 'sr_enforced_bandwidth_utilization'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo.SrBandwidthUtilization']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.CommonInfo']['meta_info']


                class RsvpTeSampleHistory(_Entity_):
                    """
                    History of bandwidth accounting RSVP\-TE samples
                    
                    .. attribute:: rsvp_te_active_interval_sample
                    
                    	RSVP\-TE samples in the current application interval
                    	**type**\: list of  		 :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample>`
                    
                    	**config**\: False
                    
                    .. attribute:: rsvp_te_previous_interval_sample
                    
                    	RSVP\-TE samples in the previous application interval
                    	**type**\: list of  		 :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, self).__init__()

                        self.yang_name = "rsvp-te-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("rsvp-te-active-interval-sample", ("rsvp_te_active_interval_sample", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample)), ("rsvp-te-previous-interval-sample", ("rsvp_te_previous_interval_sample", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample))])
                        self._leafs = OrderedDict()

                        self.rsvp_te_active_interval_sample = YList(self)
                        self.rsvp_te_previous_interval_sample = YList(self)
                        self._segment_path = lambda: "rsvp-te-sample-history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory, [], name, value)


                    class RsvpTeActiveIntervalSample(_Entity_):
                        """
                        RSVP\-TE samples in the current application
                        interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-active-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                ('total_packet_rate', (YLeaf(YType.uint64, 'total-packet-rate'), ['int'])),
                                ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                ('rsvp_te_packet_rate', (YLeaf(YType.uint64, 'rsvp-te-packet-rate'), ['int'])),
                                ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ('non_rsvp_te_packet_rate', (YLeaf(YType.uint64, 'non-rsvp-te-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.total_rate = None
                            self.total_packet_rate = None
                            self.rsvp_te_rate = None
                            self.rsvp_te_packet_rate = None
                            self.non_rsvp_te_rate = None
                            self.non_rsvp_te_packet_rate = None
                            self._segment_path = lambda: "rsvp-te-active-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample, ['timestamp_nanosec', 'total_rate', 'total_packet_rate', 'rsvp_te_rate', 'rsvp_te_packet_rate', 'non_rsvp_te_rate', 'non_rsvp_te_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTeActiveIntervalSample']['meta_info']


                    class RsvpTePreviousIntervalSample(_Entity_):
                        """
                        RSVP\-TE samples in the previous application
                        interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: total_rate
                        
                        	Total traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: total_packet_rate
                        
                        	Total traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: rsvp_te_rate
                        
                        	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: rsvp_te_packet_rate
                        
                        	RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        .. attribute:: non_rsvp_te_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: non_rsvp_te_packet_rate
                        
                        	Non\-RSVP\-TE traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                            self.yang_name = "rsvp-te-previous-interval-sample"
                            self.yang_parent_name = "rsvp-te-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                ('total_packet_rate', (YLeaf(YType.uint64, 'total-packet-rate'), ['int'])),
                                ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                ('rsvp_te_packet_rate', (YLeaf(YType.uint64, 'rsvp-te-packet-rate'), ['int'])),
                                ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ('non_rsvp_te_packet_rate', (YLeaf(YType.uint64, 'non-rsvp-te-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.total_rate = None
                            self.total_packet_rate = None
                            self.rsvp_te_rate = None
                            self.rsvp_te_packet_rate = None
                            self.non_rsvp_te_rate = None
                            self.non_rsvp_te_packet_rate = None
                            self._segment_path = lambda: "rsvp-te-previous-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample, ['timestamp_nanosec', 'total_rate', 'total_packet_rate', 'rsvp_te_rate', 'rsvp_te_packet_rate', 'non_rsvp_te_rate', 'non_rsvp_te_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory.RsvpTePreviousIntervalSample']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.RsvpTeSampleHistory']['meta_info']


                class SrSampleHistory(_Entity_):
                    """
                    History of bandwidth accounting Segment Routing
                    samples
                    
                    .. attribute:: sr_active_interval_sample
                    
                    	Segment Routing samples in the current application interval
                    	**type**\: list of  		 :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_previous_interval_sample
                    
                    	Segment Routing samples in the previous application interval
                    	**type**\: list of  		 :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, self).__init__()

                        self.yang_name = "sr-sample-history"
                        self.yang_parent_name = "bandwidth-account-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("sr-active-interval-sample", ("sr_active_interval_sample", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample)), ("sr-previous-interval-sample", ("sr_previous_interval_sample", MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample))])
                        self._leafs = OrderedDict()

                        self.sr_active_interval_sample = YList(self)
                        self.sr_previous_interval_sample = YList(self)
                        self._segment_path = lambda: "sr-sample-history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory, [], name, value)


                    class SrActiveIntervalSample(_Entity_):
                        """
                        Segment Routing samples in the current
                        application interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, self).__init__()

                            self.yang_name = "sr-active-interval-sample"
                            self.yang_parent_name = "sr-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ('sr_packet_rate', (YLeaf(YType.uint64, 'sr-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.sr_rate = None
                            self.sr_packet_rate = None
                            self._segment_path = lambda: "sr-active-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample, ['timestamp_nanosec', 'sr_rate', 'sr_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrActiveIntervalSample']['meta_info']


                    class SrPreviousIntervalSample(_Entity_):
                        """
                        Segment Routing samples in the previous
                        application interval
                        
                        .. attribute:: timestamp_nanosec
                        
                        	Timestamp in nano\-seconds of this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: sr_rate
                        
                        	Segment Routing traffic rate measured in Kilobits per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: sr_packet_rate
                        
                        	Segment Routing traffic rate measured in packets per second in this sample
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: packet/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, self).__init__()

                            self.yang_name = "sr-previous-interval-sample"
                            self.yang_parent_name = "sr-sample-history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp_nanosec', (YLeaf(YType.uint64, 'timestamp-nanosec'), ['int'])),
                                ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ('sr_packet_rate', (YLeaf(YType.uint64, 'sr-packet-rate'), ['int'])),
                            ])
                            self.timestamp_nanosec = None
                            self.sr_rate = None
                            self.sr_packet_rate = None
                            self._segment_path = lambda: "sr-previous-interval-sample"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample, ['timestamp_nanosec', 'sr_rate', 'sr_packet_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory.SrPreviousIntervalSample']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink.SrSampleHistory']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks.BandwidthAccountLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.BandwidthAccount.BandwidthAccountLinks']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.BandwidthAccount']['meta_info']


    class LinkSummary(_Entity_):
        """
        The global summary for all the interfaces
        
        .. attribute:: bandwidth_account_summary
        
        	Bandwidth account summary
        	**type**\:  :py:class:`BandwidthAccountSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary.BandwidthAccountSummary>`
        
        	**config**\: False
        
        .. attribute:: is_role_standby
        
        	TRUE if Role is Standby, Active otherwise
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: links
        
        	Total number of links
        	**type**\: int
        
        	**range:** 0..65535
        
        	**config**\: False
        
        .. attribute:: maximum_links
        
        	Maximum number of links supported
        	**type**\: int
        
        	**range:** 0..65535
        
        	**config**\: False
        
        .. attribute:: is_flooding_enabled
        
        	TRUE if flooding is enabled
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: areas_summary
        
        	Summary info for the areas
        	**type**\: list of  		 :py:class:`AreasSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkSummary.AreasSummary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.LinkSummary, self).__init__()

            self.yang_name = "link-summary"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("bandwidth-account-summary", ("bandwidth_account_summary", MplsLcac.LinkSummary.BandwidthAccountSummary)), ("areas-summary", ("areas_summary", MplsLcac.LinkSummary.AreasSummary))])
            self._leafs = OrderedDict([
                ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                ('maximum_links', (YLeaf(YType.uint16, 'maximum-links'), ['int'])),
                ('is_flooding_enabled', (YLeaf(YType.boolean, 'is-flooding-enabled'), ['bool'])),
            ])
            self.is_role_standby = None
            self.links = None
            self.maximum_links = None
            self.is_flooding_enabled = None

            self.bandwidth_account_summary = MplsLcac.LinkSummary.BandwidthAccountSummary()
            self.bandwidth_account_summary.parent = self
            self._children_name_map["bandwidth_account_summary"] = "bandwidth-account-summary"

            self.areas_summary = YList(self)
            self._segment_path = lambda: "link-summary"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.LinkSummary, ['is_role_standby', 'links', 'maximum_links', 'is_flooding_enabled'], name, value)


        class BandwidthAccountSummary(_Entity_):
            """
            Bandwidth account summary
            
            .. attribute:: is_bandwidth_account_enabled
            
            	TRUE if bandwidth accounting is enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: sample_interval
            
            	Sample interval for bandwidth accounting stats
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: sample_time_remaining
            
            	This value indicates the number of seconds until the next sample collection
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: application_interval
            
            	Application interval for bandwidth accounting stats
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: application_time_remaining
            
            	This value indicates the number of seconds until the next application
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: links_count
            
            	Total number of links
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.LinkSummary.BandwidthAccountSummary, self).__init__()

                self.yang_name = "bandwidth-account-summary"
                self.yang_parent_name = "link-summary"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                    ('sample_interval', (YLeaf(YType.uint32, 'sample-interval'), ['int'])),
                    ('sample_time_remaining', (YLeaf(YType.uint32, 'sample-time-remaining'), ['int'])),
                    ('application_interval', (YLeaf(YType.uint32, 'application-interval'), ['int'])),
                    ('application_time_remaining', (YLeaf(YType.uint32, 'application-time-remaining'), ['int'])),
                    ('links_count', (YLeaf(YType.uint32, 'links-count'), ['int'])),
                    ('maximum_links', (YLeaf(YType.uint32, 'maximum-links'), ['int'])),
                ])
                self.is_bandwidth_account_enabled = None
                self.sample_interval = None
                self.sample_time_remaining = None
                self.application_interval = None
                self.application_time_remaining = None
                self.links_count = None
                self.maximum_links = None
                self._segment_path = lambda: "bandwidth-account-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-summary/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.LinkSummary.BandwidthAccountSummary, ['is_bandwidth_account_enabled', 'sample_interval', 'sample_time_remaining', 'application_interval', 'application_time_remaining', 'links_count', 'maximum_links'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.LinkSummary.BandwidthAccountSummary']['meta_info']


        class AreasSummary(_Entity_):
            """
            Summary info for the areas
            
            .. attribute:: area_id
            
            	Area id
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: protocol
            
            	Protocol running over the area
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: is_flooded
            
            	TRUE if flooding occurred in this area
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_periodic_flooding_on
            
            	TRUE if periodic flooding is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: periodic_flooding_interval
            
            	Flooding period in seconds
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: links_flooded
            
            	Number of flooded links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: system_id
            
            	IGP id of local node
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: local_node_router_id
            
            	Local router id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: igp_neighbors
            
            	Number of IGP neighbors
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.LinkSummary.AreasSummary, self).__init__()

                self.yang_name = "areas-summary"
                self.yang_parent_name = "link-summary"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('is_flooded', (YLeaf(YType.boolean, 'is-flooded'), ['bool'])),
                    ('is_periodic_flooding_on', (YLeaf(YType.boolean, 'is-periodic-flooding-on'), ['bool'])),
                    ('periodic_flooding_interval', (YLeaf(YType.uint16, 'periodic-flooding-interval'), ['int'])),
                    ('links_flooded', (YLeaf(YType.uint16, 'links-flooded'), ['int'])),
                    ('system_id', (YLeaf(YType.str, 'system-id'), ['str'])),
                    ('local_node_router_id', (YLeaf(YType.str, 'local-node-router-id'), ['str'])),
                    ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                ])
                self.area_id = None
                self.protocol = None
                self.is_flooded = None
                self.is_periodic_flooding_on = None
                self.periodic_flooding_interval = None
                self.links_flooded = None
                self.system_id = None
                self.local_node_router_id = None
                self.igp_neighbors = None
                self._segment_path = lambda: "areas-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-summary/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.LinkSummary.AreasSummary, ['area_id', 'protocol', 'is_flooded', 'is_periodic_flooding_on', 'periodic_flooding_interval', 'links_flooded', 'system_id', 'local_node_router_id', 'igp_neighbors'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.LinkSummary.AreasSummary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.LinkSummary']['meta_info']


    class LinkInformation(_Entity_):
        """
        The interface information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global information for all the interfaces
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Global>`
        
        	**config**\: False
        
        .. attribute:: links
        
        	The table of interfaces in MPLS\-LCAC
        	**type**\:  :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.LinkInformation, self).__init__()

            self.yang_name = "link-information"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcac.LinkInformation.Global)), ("links", ("links", MplsLcac.LinkInformation.Links))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcac.LinkInformation.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.links = MplsLcac.LinkInformation.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._segment_path = lambda: "link-information"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.LinkInformation, [], name, value)


        class Global(_Entity_):
            """
            The global information for all the interfaces
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: links
            
            	The number of links
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: maximum_links
            
            	Maximum number of links supported
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.LinkInformation.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "link-information"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('links', (YLeaf(YType.uint16, 'links'), ['int'])),
                    ('maximum_links', (YLeaf(YType.uint16, 'maximum-links'), ['int'])),
                ])
                self.is_role_standby = None
                self.links = None
                self.maximum_links = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.LinkInformation.Global, ['is_role_standby', 'links', 'maximum_links'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.LinkInformation.Global']['meta_info']


        class Links(_Entity_):
            """
            The table of interfaces in MPLS\-LCAC
            
            .. attribute:: link
            
            	An interface in MPLS\-LCAC
            	**type**\: list of  		 :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.LinkInformation.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "link-information"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link", ("link", MplsLcac.LinkInformation.Links.Link))])
                self._leafs = OrderedDict()

                self.link = YList(self)
                self._segment_path = lambda: "links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.LinkInformation.Links, [], name, value)


            class Link(_Entity_):
                """
                An interface in MPLS\-LCAC
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: link_common
                
                	The link's common info
                	**type**\:  :py:class:`LinkCommon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_account
                
                	Bandwidth Account info
                	**type**\:  :py:class:`BandwidthAccount <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount>`
                
                	**config**\: False
                
                .. attribute:: hw_oor
                
                	The link's NPU OOR info. This field is NULL for platforms that do not support HW\-OOR notifications
                	**type**\:  :py:class:`HwOor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.HwOor>`
                
                	**config**\: False
                
                .. attribute:: reason_not_flooded
                
                	Reason why link is not flooded (area\-independent)
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: maximum_reservation_bandwidth_rdm
                
                	The link's maximum reservable BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth_rdm
                
                	The link's reservable pool0 BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth_rdm
                
                	The link's reservable pool1 BW in RDM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: maximum_reservation_bandwidth_mam
                
                	The link's maximum reservable BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool0_bandwidth_mam
                
                	The link's reservable pool0 BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: reservable_pool1_bandwidth_mam
                
                	The link's reservable pool1 BW in MAM
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: link_attributes
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_attribute_incomplete
                
                	TRUE if one or more affinity definition(s) is/are unknown
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_name_based_attribute
                
                	TRUE, if name based attribute style is in effect
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_te_metric_valid
                
                	Flag to indicate whether the link's TE metric is a valid value
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: link_extended_attribute
                
                	The link's extended attribute bit map
                	**type**\: list of  		 :py:class:`LinkExtendedAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute>`
                
                	**config**\: False
                
                .. attribute:: link_forwad_ref_value
                
                	Reference bits for undefined affinity names
                	**type**\: list of  		 :py:class:`LinkForwadRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue>`
                
                	**config**\: False
                
                .. attribute:: affinity_map
                
                	Affinity map array
                	**type**\: list of  		 :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.AffinityMap>`
                
                	**config**\: False
                
                .. attribute:: areas
                
                	Per\-area data
                	**type**\: list of  		 :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.Areas>`
                
                	**config**\: False
                
                .. attribute:: lockout
                
                	Flex LSP Lockout info
                	**type**\: list of  		 :py:class:`Lockout <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.Lockout>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.LinkInformation.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("link-common", ("link_common", MplsLcac.LinkInformation.Links.Link.LinkCommon)), ("bandwidth-account", ("bandwidth_account", MplsLcac.LinkInformation.Links.Link.BandwidthAccount)), ("hw-oor", ("hw_oor", MplsLcac.LinkInformation.Links.Link.HwOor)), ("link-extended-attribute", ("link_extended_attribute", MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute)), ("link-forwad-ref-value", ("link_forwad_ref_value", MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue)), ("affinity-map", ("affinity_map", MplsLcac.LinkInformation.Links.Link.AffinityMap)), ("areas", ("areas", MplsLcac.LinkInformation.Links.Link.Areas)), ("lockout", ("lockout", MplsLcac.LinkInformation.Links.Link.Lockout))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('reason_not_flooded', (YLeaf(YType.str, 'reason-not-flooded'), ['str'])),
                        ('maximum_reservation_bandwidth_rdm', (YLeaf(YType.uint64, 'maximum-reservation-bandwidth-rdm'), ['int'])),
                        ('reservable_pool0_bandwidth_rdm', (YLeaf(YType.uint64, 'reservable-pool0-bandwidth-rdm'), ['int'])),
                        ('reservable_pool1_bandwidth_rdm', (YLeaf(YType.uint64, 'reservable-pool1-bandwidth-rdm'), ['int'])),
                        ('maximum_reservation_bandwidth_mam', (YLeaf(YType.uint64, 'maximum-reservation-bandwidth-mam'), ['int'])),
                        ('reservable_pool0_bandwidth_mam', (YLeaf(YType.uint64, 'reservable-pool0-bandwidth-mam'), ['int'])),
                        ('reservable_pool1_bandwidth_mam', (YLeaf(YType.uint64, 'reservable-pool1-bandwidth-mam'), ['int'])),
                        ('link_attributes', (YLeaf(YType.uint32, 'link-attributes'), ['int'])),
                        ('is_attribute_incomplete', (YLeaf(YType.boolean, 'is-attribute-incomplete'), ['bool'])),
                        ('is_name_based_attribute', (YLeaf(YType.boolean, 'is-name-based-attribute'), ['bool'])),
                        ('te_metric', (YLeaf(YType.uint32, 'te-metric'), ['int'])),
                        ('is_te_metric_valid', (YLeaf(YType.boolean, 'is-te-metric-valid'), ['bool'])),
                    ])
                    self.interface_name = None
                    self.reason_not_flooded = None
                    self.maximum_reservation_bandwidth_rdm = None
                    self.reservable_pool0_bandwidth_rdm = None
                    self.reservable_pool1_bandwidth_rdm = None
                    self.maximum_reservation_bandwidth_mam = None
                    self.reservable_pool0_bandwidth_mam = None
                    self.reservable_pool1_bandwidth_mam = None
                    self.link_attributes = None
                    self.is_attribute_incomplete = None
                    self.is_name_based_attribute = None
                    self.te_metric = None
                    self.is_te_metric_valid = None

                    self.link_common = MplsLcac.LinkInformation.Links.Link.LinkCommon()
                    self.link_common.parent = self
                    self._children_name_map["link_common"] = "link-common"

                    self.bandwidth_account = MplsLcac.LinkInformation.Links.Link.BandwidthAccount()
                    self.bandwidth_account.parent = self
                    self._children_name_map["bandwidth_account"] = "bandwidth-account"

                    self.hw_oor = MplsLcac.LinkInformation.Links.Link.HwOor()
                    self.hw_oor.parent = self
                    self._children_name_map["hw_oor"] = "hw-oor"

                    self.link_extended_attribute = YList(self)
                    self.link_forwad_ref_value = YList(self)
                    self.affinity_map = YList(self)
                    self.areas = YList(self)
                    self.lockout = YList(self)
                    self._segment_path = lambda: "link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/link-information/links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.LinkInformation.Links.Link, ['interface_name', 'reason_not_flooded', 'maximum_reservation_bandwidth_rdm', 'reservable_pool0_bandwidth_rdm', 'reservable_pool1_bandwidth_rdm', 'maximum_reservation_bandwidth_mam', 'reservable_pool0_bandwidth_mam', 'reservable_pool1_bandwidth_mam', 'link_attributes', 'is_attribute_incomplete', 'is_name_based_attribute', 'te_metric', 'is_te_metric_valid'], name, value)


                class LinkCommon(_Entity_):
                    """
                    The link's common info
                    
                    .. attribute:: link_flags
                    
                    	The link's flags
                    	**type**\:  :py:class:`LinkFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags>`
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	The link's id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: link_address
                    
                    	The link's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_unnumbered
                    
                    	TRUE if the link is unnumbered
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: has_protection
                    
                    	TRUE if the link is protected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: capability
                    
                    	The link's protection capability
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: working_priority
                    
                    	The link's working priority
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: resource_provider
                    
                    	The link's resource provider
                    	**type**\:  :py:class:`ResourceProvider <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.ResourceProvider>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_resource_provider_installed
                    
                    	TRUE if the resource provider is installed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_units
                    
                    	The bandwidth units
                    	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                    
                    	**config**\: False
                    
                    .. attribute:: physical_bandwidth
                    
                    	The link's physical bandwidth
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: bcm_id
                    
                    	Bandwidth Constraints Model ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_bandwidth
                    
                    	The link's maximum reservable BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: last_flooded_effective_maximum_reservable_bandwidth
                    
                    	Last flooded max reservable bandwidth effective
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_bandwidth_percentage
                    
                    	Incoming reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_bandwidth_percentage
                    
                    	Outgoing reserved BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool0_bandwidth
                    
                    	The link's maximum reservable pool0 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool0_bandwidth_percentage
                    
                    	Incoming reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool0_bandwidth_percentage
                    
                    	Outgoing reserved pool0 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_reservable_pool1_bandwidth
                    
                    	The link's maximum reservable pool1 BW
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_reservable_pool1_bandwidth_percentage
                    
                    	Incoming reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_reservable_pool1_bandwidth_percentage
                    
                    	Outgoing reserved pool1 BW in %
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: inbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_admission_method
                    
                    	Deprecated
                    	**type**\:  :py:class:`AdmissionPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AdmissionPolicy>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_neighbors
                    
                    	The link's neighbor count
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The link's shared risk link groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: interface_switching_capability_descriptor
                    
                    	The link's switching capability descriptor
                    	**type**\: list of  		 :py:class:`InterfaceSwitchingCapabilityDescriptor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor>`
                    
                    	**config**\: False
                    
                    .. attribute:: flooded_areas
                    
                    	List of areas into which the link is flooded
                    	**type**\: list of  		 :py:class:`FloodedAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.LinkCommon, self).__init__()

                        self.yang_name = "link-common"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("link-flags", ("link_flags", MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags)), ("shared-risk-link-group", ("shared_risk_link_group", MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup)), ("interface-switching-capability-descriptor", ("interface_switching_capability_descriptor", MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor)), ("flooded-areas", ("flooded_areas", MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas))])
                        self._leafs = OrderedDict([
                            ('link_id', (YLeaf(YType.str, 'link-id'), ['str'])),
                            ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                            ('is_unnumbered', (YLeaf(YType.boolean, 'is-unnumbered'), ['bool'])),
                            ('has_protection', (YLeaf(YType.boolean, 'has-protection'), ['bool'])),
                            ('capability', (YLeaf(YType.uint32, 'capability'), ['int'])),
                            ('working_priority', (YLeaf(YType.uint32, 'working-priority'), ['int'])),
                            ('resource_provider', (YLeaf(YType.enumeration, 'resource-provider'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'ResourceProvider', '')])),
                            ('is_resource_provider_installed', (YLeaf(YType.boolean, 'is-resource-provider-installed'), ['bool'])),
                            ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                            ('physical_bandwidth', (YLeaf(YType.uint64, 'physical-bandwidth'), ['int'])),
                            ('bcm_id', (YLeaf(YType.uint16, 'bcm-id'), ['int'])),
                            ('maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-bandwidth'), ['int'])),
                            ('last_flooded_effective_maximum_reservable_bandwidth', (YLeaf(YType.uint64, 'last-flooded-effective-maximum-reservable-bandwidth'), ['int'])),
                            ('incoming_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool0_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool0-bandwidth'), ['int'])),
                            ('incoming_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool0_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool0-bandwidth-percentage'), ['int'])),
                            ('maximum_reservable_pool1_bandwidth', (YLeaf(YType.uint64, 'maximum-reservable-pool1-bandwidth'), ['int'])),
                            ('incoming_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'incoming-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('outgoing_reservable_pool1_bandwidth_percentage', (YLeaf(YType.uint8, 'outgoing-reservable-pool1-bandwidth-percentage'), ['int'])),
                            ('inbound_admission_method', (YLeaf(YType.enumeration, 'inbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('outbound_admission_method', (YLeaf(YType.enumeration, 'outbound-admission-method'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AdmissionPolicy', '')])),
                            ('igp_neighbors', (YLeaf(YType.uint16, 'igp-neighbors'), ['int'])),
                        ])
                        self.link_id = None
                        self.link_address = None
                        self.is_unnumbered = None
                        self.has_protection = None
                        self.capability = None
                        self.working_priority = None
                        self.resource_provider = None
                        self.is_resource_provider_installed = None
                        self.bandwidth_units = None
                        self.physical_bandwidth = None
                        self.bcm_id = None
                        self.maximum_reservable_bandwidth = None
                        self.last_flooded_effective_maximum_reservable_bandwidth = None
                        self.incoming_reservable_bandwidth_percentage = None
                        self.outgoing_reservable_bandwidth_percentage = None
                        self.maximum_reservable_pool0_bandwidth = None
                        self.incoming_reservable_pool0_bandwidth_percentage = None
                        self.outgoing_reservable_pool0_bandwidth_percentage = None
                        self.maximum_reservable_pool1_bandwidth = None
                        self.incoming_reservable_pool1_bandwidth_percentage = None
                        self.outgoing_reservable_pool1_bandwidth_percentage = None
                        self.inbound_admission_method = None
                        self.outbound_admission_method = None
                        self.igp_neighbors = None

                        self.link_flags = MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags()
                        self.link_flags.parent = self
                        self._children_name_map["link_flags"] = "link-flags"

                        self.shared_risk_link_group = YList(self)
                        self.interface_switching_capability_descriptor = YList(self)
                        self.flooded_areas = YList(self)
                        self._segment_path = lambda: "link-common"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkCommon, ['link_id', 'link_address', 'is_unnumbered', 'has_protection', 'capability', 'working_priority', 'resource_provider', 'is_resource_provider_installed', 'bandwidth_units', 'physical_bandwidth', 'bcm_id', 'maximum_reservable_bandwidth', 'last_flooded_effective_maximum_reservable_bandwidth', 'incoming_reservable_bandwidth_percentage', 'outgoing_reservable_bandwidth_percentage', 'maximum_reservable_pool0_bandwidth', 'incoming_reservable_pool0_bandwidth_percentage', 'outgoing_reservable_pool0_bandwidth_percentage', 'maximum_reservable_pool1_bandwidth', 'incoming_reservable_pool1_bandwidth_percentage', 'outgoing_reservable_pool1_bandwidth_percentage', 'inbound_admission_method', 'outbound_admission_method', 'igp_neighbors'], name, value)


                    class LinkFlags(_Entity_):
                        """
                        The link's flags
                        
                        .. attribute:: is_mpls_te_on
                        
                        	Deprecated \- TRUE if the link is a TE\-Link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: signaling_agent
                        
                        	Deprecated \- Signaling agent
                        	**type**\:  :py:class:`SignalingAgentEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.SignalingAgentEnum>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_admin_up
                        
                        	TRUE if the link is admin up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags, self).__init__()

                            self.yang_name = "link-flags"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_mpls_te_on', (YLeaf(YType.boolean, 'is-mpls-te-on'), ['bool'])),
                                ('signaling_agent', (YLeaf(YType.enumeration, 'signaling-agent'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'SignalingAgentEnum', '')])),
                                ('is_admin_up', (YLeaf(YType.boolean, 'is-admin-up'), ['bool'])),
                            ])
                            self.is_mpls_te_on = None
                            self.signaling_agent = None
                            self.is_admin_up = None
                            self._segment_path = lambda: "link-flags"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags, ['is_mpls_te_on', 'signaling_agent', 'is_admin_up'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkCommon.LinkFlags']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The link's shared risk link groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkCommon.SharedRiskLinkGroup']['meta_info']


                    class InterfaceSwitchingCapabilityDescriptor(_Entity_):
                        """
                        The link's switching capability descriptor
                        
                        .. attribute:: key
                        
                        	The switching capability descriptor key
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: switching_capability
                        
                        	The switching capability
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: encoding
                        
                        	The link encoding type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, self).__init__()

                            self.yang_name = "interface-switching-capability-descriptor"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('key', (YLeaf(YType.uint8, 'key'), ['int'])),
                                ('switching_capability', (YLeaf(YType.uint8, 'switching-capability'), ['int'])),
                                ('encoding', (YLeaf(YType.uint8, 'encoding'), ['int'])),
                            ])
                            self.key = None
                            self.switching_capability = None
                            self.encoding = None
                            self._segment_path = lambda: "interface-switching-capability-descriptor"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor, ['key', 'switching_capability', 'encoding'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkCommon.InterfaceSwitchingCapabilityDescriptor']['meta_info']


                    class FloodedAreas(_Entity_):
                        """
                        List of areas into which the link is flooded
                        
                        .. attribute:: flooded_area
                        
                        	The flooded area information
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas, self).__init__()

                            self.yang_name = "flooded-areas"
                            self.yang_parent_name = "link-common"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('flooded_area', (YLeaf(YType.str, 'flooded-area'), ['str'])),
                            ])
                            self.flooded_area = None
                            self._segment_path = lambda: "flooded-areas"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas, ['flooded_area'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkCommon.FloodedAreas']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkCommon']['meta_info']


                class BandwidthAccount(_Entity_):
                    """
                    Bandwidth Account info
                    
                    .. attribute:: bandwidth_account_common_info
                    
                    	Common info for bandwidth accounting
                    	**type**\:  :py:class:`BandwidthAccountCommonInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: rsvp_te_bandwidth_sample_history
                    
                    	RSVP\-TE Bandwidth samples history
                    	**type**\:  :py:class:`RsvpTeBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory>`
                    
                    	**config**\: False
                    
                    .. attribute:: sr_bandwidth_sample_history
                    
                    	Segment Routing Bandwidth samples history
                    	**type**\:  :py:class:`SrBandwidthSampleHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount, self).__init__()

                        self.yang_name = "bandwidth-account"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("bandwidth-account-common-info", ("bandwidth_account_common_info", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo)), ("rsvp-te-bandwidth-sample-history", ("rsvp_te_bandwidth_sample_history", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory)), ("sr-bandwidth-sample-history", ("sr_bandwidth_sample_history", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory))])
                        self._leafs = OrderedDict()

                        self.bandwidth_account_common_info = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo()
                        self.bandwidth_account_common_info.parent = self
                        self._children_name_map["bandwidth_account_common_info"] = "bandwidth-account-common-info"

                        self.rsvp_te_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory()
                        self.rsvp_te_bandwidth_sample_history.parent = self
                        self._children_name_map["rsvp_te_bandwidth_sample_history"] = "rsvp-te-bandwidth-sample-history"

                        self.sr_bandwidth_sample_history = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory()
                        self.sr_bandwidth_sample_history.parent = self
                        self._children_name_map["sr_bandwidth_sample_history"] = "sr-bandwidth-sample-history"
                        self._segment_path = lambda: "bandwidth-account"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount, [], name, value)


                    class BandwidthAccountCommonInfo(_Entity_):
                        """
                        Common info for bandwidth accounting
                        
                        .. attribute:: rsvp_te_bandwidth_utilization
                        
                        	RSVP\-TE Bandwidth utilization information
                        	**type**\:  :py:class:`RsvpTeBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization>`
                        
                        	**config**\: False
                        
                        .. attribute:: sr_bandwidth_utilization
                        
                        	Segment Routing Bandwidth utilization information
                        	**type**\:  :py:class:`SrBandwidthUtilization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_account_enabled
                        
                        	TRUE if bandwidth accounting is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: application_enforced
                        
                        	TRUE if bandwidth accounting application is enforced
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: collection_type
                        
                        	The type of traffic collected for bandwidth accounting
                        	**type**\:  :py:class:`BandwidthAccountingCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthAccountingCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: sample_interval
                        
                        	Sampling interval in seconds for bandwidth accounting stats
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: sample_time_remaining
                        
                        	This value indicates the number of seconds until the next sampling
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: last_sample_collection_timestamp
                        
                        	Timestamp for the last sample collection
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: next_sample_collection
                        
                        	Timestamp for the next sample collection
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_interval
                        
                        	Application interval in seconds for bandwidth accounting stats
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: application_time_remaining
                        
                        	This value indicates the number of seconds until the next application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: last_application_timestamp
                        
                        	Timestamp for the last application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: next_application
                        
                        	Timestamp for the next application
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_factor
                        
                        	This value indicates the adjustment factor applied to measured non RSVP\-TE bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: max_reservable_bandwidth_threshold_are_default
                        
                        	TRUE if the maximum reservable bandwidth flooding thresholds are default
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: up_threshold_max_reservable_bandwidth
                        
                        	The up threshold for flooding the maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: down_threshold_max_reservable_bandwidth
                        
                        	The down threshold for flooding the maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, self).__init__()

                            self.yang_name = "bandwidth-account-common-info"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rsvp-te-bandwidth-utilization", ("rsvp_te_bandwidth_utilization", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization)), ("sr-bandwidth-utilization", ("sr_bandwidth_utilization", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization))])
                            self._leafs = OrderedDict([
                                ('is_bandwidth_account_enabled', (YLeaf(YType.boolean, 'is-bandwidth-account-enabled'), ['bool'])),
                                ('application_enforced', (YLeaf(YType.boolean, 'application-enforced'), ['bool'])),
                                ('collection_type', (YLeaf(YType.enumeration, 'collection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthAccountingCollection', '')])),
                                ('sample_interval', (YLeaf(YType.uint32, 'sample-interval'), ['int'])),
                                ('sample_time_remaining', (YLeaf(YType.uint32, 'sample-time-remaining'), ['int'])),
                                ('last_sample_collection_timestamp', (YLeaf(YType.uint32, 'last-sample-collection-timestamp'), ['int'])),
                                ('next_sample_collection', (YLeaf(YType.uint32, 'next-sample-collection'), ['int'])),
                                ('application_interval', (YLeaf(YType.uint32, 'application-interval'), ['int'])),
                                ('application_time_remaining', (YLeaf(YType.uint32, 'application-time-remaining'), ['int'])),
                                ('last_application_timestamp', (YLeaf(YType.uint32, 'last-application-timestamp'), ['int'])),
                                ('next_application', (YLeaf(YType.uint32, 'next-application'), ['int'])),
                                ('adjustment_factor', (YLeaf(YType.uint32, 'adjustment-factor'), ['int'])),
                                ('max_reservable_bandwidth_threshold_are_default', (YLeaf(YType.boolean, 'max-reservable-bandwidth-threshold-are-default'), ['bool'])),
                                ('up_threshold_max_reservable_bandwidth', (YLeaf(YType.uint8, 'up-threshold-max-reservable-bandwidth'), ['int'])),
                                ('down_threshold_max_reservable_bandwidth', (YLeaf(YType.uint8, 'down-threshold-max-reservable-bandwidth'), ['int'])),
                            ])
                            self.is_bandwidth_account_enabled = None
                            self.application_enforced = None
                            self.collection_type = None
                            self.sample_interval = None
                            self.sample_time_remaining = None
                            self.last_sample_collection_timestamp = None
                            self.next_sample_collection = None
                            self.application_interval = None
                            self.application_time_remaining = None
                            self.last_application_timestamp = None
                            self.next_application = None
                            self.adjustment_factor = None
                            self.max_reservable_bandwidth_threshold_are_default = None
                            self.up_threshold_max_reservable_bandwidth = None
                            self.down_threshold_max_reservable_bandwidth = None

                            self.rsvp_te_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization()
                            self.rsvp_te_bandwidth_utilization.parent = self
                            self._children_name_map["rsvp_te_bandwidth_utilization"] = "rsvp-te-bandwidth-utilization"

                            self.sr_bandwidth_utilization = MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization()
                            self.sr_bandwidth_utilization.parent = self
                            self._children_name_map["sr_bandwidth_utilization"] = "sr-bandwidth-utilization"
                            self._segment_path = lambda: "bandwidth-account-common-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo, ['is_bandwidth_account_enabled', 'application_enforced', 'collection_type', 'sample_interval', 'sample_time_remaining', 'last_sample_collection_timestamp', 'next_sample_collection', 'application_interval', 'application_time_remaining', 'last_application_timestamp', 'next_application', 'adjustment_factor', 'max_reservable_bandwidth_threshold_are_default', 'up_threshold_max_reservable_bandwidth', 'down_threshold_max_reservable_bandwidth'], name, value)


                        class RsvpTeBandwidthUtilization(_Entity_):
                            """
                            RSVP\-TE Bandwidth utilization information
                            
                            .. attribute:: total_link_bandwidth_utilization
                            
                            	Total bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_bandwidth_utilization
                            
                            	RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_bandwidth_utilization
                            
                            	Non\-RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_adjusted_bandwidth_utilization
                            
                            	Adjusted RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_enforced_bandwidth_utilization
                            
                            	Enforced RSVP\-TE bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, self).__init__()

                                self.yang_name = "rsvp-te-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('total_link_bandwidth_utilization', (YLeaf(YType.uint64, 'total-link-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-bandwidth-utilization'), ['int'])),
                                    ('non_rsvp_te_bandwidth_utilization', (YLeaf(YType.uint64, 'non-rsvp-te-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-adjusted-bandwidth-utilization'), ['int'])),
                                    ('rsvp_te_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'rsvp-te-enforced-bandwidth-utilization'), ['int'])),
                                ])
                                self.total_link_bandwidth_utilization = None
                                self.rsvp_te_bandwidth_utilization = None
                                self.non_rsvp_te_bandwidth_utilization = None
                                self.rsvp_te_adjusted_bandwidth_utilization = None
                                self.rsvp_te_enforced_bandwidth_utilization = None
                                self._segment_path = lambda: "rsvp-te-bandwidth-utilization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization, ['total_link_bandwidth_utilization', 'rsvp_te_bandwidth_utilization', 'non_rsvp_te_bandwidth_utilization', 'rsvp_te_adjusted_bandwidth_utilization', 'rsvp_te_enforced_bandwidth_utilization'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.RsvpTeBandwidthUtilization']['meta_info']


                        class SrBandwidthUtilization(_Entity_):
                            """
                            Segment Routing Bandwidth utilization
                            information
                            
                            .. attribute:: sr_bandwidth_utilization
                            
                            	Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_adjusted_bandwidth_utilization
                            
                            	Adjusted Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: sr_enforced_bandwidth_utilization
                            
                            	Enforced Segment Routing bandwidth utilization measured in kilobits per second
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, self).__init__()

                                self.yang_name = "sr-bandwidth-utilization"
                                self.yang_parent_name = "bandwidth-account-common-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sr_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-bandwidth-utilization'), ['int'])),
                                    ('sr_adjusted_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-adjusted-bandwidth-utilization'), ['int'])),
                                    ('sr_enforced_bandwidth_utilization', (YLeaf(YType.uint64, 'sr-enforced-bandwidth-utilization'), ['int'])),
                                ])
                                self.sr_bandwidth_utilization = None
                                self.sr_adjusted_bandwidth_utilization = None
                                self.sr_enforced_bandwidth_utilization = None
                                self._segment_path = lambda: "sr-bandwidth-utilization"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization, ['sr_bandwidth_utilization', 'sr_adjusted_bandwidth_utilization', 'sr_enforced_bandwidth_utilization'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo.SrBandwidthUtilization']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.BandwidthAccountCommonInfo']['meta_info']


                    class RsvpTeBandwidthSampleHistory(_Entity_):
                        """
                        RSVP\-TE Bandwidth samples history
                        
                        .. attribute:: rsvp_te_active_interval_sample
                        
                        	RSVP\-TE samples in the current application interval
                        	**type**\: list of  		 :py:class:`RsvpTeActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample>`
                        
                        	**config**\: False
                        
                        .. attribute:: rsvp_te_previous_interval_sample
                        
                        	RSVP\-TE samples in the previous application interval
                        	**type**\: list of  		 :py:class:`RsvpTePreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, self).__init__()

                            self.yang_name = "rsvp-te-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("rsvp-te-active-interval-sample", ("rsvp_te_active_interval_sample", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample)), ("rsvp-te-previous-interval-sample", ("rsvp_te_previous_interval_sample", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample))])
                            self._leafs = OrderedDict()

                            self.rsvp_te_active_interval_sample = YList(self)
                            self.rsvp_te_previous_interval_sample = YList(self)
                            self._segment_path = lambda: "rsvp-te-bandwidth-sample-history"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory, [], name, value)


                        class RsvpTeActiveIntervalSample(_Entity_):
                            """
                            RSVP\-TE samples in the current application
                            interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-active-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                    ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                    ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.total_rate = None
                                self.rsvp_te_rate = None
                                self.non_rsvp_te_rate = None
                                self._segment_path = lambda: "rsvp-te-active-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample, ['timestamp', 'total_rate', 'rsvp_te_rate', 'non_rsvp_te_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTeActiveIntervalSample']['meta_info']


                        class RsvpTePreviousIntervalSample(_Entity_):
                            """
                            RSVP\-TE samples in the previous application
                            interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: total_rate
                            
                            	Total traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: rsvp_te_rate
                            
                            	RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: non_rsvp_te_rate
                            
                            	Non\-RSVP\-TE traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, self).__init__()

                                self.yang_name = "rsvp-te-previous-interval-sample"
                                self.yang_parent_name = "rsvp-te-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('total_rate', (YLeaf(YType.uint64, 'total-rate'), ['int'])),
                                    ('rsvp_te_rate', (YLeaf(YType.uint64, 'rsvp-te-rate'), ['int'])),
                                    ('non_rsvp_te_rate', (YLeaf(YType.uint64, 'non-rsvp-te-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.total_rate = None
                                self.rsvp_te_rate = None
                                self.non_rsvp_te_rate = None
                                self._segment_path = lambda: "rsvp-te-previous-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample, ['timestamp', 'total_rate', 'rsvp_te_rate', 'non_rsvp_te_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory.RsvpTePreviousIntervalSample']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.RsvpTeBandwidthSampleHistory']['meta_info']


                    class SrBandwidthSampleHistory(_Entity_):
                        """
                        Segment Routing Bandwidth samples history
                        
                        .. attribute:: sr_active_interval_sample
                        
                        	Segment Routing samples in the current application interval
                        	**type**\: list of  		 :py:class:`SrActiveIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample>`
                        
                        	**config**\: False
                        
                        .. attribute:: sr_previous_interval_sample
                        
                        	Segment Routing samples in the previous application interval
                        	**type**\: list of  		 :py:class:`SrPreviousIntervalSample <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, self).__init__()

                            self.yang_name = "sr-bandwidth-sample-history"
                            self.yang_parent_name = "bandwidth-account"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("sr-active-interval-sample", ("sr_active_interval_sample", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample)), ("sr-previous-interval-sample", ("sr_previous_interval_sample", MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample))])
                            self._leafs = OrderedDict()

                            self.sr_active_interval_sample = YList(self)
                            self.sr_previous_interval_sample = YList(self)
                            self._segment_path = lambda: "sr-bandwidth-sample-history"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory, [], name, value)


                        class SrActiveIntervalSample(_Entity_):
                            """
                            Segment Routing samples in the current
                            application interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, self).__init__()

                                self.yang_name = "sr-active-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.sr_rate = None
                                self._segment_path = lambda: "sr-active-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample, ['timestamp', 'sr_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrActiveIntervalSample']['meta_info']


                        class SrPreviousIntervalSample(_Entity_):
                            """
                            Segment Routing samples in the previous
                            application interval
                            
                            .. attribute:: timestamp
                            
                            	Timestamp in seconds of this sample
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: sr_rate
                            
                            	Segment Routing traffic rate measured in Kilobits per second in this sample
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, self).__init__()

                                self.yang_name = "sr-previous-interval-sample"
                                self.yang_parent_name = "sr-bandwidth-sample-history"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                    ('sr_rate', (YLeaf(YType.uint64, 'sr-rate'), ['int'])),
                                ])
                                self.timestamp = None
                                self.sr_rate = None
                                self._segment_path = lambda: "sr-previous-interval-sample"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample, ['timestamp', 'sr_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory.SrPreviousIntervalSample']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount.SrBandwidthSampleHistory']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.BandwidthAccount']['meta_info']


                class HwOor(_Entity_):
                    """
                    The link's NPU OOR info. This field is NULL for
                    platforms that do not support HW\-OOR
                    notifications
                    
                    .. attribute:: hw_oor_state
                    
                    	The NPU (Network Processor Unit) HW resource state
                    	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    	**config**\: False
                    
                    .. attribute:: hw_oor_timestamp
                    
                    	Timestamp when the OOR state last changed
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: hw_o_or_green_recovery_time
                    
                    	Time Remaining in Green Recovery State (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: hw_o_or_link_statistic
                    
                    	HW OOR statistics for the link
                    	**type**\: list of  		 :py:class:`HwOOrLinkStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.HwOor, self).__init__()

                        self.yang_name = "hw-oor"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("hw-o-or-link-statistic", ("hw_o_or_link_statistic", MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic))])
                        self._leafs = OrderedDict([
                            ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                            ('hw_oor_timestamp', (YLeaf(YType.uint32, 'hw-oor-timestamp'), ['int'])),
                            ('hw_o_or_green_recovery_time', (YLeaf(YType.uint32, 'hw-o-or-green-recovery-time'), ['int'])),
                        ])
                        self.hw_oor_state = None
                        self.hw_oor_timestamp = None
                        self.hw_o_or_green_recovery_time = None

                        self.hw_o_or_link_statistic = YList(self)
                        self._segment_path = lambda: "hw-oor"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.HwOor, ['hw_oor_state', 'hw_oor_timestamp', 'hw_o_or_green_recovery_time'], name, value)


                    class HwOOrLinkStatistic(_Entity_):
                        """
                        HW OOR statistics for the link
                        
                        .. attribute:: hw_oor_state
                        
                        	The HW\-OOR state that these statistics belong to
                        	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                        
                        	**config**\: False
                        
                        .. attribute:: transitions
                        
                        	Number of transitions to this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_protection_disable_number
                        
                        	Number of times this OOR state disabled node protection assignment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rejected_ls_ps_number
                        
                        	Number of LSPs that were rejected in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: accepted_ls_ps_number
                        
                        	Number of LSPs that were accepted in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: accepted_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were accepted in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rejected_reopt_ls_ps_number
                        
                        	Number of Reoptimize LSPs that were rejected in this state
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, self).__init__()

                            self.yang_name = "hw-o-or-link-statistic"
                            self.yang_parent_name = "hw-oor"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                                ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                                ('node_protection_disable_number', (YLeaf(YType.uint32, 'node-protection-disable-number'), ['int'])),
                                ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                                ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                                ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                                ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                            ])
                            self.hw_oor_state = None
                            self.transitions = None
                            self.node_protection_disable_number = None
                            self.rejected_ls_ps_number = None
                            self.accepted_ls_ps_number = None
                            self.accepted_reopt_ls_ps_number = None
                            self.rejected_reopt_ls_ps_number = None
                            self._segment_path = lambda: "hw-o-or-link-statistic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic, ['hw_oor_state', 'transitions', 'node_protection_disable_number', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.HwOor.HwOOrLinkStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.HwOor']['meta_info']


                class LinkExtendedAttribute(_Entity_):
                    """
                    The link's extended attribute bit map
                    
                    .. attribute:: entry
                    
                    	The link's extended attribute bit map
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute, self).__init__()

                        self.yang_name = "link-extended-attribute"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "link-extended-attribute"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkExtendedAttribute']['meta_info']


                class LinkForwadRefValue(_Entity_):
                    """
                    Reference bits for undefined affinity names
                    
                    .. attribute:: entry
                    
                    	Reference bits for undefined affinity names
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue, self).__init__()

                        self.yang_name = "link-forwad-ref-value"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "link-forwad-ref-value"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.LinkForwadRefValue']['meta_info']


                class AffinityMap(_Entity_):
                    """
                    Affinity map array
                    
                    .. attribute:: affinity_name
                    
                    	Affinity name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_value
                    
                    	Affinity value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_bit_position
                    
                    	Affinity bit position
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_table_id
                    
                    	Affinity table id
                    	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_extended_value
                    
                    	EAG value
                    	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.AffinityMap, self).__init__()

                        self.yang_name = "affinity-map"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue))])
                        self._leafs = OrderedDict([
                            ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                            ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                            ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                            ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                        ])
                        self.affinity_name = None
                        self.affinity_value = None
                        self.affinity_bit_position = None
                        self.affinity_table_id = None

                        self.affinity_extended_value = YList(self)
                        self._segment_path = lambda: "affinity-map"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.AffinityMap, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


                    class AffinityExtendedValue(_Entity_):
                        """
                        EAG value
                        
                        .. attribute:: entry
                        
                        	EAG value
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, self).__init__()

                            self.yang_name = "affinity-extended-value"
                            self.yang_parent_name = "affinity-map"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "affinity-extended-value"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsLcac.LinkInformation.Links.Link.AffinityMap.AffinityExtendedValue']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.AffinityMap']['meta_info']


                class Areas(_Entity_):
                    """
                    Per\-area data
                    
                    .. attribute:: area_id
                    
                    	Area id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: neighbor_id
                    
                    	The interface neighbor id
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: neighbor_address
                    
                    	The interface's neighbor's ip address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_neighbor_up
                    
                    	TRUE if the neighbor is up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	The link's IGP metric
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.Areas, self).__init__()

                        self.yang_name = "areas"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                            ('neighbor_id', (YLeaf(YType.str, 'neighbor-id'), ['str'])),
                            ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                            ('is_neighbor_up', (YLeaf(YType.boolean, 'is-neighbor-up'), ['bool'])),
                            ('igp_metric', (YLeaf(YType.uint32, 'igp-metric'), ['int'])),
                        ])
                        self.area_id = None
                        self.neighbor_id = None
                        self.neighbor_address = None
                        self.is_neighbor_up = None
                        self.igp_metric = None
                        self._segment_path = lambda: "areas"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.Areas, ['area_id', 'neighbor_id', 'neighbor_address', 'is_neighbor_up', 'igp_metric'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.Areas']['meta_info']


                class Lockout(_Entity_):
                    """
                    Flex LSP Lockout info
                    
                    .. attribute:: is_lockout
                    
                    	True if link is locked out
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_on_timestamp
                    
                    	Timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_off_timestamp
                    
                    	Timestamp when the lockout is cleared
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsLcac.LinkInformation.Links.Link.Lockout, self).__init__()

                        self.yang_name = "lockout"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_on_timestamp', (YLeaf(YType.uint32, 'lockout-on-timestamp'), ['int'])),
                            ('lockout_off_timestamp', (YLeaf(YType.uint32, 'lockout-off-timestamp'), ['int'])),
                        ])
                        self.is_lockout = None
                        self.lockout_on_timestamp = None
                        self.lockout_off_timestamp = None
                        self._segment_path = lambda: "lockout"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsLcac.LinkInformation.Links.Link.Lockout, ['is_lockout', 'lockout_on_timestamp', 'lockout_off_timestamp'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsLcac.LinkInformation.Links.Link.Lockout']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.LinkInformation.Links.Link']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.LinkInformation.Links']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.LinkInformation']['meta_info']


    class AdmissionControl(_Entity_):
        """
        The admission control information in MPLS\-LCAC
        
        .. attribute:: global_
        
        	The global admission control information
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.Global>`
        
        	**config**\: False
        
        .. attribute:: admitted_tunnels
        
        	The table of admitted tunnels information in MPLS\-LCAC
        	**type**\:  :py:class:`AdmittedTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.AdmittedTunnels>`
        
        	**config**\: False
        
        .. attribute:: link_interfaces
        
        	The global admission control information on Interfaces
        	**type**\:  :py:class:`LinkInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.LinkInterfaces>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.AdmissionControl, self).__init__()

            self.yang_name = "admission-control"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsLcac.AdmissionControl.Global)), ("admitted-tunnels", ("admitted_tunnels", MplsLcac.AdmissionControl.AdmittedTunnels)), ("link-interfaces", ("link_interfaces", MplsLcac.AdmissionControl.LinkInterfaces))])
            self._leafs = OrderedDict()

            self.global_ = MplsLcac.AdmissionControl.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.admitted_tunnels = MplsLcac.AdmissionControl.AdmittedTunnels()
            self.admitted_tunnels.parent = self
            self._children_name_map["admitted_tunnels"] = "admitted-tunnels"

            self.link_interfaces = MplsLcac.AdmissionControl.LinkInterfaces()
            self.link_interfaces.parent = self
            self._children_name_map["link_interfaces"] = "link-interfaces"
            self._segment_path = lambda: "admission-control"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.AdmissionControl, [], name, value)


        class Global(_Entity_):
            """
            The global admission control information
            
            .. attribute:: is_role_standby
            
            	TRUE if Role is Standby, Active otherwise
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: total_tunnels
            
            	Total p2p tunnels admitted
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_p2mp_tunnels
            
            	Total p2mp tunnels admitted
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: selected_tunnels
            
            	Number of tunnels selected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bandwidth_units
            
            	Bandwidth units
            	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.AdmissionControl.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                    ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                    ('total_p2mp_tunnels', (YLeaf(YType.uint32, 'total-p2mp-tunnels'), ['int'])),
                    ('selected_tunnels', (YLeaf(YType.uint32, 'selected-tunnels'), ['int'])),
                    ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                ])
                self.is_role_standby = None
                self.total_tunnels = None
                self.total_p2mp_tunnels = None
                self.selected_tunnels = None
                self.bandwidth_units = None
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.AdmissionControl.Global, ['is_role_standby', 'total_tunnels', 'total_p2mp_tunnels', 'selected_tunnels', 'bandwidth_units'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.AdmissionControl.Global']['meta_info']


        class AdmittedTunnels(_Entity_):
            """
            The table of admitted tunnels information in
            MPLS\-LCAC
            
            .. attribute:: admitted_tunnel
            
            	The information for a specific admitted tunnel
            	**type**\: list of  		 :py:class:`AdmittedTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.AdmissionControl.AdmittedTunnels, self).__init__()

                self.yang_name = "admitted-tunnels"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("admitted-tunnel", ("admitted_tunnel", MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel))])
                self._leafs = OrderedDict()

                self.admitted_tunnel = YList(self)
                self._segment_path = lambda: "admitted-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.AdmissionControl.AdmittedTunnels, [], name, value)


            class AdmittedTunnel(_Entity_):
                """
                The information for a specific admitted tunnel
                
                .. attribute:: source_address  (key)
                
                	The source IP address of the tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_port  (key)
                
                	The tunnel number at the head
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_port  (key)
                
                	The signaling instance number of the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	The destination IP address of the tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended tunnel id
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: next_hop_address  (key)
                
                	The Next hop IP
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	C type
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	The admitted tunnel's name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_state
                
                	The bandwidth state
                	**type**\:  :py:class:`BandwidthStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthStateEnum>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool
                
                	The bandwidth pool
                	**type**\:  :py:class:`BandwidthTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthTypeEnum>`
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The tunnel's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The tunnel's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: up_link_name
                
                	The uplink's name for this tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: down_link_name
                
                	The downlink's name for this tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_state
                
                	The tunnel's state
                	**type**\:  :py:class:`TunnelStateEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelStateEnum>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	The bandwidth used by this tunnel
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: local_label
                
                	The local label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: outgoing_label
                
                	The outgoing label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_interface
                
                	The backup Interface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_rerouted
                
                	TRUE if the tunnel is currently rerouted
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel, self).__init__()

                    self.yang_name = "admitted-tunnel"
                    self.yang_parent_name = "admitted-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_port','source_port','destination_address','extended_tunnel_id','next_hop_address','ctype','p2mp_id']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_port', (YLeaf(YType.uint32, 'destination-port'), ['int'])),
                        ('source_port', (YLeaf(YType.uint32, 'source-port'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('bandwidth_state', (YLeaf(YType.enumeration, 'bandwidth-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthStateEnum', '')])),
                        ('bandwidth_pool', (YLeaf(YType.enumeration, 'bandwidth-pool'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthTypeEnum', '')])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('up_link_name', (YLeaf(YType.str, 'up-link-name'), ['str'])),
                        ('down_link_name', (YLeaf(YType.str, 'down-link-name'), ['str'])),
                        ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelStateEnum', '')])),
                        ('bandwidth', (YLeaf(YType.uint64, 'bandwidth'), ['int'])),
                        ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                        ('outgoing_label', (YLeaf(YType.uint32, 'outgoing-label'), ['int'])),
                        ('backup_interface', (YLeaf(YType.str, 'backup-interface'), ['str'])),
                        ('is_rerouted', (YLeaf(YType.boolean, 'is-rerouted'), ['bool'])),
                    ])
                    self.source_address = None
                    self.destination_port = None
                    self.source_port = None
                    self.destination_address = None
                    self.extended_tunnel_id = None
                    self.next_hop_address = None
                    self.ctype = None
                    self.p2mp_id = None
                    self.tunnel_name = None
                    self.bandwidth_state = None
                    self.bandwidth_pool = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.up_link_name = None
                    self.down_link_name = None
                    self.tunnel_state = None
                    self.bandwidth = None
                    self.local_label = None
                    self.outgoing_label = None
                    self.backup_interface = None
                    self.is_rerouted = None
                    self._segment_path = lambda: "admitted-tunnel" + "[source-address='" + str(self.source_address) + "']" + "[destination-port='" + str(self.destination_port) + "']" + "[source-port='" + str(self.source_port) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[next-hop-address='" + str(self.next_hop_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/admitted-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel, ['source_address', 'destination_port', 'source_port', 'destination_address', 'extended_tunnel_id', 'next_hop_address', 'ctype', 'p2mp_id', 'tunnel_name', 'bandwidth_state', 'bandwidth_pool', 'setup_priority', 'hold_priority', 'up_link_name', 'down_link_name', 'tunnel_state', 'bandwidth', 'local_label', 'outgoing_label', 'backup_interface', 'is_rerouted'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.AdmissionControl.AdmittedTunnels.AdmittedTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.AdmissionControl.AdmittedTunnels']['meta_info']


        class LinkInterfaces(_Entity_):
            """
            The global admission control information on
            Interfaces
            
            .. attribute:: link_interface
            
            	The global admission control information on an interface
            	**type**\: list of  		 :py:class:`LinkInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.AdmissionControl.LinkInterfaces, self).__init__()

                self.yang_name = "link-interfaces"
                self.yang_parent_name = "admission-control"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link-interface", ("link_interface", MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface))])
                self._leafs = OrderedDict()

                self.link_interface = YList(self)
                self._segment_path = lambda: "link-interfaces"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.AdmissionControl.LinkInterfaces, [], name, value)


            class LinkInterface(_Entity_):
                """
                The global admission control information on an
                interface
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: is_role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: total_tunnels
                
                	Total p2p tunnels admitted
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: total_p2mp_tunnels
                
                	Total p2mp tunnels admitted
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: selected_tunnels
                
                	Number of tunnels selected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_units
                
                	Bandwidth units
                	**type**\:  :py:class:`BandwidthUnitEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.BandwidthUnitEnum>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface, self).__init__()

                    self.yang_name = "link-interface"
                    self.yang_parent_name = "link-interfaces"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('is_role_standby', (YLeaf(YType.boolean, 'is-role-standby'), ['bool'])),
                        ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                        ('total_p2mp_tunnels', (YLeaf(YType.uint32, 'total-p2mp-tunnels'), ['int'])),
                        ('selected_tunnels', (YLeaf(YType.uint32, 'selected-tunnels'), ['int'])),
                        ('bandwidth_units', (YLeaf(YType.enumeration, 'bandwidth-units'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'BandwidthUnitEnum', '')])),
                    ])
                    self.interface_name = None
                    self.is_role_standby = None
                    self.total_tunnels = None
                    self.total_p2mp_tunnels = None
                    self.selected_tunnels = None
                    self.bandwidth_units = None
                    self._segment_path = lambda: "link-interface" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/admission-control/link-interfaces/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface, ['interface_name', 'is_role_standby', 'total_tunnels', 'total_p2mp_tunnels', 'selected_tunnels', 'bandwidth_units'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.AdmissionControl.LinkInterfaces.LinkInterface']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.AdmissionControl.LinkInterfaces']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.AdmissionControl']['meta_info']


    class SoftPreemptionGlobalInfo(_Entity_):
        """
        The global soft\-preemption information
        
        .. attribute:: is_configured
        
        	Is global soft\-preemption configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: is_timeout_interval_configured
        
        	Is global soft\-preemption timeout interval configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: timeout_interval
        
        	Global soft\-preemption timeout interval
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.SoftPreemptionGlobalInfo, self).__init__()

            self.yang_name = "soft-preemption-global-info"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                ('is_timeout_interval_configured', (YLeaf(YType.boolean, 'is-timeout-interval-configured'), ['bool'])),
                ('timeout_interval', (YLeaf(YType.uint32, 'timeout-interval'), ['int'])),
            ])
            self.is_configured = None
            self.is_timeout_interval_configured = None
            self.timeout_interval = None
            self._segment_path = lambda: "soft-preemption-global-info"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.SoftPreemptionGlobalInfo, ['is_configured', 'is_timeout_interval_configured', 'timeout_interval'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.SoftPreemptionGlobalInfo']['meta_info']


    class SoftPreemptions(_Entity_):
        """
        The soft preemption information for the TE\-links
        
        .. attribute:: soft_preemption
        
        	The soft preemption info for a TE\-link
        	**type**\: list of  		 :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions.SoftPreemption>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsLcac.SoftPreemptions, self).__init__()

            self.yang_name = "soft-preemptions"
            self.yang_parent_name = "mpls-lcac"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("soft-preemption", ("soft_preemption", MplsLcac.SoftPreemptions.SoftPreemption))])
            self._leafs = OrderedDict()

            self.soft_preemption = YList(self)
            self._segment_path = lambda: "soft-preemptions"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsLcac.SoftPreemptions, [], name, value)


        class SoftPreemption(_Entity_):
            """
            The soft preemption info for a TE\-link
            
            .. attribute:: interface_name  (key)
            
            	Interface name
            	**type**\: str
            
            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
            
            	**config**\: False
            
            .. attribute:: link_address
            
            	The link's IPv4 address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: total_soft_preempted_bandwidth_bc0
            
            	The total BC0 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_soft_preempted_bandwidth_bc1
            
            	The total BC1 BW that is softly preempted\: this is the sum of bandwidth for all the LSPs that were soft preempted
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preempted_bandwidth_bc0
            
            	The current BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preempted_bandwidth_bc1
            
            	The current BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and have not been torn down yet
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: release_soft_preempted_bandwidth_bc0
            
            	The total released BC0 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: release_soft_preempted_bandwidth_bc1
            
            	The total released BC1 BW that is softly preempted\: this is the sum of bandwidth for the LSPs that are soft preempted and are torn down
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_over_subscribed_bandwidth_bc0
            
            	The BC0 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC0 BW on the link and the sum of the currently reserved BC0 bandwidth and the currently soft preempted BC0 BW
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_over_subscribed_bandwidth_bc1
            
            	The BC1 bandwidth that is over subscribed on this link\: this is the difference between the maximum available BC1 BW on the link and the sum of the currently reserved BC1 bandwidth and the currently soft preempted BC1 BW
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: current_soft_preemption_lsp
            
            	List of the soft preempted LSPs that are not yet cleaned up
            	**type**\: list of  		 :py:class:`CurrentSoftPreemptionLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsLcac.SoftPreemptions.SoftPreemption, self).__init__()

                self.yang_name = "soft-preemption"
                self.yang_parent_name = "soft-preemptions"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['interface_name']
                self._child_classes = OrderedDict([("current-soft-preemption-lsp", ("current_soft_preemption_lsp", MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp))])
                self._leafs = OrderedDict([
                    ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                    ('total_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'total-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('total_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'total-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('current_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'current-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('current_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'current-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('release_soft_preempted_bandwidth_bc0', (YLeaf(YType.uint64, 'release-soft-preempted-bandwidth-bc0'), ['int'])),
                    ('release_soft_preempted_bandwidth_bc1', (YLeaf(YType.uint64, 'release-soft-preempted-bandwidth-bc1'), ['int'])),
                    ('current_over_subscribed_bandwidth_bc0', (YLeaf(YType.uint64, 'current-over-subscribed-bandwidth-bc0'), ['int'])),
                    ('current_over_subscribed_bandwidth_bc1', (YLeaf(YType.uint64, 'current-over-subscribed-bandwidth-bc1'), ['int'])),
                ])
                self.interface_name = None
                self.link_address = None
                self.total_soft_preempted_bandwidth_bc0 = None
                self.total_soft_preempted_bandwidth_bc1 = None
                self.current_soft_preempted_bandwidth_bc0 = None
                self.current_soft_preempted_bandwidth_bc1 = None
                self.release_soft_preempted_bandwidth_bc0 = None
                self.release_soft_preempted_bandwidth_bc1 = None
                self.current_over_subscribed_bandwidth_bc0 = None
                self.current_over_subscribed_bandwidth_bc1 = None

                self.current_soft_preemption_lsp = YList(self)
                self._segment_path = lambda: "soft-preemption" + "[interface-name='" + str(self.interface_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-lcac/soft-preemptions/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsLcac.SoftPreemptions.SoftPreemption, ['interface_name', 'link_address', 'total_soft_preempted_bandwidth_bc0', 'total_soft_preempted_bandwidth_bc1', 'current_soft_preempted_bandwidth_bc0', 'current_soft_preempted_bandwidth_bc1', 'release_soft_preempted_bandwidth_bc0', 'release_soft_preempted_bandwidth_bc1', 'current_over_subscribed_bandwidth_bc0', 'current_over_subscribed_bandwidth_bc1'], name, value)


            class CurrentSoftPreemptionLsp(_Entity_):
                """
                List of the soft preempted LSPs that are not yet
                cleaned up
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type; 0\:BC0, 1\:BC1, so on
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: soft_preempted
                
                	TRUE is the preemption is a soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preemption_timeout
                
                	If the soft preemption is underway, this value indicates the number of seconds before hard preemption is triggered
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_preempted
                
                	LSPs bandwidth is already preempted
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: soft_preempted_fr_rrewrite
                
                	FRR\-rewrite is done during soft preemption
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, self).__init__()

                    self.yang_name = "current-soft-preemption-lsp"
                    self.yang_parent_name = "soft-preemption"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint8, 'bandwidth-type'), ['int'])),
                        ('soft_preempted', (YLeaf(YType.boolean, 'soft-preempted'), ['bool'])),
                        ('soft_preemption_timeout', (YLeaf(YType.uint16, 'soft-preemption-timeout'), ['int'])),
                        ('bandwidth_preempted', (YLeaf(YType.boolean, 'bandwidth-preempted'), ['bool'])),
                        ('soft_preempted_fr_rrewrite', (YLeaf(YType.boolean, 'soft-preempted-fr-rrewrite'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.requested_bandwidth = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth_type = None
                    self.soft_preempted = None
                    self.soft_preemption_timeout = None
                    self.bandwidth_preempted = None
                    self.soft_preempted_fr_rrewrite = None
                    self._segment_path = lambda: "current-soft-preemption-lsp"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp, ['tunnel_id', 'lsp_id', 'source_address', 'destination_address', 'requested_bandwidth', 'setup_priority', 'hold_priority', 'bandwidth_type', 'soft_preempted', 'soft_preemption_timeout', 'bandwidth_preempted', 'soft_preempted_fr_rrewrite'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsLcac.SoftPreemptions.SoftPreemption.CurrentSoftPreemptionLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsLcac.SoftPreemptions.SoftPreemption']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsLcac.SoftPreemptions']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsLcac()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsLcac']['meta_info']


class MplsPce(_Entity_):
    """
    mpls pce
    
    .. attribute:: lsps
    
    	Table of LSPs
    	**type**\:  :py:class:`Lsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps>`
    
    	**config**\: False
    
    .. attribute:: statistics
    
    	PCE stats info
    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics>`
    
    	**config**\: False
    
    .. attribute:: peers
    
    	The set of PCE peers
    	**type**\:  :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers>`
    
    	**config**\: False
    
    .. attribute:: topology
    
    	The topology information in PCE
    	**type**\:  :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology>`
    
    	**config**\: False
    
    .. attribute:: tunnels
    
    	Table of PCE tunnels
    	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Tunnels>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsPce, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-pce"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("lsps", ("lsps", MplsPce.Lsps)), ("statistics", ("statistics", MplsPce.Statistics)), ("peers", ("peers", MplsPce.Peers)), ("topology", ("topology", MplsPce.Topology)), ("tunnels", ("tunnels", MplsPce.Tunnels))])
        self._leafs = OrderedDict()

        self.lsps = MplsPce.Lsps()
        self.lsps.parent = self
        self._children_name_map["lsps"] = "lsps"

        self.statistics = MplsPce.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"

        self.peers = MplsPce.Peers()
        self.peers.parent = self
        self._children_name_map["peers"] = "peers"

        self.topology = MplsPce.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"

        self.tunnels = MplsPce.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsPce, [], name, value)


    class Lsps(_Entity_):
        """
        Table of LSPs
        
        .. attribute:: lsp
        
        	Information of a LSP from LSPDB
        	**type**\: list of  		 :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp>`
        
        	**config**\: False
        
        .. attribute:: creator
        
        	Creator Peer of the LSP
        	**type**\:  :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Creator>`
        
        	**config**\: False
        
        .. attribute:: delegated
        
        	Owner Peer of the LSP
        	**type**\:  :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Delegated>`
        
        	**config**\: False
        
        .. attribute:: identifiers
        
        	LSP Identifiers
        	**type**\:  :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Identifiers>`
        
        	**config**\: False
        
        .. attribute:: autoroute
        
        	Auto Route
        	**type**\:  :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Autoroute>`
        
        	**config**\: False
        
        .. attribute:: source_address
        
        	Source IP Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: destination_address
        
        	Destination IP Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: symbolic_name_xr
        
        	Symbolic Name
        	**type**\: str
        
        	**config**\: False
        
        .. attribute:: session_internal_lsp_id
        
        	Session internal ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: stateful_request_parameter_id
        
        	SRP ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: request_queue_size
        
        	Request queue size
        	**type**\: int
        
        	**range:** 0..255
        
        	**config**\: False
        
        .. attribute:: delegatable
        
        	LSP delegatable
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: operational
        
        	LSP operational status
        	**type**\:  :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
        
        	**config**\: False
        
        .. attribute:: administrative
        
        	LSP administrative status
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: cleanup_timer_exp
        
        	Deprecated
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: delegation_timer_exp
        
        	LSP delegation timer expiration in sec
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: create
        
        	LSPO create flag
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: state_timer_exp
        
        	LSP state\-timeout time expiration
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: lspo_is_used
        
        	LSP Object used flag
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: forward_class_id
        
        	Forward Class ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: load_share
        
        	Load share factor
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: path_setup_type
        
        	Path setup type
        	**type**\: int
        
        	**range:** 0..255
        
        	**config**\: False
        
        .. attribute:: binding_sid
        
        	Binding SID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: backup_path
        
        	Backup Path
        	**type**\: list of  		 :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.BackupPath>`
        
        	**config**\: False
        
        .. attribute:: paths
        
        	Array of paths
        	**type**\: list of  		 :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPce.Lsps, self).__init__()

            self.yang_name = "lsps"
            self.yang_parent_name = "mpls-pce"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("lsp", ("lsp", MplsPce.Lsps.Lsp)), ("creator", ("creator", MplsPce.Lsps.Creator)), ("delegated", ("delegated", MplsPce.Lsps.Delegated)), ("identifiers", ("identifiers", MplsPce.Lsps.Identifiers)), ("autoroute", ("autoroute", MplsPce.Lsps.Autoroute)), ("backup-path", ("backup_path", MplsPce.Lsps.BackupPath)), ("paths", ("paths", MplsPce.Lsps.Paths))])
            self._leafs = OrderedDict([
                ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                ('symbolic_name_xr', (YLeaf(YType.str, 'symbolic-name-xr'), ['str'])),
                ('session_internal_lsp_id', (YLeaf(YType.uint32, 'session-internal-lsp-id'), ['int'])),
                ('stateful_request_parameter_id', (YLeaf(YType.uint32, 'stateful-request-parameter-id'), ['int'])),
                ('request_queue_size', (YLeaf(YType.uint8, 'request-queue-size'), ['int'])),
                ('delegatable', (YLeaf(YType.boolean, 'delegatable'), ['bool'])),
                ('operational', (YLeaf(YType.enumeration, 'operational'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspOperState', '')])),
                ('administrative', (YLeaf(YType.boolean, 'administrative'), ['bool'])),
                ('cleanup_timer_exp', (YLeaf(YType.int32, 'cleanup-timer-exp'), ['int'])),
                ('delegation_timer_exp', (YLeaf(YType.int32, 'delegation-timer-exp'), ['int'])),
                ('create', (YLeaf(YType.boolean, 'create'), ['bool'])),
                ('state_timer_exp', (YLeaf(YType.int32, 'state-timer-exp'), ['int'])),
                ('lspo_is_used', (YLeaf(YType.boolean, 'lspo-is-used'), ['bool'])),
                ('forward_class_id', (YLeaf(YType.uint32, 'forward-class-id'), ['int'])),
                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                ('path_setup_type', (YLeaf(YType.uint8, 'path-setup-type'), ['int'])),
                ('binding_sid', (YLeaf(YType.uint32, 'binding-sid'), ['int'])),
            ])
            self.source_address = None
            self.destination_address = None
            self.symbolic_name_xr = None
            self.session_internal_lsp_id = None
            self.stateful_request_parameter_id = None
            self.request_queue_size = None
            self.delegatable = None
            self.operational = None
            self.administrative = None
            self.cleanup_timer_exp = None
            self.delegation_timer_exp = None
            self.create = None
            self.state_timer_exp = None
            self.lspo_is_used = None
            self.forward_class_id = None
            self.load_share = None
            self.path_setup_type = None
            self.binding_sid = None

            self.creator = MplsPce.Lsps.Creator()
            self.creator.parent = self
            self._children_name_map["creator"] = "creator"

            self.delegated = MplsPce.Lsps.Delegated()
            self.delegated.parent = self
            self._children_name_map["delegated"] = "delegated"

            self.identifiers = MplsPce.Lsps.Identifiers()
            self.identifiers.parent = self
            self._children_name_map["identifiers"] = "identifiers"

            self.autoroute = MplsPce.Lsps.Autoroute()
            self.autoroute.parent = self
            self._children_name_map["autoroute"] = "autoroute"

            self.lsp = YList(self)
            self.backup_path = YList(self)
            self.paths = YList(self)
            self._segment_path = lambda: "lsps"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPce.Lsps, ['source_address', 'destination_address', 'symbolic_name_xr', 'session_internal_lsp_id', 'stateful_request_parameter_id', 'request_queue_size', 'delegatable', 'operational', 'administrative', 'cleanup_timer_exp', 'delegation_timer_exp', 'create', 'state_timer_exp', 'lspo_is_used', 'forward_class_id', 'load_share', 'path_setup_type', 'binding_sid'], name, value)


        class Lsp(_Entity_):
            """
            Information of a LSP from LSPDB
            
            .. attribute:: symbolic_name  (key)
            
            	Symbolic name
            	**type**\: str
            
            	**length:** 1..256
            
            	**config**\: False
            
            .. attribute:: creator
            
            	Creator Peer of the LSP
            	**type**\:  :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Creator>`
            
            	**config**\: False
            
            .. attribute:: delegated
            
            	Owner Peer of the LSP
            	**type**\:  :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Delegated>`
            
            	**config**\: False
            
            .. attribute:: identifiers
            
            	LSP Identifiers
            	**type**\:  :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Identifiers>`
            
            	**config**\: False
            
            .. attribute:: autoroute
            
            	Auto Route
            	**type**\:  :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Autoroute>`
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source IP Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination IP Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: symbolic_name_xr
            
            	Symbolic Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: session_internal_lsp_id
            
            	Session internal ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: stateful_request_parameter_id
            
            	SRP ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: request_queue_size
            
            	Request queue size
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: delegatable
            
            	LSP delegatable
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: operational
            
            	LSP operational status
            	**type**\:  :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
            
            	**config**\: False
            
            .. attribute:: administrative
            
            	LSP administrative status
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: cleanup_timer_exp
            
            	Deprecated
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: delegation_timer_exp
            
            	LSP delegation timer expiration in sec
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: create
            
            	LSPO create flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: state_timer_exp
            
            	LSP state\-timeout time expiration
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: lspo_is_used
            
            	LSP Object used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: forward_class_id
            
            	Forward Class ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: load_share
            
            	Load share factor
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_setup_type
            
            	Path setup type
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: binding_sid
            
            	Binding SID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backup_path
            
            	Backup Path
            	**type**\: list of  		 :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.BackupPath>`
            
            	**config**\: False
            
            .. attribute:: paths
            
            	Array of paths
            	**type**\: list of  		 :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Lsp, self).__init__()

                self.yang_name = "lsp"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['symbolic_name']
                self._child_classes = OrderedDict([("creator", ("creator", MplsPce.Lsps.Lsp.Creator)), ("delegated", ("delegated", MplsPce.Lsps.Lsp.Delegated)), ("identifiers", ("identifiers", MplsPce.Lsps.Lsp.Identifiers)), ("autoroute", ("autoroute", MplsPce.Lsps.Lsp.Autoroute)), ("backup-path", ("backup_path", MplsPce.Lsps.Lsp.BackupPath)), ("paths", ("paths", MplsPce.Lsps.Lsp.Paths))])
                self._leafs = OrderedDict([
                    ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('symbolic_name_xr', (YLeaf(YType.str, 'symbolic-name-xr'), ['str'])),
                    ('session_internal_lsp_id', (YLeaf(YType.uint32, 'session-internal-lsp-id'), ['int'])),
                    ('stateful_request_parameter_id', (YLeaf(YType.uint32, 'stateful-request-parameter-id'), ['int'])),
                    ('request_queue_size', (YLeaf(YType.uint8, 'request-queue-size'), ['int'])),
                    ('delegatable', (YLeaf(YType.boolean, 'delegatable'), ['bool'])),
                    ('operational', (YLeaf(YType.enumeration, 'operational'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspOperState', '')])),
                    ('administrative', (YLeaf(YType.boolean, 'administrative'), ['bool'])),
                    ('cleanup_timer_exp', (YLeaf(YType.int32, 'cleanup-timer-exp'), ['int'])),
                    ('delegation_timer_exp', (YLeaf(YType.int32, 'delegation-timer-exp'), ['int'])),
                    ('create', (YLeaf(YType.boolean, 'create'), ['bool'])),
                    ('state_timer_exp', (YLeaf(YType.int32, 'state-timer-exp'), ['int'])),
                    ('lspo_is_used', (YLeaf(YType.boolean, 'lspo-is-used'), ['bool'])),
                    ('forward_class_id', (YLeaf(YType.uint32, 'forward-class-id'), ['int'])),
                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                    ('path_setup_type', (YLeaf(YType.uint8, 'path-setup-type'), ['int'])),
                    ('binding_sid', (YLeaf(YType.uint32, 'binding-sid'), ['int'])),
                ])
                self.symbolic_name = None
                self.source_address = None
                self.destination_address = None
                self.symbolic_name_xr = None
                self.session_internal_lsp_id = None
                self.stateful_request_parameter_id = None
                self.request_queue_size = None
                self.delegatable = None
                self.operational = None
                self.administrative = None
                self.cleanup_timer_exp = None
                self.delegation_timer_exp = None
                self.create = None
                self.state_timer_exp = None
                self.lspo_is_used = None
                self.forward_class_id = None
                self.load_share = None
                self.path_setup_type = None
                self.binding_sid = None

                self.creator = MplsPce.Lsps.Lsp.Creator()
                self.creator.parent = self
                self._children_name_map["creator"] = "creator"

                self.delegated = MplsPce.Lsps.Lsp.Delegated()
                self.delegated.parent = self
                self._children_name_map["delegated"] = "delegated"

                self.identifiers = MplsPce.Lsps.Lsp.Identifiers()
                self.identifiers.parent = self
                self._children_name_map["identifiers"] = "identifiers"

                self.autoroute = MplsPce.Lsps.Lsp.Autoroute()
                self.autoroute.parent = self
                self._children_name_map["autoroute"] = "autoroute"

                self.backup_path = YList(self)
                self.paths = YList(self)
                self._segment_path = lambda: "lsp" + "[symbolic-name='" + str(self.symbolic_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Lsp, ['symbolic_name', 'source_address', 'destination_address', 'symbolic_name_xr', 'session_internal_lsp_id', 'stateful_request_parameter_id', 'request_queue_size', 'delegatable', 'operational', 'administrative', 'cleanup_timer_exp', 'delegation_timer_exp', 'create', 'state_timer_exp', 'lspo_is_used', 'forward_class_id', 'load_share', 'path_setup_type', 'binding_sid'], name, value)


            class Creator(_Entity_):
                """
                Creator Peer of the LSP
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.Creator, self).__init__()

                    self.yang_name = "creator"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                    ])
                    self.node_identifier = None
                    self.address = None
                    self._segment_path = lambda: "creator"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.Creator, ['node_identifier', 'address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.Creator']['meta_info']


            class Delegated(_Entity_):
                """
                Owner Peer of the LSP
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.Delegated, self).__init__()

                    self.yang_name = "delegated"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                    ])
                    self.node_identifier = None
                    self.address = None
                    self._segment_path = lambda: "delegated"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.Delegated, ['node_identifier', 'address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.Delegated']['meta_info']


            class Identifiers(_Entity_):
                """
                LSP Identifiers
                
                .. attribute:: is_used
                
                	LSP Identifier used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: sender
                
                	Sender Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: te_lsp_id
                
                	TE LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	LSPO Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: ext_tunnel_id
                
                	External Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.Identifiers, self).__init__()

                    self.yang_name = "identifiers"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('sender', (YLeaf(YType.str, 'sender'), ['str'])),
                        ('te_lsp_id', (YLeaf(YType.uint16, 'te-lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('ext_tunnel_id', (YLeaf(YType.uint32, 'ext-tunnel-id'), ['int'])),
                    ])
                    self.is_used = None
                    self.sender = None
                    self.te_lsp_id = None
                    self.tunnel_id = None
                    self.ext_tunnel_id = None
                    self._segment_path = lambda: "identifiers"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.Identifiers, ['is_used', 'sender', 'te_lsp_id', 'tunnel_id', 'ext_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.Identifiers']['meta_info']


            class Autoroute(_Entity_):
                """
                Auto Route
                
                .. attribute:: is_used
                
                	Autoroute used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: announced
                
                	Autoroute announced
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:  :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
                
                	**config**\: False
                
                .. attribute:: metric
                
                	Metric Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Autoroute.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.Autoroute, self).__init__()

                    self.yang_name = "autoroute"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("destination", ("destination", MplsPce.Lsps.Lsp.Autoroute.Destination))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('announced', (YLeaf(YType.boolean, 'announced'), ['bool'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspAutorouteMetric', '')])),
                        ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                    ])
                    self.is_used = None
                    self.announced = None
                    self.metric_type = None
                    self.metric = None

                    self.destination = YList(self)
                    self._segment_path = lambda: "autoroute"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.Autoroute, ['is_used', 'announced', 'metric_type', 'metric'], name, value)


                class Destination(_Entity_):
                    """
                    Destinations
                    
                    .. attribute:: entry
                    
                    	Destinations
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Lsp.Autoroute.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "autoroute"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Lsp.Autoroute.Destination, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Lsp.Autoroute.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.Autoroute']['meta_info']


            class BackupPath(_Entity_):
                """
                Backup Path
                
                .. attribute:: entry
                
                	Backup Path
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.BackupPath, self).__init__()

                    self.yang_name = "backup-path"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "backup-path"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.BackupPath, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.BackupPath']['meta_info']


            class Paths(_Entity_):
                """
                Array of paths
                
                .. attribute:: ero
                
                	Explicit Router Object
                	**type**\:  :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Ero>`
                
                	**config**\: False
                
                .. attribute:: lspa
                
                	LSP Attributes Object
                	**type**\:  :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Lspa>`
                
                	**config**\: False
                
                .. attribute:: rro
                
                	Reported Route Object
                	**type**\:  :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Rro>`
                
                	**config**\: False
                
                .. attribute:: bw
                
                	Bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_bw_used
                
                	Bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reopt_bw
                
                	Reoptimize bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_reopt_bw_used
                
                	Reoptimize bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: applied_bw
                
                	Applied bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_applied_bw_used
                
                	Applied bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: metric
                
                	List of Metrics
                	**type**\: list of  		 :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Metric>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Lsp.Paths, self).__init__()

                    self.yang_name = "paths"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("ero", ("ero", MplsPce.Lsps.Lsp.Paths.Ero)), ("lspa", ("lspa", MplsPce.Lsps.Lsp.Paths.Lspa)), ("rro", ("rro", MplsPce.Lsps.Lsp.Paths.Rro)), ("metric", ("metric", MplsPce.Lsps.Lsp.Paths.Metric))])
                    self._leafs = OrderedDict([
                        ('bw', (YLeaf(YType.uint32, 'bw'), ['int'])),
                        ('is_bw_used', (YLeaf(YType.boolean, 'is-bw-used'), ['bool'])),
                        ('reopt_bw', (YLeaf(YType.uint32, 'reopt-bw'), ['int'])),
                        ('is_reopt_bw_used', (YLeaf(YType.boolean, 'is-reopt-bw-used'), ['bool'])),
                        ('applied_bw', (YLeaf(YType.uint32, 'applied-bw'), ['int'])),
                        ('is_applied_bw_used', (YLeaf(YType.boolean, 'is-applied-bw-used'), ['bool'])),
                    ])
                    self.bw = None
                    self.is_bw_used = None
                    self.reopt_bw = None
                    self.is_reopt_bw_used = None
                    self.applied_bw = None
                    self.is_applied_bw_used = None

                    self.ero = MplsPce.Lsps.Lsp.Paths.Ero()
                    self.ero.parent = self
                    self._children_name_map["ero"] = "ero"

                    self.lspa = MplsPce.Lsps.Lsp.Paths.Lspa()
                    self.lspa.parent = self
                    self._children_name_map["lspa"] = "lspa"

                    self.rro = MplsPce.Lsps.Lsp.Paths.Rro()
                    self.rro.parent = self
                    self._children_name_map["rro"] = "rro"

                    self.metric = YList(self)
                    self._segment_path = lambda: "paths"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Lsp.Paths, ['bw', 'is_bw_used', 'reopt_bw', 'is_reopt_bw_used', 'applied_bw', 'is_applied_bw_used'], name, value)


                class Ero(_Entity_):
                    """
                    Explicit Router Object
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Ero.Address>`
                    
                    	**config**\: False
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Ero.Subobject>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Lsp.Paths.Ero, self).__init__()

                        self.yang_name = "ero"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("address", ("address", MplsPce.Lsps.Lsp.Paths.Ero.Address)), ("subobject", ("subobject", MplsPce.Lsps.Lsp.Paths.Ero.Subobject))])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.is_used = None
                        self.cost = None

                        self.address = YList(self)
                        self.subobject = YList(self)
                        self._segment_path = lambda: "ero"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Ero, ['is_used', 'cost'], name, value)


                    class Address(_Entity_):
                        """
                        List of Addresses
                        
                        .. attribute:: entry
                        
                        	List of Addresses
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPce.Lsps.Lsp.Paths.Ero.Address, self).__init__()

                            self.yang_name = "address"
                            self.yang_parent_name = "ero"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "address"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Ero.Address, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Ero.Address']['meta_info']


                    class Subobject(_Entity_):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPce.Lsps.Lsp.Paths.Ero.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "ero"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                                ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                                ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                                ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                                ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                                ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                                ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                                ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                                ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                                ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                                ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                                ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                                ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                                ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                            ])
                            self.subobj_type = None
                            self.ipv4_address = None
                            self.ipv4_prefix_len = None
                            self.strict = None
                            self.global_ = None
                            self.mpls_label = None
                            self.segment_id_type = None
                            self.only_valid_mpls_label = None
                            self.complete_mpls_label_entry = None
                            self.missing_segment_id = None
                            self.missing_node_adjcency_id = None
                            self.segment_id_exists = None
                            self.segment_id_value = None
                            self.node_adjacency_id_exists = None
                            self.node_id = None
                            self.local_address = None
                            self.remote_address = None
                            self._segment_path = lambda: "subobject"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Ero.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Ero.Subobject']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Ero']['meta_info']


                class Lspa(_Entity_):
                    """
                    LSP Attributes Object
                    
                    .. attribute:: is_used
                    
                    	LSPA used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: exlude_any
                    
                    	Exclude Any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: include_any
                    
                    	Include Any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: include_all
                    
                    	Include All
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup
                    
                    	Setup
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold
                    
                    	Hold
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lbit
                    
                    	L flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Lsp.Paths.Lspa, self).__init__()

                        self.yang_name = "lspa"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('exlude_any', (YLeaf(YType.uint32, 'exlude-any'), ['int'])),
                            ('include_any', (YLeaf(YType.uint32, 'include-any'), ['int'])),
                            ('include_all', (YLeaf(YType.uint32, 'include-all'), ['int'])),
                            ('setup', (YLeaf(YType.uint8, 'setup'), ['int'])),
                            ('hold', (YLeaf(YType.uint8, 'hold'), ['int'])),
                            ('lbit', (YLeaf(YType.boolean, 'lbit'), ['bool'])),
                        ])
                        self.is_used = None
                        self.exlude_any = None
                        self.include_any = None
                        self.include_all = None
                        self.setup = None
                        self.hold = None
                        self.lbit = None
                        self._segment_path = lambda: "lspa"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Lspa, ['is_used', 'exlude_any', 'include_any', 'include_all', 'setup', 'hold', 'lbit'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Lspa']['meta_info']


                class Rro(_Entity_):
                    """
                    Reported Route Object
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Rro.Address>`
                    
                    	**config**\: False
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Lsp.Paths.Rro.Subobject>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Lsp.Paths.Rro, self).__init__()

                        self.yang_name = "rro"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("address", ("address", MplsPce.Lsps.Lsp.Paths.Rro.Address)), ("subobject", ("subobject", MplsPce.Lsps.Lsp.Paths.Rro.Subobject))])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.is_used = None
                        self.cost = None

                        self.address = YList(self)
                        self.subobject = YList(self)
                        self._segment_path = lambda: "rro"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Rro, ['is_used', 'cost'], name, value)


                    class Address(_Entity_):
                        """
                        List of Addresses
                        
                        .. attribute:: entry
                        
                        	List of Addresses
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPce.Lsps.Lsp.Paths.Rro.Address, self).__init__()

                            self.yang_name = "address"
                            self.yang_parent_name = "rro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "address"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Rro.Address, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Rro.Address']['meta_info']


                    class Subobject(_Entity_):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPce.Lsps.Lsp.Paths.Rro.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "rro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                                ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                                ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                                ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                                ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                                ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                                ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                                ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                                ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                                ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                                ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                                ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                                ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                                ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                            ])
                            self.subobj_type = None
                            self.ipv4_address = None
                            self.ipv4_prefix_len = None
                            self.strict = None
                            self.global_ = None
                            self.mpls_label = None
                            self.segment_id_type = None
                            self.only_valid_mpls_label = None
                            self.complete_mpls_label_entry = None
                            self.missing_segment_id = None
                            self.missing_node_adjcency_id = None
                            self.segment_id_exists = None
                            self.segment_id_value = None
                            self.node_adjacency_id_exists = None
                            self.node_id = None
                            self.local_address = None
                            self.remote_address = None
                            self._segment_path = lambda: "subobject"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Rro.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Rro.Subobject']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Rro']['meta_info']


                class Metric(_Entity_):
                    """
                    List of Metrics
                    
                    .. attribute:: type
                    
                    	Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Lsp.Paths.Metric, self).__init__()

                        self.yang_name = "metric"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.type = None
                        self.cost = None
                        self._segment_path = lambda: "metric"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Lsp.Paths.Metric, ['type', 'cost'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Lsp.Paths.Metric']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Lsp.Paths']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Lsp']['meta_info']


        class Creator(_Entity_):
            """
            Creator Peer of the LSP
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Creator, self).__init__()

                self.yang_name = "creator"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                    ('address', (YLeaf(YType.str, 'address'), ['str'])),
                ])
                self.node_identifier = None
                self.address = None
                self._segment_path = lambda: "creator"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Creator, ['node_identifier', 'address'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Creator']['meta_info']


        class Delegated(_Entity_):
            """
            Owner Peer of the LSP
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Delegated, self).__init__()

                self.yang_name = "delegated"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                    ('address', (YLeaf(YType.str, 'address'), ['str'])),
                ])
                self.node_identifier = None
                self.address = None
                self._segment_path = lambda: "delegated"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Delegated, ['node_identifier', 'address'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Delegated']['meta_info']


        class Identifiers(_Entity_):
            """
            LSP Identifiers
            
            .. attribute:: is_used
            
            	LSP Identifier used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: sender
            
            	Sender Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: te_lsp_id
            
            	TE LSP ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_id
            
            	LSPO Tunnel ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: ext_tunnel_id
            
            	External Tunnel ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Identifiers, self).__init__()

                self.yang_name = "identifiers"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                    ('sender', (YLeaf(YType.str, 'sender'), ['str'])),
                    ('te_lsp_id', (YLeaf(YType.uint16, 'te-lsp-id'), ['int'])),
                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                    ('ext_tunnel_id', (YLeaf(YType.uint32, 'ext-tunnel-id'), ['int'])),
                ])
                self.is_used = None
                self.sender = None
                self.te_lsp_id = None
                self.tunnel_id = None
                self.ext_tunnel_id = None
                self._segment_path = lambda: "identifiers"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Identifiers, ['is_used', 'sender', 'te_lsp_id', 'tunnel_id', 'ext_tunnel_id'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Identifiers']['meta_info']


        class Autoroute(_Entity_):
            """
            Auto Route
            
            .. attribute:: is_used
            
            	Autoroute used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: announced
            
            	Autoroute announced
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: metric_type
            
            	Metric Type
            	**type**\:  :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
            
            	**config**\: False
            
            .. attribute:: metric
            
            	Metric Value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: destination
            
            	Destinations
            	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Autoroute.Destination>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Autoroute, self).__init__()

                self.yang_name = "autoroute"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("destination", ("destination", MplsPce.Lsps.Autoroute.Destination))])
                self._leafs = OrderedDict([
                    ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                    ('announced', (YLeaf(YType.boolean, 'announced'), ['bool'])),
                    ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspAutorouteMetric', '')])),
                    ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                ])
                self.is_used = None
                self.announced = None
                self.metric_type = None
                self.metric = None

                self.destination = YList(self)
                self._segment_path = lambda: "autoroute"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Autoroute, ['is_used', 'announced', 'metric_type', 'metric'], name, value)


            class Destination(_Entity_):
                """
                Destinations
                
                .. attribute:: entry
                
                	Destinations
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Autoroute.Destination, self).__init__()

                    self.yang_name = "destination"
                    self.yang_parent_name = "autoroute"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "destination"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/autoroute/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Autoroute.Destination, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Autoroute.Destination']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Autoroute']['meta_info']


        class BackupPath(_Entity_):
            """
            Backup Path
            
            .. attribute:: entry
            
            	Backup Path
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.BackupPath, self).__init__()

                self.yang_name = "backup-path"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                ])
                self.entry = None
                self._segment_path = lambda: "backup-path"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.BackupPath, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.BackupPath']['meta_info']


        class Paths(_Entity_):
            """
            Array of paths
            
            .. attribute:: ero
            
            	Explicit Router Object
            	**type**\:  :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Ero>`
            
            	**config**\: False
            
            .. attribute:: lspa
            
            	LSP Attributes Object
            	**type**\:  :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Lspa>`
            
            	**config**\: False
            
            .. attribute:: rro
            
            	Reported Route Object
            	**type**\:  :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Rro>`
            
            	**config**\: False
            
            .. attribute:: bw
            
            	Bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_bw_used
            
            	Bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: reopt_bw
            
            	Reoptimize bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_reopt_bw_used
            
            	Reoptimize bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: applied_bw
            
            	Applied bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_applied_bw_used
            
            	Applied bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: metric
            
            	List of Metrics
            	**type**\: list of  		 :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Metric>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Lsps.Paths, self).__init__()

                self.yang_name = "paths"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("ero", ("ero", MplsPce.Lsps.Paths.Ero)), ("lspa", ("lspa", MplsPce.Lsps.Paths.Lspa)), ("rro", ("rro", MplsPce.Lsps.Paths.Rro)), ("metric", ("metric", MplsPce.Lsps.Paths.Metric))])
                self._leafs = OrderedDict([
                    ('bw', (YLeaf(YType.uint32, 'bw'), ['int'])),
                    ('is_bw_used', (YLeaf(YType.boolean, 'is-bw-used'), ['bool'])),
                    ('reopt_bw', (YLeaf(YType.uint32, 'reopt-bw'), ['int'])),
                    ('is_reopt_bw_used', (YLeaf(YType.boolean, 'is-reopt-bw-used'), ['bool'])),
                    ('applied_bw', (YLeaf(YType.uint32, 'applied-bw'), ['int'])),
                    ('is_applied_bw_used', (YLeaf(YType.boolean, 'is-applied-bw-used'), ['bool'])),
                ])
                self.bw = None
                self.is_bw_used = None
                self.reopt_bw = None
                self.is_reopt_bw_used = None
                self.applied_bw = None
                self.is_applied_bw_used = None

                self.ero = MplsPce.Lsps.Paths.Ero()
                self.ero.parent = self
                self._children_name_map["ero"] = "ero"

                self.lspa = MplsPce.Lsps.Paths.Lspa()
                self.lspa.parent = self
                self._children_name_map["lspa"] = "lspa"

                self.rro = MplsPce.Lsps.Paths.Rro()
                self.rro.parent = self
                self._children_name_map["rro"] = "rro"

                self.metric = YList(self)
                self._segment_path = lambda: "paths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Lsps.Paths, ['bw', 'is_bw_used', 'reopt_bw', 'is_reopt_bw_used', 'applied_bw', 'is_applied_bw_used'], name, value)


            class Ero(_Entity_):
                """
                Explicit Router Object
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Ero.Address>`
                
                	**config**\: False
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Ero.Subobject>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Paths.Ero, self).__init__()

                    self.yang_name = "ero"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("address", ("address", MplsPce.Lsps.Paths.Ero.Address)), ("subobject", ("subobject", MplsPce.Lsps.Paths.Ero.Subobject))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.is_used = None
                    self.cost = None

                    self.address = YList(self)
                    self.subobject = YList(self)
                    self._segment_path = lambda: "ero"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Paths.Ero, ['is_used', 'cost'], name, value)


                class Address(_Entity_):
                    """
                    List of Addresses
                    
                    .. attribute:: entry
                    
                    	List of Addresses
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Paths.Ero.Address, self).__init__()

                        self.yang_name = "address"
                        self.yang_parent_name = "ero"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "address"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/ero/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Paths.Ero.Address, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Paths.Ero.Address']['meta_info']


                class Subobject(_Entity_):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Paths.Ero.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "ero"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                            ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                            ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                            ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                            ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                            ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                            ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                            ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                            ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                            ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                            ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.subobj_type = None
                        self.ipv4_address = None
                        self.ipv4_prefix_len = None
                        self.strict = None
                        self.global_ = None
                        self.mpls_label = None
                        self.segment_id_type = None
                        self.only_valid_mpls_label = None
                        self.complete_mpls_label_entry = None
                        self.missing_segment_id = None
                        self.missing_node_adjcency_id = None
                        self.segment_id_exists = None
                        self.segment_id_value = None
                        self.node_adjacency_id_exists = None
                        self.node_id = None
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "subobject"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/ero/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Paths.Ero.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Paths.Ero.Subobject']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Paths.Ero']['meta_info']


            class Lspa(_Entity_):
                """
                LSP Attributes Object
                
                .. attribute:: is_used
                
                	LSPA used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: exlude_any
                
                	Exclude Any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: include_any
                
                	Include Any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: include_all
                
                	Include All
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup
                
                	Setup
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold
                
                	Hold
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lbit
                
                	L flag
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Paths.Lspa, self).__init__()

                    self.yang_name = "lspa"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('exlude_any', (YLeaf(YType.uint32, 'exlude-any'), ['int'])),
                        ('include_any', (YLeaf(YType.uint32, 'include-any'), ['int'])),
                        ('include_all', (YLeaf(YType.uint32, 'include-all'), ['int'])),
                        ('setup', (YLeaf(YType.uint8, 'setup'), ['int'])),
                        ('hold', (YLeaf(YType.uint8, 'hold'), ['int'])),
                        ('lbit', (YLeaf(YType.boolean, 'lbit'), ['bool'])),
                    ])
                    self.is_used = None
                    self.exlude_any = None
                    self.include_any = None
                    self.include_all = None
                    self.setup = None
                    self.hold = None
                    self.lbit = None
                    self._segment_path = lambda: "lspa"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Paths.Lspa, ['is_used', 'exlude_any', 'include_any', 'include_all', 'setup', 'hold', 'lbit'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Paths.Lspa']['meta_info']


            class Rro(_Entity_):
                """
                Reported Route Object
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Rro.Address>`
                
                	**config**\: False
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Lsps.Paths.Rro.Subobject>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Paths.Rro, self).__init__()

                    self.yang_name = "rro"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("address", ("address", MplsPce.Lsps.Paths.Rro.Address)), ("subobject", ("subobject", MplsPce.Lsps.Paths.Rro.Subobject))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.is_used = None
                    self.cost = None

                    self.address = YList(self)
                    self.subobject = YList(self)
                    self._segment_path = lambda: "rro"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Paths.Rro, ['is_used', 'cost'], name, value)


                class Address(_Entity_):
                    """
                    List of Addresses
                    
                    .. attribute:: entry
                    
                    	List of Addresses
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Paths.Rro.Address, self).__init__()

                        self.yang_name = "address"
                        self.yang_parent_name = "rro"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "address"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/rro/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Paths.Rro.Address, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Paths.Rro.Address']['meta_info']


                class Subobject(_Entity_):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPce.Lsps.Paths.Rro.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "rro"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                            ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                            ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                            ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                            ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                            ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                            ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                            ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                            ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                            ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                            ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.subobj_type = None
                        self.ipv4_address = None
                        self.ipv4_prefix_len = None
                        self.strict = None
                        self.global_ = None
                        self.mpls_label = None
                        self.segment_id_type = None
                        self.only_valid_mpls_label = None
                        self.complete_mpls_label_entry = None
                        self.missing_segment_id = None
                        self.missing_node_adjcency_id = None
                        self.segment_id_exists = None
                        self.segment_id_value = None
                        self.node_adjacency_id_exists = None
                        self.node_id = None
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "subobject"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/rro/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPce.Lsps.Paths.Rro.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPce.Lsps.Paths.Rro.Subobject']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Paths.Rro']['meta_info']


            class Metric(_Entity_):
                """
                List of Metrics
                
                .. attribute:: type
                
                	Type
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Lsps.Paths.Metric, self).__init__()

                    self.yang_name = "metric"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.type = None
                    self.cost = None
                    self._segment_path = lambda: "metric"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Lsps.Paths.Metric, ['type', 'cost'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Lsps.Paths.Metric']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Lsps.Paths']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPce.Lsps']['meta_info']


    class Statistics(_Entity_):
        """
        PCE stats info
        
        .. attribute:: igp_statistics
        
        	IGP Statistics
        	**type**\:  :py:class:`IgpStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics.IgpStatistics>`
        
        	**config**\: False
        
        .. attribute:: neighbors
        
        	Neighbor Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: tunnels
        
        	Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_total
        
        	Total number of PCEReq
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_pending
        
        	Number of pending req
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_timed_out
        
        	Number of timedout req
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_file_descriptors
        
        	Maximum number of TCP file descriptors used
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_file_descriptors
        
        	Number of TCP file descriptors currently in use
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_pceq_length
        
        	Current PCE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_teq_length
        
        	Current TE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_pceq_length
        
        	Max PCE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_teq_length
        
        	Max TE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: maximum_in_queue_depth
        
        	Max Input Queue Depth
        	**type**\: list of  		 :py:class:`MaximumInQueueDepth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics.MaximumInQueueDepth>`
        
        	**config**\: False
        
        .. attribute:: average_in_queue_depth
        
        	Average Input Queue Depth
        	**type**\: list of  		 :py:class:`AverageInQueueDepth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Statistics.AverageInQueueDepth>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPce.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-pce"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-statistics", ("igp_statistics", MplsPce.Statistics.IgpStatistics)), ("maximum-in-queue-depth", ("maximum_in_queue_depth", MplsPce.Statistics.MaximumInQueueDepth)), ("average-in-queue-depth", ("average_in_queue_depth", MplsPce.Statistics.AverageInQueueDepth))])
            self._leafs = OrderedDict([
                ('neighbors', (YLeaf(YType.uint32, 'neighbors'), ['int'])),
                ('tunnels', (YLeaf(YType.uint32, 'tunnels'), ['int'])),
                ('pce_req_total', (YLeaf(YType.uint32, 'pce-req-total'), ['int'])),
                ('pce_req_pending', (YLeaf(YType.uint32, 'pce-req-pending'), ['int'])),
                ('pce_req_timed_out', (YLeaf(YType.uint32, 'pce-req-timed-out'), ['int'])),
                ('max_file_descriptors', (YLeaf(YType.uint32, 'max-file-descriptors'), ['int'])),
                ('current_file_descriptors', (YLeaf(YType.uint32, 'current-file-descriptors'), ['int'])),
                ('current_pceq_length', (YLeaf(YType.uint32, 'current-pceq-length'), ['int'])),
                ('current_teq_length', (YLeaf(YType.uint32, 'current-teq-length'), ['int'])),
                ('max_pceq_length', (YLeaf(YType.uint32, 'max-pceq-length'), ['int'])),
                ('max_teq_length', (YLeaf(YType.uint32, 'max-teq-length'), ['int'])),
            ])
            self.neighbors = None
            self.tunnels = None
            self.pce_req_total = None
            self.pce_req_pending = None
            self.pce_req_timed_out = None
            self.max_file_descriptors = None
            self.current_file_descriptors = None
            self.current_pceq_length = None
            self.current_teq_length = None
            self.max_pceq_length = None
            self.max_teq_length = None

            self.igp_statistics = MplsPce.Statistics.IgpStatistics()
            self.igp_statistics.parent = self
            self._children_name_map["igp_statistics"] = "igp-statistics"

            self.maximum_in_queue_depth = YList(self)
            self.average_in_queue_depth = YList(self)
            self._segment_path = lambda: "statistics"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPce.Statistics, ['neighbors', 'tunnels', 'pce_req_total', 'pce_req_pending', 'pce_req_timed_out', 'max_file_descriptors', 'current_file_descriptors', 'current_pceq_length', 'current_teq_length', 'max_pceq_length', 'max_teq_length'], name, value)


        class IgpStatistics(_Entity_):
            """
            IGP Statistics
            
            .. attribute:: abr_lookup_min
            
            	ABR Lookup Min
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_max
            
            	ABR Lookup Max
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_avg
            
            	ABR Lookup Avg
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_timeout
            
            	ABR Lookup Timeout
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_complete
            
            	ABR Lookup Complete
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Statistics.IgpStatistics, self).__init__()

                self.yang_name = "igp-statistics"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('abr_lookup_min', (YLeaf(YType.uint64, 'abr-lookup-min'), ['int'])),
                    ('abr_lookup_max', (YLeaf(YType.uint64, 'abr-lookup-max'), ['int'])),
                    ('abr_lookup_avg', (YLeaf(YType.uint64, 'abr-lookup-avg'), ['int'])),
                    ('abr_lookup_timeout', (YLeaf(YType.uint64, 'abr-lookup-timeout'), ['int'])),
                    ('abr_lookup_complete', (YLeaf(YType.uint64, 'abr-lookup-complete'), ['int'])),
                ])
                self.abr_lookup_min = None
                self.abr_lookup_max = None
                self.abr_lookup_avg = None
                self.abr_lookup_timeout = None
                self.abr_lookup_complete = None
                self._segment_path = lambda: "igp-statistics"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Statistics.IgpStatistics, ['abr_lookup_min', 'abr_lookup_max', 'abr_lookup_avg', 'abr_lookup_timeout', 'abr_lookup_complete'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Statistics.IgpStatistics']['meta_info']


        class MaximumInQueueDepth(_Entity_):
            """
            Max Input Queue Depth
            
            .. attribute:: entry
            
            	Max Input Queue Depth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Statistics.MaximumInQueueDepth, self).__init__()

                self.yang_name = "maximum-in-queue-depth"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                ])
                self.entry = None
                self._segment_path = lambda: "maximum-in-queue-depth"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Statistics.MaximumInQueueDepth, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Statistics.MaximumInQueueDepth']['meta_info']


        class AverageInQueueDepth(_Entity_):
            """
            Average Input Queue Depth
            
            .. attribute:: entry
            
            	Average Input Queue Depth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Statistics.AverageInQueueDepth, self).__init__()

                self.yang_name = "average-in-queue-depth"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                ])
                self.entry = None
                self._segment_path = lambda: "average-in-queue-depth"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Statistics.AverageInQueueDepth, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Statistics.AverageInQueueDepth']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPce.Statistics']['meta_info']


    class Peers(_Entity_):
        """
        The set of PCE peers
        
        .. attribute:: peer
        
        	A PCE peer
        	**type**\: list of  		 :py:class:`Peer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPce.Peers, self).__init__()

            self.yang_name = "peers"
            self.yang_parent_name = "mpls-pce"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("peer", ("peer", MplsPce.Peers.Peer))])
            self._leafs = OrderedDict()

            self.peer = YList(self)
            self._segment_path = lambda: "peers"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPce.Peers, [], name, value)


        class Peer(_Entity_):
            """
            A PCE peer
            
            .. attribute:: peer_address  (key)
            
            	The peer address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: last_tx_pce_err
            
            	Last sent PCEErr
            	**type**\:  :py:class:`LastTxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.LastTxPceErr>`
            
            	**config**\: False
            
            .. attribute:: last_rx_pce_err
            
            	Last received PCEErr
            	**type**\:  :py:class:`LastRxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.LastRxPceErr>`
            
            	**config**\: False
            
            .. attribute:: error
            
            	Error (for display only)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: pce_state
            
            	PCE State
            	**type**\:  :py:class:`PceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceState>`
            
            	**config**\: False
            
            .. attribute:: precedence
            
            	PCE Precedence
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: stateful
            
            	Stateful
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_update
            
            	Update capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_instantiate
            
            	Instantiation capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_segment_routing
            
            	Segment Routing capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: triggered_sync_capability
            
            	Triggered Synchronization capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_db_version
            
            	DB version capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: delta_sync_capability
            
            	Delta Synchronization capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: pcep_up_time
            
            	PCEP Up Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: keepalives
            
            	Keepalive count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: candidate
            
            	Candidate
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: statically_configured
            
            	Statically Configured
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: md5_enabled
            
            	MD5 Authentication Enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: keychain_enabled
            
            	Keychain based Authentication Enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: negotiated_keepalive
            
            	Negotiated KA
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: negotated_dead_time
            
            	Negotiated DT
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_req_rx
            
            	PCEReq Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_req_tx
            
            	PCEReq Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rep_rx
            
            	PCERep Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rep_tx
            
            	PCERep Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_err_rx
            
            	PCEErr Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_err_tx
            
            	PCEErr Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_open_tx
            
            	PCEOpen Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_open_rx
            
            	PCEOpen Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rpt_rx
            
            	PCERpt Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rpt_tx
            
            	PCERpt Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_upd_rx
            
            	PCEUpd Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_upd_tx
            
            	PCEUpd Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_init_rx
            
            	PCEInit Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_init_tx
            
            	PCEInit Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_keepalive_tx
            
            	PCE Keepalive Tx
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: pce_keepalive_rx
            
            	PCE Keepalive Rx
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_min
            
            	Mininum reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_max
            
            	Maximum reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_avg
            
            	Average reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: request_timeouts
            
            	Request timeout count
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: local_sid
            
            	Local PCEP session ID
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: remote_sid
            
            	Remote PCEP session ID
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: min_keepalive_interval
            
            	Minimum keepalive interval for the peer
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: max_dead_interval
            
            	Maximum dead interval for the peer
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: ig_ps
            
            	IGPs
            	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Peers.Peer.IgPs>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Peers.Peer, self).__init__()

                self.yang_name = "peer"
                self.yang_parent_name = "peers"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['peer_address']
                self._child_classes = OrderedDict([("last-tx-pce-err", ("last_tx_pce_err", MplsPce.Peers.Peer.LastTxPceErr)), ("last-rx-pce-err", ("last_rx_pce_err", MplsPce.Peers.Peer.LastRxPceErr)), ("ig-ps", ("ig_ps", MplsPce.Peers.Peer.IgPs))])
                self._leafs = OrderedDict([
                    ('peer_address', (YLeaf(YType.str, 'peer-address'), ['str'])),
                    ('error', (YLeaf(YType.str, 'error'), ['str'])),
                    ('pce_state', (YLeaf(YType.enumeration, 'pce-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceState', '')])),
                    ('precedence', (YLeaf(YType.uint32, 'precedence'), ['int'])),
                    ('stateful', (YLeaf(YType.boolean, 'stateful'), ['bool'])),
                    ('capability_update', (YLeaf(YType.boolean, 'capability-update'), ['bool'])),
                    ('capability_instantiate', (YLeaf(YType.boolean, 'capability-instantiate'), ['bool'])),
                    ('capability_segment_routing', (YLeaf(YType.boolean, 'capability-segment-routing'), ['bool'])),
                    ('triggered_sync_capability', (YLeaf(YType.boolean, 'triggered-sync-capability'), ['bool'])),
                    ('capability_db_version', (YLeaf(YType.boolean, 'capability-db-version'), ['bool'])),
                    ('delta_sync_capability', (YLeaf(YType.boolean, 'delta-sync-capability'), ['bool'])),
                    ('pcep_up_time', (YLeaf(YType.uint32, 'pcep-up-time'), ['int'])),
                    ('keepalives', (YLeaf(YType.uint32, 'keepalives'), ['int'])),
                    ('candidate', (YLeaf(YType.boolean, 'candidate'), ['bool'])),
                    ('statically_configured', (YLeaf(YType.boolean, 'statically-configured'), ['bool'])),
                    ('md5_enabled', (YLeaf(YType.boolean, 'md5-enabled'), ['bool'])),
                    ('keychain_enabled', (YLeaf(YType.boolean, 'keychain-enabled'), ['bool'])),
                    ('negotiated_keepalive', (YLeaf(YType.uint32, 'negotiated-keepalive'), ['int'])),
                    ('negotated_dead_time', (YLeaf(YType.uint32, 'negotated-dead-time'), ['int'])),
                    ('pce_req_rx', (YLeaf(YType.uint32, 'pce-req-rx'), ['int'])),
                    ('pce_req_tx', (YLeaf(YType.uint32, 'pce-req-tx'), ['int'])),
                    ('pce_rep_rx', (YLeaf(YType.uint32, 'pce-rep-rx'), ['int'])),
                    ('pce_rep_tx', (YLeaf(YType.uint32, 'pce-rep-tx'), ['int'])),
                    ('pce_err_rx', (YLeaf(YType.uint32, 'pce-err-rx'), ['int'])),
                    ('pce_err_tx', (YLeaf(YType.uint32, 'pce-err-tx'), ['int'])),
                    ('pce_open_tx', (YLeaf(YType.uint32, 'pce-open-tx'), ['int'])),
                    ('pce_open_rx', (YLeaf(YType.uint32, 'pce-open-rx'), ['int'])),
                    ('pce_rpt_rx', (YLeaf(YType.uint32, 'pce-rpt-rx'), ['int'])),
                    ('pce_rpt_tx', (YLeaf(YType.uint32, 'pce-rpt-tx'), ['int'])),
                    ('pce_upd_rx', (YLeaf(YType.uint32, 'pce-upd-rx'), ['int'])),
                    ('pce_upd_tx', (YLeaf(YType.uint32, 'pce-upd-tx'), ['int'])),
                    ('pce_init_rx', (YLeaf(YType.uint32, 'pce-init-rx'), ['int'])),
                    ('pce_init_tx', (YLeaf(YType.uint32, 'pce-init-tx'), ['int'])),
                    ('pce_keepalive_tx', (YLeaf(YType.uint64, 'pce-keepalive-tx'), ['int'])),
                    ('pce_keepalive_rx', (YLeaf(YType.uint64, 'pce-keepalive-rx'), ['int'])),
                    ('req_reply_min', (YLeaf(YType.uint64, 'req-reply-min'), ['int'])),
                    ('req_reply_max', (YLeaf(YType.uint64, 'req-reply-max'), ['int'])),
                    ('req_reply_avg', (YLeaf(YType.uint64, 'req-reply-avg'), ['int'])),
                    ('request_timeouts', (YLeaf(YType.uint64, 'request-timeouts'), ['int'])),
                    ('local_sid', (YLeaf(YType.uint8, 'local-sid'), ['int'])),
                    ('remote_sid', (YLeaf(YType.uint8, 'remote-sid'), ['int'])),
                    ('min_keepalive_interval', (YLeaf(YType.uint8, 'min-keepalive-interval'), ['int'])),
                    ('max_dead_interval', (YLeaf(YType.uint8, 'max-dead-interval'), ['int'])),
                ])
                self.peer_address = None
                self.error = None
                self.pce_state = None
                self.precedence = None
                self.stateful = None
                self.capability_update = None
                self.capability_instantiate = None
                self.capability_segment_routing = None
                self.triggered_sync_capability = None
                self.capability_db_version = None
                self.delta_sync_capability = None
                self.pcep_up_time = None
                self.keepalives = None
                self.candidate = None
                self.statically_configured = None
                self.md5_enabled = None
                self.keychain_enabled = None
                self.negotiated_keepalive = None
                self.negotated_dead_time = None
                self.pce_req_rx = None
                self.pce_req_tx = None
                self.pce_rep_rx = None
                self.pce_rep_tx = None
                self.pce_err_rx = None
                self.pce_err_tx = None
                self.pce_open_tx = None
                self.pce_open_rx = None
                self.pce_rpt_rx = None
                self.pce_rpt_tx = None
                self.pce_upd_rx = None
                self.pce_upd_tx = None
                self.pce_init_rx = None
                self.pce_init_tx = None
                self.pce_keepalive_tx = None
                self.pce_keepalive_rx = None
                self.req_reply_min = None
                self.req_reply_max = None
                self.req_reply_avg = None
                self.request_timeouts = None
                self.local_sid = None
                self.remote_sid = None
                self.min_keepalive_interval = None
                self.max_dead_interval = None

                self.last_tx_pce_err = MplsPce.Peers.Peer.LastTxPceErr()
                self.last_tx_pce_err.parent = self
                self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"

                self.last_rx_pce_err = MplsPce.Peers.Peer.LastRxPceErr()
                self.last_rx_pce_err.parent = self
                self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"

                self.ig_ps = YList(self)
                self._segment_path = lambda: "peer" + "[peer-address='" + str(self.peer_address) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/peers/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Peers.Peer, ['peer_address', 'error', 'pce_state', 'precedence', 'stateful', 'capability_update', 'capability_instantiate', 'capability_segment_routing', 'triggered_sync_capability', 'capability_db_version', 'delta_sync_capability', 'pcep_up_time', 'keepalives', 'candidate', 'statically_configured', 'md5_enabled', 'keychain_enabled', 'negotiated_keepalive', 'negotated_dead_time', 'pce_req_rx', 'pce_req_tx', 'pce_rep_rx', 'pce_rep_tx', 'pce_err_rx', 'pce_err_tx', 'pce_open_tx', 'pce_open_rx', 'pce_rpt_rx', 'pce_rpt_tx', 'pce_upd_rx', 'pce_upd_tx', 'pce_init_rx', 'pce_init_tx', 'pce_keepalive_tx', 'pce_keepalive_rx', 'req_reply_min', 'req_reply_max', 'req_reply_avg', 'request_timeouts', 'local_sid', 'remote_sid', 'min_keepalive_interval', 'max_dead_interval'], name, value)


            class LastTxPceErr(_Entity_):
                """
                Last sent PCEErr
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Peers.Peer.LastTxPceErr, self).__init__()

                    self.yang_name = "last-tx-pce-err"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pce_err_type', (YLeaf(YType.uint32, 'pce-err-type'), ['int'])),
                        ('pce_err_value', (YLeaf(YType.uint32, 'pce-err-value'), ['int'])),
                        ('has_open_object', (YLeaf(YType.boolean, 'has-open-object'), ['bool'])),
                        ('openversion', (YLeaf(YType.uint32, 'openversion'), ['int'])),
                        ('open_keepalive', (YLeaf(YType.uint32, 'open-keepalive'), ['int'])),
                        ('open_dead_time', (YLeaf(YType.uint32, 'open-dead-time'), ['int'])),
                        ('has_rp_object', (YLeaf(YType.boolean, 'has-rp-object'), ['bool'])),
                        ('rp_request_id', (YLeaf(YType.uint32, 'rp-request-id'), ['int'])),
                    ])
                    self.pce_err_type = None
                    self.pce_err_value = None
                    self.has_open_object = None
                    self.openversion = None
                    self.open_keepalive = None
                    self.open_dead_time = None
                    self.has_rp_object = None
                    self.rp_request_id = None
                    self._segment_path = lambda: "last-tx-pce-err"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Peers.Peer.LastTxPceErr, ['pce_err_type', 'pce_err_value', 'has_open_object', 'openversion', 'open_keepalive', 'open_dead_time', 'has_rp_object', 'rp_request_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Peers.Peer.LastTxPceErr']['meta_info']


            class LastRxPceErr(_Entity_):
                """
                Last received PCEErr
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Peers.Peer.LastRxPceErr, self).__init__()

                    self.yang_name = "last-rx-pce-err"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pce_err_type', (YLeaf(YType.uint32, 'pce-err-type'), ['int'])),
                        ('pce_err_value', (YLeaf(YType.uint32, 'pce-err-value'), ['int'])),
                        ('has_open_object', (YLeaf(YType.boolean, 'has-open-object'), ['bool'])),
                        ('openversion', (YLeaf(YType.uint32, 'openversion'), ['int'])),
                        ('open_keepalive', (YLeaf(YType.uint32, 'open-keepalive'), ['int'])),
                        ('open_dead_time', (YLeaf(YType.uint32, 'open-dead-time'), ['int'])),
                        ('has_rp_object', (YLeaf(YType.boolean, 'has-rp-object'), ['bool'])),
                        ('rp_request_id', (YLeaf(YType.uint32, 'rp-request-id'), ['int'])),
                    ])
                    self.pce_err_type = None
                    self.pce_err_value = None
                    self.has_open_object = None
                    self.openversion = None
                    self.open_keepalive = None
                    self.open_dead_time = None
                    self.has_rp_object = None
                    self.rp_request_id = None
                    self._segment_path = lambda: "last-rx-pce-err"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Peers.Peer.LastRxPceErr, ['pce_err_type', 'pce_err_value', 'has_open_object', 'openversion', 'open_keepalive', 'open_dead_time', 'has_rp_object', 'rp_request_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Peers.Peer.LastRxPceErr']['meta_info']


            class IgPs(_Entity_):
                """
                IGPs
                
                .. attribute:: igp_type
                
                	Type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance_id
                
                	Instance ID
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Peers.Peer.IgPs, self).__init__()

                    self.yang_name = "ig-ps"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance_id', (YLeaf(YType.str, 'igp-instance-id'), ['str'])),
                    ])
                    self.igp_type = None
                    self.igp_instance_id = None
                    self._segment_path = lambda: "ig-ps"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Peers.Peer.IgPs, ['igp_type', 'igp_instance_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Peers.Peer.IgPs']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Peers.Peer']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPce.Peers']['meta_info']


    class Topology(_Entity_):
        """
        The topology information in PCE
        
        .. attribute:: global_
        
        	The global information of the overall  topology
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology.Global>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPce.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-pce"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsPce.Topology.Global))])
            self._leafs = OrderedDict()

            self.global_ = MplsPce.Topology.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._segment_path = lambda: "topology"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPce.Topology, [], name, value)


        class Global(_Entity_):
            """
            The global information of the overall  topology
            
            .. attribute:: nodes
            
            	Node information
            	**type**\: list of  		 :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Topology.Global.Nodes>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Topology.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nodes", ("nodes", MplsPce.Topology.Global.Nodes))])
                self._leafs = OrderedDict()

                self.nodes = YList(self)
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Topology.Global, [], name, value)


            class Nodes(_Entity_):
                """
                Node information
                
                .. attribute:: router_id
                
                	Router ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: igp_area_id
                
                	IGP Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: pce_cost
                
                	PCE cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_id
                
                	Node ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_pce_border_node
                
                	PCE border node
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPce.Topology.Global.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "global"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                        ('igp_area_id', (YLeaf(YType.uint32, 'igp-area-id'), ['int'])),
                        ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('pce_cost', (YLeaf(YType.uint32, 'pce-cost'), ['int'])),
                        ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ('is_pce_border_node', (YLeaf(YType.boolean, 'is-pce-border-node'), ['bool'])),
                    ])
                    self.router_id = None
                    self.igp_area_id = None
                    self.igp_area_format = None
                    self.pce_cost = None
                    self.node_id = None
                    self.is_pce_border_node = None
                    self._segment_path = lambda: "nodes"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/topology/global/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPce.Topology.Global.Nodes, ['router_id', 'igp_area_id', 'igp_area_format', 'pce_cost', 'node_id', 'is_pce_border_node'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPce.Topology.Global.Nodes']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Topology.Global']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPce.Topology']['meta_info']


    class Tunnels(_Entity_):
        """
        Table of PCE tunnels
        
        .. attribute:: tunnel
        
        	Information of a PCE tunnel
        	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPce.Tunnels.Tunnel>`
        
        	**config**\: False
        
        .. attribute:: source_address
        
        	Source Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: destination_address
        
        	Destination Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: is_curr_path_option_pce
        
        	True if current path option is PCE based
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: curr_path_option_index
        
        	Path Option Index of the current path
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: configured_pce_address
        
        	Configured PCE Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: sender_pce_address
        
        	Sender PCE Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: path_state
        
        	Path Request State
        	**type**\:  :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
        
        	**config**\: False
        
        .. attribute:: tunnel_state
        
        	Tunnel State
        	**type**\:  :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
        
        	**config**\: False
        
        .. attribute:: admin_weight
        
        	Path metric
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: hop_count
        
        	Hop Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPce.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-pce"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsPce.Tunnels.Tunnel))])
            self._leafs = OrderedDict([
                ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                ('is_curr_path_option_pce', (YLeaf(YType.boolean, 'is-curr-path-option-pce'), ['bool'])),
                ('curr_path_option_index', (YLeaf(YType.uint32, 'curr-path-option-index'), ['int'])),
                ('configured_pce_address', (YLeaf(YType.str, 'configured-pce-address'), ['str'])),
                ('sender_pce_address', (YLeaf(YType.str, 'sender-pce-address'), ['str'])),
                ('path_state', (YLeaf(YType.enumeration, 'path-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunPathState', '')])),
                ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunnelState', '')])),
                ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                ('hop_count', (YLeaf(YType.uint32, 'hop-count'), ['int'])),
            ])
            self.source_address = None
            self.destination_address = None
            self.is_curr_path_option_pce = None
            self.curr_path_option_index = None
            self.configured_pce_address = None
            self.sender_pce_address = None
            self.path_state = None
            self.tunnel_state = None
            self.admin_weight = None
            self.hop_count = None

            self.tunnel = YList(self)
            self._segment_path = lambda: "tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPce.Tunnels, ['source_address', 'destination_address', 'is_curr_path_option_pce', 'curr_path_option_index', 'configured_pce_address', 'sender_pce_address', 'path_state', 'tunnel_state', 'admin_weight', 'hop_count'], name, value)


        class Tunnel(_Entity_):
            """
            Information of a PCE tunnel
            
            .. attribute:: tunnel_name  (key)
            
            	Tunnel Name
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_curr_path_option_pce
            
            	True if current path option is PCE based
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: curr_path_option_index
            
            	Path Option Index of the current path
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: configured_pce_address
            
            	Configured PCE Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: sender_pce_address
            
            	Sender PCE Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: path_state
            
            	Path Request State
            	**type**\:  :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
            
            	**config**\: False
            
            .. attribute:: tunnel_state
            
            	Tunnel State
            	**type**\:  :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
            
            	**config**\: False
            
            .. attribute:: admin_weight
            
            	Path metric
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: hop_count
            
            	Hop Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPce.Tunnels.Tunnel, self).__init__()

                self.yang_name = "tunnel"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['tunnel_name']
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('is_curr_path_option_pce', (YLeaf(YType.boolean, 'is-curr-path-option-pce'), ['bool'])),
                    ('curr_path_option_index', (YLeaf(YType.uint32, 'curr-path-option-index'), ['int'])),
                    ('configured_pce_address', (YLeaf(YType.str, 'configured-pce-address'), ['str'])),
                    ('sender_pce_address', (YLeaf(YType.str, 'sender-pce-address'), ['str'])),
                    ('path_state', (YLeaf(YType.enumeration, 'path-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunPathState', '')])),
                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunnelState', '')])),
                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                    ('hop_count', (YLeaf(YType.uint32, 'hop-count'), ['int'])),
                ])
                self.tunnel_name = None
                self.source_address = None
                self.destination_address = None
                self.is_curr_path_option_pce = None
                self.curr_path_option_index = None
                self.configured_pce_address = None
                self.sender_pce_address = None
                self.path_state = None
                self.tunnel_state = None
                self.admin_weight = None
                self.hop_count = None
                self._segment_path = lambda: "tunnel" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPce.Tunnels.Tunnel, ['tunnel_name', 'source_address', 'destination_address', 'is_curr_path_option_pce', 'curr_path_option_index', 'configured_pce_address', 'sender_pce_address', 'path_state', 'tunnel_state', 'admin_weight', 'hop_count'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPce.Tunnels.Tunnel']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPce.Tunnels']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsPce()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsPce']['meta_info']


class MplsPceStdby(_Entity_):
    """
    mpls pce stdby
    
    .. attribute:: lsps
    
    	Table of LSPs
    	**type**\:  :py:class:`Lsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps>`
    
    	**config**\: False
    
    .. attribute:: statistics
    
    	PCE stats info
    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics>`
    
    	**config**\: False
    
    .. attribute:: peers
    
    	The set of PCE peers
    	**type**\:  :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers>`
    
    	**config**\: False
    
    .. attribute:: topology
    
    	The topology information in PCE
    	**type**\:  :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology>`
    
    	**config**\: False
    
    .. attribute:: tunnels
    
    	Table of PCE tunnels
    	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Tunnels>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsPceStdby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-pce-stdby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("lsps", ("lsps", MplsPceStdby.Lsps)), ("statistics", ("statistics", MplsPceStdby.Statistics)), ("peers", ("peers", MplsPceStdby.Peers)), ("topology", ("topology", MplsPceStdby.Topology)), ("tunnels", ("tunnels", MplsPceStdby.Tunnels))])
        self._leafs = OrderedDict()

        self.lsps = MplsPceStdby.Lsps()
        self.lsps.parent = self
        self._children_name_map["lsps"] = "lsps"

        self.statistics = MplsPceStdby.Statistics()
        self.statistics.parent = self
        self._children_name_map["statistics"] = "statistics"

        self.peers = MplsPceStdby.Peers()
        self.peers.parent = self
        self._children_name_map["peers"] = "peers"

        self.topology = MplsPceStdby.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"

        self.tunnels = MplsPceStdby.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsPceStdby, [], name, value)


    class Lsps(_Entity_):
        """
        Table of LSPs
        
        .. attribute:: lsp
        
        	Information of a LSP from LSPDB
        	**type**\: list of  		 :py:class:`Lsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp>`
        
        	**config**\: False
        
        .. attribute:: creator
        
        	Creator Peer of the LSP
        	**type**\:  :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Creator>`
        
        	**config**\: False
        
        .. attribute:: delegated
        
        	Owner Peer of the LSP
        	**type**\:  :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Delegated>`
        
        	**config**\: False
        
        .. attribute:: identifiers
        
        	LSP Identifiers
        	**type**\:  :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Identifiers>`
        
        	**config**\: False
        
        .. attribute:: autoroute
        
        	Auto Route
        	**type**\:  :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Autoroute>`
        
        	**config**\: False
        
        .. attribute:: source_address
        
        	Source IP Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: destination_address
        
        	Destination IP Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: symbolic_name_xr
        
        	Symbolic Name
        	**type**\: str
        
        	**config**\: False
        
        .. attribute:: session_internal_lsp_id
        
        	Session internal ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: stateful_request_parameter_id
        
        	SRP ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: request_queue_size
        
        	Request queue size
        	**type**\: int
        
        	**range:** 0..255
        
        	**config**\: False
        
        .. attribute:: delegatable
        
        	LSP delegatable
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: operational
        
        	LSP operational status
        	**type**\:  :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
        
        	**config**\: False
        
        .. attribute:: administrative
        
        	LSP administrative status
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: cleanup_timer_exp
        
        	Deprecated
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: delegation_timer_exp
        
        	LSP delegation timer expiration in sec
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: create
        
        	LSPO create flag
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: state_timer_exp
        
        	LSP state\-timeout time expiration
        	**type**\: int
        
        	**range:** \-2147483648..2147483647
        
        	**config**\: False
        
        .. attribute:: lspo_is_used
        
        	LSP Object used flag
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: forward_class_id
        
        	Forward Class ID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: load_share
        
        	Load share factor
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: path_setup_type
        
        	Path setup type
        	**type**\: int
        
        	**range:** 0..255
        
        	**config**\: False
        
        .. attribute:: binding_sid
        
        	Binding SID
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: backup_path
        
        	Backup Path
        	**type**\: list of  		 :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.BackupPath>`
        
        	**config**\: False
        
        .. attribute:: paths
        
        	Array of paths
        	**type**\: list of  		 :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPceStdby.Lsps, self).__init__()

            self.yang_name = "lsps"
            self.yang_parent_name = "mpls-pce-stdby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("lsp", ("lsp", MplsPceStdby.Lsps.Lsp)), ("creator", ("creator", MplsPceStdby.Lsps.Creator)), ("delegated", ("delegated", MplsPceStdby.Lsps.Delegated)), ("identifiers", ("identifiers", MplsPceStdby.Lsps.Identifiers)), ("autoroute", ("autoroute", MplsPceStdby.Lsps.Autoroute)), ("backup-path", ("backup_path", MplsPceStdby.Lsps.BackupPath)), ("paths", ("paths", MplsPceStdby.Lsps.Paths))])
            self._leafs = OrderedDict([
                ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                ('symbolic_name_xr', (YLeaf(YType.str, 'symbolic-name-xr'), ['str'])),
                ('session_internal_lsp_id', (YLeaf(YType.uint32, 'session-internal-lsp-id'), ['int'])),
                ('stateful_request_parameter_id', (YLeaf(YType.uint32, 'stateful-request-parameter-id'), ['int'])),
                ('request_queue_size', (YLeaf(YType.uint8, 'request-queue-size'), ['int'])),
                ('delegatable', (YLeaf(YType.boolean, 'delegatable'), ['bool'])),
                ('operational', (YLeaf(YType.enumeration, 'operational'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspOperState', '')])),
                ('administrative', (YLeaf(YType.boolean, 'administrative'), ['bool'])),
                ('cleanup_timer_exp', (YLeaf(YType.int32, 'cleanup-timer-exp'), ['int'])),
                ('delegation_timer_exp', (YLeaf(YType.int32, 'delegation-timer-exp'), ['int'])),
                ('create', (YLeaf(YType.boolean, 'create'), ['bool'])),
                ('state_timer_exp', (YLeaf(YType.int32, 'state-timer-exp'), ['int'])),
                ('lspo_is_used', (YLeaf(YType.boolean, 'lspo-is-used'), ['bool'])),
                ('forward_class_id', (YLeaf(YType.uint32, 'forward-class-id'), ['int'])),
                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                ('path_setup_type', (YLeaf(YType.uint8, 'path-setup-type'), ['int'])),
                ('binding_sid', (YLeaf(YType.uint32, 'binding-sid'), ['int'])),
            ])
            self.source_address = None
            self.destination_address = None
            self.symbolic_name_xr = None
            self.session_internal_lsp_id = None
            self.stateful_request_parameter_id = None
            self.request_queue_size = None
            self.delegatable = None
            self.operational = None
            self.administrative = None
            self.cleanup_timer_exp = None
            self.delegation_timer_exp = None
            self.create = None
            self.state_timer_exp = None
            self.lspo_is_used = None
            self.forward_class_id = None
            self.load_share = None
            self.path_setup_type = None
            self.binding_sid = None

            self.creator = MplsPceStdby.Lsps.Creator()
            self.creator.parent = self
            self._children_name_map["creator"] = "creator"

            self.delegated = MplsPceStdby.Lsps.Delegated()
            self.delegated.parent = self
            self._children_name_map["delegated"] = "delegated"

            self.identifiers = MplsPceStdby.Lsps.Identifiers()
            self.identifiers.parent = self
            self._children_name_map["identifiers"] = "identifiers"

            self.autoroute = MplsPceStdby.Lsps.Autoroute()
            self.autoroute.parent = self
            self._children_name_map["autoroute"] = "autoroute"

            self.lsp = YList(self)
            self.backup_path = YList(self)
            self.paths = YList(self)
            self._segment_path = lambda: "lsps"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPceStdby.Lsps, ['source_address', 'destination_address', 'symbolic_name_xr', 'session_internal_lsp_id', 'stateful_request_parameter_id', 'request_queue_size', 'delegatable', 'operational', 'administrative', 'cleanup_timer_exp', 'delegation_timer_exp', 'create', 'state_timer_exp', 'lspo_is_used', 'forward_class_id', 'load_share', 'path_setup_type', 'binding_sid'], name, value)


        class Lsp(_Entity_):
            """
            Information of a LSP from LSPDB
            
            .. attribute:: symbolic_name  (key)
            
            	Symbolic name
            	**type**\: str
            
            	**length:** 1..256
            
            	**config**\: False
            
            .. attribute:: creator
            
            	Creator Peer of the LSP
            	**type**\:  :py:class:`Creator <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Creator>`
            
            	**config**\: False
            
            .. attribute:: delegated
            
            	Owner Peer of the LSP
            	**type**\:  :py:class:`Delegated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Delegated>`
            
            	**config**\: False
            
            .. attribute:: identifiers
            
            	LSP Identifiers
            	**type**\:  :py:class:`Identifiers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Identifiers>`
            
            	**config**\: False
            
            .. attribute:: autoroute
            
            	Auto Route
            	**type**\:  :py:class:`Autoroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Autoroute>`
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source IP Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination IP Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: symbolic_name_xr
            
            	Symbolic Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: session_internal_lsp_id
            
            	Session internal ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: stateful_request_parameter_id
            
            	SRP ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: request_queue_size
            
            	Request queue size
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: delegatable
            
            	LSP delegatable
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: operational
            
            	LSP operational status
            	**type**\:  :py:class:`PceLspOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspOperState>`
            
            	**config**\: False
            
            .. attribute:: administrative
            
            	LSP administrative status
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: cleanup_timer_exp
            
            	Deprecated
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: delegation_timer_exp
            
            	LSP delegation timer expiration in sec
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: create
            
            	LSPO create flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: state_timer_exp
            
            	LSP state\-timeout time expiration
            	**type**\: int
            
            	**range:** \-2147483648..2147483647
            
            	**config**\: False
            
            .. attribute:: lspo_is_used
            
            	LSP Object used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: forward_class_id
            
            	Forward Class ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: load_share
            
            	Load share factor
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_setup_type
            
            	Path setup type
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: binding_sid
            
            	Binding SID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backup_path
            
            	Backup Path
            	**type**\: list of  		 :py:class:`BackupPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.BackupPath>`
            
            	**config**\: False
            
            .. attribute:: paths
            
            	Array of paths
            	**type**\: list of  		 :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Lsp, self).__init__()

                self.yang_name = "lsp"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['symbolic_name']
                self._child_classes = OrderedDict([("creator", ("creator", MplsPceStdby.Lsps.Lsp.Creator)), ("delegated", ("delegated", MplsPceStdby.Lsps.Lsp.Delegated)), ("identifiers", ("identifiers", MplsPceStdby.Lsps.Lsp.Identifiers)), ("autoroute", ("autoroute", MplsPceStdby.Lsps.Lsp.Autoroute)), ("backup-path", ("backup_path", MplsPceStdby.Lsps.Lsp.BackupPath)), ("paths", ("paths", MplsPceStdby.Lsps.Lsp.Paths))])
                self._leafs = OrderedDict([
                    ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('symbolic_name_xr', (YLeaf(YType.str, 'symbolic-name-xr'), ['str'])),
                    ('session_internal_lsp_id', (YLeaf(YType.uint32, 'session-internal-lsp-id'), ['int'])),
                    ('stateful_request_parameter_id', (YLeaf(YType.uint32, 'stateful-request-parameter-id'), ['int'])),
                    ('request_queue_size', (YLeaf(YType.uint8, 'request-queue-size'), ['int'])),
                    ('delegatable', (YLeaf(YType.boolean, 'delegatable'), ['bool'])),
                    ('operational', (YLeaf(YType.enumeration, 'operational'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspOperState', '')])),
                    ('administrative', (YLeaf(YType.boolean, 'administrative'), ['bool'])),
                    ('cleanup_timer_exp', (YLeaf(YType.int32, 'cleanup-timer-exp'), ['int'])),
                    ('delegation_timer_exp', (YLeaf(YType.int32, 'delegation-timer-exp'), ['int'])),
                    ('create', (YLeaf(YType.boolean, 'create'), ['bool'])),
                    ('state_timer_exp', (YLeaf(YType.int32, 'state-timer-exp'), ['int'])),
                    ('lspo_is_used', (YLeaf(YType.boolean, 'lspo-is-used'), ['bool'])),
                    ('forward_class_id', (YLeaf(YType.uint32, 'forward-class-id'), ['int'])),
                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                    ('path_setup_type', (YLeaf(YType.uint8, 'path-setup-type'), ['int'])),
                    ('binding_sid', (YLeaf(YType.uint32, 'binding-sid'), ['int'])),
                ])
                self.symbolic_name = None
                self.source_address = None
                self.destination_address = None
                self.symbolic_name_xr = None
                self.session_internal_lsp_id = None
                self.stateful_request_parameter_id = None
                self.request_queue_size = None
                self.delegatable = None
                self.operational = None
                self.administrative = None
                self.cleanup_timer_exp = None
                self.delegation_timer_exp = None
                self.create = None
                self.state_timer_exp = None
                self.lspo_is_used = None
                self.forward_class_id = None
                self.load_share = None
                self.path_setup_type = None
                self.binding_sid = None

                self.creator = MplsPceStdby.Lsps.Lsp.Creator()
                self.creator.parent = self
                self._children_name_map["creator"] = "creator"

                self.delegated = MplsPceStdby.Lsps.Lsp.Delegated()
                self.delegated.parent = self
                self._children_name_map["delegated"] = "delegated"

                self.identifiers = MplsPceStdby.Lsps.Lsp.Identifiers()
                self.identifiers.parent = self
                self._children_name_map["identifiers"] = "identifiers"

                self.autoroute = MplsPceStdby.Lsps.Lsp.Autoroute()
                self.autoroute.parent = self
                self._children_name_map["autoroute"] = "autoroute"

                self.backup_path = YList(self)
                self.paths = YList(self)
                self._segment_path = lambda: "lsp" + "[symbolic-name='" + str(self.symbolic_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Lsp, ['symbolic_name', 'source_address', 'destination_address', 'symbolic_name_xr', 'session_internal_lsp_id', 'stateful_request_parameter_id', 'request_queue_size', 'delegatable', 'operational', 'administrative', 'cleanup_timer_exp', 'delegation_timer_exp', 'create', 'state_timer_exp', 'lspo_is_used', 'forward_class_id', 'load_share', 'path_setup_type', 'binding_sid'], name, value)


            class Creator(_Entity_):
                """
                Creator Peer of the LSP
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.Creator, self).__init__()

                    self.yang_name = "creator"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                    ])
                    self.node_identifier = None
                    self.address = None
                    self._segment_path = lambda: "creator"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.Creator, ['node_identifier', 'address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.Creator']['meta_info']


            class Delegated(_Entity_):
                """
                Owner Peer of the LSP
                
                .. attribute:: node_identifier
                
                	Peer Node Identifier
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: address
                
                	Peer Ip Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.Delegated, self).__init__()

                    self.yang_name = "delegated"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                    ])
                    self.node_identifier = None
                    self.address = None
                    self._segment_path = lambda: "delegated"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.Delegated, ['node_identifier', 'address'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.Delegated']['meta_info']


            class Identifiers(_Entity_):
                """
                LSP Identifiers
                
                .. attribute:: is_used
                
                	LSP Identifier used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: sender
                
                	Sender Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: te_lsp_id
                
                	TE LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	LSPO Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: ext_tunnel_id
                
                	External Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.Identifiers, self).__init__()

                    self.yang_name = "identifiers"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('sender', (YLeaf(YType.str, 'sender'), ['str'])),
                        ('te_lsp_id', (YLeaf(YType.uint16, 'te-lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                        ('ext_tunnel_id', (YLeaf(YType.uint32, 'ext-tunnel-id'), ['int'])),
                    ])
                    self.is_used = None
                    self.sender = None
                    self.te_lsp_id = None
                    self.tunnel_id = None
                    self.ext_tunnel_id = None
                    self._segment_path = lambda: "identifiers"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.Identifiers, ['is_used', 'sender', 'te_lsp_id', 'tunnel_id', 'ext_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.Identifiers']['meta_info']


            class Autoroute(_Entity_):
                """
                Auto Route
                
                .. attribute:: is_used
                
                	Autoroute used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: announced
                
                	Autoroute announced
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:  :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
                
                	**config**\: False
                
                .. attribute:: metric
                
                	Metric Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Autoroute.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.Autoroute, self).__init__()

                    self.yang_name = "autoroute"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("destination", ("destination", MplsPceStdby.Lsps.Lsp.Autoroute.Destination))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('announced', (YLeaf(YType.boolean, 'announced'), ['bool'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspAutorouteMetric', '')])),
                        ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                    ])
                    self.is_used = None
                    self.announced = None
                    self.metric_type = None
                    self.metric = None

                    self.destination = YList(self)
                    self._segment_path = lambda: "autoroute"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.Autoroute, ['is_used', 'announced', 'metric_type', 'metric'], name, value)


                class Destination(_Entity_):
                    """
                    Destinations
                    
                    .. attribute:: entry
                    
                    	Destinations
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Lsp.Autoroute.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "autoroute"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Lsp.Autoroute.Destination, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Lsp.Autoroute.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.Autoroute']['meta_info']


            class BackupPath(_Entity_):
                """
                Backup Path
                
                .. attribute:: entry
                
                	Backup Path
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.BackupPath, self).__init__()

                    self.yang_name = "backup-path"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "backup-path"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.BackupPath, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.BackupPath']['meta_info']


            class Paths(_Entity_):
                """
                Array of paths
                
                .. attribute:: ero
                
                	Explicit Router Object
                	**type**\:  :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Ero>`
                
                	**config**\: False
                
                .. attribute:: lspa
                
                	LSP Attributes Object
                	**type**\:  :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Lspa>`
                
                	**config**\: False
                
                .. attribute:: rro
                
                	Reported Route Object
                	**type**\:  :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Rro>`
                
                	**config**\: False
                
                .. attribute:: bw
                
                	Bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_bw_used
                
                	Bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reopt_bw
                
                	Reoptimize bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_reopt_bw_used
                
                	Reoptimize bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: applied_bw
                
                	Applied bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_applied_bw_used
                
                	Applied bandwidth used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: metric
                
                	List of Metrics
                	**type**\: list of  		 :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Metric>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Lsp.Paths, self).__init__()

                    self.yang_name = "paths"
                    self.yang_parent_name = "lsp"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("ero", ("ero", MplsPceStdby.Lsps.Lsp.Paths.Ero)), ("lspa", ("lspa", MplsPceStdby.Lsps.Lsp.Paths.Lspa)), ("rro", ("rro", MplsPceStdby.Lsps.Lsp.Paths.Rro)), ("metric", ("metric", MplsPceStdby.Lsps.Lsp.Paths.Metric))])
                    self._leafs = OrderedDict([
                        ('bw', (YLeaf(YType.uint32, 'bw'), ['int'])),
                        ('is_bw_used', (YLeaf(YType.boolean, 'is-bw-used'), ['bool'])),
                        ('reopt_bw', (YLeaf(YType.uint32, 'reopt-bw'), ['int'])),
                        ('is_reopt_bw_used', (YLeaf(YType.boolean, 'is-reopt-bw-used'), ['bool'])),
                        ('applied_bw', (YLeaf(YType.uint32, 'applied-bw'), ['int'])),
                        ('is_applied_bw_used', (YLeaf(YType.boolean, 'is-applied-bw-used'), ['bool'])),
                    ])
                    self.bw = None
                    self.is_bw_used = None
                    self.reopt_bw = None
                    self.is_reopt_bw_used = None
                    self.applied_bw = None
                    self.is_applied_bw_used = None

                    self.ero = MplsPceStdby.Lsps.Lsp.Paths.Ero()
                    self.ero.parent = self
                    self._children_name_map["ero"] = "ero"

                    self.lspa = MplsPceStdby.Lsps.Lsp.Paths.Lspa()
                    self.lspa.parent = self
                    self._children_name_map["lspa"] = "lspa"

                    self.rro = MplsPceStdby.Lsps.Lsp.Paths.Rro()
                    self.rro.parent = self
                    self._children_name_map["rro"] = "rro"

                    self.metric = YList(self)
                    self._segment_path = lambda: "paths"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths, ['bw', 'is_bw_used', 'reopt_bw', 'is_reopt_bw_used', 'applied_bw', 'is_applied_bw_used'], name, value)


                class Ero(_Entity_):
                    """
                    Explicit Router Object
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Ero.Address>`
                    
                    	**config**\: False
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Lsp.Paths.Ero, self).__init__()

                        self.yang_name = "ero"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("address", ("address", MplsPceStdby.Lsps.Lsp.Paths.Ero.Address)), ("subobject", ("subobject", MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject))])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.is_used = None
                        self.cost = None

                        self.address = YList(self)
                        self.subobject = YList(self)
                        self._segment_path = lambda: "ero"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Ero, ['is_used', 'cost'], name, value)


                    class Address(_Entity_):
                        """
                        List of Addresses
                        
                        .. attribute:: entry
                        
                        	List of Addresses
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPceStdby.Lsps.Lsp.Paths.Ero.Address, self).__init__()

                            self.yang_name = "address"
                            self.yang_parent_name = "ero"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "address"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Ero.Address, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Ero.Address']['meta_info']


                    class Subobject(_Entity_):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "ero"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                                ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                                ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                                ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                                ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                                ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                                ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                                ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                                ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                                ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                                ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                                ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                                ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                                ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                            ])
                            self.subobj_type = None
                            self.ipv4_address = None
                            self.ipv4_prefix_len = None
                            self.strict = None
                            self.global_ = None
                            self.mpls_label = None
                            self.segment_id_type = None
                            self.only_valid_mpls_label = None
                            self.complete_mpls_label_entry = None
                            self.missing_segment_id = None
                            self.missing_node_adjcency_id = None
                            self.segment_id_exists = None
                            self.segment_id_value = None
                            self.node_adjacency_id_exists = None
                            self.node_id = None
                            self.local_address = None
                            self.remote_address = None
                            self._segment_path = lambda: "subobject"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Ero.Subobject']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Ero']['meta_info']


                class Lspa(_Entity_):
                    """
                    LSP Attributes Object
                    
                    .. attribute:: is_used
                    
                    	LSPA used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: exlude_any
                    
                    	Exclude Any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: include_any
                    
                    	Include Any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: include_all
                    
                    	Include All
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: setup
                    
                    	Setup
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold
                    
                    	Hold
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lbit
                    
                    	L flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Lsp.Paths.Lspa, self).__init__()

                        self.yang_name = "lspa"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('exlude_any', (YLeaf(YType.uint32, 'exlude-any'), ['int'])),
                            ('include_any', (YLeaf(YType.uint32, 'include-any'), ['int'])),
                            ('include_all', (YLeaf(YType.uint32, 'include-all'), ['int'])),
                            ('setup', (YLeaf(YType.uint8, 'setup'), ['int'])),
                            ('hold', (YLeaf(YType.uint8, 'hold'), ['int'])),
                            ('lbit', (YLeaf(YType.boolean, 'lbit'), ['bool'])),
                        ])
                        self.is_used = None
                        self.exlude_any = None
                        self.include_any = None
                        self.include_all = None
                        self.setup = None
                        self.hold = None
                        self.lbit = None
                        self._segment_path = lambda: "lspa"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Lspa, ['is_used', 'exlude_any', 'include_any', 'include_all', 'setup', 'hold', 'lbit'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Lspa']['meta_info']


                class Rro(_Entity_):
                    """
                    Reported Route Object
                    
                    .. attribute:: is_used
                    
                    	Route Object used flag
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: address
                    
                    	List of Addresses
                    	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Rro.Address>`
                    
                    	**config**\: False
                    
                    .. attribute:: subobject
                    
                    	List of Route Subobjects
                    	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Lsp.Paths.Rro, self).__init__()

                        self.yang_name = "rro"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("address", ("address", MplsPceStdby.Lsps.Lsp.Paths.Rro.Address)), ("subobject", ("subobject", MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject))])
                        self._leafs = OrderedDict([
                            ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.is_used = None
                        self.cost = None

                        self.address = YList(self)
                        self.subobject = YList(self)
                        self._segment_path = lambda: "rro"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Rro, ['is_used', 'cost'], name, value)


                    class Address(_Entity_):
                        """
                        List of Addresses
                        
                        .. attribute:: entry
                        
                        	List of Addresses
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPceStdby.Lsps.Lsp.Paths.Rro.Address, self).__init__()

                            self.yang_name = "address"
                            self.yang_parent_name = "rro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "address"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Rro.Address, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Rro.Address']['meta_info']


                    class Subobject(_Entity_):
                        """
                        List of Route Subobjects
                        
                        .. attribute:: subobj_type
                        
                        	Route Subobject Type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_prefix_len
                        
                        	IPv4 Address Prefix Length
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: strict
                        
                        	Strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: global_
                        
                        	Global
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label in case Segment ID type is MPLS
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_type
                        
                        	Segment ID Type
                        	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: only_valid_mpls_label
                        
                        	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: complete_mpls_label_entry
                        
                        	If this flag is true, all fields of MPLS labe entry are valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_segment_id
                        
                        	If this flag is true, ERO subobject does not have SegmentID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: missing_node_adjcency_id
                        
                        	If this flag is true, ERO subobject does not have NodeAdjacencyID
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_exists
                        
                        	If this field is true, the bag contains SegmentID value
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: segment_id_value
                        
                        	Contains a SegmentID value in case SegmentID is valid
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: node_adjacency_id_exists
                        
                        	If this flag is true, the bag contains NodeAdjacencyID information
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: node_id
                        
                        	Address of the node corresponding the node SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: local_address
                        
                        	Address of the local address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_address
                        
                        	Address of the remote address corresponding the adjacency SegmentID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject, self).__init__()

                            self.yang_name = "subobject"
                            self.yang_parent_name = "rro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                                ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                                ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                                ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                                ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                                ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                                ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                                ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                                ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                                ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                                ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                                ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                                ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                                ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                            ])
                            self.subobj_type = None
                            self.ipv4_address = None
                            self.ipv4_prefix_len = None
                            self.strict = None
                            self.global_ = None
                            self.mpls_label = None
                            self.segment_id_type = None
                            self.only_valid_mpls_label = None
                            self.complete_mpls_label_entry = None
                            self.missing_segment_id = None
                            self.missing_node_adjcency_id = None
                            self.segment_id_exists = None
                            self.segment_id_value = None
                            self.node_adjacency_id_exists = None
                            self.node_id = None
                            self.local_address = None
                            self.remote_address = None
                            self._segment_path = lambda: "subobject"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Rro.Subobject']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Rro']['meta_info']


                class Metric(_Entity_):
                    """
                    List of Metrics
                    
                    .. attribute:: type
                    
                    	Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost
                    
                    	Cost
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Lsp.Paths.Metric, self).__init__()

                        self.yang_name = "metric"
                        self.yang_parent_name = "paths"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                            ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                        ])
                        self.type = None
                        self.cost = None
                        self._segment_path = lambda: "metric"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Lsp.Paths.Metric, ['type', 'cost'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths.Metric']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Lsp.Paths']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Lsp']['meta_info']


        class Creator(_Entity_):
            """
            Creator Peer of the LSP
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Creator, self).__init__()

                self.yang_name = "creator"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                    ('address', (YLeaf(YType.str, 'address'), ['str'])),
                ])
                self.node_identifier = None
                self.address = None
                self._segment_path = lambda: "creator"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Creator, ['node_identifier', 'address'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Creator']['meta_info']


        class Delegated(_Entity_):
            """
            Owner Peer of the LSP
            
            .. attribute:: node_identifier
            
            	Peer Node Identifier
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: address
            
            	Peer Ip Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Delegated, self).__init__()

                self.yang_name = "delegated"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('node_identifier', (YLeaf(YType.str, 'node-identifier'), ['str'])),
                    ('address', (YLeaf(YType.str, 'address'), ['str'])),
                ])
                self.node_identifier = None
                self.address = None
                self._segment_path = lambda: "delegated"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Delegated, ['node_identifier', 'address'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Delegated']['meta_info']


        class Identifiers(_Entity_):
            """
            LSP Identifiers
            
            .. attribute:: is_used
            
            	LSP Identifier used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: sender
            
            	Sender Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: te_lsp_id
            
            	TE LSP ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_id
            
            	LSPO Tunnel ID
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: ext_tunnel_id
            
            	External Tunnel ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Identifiers, self).__init__()

                self.yang_name = "identifiers"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                    ('sender', (YLeaf(YType.str, 'sender'), ['str'])),
                    ('te_lsp_id', (YLeaf(YType.uint16, 'te-lsp-id'), ['int'])),
                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                    ('ext_tunnel_id', (YLeaf(YType.uint32, 'ext-tunnel-id'), ['int'])),
                ])
                self.is_used = None
                self.sender = None
                self.te_lsp_id = None
                self.tunnel_id = None
                self.ext_tunnel_id = None
                self._segment_path = lambda: "identifiers"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Identifiers, ['is_used', 'sender', 'te_lsp_id', 'tunnel_id', 'ext_tunnel_id'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Identifiers']['meta_info']


        class Autoroute(_Entity_):
            """
            Auto Route
            
            .. attribute:: is_used
            
            	Autoroute used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: announced
            
            	Autoroute announced
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: metric_type
            
            	Metric Type
            	**type**\:  :py:class:`PceLspAutorouteMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceLspAutorouteMetric>`
            
            	**config**\: False
            
            .. attribute:: metric
            
            	Metric Value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: destination
            
            	Destinations
            	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Autoroute.Destination>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Autoroute, self).__init__()

                self.yang_name = "autoroute"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("destination", ("destination", MplsPceStdby.Lsps.Autoroute.Destination))])
                self._leafs = OrderedDict([
                    ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                    ('announced', (YLeaf(YType.boolean, 'announced'), ['bool'])),
                    ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceLspAutorouteMetric', '')])),
                    ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                ])
                self.is_used = None
                self.announced = None
                self.metric_type = None
                self.metric = None

                self.destination = YList(self)
                self._segment_path = lambda: "autoroute"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Autoroute, ['is_used', 'announced', 'metric_type', 'metric'], name, value)


            class Destination(_Entity_):
                """
                Destinations
                
                .. attribute:: entry
                
                	Destinations
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Autoroute.Destination, self).__init__()

                    self.yang_name = "destination"
                    self.yang_parent_name = "autoroute"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "destination"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/autoroute/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Autoroute.Destination, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Autoroute.Destination']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Autoroute']['meta_info']


        class BackupPath(_Entity_):
            """
            Backup Path
            
            .. attribute:: entry
            
            	Backup Path
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.BackupPath, self).__init__()

                self.yang_name = "backup-path"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                ])
                self.entry = None
                self._segment_path = lambda: "backup-path"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.BackupPath, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.BackupPath']['meta_info']


        class Paths(_Entity_):
            """
            Array of paths
            
            .. attribute:: ero
            
            	Explicit Router Object
            	**type**\:  :py:class:`Ero <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Ero>`
            
            	**config**\: False
            
            .. attribute:: lspa
            
            	LSP Attributes Object
            	**type**\:  :py:class:`Lspa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Lspa>`
            
            	**config**\: False
            
            .. attribute:: rro
            
            	Reported Route Object
            	**type**\:  :py:class:`Rro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Rro>`
            
            	**config**\: False
            
            .. attribute:: bw
            
            	Bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_bw_used
            
            	Bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: reopt_bw
            
            	Reoptimize bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_reopt_bw_used
            
            	Reoptimize bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: applied_bw
            
            	Applied bandwidth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_applied_bw_used
            
            	Applied bandwidth used flag
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: metric
            
            	List of Metrics
            	**type**\: list of  		 :py:class:`Metric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Metric>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Lsps.Paths, self).__init__()

                self.yang_name = "paths"
                self.yang_parent_name = "lsps"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("ero", ("ero", MplsPceStdby.Lsps.Paths.Ero)), ("lspa", ("lspa", MplsPceStdby.Lsps.Paths.Lspa)), ("rro", ("rro", MplsPceStdby.Lsps.Paths.Rro)), ("metric", ("metric", MplsPceStdby.Lsps.Paths.Metric))])
                self._leafs = OrderedDict([
                    ('bw', (YLeaf(YType.uint32, 'bw'), ['int'])),
                    ('is_bw_used', (YLeaf(YType.boolean, 'is-bw-used'), ['bool'])),
                    ('reopt_bw', (YLeaf(YType.uint32, 'reopt-bw'), ['int'])),
                    ('is_reopt_bw_used', (YLeaf(YType.boolean, 'is-reopt-bw-used'), ['bool'])),
                    ('applied_bw', (YLeaf(YType.uint32, 'applied-bw'), ['int'])),
                    ('is_applied_bw_used', (YLeaf(YType.boolean, 'is-applied-bw-used'), ['bool'])),
                ])
                self.bw = None
                self.is_bw_used = None
                self.reopt_bw = None
                self.is_reopt_bw_used = None
                self.applied_bw = None
                self.is_applied_bw_used = None

                self.ero = MplsPceStdby.Lsps.Paths.Ero()
                self.ero.parent = self
                self._children_name_map["ero"] = "ero"

                self.lspa = MplsPceStdby.Lsps.Paths.Lspa()
                self.lspa.parent = self
                self._children_name_map["lspa"] = "lspa"

                self.rro = MplsPceStdby.Lsps.Paths.Rro()
                self.rro.parent = self
                self._children_name_map["rro"] = "rro"

                self.metric = YList(self)
                self._segment_path = lambda: "paths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Lsps.Paths, ['bw', 'is_bw_used', 'reopt_bw', 'is_reopt_bw_used', 'applied_bw', 'is_applied_bw_used'], name, value)


            class Ero(_Entity_):
                """
                Explicit Router Object
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Ero.Address>`
                
                	**config**\: False
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Ero.Subobject>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Paths.Ero, self).__init__()

                    self.yang_name = "ero"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("address", ("address", MplsPceStdby.Lsps.Paths.Ero.Address)), ("subobject", ("subobject", MplsPceStdby.Lsps.Paths.Ero.Subobject))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.is_used = None
                    self.cost = None

                    self.address = YList(self)
                    self.subobject = YList(self)
                    self._segment_path = lambda: "ero"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Paths.Ero, ['is_used', 'cost'], name, value)


                class Address(_Entity_):
                    """
                    List of Addresses
                    
                    .. attribute:: entry
                    
                    	List of Addresses
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Paths.Ero.Address, self).__init__()

                        self.yang_name = "address"
                        self.yang_parent_name = "ero"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "address"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/ero/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Paths.Ero.Address, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Paths.Ero.Address']['meta_info']


                class Subobject(_Entity_):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Paths.Ero.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "ero"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                            ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                            ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                            ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                            ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                            ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                            ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                            ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                            ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                            ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                            ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.subobj_type = None
                        self.ipv4_address = None
                        self.ipv4_prefix_len = None
                        self.strict = None
                        self.global_ = None
                        self.mpls_label = None
                        self.segment_id_type = None
                        self.only_valid_mpls_label = None
                        self.complete_mpls_label_entry = None
                        self.missing_segment_id = None
                        self.missing_node_adjcency_id = None
                        self.segment_id_exists = None
                        self.segment_id_value = None
                        self.node_adjacency_id_exists = None
                        self.node_id = None
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "subobject"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/ero/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Paths.Ero.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Paths.Ero.Subobject']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Paths.Ero']['meta_info']


            class Lspa(_Entity_):
                """
                LSP Attributes Object
                
                .. attribute:: is_used
                
                	LSPA used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: exlude_any
                
                	Exclude Any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: include_any
                
                	Include Any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: include_all
                
                	Include All
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup
                
                	Setup
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: hold
                
                	Hold
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lbit
                
                	L flag
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Paths.Lspa, self).__init__()

                    self.yang_name = "lspa"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('exlude_any', (YLeaf(YType.uint32, 'exlude-any'), ['int'])),
                        ('include_any', (YLeaf(YType.uint32, 'include-any'), ['int'])),
                        ('include_all', (YLeaf(YType.uint32, 'include-all'), ['int'])),
                        ('setup', (YLeaf(YType.uint8, 'setup'), ['int'])),
                        ('hold', (YLeaf(YType.uint8, 'hold'), ['int'])),
                        ('lbit', (YLeaf(YType.boolean, 'lbit'), ['bool'])),
                    ])
                    self.is_used = None
                    self.exlude_any = None
                    self.include_any = None
                    self.include_all = None
                    self.setup = None
                    self.hold = None
                    self.lbit = None
                    self._segment_path = lambda: "lspa"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Paths.Lspa, ['is_used', 'exlude_any', 'include_any', 'include_all', 'setup', 'hold', 'lbit'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Paths.Lspa']['meta_info']


            class Rro(_Entity_):
                """
                Reported Route Object
                
                .. attribute:: is_used
                
                	Route Object used flag
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: address
                
                	List of Addresses
                	**type**\: list of  		 :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Rro.Address>`
                
                	**config**\: False
                
                .. attribute:: subobject
                
                	List of Route Subobjects
                	**type**\: list of  		 :py:class:`Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Lsps.Paths.Rro.Subobject>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Paths.Rro, self).__init__()

                    self.yang_name = "rro"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("address", ("address", MplsPceStdby.Lsps.Paths.Rro.Address)), ("subobject", ("subobject", MplsPceStdby.Lsps.Paths.Rro.Subobject))])
                    self._leafs = OrderedDict([
                        ('is_used', (YLeaf(YType.boolean, 'is-used'), ['bool'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.is_used = None
                    self.cost = None

                    self.address = YList(self)
                    self.subobject = YList(self)
                    self._segment_path = lambda: "rro"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Paths.Rro, ['is_used', 'cost'], name, value)


                class Address(_Entity_):
                    """
                    List of Addresses
                    
                    .. attribute:: entry
                    
                    	List of Addresses
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Paths.Rro.Address, self).__init__()

                        self.yang_name = "address"
                        self.yang_parent_name = "rro"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "address"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/rro/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Paths.Rro.Address, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Paths.Rro.Address']['meta_info']


                class Subobject(_Entity_):
                    """
                    List of Route Subobjects
                    
                    .. attribute:: subobj_type
                    
                    	Route Subobject Type
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_prefix_len
                    
                    	IPv4 Address Prefix Length
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: strict
                    
                    	Strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: global_
                    
                    	Global
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label
                    
                    	MPLS Label in case Segment ID type is MPLS
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_type
                    
                    	Segment ID Type
                    	**type**\:  :py:class:`PceSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: only_valid_mpls_label
                    
                    	If this flag is true, SID has only MPLS label value. TC, S, and TTL fields are considered invalid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: complete_mpls_label_entry
                    
                    	If this flag is true, all fields of MPLS labe entry are valid
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_segment_id
                    
                    	If this flag is true, ERO subobject does not have SegmentID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: missing_node_adjcency_id
                    
                    	If this flag is true, ERO subobject does not have NodeAdjacencyID
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_exists
                    
                    	If this field is true, the bag contains SegmentID value
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_value
                    
                    	Contains a SegmentID value in case SegmentID is valid
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_adjacency_id_exists
                    
                    	If this flag is true, the bag contains NodeAdjacencyID information
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: node_id
                    
                    	Address of the node corresponding the node SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: local_address
                    
                    	Address of the local address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Address of the remote address corresponding the adjacency SegmentID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsPceStdby.Lsps.Paths.Rro.Subobject, self).__init__()

                        self.yang_name = "subobject"
                        self.yang_parent_name = "rro"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('subobj_type', (YLeaf(YType.uint8, 'subobj-type'), ['int'])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv4_prefix_len', (YLeaf(YType.uint32, 'ipv4-prefix-len'), ['int'])),
                            ('strict', (YLeaf(YType.boolean, 'strict'), ['bool'])),
                            ('global_', (YLeaf(YType.boolean, 'global'), ['bool'])),
                            ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ('segment_id_type', (YLeaf(YType.enumeration, 'segment-id-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceSrSid', '')])),
                            ('only_valid_mpls_label', (YLeaf(YType.boolean, 'only-valid-mpls-label'), ['bool'])),
                            ('complete_mpls_label_entry', (YLeaf(YType.boolean, 'complete-mpls-label-entry'), ['bool'])),
                            ('missing_segment_id', (YLeaf(YType.boolean, 'missing-segment-id'), ['bool'])),
                            ('missing_node_adjcency_id', (YLeaf(YType.boolean, 'missing-node-adjcency-id'), ['bool'])),
                            ('segment_id_exists', (YLeaf(YType.boolean, 'segment-id-exists'), ['bool'])),
                            ('segment_id_value', (YLeaf(YType.uint32, 'segment-id-value'), ['int'])),
                            ('node_adjacency_id_exists', (YLeaf(YType.boolean, 'node-adjacency-id-exists'), ['bool'])),
                            ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.subobj_type = None
                        self.ipv4_address = None
                        self.ipv4_prefix_len = None
                        self.strict = None
                        self.global_ = None
                        self.mpls_label = None
                        self.segment_id_type = None
                        self.only_valid_mpls_label = None
                        self.complete_mpls_label_entry = None
                        self.missing_segment_id = None
                        self.missing_node_adjcency_id = None
                        self.segment_id_exists = None
                        self.segment_id_value = None
                        self.node_adjacency_id_exists = None
                        self.node_id = None
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "subobject"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/rro/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsPceStdby.Lsps.Paths.Rro.Subobject, ['subobj_type', 'ipv4_address', 'ipv4_prefix_len', 'strict', 'global_', 'mpls_label', 'segment_id_type', 'only_valid_mpls_label', 'complete_mpls_label_entry', 'missing_segment_id', 'missing_node_adjcency_id', 'segment_id_exists', 'segment_id_value', 'node_adjacency_id_exists', 'node_id', 'local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsPceStdby.Lsps.Paths.Rro.Subobject']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Paths.Rro']['meta_info']


            class Metric(_Entity_):
                """
                List of Metrics
                
                .. attribute:: type
                
                	Type
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: cost
                
                	Cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Lsps.Paths.Metric, self).__init__()

                    self.yang_name = "metric"
                    self.yang_parent_name = "paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.uint8, 'type'), ['int'])),
                        ('cost', (YLeaf(YType.uint32, 'cost'), ['int'])),
                    ])
                    self.type = None
                    self.cost = None
                    self._segment_path = lambda: "metric"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/lsps/paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Lsps.Paths.Metric, ['type', 'cost'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Lsps.Paths.Metric']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Lsps.Paths']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPceStdby.Lsps']['meta_info']


    class Statistics(_Entity_):
        """
        PCE stats info
        
        .. attribute:: igp_statistics
        
        	IGP Statistics
        	**type**\:  :py:class:`IgpStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics.IgpStatistics>`
        
        	**config**\: False
        
        .. attribute:: neighbors
        
        	Neighbor Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: tunnels
        
        	Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_total
        
        	Total number of PCEReq
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_pending
        
        	Number of pending req
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: pce_req_timed_out
        
        	Number of timedout req
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_file_descriptors
        
        	Maximum number of TCP file descriptors used
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_file_descriptors
        
        	Number of TCP file descriptors currently in use
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_pceq_length
        
        	Current PCE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_teq_length
        
        	Current TE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_pceq_length
        
        	Max PCE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: max_teq_length
        
        	Max TE queue length
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: maximum_in_queue_depth
        
        	Max Input Queue Depth
        	**type**\: list of  		 :py:class:`MaximumInQueueDepth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics.MaximumInQueueDepth>`
        
        	**config**\: False
        
        .. attribute:: average_in_queue_depth
        
        	Average Input Queue Depth
        	**type**\: list of  		 :py:class:`AverageInQueueDepth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Statistics.AverageInQueueDepth>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPceStdby.Statistics, self).__init__()

            self.yang_name = "statistics"
            self.yang_parent_name = "mpls-pce-stdby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-statistics", ("igp_statistics", MplsPceStdby.Statistics.IgpStatistics)), ("maximum-in-queue-depth", ("maximum_in_queue_depth", MplsPceStdby.Statistics.MaximumInQueueDepth)), ("average-in-queue-depth", ("average_in_queue_depth", MplsPceStdby.Statistics.AverageInQueueDepth))])
            self._leafs = OrderedDict([
                ('neighbors', (YLeaf(YType.uint32, 'neighbors'), ['int'])),
                ('tunnels', (YLeaf(YType.uint32, 'tunnels'), ['int'])),
                ('pce_req_total', (YLeaf(YType.uint32, 'pce-req-total'), ['int'])),
                ('pce_req_pending', (YLeaf(YType.uint32, 'pce-req-pending'), ['int'])),
                ('pce_req_timed_out', (YLeaf(YType.uint32, 'pce-req-timed-out'), ['int'])),
                ('max_file_descriptors', (YLeaf(YType.uint32, 'max-file-descriptors'), ['int'])),
                ('current_file_descriptors', (YLeaf(YType.uint32, 'current-file-descriptors'), ['int'])),
                ('current_pceq_length', (YLeaf(YType.uint32, 'current-pceq-length'), ['int'])),
                ('current_teq_length', (YLeaf(YType.uint32, 'current-teq-length'), ['int'])),
                ('max_pceq_length', (YLeaf(YType.uint32, 'max-pceq-length'), ['int'])),
                ('max_teq_length', (YLeaf(YType.uint32, 'max-teq-length'), ['int'])),
            ])
            self.neighbors = None
            self.tunnels = None
            self.pce_req_total = None
            self.pce_req_pending = None
            self.pce_req_timed_out = None
            self.max_file_descriptors = None
            self.current_file_descriptors = None
            self.current_pceq_length = None
            self.current_teq_length = None
            self.max_pceq_length = None
            self.max_teq_length = None

            self.igp_statistics = MplsPceStdby.Statistics.IgpStatistics()
            self.igp_statistics.parent = self
            self._children_name_map["igp_statistics"] = "igp-statistics"

            self.maximum_in_queue_depth = YList(self)
            self.average_in_queue_depth = YList(self)
            self._segment_path = lambda: "statistics"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPceStdby.Statistics, ['neighbors', 'tunnels', 'pce_req_total', 'pce_req_pending', 'pce_req_timed_out', 'max_file_descriptors', 'current_file_descriptors', 'current_pceq_length', 'current_teq_length', 'max_pceq_length', 'max_teq_length'], name, value)


        class IgpStatistics(_Entity_):
            """
            IGP Statistics
            
            .. attribute:: abr_lookup_min
            
            	ABR Lookup Min
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_max
            
            	ABR Lookup Max
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_avg
            
            	ABR Lookup Avg
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_timeout
            
            	ABR Lookup Timeout
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: abr_lookup_complete
            
            	ABR Lookup Complete
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Statistics.IgpStatistics, self).__init__()

                self.yang_name = "igp-statistics"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('abr_lookup_min', (YLeaf(YType.uint64, 'abr-lookup-min'), ['int'])),
                    ('abr_lookup_max', (YLeaf(YType.uint64, 'abr-lookup-max'), ['int'])),
                    ('abr_lookup_avg', (YLeaf(YType.uint64, 'abr-lookup-avg'), ['int'])),
                    ('abr_lookup_timeout', (YLeaf(YType.uint64, 'abr-lookup-timeout'), ['int'])),
                    ('abr_lookup_complete', (YLeaf(YType.uint64, 'abr-lookup-complete'), ['int'])),
                ])
                self.abr_lookup_min = None
                self.abr_lookup_max = None
                self.abr_lookup_avg = None
                self.abr_lookup_timeout = None
                self.abr_lookup_complete = None
                self._segment_path = lambda: "igp-statistics"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Statistics.IgpStatistics, ['abr_lookup_min', 'abr_lookup_max', 'abr_lookup_avg', 'abr_lookup_timeout', 'abr_lookup_complete'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Statistics.IgpStatistics']['meta_info']


        class MaximumInQueueDepth(_Entity_):
            """
            Max Input Queue Depth
            
            .. attribute:: entry
            
            	Max Input Queue Depth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Statistics.MaximumInQueueDepth, self).__init__()

                self.yang_name = "maximum-in-queue-depth"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                ])
                self.entry = None
                self._segment_path = lambda: "maximum-in-queue-depth"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Statistics.MaximumInQueueDepth, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Statistics.MaximumInQueueDepth']['meta_info']


        class AverageInQueueDepth(_Entity_):
            """
            Average Input Queue Depth
            
            .. attribute:: entry
            
            	Average Input Queue Depth
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Statistics.AverageInQueueDepth, self).__init__()

                self.yang_name = "average-in-queue-depth"
                self.yang_parent_name = "statistics"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                ])
                self.entry = None
                self._segment_path = lambda: "average-in-queue-depth"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/statistics/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Statistics.AverageInQueueDepth, ['entry'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Statistics.AverageInQueueDepth']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPceStdby.Statistics']['meta_info']


    class Peers(_Entity_):
        """
        The set of PCE peers
        
        .. attribute:: peer
        
        	A PCE peer
        	**type**\: list of  		 :py:class:`Peer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPceStdby.Peers, self).__init__()

            self.yang_name = "peers"
            self.yang_parent_name = "mpls-pce-stdby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("peer", ("peer", MplsPceStdby.Peers.Peer))])
            self._leafs = OrderedDict()

            self.peer = YList(self)
            self._segment_path = lambda: "peers"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPceStdby.Peers, [], name, value)


        class Peer(_Entity_):
            """
            A PCE peer
            
            .. attribute:: peer_address  (key)
            
            	The peer address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: last_tx_pce_err
            
            	Last sent PCEErr
            	**type**\:  :py:class:`LastTxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.LastTxPceErr>`
            
            	**config**\: False
            
            .. attribute:: last_rx_pce_err
            
            	Last received PCEErr
            	**type**\:  :py:class:`LastRxPceErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.LastRxPceErr>`
            
            	**config**\: False
            
            .. attribute:: error
            
            	Error (for display only)
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: pce_state
            
            	PCE State
            	**type**\:  :py:class:`PceState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceState>`
            
            	**config**\: False
            
            .. attribute:: precedence
            
            	PCE Precedence
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: stateful
            
            	Stateful
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_update
            
            	Update capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_instantiate
            
            	Instantiation capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_segment_routing
            
            	Segment Routing capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: triggered_sync_capability
            
            	Triggered Synchronization capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: capability_db_version
            
            	DB version capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: delta_sync_capability
            
            	Delta Synchronization capability
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: pcep_up_time
            
            	PCEP Up Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: keepalives
            
            	Keepalive count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: candidate
            
            	Candidate
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: statically_configured
            
            	Statically Configured
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: md5_enabled
            
            	MD5 Authentication Enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: keychain_enabled
            
            	Keychain based Authentication Enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: negotiated_keepalive
            
            	Negotiated KA
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: negotated_dead_time
            
            	Negotiated DT
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_req_rx
            
            	PCEReq Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_req_tx
            
            	PCEReq Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rep_rx
            
            	PCERep Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rep_tx
            
            	PCERep Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_err_rx
            
            	PCEErr Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_err_tx
            
            	PCEErr Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_open_tx
            
            	PCEOpen Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_open_rx
            
            	PCEOpen Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rpt_rx
            
            	PCERpt Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_rpt_tx
            
            	PCERpt Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_upd_rx
            
            	PCEUpd Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_upd_tx
            
            	PCEUpd Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_init_rx
            
            	PCEInit Rx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_init_tx
            
            	PCEInit Tx
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: pce_keepalive_tx
            
            	PCE Keepalive Tx
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: pce_keepalive_rx
            
            	PCE Keepalive Rx
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_min
            
            	Mininum reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_max
            
            	Maximum reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: req_reply_avg
            
            	Average reply time from peer in ms
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: request_timeouts
            
            	Request timeout count
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: local_sid
            
            	Local PCEP session ID
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: remote_sid
            
            	Remote PCEP session ID
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: min_keepalive_interval
            
            	Minimum keepalive interval for the peer
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: max_dead_interval
            
            	Maximum dead interval for the peer
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: ig_ps
            
            	IGPs
            	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Peers.Peer.IgPs>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Peers.Peer, self).__init__()

                self.yang_name = "peer"
                self.yang_parent_name = "peers"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['peer_address']
                self._child_classes = OrderedDict([("last-tx-pce-err", ("last_tx_pce_err", MplsPceStdby.Peers.Peer.LastTxPceErr)), ("last-rx-pce-err", ("last_rx_pce_err", MplsPceStdby.Peers.Peer.LastRxPceErr)), ("ig-ps", ("ig_ps", MplsPceStdby.Peers.Peer.IgPs))])
                self._leafs = OrderedDict([
                    ('peer_address', (YLeaf(YType.str, 'peer-address'), ['str'])),
                    ('error', (YLeaf(YType.str, 'error'), ['str'])),
                    ('pce_state', (YLeaf(YType.enumeration, 'pce-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceState', '')])),
                    ('precedence', (YLeaf(YType.uint32, 'precedence'), ['int'])),
                    ('stateful', (YLeaf(YType.boolean, 'stateful'), ['bool'])),
                    ('capability_update', (YLeaf(YType.boolean, 'capability-update'), ['bool'])),
                    ('capability_instantiate', (YLeaf(YType.boolean, 'capability-instantiate'), ['bool'])),
                    ('capability_segment_routing', (YLeaf(YType.boolean, 'capability-segment-routing'), ['bool'])),
                    ('triggered_sync_capability', (YLeaf(YType.boolean, 'triggered-sync-capability'), ['bool'])),
                    ('capability_db_version', (YLeaf(YType.boolean, 'capability-db-version'), ['bool'])),
                    ('delta_sync_capability', (YLeaf(YType.boolean, 'delta-sync-capability'), ['bool'])),
                    ('pcep_up_time', (YLeaf(YType.uint32, 'pcep-up-time'), ['int'])),
                    ('keepalives', (YLeaf(YType.uint32, 'keepalives'), ['int'])),
                    ('candidate', (YLeaf(YType.boolean, 'candidate'), ['bool'])),
                    ('statically_configured', (YLeaf(YType.boolean, 'statically-configured'), ['bool'])),
                    ('md5_enabled', (YLeaf(YType.boolean, 'md5-enabled'), ['bool'])),
                    ('keychain_enabled', (YLeaf(YType.boolean, 'keychain-enabled'), ['bool'])),
                    ('negotiated_keepalive', (YLeaf(YType.uint32, 'negotiated-keepalive'), ['int'])),
                    ('negotated_dead_time', (YLeaf(YType.uint32, 'negotated-dead-time'), ['int'])),
                    ('pce_req_rx', (YLeaf(YType.uint32, 'pce-req-rx'), ['int'])),
                    ('pce_req_tx', (YLeaf(YType.uint32, 'pce-req-tx'), ['int'])),
                    ('pce_rep_rx', (YLeaf(YType.uint32, 'pce-rep-rx'), ['int'])),
                    ('pce_rep_tx', (YLeaf(YType.uint32, 'pce-rep-tx'), ['int'])),
                    ('pce_err_rx', (YLeaf(YType.uint32, 'pce-err-rx'), ['int'])),
                    ('pce_err_tx', (YLeaf(YType.uint32, 'pce-err-tx'), ['int'])),
                    ('pce_open_tx', (YLeaf(YType.uint32, 'pce-open-tx'), ['int'])),
                    ('pce_open_rx', (YLeaf(YType.uint32, 'pce-open-rx'), ['int'])),
                    ('pce_rpt_rx', (YLeaf(YType.uint32, 'pce-rpt-rx'), ['int'])),
                    ('pce_rpt_tx', (YLeaf(YType.uint32, 'pce-rpt-tx'), ['int'])),
                    ('pce_upd_rx', (YLeaf(YType.uint32, 'pce-upd-rx'), ['int'])),
                    ('pce_upd_tx', (YLeaf(YType.uint32, 'pce-upd-tx'), ['int'])),
                    ('pce_init_rx', (YLeaf(YType.uint32, 'pce-init-rx'), ['int'])),
                    ('pce_init_tx', (YLeaf(YType.uint32, 'pce-init-tx'), ['int'])),
                    ('pce_keepalive_tx', (YLeaf(YType.uint64, 'pce-keepalive-tx'), ['int'])),
                    ('pce_keepalive_rx', (YLeaf(YType.uint64, 'pce-keepalive-rx'), ['int'])),
                    ('req_reply_min', (YLeaf(YType.uint64, 'req-reply-min'), ['int'])),
                    ('req_reply_max', (YLeaf(YType.uint64, 'req-reply-max'), ['int'])),
                    ('req_reply_avg', (YLeaf(YType.uint64, 'req-reply-avg'), ['int'])),
                    ('request_timeouts', (YLeaf(YType.uint64, 'request-timeouts'), ['int'])),
                    ('local_sid', (YLeaf(YType.uint8, 'local-sid'), ['int'])),
                    ('remote_sid', (YLeaf(YType.uint8, 'remote-sid'), ['int'])),
                    ('min_keepalive_interval', (YLeaf(YType.uint8, 'min-keepalive-interval'), ['int'])),
                    ('max_dead_interval', (YLeaf(YType.uint8, 'max-dead-interval'), ['int'])),
                ])
                self.peer_address = None
                self.error = None
                self.pce_state = None
                self.precedence = None
                self.stateful = None
                self.capability_update = None
                self.capability_instantiate = None
                self.capability_segment_routing = None
                self.triggered_sync_capability = None
                self.capability_db_version = None
                self.delta_sync_capability = None
                self.pcep_up_time = None
                self.keepalives = None
                self.candidate = None
                self.statically_configured = None
                self.md5_enabled = None
                self.keychain_enabled = None
                self.negotiated_keepalive = None
                self.negotated_dead_time = None
                self.pce_req_rx = None
                self.pce_req_tx = None
                self.pce_rep_rx = None
                self.pce_rep_tx = None
                self.pce_err_rx = None
                self.pce_err_tx = None
                self.pce_open_tx = None
                self.pce_open_rx = None
                self.pce_rpt_rx = None
                self.pce_rpt_tx = None
                self.pce_upd_rx = None
                self.pce_upd_tx = None
                self.pce_init_rx = None
                self.pce_init_tx = None
                self.pce_keepalive_tx = None
                self.pce_keepalive_rx = None
                self.req_reply_min = None
                self.req_reply_max = None
                self.req_reply_avg = None
                self.request_timeouts = None
                self.local_sid = None
                self.remote_sid = None
                self.min_keepalive_interval = None
                self.max_dead_interval = None

                self.last_tx_pce_err = MplsPceStdby.Peers.Peer.LastTxPceErr()
                self.last_tx_pce_err.parent = self
                self._children_name_map["last_tx_pce_err"] = "last-tx-pce-err"

                self.last_rx_pce_err = MplsPceStdby.Peers.Peer.LastRxPceErr()
                self.last_rx_pce_err.parent = self
                self._children_name_map["last_rx_pce_err"] = "last-rx-pce-err"

                self.ig_ps = YList(self)
                self._segment_path = lambda: "peer" + "[peer-address='" + str(self.peer_address) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/peers/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Peers.Peer, ['peer_address', 'error', 'pce_state', 'precedence', 'stateful', 'capability_update', 'capability_instantiate', 'capability_segment_routing', 'triggered_sync_capability', 'capability_db_version', 'delta_sync_capability', 'pcep_up_time', 'keepalives', 'candidate', 'statically_configured', 'md5_enabled', 'keychain_enabled', 'negotiated_keepalive', 'negotated_dead_time', 'pce_req_rx', 'pce_req_tx', 'pce_rep_rx', 'pce_rep_tx', 'pce_err_rx', 'pce_err_tx', 'pce_open_tx', 'pce_open_rx', 'pce_rpt_rx', 'pce_rpt_tx', 'pce_upd_rx', 'pce_upd_tx', 'pce_init_rx', 'pce_init_tx', 'pce_keepalive_tx', 'pce_keepalive_rx', 'req_reply_min', 'req_reply_max', 'req_reply_avg', 'request_timeouts', 'local_sid', 'remote_sid', 'min_keepalive_interval', 'max_dead_interval'], name, value)


            class LastTxPceErr(_Entity_):
                """
                Last sent PCEErr
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Peers.Peer.LastTxPceErr, self).__init__()

                    self.yang_name = "last-tx-pce-err"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pce_err_type', (YLeaf(YType.uint32, 'pce-err-type'), ['int'])),
                        ('pce_err_value', (YLeaf(YType.uint32, 'pce-err-value'), ['int'])),
                        ('has_open_object', (YLeaf(YType.boolean, 'has-open-object'), ['bool'])),
                        ('openversion', (YLeaf(YType.uint32, 'openversion'), ['int'])),
                        ('open_keepalive', (YLeaf(YType.uint32, 'open-keepalive'), ['int'])),
                        ('open_dead_time', (YLeaf(YType.uint32, 'open-dead-time'), ['int'])),
                        ('has_rp_object', (YLeaf(YType.boolean, 'has-rp-object'), ['bool'])),
                        ('rp_request_id', (YLeaf(YType.uint32, 'rp-request-id'), ['int'])),
                    ])
                    self.pce_err_type = None
                    self.pce_err_value = None
                    self.has_open_object = None
                    self.openversion = None
                    self.open_keepalive = None
                    self.open_dead_time = None
                    self.has_rp_object = None
                    self.rp_request_id = None
                    self._segment_path = lambda: "last-tx-pce-err"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Peers.Peer.LastTxPceErr, ['pce_err_type', 'pce_err_value', 'has_open_object', 'openversion', 'open_keepalive', 'open_dead_time', 'has_rp_object', 'rp_request_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Peers.Peer.LastTxPceErr']['meta_info']


            class LastRxPceErr(_Entity_):
                """
                Last received PCEErr
                
                .. attribute:: pce_err_type
                
                	PCE Error Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pce_err_value
                
                	PCE Error Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: has_open_object
                
                	Has Open object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: openversion
                
                	Open Version
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: open_keepalive
                
                	Open Keepalive (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: open_dead_time
                
                	Open Deadtime (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: has_rp_object
                
                	Has RP object
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rp_request_id
                
                	RP request ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Peers.Peer.LastRxPceErr, self).__init__()

                    self.yang_name = "last-rx-pce-err"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pce_err_type', (YLeaf(YType.uint32, 'pce-err-type'), ['int'])),
                        ('pce_err_value', (YLeaf(YType.uint32, 'pce-err-value'), ['int'])),
                        ('has_open_object', (YLeaf(YType.boolean, 'has-open-object'), ['bool'])),
                        ('openversion', (YLeaf(YType.uint32, 'openversion'), ['int'])),
                        ('open_keepalive', (YLeaf(YType.uint32, 'open-keepalive'), ['int'])),
                        ('open_dead_time', (YLeaf(YType.uint32, 'open-dead-time'), ['int'])),
                        ('has_rp_object', (YLeaf(YType.boolean, 'has-rp-object'), ['bool'])),
                        ('rp_request_id', (YLeaf(YType.uint32, 'rp-request-id'), ['int'])),
                    ])
                    self.pce_err_type = None
                    self.pce_err_value = None
                    self.has_open_object = None
                    self.openversion = None
                    self.open_keepalive = None
                    self.open_dead_time = None
                    self.has_rp_object = None
                    self.rp_request_id = None
                    self._segment_path = lambda: "last-rx-pce-err"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Peers.Peer.LastRxPceErr, ['pce_err_type', 'pce_err_value', 'has_open_object', 'openversion', 'open_keepalive', 'open_dead_time', 'has_rp_object', 'rp_request_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Peers.Peer.LastRxPceErr']['meta_info']


            class IgPs(_Entity_):
                """
                IGPs
                
                .. attribute:: igp_type
                
                	Type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance_id
                
                	Instance ID
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Peers.Peer.IgPs, self).__init__()

                    self.yang_name = "ig-ps"
                    self.yang_parent_name = "peer"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance_id', (YLeaf(YType.str, 'igp-instance-id'), ['str'])),
                    ])
                    self.igp_type = None
                    self.igp_instance_id = None
                    self._segment_path = lambda: "ig-ps"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Peers.Peer.IgPs, ['igp_type', 'igp_instance_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Peers.Peer.IgPs']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Peers.Peer']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPceStdby.Peers']['meta_info']


    class Topology(_Entity_):
        """
        The topology information in PCE
        
        .. attribute:: global_
        
        	The global information of the overall  topology
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology.Global>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPceStdby.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-pce-stdby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsPceStdby.Topology.Global))])
            self._leafs = OrderedDict()

            self.global_ = MplsPceStdby.Topology.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._segment_path = lambda: "topology"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPceStdby.Topology, [], name, value)


        class Global(_Entity_):
            """
            The global information of the overall  topology
            
            .. attribute:: nodes
            
            	Node information
            	**type**\: list of  		 :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Topology.Global.Nodes>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Topology.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nodes", ("nodes", MplsPceStdby.Topology.Global.Nodes))])
                self._leafs = OrderedDict()

                self.nodes = YList(self)
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Topology.Global, [], name, value)


            class Nodes(_Entity_):
                """
                Node information
                
                .. attribute:: router_id
                
                	Router ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: igp_area_id
                
                	IGP Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: pce_cost
                
                	PCE cost
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_id
                
                	Node ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_pce_border_node
                
                	PCE border node
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsPceStdby.Topology.Global.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "global"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                        ('igp_area_id', (YLeaf(YType.uint32, 'igp-area-id'), ['int'])),
                        ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('pce_cost', (YLeaf(YType.uint32, 'pce-cost'), ['int'])),
                        ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ('is_pce_border_node', (YLeaf(YType.boolean, 'is-pce-border-node'), ['bool'])),
                    ])
                    self.router_id = None
                    self.igp_area_id = None
                    self.igp_area_format = None
                    self.pce_cost = None
                    self.node_id = None
                    self.is_pce_border_node = None
                    self._segment_path = lambda: "nodes"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/topology/global/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsPceStdby.Topology.Global.Nodes, ['router_id', 'igp_area_id', 'igp_area_format', 'pce_cost', 'node_id', 'is_pce_border_node'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsPceStdby.Topology.Global.Nodes']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Topology.Global']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPceStdby.Topology']['meta_info']


    class Tunnels(_Entity_):
        """
        Table of PCE tunnels
        
        .. attribute:: tunnel
        
        	Information of a PCE tunnel
        	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsPceStdby.Tunnels.Tunnel>`
        
        	**config**\: False
        
        .. attribute:: source_address
        
        	Source Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: destination_address
        
        	Destination Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: is_curr_path_option_pce
        
        	True if current path option is PCE based
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: curr_path_option_index
        
        	Path Option Index of the current path
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: configured_pce_address
        
        	Configured PCE Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: sender_pce_address
        
        	Sender PCE Address
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: path_state
        
        	Path Request State
        	**type**\:  :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
        
        	**config**\: False
        
        .. attribute:: tunnel_state
        
        	Tunnel State
        	**type**\:  :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
        
        	**config**\: False
        
        .. attribute:: admin_weight
        
        	Path metric
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: hop_count
        
        	Hop Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsPceStdby.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-pce-stdby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsPceStdby.Tunnels.Tunnel))])
            self._leafs = OrderedDict([
                ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                ('is_curr_path_option_pce', (YLeaf(YType.boolean, 'is-curr-path-option-pce'), ['bool'])),
                ('curr_path_option_index', (YLeaf(YType.uint32, 'curr-path-option-index'), ['int'])),
                ('configured_pce_address', (YLeaf(YType.str, 'configured-pce-address'), ['str'])),
                ('sender_pce_address', (YLeaf(YType.str, 'sender-pce-address'), ['str'])),
                ('path_state', (YLeaf(YType.enumeration, 'path-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunPathState', '')])),
                ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunnelState', '')])),
                ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                ('hop_count', (YLeaf(YType.uint32, 'hop-count'), ['int'])),
            ])
            self.source_address = None
            self.destination_address = None
            self.is_curr_path_option_pce = None
            self.curr_path_option_index = None
            self.configured_pce_address = None
            self.sender_pce_address = None
            self.path_state = None
            self.tunnel_state = None
            self.admin_weight = None
            self.hop_count = None

            self.tunnel = YList(self)
            self._segment_path = lambda: "tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsPceStdby.Tunnels, ['source_address', 'destination_address', 'is_curr_path_option_pce', 'curr_path_option_index', 'configured_pce_address', 'sender_pce_address', 'path_state', 'tunnel_state', 'admin_weight', 'hop_count'], name, value)


        class Tunnel(_Entity_):
            """
            Information of a PCE tunnel
            
            .. attribute:: tunnel_name  (key)
            
            	Tunnel Name
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: source_address
            
            	Source Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: destination_address
            
            	Destination Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_curr_path_option_pce
            
            	True if current path option is PCE based
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: curr_path_option_index
            
            	Path Option Index of the current path
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: configured_pce_address
            
            	Configured PCE Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: sender_pce_address
            
            	Sender PCE Address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: path_state
            
            	Path Request State
            	**type**\:  :py:class:`PceTunPathState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunPathState>`
            
            	**config**\: False
            
            .. attribute:: tunnel_state
            
            	Tunnel State
            	**type**\:  :py:class:`PceTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.PceTunnelState>`
            
            	**config**\: False
            
            .. attribute:: admin_weight
            
            	Path metric
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: hop_count
            
            	Hop Count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsPceStdby.Tunnels.Tunnel, self).__init__()

                self.yang_name = "tunnel"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['tunnel_name']
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                    ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('is_curr_path_option_pce', (YLeaf(YType.boolean, 'is-curr-path-option-pce'), ['bool'])),
                    ('curr_path_option_index', (YLeaf(YType.uint32, 'curr-path-option-index'), ['int'])),
                    ('configured_pce_address', (YLeaf(YType.str, 'configured-pce-address'), ['str'])),
                    ('sender_pce_address', (YLeaf(YType.str, 'sender-pce-address'), ['str'])),
                    ('path_state', (YLeaf(YType.enumeration, 'path-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunPathState', '')])),
                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'PceTunnelState', '')])),
                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                    ('hop_count', (YLeaf(YType.uint32, 'hop-count'), ['int'])),
                ])
                self.tunnel_name = None
                self.source_address = None
                self.destination_address = None
                self.is_curr_path_option_pce = None
                self.curr_path_option_index = None
                self.configured_pce_address = None
                self.sender_pce_address = None
                self.path_state = None
                self.tunnel_state = None
                self.admin_weight = None
                self.hop_count = None
                self._segment_path = lambda: "tunnel" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-pce-stdby/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsPceStdby.Tunnels.Tunnel, ['tunnel_name', 'source_address', 'destination_address', 'is_curr_path_option_pce', 'curr_path_option_index', 'configured_pce_address', 'sender_pce_address', 'path_state', 'tunnel_state', 'admin_weight', 'hop_count'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsPceStdby.Tunnels.Tunnel']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsPceStdby.Tunnels']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsPceStdby()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsPceStdby']['meta_info']


class MplsTp(_Entity_):
    """
    mpls tp
    
    .. attribute:: tp_links
    
    	Transport profile links
    	**type**\:  :py:class:`TpLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks>`
    
    	**config**\: False
    
    .. attribute:: tp_tunnels
    
    	Transport profile tunnels
    	**type**\:  :py:class:`TpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels>`
    
    	**config**\: False
    
    .. attribute:: tp_midpoints
    
    	Transport profile mid\-point
    	**type**\:  :py:class:`TpMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints>`
    
    	**config**\: False
    
    .. attribute:: tp_global_parameters
    
    	Transport profile global parameters
    	**type**\:  :py:class:`TpGlobalParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpGlobalParameters>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsTp, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-tp"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("tp-links", ("tp_links", MplsTp.TpLinks)), ("tp-tunnels", ("tp_tunnels", MplsTp.TpTunnels)), ("tp-midpoints", ("tp_midpoints", MplsTp.TpMidpoints)), ("tp-global-parameters", ("tp_global_parameters", MplsTp.TpGlobalParameters))])
        self._leafs = OrderedDict()

        self.tp_links = MplsTp.TpLinks()
        self.tp_links.parent = self
        self._children_name_map["tp_links"] = "tp-links"

        self.tp_tunnels = MplsTp.TpTunnels()
        self.tp_tunnels.parent = self
        self._children_name_map["tp_tunnels"] = "tp-tunnels"

        self.tp_midpoints = MplsTp.TpMidpoints()
        self.tp_midpoints.parent = self
        self._children_name_map["tp_midpoints"] = "tp-midpoints"

        self.tp_global_parameters = MplsTp.TpGlobalParameters()
        self.tp_global_parameters.parent = self
        self._children_name_map["tp_global_parameters"] = "tp-global-parameters"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsTp, [], name, value)


    class TpLinks(_Entity_):
        """
        Transport profile links
        
        .. attribute:: tp_detail_links
        
        	Detailed table of transport profile links
        	**type**\:  :py:class:`TpDetailLinks <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpDetailLinks>`
        
        	**config**\: False
        
        .. attribute:: tp_link_summary
        
        	Summary of transport profile links
        	**type**\:  :py:class:`TpLinkSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinkSummary>`
        
        	**config**\: False
        
        .. attribute:: tp_links
        
        	Table of transport profile links
        	**type**\:  :py:class:`TpLinks_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinks_>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTp.TpLinks, self).__init__()

            self.yang_name = "tp-links"
            self.yang_parent_name = "mpls-tp"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tp-detail-links", ("tp_detail_links", MplsTp.TpLinks.TpDetailLinks)), ("tp-link-summary", ("tp_link_summary", MplsTp.TpLinks.TpLinkSummary)), ("tp-links", ("tp_links", MplsTp.TpLinks.TpLinks_))])
            self._leafs = OrderedDict()

            self.tp_detail_links = MplsTp.TpLinks.TpDetailLinks()
            self.tp_detail_links.parent = self
            self._children_name_map["tp_detail_links"] = "tp-detail-links"

            self.tp_link_summary = MplsTp.TpLinks.TpLinkSummary()
            self.tp_link_summary.parent = self
            self._children_name_map["tp_link_summary"] = "tp-link-summary"

            self.tp_links = MplsTp.TpLinks.TpLinks_()
            self.tp_links.parent = self
            self._children_name_map["tp_links"] = "tp-links"
            self._segment_path = lambda: "tp-links"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTp.TpLinks, [], name, value)


        class TpDetailLinks(_Entity_):
            """
            Detailed table of transport profile links
            
            .. attribute:: tp_detail_link
            
            	Detailed information of transport profile link
            	**type**\: list of  		 :py:class:`TpDetailLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpDetailLinks.TpDetailLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpLinks.TpDetailLinks, self).__init__()

                self.yang_name = "tp-detail-links"
                self.yang_parent_name = "tp-links"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-detail-link", ("tp_detail_link", MplsTp.TpLinks.TpDetailLinks.TpDetailLink))])
                self._leafs = OrderedDict()

                self.tp_detail_link = YList(self)
                self._segment_path = lambda: "tp-detail-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpLinks.TpDetailLinks, [], name, value)


            class TpDetailLink(_Entity_):
                """
                Detailed information of transport profile link
                
                .. attribute:: tp_link_id  (key)
                
                	Numeric transport profile link identifier
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: interface
                
                	Deprecated
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: link_state
                
                	Deprecated
                	**type**\:  :py:class:`TpLinkState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpLinkState>`
                
                	**config**\: False
                
                .. attribute:: ls_ps
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reserved_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: unsupported_linecard
                
                	Deprecated
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpLinks.TpDetailLinks.TpDetailLink, self).__init__()

                    self.yang_name = "tp-detail-link"
                    self.yang_parent_name = "tp-detail-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_link_id']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tp_link_id', (YLeaf(YType.uint32, 'tp-link-id'), ['int'])),
                        ('link_id', (YLeaf(YType.uint32, 'link-id'), ['int'])),
                        ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('link_state', (YLeaf(YType.enumeration, 'link-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpLinkState', '')])),
                        ('ls_ps', (YLeaf(YType.uint32, 'ls-ps'), ['int'])),
                        ('reserved_bandwidth', (YLeaf(YType.uint64, 'reserved-bandwidth'), ['int'])),
                        ('available_bandwidth', (YLeaf(YType.uint64, 'available-bandwidth'), ['int'])),
                        ('unsupported_linecard', (YLeaf(YType.boolean, 'unsupported-linecard'), ['bool'])),
                    ])
                    self.tp_link_id = None
                    self.link_id = None
                    self.interface = None
                    self.next_hop_address = None
                    self.link_state = None
                    self.ls_ps = None
                    self.reserved_bandwidth = None
                    self.available_bandwidth = None
                    self.unsupported_linecard = None
                    self._segment_path = lambda: "tp-detail-link" + "[tp-link-id='" + str(self.tp_link_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/tp-detail-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpLinks.TpDetailLinks.TpDetailLink, ['tp_link_id', 'link_id', 'interface', 'next_hop_address', 'link_state', 'ls_ps', 'reserved_bandwidth', 'available_bandwidth', 'unsupported_linecard'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpLinks.TpDetailLinks.TpDetailLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpLinks.TpDetailLinks']['meta_info']


        class TpLinkSummary(_Entity_):
            """
            Summary of transport profile links
            
            .. attribute:: links
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpLinks.TpLinkSummary, self).__init__()

                self.yang_name = "tp-link-summary"
                self.yang_parent_name = "tp-links"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('links', (YLeaf(YType.uint32, 'links'), ['int'])),
                ])
                self.links = None
                self._segment_path = lambda: "tp-link-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpLinks.TpLinkSummary, ['links'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpLinks.TpLinkSummary']['meta_info']


        class TpLinks_(_Entity_):
            """
            Table of transport profile links
            
            .. attribute:: tp_link
            
            	Brief information of transport profile link
            	**type**\: list of  		 :py:class:`TpLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpLinks.TpLinks_.TpLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpLinks.TpLinks_, self).__init__()

                self.yang_name = "tp-links"
                self.yang_parent_name = "tp-links"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-link", ("tp_link", MplsTp.TpLinks.TpLinks_.TpLink))])
                self._leafs = OrderedDict()

                self.tp_link = YList(self)
                self._segment_path = lambda: "tp-links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpLinks.TpLinks_, [], name, value)


            class TpLink(_Entity_):
                """
                Brief information of transport profile link
                
                .. attribute:: tp_link_id  (key)
                
                	Numeric transport profile link identifier
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: link_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: interface
                
                	Deprecated
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: link_state
                
                	Deprecated
                	**type**\:  :py:class:`TpLinkState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpLinkState>`
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpLinks.TpLinks_.TpLink, self).__init__()

                    self.yang_name = "tp-link"
                    self.yang_parent_name = "tp-links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_link_id']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tp_link_id', (YLeaf(YType.uint32, 'tp-link-id'), ['int'])),
                        ('link_id', (YLeaf(YType.uint32, 'link-id'), ['int'])),
                        ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('link_state', (YLeaf(YType.enumeration, 'link-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpLinkState', '')])),
                        ('available_bandwidth', (YLeaf(YType.uint64, 'available-bandwidth'), ['int'])),
                    ])
                    self.tp_link_id = None
                    self.link_id = None
                    self.interface = None
                    self.next_hop_address = None
                    self.link_state = None
                    self.available_bandwidth = None
                    self._segment_path = lambda: "tp-link" + "[tp-link-id='" + str(self.tp_link_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-links/tp-links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpLinks.TpLinks_.TpLink, ['tp_link_id', 'link_id', 'interface', 'next_hop_address', 'link_state', 'available_bandwidth'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpLinks.TpLinks_.TpLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpLinks.TpLinks_']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTp.TpLinks']['meta_info']


    class TpTunnels(_Entity_):
        """
        Transport profile tunnels
        
        .. attribute:: tp_tunnel_summary
        
        	Summary of transport profile tunnels
        	**type**\:  :py:class:`TpTunnelSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnelSummary>`
        
        	**config**\: False
        
        .. attribute:: tp_detail_tunnels
        
        	Detailed table of transport profile tunnels
        	**type**\:  :py:class:`TpDetailTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels>`
        
        	**config**\: False
        
        .. attribute:: tp_tunnels
        
        	Table of transport profile tunnels
        	**type**\:  :py:class:`TpTunnels_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels_>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTp.TpTunnels, self).__init__()

            self.yang_name = "tp-tunnels"
            self.yang_parent_name = "mpls-tp"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tp-tunnel-summary", ("tp_tunnel_summary", MplsTp.TpTunnels.TpTunnelSummary)), ("tp-detail-tunnels", ("tp_detail_tunnels", MplsTp.TpTunnels.TpDetailTunnels)), ("tp-tunnels", ("tp_tunnels", MplsTp.TpTunnels.TpTunnels_))])
            self._leafs = OrderedDict()

            self.tp_tunnel_summary = MplsTp.TpTunnels.TpTunnelSummary()
            self.tp_tunnel_summary.parent = self
            self._children_name_map["tp_tunnel_summary"] = "tp-tunnel-summary"

            self.tp_detail_tunnels = MplsTp.TpTunnels.TpDetailTunnels()
            self.tp_detail_tunnels.parent = self
            self._children_name_map["tp_detail_tunnels"] = "tp-detail-tunnels"

            self.tp_tunnels = MplsTp.TpTunnels.TpTunnels_()
            self.tp_tunnels.parent = self
            self._children_name_map["tp_tunnels"] = "tp-tunnels"
            self._segment_path = lambda: "tp-tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTp.TpTunnels, [], name, value)


        class TpTunnelSummary(_Entity_):
            """
            Summary of transport profile tunnels
            
            .. attribute:: up_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: active_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: down_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: locked_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: active_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: down_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: locked_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_tunnels
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: down_tunnels
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: admin_down_tunnels
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: complete_fec_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: complete_fec_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bfd_session_working_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bfd_session_protect_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpTunnels.TpTunnelSummary, self).__init__()

                self.yang_name = "tp-tunnel-summary"
                self.yang_parent_name = "tp-tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('up_working_ls_ps', (YLeaf(YType.uint32, 'up-working-ls-ps'), ['int'])),
                    ('active_working_ls_ps', (YLeaf(YType.uint32, 'active-working-ls-ps'), ['int'])),
                    ('down_working_ls_ps', (YLeaf(YType.uint32, 'down-working-ls-ps'), ['int'])),
                    ('locked_working_ls_ps', (YLeaf(YType.uint32, 'locked-working-ls-ps'), ['int'])),
                    ('up_protect_ls_ps', (YLeaf(YType.uint32, 'up-protect-ls-ps'), ['int'])),
                    ('active_protect_ls_ps', (YLeaf(YType.uint32, 'active-protect-ls-ps'), ['int'])),
                    ('down_protect_ls_ps', (YLeaf(YType.uint32, 'down-protect-ls-ps'), ['int'])),
                    ('locked_protect_ls_ps', (YLeaf(YType.uint32, 'locked-protect-ls-ps'), ['int'])),
                    ('up_tunnels', (YLeaf(YType.uint32, 'up-tunnels'), ['int'])),
                    ('down_tunnels', (YLeaf(YType.uint32, 'down-tunnels'), ['int'])),
                    ('admin_down_tunnels', (YLeaf(YType.uint32, 'admin-down-tunnels'), ['int'])),
                    ('complete_fec_working_ls_ps', (YLeaf(YType.uint32, 'complete-fec-working-ls-ps'), ['int'])),
                    ('complete_fec_protect_ls_ps', (YLeaf(YType.uint32, 'complete-fec-protect-ls-ps'), ['int'])),
                    ('bfd_session_working_ls_ps', (YLeaf(YType.uint32, 'bfd-session-working-ls-ps'), ['int'])),
                    ('bfd_session_protect_ls_ps', (YLeaf(YType.uint32, 'bfd-session-protect-ls-ps'), ['int'])),
                ])
                self.up_working_ls_ps = None
                self.active_working_ls_ps = None
                self.down_working_ls_ps = None
                self.locked_working_ls_ps = None
                self.up_protect_ls_ps = None
                self.active_protect_ls_ps = None
                self.down_protect_ls_ps = None
                self.locked_protect_ls_ps = None
                self.up_tunnels = None
                self.down_tunnels = None
                self.admin_down_tunnels = None
                self.complete_fec_working_ls_ps = None
                self.complete_fec_protect_ls_ps = None
                self.bfd_session_working_ls_ps = None
                self.bfd_session_protect_ls_ps = None
                self._segment_path = lambda: "tp-tunnel-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpTunnels.TpTunnelSummary, ['up_working_ls_ps', 'active_working_ls_ps', 'down_working_ls_ps', 'locked_working_ls_ps', 'up_protect_ls_ps', 'active_protect_ls_ps', 'down_protect_ls_ps', 'locked_protect_ls_ps', 'up_tunnels', 'down_tunnels', 'admin_down_tunnels', 'complete_fec_working_ls_ps', 'complete_fec_protect_ls_ps', 'bfd_session_working_ls_ps', 'bfd_session_protect_ls_ps'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpTunnels.TpTunnelSummary']['meta_info']


        class TpDetailTunnels(_Entity_):
            """
            Detailed table of transport profile tunnels
            
            .. attribute:: tp_detail_tunnel
            
            	Detailed information of transport profile tunnel
            	**type**\: list of  		 :py:class:`TpDetailTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpTunnels.TpDetailTunnels, self).__init__()

                self.yang_name = "tp-detail-tunnels"
                self.yang_parent_name = "tp-tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-detail-tunnel", ("tp_detail_tunnel", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel))])
                self._leafs = OrderedDict()

                self.tp_detail_tunnel = YList(self)
                self._segment_path = lambda: "tp-detail-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels, [], name, value)


            class TpDetailTunnel(_Entity_):
                """
                Detailed information of transport profile
                tunnel
                
                .. attribute:: tp_tunnel_name  (key)
                
                	Tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: tunnel
                
                	Deprecated
                	**type**\:  :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel>`
                
                	**config**\: False
                
                .. attribute:: working_lsp
                
                	Deprecated
                	**type**\:  :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp>`
                
                	**config**\: False
                
                .. attribute:: protect_lsp
                
                	Deprecated
                	**type**\:  :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp>`
                
                	**config**\: False
                
                .. attribute:: oam_protection_triggers
                
                	Deprecated
                	**type**\:  :py:class:`OamProtectionTriggers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers>`
                
                	**config**\: False
                
                .. attribute:: req_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: oam_interval
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bfd_interval_active
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bfd_interval_active_in_micro_sec
                
                	Deprecated
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: bfd_multiplier_active
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bfd_interval_standby
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bfd_interval_standby_in_micro_sec
                
                	Deprecated
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: bfd_multiplier_standby
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_up_time
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: switchover_trig
                
                	Deprecated
                	**type**\:  :py:class:`MplsTpTunnelSwitchoverTrig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelSwitchoverTrig>`
                
                	**config**\: False
                
                .. attribute:: switch_over_time
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel, self).__init__()

                    self.yang_name = "tp-detail-tunnel"
                    self.yang_parent_name = "tp-detail-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_tunnel_name']
                    self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel)), ("working-lsp", ("working_lsp", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp)), ("protect-lsp", ("protect_lsp", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp)), ("oam-protection-triggers", ("oam_protection_triggers", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers))])
                    self._leafs = OrderedDict([
                        ('tp_tunnel_name', (YLeaf(YType.str, 'tp-tunnel-name'), ['str'])),
                        ('req_bandwidth', (YLeaf(YType.uint32, 'req-bandwidth'), ['int'])),
                        ('oam_interval', (YLeaf(YType.uint32, 'oam-interval'), ['int'])),
                        ('bfd_interval_active', (YLeaf(YType.uint32, 'bfd-interval-active'), ['int'])),
                        ('bfd_interval_active_in_micro_sec', (YLeaf(YType.boolean, 'bfd-interval-active-in-micro-sec'), ['bool'])),
                        ('bfd_multiplier_active', (YLeaf(YType.uint32, 'bfd-multiplier-active'), ['int'])),
                        ('bfd_interval_standby', (YLeaf(YType.uint32, 'bfd-interval-standby'), ['int'])),
                        ('bfd_interval_standby_in_micro_sec', (YLeaf(YType.boolean, 'bfd-interval-standby-in-micro-sec'), ['bool'])),
                        ('bfd_multiplier_standby', (YLeaf(YType.uint32, 'bfd-multiplier-standby'), ['int'])),
                        ('tunnel_up_time', (YLeaf(YType.uint32, 'tunnel-up-time'), ['int'])),
                        ('switchover_trig', (YLeaf(YType.enumeration, 'switchover-trig'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelSwitchoverTrig', '')])),
                        ('switch_over_time', (YLeaf(YType.uint32, 'switch-over-time'), ['int'])),
                    ])
                    self.tp_tunnel_name = None
                    self.req_bandwidth = None
                    self.oam_interval = None
                    self.bfd_interval_active = None
                    self.bfd_interval_active_in_micro_sec = None
                    self.bfd_multiplier_active = None
                    self.bfd_interval_standby = None
                    self.bfd_interval_standby_in_micro_sec = None
                    self.bfd_multiplier_standby = None
                    self.tunnel_up_time = None
                    self.switchover_trig = None
                    self.switch_over_time = None

                    self.tunnel = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel()
                    self.tunnel.parent = self
                    self._children_name_map["tunnel"] = "tunnel"

                    self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"

                    self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"

                    self.oam_protection_triggers = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers()
                    self.oam_protection_triggers.parent = self
                    self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
                    self._segment_path = lambda: "tp-detail-tunnel" + "[tp-tunnel-name='" + str(self.tp_tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/tp-detail-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel, ['tp_tunnel_name', 'req_bandwidth', 'oam_interval', 'bfd_interval_active', 'bfd_interval_active_in_micro_sec', 'bfd_multiplier_active', 'bfd_interval_standby', 'bfd_interval_standby_in_micro_sec', 'bfd_multiplier_standby', 'tunnel_up_time', 'switchover_trig', 'switch_over_time'], name, value)


                class Tunnel(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: working_lsp
                    
                    	Deprecated
                    	**type**\:  :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: protect_lsp
                    
                    	Deprecated
                    	**type**\:  :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_tunnel_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: source_node_id
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: source_global_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: destination_node_id
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_global_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: remote_tunnel_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: admin_status
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: operation_status
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_lsp
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpTunnelActiveLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelActiveLsp>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tp-detail-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("working-lsp", ("working_lsp", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp)), ("protect-lsp", ("protect_lsp", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('source_tunnel_id', (YLeaf(YType.uint32, 'source-tunnel-id'), ['int'])),
                            ('source_node_id', (YLeaf(YType.str, 'source-node-id'), ['str'])),
                            ('source_global_id', (YLeaf(YType.uint32, 'source-global-id'), ['int'])),
                            ('destination_node_id', (YLeaf(YType.str, 'destination-node-id'), ['str'])),
                            ('destination_global_id', (YLeaf(YType.uint32, 'destination-global-id'), ['int'])),
                            ('remote_tunnel_id', (YLeaf(YType.uint32, 'remote-tunnel-id'), ['int'])),
                            ('admin_status', (YLeaf(YType.enumeration, 'admin-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelState', '')])),
                            ('operation_status', (YLeaf(YType.enumeration, 'operation-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelState', '')])),
                            ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelActiveLsp', '')])),
                        ])
                        self.tunnel_name = None
                        self.source_tunnel_id = None
                        self.source_node_id = None
                        self.source_global_id = None
                        self.destination_node_id = None
                        self.destination_global_id = None
                        self.remote_tunnel_id = None
                        self.admin_status = None
                        self.operation_status = None
                        self.active_lsp = None

                        self.working_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp()
                        self.working_lsp.parent = self
                        self._children_name_map["working_lsp"] = "working-lsp"

                        self.protect_lsp = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp()
                        self.protect_lsp.parent = self
                        self._children_name_map["protect_lsp"] = "protect-lsp"
                        self._segment_path = lambda: "tunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel, ['tunnel_name', 'source_tunnel_id', 'source_node_id', 'source_global_id', 'destination_node_id', 'destination_global_id', 'remote_tunnel_id', 'admin_status', 'operation_status', 'active_lsp'], name, value)


                    class WorkingLsp(_Entity_):
                        """
                        Deprecated
                        
                        .. attribute:: lsp_id
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        	**config**\: False
                        
                        .. attribute:: lock_out
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: tx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp, self).__init__()

                            self.yang_name = "working-lsp"
                            self.yang_parent_name = "tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                                ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                                ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                            ])
                            self.lsp_id = None
                            self.state = None
                            self.lock_out = None
                            self.rx_oam_state = None
                            self.tx_oam_state = None
                            self.bfd_state = None
                            self._segment_path = lambda: "working-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.WorkingLsp']['meta_info']


                    class ProtectLsp(_Entity_):
                        """
                        Deprecated
                        
                        .. attribute:: lsp_id
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        	**config**\: False
                        
                        .. attribute:: lock_out
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: tx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp, self).__init__()

                            self.yang_name = "protect-lsp"
                            self.yang_parent_name = "tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                                ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                                ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                            ])
                            self.lsp_id = None
                            self.state = None
                            self.lock_out = None
                            self.rx_oam_state = None
                            self.tx_oam_state = None
                            self.bfd_state = None
                            self._segment_path = lambda: "protect-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel.ProtectLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.Tunnel']['meta_info']


                class WorkingLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: brief_information
                    
                    	Deprecated
                    	**type**\:  :py:class:`BriefInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation>`
                    
                    	**config**\: False
                    
                    .. attribute:: oam_refresh_interval
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tp_out_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: out_interface_name
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: out_next_hop
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reserved_bandwidth
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tp-detail-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("brief-information", ("brief_information", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation))])
                        self._leafs = OrderedDict([
                            ('oam_refresh_interval', (YLeaf(YType.uint32, 'oam-refresh-interval'), ['int'])),
                            ('tp_out_label', (YLeaf(YType.uint32, 'tp-out-label'), ['int'])),
                            ('link_id', (YLeaf(YType.uint32, 'link-id'), ['int'])),
                            ('out_interface_name', (YLeaf(YType.str, 'out-interface-name'), ['str'])),
                            ('out_next_hop', (YLeaf(YType.str, 'out-next-hop'), ['str'])),
                            ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                            ('reserved_bandwidth', (YLeaf(YType.uint32, 'reserved-bandwidth'), ['int'])),
                        ])
                        self.oam_refresh_interval = None
                        self.tp_out_label = None
                        self.link_id = None
                        self.out_interface_name = None
                        self.out_next_hop = None
                        self.in_label = None
                        self.reserved_bandwidth = None

                        self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation()
                        self.brief_information.parent = self
                        self._children_name_map["brief_information"] = "brief-information"
                        self._segment_path = lambda: "working-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp, ['oam_refresh_interval', 'tp_out_label', 'link_id', 'out_interface_name', 'out_next_hop', 'in_label', 'reserved_bandwidth'], name, value)


                    class BriefInformation(_Entity_):
                        """
                        Deprecated
                        
                        .. attribute:: lsp_id
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        	**config**\: False
                        
                        .. attribute:: lock_out
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: tx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation, self).__init__()

                            self.yang_name = "brief-information"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                                ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                                ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                            ])
                            self.lsp_id = None
                            self.state = None
                            self.lock_out = None
                            self.rx_oam_state = None
                            self.tx_oam_state = None
                            self.bfd_state = None
                            self._segment_path = lambda: "brief-information"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp.BriefInformation']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.WorkingLsp']['meta_info']


                class ProtectLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: brief_information
                    
                    	Deprecated
                    	**type**\:  :py:class:`BriefInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation>`
                    
                    	**config**\: False
                    
                    .. attribute:: oam_refresh_interval
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tp_out_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: out_interface_name
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: out_next_hop
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reserved_bandwidth
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tp-detail-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("brief-information", ("brief_information", MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation))])
                        self._leafs = OrderedDict([
                            ('oam_refresh_interval', (YLeaf(YType.uint32, 'oam-refresh-interval'), ['int'])),
                            ('tp_out_label', (YLeaf(YType.uint32, 'tp-out-label'), ['int'])),
                            ('link_id', (YLeaf(YType.uint32, 'link-id'), ['int'])),
                            ('out_interface_name', (YLeaf(YType.str, 'out-interface-name'), ['str'])),
                            ('out_next_hop', (YLeaf(YType.str, 'out-next-hop'), ['str'])),
                            ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                            ('reserved_bandwidth', (YLeaf(YType.uint32, 'reserved-bandwidth'), ['int'])),
                        ])
                        self.oam_refresh_interval = None
                        self.tp_out_label = None
                        self.link_id = None
                        self.out_interface_name = None
                        self.out_next_hop = None
                        self.in_label = None
                        self.reserved_bandwidth = None

                        self.brief_information = MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation()
                        self.brief_information.parent = self
                        self._children_name_map["brief_information"] = "brief-information"
                        self._segment_path = lambda: "protect-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp, ['oam_refresh_interval', 'tp_out_label', 'link_id', 'out_interface_name', 'out_next_hop', 'in_label', 'reserved_bandwidth'], name, value)


                    class BriefInformation(_Entity_):
                        """
                        Deprecated
                        
                        .. attribute:: lsp_id
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                        
                        	**config**\: False
                        
                        .. attribute:: lock_out
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: tx_oam_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_state
                        
                        	Deprecated
                        	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation, self).__init__()

                            self.yang_name = "brief-information"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                                ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                                ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                                ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                            ])
                            self.lsp_id = None
                            self.state = None
                            self.lock_out = None
                            self.rx_oam_state = None
                            self.tx_oam_state = None
                            self.bfd_state = None
                            self._segment_path = lambda: "brief-information"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp.BriefInformation']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.ProtectLsp']['meta_info']


                class OamProtectionTriggers(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: ais
                    
                    	Deprecated
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: ldi
                    
                    	Deprecated
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lkr
                    
                    	Deprecated
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers, self).__init__()

                        self.yang_name = "oam-protection-triggers"
                        self.yang_parent_name = "tp-detail-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('ais', (YLeaf(YType.boolean, 'ais'), ['bool'])),
                            ('ldi', (YLeaf(YType.boolean, 'ldi'), ['bool'])),
                            ('lkr', (YLeaf(YType.boolean, 'lkr'), ['bool'])),
                        ])
                        self.ais = None
                        self.ldi = None
                        self.lkr = None
                        self._segment_path = lambda: "oam-protection-triggers"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers, ['ais', 'ldi', 'lkr'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel.OamProtectionTriggers']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels.TpDetailTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpTunnels.TpDetailTunnels']['meta_info']


        class TpTunnels_(_Entity_):
            """
            Table of transport profile tunnels
            
            .. attribute:: tp_tunnel
            
            	Brief information of transport profile tunnel
            	**type**\: list of  		 :py:class:`TpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels_.TpTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpTunnels.TpTunnels_, self).__init__()

                self.yang_name = "tp-tunnels"
                self.yang_parent_name = "tp-tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-tunnel", ("tp_tunnel", MplsTp.TpTunnels.TpTunnels_.TpTunnel))])
                self._leafs = OrderedDict()

                self.tp_tunnel = YList(self)
                self._segment_path = lambda: "tp-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpTunnels.TpTunnels_, [], name, value)


            class TpTunnel(_Entity_):
                """
                Brief information of transport profile tunnel
                
                .. attribute:: tp_tunnel_name  (key)
                
                	Tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: working_lsp
                
                	Deprecated
                	**type**\:  :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp>`
                
                	**config**\: False
                
                .. attribute:: protect_lsp
                
                	Deprecated
                	**type**\:  :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Deprecated
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: source_tunnel_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_node_id
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_global_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_node_id
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_global_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: remote_tunnel_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: admin_status
                
                	Deprecated
                	**type**\:  :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                
                	**config**\: False
                
                .. attribute:: operation_status
                
                	Deprecated
                	**type**\:  :py:class:`MplsTpTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelState>`
                
                	**config**\: False
                
                .. attribute:: active_lsp
                
                	Deprecated
                	**type**\:  :py:class:`MplsTpTunnelActiveLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpTunnelActiveLsp>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpTunnels.TpTunnels_.TpTunnel, self).__init__()

                    self.yang_name = "tp-tunnel"
                    self.yang_parent_name = "tp-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_tunnel_name']
                    self._child_classes = OrderedDict([("working-lsp", ("working_lsp", MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp)), ("protect-lsp", ("protect_lsp", MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp))])
                    self._leafs = OrderedDict([
                        ('tp_tunnel_name', (YLeaf(YType.str, 'tp-tunnel-name'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('source_tunnel_id', (YLeaf(YType.uint32, 'source-tunnel-id'), ['int'])),
                        ('source_node_id', (YLeaf(YType.str, 'source-node-id'), ['str'])),
                        ('source_global_id', (YLeaf(YType.uint32, 'source-global-id'), ['int'])),
                        ('destination_node_id', (YLeaf(YType.str, 'destination-node-id'), ['str'])),
                        ('destination_global_id', (YLeaf(YType.uint32, 'destination-global-id'), ['int'])),
                        ('remote_tunnel_id', (YLeaf(YType.uint32, 'remote-tunnel-id'), ['int'])),
                        ('admin_status', (YLeaf(YType.enumeration, 'admin-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelState', '')])),
                        ('operation_status', (YLeaf(YType.enumeration, 'operation-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelState', '')])),
                        ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpTunnelActiveLsp', '')])),
                    ])
                    self.tp_tunnel_name = None
                    self.tunnel_name = None
                    self.source_tunnel_id = None
                    self.source_node_id = None
                    self.source_global_id = None
                    self.destination_node_id = None
                    self.destination_global_id = None
                    self.remote_tunnel_id = None
                    self.admin_status = None
                    self.operation_status = None
                    self.active_lsp = None

                    self.working_lsp = MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"

                    self.protect_lsp = MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._segment_path = lambda: "tp-tunnel" + "[tp-tunnel-name='" + str(self.tp_tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-tunnels/tp-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpTunnels.TpTunnels_.TpTunnel, ['tp_tunnel_name', 'tunnel_name', 'source_tunnel_id', 'source_node_id', 'source_global_id', 'destination_node_id', 'destination_global_id', 'remote_tunnel_id', 'admin_status', 'operation_status', 'active_lsp'], name, value)


                class WorkingLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: lsp_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lock_out
                    
                    	Deprecated
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: rx_oam_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tx_oam_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tp-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                            ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                            ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                            ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                            ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                        ])
                        self.lsp_id = None
                        self.state = None
                        self.lock_out = None
                        self.rx_oam_state = None
                        self.tx_oam_state = None
                        self.bfd_state = None
                        self._segment_path = lambda: "working-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpTunnels_.TpTunnel.WorkingLsp']['meta_info']


                class ProtectLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: lsp_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lock_out
                    
                    	Deprecated
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: rx_oam_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tx_oam_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspOamState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspOamState>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`MplsTpLspBfdState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTpLspBfdState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tp-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                            ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspState', '')])),
                            ('lock_out', (YLeaf(YType.boolean, 'lock-out'), ['bool'])),
                            ('rx_oam_state', (YLeaf(YType.enumeration, 'rx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                            ('tx_oam_state', (YLeaf(YType.enumeration, 'tx-oam-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspOamState', '')])),
                            ('bfd_state', (YLeaf(YType.enumeration, 'bfd-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTpLspBfdState', '')])),
                        ])
                        self.lsp_id = None
                        self.state = None
                        self.lock_out = None
                        self.rx_oam_state = None
                        self.tx_oam_state = None
                        self.bfd_state = None
                        self._segment_path = lambda: "protect-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp, ['lsp_id', 'state', 'lock_out', 'rx_oam_state', 'tx_oam_state', 'bfd_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpTunnels.TpTunnels_.TpTunnel.ProtectLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpTunnels.TpTunnels_.TpTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpTunnels.TpTunnels_']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTp.TpTunnels']['meta_info']


    class TpMidpoints(_Entity_):
        """
        Transport profile mid\-point
        
        .. attribute:: tp_detail_midpoints
        
        	Detailed table of transport profile mid\-points
        	**type**\:  :py:class:`TpDetailMidpoints <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints>`
        
        	**config**\: False
        
        .. attribute:: tp_midpoint_summary
        
        	Summary of transport profile mid\-points
        	**type**\:  :py:class:`TpMidpointSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpointSummary>`
        
        	**config**\: False
        
        .. attribute:: tp_midpoints
        
        	Table of transport profile mid\-points
        	**type**\:  :py:class:`TpMidpoints_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpoints_>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTp.TpMidpoints, self).__init__()

            self.yang_name = "tp-midpoints"
            self.yang_parent_name = "mpls-tp"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tp-detail-midpoints", ("tp_detail_midpoints", MplsTp.TpMidpoints.TpDetailMidpoints)), ("tp-midpoint-summary", ("tp_midpoint_summary", MplsTp.TpMidpoints.TpMidpointSummary)), ("tp-midpoints", ("tp_midpoints", MplsTp.TpMidpoints.TpMidpoints_))])
            self._leafs = OrderedDict()

            self.tp_detail_midpoints = MplsTp.TpMidpoints.TpDetailMidpoints()
            self.tp_detail_midpoints.parent = self
            self._children_name_map["tp_detail_midpoints"] = "tp-detail-midpoints"

            self.tp_midpoint_summary = MplsTp.TpMidpoints.TpMidpointSummary()
            self.tp_midpoint_summary.parent = self
            self._children_name_map["tp_midpoint_summary"] = "tp-midpoint-summary"

            self.tp_midpoints = MplsTp.TpMidpoints.TpMidpoints_()
            self.tp_midpoints.parent = self
            self._children_name_map["tp_midpoints"] = "tp-midpoints"
            self._segment_path = lambda: "tp-midpoints"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTp.TpMidpoints, [], name, value)


        class TpDetailMidpoints(_Entity_):
            """
            Detailed table of transport profile mid\-points
            
            .. attribute:: tp_detail_midpoint
            
            	Detailed information of transport profile mid\-point
            	**type**\: list of  		 :py:class:`TpDetailMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpMidpoints.TpDetailMidpoints, self).__init__()

                self.yang_name = "tp-detail-midpoints"
                self.yang_parent_name = "tp-midpoints"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-detail-midpoint", ("tp_detail_midpoint", MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint))])
                self._leafs = OrderedDict()

                self.tp_detail_midpoint = YList(self)
                self._segment_path = lambda: "tp-detail-midpoints"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpMidpoints.TpDetailMidpoints, [], name, value)


            class TpDetailMidpoint(_Entity_):
                """
                Detailed information of transport profile
                mid\-point
                
                .. attribute:: tp_midpoint_name  (key)
                
                	Mid\-point name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: brief_lsp_information
                
                	Deprecated
                	**type**\:  :py:class:`BriefLspInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation>`
                
                	**config**\: False
                
                .. attribute:: forward_lsp
                
                	Deprecated
                	**type**\:  :py:class:`ForwardLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp>`
                
                	**config**\: False
                
                .. attribute:: reverse_lsp
                
                	Deprecated
                	**type**\:  :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp>`
                
                	**config**\: False
                
                .. attribute:: forward_lsp_reserved_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reverse_lsp_reserved_bandwidth
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint, self).__init__()

                    self.yang_name = "tp-detail-midpoint"
                    self.yang_parent_name = "tp-detail-midpoints"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_midpoint_name']
                    self._child_classes = OrderedDict([("brief-lsp-information", ("brief_lsp_information", MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation)), ("forward-lsp", ("forward_lsp", MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp)), ("reverse-lsp", ("reverse_lsp", MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp))])
                    self._leafs = OrderedDict([
                        ('tp_midpoint_name', (YLeaf(YType.str, 'tp-midpoint-name'), ['str'])),
                        ('forward_lsp_reserved_bandwidth', (YLeaf(YType.uint32, 'forward-lsp-reserved-bandwidth'), ['int'])),
                        ('reverse_lsp_reserved_bandwidth', (YLeaf(YType.uint32, 'reverse-lsp-reserved-bandwidth'), ['int'])),
                    ])
                    self.tp_midpoint_name = None
                    self.forward_lsp_reserved_bandwidth = None
                    self.reverse_lsp_reserved_bandwidth = None

                    self.brief_lsp_information = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation()
                    self.brief_lsp_information.parent = self
                    self._children_name_map["brief_lsp_information"] = "brief-lsp-information"

                    self.forward_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp()
                    self.forward_lsp.parent = self
                    self._children_name_map["forward_lsp"] = "forward-lsp"

                    self.reverse_lsp = MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp()
                    self.reverse_lsp.parent = self
                    self._children_name_map["reverse_lsp"] = "reverse-lsp"
                    self._segment_path = lambda: "tp-detail-midpoint" + "[tp-midpoint-name='" + str(self.tp_midpoint_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/tp-detail-midpoints/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint, ['tp_midpoint_name', 'forward_lsp_reserved_bandwidth', 'reverse_lsp_reserved_bandwidth'], name, value)


                class BriefLspInformation(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: midpoint_name
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_node_id
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: source_global_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: source_tunnel_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: destination_node_id
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_global_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: destination_tunnel_id
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: forward_lsp_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_state
                    
                    	Deprecated
                    	**type**\:  :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation, self).__init__()

                        self.yang_name = "brief-lsp-information"
                        self.yang_parent_name = "tp-detail-midpoint"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('midpoint_name', (YLeaf(YType.str, 'midpoint-name'), ['str'])),
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('source_node_id', (YLeaf(YType.str, 'source-node-id'), ['str'])),
                            ('source_global_id', (YLeaf(YType.uint32, 'source-global-id'), ['int'])),
                            ('source_tunnel_id', (YLeaf(YType.uint32, 'source-tunnel-id'), ['int'])),
                            ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                            ('destination_node_id', (YLeaf(YType.str, 'destination-node-id'), ['str'])),
                            ('destination_global_id', (YLeaf(YType.uint32, 'destination-global-id'), ['int'])),
                            ('destination_tunnel_id', (YLeaf(YType.uint32, 'destination-tunnel-id'), ['int'])),
                            ('forward_lsp_state', (YLeaf(YType.enumeration, 'forward-lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpMidLspStatus', '')])),
                            ('reverse_lsp_state', (YLeaf(YType.enumeration, 'reverse-lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpMidLspStatus', '')])),
                        ])
                        self.midpoint_name = None
                        self.tunnel_name = None
                        self.source_node_id = None
                        self.source_global_id = None
                        self.source_tunnel_id = None
                        self.lsp_id = None
                        self.destination_node_id = None
                        self.destination_global_id = None
                        self.destination_tunnel_id = None
                        self.forward_lsp_state = None
                        self.reverse_lsp_state = None
                        self._segment_path = lambda: "brief-lsp-information"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation, ['midpoint_name', 'tunnel_name', 'source_node_id', 'source_global_id', 'source_tunnel_id', 'lsp_id', 'destination_node_id', 'destination_global_id', 'destination_tunnel_id', 'forward_lsp_state', 'reverse_lsp_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.BriefLspInformation']['meta_info']


                class ForwardLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: out_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: out_link
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: oam_refresh_interval
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_interface
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp, self).__init__()

                        self.yang_name = "forward-lsp"
                        self.yang_parent_name = "tp-detail-midpoint"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                            ('out_link', (YLeaf(YType.uint32, 'out-link'), ['int'])),
                            ('oam_refresh_interval', (YLeaf(YType.uint32, 'oam-refresh-interval'), ['int'])),
                            ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ])
                        self.out_label = None
                        self.out_link = None
                        self.oam_refresh_interval = None
                        self.outgoing_interface = None
                        self.next_hop_address = None
                        self.in_label = None
                        self.bandwidth = None
                        self._segment_path = lambda: "forward-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp, ['out_label', 'out_link', 'oam_refresh_interval', 'outgoing_interface', 'next_hop_address', 'in_label', 'bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ForwardLsp']['meta_info']


                class ReverseLsp(_Entity_):
                    """
                    Deprecated
                    
                    .. attribute:: out_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: out_link
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: oam_refresh_interval
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_interface
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	Deprecated
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: in_label
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth
                    
                    	Deprecated
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp, self).__init__()

                        self.yang_name = "reverse-lsp"
                        self.yang_parent_name = "tp-detail-midpoint"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                            ('out_link', (YLeaf(YType.uint32, 'out-link'), ['int'])),
                            ('oam_refresh_interval', (YLeaf(YType.uint32, 'oam-refresh-interval'), ['int'])),
                            ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ])
                        self.out_label = None
                        self.out_link = None
                        self.oam_refresh_interval = None
                        self.outgoing_interface = None
                        self.next_hop_address = None
                        self.in_label = None
                        self.bandwidth = None
                        self._segment_path = lambda: "reverse-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp, ['out_label', 'out_link', 'oam_refresh_interval', 'outgoing_interface', 'next_hop_address', 'in_label', 'bandwidth'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint.ReverseLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpMidpoints.TpDetailMidpoints.TpDetailMidpoint']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpMidpoints.TpDetailMidpoints']['meta_info']


        class TpMidpointSummary(_Entity_):
            """
            Summary of transport profile mid\-points
            
            .. attribute:: mid_points
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_forward_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: down_forward_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_reverse_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: down_reverse_ls_ps
            
            	Deprecated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpMidpoints.TpMidpointSummary, self).__init__()

                self.yang_name = "tp-midpoint-summary"
                self.yang_parent_name = "tp-midpoints"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('mid_points', (YLeaf(YType.uint32, 'mid-points'), ['int'])),
                    ('up_forward_ls_ps', (YLeaf(YType.uint32, 'up-forward-ls-ps'), ['int'])),
                    ('down_forward_ls_ps', (YLeaf(YType.uint32, 'down-forward-ls-ps'), ['int'])),
                    ('up_reverse_ls_ps', (YLeaf(YType.uint32, 'up-reverse-ls-ps'), ['int'])),
                    ('down_reverse_ls_ps', (YLeaf(YType.uint32, 'down-reverse-ls-ps'), ['int'])),
                ])
                self.mid_points = None
                self.up_forward_ls_ps = None
                self.down_forward_ls_ps = None
                self.up_reverse_ls_ps = None
                self.down_reverse_ls_ps = None
                self._segment_path = lambda: "tp-midpoint-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpMidpoints.TpMidpointSummary, ['mid_points', 'up_forward_ls_ps', 'down_forward_ls_ps', 'up_reverse_ls_ps', 'down_reverse_ls_ps'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpMidpoints.TpMidpointSummary']['meta_info']


        class TpMidpoints_(_Entity_):
            """
            Table of transport profile mid\-points
            
            .. attribute:: tp_midpoint
            
            	Brief information of transport profile mid\-point
            	**type**\: list of  		 :py:class:`TpMidpoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpMidpoints.TpMidpoints_.TpMidpoint>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpMidpoints.TpMidpoints_, self).__init__()

                self.yang_name = "tp-midpoints"
                self.yang_parent_name = "tp-midpoints"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tp-midpoint", ("tp_midpoint", MplsTp.TpMidpoints.TpMidpoints_.TpMidpoint))])
                self._leafs = OrderedDict()

                self.tp_midpoint = YList(self)
                self._segment_path = lambda: "tp-midpoints"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpMidpoints.TpMidpoints_, [], name, value)


            class TpMidpoint(_Entity_):
                """
                Brief information of transport profile
                mid\-point
                
                .. attribute:: tp_midpoint_name  (key)
                
                	Mid\-point name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: midpoint_name
                
                	Deprecated
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Deprecated
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: source_node_id
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_global_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_tunnel_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_node_id
                
                	Deprecated
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_global_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_tunnel_id
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: forward_lsp_state
                
                	Deprecated
                	**type**\:  :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                
                	**config**\: False
                
                .. attribute:: reverse_lsp_state
                
                	Deprecated
                	**type**\:  :py:class:`TpMidLspStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TpMidLspStatus>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTp.TpMidpoints.TpMidpoints_.TpMidpoint, self).__init__()

                    self.yang_name = "tp-midpoint"
                    self.yang_parent_name = "tp-midpoints"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tp_midpoint_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tp_midpoint_name', (YLeaf(YType.str, 'tp-midpoint-name'), ['str'])),
                        ('midpoint_name', (YLeaf(YType.str, 'midpoint-name'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('source_node_id', (YLeaf(YType.str, 'source-node-id'), ['str'])),
                        ('source_global_id', (YLeaf(YType.uint32, 'source-global-id'), ['int'])),
                        ('source_tunnel_id', (YLeaf(YType.uint32, 'source-tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('destination_node_id', (YLeaf(YType.str, 'destination-node-id'), ['str'])),
                        ('destination_global_id', (YLeaf(YType.uint32, 'destination-global-id'), ['int'])),
                        ('destination_tunnel_id', (YLeaf(YType.uint32, 'destination-tunnel-id'), ['int'])),
                        ('forward_lsp_state', (YLeaf(YType.enumeration, 'forward-lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpMidLspStatus', '')])),
                        ('reverse_lsp_state', (YLeaf(YType.enumeration, 'reverse-lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TpMidLspStatus', '')])),
                    ])
                    self.tp_midpoint_name = None
                    self.midpoint_name = None
                    self.tunnel_name = None
                    self.source_node_id = None
                    self.source_global_id = None
                    self.source_tunnel_id = None
                    self.lsp_id = None
                    self.destination_node_id = None
                    self.destination_global_id = None
                    self.destination_tunnel_id = None
                    self.forward_lsp_state = None
                    self.reverse_lsp_state = None
                    self._segment_path = lambda: "tp-midpoint" + "[tp-midpoint-name='" + str(self.tp_midpoint_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-midpoints/tp-midpoints/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTp.TpMidpoints.TpMidpoints_.TpMidpoint, ['tp_midpoint_name', 'midpoint_name', 'tunnel_name', 'source_node_id', 'source_global_id', 'source_tunnel_id', 'lsp_id', 'destination_node_id', 'destination_global_id', 'destination_tunnel_id', 'forward_lsp_state', 'reverse_lsp_state'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTp.TpMidpoints.TpMidpoints_.TpMidpoint']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpMidpoints.TpMidpoints_']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTp.TpMidpoints']['meta_info']


    class TpGlobalParameters(_Entity_):
        """
        Transport profile global parameters
        
        .. attribute:: oam_protection_triggers
        
        	Deprecated
        	**type**\:  :py:class:`OamProtectionTriggers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTp.TpGlobalParameters.OamProtectionTriggers>`
        
        	**config**\: False
        
        .. attribute:: node_id
        
        	Deprecated
        	**type**\: str
        
        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
        
        	**config**\: False
        
        .. attribute:: global_id
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: oam_refresh
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bfd_interval
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bfd_interval_in_micro_sec
        
        	Deprecated
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: bfd_interval_standby
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bfd_interval_standby_in_micro_sec
        
        	Deprecated
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: bfd_multiplier
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bfd_multiplier_standby
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: wait_to_restore_interval
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: alarm_suppression
        
        	Deprecated
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: soak_time
        
        	Deprecated
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTp.TpGlobalParameters, self).__init__()

            self.yang_name = "tp-global-parameters"
            self.yang_parent_name = "mpls-tp"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("oam-protection-triggers", ("oam_protection_triggers", MplsTp.TpGlobalParameters.OamProtectionTriggers))])
            self._leafs = OrderedDict([
                ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                ('global_id', (YLeaf(YType.uint32, 'global-id'), ['int'])),
                ('oam_refresh', (YLeaf(YType.uint32, 'oam-refresh'), ['int'])),
                ('bfd_interval', (YLeaf(YType.uint32, 'bfd-interval'), ['int'])),
                ('bfd_interval_in_micro_sec', (YLeaf(YType.boolean, 'bfd-interval-in-micro-sec'), ['bool'])),
                ('bfd_interval_standby', (YLeaf(YType.uint32, 'bfd-interval-standby'), ['int'])),
                ('bfd_interval_standby_in_micro_sec', (YLeaf(YType.boolean, 'bfd-interval-standby-in-micro-sec'), ['bool'])),
                ('bfd_multiplier', (YLeaf(YType.uint32, 'bfd-multiplier'), ['int'])),
                ('bfd_multiplier_standby', (YLeaf(YType.uint32, 'bfd-multiplier-standby'), ['int'])),
                ('wait_to_restore_interval', (YLeaf(YType.uint32, 'wait-to-restore-interval'), ['int'])),
                ('alarm_suppression', (YLeaf(YType.boolean, 'alarm-suppression'), ['bool'])),
                ('soak_time', (YLeaf(YType.uint32, 'soak-time'), ['int'])),
            ])
            self.node_id = None
            self.global_id = None
            self.oam_refresh = None
            self.bfd_interval = None
            self.bfd_interval_in_micro_sec = None
            self.bfd_interval_standby = None
            self.bfd_interval_standby_in_micro_sec = None
            self.bfd_multiplier = None
            self.bfd_multiplier_standby = None
            self.wait_to_restore_interval = None
            self.alarm_suppression = None
            self.soak_time = None

            self.oam_protection_triggers = MplsTp.TpGlobalParameters.OamProtectionTriggers()
            self.oam_protection_triggers.parent = self
            self._children_name_map["oam_protection_triggers"] = "oam-protection-triggers"
            self._segment_path = lambda: "tp-global-parameters"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTp.TpGlobalParameters, ['node_id', 'global_id', 'oam_refresh', 'bfd_interval', 'bfd_interval_in_micro_sec', 'bfd_interval_standby', 'bfd_interval_standby_in_micro_sec', 'bfd_multiplier', 'bfd_multiplier_standby', 'wait_to_restore_interval', 'alarm_suppression', 'soak_time'], name, value)


        class OamProtectionTriggers(_Entity_):
            """
            Deprecated
            
            .. attribute:: ais
            
            	Deprecated
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: ldi
            
            	Deprecated
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: lkr
            
            	Deprecated
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTp.TpGlobalParameters.OamProtectionTriggers, self).__init__()

                self.yang_name = "oam-protection-triggers"
                self.yang_parent_name = "tp-global-parameters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('ais', (YLeaf(YType.boolean, 'ais'), ['bool'])),
                    ('ldi', (YLeaf(YType.boolean, 'ldi'), ['bool'])),
                    ('lkr', (YLeaf(YType.boolean, 'lkr'), ['bool'])),
                ])
                self.ais = None
                self.ldi = None
                self.lkr = None
                self._segment_path = lambda: "oam-protection-triggers"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-tp/tp-global-parameters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTp.TpGlobalParameters.OamProtectionTriggers, ['ais', 'ldi', 'lkr'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTp.TpGlobalParameters.OamProtectionTriggers']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTp.TpGlobalParameters']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsTp()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTp']['meta_info']


class MplsTeStandby(_Entity_):
    """
    mpls te standby
    
    .. attribute:: hardware_out_of_resources
    
    	NPU Hardware OOR Information
    	**type**\:  :py:class:`HardwareOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources>`
    
    	**config**\: False
    
    .. attribute:: p2p_p2mp_tunnel
    
    	P2P or P2MP tunnels
    	**type**\:  :py:class:`P2pP2mpTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel>`
    
    	**config**\: False
    
    .. attribute:: topology_nodes
    
    	A node in the MPLS\-TE topology
    	**type**\:  :py:class:`TopologyNodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes>`
    
    	**config**\: False
    
    .. attribute:: announce_tunnels_info
    
    	Announced tunnels (forwarding adjacency and autoroute annonce)
    	**type**\:  :py:class:`AnnounceTunnelsInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo>`
    
    	**config**\: False
    
    .. attribute:: collaborator_timers
    
    	TE Collaborator timer status
    	**type**\:  :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.CollaboratorTimers>`
    
    	**config**\: False
    
    .. attribute:: auto_tunnel
    
    	Auto tunnel information
    	**type**\:  :py:class:`AutoTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel>`
    
    	**config**\: False
    
    .. attribute:: soft_preemption
    
    	Soft Preemption information
    	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SoftPreemption>`
    
    	**config**\: False
    
    .. attribute:: forwarding_adjacency_destinations
    
    	Announced Destination tunnel
    	**type**\:  :py:class:`ForwardingAdjacencyDestinations <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations>`
    
    	**config**\: False
    
    .. attribute:: igp_areas
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:  :py:class:`IgpAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas>`
    
    	**config**\: False
    
    .. attribute:: wrap_protection
    
    	Represent all the LSP Wrap Protection info in MPLS\-TE
    	**type**\:  :py:class:`WrapProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection>`
    
    	**config**\: False
    
    .. attribute:: topology
    
    	The topology information in MPLS\-TE
    	**type**\:  :py:class:`Topology <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology>`
    
    	**config**\: False
    
    .. attribute:: signalling_counters
    
    	TE counters
    	**type**\:  :py:class:`SignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters>`
    
    	**config**\: False
    
    .. attribute:: diff_serv_te_classes
    
    	The configured Diff Serv TE classes
    	**type**\:  :py:class:`DiffServTeClasses <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.DiffServTeClasses>`
    
    	**config**\: False
    
    .. attribute:: issu
    
    	MPLS TE ISSU information
    	**type**\:  :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu>`
    
    	**config**\: False
    
    .. attribute:: auto_route_destination_entries
    
    	MPLS TE autoroute destination table indexed by tunnel
    	**type**\:  :py:class:`AutoRouteDestinationEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoRouteDestinationEntries>`
    
    	**config**\: False
    
    .. attribute:: fast_reroute
    
    	Represent all the fastreroute info in MPLS\-TE
    	**type**\:  :py:class:`FastReroute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute>`
    
    	**config**\: False
    
    .. attribute:: attribute_sets
    
    	AttributeSet information
    	**type**\:  :py:class:`AttributeSets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets>`
    
    	**config**\: False
    
    .. attribute:: igp_area_briefs
    
    	The set of IGP\-areas known to MPLS\-TE
    	**type**\:  :py:class:`IgpAreaBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs>`
    
    	**config**\: False
    
    .. attribute:: bandwidth_accounting_counters
    
    	Bandwidth accounting counters
    	**type**\:  :py:class:`BandwidthAccountingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.BandwidthAccountingCounters>`
    
    	**config**\: False
    
    .. attribute:: tunnels
    
    	Failure protection provided for tunnels
    	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels>`
    
    	**config**\: False
    
    .. attribute:: maximum_tunnels
    
    	MPLS Traffic Engineering Tunnels
    	**type**\:  :py:class:`MaximumTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.MaximumTunnels>`
    
    	**config**\: False
    
    .. attribute:: path_protection
    
    	MPLS TE path protection info
    	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection>`
    
    	**config**\: False
    
    .. attribute:: fib_next_hop_label_routes
    
    	MPLS TE FIB nexthop label route database
    	**type**\:  :py:class:`FibNextHopLabelRoutes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes>`
    
    	**config**\: False
    
    .. attribute:: p2mp
    
    	P2MP Information
    	**type**\:  :py:class:`P2mp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp>`
    
    	**config**\: False
    
    .. attribute:: lsp_out_of_resources
    
    	LSP OOR information
    	**type**\:  :py:class:`LspOutOfResources <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources>`
    
    	**config**\: False
    
    .. attribute:: bfd
    
    	MPLS TE BFD Oper Info
    	**type**\:  :py:class:`Bfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd>`
    
    	**config**\: False
    
    .. attribute:: nsr
    
    	MPLS TE NSR information
    	**type**\:  :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr>`
    
    	**config**\: False
    
    .. attribute:: auto_tunnel_services
    
    	MPLS TE Auto Tunnel Services
    	**type**\:  :py:class:`AutoTunnelServices <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices>`
    
    	**config**\: False
    
    .. attribute:: affinity_map
    
    	Affinity name to value mapping
    	**type**\:  :py:class:`AffinityMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap>`
    
    	**config**\: False
    
    .. attribute:: topology_briefs
    
    	MPLS\-TE topology brief table
    	**type**\:  :py:class:`TopologyBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs>`
    
    	**config**\: False
    
    

    """

    _prefix = 'mpls-te-oper'
    _revision = '2018-08-01'

    def __init__(self):
        if sys.version_info > (3,):
            super().__init__()
        else:
            super(MplsTeStandby, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-te-standby"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-te-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self.ylist_key_names = []
        self._child_classes = OrderedDict([("hardware-out-of-resources", ("hardware_out_of_resources", MplsTeStandby.HardwareOutOfResources)), ("p2p-p2mp-tunnel", ("p2p_p2mp_tunnel", MplsTeStandby.P2pP2mpTunnel)), ("topology-nodes", ("topology_nodes", MplsTeStandby.TopologyNodes)), ("announce-tunnels-info", ("announce_tunnels_info", MplsTeStandby.AnnounceTunnelsInfo)), ("collaborator-timers", ("collaborator_timers", MplsTeStandby.CollaboratorTimers)), ("auto-tunnel", ("auto_tunnel", MplsTeStandby.AutoTunnel)), ("soft-preemption", ("soft_preemption", MplsTeStandby.SoftPreemption)), ("forwarding-adjacency-destinations", ("forwarding_adjacency_destinations", MplsTeStandby.ForwardingAdjacencyDestinations)), ("igp-areas", ("igp_areas", MplsTeStandby.IgpAreas)), ("wrap-protection", ("wrap_protection", MplsTeStandby.WrapProtection)), ("topology", ("topology", MplsTeStandby.Topology)), ("signalling-counters", ("signalling_counters", MplsTeStandby.SignallingCounters)), ("diff-serv-te-classes", ("diff_serv_te_classes", MplsTeStandby.DiffServTeClasses)), ("issu", ("issu", MplsTeStandby.Issu)), ("auto-route-destination-entries", ("auto_route_destination_entries", MplsTeStandby.AutoRouteDestinationEntries)), ("fast-reroute", ("fast_reroute", MplsTeStandby.FastReroute)), ("attribute-sets", ("attribute_sets", MplsTeStandby.AttributeSets)), ("igp-area-briefs", ("igp_area_briefs", MplsTeStandby.IgpAreaBriefs)), ("bandwidth-accounting-counters", ("bandwidth_accounting_counters", MplsTeStandby.BandwidthAccountingCounters)), ("tunnels", ("tunnels", MplsTeStandby.Tunnels)), ("maximum-tunnels", ("maximum_tunnels", MplsTeStandby.MaximumTunnels)), ("path-protection", ("path_protection", MplsTeStandby.PathProtection)), ("fib-next-hop-label-routes", ("fib_next_hop_label_routes", MplsTeStandby.FibNextHopLabelRoutes)), ("p2mp", ("p2mp", MplsTeStandby.P2mp)), ("lsp-out-of-resources", ("lsp_out_of_resources", MplsTeStandby.LspOutOfResources)), ("bfd", ("bfd", MplsTeStandby.Bfd)), ("nsr", ("nsr", MplsTeStandby.Nsr)), ("auto-tunnel-services", ("auto_tunnel_services", MplsTeStandby.AutoTunnelServices)), ("affinity-map", ("affinity_map", MplsTeStandby.AffinityMap)), ("topology-briefs", ("topology_briefs", MplsTeStandby.TopologyBriefs))])
        self._leafs = OrderedDict()

        self.hardware_out_of_resources = MplsTeStandby.HardwareOutOfResources()
        self.hardware_out_of_resources.parent = self
        self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"

        self.p2p_p2mp_tunnel = MplsTeStandby.P2pP2mpTunnel()
        self.p2p_p2mp_tunnel.parent = self
        self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"

        self.topology_nodes = MplsTeStandby.TopologyNodes()
        self.topology_nodes.parent = self
        self._children_name_map["topology_nodes"] = "topology-nodes"

        self.announce_tunnels_info = MplsTeStandby.AnnounceTunnelsInfo()
        self.announce_tunnels_info.parent = self
        self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"

        self.collaborator_timers = MplsTeStandby.CollaboratorTimers()
        self.collaborator_timers.parent = self
        self._children_name_map["collaborator_timers"] = "collaborator-timers"

        self.auto_tunnel = MplsTeStandby.AutoTunnel()
        self.auto_tunnel.parent = self
        self._children_name_map["auto_tunnel"] = "auto-tunnel"

        self.soft_preemption = MplsTeStandby.SoftPreemption()
        self.soft_preemption.parent = self
        self._children_name_map["soft_preemption"] = "soft-preemption"

        self.forwarding_adjacency_destinations = MplsTeStandby.ForwardingAdjacencyDestinations()
        self.forwarding_adjacency_destinations.parent = self
        self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"

        self.igp_areas = MplsTeStandby.IgpAreas()
        self.igp_areas.parent = self
        self._children_name_map["igp_areas"] = "igp-areas"

        self.wrap_protection = MplsTeStandby.WrapProtection()
        self.wrap_protection.parent = self
        self._children_name_map["wrap_protection"] = "wrap-protection"

        self.topology = MplsTeStandby.Topology()
        self.topology.parent = self
        self._children_name_map["topology"] = "topology"

        self.signalling_counters = MplsTeStandby.SignallingCounters()
        self.signalling_counters.parent = self
        self._children_name_map["signalling_counters"] = "signalling-counters"

        self.diff_serv_te_classes = MplsTeStandby.DiffServTeClasses()
        self.diff_serv_te_classes.parent = self
        self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"

        self.issu = MplsTeStandby.Issu()
        self.issu.parent = self
        self._children_name_map["issu"] = "issu"

        self.auto_route_destination_entries = MplsTeStandby.AutoRouteDestinationEntries()
        self.auto_route_destination_entries.parent = self
        self._children_name_map["auto_route_destination_entries"] = "auto-route-destination-entries"

        self.fast_reroute = MplsTeStandby.FastReroute()
        self.fast_reroute.parent = self
        self._children_name_map["fast_reroute"] = "fast-reroute"

        self.attribute_sets = MplsTeStandby.AttributeSets()
        self.attribute_sets.parent = self
        self._children_name_map["attribute_sets"] = "attribute-sets"

        self.igp_area_briefs = MplsTeStandby.IgpAreaBriefs()
        self.igp_area_briefs.parent = self
        self._children_name_map["igp_area_briefs"] = "igp-area-briefs"

        self.bandwidth_accounting_counters = MplsTeStandby.BandwidthAccountingCounters()
        self.bandwidth_accounting_counters.parent = self
        self._children_name_map["bandwidth_accounting_counters"] = "bandwidth-accounting-counters"

        self.tunnels = MplsTeStandby.Tunnels()
        self.tunnels.parent = self
        self._children_name_map["tunnels"] = "tunnels"

        self.maximum_tunnels = MplsTeStandby.MaximumTunnels()
        self.maximum_tunnels.parent = self
        self._children_name_map["maximum_tunnels"] = "maximum-tunnels"

        self.path_protection = MplsTeStandby.PathProtection()
        self.path_protection.parent = self
        self._children_name_map["path_protection"] = "path-protection"

        self.fib_next_hop_label_routes = MplsTeStandby.FibNextHopLabelRoutes()
        self.fib_next_hop_label_routes.parent = self
        self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"

        self.p2mp = MplsTeStandby.P2mp()
        self.p2mp.parent = self
        self._children_name_map["p2mp"] = "p2mp"

        self.lsp_out_of_resources = MplsTeStandby.LspOutOfResources()
        self.lsp_out_of_resources.parent = self
        self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"

        self.bfd = MplsTeStandby.Bfd()
        self.bfd.parent = self
        self._children_name_map["bfd"] = "bfd"

        self.nsr = MplsTeStandby.Nsr()
        self.nsr.parent = self
        self._children_name_map["nsr"] = "nsr"

        self.auto_tunnel_services = MplsTeStandby.AutoTunnelServices()
        self.auto_tunnel_services.parent = self
        self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"

        self.affinity_map = MplsTeStandby.AffinityMap()
        self.affinity_map.parent = self
        self._children_name_map["affinity_map"] = "affinity-map"

        self.topology_briefs = MplsTeStandby.TopologyBriefs()
        self.topology_briefs.parent = self
        self._children_name_map["topology_briefs"] = "topology-briefs"
        self._segment_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby"
        self._is_frozen = True

    def __setattr__(self, name, value):
        self._perform_setattr(MplsTeStandby, [], name, value)


    class HardwareOutOfResources(_Entity_):
        """
        NPU Hardware OOR Information
        
        .. attribute:: summary
        
        	HW OOR Summary information
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.HardwareOutOfResources, self).__init__()

            self.yang_name = "hardware-out-of-resources"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsTeStandby.HardwareOutOfResources.Summary))])
            self._leafs = OrderedDict()

            self.summary = MplsTeStandby.HardwareOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._segment_path = lambda: "hardware-out-of-resources"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.HardwareOutOfResources, [], name, value)


        class Summary(_Entity_):
            """
            HW OOR Summary information
            
            .. attribute:: hardware_out_of_resources_state
            
            	Array of NPU HW OOR info per state
            	**type**\: list of  		 :py:class:`HardwareOutOfResourcesState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.HardwareOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "hardware-out-of-resources"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("hardware-out-of-resources-state", ("hardware_out_of_resources_state", MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState))])
                self._leafs = OrderedDict()

                self.hardware_out_of_resources_state = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.HardwareOutOfResources.Summary, [], name, value)


            class HardwareOutOfResourcesState(_Entity_):
                """
                Array of NPU HW OOR info per state
                
                .. attribute:: statistics
                
                	NPU HW OOR Statistics per state
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics>`
                
                	**config**\: False
                
                .. attribute:: hw_oor_state
                
                	The HW\-OOR state that this information belong to
                	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                
                	**config**\: False
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this  NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: percentage
                
                .. attribute:: node_protection_disable
                
                	Disable FRR node protection when the link is in this NPU HW OOR state
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green OOR state is entered
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: minute
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this NPU HW OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the NPU HW OOR state
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, self).__init__()

                    self.yang_name = "hardware-out-of-resources-state"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics))])
                    self._leafs = OrderedDict([
                        ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                        ('te_metric_penalty', (YLeaf(YType.uint32, 'te-metric-penalty'), ['int'])),
                        ('available_bw_percentage', (YLeaf(YType.uint32, 'available-bw-percentage'), ['int'])),
                        ('node_protection_disable', (YLeaf(YType.boolean, 'node-protection-disable'), ['bool'])),
                        ('transition_duration', (YLeaf(YType.uint32, 'transition-duration'), ['int'])),
                        ('minimum_lsp_bandwidth', (YLeaf(YType.uint32, 'minimum-lsp-bandwidth'), ['int'])),
                        ('accept_reopt', (YLeaf(YType.boolean, 'accept-reopt'), ['bool'])),
                    ])
                    self.hw_oor_state = None
                    self.te_metric_penalty = None
                    self.available_bw_percentage = None
                    self.node_protection_disable = None
                    self.transition_duration = None
                    self.minimum_lsp_bandwidth = None
                    self.accept_reopt = None

                    self.statistics = MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._segment_path = lambda: "hardware-out-of-resources-state"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState, ['hw_oor_state', 'te_metric_penalty', 'available_bw_percentage', 'node_protection_disable', 'transition_duration', 'minimum_lsp_bandwidth', 'accept_reopt'], name, value)


                class Statistics(_Entity_):
                    """
                    NPU HW OOR Statistics per state
                    
                    .. attribute:: hw_oor_state
                    
                    	The HW\-OOR state that these statistics belong to
                    	**type**\:  :py:class:`HwOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.HwOorState>`
                    
                    	**config**\: False
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: node_protection_disable_number
                    
                    	Number of times this OOR state disabled node protection assignment
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "hardware-out-of-resources-state"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('hw_oor_state', (YLeaf(YType.enumeration, 'hw-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'HwOorState', '')])),
                            ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                            ('node_protection_disable_number', (YLeaf(YType.uint32, 'node-protection-disable-number'), ['int'])),
                            ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                            ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                            ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                            ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                        ])
                        self.hw_oor_state = None
                        self.transitions = None
                        self.node_protection_disable_number = None
                        self.rejected_ls_ps_number = None
                        self.accepted_ls_ps_number = None
                        self.accepted_reopt_ls_ps_number = None
                        self.rejected_reopt_ls_ps_number = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/hardware-out-of-resources/summary/hardware-out-of-resources-state/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics, ['hw_oor_state', 'transitions', 'node_protection_disable_number', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState.Statistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.HardwareOutOfResources.Summary.HardwareOutOfResourcesState']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.HardwareOutOfResources.Summary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.HardwareOutOfResources']['meta_info']


    class P2pP2mpTunnel(_Entity_):
        """
        P2P or P2MP tunnels
        
        .. attribute:: tunnel_remote_briefs
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:  :py:class:`TunnelRemoteBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs>`
        
        	**config**\: False
        
        .. attribute:: tunnel_remotes
        
        	Restrict display to P2P or P2MP mid or tail tunnels
        	**type**\:  :py:class:`TunnelRemotes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes>`
        
        	**config**\: False
        
        .. attribute:: nni_tunnels
        
        	GMPLS NNI tunnels
        	**type**\:  :py:class:`NniTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels>`
        
        	**config**\: False
        
        .. attribute:: tunnel_heads
        
        	Restrict display to P2P or P2MP head tunnels
        	**type**\:  :py:class:`TunnelHeads <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.P2pP2mpTunnel, self).__init__()

            self.yang_name = "p2p-p2mp-tunnel"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-remote-briefs", ("tunnel_remote_briefs", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs)), ("tunnel-remotes", ("tunnel_remotes", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes)), ("nni-tunnels", ("nni_tunnels", MplsTeStandby.P2pP2mpTunnel.NniTunnels)), ("tunnel-heads", ("tunnel_heads", MplsTeStandby.P2pP2mpTunnel.TunnelHeads))])
            self._leafs = OrderedDict()

            self.tunnel_remote_briefs = MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs()
            self.tunnel_remote_briefs.parent = self
            self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"

            self.tunnel_remotes = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes()
            self.tunnel_remotes.parent = self
            self._children_name_map["tunnel_remotes"] = "tunnel-remotes"

            self.nni_tunnels = MplsTeStandby.P2pP2mpTunnel.NniTunnels()
            self.nni_tunnels.parent = self
            self._children_name_map["nni_tunnels"] = "nni-tunnels"

            self.tunnel_heads = MplsTeStandby.P2pP2mpTunnel.TunnelHeads()
            self.tunnel_heads.parent = self
            self._children_name_map["tunnel_heads"] = "tunnel-heads"
            self._segment_path = lambda: "p2p-p2mp-tunnel"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel, [], name, value)


        class TunnelRemoteBriefs(_Entity_):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote_brief
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of  		 :py:class:`TunnelRemoteBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs, self).__init__()

                self.yang_name = "tunnel-remote-briefs"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-remote-brief", ("tunnel_remote_brief", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief))])
                self._leafs = OrderedDict()

                self.tunnel_remote_brief = YList(self)
                self._segment_path = lambda: "tunnel-remote-briefs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs, [], name, value)


            class TunnelRemoteBrief(_Entity_):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the LSP was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, self).__init__()

                    self.yang_name = "tunnel-remote-brief"
                    self.yang_parent_name = "tunnel-remote-briefs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['lsp_id','tunnel_id','extended_tunnel_id','source_address','ctype','destination_address','p2mp_id']
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l))])
                    self._leafs = OrderedDict([
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                    ])
                    self.lsp_id = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.ctype = None
                    self.destination_address = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.uptime = None

                    self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"

                    self.s2l = YList(self)
                    self._segment_path = lambda: "tunnel-remote-brief" + "[lsp-id='" + str(self.lsp_id) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-remote-briefs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief, ['lsp_id', 'tunnel_id', 'extended_tunnel_id', 'source_address', 'ctype', 'destination_address', 'p2mp_id', 'signaled_name', 'uptime'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote-brief"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.LspFec']['meta_info']


                class S2l(_Entity_):
                    """
                    array of S2L structures
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the S2L was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: oper_state
                    
                    	Oper state of S2L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote-brief"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec))])
                        self._leafs = OrderedDict([
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                            ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                            ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('oper_state', (YLeaf(YType.boolean, 'oper-state'), ['bool'])),
                        ])
                        self.uptime = None
                        self.egress_interface = None
                        self.ingress_interface = None
                        self.role = None
                        self.oper_state = None

                        self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l, ['uptime', 'egress_interface', 'ingress_interface', 'role', 'oper_state'], name, value)


                    class S2lFec(_Entity_):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                            ])
                            self.s2l_fec_subgroup_id = None
                            self.s2l_fec_lsp_id = None
                            self.s2l_fec_tunnel_id = None
                            self.s2l_fec_extended_tunnel_id = None
                            self.s2l_fec_source = None
                            self.s2l_fec_dest = None
                            self.s2l_fec_p2mp_id = None
                            self.s2l_fec_subgroup_originator = None
                            self.s2l_fec_ctype = None
                            self.s2l_fec_vrf = None
                            self._segment_path = lambda: "s2l-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l.S2lFec']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief.S2l']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs.TunnelRemoteBrief']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemoteBriefs']['meta_info']


        class TunnelRemotes(_Entity_):
            """
            Restrict display to P2P or P2MP mid or tail
            tunnels
            
            .. attribute:: tunnel_remote
            
            	P2P or P2MP tunnel that is a mid or tail
            	**type**\: list of  		 :py:class:`TunnelRemote <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes, self).__init__()

                self.yang_name = "tunnel-remotes"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-remote", ("tunnel_remote", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote))])
                self._leafs = OrderedDict()

                self.tunnel_remote = YList(self)
                self._segment_path = lambda: "tunnel-remotes"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes, [], name, value)


            class TunnelRemote(_Entity_):
                """
                P2P or P2MP tunnel that is a mid or tail
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_frr_failed
                
                	P2MP LSP has FRR Failed
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: frr_active_reason
                
                	P2MP LSP FRR active reason
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth
                
                	P2MP LSP Bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_setup_priority
                
                	LSP setup priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lsp_hold_priority
                
                	LSP hold priority
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth_type
                
                	The LSP bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: dste_class_match
                
                	Do the class type and priority match a DSTE class
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: dste_class_index
                
                	Matching DSTE class index
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: type
                
                	The type of this LSP
                	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: s2_ls_up
                
                	Number of connected S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls_proceeding
                
                	Number of proceeding S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls_down
                
                	Number of down S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reoptimize_reason
                
                	Reason for re\-optimization
                	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                
                	**config**\: False
                
                .. attribute:: reoptimize_trigger
                
                	Re\-optimize trigger
                	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                
                	**config**\: False
                
                .. attribute:: timer_left
                
                	Time in seconds left to take next action if any
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: protection_role
                
                	Path Protection Role
                	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                
                	**config**\: False
                
                .. attribute:: s2l
                
                	array of S2L structures
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote, self).__init__()

                    self.yang_name = "tunnel-remote"
                    self.yang_parent_name = "tunnel-remotes"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['lsp_id','tunnel_id','extended_tunnel_id','source_address','ctype','destination_address','p2mp_id']
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l))])
                    self._leafs = OrderedDict([
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                        ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                        ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                        ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                        ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                        ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                        ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                        ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                        ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                        ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                        ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                        ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                    ])
                    self.lsp_id = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.ctype = None
                    self.destination_address = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.is_frr_failed = None
                    self.frr_active_reason = None
                    self.lsp_bandwidth = None
                    self.lsp_setup_priority = None
                    self.lsp_hold_priority = None
                    self.lsp_bandwidth_type = None
                    self.dste_class_match = None
                    self.dste_class_index = None
                    self.type = None
                    self.uptime = None
                    self.s2_ls_up = None
                    self.s2_ls_proceeding = None
                    self.s2_ls_down = None
                    self.reoptimize_reason = None
                    self.reoptimize_trigger = None
                    self.timer_left = None
                    self.is_passive = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.protection_role = None

                    self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"

                    self.s2l = YList(self)
                    self._segment_path = lambda: "tunnel-remote" + "[lsp-id='" + str(self.lsp_id) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[ctype='" + str(self.ctype) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-remotes/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote, ['lsp_id', 'tunnel_id', 'extended_tunnel_id', 'source_address', 'ctype', 'destination_address', 'p2mp_id', 'signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tunnel-remote"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.LspFec']['meta_info']


                class S2l(_Entity_):
                    """
                    array of S2L structures
                    
                    .. attribute:: s2l_fec
                    
                    	FEC for the S2L
                    	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option
                    
                    	The path option used to find the path for this S2L
                    	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption>`
                    
                    	**config**\: False
                    
                    .. attribute:: out_xro
                    
                    	Outgoing XRO for this S2L
                    	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro>`
                    
                    	**config**\: False
                    
                    .. attribute:: in_xro
                    
                    	Incoming XRO for this S2L
                    	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro>`
                    
                    	**config**\: False
                    
                    .. attribute:: tspec
                    
                    	The T spec info
                    	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: generic_tspec
                    
                    	Generic TSpec
                    	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: fspec
                    
                    	The F spec info
                    	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: generic_fspec
                    
                    	Generic FSpec
                    	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address_generic
                    
                    	Next hop address
                    	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_hop_address_generic
                    
                    	Previous hop address
                    	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_address_generic
                    
                    	Incoming interface address
                    	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_convergence
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption
                    
                    	The soft preemption info for this LSP
                    	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_labels
                    
                    	GMPLS labels
                    	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels>`
                    
                    	**config**\: False
                    
                    .. attribute:: otn_s2l
                    
                    	Otn S2L Information
                    	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l>`
                    
                    	**config**\: False
                    
                    .. attribute:: head_end_bfd_info
                    
                    	The Head\-end BFD info
                    	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: tail_end_bfd_info
                    
                    	The Tail\-end BFD info
                    	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_collection
                    
                    	SRLG\-collection data
                    	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_fec
                    
                    	Reverse Associated Bidir LSP FEC
                    	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_tspec
                    
                    	The Reverse T spec info
                    	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec>`
                    
                    	**config**\: False
                    
                    .. attribute:: flex_info
                    
                    	FlexLSP S2L Information
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_wrap_info
                    
                    	Lsp Wrap  Related information
                    	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	S2L Diversity Information
                    	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: accumulated_path_metrics
                    
                    	Accumulated Path Metrics
                    	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics>`
                    
                    	**config**\: False
                    
                    .. attribute:: accumulated_reverse_path_metrics
                    
                    	Accumulated Reverse Path Metrics
                    	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_area
                    
                    	IGP\-area in which the S2L path was calculated
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_expanded_ero
                    
                    	TRUE if this LSR expanded a loose path
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_reeval_query_mid
                    
                    	Loose path reevaluation query received at mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_query_received_mid
                    
                    	Time since last reevaluation query received at mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_preferred_path_exists_send_mid
                    
                    	Time since last preferred path exists msg send from mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: time_since_last_preferred_tree_exists_send_mid
                    
                    	Time since last preferred tree exists msg send from mid\-point
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_area_id
                    
                    	Indicates the protocol and area used to find Outgoing ERO
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_affinity_bits
                    
                    	The Outgoing ERO's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_affinity_mask
                    
                    	The Outgoing ERO's affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_metric_type
                    
                    	The Outgoing ERO's selection metric
                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    	**config**\: False
                    
                    .. attribute:: expanded_ero_metric
                    
                    	The metric value of the expanded path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: abr_auto_discovered
                    
                    	Next ABR auto discovered
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_enabled
                    
                    	FRR Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_node_protected
                    
                    	Node Protection Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_protect
                    
                    	BW Protection Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_rro_enabled
                    
                    	Path RRO Enabled or Disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: weight
                    
                    	The path's weight
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_weight
                    
                    	The reverse path weight
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: egress_interface
                    
                    	Egress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: egress_interface_state
                    
                    	State of Outgoing Interface
                    	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_interface_brief
                    
                    	Egress Interface in brief format
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface
                    
                    	Ingress Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface_state
                    
                    	State of Incoming Interface
                    	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                    
                    	**config**\: False
                    
                    .. attribute:: ingress_interface_brief
                    
                    	Ingress Interface in brief format
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_local_label
                    
                    	Local label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_out_label
                    
                    	Outgoing label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: outbound_frr_state
                    
                    	Indicates outbound FRR state
                    	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                    
                    	**config**\: False
                    
                    .. attribute:: frr_out_tunnel_interface
                    
                    	FRR out tunnel intface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: role
                    
                    	Role of S2L
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: signalling_status
                    
                    	Signaling status
                    	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_router_id
                    
                    	Local router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: upstream_router_id
                    
                    	Upstream router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: downstream_router_id
                    
                    	Downstream router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	Next hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_address
                    
                    	Next next hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: previous_hop_address
                    
                    	Previous hop address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: incoming_address
                    
                    	Incoming interface address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: backup_tunnel_interface
                    
                    	Interface handle of the backup tunnel
                    	**type**\: str
                    
                    	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                    
                    	**config**\: False
                    
                    .. attribute:: node_hop_count
                    
                    	Hop count
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_optical
                    
                    	Is Optical
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_ero_obj_present
                    
                    	 S2l Reverse ERO Object Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_present
                    
                    	Reverse Associated Bidir LSP Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_connected
                    
                    	Reverse Associated Bidir LSP Connected
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp_name
                    
                    	Reverse Associated Bidir LSP Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_tspec_obj_present
                    
                    	 S2L Reverse TSpec Object Present
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_using_strict_spf
                    
                    	Path is using Strict SPF
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_reverse_lsp_sub_obj
                    
                    	Reverse LSP Sub Objects
                    	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj>`
                    
                    	**config**\: False
                    
                    .. attribute:: shared_risk_link_group
                    
                    	The S2L's excluded srlg groups
                    	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: out_ero
                    
                    	Outgoing ERO for this S2L
                    	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: in_ero
                    
                    	Incoming ERO for this S2L
                    	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_rro
                    
                    	Path RRO for this S2L
                    	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro>`
                    
                    	**config**\: False
                    
                    .. attribute:: resv_rro
                    
                    	Resv RRO for this S2L
                    	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_affinity_array
                    
                    	Tunnel's Path hops with affinity
                    	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_in
                    
                    	 Reverse Incoming ERO for this S2L
                    	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_segment_routing_path
                    
                    	Segment\-Routing S2L path info
                    	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "tunnel-remote"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath))])
                        self._leafs = OrderedDict([
                            ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                            ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                            ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                            ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                            ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                            ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                            ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                            ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                            ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                            ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                            ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                            ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                            ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                            ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                            ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                            ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                            ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                            ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                            ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                            ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                            ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                            ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                            ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                            ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                            ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                            ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                            ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                            ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                            ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                            ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                            ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                            ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                            ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                            ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                            ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                            ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                            ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                            ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                            ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                            ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                            ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                        ])
                        self.pcalc_area = None
                        self.is_expanded_ero = None
                        self.path_reeval_query_mid = None
                        self.time_since_last_query_received_mid = None
                        self.time_since_last_preferred_path_exists_send_mid = None
                        self.time_since_last_preferred_tree_exists_send_mid = None
                        self.expanded_ero_area_id = None
                        self.expanded_ero_affinity_bits = None
                        self.expanded_ero_affinity_mask = None
                        self.expanded_ero_metric_type = None
                        self.expanded_ero_metric = None
                        self.abr_auto_discovered = None
                        self.is_frr_enabled = None
                        self.is_node_protected = None
                        self.is_bandwidth_protect = None
                        self.path_rro_enabled = None
                        self.weight = None
                        self.reverse_weight = None
                        self.uptime = None
                        self.egress_interface = None
                        self.egress_interface_state = None
                        self.egress_interface_brief = None
                        self.ingress_interface = None
                        self.ingress_interface_state = None
                        self.ingress_interface_brief = None
                        self.s2l_local_label = None
                        self.s2l_out_label = None
                        self.outbound_frr_state = None
                        self.frr_out_tunnel_interface = None
                        self.role = None
                        self.signalling_status = None
                        self.local_router_id = None
                        self.upstream_router_id = None
                        self.downstream_router_id = None
                        self.next_hop_address = None
                        self.next_next_hop_address = None
                        self.previous_hop_address = None
                        self.incoming_address = None
                        self.backup_tunnel_interface = None
                        self.node_hop_count = None
                        self.is_optical = None
                        self.s2l_reverse_ero_obj_present = None
                        self.reverse_lsp_present = None
                        self.reverse_lsp_connected = None
                        self.reverse_lsp_name = None
                        self.s2l_reverse_tspec_obj_present = None
                        self.path_using_strict_spf = None

                        self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec()
                        self.s2l_fec.parent = self
                        self._children_name_map["s2l_fec"] = "s2l-fec"

                        self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption()
                        self.active_path_option.parent = self
                        self._children_name_map["active_path_option"] = "active-path-option"

                        self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro()
                        self.out_xro.parent = self
                        self._children_name_map["out_xro"] = "out-xro"

                        self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro()
                        self.in_xro.parent = self
                        self._children_name_map["in_xro"] = "in-xro"

                        self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec()
                        self.tspec.parent = self
                        self._children_name_map["tspec"] = "tspec"

                        self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec()
                        self.generic_tspec.parent = self
                        self._children_name_map["generic_tspec"] = "generic-tspec"

                        self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec()
                        self.fspec.parent = self
                        self._children_name_map["fspec"] = "fspec"

                        self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec()
                        self.generic_fspec.parent = self
                        self._children_name_map["generic_fspec"] = "generic-fspec"

                        self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric()
                        self.next_hop_address_generic.parent = self
                        self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                        self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric()
                        self.previous_hop_address_generic.parent = self
                        self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                        self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric()
                        self.incoming_address_generic.parent = self
                        self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                        self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence()
                        self.s2l_convergence.parent = self
                        self._children_name_map["s2l_convergence"] = "s2l-convergence"

                        self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption()
                        self.soft_preemption.parent = self
                        self._children_name_map["soft_preemption"] = "soft-preemption"

                        self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels()
                        self.gmpls_labels.parent = self
                        self._children_name_map["gmpls_labels"] = "gmpls-labels"

                        self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l()
                        self.otn_s2l.parent = self
                        self._children_name_map["otn_s2l"] = "otn-s2l"

                        self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo()
                        self.head_end_bfd_info.parent = self
                        self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                        self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo()
                        self.tail_end_bfd_info.parent = self
                        self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                        self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection()
                        self.srlg_collection.parent = self
                        self._children_name_map["srlg_collection"] = "srlg-collection"

                        self.association = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec()
                        self.reverse_lsp_fec.parent = self
                        self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                        self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec()
                        self.reverse_tspec.parent = self
                        self._children_name_map["reverse_tspec"] = "reverse-tspec"

                        self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo()
                        self.lsp_wrap_info.parent = self
                        self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                        self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo()
                        self.diversity_info.parent = self
                        self._children_name_map["diversity_info"] = "diversity-info"

                        self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics()
                        self.accumulated_path_metrics.parent = self
                        self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                        self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics()
                        self.accumulated_reverse_path_metrics.parent = self
                        self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                        self.s2l_reverse_lsp_sub_obj = YList(self)
                        self.shared_risk_link_group = YList(self)
                        self.out_ero = YList(self)
                        self.in_ero = YList(self)
                        self.path_rro = YList(self)
                        self.resv_rro = YList(self)
                        self.path_affinity_array = YList(self)
                        self.reverse_ero_in = YList(self)
                        self.s2l_segment_routing_path = YList(self)
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                    class S2lFec(_Entity_):
                        """
                        FEC for the S2L
                        
                        .. attribute:: s2l_fec_subgroup_id
                        
                        	sub\-LSP subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_source
                        
                        	LSP source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_dest
                        
                        	sub\-LSP destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_subgroup_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_ctype
                        
                        	Session identifier (ctype)
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec, self).__init__()

                            self.yang_name = "s2l-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                            ])
                            self.s2l_fec_subgroup_id = None
                            self.s2l_fec_lsp_id = None
                            self.s2l_fec_tunnel_id = None
                            self.s2l_fec_extended_tunnel_id = None
                            self.s2l_fec_source = None
                            self.s2l_fec_dest = None
                            self.s2l_fec_p2mp_id = None
                            self.s2l_fec_subgroup_originator = None
                            self.s2l_fec_ctype = None
                            self.s2l_fec_vrf = None
                            self._segment_path = lambda: "s2l-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lFec']['meta_info']


                    class ActivePathOption(_Entity_):
                        """
                        The path option used to find the path for this
                        S2L
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption, self).__init__()

                            self.yang_name = "active-path-option"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "active-path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "active-path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ActivePathOption']['meta_info']


                    class OutXro(_Entity_):
                        """
                        Outgoing XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro, self).__init__()

                            self.yang_name = "out-xro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "out-xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "out-xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutXro']['meta_info']


                    class InXro(_Entity_):
                        """
                        Incoming XRO for this S2L
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro, self).__init__()

                            self.yang_name = "in-xro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "in-xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "in-xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InXro']['meta_info']


                    class Tspec(_Entity_):
                        """
                        The T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec, self).__init__()

                            self.yang_name = "tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Tspec']['meta_info']


                    class GenericTspec(_Entity_):
                        """
                        Generic TSpec
                        
                        .. attribute:: otntspec
                        
                        	TE TSpec for G709 OTN
                        	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec_type
                        
                        	TSpecType
                        	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec, self).__init__()

                            self.yang_name = "generic-tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec))])
                            self._leafs = OrderedDict([
                                ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                            ])
                            self.tspec_type = None

                            self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec()
                            self.otntspec.parent = self
                            self._children_name_map["otntspec"] = "otntspec"
                            self._segment_path = lambda: "generic-tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec, ['tspec_type'], name, value)


                        class Otntspec(_Entity_):
                            """
                            TE TSpec for G709 OTN
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec, self).__init__()

                                self.yang_name = "otntspec"
                                self.yang_parent_name = "generic-tspec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                    ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                    ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                    ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                    ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                ])
                                self.signal_type = None
                                self.nmc_or_tolerance = None
                                self.nvc = None
                                self.multiplier = None
                                self.bit_rate = None
                                self._segment_path = lambda: "otntspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec.Otntspec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericTspec']['meta_info']


                    class Fspec(_Entity_):
                        """
                        The F spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec, self).__init__()

                            self.yang_name = "fspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "fspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Fspec']['meta_info']


                    class GenericFspec(_Entity_):
                        """
                        Generic FSpec
                        
                        .. attribute:: otnfspec
                        
                        	TE FSpec for G709 OTN
                        	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec_type
                        
                        	FSpecType
                        	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec, self).__init__()

                            self.yang_name = "generic-fspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec))])
                            self._leafs = OrderedDict([
                                ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                            ])
                            self.fspec_type = None

                            self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec()
                            self.otnfspec.parent = self
                            self._children_name_map["otnfspec"] = "otnfspec"
                            self._segment_path = lambda: "generic-fspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec, ['fspec_type'], name, value)


                        class Otnfspec(_Entity_):
                            """
                            TE FSpec for G709 OTN
                            
                            .. attribute:: signal_type
                            
                            	Signal Type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: nmc_or_tolerance
                            
                            	NMC or Tolerance
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: nvc
                            
                            	Number of Virtual Components
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: bit_rate
                            
                            	Bit Rate in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec, self).__init__()

                                self.yang_name = "otnfspec"
                                self.yang_parent_name = "generic-fspec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                    ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                    ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                    ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                    ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                ])
                                self.signal_type = None
                                self.nmc_or_tolerance = None
                                self.nvc = None
                                self.multiplier = None
                                self.bit_rate = None
                                self._segment_path = lambda: "otnfspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec.Otnfspec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GenericFspec']['meta_info']


                    class NextHopAddressGeneric(_Entity_):
                        """
                        Next hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric, self).__init__()

                            self.yang_name = "next-hop-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "next-hop-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "next-hop-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.NextHopAddressGeneric']['meta_info']


                    class PreviousHopAddressGeneric(_Entity_):
                        """
                        Previous hop address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric, self).__init__()

                            self.yang_name = "previous-hop-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "previous-hop-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "previous-hop-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PreviousHopAddressGeneric']['meta_info']


                    class IncomingAddressGeneric(_Entity_):
                        """
                        Incoming interface address
                        
                        .. attribute:: te_addr
                        
                        	TE Address
                        	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric, self).__init__()

                            self.yang_name = "incoming-address-generic"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr))])
                            self._leafs = OrderedDict()

                            self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr()
                            self.te_addr.parent = self
                            self._children_name_map["te_addr"] = "te-addr"
                            self._segment_path = lambda: "incoming-address-generic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric, [], name, value)


                        class TeAddr(_Entity_):
                            """
                            TE Address
                            
                            .. attribute:: ipv4_unnumbered_address
                            
                            	IPv4 unnumbered address
                            	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv4_address
                            
                            	IPv4 address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                self.yang_name = "te-addr"
                                self.yang_parent_name = "incoming-address-generic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                    ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ])
                                self.type = None
                                self.ipv4_address = None

                                self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                self.ipv4_unnumbered_address.parent = self
                                self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                self._segment_path = lambda: "te-addr"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                            class Ipv4UnnumberedAddress(_Entity_):
                                """
                                IPv4 unnumbered address
                                
                                .. attribute:: router_id
                                
                                	IPv4 router ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_index
                                
                                	Interface index
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                    self.yang_name = "ipv4-unnumbered-address"
                                    self.yang_parent_name = "te-addr"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                        ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                    ])
                                    self.router_id = None
                                    self.interface_index = None
                                    self._segment_path = lambda: "ipv4-unnumbered-address"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.IncomingAddressGeneric']['meta_info']


                    class S2lConvergence(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence, self).__init__()

                            self.yang_name = "s2l-convergence"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "s2l-convergence"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lConvergence']['meta_info']


                    class SoftPreemption(_Entity_):
                        """
                        The soft preemption info for this LSP.
                        
                        .. attribute:: status
                        
                        	The current state of the soft preemption operation
                        	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption_timestamp
                        
                        	The POSIX timestamp when the soft preemption occurred
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption_link
                        
                        	Name of the link where the soft preemption occurred
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: time_to_hard_preemption
                        
                        	The number of seconds until hard preemption is triggered
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: fr_rrewrite
                        
                        	FRR\-rewrite during soft preemption
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fr_rrewrite_tunnel_name
                        
                        	The tunnel name of the backup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption, self).__init__()

                            self.yang_name = "soft-preemption"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                            ])
                            self.status = None
                            self.soft_preemption_timestamp = None
                            self.soft_preemption_link = None
                            self.preempting_link_address = None
                            self.time_to_hard_preemption = None
                            self.fr_rrewrite = None
                            self.fr_rrewrite_tunnel_name = None
                            self._segment_path = lambda: "soft-preemption"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SoftPreemption']['meta_info']


                    class GmplsLabels(_Entity_):
                        """
                        GMPLS labels
                        
                        .. attribute:: path_ingress_label
                        
                        	Path message (upstream) ingress label
                        	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_egress_label
                        
                        	Path message (upstream) egress label
                        	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_ingress_label
                        
                        	Resv message (downstream) ingress label
                        	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_egress_label
                        
                        	Resv message (downstream) egress label
                        	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels, self).__init__()

                            self.yang_name = "gmpls-labels"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel))])
                            self._leafs = OrderedDict()

                            self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel()
                            self.path_ingress_label.parent = self
                            self._children_name_map["path_ingress_label"] = "path-ingress-label"

                            self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel()
                            self.path_egress_label.parent = self
                            self._children_name_map["path_egress_label"] = "path-egress-label"

                            self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel()
                            self.resv_ingress_label.parent = self
                            self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                            self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel()
                            self.resv_egress_label.parent = self
                            self._children_name_map["resv_egress_label"] = "resv-egress-label"
                            self._segment_path = lambda: "gmpls-labels"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels, [], name, value)


                        class PathIngressLabel(_Entity_):
                            """
                            Path message (upstream) ingress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                self.yang_name = "path-ingress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "path-ingress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                        class PathEgressLabel(_Entity_):
                            """
                            Path message (upstream) egress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                self.yang_name = "path-egress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "path-egress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "path-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "path-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                        class ResvIngressLabel(_Entity_):
                            """
                            Resv message (downstream) ingress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                self.yang_name = "resv-ingress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "resv-ingress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-ingress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                        class ResvEgressLabel(_Entity_):
                            """
                            Resv message (downstream) egress label
                            
                            .. attribute:: wdm
                            
                            	Fixed\-grid WDM label
                            	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                            
                            	**config**\: False
                            
                            .. attribute:: otn
                            
                            	Fixed\-size G09 OTN label
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_type
                            
                            	LabelType
                            	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                self.yang_name = "resv-egress-label"
                                self.yang_parent_name = "gmpls-labels"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                self._leafs = OrderedDict([
                                    ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                ])
                                self.label_type = None

                                self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                self.wdm.parent = self
                                self._children_name_map["wdm"] = "wdm"

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._segment_path = lambda: "resv-egress-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                            class Wdm(_Entity_):
                                """
                                Fixed\-grid WDM label
                                
                                .. attribute:: label_set
                                
                                	Flag to indicate whether label is set
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: grid
                                
                                	Grid
                                	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                
                                	**config**\: False
                                
                                .. attribute:: channel_spacing
                                
                                	Channel spacing
                                	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                
                                	**config**\: False
                                
                                .. attribute:: identifier
                                
                                	Identifier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: channel
                                
                                	Channel Number
                                	**type**\: int
                                
                                	**range:** \-32768..32767
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                    self.yang_name = "wdm"
                                    self.yang_parent_name = "resv-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                        ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                        ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                        ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                        ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                    ])
                                    self.label_set = None
                                    self.grid = None
                                    self.channel_spacing = None
                                    self.identifier = None
                                    self.channel = None
                                    self._segment_path = lambda: "wdm"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                            class Otn(_Entity_):
                                """
                                Fixed\-size G09 OTN label
                                
                                .. attribute:: tpn
                                
                                	Tributary time slot
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map_length
                                
                                	Bit map length
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_map
                                
                                	Bit Map
                                	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "resv-egress-label"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                    self._leafs = OrderedDict([
                                        ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                        ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                    ])
                                    self.tpn = None
                                    self.bit_map_length = None

                                    self.bit_map = YList(self)
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                class BitMap(_Entity_):
                                    """
                                    Bit Map
                                    
                                    .. attribute:: entry
                                    
                                    	Bit Map
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                        self.yang_name = "bit-map"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "bit-map"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.GmplsLabels']['meta_info']


                    class OtnS2l(_Entity_):
                        """
                        Otn S2L Information
                        
                        .. attribute:: otn
                        
                        	Info Related to OTN technology in S2L
                        	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn>`
                        
                        	**config**\: False
                        
                        .. attribute:: aps
                        
                        	APS Info for OTN S2L
                        	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l, self).__init__()

                            self.yang_name = "otn-s2l"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps))])
                            self._leafs = OrderedDict()

                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn()
                            self.otn.parent = self
                            self._children_name_map["otn"] = "otn"

                            self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps()
                            self.aps.parent = self
                            self._children_name_map["aps"] = "aps"
                            self._segment_path = lambda: "otn-s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l, [], name, value)


                        class Otn(_Entity_):
                            """
                            Info Related to OTN technology in S2L
                            
                            .. attribute:: bandwidth
                            
                            	OTN Bandwidth for s2l
                            	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth>`
                            
                            	**config**\: False
                            
                            .. attribute:: labels
                            
                            	Labels
                            	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels>`
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller
                            
                            	Incoming Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller_state
                            
                            	State of Incoming Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller
                            
                            	Incoming Sub Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller_state
                            
                            	State of Incoming Sub Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller
                            
                            	Outgoing Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller_state
                            
                            	State of Outgoing Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller
                            
                            	Outgoing Sub Controller
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller_state
                            
                            	State of Outgoing Sub Controller
                            	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                            
                            	**config**\: False
                            
                            .. attribute:: cross_connect_id
                            
                            	Cross connect id
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_connected
                            
                            	True if subcontrollers are connected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: uptime
                            
                            	XC Uptime
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_controller_ifhandle
                            
                            	Outgoing Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: outgoing_sub_controller_ifhandle
                            
                            	Outgoing Sub Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_controller_ifhandle
                            
                            	Incoming Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: incoming_sub_controller_ifhandle
                            
                            	Incoming Sub Controller Ifhandle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: gpid
                            
                            	Gpid Payload
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn, self).__init__()

                                self.yang_name = "otn"
                                self.yang_parent_name = "otn-s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels))])
                                self._leafs = OrderedDict([
                                    ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                    ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                    ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                    ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                    ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                    ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                    ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                    ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                    ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                    ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                    ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                    ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                    ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                ])
                                self.incoming_controller = None
                                self.incoming_controller_state = None
                                self.incoming_sub_controller = None
                                self.incoming_sub_controller_state = None
                                self.outgoing_controller = None
                                self.outgoing_controller_state = None
                                self.outgoing_sub_controller = None
                                self.outgoing_sub_controller_state = None
                                self.cross_connect_id = None
                                self.is_connected = None
                                self.uptime = None
                                self.outgoing_controller_ifhandle = None
                                self.outgoing_sub_controller_ifhandle = None
                                self.incoming_controller_ifhandle = None
                                self.incoming_sub_controller_ifhandle = None
                                self.gpid = None

                                self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth()
                                self.bandwidth.parent = self
                                self._children_name_map["bandwidth"] = "bandwidth"

                                self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels()
                                self.labels.parent = self
                                self._children_name_map["labels"] = "labels"
                                self._segment_path = lambda: "otn"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                            class Bandwidth(_Entity_):
                                """
                                OTN Bandwidth for s2l
                                
                                .. attribute:: odu_flex_cbr
                                
                                	Odu flex CBR info
                                	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_flex_gfp_f_res
                                
                                	Odu flex GFP\-F resizable info
                                	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_flex_gfp_f_non_res
                                
                                	Odu flex GFP\-F non\-resizable info
                                	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                
                                	**config**\: False
                                
                                .. attribute:: odu_level
                                
                                	ODULevel
                                	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                    self.yang_name = "bandwidth"
                                    self.yang_parent_name = "otn"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                    self._leafs = OrderedDict([
                                        ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                    ])
                                    self.odu_level = None

                                    self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                    self.odu_flex_cbr.parent = self
                                    self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                    self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                    self.odu_flex_gfp_f_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                    self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                    self.odu_flex_gfp_f_non_res.parent = self
                                    self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    self._segment_path = lambda: "bandwidth"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                class OduFlexCbr(_Entity_):
                                    """
                                    Odu flex CBR info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tolerance
                                    
                                    	Tolerance
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                        self.yang_name = "odu-flex-cbr"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self.tolerance = None
                                        self._segment_path = lambda: "odu-flex-cbr"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                class OduFlexGfpFRes(_Entity_):
                                    """
                                    Odu flex GFP\-F resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-res"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self._segment_path = lambda: "odu-flex-gfp-f-res"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                class OduFlexGfpFNonRes(_Entity_):
                                    """
                                    Odu flex GFP\-F non\-resizable info
                                    
                                    .. attribute:: bit_rate
                                    
                                    	Bit rate in kbit/s
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                        self.yang_name = "odu-flex-gfp-f-non-res"
                                        self.yang_parent_name = "bandwidth"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ])
                                        self.bit_rate = None
                                        self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                            class Labels(_Entity_):
                                """
                                Labels
                                
                                .. attribute:: path_ingress_label
                                
                                	Path message (upstream) ingress label
                                	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: path_egress_label
                                
                                	Path message (upstream) egress label
                                	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: resv_ingress_label
                                
                                	Resv message (downstream) ingress label
                                	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                
                                	**config**\: False
                                
                                .. attribute:: resv_egress_label
                                
                                	Resv message (downstream) egress label
                                	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels, self).__init__()

                                    self.yang_name = "labels"
                                    self.yang_parent_name = "otn"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                    self._leafs = OrderedDict()

                                    self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                    self.path_ingress_label.parent = self
                                    self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                    self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                    self.path_egress_label.parent = self
                                    self._children_name_map["path_egress_label"] = "path-egress-label"

                                    self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                    self.resv_ingress_label.parent = self
                                    self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                    self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                    self.resv_egress_label.parent = self
                                    self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    self._segment_path = lambda: "labels"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels, [], name, value)


                                class PathIngressLabel(_Entity_):
                                    """
                                    Path message (upstream) ingress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                        self.yang_name = "path-ingress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "path-ingress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                class PathEgressLabel(_Entity_):
                                    """
                                    Path message (upstream) egress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                        self.yang_name = "path-egress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "path-egress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "path-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "path-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                class ResvIngressLabel(_Entity_):
                                    """
                                    Resv message (downstream) ingress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                        self.yang_name = "resv-ingress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "resv-ingress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-ingress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                class ResvEgressLabel(_Entity_):
                                    """
                                    Resv message (downstream) egress label
                                    
                                    .. attribute:: wdm
                                    
                                    	Fixed\-grid WDM label
                                    	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: otn
                                    
                                    	Fixed\-size G09 OTN label
                                    	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: label_type
                                    
                                    	LabelType
                                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                        self.yang_name = "resv-egress-label"
                                        self.yang_parent_name = "labels"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                        self._leafs = OrderedDict([
                                            ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                        ])
                                        self.label_type = None

                                        self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                        self.wdm.parent = self
                                        self._children_name_map["wdm"] = "wdm"

                                        self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                        self._segment_path = lambda: "resv-egress-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                    class Wdm(_Entity_):
                                        """
                                        Fixed\-grid WDM label
                                        
                                        .. attribute:: label_set
                                        
                                        	Flag to indicate whether label is set
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: grid
                                        
                                        	Grid
                                        	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel_spacing
                                        
                                        	Channel spacing
                                        	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: identifier
                                        
                                        	Identifier
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: channel
                                        
                                        	Channel Number
                                        	**type**\: int
                                        
                                        	**range:** \-32768..32767
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                            self.yang_name = "wdm"
                                            self.yang_parent_name = "resv-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                            ])
                                            self.label_set = None
                                            self.grid = None
                                            self.channel_spacing = None
                                            self.identifier = None
                                            self.channel = None
                                            self._segment_path = lambda: "wdm"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                    class Otn_(_Entity_):
                                        """
                                        Fixed\-size G09 OTN label
                                        
                                        .. attribute:: tpn
                                        
                                        	Tributary time slot
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map_length
                                        
                                        	Bit map length
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bit_map
                                        
                                        	Bit Map
                                        	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                            self.yang_name = "otn"
                                            self.yang_parent_name = "resv-egress-label"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                            self._leafs = OrderedDict([
                                                ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                            ])
                                            self.tpn = None
                                            self.bit_map_length = None

                                            self.bit_map = YList(self)
                                            self._segment_path = lambda: "otn"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                        class BitMap(_Entity_):
                                            """
                                            Bit Map
                                            
                                            .. attribute:: entry
                                            
                                            	Bit Map
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                self.yang_name = "bit-map"
                                                self.yang_parent_name = "otn"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "bit-map"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn.Labels']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Otn']['meta_info']


                        class Aps(_Entity_):
                            """
                            APS Info for OTN S2L
                            
                            .. attribute:: protection_info
                            
                            	Protection Info
                            	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps, self).__init__()

                                self.yang_name = "aps"
                                self.yang_parent_name = "otn-s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo))])
                                self._leafs = OrderedDict()

                                self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo()
                                self.protection_info.parent = self
                                self._children_name_map["protection_info"] = "protection-info"
                                self._segment_path = lambda: "aps"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps, [], name, value)


                            class ProtectionInfo(_Entity_):
                                """
                                Protection Info
                                
                                .. attribute:: sbit
                                
                                	Secondary bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: pbit
                                
                                	Protecting bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: nbit
                                
                                	Notification bit 
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: obit
                                
                                	Operational bit
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: protect_type
                                
                                	LSP Protect Type
                                	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_wtr_present
                                
                                	Is Wait\-to\-Restore timeout present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: wtr_timeout
                                
                                	Wait\-to\-Restore timeout
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_hopresent
                                
                                	Is Hold\-Off timeout present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ho_timeout
                                
                                	Hold\-Off timeout
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_snc_mode_present
                                
                                	Is SNC mode present
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: snc_mode
                                
                                	SNC mode
                                	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: tcm_id
                                
                                	TCM ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: path_prot_profile_type
                                
                                	Path protection profile type
                                	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                    self.yang_name = "protection-info"
                                    self.yang_parent_name = "aps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                        ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                        ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                        ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                        ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                        ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                        ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                        ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                        ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                        ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                        ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                        ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                        ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ])
                                    self.sbit = None
                                    self.pbit = None
                                    self.nbit = None
                                    self.obit = None
                                    self.protect_type = None
                                    self.is_wtr_present = None
                                    self.wtr_timeout = None
                                    self.is_hopresent = None
                                    self.ho_timeout = None
                                    self.is_snc_mode_present = None
                                    self.snc_mode = None
                                    self.tcm_id = None
                                    self.path_prot_profile_type = None
                                    self._segment_path = lambda: "protection-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l.Aps']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OtnS2l']['meta_info']


                    class HeadEndBfdInfo(_Entity_):
                        """
                        The Head\-end BFD info
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: deletion_history
                        
                        	BFD Session Deletion History
                        	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory>`
                        
                        	**config**\: False
                        
                        .. attribute:: creation_time
                        
                        	Time in seconds since the BFD session created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: lspbfd_type
                        
                        	LSP BFD type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_redundant
                        
                        	sBFD session is redundant
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_reverse_path_stale
                        
                        	The BFD reverse path is stale compared to configuration
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_reverse_path_label
                        
                        	BFD reverse path labels
                        	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo, self).__init__()

                            self.yang_name = "head-end-bfd-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                            self._leafs = OrderedDict([
                                ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                            ])
                            self.creation_time = None
                            self.lspbfd_type = None
                            self.is_redundant = None
                            self.bfd_reverse_path_stale = None

                            self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"

                            self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory()
                            self.deletion_history.parent = self
                            self._children_name_map["deletion_history"] = "deletion-history"

                            self.bfd_reverse_path_label = YList(self)
                            self._segment_path = lambda: "head-end-bfd-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                        class SessionInfo(_Entity_):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                    ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                ])
                                self.state = None
                                self.state_change_time = None
                                self._segment_path = lambda: "session-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                        class DeletionHistory(_Entity_):
                            """
                            BFD Session Deletion History
                            
                            .. attribute:: lsp_id
                            
                            	LSP ID of the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_time
                            
                            	Time stamp of the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_reason
                            
                            	Reason for the BFD session get deleted
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_diagnostic_code
                            
                            	Diagnostic Code for the BFD session get deleted
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                self.yang_name = "deletion-history"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                    ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                    ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                    ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                ])
                                self.lsp_id = None
                                self.deletion_time = None
                                self.deletion_reason = None
                                self.deletion_diagnostic_code = None
                                self._segment_path = lambda: "deletion-history"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                        class BfdReversePathLabel(_Entity_):
                            """
                            BFD reverse path labels
                            
                            .. attribute:: entry
                            
                            	BFD reverse path labels
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                self.yang_name = "bfd-reverse-path-label"
                                self.yang_parent_name = "head-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "bfd-reverse-path-label"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.HeadEndBfdInfo']['meta_info']


                    class TailEndBfdInfo(_Entity_):
                        """
                        The Tail\-end BFD info
                        
                        .. attribute:: session_info
                        
                        	BFD Session Info
                        	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: failure_diagnostic_code
                        
                        	BFD session failure diagnostic code
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: failure_reason
                        
                        	BFD session failure reason
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: local_discriminator
                        
                        	BFD Local Discriminator
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remote_discriminator
                        
                        	BFD Remote Discrminator
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in mini second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo, self).__init__()

                            self.yang_name = "tail-end-bfd-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo))])
                            self._leafs = OrderedDict([
                                ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                            ])
                            self.failure_diagnostic_code = None
                            self.failure_reason = None
                            self.local_discriminator = None
                            self.remote_discriminator = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None

                            self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo()
                            self.session_info.parent = self
                            self._children_name_map["session_info"] = "session-info"
                            self._segment_path = lambda: "tail-end-bfd-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                        class SessionInfo(_Entity_):
                            """
                            BFD Session Info
                            
                            .. attribute:: state
                            
                            	BFD session state
                            	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: state_change_time
                            
                            	Time in seconds since the last session state change
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                self.yang_name = "session-info"
                                self.yang_parent_name = "tail-end-bfd-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                    ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                ])
                                self.state = None
                                self.state_change_time = None
                                self._segment_path = lambda: "session-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.TailEndBfdInfo']['meta_info']


                    class SrlgCollection(_Entity_):
                        """
                        SRLG\-collection data
                        
                        .. attribute:: srlg_collect_type
                        
                        	SRLG\-collection mechanism
                        	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                        
                        	**config**\: False
                        
                        .. attribute:: discovered_srlg
                        
                        	Discovered SRLGs
                        	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection, self).__init__()

                            self.yang_name = "srlg-collection"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg))])
                            self._leafs = OrderedDict([
                                ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                            ])
                            self.srlg_collect_type = None

                            self.discovered_srlg = YList(self)
                            self._segment_path = lambda: "srlg-collection"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                        class DiscoveredSrlg(_Entity_):
                            """
                            Discovered SRLGs
                            
                            .. attribute:: entry
                            
                            	Discovered SRLGs
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                self.yang_name = "discovered-srlg"
                                self.yang_parent_name = "srlg-collection"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "discovered-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SrlgCollection']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.Protection']['meta_info']


                    class ReverseLspFec(_Entity_):
                        """
                        Reverse Associated Bidir LSP FEC
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec, self).__init__()

                            self.yang_name = "reverse-lsp-fec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "reverse-lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "reverse-lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseLspFec']['meta_info']


                    class ReverseTspec(_Entity_):
                        """
                        The Reverse T spec info
                        
                        .. attribute:: average_rate
                        
                        	Average bandwidth in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: maximum_burst
                        
                        	Maximum burst of data in bytes
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: byte
                        
                        .. attribute:: peak_rate
                        
                        	Peak rate in  kbps
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec, self).__init__()

                            self.yang_name = "reverse-tspec"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                            ])
                            self.average_rate = None
                            self.maximum_burst = None
                            self.peak_rate = None
                            self._segment_path = lambda: "reverse-tspec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseTspec']['meta_info']


                    class FlexInfo(_Entity_):
                        """
                        FlexLSP S2L Information
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.FlexInfo']['meta_info']


                    class LspWrapInfo(_Entity_):
                        """
                        Lsp Wrap  Related information
                        
                        .. attribute:: lsp_wrap_protection_enable
                        
                        	LSP Wrap protection enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_protection_label
                        
                        	LSP Wrap Merge Point Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_egress_interface
                        
                        	Reverse Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_label
                        
                        	Reverse LSP label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_protection_state
                        
                        	LSP wrap protection state
                        	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo, self).__init__()

                            self.yang_name = "lsp-wrap-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                            ])
                            self.lsp_wrap_protection_enable = None
                            self.lsp_wrap_protection_label = None
                            self.reverse_egress_interface = None
                            self.reverse_lsp_label = None
                            self.lsp_wrap_protection_state = None
                            self._segment_path = lambda: "lsp-wrap-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.LspWrapInfo']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        S2L Diversity Information
                        
                        .. attribute:: diversity_type
                        
                        	S2L path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.diversity_type = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo, ['diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.DiversityInfo']['meta_info']


                    class AccumulatedPathMetrics(_Entity_):
                        """
                        Accumulated Path Metrics
                        
                        .. attribute:: te_metric
                        
                        	Path TE Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: igp_metric
                        
                        	Path IGP Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: delay_metric
                        
                        	Path Delay Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics, self).__init__()

                            self.yang_name = "accumulated-path-metrics"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                            ])
                            self.te_metric = None
                            self.igp_metric = None
                            self.delay_metric = None
                            self._segment_path = lambda: "accumulated-path-metrics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedPathMetrics']['meta_info']


                    class AccumulatedReversePathMetrics(_Entity_):
                        """
                        Accumulated Reverse Path Metrics
                        
                        .. attribute:: te_metric
                        
                        	Path TE Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: igp_metric
                        
                        	Path IGP Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: delay_metric
                        
                        	Path Delay Metric
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics, self).__init__()

                            self.yang_name = "accumulated-reverse-path-metrics"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                            ])
                            self.te_metric = None
                            self.igp_metric = None
                            self.delay_metric = None
                            self._segment_path = lambda: "accumulated-reverse-path-metrics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.AccumulatedReversePathMetrics']['meta_info']


                    class S2lReverseLspSubObj(_Entity_):
                        """
                        Reverse LSP Sub Objects
                        
                        .. attribute:: entry
                        
                        	Reverse LSP Sub Objects
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj, self).__init__()

                            self.yang_name = "s2l-reverse-lsp-sub-obj"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lReverseLspSubObj']['meta_info']


                    class SharedRiskLinkGroup(_Entity_):
                        """
                        The S2L's excluded srlg groups
                        
                        .. attribute:: shared_risk_group
                        
                        	SRLG number
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_name
                        
                        	SRLG name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup, self).__init__()

                            self.yang_name = "shared-risk-link-group"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                            ])
                            self.shared_risk_group = None
                            self.srlg_name = None
                            self._segment_path = lambda: "shared-risk-link-group"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.SharedRiskLinkGroup']['meta_info']


                    class OutEro(_Entity_):
                        """
                        Outgoing ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro, self).__init__()

                            self.yang_name = "out-ero"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "out-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "out-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "out-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.OutEro']['meta_info']


                    class InEro(_Entity_):
                        """
                        Incoming ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro, self).__init__()

                            self.yang_name = "in-ero"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "in-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "in-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "in-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.InEro']['meta_info']


                    class PathRro(_Entity_):
                        """
                        Path RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro, self).__init__()

                            self.yang_name = "path-rro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject))])
                            self._leafs = OrderedDict([
                                ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                            ])
                            self.rro_type = None

                            self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                            self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                            self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                            self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._segment_path = lambda: "path-rro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro, ['rro_type'], name, value)


                        class Ipv4rroSubObject(_Entity_):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                ])
                                self.rro_address = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "ipv4rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                        class LabelRroSubObject(_Entity_):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                self._leafs = OrderedDict([
                                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                    ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                ])
                                self.label = None
                                self.is_label_variable_length = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"

                                self.variable_length_label = YList(self)
                                self._segment_path = lambda: "label-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                    ])
                                    self.is_global_label = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                            class VariableLengthLabel(_Entity_):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "variable-length-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.LabelRroSubObject']['meta_info']


                        class UnnumberedRroSubObject(_Entity_):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                    ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                ])
                                self.interface_address = None
                                self.interface_id = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "unnumbered-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                        class SrlgRroSubObject(_Entity_):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "path-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                self._leafs = OrderedDict()

                                self.srl_gs = YList(self)
                                self._segment_path = lambda: "srlg-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject, [], name, value)


                            class SrlGs(_Entity_):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "srl-gs"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro.SrlgRroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathRro']['meta_info']


                    class ResvRro(_Entity_):
                        """
                        Resv RRO for this S2L
                        
                        .. attribute:: ipv4rro_sub_object
                        
                        	IPV4 RRO Sub Object
                        	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: label_rro_sub_object
                        
                        	Label RRO Sub Object
                        	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_rro_sub_object
                        
                        	Unnumbered RRO Sub Object
                        	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_rro_sub_object
                        
                        	SRLG RRO Sub Object
                        	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: rro_type
                        
                        	RROType
                        	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro, self).__init__()

                            self.yang_name = "resv-rro"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject))])
                            self._leafs = OrderedDict([
                                ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                            ])
                            self.rro_type = None

                            self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject()
                            self.ipv4rro_sub_object.parent = self
                            self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                            self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject()
                            self.label_rro_sub_object.parent = self
                            self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                            self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject()
                            self.unnumbered_rro_sub_object.parent = self
                            self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                            self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject()
                            self.srlg_rro_sub_object.parent = self
                            self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                            self._segment_path = lambda: "resv-rro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro, ['rro_type'], name, value)


                        class Ipv4rroSubObject(_Entity_):
                            """
                            IPV4 RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO IPV4 Subobject Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_address
                            
                            	The RRO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                self.yang_name = "ipv4rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                ])
                                self.rro_address = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "ipv4rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO IPV4 Subobject Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "ipv4rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                        class LabelRroSubObject(_Entity_):
                            """
                            Label RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Label Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: label
                            
                            	The RRO Subobject Label Value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_label_variable_length
                            
                            	Is the RRO Subobject Label Variable Length
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: variable_length_label
                            
                            	The RRO Subobject Variable Length Label
                            	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                self.yang_name = "label-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                self._leafs = OrderedDict([
                                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                    ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                ])
                                self.label = None
                                self.is_label_variable_length = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"

                                self.variable_length_label = YList(self)
                                self._segment_path = lambda: "label-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Label Flags
                                
                                .. attribute:: is_global_label
                                
                                	Label is Global across all interfaces
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                    ])
                                    self.is_global_label = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                            class VariableLengthLabel(_Entity_):
                                """
                                The RRO Subobject Variable Length Label
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                    self.yang_name = "variable-length-label"
                                    self.yang_parent_name = "label-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "variable-length-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.LabelRroSubObject']['meta_info']


                        class UnnumberedRroSubObject(_Entity_):
                            """
                            Unnumbered RRO Sub Object
                            
                            .. attribute:: flags
                            
                            	The RRO Subobject Unnumbered Flags
                            	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                            
                            	**config**\: False
                            
                            .. attribute:: interface_address
                            
                            	The RRO Interface Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: interface_id
                            
                            	The RRO Interface ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                self.yang_name = "unnumbered-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                self._leafs = OrderedDict([
                                    ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                    ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                ])
                                self.interface_address = None
                                self.interface_id = None

                                self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                self.flags.parent = self
                                self._children_name_map["flags"] = "flags"
                                self._segment_path = lambda: "unnumbered-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                            class Flags(_Entity_):
                                """
                                The RRO Subobject Unnumbered Flags
                                
                                .. attribute:: is_protection_available
                                
                                	Local Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_protection_in_use
                                
                                	Local Protection In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_bandwidth_protected
                                
                                	Bandwidth Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_protection_available
                                
                                	Node Protection Available
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: is_node_id
                                
                                	Node ID In Use
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                    self.yang_name = "flags"
                                    self.yang_parent_name = "unnumbered-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                        ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                        ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                        ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                        ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                    ])
                                    self.is_protection_available = None
                                    self.is_protection_in_use = None
                                    self.is_bandwidth_protected = None
                                    self.is_node_protection_available = None
                                    self.is_node_id = None
                                    self._segment_path = lambda: "flags"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                        class SrlgRroSubObject(_Entity_):
                            """
                            SRLG RRO Sub Object
                            
                            .. attribute:: srl_gs
                            
                            	The RRO Subobject SRLGs
                            	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                self.yang_name = "srlg-rro-sub-object"
                                self.yang_parent_name = "resv-rro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                self._leafs = OrderedDict()

                                self.srl_gs = YList(self)
                                self._segment_path = lambda: "srlg-rro-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                            class SrlGs(_Entity_):
                                """
                                The RRO Subobject SRLGs
                                
                                .. attribute:: entry
                                
                                	The RRO Subobject SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                    self.yang_name = "srl-gs"
                                    self.yang_parent_name = "srlg-rro-sub-object"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "srl-gs"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ResvRro']['meta_info']


                    class PathAffinityArray(_Entity_):
                        """
                        Tunnel's Path hops with affinity
                        
                        .. attribute:: hop_address
                        
                        	Hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: hop_affinity
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hop_extended_affinity
                        
                        	Hop affinity
                        	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray, self).__init__()

                            self.yang_name = "path-affinity-array"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity))])
                            self._leafs = OrderedDict([
                                ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                            ])
                            self.hop_address = None
                            self.hop_affinity = None

                            self.hop_extended_affinity = YList(self)
                            self._segment_path = lambda: "path-affinity-array"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                        class HopExtendedAffinity(_Entity_):
                            """
                            Hop affinity
                            
                            .. attribute:: entry
                            
                            	Hop affinity
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                self.yang_name = "hop-extended-affinity"
                                self.yang_parent_name = "path-affinity-array"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "hop-extended-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.PathAffinityArray']['meta_info']


                    class ReverseEroIn(_Entity_):
                        """
                         Reverse Incoming ERO for this S2L
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn, self).__init__()

                            self.yang_name = "reverse-ero-in"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "reverse-ero-in"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "reverse-ero-in"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.ReverseEroIn']['meta_info']


                    class S2lSegmentRoutingPath(_Entity_):
                        """
                        Segment\-Routing S2L path info
                        
                        .. attribute:: sid_type
                        
                        	Type of the SID
                        	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                        
                        	**config**\: False
                        
                        .. attribute:: has_ip_addresses
                        
                        	Node has IP addresses specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: local_addr
                        
                        	Local IP address of adjacency or Node ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: remote_addr
                        
                        	Remote IP address of adjacency
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: has_mpls_label
                        
                        	Hop has MPLS label specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label_value
                        
                        	The MPLS label value
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: has_entropy_label
                        
                        	Hop has EL specified
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath, self).__init__()

                            self.yang_name = "s2l-segment-routing-path"
                            self.yang_parent_name = "s2l"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                            ])
                            self.sid_type = None
                            self.has_ip_addresses = None
                            self.local_addr = None
                            self.remote_addr = None
                            self.has_mpls_label = None
                            self.mpls_label_value = None
                            self.has_entropy_label = None
                            self._segment_path = lambda: "s2l-segment-routing-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l.S2lSegmentRoutingPath']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote.S2l']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes.TunnelRemote']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelRemotes']['meta_info']


        class NniTunnels(_Entity_):
            """
            GMPLS NNI tunnels
            
            .. attribute:: nni_tunnel
            
            	GMPLS\-NNI tail tunnel
            	**type**\: list of  		 :py:class:`NniTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels, self).__init__()

                self.yang_name = "nni-tunnels"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("nni-tunnel", ("nni_tunnel", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel))])
                self._leafs = OrderedDict()

                self.nni_tunnel = YList(self)
                self._segment_path = lambda: "nni-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels, [], name, value)


            class NniTunnel(_Entity_):
                """
                GMPLS\-NNI tail tunnel
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config>`
                
                	**config**\: False
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:  :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:  :py:class:`ReoptimizedP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:  :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:  :py:class:`ReoptimizedStandbyP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:  :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp>`
                
                	**config**\: False
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:  :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp>`
                
                	**config**\: False
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:  :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp>`
                
                	**config**\: False
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo>`
                
                	**config**\: False
                
                .. attribute:: auto_capacity
                
                	Auto\-capacity Info
                	**type**\:  :py:class:`AutoCapacity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity>`
                
                	**config**\: False
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:  :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History>`
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:  :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup>`
                
                	**config**\: False
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:  :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh>`
                
                	**config**\: False
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:  :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc>`
                
                	**config**\: False
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:  :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation>`
                
                	**config**\: False
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption>`
                
                	**config**\: False
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:  :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel>`
                
                	**config**\: False
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:  :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo>`
                
                	**config**\: False
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:  :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo>`
                
                	**config**\: False
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:  :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir>`
                
                	**config**\: False
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:  :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:  :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence>`
                
                	**config**\: False
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo>`
                
                	**config**\: False
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:  :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                	**config**\: False
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                	**config**\: False
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:  :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                	**config**\: False
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:  :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                	**config**\: False
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                	**config**\: False
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                	**config**\: False
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:  :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:  :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                	**config**\: False
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_working_lsp_id
                
                	LSP\-id of last working LSP
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel, self).__init__()

                    self.yang_name = "nni-tunnel"
                    self.yang_parent_name = "nni-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','source_address','destination_address']
                    self._child_classes = OrderedDict([("config", ("config", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config)), ("tunnel-current-lsp", ("tunnel_current_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp)), ("reoptimized-p2mp-lsp", ("reoptimized_p2mp_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp)), ("tunnel-standby-lsp", ("tunnel_standby_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp)), ("reoptimized-standby-p2mp-lsp", ("reoptimized_standby_p2mp_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp)), ("tunnel-restoration-lsp", ("tunnel_restoration_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp)), ("delay-clean-pp-lsp", ("delay_clean_pp_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp)), ("cleaned-lsp", ("cleaned_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp)), ("p2p-info", ("p2p_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo)), ("auto-capacity", ("auto_capacity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity)), ("history", ("history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History)), ("path-protection", ("path_protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection)), ("auto-backup", ("auto_backup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup)), ("auto-mesh", ("auto_mesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh)), ("auto-pcc", ("auto_pcc", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc)), ("pce-delegation", ("pce_delegation", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption)), ("wdm-unitunnel", ("wdm_unitunnel", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel)), ("transport-tunnel-info", ("transport_tunnel_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo)), ("bfd-info", ("bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo)), ("otn-bidir", ("otn_bidir", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir)), ("bidir", ("bidir", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet)), ("te-tunnel-convergence", ("te_tunnel_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo)), ("destination", ("destination", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('role_standby', (YLeaf(YType.boolean, 'role-standby'), ['bool'])),
                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                        ('admin_state', (YLeaf(YType.enumeration, 'admin-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelAdminState', '')])),
                        ('operational_state', (YLeaf(YType.enumeration, 'operational-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                        ('operational_state_changes', (YLeaf(YType.uint32, 'operational-state-changes'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('fail_reason', (YLeaf(YType.enumeration, 'fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsMteTunnelFailReason', '')])),
                        ('destination_up_count', (YLeaf(YType.uint32, 'destination-up-count'), ['int'])),
                        ('destination_disabled_count', (YLeaf(YType.uint32, 'destination-disabled-count'), ['int'])),
                        ('destination_down_count', (YLeaf(YType.uint32, 'destination-down-count'), ['int'])),
                        ('re_opt_hold_down_timer_remaining', (YLeaf(YType.uint32, 're-opt-hold-down-timer-remaining'), ['int'])),
                        ('bandwidth_requested', (YLeaf(YType.uint32, 'bandwidth-requested'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                        ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                        ('tunnel_recovering', (YLeaf(YType.boolean, 'tunnel-recovering'), ['bool'])),
                        ('reroute_pending', (YLeaf(YType.boolean, 'reroute-pending'), ['bool'])),
                        ('explicit_path_change', (YLeaf(YType.boolean, 'explicit-path-change'), ['bool'])),
                        ('path_option_change', (YLeaf(YType.boolean, 'path-option-change'), ['bool'])),
                        ('affinity_failure_reopt_disabled', (YLeaf(YType.boolean, 'affinity-failure-reopt-disabled'), ['bool'])),
                        ('affinity_failure_reopt_time_remained', (YLeaf(YType.uint32, 'affinity-failure-reopt-time-remained'), ['int'])),
                        ('affinity_failure_delayed_tear_time_remained', (YLeaf(YType.uint32, 'affinity-failure-delayed-tear-time-remained'), ['int'])),
                        ('invalidation_time_remained', (YLeaf(YType.uint32, 'invalidation-time-remained'), ['int'])),
                        ('drop_mode', (YLeaf(YType.boolean, 'drop-mode'), ['bool'])),
                        ('auto_route', (YLeaf(YType.boolean, 'auto-route'), ['bool'])),
                        ('forwarding_adjacency', (YLeaf(YType.boolean, 'forwarding-adjacency'), ['bool'])),
                        ('load_share_factor', (YLeaf(YType.uint32, 'load-share-factor'), ['int'])),
                        ('load_share_type', (YLeaf(YType.enumeration, 'load-share-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLoadshare', '')])),
                        ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                        ('tie_breaker', (YLeaf(YType.enumeration, 'tie-breaker'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                        ('tiebreaker_type', (YLeaf(YType.uint32, 'tiebreaker-type'), ['int'])),
                        ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('metric_qualifier', (YLeaf(YType.enumeration, 'metric-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('is_hop_limit_ignore', (YLeaf(YType.boolean, 'is-hop-limit-ignore'), ['bool'])),
                        ('hop_limit_ignored_reason', (YLeaf(YType.enumeration, 'hop-limit-ignored-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeHopLimitIgnore', '')])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('pce_fail_reason', (YLeaf(YType.enumeration, 'pce-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePceFailReasons', '')])),
                        ('snmp_index', (YLeaf(YType.uint32, 'snmp-index'), ['int'])),
                        ('is_inter_area_tunnel', (YLeaf(YType.boolean, 'is-inter-area-tunnel'), ['bool'])),
                        ('is_auto_backup', (YLeaf(YType.boolean, 'is-auto-backup'), ['bool'])),
                        ('is_auto_pcc', (YLeaf(YType.boolean, 'is-auto-pcc'), ['bool'])),
                        ('is_pce_delegated', (YLeaf(YType.boolean, 'is-pce-delegated'), ['bool'])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                        ('xro_attribute_set_name', (YLeaf(YType.str, 'xro-attribute-set-name'), ['str'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('passive_tunnel_name', (YLeaf(YType.str, 'passive-tunnel-name'), ['str'])),
                        ('binding_label_exists', (YLeaf(YType.boolean, 'binding-label-exists'), ['bool'])),
                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                        ('last_hop_ifindex', (YLeaf(YType.uint32, 'last-hop-ifindex'), ['int'])),
                        ('is_named', (YLeaf(YType.boolean, 'is-named'), ['bool'])),
                        ('lsp_wrap_protection_enabled', (YLeaf(YType.boolean, 'lsp-wrap-protection-enabled'), ['bool'])),
                        ('lsp_wrap_label', (YLeaf(YType.uint32, 'lsp-wrap-label'), ['int'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('autoroute_announce_exclude_segment_routing', (YLeaf(YType.boolean, 'autoroute-announce-exclude-segment-routing'), ['bool'])),
                        ('last_working_lsp_id', (YLeaf(YType.uint16, 'last-working-lsp-id'), ['int'])),
                    ])
                    self.tunnel_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.role_standby = None
                    self.tunnel_interface_name = None
                    self.admin_state = None
                    self.operational_state = None
                    self.operational_state_changes = None
                    self.signaled_name = None
                    self.fail_reason = None
                    self.destination_up_count = None
                    self.destination_disabled_count = None
                    self.destination_down_count = None
                    self.re_opt_hold_down_timer_remaining = None
                    self.bandwidth_requested = None
                    self.bandwidth_type = None
                    self.is_node_protected = None
                    self.is_bandwidth_protect = None
                    self.tunnel_recovering = None
                    self.reroute_pending = None
                    self.explicit_path_change = None
                    self.path_option_change = None
                    self.affinity_failure_reopt_disabled = None
                    self.affinity_failure_reopt_time_remained = None
                    self.affinity_failure_delayed_tear_time_remained = None
                    self.invalidation_time_remained = None
                    self.drop_mode = None
                    self.auto_route = None
                    self.forwarding_adjacency = None
                    self.load_share_factor = None
                    self.load_share_type = None
                    self.create_time = None
                    self.uptime = None
                    self.metric_type = None
                    self.tie_breaker = None
                    self.tiebreaker_type = None
                    self.tiebreaker_qualifier = None
                    self.metric_qualifier = None
                    self.is_hop_limit_ignore = None
                    self.hop_limit_ignored_reason = None
                    self.outbound_frr_state = None
                    self.area_id = None
                    self.pce_fail_reason = None
                    self.snmp_index = None
                    self.is_inter_area_tunnel = None
                    self.is_auto_backup = None
                    self.is_auto_pcc = None
                    self.is_pce_delegated = None
                    self.tunnel_attribute_set_name = None
                    self.tunnel_attribute_set_type = None
                    self.xro_attribute_set_name = None
                    self.is_passive = None
                    self.passive_tunnel_name = None
                    self.binding_label_exists = None
                    self.binding_label = None
                    self.last_hop_ifindex = None
                    self.is_named = None
                    self.lsp_wrap_protection_enabled = None
                    self.lsp_wrap_label = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.autoroute_announce_exclude_segment_routing = None
                    self.last_working_lsp_id = None

                    self.config = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"

                    self.tunnel_current_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"

                    self.reoptimized_p2mp_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"

                    self.tunnel_standby_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"

                    self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"

                    self.tunnel_restoration_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"

                    self.delay_clean_pp_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"

                    self.cleaned_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"

                    self.p2p_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"

                    self.auto_capacity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity()
                    self.auto_capacity.parent = self
                    self._children_name_map["auto_capacity"] = "auto-capacity"

                    self.history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"

                    self.path_protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.auto_backup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"

                    self.auto_mesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"

                    self.auto_pcc = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"

                    self.pce_delegation = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"

                    self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"

                    self.wdm_unitunnel = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"

                    self.transport_tunnel_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"

                    self.bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"

                    self.otn_bidir = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"

                    self.bidir = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"

                    self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                    self.te_tunnel_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"

                    self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"

                    self.destination = YList(self)
                    self._segment_path = lambda: "nni-tunnel" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/nni-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel, ['tunnel_id', 'source_address', 'destination_address', 'role_standby', 'tunnel_interface_name', 'admin_state', 'operational_state', 'operational_state_changes', 'signaled_name', 'fail_reason', 'destination_up_count', 'destination_disabled_count', 'destination_down_count', 're_opt_hold_down_timer_remaining', 'bandwidth_requested', 'bandwidth_type', 'is_node_protected', 'is_bandwidth_protect', 'tunnel_recovering', 'reroute_pending', 'explicit_path_change', 'path_option_change', 'affinity_failure_reopt_disabled', 'affinity_failure_reopt_time_remained', 'affinity_failure_delayed_tear_time_remained', 'invalidation_time_remained', 'drop_mode', 'auto_route', 'forwarding_adjacency', 'load_share_factor', 'load_share_type', 'create_time', 'uptime', 'metric_type', 'tie_breaker', 'tiebreaker_type', 'tiebreaker_qualifier', 'metric_qualifier', 'is_hop_limit_ignore', 'hop_limit_ignored_reason', 'outbound_frr_state', 'area_id', 'pce_fail_reason', 'snmp_index', 'is_inter_area_tunnel', 'is_auto_backup', 'is_auto_pcc', 'is_pce_delegated', 'tunnel_attribute_set_name', 'tunnel_attribute_set_type', 'xro_attribute_set_name', 'is_passive', 'passive_tunnel_name', 'binding_label_exists', 'binding_label', 'last_hop_ifindex', 'is_named', 'lsp_wrap_protection_enabled', 'lsp_wrap_label', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'autoroute_announce_exclude_segment_routing', 'last_working_lsp_id'], name, value)


                class Config(_Entity_):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:  :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:  :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging configuration
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if Forward class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit_global
                    
                    	Global Delay Limit (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of  		 :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity)), ("bidirectional-config", ("bidirectional_config", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig)), ("bfd-config", ("bfd_config", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry)), ("autoroute-destination", ("autoroute_destination", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                            ('is_p2mp', (YLeaf(YType.boolean, 'is-p2mp'), ['bool'])),
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('interface_configured_bandwidth', (YLeaf(YType.uint32, 'interface-configured-bandwidth'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                            ('backup_bandwidth_flags', (YLeaf(YType.uint8, 'backup-bandwidth-flags'), ['int'])),
                            ('config_load_share', (YLeaf(YType.uint32, 'config-load-share'), ['int'])),
                            ('payload_type', (YLeaf(YType.uint16, 'payload-type'), ['int'])),
                            ('is_in_config', (YLeaf(YType.boolean, 'is-in-config'), ['bool'])),
                            ('explicit_null_imposition', (YLeaf(YType.boolean, 'explicit-null-imposition'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('is_backup_tunnel', (YLeaf(YType.boolean, 'is-backup-tunnel'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                            ('path_protection_enabled', (YLeaf(YType.boolean, 'path-protection-enabled'), ['bool'])),
                            ('hop_limit', (YLeaf(YType.uint8, 'hop-limit'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('cost_limit_global', (YLeaf(YType.uint32, 'cost-limit-global'), ['int'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                            ('delay_limit_global', (YLeaf(YType.uint32, 'delay-limit-global'), ['int'])),
                            ('path_invalidation_timeout_source', (YLeaf(YType.uint32, 'path-invalidation-timeout-source'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action_source', (YLeaf(YType.uint32, 'path-invalidation-action-source'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('soft_preempt', (YLeaf(YType.boolean, 'soft-preempt'), ['bool'])),
                            ('disable_affinity_failure_reopt', (YLeaf(YType.boolean, 'disable-affinity-failure-reopt'), ['bool'])),
                            ('affinity_failure_reopt_timer', (YLeaf(YType.uint32, 'affinity-failure-reopt-timer'), ['int'])),
                            ('segment_routing_path_selection', (YLeaf(YType.enumeration, 'segment-routing-path-selection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_id = None
                        self.is_p2mp = None
                        self.signaled_name = None
                        self.configured_bandwidth = None
                        self.interface_configured_bandwidth = None
                        self.bandwidth_type = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.policy_class = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.backup_bandwidth = None
                        self.backup_bandwidth_flags = None
                        self.config_load_share = None
                        self.payload_type = None
                        self.is_in_config = None
                        self.explicit_null_imposition = None
                        self.fast_reroute = None
                        self.is_backup_tunnel = None
                        self.record_route = None
                        self.srlg_discovery = None
                        self.path_protection_enabled = None
                        self.hop_limit = None
                        self.cost_limit = None
                        self.cost_limit_global = None
                        self.delay_limit = None
                        self.delay_limit_global = None
                        self.path_invalidation_timeout_source = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action_source = None
                        self.path_invalidation_action = None
                        self.soft_preempt = None
                        self.disable_affinity_failure_reopt = None
                        self.affinity_failure_reopt_timer = None
                        self.segment_routing_path_selection = None

                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bidirectional_config = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"

                        self.bfd_config = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"

                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.autoroute_destination = YList(self)
                        self._segment_path = lambda: "config"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config, ['tunnel_name', 'tunnel_id', 'is_p2mp', 'signaled_name', 'configured_bandwidth', 'interface_configured_bandwidth', 'bandwidth_type', 'setup_priority', 'hold_priority', 'policy_class', 'forward_class', 'is_forward_class_configured', 'backup_bandwidth', 'backup_bandwidth_flags', 'config_load_share', 'payload_type', 'is_in_config', 'explicit_null_imposition', 'fast_reroute', 'is_backup_tunnel', 'record_route', 'srlg_discovery', 'path_protection_enabled', 'hop_limit', 'cost_limit', 'cost_limit_global', 'delay_limit', 'delay_limit_global', 'path_invalidation_timeout_source', 'path_invalidation_timeout', 'path_invalidation_action_source', 'path_invalidation_action', 'soft_preempt', 'disable_affinity_failure_reopt', 'affinity_failure_reopt_timer', 'segment_routing_path_selection'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Affinity']['meta_info']


                    class BidirectionalConfig(_Entity_):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_type
                        
                        	Association Type (RFC 7751)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('association_type', (YLeaf(YType.uint16, 'association-type'), ['int'])),
                                ('association_id', (YLeaf(YType.uint16, 'association-id'), ['int'])),
                                ('association_source', (YLeaf(YType.str, 'association-source'), ['str'])),
                                ('association_global_id', (YLeaf(YType.uint32, 'association-global-id'), ['int'])),
                                ('association_corouted', (YLeaf(YType.boolean, 'association-corouted'), ['bool'])),
                            ])
                            self.association_type = None
                            self.association_id = None
                            self.association_source = None
                            self.association_global_id = None
                            self.association_corouted = None
                            self._segment_path = lambda: "bidirectional-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig, ['association_type', 'association_id', 'association_source', 'association_global_id', 'association_corouted'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BidirectionalConfig']['meta_info']


                    class BfdConfig(_Entity_):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:  :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:  :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('bfd_fast_detecting_enabled', (YLeaf(YType.boolean, 'bfd-fast-detecting-enabled'), ['bool'])),
                                ('bfd_type', (YLeaf(YType.enumeration, 'bfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ('bring_up_timeout', (YLeaf(YType.uint16, 'bring-up-timeout'), ['int'])),
                                ('bring_up_timeout_default', (YLeaf(YType.boolean, 'bring-up-timeout-default'), ['bool'])),
                                ('dampening_initial_wait', (YLeaf(YType.uint32, 'dampening-initial-wait'), ['int'])),
                                ('dampening_initial_wait_default', (YLeaf(YType.boolean, 'dampening-initial-wait-default'), ['bool'])),
                                ('dampening_max_wait', (YLeaf(YType.uint32, 'dampening-max-wait'), ['int'])),
                                ('dampening_max_wait_default', (YLeaf(YType.boolean, 'dampening-max-wait-default'), ['bool'])),
                                ('dampening_secondary_wait', (YLeaf(YType.uint32, 'dampening-secondary-wait'), ['int'])),
                                ('dampening_secondary_wait_default', (YLeaf(YType.boolean, 'dampening-secondary-wait-default'), ['bool'])),
                                ('periodic_lsp_ping_disabled', (YLeaf(YType.boolean, 'periodic-lsp-ping-disabled'), ['bool'])),
                                ('periodic_lsp_ping_interval', (YLeaf(YType.uint32, 'periodic-lsp-ping-interval'), ['int'])),
                                ('periodic_lsp_ping_interval_default', (YLeaf(YType.boolean, 'periodic-lsp-ping-interval-default'), ['bool'])),
                                ('bfd_session_down_action', (YLeaf(YType.enumeration, 'bfd-session-down-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBfdSessionDownAction1', '')])),
                                ('bfd_session_down_reopt_timeout', (YLeaf(YType.uint32, 'bfd-session-down-reopt-timeout'), ['int'])),
                                ('bfd_encap_mode', (YLeaf(YType.enumeration, 'bfd-encap-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfdEncapMode', '')])),
                                ('sbfd_target_id', (YLeaf(YType.str, 'sbfd-target-id'), ['str'])),
                            ])
                            self.bfd_fast_detecting_enabled = None
                            self.bfd_type = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None
                            self.bring_up_timeout = None
                            self.bring_up_timeout_default = None
                            self.dampening_initial_wait = None
                            self.dampening_initial_wait_default = None
                            self.dampening_max_wait = None
                            self.dampening_max_wait_default = None
                            self.dampening_secondary_wait = None
                            self.dampening_secondary_wait_default = None
                            self.periodic_lsp_ping_disabled = None
                            self.periodic_lsp_ping_interval = None
                            self.periodic_lsp_ping_interval_default = None
                            self.bfd_session_down_action = None
                            self.bfd_session_down_reopt_timeout = None
                            self.bfd_encap_mode = None
                            self.sbfd_target_id = None
                            self._segment_path = lambda: "bfd-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig, ['bfd_fast_detecting_enabled', 'bfd_type', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default', 'bring_up_timeout', 'bring_up_timeout_default', 'dampening_initial_wait', 'dampening_initial_wait_default', 'dampening_max_wait', 'dampening_max_wait_default', 'dampening_secondary_wait', 'dampening_secondary_wait_default', 'periodic_lsp_ping_disabled', 'periodic_lsp_ping_interval', 'periodic_lsp_ping_interval_default', 'bfd_session_down_action', 'bfd_session_down_reopt_timeout', 'bfd_encap_mode', 'sbfd_target_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.BfdConfig']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging configuration
                        
                        .. attribute:: all
                        
                        	All tunnel logging enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimize
                        
                        	Reoptimization Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	State Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reroute
                        
                        	Reroute logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_change
                        
                        	Bandwidth change logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchover
                        
                        	Path protection switchover logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: record_route
                        
                        	Record route logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_failure
                        
                        	Path calculation failure logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimization_attempt
                        
                        	Reoptimization attempt logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: insufficient_bandwidth
                        
                        	Insufficient bandwidth logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('all', (YLeaf(YType.boolean, 'all'), ['bool'])),
                                ('reoptimize', (YLeaf(YType.boolean, 'reoptimize'), ['bool'])),
                                ('state', (YLeaf(YType.boolean, 'state'), ['bool'])),
                                ('reroute', (YLeaf(YType.boolean, 'reroute'), ['bool'])),
                                ('bandwidth_change', (YLeaf(YType.boolean, 'bandwidth-change'), ['bool'])),
                                ('switchover', (YLeaf(YType.boolean, 'switchover'), ['bool'])),
                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ('path_calculation_failure', (YLeaf(YType.boolean, 'path-calculation-failure'), ['bool'])),
                                ('reoptimization_attempt', (YLeaf(YType.boolean, 'reoptimization-attempt'), ['bool'])),
                                ('insufficient_bandwidth', (YLeaf(YType.boolean, 'insufficient-bandwidth'), ['bool'])),
                            ])
                            self.all = None
                            self.reoptimize = None
                            self.state = None
                            self.reroute = None
                            self.bandwidth_change = None
                            self.switchover = None
                            self.record_route = None
                            self.path_calculation_failure = None
                            self.reoptimization_attempt = None
                            self.insufficient_bandwidth = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging, ['all', 'reoptimize', 'state', 'reroute', 'bandwidth_change', 'switchover', 'record_route', 'path_calculation_failure', 'reoptimization_attempt', 'insufficient_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.PolicyClassEntry']['meta_info']


                    class AutorouteDestination(_Entity_):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('prefix_length', (YLeaf(YType.uint16, 'prefix-length'), ['int'])),
                            ])
                            self.destination_address = None
                            self.prefix_length = None
                            self._segment_path = lambda: "autoroute-destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination, ['destination_address', 'prefix_length'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config.AutorouteDestination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Config']['meta_info']


                class TunnelCurrentLsp(_Entity_):
                    """
                    Current LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-current-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelCurrentLsp']['meta_info']


                class ReoptimizedP2mpLsp(_Entity_):
                    """
                    Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedP2mpLsp']['meta_info']


                class TunnelStandbyLsp(_Entity_):
                    """
                    Standby LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-standby-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelStandbyLsp']['meta_info']


                class ReoptimizedStandbyP2mpLsp(_Entity_):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-standby-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.ReoptimizedStandbyP2mpLsp']['meta_info']


                class TunnelRestorationLsp(_Entity_):
                    """
                    Restoration LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-restoration-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TunnelRestorationLsp']['meta_info']


                class DelayCleanPpLsp(_Entity_):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "delay-clean-pp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.DelayCleanPpLsp']['meta_info']


                class CleanedLsp(_Entity_):
                    """
                    Cleaned LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "cleaned-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.CleanedLsp']['meta_info']


                class P2pInfo(_Entity_):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:  :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:  :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus)), ("auto-bandwidth-config", ("auto_bandwidth_config", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig)), ("auto-bandwidth-oper", ("auto_bandwidth_oper", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper))])
                        self._leafs = OrderedDict([
                            ('is_bidirectional', (YLeaf(YType.boolean, 'is-bidirectional'), ['bool'])),
                        ])
                        self.is_bidirectional = None

                        self.auto_bandwidth_status = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"

                        self.auto_bandwidth_config = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"

                        self.auto_bandwidth_oper = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._segment_path = lambda: "p2p-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo, ['is_bidirectional'], name, value)


                    class AutoBandwidthStatus(_Entity_):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                                ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                            ])
                            self.is_auto_bandwidth_enabled = None
                            self.reactivation_time = None
                            self._segment_path = lambda: "auto-bandwidth-status"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthStatus']['meta_info']


                    class AutoBandwidthConfig(_Entity_):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_enabled
                        
                        	TRUE if resignal last bandwidth is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_timeout
                        
                        	The configured time\-out value in seconds for resignal  last bandwidth after tunnel down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_collect_only', (YLeaf(YType.boolean, 'is-auto-bandwidth-collect-only'), ['bool'])),
                                ('minimum_bandwidth', (YLeaf(YType.uint32, 'minimum-bandwidth'), ['int'])),
                                ('maximum_bandwidth', (YLeaf(YType.uint32, 'maximum-bandwidth'), ['int'])),
                                ('application_frequency', (YLeaf(YType.uint32, 'application-frequency'), ['int'])),
                                ('collection_frequency', (YLeaf(YType.uint32, 'collection-frequency'), ['int'])),
                                ('adjustment_threshold_percent', (YLeaf(YType.uint32, 'adjustment-threshold-percent'), ['int'])),
                                ('adjustment_threshold_value', (YLeaf(YType.uint32, 'adjustment-threshold-value'), ['int'])),
                                ('overflow_threshold_percent', (YLeaf(YType.uint32, 'overflow-threshold-percent'), ['int'])),
                                ('overflow_threshold_value', (YLeaf(YType.uint32, 'overflow-threshold-value'), ['int'])),
                                ('overflow_threshold_limit', (YLeaf(YType.uint32, 'overflow-threshold-limit'), ['int'])),
                                ('underflow_threshold_percent', (YLeaf(YType.uint32, 'underflow-threshold-percent'), ['int'])),
                                ('underflow_threshold_value', (YLeaf(YType.uint32, 'underflow-threshold-value'), ['int'])),
                                ('underflow_threshold_limit', (YLeaf(YType.uint32, 'underflow-threshold-limit'), ['int'])),
                                ('resignal_last_bandwidth_enabled', (YLeaf(YType.boolean, 'resignal-last-bandwidth-enabled'), ['bool'])),
                                ('resignal_last_bandwidth_timeout', (YLeaf(YType.uint32, 'resignal-last-bandwidth-timeout'), ['int'])),
                            ])
                            self.is_auto_bandwidth_collect_only = None
                            self.minimum_bandwidth = None
                            self.maximum_bandwidth = None
                            self.application_frequency = None
                            self.collection_frequency = None
                            self.adjustment_threshold_percent = None
                            self.adjustment_threshold_value = None
                            self.overflow_threshold_percent = None
                            self.overflow_threshold_value = None
                            self.overflow_threshold_limit = None
                            self.underflow_threshold_percent = None
                            self.underflow_threshold_value = None
                            self.underflow_threshold_limit = None
                            self.resignal_last_bandwidth_enabled = None
                            self.resignal_last_bandwidth_timeout = None
                            self._segment_path = lambda: "auto-bandwidth-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig, ['is_auto_bandwidth_collect_only', 'minimum_bandwidth', 'maximum_bandwidth', 'application_frequency', 'collection_frequency', 'adjustment_threshold_percent', 'adjustment_threshold_value', 'overflow_threshold_percent', 'overflow_threshold_value', 'overflow_threshold_limit', 'underflow_threshold_percent', 'underflow_threshold_value', 'underflow_threshold_limit', 'resignal_last_bandwidth_enabled', 'resignal_last_bandwidth_timeout'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthConfig']['meta_info']


                    class AutoBandwidthOper(_Entity_):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:  :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        	**config**\: False
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:  :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_expire_time
                        
                        	Timestamp when the resignal last bandwidth will expire and tunnel will use configured bandwidth to setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                                ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                                ('last_application_trigger', (YLeaf(YType.enumeration, 'last-application-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppTrigger', '')])),
                                ('application_jitter', (YLeaf(YType.uint32, 'application-jitter'), ['int'])),
                                ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                                ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                                ('time_left_collection', (YLeaf(YType.uint32, 'time-left-collection'), ['int'])),
                                ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                                ('underflow_highest_bandwidth', (YLeaf(YType.uint32, 'underflow-highest-bandwidth'), ['int'])),
                                ('threshold_overflows', (YLeaf(YType.uint32, 'threshold-overflows'), ['int'])),
                                ('overflow_early_bw_applications', (YLeaf(YType.uint32, 'overflow-early-bw-applications'), ['int'])),
                                ('threshold_underflows', (YLeaf(YType.uint32, 'threshold-underflows'), ['int'])),
                                ('underflow_early_bw_applications', (YLeaf(YType.uint32, 'underflow-early-bw-applications'), ['int'])),
                                ('collect_only_requested_bandwidth', (YLeaf(YType.uint32, 'collect-only-requested-bandwidth'), ['int'])),
                                ('application_reject_reason', (YLeaf(YType.enumeration, 'application-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppRej', '')])),
                                ('resignal_last_bandwidth_expire_time', (YLeaf(YType.uint32, 'resignal-last-bandwidth-expire-time'), ['int'])),
                            ])
                            self.last_bandwidth_applied = None
                            self.bandwidth_pool_type = None
                            self.bandwidth_applications = None
                            self.last_application_trigger = None
                            self.application_jitter = None
                            self.time_left_application = None
                            self.samples_collected = None
                            self.time_left_collection = None
                            self.highest_bandwidth = None
                            self.underflow_highest_bandwidth = None
                            self.threshold_overflows = None
                            self.overflow_early_bw_applications = None
                            self.threshold_underflows = None
                            self.underflow_early_bw_applications = None
                            self.collect_only_requested_bandwidth = None
                            self.application_reject_reason = None
                            self.resignal_last_bandwidth_expire_time = None
                            self._segment_path = lambda: "auto-bandwidth-oper"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper, ['last_bandwidth_applied', 'bandwidth_pool_type', 'bandwidth_applications', 'last_application_trigger', 'application_jitter', 'time_left_application', 'samples_collected', 'time_left_collection', 'highest_bandwidth', 'underflow_highest_bandwidth', 'threshold_overflows', 'overflow_early_bw_applications', 'threshold_underflows', 'underflow_early_bw_applications', 'collect_only_requested_bandwidth', 'application_reject_reason', 'resignal_last_bandwidth_expire_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo.AutoBandwidthOper']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.P2pInfo']['meta_info']


                class AutoCapacity(_Entity_):
                    """
                    Auto\-capacity Info
                    
                    .. attribute:: auto_capacity_configuration
                    
                    	The configured properties of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityConfiguration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_capacity_stats
                    
                    	The statistic of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats>`
                    
                    	**config**\: False
                    
                    .. attribute:: clone
                    
                    	Table of clones
                    	**type**\: list of  		 :py:class:`Clone <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity, self).__init__()

                        self.yang_name = "auto-capacity"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-capacity-configuration", ("auto_capacity_configuration", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration)), ("auto-capacity-stats", ("auto_capacity_stats", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats)), ("clone", ("clone", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone))])
                        self._leafs = OrderedDict()

                        self.auto_capacity_configuration = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration()
                        self.auto_capacity_configuration.parent = self
                        self._children_name_map["auto_capacity_configuration"] = "auto-capacity-configuration"

                        self.auto_capacity_stats = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats()
                        self.auto_capacity_stats.parent = self
                        self._children_name_map["auto_capacity_stats"] = "auto-capacity-stats"

                        self.clone = YList(self)
                        self._segment_path = lambda: "auto-capacity"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity, [], name, value)


                    class AutoCapacityConfiguration(_Entity_):
                        """
                        The configured properties of auto\-capacity
                        
                        .. attribute:: minimum_clones
                        
                        	The minimum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_clones
                        
                        	The maximum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merge_bandwidth
                        
                        	The merge bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: split_bandwidth
                        
                        	The split bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: nominal_bandwidth
                        
                        	The optimal or nominal bandwidth for the clones in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration, self).__init__()

                            self.yang_name = "auto-capacity-configuration"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('minimum_clones', (YLeaf(YType.uint32, 'minimum-clones'), ['int'])),
                                ('maximum_clones', (YLeaf(YType.uint32, 'maximum-clones'), ['int'])),
                                ('merge_bandwidth', (YLeaf(YType.uint32, 'merge-bandwidth'), ['int'])),
                                ('split_bandwidth', (YLeaf(YType.uint32, 'split-bandwidth'), ['int'])),
                                ('nominal_bandwidth', (YLeaf(YType.uint32, 'nominal-bandwidth'), ['int'])),
                            ])
                            self.minimum_clones = None
                            self.maximum_clones = None
                            self.merge_bandwidth = None
                            self.split_bandwidth = None
                            self.nominal_bandwidth = None
                            self._segment_path = lambda: "auto-capacity-configuration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration, ['minimum_clones', 'maximum_clones', 'merge_bandwidth', 'split_bandwidth', 'nominal_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityConfiguration']['meta_info']


                    class AutoCapacityStats(_Entity_):
                        """
                        The statistic of auto\-capacity
                        
                        .. attribute:: splits
                        
                        	Count of splits events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merges
                        
                        	Count of merges events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_created
                        
                        	Total clones created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_deleted
                        
                        	Total clones deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_watermark_clones
                        
                        	Highest number of clones reached at any point in time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats, self).__init__()

                            self.yang_name = "auto-capacity-stats"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('splits', (YLeaf(YType.uint32, 'splits'), ['int'])),
                                ('merges', (YLeaf(YType.uint32, 'merges'), ['int'])),
                                ('total_clones_created', (YLeaf(YType.uint32, 'total-clones-created'), ['int'])),
                                ('total_clones_deleted', (YLeaf(YType.uint32, 'total-clones-deleted'), ['int'])),
                                ('high_watermark_clones', (YLeaf(YType.uint32, 'high-watermark-clones'), ['int'])),
                            ])
                            self.splits = None
                            self.merges = None
                            self.total_clones_created = None
                            self.total_clones_deleted = None
                            self.high_watermark_clones = None
                            self._segment_path = lambda: "auto-capacity-stats"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats, ['splits', 'merges', 'total_clones_created', 'total_clones_deleted', 'high_watermark_clones'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.AutoCapacityStats']['meta_info']


                    class Clone(_Entity_):
                        """
                        Table of clones
                        
                        .. attribute:: name
                        
                        	Name of the clone
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: creation_timestamp
                        
                        	The timestamp when this clone was created relative to Jan 1, 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	The interface state of the cloned tunnel
                        	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_bandwidth
                        
                        	The signaled bandwidth (kbps) of the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: current_bandwidth_demand
                        
                        	The current demand (kbps) read from the traffic stats for the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone, self).__init__()

                            self.yang_name = "clone"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('creation_timestamp', (YLeaf(YType.uint32, 'creation-timestamp'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                                ('signaled_bandwidth', (YLeaf(YType.uint32, 'signaled-bandwidth'), ['int'])),
                                ('current_bandwidth_demand', (YLeaf(YType.uint32, 'current-bandwidth-demand'), ['int'])),
                            ])
                            self.name = None
                            self.creation_timestamp = None
                            self.state = None
                            self.signaled_bandwidth = None
                            self.current_bandwidth_demand = None
                            self._segment_path = lambda: "clone"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone, ['name', 'creation_timestamp', 'state', 'signaled_bandwidth', 'current_bandwidth_demand'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity.Clone']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoCapacity']['meta_info']


                class History(_Entity_):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:  :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:  :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:  :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:  :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:  :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:  :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:  :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:  :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:  :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:  :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:  :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("current-setup", ("current_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup)), ("reopt-setup", ("reopt_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup)), ("gmpls-path-protect-setup", ("gmpls_path_protect_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup)), ("previous-setup", ("previous_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup)), ("previous-gmpls-path-protect-setup", ("previous_gmpls_path_protect_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup)), ("gmpls-other-setup", ("gmpls_other_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup)), ("gmpls-other-protect-setup", ("gmpls_other_protect_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup)), ("standby-setup", ("standby_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup)), ("standby-reopt-setup", ("standby_reopt_setup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup)), ("last-re-opt-fail", ("last_re_opt_fail", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail)), ("last-stdby-re-opt-fail", ("last_stdby_re_opt_fail", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail))])
                        self._leafs = OrderedDict()

                        self.current_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"

                        self.reopt_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"

                        self.gmpls_path_protect_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"

                        self.previous_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"

                        self.previous_gmpls_path_protect_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"

                        self.gmpls_other_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"

                        self.gmpls_other_protect_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"

                        self.standby_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"

                        self.standby_reopt_setup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"

                        self.last_re_opt_fail = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"

                        self.last_stdby_re_opt_fail = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._segment_path = lambda: "history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History, [], name, value)


                    class CurrentSetup(_Entity_):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:  :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes>`
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("connected-uptimes", ("connected_uptimes", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes))])
                            self._leafs = OrderedDict([
                                ('current_setup_timer', (YLeaf(YType.uint32, 'current-setup-timer'), ['int'])),
                                ('selection_reason', (YLeaf(YType.str, 'selection-reason'), ['str'])),
                                ('current_setup_last_error', (YLeaf(YType.str, 'current-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.current_setup_timer = None
                            self.selection_reason = None
                            self.current_setup_last_error = None
                            self.protection_role = None

                            self.connected_uptimes = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._segment_path = lambda: "current-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup, ['current_setup_timer', 'selection_reason', 'current_setup_last_error', 'protection_role'], name, value)


                        class ConnectedUptimes(_Entity_):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('current_lsp_uptime', (YLeaf(YType.uint32, 'current-lsp-uptime'), ['int'])),
                                    ('current_uptime', (YLeaf(YType.uint32, 'current-uptime'), ['int'])),
                                ])
                                self.current_lsp_uptime = None
                                self.current_uptime = None
                                self._segment_path = lambda: "connected-uptimes"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes, ['current_lsp_uptime', 'current_uptime'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup.ConnectedUptimes']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.CurrentSetup']['meta_info']


                    class ReoptSetup(_Entity_):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.ReoptSetup']['meta_info']


                    class GmplsPathProtectSetup(_Entity_):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protecting_setup_uptime', (YLeaf(YType.uint32, 'protecting-setup-uptime'), ['int'])),
                                ('protecting_setup_timer', (YLeaf(YType.uint32, 'protecting-setup-timer'), ['int'])),
                                ('protecting_setup_last_error', (YLeaf(YType.str, 'protecting-setup-last-error'), ['str'])),
                            ])
                            self.protecting_setup_uptime = None
                            self.protecting_setup_timer = None
                            self.protecting_setup_last_error = None
                            self._segment_path = lambda: "gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup, ['protecting_setup_uptime', 'protecting_setup_timer', 'protecting_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsPathProtectSetup']['meta_info']


                    class PreviousSetup(_Entity_):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_path_option', (YLeaf(YType.str, 'previous-path-option'), ['str'])),
                                ('previous_tunnel_instance', (YLeaf(YType.uint32, 'previous-tunnel-instance'), ['int'])),
                                ('previous_fail_reason', (YLeaf(YType.str, 'previous-fail-reason'), ['str'])),
                                ('previous_setup_last_error', (YLeaf(YType.str, 'previous-setup-last-error'), ['str'])),
                            ])
                            self.previous_path_option = None
                            self.previous_tunnel_instance = None
                            self.previous_fail_reason = None
                            self.previous_setup_last_error = None
                            self._segment_path = lambda: "previous-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup, ['previous_path_option', 'previous_tunnel_instance', 'previous_fail_reason', 'previous_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousSetup']['meta_info']


                    class PreviousGmplsPathProtectSetup(_Entity_):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_protect_path_option', (YLeaf(YType.str, 'previous-protect-path-option'), ['str'])),
                                ('previous_protect_tunnel_instance', (YLeaf(YType.uint32, 'previous-protect-tunnel-instance'), ['int'])),
                                ('previous_protect_fail_reason', (YLeaf(YType.str, 'previous-protect-fail-reason'), ['str'])),
                                ('previous_protect_setup_last_error', (YLeaf(YType.str, 'previous-protect-setup-last-error'), ['str'])),
                            ])
                            self.previous_protect_path_option = None
                            self.previous_protect_tunnel_instance = None
                            self.previous_protect_fail_reason = None
                            self.previous_protect_setup_last_error = None
                            self._segment_path = lambda: "previous-gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup, ['previous_protect_path_option', 'previous_protect_tunnel_instance', 'previous_protect_fail_reason', 'previous_protect_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.PreviousGmplsPathProtectSetup']['meta_info']


                    class GmplsOtherSetup(_Entity_):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherSetup']['meta_info']


                    class GmplsOtherProtectSetup(_Entity_):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.GmplsOtherProtectSetup']['meta_info']


                    class StandbySetup(_Entity_):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('standby_lsp_uptime', (YLeaf(YType.uint32, 'standby-lsp-uptime'), ['int'])),
                                ('standby_setup_timer', (YLeaf(YType.uint32, 'standby-setup-timer'), ['int'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.standby_lsp_uptime = None
                            self.standby_setup_timer = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup, ['standby_lsp_uptime', 'standby_setup_timer', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbySetup']['meta_info']


                    class StandbyReoptSetup(_Entity_):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.StandbyReoptSetup']['meta_info']


                    class LastReOptFail(_Entity_):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastReOptFail']['meta_info']


                    class LastStdbyReOptFail(_Entity_):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-stdby-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History.LastStdbyReOptFail']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.History']['meta_info']


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PathProtection']['meta_info']


                class AutoBackup(_Entity_):
                    """
                    Autobackup Information
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:  :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of  		 :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("weighted-srlg-info", ("weighted_srlg_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo)), ("iep", ("iep", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep))])
                        self._leafs = OrderedDict([
                            ('protected_ls_ps', (YLeaf(YType.uint32, 'protected-ls-ps'), ['int'])),
                            ('protected_s2_ls', (YLeaf(YType.uint32, 'protected-s2-ls'), ['int'])),
                            ('sharing_families', (YLeaf(YType.uint32, 'sharing-families'), ['int'])),
                            ('ab_protection_type', (YLeaf(YType.enumeration, 'ab-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('is_using_srlg', (YLeaf(YType.boolean, 'is-using-srlg'), ['bool'])),
                            ('srlg_prot_type', (YLeaf(YType.enumeration, 'srlg-prot-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('ab_protected_interface', (YLeaf(YType.str, 'ab-protected-interface'), ['str'])),
                            ('protected_address', (YLeaf(YType.str, 'protected-address'), ['str'])),
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('is_unused_removal_timer_running', (YLeaf(YType.boolean, 'is-unused-removal-timer-running'), ['bool'])),
                            ('unused_removal_remaining_time', (YLeaf(YType.uint32, 'unused-removal-remaining-time'), ['int'])),
                        ])
                        self.protected_ls_ps = None
                        self.protected_s2_ls = None
                        self.sharing_families = None
                        self.ab_protection_type = None
                        self.is_using_srlg = None
                        self.srlg_prot_type = None
                        self.ab_protected_interface = None
                        self.protected_address = None
                        self.tunnel_attribute_set_name = None
                        self.is_unused_removal_timer_running = None
                        self.unused_removal_remaining_time = None

                        self.weighted_srlg_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"

                        self.iep = YList(self)
                        self._segment_path = lambda: "auto-backup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup, ['protected_ls_ps', 'protected_s2_ls', 'sharing_families', 'ab_protection_type', 'is_using_srlg', 'srlg_prot_type', 'ab_protected_interface', 'protected_address', 'tunnel_attribute_set_name', 'is_unused_removal_timer_running', 'unused_removal_remaining_time'], name, value)


                    class WeightedSrlgInfo(_Entity_):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of  		 :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of  		 :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protected-interface-srlg", ("protected_interface_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg)), ("weighted-srlg-hop", ("weighted_srlg_hop", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop))])
                            self._leafs = OrderedDict()

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)
                            self._segment_path = lambda: "weighted-srlg-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo, [], name, value)


                        class ProtectedInterfaceSrlg(_Entity_):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('srlg', (YLeaf(YType.uint32, 'srlg'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                                ])
                                self.srlg = None
                                self.srlg_name = None
                                self.admin_weight = None
                                self._segment_path = lambda: "protected-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, ['srlg', 'srlg_name', 'admin_weight'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg']['meta_info']


                        class WeightedSrlgHop(_Entity_):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of  		 :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("common-srlg", ("common_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg))])
                                self._leafs = OrderedDict([
                                    ('from_address', (YLeaf(YType.str, 'from-address'), ['str'])),
                                    ('to_address', (YLeaf(YType.str, 'to-address'), ['str'])),
                                    ('aggregate_admin_weight', (YLeaf(YType.uint64, 'aggregate-admin-weight'), ['int'])),
                                ])
                                self.from_address = None
                                self.to_address = None
                                self.aggregate_admin_weight = None

                                self.common_srlg = YList(self)
                                self._segment_path = lambda: "weighted-srlg-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, ['from_address', 'to_address', 'aggregate_admin_weight'], name, value)


                            class CommonSrlg(_Entity_):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	Common SRLG between this hop and the protected  interface
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "common-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.WeightedSrlgInfo']['meta_info']


                    class Iep(_Entity_):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of  		 :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("iep-hop", ("iep_hop", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop))])
                            self._leafs = OrderedDict([
                                ('path_option_id', (YLeaf(YType.uint32, 'path-option-id'), ['int'])),
                            ])
                            self.path_option_id = None

                            self.iep_hop = YList(self)
                            self._segment_path = lambda: "iep"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep, ['path_option_id'], name, value)


                        class IepHop(_Entity_):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:  :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('hop_index', (YLeaf(YType.uint32, 'hop-index'), ['int'])),
                                    ('iep_hop_type', (YLeaf(YType.enumeration, 'iep-hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIepHop', '')])),
                                    ('iep_hop_address', (YLeaf(YType.str, 'iep-hop-address'), ['str'])),
                                ])
                                self.hop_index = None
                                self.iep_hop_type = None
                                self.iep_hop_address = None
                                self._segment_path = lambda: "iep-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop, ['hop_index', 'iep_hop_type', 'iep_hop_address'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep.IepHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup.Iep']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoBackup']['meta_info']


                class AutoMesh(_Entity_):
                    """
                    Automesh Information
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('tunnel_destination_list_name', (YLeaf(YType.str, 'tunnel-destination-list-name'), ['str'])),
                            ('is_tunnel_unused_timer_running', (YLeaf(YType.boolean, 'is-tunnel-unused-timer-running'), ['bool'])),
                            ('remaining_unused_time', (YLeaf(YType.uint32, 'remaining-unused-time'), ['int'])),
                            ('mesh_group_type', (YLeaf(YType.enumeration, 'mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.tunnel_destination_list_name = None
                        self.is_tunnel_unused_timer_running = None
                        self.remaining_unused_time = None
                        self.mesh_group_type = None
                        self._segment_path = lambda: "auto-mesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh, ['mesh_group_id', 'tunnel_destination_list_name', 'is_tunnel_unused_timer_running', 'remaining_unused_time', 'mesh_group_type'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoMesh']['meta_info']


                class AutoPcc(_Entity_):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('creator_address', (YLeaf(YType.str, 'creator-address'), ['str'])),
                            ('has_creator_id', (YLeaf(YType.boolean, 'has-creator-id'), ['bool'])),
                            ('creator_id', (YLeaf(YType.str, 'creator-id'), ['str'])),
                            ('plspid', (YLeaf(YType.uint32, 'plspid'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.owner_address = None
                        self.creator_address = None
                        self.has_creator_id = None
                        self.creator_id = None
                        self.plspid = None
                        self.symbolic_name = None
                        self.operationally_up = None
                        self._segment_path = lambda: "auto-pcc"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc, ['owner_address', 'creator_address', 'has_creator_id', 'creator_id', 'plspid', 'symbolic_name', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.AutoPcc']['meta_info']


                class PceDelegation(_Entity_):
                    """
                    PCE Delegation information
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('plsp_id', (YLeaf(YType.uint32, 'plsp-id'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.plsp_id = None
                        self.symbolic_name = None
                        self.owner_address = None
                        self.operationally_up = None
                        self._segment_path = lambda: "pce-delegation"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation, ['plsp_id', 'symbolic_name', 'owner_address', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.PceDelegation']['meta_info']


                class SoftPreemption(_Entity_):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:  :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:  :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of  		 :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("soft-preemption-counters", ("soft_preemption_counters", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters)), ("soft-preemption-path-error", ("soft_preemption_path_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError))])
                        self._leafs = OrderedDict([
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                            ('time_in_preemption_pending', (YLeaf(YType.uint16, 'time-in-preemption-pending'), ['int'])),
                            ('preemption_pending_resolution', (YLeaf(YType.enumeration, 'preemption-pending-resolution'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionResolution', '')])),
                        ])
                        self.status = None
                        self.time_in_preemption_pending = None
                        self.preemption_pending_resolution = None

                        self.soft_preemption_counters = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"

                        self.soft_preemption_path_error = YList(self)
                        self._segment_path = lambda: "soft-preemption"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption, ['status', 'time_in_preemption_pending', 'preemption_pending_resolution'], name, value)


                    class SoftPreemptionCounters(_Entity_):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                                ('reopt_completed_ls_ps', (YLeaf(YType.uint32, 'reopt-completed-ls-ps'), ['int'])),
                                ('torn_down_ls_ps', (YLeaf(YType.uint32, 'torn-down-ls-ps'), ['int'])),
                                ('path_protection_switchover_ls_ps', (YLeaf(YType.uint32, 'path-protection-switchover-ls-ps'), ['int'])),
                                ('frr_triggered_ls_ps', (YLeaf(YType.uint32, 'frr-triggered-ls-ps'), ['int'])),
                                ('time_in_preemption_pending_min', (YLeaf(YType.uint16, 'time-in-preemption-pending-min'), ['int'])),
                                ('time_in_preemption_pending_max', (YLeaf(YType.uint16, 'time-in-preemption-pending-max'), ['int'])),
                                ('time_in_preemption_pending_avg', (YLeaf(YType.uint16, 'time-in-preemption-pending-avg'), ['int'])),
                            ])
                            self.soft_preemption_events = None
                            self.reopt_completed_ls_ps = None
                            self.torn_down_ls_ps = None
                            self.path_protection_switchover_ls_ps = None
                            self.frr_triggered_ls_ps = None
                            self.time_in_preemption_pending_min = None
                            self.time_in_preemption_pending_max = None
                            self.time_in_preemption_pending_avg = None
                            self._segment_path = lambda: "soft-preemption-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters, ['soft_preemption_events', 'reopt_completed_ls_ps', 'torn_down_ls_ps', 'path_protection_switchover_ls_ps', 'frr_triggered_ls_ps', 'time_in_preemption_pending_min', 'time_in_preemption_pending_max', 'time_in_preemption_pending_avg'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionCounters']['meta_info']


                    class SoftPreemptionPathError(_Entity_):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                            ])
                            self.timestamp = None
                            self.preempting_link_address = None
                            self._segment_path = lambda: "soft-preemption-path-error"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError, ['timestamp', 'preempting_link_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption.SoftPreemptionPathError']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.SoftPreemption']['meta_info']


                class WdmUnitunnel(_Entity_):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                            ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                            ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                            ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                            ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                        ])
                        self.tunnel_state = None
                        self.tunnel_role = None
                        self.tunnel_id = None
                        self.lsp_id = None
                        self.local_optical_router_id = None
                        self.remote_optical_router_id = None
                        self.controlled_interface = None
                        self.source_address = None
                        self.destination_address = None
                        self.extended_tunnel_id = None
                        self.label_origin = None
                        self.srlg_discovery = None
                        self._segment_path = lambda: "wdm-unitunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.WdmUnitunnel']['meta_info']


                class TransportTunnelInfo(_Entity_):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn>`
                    
                    	**config**\: False
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:  :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:  :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of  		 :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of  		 :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn)), ("static-uni", ("static_uni", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni)), ("egress-static-uni", ("egress_static_uni", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni)), ("homepath-ero", ("homepath_ero", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo))])
                        self._leafs = OrderedDict([
                            ('status_homepath_working', (YLeaf(YType.boolean, 'status-homepath-working'), ['bool'])),
                        ])
                        self.status_homepath_working = None

                        self.otn = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"

                        self.static_uni = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"

                        self.egress_static_uni = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"

                        self.homepath_ero = YList(self)
                        self.diversity_info = YList(self)
                        self._segment_path = lambda: "transport-tunnel-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo, ['status_homepath_working'], name, value)


                    class Otn(_Entity_):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:  :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        	**config**\: False
                        
                        .. attribute:: config_bit_rate
                        
                        	Configured OTN Bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-cfg", ("bandwidth_cfg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg))])
                            self._leafs = OrderedDict([
                                ('config_bit_rate', (YLeaf(YType.uint32, 'config-bit-rate'), ['int'])),
                            ])
                            self.config_bit_rate = None

                            self.bandwidth_cfg = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._segment_path = lambda: "otn"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn, ['config_bit_rate'], name, value)


                        class BandwidthCfg(_Entity_):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes))])
                                self._leafs = OrderedDict([
                                    ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ])
                                self.odu_level = None

                                self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._segment_path = lambda: "bandwidth-cfg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg, ['odu_level'], name, value)


                            class OduFlexCbr(_Entity_):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self.tolerance = None
                                    self._segment_path = lambda: "odu-flex-cbr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr']['meta_info']


                            class OduFlexGfpFRes(_Entity_):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes']['meta_info']


                            class OduFlexGfpFNonRes(_Entity_):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn.BandwidthCfg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.Otn']['meta_info']


                    class StaticUni(_Entity_):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: term_interface_srlg
                        
                        	Termination Interface SRLG
                        	**type**\:  :py:class:`TermInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("term-interface-srlg", ("term_interface_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg))])
                            self._leafs = OrderedDict([
                                ('client_port', (YLeaf(YType.str, 'client-port'), ['str'])),
                                ('client_if_handle', (YLeaf(YType.str, 'client-if-handle'), ['str'])),
                                ('client_odu_name', (YLeaf(YType.str, 'client-odu-name'), ['str'])),
                                ('client_odu_if_handle', (YLeaf(YType.str, 'client-odu-if-handle'), ['str'])),
                                ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('static_uni_type', (YLeaf(YType.enumeration, 'static-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                                ('term_client_port', (YLeaf(YType.str, 'term-client-port'), ['str'])),
                                ('term_client_if_handle', (YLeaf(YType.str, 'term-client-if-handle'), ['str'])),
                            ])
                            self.client_port = None
                            self.client_if_handle = None
                            self.client_odu_name = None
                            self.client_odu_if_handle = None
                            self.cross_connect_id = None
                            self.is_connected = None
                            self.uptime = None
                            self.local_termination = None
                            self.static_uni_type = None
                            self.term_client_port = None
                            self.term_client_if_handle = None

                            self.term_interface_srlg = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg()
                            self.term_interface_srlg.parent = self
                            self._children_name_map["term_interface_srlg"] = "term-interface-srlg"
                            self._segment_path = lambda: "static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni, ['client_port', 'client_if_handle', 'client_odu_name', 'client_odu_if_handle', 'cross_connect_id', 'is_connected', 'uptime', 'local_termination', 'static_uni_type', 'term_client_port', 'term_client_if_handle'], name, value)


                        class TermInterfaceSrlg(_Entity_):
                            """
                            Termination Interface SRLG
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLG
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, self).__init__()

                                self.yang_name = "term-interface-srlg"
                                self.yang_parent_name = "static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg))])
                                self._leafs = OrderedDict()

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "term-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, [], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLG
                                
                                .. attribute:: entry
                                
                                	Discovered SRLG
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "term-interface-srlg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni.TermInterfaceSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.StaticUni']['meta_info']


                    class EgressStaticUni(_Entity_):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:  :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:  :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("egress-port", ("egress_port", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort)), ("term-egress-port", ("term_egress_port", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort))])
                            self._leafs = OrderedDict([
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('remote_uni_type', (YLeaf(YType.enumeration, 'remote-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                            ])
                            self.local_termination = None
                            self.remote_uni_type = None

                            self.egress_port = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"

                            self.term_egress_port = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._segment_path = lambda: "egress-static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni, ['local_termination', 'remote_uni_type'], name, value)


                        class EgressPort(_Entity_):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.EgressPort']['meta_info']


                        class TermEgressPort(_Entity_):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "term-egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni.TermEgressPort']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.EgressStaticUni']['meta_info']


                    class HomepathEro(_Entity_):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "homepath-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.HomepathEro']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ])
                            self.tunnel_id = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo, ['tunnel_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo.DiversityInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TransportTunnelInfo']['meta_info']


                class BfdInfo(_Entity_):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:  :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of  		 :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("event-counters", ("event_counters", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters)), ("dampening-info", ("dampening_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo))])
                        self._leafs = OrderedDict([
                            ('bfd_session_up', (YLeaf(YType.boolean, 'bfd-session-up'), ['bool'])),
                            ('session_up_time', (YLeaf(YType.uint32, 'session-up-time'), ['int'])),
                            ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                            ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                            ('minimum_session_up_interval', (YLeaf(YType.uint32, 'minimum-session-up-interval'), ['int'])),
                            ('maximum_session_up_interval', (YLeaf(YType.uint32, 'maximum-session-up-interval'), ['int'])),
                        ])
                        self.bfd_session_up = None
                        self.session_up_time = None
                        self.failure_diagnostic_code = None
                        self.failure_reason = None
                        self.minimum_session_up_interval = None
                        self.maximum_session_up_interval = None

                        self.event_counters = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"

                        self.dampening_info = YList(self)
                        self._segment_path = lambda: "bfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo, ['bfd_session_up', 'session_up_time', 'failure_diagnostic_code', 'failure_reason', 'minimum_session_up_interval', 'maximum_session_up_interval'], name, value)


                    class EventCounters(_Entity_):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                                ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                                ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                                ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                                ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                                ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                                ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                                ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                                ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                            ])
                            self.session_create_events = None
                            self.session_up_events = None
                            self.session_creation_failed_events = None
                            self.session_down_events = None
                            self.session_admin_down_events = None
                            self.session_gracefully_delete_events = None
                            self.session_non_gracefully_delete_events = None
                            self.session_create_timeout_events = None
                            self.session_replay_events = None
                            self._segment_path = lambda: "event-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.EventCounters']['meta_info']


                    class DampeningInfo(_Entity_):
                        """
                        Path option dampening info
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('hold_down_time', (YLeaf(YType.uint32, 'hold-down-time'), ['int'])),
                                ('remained_time', (YLeaf(YType.uint32, 'remained-time'), ['int'])),
                                ('backoff_count', (YLeaf(YType.uint32, 'backoff-count'), ['int'])),
                            ])
                            self.option_index = None
                            self.hold_down_time = None
                            self.remained_time = None
                            self.backoff_count = None
                            self._segment_path = lambda: "dampening-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo, ['option_index', 'hold_down_time', 'remained_time', 'backoff_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo.DampeningInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.BfdInfo']['meta_info']


                class OtnBidir(_Entity_):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:  :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps)), ("restoration", ("restoration", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration))])
                        self._leafs = OrderedDict()

                        self.aps = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"

                        self.restoration = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._segment_path = lambda: "otn-bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir, [], name, value)


                    class Aps(_Entity_):
                        """
                        APS Protection Info
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:  :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protection-profile", ("protection_profile", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile))])
                            self._leafs = OrderedDict([
                                ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.active_lsp = None
                            self.diversity_type = None

                            self.protection_profile = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._segment_path = lambda: "aps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps, ['active_lsp', 'diversity_type'], name, value)


                        class ProtectionProfile(_Entity_):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "protection-profile"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps.ProtectionProfile']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Aps']['meta_info']


                    class Restoration(_Entity_):
                        """
                        Restoration Info
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        	**config**\: False
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('revert_option', (YLeaf(YType.enumeration, 'revert-option'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                ('diverse_lsp', (YLeaf(YType.enumeration, 'diverse-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.revert_option = None
                            self.diverse_lsp = None
                            self.diversity_type = None
                            self._segment_path = lambda: "restoration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration, ['revert_option', 'diverse_lsp', 'diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir.Restoration']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.OtnBidir']['meta_info']


                class Bidir(_Entity_):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:  :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reverse-ero-error-current", ("reverse_ero_error_current", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent)), ("reverse-ero-error-reopt", ("reverse_ero_error_reopt", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt)), ("reverse-ero-error-standby", ("reverse_ero_error_standby", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby)), ("reverse-ero-error-standby-reopt", ("reverse_ero_error_standby_reopt", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt))])
                        self._leafs = OrderedDict([
                            ('reverse_bandwidth', (YLeaf(YType.uint32, 'reverse-bandwidth'), ['int'])),
                            ('reverse_bandwidth_standby', (YLeaf(YType.uint32, 'reverse-bandwidth-standby'), ['int'])),
                        ])
                        self.reverse_bandwidth = None
                        self.reverse_bandwidth_standby = None

                        self.reverse_ero_error_current = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"

                        self.reverse_ero_error_reopt = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"

                        self.reverse_ero_error_standby = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"

                        self.reverse_ero_error_standby_reopt = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._segment_path = lambda: "bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir, ['reverse_bandwidth', 'reverse_bandwidth_standby'], name, value)


                    class ReverseEroErrorCurrent(_Entity_):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-current"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorCurrent']['meta_info']


                    class ReverseEroErrorReopt(_Entity_):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorReopt']['meta_info']


                    class ReverseEroErrorStandby(_Entity_):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandby']['meta_info']


                    class ReverseEroErrorStandbyReopt(_Entity_):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir.ReverseEroErrorStandbyReopt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Bidir']['meta_info']


                class XroAttributeSet(_Entity_):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion))])
                        self._leafs = OrderedDict([
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                        ])
                        self.tunnel_attribute_set_name = None
                        self.tunnel_attribute_set_name_crc32 = None

                        self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._segment_path = lambda: "xro-attribute-set"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                    class AttributeSetUnion(_Entity_):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                            self._leafs = OrderedDict([
                                ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                            ])
                            self.tunnel_attribute_set_type = None

                            self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                            self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                            self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                            self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                            self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                            self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                            self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._segment_path = lambda: "attribute-set-union"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                        class AttributeSetPathOption(_Entity_):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_delay_limit_configured
                            
                            	Is Delay Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: delay_limit
                            
                            	Delay limit on the tunnel path (usec) When delay limit is configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                    ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                    ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                    ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                    ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                ])
                                self.configured_bandwidth = None
                                self.cost_limit = None
                                self.dste_class_type = None
                                self.bandwidth_type = None
                                self.is_bandwidth_configured = None
                                self.is_cost_limit_configured = None
                                self.is_affinity_configured = None
                                self.generation = None
                                self.path_invalidation_timeout = None
                                self.path_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.exclude_list_name = None
                                self.is_exclude_list_name_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None
                                self.is_bfd_reverse_pat_configured = None
                                self.is_delay_limit_configured = None
                                self.delay_limit = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)
                                self._segment_path = lambda: "attribute-set-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                            class BfdReversePath(_Entity_):
                                """
                                BFD reverse path
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                	**config**\: False
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                    ])
                                    self.path_type = None
                                    self.binding_label = None
                                    self._segment_path = lambda: "bfd-reverse-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                            class VersionInfo(_Entity_):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                        ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                    ])
                                    self.attribute_type = None
                                    self.generation = None
                                    self.is_default = None
                                    self._segment_path = lambda: "version-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                        class AttributeSetAutobackup(_Entity_):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                self._leafs = OrderedDict([
                                    ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ])
                                self.is_signalled_name_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.is_affinity_configured = None
                                self.record_route = None

                                self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)
                                self.protected_interface = YList(self)
                                self._segment_path = lambda: "attribute-set-autobackup"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                            class SignalledName(_Entity_):
                                """
                                Signalled name
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                    ])
                                    self.name = None
                                    self.source_type = None
                                    self.protected_interface_type = None
                                    self.is_mp_addresses = None
                                    self._segment_path = lambda: "signalled-name"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                            class ProtectedInterface(_Entity_):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                    ])
                                    self.protected_interface = None
                                    self._segment_path = lambda: "protected-interface"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                        class AttributeSetAutomesh(_Entity_):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_forward_class_configured
                            
                            	True if forward\-class is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                    ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                    ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                    ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                    ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                    ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                    ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                ])
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.forward_class = None
                                self.is_forward_class_configured = None
                                self.is_affinity_configured = None
                                self.fast_reroute = None
                                self.frr_node_protection = None
                                self.frr_bandwidth_protection = None
                                self.record_route = None
                                self.auto_bandwidth_collect = None
                                self.auto_route_announce = None
                                self.soft_preemption_configured = None
                                self.bandwidth = None
                                self.load_share = None
                                self.is_interface_bw_configured = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.mesh_group_id = YList(self)
                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-automesh"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                            class MeshGroupId(_Entity_):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	Meshgroup ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "mesh-group-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                        class AttributeSetXro(_Entity_):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                self._leafs = OrderedDict()

                                self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._segment_path = lambda: "attribute-set-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                            class Xro(_Entity_):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                    self._leafs = OrderedDict([
                                        ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                    ])
                                    self.mutual_diversity_flag = None

                                    self.xro_subobject = YList(self)
                                    self._segment_path = lambda: "xro"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                class XroSubobject(_Entity_):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                        ])
                                        self.type = None

                                        self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                        self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                        self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                        self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"

                                        self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                        self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._segment_path = lambda: "xro-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                    class Ipv4Subobject(_Entity_):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv4-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                    class Ipv6Subobject(_Entity_):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\: str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv6-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                    class UnnumberedSubobject(_Entity_):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.te_router_id = None
                                            self.interface_id = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "unnumbered-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                    class AsSubobject(_Entity_):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                            ])
                                            self.as_number = None
                                            self._segment_path = lambda: "as-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                    class SrlgSubobject(_Entity_):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.srlg_id = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "srlg-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                    class LspSubobject(_Entity_):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                            self._leafs = OrderedDict([
                                                ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.ignore_lsp_id = None
                                            self.processing_node_exception = None
                                            self.penultimate_node_exception = None
                                            self.destination_node_exception = None
                                            self.exclusion_type = None

                                            self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._segment_path = lambda: "lsp-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                        class Fec(_Entity_):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                self._leafs = OrderedDict([
                                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                ])
                                                self.fec_lsp_id = None
                                                self.fec_tunnel_id = None
                                                self.fec_extended_tunnel_id = None
                                                self.fec_source = None
                                                self.fec_vrf = None

                                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._segment_path = lambda: "fec"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                            class FecDestinationInfo(_Entity_):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                    ])
                                                    self.fec_ctype = None
                                                    self.p2p_lsp_destination = None
                                                    self.fec_destination_p2mp_id = None
                                                    self._segment_path = lambda: "fec-destination-info"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                        class AttributeSetP2mpte(_Entity_):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                ])
                                self.fast_reroute = None
                                self.frr_bandwidth_protection = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.is_affinity_configured = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2mpte"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                        class AttributeSetApsPp(_Entity_):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "attribute-set-aps-pp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                        class AttributeSetP2pTe(_Entity_):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                    ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                    ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                    ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                    ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                    ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                    ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                    ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                    ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                    ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                ])
                                self.is_affinity_configured = None
                                self.path_selection_segment_routing_adjacency_protection = None
                                self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                self.path_invalidation_timeout = None
                                self.path_selection_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.path_selection_metric = None
                                self.is_path_selection_metric_configured = None
                                self.path_selection_segment_routing_margin = None
                                self.is_path_selection_segment_routing_margin_relative = None
                                self.is_path_selection_segment_routing_margin_configured = None
                                self.path_selection_segment_routing_segment_limit = None
                                self.is_path_selection_segment_routing_segment_limit_configured = None
                                self.is_path_select_configured = None
                                self.is_prepend_list_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2p-te"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                            class PrependList(_Entity_):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                    self._leafs = OrderedDict()

                                    self.prepend_entry = YList(self)
                                    self._segment_path = lambda: "prepend-list"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                class PrependEntry(_Entity_):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                            ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                            ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                        ])
                                        self.type = None
                                        self.index = None
                                        self.next_label = None
                                        self._segment_path = lambda: "prepend-entry"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet.AttributeSetUnion']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.XroAttributeSet']['meta_info']


                class TeTunnelConvergence(_Entity_):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("convergence-lsp", ("convergence_lsp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp))])
                        self._leafs = OrderedDict([
                            ('is_convergence_in_progress', (YLeaf(YType.boolean, 'is-convergence-in-progress'), ['bool'])),
                            ('frr_trigger_time', (YLeaf(YType.uint64, 'frr-trigger-time'), ['int'])),
                            ('pcalc_complete_time', (YLeaf(YType.uint64, 'pcalc-complete-time'), ['int'])),
                            ('convergence_complete_time', (YLeaf(YType.uint64, 'convergence-complete-time'), ['int'])),
                            ('binding_label_rewrite_time', (YLeaf(YType.uint64, 'binding-label-rewrite-time'), ['int'])),
                            ('vif_creation_time', (YLeaf(YType.uint64, 'vif-creation-time'), ['int'])),
                        ])
                        self.is_convergence_in_progress = None
                        self.frr_trigger_time = None
                        self.pcalc_complete_time = None
                        self.convergence_complete_time = None
                        self.binding_label_rewrite_time = None
                        self.vif_creation_time = None

                        self.convergence_lsp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._segment_path = lambda: "te-tunnel-convergence"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence, ['is_convergence_in_progress', 'frr_trigger_time', 'pcalc_complete_time', 'convergence_complete_time', 'binding_label_rewrite_time', 'vif_creation_time'], name, value)


                    class ConvergenceLsp(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "convergence-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence.ConvergenceLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.TeTunnelConvergence']['meta_info']


                class FlexInfo(_Entity_):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:  :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                            ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                            ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                            ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                            ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ('fault_in_label', (YLeaf(YType.uint32, 'fault-in-label'), ['int'])),
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_timestamp', (YLeaf(YType.uint32, 'lockout-timestamp'), ['int'])),
                            ('lockout_lsp_id', (YLeaf(YType.uint16, 'lockout-lsp-id'), ['int'])),
                            ('origination', (YLeaf(YType.enumeration, 'origination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FlexLspLockoutOrigination', '')])),
                        ])
                        self.fault_ldi_lockout = None
                        self.fault_ldi = None
                        self.fault_lkr = None
                        self.fault_ais = None
                        self.fault_time = None
                        self.fault_in_label = None
                        self.is_lockout = None
                        self.lockout_timestamp = None
                        self.lockout_lsp_id = None
                        self.origination = None
                        self._segment_path = lambda: "flex-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo, ['fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time', 'fault_in_label', 'is_lockout', 'lockout_timestamp', 'lockout_lsp_id', 'origination'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.FlexInfo']['meta_info']


                class Destination(_Entity_):
                    """
                    Destinations array
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:  :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:  :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionCause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of  		 :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of  		 :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "nni-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("inter-area-reoptimization", ("inter_area_reoptimization", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization)), ("path-option-entry", ("path_option_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry)), ("path-option", ("path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('destination_state', (YLeaf(YType.enumeration, 'destination-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeDestinationState', '')])),
                            ('active_path_option_index', (YLeaf(YType.uint32, 'active-path-option-index'), ['int'])),
                            ('path_option_exhausted', (YLeaf(YType.boolean, 'path-option-exhausted'), ['bool'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('path_change_time', (YLeaf(YType.uint32, 'path-change-time'), ['int'])),
                            ('total_uptime', (YLeaf(YType.uint32, 'total-uptime'), ['int'])),
                            ('s2l_exist', (YLeaf(YType.boolean, 's2l-exist'), ['bool'])),
                            ('destination_deletion_cause', (YLeaf(YType.enumeration, 'destination-deletion-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionCause', '')])),
                            ('destination_deletion_sub_cause', (YLeaf(YType.enumeration, 'destination-deletion-sub-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ('destination_deletion_timestamp', (YLeaf(YType.uint32, 'destination-deletion-timestamp'), ['int'])),
                            ('is_inter_area', (YLeaf(YType.boolean, 'is-inter-area'), ['bool'])),
                        ])
                        self.destination_address = None
                        self.destination_state = None
                        self.active_path_option_index = None
                        self.path_option_exhausted = None
                        self.uptime = None
                        self.path_change_time = None
                        self.total_uptime = None
                        self.s2l_exist = None
                        self.destination_deletion_cause = None
                        self.destination_deletion_sub_cause = None
                        self.destination_deletion_timestamp = None
                        self.is_inter_area = None

                        self.inter_area_reoptimization = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"

                        self.path_option_entry = YList(self)
                        self.path_option = YList(self)
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination, ['destination_address', 'destination_state', 'active_path_option_index', 'path_option_exhausted', 'uptime', 'path_change_time', 'total_uptime', 's2l_exist', 'destination_deletion_cause', 'destination_deletion_sub_cause', 'destination_deletion_timestamp', 'is_inter_area'], name, value)


                    class InterAreaReoptimization(_Entity_):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sent_path_queries', (YLeaf(YType.uint16, 'sent-path-queries'), ['int'])),
                                ('time_since_last_query_sent', (YLeaf(YType.uint32, 'time-since-last-query-sent'), ['int'])),
                                ('received_preferred_path_errors', (YLeaf(YType.uint16, 'received-preferred-path-errors'), ['int'])),
                                ('time_since_last_preferred_path_error', (YLeaf(YType.uint32, 'time-since-last-preferred-path-error'), ['int'])),
                                ('received_preferred_tree_errors', (YLeaf(YType.uint16, 'received-preferred-tree-errors'), ['int'])),
                                ('time_since_last_preferred_tree_error', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-error'), ['int'])),
                                ('preferred_path_error_node', (YLeaf(YType.str, 'preferred-path-error-node'), ['str'])),
                                ('preferred_tree_error_node', (YLeaf(YType.str, 'preferred-tree-error-node'), ['str'])),
                            ])
                            self.sent_path_queries = None
                            self.time_since_last_query_sent = None
                            self.received_preferred_path_errors = None
                            self.time_since_last_preferred_path_error = None
                            self.received_preferred_tree_errors = None
                            self.time_since_last_preferred_tree_error = None
                            self.preferred_path_error_node = None
                            self.preferred_tree_error_node = None
                            self._segment_path = lambda: "inter-area-reoptimization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization, ['sent_path_queries', 'time_since_last_query_sent', 'received_preferred_path_errors', 'time_since_last_preferred_path_error', 'received_preferred_tree_errors', 'time_since_last_preferred_tree_error', 'preferred_path_error_node', 'preferred_tree_error_node'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.InterAreaReoptimization']['meta_info']


                    class PathOptionEntry(_Entity_):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOptionEntry']['meta_info']


                    class PathOption(_Entity_):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination.PathOption']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels.NniTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.NniTunnels']['meta_info']


        class TunnelHeads(_Entity_):
            """
            Restrict display to P2P or P2MP head tunnels
            
            .. attribute:: tunnel_head
            
            	mpls te p2p or p2mp tunnels
            	**type**\: list of  		 :py:class:`TunnelHead <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads, self).__init__()

                self.yang_name = "tunnel-heads"
                self.yang_parent_name = "p2p-p2mp-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-head", ("tunnel_head", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead))])
                self._leafs = OrderedDict()

                self.tunnel_head = YList(self)
                self._segment_path = lambda: "tunnel-heads"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads, [], name, value)


            class TunnelHead(_Entity_):
                """
                mpls te p2p or p2mp tunnels
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: config
                
                	Configuration data
                	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config>`
                
                	**config**\: False
                
                .. attribute:: tunnel_current_lsp
                
                	Current LSP
                	**type**\:  :py:class:`TunnelCurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_p2mp_lsp
                
                	Reopt LSP
                	**type**\:  :py:class:`ReoptimizedP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_standby_lsp
                
                	Standby LSP
                	**type**\:  :py:class:`TunnelStandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_standby_p2mp_lsp
                
                	Standby Reopt LSP
                	**type**\:  :py:class:`ReoptimizedStandbyP2mpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp>`
                
                	**config**\: False
                
                .. attribute:: tunnel_restoration_lsp
                
                	Restoration LSP
                	**type**\:  :py:class:`TunnelRestorationLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp>`
                
                	**config**\: False
                
                .. attribute:: delay_clean_pp_lsp
                
                	Delay Clean PP LSP
                	**type**\:  :py:class:`DelayCleanPpLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp>`
                
                	**config**\: False
                
                .. attribute:: cleaned_lsp
                
                	Cleaned LSP
                	**type**\:  :py:class:`CleanedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp>`
                
                	**config**\: False
                
                .. attribute:: p2p_info
                
                	P2P specific info
                	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo>`
                
                	**config**\: False
                
                .. attribute:: auto_capacity
                
                	Auto\-capacity Info
                	**type**\:  :py:class:`AutoCapacity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity>`
                
                	**config**\: False
                
                .. attribute:: history
                
                	Tunnel history
                	**type**\:  :py:class:`History <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History>`
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: auto_backup
                
                	Autobackup Information
                	**type**\:  :py:class:`AutoBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup>`
                
                	**config**\: False
                
                .. attribute:: auto_mesh
                
                	Automesh Information
                	**type**\:  :py:class:`AutoMesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh>`
                
                	**config**\: False
                
                .. attribute:: auto_pcc
                
                	Auto\-PCC Information
                	**type**\:  :py:class:`AutoPcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc>`
                
                	**config**\: False
                
                .. attribute:: pce_delegation
                
                	PCE Delegation information
                	**type**\:  :py:class:`PceDelegation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation>`
                
                	**config**\: False
                
                .. attribute:: soft_preemption
                
                	Tunnel head soft preemption info. This is NULL if soft preemption is not configured
                	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption>`
                
                	**config**\: False
                
                .. attribute:: wdm_unitunnel
                
                	WDM\-UNI tunnel data. Only exists for WDM\-UNI tunnels
                	**type**\:  :py:class:`WdmUnitunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel>`
                
                	**config**\: False
                
                .. attribute:: transport_tunnel_info
                
                	Transport tunnel data. Only exists for Transport tunnels
                	**type**\:  :py:class:`TransportTunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo>`
                
                	**config**\: False
                
                .. attribute:: bfd_info
                
                	BFD session info. This is NULL if BFD is not configured
                	**type**\:  :py:class:`BfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo>`
                
                	**config**\: False
                
                .. attribute:: otn_bidir
                
                	OTN bidir info
                	**type**\:  :py:class:`OtnBidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir>`
                
                	**config**\: False
                
                .. attribute:: bidir
                
                	Bidir info
                	**type**\:  :py:class:`Bidir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set
                
                	XRO attribute\-set
                	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: te_tunnel_convergence
                
                	TE tunnel convergence related information
                	**type**\:  :py:class:`TeTunnelConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence>`
                
                	**config**\: False
                
                .. attribute:: flex_info
                
                	Flex Info
                	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo>`
                
                	**config**\: False
                
                .. attribute:: role_standby
                
                	TRUE if Role is Standby, Active otherwise
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_interface_name
                
                	Interface handle of the associated tunnel
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: admin_state
                
                	Administrative State
                	**type**\:  :py:class:`MteTunnelAdminState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelAdminState>`
                
                	**config**\: False
                
                .. attribute:: operational_state
                
                	Operational State
                	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                
                	**config**\: False
                
                .. attribute:: operational_state_changes
                
                	Counters for operational state changes
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: fail_reason
                
                	The reason why failure occurred
                	**type**\:  :py:class:`MplsMteTunnelFailReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsMteTunnelFailReason>`
                
                	**config**\: False
                
                .. attribute:: destination_up_count
                
                	Count of up destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_disabled_count
                
                	Count of disabled destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_down_count
                
                	Count of down destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: re_opt_hold_down_timer_remaining
                
                	Backup hold\-down timer remaining time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: bandwidth_requested
                
                	Bandwidth Requested
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The requested bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: is_node_protected
                
                	Node Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_bandwidth_protect
                
                	BW Protection Enabled or Disabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_recovering
                
                	Tunnel recovering
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: reroute_pending
                
                	ReroutePending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: explicit_path_change
                
                	Explicit\-path inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: path_option_change
                
                	Path\-Option inuse by the current LSP has been modified
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_disabled
                
                	AffinityFailureReoptDisabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: affinity_failure_reopt_time_remained
                
                	AffinityFailureReoptTimeRemained
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_failure_delayed_tear_time_remained
                
                	Affinity Failure LSP tear down time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: invalidation_time_remained
                
                	Path invalidation time remaining
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: drop_mode
                
                	True if tunnel is in drop mode
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: auto_route
                
                	IGP Auto route announce enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency
                
                	IGP forwarding adjacency enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: load_share_factor
                
                	The specified loadsharing for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: load_share_type
                
                	Loadsharing type
                	**type**\:  :py:class:`MplsTeLoadshare <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLoadshare>`
                
                	**config**\: False
                
                .. attribute:: create_time
                
                	Time at which the tunnel was created
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: uptime
                
                	Time in seconds since the tunnel was up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: metric_type
                
                	The path selection metric
                	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                
                	**config**\: False
                
                .. attribute:: tie_breaker
                
                	The path selection tiebreaker
                	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
                
                	**config**\: False
                
                .. attribute:: tiebreaker_type
                
                	Deprecated \- replaced by Tiebreaker
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tiebreaker_qualifier
                
                	Describes how the path selection tiebreaker was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: metric_qualifier
                
                	Describe how the metric was specified\: default, globally set, or per interface
                	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
                
                	**config**\: False
                
                .. attribute:: is_hop_limit_ignore
                
                	Is Hop\-limit ignored
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: hop_limit_ignored_reason
                
                	Hop\-limit ignored reason
                	**type**\:  :py:class:`TeHopLimitIgnore <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeHopLimitIgnore>`
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	Indicates the protocol and area used to find Outgoing ERO
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: pce_fail_reason
                
                	Failure reason for PCE\-based tunnels
                	**type**\:  :py:class:`MplsTePceFailReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePceFailReasons>`
                
                	**config**\: False
                
                .. attribute:: snmp_index
                
                	SNMP index for interface
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_inter_area_tunnel
                
                	Indicates whether this tunnel spans multiple areas
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_backup
                
                	Indicates whether this is an automatically generated backup tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_auto_pcc
                
                	Indicates whether this is an automatic PCC tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_pce_delegated
                
                	Indicates whether this tunnel is delegated to a PCE server or not
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	AttributeSet name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	AttributeSet type
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                .. attribute:: xro_attribute_set_name
                
                	Configured XRO attribute\-set name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_passive
                
                	True for passive tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: passive_tunnel_name
                
                	Passive tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: binding_label_exists
                
                	True, if binding label exists
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_label
                
                	Binding Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_hop_ifindex
                
                	Termination destination ifindex
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_named
                
                	Indicates whether this tunnel is named
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enabled
                
                	Lsp\-wrap Protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_label
                
                	Lsp\-wrap label value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_interface
                
                	True for tunnel head
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_path_change
                
                	Time in seconds since the last path change
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: persistent_bytes
                
                	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: byte
                
                .. attribute:: persistent_packets
                
                	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: autoroute_announce_exclude_segment_routing
                
                	Indicates whether this tunnel is autoroute announced with exclude segment\-routing option
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: last_working_lsp_id
                
                	LSP\-id of last working LSP
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destinations array
                	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead, self).__init__()

                    self.yang_name = "tunnel-head"
                    self.yang_parent_name = "tunnel-heads"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("config", ("config", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config)), ("tunnel-current-lsp", ("tunnel_current_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp)), ("reoptimized-p2mp-lsp", ("reoptimized_p2mp_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp)), ("tunnel-standby-lsp", ("tunnel_standby_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp)), ("reoptimized-standby-p2mp-lsp", ("reoptimized_standby_p2mp_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp)), ("tunnel-restoration-lsp", ("tunnel_restoration_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp)), ("delay-clean-pp-lsp", ("delay_clean_pp_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp)), ("cleaned-lsp", ("cleaned_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp)), ("p2p-info", ("p2p_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo)), ("auto-capacity", ("auto_capacity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity)), ("history", ("history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History)), ("path-protection", ("path_protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection)), ("auto-backup", ("auto_backup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup)), ("auto-mesh", ("auto_mesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh)), ("auto-pcc", ("auto_pcc", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc)), ("pce-delegation", ("pce_delegation", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption)), ("wdm-unitunnel", ("wdm_unitunnel", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel)), ("transport-tunnel-info", ("transport_tunnel_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo)), ("bfd-info", ("bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo)), ("otn-bidir", ("otn_bidir", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir)), ("bidir", ("bidir", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet)), ("te-tunnel-convergence", ("te_tunnel_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo)), ("destination", ("destination", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('role_standby', (YLeaf(YType.boolean, 'role-standby'), ['bool'])),
                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                        ('admin_state', (YLeaf(YType.enumeration, 'admin-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelAdminState', '')])),
                        ('operational_state', (YLeaf(YType.enumeration, 'operational-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                        ('operational_state_changes', (YLeaf(YType.uint32, 'operational-state-changes'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('fail_reason', (YLeaf(YType.enumeration, 'fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsMteTunnelFailReason', '')])),
                        ('destination_up_count', (YLeaf(YType.uint32, 'destination-up-count'), ['int'])),
                        ('destination_disabled_count', (YLeaf(YType.uint32, 'destination-disabled-count'), ['int'])),
                        ('destination_down_count', (YLeaf(YType.uint32, 'destination-down-count'), ['int'])),
                        ('re_opt_hold_down_timer_remaining', (YLeaf(YType.uint32, 're-opt-hold-down-timer-remaining'), ['int'])),
                        ('bandwidth_requested', (YLeaf(YType.uint32, 'bandwidth-requested'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                        ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                        ('tunnel_recovering', (YLeaf(YType.boolean, 'tunnel-recovering'), ['bool'])),
                        ('reroute_pending', (YLeaf(YType.boolean, 'reroute-pending'), ['bool'])),
                        ('explicit_path_change', (YLeaf(YType.boolean, 'explicit-path-change'), ['bool'])),
                        ('path_option_change', (YLeaf(YType.boolean, 'path-option-change'), ['bool'])),
                        ('affinity_failure_reopt_disabled', (YLeaf(YType.boolean, 'affinity-failure-reopt-disabled'), ['bool'])),
                        ('affinity_failure_reopt_time_remained', (YLeaf(YType.uint32, 'affinity-failure-reopt-time-remained'), ['int'])),
                        ('affinity_failure_delayed_tear_time_remained', (YLeaf(YType.uint32, 'affinity-failure-delayed-tear-time-remained'), ['int'])),
                        ('invalidation_time_remained', (YLeaf(YType.uint32, 'invalidation-time-remained'), ['int'])),
                        ('drop_mode', (YLeaf(YType.boolean, 'drop-mode'), ['bool'])),
                        ('auto_route', (YLeaf(YType.boolean, 'auto-route'), ['bool'])),
                        ('forwarding_adjacency', (YLeaf(YType.boolean, 'forwarding-adjacency'), ['bool'])),
                        ('load_share_factor', (YLeaf(YType.uint32, 'load-share-factor'), ['int'])),
                        ('load_share_type', (YLeaf(YType.enumeration, 'load-share-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLoadshare', '')])),
                        ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                        ('tie_breaker', (YLeaf(YType.enumeration, 'tie-breaker'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                        ('tiebreaker_type', (YLeaf(YType.uint32, 'tiebreaker-type'), ['int'])),
                        ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('metric_qualifier', (YLeaf(YType.enumeration, 'metric-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                        ('is_hop_limit_ignore', (YLeaf(YType.boolean, 'is-hop-limit-ignore'), ['bool'])),
                        ('hop_limit_ignored_reason', (YLeaf(YType.enumeration, 'hop-limit-ignored-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeHopLimitIgnore', '')])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                        ('pce_fail_reason', (YLeaf(YType.enumeration, 'pce-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePceFailReasons', '')])),
                        ('snmp_index', (YLeaf(YType.uint32, 'snmp-index'), ['int'])),
                        ('is_inter_area_tunnel', (YLeaf(YType.boolean, 'is-inter-area-tunnel'), ['bool'])),
                        ('is_auto_backup', (YLeaf(YType.boolean, 'is-auto-backup'), ['bool'])),
                        ('is_auto_pcc', (YLeaf(YType.boolean, 'is-auto-pcc'), ['bool'])),
                        ('is_pce_delegated', (YLeaf(YType.boolean, 'is-pce-delegated'), ['bool'])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                        ('xro_attribute_set_name', (YLeaf(YType.str, 'xro-attribute-set-name'), ['str'])),
                        ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                        ('passive_tunnel_name', (YLeaf(YType.str, 'passive-tunnel-name'), ['str'])),
                        ('binding_label_exists', (YLeaf(YType.boolean, 'binding-label-exists'), ['bool'])),
                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                        ('last_hop_ifindex', (YLeaf(YType.uint32, 'last-hop-ifindex'), ['int'])),
                        ('is_named', (YLeaf(YType.boolean, 'is-named'), ['bool'])),
                        ('lsp_wrap_protection_enabled', (YLeaf(YType.boolean, 'lsp-wrap-protection-enabled'), ['bool'])),
                        ('lsp_wrap_label', (YLeaf(YType.uint32, 'lsp-wrap-label'), ['int'])),
                        ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                        ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                        ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                        ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                        ('autoroute_announce_exclude_segment_routing', (YLeaf(YType.boolean, 'autoroute-announce-exclude-segment-routing'), ['bool'])),
                        ('last_working_lsp_id', (YLeaf(YType.uint16, 'last-working-lsp-id'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.role_standby = None
                    self.tunnel_interface_name = None
                    self.admin_state = None
                    self.operational_state = None
                    self.operational_state_changes = None
                    self.signaled_name = None
                    self.fail_reason = None
                    self.destination_up_count = None
                    self.destination_disabled_count = None
                    self.destination_down_count = None
                    self.re_opt_hold_down_timer_remaining = None
                    self.bandwidth_requested = None
                    self.bandwidth_type = None
                    self.is_node_protected = None
                    self.is_bandwidth_protect = None
                    self.tunnel_recovering = None
                    self.reroute_pending = None
                    self.explicit_path_change = None
                    self.path_option_change = None
                    self.affinity_failure_reopt_disabled = None
                    self.affinity_failure_reopt_time_remained = None
                    self.affinity_failure_delayed_tear_time_remained = None
                    self.invalidation_time_remained = None
                    self.drop_mode = None
                    self.auto_route = None
                    self.forwarding_adjacency = None
                    self.load_share_factor = None
                    self.load_share_type = None
                    self.create_time = None
                    self.uptime = None
                    self.metric_type = None
                    self.tie_breaker = None
                    self.tiebreaker_type = None
                    self.tiebreaker_qualifier = None
                    self.metric_qualifier = None
                    self.is_hop_limit_ignore = None
                    self.hop_limit_ignored_reason = None
                    self.outbound_frr_state = None
                    self.area_id = None
                    self.pce_fail_reason = None
                    self.snmp_index = None
                    self.is_inter_area_tunnel = None
                    self.is_auto_backup = None
                    self.is_auto_pcc = None
                    self.is_pce_delegated = None
                    self.tunnel_attribute_set_name = None
                    self.tunnel_attribute_set_type = None
                    self.xro_attribute_set_name = None
                    self.is_passive = None
                    self.passive_tunnel_name = None
                    self.binding_label_exists = None
                    self.binding_label = None
                    self.last_hop_ifindex = None
                    self.is_named = None
                    self.lsp_wrap_protection_enabled = None
                    self.lsp_wrap_label = None
                    self.is_interface = None
                    self.last_path_change = None
                    self.persistent_bytes = None
                    self.persistent_packets = None
                    self.autoroute_announce_exclude_segment_routing = None
                    self.last_working_lsp_id = None

                    self.config = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config()
                    self.config.parent = self
                    self._children_name_map["config"] = "config"

                    self.tunnel_current_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                    self.tunnel_current_lsp.parent = self
                    self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"

                    self.reoptimized_p2mp_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp()
                    self.reoptimized_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"

                    self.tunnel_standby_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                    self.tunnel_standby_lsp.parent = self
                    self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"

                    self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp()
                    self.reoptimized_standby_p2mp_lsp.parent = self
                    self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"

                    self.tunnel_restoration_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                    self.tunnel_restoration_lsp.parent = self
                    self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"

                    self.delay_clean_pp_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                    self.delay_clean_pp_lsp.parent = self
                    self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"

                    self.cleaned_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                    self.cleaned_lsp.parent = self
                    self._children_name_map["cleaned_lsp"] = "cleaned-lsp"

                    self.p2p_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo()
                    self.p2p_info.parent = self
                    self._children_name_map["p2p_info"] = "p2p-info"

                    self.auto_capacity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity()
                    self.auto_capacity.parent = self
                    self._children_name_map["auto_capacity"] = "auto-capacity"

                    self.history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History()
                    self.history.parent = self
                    self._children_name_map["history"] = "history"

                    self.path_protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.auto_backup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                    self.auto_backup.parent = self
                    self._children_name_map["auto_backup"] = "auto-backup"

                    self.auto_mesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                    self.auto_mesh.parent = self
                    self._children_name_map["auto_mesh"] = "auto-mesh"

                    self.auto_pcc = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                    self.auto_pcc.parent = self
                    self._children_name_map["auto_pcc"] = "auto-pcc"

                    self.pce_delegation = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                    self.pce_delegation.parent = self
                    self._children_name_map["pce_delegation"] = "pce-delegation"

                    self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                    self.soft_preemption.parent = self
                    self._children_name_map["soft_preemption"] = "soft-preemption"

                    self.wdm_unitunnel = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                    self.wdm_unitunnel.parent = self
                    self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"

                    self.transport_tunnel_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                    self.transport_tunnel_info.parent = self
                    self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"

                    self.bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                    self.bfd_info.parent = self
                    self._children_name_map["bfd_info"] = "bfd-info"

                    self.otn_bidir = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                    self.otn_bidir.parent = self
                    self._children_name_map["otn_bidir"] = "otn-bidir"

                    self.bidir = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir()
                    self.bidir.parent = self
                    self._children_name_map["bidir"] = "bidir"

                    self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                    self.xro_attribute_set.parent = self
                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                    self.te_tunnel_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                    self.te_tunnel_convergence.parent = self
                    self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"

                    self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                    self.flex_info.parent = self
                    self._children_name_map["flex_info"] = "flex-info"

                    self.destination = YList(self)
                    self._segment_path = lambda: "tunnel-head" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-heads/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead, ['tunnel_name', 'role_standby', 'tunnel_interface_name', 'admin_state', 'operational_state', 'operational_state_changes', 'signaled_name', 'fail_reason', 'destination_up_count', 'destination_disabled_count', 'destination_down_count', 're_opt_hold_down_timer_remaining', 'bandwidth_requested', 'bandwidth_type', 'is_node_protected', 'is_bandwidth_protect', 'tunnel_recovering', 'reroute_pending', 'explicit_path_change', 'path_option_change', 'affinity_failure_reopt_disabled', 'affinity_failure_reopt_time_remained', 'affinity_failure_delayed_tear_time_remained', 'invalidation_time_remained', 'drop_mode', 'auto_route', 'forwarding_adjacency', 'load_share_factor', 'load_share_type', 'create_time', 'uptime', 'metric_type', 'tie_breaker', 'tiebreaker_type', 'tiebreaker_qualifier', 'metric_qualifier', 'is_hop_limit_ignore', 'hop_limit_ignored_reason', 'outbound_frr_state', 'area_id', 'pce_fail_reason', 'snmp_index', 'is_inter_area_tunnel', 'is_auto_backup', 'is_auto_pcc', 'is_pce_delegated', 'tunnel_attribute_set_name', 'tunnel_attribute_set_type', 'xro_attribute_set_name', 'is_passive', 'passive_tunnel_name', 'binding_label_exists', 'binding_label', 'last_hop_ifindex', 'is_named', 'lsp_wrap_protection_enabled', 'lsp_wrap_label', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'autoroute_announce_exclude_segment_routing', 'last_working_lsp_id'], name, value)


                class Config(_Entity_):
                    """
                    Configuration data
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bidirectional_config
                    
                    	Bidirectional Configuration Information
                    	**type**\:  :py:class:`BidirectionalConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_config
                    
                    	BFD Configuration Information
                    	**type**\:  :py:class:`BfdConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging configuration
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel id
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_p2mp
                    
                    	True if tunnel is a P2MP tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Configured Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: interface_configured_bandwidth
                    
                    	Configured Interface Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if Forward class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth
                    
                    	Backup bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_bandwidth_flags
                    
                    	Backup bandwidth flags
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: config_load_share
                    
                    	Config loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: payload_type
                    
                    	Payload type
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: is_in_config
                    
                    	Is in config
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: explicit_null_imposition
                    
                    	Imposition of Explicit NULL
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup_tunnel
                    
                    	TRUE if this is a backup tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_enabled
                    
                    	Path Protection enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hop_limit
                    
                    	Hop Limit
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: cost_limit_global
                    
                    	Global Cost Limit
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit_global
                    
                    	Global Delay Limit (usec)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout_source
                    
                    	Path invalidation timeout configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action_source
                    
                    	Path invalidation action configuration source
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preempt
                    
                    	Soft preemption enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: disable_affinity_failure_reopt
                    
                    	DisableAffinityFailureReopt
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_failure_reopt_timer
                    
                    	AffinityFailureReoptTimer
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_routing_path_selection
                    
                    	Segment\-Routing path selection type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: autoroute_destination
                    
                    	Autoroute Destinations list
                    	**type**\: list of  		 :py:class:`AutorouteDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config, self).__init__()

                        self.yang_name = "config"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity)), ("bidirectional-config", ("bidirectional_config", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig)), ("bfd-config", ("bfd_config", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry)), ("autoroute-destination", ("autoroute_destination", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                            ('is_p2mp', (YLeaf(YType.boolean, 'is-p2mp'), ['bool'])),
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('interface_configured_bandwidth', (YLeaf(YType.uint32, 'interface-configured-bandwidth'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                            ('backup_bandwidth_flags', (YLeaf(YType.uint8, 'backup-bandwidth-flags'), ['int'])),
                            ('config_load_share', (YLeaf(YType.uint32, 'config-load-share'), ['int'])),
                            ('payload_type', (YLeaf(YType.uint16, 'payload-type'), ['int'])),
                            ('is_in_config', (YLeaf(YType.boolean, 'is-in-config'), ['bool'])),
                            ('explicit_null_imposition', (YLeaf(YType.boolean, 'explicit-null-imposition'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('is_backup_tunnel', (YLeaf(YType.boolean, 'is-backup-tunnel'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                            ('path_protection_enabled', (YLeaf(YType.boolean, 'path-protection-enabled'), ['bool'])),
                            ('hop_limit', (YLeaf(YType.uint8, 'hop-limit'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('cost_limit_global', (YLeaf(YType.uint32, 'cost-limit-global'), ['int'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                            ('delay_limit_global', (YLeaf(YType.uint32, 'delay-limit-global'), ['int'])),
                            ('path_invalidation_timeout_source', (YLeaf(YType.uint32, 'path-invalidation-timeout-source'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action_source', (YLeaf(YType.uint32, 'path-invalidation-action-source'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('soft_preempt', (YLeaf(YType.boolean, 'soft-preempt'), ['bool'])),
                            ('disable_affinity_failure_reopt', (YLeaf(YType.boolean, 'disable-affinity-failure-reopt'), ['bool'])),
                            ('affinity_failure_reopt_timer', (YLeaf(YType.uint32, 'affinity-failure-reopt-timer'), ['int'])),
                            ('segment_routing_path_selection', (YLeaf(YType.enumeration, 'segment-routing-path-selection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_id = None
                        self.is_p2mp = None
                        self.signaled_name = None
                        self.configured_bandwidth = None
                        self.interface_configured_bandwidth = None
                        self.bandwidth_type = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.policy_class = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.backup_bandwidth = None
                        self.backup_bandwidth_flags = None
                        self.config_load_share = None
                        self.payload_type = None
                        self.is_in_config = None
                        self.explicit_null_imposition = None
                        self.fast_reroute = None
                        self.is_backup_tunnel = None
                        self.record_route = None
                        self.srlg_discovery = None
                        self.path_protection_enabled = None
                        self.hop_limit = None
                        self.cost_limit = None
                        self.cost_limit_global = None
                        self.delay_limit = None
                        self.delay_limit_global = None
                        self.path_invalidation_timeout_source = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action_source = None
                        self.path_invalidation_action = None
                        self.soft_preempt = None
                        self.disable_affinity_failure_reopt = None
                        self.affinity_failure_reopt_timer = None
                        self.segment_routing_path_selection = None

                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bidirectional_config = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig()
                        self.bidirectional_config.parent = self
                        self._children_name_map["bidirectional_config"] = "bidirectional-config"

                        self.bfd_config = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig()
                        self.bfd_config.parent = self
                        self._children_name_map["bfd_config"] = "bfd-config"

                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.autoroute_destination = YList(self)
                        self._segment_path = lambda: "config"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config, ['tunnel_name', 'tunnel_id', 'is_p2mp', 'signaled_name', 'configured_bandwidth', 'interface_configured_bandwidth', 'bandwidth_type', 'setup_priority', 'hold_priority', 'policy_class', 'forward_class', 'is_forward_class_configured', 'backup_bandwidth', 'backup_bandwidth_flags', 'config_load_share', 'payload_type', 'is_in_config', 'explicit_null_imposition', 'fast_reroute', 'is_backup_tunnel', 'record_route', 'srlg_discovery', 'path_protection_enabled', 'hop_limit', 'cost_limit', 'cost_limit_global', 'delay_limit', 'delay_limit_global', 'path_invalidation_timeout_source', 'path_invalidation_timeout', 'path_invalidation_action_source', 'path_invalidation_action', 'soft_preempt', 'disable_affinity_failure_reopt', 'affinity_failure_reopt_timer', 'segment_routing_path_selection'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Affinity']['meta_info']


                    class BidirectionalConfig(_Entity_):
                        """
                        Bidirectional Configuration Information
                        
                        .. attribute:: association_type
                        
                        	Association Type (RFC 7751)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_id
                        
                        	The association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: association_source
                        
                        	The association source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: association_global_id
                        
                        	The association global ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: association_corouted
                        
                        	Is the association co\-routed
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, self).__init__()

                            self.yang_name = "bidirectional-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('association_type', (YLeaf(YType.uint16, 'association-type'), ['int'])),
                                ('association_id', (YLeaf(YType.uint16, 'association-id'), ['int'])),
                                ('association_source', (YLeaf(YType.str, 'association-source'), ['str'])),
                                ('association_global_id', (YLeaf(YType.uint32, 'association-global-id'), ['int'])),
                                ('association_corouted', (YLeaf(YType.boolean, 'association-corouted'), ['bool'])),
                            ])
                            self.association_type = None
                            self.association_id = None
                            self.association_source = None
                            self.association_global_id = None
                            self.association_corouted = None
                            self._segment_path = lambda: "bidirectional-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig, ['association_type', 'association_id', 'association_source', 'association_global_id', 'association_corouted'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BidirectionalConfig']['meta_info']


                    class BfdConfig(_Entity_):
                        """
                        BFD Configuration Information
                        
                        .. attribute:: bfd_fast_detecting_enabled
                        
                        	Deprecated
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_type
                        
                        	BFD Type
                        	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                        
                        	**config**\: False
                        
                        .. attribute:: min_interval
                        
                        	Hello interval in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: min_interval_default
                        
                        	Is default hello interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier
                        
                        	Multiplier
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: multiplier_default
                        
                        	Is default multiplier
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout
                        
                        	Bring Up Timeout in second
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: bring_up_timeout_default
                        
                        	Is default bring up timeout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_initial_wait
                        
                        	Dampening initial wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_initial_wait_default
                        
                        	Is default dampening inital wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_max_wait
                        
                        	Dampening max wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_max_wait_default
                        
                        	Is default dampening max wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: dampening_secondary_wait
                        
                        	Dampening secondary wait time in milliseconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: dampening_secondary_wait_default
                        
                        	Is default dampening secondary wait time
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_disabled
                        
                        	Periodic LSP Ping disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: periodic_lsp_ping_interval
                        
                        	Periodic LSP Ping interval in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: periodic_lsp_ping_interval_default
                        
                        	Is default LSP Ping interval
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_action
                        
                        	BFD Session Down Action
                        	**type**\:  :py:class:`MplsTeBfdSessionDownAction1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBfdSessionDownAction1>`
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_session_down_reopt_timeout
                        
                        	BFD Session Down Reopt Timeout
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_encap_mode
                        
                        	BFD Encap Mode
                        	**type**\:  :py:class:`TeVifBfdEncapMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfdEncapMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: sbfd_target_id
                        
                        	SBFD Target ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, self).__init__()

                            self.yang_name = "bfd-config"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('bfd_fast_detecting_enabled', (YLeaf(YType.boolean, 'bfd-fast-detecting-enabled'), ['bool'])),
                                ('bfd_type', (YLeaf(YType.enumeration, 'bfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ('bring_up_timeout', (YLeaf(YType.uint16, 'bring-up-timeout'), ['int'])),
                                ('bring_up_timeout_default', (YLeaf(YType.boolean, 'bring-up-timeout-default'), ['bool'])),
                                ('dampening_initial_wait', (YLeaf(YType.uint32, 'dampening-initial-wait'), ['int'])),
                                ('dampening_initial_wait_default', (YLeaf(YType.boolean, 'dampening-initial-wait-default'), ['bool'])),
                                ('dampening_max_wait', (YLeaf(YType.uint32, 'dampening-max-wait'), ['int'])),
                                ('dampening_max_wait_default', (YLeaf(YType.boolean, 'dampening-max-wait-default'), ['bool'])),
                                ('dampening_secondary_wait', (YLeaf(YType.uint32, 'dampening-secondary-wait'), ['int'])),
                                ('dampening_secondary_wait_default', (YLeaf(YType.boolean, 'dampening-secondary-wait-default'), ['bool'])),
                                ('periodic_lsp_ping_disabled', (YLeaf(YType.boolean, 'periodic-lsp-ping-disabled'), ['bool'])),
                                ('periodic_lsp_ping_interval', (YLeaf(YType.uint32, 'periodic-lsp-ping-interval'), ['int'])),
                                ('periodic_lsp_ping_interval_default', (YLeaf(YType.boolean, 'periodic-lsp-ping-interval-default'), ['bool'])),
                                ('bfd_session_down_action', (YLeaf(YType.enumeration, 'bfd-session-down-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBfdSessionDownAction1', '')])),
                                ('bfd_session_down_reopt_timeout', (YLeaf(YType.uint32, 'bfd-session-down-reopt-timeout'), ['int'])),
                                ('bfd_encap_mode', (YLeaf(YType.enumeration, 'bfd-encap-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfdEncapMode', '')])),
                                ('sbfd_target_id', (YLeaf(YType.str, 'sbfd-target-id'), ['str'])),
                            ])
                            self.bfd_fast_detecting_enabled = None
                            self.bfd_type = None
                            self.min_interval = None
                            self.min_interval_default = None
                            self.multiplier = None
                            self.multiplier_default = None
                            self.bring_up_timeout = None
                            self.bring_up_timeout_default = None
                            self.dampening_initial_wait = None
                            self.dampening_initial_wait_default = None
                            self.dampening_max_wait = None
                            self.dampening_max_wait_default = None
                            self.dampening_secondary_wait = None
                            self.dampening_secondary_wait_default = None
                            self.periodic_lsp_ping_disabled = None
                            self.periodic_lsp_ping_interval = None
                            self.periodic_lsp_ping_interval_default = None
                            self.bfd_session_down_action = None
                            self.bfd_session_down_reopt_timeout = None
                            self.bfd_encap_mode = None
                            self.sbfd_target_id = None
                            self._segment_path = lambda: "bfd-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig, ['bfd_fast_detecting_enabled', 'bfd_type', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default', 'bring_up_timeout', 'bring_up_timeout_default', 'dampening_initial_wait', 'dampening_initial_wait_default', 'dampening_max_wait', 'dampening_max_wait_default', 'dampening_secondary_wait', 'dampening_secondary_wait_default', 'periodic_lsp_ping_disabled', 'periodic_lsp_ping_interval', 'periodic_lsp_ping_interval_default', 'bfd_session_down_action', 'bfd_session_down_reopt_timeout', 'bfd_encap_mode', 'sbfd_target_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.BfdConfig']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging configuration
                        
                        .. attribute:: all
                        
                        	All tunnel logging enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimize
                        
                        	Reoptimization Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	State Logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reroute
                        
                        	Reroute logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_change
                        
                        	Bandwidth change logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchover
                        
                        	Path protection switchover logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: record_route
                        
                        	Record route logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_failure
                        
                        	Path calculation failure logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reoptimization_attempt
                        
                        	Reoptimization attempt logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: insufficient_bandwidth
                        
                        	Insufficient bandwidth logging
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('all', (YLeaf(YType.boolean, 'all'), ['bool'])),
                                ('reoptimize', (YLeaf(YType.boolean, 'reoptimize'), ['bool'])),
                                ('state', (YLeaf(YType.boolean, 'state'), ['bool'])),
                                ('reroute', (YLeaf(YType.boolean, 'reroute'), ['bool'])),
                                ('bandwidth_change', (YLeaf(YType.boolean, 'bandwidth-change'), ['bool'])),
                                ('switchover', (YLeaf(YType.boolean, 'switchover'), ['bool'])),
                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ('path_calculation_failure', (YLeaf(YType.boolean, 'path-calculation-failure'), ['bool'])),
                                ('reoptimization_attempt', (YLeaf(YType.boolean, 'reoptimization-attempt'), ['bool'])),
                                ('insufficient_bandwidth', (YLeaf(YType.boolean, 'insufficient-bandwidth'), ['bool'])),
                            ])
                            self.all = None
                            self.reoptimize = None
                            self.state = None
                            self.reroute = None
                            self.bandwidth_change = None
                            self.switchover = None
                            self.record_route = None
                            self.path_calculation_failure = None
                            self.reoptimization_attempt = None
                            self.insufficient_bandwidth = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging, ['all', 'reoptimize', 'state', 'reroute', 'bandwidth_change', 'switchover', 'record_route', 'path_calculation_failure', 'reoptimization_attempt', 'insufficient_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.PolicyClassEntry']['meta_info']


                    class AutorouteDestination(_Entity_):
                        """
                        Autoroute Destinations list
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: prefix_length
                        
                        	Prefix length
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, self).__init__()

                            self.yang_name = "autoroute-destination"
                            self.yang_parent_name = "config"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('prefix_length', (YLeaf(YType.uint16, 'prefix-length'), ['int'])),
                            ])
                            self.destination_address = None
                            self.prefix_length = None
                            self._segment_path = lambda: "autoroute-destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination, ['destination_address', 'prefix_length'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config.AutorouteDestination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Config']['meta_info']


                class TunnelCurrentLsp(_Entity_):
                    """
                    Current LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, self).__init__()

                        self.yang_name = "tunnel-current-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-current-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp']['meta_info']


                class ReoptimizedP2mpLsp(_Entity_):
                    """
                    Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2mpLsp']['meta_info']


                class TunnelStandbyLsp(_Entity_):
                    """
                    Standby LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, self).__init__()

                        self.yang_name = "tunnel-standby-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-standby-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp']['meta_info']


                class ReoptimizedStandbyP2mpLsp(_Entity_):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "reoptimized-standby-p2mp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2mpLsp']['meta_info']


                class TunnelRestorationLsp(_Entity_):
                    """
                    Restoration LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "tunnel-restoration-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp']['meta_info']


                class DelayCleanPpLsp(_Entity_):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "delay-clean-pp-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp']['meta_info']


                class CleanedLsp(_Entity_):
                    """
                    Cleaned LSP
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec>`
                    
                    	**config**\: False
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:  :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:  :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    	**config**\: False
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: protection_role
                    
                    	Path Protection Role
                    	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec)), ("s2l", ("s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l))])
                        self._leafs = OrderedDict([
                            ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                            ('is_frr_failed', (YLeaf(YType.boolean, 'is-frr-failed'), ['bool'])),
                            ('frr_active_reason', (YLeaf(YType.uint32, 'frr-active-reason'), ['int'])),
                            ('lsp_bandwidth', (YLeaf(YType.uint32, 'lsp-bandwidth'), ['int'])),
                            ('lsp_setup_priority', (YLeaf(YType.uint8, 'lsp-setup-priority'), ['int'])),
                            ('lsp_hold_priority', (YLeaf(YType.uint8, 'lsp-hold-priority'), ['int'])),
                            ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('dste_class_match', (YLeaf(YType.boolean, 'dste-class-match'), ['bool'])),
                            ('dste_class_index', (YLeaf(YType.uint8, 'dste-class-index'), ['int'])),
                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLsp', '')])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('s2_ls_up', (YLeaf(YType.uint32, 's2-ls-up'), ['int'])),
                            ('s2_ls_proceeding', (YLeaf(YType.uint32, 's2-ls-proceeding'), ['int'])),
                            ('s2_ls_down', (YLeaf(YType.uint32, 's2-ls-down'), ['int'])),
                            ('reoptimize_reason', (YLeaf(YType.enumeration, 'reoptimize-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                            ('reoptimize_trigger', (YLeaf(YType.enumeration, 'reoptimize-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteReoptTrigger', '')])),
                            ('timer_left', (YLeaf(YType.uint32, 'timer-left'), ['int'])),
                            ('is_passive', (YLeaf(YType.boolean, 'is-passive'), ['bool'])),
                            ('is_interface', (YLeaf(YType.boolean, 'is-interface'), ['bool'])),
                            ('last_path_change', (YLeaf(YType.uint32, 'last-path-change'), ['int'])),
                            ('persistent_bytes', (YLeaf(YType.uint64, 'persistent-bytes'), ['int'])),
                            ('persistent_packets', (YLeaf(YType.uint64, 'persistent-packets'), ['int'])),
                            ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                        ])
                        self.signaled_name = None
                        self.is_frr_failed = None
                        self.frr_active_reason = None
                        self.lsp_bandwidth = None
                        self.lsp_setup_priority = None
                        self.lsp_hold_priority = None
                        self.lsp_bandwidth_type = None
                        self.dste_class_match = None
                        self.dste_class_index = None
                        self.type = None
                        self.uptime = None
                        self.s2_ls_up = None
                        self.s2_ls_proceeding = None
                        self.s2_ls_down = None
                        self.reoptimize_reason = None
                        self.reoptimize_trigger = None
                        self.timer_left = None
                        self.is_passive = None
                        self.is_interface = None
                        self.last_path_change = None
                        self.persistent_bytes = None
                        self.persistent_packets = None
                        self.protection_role = None

                        self.lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"

                        self.s2l = YList(self)
                        self._segment_path = lambda: "cleaned-lsp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp, ['signaled_name', 'is_frr_failed', 'frr_active_reason', 'lsp_bandwidth', 'lsp_setup_priority', 'lsp_hold_priority', 'lsp_bandwidth_type', 'dste_class_match', 'dste_class_index', 'type', 'uptime', 's2_ls_up', 's2_ls_proceeding', 's2_ls_down', 'reoptimize_reason', 'reoptimize_trigger', 'timer_left', 'is_passive', 'is_interface', 'last_path_change', 'persistent_bytes', 'persistent_packets', 'protection_role'], name, value)


                    class LspFec(_Entity_):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo))])
                            self._leafs = OrderedDict([
                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                            ])
                            self.fec_lsp_id = None
                            self.fec_tunnel_id = None
                            self.fec_extended_tunnel_id = None
                            self.fec_source = None
                            self.fec_vrf = None

                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._segment_path = lambda: "lsp-fec"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                        class FecDestinationInfo(_Entity_):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                ])
                                self.fec_ctype = None
                                self.p2p_lsp_destination = None
                                self.fec_destination_p2mp_id = None
                                self._segment_path = lambda: "fec-destination-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec']['meta_info']


                    class S2l(_Entity_):
                        """
                        array of S2L structures
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:  :py:class:`S2lFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:  :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:  :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:  :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:  :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:  :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:  :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:  :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:  :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:  :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:  :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:  :py:class:`S2lConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence>`
                        
                        	**config**\: False
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:  :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption>`
                        
                        	**config**\: False
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:  :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels>`
                        
                        	**config**\: False
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:  :py:class:`OtnS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:  :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:  :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:  :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:  :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec>`
                        
                        	**config**\: False
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:  :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:  :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_path_metrics
                        
                        	Accumulated Path Metrics
                        	**type**\:  :py:class:`AccumulatedPathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: accumulated_reverse_path_metrics
                        
                        	Accumulated Reverse Path Metrics
                        	**type**\:  :py:class:`AccumulatedReversePathMetrics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics>`
                        
                        	**config**\: False
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        	**config**\: False
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        	**config**\: False
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        	**config**\: False
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:  :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of  		 :py:class:`S2lReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj>`
                        
                        	**config**\: False
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup>`
                        
                        	**config**\: False
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of  		 :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of  		 :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of  		 :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of  		 :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of  		 :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of  		 :py:class:`S2lSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-fec", ("s2l_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec)), ("active-path-option", ("active_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption)), ("out-xro", ("out_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro)), ("in-xro", ("in_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro)), ("tspec", ("tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec)), ("generic-tspec", ("generic_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec)), ("fspec", ("fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec)), ("generic-fspec", ("generic_fspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec)), ("next-hop-address-generic", ("next_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric)), ("previous-hop-address-generic", ("previous_hop_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric)), ("incoming-address-generic", ("incoming_address_generic", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric)), ("s2l-convergence", ("s2l_convergence", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence)), ("soft-preemption", ("soft_preemption", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption)), ("gmpls-labels", ("gmpls_labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels)), ("otn-s2l", ("otn_s2l", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l)), ("head-end-bfd-info", ("head_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo)), ("tail-end-bfd-info", ("tail_end_bfd_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo)), ("srlg-collection", ("srlg_collection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection)), ("association", ("association", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association)), ("protection", ("protection", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection)), ("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec)), ("reverse-tspec", ("reverse_tspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec)), ("flex-info", ("flex_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo)), ("lsp-wrap-info", ("lsp_wrap_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo)), ("accumulated-path-metrics", ("accumulated_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics)), ("accumulated-reverse-path-metrics", ("accumulated_reverse_path_metrics", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics)), ("s2l-reverse-lsp-sub-obj", ("s2l_reverse_lsp_sub_obj", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup)), ("out-ero", ("out_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro)), ("in-ero", ("in_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro)), ("path-rro", ("path_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro)), ("resv-rro", ("resv_rro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro)), ("path-affinity-array", ("path_affinity_array", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray)), ("reverse-ero-in", ("reverse_ero_in", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn)), ("s2l-segment-routing-path", ("s2l_segment_routing_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath))])
                            self._leafs = OrderedDict([
                                ('pcalc_area', (YLeaf(YType.str, 'pcalc-area'), ['str'])),
                                ('is_expanded_ero', (YLeaf(YType.boolean, 'is-expanded-ero'), ['bool'])),
                                ('path_reeval_query_mid', (YLeaf(YType.uint32, 'path-reeval-query-mid'), ['int'])),
                                ('time_since_last_query_received_mid', (YLeaf(YType.uint32, 'time-since-last-query-received-mid'), ['int'])),
                                ('time_since_last_preferred_path_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-path-exists-send-mid'), ['int'])),
                                ('time_since_last_preferred_tree_exists_send_mid', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-exists-send-mid'), ['int'])),
                                ('expanded_ero_area_id', (YLeaf(YType.str, 'expanded-ero-area-id'), ['str'])),
                                ('expanded_ero_affinity_bits', (YLeaf(YType.uint32, 'expanded-ero-affinity-bits'), ['int'])),
                                ('expanded_ero_affinity_mask', (YLeaf(YType.uint32, 'expanded-ero-affinity-mask'), ['int'])),
                                ('expanded_ero_metric_type', (YLeaf(YType.enumeration, 'expanded-ero-metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                ('expanded_ero_metric', (YLeaf(YType.uint32, 'expanded-ero-metric'), ['int'])),
                                ('abr_auto_discovered', (YLeaf(YType.str, 'abr-auto-discovered'), ['str'])),
                                ('is_frr_enabled', (YLeaf(YType.boolean, 'is-frr-enabled'), ['bool'])),
                                ('is_node_protected', (YLeaf(YType.boolean, 'is-node-protected'), ['bool'])),
                                ('is_bandwidth_protect', (YLeaf(YType.boolean, 'is-bandwidth-protect'), ['bool'])),
                                ('path_rro_enabled', (YLeaf(YType.boolean, 'path-rro-enabled'), ['bool'])),
                                ('weight', (YLeaf(YType.uint64, 'weight'), ['int'])),
                                ('reverse_weight', (YLeaf(YType.uint64, 'reverse-weight'), ['int'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('egress_interface', (YLeaf(YType.str, 'egress-interface'), ['str'])),
                                ('egress_interface_state', (YLeaf(YType.enumeration, 'egress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('egress_interface_brief', (YLeaf(YType.str, 'egress-interface-brief'), ['str'])),
                                ('ingress_interface', (YLeaf(YType.str, 'ingress-interface'), ['str'])),
                                ('ingress_interface_state', (YLeaf(YType.enumeration, 'ingress-interface-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                ('ingress_interface_brief', (YLeaf(YType.str, 'ingress-interface-brief'), ['str'])),
                                ('s2l_local_label', (YLeaf(YType.uint32, 's2l-local-label'), ['int'])),
                                ('s2l_out_label', (YLeaf(YType.uint32, 's2l-out-label'), ['int'])),
                                ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                                ('frr_out_tunnel_interface', (YLeaf(YType.str, 'frr-out-tunnel-interface'), ['str'])),
                                ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('signalling_status', (YLeaf(YType.enumeration, 'signalling-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsSignalingStatus', '')])),
                                ('local_router_id', (YLeaf(YType.str, 'local-router-id'), ['str'])),
                                ('upstream_router_id', (YLeaf(YType.str, 'upstream-router-id'), ['str'])),
                                ('downstream_router_id', (YLeaf(YType.str, 'downstream-router-id'), ['str'])),
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('incoming_address', (YLeaf(YType.str, 'incoming-address'), ['str'])),
                                ('backup_tunnel_interface', (YLeaf(YType.str, 'backup-tunnel-interface'), ['str'])),
                                ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                                ('is_optical', (YLeaf(YType.boolean, 'is-optical'), ['bool'])),
                                ('s2l_reverse_ero_obj_present', (YLeaf(YType.boolean, 's2l-reverse-ero-obj-present'), ['bool'])),
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                                ('reverse_lsp_name', (YLeaf(YType.str, 'reverse-lsp-name'), ['str'])),
                                ('s2l_reverse_tspec_obj_present', (YLeaf(YType.boolean, 's2l-reverse-tspec-obj-present'), ['bool'])),
                                ('path_using_strict_spf', (YLeaf(YType.boolean, 'path-using-strict-spf'), ['bool'])),
                            ])
                            self.pcalc_area = None
                            self.is_expanded_ero = None
                            self.path_reeval_query_mid = None
                            self.time_since_last_query_received_mid = None
                            self.time_since_last_preferred_path_exists_send_mid = None
                            self.time_since_last_preferred_tree_exists_send_mid = None
                            self.expanded_ero_area_id = None
                            self.expanded_ero_affinity_bits = None
                            self.expanded_ero_affinity_mask = None
                            self.expanded_ero_metric_type = None
                            self.expanded_ero_metric = None
                            self.abr_auto_discovered = None
                            self.is_frr_enabled = None
                            self.is_node_protected = None
                            self.is_bandwidth_protect = None
                            self.path_rro_enabled = None
                            self.weight = None
                            self.reverse_weight = None
                            self.uptime = None
                            self.egress_interface = None
                            self.egress_interface_state = None
                            self.egress_interface_brief = None
                            self.ingress_interface = None
                            self.ingress_interface_state = None
                            self.ingress_interface_brief = None
                            self.s2l_local_label = None
                            self.s2l_out_label = None
                            self.outbound_frr_state = None
                            self.frr_out_tunnel_interface = None
                            self.role = None
                            self.signalling_status = None
                            self.local_router_id = None
                            self.upstream_router_id = None
                            self.downstream_router_id = None
                            self.next_hop_address = None
                            self.next_next_hop_address = None
                            self.previous_hop_address = None
                            self.incoming_address = None
                            self.backup_tunnel_interface = None
                            self.node_hop_count = None
                            self.is_optical = None
                            self.s2l_reverse_ero_obj_present = None
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None
                            self.reverse_lsp_name = None
                            self.s2l_reverse_tspec_obj_present = None
                            self.path_using_strict_spf = None

                            self.s2l_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"

                            self.active_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"

                            self.out_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"

                            self.in_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"

                            self.tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"

                            self.generic_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"

                            self.fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"

                            self.generic_fspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"

                            self.next_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"

                            self.previous_hop_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"

                            self.incoming_address_generic = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"

                            self.s2l_convergence = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"

                            self.soft_preemption = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"

                            self.gmpls_labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"

                            self.otn_s2l = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"

                            self.head_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"

                            self.tail_end_bfd_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"

                            self.srlg_collection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"

                            self.association = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"

                            self.reverse_lsp_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.reverse_tspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"

                            self.flex_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"

                            self.lsp_wrap_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"

                            self.diversity_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"

                            self.accumulated_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics()
                            self.accumulated_path_metrics.parent = self
                            self._children_name_map["accumulated_path_metrics"] = "accumulated-path-metrics"

                            self.accumulated_reverse_path_metrics = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics()
                            self.accumulated_reverse_path_metrics.parent = self
                            self._children_name_map["accumulated_reverse_path_metrics"] = "accumulated-reverse-path-metrics"

                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.shared_risk_link_group = YList(self)
                            self.out_ero = YList(self)
                            self.in_ero = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.path_affinity_array = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self._segment_path = lambda: "s2l"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l, ['pcalc_area', 'is_expanded_ero', 'path_reeval_query_mid', 'time_since_last_query_received_mid', 'time_since_last_preferred_path_exists_send_mid', 'time_since_last_preferred_tree_exists_send_mid', 'expanded_ero_area_id', 'expanded_ero_affinity_bits', 'expanded_ero_affinity_mask', 'expanded_ero_metric_type', 'expanded_ero_metric', 'abr_auto_discovered', 'is_frr_enabled', 'is_node_protected', 'is_bandwidth_protect', 'path_rro_enabled', 'weight', 'reverse_weight', 'uptime', 'egress_interface', 'egress_interface_state', 'egress_interface_brief', 'ingress_interface', 'ingress_interface_state', 'ingress_interface_brief', 's2l_local_label', 's2l_out_label', 'outbound_frr_state', 'frr_out_tunnel_interface', 'role', 'signalling_status', 'local_router_id', 'upstream_router_id', 'downstream_router_id', 'next_hop_address', 'next_next_hop_address', 'previous_hop_address', 'incoming_address', 'backup_tunnel_interface', 'node_hop_count', 'is_optical', 's2l_reverse_ero_obj_present', 'reverse_lsp_present', 'reverse_lsp_connected', 'reverse_lsp_name', 's2l_reverse_tspec_obj_present', 'path_using_strict_spf'], name, value)


                        class S2lFec(_Entity_):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "s2l-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lFec']['meta_info']


                        class ActivePathOption(_Entity_):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet>`
                            
                            	**config**\: False
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError>`
                            
                            	**config**\: False
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError>`
                            
                            	**config**\: False
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError))])
                                self._leafs = OrderedDict([
                                    ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                    ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                    ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                    ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                    ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                    ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                    ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                    ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                    ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                    ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                    ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                    ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                    ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                    ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                    ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                    ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                    ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                    ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                    ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                    ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                    ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                                ])
                                self.option_index_is_valid = None
                                self.option_index = None
                                self.path_option_name = None
                                self.path_option_type = None
                                self.explicit_path_name = None
                                self.explicit_path_id = None
                                self.holddown_duration = None
                                self.pce_address = None
                                self.path_option_area_id = None
                                self.is_strict_explicit_path = None
                                self.is_helddown = None
                                self.is_lockdown = None
                                self.is_verbatim = None
                                self.is_disabled = None
                                self.has_attribute_set = None
                                self.attribute_set_found = None
                                self.has_xro_attribute_set = None
                                self.xro_attribute_set_found = None
                                self.is_segment_routing = None
                                self.protected_by_path_option_index = None
                                self.restored_from_path_option_index = None

                                self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"

                                self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)
                                self._segment_path = lambda: "active-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                            class AttributeSet(_Entity_):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.AttributeSet']['meta_info']


                            class XroAttributeSet(_Entity_):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                        ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                    ])
                                    self.tunnel_attribute_set_name = None
                                    self.tunnel_attribute_set_name_crc32 = None

                                    self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._segment_path = lambda: "xro-attribute-set"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                                class AttributeSetUnion(_Entity_):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                        self._leafs = OrderedDict([
                                            ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                        ])
                                        self.tunnel_attribute_set_type = None

                                        self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                        self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                        self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                        self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                        self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                        self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                        self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._segment_path = lambda: "attribute-set-union"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                    class AttributeSetPathOption(_Entity_):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_delay_limit_configured
                                        
                                        	Is Delay Limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: delay_limit
                                        
                                        	Delay limit on the tunnel path (usec) When delay limit is configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                                ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                                ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                                ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                                ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.cost_limit = None
                                            self.dste_class_type = None
                                            self.bandwidth_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_cost_limit_configured = None
                                            self.is_affinity_configured = None
                                            self.generation = None
                                            self.path_invalidation_timeout = None
                                            self.path_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.exclude_list_name = None
                                            self.is_exclude_list_name_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None
                                            self.is_bfd_reverse_pat_configured = None
                                            self.is_delay_limit_configured = None
                                            self.delay_limit = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)
                                            self._segment_path = lambda: "attribute-set-path-option"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                        class BfdReversePath(_Entity_):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                    ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                                ])
                                                self.path_type = None
                                                self.binding_label = None
                                                self._segment_path = lambda: "bfd-reverse-path"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                        class VersionInfo(_Entity_):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                    ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                                ])
                                                self.attribute_type = None
                                                self.generation = None
                                                self.is_default = None
                                                self._segment_path = lambda: "version-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                    class AttributeSetAutobackup(_Entity_):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                            self._leafs = OrderedDict([
                                                ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ])
                                            self.is_signalled_name_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.is_affinity_configured = None
                                            self.record_route = None

                                            self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)
                                            self.protected_interface = YList(self)
                                            self._segment_path = lambda: "attribute-set-autobackup"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                        class SignalledName(_Entity_):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                    ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                    ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                                ])
                                                self.name = None
                                                self.source_type = None
                                                self.protected_interface_type = None
                                                self.is_mp_addresses = None
                                                self._segment_path = lambda: "signalled-name"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                        class ProtectedInterface(_Entity_):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                                ])
                                                self.protected_interface = None
                                                self._segment_path = lambda: "protected-interface"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                    class AttributeSetAutomesh(_Entity_):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_forward_class_configured
                                        
                                        	True if forward\-class is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                                ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                                ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                                ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                                ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                                ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                                ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                                ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                                ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                                ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                            ])
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.policy_class = None
                                            self.is_policyclass_configured = None
                                            self.forward_class = None
                                            self.is_forward_class_configured = None
                                            self.is_affinity_configured = None
                                            self.fast_reroute = None
                                            self.frr_node_protection = None
                                            self.frr_bandwidth_protection = None
                                            self.record_route = None
                                            self.auto_bandwidth_collect = None
                                            self.auto_route_announce = None
                                            self.soft_preemption_configured = None
                                            self.bandwidth = None
                                            self.load_share = None
                                            self.is_interface_bw_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.policy_class_entry = YList(self)
                                            self.mesh_group_id = YList(self)
                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-automesh"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                        class PolicyClassEntry(_Entity_):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	PBTS policy classes
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "policy-class-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                        class MeshGroupId(_Entity_):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	Meshgroup ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "mesh-group-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                    class AttributeSetXro(_Entity_):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                            self._leafs = OrderedDict()

                                            self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._segment_path = lambda: "attribute-set-xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                        class Xro(_Entity_):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                                ])
                                                self.mutual_diversity_flag = None

                                                self.xro_subobject = YList(self)
                                                self._segment_path = lambda: "xro"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                            class XroSubobject(_Entity_):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                    ])
                                                    self.type = None

                                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"

                                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._segment_path = lambda: "xro-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                                class Ipv4Subobject(_Entity_):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv4-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                                class Ipv6Subobject(_Entity_):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.address = None
                                                        self.prefix_len = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "ipv6-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                                class UnnumberedSubobject(_Entity_):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.te_router_id = None
                                                        self.interface_id = None
                                                        self.attribute = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "unnumbered-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                                class AsSubobject(_Entity_):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                        ])
                                                        self.as_number = None
                                                        self._segment_path = lambda: "as-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                                class SrlgSubobject(_Entity_):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.srlg_id = None
                                                        self.exclusion_type = None
                                                        self._segment_path = lambda: "srlg-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                                class LspSubobject(_Entity_):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\: bool
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                        self._leafs = OrderedDict([
                                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                        ])
                                                        self.ignore_lsp_id = None
                                                        self.processing_node_exception = None
                                                        self.penultimate_node_exception = None
                                                        self.destination_node_exception = None
                                                        self.exclusion_type = None

                                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._segment_path = lambda: "lsp-subobject"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                    class Fec(_Entity_):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\: str
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                            self._leafs = OrderedDict([
                                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                            ])
                                                            self.fec_lsp_id = None
                                                            self.fec_tunnel_id = None
                                                            self.fec_extended_tunnel_id = None
                                                            self.fec_source = None
                                                            self.fec_vrf = None

                                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._segment_path = lambda: "fec"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                        class FecDestinationInfo(_Entity_):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\: str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            	**config**\: False
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\: int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**config**\: False
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2018-08-01'

                                                            def __init__(self):
                                                                if sys.version_info > (3,):
                                                                    super().__init__()
                                                                else:
                                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self.ylist_key_names = []
                                                                self._child_classes = OrderedDict([])
                                                                self._leafs = OrderedDict([
                                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                                ])
                                                                self.fec_ctype = None
                                                                self.p2p_lsp_destination = None
                                                                self.fec_destination_p2mp_id = None
                                                                self._segment_path = lambda: "fec-destination-info"
                                                                self._is_frozen = True

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                            @staticmethod
                                                            def _meta_info():
                                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                    class AttributeSetP2mpte(_Entity_):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                                ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                                ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                                ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                                ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                                ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                                ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                                ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ])
                                            self.fast_reroute = None
                                            self.frr_bandwidth_protection = None
                                            self.setup_priority = None
                                            self.hold_priority = None
                                            self.is_priority_configured = None
                                            self.configured_bandwidth = None
                                            self.dste_class_type = None
                                            self.is_bandwidth_configured = None
                                            self.is_affinity_configured = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2mpte"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                    class AttributeSetApsPp(_Entity_):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                            self._leafs = OrderedDict([
                                                ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                                ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                                ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                                ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                                ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                                ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                                ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                                ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                            ])
                                            self.snc_mode = None
                                            self.tcm_id = None
                                            self.protection_type = None
                                            self.protection_mode = None
                                            self.wait_to_restore_time = None
                                            self.hold_off_time = None
                                            self.path_prot_profile_type = None
                                            self.restoration_style = None

                                            self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._segment_path = lambda: "attribute-set-aps-pp"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                        class RevertSchedule(_Entity_):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\: str
                                            
                                            	**length:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                    ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                    ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                    ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                                ])
                                                self.schedulename = None
                                                self.schedule_date = None
                                                self.schedule_frequency = None
                                                self.duration = None
                                                self.max_tries = None
                                                self._segment_path = lambda: "revert-schedule"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                    class AttributeSetP2pTe(_Entity_):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                            self._leafs = OrderedDict([
                                                ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                                ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                                ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                                ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                                ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                                ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                                ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                                ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                                ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                                ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                                ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                                ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                                ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                                ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                                ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                                ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                                ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                                ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                                ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                                ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                                ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                                ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                                ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                                ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                                ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                                ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                                ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ])
                                            self.is_affinity_configured = None
                                            self.path_selection_segment_routing_adjacency_protection = None
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                            self.path_invalidation_timeout = None
                                            self.path_selection_invalidation_action = None
                                            self.is_path_invalidation_timeout_configured = None
                                            self.is_path_invalidation_action_configured = None
                                            self.path_selection_metric = None
                                            self.is_path_selection_metric_configured = None
                                            self.path_selection_segment_routing_margin = None
                                            self.is_path_selection_segment_routing_margin_relative = None
                                            self.is_path_selection_segment_routing_margin_configured = None
                                            self.path_selection_segment_routing_segment_limit = None
                                            self.is_path_selection_segment_routing_segment_limit_configured = None
                                            self.is_path_select_configured = None
                                            self.is_prepend_list_configured = None
                                            self.is_pce_configured = None
                                            self.is_pce_disj_source_configured = None
                                            self.is_pce_disj_type_configured = None
                                            self.is_pce_disj_group_id_configured = None
                                            self.pcedp_source_address = None
                                            self.pcedp_type = None
                                            self.pcedp_group_id = None
                                            self.is_pceb_dj_source_configured = None
                                            self.is_pcebd_group_id_configured = None
                                            self.pcebd_source_address = None
                                            self.pcebd_group_id = None

                                            self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"

                                            self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"

                                            self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"

                                            self.tunnel_id = YList(self)
                                            self._segment_path = lambda: "attribute-set-p2p-te"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                        class Affinity(_Entity_):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                                self._leafs = OrderedDict([
                                                    ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                    ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                                ])
                                                self.affinity_bits = None
                                                self.affinity_mask = None

                                                self.named_affinity = YList(self)
                                                self._segment_path = lambda: "affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                            class NamedAffinity(_Entity_):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                    self._leafs = OrderedDict([
                                                        ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                        ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                        ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                    ])
                                                    self.constraint_type = None
                                                    self.constraint_value = None
                                                    self.forward_ref_value = None

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)
                                                    self._segment_path = lambda: "named-affinity"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                                class ConstraintExtendedValue(_Entity_):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Constraint value
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "constraint-extended-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                                class ExtendedForwardRefValue(_Entity_):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	Reference bits for undefined affinity names
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([])
                                                        self._leafs = OrderedDict([
                                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                        ])
                                                        self.entry = None
                                                        self._segment_path = lambda: "extended-forward-ref-value"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                        class Logging(_Entity_):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                    ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                    ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                    ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                    ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                    ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                    ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                    ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                                ])
                                                self.lsp_state = None
                                                self.s2l_state = None
                                                self.lsp_re_route = None
                                                self.lsp_re_opt = None
                                                self.lsp_insufficient_bw = None
                                                self.lsp_bandwidth_change = None
                                                self.lsp_pcalc_failure_logging_enabled = None
                                                self.all_logging_enabled = None
                                                self._segment_path = lambda: "logging"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                        class PrependList(_Entity_):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                                self._leafs = OrderedDict()

                                                self.prepend_entry = YList(self)
                                                self._segment_path = lambda: "prepend-list"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                            class PrependEntry(_Entity_):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                        ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                        ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                    ])
                                                    self.type = None
                                                    self.index = None
                                                    self.next_label = None
                                                    self._segment_path = lambda: "prepend-entry"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                        class TunnelId(_Entity_):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                                ])
                                                self.entry = None
                                                self._segment_path = lambda: "tunnel-id"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.XroAttributeSet']['meta_info']


                            class PathCalculationError(_Entity_):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "path-calculation-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.PathCalculationError']['meta_info']


                            class RemergeError(_Entity_):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ])
                                    self.error_message = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self._segment_path = lambda: "remerge-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.RemergeError']['meta_info']


                            class SignallingError(_Entity_):
                                """
                                Signalling information
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                	**config**\: False
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                        ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                        ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                        ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                        ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                        ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                        ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                        ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                    ])
                                    self.error_node = None
                                    self.error = None
                                    self.sub_code = None
                                    self.lsp_mode = None
                                    self.log_time = None
                                    self.signalling_lsp_id = None
                                    self.error_message = None
                                    self.reverse_lsp = None
                                    self._segment_path = lambda: "signalling-error"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption.SignallingError']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ActivePathOption']['meta_info']


                        class OutXro(_Entity_):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "out-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutXro']['meta_info']


                        class InXro(_Entity_):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject))])
                                self._leafs = OrderedDict([
                                    ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                ])
                                self.mutual_diversity_flag = None

                                self.xro_subobject = YList(self)
                                self._segment_path = lambda: "in-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro, ['mutual_diversity_flag'], name, value)


                            class XroSubobject(_Entity_):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                    ])
                                    self.type = None

                                    self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                    self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                    self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                    self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"

                                    self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                    self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._segment_path = lambda: "xro-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject, ['type'], name, value)


                                class Ipv4Subobject(_Entity_):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv4-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv4Subobject']['meta_info']


                                class Ipv6Subobject(_Entity_):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\: str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                            ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.address = None
                                        self.prefix_len = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "ipv6-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.Ipv6Subobject']['meta_info']


                                class UnnumberedSubobject(_Entity_):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                            ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                            ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.te_router_id = None
                                        self.interface_id = None
                                        self.attribute = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "unnumbered-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.UnnumberedSubobject']['meta_info']


                                class AsSubobject(_Entity_):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                        ])
                                        self.as_number = None
                                        self._segment_path = lambda: "as-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.AsSubobject']['meta_info']


                                class SrlgSubobject(_Entity_):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.srlg_id = None
                                        self.exclusion_type = None
                                        self._segment_path = lambda: "srlg-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.SrlgSubobject']['meta_info']


                                class LspSubobject(_Entity_):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec))])
                                        self._leafs = OrderedDict([
                                            ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                            ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                            ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                            ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                            ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                        ])
                                        self.ignore_lsp_id = None
                                        self.processing_node_exception = None
                                        self.penultimate_node_exception = None
                                        self.destination_node_exception = None
                                        self.exclusion_type = None

                                        self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._segment_path = lambda: "lsp-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                    class Fec(_Entity_):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                            self._leafs = OrderedDict([
                                                ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                            ])
                                            self.fec_lsp_id = None
                                            self.fec_tunnel_id = None
                                            self.fec_extended_tunnel_id = None
                                            self.fec_source = None
                                            self.fec_vrf = None

                                            self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._segment_path = lambda: "fec"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                        class FecDestinationInfo(_Entity_):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                    ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                    ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                ])
                                                self.fec_ctype = None
                                                self.p2p_lsp_destination = None
                                                self.fec_destination_p2mp_id = None
                                                self._segment_path = lambda: "fec-destination-info"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject.Fec']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject.LspSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro.XroSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InXro']['meta_info']


                        class Tspec(_Entity_):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Tspec']['meta_info']


                        class GenericTspec(_Entity_):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:  :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:  :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otntspec", ("otntspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec))])
                                self._leafs = OrderedDict([
                                    ('tspec_type', (YLeaf(YType.enumeration, 'tspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericTspec', '')])),
                                ])
                                self.tspec_type = None

                                self.otntspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._segment_path = lambda: "generic-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec, ['tspec_type'], name, value)


                            class Otntspec(_Entity_):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otntspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec.Otntspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericTspec']['meta_info']


                        class Fspec(_Entity_):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Fspec']['meta_info']


                        class GenericFspec(_Entity_):
                            """
                            Generic FSpec
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:  :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec>`
                            
                            	**config**\: False
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:  :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otnfspec", ("otnfspec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec))])
                                self._leafs = OrderedDict([
                                    ('fspec_type', (YLeaf(YType.enumeration, 'fspec-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMgmtGenericFspec', '')])),
                                ])
                                self.fspec_type = None

                                self.otnfspec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._segment_path = lambda: "generic-fspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec, ['fspec_type'], name, value)


                            class Otnfspec(_Entity_):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('signal_type', (YLeaf(YType.uint8, 'signal-type'), ['int'])),
                                        ('nmc_or_tolerance', (YLeaf(YType.uint16, 'nmc-or-tolerance'), ['int'])),
                                        ('nvc', (YLeaf(YType.uint16, 'nvc'), ['int'])),
                                        ('multiplier', (YLeaf(YType.uint16, 'multiplier'), ['int'])),
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.signal_type = None
                                    self.nmc_or_tolerance = None
                                    self.nvc = None
                                    self.multiplier = None
                                    self.bit_rate = None
                                    self._segment_path = lambda: "otnfspec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec, ['signal_type', 'nmc_or_tolerance', 'nvc', 'multiplier', 'bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec.Otnfspec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GenericFspec']['meta_info']


                        class NextHopAddressGeneric(_Entity_):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "next-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.NextHopAddressGeneric']['meta_info']


                        class PreviousHopAddressGeneric(_Entity_):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "previous-hop-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PreviousHopAddressGeneric']['meta_info']


                        class IncomingAddressGeneric(_Entity_):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "incoming-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.IncomingAddressGeneric']['meta_info']


                        class S2lConvergence(_Entity_):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                    ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                    ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                    ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                    ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                    ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                    ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                                ])
                                self.path_in = None
                                self.path_out = None
                                self.resv_in = None
                                self.resv_out = None
                                self.label_rewrite = None
                                self.tunnel_rewrite = None
                                self.creation_time = None
                                self._segment_path = lambda: "s2l-convergence"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lConvergence']['meta_info']


                        class SoftPreemption(_Entity_):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                                    ('soft_preemption_timestamp', (YLeaf(YType.uint32, 'soft-preemption-timestamp'), ['int'])),
                                    ('soft_preemption_link', (YLeaf(YType.str, 'soft-preemption-link'), ['str'])),
                                    ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                                    ('time_to_hard_preemption', (YLeaf(YType.uint16, 'time-to-hard-preemption'), ['int'])),
                                    ('fr_rrewrite', (YLeaf(YType.boolean, 'fr-rrewrite'), ['bool'])),
                                    ('fr_rrewrite_tunnel_name', (YLeaf(YType.str, 'fr-rrewrite-tunnel-name'), ['str'])),
                                ])
                                self.status = None
                                self.soft_preemption_timestamp = None
                                self.soft_preemption_link = None
                                self.preempting_link_address = None
                                self.time_to_hard_preemption = None
                                self.fr_rrewrite = None
                                self.fr_rrewrite_tunnel_name = None
                                self._segment_path = lambda: "soft-preemption"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption, ['status', 'soft_preemption_timestamp', 'soft_preemption_link', 'preempting_link_address', 'time_to_hard_preemption', 'fr_rrewrite', 'fr_rrewrite_tunnel_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SoftPreemption']['meta_info']


                        class GmplsLabels(_Entity_):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel>`
                            
                            	**config**\: False
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel))])
                                self._leafs = OrderedDict()

                                self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"

                                self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._segment_path = lambda: "gmpls-labels"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels, [], name, value)


                            class PathIngressLabel(_Entity_):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathIngressLabel']['meta_info']


                            class PathEgressLabel(_Entity_):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "path-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.PathEgressLabel']['meta_info']


                            class ResvIngressLabel(_Entity_):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-ingress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvIngressLabel']['meta_info']


                            class ResvEgressLabel(_Entity_):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                	**config**\: False
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                	**config**\: False
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn))])
                                    self._leafs = OrderedDict([
                                        ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                    ])
                                    self.label_type = None

                                    self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"

                                    self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._segment_path = lambda: "resv-egress-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel, ['label_type'], name, value)


                                class Wdm(_Entity_):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\: int
                                    
                                    	**range:** \-32768..32767
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                            ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                            ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                            ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                            ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                        ])
                                        self.label_set = None
                                        self.grid = None
                                        self.channel_spacing = None
                                        self.identifier = None
                                        self.channel = None
                                        self._segment_path = lambda: "wdm"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Wdm']['meta_info']


                                class Otn(_Entity_):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap))])
                                        self._leafs = OrderedDict([
                                            ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                            ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                        ])
                                        self.tpn = None
                                        self.bit_map_length = None

                                        self.bit_map = YList(self)
                                        self._segment_path = lambda: "otn"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn, ['tpn', 'bit_map_length'], name, value)


                                    class BitMap(_Entity_):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	Bit Map
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "bit-map"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn.BitMap']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel.Otn']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels.ResvEgressLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.GmplsLabels']['meta_info']


                        class OtnS2l(_Entity_):
                            """
                            Otn S2L Information
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn>`
                            
                            	**config**\: False
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn)), ("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps))])
                                self._leafs = OrderedDict()

                                self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"

                                self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._segment_path = lambda: "otn-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l, [], name, value)


                            class Otn(_Entity_):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:  :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth>`
                                
                                	**config**\: False
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:  :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:  :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                	**config**\: False
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("bandwidth", ("bandwidth", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth)), ("labels", ("labels", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels))])
                                    self._leafs = OrderedDict([
                                        ('incoming_controller', (YLeaf(YType.str, 'incoming-controller'), ['str'])),
                                        ('incoming_controller_state', (YLeaf(YType.enumeration, 'incoming-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('incoming_sub_controller', (YLeaf(YType.str, 'incoming-sub-controller'), ['str'])),
                                        ('incoming_sub_controller_state', (YLeaf(YType.enumeration, 'incoming-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_controller', (YLeaf(YType.str, 'outgoing-controller'), ['str'])),
                                        ('outgoing_controller_state', (YLeaf(YType.enumeration, 'outgoing-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('outgoing_sub_controller', (YLeaf(YType.str, 'outgoing-sub-controller'), ['str'])),
                                        ('outgoing_sub_controller_state', (YLeaf(YType.enumeration, 'outgoing-sub-controller-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeControllerState', '')])),
                                        ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                        ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                        ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                        ('outgoing_controller_ifhandle', (YLeaf(YType.str, 'outgoing-controller-ifhandle'), ['str'])),
                                        ('outgoing_sub_controller_ifhandle', (YLeaf(YType.str, 'outgoing-sub-controller-ifhandle'), ['str'])),
                                        ('incoming_controller_ifhandle', (YLeaf(YType.str, 'incoming-controller-ifhandle'), ['str'])),
                                        ('incoming_sub_controller_ifhandle', (YLeaf(YType.str, 'incoming-sub-controller-ifhandle'), ['str'])),
                                        ('gpid', (YLeaf(YType.uint16, 'gpid'), ['int'])),
                                    ])
                                    self.incoming_controller = None
                                    self.incoming_controller_state = None
                                    self.incoming_sub_controller = None
                                    self.incoming_sub_controller_state = None
                                    self.outgoing_controller = None
                                    self.outgoing_controller_state = None
                                    self.outgoing_sub_controller = None
                                    self.outgoing_sub_controller_state = None
                                    self.cross_connect_id = None
                                    self.is_connected = None
                                    self.uptime = None
                                    self.outgoing_controller_ifhandle = None
                                    self.outgoing_sub_controller_ifhandle = None
                                    self.incoming_controller_ifhandle = None
                                    self.incoming_sub_controller_ifhandle = None
                                    self.gpid = None

                                    self.bandwidth = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"

                                    self.labels = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._segment_path = lambda: "otn"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn, ['incoming_controller', 'incoming_controller_state', 'incoming_sub_controller', 'incoming_sub_controller_state', 'outgoing_controller', 'outgoing_controller_state', 'outgoing_sub_controller', 'outgoing_sub_controller_state', 'cross_connect_id', 'is_connected', 'uptime', 'outgoing_controller_ifhandle', 'outgoing_sub_controller_ifhandle', 'incoming_controller_ifhandle', 'incoming_sub_controller_ifhandle', 'gpid'], name, value)


                                class Bandwidth(_Entity_):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes))])
                                        self._leafs = OrderedDict([
                                            ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                        ])
                                        self.odu_level = None

                                        self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._segment_path = lambda: "bandwidth"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth, ['odu_level'], name, value)


                                    class OduFlexCbr(_Entity_):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                                ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self.tolerance = None
                                            self._segment_path = lambda: "odu-flex-cbr"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexCbr']['meta_info']


                                    class OduFlexGfpFRes(_Entity_):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFRes']['meta_info']


                                    class OduFlexGfpFNonRes(_Entity_):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                            ])
                                            self.bit_rate = None
                                            self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth.OduFlexGfpFNonRes']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Bandwidth']['meta_info']


                                class Labels(_Entity_):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:  :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:  :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:  :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:  :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("path-ingress-label", ("path_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel)), ("path-egress-label", ("path_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel)), ("resv-ingress-label", ("resv_ingress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel)), ("resv-egress-label", ("resv_egress_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel))])
                                        self._leafs = OrderedDict()

                                        self.path_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"

                                        self.path_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"

                                        self.resv_ingress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"

                                        self.resv_egress_label = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._segment_path = lambda: "labels"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels, [], name, value)


                                    class PathIngressLabel(_Entity_):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathIngressLabel']['meta_info']


                                    class PathEgressLabel(_Entity_):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "path-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.PathEgressLabel']['meta_info']


                                    class ResvIngressLabel(_Entity_):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-ingress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvIngressLabel']['meta_info']


                                    class ResvEgressLabel(_Entity_):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:  :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:  :py:class:`Otn_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:  :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("wdm", ("wdm", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm)), ("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_))])
                                            self._leafs = OrderedDict([
                                                ('label_type', (YLeaf(YType.enumeration, 'label-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabel', '')])),
                                            ])
                                            self.label_type = None

                                            self.wdm = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"

                                            self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._segment_path = lambda: "resv-egress-label"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel, ['label_type'], name, value)


                                        class Wdm(_Entity_):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\: bool
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:  :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:  :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\: int
                                            
                                            	**range:** \-32768..32767
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('label_set', (YLeaf(YType.boolean, 'label-set'), ['bool'])),
                                                    ('grid', (YLeaf(YType.enumeration, 'grid'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtWdmGrid', '')])),
                                                    ('channel_spacing', (YLeaf(YType.enumeration, 'channel-spacing'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'GmplsUniMgmtDwdmCs', '')])),
                                                    ('identifier', (YLeaf(YType.uint16, 'identifier'), ['int'])),
                                                    ('channel', (YLeaf(YType.int16, 'channel'), ['int'])),
                                                ])
                                                self.label_set = None
                                                self.grid = None
                                                self.channel_spacing = None
                                                self.identifier = None
                                                self.channel = None
                                                self._segment_path = lambda: "wdm"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm, ['label_set', 'grid', 'channel_spacing', 'identifier', 'channel'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Wdm']['meta_info']


                                        class Otn_(_Entity_):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of  		 :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("bit-map", ("bit_map", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap))])
                                                self._leafs = OrderedDict([
                                                    ('tpn', (YLeaf(YType.uint16, 'tpn'), ['int'])),
                                                    ('bit_map_length', (YLeaf(YType.uint16, 'bit-map-length'), ['int'])),
                                                ])
                                                self.tpn = None
                                                self.bit_map_length = None

                                                self.bit_map = YList(self)
                                                self._segment_path = lambda: "otn"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_, ['tpn', 'bit_map_length'], name, value)


                                            class BitMap(_Entity_):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	Bit Map
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "bit-map"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_.BitMap']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel.Otn_']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels.ResvEgressLabel']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn.Labels']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Otn']['meta_info']


                            class Aps(_Entity_):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:  :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("protection-info", ("protection_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo))])
                                    self._leafs = OrderedDict()

                                    self.protection_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._segment_path = lambda: "aps"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps, [], name, value)


                                class ProtectionInfo(_Entity_):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('sbit', (YLeaf(YType.boolean, 'sbit'), ['bool'])),
                                            ('pbit', (YLeaf(YType.boolean, 'pbit'), ['bool'])),
                                            ('nbit', (YLeaf(YType.boolean, 'nbit'), ['bool'])),
                                            ('obit', (YLeaf(YType.boolean, 'obit'), ['bool'])),
                                            ('protect_type', (YLeaf(YType.enumeration, 'protect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('is_wtr_present', (YLeaf(YType.boolean, 'is-wtr-present'), ['bool'])),
                                            ('wtr_timeout', (YLeaf(YType.uint32, 'wtr-timeout'), ['int'])),
                                            ('is_hopresent', (YLeaf(YType.boolean, 'is-hopresent'), ['bool'])),
                                            ('ho_timeout', (YLeaf(YType.uint32, 'ho-timeout'), ['int'])),
                                            ('is_snc_mode_present', (YLeaf(YType.boolean, 'is-snc-mode-present'), ['bool'])),
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                        ])
                                        self.sbit = None
                                        self.pbit = None
                                        self.nbit = None
                                        self.obit = None
                                        self.protect_type = None
                                        self.is_wtr_present = None
                                        self.wtr_timeout = None
                                        self.is_hopresent = None
                                        self.ho_timeout = None
                                        self.is_snc_mode_present = None
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.path_prot_profile_type = None
                                        self._segment_path = lambda: "protection-info"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo, ['sbit', 'pbit', 'nbit', 'obit', 'protect_type', 'is_wtr_present', 'wtr_timeout', 'is_hopresent', 'ho_timeout', 'is_snc_mode_present', 'snc_mode', 'tcm_id', 'path_prot_profile_type'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps.ProtectionInfo']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l.Aps']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OtnS2l']['meta_info']


                        class HeadEndBfdInfo(_Entity_):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:  :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory>`
                            
                            	**config**\: False
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of  		 :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo)), ("deletion-history", ("deletion_history", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory)), ("bfd-reverse-path-label", ("bfd_reverse_path_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel))])
                                self._leafs = OrderedDict([
                                    ('creation_time', (YLeaf(YType.uint32, 'creation-time'), ['int'])),
                                    ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                                    ('is_redundant', (YLeaf(YType.boolean, 'is-redundant'), ['bool'])),
                                    ('bfd_reverse_path_stale', (YLeaf(YType.boolean, 'bfd-reverse-path-stale'), ['bool'])),
                                ])
                                self.creation_time = None
                                self.lspbfd_type = None
                                self.is_redundant = None
                                self.bfd_reverse_path_stale = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"

                                self.deletion_history = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"

                                self.bfd_reverse_path_label = YList(self)
                                self._segment_path = lambda: "head-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo, ['creation_time', 'lspbfd_type', 'is_redundant', 'bfd_reverse_path_stale'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.SessionInfo']['meta_info']


                            class DeletionHistory(_Entity_):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                                        ('deletion_time', (YLeaf(YType.uint32, 'deletion-time'), ['int'])),
                                        ('deletion_reason', (YLeaf(YType.str, 'deletion-reason'), ['str'])),
                                        ('deletion_diagnostic_code', (YLeaf(YType.uint32, 'deletion-diagnostic-code'), ['int'])),
                                    ])
                                    self.lsp_id = None
                                    self.deletion_time = None
                                    self.deletion_reason = None
                                    self.deletion_diagnostic_code = None
                                    self._segment_path = lambda: "deletion-history"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory, ['lsp_id', 'deletion_time', 'deletion_reason', 'deletion_diagnostic_code'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.DeletionHistory']['meta_info']


                            class BfdReversePathLabel(_Entity_):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	BFD reverse path labels
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "bfd-reverse-path-label"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo.BfdReversePathLabel']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.HeadEndBfdInfo']['meta_info']


                        class TailEndBfdInfo(_Entity_):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:  :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("session-info", ("session_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo))])
                                self._leafs = OrderedDict([
                                    ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                                    ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                                    ('local_discriminator', (YLeaf(YType.uint32, 'local-discriminator'), ['int'])),
                                    ('remote_discriminator', (YLeaf(YType.uint32, 'remote-discriminator'), ['int'])),
                                    ('min_interval', (YLeaf(YType.uint32, 'min-interval'), ['int'])),
                                    ('min_interval_default', (YLeaf(YType.boolean, 'min-interval-default'), ['bool'])),
                                    ('multiplier', (YLeaf(YType.uint8, 'multiplier'), ['int'])),
                                    ('multiplier_default', (YLeaf(YType.boolean, 'multiplier-default'), ['bool'])),
                                ])
                                self.failure_diagnostic_code = None
                                self.failure_reason = None
                                self.local_discriminator = None
                                self.remote_discriminator = None
                                self.min_interval = None
                                self.min_interval_default = None
                                self.multiplier = None
                                self.multiplier_default = None

                                self.session_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._segment_path = lambda: "tail-end-bfd-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo, ['failure_diagnostic_code', 'failure_reason', 'local_discriminator', 'remote_discriminator', 'min_interval', 'min_interval_default', 'multiplier', 'multiplier_default'], name, value)


                            class SessionInfo(_Entity_):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                	**config**\: False
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                                        ('state_change_time', (YLeaf(YType.uint32, 'state-change-time'), ['int'])),
                                    ])
                                    self.state = None
                                    self.state_change_time = None
                                    self._segment_path = lambda: "session-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo, ['state', 'state_change_time'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo.SessionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.TailEndBfdInfo']['meta_info']


                        class SrlgCollection(_Entity_):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:  :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            	**config**\: False
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg))])
                                self._leafs = OrderedDict([
                                    ('srlg_collect_type', (YLeaf(YType.enumeration, 'srlg-collect-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrlgCollectRequest', '')])),
                                ])
                                self.srlg_collect_type = None

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "srlg-collection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection, ['srlg_collect_type'], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	Discovered SRLGs
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SrlgCollection']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.Protection']['meta_info']


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseLspFec']['meta_info']


                        class ReverseTspec(_Entity_):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('average_rate', (YLeaf(YType.uint64, 'average-rate'), ['int'])),
                                    ('maximum_burst', (YLeaf(YType.uint64, 'maximum-burst'), ['int'])),
                                    ('peak_rate', (YLeaf(YType.uint64, 'peak-rate'), ['int'])),
                                ])
                                self.average_rate = None
                                self.maximum_burst = None
                                self.peak_rate = None
                                self._segment_path = lambda: "reverse-tspec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec, ['average_rate', 'maximum_burst', 'peak_rate'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseTspec']['meta_info']


                        class FlexInfo(_Entity_):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec>`
                            
                            	**config**\: False
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec))])
                                self._leafs = OrderedDict([
                                    ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                    ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                    ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                    ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                    ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                    ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                    ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                    ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                    ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                    ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                    ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                    ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                    ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                    ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                    ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                                ])
                                self.entry_exists = None
                                self.in_label = None
                                self.bfd_created = None
                                self.bfd_up = None
                                self.oam_created = None
                                self.bfd_next_hop = None
                                self.bfd_tun_ifh = None
                                self.bfd_out_ifh = None
                                self.bfd_int_label = None
                                self.bfd_egress_label = None
                                self.fault_ldi_lockout = None
                                self.fault_ldi = None
                                self.fault_lkr = None
                                self.fault_ais = None
                                self.fault_time = None

                                self.flex_fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._segment_path = lambda: "flex-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                            class FlexFec(_Entity_):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                        ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                        ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                        ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                        ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                        ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                        ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                        ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                        ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                    ])
                                    self.s2l_fec_subgroup_id = None
                                    self.s2l_fec_lsp_id = None
                                    self.s2l_fec_tunnel_id = None
                                    self.s2l_fec_extended_tunnel_id = None
                                    self.s2l_fec_source = None
                                    self.s2l_fec_dest = None
                                    self.s2l_fec_p2mp_id = None
                                    self.s2l_fec_subgroup_originator = None
                                    self.s2l_fec_ctype = None
                                    self.s2l_fec_vrf = None
                                    self._segment_path = lambda: "flex-fec"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo.FlexFec']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.FlexInfo']['meta_info']


                        class LspWrapInfo(_Entity_):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                                    ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                                    ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                                    ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                                    ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                                ])
                                self.lsp_wrap_protection_enable = None
                                self.lsp_wrap_protection_label = None
                                self.reverse_egress_interface = None
                                self.reverse_lsp_label = None
                                self.lsp_wrap_protection_state = None
                                self._segment_path = lambda: "lsp-wrap-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo, ['lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.LspWrapInfo']['meta_info']


                        class DiversityInfo(_Entity_):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                                ])
                                self.diversity_type = None
                                self._segment_path = lambda: "diversity-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo, ['diversity_type'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.DiversityInfo']['meta_info']


                        class AccumulatedPathMetrics(_Entity_):
                            """
                            Accumulated Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics, self).__init__()

                                self.yang_name = "accumulated-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedPathMetrics']['meta_info']


                        class AccumulatedReversePathMetrics(_Entity_):
                            """
                            Accumulated Reverse Path Metrics
                            
                            .. attribute:: te_metric
                            
                            	Path TE Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: igp_metric
                            
                            	Path IGP Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: delay_metric
                            
                            	Path Delay Metric
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics, self).__init__()

                                self.yang_name = "accumulated-reverse-path-metrics"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('te_metric', (YLeaf(YType.uint64, 'te-metric'), ['int'])),
                                    ('igp_metric', (YLeaf(YType.uint64, 'igp-metric'), ['int'])),
                                    ('delay_metric', (YLeaf(YType.uint64, 'delay-metric'), ['int'])),
                                ])
                                self.te_metric = None
                                self.igp_metric = None
                                self.delay_metric = None
                                self._segment_path = lambda: "accumulated-reverse-path-metrics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics, ['te_metric', 'igp_metric', 'delay_metric'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.AccumulatedReversePathMetrics']['meta_info']


                        class S2lReverseLspSubObj(_Entity_):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	Reverse LSP Sub Objects
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-reverse-lsp-sub-obj"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lReverseLspSubObj']['meta_info']


                        class SharedRiskLinkGroup(_Entity_):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                ])
                                self.shared_risk_group = None
                                self.srlg_name = None
                                self._segment_path = lambda: "shared-risk-link-group"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.SharedRiskLinkGroup']['meta_info']


                        class OutEro(_Entity_):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "out-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.OutEro']['meta_info']


                        class InEro(_Entity_):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "in-ero"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.InEro']['meta_info']


                        class PathRro(_Entity_):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "path-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathRro']['meta_info']


                        class ResvRro(_Entity_):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:  :py:class:`Ipv4rroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:  :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:  :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:  :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:  :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4rro-sub-object", ("ipv4rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject)), ("label-rro-sub-object", ("label_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject)), ("unnumbered-rro-sub-object", ("unnumbered_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject)), ("srlg-rro-sub-object", ("srlg_rro_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject))])
                                self._leafs = OrderedDict([
                                    ('rro_type', (YLeaf(YType.enumeration, 'rro-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtRroSubobj', '')])),
                                ])
                                self.rro_type = None

                                self.ipv4rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"

                                self.label_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"

                                self.srlg_rro_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._segment_path = lambda: "resv-rro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro, ['rro_type'], name, value)


                            class Ipv4rroSubObject(_Entity_):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('rro_address', (YLeaf(YType.str, 'rro-address'), ['str'])),
                                    ])
                                    self.rro_address = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "ipv4rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject, ['rro_address'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.Ipv4rroSubObject']['meta_info']


                            class LabelRroSubObject(_Entity_):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of  		 :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags)), ("variable-length-label", ("variable_length_label", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel))])
                                    self._leafs = OrderedDict([
                                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                        ('is_label_variable_length', (YLeaf(YType.boolean, 'is-label-variable-length'), ['bool'])),
                                    ])
                                    self.label = None
                                    self.is_label_variable_length = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"

                                    self.variable_length_label = YList(self)
                                    self._segment_path = lambda: "label-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject, ['label', 'is_label_variable_length'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_global_label', (YLeaf(YType.boolean, 'is-global-label'), ['bool'])),
                                        ])
                                        self.is_global_label = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags, ['is_global_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.Flags']['meta_info']


                                class VariableLengthLabel(_Entity_):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject Variable Length Label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "variable-length-label"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject.VariableLengthLabel']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.LabelRroSubObject']['meta_info']


                            class UnnumberedRroSubObject(_Entity_):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:  :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                	**config**\: False
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("flags", ("flags", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags))])
                                    self._leafs = OrderedDict([
                                        ('interface_address', (YLeaf(YType.str, 'interface-address'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                    ])
                                    self.interface_address = None
                                    self.interface_id = None

                                    self.flags = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._segment_path = lambda: "unnumbered-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject, ['interface_address', 'interface_id'], name, value)


                                class Flags(_Entity_):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('is_protection_available', (YLeaf(YType.boolean, 'is-protection-available'), ['bool'])),
                                            ('is_protection_in_use', (YLeaf(YType.boolean, 'is-protection-in-use'), ['bool'])),
                                            ('is_bandwidth_protected', (YLeaf(YType.boolean, 'is-bandwidth-protected'), ['bool'])),
                                            ('is_node_protection_available', (YLeaf(YType.boolean, 'is-node-protection-available'), ['bool'])),
                                            ('is_node_id', (YLeaf(YType.boolean, 'is-node-id'), ['bool'])),
                                        ])
                                        self.is_protection_available = None
                                        self.is_protection_in_use = None
                                        self.is_bandwidth_protected = None
                                        self.is_node_protection_available = None
                                        self.is_node_id = None
                                        self._segment_path = lambda: "flags"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags, ['is_protection_available', 'is_protection_in_use', 'is_bandwidth_protected', 'is_node_protection_available', 'is_node_id'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject.Flags']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.UnnumberedRroSubObject']['meta_info']


                            class SrlgRroSubObject(_Entity_):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of  		 :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("srl-gs", ("srl_gs", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs))])
                                    self._leafs = OrderedDict()

                                    self.srl_gs = YList(self)
                                    self._segment_path = lambda: "srlg-rro-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject, [], name, value)


                                class SrlGs(_Entity_):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	The RRO Subobject SRLGs
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "srl-gs"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject.SrlGs']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro.SrlgRroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ResvRro']['meta_info']


                        class PathAffinityArray(_Entity_):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of  		 :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("hop-extended-affinity", ("hop_extended_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity))])
                                self._leafs = OrderedDict([
                                    ('hop_address', (YLeaf(YType.str, 'hop-address'), ['str'])),
                                    ('hop_affinity', (YLeaf(YType.uint32, 'hop-affinity'), ['int'])),
                                ])
                                self.hop_address = None
                                self.hop_affinity = None

                                self.hop_extended_affinity = YList(self)
                                self._segment_path = lambda: "path-affinity-array"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray, ['hop_address', 'hop_affinity'], name, value)


                            class HopExtendedAffinity(_Entity_):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	Hop affinity
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "hop-extended-affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray.HopExtendedAffinity']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.PathAffinityArray']['meta_info']


                        class ReverseEroIn(_Entity_):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject))])
                                self._leafs = OrderedDict([
                                    ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                                ])
                                self.ero_type = None

                                self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._segment_path = lambda: "reverse-ero-in"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn, ['ero_type'], name, value)


                            class Ipv4eroSubObject(_Entity_):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                        ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_address = None
                                    self.prefix_length = None
                                    self._segment_path = lambda: "ipv4ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.Ipv4eroSubObject']['meta_info']


                            class UnnumberedEroSubObject(_Entity_):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                        ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                        ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                        ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                    ])
                                    self.is_strict_route = None
                                    self.ero_interface_id = None
                                    self.ero_router_id = None
                                    self.status = None
                                    self._segment_path = lambda: "unnumbered-ero-sub-object"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn.UnnumberedEroSubObject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.ReverseEroIn']['meta_info']


                        class S2lSegmentRoutingPath(_Entity_):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            	**config**\: False
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                                    ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                                    ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                                    ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                                    ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                                    ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                                    ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                                ])
                                self.sid_type = None
                                self.has_ip_addresses = None
                                self.local_addr = None
                                self.remote_addr = None
                                self.has_mpls_label = None
                                self.mpls_label_value = None
                                self.has_entropy_label = None
                                self._segment_path = lambda: "s2l-segment-routing-path"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l.S2lSegmentRoutingPath']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2l']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.CleanedLsp']['meta_info']


                class P2pInfo(_Entity_):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:  :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:  :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus)), ("auto-bandwidth-config", ("auto_bandwidth_config", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig)), ("auto-bandwidth-oper", ("auto_bandwidth_oper", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper))])
                        self._leafs = OrderedDict([
                            ('is_bidirectional', (YLeaf(YType.boolean, 'is-bidirectional'), ['bool'])),
                        ])
                        self.is_bidirectional = None

                        self.auto_bandwidth_status = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"

                        self.auto_bandwidth_config = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"

                        self.auto_bandwidth_oper = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._segment_path = lambda: "p2p-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo, ['is_bidirectional'], name, value)


                    class AutoBandwidthStatus(_Entity_):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                                ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                            ])
                            self.is_auto_bandwidth_enabled = None
                            self.reactivation_time = None
                            self._segment_path = lambda: "auto-bandwidth-status"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthStatus']['meta_info']


                    class AutoBandwidthConfig(_Entity_):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_enabled
                        
                        	TRUE if resignal last bandwidth is enabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_timeout
                        
                        	The configured time\-out value in seconds for resignal  last bandwidth after tunnel down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('is_auto_bandwidth_collect_only', (YLeaf(YType.boolean, 'is-auto-bandwidth-collect-only'), ['bool'])),
                                ('minimum_bandwidth', (YLeaf(YType.uint32, 'minimum-bandwidth'), ['int'])),
                                ('maximum_bandwidth', (YLeaf(YType.uint32, 'maximum-bandwidth'), ['int'])),
                                ('application_frequency', (YLeaf(YType.uint32, 'application-frequency'), ['int'])),
                                ('collection_frequency', (YLeaf(YType.uint32, 'collection-frequency'), ['int'])),
                                ('adjustment_threshold_percent', (YLeaf(YType.uint32, 'adjustment-threshold-percent'), ['int'])),
                                ('adjustment_threshold_value', (YLeaf(YType.uint32, 'adjustment-threshold-value'), ['int'])),
                                ('overflow_threshold_percent', (YLeaf(YType.uint32, 'overflow-threshold-percent'), ['int'])),
                                ('overflow_threshold_value', (YLeaf(YType.uint32, 'overflow-threshold-value'), ['int'])),
                                ('overflow_threshold_limit', (YLeaf(YType.uint32, 'overflow-threshold-limit'), ['int'])),
                                ('underflow_threshold_percent', (YLeaf(YType.uint32, 'underflow-threshold-percent'), ['int'])),
                                ('underflow_threshold_value', (YLeaf(YType.uint32, 'underflow-threshold-value'), ['int'])),
                                ('underflow_threshold_limit', (YLeaf(YType.uint32, 'underflow-threshold-limit'), ['int'])),
                                ('resignal_last_bandwidth_enabled', (YLeaf(YType.boolean, 'resignal-last-bandwidth-enabled'), ['bool'])),
                                ('resignal_last_bandwidth_timeout', (YLeaf(YType.uint32, 'resignal-last-bandwidth-timeout'), ['int'])),
                            ])
                            self.is_auto_bandwidth_collect_only = None
                            self.minimum_bandwidth = None
                            self.maximum_bandwidth = None
                            self.application_frequency = None
                            self.collection_frequency = None
                            self.adjustment_threshold_percent = None
                            self.adjustment_threshold_value = None
                            self.overflow_threshold_percent = None
                            self.overflow_threshold_value = None
                            self.overflow_threshold_limit = None
                            self.underflow_threshold_percent = None
                            self.underflow_threshold_value = None
                            self.underflow_threshold_limit = None
                            self.resignal_last_bandwidth_enabled = None
                            self.resignal_last_bandwidth_timeout = None
                            self._segment_path = lambda: "auto-bandwidth-config"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig, ['is_auto_bandwidth_collect_only', 'minimum_bandwidth', 'maximum_bandwidth', 'application_frequency', 'collection_frequency', 'adjustment_threshold_percent', 'adjustment_threshold_value', 'overflow_threshold_percent', 'overflow_threshold_value', 'overflow_threshold_limit', 'underflow_threshold_percent', 'underflow_threshold_value', 'underflow_threshold_limit', 'resignal_last_bandwidth_enabled', 'resignal_last_bandwidth_timeout'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthConfig']['meta_info']


                    class AutoBandwidthOper(_Entity_):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        	**config**\: False
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:  :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        	**config**\: False
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:  :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        	**config**\: False
                        
                        .. attribute:: resignal_last_bandwidth_expire_time
                        
                        	Timestamp when the resignal last bandwidth will expire and tunnel will use configured bandwidth to setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                                ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                                ('last_application_trigger', (YLeaf(YType.enumeration, 'last-application-trigger'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppTrigger', '')])),
                                ('application_jitter', (YLeaf(YType.uint32, 'application-jitter'), ['int'])),
                                ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                                ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                                ('time_left_collection', (YLeaf(YType.uint32, 'time-left-collection'), ['int'])),
                                ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                                ('underflow_highest_bandwidth', (YLeaf(YType.uint32, 'underflow-highest-bandwidth'), ['int'])),
                                ('threshold_overflows', (YLeaf(YType.uint32, 'threshold-overflows'), ['int'])),
                                ('overflow_early_bw_applications', (YLeaf(YType.uint32, 'overflow-early-bw-applications'), ['int'])),
                                ('threshold_underflows', (YLeaf(YType.uint32, 'threshold-underflows'), ['int'])),
                                ('underflow_early_bw_applications', (YLeaf(YType.uint32, 'underflow-early-bw-applications'), ['int'])),
                                ('collect_only_requested_bandwidth', (YLeaf(YType.uint32, 'collect-only-requested-bandwidth'), ['int'])),
                                ('application_reject_reason', (YLeaf(YType.enumeration, 'application-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutobwAppRej', '')])),
                                ('resignal_last_bandwidth_expire_time', (YLeaf(YType.uint32, 'resignal-last-bandwidth-expire-time'), ['int'])),
                            ])
                            self.last_bandwidth_applied = None
                            self.bandwidth_pool_type = None
                            self.bandwidth_applications = None
                            self.last_application_trigger = None
                            self.application_jitter = None
                            self.time_left_application = None
                            self.samples_collected = None
                            self.time_left_collection = None
                            self.highest_bandwidth = None
                            self.underflow_highest_bandwidth = None
                            self.threshold_overflows = None
                            self.overflow_early_bw_applications = None
                            self.threshold_underflows = None
                            self.underflow_early_bw_applications = None
                            self.collect_only_requested_bandwidth = None
                            self.application_reject_reason = None
                            self.resignal_last_bandwidth_expire_time = None
                            self._segment_path = lambda: "auto-bandwidth-oper"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper, ['last_bandwidth_applied', 'bandwidth_pool_type', 'bandwidth_applications', 'last_application_trigger', 'application_jitter', 'time_left_application', 'samples_collected', 'time_left_collection', 'highest_bandwidth', 'underflow_highest_bandwidth', 'threshold_overflows', 'overflow_early_bw_applications', 'threshold_underflows', 'underflow_early_bw_applications', 'collect_only_requested_bandwidth', 'application_reject_reason', 'resignal_last_bandwidth_expire_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo.AutoBandwidthOper']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.P2pInfo']['meta_info']


                class AutoCapacity(_Entity_):
                    """
                    Auto\-capacity Info
                    
                    .. attribute:: auto_capacity_configuration
                    
                    	The configured properties of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityConfiguration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration>`
                    
                    	**config**\: False
                    
                    .. attribute:: auto_capacity_stats
                    
                    	The statistic of auto\-capacity
                    	**type**\:  :py:class:`AutoCapacityStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats>`
                    
                    	**config**\: False
                    
                    .. attribute:: clone
                    
                    	Table of clones
                    	**type**\: list of  		 :py:class:`Clone <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity, self).__init__()

                        self.yang_name = "auto-capacity"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("auto-capacity-configuration", ("auto_capacity_configuration", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration)), ("auto-capacity-stats", ("auto_capacity_stats", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats)), ("clone", ("clone", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone))])
                        self._leafs = OrderedDict()

                        self.auto_capacity_configuration = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration()
                        self.auto_capacity_configuration.parent = self
                        self._children_name_map["auto_capacity_configuration"] = "auto-capacity-configuration"

                        self.auto_capacity_stats = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats()
                        self.auto_capacity_stats.parent = self
                        self._children_name_map["auto_capacity_stats"] = "auto-capacity-stats"

                        self.clone = YList(self)
                        self._segment_path = lambda: "auto-capacity"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity, [], name, value)


                    class AutoCapacityConfiguration(_Entity_):
                        """
                        The configured properties of auto\-capacity
                        
                        .. attribute:: minimum_clones
                        
                        	The minimum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: maximum_clones
                        
                        	The maximum number of clones
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merge_bandwidth
                        
                        	The merge bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: split_bandwidth
                        
                        	The split bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: nominal_bandwidth
                        
                        	The optimal or nominal bandwidth for the clones in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration, self).__init__()

                            self.yang_name = "auto-capacity-configuration"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('minimum_clones', (YLeaf(YType.uint32, 'minimum-clones'), ['int'])),
                                ('maximum_clones', (YLeaf(YType.uint32, 'maximum-clones'), ['int'])),
                                ('merge_bandwidth', (YLeaf(YType.uint32, 'merge-bandwidth'), ['int'])),
                                ('split_bandwidth', (YLeaf(YType.uint32, 'split-bandwidth'), ['int'])),
                                ('nominal_bandwidth', (YLeaf(YType.uint32, 'nominal-bandwidth'), ['int'])),
                            ])
                            self.minimum_clones = None
                            self.maximum_clones = None
                            self.merge_bandwidth = None
                            self.split_bandwidth = None
                            self.nominal_bandwidth = None
                            self._segment_path = lambda: "auto-capacity-configuration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration, ['minimum_clones', 'maximum_clones', 'merge_bandwidth', 'split_bandwidth', 'nominal_bandwidth'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityConfiguration']['meta_info']


                    class AutoCapacityStats(_Entity_):
                        """
                        The statistic of auto\-capacity
                        
                        .. attribute:: splits
                        
                        	Count of splits events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: merges
                        
                        	Count of merges events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_created
                        
                        	Total clones created
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: total_clones_deleted
                        
                        	Total clones deleted
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: high_watermark_clones
                        
                        	Highest number of clones reached at any point in time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats, self).__init__()

                            self.yang_name = "auto-capacity-stats"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('splits', (YLeaf(YType.uint32, 'splits'), ['int'])),
                                ('merges', (YLeaf(YType.uint32, 'merges'), ['int'])),
                                ('total_clones_created', (YLeaf(YType.uint32, 'total-clones-created'), ['int'])),
                                ('total_clones_deleted', (YLeaf(YType.uint32, 'total-clones-deleted'), ['int'])),
                                ('high_watermark_clones', (YLeaf(YType.uint32, 'high-watermark-clones'), ['int'])),
                            ])
                            self.splits = None
                            self.merges = None
                            self.total_clones_created = None
                            self.total_clones_deleted = None
                            self.high_watermark_clones = None
                            self._segment_path = lambda: "auto-capacity-stats"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats, ['splits', 'merges', 'total_clones_created', 'total_clones_deleted', 'high_watermark_clones'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.AutoCapacityStats']['meta_info']


                    class Clone(_Entity_):
                        """
                        Table of clones
                        
                        .. attribute:: name
                        
                        	Name of the clone
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: creation_timestamp
                        
                        	The timestamp when this clone was created relative to Jan 1, 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: state
                        
                        	The interface state of the cloned tunnel
                        	**type**\:  :py:class:`MteTunnelOperState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteTunnelOperState>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_bandwidth
                        
                        	The signaled bandwidth (kbps) of the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: current_bandwidth_demand
                        
                        	The current demand (kbps) read from the traffic stats for the clone
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone, self).__init__()

                            self.yang_name = "clone"
                            self.yang_parent_name = "auto-capacity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('creation_timestamp', (YLeaf(YType.uint32, 'creation-timestamp'), ['int'])),
                                ('state', (YLeaf(YType.enumeration, 'state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MteTunnelOperState', '')])),
                                ('signaled_bandwidth', (YLeaf(YType.uint32, 'signaled-bandwidth'), ['int'])),
                                ('current_bandwidth_demand', (YLeaf(YType.uint32, 'current-bandwidth-demand'), ['int'])),
                            ])
                            self.name = None
                            self.creation_timestamp = None
                            self.state = None
                            self.signaled_bandwidth = None
                            self.current_bandwidth_demand = None
                            self._segment_path = lambda: "clone"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone, ['name', 'creation_timestamp', 'state', 'signaled_bandwidth', 'current_bandwidth_demand'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity.Clone']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoCapacity']['meta_info']


                class History(_Entity_):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:  :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:  :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:  :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:  :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:  :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:  :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:  :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:  :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:  :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:  :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail>`
                    
                    	**config**\: False
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:  :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("current-setup", ("current_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup)), ("reopt-setup", ("reopt_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup)), ("gmpls-path-protect-setup", ("gmpls_path_protect_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup)), ("previous-setup", ("previous_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup)), ("previous-gmpls-path-protect-setup", ("previous_gmpls_path_protect_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup)), ("gmpls-other-setup", ("gmpls_other_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup)), ("gmpls-other-protect-setup", ("gmpls_other_protect_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup)), ("standby-setup", ("standby_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup)), ("standby-reopt-setup", ("standby_reopt_setup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup)), ("last-re-opt-fail", ("last_re_opt_fail", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail)), ("last-stdby-re-opt-fail", ("last_stdby_re_opt_fail", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail))])
                        self._leafs = OrderedDict()

                        self.current_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"

                        self.reopt_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"

                        self.gmpls_path_protect_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"

                        self.previous_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"

                        self.previous_gmpls_path_protect_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"

                        self.gmpls_other_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"

                        self.gmpls_other_protect_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"

                        self.standby_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"

                        self.standby_reopt_setup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"

                        self.last_re_opt_fail = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"

                        self.last_stdby_re_opt_fail = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._segment_path = lambda: "history"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History, [], name, value)


                    class CurrentSetup(_Entity_):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:  :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes>`
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("connected-uptimes", ("connected_uptimes", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes))])
                            self._leafs = OrderedDict([
                                ('current_setup_timer', (YLeaf(YType.uint32, 'current-setup-timer'), ['int'])),
                                ('selection_reason', (YLeaf(YType.str, 'selection-reason'), ['str'])),
                                ('current_setup_last_error', (YLeaf(YType.str, 'current-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.current_setup_timer = None
                            self.selection_reason = None
                            self.current_setup_last_error = None
                            self.protection_role = None

                            self.connected_uptimes = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._segment_path = lambda: "current-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, ['current_setup_timer', 'selection_reason', 'current_setup_last_error', 'protection_role'], name, value)


                        class ConnectedUptimes(_Entity_):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('current_lsp_uptime', (YLeaf(YType.uint32, 'current-lsp-uptime'), ['int'])),
                                    ('current_uptime', (YLeaf(YType.uint32, 'current-uptime'), ['int'])),
                                ])
                                self.current_lsp_uptime = None
                                self.current_uptime = None
                                self._segment_path = lambda: "connected-uptimes"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, ['current_lsp_uptime', 'current_uptime'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup']['meta_info']


                    class ReoptSetup(_Entity_):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup']['meta_info']


                    class GmplsPathProtectSetup(_Entity_):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protecting_setup_uptime', (YLeaf(YType.uint32, 'protecting-setup-uptime'), ['int'])),
                                ('protecting_setup_timer', (YLeaf(YType.uint32, 'protecting-setup-timer'), ['int'])),
                                ('protecting_setup_last_error', (YLeaf(YType.str, 'protecting-setup-last-error'), ['str'])),
                            ])
                            self.protecting_setup_uptime = None
                            self.protecting_setup_timer = None
                            self.protecting_setup_last_error = None
                            self._segment_path = lambda: "gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, ['protecting_setup_uptime', 'protecting_setup_timer', 'protecting_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup']['meta_info']


                    class PreviousSetup(_Entity_):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_path_option', (YLeaf(YType.str, 'previous-path-option'), ['str'])),
                                ('previous_tunnel_instance', (YLeaf(YType.uint32, 'previous-tunnel-instance'), ['int'])),
                                ('previous_fail_reason', (YLeaf(YType.str, 'previous-fail-reason'), ['str'])),
                                ('previous_setup_last_error', (YLeaf(YType.str, 'previous-setup-last-error'), ['str'])),
                            ])
                            self.previous_path_option = None
                            self.previous_tunnel_instance = None
                            self.previous_fail_reason = None
                            self.previous_setup_last_error = None
                            self._segment_path = lambda: "previous-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, ['previous_path_option', 'previous_tunnel_instance', 'previous_fail_reason', 'previous_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup']['meta_info']


                    class PreviousGmplsPathProtectSetup(_Entity_):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('previous_protect_path_option', (YLeaf(YType.str, 'previous-protect-path-option'), ['str'])),
                                ('previous_protect_tunnel_instance', (YLeaf(YType.uint32, 'previous-protect-tunnel-instance'), ['int'])),
                                ('previous_protect_fail_reason', (YLeaf(YType.str, 'previous-protect-fail-reason'), ['str'])),
                                ('previous_protect_setup_last_error', (YLeaf(YType.str, 'previous-protect-setup-last-error'), ['str'])),
                            ])
                            self.previous_protect_path_option = None
                            self.previous_protect_tunnel_instance = None
                            self.previous_protect_fail_reason = None
                            self.previous_protect_setup_last_error = None
                            self._segment_path = lambda: "previous-gmpls-path-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, ['previous_protect_path_option', 'previous_protect_tunnel_instance', 'previous_protect_fail_reason', 'previous_protect_setup_last_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup']['meta_info']


                    class GmplsOtherSetup(_Entity_):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup']['meta_info']


                    class GmplsOtherProtectSetup(_Entity_):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_option_index', (YLeaf(YType.uint32, 'path-option-index'), ['int'])),
                                ('other_setup_error', (YLeaf(YType.str, 'other-setup-error'), ['str'])),
                            ])
                            self.path_option_index = None
                            self.other_setup_error = None
                            self._segment_path = lambda: "gmpls-other-protect-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, ['path_option_index', 'other_setup_error'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup']['meta_info']


                    class StandbySetup(_Entity_):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('standby_lsp_uptime', (YLeaf(YType.uint32, 'standby-lsp-uptime'), ['int'])),
                                ('standby_setup_timer', (YLeaf(YType.uint32, 'standby-setup-timer'), ['int'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.standby_lsp_uptime = None
                            self.standby_setup_timer = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, ['standby_lsp_uptime', 'standby_setup_timer', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbySetup']['meta_info']


                    class StandbyReoptSetup(_Entity_):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: protection_role
                        
                        	Path Protection Role
                        	**type**\:  :py:class:`TeLspPathProtectionRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeLspPathProtectionRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('reoptimized_setup_uptime', (YLeaf(YType.uint32, 'reoptimized-setup-uptime'), ['int'])),
                                ('reoptimized_setup_timer', (YLeaf(YType.uint32, 'reoptimized-setup-timer'), ['int'])),
                                ('reoptimized_setup_last_error', (YLeaf(YType.str, 'reoptimized-setup-last-error'), ['str'])),
                                ('protection_role', (YLeaf(YType.enumeration, 'protection-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeLspPathProtectionRole', '')])),
                            ])
                            self.reoptimized_setup_uptime = None
                            self.reoptimized_setup_timer = None
                            self.reoptimized_setup_last_error = None
                            self.protection_role = None
                            self._segment_path = lambda: "standby-reopt-setup"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, ['reoptimized_setup_uptime', 'reoptimized_setup_timer', 'reoptimized_setup_last_error', 'protection_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup']['meta_info']


                    class LastReOptFail(_Entity_):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail']['meta_info']


                    class LastStdbyReOptFail(_Entity_):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:  :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('re_opt_last_fail_reason', (YLeaf(YType.enumeration, 're-opt-last-fail-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeReoptDecisionReason', '')])),
                                ('re_opt_failed_destination', (YLeaf(YType.str, 're-opt-failed-destination'), ['str'])),
                                ('re_opt_failed_timestamp', (YLeaf(YType.uint32, 're-opt-failed-timestamp'), ['int'])),
                            ])
                            self.re_opt_last_fail_reason = None
                            self.re_opt_failed_destination = None
                            self.re_opt_failed_timestamp = None
                            self._segment_path = lambda: "last-stdby-re-opt-fail"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, ['re_opt_last_fail_reason', 're_opt_failed_destination', 're_opt_failed_timestamp'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.History']['meta_info']


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PathProtection']['meta_info']


                class AutoBackup(_Entity_):
                    """
                    Autobackup Information
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:  :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of  		 :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("weighted-srlg-info", ("weighted_srlg_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo)), ("iep", ("iep", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep))])
                        self._leafs = OrderedDict([
                            ('protected_ls_ps', (YLeaf(YType.uint32, 'protected-ls-ps'), ['int'])),
                            ('protected_s2_ls', (YLeaf(YType.uint32, 'protected-s2-ls'), ['int'])),
                            ('sharing_families', (YLeaf(YType.uint32, 'sharing-families'), ['int'])),
                            ('ab_protection_type', (YLeaf(YType.enumeration, 'ab-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('is_using_srlg', (YLeaf(YType.boolean, 'is-using-srlg'), ['bool'])),
                            ('srlg_prot_type', (YLeaf(YType.enumeration, 'srlg-prot-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('ab_protected_interface', (YLeaf(YType.str, 'ab-protected-interface'), ['str'])),
                            ('protected_address', (YLeaf(YType.str, 'protected-address'), ['str'])),
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('is_unused_removal_timer_running', (YLeaf(YType.boolean, 'is-unused-removal-timer-running'), ['bool'])),
                            ('unused_removal_remaining_time', (YLeaf(YType.uint32, 'unused-removal-remaining-time'), ['int'])),
                        ])
                        self.protected_ls_ps = None
                        self.protected_s2_ls = None
                        self.sharing_families = None
                        self.ab_protection_type = None
                        self.is_using_srlg = None
                        self.srlg_prot_type = None
                        self.ab_protected_interface = None
                        self.protected_address = None
                        self.tunnel_attribute_set_name = None
                        self.is_unused_removal_timer_running = None
                        self.unused_removal_remaining_time = None

                        self.weighted_srlg_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"

                        self.iep = YList(self)
                        self._segment_path = lambda: "auto-backup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup, ['protected_ls_ps', 'protected_s2_ls', 'sharing_families', 'ab_protection_type', 'is_using_srlg', 'srlg_prot_type', 'ab_protected_interface', 'protected_address', 'tunnel_attribute_set_name', 'is_unused_removal_timer_running', 'unused_removal_remaining_time'], name, value)


                    class WeightedSrlgInfo(_Entity_):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of  		 :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of  		 :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protected-interface-srlg", ("protected_interface_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg)), ("weighted-srlg-hop", ("weighted_srlg_hop", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop))])
                            self._leafs = OrderedDict()

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)
                            self._segment_path = lambda: "weighted-srlg-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, [], name, value)


                        class ProtectedInterfaceSrlg(_Entity_):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('srlg', (YLeaf(YType.uint32, 'srlg'), ['int'])),
                                    ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                                    ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                                ])
                                self.srlg = None
                                self.srlg_name = None
                                self.admin_weight = None
                                self._segment_path = lambda: "protected-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, ['srlg', 'srlg_name', 'admin_weight'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg']['meta_info']


                        class WeightedSrlgHop(_Entity_):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\: int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**config**\: False
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of  		 :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("common-srlg", ("common_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg))])
                                self._leafs = OrderedDict([
                                    ('from_address', (YLeaf(YType.str, 'from-address'), ['str'])),
                                    ('to_address', (YLeaf(YType.str, 'to-address'), ['str'])),
                                    ('aggregate_admin_weight', (YLeaf(YType.uint64, 'aggregate-admin-weight'), ['int'])),
                                ])
                                self.from_address = None
                                self.to_address = None
                                self.aggregate_admin_weight = None

                                self.common_srlg = YList(self)
                                self._segment_path = lambda: "weighted-srlg-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, ['from_address', 'to_address', 'aggregate_admin_weight'], name, value)


                            class CommonSrlg(_Entity_):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	Common SRLG between this hop and the protected  interface
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "common-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo']['meta_info']


                    class Iep(_Entity_):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of  		 :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("iep-hop", ("iep_hop", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop))])
                            self._leafs = OrderedDict([
                                ('path_option_id', (YLeaf(YType.uint32, 'path-option-id'), ['int'])),
                            ])
                            self.path_option_id = None

                            self.iep_hop = YList(self)
                            self._segment_path = lambda: "iep"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, ['path_option_id'], name, value)


                        class IepHop(_Entity_):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:  :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            	**config**\: False
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('hop_index', (YLeaf(YType.uint32, 'hop-index'), ['int'])),
                                    ('iep_hop_type', (YLeaf(YType.enumeration, 'iep-hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIepHop', '')])),
                                    ('iep_hop_address', (YLeaf(YType.str, 'iep-hop-address'), ['str'])),
                                ])
                                self.hop_index = None
                                self.iep_hop_type = None
                                self.iep_hop_address = None
                                self._segment_path = lambda: "iep-hop"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, ['hop_index', 'iep_hop_type', 'iep_hop_address'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoBackup']['meta_info']


                class AutoMesh(_Entity_):
                    """
                    Automesh Information
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('tunnel_destination_list_name', (YLeaf(YType.str, 'tunnel-destination-list-name'), ['str'])),
                            ('is_tunnel_unused_timer_running', (YLeaf(YType.boolean, 'is-tunnel-unused-timer-running'), ['bool'])),
                            ('remaining_unused_time', (YLeaf(YType.uint32, 'remaining-unused-time'), ['int'])),
                            ('mesh_group_type', (YLeaf(YType.enumeration, 'mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.tunnel_destination_list_name = None
                        self.is_tunnel_unused_timer_running = None
                        self.remaining_unused_time = None
                        self.mesh_group_type = None
                        self._segment_path = lambda: "auto-mesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh, ['mesh_group_id', 'tunnel_destination_list_name', 'is_tunnel_unused_timer_running', 'remaining_unused_time', 'mesh_group_type'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoMesh']['meta_info']


                class AutoPcc(_Entity_):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('creator_address', (YLeaf(YType.str, 'creator-address'), ['str'])),
                            ('has_creator_id', (YLeaf(YType.boolean, 'has-creator-id'), ['bool'])),
                            ('creator_id', (YLeaf(YType.str, 'creator-id'), ['str'])),
                            ('plspid', (YLeaf(YType.uint32, 'plspid'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.owner_address = None
                        self.creator_address = None
                        self.has_creator_id = None
                        self.creator_id = None
                        self.plspid = None
                        self.symbolic_name = None
                        self.operationally_up = None
                        self._segment_path = lambda: "auto-pcc"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc, ['owner_address', 'creator_address', 'has_creator_id', 'creator_id', 'plspid', 'symbolic_name', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.AutoPcc']['meta_info']


                class PceDelegation(_Entity_):
                    """
                    PCE Delegation information
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('plsp_id', (YLeaf(YType.uint32, 'plsp-id'), ['int'])),
                            ('symbolic_name', (YLeaf(YType.str, 'symbolic-name'), ['str'])),
                            ('owner_address', (YLeaf(YType.str, 'owner-address'), ['str'])),
                            ('operationally_up', (YLeaf(YType.boolean, 'operationally-up'), ['bool'])),
                        ])
                        self.plsp_id = None
                        self.symbolic_name = None
                        self.owner_address = None
                        self.operationally_up = None
                        self._segment_path = lambda: "pce-delegation"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation, ['plsp_id', 'symbolic_name', 'owner_address', 'operationally_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.PceDelegation']['meta_info']


                class SoftPreemption(_Entity_):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:  :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:  :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:  :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of  		 :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("soft-preemption-counters", ("soft_preemption_counters", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters)), ("soft-preemption-path-error", ("soft_preemption_path_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError))])
                        self._leafs = OrderedDict([
                            ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionState', '')])),
                            ('time_in_preemption_pending', (YLeaf(YType.uint16, 'time-in-preemption-pending'), ['int'])),
                            ('preemption_pending_resolution', (YLeaf(YType.enumeration, 'preemption-pending-resolution'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeSoftPreemptionResolution', '')])),
                        ])
                        self.status = None
                        self.time_in_preemption_pending = None
                        self.preemption_pending_resolution = None

                        self.soft_preemption_counters = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"

                        self.soft_preemption_path_error = YList(self)
                        self._segment_path = lambda: "soft-preemption"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption, ['status', 'time_in_preemption_pending', 'preemption_pending_resolution'], name, value)


                    class SoftPreemptionCounters(_Entity_):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                                ('reopt_completed_ls_ps', (YLeaf(YType.uint32, 'reopt-completed-ls-ps'), ['int'])),
                                ('torn_down_ls_ps', (YLeaf(YType.uint32, 'torn-down-ls-ps'), ['int'])),
                                ('path_protection_switchover_ls_ps', (YLeaf(YType.uint32, 'path-protection-switchover-ls-ps'), ['int'])),
                                ('frr_triggered_ls_ps', (YLeaf(YType.uint32, 'frr-triggered-ls-ps'), ['int'])),
                                ('time_in_preemption_pending_min', (YLeaf(YType.uint16, 'time-in-preemption-pending-min'), ['int'])),
                                ('time_in_preemption_pending_max', (YLeaf(YType.uint16, 'time-in-preemption-pending-max'), ['int'])),
                                ('time_in_preemption_pending_avg', (YLeaf(YType.uint16, 'time-in-preemption-pending-avg'), ['int'])),
                            ])
                            self.soft_preemption_events = None
                            self.reopt_completed_ls_ps = None
                            self.torn_down_ls_ps = None
                            self.path_protection_switchover_ls_ps = None
                            self.frr_triggered_ls_ps = None
                            self.time_in_preemption_pending_min = None
                            self.time_in_preemption_pending_max = None
                            self.time_in_preemption_pending_avg = None
                            self._segment_path = lambda: "soft-preemption-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, ['soft_preemption_events', 'reopt_completed_ls_ps', 'torn_down_ls_ps', 'path_protection_switchover_ls_ps', 'frr_triggered_ls_ps', 'time_in_preemption_pending_min', 'time_in_preemption_pending_max', 'time_in_preemption_pending_avg'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters']['meta_info']


                    class SoftPreemptionPathError(_Entity_):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('preempting_link_address', (YLeaf(YType.str, 'preempting-link-address'), ['str'])),
                            ])
                            self.timestamp = None
                            self.preempting_link_address = None
                            self._segment_path = lambda: "soft-preemption-path-error"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, ['timestamp', 'preempting_link_address'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.SoftPreemption']['meta_info']


                class WdmUnitunnel(_Entity_):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:  :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('tunnel_role', (YLeaf(YType.enumeration, 'tunnel-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('local_optical_router_id', (YLeaf(YType.str, 'local-optical-router-id'), ['str'])),
                            ('remote_optical_router_id', (YLeaf(YType.str, 'remote-optical-router-id'), ['str'])),
                            ('controlled_interface', (YLeaf(YType.str, 'controlled-interface'), ['str'])),
                            ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                            ('label_origin', (YLeaf(YType.enumeration, 'label-origin'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMgmtGmplsLabelOrigin', '')])),
                            ('srlg_discovery', (YLeaf(YType.boolean, 'srlg-discovery'), ['bool'])),
                        ])
                        self.tunnel_state = None
                        self.tunnel_role = None
                        self.tunnel_id = None
                        self.lsp_id = None
                        self.local_optical_router_id = None
                        self.remote_optical_router_id = None
                        self.controlled_interface = None
                        self.source_address = None
                        self.destination_address = None
                        self.extended_tunnel_id = None
                        self.label_origin = None
                        self.srlg_discovery = None
                        self._segment_path = lambda: "wdm-unitunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, ['tunnel_state', 'tunnel_role', 'tunnel_id', 'lsp_id', 'local_optical_router_id', 'remote_optical_router_id', 'controlled_interface', 'source_address', 'destination_address', 'extended_tunnel_id', 'label_origin', 'srlg_discovery'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel']['meta_info']


                class TransportTunnelInfo(_Entity_):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:  :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn>`
                    
                    	**config**\: False
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:  :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:  :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni>`
                    
                    	**config**\: False
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of  		 :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro>`
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of  		 :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("otn", ("otn", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn)), ("static-uni", ("static_uni", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni)), ("egress-static-uni", ("egress_static_uni", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni)), ("homepath-ero", ("homepath_ero", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro)), ("diversity-info", ("diversity_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo))])
                        self._leafs = OrderedDict([
                            ('status_homepath_working', (YLeaf(YType.boolean, 'status-homepath-working'), ['bool'])),
                        ])
                        self.status_homepath_working = None

                        self.otn = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"

                        self.static_uni = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"

                        self.egress_static_uni = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"

                        self.homepath_ero = YList(self)
                        self.diversity_info = YList(self)
                        self._segment_path = lambda: "transport-tunnel-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, ['status_homepath_working'], name, value)


                    class Otn(_Entity_):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:  :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        	**config**\: False
                        
                        .. attribute:: config_bit_rate
                        
                        	Configured OTN Bandwidth in kbps
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: kbit/s
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-cfg", ("bandwidth_cfg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg))])
                            self._leafs = OrderedDict([
                                ('config_bit_rate', (YLeaf(YType.uint32, 'config-bit-rate'), ['int'])),
                            ])
                            self.config_bit_rate = None

                            self.bandwidth_cfg = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._segment_path = lambda: "otn"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, ['config_bit_rate'], name, value)


                        class BandwidthCfg(_Entity_):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:  :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:  :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:  :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            	**config**\: False
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("odu-flex-cbr", ("odu_flex_cbr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr)), ("odu-flex-gfp-f-res", ("odu_flex_gfp_f_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes)), ("odu-flex-gfp-f-non-res", ("odu_flex_gfp_f_non_res", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes))])
                                self._leafs = OrderedDict([
                                    ('odu_level', (YLeaf(YType.enumeration, 'odu-level'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ])
                                self.odu_level = None

                                self.odu_flex_cbr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"

                                self.odu_flex_gfp_f_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"

                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._segment_path = lambda: "bandwidth-cfg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, ['odu_level'], name, value)


                            class OduFlexCbr(_Entity_):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                        ('tolerance', (YLeaf(YType.uint16, 'tolerance'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self.tolerance = None
                                    self._segment_path = lambda: "odu-flex-cbr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, ['bit_rate', 'tolerance'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr']['meta_info']


                            class OduFlexGfpFRes(_Entity_):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes']['meta_info']


                            class OduFlexGfpFNonRes(_Entity_):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('bit_rate', (YLeaf(YType.uint32, 'bit-rate'), ['int'])),
                                    ])
                                    self.bit_rate = None
                                    self._segment_path = lambda: "odu-flex-gfp-f-non-res"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, ['bit_rate'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn']['meta_info']


                    class StaticUni(_Entity_):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: term_interface_srlg
                        
                        	Termination Interface SRLG
                        	**type**\:  :py:class:`TermInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg>`
                        
                        	**config**\: False
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("term-interface-srlg", ("term_interface_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg))])
                            self._leafs = OrderedDict([
                                ('client_port', (YLeaf(YType.str, 'client-port'), ['str'])),
                                ('client_if_handle', (YLeaf(YType.str, 'client-if-handle'), ['str'])),
                                ('client_odu_name', (YLeaf(YType.str, 'client-odu-name'), ['str'])),
                                ('client_odu_if_handle', (YLeaf(YType.str, 'client-odu-if-handle'), ['str'])),
                                ('cross_connect_id', (YLeaf(YType.uint32, 'cross-connect-id'), ['int'])),
                                ('is_connected', (YLeaf(YType.boolean, 'is-connected'), ['bool'])),
                                ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('static_uni_type', (YLeaf(YType.enumeration, 'static-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                                ('term_client_port', (YLeaf(YType.str, 'term-client-port'), ['str'])),
                                ('term_client_if_handle', (YLeaf(YType.str, 'term-client-if-handle'), ['str'])),
                            ])
                            self.client_port = None
                            self.client_if_handle = None
                            self.client_odu_name = None
                            self.client_odu_if_handle = None
                            self.cross_connect_id = None
                            self.is_connected = None
                            self.uptime = None
                            self.local_termination = None
                            self.static_uni_type = None
                            self.term_client_port = None
                            self.term_client_if_handle = None

                            self.term_interface_srlg = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg()
                            self.term_interface_srlg.parent = self
                            self._children_name_map["term_interface_srlg"] = "term-interface-srlg"
                            self._segment_path = lambda: "static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, ['client_port', 'client_if_handle', 'client_odu_name', 'client_odu_if_handle', 'cross_connect_id', 'is_connected', 'uptime', 'local_termination', 'static_uni_type', 'term_client_port', 'term_client_if_handle'], name, value)


                        class TermInterfaceSrlg(_Entity_):
                            """
                            Termination Interface SRLG
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLG
                            	**type**\: list of  		 :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, self).__init__()

                                self.yang_name = "term-interface-srlg"
                                self.yang_parent_name = "static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("discovered-srlg", ("discovered_srlg", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg))])
                                self._leafs = OrderedDict()

                                self.discovered_srlg = YList(self)
                                self._segment_path = lambda: "term-interface-srlg"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg, [], name, value)


                            class DiscoveredSrlg(_Entity_):
                                """
                                Discovered SRLG
                                
                                .. attribute:: entry
                                
                                	Discovered SRLG
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "term-interface-srlg"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "discovered-srlg"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg.DiscoveredSrlg']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni.TermInterfaceSrlg']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni']['meta_info']


                    class EgressStaticUni(_Entity_):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:  :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:  :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        	**config**\: False
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:  :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        	**config**\: False
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:  :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("egress-port", ("egress_port", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort)), ("term-egress-port", ("term_egress_port", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort))])
                            self._leafs = OrderedDict([
                                ('local_termination', (YLeaf(YType.enumeration, 'local-termination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTermination', '')])),
                                ('remote_uni_type', (YLeaf(YType.enumeration, 'remote-uni-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeUni', '')])),
                            ])
                            self.local_termination = None
                            self.remote_uni_type = None

                            self.egress_port = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"

                            self.term_egress_port = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._segment_path = lambda: "egress-static-uni"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, ['local_termination', 'remote_uni_type'], name, value)


                        class EgressPort(_Entity_):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort']['meta_info']


                        class TermEgressPort(_Entity_):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "term-egress-port"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni']['meta_info']


                    class HomepathEro(_Entity_):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "homepath-ero"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro']['meta_info']


                    class DiversityInfo(_Entity_):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                            ])
                            self.tunnel_id = None
                            self._segment_path = lambda: "diversity-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, ['tunnel_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo']['meta_info']


                class BfdInfo(_Entity_):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:  :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of  		 :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("event-counters", ("event_counters", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters)), ("dampening-info", ("dampening_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo))])
                        self._leafs = OrderedDict([
                            ('bfd_session_up', (YLeaf(YType.boolean, 'bfd-session-up'), ['bool'])),
                            ('session_up_time', (YLeaf(YType.uint32, 'session-up-time'), ['int'])),
                            ('failure_diagnostic_code', (YLeaf(YType.uint32, 'failure-diagnostic-code'), ['int'])),
                            ('failure_reason', (YLeaf(YType.str, 'failure-reason'), ['str'])),
                            ('minimum_session_up_interval', (YLeaf(YType.uint32, 'minimum-session-up-interval'), ['int'])),
                            ('maximum_session_up_interval', (YLeaf(YType.uint32, 'maximum-session-up-interval'), ['int'])),
                        ])
                        self.bfd_session_up = None
                        self.session_up_time = None
                        self.failure_diagnostic_code = None
                        self.failure_reason = None
                        self.minimum_session_up_interval = None
                        self.maximum_session_up_interval = None

                        self.event_counters = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"

                        self.dampening_info = YList(self)
                        self._segment_path = lambda: "bfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo, ['bfd_session_up', 'session_up_time', 'failure_diagnostic_code', 'failure_reason', 'minimum_session_up_interval', 'maximum_session_up_interval'], name, value)


                    class EventCounters(_Entity_):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                                ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                                ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                                ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                                ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                                ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                                ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                                ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                                ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                            ])
                            self.session_create_events = None
                            self.session_up_events = None
                            self.session_creation_failed_events = None
                            self.session_down_events = None
                            self.session_admin_down_events = None
                            self.session_gracefully_delete_events = None
                            self.session_non_gracefully_delete_events = None
                            self.session_create_timeout_events = None
                            self.session_replay_events = None
                            self._segment_path = lambda: "event-counters"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters']['meta_info']


                    class DampeningInfo(_Entity_):
                        """
                        Path option dampening info
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('hold_down_time', (YLeaf(YType.uint32, 'hold-down-time'), ['int'])),
                                ('remained_time', (YLeaf(YType.uint32, 'remained-time'), ['int'])),
                                ('backoff_count', (YLeaf(YType.uint32, 'backoff-count'), ['int'])),
                            ])
                            self.option_index = None
                            self.hold_down_time = None
                            self.remained_time = None
                            self.backoff_count = None
                            self._segment_path = lambda: "dampening-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, ['option_index', 'hold_down_time', 'remained_time', 'backoff_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.BfdInfo']['meta_info']


                class OtnBidir(_Entity_):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:  :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:  :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("aps", ("aps", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps)), ("restoration", ("restoration", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration))])
                        self._leafs = OrderedDict()

                        self.aps = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"

                        self.restoration = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._segment_path = lambda: "otn-bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir, [], name, value)


                    class Aps(_Entity_):
                        """
                        APS Protection Info
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:  :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile>`
                        
                        	**config**\: False
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("protection-profile", ("protection_profile", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile))])
                            self._leafs = OrderedDict([
                                ('active_lsp', (YLeaf(YType.enumeration, 'active-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.active_lsp = None
                            self.diversity_type = None

                            self.protection_profile = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._segment_path = lambda: "aps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, ['active_lsp', 'diversity_type'], name, value)


                        class ProtectionProfile(_Entity_):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "protection-profile"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps']['meta_info']


                    class Restoration(_Entity_):
                        """
                        Restoration Info
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        	**config**\: False
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        	**config**\: False
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('revert_option', (YLeaf(YType.enumeration, 'revert-option'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                ('diverse_lsp', (YLeaf(YType.enumeration, 'diverse-lsp'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ])
                            self.revert_option = None
                            self.diverse_lsp = None
                            self.diversity_type = None
                            self._segment_path = lambda: "restoration"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, ['revert_option', 'diverse_lsp', 'diversity_type'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.OtnBidir']['meta_info']


                class Bidir(_Entity_):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:  :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:  :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("reverse-ero-error-current", ("reverse_ero_error_current", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent)), ("reverse-ero-error-reopt", ("reverse_ero_error_reopt", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt)), ("reverse-ero-error-standby", ("reverse_ero_error_standby", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby)), ("reverse-ero-error-standby-reopt", ("reverse_ero_error_standby_reopt", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt))])
                        self._leafs = OrderedDict([
                            ('reverse_bandwidth', (YLeaf(YType.uint32, 'reverse-bandwidth'), ['int'])),
                            ('reverse_bandwidth_standby', (YLeaf(YType.uint32, 'reverse-bandwidth-standby'), ['int'])),
                        ])
                        self.reverse_bandwidth = None
                        self.reverse_bandwidth_standby = None

                        self.reverse_ero_error_current = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"

                        self.reverse_ero_error_reopt = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"

                        self.reverse_ero_error_standby = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"

                        self.reverse_ero_error_standby_reopt = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._segment_path = lambda: "bidir"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir, ['reverse_bandwidth', 'reverse_bandwidth_standby'], name, value)


                    class ReverseEroErrorCurrent(_Entity_):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-current"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent']['meta_info']


                    class ReverseEroErrorReopt(_Entity_):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt']['meta_info']


                    class ReverseEroErrorStandby(_Entity_):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby']['meta_info']


                    class ReverseEroErrorStandbyReopt(_Entity_):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:  :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:  :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_id', (YLeaf(YType.uint16, 'reverse-lsp-id'), ['int'])),
                                ('path_reject_reason_bw', (YLeaf(YType.boolean, 'path-reject-reason-bw'), ['bool'])),
                                ('path_reject_reason_affinity', (YLeaf(YType.boolean, 'path-reject-reason-affinity'), ['bool'])),
                                ('path_reject_reason_ip_addr', (YLeaf(YType.boolean, 'path-reject-reason-ip-addr'), ['bool'])),
                                ('path_reject_reason_reverse_link', (YLeaf(YType.boolean, 'path-reject-reason-reverse-link'), ['bool'])),
                                ('path_reject_reason_ixcd', (YLeaf(YType.boolean, 'path-reject-reason-ixcd'), ['bool'])),
                                ('path_reject_reason_holddown', (YLeaf(YType.boolean, 'path-reject-reason-holddown'), ['bool'])),
                                ('path_reject_reason_exclude_node', (YLeaf(YType.boolean, 'path-reject-reason-exclude-node'), ['bool'])),
                                ('path_reject_reason_exclude_link', (YLeaf(YType.boolean, 'path-reject-reason-exclude-link'), ['bool'])),
                                ('path_reject_reason_exclude_srlg', (YLeaf(YType.boolean, 'path-reject-reason-exclude-srlg'), ['bool'])),
                                ('path_reject_reason_hop_limit', (YLeaf(YType.boolean, 'path-reject-reason-hop-limit'), ['bool'])),
                                ('path_reject_reason_node_ol_unknown', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-unknown'), ['bool'])),
                                ('path_reject_reason_node_ol_head', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-head'), ['bool'])),
                                ('path_reject_reason_node_ol_mid', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-mid'), ['bool'])),
                                ('path_reject_reason_node_ol_tail', (YLeaf(YType.boolean, 'path-reject-reason-node-ol-tail'), ['bool'])),
                                ('path_reject_reason_reverse_bw', (YLeaf(YType.boolean, 'path-reject-reason-reverse-bw'), ['bool'])),
                                ('path_reject_reason_node_unreachable', (YLeaf(YType.boolean, 'path-reject-reason-node-unreachable'), ['bool'])),
                                ('path_option_index', (YLeaf(YType.uint16, 'path-option-index'), ['int'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MtePathOption', '')])),
                                ('ero_reject_reason', (YLeaf(YType.enumeration, 'ero-reject-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRevEroRejectReasons', '')])),
                            ])
                            self.reverse_lsp_id = None
                            self.path_reject_reason_bw = None
                            self.path_reject_reason_affinity = None
                            self.path_reject_reason_ip_addr = None
                            self.path_reject_reason_reverse_link = None
                            self.path_reject_reason_ixcd = None
                            self.path_reject_reason_holddown = None
                            self.path_reject_reason_exclude_node = None
                            self.path_reject_reason_exclude_link = None
                            self.path_reject_reason_exclude_srlg = None
                            self.path_reject_reason_hop_limit = None
                            self.path_reject_reason_node_ol_unknown = None
                            self.path_reject_reason_node_ol_head = None
                            self.path_reject_reason_node_ol_mid = None
                            self.path_reject_reason_node_ol_tail = None
                            self.path_reject_reason_reverse_bw = None
                            self.path_reject_reason_node_unreachable = None
                            self.path_option_index = None
                            self.path_option_type = None
                            self.ero_reject_reason = None

                            self.path_calculation_error = YList(self)
                            self._segment_path = lambda: "reverse-ero-error-standby-reopt"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, ['reverse_lsp_id', 'path_reject_reason_bw', 'path_reject_reason_affinity', 'path_reject_reason_ip_addr', 'path_reject_reason_reverse_link', 'path_reject_reason_ixcd', 'path_reject_reason_holddown', 'path_reject_reason_exclude_node', 'path_reject_reason_exclude_link', 'path_reject_reason_exclude_srlg', 'path_reject_reason_hop_limit', 'path_reject_reason_node_ol_unknown', 'path_reject_reason_node_ol_head', 'path_reject_reason_node_ol_mid', 'path_reject_reason_node_ol_tail', 'path_reject_reason_reverse_bw', 'path_reject_reason_node_unreachable', 'path_option_index', 'path_option_type', 'ero_reject_reason'], name, value)


                        class PathCalculationError(_Entity_):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Bidir']['meta_info']


                class XroAttributeSet(_Entity_):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion))])
                        self._leafs = OrderedDict([
                            ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                            ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                        ])
                        self.tunnel_attribute_set_name = None
                        self.tunnel_attribute_set_name_crc32 = None

                        self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._segment_path = lambda: "xro-attribute-set"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                    class AttributeSetUnion(_Entity_):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                            self._leafs = OrderedDict([
                                ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                            ])
                            self.tunnel_attribute_set_type = None

                            self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                            self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                            self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                            self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                            self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                            self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                            self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._segment_path = lambda: "attribute-set-union"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                        class AttributeSetPathOption(_Entity_):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_delay_limit_configured
                            
                            	Is Delay Limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: delay_limit
                            
                            	Delay limit on the tunnel path (usec) When delay limit is configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                    ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                    ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                    ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                    ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                ])
                                self.configured_bandwidth = None
                                self.cost_limit = None
                                self.dste_class_type = None
                                self.bandwidth_type = None
                                self.is_bandwidth_configured = None
                                self.is_cost_limit_configured = None
                                self.is_affinity_configured = None
                                self.generation = None
                                self.path_invalidation_timeout = None
                                self.path_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.exclude_list_name = None
                                self.is_exclude_list_name_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None
                                self.is_bfd_reverse_pat_configured = None
                                self.is_delay_limit_configured = None
                                self.delay_limit = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)
                                self._segment_path = lambda: "attribute-set-path-option"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                            class BfdReversePath(_Entity_):
                                """
                                BFD reverse path
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                	**config**\: False
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                        ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                    ])
                                    self.path_type = None
                                    self.binding_label = None
                                    self._segment_path = lambda: "bfd-reverse-path"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                            class VersionInfo(_Entity_):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                        ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                        ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                    ])
                                    self.attribute_type = None
                                    self.generation = None
                                    self.is_default = None
                                    self._segment_path = lambda: "version-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                        class AttributeSetAutobackup(_Entity_):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            	**config**\: False
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            	**config**\: False
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                self._leafs = OrderedDict([
                                    ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                ])
                                self.is_signalled_name_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.is_affinity_configured = None
                                self.record_route = None

                                self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)
                                self.protected_interface = YList(self)
                                self._segment_path = lambda: "attribute-set-autobackup"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                            class SignalledName(_Entity_):
                                """
                                Signalled name
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                	**config**\: False
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                        ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                        ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                    ])
                                    self.name = None
                                    self.source_type = None
                                    self.protected_interface_type = None
                                    self.is_mp_addresses = None
                                    self._segment_path = lambda: "signalled-name"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                            class ProtectedInterface(_Entity_):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\: str
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                    ])
                                    self.protected_interface = None
                                    self._segment_path = lambda: "protected-interface"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                        class AttributeSetAutomesh(_Entity_):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_forward_class_configured
                            
                            	True if forward\-class is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                    ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                    ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                    ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                    ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                    ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                    ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                    ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                    ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                    ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                ])
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.policy_class = None
                                self.is_policyclass_configured = None
                                self.forward_class = None
                                self.is_forward_class_configured = None
                                self.is_affinity_configured = None
                                self.fast_reroute = None
                                self.frr_node_protection = None
                                self.frr_bandwidth_protection = None
                                self.record_route = None
                                self.auto_bandwidth_collect = None
                                self.auto_route_announce = None
                                self.soft_preemption_configured = None
                                self.bandwidth = None
                                self.load_share = None
                                self.is_interface_bw_configured = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.policy_class_entry = YList(self)
                                self.mesh_group_id = YList(self)
                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-automesh"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                            class PolicyClassEntry(_Entity_):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	PBTS policy classes
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "policy-class-entry"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                            class MeshGroupId(_Entity_):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	Meshgroup ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "mesh-group-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                        class AttributeSetXro(_Entity_):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                self._leafs = OrderedDict()

                                self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._segment_path = lambda: "attribute-set-xro"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                            class Xro(_Entity_):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                    self._leafs = OrderedDict([
                                        ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                    ])
                                    self.mutual_diversity_flag = None

                                    self.xro_subobject = YList(self)
                                    self._segment_path = lambda: "xro"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                class XroSubobject(_Entity_):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                        ])
                                        self.type = None

                                        self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                        self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                        self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                        self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"

                                        self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                        self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._segment_path = lambda: "xro-subobject"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                    class Ipv4Subobject(_Entity_):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv4-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                    class Ipv6Subobject(_Entity_):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\: str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.address = None
                                            self.prefix_len = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "ipv6-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                    class UnnumberedSubobject(_Entity_):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.te_router_id = None
                                            self.interface_id = None
                                            self.attribute = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "unnumbered-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                    class AsSubobject(_Entity_):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                            ])
                                            self.as_number = None
                                            self._segment_path = lambda: "as-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                    class SrlgSubobject(_Entity_):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.srlg_id = None
                                            self.exclusion_type = None
                                            self._segment_path = lambda: "srlg-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                    class LspSubobject(_Entity_):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                            self._leafs = OrderedDict([
                                                ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                            ])
                                            self.ignore_lsp_id = None
                                            self.processing_node_exception = None
                                            self.penultimate_node_exception = None
                                            self.destination_node_exception = None
                                            self.exclusion_type = None

                                            self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._segment_path = lambda: "lsp-subobject"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                        class Fec(_Entity_):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\: int
                                            
                                            	**range:** 0..65535
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\: str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\: str
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                self._leafs = OrderedDict([
                                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                ])
                                                self.fec_lsp_id = None
                                                self.fec_tunnel_id = None
                                                self.fec_extended_tunnel_id = None
                                                self.fec_source = None
                                                self.fec_vrf = None

                                                self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._segment_path = lambda: "fec"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                            class FecDestinationInfo(_Entity_):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                    ])
                                                    self.fec_ctype = None
                                                    self.p2p_lsp_destination = None
                                                    self.fec_destination_p2mp_id = None
                                                    self._segment_path = lambda: "fec-destination-info"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                        class AttributeSetP2mpte(_Entity_):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                    ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                    ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                    ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                    ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                    ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                    ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                    ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                ])
                                self.fast_reroute = None
                                self.frr_bandwidth_protection = None
                                self.setup_priority = None
                                self.hold_priority = None
                                self.is_priority_configured = None
                                self.configured_bandwidth = None
                                self.dste_class_type = None
                                self.is_bandwidth_configured = None
                                self.is_affinity_configured = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2mpte"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                        class AttributeSetApsPp(_Entity_):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            	**config**\: False
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            	**config**\: False
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            	**config**\: False
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            	**config**\: False
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                self._leafs = OrderedDict([
                                    ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                    ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                    ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                    ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                    ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                    ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                    ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                    ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                ])
                                self.snc_mode = None
                                self.tcm_id = None
                                self.protection_type = None
                                self.protection_mode = None
                                self.wait_to_restore_time = None
                                self.hold_off_time = None
                                self.path_prot_profile_type = None
                                self.restoration_style = None

                                self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._segment_path = lambda: "attribute-set-aps-pp"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                            class RevertSchedule(_Entity_):
                                """
                                Revert Schedule
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\: str
                                
                                	**length:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                	**config**\: False
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                        ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                        ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                        ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                    ])
                                    self.schedulename = None
                                    self.schedule_date = None
                                    self.schedule_frequency = None
                                    self.duration = None
                                    self.max_tries = None
                                    self._segment_path = lambda: "revert-schedule"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                        class AttributeSetP2pTe(_Entity_):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                            
                            	**config**\: False
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                            
                            	**config**\: False
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            	**config**\: False
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                self._leafs = OrderedDict([
                                    ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                    ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                    ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                    ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                    ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                    ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                    ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                    ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                    ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                    ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                    ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                    ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                    ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                    ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                    ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                    ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                    ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                    ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                    ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                    ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                    ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                    ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                    ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                    ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                    ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                    ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                    ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                ])
                                self.is_affinity_configured = None
                                self.path_selection_segment_routing_adjacency_protection = None
                                self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                self.path_invalidation_timeout = None
                                self.path_selection_invalidation_action = None
                                self.is_path_invalidation_timeout_configured = None
                                self.is_path_invalidation_action_configured = None
                                self.path_selection_metric = None
                                self.is_path_selection_metric_configured = None
                                self.path_selection_segment_routing_margin = None
                                self.is_path_selection_segment_routing_margin_relative = None
                                self.is_path_selection_segment_routing_margin_configured = None
                                self.path_selection_segment_routing_segment_limit = None
                                self.is_path_selection_segment_routing_segment_limit_configured = None
                                self.is_path_select_configured = None
                                self.is_prepend_list_configured = None
                                self.is_pce_configured = None
                                self.is_pce_disj_source_configured = None
                                self.is_pce_disj_type_configured = None
                                self.is_pce_disj_group_id_configured = None
                                self.pcedp_source_address = None
                                self.pcedp_type = None
                                self.pcedp_group_id = None
                                self.is_pceb_dj_source_configured = None
                                self.is_pcebd_group_id_configured = None
                                self.pcebd_source_address = None
                                self.pcebd_group_id = None

                                self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"

                                self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"

                                self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"

                                self.tunnel_id = YList(self)
                                self._segment_path = lambda: "attribute-set-p2p-te"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                            class Affinity(_Entity_):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                    self._leafs = OrderedDict([
                                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                    ])
                                    self.affinity_bits = None
                                    self.affinity_mask = None

                                    self.named_affinity = YList(self)
                                    self._segment_path = lambda: "affinity"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                class NamedAffinity(_Entity_):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                        self._leafs = OrderedDict([
                                            ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                            ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                            ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                        ])
                                        self.constraint_type = None
                                        self.constraint_value = None
                                        self.forward_ref_value = None

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)
                                        self._segment_path = lambda: "named-affinity"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                    class ConstraintExtendedValue(_Entity_):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	Constraint value
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "constraint-extended-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                    class ExtendedForwardRefValue(_Entity_):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	Reference bits for undefined affinity names
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "extended-forward-ref-value"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                            class Logging(_Entity_):
                                """
                                Logging attributes
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                        ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                        ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                        ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                        ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                        ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                        ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                        ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                    ])
                                    self.lsp_state = None
                                    self.s2l_state = None
                                    self.lsp_re_route = None
                                    self.lsp_re_opt = None
                                    self.lsp_insufficient_bw = None
                                    self.lsp_bandwidth_change = None
                                    self.lsp_pcalc_failure_logging_enabled = None
                                    self.all_logging_enabled = None
                                    self._segment_path = lambda: "logging"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                            class PrependList(_Entity_):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                    self._leafs = OrderedDict()

                                    self.prepend_entry = YList(self)
                                    self._segment_path = lambda: "prepend-list"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                class PrependEntry(_Entity_):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                            ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                            ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                        ])
                                        self.type = None
                                        self.index = None
                                        self.next_label = None
                                        self._segment_path = lambda: "prepend-entry"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                            class TunnelId(_Entity_):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	Tunnel ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "tunnel-id"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.XroAttributeSet']['meta_info']


                class TeTunnelConvergence(_Entity_):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:  :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\: int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**config**\: False
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("convergence-lsp", ("convergence_lsp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp))])
                        self._leafs = OrderedDict([
                            ('is_convergence_in_progress', (YLeaf(YType.boolean, 'is-convergence-in-progress'), ['bool'])),
                            ('frr_trigger_time', (YLeaf(YType.uint64, 'frr-trigger-time'), ['int'])),
                            ('pcalc_complete_time', (YLeaf(YType.uint64, 'pcalc-complete-time'), ['int'])),
                            ('convergence_complete_time', (YLeaf(YType.uint64, 'convergence-complete-time'), ['int'])),
                            ('binding_label_rewrite_time', (YLeaf(YType.uint64, 'binding-label-rewrite-time'), ['int'])),
                            ('vif_creation_time', (YLeaf(YType.uint64, 'vif-creation-time'), ['int'])),
                        ])
                        self.is_convergence_in_progress = None
                        self.frr_trigger_time = None
                        self.pcalc_complete_time = None
                        self.convergence_complete_time = None
                        self.binding_label_rewrite_time = None
                        self.vif_creation_time = None

                        self.convergence_lsp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._segment_path = lambda: "te-tunnel-convergence"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, ['is_convergence_in_progress', 'frr_trigger_time', 'pcalc_complete_time', 'convergence_complete_time', 'binding_label_rewrite_time', 'vif_creation_time'], name, value)


                    class ConvergenceLsp(_Entity_):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\: int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**config**\: False
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_in', (YLeaf(YType.uint64, 'path-in'), ['int'])),
                                ('path_out', (YLeaf(YType.uint64, 'path-out'), ['int'])),
                                ('resv_in', (YLeaf(YType.uint64, 'resv-in'), ['int'])),
                                ('resv_out', (YLeaf(YType.uint64, 'resv-out'), ['int'])),
                                ('label_rewrite', (YLeaf(YType.uint64, 'label-rewrite'), ['int'])),
                                ('tunnel_rewrite', (YLeaf(YType.uint64, 'tunnel-rewrite'), ['int'])),
                                ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                            ])
                            self.path_in = None
                            self.path_out = None
                            self.resv_in = None
                            self.resv_out = None
                            self.label_rewrite = None
                            self.tunnel_rewrite = None
                            self.creation_time = None
                            self._segment_path = lambda: "convergence-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, ['path_in', 'path_out', 'resv_in', 'resv_out', 'label_rewrite', 'tunnel_rewrite', 'creation_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence']['meta_info']


                class FlexInfo(_Entity_):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:  :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                            ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                            ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                            ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                            ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ('fault_in_label', (YLeaf(YType.uint32, 'fault-in-label'), ['int'])),
                            ('is_lockout', (YLeaf(YType.boolean, 'is-lockout'), ['bool'])),
                            ('lockout_timestamp', (YLeaf(YType.uint32, 'lockout-timestamp'), ['int'])),
                            ('lockout_lsp_id', (YLeaf(YType.uint16, 'lockout-lsp-id'), ['int'])),
                            ('origination', (YLeaf(YType.enumeration, 'origination'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'FlexLspLockoutOrigination', '')])),
                        ])
                        self.fault_ldi_lockout = None
                        self.fault_ldi = None
                        self.fault_lkr = None
                        self.fault_ais = None
                        self.fault_time = None
                        self.fault_in_label = None
                        self.is_lockout = None
                        self.lockout_timestamp = None
                        self.lockout_lsp_id = None
                        self.origination = None
                        self._segment_path = lambda: "flex-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo, ['fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time', 'fault_in_label', 'is_lockout', 'lockout_timestamp', 'lockout_lsp_id', 'origination'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.FlexInfo']['meta_info']


                class Destination(_Entity_):
                    """
                    Destinations array
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:  :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:  :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    	**config**\: False
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionCause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of  		 :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of  		 :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "tunnel-head"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("inter-area-reoptimization", ("inter_area_reoptimization", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization)), ("path-option-entry", ("path_option_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry)), ("path-option", ("path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('destination_state', (YLeaf(YType.enumeration, 'destination-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeDestinationState', '')])),
                            ('active_path_option_index', (YLeaf(YType.uint32, 'active-path-option-index'), ['int'])),
                            ('path_option_exhausted', (YLeaf(YType.boolean, 'path-option-exhausted'), ['bool'])),
                            ('uptime', (YLeaf(YType.uint32, 'uptime'), ['int'])),
                            ('path_change_time', (YLeaf(YType.uint32, 'path-change-time'), ['int'])),
                            ('total_uptime', (YLeaf(YType.uint32, 'total-uptime'), ['int'])),
                            ('s2l_exist', (YLeaf(YType.boolean, 's2l-exist'), ['bool'])),
                            ('destination_deletion_cause', (YLeaf(YType.enumeration, 'destination-deletion-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionCause', '')])),
                            ('destination_deletion_sub_cause', (YLeaf(YType.enumeration, 'destination-deletion-sub-cause'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ('destination_deletion_timestamp', (YLeaf(YType.uint32, 'destination-deletion-timestamp'), ['int'])),
                            ('is_inter_area', (YLeaf(YType.boolean, 'is-inter-area'), ['bool'])),
                        ])
                        self.destination_address = None
                        self.destination_state = None
                        self.active_path_option_index = None
                        self.path_option_exhausted = None
                        self.uptime = None
                        self.path_change_time = None
                        self.total_uptime = None
                        self.s2l_exist = None
                        self.destination_deletion_cause = None
                        self.destination_deletion_sub_cause = None
                        self.destination_deletion_timestamp = None
                        self.is_inter_area = None

                        self.inter_area_reoptimization = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"

                        self.path_option_entry = YList(self)
                        self.path_option = YList(self)
                        self._segment_path = lambda: "destination"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination, ['destination_address', 'destination_state', 'active_path_option_index', 'path_option_exhausted', 'uptime', 'path_change_time', 'total_uptime', 's2l_exist', 'destination_deletion_cause', 'destination_deletion_sub_cause', 'destination_deletion_timestamp', 'is_inter_area'], name, value)


                    class InterAreaReoptimization(_Entity_):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('sent_path_queries', (YLeaf(YType.uint16, 'sent-path-queries'), ['int'])),
                                ('time_since_last_query_sent', (YLeaf(YType.uint32, 'time-since-last-query-sent'), ['int'])),
                                ('received_preferred_path_errors', (YLeaf(YType.uint16, 'received-preferred-path-errors'), ['int'])),
                                ('time_since_last_preferred_path_error', (YLeaf(YType.uint32, 'time-since-last-preferred-path-error'), ['int'])),
                                ('received_preferred_tree_errors', (YLeaf(YType.uint16, 'received-preferred-tree-errors'), ['int'])),
                                ('time_since_last_preferred_tree_error', (YLeaf(YType.uint32, 'time-since-last-preferred-tree-error'), ['int'])),
                                ('preferred_path_error_node', (YLeaf(YType.str, 'preferred-path-error-node'), ['str'])),
                                ('preferred_tree_error_node', (YLeaf(YType.str, 'preferred-tree-error-node'), ['str'])),
                            ])
                            self.sent_path_queries = None
                            self.time_since_last_query_sent = None
                            self.received_preferred_path_errors = None
                            self.time_since_last_preferred_path_error = None
                            self.received_preferred_tree_errors = None
                            self.time_since_last_preferred_tree_error = None
                            self.preferred_path_error_node = None
                            self.preferred_tree_error_node = None
                            self._segment_path = lambda: "inter-area-reoptimization"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, ['sent_path_queries', 'time_since_last_query_sent', 'received_preferred_path_errors', 'time_since_last_preferred_path_error', 'received_preferred_tree_errors', 'time_since_last_preferred_tree_error', 'preferred_path_error_node', 'preferred_tree_error_node'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization']['meta_info']


                    class PathOptionEntry(_Entity_):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry']['meta_info']


                    class PathOption(_Entity_):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:  :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:  :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet>`
                        
                        	**config**\: False
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:  :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of  		 :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError>`
                        
                        	**config**\: False
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of  		 :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError>`
                        
                        	**config**\: False
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of  		 :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet)), ("xro-attribute-set", ("xro_attribute_set", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet)), ("path-calculation-error", ("path_calculation_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError)), ("remerge-error", ("remerge_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError)), ("signalling-error", ("signalling_error", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError))])
                            self._leafs = OrderedDict([
                                ('option_index_is_valid', (YLeaf(YType.boolean, 'option-index-is-valid'), ['bool'])),
                                ('option_index', (YLeaf(YType.uint32, 'option-index'), ['int'])),
                                ('path_option_name', (YLeaf(YType.str, 'path-option-name'), ['str'])),
                                ('path_option_type', (YLeaf(YType.enumeration, 'path-option-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathoption', '')])),
                                ('explicit_path_name', (YLeaf(YType.str, 'explicit-path-name'), ['str'])),
                                ('explicit_path_id', (YLeaf(YType.uint16, 'explicit-path-id'), ['int'])),
                                ('holddown_duration', (YLeaf(YType.uint16, 'holddown-duration'), ['int'])),
                                ('pce_address', (YLeaf(YType.str, 'pce-address'), ['str'])),
                                ('path_option_area_id', (YLeaf(YType.str, 'path-option-area-id'), ['str'])),
                                ('is_strict_explicit_path', (YLeaf(YType.boolean, 'is-strict-explicit-path'), ['bool'])),
                                ('is_helddown', (YLeaf(YType.boolean, 'is-helddown'), ['bool'])),
                                ('is_lockdown', (YLeaf(YType.boolean, 'is-lockdown'), ['bool'])),
                                ('is_verbatim', (YLeaf(YType.boolean, 'is-verbatim'), ['bool'])),
                                ('is_disabled', (YLeaf(YType.boolean, 'is-disabled'), ['bool'])),
                                ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                                ('attribute_set_found', (YLeaf(YType.boolean, 'attribute-set-found'), ['bool'])),
                                ('has_xro_attribute_set', (YLeaf(YType.boolean, 'has-xro-attribute-set'), ['bool'])),
                                ('xro_attribute_set_found', (YLeaf(YType.boolean, 'xro-attribute-set-found'), ['bool'])),
                                ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                                ('protected_by_path_option_index', (YLeaf(YType.uint32, 'protected-by-path-option-index'), ['int'])),
                                ('restored_from_path_option_index', (YLeaf(YType.uint32, 'restored-from-path-option-index'), ['int'])),
                            ])
                            self.option_index_is_valid = None
                            self.option_index = None
                            self.path_option_name = None
                            self.path_option_type = None
                            self.explicit_path_name = None
                            self.explicit_path_id = None
                            self.holddown_duration = None
                            self.pce_address = None
                            self.path_option_area_id = None
                            self.is_strict_explicit_path = None
                            self.is_helddown = None
                            self.is_lockdown = None
                            self.is_verbatim = None
                            self.is_disabled = None
                            self.has_attribute_set = None
                            self.attribute_set_found = None
                            self.has_xro_attribute_set = None
                            self.xro_attribute_set_found = None
                            self.is_segment_routing = None
                            self.protected_by_path_option_index = None
                            self.restored_from_path_option_index = None

                            self.attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"

                            self.xro_attribute_set = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)
                            self._segment_path = lambda: "path-option"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, ['option_index_is_valid', 'option_index', 'path_option_name', 'path_option_type', 'explicit_path_name', 'explicit_path_id', 'holddown_duration', 'pce_address', 'path_option_area_id', 'is_strict_explicit_path', 'is_helddown', 'is_lockdown', 'is_verbatim', 'is_disabled', 'has_attribute_set', 'attribute_set_found', 'has_xro_attribute_set', 'xro_attribute_set_found', 'is_segment_routing', 'protected_by_path_option_index', 'restored_from_path_option_index'], name, value)


                        class AttributeSet(_Entity_):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet']['meta_info']


                        class XroAttributeSet(_Entity_):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion))])
                                self._leafs = OrderedDict([
                                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                                ])
                                self.tunnel_attribute_set_name = None
                                self.tunnel_attribute_set_name_crc32 = None

                                self.attribute_set_union = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._segment_path = lambda: "xro-attribute-set"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, ['tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


                            class AttributeSetUnion(_Entity_):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                	**config**\: False
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                                    self._leafs = OrderedDict([
                                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                                    ])
                                    self.tunnel_attribute_set_type = None

                                    self.attribute_set_path_option = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                                    self.attribute_set_autobackup = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                                    self.attribute_set_automesh = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                                    self.attribute_set_xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                                    self.attribute_set_p2mpte = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                                    self.attribute_set_aps_pp = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                                    self.attribute_set_p2p_te = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._segment_path = lambda: "attribute-set-union"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                                class AttributeSetPathOption(_Entity_):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_delay_limit_configured
                                    
                                    	Is Delay Limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: delay_limit
                                    
                                    	Delay limit on the tunnel path (usec) When delay limit is configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.cost_limit = None
                                        self.dste_class_type = None
                                        self.bandwidth_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_cost_limit_configured = None
                                        self.is_affinity_configured = None
                                        self.generation = None
                                        self.path_invalidation_timeout = None
                                        self.path_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.exclude_list_name = None
                                        self.is_exclude_list_name_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None
                                        self.is_bfd_reverse_pat_configured = None
                                        self.is_delay_limit_configured = None
                                        self.delay_limit = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.bfd_reverse_path = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)
                                        self._segment_path = lambda: "attribute-set-path-option"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                                    class BfdReversePath(_Entity_):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                                            ])
                                            self.path_type = None
                                            self.binding_label = None
                                            self._segment_path = lambda: "bfd-reverse-path"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                                    class VersionInfo(_Entity_):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                                            ])
                                            self.attribute_type = None
                                            self.generation = None
                                            self.is_default = None
                                            self._segment_path = lambda: "version-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                                class AttributeSetAutobackup(_Entity_):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                                        self._leafs = OrderedDict([
                                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                        ])
                                        self.is_signalled_name_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.is_affinity_configured = None
                                        self.record_route = None

                                        self.signalled_name = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)
                                        self.protected_interface = YList(self)
                                        self._segment_path = lambda: "attribute-set-autobackup"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                                    class SignalledName(_Entity_):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                                            ])
                                            self.name = None
                                            self.source_type = None
                                            self.protected_interface_type = None
                                            self.is_mp_addresses = None
                                            self._segment_path = lambda: "signalled-name"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                                    class ProtectedInterface(_Entity_):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\: str
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                                            ])
                                            self.protected_interface = None
                                            self._segment_path = lambda: "protected-interface"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                                class AttributeSetAutomesh(_Entity_):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_forward_class_configured
                                    
                                    	True if forward\-class is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                                        ])
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.policy_class = None
                                        self.is_policyclass_configured = None
                                        self.forward_class = None
                                        self.is_forward_class_configured = None
                                        self.is_affinity_configured = None
                                        self.fast_reroute = None
                                        self.frr_node_protection = None
                                        self.frr_bandwidth_protection = None
                                        self.record_route = None
                                        self.auto_bandwidth_collect = None
                                        self.auto_route_announce = None
                                        self.soft_preemption_configured = None
                                        self.bandwidth = None
                                        self.load_share = None
                                        self.is_interface_bw_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.policy_class_entry = YList(self)
                                        self.mesh_group_id = YList(self)
                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-automesh"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                                    class PolicyClassEntry(_Entity_):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	PBTS policy classes
                                        	**type**\: int
                                        
                                        	**range:** 0..255
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "policy-class-entry"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                                    class MeshGroupId(_Entity_):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	Meshgroup ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "mesh-group-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                                class AttributeSetXro(_Entity_):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                                        self._leafs = OrderedDict()

                                        self.xro = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._segment_path = lambda: "attribute-set-xro"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                                    class Xro(_Entity_):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                                            self._leafs = OrderedDict([
                                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                                            ])
                                            self.mutual_diversity_flag = None

                                            self.xro_subobject = YList(self)
                                            self._segment_path = lambda: "xro"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                                        class XroSubobject(_Entity_):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                                ])
                                                self.type = None

                                                self.ipv4_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                                self.ipv6_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                                self.unnumbered_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                                self.as_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"

                                                self.srlg_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                                self.lsp_subobject = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._segment_path = lambda: "xro-subobject"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                                            class Ipv4Subobject(_Entity_):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv4-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                                            class Ipv6Subobject(_Entity_):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\: str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\: int
                                                
                                                	**range:** 0..255
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.address = None
                                                    self.prefix_len = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "ipv6-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                                            class UnnumberedSubobject(_Entity_):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\: str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.te_router_id = None
                                                    self.interface_id = None
                                                    self.attribute = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "unnumbered-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                                            class AsSubobject(_Entity_):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\: int
                                                
                                                	**range:** 0..65535
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                                    ])
                                                    self.as_number = None
                                                    self._segment_path = lambda: "as-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                                            class SrlgSubobject(_Entity_):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.srlg_id = None
                                                    self.exclusion_type = None
                                                    self._segment_path = lambda: "srlg-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                                            class LspSubobject(_Entity_):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\: bool
                                                
                                                	**config**\: False
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                                    self._leafs = OrderedDict([
                                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                                    ])
                                                    self.ignore_lsp_id = None
                                                    self.processing_node_exception = None
                                                    self.penultimate_node_exception = None
                                                    self.destination_node_exception = None
                                                    self.exclusion_type = None

                                                    self.fec = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._segment_path = lambda: "lsp-subobject"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                                class Fec(_Entity_):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\: int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\: str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    	**config**\: False
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\: str
                                                    
                                                    	**config**\: False
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2018-08-01'

                                                    def __init__(self):
                                                        if sys.version_info > (3,):
                                                            super().__init__()
                                                        else:
                                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self.ylist_key_names = []
                                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                                        self._leafs = OrderedDict([
                                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                                        ])
                                                        self.fec_lsp_id = None
                                                        self.fec_tunnel_id = None
                                                        self.fec_extended_tunnel_id = None
                                                        self.fec_source = None
                                                        self.fec_vrf = None

                                                        self.fec_destination_info = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._segment_path = lambda: "fec"
                                                        self._is_frozen = True

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                                    class FecDestinationInfo(_Entity_):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\: str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        	**config**\: False
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\: int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**config**\: False
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2018-08-01'

                                                        def __init__(self):
                                                            if sys.version_info > (3,):
                                                                super().__init__()
                                                            else:
                                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self.ylist_key_names = []
                                                            self._child_classes = OrderedDict([])
                                                            self._leafs = OrderedDict([
                                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                                            ])
                                                            self.fec_ctype = None
                                                            self.p2p_lsp_destination = None
                                                            self.fec_destination_p2mp_id = None
                                                            self._segment_path = lambda: "fec-destination-info"
                                                            self._is_frozen = True

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                                        @staticmethod
                                                        def _meta_info():
                                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                                    @staticmethod
                                                    def _meta_info():
                                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                                class AttributeSetP2mpte(_Entity_):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\: int
                                    
                                    	**range:** 0..255
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                        ])
                                        self.fast_reroute = None
                                        self.frr_bandwidth_protection = None
                                        self.setup_priority = None
                                        self.hold_priority = None
                                        self.is_priority_configured = None
                                        self.configured_bandwidth = None
                                        self.dste_class_type = None
                                        self.is_bandwidth_configured = None
                                        self.is_affinity_configured = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2mpte"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                                class AttributeSetApsPp(_Entity_):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                                        self._leafs = OrderedDict([
                                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                                        ])
                                        self.snc_mode = None
                                        self.tcm_id = None
                                        self.protection_type = None
                                        self.protection_mode = None
                                        self.wait_to_restore_time = None
                                        self.hold_off_time = None
                                        self.path_prot_profile_type = None
                                        self.restoration_style = None

                                        self.revert_schedule = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._segment_path = lambda: "attribute-set-aps-pp"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                                    class RevertSchedule(_Entity_):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\: str
                                        
                                        	**length:** 0..255
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                                            ])
                                            self.schedulename = None
                                            self.schedule_date = None
                                            self.schedule_frequency = None
                                            self.duration = None
                                            self.max_tries = None
                                            self._segment_path = lambda: "revert-schedule"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                                class AttributeSetP2pTe(_Entity_):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\: bool
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                                        self._leafs = OrderedDict([
                                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                                        ])
                                        self.is_affinity_configured = None
                                        self.path_selection_segment_routing_adjacency_protection = None
                                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                                        self.path_invalidation_timeout = None
                                        self.path_selection_invalidation_action = None
                                        self.is_path_invalidation_timeout_configured = None
                                        self.is_path_invalidation_action_configured = None
                                        self.path_selection_metric = None
                                        self.is_path_selection_metric_configured = None
                                        self.path_selection_segment_routing_margin = None
                                        self.is_path_selection_segment_routing_margin_relative = None
                                        self.is_path_selection_segment_routing_margin_configured = None
                                        self.path_selection_segment_routing_segment_limit = None
                                        self.is_path_selection_segment_routing_segment_limit_configured = None
                                        self.is_path_select_configured = None
                                        self.is_prepend_list_configured = None
                                        self.is_pce_configured = None
                                        self.is_pce_disj_source_configured = None
                                        self.is_pce_disj_type_configured = None
                                        self.is_pce_disj_group_id_configured = None
                                        self.pcedp_source_address = None
                                        self.pcedp_type = None
                                        self.pcedp_group_id = None
                                        self.is_pceb_dj_source_configured = None
                                        self.is_pcebd_group_id_configured = None
                                        self.pcebd_source_address = None
                                        self.pcebd_group_id = None

                                        self.affinity = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"

                                        self.logging = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"

                                        self.prepend_list = MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"

                                        self.tunnel_id = YList(self)
                                        self._segment_path = lambda: "attribute-set-p2p-te"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                                    class Affinity(_Entity_):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                                            self._leafs = OrderedDict([
                                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                                            ])
                                            self.affinity_bits = None
                                            self.affinity_mask = None

                                            self.named_affinity = YList(self)
                                            self._segment_path = lambda: "affinity"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                                        class NamedAffinity(_Entity_):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\: int
                                            
                                            	**range:** 0..255
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                                self._leafs = OrderedDict([
                                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                                ])
                                                self.constraint_type = None
                                                self.constraint_value = None
                                                self.forward_ref_value = None

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)
                                                self._segment_path = lambda: "named-affinity"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                                            class ConstraintExtendedValue(_Entity_):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	Constraint value
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "constraint-extended-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                                            class ExtendedForwardRefValue(_Entity_):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**config**\: False
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2018-08-01'

                                                def __init__(self):
                                                    if sys.version_info > (3,):
                                                        super().__init__()
                                                    else:
                                                        super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self.ylist_key_names = []
                                                    self._child_classes = OrderedDict([])
                                                    self._leafs = OrderedDict([
                                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                                    ])
                                                    self.entry = None
                                                    self._segment_path = lambda: "extended-forward-ref-value"
                                                    self._is_frozen = True

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                                @staticmethod
                                                def _meta_info():
                                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                                    class Logging(_Entity_):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\: bool
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                                            ])
                                            self.lsp_state = None
                                            self.s2l_state = None
                                            self.lsp_re_route = None
                                            self.lsp_re_opt = None
                                            self.lsp_insufficient_bw = None
                                            self.lsp_bandwidth_change = None
                                            self.lsp_pcalc_failure_logging_enabled = None
                                            self.all_logging_enabled = None
                                            self._segment_path = lambda: "logging"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                                    class PrependList(_Entity_):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                                            self._leafs = OrderedDict()

                                            self.prepend_entry = YList(self)
                                            self._segment_path = lambda: "prepend-list"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                                        class PrependEntry(_Entity_):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\: int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**config**\: False
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2018-08-01'

                                            def __init__(self):
                                                if sys.version_info > (3,):
                                                    super().__init__()
                                                else:
                                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self.ylist_key_names = []
                                                self._child_classes = OrderedDict([])
                                                self._leafs = OrderedDict([
                                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                                ])
                                                self.type = None
                                                self.index = None
                                                self.next_label = None
                                                self._segment_path = lambda: "prepend-entry"
                                                self._is_frozen = True

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                                            @staticmethod
                                            def _meta_info():
                                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                                    class TunnelId(_Entity_):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	Tunnel ID
                                        	**type**\: int
                                        
                                        	**range:** 0..65535
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                                            ])
                                            self.entry = None
                                            self._segment_path = lambda: "tunnel-id"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet']['meta_info']


                        class PathCalculationError(_Entity_):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "path-calculation-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError']['meta_info']


                        class RemergeError(_Entity_):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                ])
                                self.error_message = None
                                self.lsp_mode = None
                                self.log_time = None
                                self._segment_path = lambda: "remerge-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, ['error_message', 'lsp_mode', 'log_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError']['meta_info']


                        class SignallingError(_Entity_):
                            """
                            Signalling information
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            	**config**\: False
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('error_node', (YLeaf(YType.uint32, 'error-node'), ['int'])),
                                    ('error', (YLeaf(YType.uint8, 'error'), ['int'])),
                                    ('sub_code', (YLeaf(YType.uint16, 'sub-code'), ['int'])),
                                    ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                                    ('log_time', (YLeaf(YType.uint32, 'log-time'), ['int'])),
                                    ('signalling_lsp_id', (YLeaf(YType.uint16, 'signalling-lsp-id'), ['int'])),
                                    ('error_message', (YLeaf(YType.str, 'error-message'), ['str'])),
                                    ('reverse_lsp', (YLeaf(YType.boolean, 'reverse-lsp'), ['bool'])),
                                ])
                                self.error_node = None
                                self.error = None
                                self.sub_code = None
                                self.lsp_mode = None
                                self.log_time = None
                                self.signalling_lsp_id = None
                                self.error_message = None
                                self.reverse_lsp = None
                                self._segment_path = lambda: "signalling-error"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, ['error_node', 'error', 'sub_code', 'lsp_mode', 'log_time', 'signalling_lsp_id', 'error_message', 'reverse_lsp'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination.PathOption']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead.Destination']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads.TunnelHead']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2pP2mpTunnel.TunnelHeads']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.P2pP2mpTunnel']['meta_info']


    class TopologyNodes(_Entity_):
        """
        A node in the MPLS\-TE topology
        
        .. attribute:: topology_node
        
        	A node in the MPLS\-TE topology
        	**type**\: list of  		 :py:class:`TopologyNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.TopologyNodes, self).__init__()

            self.yang_name = "topology-nodes"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("topology-node", ("topology_node", MplsTeStandby.TopologyNodes.TopologyNode))])
            self._leafs = OrderedDict()

            self.topology_node = YList(self)
            self._segment_path = lambda: "topology-nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.TopologyNodes, [], name, value)


        class TopologyNode(_Entity_):
            """
            A node in the MPLS\-TE topology
            
            .. attribute:: protocol  (key)
            
            	IGP protocol type
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: igp_id  (key)
            
            	IGP instance
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: area  (key)
            
            	IGP area
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: topology_node_type  (key)
            
            	Node type
            	**type**\:  :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            	**config**\: False
            
            .. attribute:: igp_node_id  (key)
            
            	IGP Node ID
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:  :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg>`
            
            	**config**\: False
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of  		 :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.TopologyNodes.TopologyNode, self).__init__()

                self.yang_name = "topology-node"
                self.yang_parent_name = "topology-nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','igp_id','area','topology_node_type','igp_node_id']
                self._child_classes = OrderedDict([("topology-node-sid-and-srbg", ("topology_node_sid_and_srbg", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg)), ("topology-node-link", ("topology_node_link", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                    ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                    ('topology_node_type', (YLeaf(YType.enumeration, 'topology-node-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeNode', '')])),
                    ('igp_node_id', (YLeaf(YType.str, 'igp-node-id'), ['str'])),
                    ('topology_node_te_router_id', (YLeaf(YType.str, 'topology-node-te-router-id'), ['str'])),
                    ('topology_node_overloaded', (YLeaf(YType.boolean, 'topology-node-overloaded'), ['bool'])),
                ])
                self.protocol = None
                self.igp_id = None
                self.area = None
                self.topology_node_type = None
                self.igp_node_id = None
                self.topology_node_te_router_id = None
                self.topology_node_overloaded = None

                self.topology_node_sid_and_srbg = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"

                self.topology_node_link = YList(self)
                self._segment_path = lambda: "topology-node" + "[protocol='" + str(self.protocol) + "']" + "[igp-id='" + str(self.igp_id) + "']" + "[area='" + str(self.area) + "']" + "[topology-node-type='" + str(self.topology_node_type) + "']" + "[igp-node-id='" + str(self.igp_node_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology-nodes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode, ['protocol', 'igp_id', 'area', 'topology_node_type', 'igp_node_id', 'topology_node_te_router_id', 'topology_node_overloaded'], name, value)


            class TopologyNodeSidAndSrbg(_Entity_):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                        ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                        ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                        ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                    ])
                    self.segment_id = None
                    self.segment_id_local_absolute_value = None
                    self.srgb_start = None
                    self.srgb_size = None
                    self._segment_path = lambda: "topology-node-sid-and-srbg"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg']['meta_info']


            class TopologyNodeLink(_Entity_):
                """
                This node's link information
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:  :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth>`
                
                	**config**\: False
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: min_max_delay
                
                	Minimum and maximum measured link delay
                	**type**\:  :py:class:`MinMaxDelay <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay>`
                
                	**config**\: False
                
                .. attribute:: loss
                
                	Link Loss
                	**type**\:  :py:class:`Loss <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss>`
                
                	**config**\: False
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:  :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                	**config**\: False
                
                .. attribute:: delay_variation
                
                	Delay Variation
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: residual_bandwidth
                
                	Residual Bandwidth (kbytes per seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Available Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: utilized_bandwidth
                
                	Utilized Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of  		 :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of  		 :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("topology-link-bandwidth", ("topology_link_bandwidth", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth)), ("odu-link-capabilities", ("odu_link_capabilities", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities)), ("min-max-delay", ("min_max_delay", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay)), ("loss", ("loss", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss)), ("topology-link-extended-affinity-bit", ("topology_link_extended_affinity_bit", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup)), ("adjacency-sid", ("adjacency_sid", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid))])
                    self._leafs = OrderedDict([
                        ('topology_link_type', (YLeaf(YType.enumeration, 'topology-link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('topology_link_interface_address', (YLeaf(YType.str, 'topology-link-interface-address'), ['str'])),
                        ('topology_link_interface_id', (YLeaf(YType.uint32, 'topology-link-interface-id'), ['int'])),
                        ('topology_link_neighbor_address', (YLeaf(YType.str, 'topology-link-neighbor-address'), ['str'])),
                        ('topology_link_neighbor_id', (YLeaf(YType.uint32, 'topology-link-neighbor-id'), ['int'])),
                        ('topology_link_neighbor_system_id', (YLeaf(YType.str, 'topology-link-neighbor-system-id'), ['str'])),
                        ('topology_link_neighbor_node_id', (YLeaf(YType.uint32, 'topology-link-neighbor-node-id'), ['int'])),
                        ('topology_link_neighbor_generation', (YLeaf(YType.uint32, 'topology-link-neighbor-generation'), ['int'])),
                        ('topology_link_fragment_id', (YLeaf(YType.uint32, 'topology-link-fragment-id'), ['int'])),
                        ('topology_link_te_metric', (YLeaf(YType.uint32, 'topology-link-te-metric'), ['int'])),
                        ('topology_link_igp_metric', (YLeaf(YType.uint32, 'topology-link-igp-metric'), ['int'])),
                        ('topology_link_uni_delay', (YLeaf(YType.uint32, 'topology-link-uni-delay'), ['int'])),
                        ('topology_link_affinity_bits', (YLeaf(YType.uint32, 'topology-link-affinity-bits'), ['int'])),
                        ('topology_link_switching_capability', (YLeaf(YType.uint8, 'topology-link-switching-capability'), ['int'])),
                        ('topology_link_encoding', (YLeaf(YType.uint8, 'topology-link-encoding'), ['int'])),
                        ('topology_link_bandwidth_model', (YLeaf(YType.enumeration, 'topology-link-bandwidth-model'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLibBwModel', '')])),
                        ('delay_variation', (YLeaf(YType.uint32, 'delay-variation'), ['int'])),
                        ('residual_bandwidth', (YLeaf(YType.uint32, 'residual-bandwidth'), ['int'])),
                        ('available_bandwidth', (YLeaf(YType.uint32, 'available-bandwidth'), ['int'])),
                        ('utilized_bandwidth', (YLeaf(YType.uint32, 'utilized-bandwidth'), ['int'])),
                    ])
                    self.topology_link_type = None
                    self.topology_link_interface_address = None
                    self.topology_link_interface_id = None
                    self.topology_link_neighbor_address = None
                    self.topology_link_neighbor_id = None
                    self.topology_link_neighbor_system_id = None
                    self.topology_link_neighbor_node_id = None
                    self.topology_link_neighbor_generation = None
                    self.topology_link_fragment_id = None
                    self.topology_link_te_metric = None
                    self.topology_link_igp_metric = None
                    self.topology_link_uni_delay = None
                    self.topology_link_affinity_bits = None
                    self.topology_link_switching_capability = None
                    self.topology_link_encoding = None
                    self.topology_link_bandwidth_model = None
                    self.delay_variation = None
                    self.residual_bandwidth = None
                    self.available_bandwidth = None
                    self.utilized_bandwidth = None

                    self.topology_link_bandwidth = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"

                    self.odu_link_capabilities = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.min_max_delay = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay()
                    self.min_max_delay.parent = self
                    self._children_name_map["min_max_delay"] = "min-max-delay"

                    self.loss = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss()
                    self.loss.parent = self
                    self._children_name_map["loss"] = "loss"

                    self.topology_link_extended_affinity_bit = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.adjacency_sid = YList(self)
                    self._segment_path = lambda: "topology-node-link"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink, ['topology_link_type', 'topology_link_interface_address', 'topology_link_interface_id', 'topology_link_neighbor_address', 'topology_link_neighbor_id', 'topology_link_neighbor_system_id', 'topology_link_neighbor_node_id', 'topology_link_neighbor_generation', 'topology_link_fragment_id', 'topology_link_te_metric', 'topology_link_igp_metric', 'topology_link_uni_delay', 'topology_link_affinity_bits', 'topology_link_switching_capability', 'topology_link_encoding', 'topology_link_bandwidth_model', 'delay_variation', 'residual_bandwidth', 'available_bandwidth', 'utilized_bandwidth'], name, value)


                class TopologyLinkBandwidth(_Entity_):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("topology-link-bandwidth-prestandard", ("topology_link_bandwidth_prestandard", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard)), ("topology-link-bandwidth-standard", ("topology_link_bandwidth_standard", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard))])
                        self._leafs = OrderedDict([
                            ('bandwidth_migration_mode', (YLeaf(YType.enumeration, 'bandwidth-migration-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.bandwidth_migration_mode = None

                        self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"

                        self.topology_link_bandwidth_standard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._segment_path = lambda: "topology-link-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, ['bandwidth_migration_mode'], name, value)


                    class TopologyLinkBandwidthPrestandard(_Entity_):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-detail", ("topology_link_prestandard_bandwidth_detail", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail))])
                            self._leafs = OrderedDict([
                                ('topology_link_prestandard_bandwidth_physical', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-physical'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_global', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-global'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_subpool', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-subpool'), ['int'])),
                            ])
                            self.topology_link_prestandard_bandwidth_physical = None
                            self.topology_link_prestandard_bandwidth_reservation_global = None
                            self.topology_link_prestandard_bandwidth_reservation_subpool = None

                            self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-prestandard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, ['topology_link_prestandard_bandwidth_physical', 'topology_link_prestandard_bandwidth_reservation_global', 'topology_link_prestandard_bandwidth_reservation_subpool'], name, value)


                        class TopologyLinkPrestandardBandwidthDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-allocated", ("topology_link_prestandard_bandwidth_allocated", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated)), ("topology-link-prestandard-bandwidth-available-global", ("topology_link_prestandard_bandwidth_available_global", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal)), ("topology-link-prestandard-bandwidth-available-subpool", ("topology_link_prestandard_bandwidth_available_subpool", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool))])
                                self._leafs = OrderedDict()

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)
                                self._segment_path = lambda: "topology-link-prestandard-bandwidth-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, [], name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(_Entity_):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(_Entity_):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-global"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(_Entity_):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-subpool"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard']['meta_info']


                    class TopologyLinkBandwidthStandard(_Entity_):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topo-link-std-bw-detail", ("topo_link_std_bw_detail", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail))])
                            self._leafs = OrderedDict([
                                ('topo_link_std_bw_physical', (YLeaf(YType.uint32, 'topo-link-std-bw-physical'), ['int'])),
                                ('topo_link_std_bw_res_max', (YLeaf(YType.uint32, 'topo-link-std-bw-res-max'), ['int'])),
                                ('topo_link_std_bw_res_pool0', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool0'), ['int'])),
                                ('topo_link_std_bw_res_pool1', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool1'), ['int'])),
                            ])
                            self.topo_link_std_bw_physical = None
                            self.topo_link_std_bw_res_max = None
                            self.topo_link_std_bw_res_pool0 = None
                            self.topo_link_std_bw_res_pool1 = None

                            self.topo_link_std_bw_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-standard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, ['topo_link_std_bw_physical', 'topo_link_std_bw_res_max', 'topo_link_std_bw_res_pool0', 'topo_link_std_bw_res_pool1'], name, value)


                        class TopoLinkStdBwDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topo-link-std-bw-allocated", ("topo_link_std_bw_allocated", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated)), ("topo-link-std-bw-available", ("topo_link_std_bw_available", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable))])
                                self._leafs = OrderedDict()

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)
                                self._segment_path = lambda: "topo-link-std-bw-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, [], name, value)


                            class TopoLinkStdBwAllocated(_Entity_):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated']['meta_info']


                            class TopoLinkStdBwAvailable(_Entity_):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's available bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-available"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth']['meta_info']


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities']['meta_info']


                class MinMaxDelay(_Entity_):
                    """
                    Minimum and maximum measured link delay
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_delay
                    
                    	Mimimum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_delay
                    
                    	Maximum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay, self).__init__()

                        self.yang_name = "min-max-delay"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('minimum_delay', (YLeaf(YType.uint32, 'minimum-delay'), ['int'])),
                            ('maximum_delay', (YLeaf(YType.uint32, 'maximum-delay'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.minimum_delay = None
                        self.maximum_delay = None
                        self._segment_path = lambda: "min-max-delay"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay, ['anomalous_bit', 'minimum_delay', 'maximum_delay'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.MinMaxDelay']['meta_info']


                class Loss(_Entity_):
                    """
                    Link Loss
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: loss_value
                    
                    	Loss Value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss, self).__init__()

                        self.yang_name = "loss"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('loss_value', (YLeaf(YType.uint32, 'loss-value'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.loss_value = None
                        self._segment_path = lambda: "loss"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss, ['anomalous_bit', 'loss_value'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.Loss']['meta_info']


                class TopologyLinkExtendedAffinityBit(_Entity_):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	The link's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "topology-link-extended-affinity-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup']['meta_info']


                class AdjacencySid(_Entity_):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('adjacency_sid', (YLeaf(YType.uint32, 'adjacency-sid'), ['int'])),
                            ('link_type', (YLeaf(YType.enumeration, 'link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('nbr_node_igpid', (YLeaf(YType.str, 'nbr-node-igpid'), ['str'])),
                            ('nbr_node_te_router_id', (YLeaf(YType.str, 'nbr-node-te-router-id'), ['str'])),
                            ('flag_f', (YLeaf(YType.boolean, 'flag-f'), ['bool'])),
                            ('flag_b', (YLeaf(YType.boolean, 'flag-b'), ['bool'])),
                            ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                            ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                            ('flag_s', (YLeaf(YType.boolean, 'flag-s'), ['bool'])),
                        ])
                        self.adjacency_sid = None
                        self.link_type = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.nbr_node_igpid = None
                        self.nbr_node_te_router_id = None
                        self.flag_f = None
                        self.flag_b = None
                        self.flag_v = None
                        self.flag_l = None
                        self.flag_s = None
                        self._segment_path = lambda: "adjacency-sid"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, ['adjacency_sid', 'link_type', 'local_addr', 'remote_addr', 'nbr_node_igpid', 'nbr_node_te_router_id', 'flag_f', 'flag_b', 'flag_v', 'flag_l', 'flag_s'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.TopologyNodes.TopologyNode']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.TopologyNodes']['meta_info']


    class AnnounceTunnelsInfo(_Entity_):
        """
        Announced tunnels (forwarding adjacency and
        autoroute annonce)
        
        .. attribute:: autoroute_announce_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:  :py:class:`AutorouteAnnounceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable>`
        
        	**config**\: False
        
        .. attribute:: all_autoroute_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:  :py:class:`AllAutorouteTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AnnounceTunnelsInfo, self).__init__()

            self.yang_name = "announce-tunnels-info"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("autoroute-announce-table", ("autoroute_announce_table", MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable)), ("all-autoroute-table", ("all_autoroute_table", MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable))])
            self._leafs = OrderedDict()

            self.autoroute_announce_table = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable()
            self.autoroute_announce_table.parent = self
            self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"

            self.all_autoroute_table = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable()
            self.all_autoroute_table.parent = self
            self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
            self._segment_path = lambda: "announce-tunnels-info"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo, [], name, value)


        class AutorouteAnnounceTable(_Entity_):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of  		 :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__init__()

                self.yang_name = "autoroute-announce-table"
                self.yang_parent_name = "announce-tunnels-info"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("announce-dest", ("announce_dest", MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest))])
                self._leafs = OrderedDict()

                self.announce_dest = YList(self)
                self._segment_path = lambda: "autoroute-announce-table"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable, [], name, value)


            class AnnounceDest(_Entity_):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: protocol  (key)
                
                	The IGP protocol used by the tunnel
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_id  (key)
                
                	IGP Instance ID
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of  		 :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "autoroute-announce-table"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['destination_address','protocol','area','igp_id']
                    self._child_classes = OrderedDict([("total-tunnel", ("total_tunnel", MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('destination', (YLeaf(YType.str, 'destination'), ['str'])),
                        ('announced_tunnels_count', (YLeaf(YType.uint16, 'announced-tunnels-count'), ['int'])),
                        ('autorouted_tunnels_count', (YLeaf(YType.uint16, 'autorouted-tunnels-count'), ['int'])),
                        ('forwarding_adjacency_tunnels_count', (YLeaf(YType.uint16, 'forwarding-adjacency-tunnels-count'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                    ])
                    self.destination_address = None
                    self.protocol = None
                    self.area = None
                    self.igp_id = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.destination = None
                    self.announced_tunnels_count = None
                    self.autorouted_tunnels_count = None
                    self.forwarding_adjacency_tunnels_count = None
                    self.area_format = None

                    self.total_tunnel = YList(self)
                    self._segment_path = lambda: "announce-dest" + "[destination-address='" + str(self.destination_address) + "']" + "[protocol='" + str(self.protocol) + "']" + "[area='" + str(self.area) + "']" + "[igp-id='" + str(self.igp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/autoroute-announce-table/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, ['destination_address', 'protocol', 'area', 'igp_id', 'igp_type', 'igp_instance', 'igp_area', 'destination', 'announced_tunnels_count', 'autorouted_tunnels_count', 'forwarding_adjacency_tunnels_count', 'area_format'], name, value)


                class TotalTunnel(_Entity_):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:  :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:  :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                            ('tunnel_loadshare', (YLeaf(YType.uint32, 'tunnel-loadshare'), ['int'])),
                            ('announce_type', (YLeaf(YType.enumeration, 'announce-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelAnnounce', '')])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteAaMetricMode', '')])),
                            ('igp_metric', (YLeaf(YType.int32, 'igp-metric'), ['int'])),
                            ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                            ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                            ('is_auto_mesh_aa', (YLeaf(YType.boolean, 'is-auto-mesh-aa'), ['bool'])),
                            ('is_sr', (YLeaf(YType.boolean, 'is-sr'), ['bool'])),
                            ('is_sr_strict', (YLeaf(YType.boolean, 'is-sr-strict'), ['bool'])),
                            ('mesh_group_idaa', (YLeaf(YType.uint32, 'mesh-group-idaa'), ['int'])),
                            ('is_exclude_segment_routing', (YLeaf(YType.boolean, 'is-exclude-segment-routing'), ['bool'])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_sig_name = None
                        self.tunnel_loadshare = None
                        self.announce_type = None
                        self.next_hop_address = None
                        self.mode = None
                        self.igp_metric = None
                        self.hold_time = None
                        self.area_format = None
                        self.is_auto_mesh_aa = None
                        self.is_sr = None
                        self.is_sr_strict = None
                        self.mesh_group_idaa = None
                        self.is_exclude_segment_routing = None

                        self.ig_ps = YList(self)
                        self._segment_path = lambda: "total-tunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, ['tunnel_name', 'tunnel_sig_name', 'tunnel_loadshare', 'announce_type', 'next_hop_address', 'mode', 'igp_metric', 'hold_time', 'area_format', 'is_auto_mesh_aa', 'is_sr', 'is_sr_strict', 'mesh_group_idaa', 'is_exclude_segment_routing'], name, value)


                    class IgPs(_Entity_):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ])
                            self.igp_area_id = None
                            self.afi = None
                            self._segment_path = lambda: "ig-ps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, ['igp_area_id', 'afi'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable']['meta_info']


        class AllAutorouteTable(_Entity_):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of  		 :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable, self).__init__()

                self.yang_name = "all-autoroute-table"
                self.yang_parent_name = "announce-tunnels-info"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("announce-dest", ("announce_dest", MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest))])
                self._leafs = OrderedDict()

                self.announce_dest = YList(self)
                self._segment_path = lambda: "all-autoroute-table"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable, [], name, value)


            class AnnounceDest(_Entity_):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: protocol  (key)
                
                	The IGP protocol used by the tunnel
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: area  (key)
                
                	Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: igp_id  (key)
                
                	IGP Instance ID
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of  		 :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "all-autoroute-table"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['destination_address','protocol','area','igp_id']
                    self._child_classes = OrderedDict([("total-tunnel", ("total_tunnel", MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                        ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('destination', (YLeaf(YType.str, 'destination'), ['str'])),
                        ('announced_tunnels_count', (YLeaf(YType.uint16, 'announced-tunnels-count'), ['int'])),
                        ('autorouted_tunnels_count', (YLeaf(YType.uint16, 'autorouted-tunnels-count'), ['int'])),
                        ('forwarding_adjacency_tunnels_count', (YLeaf(YType.uint16, 'forwarding-adjacency-tunnels-count'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                    ])
                    self.destination_address = None
                    self.protocol = None
                    self.area = None
                    self.igp_id = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.destination = None
                    self.announced_tunnels_count = None
                    self.autorouted_tunnels_count = None
                    self.forwarding_adjacency_tunnels_count = None
                    self.area_format = None

                    self.total_tunnel = YList(self)
                    self._segment_path = lambda: "announce-dest" + "[destination-address='" + str(self.destination_address) + "']" + "[protocol='" + str(self.protocol) + "']" + "[area='" + str(self.area) + "']" + "[igp-id='" + str(self.igp_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/all-autoroute-table/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, ['destination_address', 'protocol', 'area', 'igp_id', 'igp_type', 'igp_instance', 'igp_area', 'destination', 'announced_tunnels_count', 'autorouted_tunnels_count', 'forwarding_adjacency_tunnels_count', 'area_format'], name, value)


                class TotalTunnel(_Entity_):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:  :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:  :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\: int
                    
                    	**range:** \-2147483648..2147483647
                    
                    	**config**\: False
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs))])
                        self._leafs = OrderedDict([
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                            ('tunnel_loadshare', (YLeaf(YType.uint32, 'tunnel-loadshare'), ['int'])),
                            ('announce_type', (YLeaf(YType.enumeration, 'announce-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelAnnounce', '')])),
                            ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                            ('mode', (YLeaf(YType.enumeration, 'mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteAaMetricMode', '')])),
                            ('igp_metric', (YLeaf(YType.int32, 'igp-metric'), ['int'])),
                            ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                            ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                            ('is_auto_mesh_aa', (YLeaf(YType.boolean, 'is-auto-mesh-aa'), ['bool'])),
                            ('is_sr', (YLeaf(YType.boolean, 'is-sr'), ['bool'])),
                            ('is_sr_strict', (YLeaf(YType.boolean, 'is-sr-strict'), ['bool'])),
                            ('mesh_group_idaa', (YLeaf(YType.uint32, 'mesh-group-idaa'), ['int'])),
                            ('is_exclude_segment_routing', (YLeaf(YType.boolean, 'is-exclude-segment-routing'), ['bool'])),
                        ])
                        self.tunnel_name = None
                        self.tunnel_sig_name = None
                        self.tunnel_loadshare = None
                        self.announce_type = None
                        self.next_hop_address = None
                        self.mode = None
                        self.igp_metric = None
                        self.hold_time = None
                        self.area_format = None
                        self.is_auto_mesh_aa = None
                        self.is_sr = None
                        self.is_sr_strict = None
                        self.mesh_group_idaa = None
                        self.is_exclude_segment_routing = None

                        self.ig_ps = YList(self)
                        self._segment_path = lambda: "total-tunnel"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, ['tunnel_name', 'tunnel_sig_name', 'tunnel_loadshare', 'announce_type', 'next_hop_address', 'mode', 'igp_metric', 'hold_time', 'area_format', 'is_auto_mesh_aa', 'is_sr', 'is_sr_strict', 'mesh_group_idaa', 'is_exclude_segment_routing'], name, value)


                    class IgPs(_Entity_):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                                ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ])
                            self.igp_area_id = None
                            self.afi = None
                            self._segment_path = lambda: "ig-ps"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, ['igp_area_id', 'afi'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AnnounceTunnelsInfo']['meta_info']


    class CollaboratorTimers(_Entity_):
        """
        TE Collaborator timer status
        
        .. attribute:: p2mp_timer
        
        	Description of all P2MP timers
        	**type**\: list of  		 :py:class:`P2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.CollaboratorTimers.P2mpTimer>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.CollaboratorTimers, self).__init__()

            self.yang_name = "collaborator-timers"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("p2mp-timer", ("p2mp_timer", MplsTeStandby.CollaboratorTimers.P2mpTimer))])
            self._leafs = OrderedDict()

            self.p2mp_timer = YList(self)
            self._segment_path = lambda: "collaborator-timers"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.CollaboratorTimers, [], name, value)


        class P2mpTimer(_Entity_):
            """
            Description of all P2MP timers
            
            .. attribute:: timer_type
            
            	Timer Type
            	**type**\:  :py:class:`MplsTeP2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2mpTimer>`
            
            	**config**\: False
            
            .. attribute:: timer_name
            
            	Timer Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: start_time
            
            	Date when timer was last started in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: expiry_time
            
            	Date when the timer last expired in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: stop_time
            
            	Date when the timer was last stopped in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: duration
            
            	The expiry delay in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: is_running
            
            	True if the timer is running
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.CollaboratorTimers.P2mpTimer, self).__init__()

                self.yang_name = "p2mp-timer"
                self.yang_parent_name = "collaborator-timers"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('timer_type', (YLeaf(YType.enumeration, 'timer-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeP2mpTimer', '')])),
                    ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                    ('start_time', (YLeaf(YType.uint32, 'start-time'), ['int'])),
                    ('expiry_time', (YLeaf(YType.uint32, 'expiry-time'), ['int'])),
                    ('stop_time', (YLeaf(YType.uint32, 'stop-time'), ['int'])),
                    ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                    ('is_running', (YLeaf(YType.boolean, 'is-running'), ['bool'])),
                ])
                self.timer_type = None
                self.timer_name = None
                self.start_time = None
                self.expiry_time = None
                self.stop_time = None
                self.duration = None
                self.is_running = None
                self._segment_path = lambda: "p2mp-timer"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/collaborator-timers/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.CollaboratorTimers.P2mpTimer, ['timer_type', 'timer_name', 'start_time', 'expiry_time', 'stop_time', 'duration', 'is_running'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.CollaboratorTimers.P2mpTimer']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.CollaboratorTimers']['meta_info']


    class AutoTunnel(_Entity_):
        """
        Auto tunnel information.
        
        .. attribute:: pcc
        
        	Auto tunnel PCC (Path Computation Client) information
        	**type**\:  :py:class:`Pcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Pcc>`
        
        	**config**\: False
        
        .. attribute:: mesh
        
        	Auto tunnel mesh information
        	**type**\:  :py:class:`Mesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh>`
        
        	**config**\: False
        
        .. attribute:: backup
        
        	Auto tunnel backup information
        	**type**\:  :py:class:`Backup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AutoTunnel, self).__init__()

            self.yang_name = "auto-tunnel"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("pcc", ("pcc", MplsTeStandby.AutoTunnel.Pcc)), ("mesh", ("mesh", MplsTeStandby.AutoTunnel.Mesh)), ("backup", ("backup", MplsTeStandby.AutoTunnel.Backup))])
            self._leafs = OrderedDict()

            self.pcc = MplsTeStandby.AutoTunnel.Pcc()
            self.pcc.parent = self
            self._children_name_map["pcc"] = "pcc"

            self.mesh = MplsTeStandby.AutoTunnel.Mesh()
            self.mesh.parent = self
            self._children_name_map["mesh"] = "mesh"

            self.backup = MplsTeStandby.AutoTunnel.Backup()
            self.backup.parent = self
            self._children_name_map["backup"] = "backup"
            self._segment_path = lambda: "auto-tunnel"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AutoTunnel, [], name, value)


        class Pcc(_Entity_):
            """
            Auto tunnel PCC (Path Computation Client)
            information.
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel pcc summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Pcc.Summary>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AutoTunnel.Pcc, self).__init__()

                self.yang_name = "pcc"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("summary", ("summary", MplsTeStandby.AutoTunnel.Pcc.Summary))])
                self._leafs = OrderedDict()

                self.summary = MplsTeStandby.AutoTunnel.Pcc.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._segment_path = lambda: "pcc"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AutoTunnel.Pcc, [], name, value)


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel pcc summary information
                
                .. attribute:: pcc_auto_tunnel
                
                	Total number of stateful PCE client auto\-tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Pcc.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "pcc"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('pcc_auto_tunnel', (YLeaf(YType.uint32, 'pcc-auto-tunnel'), ['int'])),
                        ('up_pcc_auto_tunnels', (YLeaf(YType.uint32, 'up-pcc-auto-tunnels'), ['int'])),
                        ('down_pcc_auto_tunnels', (YLeaf(YType.uint32, 'down-pcc-auto-tunnels'), ['int'])),
                    ])
                    self.pcc_auto_tunnel = None
                    self.up_pcc_auto_tunnels = None
                    self.down_pcc_auto_tunnels = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/pcc/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Pcc.Summary, ['pcc_auto_tunnel', 'up_pcc_auto_tunnels', 'down_pcc_auto_tunnels'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Pcc.Summary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AutoTunnel.Pcc']['meta_info']


        class Mesh(_Entity_):
            """
            Auto tunnel mesh information.
            
            .. attribute:: mesh_groups
            
            	Display auto\-tunnel mesh group
            	**type**\:  :py:class:`MeshGroups <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups>`
            
            	**config**\: False
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel mesh counters (stats) information
            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Statistics>`
            
            	**config**\: False
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel mesh summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Summary>`
            
            	**config**\: False
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel mesh configuration information
            	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Config>`
            
            	**config**\: False
            
            .. attribute:: one_hop
            
            	MPLS TE auto\-tunnel mesh onehop information
            	**type**\:  :py:class:`OneHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AutoTunnel.Mesh, self).__init__()

                self.yang_name = "mesh"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("mesh-groups", ("mesh_groups", MplsTeStandby.AutoTunnel.Mesh.MeshGroups)), ("statistics", ("statistics", MplsTeStandby.AutoTunnel.Mesh.Statistics)), ("summary", ("summary", MplsTeStandby.AutoTunnel.Mesh.Summary)), ("config", ("config", MplsTeStandby.AutoTunnel.Mesh.Config)), ("one-hop", ("one_hop", MplsTeStandby.AutoTunnel.Mesh.OneHop))])
                self._leafs = OrderedDict()

                self.mesh_groups = MplsTeStandby.AutoTunnel.Mesh.MeshGroups()
                self.mesh_groups.parent = self
                self._children_name_map["mesh_groups"] = "mesh-groups"

                self.statistics = MplsTeStandby.AutoTunnel.Mesh.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"

                self.summary = MplsTeStandby.AutoTunnel.Mesh.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"

                self.config = MplsTeStandby.AutoTunnel.Mesh.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"

                self.one_hop = MplsTeStandby.AutoTunnel.Mesh.OneHop()
                self.one_hop.parent = self
                self._children_name_map["one_hop"] = "one-hop"
                self._segment_path = lambda: "mesh"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh, [], name, value)


            class MeshGroups(_Entity_):
                """
                Display auto\-tunnel mesh group
                
                .. attribute:: mesh_group
                
                	Display auto\-tunnel mesh group information
                	**type**\: list of  		 :py:class:`MeshGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups, self).__init__()

                    self.yang_name = "mesh-groups"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("mesh-group", ("mesh_group", MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup))])
                    self._leafs = OrderedDict()

                    self.mesh_group = YList(self)
                    self._segment_path = lambda: "mesh-groups"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.MeshGroups, [], name, value)


                class MeshGroup(_Entity_):
                    """
                    Display auto\-tunnel mesh group information
                    
                    .. attribute:: mesh_group_id  (key)
                    
                    	Mesh group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_id_xr
                    
                    	Meshgroup ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_meshgroup_disabled
                    
                    	Is the meshgroup disabled
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: attribute_set_name
                    
                    	Attribute set name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_attribute_set_configured
                    
                    	Is any attribute\-set associated to this meshgroup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_attribute_set_in_db
                    
                    	Flag to indicate the existence of attribute set found in database
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_list_name
                    
                    	Destination List name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_destination_list_configured
                    
                    	Is any destiantion\-list associated to this meshgroup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: destination_list_type
                    
                    	Type of the  destlist
                    	**type**\:  :py:class:`TeAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAcl>`
                    
                    	**config**\: False
                    
                    .. attribute:: remaining_time
                    
                    	Remaining time for recreate timer in seconds
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: auto_mesh_tunnels
                    
                    	Total number of automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_total_destinations
                    
                    	Total number of destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_group_type
                    
                    	Meshgroup Type
                    	**type**\:  :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination
                    
                    	List of destinations for this meshgroup
                    	**type**\: list of  		 :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__init__()

                        self.yang_name = "mesh-group"
                        self.yang_parent_name = "mesh-groups"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['mesh_group_id']
                        self._child_classes = OrderedDict([("destination", ("destination", MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination))])
                        self._leafs = OrderedDict([
                            ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                            ('mesh_group_id_xr', (YLeaf(YType.uint32, 'mesh-group-id-xr'), ['int'])),
                            ('is_meshgroup_disabled', (YLeaf(YType.boolean, 'is-meshgroup-disabled'), ['bool'])),
                            ('attribute_set_name', (YLeaf(YType.str, 'attribute-set-name'), ['str'])),
                            ('is_attribute_set_configured', (YLeaf(YType.boolean, 'is-attribute-set-configured'), ['bool'])),
                            ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                            ('destination_list_name', (YLeaf(YType.str, 'destination-list-name'), ['str'])),
                            ('is_destination_list_configured', (YLeaf(YType.boolean, 'is-destination-list-configured'), ['bool'])),
                            ('destination_list_type', (YLeaf(YType.enumeration, 'destination-list-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAcl', '')])),
                            ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                            ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_total_destinations', (YLeaf(YType.uint32, 'auto-mesh-total-destinations'), ['int'])),
                            ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                            ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                            ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_group_type', (YLeaf(YType.enumeration, 'auto-mesh-group-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeMeshgroup', '')])),
                        ])
                        self.mesh_group_id = None
                        self.mesh_group_id_xr = None
                        self.is_meshgroup_disabled = None
                        self.attribute_set_name = None
                        self.is_attribute_set_configured = None
                        self.is_attribute_set_in_db = None
                        self.destination_list_name = None
                        self.is_destination_list_configured = None
                        self.destination_list_type = None
                        self.remaining_time = None
                        self.auto_mesh_tunnels = None
                        self.auto_mesh_total_destinations = None
                        self.up_auto_mesh_tunnels = None
                        self.down_auto_mesh_tunnels = None
                        self.frr_auto_mesh_tunnels = None
                        self.auto_mesh_group_type = None

                        self.destination = YList(self)
                        self._segment_path = lambda: "mesh-group" + "[mesh-group-id='" + str(self.mesh_group_id) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/mesh-groups/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup, ['mesh_group_id', 'mesh_group_id_xr', 'is_meshgroup_disabled', 'attribute_set_name', 'is_attribute_set_configured', 'is_attribute_set_in_db', 'destination_list_name', 'is_destination_list_configured', 'destination_list_type', 'remaining_time', 'auto_mesh_tunnels', 'auto_mesh_total_destinations', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_group_type'], name, value)


                    class Destination(_Entity_):
                        """
                        List of destinations for this meshgroup
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: operational_status
                        
                        	Tunnel operational status
                        	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                        
                        	**config**\: False
                        
                        .. attribute:: remaining_time
                        
                        	Remaining time for unused timer in seconds
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__init__()

                            self.yang_name = "destination"
                            self.yang_parent_name = "mesh-group"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                ('operational_status', (YLeaf(YType.enumeration, 'operational-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                            ])
                            self.destination_address = None
                            self.tunnel_id = None
                            self.operational_status = None
                            self.remaining_time = None
                            self._segment_path = lambda: "destination"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, ['destination_address', 'tunnel_id', 'operational_status', 'remaining_time'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.MeshGroups']['meta_info']


            class Statistics(_Entity_):
                """
                MPLS TE auto\-tunnel mesh counters (stats)
                information
                
                .. attribute:: created
                
                	Number of connected automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: connected
                
                	Number of connected automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_unused
                
                	Number of automesh tunnels removed while unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_in_use
                
                	Number of automesh tunnels removed while up and in use
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: removed_range_exceeded
                
                	Number of automesh tunnel attempts rejected because the total number exceeds the range
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_cleared_time
                
                	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Mesh.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('created', (YLeaf(YType.uint32, 'created'), ['int'])),
                        ('connected', (YLeaf(YType.uint32, 'connected'), ['int'])),
                        ('removed_unused', (YLeaf(YType.uint32, 'removed-unused'), ['int'])),
                        ('removed_in_use', (YLeaf(YType.uint32, 'removed-in-use'), ['int'])),
                        ('removed_range_exceeded', (YLeaf(YType.uint32, 'removed-range-exceeded'), ['int'])),
                        ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ])
                    self.created = None
                    self.connected = None
                    self.removed_unused = None
                    self.removed_in_use = None
                    self.removed_range_exceeded = None
                    self.last_cleared_time = None
                    self._segment_path = lambda: "statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.Statistics, ['created', 'connected', 'removed_unused', 'removed_in_use', 'removed_range_exceeded', 'last_cleared_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.Statistics']['meta_info']


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel mesh summary information
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Mesh.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                        ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                        ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_groups', (YLeaf(YType.uint32, 'auto-mesh-groups'), ['int'])),
                        ('auto_mesh_destinations', (YLeaf(YType.uint32, 'auto-mesh-destinations'), ['int'])),
                    ])
                    self.auto_mesh_tunnels = None
                    self.up_auto_mesh_tunnels = None
                    self.down_auto_mesh_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_groups = None
                    self.auto_mesh_destinations = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.Summary, ['auto_mesh_tunnels', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_groups', 'auto_mesh_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.Summary']['meta_info']


            class Config(_Entity_):
                """
                MPLS TE auto\-tunnel mesh configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel mesh feature is configured 
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Mesh.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                        ('unused_removal_timeout_configured', (YLeaf(YType.uint32, 'unused-removal-timeout-configured'), ['int'])),
                        ('min_tunnel_id', (YLeaf(YType.uint16, 'min-tunnel-id'), ['int'])),
                        ('max_tunnel_id', (YLeaf(YType.uint16, 'max-tunnel-id'), ['int'])),
                    ])
                    self.is_configured = None
                    self.unused_removal_timeout_configured = None
                    self.min_tunnel_id = None
                    self.max_tunnel_id = None
                    self._segment_path = lambda: "config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.Config, ['is_configured', 'unused_removal_timeout_configured', 'min_tunnel_id', 'max_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.Config']['meta_info']


            class OneHop(_Entity_):
                """
                MPLS TE auto\-tunnel mesh onehop information
                
                .. attribute:: interfaces
                
                	Display auto\-tunnel onehop interfaces
                	**type**\:  :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces>`
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	MPLS TE auto\-tunnel mesh onehop counters (stats) information
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics>`
                
                	**config**\: False
                
                .. attribute:: summary
                
                	MPLS TE auto\-tunnel mesh onehop summary information
                	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop, self).__init__()

                    self.yang_name = "one-hop"
                    self.yang_parent_name = "mesh"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("interfaces", ("interfaces", MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces)), ("statistics", ("statistics", MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics)), ("summary", ("summary", MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary))])
                    self._leafs = OrderedDict()

                    self.interfaces = MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces()
                    self.interfaces.parent = self
                    self._children_name_map["interfaces"] = "interfaces"

                    self.statistics = MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.summary = MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._segment_path = lambda: "one-hop"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop, [], name, value)


                class Interfaces(_Entity_):
                    """
                    Display auto\-tunnel onehop interfaces
                    
                    .. attribute:: interface
                    
                    	Display auto\-tunnel mesh onehop interface information
                    	**type**\: list of  		 :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces, self).__init__()

                        self.yang_name = "interfaces"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("interface", ("interface", MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface))])
                        self._leafs = OrderedDict()

                        self.interface = YList(self)
                        self._segment_path = lambda: "interfaces"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces, [], name, value)


                    class Interface(_Entity_):
                        """
                        Display auto\-tunnel mesh onehop interface
                        information
                        
                        .. attribute:: interface_name  (key)
                        
                        	Interface Name
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: interface_name_xr
                        
                        	Interface name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel
                        
                        	Onehop tunnels created for this interface
                        	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interfaces"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = ['interface_name']
                            self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel))])
                            self._leafs = OrderedDict([
                                ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                                ('interface_name_xr', (YLeaf(YType.str, 'interface-name-xr'), ['str'])),
                            ])
                            self.interface_name = None
                            self.interface_name_xr = None

                            self.tunnel = YList(self)
                            self._segment_path = lambda: "interface" + "[interface-name='" + str(self.interface_name) + "']"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/interfaces/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface, ['interface_name', 'interface_name_xr'], name, value)


                        class Tunnel(_Entity_):
                            """
                            Onehop tunnels created for this interface
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_lspid
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "interface"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('tunnel_lspid', (YLeaf(YType.uint16, 'tunnel-lspid'), ['int'])),
                                    ('mesh_group_id', (YLeaf(YType.uint32, 'mesh-group-id'), ['int'])),
                                    ('tunnel_state', (YLeaf(YType.enumeration, 'tunnel-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                                ])
                                self.tunnel_id = None
                                self.destination_address = None
                                self.tunnel_lspid = None
                                self.mesh_group_id = None
                                self.tunnel_state = None
                                self._segment_path = lambda: "tunnel"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, ['tunnel_id', 'destination_address', 'tunnel_lspid', 'mesh_group_id', 'tunnel_state'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces']['meta_info']


                class Statistics(_Entity_):
                    """
                    MPLS TE auto\-tunnel mesh onehop counters
                    (stats) information
                    
                    .. attribute:: created
                    
                    	Number of connected automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: connected
                    
                    	Number of connected automesh tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_unused
                    
                    	Number of automesh tunnels removed while unused
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_in_use
                    
                    	Number of automesh tunnels removed while up and in use
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: removed_range_exceeded
                    
                    	Number of automesh tunnel attempts rejected because the total number exceeds the range
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: last_cleared_time
                    
                    	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('created', (YLeaf(YType.uint32, 'created'), ['int'])),
                            ('connected', (YLeaf(YType.uint32, 'connected'), ['int'])),
                            ('removed_unused', (YLeaf(YType.uint32, 'removed-unused'), ['int'])),
                            ('removed_in_use', (YLeaf(YType.uint32, 'removed-in-use'), ['int'])),
                            ('removed_range_exceeded', (YLeaf(YType.uint32, 'removed-range-exceeded'), ['int'])),
                            ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                        ])
                        self.created = None
                        self.connected = None
                        self.removed_unused = None
                        self.removed_in_use = None
                        self.removed_range_exceeded = None
                        self.last_cleared_time = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics, ['created', 'connected', 'removed_unused', 'removed_in_use', 'removed_range_exceeded', 'last_cleared_time'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics']['meta_info']


                class Summary(_Entity_):
                    """
                    MPLS TE auto\-tunnel mesh onehop summary
                    information
                    
                    .. attribute:: auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh onehop tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_one_hop_groups
                    
                    	Total number of automesh onehop mesh\-groups
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_mesh_one_hop_destinations
                    
                    	Total number of automesh onehop destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "one-hop"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'auto-mesh-one-hop-tunnels'), ['int'])),
                            ('up_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-one-hop-tunnels'), ['int'])),
                            ('down_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-one-hop-tunnels'), ['int'])),
                            ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                            ('auto_mesh_one_hop_groups', (YLeaf(YType.uint32, 'auto-mesh-one-hop-groups'), ['int'])),
                            ('auto_mesh_one_hop_destinations', (YLeaf(YType.uint32, 'auto-mesh-one-hop-destinations'), ['int'])),
                        ])
                        self.auto_mesh_one_hop_tunnels = None
                        self.up_auto_mesh_one_hop_tunnels = None
                        self.down_auto_mesh_one_hop_tunnels = None
                        self.frr_auto_mesh_tunnels = None
                        self.auto_mesh_one_hop_groups = None
                        self.auto_mesh_one_hop_destinations = None
                        self._segment_path = lambda: "summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary, ['auto_mesh_one_hop_tunnels', 'up_auto_mesh_one_hop_tunnels', 'down_auto_mesh_one_hop_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_one_hop_groups', 'auto_mesh_one_hop_destinations'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh.OneHop']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AutoTunnel.Mesh']['meta_info']


        class Backup(_Entity_):
            """
            Auto tunnel backup information.
            
            .. attribute:: tunnels
            
            	auto\-tunnel backup information
            	**type**\:  :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Tunnels>`
            
            	**config**\: False
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel backup counters (stats) information
            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics>`
            
            	**config**\: False
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel backup summary information
            	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Summary>`
            
            	**config**\: False
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel backup configuration information
            	**type**\:  :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Config>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AutoTunnel.Backup, self).__init__()

                self.yang_name = "backup"
                self.yang_parent_name = "auto-tunnel"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnels", ("tunnels", MplsTeStandby.AutoTunnel.Backup.Tunnels)), ("statistics", ("statistics", MplsTeStandby.AutoTunnel.Backup.Statistics)), ("summary", ("summary", MplsTeStandby.AutoTunnel.Backup.Summary)), ("config", ("config", MplsTeStandby.AutoTunnel.Backup.Config))])
                self._leafs = OrderedDict()

                self.tunnels = MplsTeStandby.AutoTunnel.Backup.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"

                self.statistics = MplsTeStandby.AutoTunnel.Backup.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"

                self.summary = MplsTeStandby.AutoTunnel.Backup.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"

                self.config = MplsTeStandby.AutoTunnel.Backup.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._segment_path = lambda: "backup"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AutoTunnel.Backup, [], name, value)


            class Tunnels(_Entity_):
                """
                auto\-tunnel backup information
                
                .. attribute:: tunnel
                
                	Display auto tunnel backup tunnel information
                	**type**\: list of  		 :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Backup.Tunnels, self).__init__()

                    self.yang_name = "tunnels"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("tunnel", ("tunnel", MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel))])
                    self._leafs = OrderedDict()

                    self.tunnel = YList(self)
                    self._segment_path = lambda: "tunnels"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Tunnels, [], name, value)


                class Tunnel(_Entity_):
                    """
                    Display auto tunnel backup tunnel information
                    
                    .. attribute:: backup_tunnel_name  (key)
                    
                    	Backup tunnel name
                    	**type**\: str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: operational_status
                    
                    	Tunnel operational status
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_mode
                    
                    	SRLG exclude mode for this auto\-tunnel backup
                    	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: atb_protection_type
                    
                    	Type of protection offered by this auto\-tunnel backup
                    	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_flows
                    
                    	Number of protected flows
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protected_interface_name
                    
                    	Interface protected by this auto\-tunnel backup
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: protected_router_id
                    
                    	Router ID of node protected by this auto\-tunnel backup
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tunnels"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = ['backup_tunnel_name']
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                            ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ('operational_status', (YLeaf(YType.enumeration, 'operational-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                            ('srlg_mode', (YLeaf(YType.enumeration, 'srlg-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                            ('atb_protection_type', (YLeaf(YType.enumeration, 'atb-protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                            ('protected_flows', (YLeaf(YType.uint32, 'protected-flows'), ['int'])),
                            ('protected_interface_name', (YLeaf(YType.str, 'protected-interface-name'), ['str'])),
                            ('protected_router_id', (YLeaf(YType.str, 'protected-router-id'), ['str'])),
                        ])
                        self.backup_tunnel_name = None
                        self.tunnel_name = None
                        self.operational_status = None
                        self.srlg_mode = None
                        self.atb_protection_type = None
                        self.protected_flows = None
                        self.protected_interface_name = None
                        self.protected_router_id = None
                        self._segment_path = lambda: "tunnel" + "[backup-tunnel-name='" + str(self.backup_tunnel_name) + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/tunnels/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel, ['backup_tunnel_name', 'tunnel_name', 'operational_status', 'srlg_mode', 'atb_protection_type', 'protected_flows', 'protected_interface_name', 'protected_router_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Tunnels']['meta_info']


            class Statistics(_Entity_):
                """
                MPLS TE auto\-tunnel backup counters (stats)
                information
                
                .. attribute:: created
                
                	Number of connected auto backup tunnels
                	**type**\:  :py:class:`Created <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.Created>`
                
                	**config**\: False
                
                .. attribute:: connected
                
                	Number of connected auto backup tunnels
                	**type**\:  :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.Connected>`
                
                	**config**\: False
                
                .. attribute:: removed_down
                
                	Number of NNHOP auto backup tunnels removed while down
                	**type**\:  :py:class:`RemovedDown <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown>`
                
                	**config**\: False
                
                .. attribute:: removed_unused
                
                	Number of auto backup tunnels removed while unused
                	**type**\:  :py:class:`RemovedUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused>`
                
                	**config**\: False
                
                .. attribute:: removed_in_use
                
                	Number of auto backup tunnels removed while up and in use
                	**type**\:  :py:class:`RemovedInUse <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse>`
                
                	**config**\: False
                
                .. attribute:: removed_range_exceeded
                
                	Number of auto backup tunnel attempts rejected because the total number exceeds the range
                	**type**\:  :py:class:`RemovedRangeExceeded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded>`
                
                	**config**\: False
                
                .. attribute:: last_cleared_time
                
                	Timestamp when the stat has been cleared
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("created", ("created", MplsTeStandby.AutoTunnel.Backup.Statistics.Created)), ("connected", ("connected", MplsTeStandby.AutoTunnel.Backup.Statistics.Connected)), ("removed-down", ("removed_down", MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown)), ("removed-unused", ("removed_unused", MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused)), ("removed-in-use", ("removed_in_use", MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse)), ("removed-range-exceeded", ("removed_range_exceeded", MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded))])
                    self._leafs = OrderedDict([
                        ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ])
                    self.last_cleared_time = None

                    self.created = MplsTeStandby.AutoTunnel.Backup.Statistics.Created()
                    self.created.parent = self
                    self._children_name_map["created"] = "created"

                    self.connected = MplsTeStandby.AutoTunnel.Backup.Statistics.Connected()
                    self.connected.parent = self
                    self._children_name_map["connected"] = "connected"

                    self.removed_down = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown()
                    self.removed_down.parent = self
                    self._children_name_map["removed_down"] = "removed-down"

                    self.removed_unused = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused()
                    self.removed_unused.parent = self
                    self._children_name_map["removed_unused"] = "removed-unused"

                    self.removed_in_use = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse()
                    self.removed_in_use.parent = self
                    self._children_name_map["removed_in_use"] = "removed-in-use"

                    self.removed_range_exceeded = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                    self.removed_range_exceeded.parent = self
                    self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                    self._segment_path = lambda: "statistics"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics, ['last_cleared_time'], name, value)


                class Created(_Entity_):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.Created, self).__init__()

                        self.yang_name = "created"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "created"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.Created, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.Created']['meta_info']


                class Connected(_Entity_):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.Connected, self).__init__()

                        self.yang_name = "connected"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "connected"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.Connected, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.Connected']['meta_info']


                class RemovedDown(_Entity_):
                    """
                    Number of NNHOP auto backup tunnels removed
                    while down
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown, self).__init__()

                        self.yang_name = "removed-down"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-down"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown']['meta_info']


                class RemovedUnused(_Entity_):
                    """
                    Number of auto backup tunnels removed while
                    unused
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused, self).__init__()

                        self.yang_name = "removed-unused"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-unused"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused']['meta_info']


                class RemovedInUse(_Entity_):
                    """
                    Number of auto backup tunnels removed while up
                    and in use
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse, self).__init__()

                        self.yang_name = "removed-in-use"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-in-use"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse']['meta_info']


                class RemovedRangeExceeded(_Entity_):
                    """
                    Number of auto backup tunnel attempts rejected
                    because the total number exceeds the range
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__init__()

                        self.yang_name = "removed-range-exceeded"
                        self.yang_parent_name = "statistics"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('total_tunnels', (YLeaf(YType.uint32, 'total-tunnels'), ['int'])),
                            ('next_hop_tunnels', (YLeaf(YType.uint32, 'next-hop-tunnels'), ['int'])),
                            ('next_next_hop_tunnels', (YLeaf(YType.uint32, 'next-next-hop-tunnels'), ['int'])),
                        ])
                        self.total_tunnels = None
                        self.next_hop_tunnels = None
                        self.next_next_hop_tunnels = None
                        self._segment_path = lambda: "removed-range-exceeded"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, ['total_tunnels', 'next_hop_tunnels', 'next_next_hop_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Statistics']['meta_info']


            class Summary(_Entity_):
                """
                MPLS TE auto\-tunnel backup summary information
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Backup.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('autobackups', (YLeaf(YType.uint32, 'autobackups'), ['int'])),
                        ('up_autobackups', (YLeaf(YType.uint32, 'up-autobackups'), ['int'])),
                        ('down_autobackups', (YLeaf(YType.uint32, 'down-autobackups'), ['int'])),
                        ('unused_autobackups', (YLeaf(YType.uint32, 'unused-autobackups'), ['int'])),
                        ('next_hop_autobackups', (YLeaf(YType.uint32, 'next-hop-autobackups'), ['int'])),
                        ('next_next_hop_autobackups', (YLeaf(YType.uint32, 'next-next-hop-autobackups'), ['int'])),
                        ('srlg_strict_autobackups', (YLeaf(YType.uint32, 'srlg-strict-autobackups'), ['int'])),
                        ('srlg_preferred_autobackups', (YLeaf(YType.uint32, 'srlg-preferred-autobackups'), ['int'])),
                        ('srlg_weighted_autobackups', (YLeaf(YType.uint32, 'srlg-weighted-autobackups'), ['int'])),
                        ('next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                    ])
                    self.autobackups = None
                    self.up_autobackups = None
                    self.down_autobackups = None
                    self.unused_autobackups = None
                    self.next_hop_autobackups = None
                    self.next_next_hop_autobackups = None
                    self.srlg_strict_autobackups = None
                    self.srlg_preferred_autobackups = None
                    self.srlg_weighted_autobackups = None
                    self.next_hop_autobackup_protected_ls_ps = None
                    self.next_next_hop_autobackup_protected_ls_ps = None
                    self.next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_hop_autobackup_protected_s2l_families = None
                    self.next_next_hop_autobackup_protected_s2l_families = None
                    self.next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_hop_autobackup_protected_s2_ls = None
                    self.next_next_hop_autobackup_protected_s2_ls = None
                    self.next_hop_srlg_autobackup_protected_s2_ls = None
                    self.next_next_hop_srlg_autobackup_protected_s2_ls = None
                    self._segment_path = lambda: "summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Summary, ['autobackups', 'up_autobackups', 'down_autobackups', 'unused_autobackups', 'next_hop_autobackups', 'next_next_hop_autobackups', 'srlg_strict_autobackups', 'srlg_preferred_autobackups', 'srlg_weighted_autobackups', 'next_hop_autobackup_protected_ls_ps', 'next_next_hop_autobackup_protected_ls_ps', 'next_hop_srlg_autobackup_protected_ls_ps', 'next_next_hop_srlg_autobackup_protected_ls_ps', 'next_hop_autobackup_protected_s2l_families', 'next_next_hop_autobackup_protected_s2l_families', 'next_hop_srlg_autobackup_protected_s2l_families', 'next_next_hop_srlg_autobackup_protected_s2l_families', 'next_hop_autobackup_protected_s2_ls', 'next_next_hop_autobackup_protected_s2_ls', 'next_hop_srlg_autobackup_protected_s2_ls', 'next_next_hop_srlg_autobackup_protected_s2_ls'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Summary']['meta_info']


            class Config(_Entity_):
                """
                MPLS TE auto\-tunnel backup configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel bacukp feature is configured 
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: interface_count
                
                	Number of TE link interfaces with auto\-tunnel backup configured
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnel.Backup.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "backup"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                        ('interface_count', (YLeaf(YType.uint32, 'interface-count'), ['int'])),
                        ('unused_removal_timeout_configured', (YLeaf(YType.uint32, 'unused-removal-timeout-configured'), ['int'])),
                        ('min_tunnel_id', (YLeaf(YType.uint16, 'min-tunnel-id'), ['int'])),
                        ('max_tunnel_id', (YLeaf(YType.uint16, 'max-tunnel-id'), ['int'])),
                    ])
                    self.is_configured = None
                    self.interface_count = None
                    self.unused_removal_timeout_configured = None
                    self.min_tunnel_id = None
                    self.max_tunnel_id = None
                    self._segment_path = lambda: "config"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnel.Backup.Config, ['is_configured', 'interface_count', 'unused_removal_timeout_configured', 'min_tunnel_id', 'max_tunnel_id'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnel.Backup.Config']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AutoTunnel.Backup']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AutoTunnel']['meta_info']


    class SoftPreemption(_Entity_):
        """
        Soft Preemption information.
        
        .. attribute:: statistics
        
        	MPLS TE soft preemption stats information
        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SoftPreemption.Statistics>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.SoftPreemption, self).__init__()

            self.yang_name = "soft-preemption"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SoftPreemption.Statistics))])
            self._leafs = OrderedDict()

            self.statistics = MplsTeStandby.SoftPreemption.Statistics()
            self.statistics.parent = self
            self._children_name_map["statistics"] = "statistics"
            self._segment_path = lambda: "soft-preemption"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.SoftPreemption, [], name, value)


        class Statistics(_Entity_):
            """
            MPLS TE soft preemption stats information
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: soft_preemption_events
            
            	The number of soft preemption events triggered
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: timed_out_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and timed out at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: torn_down_soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node and torn down before timing out
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_triggered_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and then fast rerouted at this node
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: minimum_time_in_soft_preempted_state
            
            	The minimum number of seconds an LSP remained in the soft preempted state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_max
            
            	The maximum number of seconds an LSP remained in the soft preempted state without being hard preempted
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_avg
            
            	The average number of seconds an LSP remained in the soft preempted state. This excludes the timed out LSPs
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: soft_preempted_head_ls_ps
            
            	Number of soft preempted LSPs at the headend. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: reoptimized_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are reoptimized. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: torndown_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are torn down instead of being reoptimized. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_protected_switchover_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are replaced with the path protection LSP. This is relevant to the headend
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SoftPreemption.Statistics, self).__init__()

                self.yang_name = "statistics"
                self.yang_parent_name = "soft-preemption"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                    ('soft_preemption_events', (YLeaf(YType.uint32, 'soft-preemption-events'), ['int'])),
                    ('soft_preempted_ls_ps', (YLeaf(YType.uint32, 'soft-preempted-ls-ps'), ['int'])),
                    ('timed_out_soft_preempted_lsp_ss', (YLeaf(YType.uint32, 'timed-out-soft-preempted-lsp-ss'), ['int'])),
                    ('torn_down_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'torn-down-soft-preempted-ls-ps'), ['int'])),
                    ('frr_triggered_soft_preempted_lsp_ss', (YLeaf(YType.uint32, 'frr-triggered-soft-preempted-lsp-ss'), ['int'])),
                    ('minimum_time_in_soft_preempted_state', (YLeaf(YType.uint16, 'minimum-time-in-soft-preempted-state'), ['int'])),
                    ('time_in_soft_preempted_state_max', (YLeaf(YType.uint16, 'time-in-soft-preempted-state-max'), ['int'])),
                    ('time_in_soft_preempted_state_avg', (YLeaf(YType.uint16, 'time-in-soft-preempted-state-avg'), ['int'])),
                    ('soft_preempted_head_ls_ps', (YLeaf(YType.uint32, 'soft-preempted-head-ls-ps'), ['int'])),
                    ('reoptimized_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'reoptimized-soft-preempted-ls-ps'), ['int'])),
                    ('torndown_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'torndown-soft-preempted-ls-ps'), ['int'])),
                    ('path_protected_switchover_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'path-protected-switchover-soft-preempted-ls-ps'), ['int'])),
                ])
                self.last_cleared_timestamp = None
                self.soft_preemption_events = None
                self.soft_preempted_ls_ps = None
                self.timed_out_soft_preempted_lsp_ss = None
                self.torn_down_soft_preempted_ls_ps = None
                self.frr_triggered_soft_preempted_lsp_ss = None
                self.minimum_time_in_soft_preempted_state = None
                self.time_in_soft_preempted_state_max = None
                self.time_in_soft_preempted_state_avg = None
                self.soft_preempted_head_ls_ps = None
                self.reoptimized_soft_preempted_ls_ps = None
                self.torndown_soft_preempted_ls_ps = None
                self.path_protected_switchover_soft_preempted_ls_ps = None
                self._segment_path = lambda: "statistics"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/soft-preemption/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SoftPreemption.Statistics, ['last_cleared_timestamp', 'soft_preemption_events', 'soft_preempted_ls_ps', 'timed_out_soft_preempted_lsp_ss', 'torn_down_soft_preempted_ls_ps', 'frr_triggered_soft_preempted_lsp_ss', 'minimum_time_in_soft_preempted_state', 'time_in_soft_preempted_state_max', 'time_in_soft_preempted_state_avg', 'soft_preempted_head_ls_ps', 'reoptimized_soft_preempted_ls_ps', 'torndown_soft_preempted_ls_ps', 'path_protected_switchover_soft_preempted_ls_ps'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SoftPreemption.Statistics']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.SoftPreemption']['meta_info']


    class ForwardingAdjacencyDestinations(_Entity_):
        """
        Announced Destination tunnel
        
        .. attribute:: forwarding_adjacency_destination
        
        	Forwarding Adjacencies for a destination
        	**type**\: list of  		 :py:class:`ForwardingAdjacencyDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.ForwardingAdjacencyDestinations, self).__init__()

            self.yang_name = "forwarding-adjacency-destinations"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("forwarding-adjacency-destination", ("forwarding_adjacency_destination", MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination))])
            self._leafs = OrderedDict()

            self.forwarding_adjacency_destination = YList(self)
            self._segment_path = lambda: "forwarding-adjacency-destinations"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.ForwardingAdjacencyDestinations, [], name, value)


        class ForwardingAdjacencyDestination(_Entity_):
            """
            Forwarding Adjacencies for a destination
            
            .. attribute:: destination_address  (key)
            
            	Destination address
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: adjacencies
            
            	Number of Forwarding Adjacencies
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: ipv6_adjacencies
            
            	Number of IPv6 Forwarding Adjacencies
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: destination_address_xr
            
            	The tunnel destination
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: forward_adjacency
            
            	Forwarding\-adjacency list
            	**type**\: list of  		 :py:class:`ForwardAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__init__()

                self.yang_name = "forwarding-adjacency-destination"
                self.yang_parent_name = "forwarding-adjacency-destinations"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['destination_address']
                self._child_classes = OrderedDict([("forward-adjacency", ("forward_adjacency", MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency))])
                self._leafs = OrderedDict([
                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                    ('adjacencies', (YLeaf(YType.uint32, 'adjacencies'), ['int'])),
                    ('ipv6_adjacencies', (YLeaf(YType.uint32, 'ipv6-adjacencies'), ['int'])),
                    ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                ])
                self.destination_address = None
                self.adjacencies = None
                self.ipv6_adjacencies = None
                self.destination_address_xr = None

                self.forward_adjacency = YList(self)
                self._segment_path = lambda: "forwarding-adjacency-destination" + "[destination-address='" + str(self.destination_address) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/forwarding-adjacency-destinations/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, ['destination_address', 'adjacencies', 'ipv6_adjacencies', 'destination_address_xr'], name, value)


            class ForwardAdjacency(_Entity_):
                """
                Forwarding\-adjacency list
                
                .. attribute:: tunnel_name
                
                	The tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: traffic_share
                
                	Traffic Share
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_time
                
                	Hold time in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_adjacency_up
                
                	True if adj is up
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: ig_ps
                
                	List of IGPs to which it is announced
                	**type**\: list of  		 :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__init__()

                    self.yang_name = "forward-adjacency"
                    self.yang_parent_name = "forwarding-adjacency-destination"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("ig-ps", ("ig_ps", MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('traffic_share', (YLeaf(YType.uint32, 'traffic-share'), ['int'])),
                        ('hold_time', (YLeaf(YType.uint32, 'hold-time'), ['int'])),
                        ('is_adjacency_up', (YLeaf(YType.boolean, 'is-adjacency-up'), ['bool'])),
                    ])
                    self.tunnel_name = None
                    self.traffic_share = None
                    self.hold_time = None
                    self.is_adjacency_up = None

                    self.ig_ps = YList(self)
                    self._segment_path = lambda: "forward-adjacency"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, ['tunnel_name', 'traffic_share', 'hold_time', 'is_adjacency_up'], name, value)


                class IgPs(_Entity_):
                    """
                    List of IGPs to which it is announced
                    
                    .. attribute:: igp_area_id
                    
                    	The IGP Instance and Area ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: afi
                    
                    	AFI
                    	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__init__()

                        self.yang_name = "ig-ps"
                        self.yang_parent_name = "forward-adjacency"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('igp_area_id', (YLeaf(YType.str, 'igp-area-id'), ['str'])),
                            ('afi', (YLeaf(YType.enumeration, 'afi'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                        ])
                        self.igp_area_id = None
                        self.afi = None
                        self._segment_path = lambda: "ig-ps"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, ['igp_area_id', 'afi'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.ForwardingAdjacencyDestinations']['meta_info']


    class IgpAreas(_Entity_):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area
        
        	An IGP instance
        	**type**\: list of  		 :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.IgpAreas, self).__init__()

            self.yang_name = "igp-areas"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-area", ("igp_area", MplsTeStandby.IgpAreas.IgpArea))])
            self._leafs = OrderedDict()

            self.igp_area = YList(self)
            self._segment_path = lambda: "igp-areas"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.IgpAreas, [], name, value)


        class IgpArea(_Entity_):
            """
            An IGP instance
            
            .. attribute:: protocol  (key)
            
            	The IGP protocol
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: process_tag  (key)
            
            	IGP Process Tag
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of  		 :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId>`
            
            	**config**\: False
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of  		 :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.IgpAreas.IgpArea, self).__init__()

                self.yang_name = "igp-area"
                self.yang_parent_name = "igp-areas"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','process_tag']
                self._child_classes = OrderedDict([("secondary-router-id", ("secondary_router_id", MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId)), ("area", ("area", MplsTeStandby.IgpAreas.IgpArea.Area))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('process_tag', (YLeaf(YType.str, 'process-tag'), ['str'])),
                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ('igp_system_id', (YLeaf(YType.str, 'igp-system-id'), ['str'])),
                    ('configured_te_router_id', (YLeaf(YType.str, 'configured-te-router-id'), ['str'])),
                    ('global_router_id', (YLeaf(YType.str, 'global-router-id'), ['str'])),
                    ('globall_router_id_optical', (YLeaf(YType.str, 'globall-router-id-optical'), ['str'])),
                    ('in_use_te_router_id', (YLeaf(YType.str, 'in-use-te-router-id'), ['str'])),
                    ('is_connection_up', (YLeaf(YType.boolean, 'is-connection-up'), ['bool'])),
                    ('connection_up_count', (YLeaf(YType.uint32, 'connection-up-count'), ['int'])),
                    ('connection_down_count', (YLeaf(YType.uint32, 'connection-down-count'), ['int'])),
                ])
                self.protocol = None
                self.process_tag = None
                self.igp_type = None
                self.instance_name = None
                self.igp_system_id = None
                self.configured_te_router_id = None
                self.global_router_id = None
                self.globall_router_id_optical = None
                self.in_use_te_router_id = None
                self.is_connection_up = None
                self.connection_up_count = None
                self.connection_down_count = None

                self.secondary_router_id = YList(self)
                self.area = YList(self)
                self._segment_path = lambda: "igp-area" + "[protocol='" + str(self.protocol) + "']" + "[process-tag='" + str(self.process_tag) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/igp-areas/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.IgpAreas.IgpArea, ['protocol', 'process_tag', 'igp_type', 'instance_name', 'igp_system_id', 'configured_te_router_id', 'global_router_id', 'globall_router_id_optical', 'in_use_te_router_id', 'is_connection_up', 'connection_up_count', 'connection_down_count'], name, value)


            class SecondaryRouterId(_Entity_):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	Secondary router\-ids
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "secondary-router-id"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId']['meta_info']


            class Area(_Entity_):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:  :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData>`
                
                	**config**\: False
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_number
                
                	Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.IgpAreas.IgpArea.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("active-data", ("active_data", MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData))])
                    self._leafs = OrderedDict([
                        ('area_index', (YLeaf(YType.uint32, 'area-index'), ['int'])),
                        ('area_number', (YLeaf(YType.uint32, 'area-number'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('is_config_ready', (YLeaf(YType.boolean, 'is-config-ready'), ['bool'])),
                    ])
                    self.area_index = None
                    self.area_number = None
                    self.area_format = None
                    self.is_config_ready = None

                    self.active_data = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._segment_path = lambda: "area"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.IgpAreas.IgpArea.Area, ['area_index', 'area_number', 'area_format', 'is_config_ready'], name, value)


                class ActiveData(_Entity_):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:  :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("area-statistics", ("area_statistics", MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics))])
                        self._leafs = OrderedDict([
                            ('interfaces_count', (YLeaf(YType.uint32, 'interfaces-count'), ['int'])),
                            ('link_idt_received', (YLeaf(YType.boolean, 'link-idt-received'), ['bool'])),
                            ('topology_idt_received', (YLeaf(YType.boolean, 'topology-idt-received'), ['bool'])),
                            ('sr_strict', (YLeaf(YType.boolean, 'sr-strict'), ['bool'])),
                            ('p2p_heads_count', (YLeaf(YType.uint32, 'p2p-heads-count'), ['int'])),
                            ('p2p_autoroute_announced_count', (YLeaf(YType.uint32, 'p2p-autoroute-announced-count'), ['int'])),
                            ('p2p_forwarding_adjacency_count', (YLeaf(YType.uint32, 'p2p-forwarding-adjacency-count'), ['int'])),
                            ('p2mp_destination_count', (YLeaf(YType.uint32, 'p2mp-destination-count'), ['int'])),
                            ('tunnel_loose_hops', (YLeaf(YType.uint32, 'tunnel-loose-hops'), ['int'])),
                        ])
                        self.interfaces_count = None
                        self.link_idt_received = None
                        self.topology_idt_received = None
                        self.sr_strict = None
                        self.p2p_heads_count = None
                        self.p2p_autoroute_announced_count = None
                        self.p2p_forwarding_adjacency_count = None
                        self.p2mp_destination_count = None
                        self.tunnel_loose_hops = None

                        self.area_statistics = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._segment_path = lambda: "active-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData, ['interfaces_count', 'link_idt_received', 'topology_idt_received', 'sr_strict', 'p2p_heads_count', 'p2p_autoroute_announced_count', 'p2p_forwarding_adjacency_count', 'p2mp_destination_count', 'tunnel_loose_hops'], name, value)


                    class AreaStatistics(_Entity_):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('area_adjacency_request_messages', (YLeaf(YType.uint32, 'area-adjacency-request-messages'), ['int'])),
                                ('area_adjacency_announce_messages', (YLeaf(YType.uint32, 'area-adjacency-announce-messages'), ['int'])),
                                ('area_flood_messages', (YLeaf(YType.uint32, 'area-flood-messages'), ['int'])),
                                ('area_lsa_announce_messages', (YLeaf(YType.uint32, 'area-lsa-announce-messages'), ['int'])),
                                ('area_lsa_fragment_announce_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-announce-messages'), ['int'])),
                                ('area_lsa_delete_messages', (YLeaf(YType.uint32, 'area-lsa-delete-messages'), ['int'])),
                                ('area_lsa_fragment_delete_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-delete-messages'), ['int'])),
                                ('area_tunnel_announce_messages', (YLeaf(YType.uint32, 'area-tunnel-announce-messages'), ['int'])),
                            ])
                            self.area_adjacency_request_messages = None
                            self.area_adjacency_announce_messages = None
                            self.area_flood_messages = None
                            self.area_lsa_announce_messages = None
                            self.area_lsa_fragment_announce_messages = None
                            self.area_lsa_delete_messages = None
                            self.area_lsa_fragment_delete_messages = None
                            self.area_tunnel_announce_messages = None
                            self._segment_path = lambda: "area-statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, ['area_adjacency_request_messages', 'area_adjacency_announce_messages', 'area_flood_messages', 'area_lsa_announce_messages', 'area_lsa_fragment_announce_messages', 'area_lsa_delete_messages', 'area_lsa_fragment_delete_messages', 'area_tunnel_announce_messages'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.IgpAreas.IgpArea.Area']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.IgpAreas.IgpArea']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.IgpAreas']['meta_info']


    class WrapProtection(_Entity_):
        """
        Represent all the LSP Wrap Protection info in
        MPLS\-TE
        
        .. attribute:: protected_lsps
        
        	The set of wrap protected LSPs available in MPLS\-TE
        	**type**\:  :py:class:`ProtectedLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection.ProtectedLsps>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.WrapProtection, self).__init__()

            self.yang_name = "wrap-protection"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("protected-lsps", ("protected_lsps", MplsTeStandby.WrapProtection.ProtectedLsps))])
            self._leafs = OrderedDict()

            self.protected_lsps = MplsTeStandby.WrapProtection.ProtectedLsps()
            self.protected_lsps.parent = self
            self._children_name_map["protected_lsps"] = "protected-lsps"
            self._segment_path = lambda: "wrap-protection"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.WrapProtection, [], name, value)


        class ProtectedLsps(_Entity_):
            """
            The set of wrap protected LSPs available in
            MPLS\-TE
            
            .. attribute:: protected_lsp
            
            	Wrap protection info for a given protected LSP
            	**type**\: list of  		 :py:class:`ProtectedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.WrapProtection.ProtectedLsps, self).__init__()

                self.yang_name = "protected-lsps"
                self.yang_parent_name = "wrap-protection"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protected-lsp", ("protected_lsp", MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp))])
                self._leafs = OrderedDict()

                self.protected_lsp = YList(self)
                self._segment_path = lambda: "protected-lsps"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/wrap-protection/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.WrapProtection.ProtectedLsps, [], name, value)


            class ProtectedLsp(_Entity_):
                """
                Wrap protection info for a given protected LSP
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup Orig ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_type  (key)
                
                	Session Type
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_enable
                
                	LSP Wrap protection enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_label
                
                	LSP Wrap Merge Point Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: reverse_egress_interface
                
                	Reverse Egress Interface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: reverse_lsp_label
                
                	Reverse LSP label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_wrap_protection_state
                
                	LSP wrap protection state
                	**type**\:  :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                
                	**config**\: False
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp, self).__init__()

                    self.yang_name = "protected-lsp"
                    self.yang_parent_name = "protected-lsps"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_address','tunnel_id','extended_tunnel_id','lsp_id','sub_group_id','sub_group_originator','p2mp_id','session_type']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('session_type', (YLeaf(YType.enumeration, 'session-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('source_address_xr', (YLeaf(YType.str, 'source-address-xr'), ['str'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint16, 'tunnel-id-xr'), ['int'])),
                        ('extended_tunnel_id_xr', (YLeaf(YType.str, 'extended-tunnel-id-xr'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('lsp_wrap_protection_enable', (YLeaf(YType.boolean, 'lsp-wrap-protection-enable'), ['bool'])),
                        ('lsp_wrap_protection_label', (YLeaf(YType.uint32, 'lsp-wrap-protection-label'), ['int'])),
                        ('reverse_egress_interface', (YLeaf(YType.str, 'reverse-egress-interface'), ['str'])),
                        ('reverse_lsp_label', (YLeaf(YType.uint32, 'reverse-lsp-label'), ['int'])),
                        ('lsp_wrap_protection_state', (YLeaf(YType.enumeration, 'lsp-wrap-protection-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspWrapState', '')])),
                        ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ('sub_group_id_xr', (YLeaf(YType.uint16, 'sub-group-id-xr'), ['int'])),
                        ('p2mp_id_xr', (YLeaf(YType.uint32, 'p2mp-id-xr'), ['int'])),
                    ])
                    self.source_address = None
                    self.destination_address = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.lsp_id = None
                    self.sub_group_id = None
                    self.sub_group_originator = None
                    self.p2mp_id = None
                    self.session_type = None
                    self.source_address_xr = None
                    self.destination_address_xr = None
                    self.tunnel_id_xr = None
                    self.extended_tunnel_id_xr = None
                    self.tunnel_name = None
                    self.tunnel_instance = None
                    self.lsp_wrap_protection_enable = None
                    self.lsp_wrap_protection_label = None
                    self.reverse_egress_interface = None
                    self.reverse_lsp_label = None
                    self.lsp_wrap_protection_state = None
                    self.sub_group_original_id = None
                    self.sub_group_id_xr = None
                    self.p2mp_id_xr = None
                    self._segment_path = lambda: "protected-lsp" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[session-type='" + str(self.session_type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/wrap-protection/protected-lsps/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp, ['source_address', 'destination_address', 'tunnel_id', 'extended_tunnel_id', 'lsp_id', 'sub_group_id', 'sub_group_originator', 'p2mp_id', 'session_type', 'source_address_xr', 'destination_address_xr', 'tunnel_id_xr', 'extended_tunnel_id_xr', 'tunnel_name', 'tunnel_instance', 'lsp_wrap_protection_enable', 'lsp_wrap_protection_label', 'reverse_egress_interface', 'reverse_lsp_label', 'lsp_wrap_protection_state', 'sub_group_original_id', 'sub_group_id_xr', 'p2mp_id_xr'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.WrapProtection.ProtectedLsps']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.WrapProtection']['meta_info']


    class Topology(_Entity_):
        """
        The topology information in MPLS\-TE
        
        .. attribute:: global_
        
        	Global information about the overall MPLS\-TE topology
        	**type**\:  :py:class:`Global <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global>`
        
        	**config**\: False
        
        .. attribute:: destination_paths
        
        	This table models the path calculation capabilities in MPLS\-TE.A GET operation for the complete table will return no entries.See the class DestinationPath for more details
        	**type**\:  :py:class:`DestinationPaths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths>`
        
        	**config**\: False
        
        .. attribute:: configured_srlgs
        
        	Set of configured SRLG
        	**type**\:  :py:class:`ConfiguredSrlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs>`
        
        	**config**\: False
        
        .. attribute:: srlgs
        
        	Set of SRLG operational value for the overall MPLS\-TE topology
        	**type**\:  :py:class:`Srlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs>`
        
        	**config**\: False
        
        .. attribute:: path_tunnels
        
        	MPLS\-Te topology path info
        	**type**\:  :py:class:`PathTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("global", ("global_", MplsTeStandby.Topology.Global)), ("destination-paths", ("destination_paths", MplsTeStandby.Topology.DestinationPaths)), ("configured-srlgs", ("configured_srlgs", MplsTeStandby.Topology.ConfiguredSrlgs)), ("srlgs", ("srlgs", MplsTeStandby.Topology.Srlgs)), ("path-tunnels", ("path_tunnels", MplsTeStandby.Topology.PathTunnels))])
            self._leafs = OrderedDict()

            self.global_ = MplsTeStandby.Topology.Global()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"

            self.destination_paths = MplsTeStandby.Topology.DestinationPaths()
            self.destination_paths.parent = self
            self._children_name_map["destination_paths"] = "destination-paths"

            self.configured_srlgs = MplsTeStandby.Topology.ConfiguredSrlgs()
            self.configured_srlgs.parent = self
            self._children_name_map["configured_srlgs"] = "configured-srlgs"

            self.srlgs = MplsTeStandby.Topology.Srlgs()
            self.srlgs.parent = self
            self._children_name_map["srlgs"] = "srlgs"

            self.path_tunnels = MplsTeStandby.Topology.PathTunnels()
            self.path_tunnels.parent = self
            self._children_name_map["path_tunnels"] = "path-tunnels"
            self._segment_path = lambda: "topology"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.Topology, [], name, value)


        class Global(_Entity_):
            """
            Global information about the overall MPLS\-TE
            topology
            
            .. attribute:: hold_down_interval
            
            	Interval in seconds to hold down a neighbor after a signalling error
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: link_add_remove_count
            
            	Link add/remove counter
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: local_model_id
            
            	Local BC Model ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: areas
            
            	Information for areas
            	**type**\: list of  		 :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global.Areas>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Topology.Global, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("areas", ("areas", MplsTeStandby.Topology.Global.Areas))])
                self._leafs = OrderedDict([
                    ('hold_down_interval', (YLeaf(YType.uint32, 'hold-down-interval'), ['int'])),
                    ('link_add_remove_count', (YLeaf(YType.uint32, 'link-add-remove-count'), ['int'])),
                    ('local_model_id', (YLeaf(YType.uint32, 'local-model-id'), ['int'])),
                ])
                self.hold_down_interval = None
                self.link_add_remove_count = None
                self.local_model_id = None

                self.areas = YList(self)
                self._segment_path = lambda: "global"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Topology.Global, ['hold_down_interval', 'link_add_remove_count', 'local_model_id'], name, value)


            class Areas(_Entity_):
                """
                Information for areas
                
                .. attribute:: local_sid_and_srbg
                
                	Local SID and SRBG
                	**type**\:  :py:class:`LocalSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg>`
                
                	**config**\: False
                
                .. attribute:: protocol
                
                	Protocol used
                	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: node_id
                
                	The node's IGP id
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: area_id
                
                	The area's id
                	**type**\: str
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Topology.Global.Areas, self).__init__()

                    self.yang_name = "areas"
                    self.yang_parent_name = "global"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("local-sid-and-srbg", ("local_sid_and_srbg", MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg))])
                    self._leafs = OrderedDict([
                        ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                        ('node_id', (YLeaf(YType.str, 'node-id'), ['str'])),
                        ('area_id', (YLeaf(YType.str, 'area-id'), ['str'])),
                    ])
                    self.protocol = None
                    self.node_id = None
                    self.area_id = None

                    self.local_sid_and_srbg = MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg()
                    self.local_sid_and_srbg.parent = self
                    self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                    self._segment_path = lambda: "areas"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/global/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Topology.Global.Areas, ['protocol', 'node_id', 'area_id'], name, value)


                class LocalSidAndSrbg(_Entity_):
                    """
                    Local SID and SRBG
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg, self).__init__()

                        self.yang_name = "local-sid-and-srbg"
                        self.yang_parent_name = "areas"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                            ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                            ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                            ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                        ])
                        self.segment_id = None
                        self.segment_id_local_absolute_value = None
                        self.srgb_start = None
                        self.srgb_size = None
                        self._segment_path = lambda: "local-sid-and-srbg"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/global/areas/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.Global.Areas.LocalSidAndSrbg']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Topology.Global.Areas']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Topology.Global']['meta_info']


        class DestinationPaths(_Entity_):
            """
            This table models the path calculation
            capabilities in MPLS\-TE.A GET operation for the
            complete table will return no entries.See the
            class DestinationPath for more details.
            
            .. attribute:: destination_path
            
            	A GET operation on this class returns the best available path in the TE topology to reach the specified destination while satisfying the specified constraints
            	**type**\: list of  		 :py:class:`DestinationPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Topology.DestinationPaths, self).__init__()

                self.yang_name = "destination-paths"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("destination-path", ("destination_path", MplsTeStandby.Topology.DestinationPaths.DestinationPath))])
                self._leafs = OrderedDict()

                self.destination_path = YList(self)
                self._segment_path = lambda: "destination-paths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Topology.DestinationPaths, [], name, value)


            class DestinationPath(_Entity_):
                """
                A GET operation on this class returns the best
                available path in the TE topology to reach the
                specified destination while satisfying the
                specified constraints.
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: affinity_bits
                
                	Affinity Bits
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity_mask
                
                	Affinity Mask
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: setup_priority
                
                	Setup Priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority
                
                	Hold Priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth in kbps
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: igp_type
                
                	IGP Type
                	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                	**config**\: False
                
                .. attribute:: igp_instance
                
                	IGP Instance
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: igp_area
                
                	IGP Area
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hop_limit
                
                	Hop Limit
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_ip_address
                
                	Exclude SRLG IP Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: path_type
                
                	Path Type
                	**type**\:  :py:class:`MplsTePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePath>`
                
                	**config**\: False
                
                .. attribute:: path_id
                
                	This is the ID of the explicit path to be used for this path calculation query
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: path_name
                
                	This is the name of the explicit path to be used for this path calculation query
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: cost_limit
                
                	Cost Limit
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: metric_type
                
                	Metric Type
                	**type**\:  :py:class:`MplsTePathSelectionMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathSelectionMetric>`
                
                	**config**\: False
                
                .. attribute:: delay_limit
                
                	Delay Limit in usec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of  		 :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of  		 :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath, self).__init__()

                    self.yang_name = "destination-path"
                    self.yang_parent_name = "destination-paths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity)), ("hop", ("hop", MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup)), ("sr-segment", ("sr_segment", MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment))])
                    self._leafs = OrderedDict([
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                        ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ('setup_priority', (YLeaf(YType.uint32, 'setup-priority'), ['int'])),
                        ('hold_priority', (YLeaf(YType.uint32, 'hold-priority'), ['int'])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                        ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                        ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                        ('hop_limit', (YLeaf(YType.uint32, 'hop-limit'), ['int'])),
                        ('exclude_srlg_ip_address', (YLeaf(YType.str, 'exclude-srlg-ip-address'), ['str'])),
                        ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePath', '')])),
                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                        ('path_name', (YLeaf(YType.str, 'path-name'), ['str'])),
                        ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                        ('metric_type', (YLeaf(YType.enumeration, 'metric-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTePathSelectionMetric', '')])),
                        ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('is_partial_path', (YLeaf(YType.boolean, 'is-partial-path'), ['bool'])),
                        ('is_full_path', (YLeaf(YType.boolean, 'is-full-path'), ['bool'])),
                        ('is_topology_checked', (YLeaf(YType.boolean, 'is-topology-checked'), ['bool'])),
                        ('is_segment_routing_db_checked', (YLeaf(YType.boolean, 'is-segment-routing-db-checked'), ['bool'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint64, 'bandwidth-type'), ['int'])),
                        ('mininum_bandwidth', (YLeaf(YType.uint64, 'mininum-bandwidth'), ['int'])),
                        ('accumulated_admin_weight', (YLeaf(YType.uint64, 'accumulated-admin-weight'), ['int'])),
                        ('setup_priority_xr', (YLeaf(YType.uint32, 'setup-priority-xr'), ['int'])),
                        ('hold_priority_xr', (YLeaf(YType.uint32, 'hold-priority-xr'), ['int'])),
                        ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                        ('exclude_srlg_address', (YLeaf(YType.str, 'exclude-srlg-address'), ['str'])),
                    ])
                    self.destination_address = None
                    self.affinity_bits = None
                    self.affinity_mask = None
                    self.setup_priority = None
                    self.hold_priority = None
                    self.bandwidth = None
                    self.igp_type = None
                    self.igp_instance = None
                    self.igp_area = None
                    self.hop_limit = None
                    self.exclude_srlg_ip_address = None
                    self.path_type = None
                    self.path_id = None
                    self.path_name = None
                    self.cost_limit = None
                    self.metric_type = None
                    self.delay_limit = None
                    self.tunnel_id_xr = None
                    self.destination_address_xr = None
                    self.is_partial_path = None
                    self.is_full_path = None
                    self.is_topology_checked = None
                    self.is_segment_routing_db_checked = None
                    self.requested_bandwidth = None
                    self.bandwidth_type = None
                    self.mininum_bandwidth = None
                    self.accumulated_admin_weight = None
                    self.setup_priority_xr = None
                    self.hold_priority_xr = None
                    self.node_hop_count = None
                    self.exclude_srlg_address = None

                    self.affinity = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)
                    self._segment_path = lambda: "destination-path"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath, ['destination_address', 'affinity_bits', 'affinity_mask', 'setup_priority', 'hold_priority', 'bandwidth', 'igp_type', 'igp_instance', 'igp_area', 'hop_limit', 'exclude_srlg_ip_address', 'path_type', 'path_id', 'path_name', 'cost_limit', 'metric_type', 'delay_limit', 'tunnel_id_xr', 'destination_address_xr', 'is_partial_path', 'is_full_path', 'is_topology_checked', 'is_segment_routing_db_checked', 'requested_bandwidth', 'bandwidth_type', 'mininum_bandwidth', 'accumulated_admin_weight', 'setup_priority_xr', 'hold_priority_xr', 'node_hop_count', 'exclude_srlg_address'], name, value)


                class Affinity(_Entity_):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity))])
                        self._leafs = OrderedDict([
                            ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                            ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ])
                        self.affinity_bits = None
                        self.affinity_mask = None

                        self.named_affinity = YList(self)
                        self._segment_path = lambda: "affinity"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                    class NamedAffinity(_Entity_):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                            self._leafs = OrderedDict([
                                ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                            ])
                            self.constraint_type = None
                            self.constraint_value = None
                            self.forward_ref_value = None

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)
                            self._segment_path = lambda: "named-affinity"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                        class ConstraintExtendedValue(_Entity_):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	Constraint value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "constraint-extended-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                        class ExtendedForwardRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "extended-forward-ref-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity']['meta_info']


                class Hop(_Entity_):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	The path's array of hops
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "hop"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup']['meta_info']


                class SrSegment(_Entity_):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "destination-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                            ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                            ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                            ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                        ])
                        self.sid_type = None
                        self.has_ip_addresses = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.has_mpls_label = None
                        self.mpls_label_value = None
                        self.has_entropy_label = None
                        self._segment_path = lambda: "sr-segment"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Topology.DestinationPaths.DestinationPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Topology.DestinationPaths']['meta_info']


        class ConfiguredSrlgs(_Entity_):
            """
            Set of configured SRLG
            
            .. attribute:: configured_srlg
            
            	Configured SRLG value and the addresses using it
            	**type**\: list of  		 :py:class:`ConfiguredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Topology.ConfiguredSrlgs, self).__init__()

                self.yang_name = "configured-srlgs"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("configured-srlg", ("configured_srlg", MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg))])
                self._leafs = OrderedDict()

                self.configured_srlg = YList(self)
                self._segment_path = lambda: "configured-srlgs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Topology.ConfiguredSrlgs, [], name, value)


            class ConfiguredSrlg(_Entity_):
                """
                Configured SRLG value and the addresses using
                it
                
                .. attribute:: srlg_number  (key)
                
                	SRLG Number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_number_xr
                
                	SRLG number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: is_admin_weight_configured
                
                	Set to TRUE if the admin weight is explicitely configured
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: srlg_link
                
                	Link associated with the SRLG
                	**type**\: list of  		 :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__init__()

                    self.yang_name = "configured-srlg"
                    self.yang_parent_name = "configured-srlgs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['srlg_number']
                    self._child_classes = OrderedDict([("srlg-link", ("srlg_link", MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink))])
                    self._leafs = OrderedDict([
                        ('srlg_number', (YLeaf(YType.uint32, 'srlg-number'), ['int'])),
                        ('srlg_number_xr', (YLeaf(YType.uint32, 'srlg-number-xr'), ['int'])),
                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                        ('is_admin_weight_configured', (YLeaf(YType.boolean, 'is-admin-weight-configured'), ['bool'])),
                    ])
                    self.srlg_number = None
                    self.srlg_number_xr = None
                    self.srlg_name = None
                    self.admin_weight = None
                    self.is_admin_weight_configured = None

                    self.srlg_link = YList(self)
                    self._segment_path = lambda: "configured-srlg" + "[srlg-number='" + str(self.srlg_number) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/configured-srlgs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg, ['srlg_number', 'srlg_number_xr', 'srlg_name', 'admin_weight', 'is_admin_weight_configured'], name, value)


                class SrlgLink(_Entity_):
                    """
                    Link associated with the SRLG
                    
                    .. attribute:: local_address
                    
                    	Local address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_address
                    
                    	Remote address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__init__()

                        self.yang_name = "srlg-link"
                        self.yang_parent_name = "configured-srlg"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('local_address', (YLeaf(YType.str, 'local-address'), ['str'])),
                            ('remote_address', (YLeaf(YType.str, 'remote-address'), ['str'])),
                        ])
                        self.local_address = None
                        self.remote_address = None
                        self._segment_path = lambda: "srlg-link"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, ['local_address', 'remote_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Topology.ConfiguredSrlgs']['meta_info']


        class Srlgs(_Entity_):
            """
            Set of SRLG operational value for the overall
            MPLS\-TE topology
            
            .. attribute:: srlg
            
            	SRLG operational value for the overall MPLS\-TE topology
            	**type**\: list of  		 :py:class:`Srlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Topology.Srlgs, self).__init__()

                self.yang_name = "srlgs"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("srlg", ("srlg", MplsTeStandby.Topology.Srlgs.Srlg))])
                self._leafs = OrderedDict()

                self.srlg = YList(self)
                self._segment_path = lambda: "srlgs"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Topology.Srlgs, [], name, value)


            class Srlg(_Entity_):
                """
                SRLG operational value for the overall MPLS\-TE
                topology
                
                .. attribute:: srlg_number  (key)
                
                	SRLG Number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_areas
                
                	Topology areas in this SRLG
                	**type**\: list of  		 :py:class:`SrlgAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Topology.Srlgs.Srlg, self).__init__()

                    self.yang_name = "srlg"
                    self.yang_parent_name = "srlgs"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['srlg_number']
                    self._child_classes = OrderedDict([("srlg-areas", ("srlg_areas", MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas))])
                    self._leafs = OrderedDict([
                        ('srlg_number', (YLeaf(YType.uint32, 'srlg-number'), ['int'])),
                        ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ('admin_weight', (YLeaf(YType.uint32, 'admin-weight'), ['int'])),
                    ])
                    self.srlg_number = None
                    self.srlg_name = None
                    self.admin_weight = None

                    self.srlg_areas = YList(self)
                    self._segment_path = lambda: "srlg" + "[srlg-number='" + str(self.srlg_number) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/srlgs/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg, ['srlg_number', 'srlg_name', 'admin_weight'], name, value)


                class SrlgAreas(_Entity_):
                    """
                    Topology areas in this SRLG
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    	**config**\: False
                    
                    .. attribute:: igp_instance
                    
                    	IGP Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_link
                    
                    	Links in this SRLG/area
                    	**type**\: list of  		 :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas, self).__init__()

                        self.yang_name = "srlg-areas"
                        self.yang_parent_name = "srlg"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlg-link", ("srlg_link", MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink))])
                        self._leafs = OrderedDict([
                            ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                            ('igp_instance', (YLeaf(YType.str, 'igp-instance'), ['str'])),
                            ('igp_area', (YLeaf(YType.uint32, 'igp-area'), ['int'])),
                            ('igp_area_format', (YLeaf(YType.enumeration, 'igp-area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ])
                        self.igp_type = None
                        self.igp_instance = None
                        self.igp_area = None
                        self.igp_area_format = None

                        self.srlg_link = YList(self)
                        self._segment_path = lambda: "srlg-areas"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas, ['igp_type', 'igp_instance', 'igp_area', 'igp_area_format'], name, value)


                    class SrlgLink(_Entity_):
                        """
                        Links in this SRLG/area
                        
                        .. attribute:: link_address_generic
                        
                        	Link address
                        	**type**\:  :py:class:`LinkAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric>`
                        
                        	**config**\: False
                        
                        .. attribute:: link_address
                        
                        	Link address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: te_router_id
                        
                        	Link TE router\-id
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__init__()

                            self.yang_name = "srlg-link"
                            self.yang_parent_name = "srlg-areas"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("link-address-generic", ("link_address_generic", MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric))])
                            self._leafs = OrderedDict([
                                ('link_address', (YLeaf(YType.str, 'link-address'), ['str'])),
                                ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                            ])
                            self.link_address = None
                            self.te_router_id = None

                            self.link_address_generic = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                            self.link_address_generic.parent = self
                            self._children_name_map["link_address_generic"] = "link-address-generic"
                            self._segment_path = lambda: "srlg-link"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, ['link_address', 'te_router_id'], name, value)


                        class LinkAddressGeneric(_Entity_):
                            """
                            Link address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, self).__init__()

                                self.yang_name = "link-address-generic"
                                self.yang_parent_name = "srlg-link"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("te-addr", ("te_addr", MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr))])
                                self._leafs = OrderedDict()

                                self.te_addr = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._segment_path = lambda: "link-address-generic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, [], name, value)


                            class TeAddr(_Entity_):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:  :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                	**config**\: False
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:  :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                	**config**\: False
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "link-address-generic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("ipv4-unnumbered-address", ("ipv4_unnumbered_address", MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress))])
                                    self._leafs = OrderedDict([
                                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAddr', '')])),
                                        ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                    ])
                                    self.type = None
                                    self.ipv4_address = None

                                    self.ipv4_unnumbered_address = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._segment_path = lambda: "te-addr"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, ['type', 'ipv4_address'], name, value)


                                class Ipv4UnnumberedAddress(_Entity_):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('router_id', (YLeaf(YType.str, 'router-id'), ['str'])),
                                            ('interface_index', (YLeaf(YType.uint32, 'interface-index'), ['int'])),
                                        ])
                                        self.router_id = None
                                        self.interface_index = None
                                        self._segment_path = lambda: "ipv4-unnumbered-address"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, ['router_id', 'interface_index'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Topology.Srlgs.Srlg']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Topology.Srlgs']['meta_info']


        class PathTunnels(_Entity_):
            """
            MPLS\-Te topology path info
            
            .. attribute:: path_tunnel
            
            	MPLS\-TE topology path taken by the specified tunnel
            	**type**\: list of  		 :py:class:`PathTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Topology.PathTunnels, self).__init__()

                self.yang_name = "path-tunnels"
                self.yang_parent_name = "topology"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-tunnel", ("path_tunnel", MplsTeStandby.Topology.PathTunnels.PathTunnel))])
                self._leafs = OrderedDict()

                self.path_tunnel = YList(self)
                self._segment_path = lambda: "path-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Topology.PathTunnels, [], name, value)


            class PathTunnel(_Entity_):
                """
                MPLS\-TE topology path taken by the specified
                tunnel
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of  		 :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of  		 :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel, self).__init__()

                    self.yang_name = "path-tunnel"
                    self.yang_parent_name = "path-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity)), ("hop", ("hop", MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup)), ("sr-segment", ("sr_segment", MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('is_partial_path', (YLeaf(YType.boolean, 'is-partial-path'), ['bool'])),
                        ('is_full_path', (YLeaf(YType.boolean, 'is-full-path'), ['bool'])),
                        ('is_topology_checked', (YLeaf(YType.boolean, 'is-topology-checked'), ['bool'])),
                        ('is_segment_routing_db_checked', (YLeaf(YType.boolean, 'is-segment-routing-db-checked'), ['bool'])),
                        ('requested_bandwidth', (YLeaf(YType.uint64, 'requested-bandwidth'), ['int'])),
                        ('bandwidth_type', (YLeaf(YType.uint64, 'bandwidth-type'), ['int'])),
                        ('mininum_bandwidth', (YLeaf(YType.uint64, 'mininum-bandwidth'), ['int'])),
                        ('accumulated_admin_weight', (YLeaf(YType.uint64, 'accumulated-admin-weight'), ['int'])),
                        ('setup_priority_xr', (YLeaf(YType.uint32, 'setup-priority-xr'), ['int'])),
                        ('hold_priority_xr', (YLeaf(YType.uint32, 'hold-priority-xr'), ['int'])),
                        ('node_hop_count', (YLeaf(YType.uint8, 'node-hop-count'), ['int'])),
                        ('exclude_srlg_address', (YLeaf(YType.str, 'exclude-srlg-address'), ['str'])),
                    ])
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.tunnel_id_xr = None
                    self.destination_address_xr = None
                    self.is_partial_path = None
                    self.is_full_path = None
                    self.is_topology_checked = None
                    self.is_segment_routing_db_checked = None
                    self.requested_bandwidth = None
                    self.bandwidth_type = None
                    self.mininum_bandwidth = None
                    self.accumulated_admin_weight = None
                    self.setup_priority_xr = None
                    self.hold_priority_xr = None
                    self.node_hop_count = None
                    self.exclude_srlg_address = None

                    self.affinity = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)
                    self._segment_path = lambda: "path-tunnel"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel, ['tunnel_id', 'tunnel_name', 'tunnel_id_xr', 'destination_address_xr', 'is_partial_path', 'is_full_path', 'is_topology_checked', 'is_segment_routing_db_checked', 'requested_bandwidth', 'bandwidth_type', 'mininum_bandwidth', 'accumulated_admin_weight', 'setup_priority_xr', 'hold_priority_xr', 'node_hop_count', 'exclude_srlg_address'], name, value)


                class Affinity(_Entity_):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity))])
                        self._leafs = OrderedDict([
                            ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                            ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                        ])
                        self.affinity_bits = None
                        self.affinity_mask = None

                        self.named_affinity = YList(self)
                        self._segment_path = lambda: "affinity"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                    class NamedAffinity(_Entity_):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        	**config**\: False
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                            self._leafs = OrderedDict([
                                ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                            ])
                            self.constraint_type = None
                            self.constraint_value = None
                            self.forward_ref_value = None

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)
                            self._segment_path = lambda: "named-affinity"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                        class ConstraintExtendedValue(_Entity_):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	Constraint value
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "constraint-extended-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                        class ExtendedForwardRefValue(_Entity_):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	Reference bits for undefined affinity names
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "extended-forward-ref-value"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity']['meta_info']


                class Hop(_Entity_):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	The path's array of hops
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "hop"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup']['meta_info']


                class SrSegment(_Entity_):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:  :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    	**config**\: False
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "path-tunnel"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('sid_type', (YLeaf(YType.enumeration, 'sid-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSrSid', '')])),
                            ('has_ip_addresses', (YLeaf(YType.boolean, 'has-ip-addresses'), ['bool'])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('has_mpls_label', (YLeaf(YType.boolean, 'has-mpls-label'), ['bool'])),
                            ('mpls_label_value', (YLeaf(YType.uint32, 'mpls-label-value'), ['int'])),
                            ('has_entropy_label', (YLeaf(YType.boolean, 'has-entropy-label'), ['bool'])),
                        ])
                        self.sid_type = None
                        self.has_ip_addresses = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.has_mpls_label = None
                        self.mpls_label_value = None
                        self.has_entropy_label = None
                        self._segment_path = lambda: "sr-segment"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment, ['sid_type', 'has_ip_addresses', 'local_addr', 'remote_addr', 'has_mpls_label', 'mpls_label_value', 'has_entropy_label'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Topology.PathTunnels.PathTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Topology.PathTunnels']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.Topology']['meta_info']


    class SignallingCounters(_Entity_):
        """
        TE counters
        
        .. attribute:: issu
        
        	MPLS TE ISSU counters
        	**type**\:  :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Issu>`
        
        	**config**\: False
        
        .. attribute:: fsm_unexpected_event_stats
        
        	TE S2L FSM unexpected event stats
        	**type**\:  :py:class:`FsmUnexpectedEventStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats>`
        
        	**config**\: False
        
        .. attribute:: head_signalling_counters
        
        	Sig Head Table TE counters
        	**type**\:  :py:class:`HeadSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters>`
        
        	**config**\: False
        
        .. attribute:: remote_signalling_counters
        
        	Sig mid tail Table TE counters
        	**type**\:  :py:class:`RemoteSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters>`
        
        	**config**\: False
        
        .. attribute:: signallings
        
        	TE counters
        	**type**\:  :py:class:`Signallings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings>`
        
        	**config**\: False
        
        .. attribute:: signalling_summary
        
        	Send\-Recv count summary for TE Signaling
        	**type**\:  :py:class:`SignallingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.SignallingSummary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.SignallingCounters, self).__init__()

            self.yang_name = "signalling-counters"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("issu", ("issu", MplsTeStandby.SignallingCounters.Issu)), ("fsm-unexpected-event-stats", ("fsm_unexpected_event_stats", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats)), ("head-signalling-counters", ("head_signalling_counters", MplsTeStandby.SignallingCounters.HeadSignallingCounters)), ("remote-signalling-counters", ("remote_signalling_counters", MplsTeStandby.SignallingCounters.RemoteSignallingCounters)), ("signallings", ("signallings", MplsTeStandby.SignallingCounters.Signallings)), ("signalling-summary", ("signalling_summary", MplsTeStandby.SignallingCounters.SignallingSummary))])
            self._leafs = OrderedDict()

            self.issu = MplsTeStandby.SignallingCounters.Issu()
            self.issu.parent = self
            self._children_name_map["issu"] = "issu"

            self.fsm_unexpected_event_stats = MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats()
            self.fsm_unexpected_event_stats.parent = self
            self._children_name_map["fsm_unexpected_event_stats"] = "fsm-unexpected-event-stats"

            self.head_signalling_counters = MplsTeStandby.SignallingCounters.HeadSignallingCounters()
            self.head_signalling_counters.parent = self
            self._children_name_map["head_signalling_counters"] = "head-signalling-counters"

            self.remote_signalling_counters = MplsTeStandby.SignallingCounters.RemoteSignallingCounters()
            self.remote_signalling_counters.parent = self
            self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"

            self.signallings = MplsTeStandby.SignallingCounters.Signallings()
            self.signallings.parent = self
            self._children_name_map["signallings"] = "signallings"

            self.signalling_summary = MplsTeStandby.SignallingCounters.SignallingSummary()
            self.signalling_summary.parent = self
            self._children_name_map["signalling_summary"] = "signalling-summary"
            self._segment_path = lambda: "signalling-counters"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.SignallingCounters, [], name, value)


        class Issu(_Entity_):
            """
            MPLS TE ISSU counters
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp, in seconds, when these statistics are cleared              since 00\:00\:00 UTC, January 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            .. attribute:: last_idt_states
            
            	Last IDT States
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_states
            
            	Total states
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_deletions
            
            	Total deletions
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: total_nac_ks
            
            	Total NACKs
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: total_id_ts
            
            	Total IDTs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.Issu, self).__init__()

                self.yang_name = "issu"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                    ('last_idt_states', (YLeaf(YType.uint32, 'last-idt-states'), ['int'])),
                    ('total_states', (YLeaf(YType.uint32, 'total-states'), ['int'])),
                    ('total_deletions', (YLeaf(YType.uint32, 'total-deletions'), ['int'])),
                    ('total_nac_ks', (YLeaf(YType.uint64, 'total-nac-ks'), ['int'])),
                    ('total_id_ts', (YLeaf(YType.uint32, 'total-id-ts'), ['int'])),
                ])
                self.last_cleared_timestamp = None
                self.role = None
                self.last_idt_states = None
                self.total_states = None
                self.total_deletions = None
                self.total_nac_ks = None
                self.total_id_ts = None
                self._segment_path = lambda: "issu"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.Issu, ['last_cleared_timestamp', 'role', 'last_idt_states', 'total_states', 'total_deletions', 'total_nac_ks', 'total_id_ts'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.Issu']['meta_info']


        class FsmUnexpectedEventStats(_Entity_):
            """
            TE S2L FSM unexpected event stats
            
            .. attribute:: head_fsm_events
            
            	FSM unexpected event stats for headend S2Ls
            	**type**\:  :py:class:`HeadFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: mid_fsm_events
            
            	FSM unexpected event stats for midpoint S2Ls
            	**type**\:  :py:class:`MidFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: tail_fsm_events
            
            	FSM unexpected event stats for tailend S2Ls
            	**type**\:  :py:class:`TailFsmEvents <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents>`
            
            	**config**\: False
            
            .. attribute:: last_cleared_time
            
            	Timestamp when the stat has been cleared
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: unexpected_event_num
            
            	Total number of unexpected events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats, self).__init__()

                self.yang_name = "fsm-unexpected-event-stats"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-fsm-events", ("head_fsm_events", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents)), ("mid-fsm-events", ("mid_fsm_events", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents)), ("tail-fsm-events", ("tail_fsm_events", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents))])
                self._leafs = OrderedDict([
                    ('last_cleared_time', (YLeaf(YType.uint32, 'last-cleared-time'), ['int'])),
                    ('unexpected_event_num', (YLeaf(YType.uint32, 'unexpected-event-num'), ['int'])),
                ])
                self.last_cleared_time = None
                self.unexpected_event_num = None

                self.head_fsm_events = MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents()
                self.head_fsm_events.parent = self
                self._children_name_map["head_fsm_events"] = "head-fsm-events"

                self.mid_fsm_events = MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents()
                self.mid_fsm_events.parent = self
                self._children_name_map["mid_fsm_events"] = "mid-fsm-events"

                self.tail_fsm_events = MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents()
                self.tail_fsm_events.parent = self
                self._children_name_map["tail_fsm_events"] = "tail-fsm-events"
                self._segment_path = lambda: "fsm-unexpected-event-stats"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats, ['last_cleared_time', 'unexpected_event_num'], name, value)


            class HeadFsmEvents(_Entity_):
                """
                FSM unexpected event stats for headend S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents, self).__init__()

                    self.yang_name = "head-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "head-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "head-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/head-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.HeadFsmEvents']['meta_info']


            class MidFsmEvents(_Entity_):
                """
                FSM unexpected event stats for midpoint S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents, self).__init__()

                    self.yang_name = "mid-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "mid-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "mid-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/mid-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.MidFsmEvents']['meta_info']


            class TailFsmEvents(_Entity_):
                """
                FSM unexpected event stats for tailend S2Ls
                
                .. attribute:: te_s2l_fsm_stats_array
                
                	te s2l fsm stats array
                	**type**\: list of  		 :py:class:`TeS2lFsmStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents, self).__init__()

                    self.yang_name = "tail-fsm-events"
                    self.yang_parent_name = "fsm-unexpected-event-stats"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("te-s2l-fsm-stats-array", ("te_s2l_fsm_stats_array", MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray))])
                    self._leafs = OrderedDict()

                    self.te_s2l_fsm_stats_array = YList(self)
                    self._segment_path = lambda: "tail-fsm-events"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents, [], name, value)


                class TeS2lFsmStatsArray(_Entity_):
                    """
                    te s2l fsm stats array
                    
                    .. attribute:: te_s2l_fsm_event_array
                    
                    	te s2l fsm event array
                    	**type**\: list of int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray, self).__init__()

                        self.yang_name = "te-s2l-fsm-stats-array"
                        self.yang_parent_name = "tail-fsm-events"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('te_s2l_fsm_event_array', (YLeafList(YType.uint32, 'te-s2l-fsm-event-array'), ['int'])),
                        ])
                        self.te_s2l_fsm_event_array = []
                        self._segment_path = lambda: "te-s2l-fsm-stats-array"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/fsm-unexpected-event-stats/tail-fsm-events/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray, ['te_s2l_fsm_event_array'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents.TeS2lFsmStatsArray']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats.TailFsmEvents']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.FsmUnexpectedEventStats']['meta_info']


        class HeadSignallingCounters(_Entity_):
            """
            Sig Head Table TE counters
            
            .. attribute:: head_signalling_counter
            
            	TE stats
            	**type**\: list of  		 :py:class:`HeadSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters, self).__init__()

                self.yang_name = "head-signalling-counters"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-signalling-counter", ("head_signalling_counter", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter))])
                self._leafs = OrderedDict()

                self.head_signalling_counter = YList(self)
                self._segment_path = lambda: "head-signalling-counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters, [], name, value)


            class HeadSignallingCounter(_Entity_):
                """
                TE stats
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of  		 :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__init__()

                    self.yang_name = "head-signalling-counter"
                    self.yang_parent_name = "head-signalling-counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id']
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics)), ("destination-statistic", ("destination_statistic", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.tunnel_sig_name = None
                    self.lsp_id = None

                    self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.destination_statistic = YList(self)
                    self._segment_path = lambda: "head-signalling-counter" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/head-signalling-counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, ['ctype', 'tunnel_id', 'tunnel_name', 'tunnel_sig_name', 'lsp_id'], name, value)


                class Statistics(_Entity_):
                    """
                    VIF stats
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "head-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                        ])
                        self.tx_event_unknown = None
                        self.tx_path_create_event = None
                        self.tx_path_change_event = None
                        self.tx_path_delete_event = None
                        self.tx_path_error_event = None
                        self.tx_resv_create_event = None
                        self.tx_resv_change_event = None
                        self.tx_resv_delete_event = None
                        self.tx_resv_error_event = None
                        self.tx_path_reeval_query_event = None
                        self.rx_event_unknown = None
                        self.rx_path_create_event = None
                        self.rx_path_change_event = None
                        self.rx_path_delete_event = None
                        self.rx_path_error_event = None
                        self.rx_resv_create_event = None
                        self.rx_resv_change_event = None
                        self.rx_resv_delete_event = None
                        self.rx_resv_error_event = None
                        self.rx_path_reeval_query_event = None
                        self.tx_backup_assign_event = None
                        self.rx_backup_assign_err_event = None
                        self.events_total_count = None
                        self.events_count = None
                        self._segment_path = lambda: "statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics']['meta_info']


                class DestinationStatistic(_Entity_):
                    """
                    List of Destination Stats
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "head-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic))])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ])
                        self.destination_address = None

                        self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"

                        self.s2l_statistic = YList(self)
                        self._segment_path = lambda: "destination-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, ['destination_address'], name, value)


                    class Statistics(_Entity_):
                        """
                        Destination stats
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                            ])
                            self.tx_event_unknown = None
                            self.tx_path_create_event = None
                            self.tx_path_change_event = None
                            self.tx_path_delete_event = None
                            self.tx_path_error_event = None
                            self.tx_resv_create_event = None
                            self.tx_resv_change_event = None
                            self.tx_resv_delete_event = None
                            self.tx_resv_error_event = None
                            self.tx_path_reeval_query_event = None
                            self.rx_event_unknown = None
                            self.rx_path_create_event = None
                            self.rx_path_change_event = None
                            self.rx_path_delete_event = None
                            self.rx_path_error_event = None
                            self.rx_resv_create_event = None
                            self.rx_resv_change_event = None
                            self.rx_resv_delete_event = None
                            self.rx_resv_error_event = None
                            self.rx_path_reeval_query_event = None
                            self.tx_backup_assign_event = None
                            self.rx_backup_assign_err_event = None
                            self.events_total_count = None
                            self.events_count = None
                            self._segment_path = lambda: "statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics']['meta_info']


                    class S2lStatistic(_Entity_):
                        """
                        List of S2L Stats
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics))])
                            self._leafs = OrderedDict([
                                ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ])
                            self.sub_group_originator = None
                            self.sub_group_id = None
                            self.destination_address = None

                            self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._segment_path = lambda: "s2l-statistic"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                        class Statistics(_Entity_):
                            """
                            S2L stats
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic.Statistics']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2lStatistic']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.HeadSignallingCounters']['meta_info']


        class RemoteSignallingCounters(_Entity_):
            """
            Sig mid tail Table TE counters
            
            .. attribute:: remote_signalling_counter
            
            	TE stats
            	**type**\: list of  		 :py:class:`RemoteSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters, self).__init__()

                self.yang_name = "remote-signalling-counters"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("remote-signalling-counter", ("remote_signalling_counter", MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter))])
                self._leafs = OrderedDict()

                self.remote_signalling_counter = YList(self)
                self._segment_path = lambda: "remote-signalling-counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.RemoteSignallingCounters, [], name, value)


            class RemoteSignallingCounter(_Entity_):
                """
                TE stats
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup originator
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__init__()

                    self.yang_name = "remote-signalling-counter"
                    self.yang_parent_name = "remote-signalling-counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id','extended_tunnel_id','p2mp_id','lsp_id','source_address','destination_address','sub_group_originator','sub_group_id']
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.p2mp_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.sub_group_originator = None
                    self.sub_group_id = None
                    self.tunnel_name = None

                    self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"

                    self.s2l_statistic = YList(self)
                    self._segment_path = lambda: "remote-signalling-counter" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/remote-signalling-counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, ['ctype', 'tunnel_id', 'extended_tunnel_id', 'p2mp_id', 'lsp_id', 'source_address', 'destination_address', 'sub_group_originator', 'sub_group_id', 'tunnel_name'], name, value)


                class Statistics(_Entity_):
                    """
                    LSP statistics
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "remote-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                        ])
                        self.tx_event_unknown = None
                        self.tx_path_create_event = None
                        self.tx_path_change_event = None
                        self.tx_path_delete_event = None
                        self.tx_path_error_event = None
                        self.tx_resv_create_event = None
                        self.tx_resv_change_event = None
                        self.tx_resv_delete_event = None
                        self.tx_resv_error_event = None
                        self.tx_path_reeval_query_event = None
                        self.rx_event_unknown = None
                        self.rx_path_create_event = None
                        self.rx_path_change_event = None
                        self.rx_path_delete_event = None
                        self.rx_path_error_event = None
                        self.rx_resv_create_event = None
                        self.rx_resv_change_event = None
                        self.rx_resv_delete_event = None
                        self.rx_resv_error_event = None
                        self.rx_path_reeval_query_event = None
                        self.tx_backup_assign_event = None
                        self.rx_backup_assign_err_event = None
                        self.events_total_count = None
                        self.events_count = None
                        self._segment_path = lambda: "statistics"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics']['meta_info']


                class S2lStatistic(_Entity_):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "remote-signalling-counter"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics))])
                        self._leafs = OrderedDict([
                            ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                            ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ])
                        self.sub_group_originator = None
                        self.sub_group_id = None
                        self.destination_address = None

                        self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._segment_path = lambda: "s2l-statistic"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                    class Statistics(_Entity_):
                        """
                        S2L stats
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                            ])
                            self.tx_event_unknown = None
                            self.tx_path_create_event = None
                            self.tx_path_change_event = None
                            self.tx_path_delete_event = None
                            self.tx_path_error_event = None
                            self.tx_resv_create_event = None
                            self.tx_resv_change_event = None
                            self.tx_resv_delete_event = None
                            self.tx_resv_error_event = None
                            self.tx_path_reeval_query_event = None
                            self.rx_event_unknown = None
                            self.rx_path_create_event = None
                            self.rx_path_change_event = None
                            self.rx_path_delete_event = None
                            self.rx_path_error_event = None
                            self.rx_resv_create_event = None
                            self.rx_resv_change_event = None
                            self.rx_resv_delete_event = None
                            self.rx_resv_error_event = None
                            self.rx_path_reeval_query_event = None
                            self.tx_backup_assign_event = None
                            self.rx_backup_assign_err_event = None
                            self.events_total_count = None
                            self.events_count = None
                            self._segment_path = lambda: "statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic.Statistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2lStatistic']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.RemoteSignallingCounters']['meta_info']


        class Signallings(_Entity_):
            """
            TE counters
            
            .. attribute:: signalling
            
            	TE Sig
            	**type**\: list of  		 :py:class:`Signalling <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.Signallings, self).__init__()

                self.yang_name = "signallings"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("signalling", ("signalling", MplsTeStandby.SignallingCounters.Signallings.Signalling))])
                self._leafs = OrderedDict()

                self.signalling = YList(self)
                self._segment_path = lambda: "signallings"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings, [], name, value)


            class Signalling(_Entity_):
                """
                TE Sig
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup originator
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_signalling_filter_data
                
                	TE Signaling Filter data
                	**type**\:  :py:class:`TeSignallingFilterData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling, self).__init__()

                    self.yang_name = "signalling"
                    self.yang_parent_name = "signallings"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['ctype','tunnel_id','extended_tunnel_id','p2mp_id','lsp_id','source_address','destination_address','sub_group_originator','sub_group_id']
                    self._child_classes = OrderedDict([("te-signalling-filter-data", ("te_signalling_filter_data", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.p2mp_id = None
                    self.lsp_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.sub_group_originator = None
                    self.sub_group_id = None

                    self.te_signalling_filter_data = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                    self.te_signalling_filter_data.parent = self
                    self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                    self._segment_path = lambda: "signalling" + "[ctype='" + str(self.ctype) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/signallings/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling, ['ctype', 'tunnel_id', 'extended_tunnel_id', 'p2mp_id', 'lsp_id', 'source_address', 'destination_address', 'sub_group_originator', 'sub_group_id'], name, value)


                class TeSignallingFilterData(_Entity_):
                    """
                    TE Signaling Filter data
                    
                    .. attribute:: te_signalling_filter_vif
                    
                    	VIF data
                    	**type**\:  :py:class:`TeSignallingFilterVif <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif>`
                    
                    	**config**\: False
                    
                    .. attribute:: te_signalling_filter_lsp
                    
                    	LSP data
                    	**type**\:  :py:class:`TeSignallingFilterLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: statistics_filter
                    
                    	StatisticsFilter
                    	**type**\:  :py:class:`TeStatsSigFilter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeStatsSigFilter>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__init__()

                        self.yang_name = "te-signalling-filter-data"
                        self.yang_parent_name = "signalling"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("te-signalling-filter-vif", ("te_signalling_filter_vif", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif)), ("te-signalling-filter-lsp", ("te_signalling_filter_lsp", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp))])
                        self._leafs = OrderedDict([
                            ('statistics_filter', (YLeaf(YType.enumeration, 'statistics-filter'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeStatsSigFilter', '')])),
                        ])
                        self.statistics_filter = None

                        self.te_signalling_filter_vif = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                        self.te_signalling_filter_vif.parent = self
                        self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"

                        self.te_signalling_filter_lsp = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                        self.te_signalling_filter_lsp.parent = self
                        self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                        self._segment_path = lambda: "te-signalling-filter-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, ['statistics_filter'], name, value)


                    class TeSignallingFilterVif(_Entity_):
                        """
                        VIF data
                        
                        .. attribute:: statistics
                        
                        	VIF stats
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_sig_name
                        
                        	Tunnel Signalled\-Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_id
                        
                        	LSP ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: destination_statistic
                        
                        	List of Destination Stats
                        	**type**\: list of  		 :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__init__()

                            self.yang_name = "te-signalling-filter-vif"
                            self.yang_parent_name = "te-signalling-filter-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics)), ("destination-statistic", ("destination_statistic", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic))])
                            self._leafs = OrderedDict([
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                                ('tunnel_sig_name', (YLeaf(YType.str, 'tunnel-sig-name'), ['str'])),
                                ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ])
                            self.tunnel_name = None
                            self.tunnel_sig_name = None
                            self.lsp_id = None

                            self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"

                            self.destination_statistic = YList(self)
                            self._segment_path = lambda: "te-signalling-filter-vif"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, ['tunnel_name', 'tunnel_sig_name', 'lsp_id'], name, value)


                        class Statistics(_Entity_):
                            """
                            VIF stats
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-vif"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics']['meta_info']


                        class DestinationStatistic(_Entity_):
                            """
                            List of Destination Stats
                            
                            .. attribute:: statistics
                            
                            	Destination stats
                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_statistic
                            
                            	List of S2L Stats
                            	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__init__()

                                self.yang_name = "destination-statistic"
                                self.yang_parent_name = "te-signalling-filter-vif"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic))])
                                self._leafs = OrderedDict([
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ])
                                self.destination_address = None

                                self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"

                                self.s2l_statistic = YList(self)
                                self._segment_path = lambda: "destination-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, ['destination_address'], name, value)


                            class Statistics(_Entity_):
                                """
                                Destination stats
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "destination-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                        ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                        ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                        ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                        ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                        ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                        ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                        ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                        ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                        ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                        ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                        ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                        ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                        ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                        ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                        ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                        ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                        ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                        ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                        ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                        ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                        ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                        ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                        ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                    ])
                                    self.tx_event_unknown = None
                                    self.tx_path_create_event = None
                                    self.tx_path_change_event = None
                                    self.tx_path_delete_event = None
                                    self.tx_path_error_event = None
                                    self.tx_resv_create_event = None
                                    self.tx_resv_change_event = None
                                    self.tx_resv_delete_event = None
                                    self.tx_resv_error_event = None
                                    self.tx_path_reeval_query_event = None
                                    self.rx_event_unknown = None
                                    self.rx_path_create_event = None
                                    self.rx_path_change_event = None
                                    self.rx_path_delete_event = None
                                    self.rx_path_error_event = None
                                    self.rx_resv_create_event = None
                                    self.rx_resv_change_event = None
                                    self.rx_resv_delete_event = None
                                    self.rx_resv_error_event = None
                                    self.rx_path_reeval_query_event = None
                                    self.tx_backup_assign_event = None
                                    self.rx_backup_assign_err_event = None
                                    self.events_total_count = None
                                    self.events_count = None
                                    self._segment_path = lambda: "statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics']['meta_info']


                            class S2lStatistic(_Entity_):
                                """
                                List of S2L Stats
                                
                                .. attribute:: statistics
                                
                                	S2L stats
                                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics>`
                                
                                	**config**\: False
                                
                                .. attribute:: sub_group_originator
                                
                                	Subgroup Originator
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: sub_group_id
                                
                                	subgroup ID
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                .. attribute:: destination_address
                                
                                	Destination address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic, self).__init__()

                                    self.yang_name = "s2l-statistic"
                                    self.yang_parent_name = "destination-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics))])
                                    self._leafs = OrderedDict([
                                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                        ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ])
                                    self.sub_group_originator = None
                                    self.sub_group_id = None
                                    self.destination_address = None

                                    self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._segment_path = lambda: "s2l-statistic"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                                class Statistics(_Entity_):
                                    """
                                    S2L stats
                                    
                                    .. attribute:: tx_event_unknown
                                    
                                    	Unknown TX events
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_create_event
                                    
                                    	TX Path Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_change_event
                                    
                                    	TX Path Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_delete_event
                                    
                                    	TX Path Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_error_event
                                    
                                    	TX Path Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_create_event
                                    
                                    	TX Resv Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_change_event
                                    
                                    	TX Resv Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_delete_event
                                    
                                    	TX Resv Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_resv_error_event
                                    
                                    	TX Resv Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_path_reeval_query_event
                                    
                                    	TX Path Reeval Query event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_event_unknown
                                    
                                    	RX Unknown events
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_create_event
                                    
                                    	RX Path Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_change_event
                                    
                                    	RX Path Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_delete_event
                                    
                                    	RX Path Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_error_event
                                    
                                    	RX Path Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_create_event
                                    
                                    	RX Resv Create event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_change_event
                                    
                                    	RX Resv Change event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_delete_event
                                    
                                    	RX Resv Delete event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_resv_error_event
                                    
                                    	RX Resv Error event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_path_reeval_query_event
                                    
                                    	RX Path Reeval Query event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: tx_backup_assign_event
                                    
                                    	Backup Assign event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: rx_backup_assign_err_event
                                    
                                    	Error on Backup Assign event
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: events_total_count
                                    
                                    	Total TE Signalling event count
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: events_count
                                    
                                    	TE Signaling event count
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "s2l-statistic"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                            ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                            ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                            ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                            ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                            ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                            ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                            ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                            ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                            ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                            ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                            ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                            ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                            ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                            ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                            ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                            ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                            ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                            ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                            ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                            ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                            ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                            ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                            ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                        ])
                                        self.tx_event_unknown = None
                                        self.tx_path_create_event = None
                                        self.tx_path_change_event = None
                                        self.tx_path_delete_event = None
                                        self.tx_path_error_event = None
                                        self.tx_resv_create_event = None
                                        self.tx_resv_change_event = None
                                        self.tx_resv_delete_event = None
                                        self.tx_resv_error_event = None
                                        self.tx_path_reeval_query_event = None
                                        self.rx_event_unknown = None
                                        self.rx_path_create_event = None
                                        self.rx_path_change_event = None
                                        self.rx_path_delete_event = None
                                        self.rx_path_error_event = None
                                        self.rx_resv_create_event = None
                                        self.rx_resv_change_event = None
                                        self.rx_resv_delete_event = None
                                        self.rx_resv_error_event = None
                                        self.rx_path_reeval_query_event = None
                                        self.tx_backup_assign_event = None
                                        self.rx_backup_assign_err_event = None
                                        self.events_total_count = None
                                        self.events_count = None
                                        self._segment_path = lambda: "statistics"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic.Statistics']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2lStatistic']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif']['meta_info']


                    class TeSignallingFilterLsp(_Entity_):
                        """
                        LSP data
                        
                        .. attribute:: statistics
                        
                        	LSP statistics
                        	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_statistic
                        
                        	List of S2L Statistics
                        	**type**\: list of  		 :py:class:`S2lStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__init__()

                            self.yang_name = "te-signalling-filter-lsp"
                            self.yang_parent_name = "te-signalling-filter-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics)), ("s2l-statistic", ("s2l_statistic", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic))])
                            self._leafs = OrderedDict([
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.tunnel_name = None

                            self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"

                            self.s2l_statistic = YList(self)
                            self._segment_path = lambda: "te-signalling-filter-lsp"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, ['tunnel_name'], name, value)


                        class Statistics(_Entity_):
                            """
                            LSP statistics
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                ])
                                self.tx_event_unknown = None
                                self.tx_path_create_event = None
                                self.tx_path_change_event = None
                                self.tx_path_delete_event = None
                                self.tx_path_error_event = None
                                self.tx_resv_create_event = None
                                self.tx_resv_change_event = None
                                self.tx_resv_delete_event = None
                                self.tx_resv_error_event = None
                                self.tx_path_reeval_query_event = None
                                self.rx_event_unknown = None
                                self.rx_path_create_event = None
                                self.rx_path_change_event = None
                                self.rx_path_delete_event = None
                                self.rx_path_error_event = None
                                self.rx_resv_create_event = None
                                self.rx_resv_change_event = None
                                self.rx_resv_delete_event = None
                                self.rx_resv_error_event = None
                                self.rx_path_reeval_query_event = None
                                self.tx_backup_assign_event = None
                                self.rx_backup_assign_err_event = None
                                self.events_total_count = None
                                self.events_count = None
                                self._segment_path = lambda: "statistics"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics']['meta_info']


                        class S2lStatistic(_Entity_):
                            """
                            List of S2L Statistics
                            
                            .. attribute:: statistics
                            
                            	S2L stats
                            	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics>`
                            
                            	**config**\: False
                            
                            .. attribute:: sub_group_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: sub_group_id
                            
                            	subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic, self).__init__()

                                self.yang_name = "s2l-statistic"
                                self.yang_parent_name = "te-signalling-filter-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics))])
                                self._leafs = OrderedDict([
                                    ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                                    ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                ])
                                self.sub_group_originator = None
                                self.sub_group_id = None
                                self.destination_address = None

                                self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._segment_path = lambda: "s2l-statistic"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic, ['sub_group_originator', 'sub_group_id', 'destination_address'], name, value)


                            class Statistics(_Entity_):
                                """
                                S2L stats
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "s2l-statistic"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                                        ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                                        ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                                        ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                                        ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                                        ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                                        ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                                        ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                                        ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                                        ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                                        ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                                        ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                                        ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                                        ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                                        ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                                        ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                                        ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                                        ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                                        ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                                        ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                                        ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                                        ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                                        ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                                        ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                                    ])
                                    self.tx_event_unknown = None
                                    self.tx_path_create_event = None
                                    self.tx_path_change_event = None
                                    self.tx_path_delete_event = None
                                    self.tx_path_error_event = None
                                    self.tx_resv_create_event = None
                                    self.tx_resv_change_event = None
                                    self.tx_resv_delete_event = None
                                    self.tx_resv_error_event = None
                                    self.tx_path_reeval_query_event = None
                                    self.rx_event_unknown = None
                                    self.rx_path_create_event = None
                                    self.rx_path_change_event = None
                                    self.rx_path_delete_event = None
                                    self.rx_path_error_event = None
                                    self.rx_resv_create_event = None
                                    self.rx_resv_change_event = None
                                    self.rx_resv_delete_event = None
                                    self.rx_resv_error_event = None
                                    self.rx_path_reeval_query_event = None
                                    self.tx_backup_assign_event = None
                                    self.rx_backup_assign_err_event = None
                                    self.events_total_count = None
                                    self.events_count = None
                                    self._segment_path = lambda: "statistics"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic.Statistics']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2lStatistic']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings.Signalling']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.Signallings']['meta_info']


        class SignallingSummary(_Entity_):
            """
            Send\-Recv count summary for TE Signaling
            
            .. attribute:: tx_event_unknown
            
            	Unknown TX events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_create_event
            
            	TX Path Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_change_event
            
            	TX Path Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_delete_event
            
            	TX Path Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_error_event
            
            	TX Path Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_create_event
            
            	TX Resv Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_change_event
            
            	TX Resv Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_delete_event
            
            	TX Resv Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_resv_error_event
            
            	TX Resv Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_path_reeval_query_event
            
            	TX Path Reeval Query event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_event_unknown
            
            	RX Unknown events
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_create_event
            
            	RX Path Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_change_event
            
            	RX Path Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_delete_event
            
            	RX Path Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_error_event
            
            	RX Path Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_create_event
            
            	RX Resv Create event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_change_event
            
            	RX Resv Change event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_delete_event
            
            	RX Resv Delete event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_resv_error_event
            
            	RX Resv Error event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_path_reeval_query_event
            
            	RX Path Reeval Query event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tx_backup_assign_event
            
            	Backup Assign event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rx_backup_assign_err_event
            
            	Error on Backup Assign event
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: events_total_count
            
            	Total TE Signalling event count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: events_count
            
            	TE Signaling event count
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.SignallingCounters.SignallingSummary, self).__init__()

                self.yang_name = "signalling-summary"
                self.yang_parent_name = "signalling-counters"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tx_event_unknown', (YLeaf(YType.uint32, 'tx-event-unknown'), ['int'])),
                    ('tx_path_create_event', (YLeaf(YType.uint32, 'tx-path-create-event'), ['int'])),
                    ('tx_path_change_event', (YLeaf(YType.uint32, 'tx-path-change-event'), ['int'])),
                    ('tx_path_delete_event', (YLeaf(YType.uint32, 'tx-path-delete-event'), ['int'])),
                    ('tx_path_error_event', (YLeaf(YType.uint32, 'tx-path-error-event'), ['int'])),
                    ('tx_resv_create_event', (YLeaf(YType.uint32, 'tx-resv-create-event'), ['int'])),
                    ('tx_resv_change_event', (YLeaf(YType.uint32, 'tx-resv-change-event'), ['int'])),
                    ('tx_resv_delete_event', (YLeaf(YType.uint32, 'tx-resv-delete-event'), ['int'])),
                    ('tx_resv_error_event', (YLeaf(YType.uint32, 'tx-resv-error-event'), ['int'])),
                    ('tx_path_reeval_query_event', (YLeaf(YType.uint32, 'tx-path-reeval-query-event'), ['int'])),
                    ('rx_event_unknown', (YLeaf(YType.uint32, 'rx-event-unknown'), ['int'])),
                    ('rx_path_create_event', (YLeaf(YType.uint32, 'rx-path-create-event'), ['int'])),
                    ('rx_path_change_event', (YLeaf(YType.uint32, 'rx-path-change-event'), ['int'])),
                    ('rx_path_delete_event', (YLeaf(YType.uint32, 'rx-path-delete-event'), ['int'])),
                    ('rx_path_error_event', (YLeaf(YType.uint32, 'rx-path-error-event'), ['int'])),
                    ('rx_resv_create_event', (YLeaf(YType.uint32, 'rx-resv-create-event'), ['int'])),
                    ('rx_resv_change_event', (YLeaf(YType.uint32, 'rx-resv-change-event'), ['int'])),
                    ('rx_resv_delete_event', (YLeaf(YType.uint32, 'rx-resv-delete-event'), ['int'])),
                    ('rx_resv_error_event', (YLeaf(YType.uint32, 'rx-resv-error-event'), ['int'])),
                    ('rx_path_reeval_query_event', (YLeaf(YType.uint32, 'rx-path-reeval-query-event'), ['int'])),
                    ('tx_backup_assign_event', (YLeaf(YType.uint32, 'tx-backup-assign-event'), ['int'])),
                    ('rx_backup_assign_err_event', (YLeaf(YType.uint32, 'rx-backup-assign-err-event'), ['int'])),
                    ('events_total_count', (YLeaf(YType.uint32, 'events-total-count'), ['int'])),
                    ('events_count', (YLeaf(YType.uint32, 'events-count'), ['int'])),
                ])
                self.tx_event_unknown = None
                self.tx_path_create_event = None
                self.tx_path_change_event = None
                self.tx_path_delete_event = None
                self.tx_path_error_event = None
                self.tx_resv_create_event = None
                self.tx_resv_change_event = None
                self.tx_resv_delete_event = None
                self.tx_resv_error_event = None
                self.tx_path_reeval_query_event = None
                self.rx_event_unknown = None
                self.rx_path_create_event = None
                self.rx_path_change_event = None
                self.rx_path_delete_event = None
                self.rx_path_error_event = None
                self.rx_resv_create_event = None
                self.rx_resv_change_event = None
                self.rx_resv_delete_event = None
                self.rx_resv_error_event = None
                self.rx_path_reeval_query_event = None
                self.tx_backup_assign_event = None
                self.rx_backup_assign_err_event = None
                self.events_total_count = None
                self.events_count = None
                self._segment_path = lambda: "signalling-summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.SignallingCounters.SignallingSummary, ['tx_event_unknown', 'tx_path_create_event', 'tx_path_change_event', 'tx_path_delete_event', 'tx_path_error_event', 'tx_resv_create_event', 'tx_resv_change_event', 'tx_resv_delete_event', 'tx_resv_error_event', 'tx_path_reeval_query_event', 'rx_event_unknown', 'rx_path_create_event', 'rx_path_change_event', 'rx_path_delete_event', 'rx_path_error_event', 'rx_resv_create_event', 'rx_resv_change_event', 'rx_resv_delete_event', 'rx_resv_error_event', 'rx_path_reeval_query_event', 'tx_backup_assign_event', 'rx_backup_assign_err_event', 'events_total_count', 'events_count'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.SignallingCounters.SignallingSummary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.SignallingCounters']['meta_info']


    class DiffServTeClasses(_Entity_):
        """
        The configured Diff Serv TE classes
        
        .. attribute:: te_class
        
        	te class
        	**type**\: list of  		 :py:class:`TeClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.DiffServTeClasses.TeClass>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.DiffServTeClasses, self).__init__()

            self.yang_name = "diff-serv-te-classes"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("te-class", ("te_class", MplsTeStandby.DiffServTeClasses.TeClass))])
            self._leafs = OrderedDict()

            self.te_class = YList(self)
            self._segment_path = lambda: "diff-serv-te-classes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.DiffServTeClasses, [], name, value)


        class TeClass(_Entity_):
            """
            te class
            
            .. attribute:: class_number
            
            	The DS\-TE class number from 0 to 7
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: class_type
            
            	The class type of the TE class
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: priority
            
            	The priority of the TE class
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: class_status
            
            	The status of the TE class
            	**type**\:  :py:class:`MplsTeDsteClassStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeDsteClassStatus>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.DiffServTeClasses.TeClass, self).__init__()

                self.yang_name = "te-class"
                self.yang_parent_name = "diff-serv-te-classes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('class_number', (YLeaf(YType.uint8, 'class-number'), ['int'])),
                    ('class_type', (YLeaf(YType.uint8, 'class-type'), ['int'])),
                    ('priority', (YLeaf(YType.uint8, 'priority'), ['int'])),
                    ('class_status', (YLeaf(YType.enumeration, 'class-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeDsteClassStatus', '')])),
                ])
                self.class_number = None
                self.class_type = None
                self.priority = None
                self.class_status = None
                self._segment_path = lambda: "te-class"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/diff-serv-te-classes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.DiffServTeClasses.TeClass, ['class_number', 'class_type', 'priority', 'class_status'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.DiffServTeClasses.TeClass']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.DiffServTeClasses']['meta_info']


    class Issu(_Entity_):
        """
        MPLS TE ISSU information
        
        .. attribute:: status
        
        	MPLS TE ISSU Status information
        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status>`
        
        	**config**\: False
        
        .. attribute:: detail
        
        	MPLS TE ISSU Status information
        	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.Issu, self).__init__()

            self.yang_name = "issu"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("status", ("status", MplsTeStandby.Issu.Status)), ("detail", ("detail", MplsTeStandby.Issu.Detail))])
            self._leafs = OrderedDict()

            self.status = MplsTeStandby.Issu.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"

            self.detail = MplsTeStandby.Issu.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._segment_path = lambda: "issu"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.Issu, [], name, value)


        class Status(_Entity_):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Issu.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "issu"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTeStandby.Issu.Status.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTeStandby.Issu.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "status"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Issu.Status, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Issu.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Issu.Status.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Issu.Status']['meta_info']


        class Detail(_Entity_):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Issu.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "issu"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTeStandby.Issu.Detail.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTeStandby.Issu.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "detail"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Issu.Detail, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Issu.Detail.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Issu.Detail']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.Issu']['meta_info']


    class AutoRouteDestinationEntries(_Entity_):
        """
        MPLS TE autoroute destination table indexed by
        tunnel
        
        .. attribute:: auto_route_destination_entry
        
        	MPLS TE autoroute destination info for one tunnel
        	**type**\: list of  		 :py:class:`AutoRouteDestinationEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AutoRouteDestinationEntries, self).__init__()

            self.yang_name = "auto-route-destination-entries"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("auto-route-destination-entry", ("auto_route_destination_entry", MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry))])
            self._leafs = OrderedDict()

            self.auto_route_destination_entry = YList(self)
            self._segment_path = lambda: "auto-route-destination-entries"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AutoRouteDestinationEntries, [], name, value)


        class AutoRouteDestinationEntry(_Entity_):
            """
            MPLS TE autoroute destination info for one
            tunnel
            
            .. attribute:: tunnel_id  (key)
            
            	Tunnel ID
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tunnel_id_xr
            
            	tunnel id xr
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_name
            
            	Tunnel name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: tunnel_autoroute_dest
            
            	tunnel autoroute dest
            	**type**\: list of  		 :py:class:`TunnelAutorouteDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry, self).__init__()

                self.yang_name = "auto-route-destination-entry"
                self.yang_parent_name = "auto-route-destination-entries"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['tunnel_id']
                self._child_classes = OrderedDict([("tunnel-autoroute-dest", ("tunnel_autoroute_dest", MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest))])
                self._leafs = OrderedDict([
                    ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                    ('tunnel_id_xr', (YLeaf(YType.uint16, 'tunnel-id-xr'), ['int'])),
                    ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                ])
                self.tunnel_id = None
                self.tunnel_id_xr = None
                self.tunnel_name = None

                self.tunnel_autoroute_dest = YList(self)
                self._segment_path = lambda: "auto-route-destination-entry" + "[tunnel-id='" + str(self.tunnel_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-route-destination-entries/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry, ['tunnel_id', 'tunnel_id_xr', 'tunnel_name'], name, value)


            class TunnelAutorouteDest(_Entity_):
                """
                tunnel autoroute dest
                
                .. attribute:: prefix_address
                
                	PrefixAddress
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: prefix_length
                
                	PrefixLength
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: metric
                
                	Metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: install_time
                
                	InstallTime
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: interface_handle
                
                	InterfaceHandle
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, self).__init__()

                    self.yang_name = "tunnel-autoroute-dest"
                    self.yang_parent_name = "auto-route-destination-entry"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('prefix_address', (YLeaf(YType.str, 'prefix-address'), ['str'])),
                        ('prefix_length', (YLeaf(YType.uint32, 'prefix-length'), ['int'])),
                        ('metric', (YLeaf(YType.uint32, 'metric'), ['int'])),
                        ('install_time', (YLeaf(YType.uint32, 'install-time'), ['int'])),
                        ('interface_handle', (YLeaf(YType.str, 'interface-handle'), ['str'])),
                    ])
                    self.prefix_address = None
                    self.prefix_length = None
                    self.metric = None
                    self.install_time = None
                    self.interface_handle = None
                    self._segment_path = lambda: "tunnel-autoroute-dest"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest, ['prefix_address', 'prefix_length', 'metric', 'install_time', 'interface_handle'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry.TunnelAutorouteDest']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AutoRouteDestinationEntries.AutoRouteDestinationEntry']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AutoRouteDestinationEntries']['meta_info']


    class FastReroute(_Entity_):
        """
        Represent all the fastreroute info in MPLS\-TE
        
        .. attribute:: backup_tunnels
        
        	The set of fastreroute backup tunnels available in MPLS\-TE
        	**type**\:  :py:class:`BackupTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.BackupTunnels>`
        
        	**config**\: False
        
        .. attribute:: protected_interfaces
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:  :py:class:`ProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.ProtectedInterfaces>`
        
        	**config**\: False
        
        .. attribute:: protections
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:  :py:class:`Protections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Protections>`
        
        	**config**\: False
        
        .. attribute:: promotion
        
        	The info about the promotion timer of backup tunnels
        	**type**\:  :py:class:`Promotion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Promotion>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.FastReroute, self).__init__()

            self.yang_name = "fast-reroute"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("backup-tunnels", ("backup_tunnels", MplsTeStandby.FastReroute.BackupTunnels)), ("protected-interfaces", ("protected_interfaces", MplsTeStandby.FastReroute.ProtectedInterfaces)), ("protections", ("protections", MplsTeStandby.FastReroute.Protections)), ("promotion", ("promotion", MplsTeStandby.FastReroute.Promotion))])
            self._leafs = OrderedDict()

            self.backup_tunnels = MplsTeStandby.FastReroute.BackupTunnels()
            self.backup_tunnels.parent = self
            self._children_name_map["backup_tunnels"] = "backup-tunnels"

            self.protected_interfaces = MplsTeStandby.FastReroute.ProtectedInterfaces()
            self.protected_interfaces.parent = self
            self._children_name_map["protected_interfaces"] = "protected-interfaces"

            self.protections = MplsTeStandby.FastReroute.Protections()
            self.protections.parent = self
            self._children_name_map["protections"] = "protections"

            self.promotion = MplsTeStandby.FastReroute.Promotion()
            self.promotion.parent = self
            self._children_name_map["promotion"] = "promotion"
            self._segment_path = lambda: "fast-reroute"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.FastReroute, [], name, value)


        class BackupTunnels(_Entity_):
            """
            The set of fastreroute backup tunnels available
            in MPLS\-TE
            
            .. attribute:: backup_tunnel
            
            	Fastreroute info for a given backup tunnel
            	**type**\: list of  		 :py:class:`BackupTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.FastReroute.BackupTunnels, self).__init__()

                self.yang_name = "backup-tunnels"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("backup-tunnel", ("backup_tunnel", MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel))])
                self._leafs = OrderedDict()

                self.backup_tunnel = YList(self)
                self._segment_path = lambda: "backup-tunnels"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.FastReroute.BackupTunnels, [], name, value)


            class BackupTunnel(_Entity_):
                """
                Fastreroute info for a given backup tunnel
                
                .. attribute:: tunnel_name  (key)
                
                	Backup tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: interface_name  (key)
                
                	Protected interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:  :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                	**config**\: False
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:  :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel, self).__init__()

                    self.yang_name = "backup-tunnel"
                    self.yang_parent_name = "backup-tunnels"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name','interface_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('backup_tunnel_id', (YLeaf(YType.uint32, 'backup-tunnel-id'), ['int'])),
                        ('backup_tunnel_name_xr', (YLeaf(YType.str, 'backup-tunnel-name-xr'), ['str'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('backup_type', (YLeaf(YType.enumeration, 'backup-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackup', '')])),
                        ('backup_usage', (YLeaf(YType.enumeration, 'backup-usage'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupUsage', '')])),
                        ('prot_interface_autobackup_config', (YLeaf(YType.enumeration, 'prot-interface-autobackup-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                        ('prot_interface_srlg_config', (YLeaf(YType.enumeration, 'prot-interface-srlg-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                        ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                        ('recreate_timer_is_running', (YLeaf(YType.boolean, 'recreate-timer-is-running'), ['bool'])),
                        ('recreate_remaining_time', (YLeaf(YType.uint32, 'recreate-remaining-time'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('general_status', (YLeaf(YType.enumeration, 'general-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('connection_status', (YLeaf(YType.enumeration, 'connection-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('in_use_bandwidth', (YLeaf(YType.uint32, 'in-use-bandwidth'), ['int'])),
                        ('soft_preempted_in_use_bandwidth', (YLeaf(YType.uint32, 'soft-preempted-in-use-bandwidth'), ['int'])),
                        ('ls_ps', (YLeaf(YType.uint32, 'ls-ps'), ['int'])),
                        ('s2l_families', (YLeaf(YType.uint32, 's2l-families'), ['int'])),
                        ('s2_ls', (YLeaf(YType.uint32, 's2-ls'), ['int'])),
                        ('frr_active_ls_ps', (YLeaf(YType.uint32, 'frr-active-ls-ps'), ['int'])),
                        ('frr_active_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'frr-active-soft-preempted-ls-ps'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.interface_name = None
                    self.backup_tunnel_id = None
                    self.backup_tunnel_name_xr = None
                    self.backup_status = None
                    self.backup_type = None
                    self.backup_usage = None
                    self.prot_interface_autobackup_config = None
                    self.prot_interface_srlg_config = None
                    self.tunnel_attribute_set_name = None
                    self.has_attribute_set = None
                    self.is_attribute_set_in_db = None
                    self.recreate_timer_is_running = None
                    self.recreate_remaining_time = None
                    self.source_address = None
                    self.destination_address = None
                    self.general_status = None
                    self.connection_status = None
                    self.output_interface_name = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.bandwidth = None
                    self.tunnel_instance = None
                    self.in_use_bandwidth = None
                    self.soft_preempted_in_use_bandwidth = None
                    self.ls_ps = None
                    self.s2l_families = None
                    self.s2_ls = None
                    self.frr_active_ls_ps = None
                    self.frr_active_soft_preempted_ls_ps = None
                    self._segment_path = lambda: "backup-tunnel" + "[tunnel-name='" + str(self.tunnel_name) + "']" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/backup-tunnels/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel, ['tunnel_name', 'interface_name', 'backup_tunnel_id', 'backup_tunnel_name_xr', 'backup_status', 'backup_type', 'backup_usage', 'prot_interface_autobackup_config', 'prot_interface_srlg_config', 'tunnel_attribute_set_name', 'has_attribute_set', 'is_attribute_set_in_db', 'recreate_timer_is_running', 'recreate_remaining_time', 'source_address', 'destination_address', 'general_status', 'connection_status', 'output_interface_name', 'bandwidth_pool_type', 'bandwidth_limit_type', 'bandwidth', 'tunnel_instance', 'in_use_bandwidth', 'soft_preempted_in_use_bandwidth', 'ls_ps', 's2l_families', 's2_ls', 'frr_active_ls_ps', 'frr_active_soft_preempted_ls_ps'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.FastReroute.BackupTunnels']['meta_info']


        class ProtectedInterfaces(_Entity_):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protected_interface
            
            	Fastreroute info for a given protected interface
            	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.FastReroute.ProtectedInterfaces, self).__init__()

                self.yang_name = "protected-interfaces"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protected-interface", ("protected_interface", MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface))])
                self._leafs = OrderedDict()

                self.protected_interface = YList(self)
                self._segment_path = lambda: "protected-interfaces"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.FastReroute.ProtectedInterfaces, [], name, value)


            class ProtectedInterface(_Entity_):
                """
                Fastreroute info for a given protected
                interface
                
                .. attribute:: interface_name  (key)
                
                	Protected interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name  (key)
                
                	Backup tunnel name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:  :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                	**config**\: False
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:  :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:  :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                	**config**\: False
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:  :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: kbit/s
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__init__()

                    self.yang_name = "protected-interface"
                    self.yang_parent_name = "protected-interfaces"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name','backup_tunnel_name']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                        ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                        ('backup_tunnel_id', (YLeaf(YType.uint32, 'backup-tunnel-id'), ['int'])),
                        ('backup_tunnel_name_xr', (YLeaf(YType.str, 'backup-tunnel-name-xr'), ['str'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('backup_type', (YLeaf(YType.enumeration, 'backup-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackup', '')])),
                        ('backup_usage', (YLeaf(YType.enumeration, 'backup-usage'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupUsage', '')])),
                        ('prot_interface_autobackup_config', (YLeaf(YType.enumeration, 'prot-interface-autobackup-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupProtection', '')])),
                        ('prot_interface_srlg_config', (YLeaf(YType.enumeration, 'prot-interface-srlg-config'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'AutoBackupSrlgMode', '')])),
                        ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                        ('has_attribute_set', (YLeaf(YType.boolean, 'has-attribute-set'), ['bool'])),
                        ('is_attribute_set_in_db', (YLeaf(YType.boolean, 'is-attribute-set-in-db'), ['bool'])),
                        ('recreate_timer_is_running', (YLeaf(YType.boolean, 'recreate-timer-is-running'), ['bool'])),
                        ('recreate_remaining_time', (YLeaf(YType.uint32, 'recreate-remaining-time'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('general_status', (YLeaf(YType.enumeration, 'general-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('connection_status', (YLeaf(YType.enumeration, 'connection-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('in_use_bandwidth', (YLeaf(YType.uint32, 'in-use-bandwidth'), ['int'])),
                        ('soft_preempted_in_use_bandwidth', (YLeaf(YType.uint32, 'soft-preempted-in-use-bandwidth'), ['int'])),
                        ('ls_ps', (YLeaf(YType.uint32, 'ls-ps'), ['int'])),
                        ('s2l_families', (YLeaf(YType.uint32, 's2l-families'), ['int'])),
                        ('s2_ls', (YLeaf(YType.uint32, 's2-ls'), ['int'])),
                        ('frr_active_ls_ps', (YLeaf(YType.uint32, 'frr-active-ls-ps'), ['int'])),
                        ('frr_active_soft_preempted_ls_ps', (YLeaf(YType.uint32, 'frr-active-soft-preempted-ls-ps'), ['int'])),
                    ])
                    self.interface_name = None
                    self.backup_tunnel_name = None
                    self.backup_tunnel_id = None
                    self.backup_tunnel_name_xr = None
                    self.backup_status = None
                    self.backup_type = None
                    self.backup_usage = None
                    self.prot_interface_autobackup_config = None
                    self.prot_interface_srlg_config = None
                    self.tunnel_attribute_set_name = None
                    self.has_attribute_set = None
                    self.is_attribute_set_in_db = None
                    self.recreate_timer_is_running = None
                    self.recreate_remaining_time = None
                    self.source_address = None
                    self.destination_address = None
                    self.general_status = None
                    self.connection_status = None
                    self.output_interface_name = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.bandwidth = None
                    self.tunnel_instance = None
                    self.in_use_bandwidth = None
                    self.soft_preempted_in_use_bandwidth = None
                    self.ls_ps = None
                    self.s2l_families = None
                    self.s2_ls = None
                    self.frr_active_ls_ps = None
                    self.frr_active_soft_preempted_ls_ps = None
                    self._segment_path = lambda: "protected-interface" + "[interface-name='" + str(self.interface_name) + "']" + "[backup-tunnel-name='" + str(self.backup_tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/protected-interfaces/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface, ['interface_name', 'backup_tunnel_name', 'backup_tunnel_id', 'backup_tunnel_name_xr', 'backup_status', 'backup_type', 'backup_usage', 'prot_interface_autobackup_config', 'prot_interface_srlg_config', 'tunnel_attribute_set_name', 'has_attribute_set', 'is_attribute_set_in_db', 'recreate_timer_is_running', 'recreate_remaining_time', 'source_address', 'destination_address', 'general_status', 'connection_status', 'output_interface_name', 'bandwidth_pool_type', 'bandwidth_limit_type', 'bandwidth', 'tunnel_instance', 'in_use_bandwidth', 'soft_preempted_in_use_bandwidth', 'ls_ps', 's2l_families', 's2_ls', 'frr_active_ls_ps', 'frr_active_soft_preempted_ls_ps'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.FastReroute.ProtectedInterfaces']['meta_info']


        class Protections(_Entity_):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protection
            
            	Fastreroute info for a given protection interface
            	**type**\: list of  		 :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Protections.Protection>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.FastReroute.Protections, self).__init__()

                self.yang_name = "protections"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("protection", ("protection", MplsTeStandby.FastReroute.Protections.Protection))])
                self._leafs = OrderedDict()

                self.protection = YList(self)
                self._segment_path = lambda: "protections"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.FastReroute.Protections, [], name, value)


            class Protection(_Entity_):
                """
                Fastreroute info for a given protection
                interface
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_id  (key)
                
                	Subgroup ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: sub_group_originator  (key)
                
                	Subgroup Orig ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_type  (key)
                
                	Session Type
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: role
                
                	Role of LSP
                	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                
                	**config**\: False
                
                .. attribute:: admin_status
                
                	Tunnel Admin status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: operation_status
                
                	Tunnel operational status
                	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                	**config**\: False
                
                .. attribute:: is_signalled
                
                	Indicates whether signalled
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_frr_requested
                
                	TRUE if frr protection is on
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: inbound_frr_state
                
                	Indicates inbound FRR state
                	**type**\:  :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                	**config**\: False
                
                .. attribute:: output_interface_lsp
                
                	Output intface of the LSP
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: output_label
                
                	Output label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Next hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: frr_output_tunnel_interface
                
                	FRR output tunnel intface
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: frr_output_label
                
                	FRR output label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_status
                
                	Backup status
                	**type**\:  :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:  :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                	**config**\: False
                
                .. attribute:: original_input_interface
                
                	Input intface of the LSP
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: input_label
                
                	Input label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: previous_hop_address
                
                	Previous hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: backup_bandwidth
                
                	Backup bandwidth
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_output_interface
                
                	Output interface of bkup tunnel
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_next_hop_address
                
                	S2L Nexthop of the backup tunnel
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lsp_bandwidth_type
                
                	LSP bandwidth type
                	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                	**config**\: False
                
                .. attribute:: sharing_type
                
                	Outgoing i/f Sharing type
                	**type**\:  :py:class:`MplsTeFrrSharing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrSharing>`
                
                	**config**\: False
                
                .. attribute:: is_p2mp_tunnel
                
                	Is P2P or P2MP Tunnel
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.FastReroute.Protections.Protection, self).__init__()

                    self.yang_name = "protection"
                    self.yang_parent_name = "protections"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['source_address','destination_address','tunnel_id','extended_tunnel_id','lsp_id','sub_group_id','sub_group_originator','p2mp_id','session_type']
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('sub_group_id', (YLeaf(YType.uint32, 'sub-group-id'), ['int'])),
                        ('sub_group_originator', (YLeaf(YType.str, 'sub-group-originator'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('session_type', (YLeaf(YType.uint32, 'session-type'), ['int'])),
                        ('source_address_xr', (YLeaf(YType.str, 'source-address-xr'), ['str'])),
                        ('destination_address_xr', (YLeaf(YType.str, 'destination-address-xr'), ['str'])),
                        ('tunnel_id_xr', (YLeaf(YType.uint32, 'tunnel-id-xr'), ['int'])),
                        ('extended_tunnel_id_xr', (YLeaf(YType.str, 'extended-tunnel-id-xr'), ['str'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_instance', (YLeaf(YType.uint32, 'tunnel-instance'), ['int'])),
                        ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                        ('admin_status', (YLeaf(YType.enumeration, 'admin-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('operation_status', (YLeaf(YType.enumeration, 'operation-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ('is_signalled', (YLeaf(YType.boolean, 'is-signalled'), ['bool'])),
                        ('is_frr_requested', (YLeaf(YType.boolean, 'is-frr-requested'), ['bool'])),
                        ('outbound_frr_state', (YLeaf(YType.enumeration, 'outbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('inbound_frr_state', (YLeaf(YType.enumeration, 'inbound-frr-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrState', '')])),
                        ('output_interface_lsp', (YLeaf(YType.str, 'output-interface-lsp'), ['str'])),
                        ('output_label', (YLeaf(YType.uint32, 'output-label'), ['int'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('frr_output_tunnel_interface', (YLeaf(YType.str, 'frr-output-tunnel-interface'), ['str'])),
                        ('frr_output_label', (YLeaf(YType.uint32, 'frr-output-label'), ['int'])),
                        ('backup_status', (YLeaf(YType.enumeration, 'backup-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBackupStatus', '')])),
                        ('bandwidth_pool_type', (YLeaf(YType.enumeration, 'bandwidth-pool-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('bandwidth_limit_type', (YLeaf(YType.enumeration, 'bandwidth-limit-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwLimit', '')])),
                        ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                        ('input_label', (YLeaf(YType.uint32, 'input-label'), ['int'])),
                        ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                        ('backup_bandwidth', (YLeaf(YType.uint32, 'backup-bandwidth'), ['int'])),
                        ('frr_output_interface', (YLeaf(YType.str, 'frr-output-interface'), ['str'])),
                        ('backup_next_hop_address', (YLeaf(YType.str, 'backup-next-hop-address'), ['str'])),
                        ('lsp_bandwidth_type', (YLeaf(YType.enumeration, 'lsp-bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                        ('sharing_type', (YLeaf(YType.enumeration, 'sharing-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeFrrSharing', '')])),
                        ('is_p2mp_tunnel', (YLeaf(YType.boolean, 'is-p2mp-tunnel'), ['bool'])),
                        ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ('sub_group_id_xr', (YLeaf(YType.uint16, 'sub-group-id-xr'), ['int'])),
                        ('p2mp_id_xr', (YLeaf(YType.uint32, 'p2mp-id-xr'), ['int'])),
                    ])
                    self.source_address = None
                    self.destination_address = None
                    self.tunnel_id = None
                    self.extended_tunnel_id = None
                    self.lsp_id = None
                    self.sub_group_id = None
                    self.sub_group_originator = None
                    self.p2mp_id = None
                    self.session_type = None
                    self.source_address_xr = None
                    self.destination_address_xr = None
                    self.tunnel_id_xr = None
                    self.extended_tunnel_id_xr = None
                    self.tunnel_name = None
                    self.tunnel_instance = None
                    self.role = None
                    self.admin_status = None
                    self.operation_status = None
                    self.is_signalled = None
                    self.is_frr_requested = None
                    self.outbound_frr_state = None
                    self.inbound_frr_state = None
                    self.output_interface_lsp = None
                    self.output_label = None
                    self.next_hop_address = None
                    self.frr_output_tunnel_interface = None
                    self.frr_output_label = None
                    self.backup_status = None
                    self.bandwidth_pool_type = None
                    self.bandwidth_limit_type = None
                    self.original_input_interface = None
                    self.input_label = None
                    self.previous_hop_address = None
                    self.backup_bandwidth = None
                    self.frr_output_interface = None
                    self.backup_next_hop_address = None
                    self.lsp_bandwidth_type = None
                    self.sharing_type = None
                    self.is_p2mp_tunnel = None
                    self.sub_group_original_id = None
                    self.sub_group_id_xr = None
                    self.p2mp_id_xr = None
                    self._segment_path = lambda: "protection" + "[source-address='" + str(self.source_address) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[sub-group-id='" + str(self.sub_group_id) + "']" + "[sub-group-originator='" + str(self.sub_group_originator) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[session-type='" + str(self.session_type) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/protections/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.FastReroute.Protections.Protection, ['source_address', 'destination_address', 'tunnel_id', 'extended_tunnel_id', 'lsp_id', 'sub_group_id', 'sub_group_originator', 'p2mp_id', 'session_type', 'source_address_xr', 'destination_address_xr', 'tunnel_id_xr', 'extended_tunnel_id_xr', 'tunnel_name', 'tunnel_instance', 'role', 'admin_status', 'operation_status', 'is_signalled', 'is_frr_requested', 'outbound_frr_state', 'inbound_frr_state', 'output_interface_lsp', 'output_label', 'next_hop_address', 'frr_output_tunnel_interface', 'frr_output_label', 'backup_status', 'bandwidth_pool_type', 'bandwidth_limit_type', 'original_input_interface', 'input_label', 'previous_hop_address', 'backup_bandwidth', 'frr_output_interface', 'backup_next_hop_address', 'lsp_bandwidth_type', 'sharing_type', 'is_p2mp_tunnel', 'sub_group_original_id', 'sub_group_id_xr', 'p2mp_id_xr'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.FastReroute.Protections.Protection']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.FastReroute.Protections']['meta_info']


        class Promotion(_Entity_):
            """
            The info about the promotion timer of backup
            tunnels
            
            .. attribute:: promotion_period
            
            	Promotion period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: remaining_time
            
            	Remaining time for next promotion in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: is_configured
            
            	Indicate if periodic promotion is configured 
            	**type**\: bool
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.FastReroute.Promotion, self).__init__()

                self.yang_name = "promotion"
                self.yang_parent_name = "fast-reroute"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('promotion_period', (YLeaf(YType.uint32, 'promotion-period'), ['int'])),
                    ('remaining_time', (YLeaf(YType.uint32, 'remaining-time'), ['int'])),
                    ('is_configured', (YLeaf(YType.boolean, 'is-configured'), ['bool'])),
                ])
                self.promotion_period = None
                self.remaining_time = None
                self.is_configured = None
                self._segment_path = lambda: "promotion"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.FastReroute.Promotion, ['promotion_period', 'remaining_time', 'is_configured'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.FastReroute.Promotion']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.FastReroute']['meta_info']


    class AttributeSets(_Entity_):
        """
        AttributeSet information.
        
        .. attribute:: attribute_set
        
        	MPLS TE attribute\-set information
        	**type**\: list of  		 :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AttributeSets, self).__init__()

            self.yang_name = "attribute-sets"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("attribute-set", ("attribute_set", MplsTeStandby.AttributeSets.AttributeSet))])
            self._leafs = OrderedDict()

            self.attribute_set = YList(self)
            self._segment_path = lambda: "attribute-sets"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AttributeSets, [], name, value)


        class AttributeSet(_Entity_):
            """
            MPLS TE attribute\-set information
            
            .. attribute:: attribute_set_type  (key)
            
            	Attribute Set Type
            	**type**\:  :py:class:`MplsTeAttrSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAttrSet>`
            
            	**config**\: False
            
            .. attribute:: attribute_set_name  (key)
            
            	Attribute Set Name
            	**type**\: str
            
            	**length:** 1..64
            
            	**config**\: False
            
            .. attribute:: attribute_set_union
            
            	Union of Attribute Sets
            	**type**\:  :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion>`
            
            	**config**\: False
            
            .. attribute:: tunnel_attribute_set_name
            
            	Attribute Set Name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: tunnel_attribute_set_name_crc32
            
            	Attribute Set name CRC32 value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AttributeSets.AttributeSet, self).__init__()

                self.yang_name = "attribute-set"
                self.yang_parent_name = "attribute-sets"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['attribute_set_type','attribute_set_name']
                self._child_classes = OrderedDict([("attribute-set-union", ("attribute_set_union", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion))])
                self._leafs = OrderedDict([
                    ('attribute_set_type', (YLeaf(YType.enumeration, 'attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAttrSet', '')])),
                    ('attribute_set_name', (YLeaf(YType.str, 'attribute-set-name'), ['str'])),
                    ('tunnel_attribute_set_name', (YLeaf(YType.str, 'tunnel-attribute-set-name'), ['str'])),
                    ('tunnel_attribute_set_name_crc32', (YLeaf(YType.uint32, 'tunnel-attribute-set-name-crc32'), ['int'])),
                ])
                self.attribute_set_type = None
                self.attribute_set_name = None
                self.tunnel_attribute_set_name = None
                self.tunnel_attribute_set_name_crc32 = None

                self.attribute_set_union = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion()
                self.attribute_set_union.parent = self
                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                self._segment_path = lambda: "attribute-set" + "[attribute-set-type='" + str(self.attribute_set_type) + "']" + "[attribute-set-name='" + str(self.attribute_set_name) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/attribute-sets/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet, ['attribute_set_type', 'attribute_set_name', 'tunnel_attribute_set_name', 'tunnel_attribute_set_name_crc32'], name, value)


            class AttributeSetUnion(_Entity_):
                """
                Union of Attribute Sets
                
                .. attribute:: attribute_set_path_option
                
                	MPLS TE Path Option Attribute Set
                	**type**\:  :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_autobackup
                
                	MPLS TE Auto\-backup Attribute Set
                	**type**\:  :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_automesh
                
                	MPLS TE Auto\-mesh Attribute Set
                	**type**\:  :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_xro
                
                	Attribute Set XRO
                	**type**\:  :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_p2mpte
                
                	MPLS TE P2MP\-TE Attribute Set
                	**type**\:  :py:class:`AttributeSetP2mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_aps_pp
                
                	Attribute Set OTN APS Path Protection
                	**type**\:  :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                
                	**config**\: False
                
                .. attribute:: attribute_set_p2p_te
                
                	MPLS TE P2P\-TE Attribute Set
                	**type**\:  :py:class:`AttributeSetP2pTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe>`
                
                	**config**\: False
                
                .. attribute:: tunnel_attribute_set_type
                
                	TunnelAttributeSetType
                	**type**\:  :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion, self).__init__()

                    self.yang_name = "attribute-set-union"
                    self.yang_parent_name = "attribute-set"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("attribute-set-path-option", ("attribute_set_path_option", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption)), ("attribute-set-autobackup", ("attribute_set_autobackup", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup)), ("attribute-set-automesh", ("attribute_set_automesh", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh)), ("attribute-set-xro", ("attribute_set_xro", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro)), ("attribute-set-p2mpte", ("attribute_set_p2mpte", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte)), ("attribute-set-aps-pp", ("attribute_set_aps_pp", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp)), ("attribute-set-p2p-te", ("attribute_set_p2p_te", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe))])
                    self._leafs = OrderedDict([
                        ('tunnel_attribute_set_type', (YLeaf(YType.enumeration, 'tunnel-attribute-set-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TunnelAttributeSet', '')])),
                    ])
                    self.tunnel_attribute_set_type = None

                    self.attribute_set_path_option = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                    self.attribute_set_path_option.parent = self
                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"

                    self.attribute_set_autobackup = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                    self.attribute_set_autobackup.parent = self
                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"

                    self.attribute_set_automesh = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                    self.attribute_set_automesh.parent = self
                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"

                    self.attribute_set_xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                    self.attribute_set_xro.parent = self
                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"

                    self.attribute_set_p2mpte = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte()
                    self.attribute_set_p2mpte.parent = self
                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"

                    self.attribute_set_aps_pp = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                    self.attribute_set_aps_pp.parent = self
                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"

                    self.attribute_set_p2p_te = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe()
                    self.attribute_set_p2p_te.parent = self
                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                    self._segment_path = lambda: "attribute-set-union"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion, ['tunnel_attribute_set_type'], name, value)


                class AttributeSetPathOption(_Entity_):
                    """
                    MPLS TE Path Option Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_reverse_path
                    
                    	BFD reverse path
                    	**type**\:  :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:  :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_cost_limit_configured
                    
                    	Is Cost Limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: generation
                    
                    	Generation
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation interval on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is path invalidation timeout configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is path invalidation action configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: exclude_list_name
                    
                    	Exclude list name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: is_exclude_list_name_configured
                    
                    	Is exclude list name configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_bfd_reverse_pat_configured
                    
                    	Is BFD reverse path configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_delay_limit_configured
                    
                    	Is Delay Limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: delay_limit
                    
                    	Delay limit on the tunnel path (usec) When delay limit is configured
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                    
                    	**config**\: False
                    
                    .. attribute:: version_info
                    
                    	Version Info
                    	**type**\: list of  		 :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                        self.yang_name = "attribute-set-path-option"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity)), ("bfd-reverse-path", ("bfd_reverse_path", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath)), ("tunnel-id", ("tunnel_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId)), ("version-info", ("version_info", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo))])
                        self._leafs = OrderedDict([
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('cost_limit', (YLeaf(YType.uint32, 'cost-limit'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('bandwidth_type', (YLeaf(YType.enumeration, 'bandwidth-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeBwPool', '')])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('is_cost_limit_configured', (YLeaf(YType.boolean, 'is-cost-limit-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_invalidation_action', (YLeaf(YType.uint32, 'path-invalidation-action'), ['int'])),
                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                            ('exclude_list_name', (YLeaf(YType.str, 'exclude-list-name'), ['str'])),
                            ('is_exclude_list_name_configured', (YLeaf(YType.boolean, 'is-exclude-list-name-configured'), ['bool'])),
                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                            ('is_bfd_reverse_pat_configured', (YLeaf(YType.boolean, 'is-bfd-reverse-pat-configured'), ['bool'])),
                            ('is_delay_limit_configured', (YLeaf(YType.boolean, 'is-delay-limit-configured'), ['bool'])),
                            ('delay_limit', (YLeaf(YType.uint32, 'delay-limit'), ['int'])),
                        ])
                        self.configured_bandwidth = None
                        self.cost_limit = None
                        self.dste_class_type = None
                        self.bandwidth_type = None
                        self.is_bandwidth_configured = None
                        self.is_cost_limit_configured = None
                        self.is_affinity_configured = None
                        self.generation = None
                        self.path_invalidation_timeout = None
                        self.path_invalidation_action = None
                        self.is_path_invalidation_timeout_configured = None
                        self.is_path_invalidation_action_configured = None
                        self.exclude_list_name = None
                        self.is_exclude_list_name_configured = None
                        self.is_pce_configured = None
                        self.is_pce_disj_source_configured = None
                        self.is_pce_disj_type_configured = None
                        self.is_pce_disj_group_id_configured = None
                        self.pcedp_source_address = None
                        self.pcedp_type = None
                        self.pcedp_group_id = None
                        self.is_pceb_dj_source_configured = None
                        self.is_pcebd_group_id_configured = None
                        self.pcebd_source_address = None
                        self.pcebd_group_id = None
                        self.is_bfd_reverse_pat_configured = None
                        self.is_delay_limit_configured = None
                        self.delay_limit = None

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.bfd_reverse_path = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                        self.bfd_reverse_path.parent = self
                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"

                        self.tunnel_id = YList(self)
                        self.version_info = YList(self)
                        self._segment_path = lambda: "attribute-set-path-option"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, ['configured_bandwidth', 'cost_limit', 'dste_class_type', 'bandwidth_type', 'is_bandwidth_configured', 'is_cost_limit_configured', 'is_affinity_configured', 'generation', 'path_invalidation_timeout', 'path_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'exclude_list_name', 'is_exclude_list_name_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id', 'is_bfd_reverse_pat_configured', 'is_delay_limit_configured', 'delay_limit'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity']['meta_info']


                    class BfdReversePath(_Entity_):
                        """
                        BFD reverse path
                        
                        .. attribute:: path_type
                        
                        	BFD reverse path type
                        	**type**\:  :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                        
                        	**config**\: False
                        
                        .. attribute:: binding_label
                        
                        	BFD reverse path binding label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                            self.yang_name = "bfd-reverse-path"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_type', (YLeaf(YType.enumeration, 'path-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdReversePath', '')])),
                                ('binding_label', (YLeaf(YType.uint32, 'binding-label'), ['int'])),
                            ])
                            self.path_type = None
                            self.binding_label = None
                            self._segment_path = lambda: "bfd-reverse-path"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, ['path_type', 'binding_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId']['meta_info']


                    class VersionInfo(_Entity_):
                        """
                        Version Info
                        
                        .. attribute:: attribute_type
                        
                        	Attribute Type
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: generation
                        
                        	Generation
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: is_default
                        
                        	Is default
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                            self.yang_name = "version-info"
                            self.yang_parent_name = "attribute-set-path-option"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('attribute_type', (YLeaf(YType.str, 'attribute-type'), ['str'])),
                                ('generation', (YLeaf(YType.uint32, 'generation'), ['int'])),
                                ('is_default', (YLeaf(YType.boolean, 'is-default'), ['bool'])),
                            ])
                            self.attribute_type = None
                            self.generation = None
                            self.is_default = None
                            self._segment_path = lambda: "version-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, ['attribute_type', 'generation', 'is_default'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption']['meta_info']


                class AttributeSetAutobackup(_Entity_):
                    """
                    MPLS TE Auto\-backup Attribute Set
                    
                    .. attribute:: signalled_name
                    
                    	Signalled name
                    	**type**\:  :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                    
                    	**config**\: False
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_signalled_name_configured
                    
                    	Is signalled name configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                    
                    	**config**\: False
                    
                    .. attribute:: protected_interface
                    
                    	Array of Protected Interface Names
                    	**type**\: list of  		 :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                        self.yang_name = "attribute-set-autobackup"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("signalled-name", ("signalled_name", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName)), ("affinity", ("affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity)), ("logging", ("logging", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry)), ("tunnel-id", ("tunnel_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId)), ("protected-interface", ("protected_interface", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface))])
                        self._leafs = OrderedDict([
                            ('is_signalled_name_configured', (YLeaf(YType.boolean, 'is-signalled-name-configured'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                        ])
                        self.is_signalled_name_configured = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.policy_class = None
                        self.is_policyclass_configured = None
                        self.is_affinity_configured = None
                        self.record_route = None

                        self.signalled_name = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                        self.signalled_name.parent = self
                        self._children_name_map["signalled_name"] = "signalled-name"

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.tunnel_id = YList(self)
                        self.protected_interface = YList(self)
                        self._segment_path = lambda: "attribute-set-autobackup"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, ['is_signalled_name_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'is_affinity_configured', 'record_route'], name, value)


                    class SignalledName(_Entity_):
                        """
                        Signalled name
                        
                        .. attribute:: name
                        
                        	Signalled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: source_type
                        
                        	Source address or name
                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        	**config**\: False
                        
                        .. attribute:: protected_interface_type
                        
                        	Protected interface address or name
                        	**type**\:  :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        	**config**\: False
                        
                        .. attribute:: is_mp_addresses
                        
                        	MP address appended
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                            self.yang_name = "signalled-name"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('name', (YLeaf(YType.str, 'name'), ['str'])),
                                ('source_type', (YLeaf(YType.enumeration, 'source-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                ('protected_interface_type', (YLeaf(YType.enumeration, 'protected-interface-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSigNameAppend', '')])),
                                ('is_mp_addresses', (YLeaf(YType.boolean, 'is-mp-addresses'), ['bool'])),
                            ])
                            self.name = None
                            self.source_type = None
                            self.protected_interface_type = None
                            self.is_mp_addresses = None
                            self._segment_path = lambda: "signalled-name"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, ['name', 'source_type', 'protected_interface_type', 'is_mp_addresses'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName']['meta_info']


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId']['meta_info']


                    class ProtectedInterface(_Entity_):
                        """
                        Array of Protected Interface Names
                        
                        .. attribute:: protected_interface
                        
                        	Protected Interface Name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                            self.yang_name = "protected-interface"
                            self.yang_parent_name = "attribute-set-autobackup"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('protected_interface', (YLeaf(YType.str, 'protected-interface'), ['str'])),
                            ])
                            self.protected_interface = None
                            self._segment_path = lambda: "protected-interface"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, ['protected_interface'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup']['meta_info']


                class AttributeSetAutomesh(_Entity_):
                    """
                    MPLS TE Auto\-mesh Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_forward_class_configured
                    
                    	True if forward\-class is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_node_protection
                    
                    	FRR Node protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: auto_bandwidth_collect
                    
                    	Auto bandwidth collect only
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: auto_route_announce
                    
                    	Announce auto route to IGP
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: soft_preemption_configured
                    
                    	Soft preemption is configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth
                    
                    	IM bandwidth
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: load_share
                    
                    	Load Share
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_interface_bw_configured
                    
                    	Is Interface BW configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of  		 :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                    
                    	**config**\: False
                    
                    .. attribute:: mesh_group_id
                    
                    	Meshgroup ID
                    	**type**\: list of  		 :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                        self.yang_name = "attribute-set-automesh"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity)), ("logging", ("logging", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging)), ("policy-class-entry", ("policy_class_entry", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry)), ("mesh-group-id", ("mesh_group_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId)), ("tunnel-id", ("tunnel_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId))])
                        self._leafs = OrderedDict([
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('policy_class', (YLeaf(YType.uint8, 'policy-class'), ['int'])),
                            ('is_policyclass_configured', (YLeaf(YType.boolean, 'is-policyclass-configured'), ['bool'])),
                            ('forward_class', (YLeaf(YType.uint32, 'forward-class'), ['int'])),
                            ('is_forward_class_configured', (YLeaf(YType.boolean, 'is-forward-class-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('frr_node_protection', (YLeaf(YType.boolean, 'frr-node-protection'), ['bool'])),
                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                            ('record_route', (YLeaf(YType.boolean, 'record-route'), ['bool'])),
                            ('auto_bandwidth_collect', (YLeaf(YType.boolean, 'auto-bandwidth-collect'), ['bool'])),
                            ('auto_route_announce', (YLeaf(YType.boolean, 'auto-route-announce'), ['bool'])),
                            ('soft_preemption_configured', (YLeaf(YType.boolean, 'soft-preemption-configured'), ['bool'])),
                            ('bandwidth', (YLeaf(YType.uint32, 'bandwidth'), ['int'])),
                            ('load_share', (YLeaf(YType.uint32, 'load-share'), ['int'])),
                            ('is_interface_bw_configured', (YLeaf(YType.boolean, 'is-interface-bw-configured'), ['bool'])),
                        ])
                        self.configured_bandwidth = None
                        self.dste_class_type = None
                        self.is_bandwidth_configured = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.policy_class = None
                        self.is_policyclass_configured = None
                        self.forward_class = None
                        self.is_forward_class_configured = None
                        self.is_affinity_configured = None
                        self.fast_reroute = None
                        self.frr_node_protection = None
                        self.frr_bandwidth_protection = None
                        self.record_route = None
                        self.auto_bandwidth_collect = None
                        self.auto_route_announce = None
                        self.soft_preemption_configured = None
                        self.bandwidth = None
                        self.load_share = None
                        self.is_interface_bw_configured = None

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.policy_class_entry = YList(self)
                        self.mesh_group_id = YList(self)
                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-automesh"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, ['configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'setup_priority', 'hold_priority', 'is_priority_configured', 'policy_class', 'is_policyclass_configured', 'forward_class', 'is_forward_class_configured', 'is_affinity_configured', 'fast_reroute', 'frr_node_protection', 'frr_bandwidth_protection', 'record_route', 'auto_bandwidth_collect', 'auto_route_announce', 'soft_preemption_configured', 'bandwidth', 'load_share', 'is_interface_bw_configured'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging']['meta_info']


                    class PolicyClassEntry(_Entity_):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	PBTS policy classes
                        	**type**\: int
                        
                        	**range:** 0..255
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint8, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "policy-class-entry"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry']['meta_info']


                    class MeshGroupId(_Entity_):
                        """
                        Meshgroup ID
                        
                        .. attribute:: entry
                        
                        	Meshgroup ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                            self.yang_name = "mesh-group-id"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "mesh-group-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-automesh"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh']['meta_info']


                class AttributeSetXro(_Entity_):
                    """
                    Attribute Set XRO
                    
                    .. attribute:: xro
                    
                    	The XRO specified by this attribute\-set
                    	**type**\:  :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                        self.yang_name = "attribute-set-xro"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("xro", ("xro", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro))])
                        self._leafs = OrderedDict()

                        self.xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                        self.xro.parent = self
                        self._children_name_map["xro"] = "xro"
                        self._segment_path = lambda: "attribute-set-xro"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, [], name, value)


                    class Xro(_Entity_):
                        """
                        The XRO specified by this attribute\-set
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of  		 :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                            self.yang_name = "xro"
                            self.yang_parent_name = "attribute-set-xro"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("xro-subobject", ("xro_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject))])
                            self._leafs = OrderedDict([
                                ('mutual_diversity_flag', (YLeaf(YType.boolean, 'mutual-diversity-flag'), ['bool'])),
                            ])
                            self.mutual_diversity_flag = None

                            self.xro_subobject = YList(self)
                            self._segment_path = lambda: "xro"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, ['mutual_diversity_flag'], name, value)


                        class XroSubobject(_Entity_):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:  :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:  :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:  :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:  :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:  :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:  :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:  :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "xro"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("ipv4-subobject", ("ipv4_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject)), ("ipv6-subobject", ("ipv6_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject)), ("unnumbered-subobject", ("unnumbered_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject)), ("as-subobject", ("as_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject)), ("srlg-subobject", ("srlg_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject)), ("lsp-subobject", ("lsp_subobject", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroSubobj', '')])),
                                ])
                                self.type = None

                                self.ipv4_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"

                                self.ipv6_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"

                                self.unnumbered_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"

                                self.as_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"

                                self.srlg_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"

                                self.lsp_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._segment_path = lambda: "xro-subobject"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, ['type'], name, value)


                            class Ipv4Subobject(_Entity_):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv4-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject']['meta_info']


                            class Ipv6Subobject(_Entity_):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\: str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('address', (YLeaf(YType.str, 'address'), ['str'])),
                                        ('prefix_len', (YLeaf(YType.uint8, 'prefix-len'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.address = None
                                    self.prefix_len = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "ipv6-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, ['address', 'prefix_len', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject']['meta_info']


                            class UnnumberedSubobject(_Entity_):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:  :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('te_router_id', (YLeaf(YType.str, 'te-router-id'), ['str'])),
                                        ('interface_id', (YLeaf(YType.uint32, 'interface-id'), ['int'])),
                                        ('attribute', (YLeaf(YType.enumeration, 'attribute'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroAttribute', '')])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.te_router_id = None
                                    self.interface_id = None
                                    self.attribute = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "unnumbered-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, ['te_router_id', 'interface_id', 'attribute', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject']['meta_info']


                            class AsSubobject(_Entity_):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\: int
                                
                                	**range:** 0..65535
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('as_number', (YLeaf(YType.uint16, 'as-number'), ['int'])),
                                    ])
                                    self.as_number = None
                                    self._segment_path = lambda: "as-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, ['as_number'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject']['meta_info']


                            class SrlgSubobject(_Entity_):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('srlg_id', (YLeaf(YType.uint32, 'srlg-id'), ['int'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.srlg_id = None
                                    self.exclusion_type = None
                                    self._segment_path = lambda: "srlg-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, ['srlg_id', 'exclusion_type'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject']['meta_info']


                            class LspSubobject(_Entity_):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:  :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                
                                	**config**\: False
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\: bool
                                
                                	**config**\: False
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:  :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("fec", ("fec", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec))])
                                    self._leafs = OrderedDict([
                                        ('ignore_lsp_id', (YLeaf(YType.boolean, 'ignore-lsp-id'), ['bool'])),
                                        ('processing_node_exception', (YLeaf(YType.boolean, 'processing-node-exception'), ['bool'])),
                                        ('penultimate_node_exception', (YLeaf(YType.boolean, 'penultimate-node-exception'), ['bool'])),
                                        ('destination_node_exception', (YLeaf(YType.boolean, 'destination-node-exception'), ['bool'])),
                                        ('exclusion_type', (YLeaf(YType.enumeration, 'exclusion-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeXroExclusion', '')])),
                                    ])
                                    self.ignore_lsp_id = None
                                    self.processing_node_exception = None
                                    self.penultimate_node_exception = None
                                    self.destination_node_exception = None
                                    self.exclusion_type = None

                                    self.fec = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._segment_path = lambda: "lsp-subobject"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, ['ignore_lsp_id', 'processing_node_exception', 'penultimate_node_exception', 'destination_node_exception', 'exclusion_type'], name, value)


                                class Fec(_Entity_):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: int
                                    
                                    	**range:** 0..65535
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\: str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    	**config**\: False
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\: str
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo))])
                                        self._leafs = OrderedDict([
                                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                        ])
                                        self.fec_lsp_id = None
                                        self.fec_tunnel_id = None
                                        self.fec_extended_tunnel_id = None
                                        self.fec_source = None
                                        self.fec_vrf = None

                                        self.fec_destination_info = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._segment_path = lambda: "fec"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                                    class FecDestinationInfo(_Entity_):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\: str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        	**config**\: False
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\: int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**config**\: False
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2018-08-01'

                                        def __init__(self):
                                            if sys.version_info > (3,):
                                                super().__init__()
                                            else:
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self.ylist_key_names = []
                                            self._child_classes = OrderedDict([])
                                            self._leafs = OrderedDict([
                                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                            ])
                                            self.fec_ctype = None
                                            self.p2p_lsp_destination = None
                                            self.fec_destination_p2mp_id = None
                                            self._segment_path = lambda: "fec-destination-info"
                                            self._is_frozen = True

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                        @staticmethod
                                        def _meta_info():
                                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo']['meta_info']

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro']['meta_info']


                class AttributeSetP2mpte(_Entity_):
                    """
                    MPLS TE P2MP\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\: int
                    
                    	**range:** 0..255
                    
                    	**config**\: False
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, self).__init__()

                        self.yang_name = "attribute-set-p2mpte"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity)), ("tunnel-id", ("tunnel_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId))])
                        self._leafs = OrderedDict([
                            ('fast_reroute', (YLeaf(YType.boolean, 'fast-reroute'), ['bool'])),
                            ('frr_bandwidth_protection', (YLeaf(YType.boolean, 'frr-bandwidth-protection'), ['bool'])),
                            ('setup_priority', (YLeaf(YType.uint8, 'setup-priority'), ['int'])),
                            ('hold_priority', (YLeaf(YType.uint8, 'hold-priority'), ['int'])),
                            ('is_priority_configured', (YLeaf(YType.boolean, 'is-priority-configured'), ['bool'])),
                            ('configured_bandwidth', (YLeaf(YType.uint32, 'configured-bandwidth'), ['int'])),
                            ('dste_class_type', (YLeaf(YType.uint8, 'dste-class-type'), ['int'])),
                            ('is_bandwidth_configured', (YLeaf(YType.boolean, 'is-bandwidth-configured'), ['bool'])),
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                        ])
                        self.fast_reroute = None
                        self.frr_bandwidth_protection = None
                        self.setup_priority = None
                        self.hold_priority = None
                        self.is_priority_configured = None
                        self.configured_bandwidth = None
                        self.dste_class_type = None
                        self.is_bandwidth_configured = None
                        self.is_affinity_configured = None

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-p2mpte"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte, ['fast_reroute', 'frr_bandwidth_protection', 'setup_priority', 'hold_priority', 'is_priority_configured', 'configured_bandwidth', 'dste_class_type', 'is_bandwidth_configured', 'is_affinity_configured'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2mpte"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.Affinity']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2mpte"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2mpte']['meta_info']


                class AttributeSetApsPp(_Entity_):
                    """
                    Attribute Set OTN APS Path Protection
                    
                    .. attribute:: revert_schedule
                    
                    	Revert Schedule
                    	**type**\:  :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                    
                    	**config**\: False
                    
                    .. attribute:: snc_mode
                    
                    	Sub\-network Connection Mode
                    	**type**\:  :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: tcm_id
                    
                    	Sub\-network Connection Monitoring Mode
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: protection_type
                    
                    	Protection Type
                    	**type**\:  :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection_mode
                    
                    	Protection Restoration Mode
                    	**type**\:  :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                    
                    	**config**\: False
                    
                    .. attribute:: wait_to_restore_time
                    
                    	Wait to restore time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: hold_off_time
                    
                    	Hold\-off time
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_prot_profile_type
                    
                    	Path Protection Profile Type
                    	**type**\:  :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                    
                    	**config**\: False
                    
                    .. attribute:: restoration_style
                    
                    	Restoration Style
                    	**type**\:  :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                        self.yang_name = "attribute-set-aps-pp"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("revert-schedule", ("revert_schedule", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule))])
                        self._leafs = OrderedDict([
                            ('snc_mode', (YLeaf(YType.enumeration, 'snc-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeApsSncMode', '')])),
                            ('tcm_id', (YLeaf(YType.uint32, 'tcm-id'), ['int'])),
                            ('protection_type', (YLeaf(YType.enumeration, 'protection-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProtect', '')])),
                            ('protection_mode', (YLeaf(YType.enumeration, 'protection-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePnrRevertOptions', '')])),
                            ('wait_to_restore_time', (YLeaf(YType.uint32, 'wait-to-restore-time'), ['int'])),
                            ('hold_off_time', (YLeaf(YType.uint32, 'hold-off-time'), ['int'])),
                            ('path_prot_profile_type', (YLeaf(YType.enumeration, 'path-prot-profile-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathProtProfile', '')])),
                            ('restoration_style', (YLeaf(YType.enumeration, 'restoration-style'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeRestorationStyle', '')])),
                        ])
                        self.snc_mode = None
                        self.tcm_id = None
                        self.protection_type = None
                        self.protection_mode = None
                        self.wait_to_restore_time = None
                        self.hold_off_time = None
                        self.path_prot_profile_type = None
                        self.restoration_style = None

                        self.revert_schedule = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                        self.revert_schedule.parent = self
                        self._children_name_map["revert_schedule"] = "revert-schedule"
                        self._segment_path = lambda: "attribute-set-aps-pp"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, ['snc_mode', 'tcm_id', 'protection_type', 'protection_mode', 'wait_to_restore_time', 'hold_off_time', 'path_prot_profile_type', 'restoration_style'], name, value)


                    class RevertSchedule(_Entity_):
                        """
                        Revert Schedule
                        
                        .. attribute:: schedulename
                        
                        	Schedule name identifier
                        	**type**\: str
                        
                        	**length:** 0..255
                        
                        	**config**\: False
                        
                        .. attribute:: schedule_date
                        
                        	Schedule time for reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: schedule_frequency
                        
                        	Schedule frequency for reversion
                        	**type**\:  :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                        
                        	**config**\: False
                        
                        .. attribute:: duration
                        
                        	Duration for scheduled reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: max_tries
                        
                        	Max tries for scheduled reversion
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                            self.yang_name = "revert-schedule"
                            self.yang_parent_name = "attribute-set-aps-pp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('schedulename', (YLeaf(YType.str, 'schedulename'), ['str'])),
                                ('schedule_date', (YLeaf(YType.uint32, 'schedule-date'), ['int'])),
                                ('schedule_frequency', (YLeaf(YType.enumeration, 'schedule-frequency'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSchFreq', '')])),
                                ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                                ('max_tries', (YLeaf(YType.uint32, 'max-tries'), ['int'])),
                            ])
                            self.schedulename = None
                            self.schedule_date = None
                            self.schedule_frequency = None
                            self.duration = None
                            self.max_tries = None
                            self._segment_path = lambda: "revert-schedule"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, ['schedulename', 'schedule_date', 'schedule_frequency', 'duration', 'max_tries'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp']['meta_info']


                class AttributeSetP2pTe(_Entity_):
                    """
                    MPLS TE P2P\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:  :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity>`
                    
                    	**config**\: False
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:  :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging>`
                    
                    	**config**\: False
                    
                    .. attribute:: prepend_list
                    
                    	SR prepend list
                    	**type**\:  :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_adjacency_protection
                    
                    	Path selection segment\-routing type
                    	**type**\:  :py:class:`TeS2lSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lSrPathSelection>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                    
                    	Is path selection segment routing configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout on the tunnel path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:  :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is Path Invalidation timeout configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is Path Invalidation action configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_metric
                    
                    	Path selection metric type
                    	**type**\:  :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_metric_configured
                    
                    	Is path selection metric configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_margin
                    
                    	Path selection margin
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_margin_relative
                    
                    	Path selection margin is\_relative
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_margin_configured
                    
                    	Is path selection margin configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_selection_segment_routing_segment_limit
                    
                    	Is path selection segment limit configured
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                    
                    	Is path selection segment limit configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_select_configured
                    
                    	Is any of the path selection parameters configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_prepend_list_configured
                    
                    	Is SR prepend list configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:  :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    	**config**\: False
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of  		 :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, self).__init__()

                        self.yang_name = "attribute-set-p2p-te"
                        self.yang_parent_name = "attribute-set-union"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("affinity", ("affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity)), ("logging", ("logging", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging)), ("prepend-list", ("prepend_list", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList)), ("tunnel-id", ("tunnel_id", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId))])
                        self._leafs = OrderedDict([
                            ('is_affinity_configured', (YLeaf(YType.boolean, 'is-affinity-configured'), ['bool'])),
                            ('path_selection_segment_routing_adjacency_protection', (YLeaf(YType.enumeration, 'path-selection-segment-routing-adjacency-protection'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lSrPathSelection', '')])),
                            ('is_path_selection_segment_routing_adjacency_protection_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-adjacency-protection-configured'), ['bool'])),
                            ('path_invalidation_timeout', (YLeaf(YType.uint32, 'path-invalidation-timeout'), ['int'])),
                            ('path_selection_invalidation_action', (YLeaf(YType.enumeration, 'path-selection-invalidation-action'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathInvalAction', '')])),
                            ('is_path_invalidation_timeout_configured', (YLeaf(YType.boolean, 'is-path-invalidation-timeout-configured'), ['bool'])),
                            ('is_path_invalidation_action_configured', (YLeaf(YType.boolean, 'is-path-invalidation-action-configured'), ['bool'])),
                            ('path_selection_metric', (YLeaf(YType.enumeration, 'path-selection-metric'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetric', '')])),
                            ('is_path_selection_metric_configured', (YLeaf(YType.boolean, 'is-path-selection-metric-configured'), ['bool'])),
                            ('path_selection_segment_routing_margin', (YLeaf(YType.uint32, 'path-selection-segment-routing-margin'), ['int'])),
                            ('is_path_selection_segment_routing_margin_relative', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-relative'), ['bool'])),
                            ('is_path_selection_segment_routing_margin_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-margin-configured'), ['bool'])),
                            ('path_selection_segment_routing_segment_limit', (YLeaf(YType.uint32, 'path-selection-segment-routing-segment-limit'), ['int'])),
                            ('is_path_selection_segment_routing_segment_limit_configured', (YLeaf(YType.boolean, 'is-path-selection-segment-routing-segment-limit-configured'), ['bool'])),
                            ('is_path_select_configured', (YLeaf(YType.boolean, 'is-path-select-configured'), ['bool'])),
                            ('is_prepend_list_configured', (YLeaf(YType.boolean, 'is-prepend-list-configured'), ['bool'])),
                            ('is_pce_configured', (YLeaf(YType.boolean, 'is-pce-configured'), ['bool'])),
                            ('is_pce_disj_source_configured', (YLeaf(YType.boolean, 'is-pce-disj-source-configured'), ['bool'])),
                            ('is_pce_disj_type_configured', (YLeaf(YType.boolean, 'is-pce-disj-type-configured'), ['bool'])),
                            ('is_pce_disj_group_id_configured', (YLeaf(YType.boolean, 'is-pce-disj-group-id-configured'), ['bool'])),
                            ('pcedp_source_address', (YLeaf(YType.uint32, 'pcedp-source-address'), ['int'])),
                            ('pcedp_type', (YLeaf(YType.enumeration, 'pcedp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePceDisjoint', '')])),
                            ('pcedp_group_id', (YLeaf(YType.uint32, 'pcedp-group-id'), ['int'])),
                            ('is_pceb_dj_source_configured', (YLeaf(YType.boolean, 'is-pceb-dj-source-configured'), ['bool'])),
                            ('is_pcebd_group_id_configured', (YLeaf(YType.boolean, 'is-pcebd-group-id-configured'), ['bool'])),
                            ('pcebd_source_address', (YLeaf(YType.uint32, 'pcebd-source-address'), ['int'])),
                            ('pcebd_group_id', (YLeaf(YType.uint32, 'pcebd-group-id'), ['int'])),
                        ])
                        self.is_affinity_configured = None
                        self.path_selection_segment_routing_adjacency_protection = None
                        self.is_path_selection_segment_routing_adjacency_protection_configured = None
                        self.path_invalidation_timeout = None
                        self.path_selection_invalidation_action = None
                        self.is_path_invalidation_timeout_configured = None
                        self.is_path_invalidation_action_configured = None
                        self.path_selection_metric = None
                        self.is_path_selection_metric_configured = None
                        self.path_selection_segment_routing_margin = None
                        self.is_path_selection_segment_routing_margin_relative = None
                        self.is_path_selection_segment_routing_margin_configured = None
                        self.path_selection_segment_routing_segment_limit = None
                        self.is_path_selection_segment_routing_segment_limit_configured = None
                        self.is_path_select_configured = None
                        self.is_prepend_list_configured = None
                        self.is_pce_configured = None
                        self.is_pce_disj_source_configured = None
                        self.is_pce_disj_type_configured = None
                        self.is_pce_disj_group_id_configured = None
                        self.pcedp_source_address = None
                        self.pcedp_type = None
                        self.pcedp_group_id = None
                        self.is_pceb_dj_source_configured = None
                        self.is_pcebd_group_id_configured = None
                        self.pcebd_source_address = None
                        self.pcebd_group_id = None

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"

                        self.prepend_list = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList()
                        self.prepend_list.parent = self
                        self._children_name_map["prepend_list"] = "prepend-list"

                        self.tunnel_id = YList(self)
                        self._segment_path = lambda: "attribute-set-p2p-te"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe, ['is_affinity_configured', 'path_selection_segment_routing_adjacency_protection', 'is_path_selection_segment_routing_adjacency_protection_configured', 'path_invalidation_timeout', 'path_selection_invalidation_action', 'is_path_invalidation_timeout_configured', 'is_path_invalidation_action_configured', 'path_selection_metric', 'is_path_selection_metric_configured', 'path_selection_segment_routing_margin', 'is_path_selection_segment_routing_margin_relative', 'is_path_selection_segment_routing_margin_configured', 'path_selection_segment_routing_segment_limit', 'is_path_selection_segment_routing_segment_limit_configured', 'is_path_select_configured', 'is_prepend_list_configured', 'is_pce_configured', 'is_pce_disj_source_configured', 'is_pce_disj_type_configured', 'is_pce_disj_group_id_configured', 'pcedp_source_address', 'pcedp_type', 'pcedp_group_id', 'is_pceb_dj_source_configured', 'is_pcebd_group_id_configured', 'pcebd_source_address', 'pcebd_group_id'], name, value)


                    class Affinity(_Entity_):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of  		 :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("named-affinity", ("named_affinity", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity))])
                            self._leafs = OrderedDict([
                                ('affinity_bits', (YLeaf(YType.uint32, 'affinity-bits'), ['int'])),
                                ('affinity_mask', (YLeaf(YType.uint32, 'affinity-mask'), ['int'])),
                            ])
                            self.affinity_bits = None
                            self.affinity_mask = None

                            self.named_affinity = YList(self)
                            self._segment_path = lambda: "affinity"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity, ['affinity_bits', 'affinity_mask'], name, value)


                        class NamedAffinity(_Entity_):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of  		 :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            	**config**\: False
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of  		 :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("constraint-extended-value", ("constraint_extended_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue)), ("extended-forward-ref-value", ("extended_forward_ref_value", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue))])
                                self._leafs = OrderedDict([
                                    ('constraint_type', (YLeaf(YType.uint8, 'constraint-type'), ['int'])),
                                    ('constraint_value', (YLeaf(YType.uint32, 'constraint-value'), ['int'])),
                                    ('forward_ref_value', (YLeaf(YType.uint32, 'forward-ref-value'), ['int'])),
                                ])
                                self.constraint_type = None
                                self.constraint_value = None
                                self.forward_ref_value = None

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)
                                self._segment_path = lambda: "named-affinity"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity, ['constraint_type', 'constraint_value', 'forward_ref_value'], name, value)


                            class ConstraintExtendedValue(_Entity_):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	Constraint value
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "constraint-extended-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ConstraintExtendedValue']['meta_info']


                            class ExtendedForwardRefValue(_Entity_):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	Reference bits for undefined affinity names
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "extended-forward-ref-value"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity.ExtendedForwardRefValue']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity.NamedAffinity']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Affinity']['meta_info']


                    class Logging(_Entity_):
                        """
                        Logging attributes
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_state', (YLeaf(YType.boolean, 'lsp-state'), ['bool'])),
                                ('s2l_state', (YLeaf(YType.boolean, 's2l-state'), ['bool'])),
                                ('lsp_re_route', (YLeaf(YType.boolean, 'lsp-re-route'), ['bool'])),
                                ('lsp_re_opt', (YLeaf(YType.boolean, 'lsp-re-opt'), ['bool'])),
                                ('lsp_insufficient_bw', (YLeaf(YType.boolean, 'lsp-insufficient-bw'), ['bool'])),
                                ('lsp_bandwidth_change', (YLeaf(YType.boolean, 'lsp-bandwidth-change'), ['bool'])),
                                ('lsp_pcalc_failure_logging_enabled', (YLeaf(YType.boolean, 'lsp-pcalc-failure-logging-enabled'), ['bool'])),
                                ('all_logging_enabled', (YLeaf(YType.boolean, 'all-logging-enabled'), ['bool'])),
                            ])
                            self.lsp_state = None
                            self.s2l_state = None
                            self.lsp_re_route = None
                            self.lsp_re_opt = None
                            self.lsp_insufficient_bw = None
                            self.lsp_bandwidth_change = None
                            self.lsp_pcalc_failure_logging_enabled = None
                            self.all_logging_enabled = None
                            self._segment_path = lambda: "logging"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging, ['lsp_state', 's2l_state', 'lsp_re_route', 'lsp_re_opt', 'lsp_insufficient_bw', 'lsp_bandwidth_change', 'lsp_pcalc_failure_logging_enabled', 'all_logging_enabled'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.Logging']['meta_info']


                    class PrependList(_Entity_):
                        """
                        SR prepend list
                        
                        .. attribute:: prepend_entry
                        
                        	List of prepend entries
                        	**type**\: list of  		 :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, self).__init__()

                            self.yang_name = "prepend-list"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("prepend-entry", ("prepend_entry", MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry))])
                            self._leafs = OrderedDict()

                            self.prepend_entry = YList(self)
                            self._segment_path = lambda: "prepend-list"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList, [], name, value)


                        class PrependEntry(_Entity_):
                            """
                            List of prepend entries
                            
                            .. attribute:: type
                            
                            	Prepend Type
                            	**type**\:  :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                            
                            	**config**\: False
                            
                            .. attribute:: index
                            
                            	Prepend index
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: next_label
                            
                            	Prepend next label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, self).__init__()

                                self.yang_name = "prepend-entry"
                                self.yang_parent_name = "prepend-list"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAttributeSetSrPrepend', '')])),
                                    ('index', (YLeaf(YType.uint32, 'index'), ['int'])),
                                    ('next_label', (YLeaf(YType.uint32, 'next-label'), ['int'])),
                                ])
                                self.type = None
                                self.index = None
                                self.next_label = None
                                self._segment_path = lambda: "prepend-entry"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry, ['type', 'index', 'next_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList.PrependEntry']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.PrependList']['meta_info']


                    class TunnelId(_Entity_):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2p-te"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint16, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "tunnel-id"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe.TunnelId']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2pTe']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AttributeSets.AttributeSet']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AttributeSets']['meta_info']


    class IgpAreaBriefs(_Entity_):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area_brief
        
        	An IGP instance Brief info
        	**type**\: list of  		 :py:class:`IgpAreaBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.IgpAreaBriefs, self).__init__()

            self.yang_name = "igp-area-briefs"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("igp-area-brief", ("igp_area_brief", MplsTeStandby.IgpAreaBriefs.IgpAreaBrief))])
            self._leafs = OrderedDict()

            self.igp_area_brief = YList(self)
            self._segment_path = lambda: "igp-area-briefs"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.IgpAreaBriefs, [], name, value)


        class IgpAreaBrief(_Entity_):
            """
            An IGP instance Brief info
            
            .. attribute:: protocol  (key)
            
            	The IGP protocol
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: process_tag  (key)
            
            	IGP Process Tag
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:  :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of  		 :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId>`
            
            	**config**\: False
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of  		 :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief, self).__init__()

                self.yang_name = "igp-area-brief"
                self.yang_parent_name = "igp-area-briefs"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','process_tag']
                self._child_classes = OrderedDict([("secondary-router-id", ("secondary_router_id", MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId)), ("area", ("area", MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('process_tag', (YLeaf(YType.str, 'process-tag'), ['str'])),
                    ('igp_type', (YLeaf(YType.enumeration, 'igp-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpProtocol', '')])),
                    ('instance_name', (YLeaf(YType.str, 'instance-name'), ['str'])),
                    ('igp_system_id', (YLeaf(YType.str, 'igp-system-id'), ['str'])),
                    ('configured_te_router_id', (YLeaf(YType.str, 'configured-te-router-id'), ['str'])),
                    ('global_router_id', (YLeaf(YType.str, 'global-router-id'), ['str'])),
                    ('globall_router_id_optical', (YLeaf(YType.str, 'globall-router-id-optical'), ['str'])),
                    ('in_use_te_router_id', (YLeaf(YType.str, 'in-use-te-router-id'), ['str'])),
                    ('is_connection_up', (YLeaf(YType.boolean, 'is-connection-up'), ['bool'])),
                    ('connection_up_count', (YLeaf(YType.uint32, 'connection-up-count'), ['int'])),
                    ('connection_down_count', (YLeaf(YType.uint32, 'connection-down-count'), ['int'])),
                ])
                self.protocol = None
                self.process_tag = None
                self.igp_type = None
                self.instance_name = None
                self.igp_system_id = None
                self.configured_te_router_id = None
                self.global_router_id = None
                self.globall_router_id_optical = None
                self.in_use_te_router_id = None
                self.is_connection_up = None
                self.connection_up_count = None
                self.connection_down_count = None

                self.secondary_router_id = YList(self)
                self.area = YList(self)
                self._segment_path = lambda: "igp-area-brief" + "[protocol='" + str(self.protocol) + "']" + "[process-tag='" + str(self.process_tag) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/igp-area-briefs/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief, ['protocol', 'process_tag', 'igp_type', 'instance_name', 'igp_system_id', 'configured_te_router_id', 'global_router_id', 'globall_router_id_optical', 'in_use_te_router_id', 'is_connection_up', 'connection_up_count', 'connection_down_count'], name, value)


            class SecondaryRouterId(_Entity_):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	Secondary router\-ids
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.str, 'entry'), ['str'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "secondary-router-id"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId']['meta_info']


            class Area(_Entity_):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:  :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData>`
                
                	**config**\: False
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_number
                
                	Area number
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:  :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                	**config**\: False
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("active-data", ("active_data", MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData))])
                    self._leafs = OrderedDict([
                        ('area_index', (YLeaf(YType.uint32, 'area-index'), ['int'])),
                        ('area_number', (YLeaf(YType.uint32, 'area-number'), ['int'])),
                        ('area_format', (YLeaf(YType.enumeration, 'area-format'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpOspfAreaFormat', '')])),
                        ('is_config_ready', (YLeaf(YType.boolean, 'is-config-ready'), ['bool'])),
                    ])
                    self.area_index = None
                    self.area_number = None
                    self.area_format = None
                    self.is_config_ready = None

                    self.active_data = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._segment_path = lambda: "area"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area, ['area_index', 'area_number', 'area_format', 'is_config_ready'], name, value)


                class ActiveData(_Entity_):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:  :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics>`
                    
                    	**config**\: False
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("area-statistics", ("area_statistics", MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics))])
                        self._leafs = OrderedDict([
                            ('interfaces_count', (YLeaf(YType.uint32, 'interfaces-count'), ['int'])),
                            ('link_idt_received', (YLeaf(YType.boolean, 'link-idt-received'), ['bool'])),
                            ('topology_idt_received', (YLeaf(YType.boolean, 'topology-idt-received'), ['bool'])),
                            ('sr_strict', (YLeaf(YType.boolean, 'sr-strict'), ['bool'])),
                            ('p2p_heads_count', (YLeaf(YType.uint32, 'p2p-heads-count'), ['int'])),
                            ('p2p_autoroute_announced_count', (YLeaf(YType.uint32, 'p2p-autoroute-announced-count'), ['int'])),
                            ('p2p_forwarding_adjacency_count', (YLeaf(YType.uint32, 'p2p-forwarding-adjacency-count'), ['int'])),
                            ('p2mp_destination_count', (YLeaf(YType.uint32, 'p2mp-destination-count'), ['int'])),
                            ('tunnel_loose_hops', (YLeaf(YType.uint32, 'tunnel-loose-hops'), ['int'])),
                        ])
                        self.interfaces_count = None
                        self.link_idt_received = None
                        self.topology_idt_received = None
                        self.sr_strict = None
                        self.p2p_heads_count = None
                        self.p2p_autoroute_announced_count = None
                        self.p2p_forwarding_adjacency_count = None
                        self.p2mp_destination_count = None
                        self.tunnel_loose_hops = None

                        self.area_statistics = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._segment_path = lambda: "active-data"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, ['interfaces_count', 'link_idt_received', 'topology_idt_received', 'sr_strict', 'p2p_heads_count', 'p2p_autoroute_announced_count', 'p2p_forwarding_adjacency_count', 'p2mp_destination_count', 'tunnel_loose_hops'], name, value)


                    class AreaStatistics(_Entity_):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('area_adjacency_request_messages', (YLeaf(YType.uint32, 'area-adjacency-request-messages'), ['int'])),
                                ('area_adjacency_announce_messages', (YLeaf(YType.uint32, 'area-adjacency-announce-messages'), ['int'])),
                                ('area_flood_messages', (YLeaf(YType.uint32, 'area-flood-messages'), ['int'])),
                                ('area_lsa_announce_messages', (YLeaf(YType.uint32, 'area-lsa-announce-messages'), ['int'])),
                                ('area_lsa_fragment_announce_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-announce-messages'), ['int'])),
                                ('area_lsa_delete_messages', (YLeaf(YType.uint32, 'area-lsa-delete-messages'), ['int'])),
                                ('area_lsa_fragment_delete_messages', (YLeaf(YType.uint32, 'area-lsa-fragment-delete-messages'), ['int'])),
                                ('area_tunnel_announce_messages', (YLeaf(YType.uint32, 'area-tunnel-announce-messages'), ['int'])),
                            ])
                            self.area_adjacency_request_messages = None
                            self.area_adjacency_announce_messages = None
                            self.area_flood_messages = None
                            self.area_lsa_announce_messages = None
                            self.area_lsa_fragment_announce_messages = None
                            self.area_lsa_delete_messages = None
                            self.area_lsa_fragment_delete_messages = None
                            self.area_tunnel_announce_messages = None
                            self._segment_path = lambda: "area-statistics"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, ['area_adjacency_request_messages', 'area_adjacency_announce_messages', 'area_flood_messages', 'area_lsa_announce_messages', 'area_lsa_fragment_announce_messages', 'area_lsa_delete_messages', 'area_lsa_fragment_delete_messages', 'area_tunnel_announce_messages'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.IgpAreaBriefs.IgpAreaBrief']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.IgpAreaBriefs']['meta_info']


    class BandwidthAccountingCounters(_Entity_):
        """
        Bandwidth accounting counters
        
        .. attribute:: last_cleared_timestamp
        
        	The timestamp when these stats are cleared relative to Jan 1, 1970
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bandwidth_application_count
        
        	Number of bandwidth accounting applications
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: bandwidth_sample_count
        
        	Number of bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: invalid_sample_count
        
        	Number of invalid bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: skipped_application_count
        
        	Number of skipped bandwidth accounting applications
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: capped_sample_count
        
        	Number of capped bandwidth accounting samples
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: high_latency_count
        
        	Number of statsd requests that returned with high latency
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.BandwidthAccountingCounters, self).__init__()

            self.yang_name = "bandwidth-accounting-counters"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                ('bandwidth_application_count', (YLeaf(YType.uint32, 'bandwidth-application-count'), ['int'])),
                ('bandwidth_sample_count', (YLeaf(YType.uint32, 'bandwidth-sample-count'), ['int'])),
                ('invalid_sample_count', (YLeaf(YType.uint32, 'invalid-sample-count'), ['int'])),
                ('skipped_application_count', (YLeaf(YType.uint32, 'skipped-application-count'), ['int'])),
                ('capped_sample_count', (YLeaf(YType.uint32, 'capped-sample-count'), ['int'])),
                ('high_latency_count', (YLeaf(YType.uint32, 'high-latency-count'), ['int'])),
            ])
            self.last_cleared_timestamp = None
            self.bandwidth_application_count = None
            self.bandwidth_sample_count = None
            self.invalid_sample_count = None
            self.skipped_application_count = None
            self.capped_sample_count = None
            self.high_latency_count = None
            self._segment_path = lambda: "bandwidth-accounting-counters"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.BandwidthAccountingCounters, ['last_cleared_timestamp', 'bandwidth_application_count', 'bandwidth_sample_count', 'invalid_sample_count', 'skipped_application_count', 'capped_sample_count', 'high_latency_count'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.BandwidthAccountingCounters']['meta_info']


    class Tunnels(_Entity_):
        """
        Failure protection provided for tunnels
        
        .. attribute:: tunnel_flex_lsps
        
        	Flex LSP
        	**type**\:  :py:class:`TunnelFlexLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps>`
        
        	**config**\: False
        
        .. attribute:: tunnel_auto_bandwidths
        
        	Auto Bandwidth Brief Table
        	**type**\:  :py:class:`TunnelAutoBandwidths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths>`
        
        	**config**\: False
        
        .. attribute:: summary
        
        	Summary of tunnel info
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary>`
        
        	**config**\: False
        
        .. attribute:: tunnel_path_protections
        
        	Path protection
        	**type**\:  :py:class:`TunnelPathProtections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-flex-lsps", ("tunnel_flex_lsps", MplsTeStandby.Tunnels.TunnelFlexLsps)), ("tunnel-auto-bandwidths", ("tunnel_auto_bandwidths", MplsTeStandby.Tunnels.TunnelAutoBandwidths)), ("summary", ("summary", MplsTeStandby.Tunnels.Summary)), ("tunnel-path-protections", ("tunnel_path_protections", MplsTeStandby.Tunnels.TunnelPathProtections))])
            self._leafs = OrderedDict()

            self.tunnel_flex_lsps = MplsTeStandby.Tunnels.TunnelFlexLsps()
            self.tunnel_flex_lsps.parent = self
            self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"

            self.tunnel_auto_bandwidths = MplsTeStandby.Tunnels.TunnelAutoBandwidths()
            self.tunnel_auto_bandwidths.parent = self
            self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"

            self.summary = MplsTeStandby.Tunnels.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.tunnel_path_protections = MplsTeStandby.Tunnels.TunnelPathProtections()
            self.tunnel_path_protections.parent = self
            self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
            self._segment_path = lambda: "tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.Tunnels, [], name, value)


        class TunnelFlexLsps(_Entity_):
            """
            Flex LSP
            
            .. attribute:: tunnel_flex_lsp
            
            	Flex LSP
            	**type**\: list of  		 :py:class:`TunnelFlexLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Tunnels.TunnelFlexLsps, self).__init__()

                self.yang_name = "tunnel-flex-lsps"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-flex-lsp", ("tunnel_flex_lsp", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp))])
                self._leafs = OrderedDict()

                self.tunnel_flex_lsp = YList(self)
                self._segment_path = lambda: "tunnel-flex-lsps"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps, [], name, value)


            class TunnelFlexLsp(_Entity_):
                """
                Flex LSP
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: working_lsp
                
                	 Working LSP info
                	**type**\:  :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp>`
                
                	**config**\: False
                
                .. attribute:: protect_lsp
                
                	 Protect LSP info
                	**type**\:  :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp>`
                
                	**config**\: False
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: tun_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__init__()

                    self.yang_name = "tunnel-flex-lsp"
                    self.yang_parent_name = "tunnel-flex-lsps"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("working-lsp", ("working_lsp", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp)), ("protect-lsp", ("protect_lsp", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('is_tunnel_up', (YLeaf(YType.boolean, 'is-tunnel-up'), ['bool'])),
                        ('tun_id', (YLeaf(YType.uint16, 'tun-id'), ['int'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.is_tunnel_up = None
                    self.tun_id = None
                    self.source_address = None
                    self.destination_address = None
                    self.extended_tunnel_id = None

                    self.working_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"

                    self.protect_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._segment_path = lambda: "tunnel-flex-lsp"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp, ['ctype', 'tunnel_id', 'tunnel_name', 'is_tunnel_up', 'tun_id', 'source_address', 'destination_address', 'extended_tunnel_id'], name, value)


                class WorkingLsp(_Entity_):
                    """
                     Working LSP info
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:  :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("flex-info", ("flex_info", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo)), ("association", ("association", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association)), ("protection", ("protection", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection)), ("reverse-lsp", ("reverse_lsp", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp)), ("lsp-hop", ("lsp_hop", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('is_operational', (YLeaf(YType.boolean, 'is-operational'), ['bool'])),
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.is_operational = None
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_mode = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"

                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "working-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, ['is_operational', 'lsp_uptime', 'path_protection_lsp_id', 'lsp_mode', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class FlexInfo(_Entity_):
                        """
                        Flex Info
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/flex-info/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/association/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection']['meta_info']


                    class ReverseLsp(_Entity_):
                        """
                        Reverse LSP information
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec)), ("association", ("association", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association)), ("protection", ("protection", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ])
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None

                            self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._segment_path = lambda: "reverse-lsp"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, ['reverse_lsp_present', 'reverse_lsp_connected'], name, value)


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/reverse-lsp-fec/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/association/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "working-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp']['meta_info']


                class ProtectLsp(_Entity_):
                    """
                     Protect LSP info
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:  :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association>`
                    
                    	**config**\: False
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection>`
                    
                    	**config**\: False
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:  :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:  :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("flex-info", ("flex_info", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo)), ("association", ("association", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association)), ("protection", ("protection", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection)), ("reverse-lsp", ("reverse_lsp", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp)), ("lsp-hop", ("lsp_hop", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('is_operational', (YLeaf(YType.boolean, 'is-operational'), ['bool'])),
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_mode', (YLeaf(YType.enumeration, 'lsp-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeLspMode', '')])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.is_operational = None
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_mode = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"

                        self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"

                        self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"

                        self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"

                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "protect-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, ['is_operational', 'lsp_uptime', 'path_protection_lsp_id', 'lsp_mode', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class FlexInfo(_Entity_):
                        """
                        Flex Info
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:  :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\: str
                        
                        	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("flex-fec", ("flex_fec", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec))])
                            self._leafs = OrderedDict([
                                ('entry_exists', (YLeaf(YType.boolean, 'entry-exists'), ['bool'])),
                                ('in_label', (YLeaf(YType.uint32, 'in-label'), ['int'])),
                                ('bfd_created', (YLeaf(YType.boolean, 'bfd-created'), ['bool'])),
                                ('bfd_up', (YLeaf(YType.boolean, 'bfd-up'), ['bool'])),
                                ('oam_created', (YLeaf(YType.boolean, 'oam-created'), ['bool'])),
                                ('bfd_next_hop', (YLeaf(YType.str, 'bfd-next-hop'), ['str'])),
                                ('bfd_tun_ifh', (YLeaf(YType.str, 'bfd-tun-ifh'), ['str'])),
                                ('bfd_out_ifh', (YLeaf(YType.str, 'bfd-out-ifh'), ['str'])),
                                ('bfd_int_label', (YLeaf(YType.uint32, 'bfd-int-label'), ['int'])),
                                ('bfd_egress_label', (YLeaf(YType.uint32, 'bfd-egress-label'), ['int'])),
                                ('fault_ldi_lockout', (YLeaf(YType.boolean, 'fault-ldi-lockout'), ['bool'])),
                                ('fault_ldi', (YLeaf(YType.boolean, 'fault-ldi'), ['bool'])),
                                ('fault_lkr', (YLeaf(YType.boolean, 'fault-lkr'), ['bool'])),
                                ('fault_ais', (YLeaf(YType.boolean, 'fault-ais'), ['bool'])),
                                ('fault_time', (YLeaf(YType.uint32, 'fault-time'), ['int'])),
                            ])
                            self.entry_exists = None
                            self.in_label = None
                            self.bfd_created = None
                            self.bfd_up = None
                            self.oam_created = None
                            self.bfd_next_hop = None
                            self.bfd_tun_ifh = None
                            self.bfd_out_ifh = None
                            self.bfd_int_label = None
                            self.bfd_egress_label = None
                            self.fault_ldi_lockout = None
                            self.fault_ldi = None
                            self.fault_lkr = None
                            self.fault_ais = None
                            self.fault_time = None

                            self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._segment_path = lambda: "flex-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, ['entry_exists', 'in_label', 'bfd_created', 'bfd_up', 'oam_created', 'bfd_next_hop', 'bfd_tun_ifh', 'bfd_out_ifh', 'bfd_int_label', 'bfd_egress_label', 'fault_ldi_lockout', 'fault_ldi', 'fault_lkr', 'fault_ais', 'fault_time'], name, value)


                        class FlexFec(_Entity_):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_fec_subgroup_id', (YLeaf(YType.uint16, 's2l-fec-subgroup-id'), ['int'])),
                                    ('s2l_fec_lsp_id', (YLeaf(YType.uint16, 's2l-fec-lsp-id'), ['int'])),
                                    ('s2l_fec_tunnel_id', (YLeaf(YType.uint16, 's2l-fec-tunnel-id'), ['int'])),
                                    ('s2l_fec_extended_tunnel_id', (YLeaf(YType.str, 's2l-fec-extended-tunnel-id'), ['str'])),
                                    ('s2l_fec_source', (YLeaf(YType.str, 's2l-fec-source'), ['str'])),
                                    ('s2l_fec_dest', (YLeaf(YType.str, 's2l-fec-dest'), ['str'])),
                                    ('s2l_fec_p2mp_id', (YLeaf(YType.uint32, 's2l-fec-p2mp-id'), ['int'])),
                                    ('s2l_fec_subgroup_originator', (YLeaf(YType.str, 's2l-fec-subgroup-originator'), ['str'])),
                                    ('s2l_fec_ctype', (YLeaf(YType.enumeration, 's2l-fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                    ('s2l_fec_vrf', (YLeaf(YType.str, 's2l-fec-vrf'), ['str'])),
                                ])
                                self.s2l_fec_subgroup_id = None
                                self.s2l_fec_lsp_id = None
                                self.s2l_fec_tunnel_id = None
                                self.s2l_fec_extended_tunnel_id = None
                                self.s2l_fec_source = None
                                self.s2l_fec_dest = None
                                self.s2l_fec_p2mp_id = None
                                self.s2l_fec_subgroup_originator = None
                                self.s2l_fec_ctype = None
                                self.s2l_fec_vrf = None
                                self._segment_path = lambda: "flex-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/flex-info/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, ['s2l_fec_subgroup_id', 's2l_fec_lsp_id', 's2l_fec_tunnel_id', 's2l_fec_extended_tunnel_id', 's2l_fec_source', 's2l_fec_dest', 's2l_fec_p2mp_id', 's2l_fec_subgroup_originator', 's2l_fec_ctype', 's2l_fec_vrf'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo']['meta_info']


                    class Association(_Entity_):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId))])
                            self._leafs = OrderedDict([
                                ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                            ])
                            self.s2l_association_type = None
                            self.s2l_association_tie_role = None
                            self.s2l_association_id = None
                            self.s2l_association_source = None
                            self.s2l_global_source = None

                            self.s2l_extended_id = YList(self)
                            self._segment_path = lambda: "association"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                        class S2lExtendedId(_Entity_):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	S2L Extended ID Array
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                ])
                                self.entry = None
                                self._segment_path = lambda: "s2l-extended-id"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/association/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId, ['entry'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2lExtendedId']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association']['meta_info']


                    class Protection(_Entity_):
                        """
                        Protection Object
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                            ])
                            self.s2l_secondary = None
                            self.s2l_protecting = None
                            self.s2l_notification = None
                            self.s2l_operational = None
                            self.enhanced = None
                            self.ded1_plus1 = None
                            self.ded1_to1 = None
                            self.shared = None
                            self.link_unprotected = None
                            self.extra_traffic = None
                            self.any = None
                            self.rerouting = None
                            self.rerouting_no_et = None
                            self.one_to_n_protection_et = None
                            self.one_plus_one_uni = None
                            self.one_plus_one_bi = None
                            self.lsp_unprotected = None
                            self._segment_path = lambda: "protection"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection']['meta_info']


                    class ReverseLsp(_Entity_):
                        """
                        Reverse LSP information
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:  :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:  :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association>`
                        
                        	**config**\: False
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:  :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection>`
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("reverse-lsp-fec", ("reverse_lsp_fec", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec)), ("association", ("association", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association)), ("protection", ("protection", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection))])
                            self._leafs = OrderedDict([
                                ('reverse_lsp_present', (YLeaf(YType.boolean, 'reverse-lsp-present'), ['bool'])),
                                ('reverse_lsp_connected', (YLeaf(YType.boolean, 'reverse-lsp-connected'), ['bool'])),
                            ])
                            self.reverse_lsp_present = None
                            self.reverse_lsp_connected = None

                            self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"

                            self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"

                            self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._segment_path = lambda: "reverse-lsp"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, ['reverse_lsp_present', 'reverse_lsp_connected'], name, value)


                        class ReverseLspFec(_Entity_):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "reverse-lsp-fec"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/reverse-lsp-fec/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec']['meta_info']


                        class Association(_Entity_):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:  :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of  		 :py:class:`S2lExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("s2l-extended-id", ("s2l_extended_id", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId))])
                                self._leafs = OrderedDict([
                                    ('s2l_association_type', (YLeaf(YType.uint16, 's2l-association-type'), ['int'])),
                                    ('s2l_association_tie_role', (YLeaf(YType.enumeration, 's2l-association-tie-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAssociationTieRole', '')])),
                                    ('s2l_association_id', (YLeaf(YType.uint16, 's2l-association-id'), ['int'])),
                                    ('s2l_association_source', (YLeaf(YType.str, 's2l-association-source'), ['str'])),
                                    ('s2l_global_source', (YLeaf(YType.uint32, 's2l-global-source'), ['int'])),
                                ])
                                self.s2l_association_type = None
                                self.s2l_association_tie_role = None
                                self.s2l_association_id = None
                                self.s2l_association_source = None
                                self.s2l_global_source = None

                                self.s2l_extended_id = YList(self)
                                self._segment_path = lambda: "association"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, ['s2l_association_type', 's2l_association_tie_role', 's2l_association_id', 's2l_association_source', 's2l_global_source'], name, value)


                            class S2lExtendedId(_Entity_):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	S2L Extended ID Array
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = False
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "s2l-extended-id"
                                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/association/%s" % self._segment_path()
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2lExtendedId']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association']['meta_info']


                        class Protection(_Entity_):
                            """
                            Protection Object
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('s2l_secondary', (YLeaf(YType.boolean, 's2l-secondary'), ['bool'])),
                                    ('s2l_protecting', (YLeaf(YType.boolean, 's2l-protecting'), ['bool'])),
                                    ('s2l_notification', (YLeaf(YType.boolean, 's2l-notification'), ['bool'])),
                                    ('s2l_operational', (YLeaf(YType.boolean, 's2l-operational'), ['bool'])),
                                    ('enhanced', (YLeaf(YType.boolean, 'enhanced'), ['bool'])),
                                    ('ded1_plus1', (YLeaf(YType.boolean, 'ded1-plus1'), ['bool'])),
                                    ('ded1_to1', (YLeaf(YType.boolean, 'ded1-to1'), ['bool'])),
                                    ('shared', (YLeaf(YType.boolean, 'shared'), ['bool'])),
                                    ('link_unprotected', (YLeaf(YType.boolean, 'link-unprotected'), ['bool'])),
                                    ('extra_traffic', (YLeaf(YType.boolean, 'extra-traffic'), ['bool'])),
                                    ('any', (YLeaf(YType.boolean, 'any'), ['bool'])),
                                    ('rerouting', (YLeaf(YType.boolean, 'rerouting'), ['bool'])),
                                    ('rerouting_no_et', (YLeaf(YType.boolean, 'rerouting-no-et'), ['bool'])),
                                    ('one_to_n_protection_et', (YLeaf(YType.boolean, 'one-to-n-protection-et'), ['bool'])),
                                    ('one_plus_one_uni', (YLeaf(YType.boolean, 'one-plus-one-uni'), ['bool'])),
                                    ('one_plus_one_bi', (YLeaf(YType.boolean, 'one-plus-one-bi'), ['bool'])),
                                    ('lsp_unprotected', (YLeaf(YType.boolean, 'lsp-unprotected'), ['bool'])),
                                ])
                                self.s2l_secondary = None
                                self.s2l_protecting = None
                                self.s2l_notification = None
                                self.s2l_operational = None
                                self.enhanced = None
                                self.ded1_plus1 = None
                                self.ded1_to1 = None
                                self.shared = None
                                self.link_unprotected = None
                                self.extra_traffic = None
                                self.any = None
                                self.rerouting = None
                                self.rerouting_no_et = None
                                self.one_to_n_protection_et = None
                                self.one_plus_one_uni = None
                                self.one_plus_one_bi = None
                                self.lsp_unprotected = None
                                self._segment_path = lambda: "protection"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, ['s2l_secondary', 's2l_protecting', 's2l_notification', 's2l_operational', 'enhanced', 'ded1_plus1', 'ded1_to1', 'shared', 'link_unprotected', 'extra_traffic', 'any', 'rerouting', 'rerouting_no_et', 'one_to_n_protection_et', 'one_plus_one_uni', 'one_plus_one_bi', 'lsp_unprotected'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "protect-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Tunnels.TunnelFlexLsps']['meta_info']


        class TunnelAutoBandwidths(_Entity_):
            """
            Auto Bandwidth Brief Table
            
            .. attribute:: tunnel_auto_bandwidth
            
            	Auto Bandwidth info bag
            	**type**\: list of  		 :py:class:`TunnelAutoBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Tunnels.TunnelAutoBandwidths, self).__init__()

                self.yang_name = "tunnel-auto-bandwidths"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-auto-bandwidth", ("tunnel_auto_bandwidth", MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth))])
                self._leafs = OrderedDict()

                self.tunnel_auto_bandwidth = YList(self)
                self._segment_path = lambda: "tunnel-auto-bandwidths"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Tunnels.TunnelAutoBandwidths, [], name, value)


            class TunnelAutoBandwidth(_Entity_):
                """
                Auto Bandwidth info bag
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: auto_bandwidth_status
                
                	Tunnels's AutoBandwidth Status information
                	**type**\:  :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Tunnel signaled name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_lsp_id
                
                	Tunnel Lsp Id
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: bandwidth_applications
                
                	Total number of bandwidth applications requested by auto\-bw
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_bandwidth_applied
                
                	Last bandwidth requested by auto\-bw for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_requested_bandwidth
                
                	Requested Bandwidth for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: signalled_bandwidth
                
                	Signalled bandwidth for the tunnel
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: highest_bandwidth
                
                	Highest bandwidth registered within current application period
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: last_sample_bandwidth
                
                	Last sample bandwidth collected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: samples_collected
                
                	Number of samples collected within current application period
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: time_left_application
                
                	Time left until next auto\-bw application algorithm is performed
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__init__()

                    self.yang_name = "tunnel-auto-bandwidth"
                    self.yang_parent_name = "tunnel-auto-bandwidths"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("auto-bandwidth-status", ("auto_bandwidth_status", MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_name_xr', (YLeaf(YType.str, 'tunnel-name-xr'), ['str'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('tunnel_lsp_id', (YLeaf(YType.uint32, 'tunnel-lsp-id'), ['int'])),
                        ('bandwidth_applications', (YLeaf(YType.uint32, 'bandwidth-applications'), ['int'])),
                        ('last_bandwidth_applied', (YLeaf(YType.uint32, 'last-bandwidth-applied'), ['int'])),
                        ('tunnel_requested_bandwidth', (YLeaf(YType.uint32, 'tunnel-requested-bandwidth'), ['int'])),
                        ('signalled_bandwidth', (YLeaf(YType.uint32, 'signalled-bandwidth'), ['int'])),
                        ('highest_bandwidth', (YLeaf(YType.uint32, 'highest-bandwidth'), ['int'])),
                        ('last_sample_bandwidth', (YLeaf(YType.uint32, 'last-sample-bandwidth'), ['int'])),
                        ('samples_collected', (YLeaf(YType.uint32, 'samples-collected'), ['int'])),
                        ('time_left_application', (YLeaf(YType.uint32, 'time-left-application'), ['int'])),
                    ])
                    self.tunnel_name = None
                    self.tunnel_name_xr = None
                    self.signaled_name = None
                    self.tunnel_lsp_id = None
                    self.bandwidth_applications = None
                    self.last_bandwidth_applied = None
                    self.tunnel_requested_bandwidth = None
                    self.signalled_bandwidth = None
                    self.highest_bandwidth = None
                    self.last_sample_bandwidth = None
                    self.samples_collected = None
                    self.time_left_application = None

                    self.auto_bandwidth_status = MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                    self.auto_bandwidth_status.parent = self
                    self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                    self._segment_path = lambda: "tunnel-auto-bandwidth" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-auto-bandwidths/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, ['tunnel_name', 'tunnel_name_xr', 'signaled_name', 'tunnel_lsp_id', 'bandwidth_applications', 'last_bandwidth_applied', 'tunnel_requested_bandwidth', 'signalled_bandwidth', 'highest_bandwidth', 'last_sample_bandwidth', 'samples_collected', 'time_left_application'], name, value)


                class AutoBandwidthStatus(_Entity_):
                    """
                    Tunnels's AutoBandwidth Status information
                    
                    .. attribute:: is_auto_bandwidth_enabled
                    
                    	TRUE if auto\-bw is enabled for the tunnel
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reactivation_time
                    
                    	Time until auto\-bw gets activated if activation has been delayed due to failover
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__init__()

                        self.yang_name = "auto-bandwidth-status"
                        self.yang_parent_name = "tunnel-auto-bandwidth"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('is_auto_bandwidth_enabled', (YLeaf(YType.boolean, 'is-auto-bandwidth-enabled'), ['bool'])),
                            ('reactivation_time', (YLeaf(YType.uint32, 'reactivation-time'), ['int'])),
                        ])
                        self.is_auto_bandwidth_enabled = None
                        self.reactivation_time = None
                        self._segment_path = lambda: "auto-bandwidth-status"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, ['is_auto_bandwidth_enabled', 'reactivation_time'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Tunnels.TunnelAutoBandwidths']['meta_info']


        class Summary(_Entity_):
            """
            Summary of tunnel info
            
            .. attribute:: autobackup_summary
            
            	Autobackup summary
            	**type**\:  :py:class:`AutobackupSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutobackupSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_mesh_summary
            
            	Automesh summary
            	**type**\:  :py:class:`AutoMeshSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoMeshSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_mesh_one_hop_summary
            
            	Automesh Onehop summary
            	**type**\:  :py:class:`AutoMeshOneHopSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary>`
            
            	**config**\: False
            
            .. attribute:: gmpls_uni_summary
            
            	GMPLS\-UNI summary
            	**type**\:  :py:class:`GmplsUniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.GmplsUniSummary>`
            
            	**config**\: False
            
            .. attribute:: gmpls_nni_summary
            
            	GMPLS\-NNI summary
            	**type**\:  :py:class:`GmplsNniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.GmplsNniSummary>`
            
            	**config**\: False
            
            .. attribute:: current_tunnel_convergence_summary
            
            	Current Tunnel convergemce summary information
            	**type**\:  :py:class:`CurrentTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary>`
            
            	**config**\: False
            
            .. attribute:: last_tunnel_convergence_summary
            
            	Last Tunnel convergemce summary information
            	**type**\:  :py:class:`LastTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary>`
            
            	**config**\: False
            
            .. attribute:: auto_tun_server_summary
            
            	Auto\-tunnel server tunnel summary
            	**type**\:  :py:class:`AutoTunServerSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary>`
            
            	**config**\: False
            
            .. attribute:: pcalc_tie_breaker_type
            
            	PCALC tiebreaker type
            	**type**\:  :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
            
            	**config**\: False
            
            .. attribute:: pcalc_tiebreaker
            
            	Deprecated \- replaced by PCALCTiebreakerType
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: tiebreaker_qualifier
            
            	Describes how the path selection tiebreaker was specified\:default, or globally set
            	**type**\:  :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
            
            	**config**\: False
            
            .. attribute:: te_process_status
            
            	Status of te\_control
            	**type**\:  :py:class:`MplsTeTunnelsProcessStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsProcessStatus>`
            
            	**config**\: False
            
            .. attribute:: is_rsvp_process_enabled
            
            	Status of rsvp
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_forwarding_enabled
            
            	TRUE if forwarding is enabled
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: activated_heads
            
            	Total tunnel heads activated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: deactivated_heads
            
            	Total tunnel heads deactivated
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: recovered_heads
            
            	Number of heads recovered
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_periodic_reoptimization_on
            
            	TRUE if periodic reoptimization is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: reoptimization_period
            
            	Reoptimization period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_reoptimization_timer
            
            	Time left till next reoptimization (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: auto_bandwidth_tunnels
            
            	Counter with number of auto\-bw enabled tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: auto_bandwidth_collection_period
            
            	Collection period in minutes
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: minute
            
            .. attribute:: is_promotion_on
            
            	TRUE if periodic frr promotion is on
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: promotion_period
            
            	FRR promotion period in seconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_promotion_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: tunnel_check_period
            
            	Tunnel head check period (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_check_time
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: tunnel_verify_period
            
            	Tunnel head verify period (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: next_verify_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: frr_head_tunnels
            
            	FRR tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_head_tunnels
            
            	FRR protected tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_head_tunnels
            
            	FRR rerouted tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_mid_point_tunnels
            
            	FRR tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_mid_point_tunnels
            
            	FRR protected tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_mid_point_tunnels
            
            	FRR rerouted tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_tunnels
            
            	FRR link protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_protected_tunnels
            
            	FRR node protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_tunnels
            
            	FRR BW protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_head_tunnels
            
            	P2P FRR tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_head_tunnels
            
            	P2P FRR protected tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_head_tunnels
            
            	P2P FRR rerouted tunnels in Up state at head end
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_mid_point_tunnels
            
            	P2P FRR tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_mid_point_tunnels
            
            	P2P FRR protected tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_mid_point_tunnels
            
            	P2P FRR rerouted tunnels at mid point
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2p_tunnels
            
            	P2P FRR link protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: node_protected_p2p_tunnels
            
            	P2P FRR node protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2p_tunnels
            
            	P2P FRR BW protected tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backup_tunnels
            
            	FRR backup tunnels in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: backups_assigned
            
            	FRR backup tunnels assigned
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_protected_interfaces
            
            	FRR Protected Interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_interfaces
            
            	FRR Rerouted Interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_tunnels
            
            	p2p Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_head_tunnels
            
            	p2p Tunnel interfaces in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: dynamic_up_p2p_head_tunnels
            
            	p2p Tunnel up via a dynamic path
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_config_p2p_head_tunnels
            
            	p2p Tunnel interfaces with FRR configuration
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_destinations
            
            	p2p Destinations at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_head_destinations_up
            
            	p2p Destinations in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2p_s2_ls
            
            	p2p S2Ls BW Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2p_s2_ls
            
            	p2p S2Ls Link Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_head_s2_ls
            
            	p2p S2Ls in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2p_head_s2_ls
            
            	p2p S2Ls in signalling\-proceeding state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: recovering_p2p_head_s2_ls
            
            	p2p S2Ls recovering at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_head_s2_ls
            
            	p2p S2Ls with FRR requested at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_head_s2_ls
            
            	p2p S2Ls FRR Protected at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_head_s2_ls
            
            	p2p S2Ls FRR Rerouted at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_mid_point_s2_ls
            
            	p2p S2Ls at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_mid_point_s2_ls
            
            	p2p S2Ls in Up state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2p_mid_point_s2_ls
            
            	p2p S2Ls in signalling=proceeding state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2p_mid_point_s2_ls
            
            	p2p S2Ls with FRR requested at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Protected at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Rerouted at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_tail_s2_ls
            
            	p2p S2Ls at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2p_tail_s2_ls
            
            	p2p S2Ls in Up state at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2p_tail_tunnels
            
            	p2p Tunnel tail interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels
            
            	Tunnels configured with Path Protect
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels_up
            
            	Path Protect configured tunnels connected/up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: path_protect_configured_tunnels_standby_up
            
            	Tunnels with standby LSP up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_diverse_paths
            
            	Link diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: node_diverse_paths
            
            	Node diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_and_node_diverse_paths
            
            	Link and Node diverse paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: user_defined_paths
            
            	User defined paths
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: p2mp_head_tunnels
            
            	P2MP Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces in Up state
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_config_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces with FRR configuration
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_head_destinations
            
            	P2MP Destinations at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_destinations
            
            	P2MP Destinations in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bw_protected_p2mp_s2_ls
            
            	P2MP S2Ls BW Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: link_protected_p2mp_s2_ls
            
            	P2MP S2Ls Link Protected
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_head_s2_ls
            
            	P2MP S2Ls in Up state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2mp_head_s2_ls
            
            	P2MP S2Ls in signalling\-proceeding state at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2mp_head_s2_ls
            
            	P2MP S2Ls with FRR requested at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Protected at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Head
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_mid_point_s2_ls
            
            	P2MP S2Ls at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in Up state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: proceeding_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in signalling=proceeding state at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: frr_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls with FRR requested at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: protected_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Protected at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: rerouted_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Mid
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: p2mp_tail_s2_ls
            
            	P2MP S2Ls at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: up_p2mp_tail_s2_ls
            
            	P2MP S2Ls in Up state at Tail
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels
            
            	Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_associated
            
            	Associated Bidirectional Head Tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_tunnels_corouted
            
            	Corouted Bidirectional Head Tunnels
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_proceeding
            
            	Proceeding Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_associated
            
            	Associated Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_head_ls_ps_standby
            
            	Standby Bidirectional Head LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_tunnels
            
            	Bidirectional Mid Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_tunnels_up
            
            	Connected Bidirectional Mid Tunnel interfaces
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_proceeding
            
            	Proceeding Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_associated
            
            	Associated Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_mid_ls_ps_standby
            
            	Standby Bidirectional Mid LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps
            
            	Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_up
            
            	Connected Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_proceeding
            
            	Proceeding Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_associated
            
            	Associated Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_standby
            
            	Standby Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: bidir_tail_ls_ps_corouted
            
            	Corouted Bidirectional Tail LSPs
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Tunnels.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("autobackup-summary", ("autobackup_summary", MplsTeStandby.Tunnels.Summary.AutobackupSummary)), ("auto-mesh-summary", ("auto_mesh_summary", MplsTeStandby.Tunnels.Summary.AutoMeshSummary)), ("auto-mesh-one-hop-summary", ("auto_mesh_one_hop_summary", MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary)), ("gmpls-uni-summary", ("gmpls_uni_summary", MplsTeStandby.Tunnels.Summary.GmplsUniSummary)), ("gmpls-nni-summary", ("gmpls_nni_summary", MplsTeStandby.Tunnels.Summary.GmplsNniSummary)), ("current-tunnel-convergence-summary", ("current_tunnel_convergence_summary", MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary)), ("last-tunnel-convergence-summary", ("last_tunnel_convergence_summary", MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary)), ("auto-tun-server-summary", ("auto_tun_server_summary", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary))])
                self._leafs = OrderedDict([
                    ('pcalc_tie_breaker_type', (YLeaf(YType.enumeration, 'pcalc-tie-breaker-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePathSelectionTiebreaker', '')])),
                    ('pcalc_tiebreaker', (YLeaf(YType.uint32, 'pcalc-tiebreaker'), ['int'])),
                    ('tiebreaker_qualifier', (YLeaf(YType.enumeration, 'tiebreaker-qualifier'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeMetricQualifier', '')])),
                    ('te_process_status', (YLeaf(YType.enumeration, 'te-process-status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelsProcessStatus', '')])),
                    ('is_rsvp_process_enabled', (YLeaf(YType.boolean, 'is-rsvp-process-enabled'), ['bool'])),
                    ('is_forwarding_enabled', (YLeaf(YType.boolean, 'is-forwarding-enabled'), ['bool'])),
                    ('activated_heads', (YLeaf(YType.uint32, 'activated-heads'), ['int'])),
                    ('deactivated_heads', (YLeaf(YType.uint32, 'deactivated-heads'), ['int'])),
                    ('recovered_heads', (YLeaf(YType.uint32, 'recovered-heads'), ['int'])),
                    ('is_periodic_reoptimization_on', (YLeaf(YType.boolean, 'is-periodic-reoptimization-on'), ['bool'])),
                    ('reoptimization_period', (YLeaf(YType.uint32, 'reoptimization-period'), ['int'])),
                    ('next_reoptimization_timer', (YLeaf(YType.uint32, 'next-reoptimization-timer'), ['int'])),
                    ('auto_bandwidth_tunnels', (YLeaf(YType.uint32, 'auto-bandwidth-tunnels'), ['int'])),
                    ('auto_bandwidth_collection_period', (YLeaf(YType.uint32, 'auto-bandwidth-collection-period'), ['int'])),
                    ('is_promotion_on', (YLeaf(YType.boolean, 'is-promotion-on'), ['bool'])),
                    ('promotion_period', (YLeaf(YType.uint32, 'promotion-period'), ['int'])),
                    ('next_promotion_timer', (YLeaf(YType.uint32, 'next-promotion-timer'), ['int'])),
                    ('tunnel_check_period', (YLeaf(YType.uint32, 'tunnel-check-period'), ['int'])),
                    ('next_check_time', (YLeaf(YType.uint32, 'next-check-time'), ['int'])),
                    ('tunnel_verify_period', (YLeaf(YType.uint32, 'tunnel-verify-period'), ['int'])),
                    ('next_verify_timer', (YLeaf(YType.uint32, 'next-verify-timer'), ['int'])),
                    ('frr_head_tunnels', (YLeaf(YType.uint32, 'frr-head-tunnels'), ['int'])),
                    ('protected_head_tunnels', (YLeaf(YType.uint32, 'protected-head-tunnels'), ['int'])),
                    ('rerouted_head_tunnels', (YLeaf(YType.uint32, 'rerouted-head-tunnels'), ['int'])),
                    ('frr_mid_point_tunnels', (YLeaf(YType.uint32, 'frr-mid-point-tunnels'), ['int'])),
                    ('protected_mid_point_tunnels', (YLeaf(YType.uint32, 'protected-mid-point-tunnels'), ['int'])),
                    ('rerouted_mid_point_tunnels', (YLeaf(YType.uint32, 'rerouted-mid-point-tunnels'), ['int'])),
                    ('link_protected_tunnels', (YLeaf(YType.uint32, 'link-protected-tunnels'), ['int'])),
                    ('node_protected_tunnels', (YLeaf(YType.uint32, 'node-protected-tunnels'), ['int'])),
                    ('bw_protected_tunnels', (YLeaf(YType.uint32, 'bw-protected-tunnels'), ['int'])),
                    ('frr_p2p_head_tunnels', (YLeaf(YType.uint32, 'frr-p2p-head-tunnels'), ['int'])),
                    ('protected_p2p_head_tunnels', (YLeaf(YType.uint32, 'protected-p2p-head-tunnels'), ['int'])),
                    ('rerouted_p2p_head_tunnels', (YLeaf(YType.uint32, 'rerouted-p2p-head-tunnels'), ['int'])),
                    ('frr_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'frr-p2p-mid-point-tunnels'), ['int'])),
                    ('protected_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'protected-p2p-mid-point-tunnels'), ['int'])),
                    ('rerouted_p2p_mid_point_tunnels', (YLeaf(YType.uint32, 'rerouted-p2p-mid-point-tunnels'), ['int'])),
                    ('link_protected_p2p_tunnels', (YLeaf(YType.uint32, 'link-protected-p2p-tunnels'), ['int'])),
                    ('node_protected_p2p_tunnels', (YLeaf(YType.uint32, 'node-protected-p2p-tunnels'), ['int'])),
                    ('bw_protected_p2p_tunnels', (YLeaf(YType.uint32, 'bw-protected-p2p-tunnels'), ['int'])),
                    ('backup_tunnels', (YLeaf(YType.uint32, 'backup-tunnels'), ['int'])),
                    ('backups_assigned', (YLeaf(YType.uint32, 'backups-assigned'), ['int'])),
                    ('frr_protected_interfaces', (YLeaf(YType.uint32, 'frr-protected-interfaces'), ['int'])),
                    ('rerouted_interfaces', (YLeaf(YType.uint32, 'rerouted-interfaces'), ['int'])),
                    ('p2p_head_tunnels', (YLeaf(YType.uint32, 'p2p-head-tunnels'), ['int'])),
                    ('up_p2p_head_tunnels', (YLeaf(YType.uint32, 'up-p2p-head-tunnels'), ['int'])),
                    ('dynamic_up_p2p_head_tunnels', (YLeaf(YType.uint32, 'dynamic-up-p2p-head-tunnels'), ['int'])),
                    ('frr_config_p2p_head_tunnels', (YLeaf(YType.uint32, 'frr-config-p2p-head-tunnels'), ['int'])),
                    ('p2p_head_destinations', (YLeaf(YType.uint32, 'p2p-head-destinations'), ['int'])),
                    ('p2p_head_destinations_up', (YLeaf(YType.uint32, 'p2p-head-destinations-up'), ['int'])),
                    ('bw_protected_p2p_s2_ls', (YLeaf(YType.uint32, 'bw-protected-p2p-s2-ls'), ['int'])),
                    ('link_protected_p2p_s2_ls', (YLeaf(YType.uint32, 'link-protected-p2p-s2-ls'), ['int'])),
                    ('up_p2p_head_s2_ls', (YLeaf(YType.uint32, 'up-p2p-head-s2-ls'), ['int'])),
                    ('proceeding_p2p_head_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2p-head-s2-ls'), ['int'])),
                    ('recovering_p2p_head_s2_ls', (YLeaf(YType.uint32, 'recovering-p2p-head-s2-ls'), ['int'])),
                    ('frr_p2p_head_s2_ls', (YLeaf(YType.uint32, 'frr-p2p-head-s2-ls'), ['int'])),
                    ('protected_p2p_head_s2_ls', (YLeaf(YType.uint32, 'protected-p2p-head-s2-ls'), ['int'])),
                    ('rerouted_p2p_head_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2p-head-s2-ls'), ['int'])),
                    ('p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'p2p-mid-point-s2-ls'), ['int'])),
                    ('up_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'up-p2p-mid-point-s2-ls'), ['int'])),
                    ('proceeding_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2p-mid-point-s2-ls'), ['int'])),
                    ('frr_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'frr-p2p-mid-point-s2-ls'), ['int'])),
                    ('protected_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'protected-p2p-mid-point-s2-ls'), ['int'])),
                    ('rerouted_p2p_mid_point_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2p-mid-point-s2-ls'), ['int'])),
                    ('p2p_tail_s2_ls', (YLeaf(YType.uint32, 'p2p-tail-s2-ls'), ['int'])),
                    ('up_p2p_tail_s2_ls', (YLeaf(YType.uint32, 'up-p2p-tail-s2-ls'), ['int'])),
                    ('p2p_tail_tunnels', (YLeaf(YType.uint32, 'p2p-tail-tunnels'), ['int'])),
                    ('path_protect_configured_tunnels', (YLeaf(YType.uint16, 'path-protect-configured-tunnels'), ['int'])),
                    ('path_protect_configured_tunnels_up', (YLeaf(YType.uint16, 'path-protect-configured-tunnels-up'), ['int'])),
                    ('path_protect_configured_tunnels_standby_up', (YLeaf(YType.uint16, 'path-protect-configured-tunnels-standby-up'), ['int'])),
                    ('link_diverse_paths', (YLeaf(YType.uint16, 'link-diverse-paths'), ['int'])),
                    ('node_diverse_paths', (YLeaf(YType.uint16, 'node-diverse-paths'), ['int'])),
                    ('link_and_node_diverse_paths', (YLeaf(YType.uint16, 'link-and-node-diverse-paths'), ['int'])),
                    ('user_defined_paths', (YLeaf(YType.uint16, 'user-defined-paths'), ['int'])),
                    ('p2mp_head_tunnels', (YLeaf(YType.uint32, 'p2mp-head-tunnels'), ['int'])),
                    ('up_p2mp_head_tunnels', (YLeaf(YType.uint32, 'up-p2mp-head-tunnels'), ['int'])),
                    ('frr_config_p2mp_head_tunnels', (YLeaf(YType.uint32, 'frr-config-p2mp-head-tunnels'), ['int'])),
                    ('p2mp_head_destinations', (YLeaf(YType.uint32, 'p2mp-head-destinations'), ['int'])),
                    ('up_p2mp_head_destinations', (YLeaf(YType.uint32, 'up-p2mp-head-destinations'), ['int'])),
                    ('bw_protected_p2mp_s2_ls', (YLeaf(YType.uint32, 'bw-protected-p2mp-s2-ls'), ['int'])),
                    ('link_protected_p2mp_s2_ls', (YLeaf(YType.uint32, 'link-protected-p2mp-s2-ls'), ['int'])),
                    ('up_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-head-s2-ls'), ['int'])),
                    ('proceeding_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2mp-head-s2-ls'), ['int'])),
                    ('frr_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'frr-p2mp-head-s2-ls'), ['int'])),
                    ('protected_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'protected-p2mp-head-s2-ls'), ['int'])),
                    ('rerouted_p2mp_head_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2mp-head-s2-ls'), ['int'])),
                    ('p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'p2mp-mid-point-s2-ls'), ['int'])),
                    ('up_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-mid-point-s2-ls'), ['int'])),
                    ('proceeding_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'proceeding-p2mp-mid-point-s2-ls'), ['int'])),
                    ('frr_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'frr-p2mp-mid-point-s2-ls'), ['int'])),
                    ('protected_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'protected-p2mp-mid-point-s2-ls'), ['int'])),
                    ('rerouted_p2mp_mid_point_s2_ls', (YLeaf(YType.uint32, 'rerouted-p2mp-mid-point-s2-ls'), ['int'])),
                    ('p2mp_tail_s2_ls', (YLeaf(YType.uint32, 'p2mp-tail-s2-ls'), ['int'])),
                    ('up_p2mp_tail_s2_ls', (YLeaf(YType.uint32, 'up-p2mp-tail-s2-ls'), ['int'])),
                    ('bidir_head_tunnels', (YLeaf(YType.uint32, 'bidir-head-tunnels'), ['int'])),
                    ('bidir_head_tunnels_up', (YLeaf(YType.uint32, 'bidir-head-tunnels-up'), ['int'])),
                    ('bidir_head_tunnels_associated', (YLeaf(YType.uint32, 'bidir-head-tunnels-associated'), ['int'])),
                    ('bidir_head_tunnels_corouted', (YLeaf(YType.uint32, 'bidir-head-tunnels-corouted'), ['int'])),
                    ('bidir_head_ls_ps_up', (YLeaf(YType.uint32, 'bidir-head-ls-ps-up'), ['int'])),
                    ('bidir_head_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-head-ls-ps-proceeding'), ['int'])),
                    ('bidir_head_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-head-ls-ps-associated'), ['int'])),
                    ('bidir_head_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-head-ls-ps-standby'), ['int'])),
                    ('bidir_mid_tunnels', (YLeaf(YType.uint32, 'bidir-mid-tunnels'), ['int'])),
                    ('bidir_mid_tunnels_up', (YLeaf(YType.uint32, 'bidir-mid-tunnels-up'), ['int'])),
                    ('bidir_mid_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-proceeding'), ['int'])),
                    ('bidir_mid_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-associated'), ['int'])),
                    ('bidir_mid_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-mid-ls-ps-standby'), ['int'])),
                    ('bidir_tail_ls_ps', (YLeaf(YType.uint32, 'bidir-tail-ls-ps'), ['int'])),
                    ('bidir_tail_ls_ps_up', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-up'), ['int'])),
                    ('bidir_tail_ls_ps_proceeding', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-proceeding'), ['int'])),
                    ('bidir_tail_ls_ps_associated', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-associated'), ['int'])),
                    ('bidir_tail_ls_ps_standby', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-standby'), ['int'])),
                    ('bidir_tail_ls_ps_corouted', (YLeaf(YType.uint32, 'bidir-tail-ls-ps-corouted'), ['int'])),
                ])
                self.pcalc_tie_breaker_type = None
                self.pcalc_tiebreaker = None
                self.tiebreaker_qualifier = None
                self.te_process_status = None
                self.is_rsvp_process_enabled = None
                self.is_forwarding_enabled = None
                self.activated_heads = None
                self.deactivated_heads = None
                self.recovered_heads = None
                self.is_periodic_reoptimization_on = None
                self.reoptimization_period = None
                self.next_reoptimization_timer = None
                self.auto_bandwidth_tunnels = None
                self.auto_bandwidth_collection_period = None
                self.is_promotion_on = None
                self.promotion_period = None
                self.next_promotion_timer = None
                self.tunnel_check_period = None
                self.next_check_time = None
                self.tunnel_verify_period = None
                self.next_verify_timer = None
                self.frr_head_tunnels = None
                self.protected_head_tunnels = None
                self.rerouted_head_tunnels = None
                self.frr_mid_point_tunnels = None
                self.protected_mid_point_tunnels = None
                self.rerouted_mid_point_tunnels = None
                self.link_protected_tunnels = None
                self.node_protected_tunnels = None
                self.bw_protected_tunnels = None
                self.frr_p2p_head_tunnels = None
                self.protected_p2p_head_tunnels = None
                self.rerouted_p2p_head_tunnels = None
                self.frr_p2p_mid_point_tunnels = None
                self.protected_p2p_mid_point_tunnels = None
                self.rerouted_p2p_mid_point_tunnels = None
                self.link_protected_p2p_tunnels = None
                self.node_protected_p2p_tunnels = None
                self.bw_protected_p2p_tunnels = None
                self.backup_tunnels = None
                self.backups_assigned = None
                self.frr_protected_interfaces = None
                self.rerouted_interfaces = None
                self.p2p_head_tunnels = None
                self.up_p2p_head_tunnels = None
                self.dynamic_up_p2p_head_tunnels = None
                self.frr_config_p2p_head_tunnels = None
                self.p2p_head_destinations = None
                self.p2p_head_destinations_up = None
                self.bw_protected_p2p_s2_ls = None
                self.link_protected_p2p_s2_ls = None
                self.up_p2p_head_s2_ls = None
                self.proceeding_p2p_head_s2_ls = None
                self.recovering_p2p_head_s2_ls = None
                self.frr_p2p_head_s2_ls = None
                self.protected_p2p_head_s2_ls = None
                self.rerouted_p2p_head_s2_ls = None
                self.p2p_mid_point_s2_ls = None
                self.up_p2p_mid_point_s2_ls = None
                self.proceeding_p2p_mid_point_s2_ls = None
                self.frr_p2p_mid_point_s2_ls = None
                self.protected_p2p_mid_point_s2_ls = None
                self.rerouted_p2p_mid_point_s2_ls = None
                self.p2p_tail_s2_ls = None
                self.up_p2p_tail_s2_ls = None
                self.p2p_tail_tunnels = None
                self.path_protect_configured_tunnels = None
                self.path_protect_configured_tunnels_up = None
                self.path_protect_configured_tunnels_standby_up = None
                self.link_diverse_paths = None
                self.node_diverse_paths = None
                self.link_and_node_diverse_paths = None
                self.user_defined_paths = None
                self.p2mp_head_tunnels = None
                self.up_p2mp_head_tunnels = None
                self.frr_config_p2mp_head_tunnels = None
                self.p2mp_head_destinations = None
                self.up_p2mp_head_destinations = None
                self.bw_protected_p2mp_s2_ls = None
                self.link_protected_p2mp_s2_ls = None
                self.up_p2mp_head_s2_ls = None
                self.proceeding_p2mp_head_s2_ls = None
                self.frr_p2mp_head_s2_ls = None
                self.protected_p2mp_head_s2_ls = None
                self.rerouted_p2mp_head_s2_ls = None
                self.p2mp_mid_point_s2_ls = None
                self.up_p2mp_mid_point_s2_ls = None
                self.proceeding_p2mp_mid_point_s2_ls = None
                self.frr_p2mp_mid_point_s2_ls = None
                self.protected_p2mp_mid_point_s2_ls = None
                self.rerouted_p2mp_mid_point_s2_ls = None
                self.p2mp_tail_s2_ls = None
                self.up_p2mp_tail_s2_ls = None
                self.bidir_head_tunnels = None
                self.bidir_head_tunnels_up = None
                self.bidir_head_tunnels_associated = None
                self.bidir_head_tunnels_corouted = None
                self.bidir_head_ls_ps_up = None
                self.bidir_head_ls_ps_proceeding = None
                self.bidir_head_ls_ps_associated = None
                self.bidir_head_ls_ps_standby = None
                self.bidir_mid_tunnels = None
                self.bidir_mid_tunnels_up = None
                self.bidir_mid_ls_ps_proceeding = None
                self.bidir_mid_ls_ps_associated = None
                self.bidir_mid_ls_ps_standby = None
                self.bidir_tail_ls_ps = None
                self.bidir_tail_ls_ps_up = None
                self.bidir_tail_ls_ps_proceeding = None
                self.bidir_tail_ls_ps_associated = None
                self.bidir_tail_ls_ps_standby = None
                self.bidir_tail_ls_ps_corouted = None

                self.autobackup_summary = MplsTeStandby.Tunnels.Summary.AutobackupSummary()
                self.autobackup_summary.parent = self
                self._children_name_map["autobackup_summary"] = "autobackup-summary"

                self.auto_mesh_summary = MplsTeStandby.Tunnels.Summary.AutoMeshSummary()
                self.auto_mesh_summary.parent = self
                self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"

                self.auto_mesh_one_hop_summary = MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary()
                self.auto_mesh_one_hop_summary.parent = self
                self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"

                self.gmpls_uni_summary = MplsTeStandby.Tunnels.Summary.GmplsUniSummary()
                self.gmpls_uni_summary.parent = self
                self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"

                self.gmpls_nni_summary = MplsTeStandby.Tunnels.Summary.GmplsNniSummary()
                self.gmpls_nni_summary.parent = self
                self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"

                self.current_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                self.current_tunnel_convergence_summary.parent = self
                self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"

                self.last_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary()
                self.last_tunnel_convergence_summary.parent = self
                self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"

                self.auto_tun_server_summary = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary()
                self.auto_tun_server_summary.parent = self
                self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Tunnels.Summary, ['pcalc_tie_breaker_type', 'pcalc_tiebreaker', 'tiebreaker_qualifier', 'te_process_status', 'is_rsvp_process_enabled', 'is_forwarding_enabled', 'activated_heads', 'deactivated_heads', 'recovered_heads', 'is_periodic_reoptimization_on', 'reoptimization_period', 'next_reoptimization_timer', 'auto_bandwidth_tunnels', 'auto_bandwidth_collection_period', 'is_promotion_on', 'promotion_period', 'next_promotion_timer', 'tunnel_check_period', 'next_check_time', 'tunnel_verify_period', 'next_verify_timer', 'frr_head_tunnels', 'protected_head_tunnels', 'rerouted_head_tunnels', 'frr_mid_point_tunnels', 'protected_mid_point_tunnels', 'rerouted_mid_point_tunnels', 'link_protected_tunnels', 'node_protected_tunnels', 'bw_protected_tunnels', 'frr_p2p_head_tunnels', 'protected_p2p_head_tunnels', 'rerouted_p2p_head_tunnels', 'frr_p2p_mid_point_tunnels', 'protected_p2p_mid_point_tunnels', 'rerouted_p2p_mid_point_tunnels', 'link_protected_p2p_tunnels', 'node_protected_p2p_tunnels', 'bw_protected_p2p_tunnels', 'backup_tunnels', 'backups_assigned', 'frr_protected_interfaces', 'rerouted_interfaces', 'p2p_head_tunnels', 'up_p2p_head_tunnels', 'dynamic_up_p2p_head_tunnels', 'frr_config_p2p_head_tunnels', 'p2p_head_destinations', 'p2p_head_destinations_up', 'bw_protected_p2p_s2_ls', 'link_protected_p2p_s2_ls', 'up_p2p_head_s2_ls', 'proceeding_p2p_head_s2_ls', 'recovering_p2p_head_s2_ls', 'frr_p2p_head_s2_ls', 'protected_p2p_head_s2_ls', 'rerouted_p2p_head_s2_ls', 'p2p_mid_point_s2_ls', 'up_p2p_mid_point_s2_ls', 'proceeding_p2p_mid_point_s2_ls', 'frr_p2p_mid_point_s2_ls', 'protected_p2p_mid_point_s2_ls', 'rerouted_p2p_mid_point_s2_ls', 'p2p_tail_s2_ls', 'up_p2p_tail_s2_ls', 'p2p_tail_tunnels', 'path_protect_configured_tunnels', 'path_protect_configured_tunnels_up', 'path_protect_configured_tunnels_standby_up', 'link_diverse_paths', 'node_diverse_paths', 'link_and_node_diverse_paths', 'user_defined_paths', 'p2mp_head_tunnels', 'up_p2mp_head_tunnels', 'frr_config_p2mp_head_tunnels', 'p2mp_head_destinations', 'up_p2mp_head_destinations', 'bw_protected_p2mp_s2_ls', 'link_protected_p2mp_s2_ls', 'up_p2mp_head_s2_ls', 'proceeding_p2mp_head_s2_ls', 'frr_p2mp_head_s2_ls', 'protected_p2mp_head_s2_ls', 'rerouted_p2mp_head_s2_ls', 'p2mp_mid_point_s2_ls', 'up_p2mp_mid_point_s2_ls', 'proceeding_p2mp_mid_point_s2_ls', 'frr_p2mp_mid_point_s2_ls', 'protected_p2mp_mid_point_s2_ls', 'rerouted_p2mp_mid_point_s2_ls', 'p2mp_tail_s2_ls', 'up_p2mp_tail_s2_ls', 'bidir_head_tunnels', 'bidir_head_tunnels_up', 'bidir_head_tunnels_associated', 'bidir_head_tunnels_corouted', 'bidir_head_ls_ps_up', 'bidir_head_ls_ps_proceeding', 'bidir_head_ls_ps_associated', 'bidir_head_ls_ps_standby', 'bidir_mid_tunnels', 'bidir_mid_tunnels_up', 'bidir_mid_ls_ps_proceeding', 'bidir_mid_ls_ps_associated', 'bidir_mid_ls_ps_standby', 'bidir_tail_ls_ps', 'bidir_tail_ls_ps_up', 'bidir_tail_ls_ps_proceeding', 'bidir_tail_ls_ps_associated', 'bidir_tail_ls_ps_standby', 'bidir_tail_ls_ps_corouted'], name, value)


            class AutobackupSummary(_Entity_):
                """
                Autobackup summary
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.AutobackupSummary, self).__init__()

                    self.yang_name = "autobackup-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('autobackups', (YLeaf(YType.uint32, 'autobackups'), ['int'])),
                        ('up_autobackups', (YLeaf(YType.uint32, 'up-autobackups'), ['int'])),
                        ('down_autobackups', (YLeaf(YType.uint32, 'down-autobackups'), ['int'])),
                        ('unused_autobackups', (YLeaf(YType.uint32, 'unused-autobackups'), ['int'])),
                        ('next_hop_autobackups', (YLeaf(YType.uint32, 'next-hop-autobackups'), ['int'])),
                        ('next_next_hop_autobackups', (YLeaf(YType.uint32, 'next-next-hop-autobackups'), ['int'])),
                        ('srlg_strict_autobackups', (YLeaf(YType.uint32, 'srlg-strict-autobackups'), ['int'])),
                        ('srlg_preferred_autobackups', (YLeaf(YType.uint32, 'srlg-preferred-autobackups'), ['int'])),
                        ('srlg_weighted_autobackups', (YLeaf(YType.uint32, 'srlg-weighted-autobackups'), ['int'])),
                        ('next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_ls_ps', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-ls-ps'), ['int'])),
                        ('next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2l_families', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2l-families'), ['int'])),
                        ('next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-autobackup-protected-s2-ls'), ['int'])),
                        ('next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                        ('next_next_hop_srlg_autobackup_protected_s2_ls', (YLeaf(YType.uint32, 'next-next-hop-srlg-autobackup-protected-s2-ls'), ['int'])),
                    ])
                    self.autobackups = None
                    self.up_autobackups = None
                    self.down_autobackups = None
                    self.unused_autobackups = None
                    self.next_hop_autobackups = None
                    self.next_next_hop_autobackups = None
                    self.srlg_strict_autobackups = None
                    self.srlg_preferred_autobackups = None
                    self.srlg_weighted_autobackups = None
                    self.next_hop_autobackup_protected_ls_ps = None
                    self.next_next_hop_autobackup_protected_ls_ps = None
                    self.next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_next_hop_srlg_autobackup_protected_ls_ps = None
                    self.next_hop_autobackup_protected_s2l_families = None
                    self.next_next_hop_autobackup_protected_s2l_families = None
                    self.next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_next_hop_srlg_autobackup_protected_s2l_families = None
                    self.next_hop_autobackup_protected_s2_ls = None
                    self.next_next_hop_autobackup_protected_s2_ls = None
                    self.next_hop_srlg_autobackup_protected_s2_ls = None
                    self.next_next_hop_srlg_autobackup_protected_s2_ls = None
                    self._segment_path = lambda: "autobackup-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutobackupSummary, ['autobackups', 'up_autobackups', 'down_autobackups', 'unused_autobackups', 'next_hop_autobackups', 'next_next_hop_autobackups', 'srlg_strict_autobackups', 'srlg_preferred_autobackups', 'srlg_weighted_autobackups', 'next_hop_autobackup_protected_ls_ps', 'next_next_hop_autobackup_protected_ls_ps', 'next_hop_srlg_autobackup_protected_ls_ps', 'next_next_hop_srlg_autobackup_protected_ls_ps', 'next_hop_autobackup_protected_s2l_families', 'next_next_hop_autobackup_protected_s2l_families', 'next_hop_srlg_autobackup_protected_s2l_families', 'next_next_hop_srlg_autobackup_protected_s2l_families', 'next_hop_autobackup_protected_s2_ls', 'next_next_hop_autobackup_protected_s2_ls', 'next_hop_srlg_autobackup_protected_s2_ls', 'next_next_hop_srlg_autobackup_protected_s2_ls'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutobackupSummary']['meta_info']


            class AutoMeshSummary(_Entity_):
                """
                Automesh summary
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.AutoMeshSummary, self).__init__()

                    self.yang_name = "auto-mesh-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_tunnels', (YLeaf(YType.uint32, 'auto-mesh-tunnels'), ['int'])),
                        ('up_auto_mesh_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-tunnels'), ['int'])),
                        ('down_auto_mesh_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_groups', (YLeaf(YType.uint32, 'auto-mesh-groups'), ['int'])),
                        ('auto_mesh_destinations', (YLeaf(YType.uint32, 'auto-mesh-destinations'), ['int'])),
                    ])
                    self.auto_mesh_tunnels = None
                    self.up_auto_mesh_tunnels = None
                    self.down_auto_mesh_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_groups = None
                    self.auto_mesh_destinations = None
                    self._segment_path = lambda: "auto-mesh-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoMeshSummary, ['auto_mesh_tunnels', 'up_auto_mesh_tunnels', 'down_auto_mesh_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_groups', 'auto_mesh_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoMeshSummary']['meta_info']


            class AutoMeshOneHopSummary(_Entity_):
                """
                Automesh Onehop summary
                
                .. attribute:: auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: up_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are up
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: down_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are down
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh onehop tunnels that are FRR enabled
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_one_hop_groups
                
                	Total number of automesh onehop mesh\-groups
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: auto_mesh_one_hop_destinations
                
                	Total number of automesh onehop destinations
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary, self).__init__()

                    self.yang_name = "auto-mesh-one-hop-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'auto-mesh-one-hop-tunnels'), ['int'])),
                        ('up_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'up-auto-mesh-one-hop-tunnels'), ['int'])),
                        ('down_auto_mesh_one_hop_tunnels', (YLeaf(YType.uint32, 'down-auto-mesh-one-hop-tunnels'), ['int'])),
                        ('frr_auto_mesh_tunnels', (YLeaf(YType.uint32, 'frr-auto-mesh-tunnels'), ['int'])),
                        ('auto_mesh_one_hop_groups', (YLeaf(YType.uint32, 'auto-mesh-one-hop-groups'), ['int'])),
                        ('auto_mesh_one_hop_destinations', (YLeaf(YType.uint32, 'auto-mesh-one-hop-destinations'), ['int'])),
                    ])
                    self.auto_mesh_one_hop_tunnels = None
                    self.up_auto_mesh_one_hop_tunnels = None
                    self.down_auto_mesh_one_hop_tunnels = None
                    self.frr_auto_mesh_tunnels = None
                    self.auto_mesh_one_hop_groups = None
                    self.auto_mesh_one_hop_destinations = None
                    self._segment_path = lambda: "auto-mesh-one-hop-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary, ['auto_mesh_one_hop_tunnels', 'up_auto_mesh_one_hop_tunnels', 'down_auto_mesh_one_hop_tunnels', 'frr_auto_mesh_tunnels', 'auto_mesh_one_hop_groups', 'auto_mesh_one_hop_destinations'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary']['meta_info']


            class GmplsUniSummary(_Entity_):
                """
                GMPLS\-UNI summary
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.GmplsUniSummary, self).__init__()

                    self.yang_name = "gmpls-uni-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('heads_up', (YLeaf(YType.uint32, 'heads-up'), ['int'])),
                        ('heads_down', (YLeaf(YType.uint32, 'heads-down'), ['int'])),
                        ('tails_up', (YLeaf(YType.uint32, 'tails-up'), ['int'])),
                        ('tails_down', (YLeaf(YType.uint32, 'tails-down'), ['int'])),
                    ])
                    self.heads_up = None
                    self.heads_down = None
                    self.tails_up = None
                    self.tails_down = None
                    self._segment_path = lambda: "gmpls-uni-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.GmplsUniSummary, ['heads_up', 'heads_down', 'tails_up', 'tails_down'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.GmplsUniSummary']['meta_info']


            class GmplsNniSummary(_Entity_):
                """
                GMPLS\-NNI summary
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: mids_up
                
                	Tunnel mids in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: mids_down
                
                	Tunnel mids in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.GmplsNniSummary, self).__init__()

                    self.yang_name = "gmpls-nni-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('heads_up', (YLeaf(YType.uint32, 'heads-up'), ['int'])),
                        ('heads_down', (YLeaf(YType.uint32, 'heads-down'), ['int'])),
                        ('mids_up', (YLeaf(YType.uint32, 'mids-up'), ['int'])),
                        ('mids_down', (YLeaf(YType.uint32, 'mids-down'), ['int'])),
                        ('tails_up', (YLeaf(YType.uint32, 'tails-up'), ['int'])),
                        ('tails_down', (YLeaf(YType.uint32, 'tails-down'), ['int'])),
                    ])
                    self.heads_up = None
                    self.heads_down = None
                    self.mids_up = None
                    self.mids_down = None
                    self.tails_up = None
                    self.tails_down = None
                    self._segment_path = lambda: "gmpls-nni-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.GmplsNniSummary, ['heads_up', 'heads_down', 'mids_up', 'mids_down', 'tails_up', 'tails_down'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.GmplsNniSummary']['meta_info']


            class CurrentTunnelConvergenceSummary(_Entity_):
                """
                Current Tunnel convergemce summary information
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "current-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_frr_active_count', (YLeaf(YType.uint32, 'tunnel-frr-active-count'), ['int'])),
                        ('tunnel_frr_total_count', (YLeaf(YType.uint32, 'tunnel-frr-total-count'), ['int'])),
                        ('tunnel_converged_count', (YLeaf(YType.uint32, 'tunnel-converged-count'), ['int'])),
                        ('tunnel_total_convergence_complete_time', (YLeaf(YType.uint64, 'tunnel-total-convergence-complete-time'), ['int'])),
                    ])
                    self.tunnel_frr_active_count = None
                    self.tunnel_frr_total_count = None
                    self.tunnel_converged_count = None
                    self.tunnel_total_convergence_complete_time = None
                    self._segment_path = lambda: "current-tunnel-convergence-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary, ['tunnel_frr_active_count', 'tunnel_frr_total_count', 'tunnel_converged_count', 'tunnel_total_convergence_complete_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary']['meta_info']


            class LastTunnelConvergenceSummary(_Entity_):
                """
                Last Tunnel convergemce summary information
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "last-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('tunnel_frr_active_count', (YLeaf(YType.uint32, 'tunnel-frr-active-count'), ['int'])),
                        ('tunnel_frr_total_count', (YLeaf(YType.uint32, 'tunnel-frr-total-count'), ['int'])),
                        ('tunnel_converged_count', (YLeaf(YType.uint32, 'tunnel-converged-count'), ['int'])),
                        ('tunnel_total_convergence_complete_time', (YLeaf(YType.uint64, 'tunnel-total-convergence-complete-time'), ['int'])),
                    ])
                    self.tunnel_frr_active_count = None
                    self.tunnel_frr_total_count = None
                    self.tunnel_converged_count = None
                    self.tunnel_total_convergence_complete_time = None
                    self._segment_path = lambda: "last-tunnel-convergence-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary, ['tunnel_frr_active_count', 'tunnel_frr_total_count', 'tunnel_converged_count', 'tunnel_total_convergence_complete_time'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary']['meta_info']


            class AutoTunServerSummary(_Entity_):
                """
                Auto\-tunnel server tunnel summary
                
                .. attribute:: total_auto_p2mp_tunnels
                
                	Total number of P2MP auto\-tunnels
                	**type**\:  :py:class:`TotalAutoP2mpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels>`
                
                	**config**\: False
                
                .. attribute:: total_auto_p2p_tunnels
                
                	Total number of P2P auto\-tunnels
                	**type**\:  :py:class:`TotalAutoP2pTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels>`
                
                	**config**\: False
                
                .. attribute:: clients_summary
                
                	List of auto\-tunnel server clients
                	**type**\: list of  		 :py:class:`ClientsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary, self).__init__()

                    self.yang_name = "auto-tun-server-summary"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("total-auto-p2mp-tunnels", ("total_auto_p2mp_tunnels", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels)), ("total-auto-p2p-tunnels", ("total_auto_p2p_tunnels", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels)), ("clients-summary", ("clients_summary", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary))])
                    self._leafs = OrderedDict()

                    self.total_auto_p2mp_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels()
                    self.total_auto_p2mp_tunnels.parent = self
                    self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"

                    self.total_auto_p2p_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels()
                    self.total_auto_p2p_tunnels.parent = self
                    self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"

                    self.clients_summary = YList(self)
                    self._segment_path = lambda: "auto-tun-server-summary"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary, [], name, value)


                class TotalAutoP2mpTunnels(_Entity_):
                    """
                    Total number of P2MP auto\-tunnels
                    
                    .. attribute:: auto_p2mp_tunnel
                    
                    	Total number of client P2MP auto\-tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: frr_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are FRR enabled
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels, self).__init__()

                        self.yang_name = "total-auto-p2mp-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_p2mp_tunnel', (YLeaf(YType.uint32, 'auto-p2mp-tunnel'), ['int'])),
                            ('auto_p2mp_destinations', (YLeaf(YType.uint32, 'auto-p2mp-destinations'), ['int'])),
                            ('up_auto_p2mp_destinations', (YLeaf(YType.uint32, 'up-auto-p2mp-destinations'), ['int'])),
                            ('down_auto_p2mp_destinations', (YLeaf(YType.uint32, 'down-auto-p2mp-destinations'), ['int'])),
                            ('up_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'up-auto-p2mp-tunnels'), ['int'])),
                            ('down_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'down-auto-p2mp-tunnels'), ['int'])),
                            ('frr_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'frr-auto-p2mp-tunnels'), ['int'])),
                        ])
                        self.auto_p2mp_tunnel = None
                        self.auto_p2mp_destinations = None
                        self.up_auto_p2mp_destinations = None
                        self.down_auto_p2mp_destinations = None
                        self.up_auto_p2mp_tunnels = None
                        self.down_auto_p2mp_tunnels = None
                        self.frr_auto_p2mp_tunnels = None
                        self._segment_path = lambda: "total-auto-p2mp-tunnels"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels, ['auto_p2mp_tunnel', 'auto_p2mp_destinations', 'up_auto_p2mp_destinations', 'down_auto_p2mp_destinations', 'up_auto_p2mp_tunnels', 'down_auto_p2mp_tunnels', 'frr_auto_p2mp_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2mpTunnels']['meta_info']


                class TotalAutoP2pTunnels(_Entity_):
                    """
                    Total number of P2P auto\-tunnels
                    
                    .. attribute:: auto_p2p_tunnel
                    
                    	Total number of client P2P auto\-tunnels
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: up_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are up
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: down_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are down
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels, self).__init__()

                        self.yang_name = "total-auto-p2p-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('auto_p2p_tunnel', (YLeaf(YType.uint32, 'auto-p2p-tunnel'), ['int'])),
                            ('up_auto_p2p_tunnels', (YLeaf(YType.uint32, 'up-auto-p2p-tunnels'), ['int'])),
                            ('down_auto_p2p_tunnels', (YLeaf(YType.uint32, 'down-auto-p2p-tunnels'), ['int'])),
                        ])
                        self.auto_p2p_tunnel = None
                        self.up_auto_p2p_tunnels = None
                        self.down_auto_p2p_tunnels = None
                        self._segment_path = lambda: "total-auto-p2p-tunnels"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels, ['auto_p2p_tunnel', 'up_auto_p2p_tunnels', 'down_auto_p2p_tunnels'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2pTunnels']['meta_info']


                class ClientsSummary(_Entity_):
                    """
                    List of auto\-tunnel server clients
                    
                    .. attribute:: p2mp_info
                    
                    	P2MP info for a client
                    	**type**\:  :py:class:`P2mpInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: p2p_info
                    
                    	P2P info for a client
                    	**type**\:  :py:class:`P2pInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: protocol_type
                    
                    	Client's protocol type
                    	**type**\:  :py:class:`TeServTunClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeServTunClient>`
                    
                    	**config**\: False
                    
                    .. attribute:: client_instance_name
                    
                    	Client Instance name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: client_id
                    
                    	Client ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__init__()

                        self.yang_name = "clients-summary"
                        self.yang_parent_name = "auto-tun-server-summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("p2mp-info", ("p2mp_info", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo)), ("p2p-info", ("p2p_info", MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo))])
                        self._leafs = OrderedDict([
                            ('protocol_type', (YLeaf(YType.enumeration, 'protocol-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeServTunClient', '')])),
                            ('client_instance_name', (YLeaf(YType.str, 'client-instance-name'), ['str'])),
                            ('client_id', (YLeaf(YType.uint32, 'client-id'), ['int'])),
                        ])
                        self.protocol_type = None
                        self.client_instance_name = None
                        self.client_id = None

                        self.p2mp_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo()
                        self.p2mp_info.parent = self
                        self._children_name_map["p2mp_info"] = "p2mp-info"

                        self.p2p_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo()
                        self.p2p_info.parent = self
                        self._children_name_map["p2p_info"] = "p2p-info"
                        self._segment_path = lambda: "clients-summary"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, ['protocol_type', 'client_instance_name', 'client_id'], name, value)


                    class P2mpInfo(_Entity_):
                        """
                        P2MP info for a client
                        
                        .. attribute:: auto_p2mp_tunnel
                        
                        	Total number of client P2MP auto\-tunnels
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: frr_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are FRR enabled
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo, self).__init__()

                            self.yang_name = "p2mp-info"
                            self.yang_parent_name = "clients-summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('auto_p2mp_tunnel', (YLeaf(YType.uint32, 'auto-p2mp-tunnel'), ['int'])),
                                ('auto_p2mp_destinations', (YLeaf(YType.uint32, 'auto-p2mp-destinations'), ['int'])),
                                ('up_auto_p2mp_destinations', (YLeaf(YType.uint32, 'up-auto-p2mp-destinations'), ['int'])),
                                ('down_auto_p2mp_destinations', (YLeaf(YType.uint32, 'down-auto-p2mp-destinations'), ['int'])),
                                ('up_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'up-auto-p2mp-tunnels'), ['int'])),
                                ('down_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'down-auto-p2mp-tunnels'), ['int'])),
                                ('frr_auto_p2mp_tunnels', (YLeaf(YType.uint32, 'frr-auto-p2mp-tunnels'), ['int'])),
                            ])
                            self.auto_p2mp_tunnel = None
                            self.auto_p2mp_destinations = None
                            self.up_auto_p2mp_destinations = None
                            self.down_auto_p2mp_destinations = None
                            self.up_auto_p2mp_tunnels = None
                            self.down_auto_p2mp_tunnels = None
                            self.frr_auto_p2mp_tunnels = None
                            self._segment_path = lambda: "p2mp-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo, ['auto_p2mp_tunnel', 'auto_p2mp_destinations', 'up_auto_p2mp_destinations', 'down_auto_p2mp_destinations', 'up_auto_p2mp_tunnels', 'down_auto_p2mp_tunnels', 'frr_auto_p2mp_tunnels'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2mpInfo']['meta_info']


                    class P2pInfo(_Entity_):
                        """
                        P2P info for a client
                        
                        .. attribute:: auto_p2p_tunnel
                        
                        	Total number of client P2P auto\-tunnels
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: up_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are up
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: down_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are down
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo, self).__init__()

                            self.yang_name = "p2p-info"
                            self.yang_parent_name = "clients-summary"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('auto_p2p_tunnel', (YLeaf(YType.uint32, 'auto-p2p-tunnel'), ['int'])),
                                ('up_auto_p2p_tunnels', (YLeaf(YType.uint32, 'up-auto-p2p-tunnels'), ['int'])),
                                ('down_auto_p2p_tunnels', (YLeaf(YType.uint32, 'down-auto-p2p-tunnels'), ['int'])),
                            ])
                            self.auto_p2p_tunnel = None
                            self.up_auto_p2p_tunnels = None
                            self.down_auto_p2p_tunnels = None
                            self._segment_path = lambda: "p2p-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo, ['auto_p2p_tunnel', 'up_auto_p2p_tunnels', 'down_auto_p2p_tunnels'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2pInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.Summary.AutoTunServerSummary']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Tunnels.Summary']['meta_info']


        class TunnelPathProtections(_Entity_):
            """
            Path protection
            
            .. attribute:: tunnel_path_protection
            
            	Path Protection
            	**type**\: list of  		 :py:class:`TunnelPathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Tunnels.TunnelPathProtections, self).__init__()

                self.yang_name = "tunnel-path-protections"
                self.yang_parent_name = "tunnels"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-path-protection", ("tunnel_path_protection", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection))])
                self._leafs = OrderedDict()

                self.tunnel_path_protection = YList(self)
                self._segment_path = lambda: "tunnel-path-protections"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections, [], name, value)


            class TunnelPathProtection(_Entity_):
                """
                Path Protection
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:  :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection>`
                
                	**config**\: False
                
                .. attribute:: current_lsp
                
                	 Current LSP info
                	**type**\:  :py:class:`CurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp>`
                
                	**config**\: False
                
                .. attribute:: standby_lsp
                
                	 Standby LSP info
                	**type**\:  :py:class:`StandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp>`
                
                	**config**\: False
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: source_address
                
                	Source
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__init__()

                    self.yang_name = "tunnel-path-protection"
                    self.yang_parent_name = "tunnel-path-protections"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("path-protection", ("path_protection", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection)), ("current-lsp", ("current_lsp", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp)), ("standby-lsp", ("standby_lsp", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp))])
                    self._leafs = OrderedDict([
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('is_tunnel_up', (YLeaf(YType.boolean, 'is-tunnel-up'), ['bool'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                    ])
                    self.ctype = None
                    self.tunnel_id = None
                    self.tunnel_name = None
                    self.is_tunnel_up = None
                    self.source_address = None
                    self.destination_address = None
                    self.extended_tunnel_id = None

                    self.path_protection = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"

                    self.current_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                    self.current_lsp.parent = self
                    self._children_name_map["current_lsp"] = "current-lsp"

                    self.standby_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                    self.standby_lsp.parent = self
                    self._children_name_map["standby_lsp"] = "standby-lsp"
                    self._segment_path = lambda: "tunnel-path-protection"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection, ['ctype', 'tunnel_id', 'tunnel_name', 'is_tunnel_up', 'source_address', 'destination_address', 'extended_tunnel_id'], name, value)


                class PathProtection(_Entity_):
                    """
                    Path Protect Info
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:  :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover>`
                    
                    	**config**\: False
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:  :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("switchover", ("switchover", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover))])
                        self._leafs = OrderedDict([
                            ('time_of_switchover_sec', (YLeaf(YType.uint32, 'time-of-switchover-sec'), ['int'])),
                            ('switchover_total', (YLeaf(YType.uint16, 'switchover-total'), ['int'])),
                            ('switchover_ready', (YLeaf(YType.uint16, 'switchover-ready'), ['int'])),
                            ('standby_reoptimized_number', (YLeaf(YType.uint16, 'standby-reoptimized-number'), ['int'])),
                            ('switchover_reason', (YLeaf(YType.uint16, 'switchover-reason'), ['int'])),
                            ('diversity_type', (YLeaf(YType.enumeration, 'diversity-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TePpDiversity', '')])),
                            ('is_path_protect_configured', (YLeaf(YType.boolean, 'is-path-protect-configured'), ['bool'])),
                            ('path_protection_protected_by_id', (YLeaf(YType.uint32, 'path-protection-protected-by-id'), ['int'])),
                            ('valid_path_protection_path_option_exists', (YLeaf(YType.boolean, 'valid-path-protection-path-option-exists'), ['bool'])),
                            ('is_path_protect_switch_over_underway', (YLeaf(YType.boolean, 'is-path-protect-switch-over-underway'), ['bool'])),
                            ('reoptimization_time_remaining', (YLeaf(YType.uint32, 'reoptimization-time-remaining'), ['int'])),
                        ])
                        self.time_of_switchover_sec = None
                        self.switchover_total = None
                        self.switchover_ready = None
                        self.standby_reoptimized_number = None
                        self.switchover_reason = None
                        self.diversity_type = None
                        self.is_path_protect_configured = None
                        self.path_protection_protected_by_id = None
                        self.valid_path_protection_path_option_exists = None
                        self.is_path_protect_switch_over_underway = None
                        self.reoptimization_time_remaining = None

                        self.switchover = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._segment_path = lambda: "path-protection"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, ['time_of_switchover_sec', 'switchover_total', 'switchover_ready', 'standby_reoptimized_number', 'switchover_reason', 'diversity_type', 'is_path_protect_configured', 'path_protection_protected_by_id', 'valid_path_protection_path_option_exists', 'is_path_protect_switch_over_underway', 'reoptimization_time_remaining'], name, value)


                    class Switchover(_Entity_):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: millisecond
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                                ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                                ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                                ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                                ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                                ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                                ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                                ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                            ])
                            self.path_protection_switchover_event_index = None
                            self.path_protection_tunnel_id = None
                            self.from_lsp_id = None
                            self.to_lsp_id = None
                            self.date_of_error_detection = None
                            self.date_of_error_detection_millisec = None
                            self.switchover_duration_millisec = None
                            self.path_protection_switchover_reason = None
                            self._segment_path = lambda: "switchover"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/path-protection/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection']['meta_info']


                class CurrentLsp(_Entity_):
                    """
                     Current LSP info
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of  		 :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__init__()

                        self.yang_name = "current-lsp"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlsp-outgoing-info", ("srlsp_outgoing_info", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo)), ("lsp-hop", ("lsp_hop", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.srlsp_outgoing_info = YList(self)
                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "current-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, ['lsp_uptime', 'path_protection_lsp_id', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class SrlspOutgoingInfo(_Entity_):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                                ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ])
                            self.lsp_output_interface = None
                            self.lsp_output_label = None
                            self._segment_path = lambda: "srlsp-outgoing-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, ['lsp_output_interface', 'lsp_output_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "current-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp']['meta_info']


                class StandbyLsp(_Entity_):
                    """
                     Standby LSP info
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:  :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    	**config**\: False
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of  		 :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of  		 :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__init__()

                        self.yang_name = "standby-lsp"
                        self.yang_parent_name = "tunnel-path-protection"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("srlsp-outgoing-info", ("srlsp_outgoing_info", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo)), ("lsp-hop", ("lsp_hop", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop))])
                        self._leafs = OrderedDict([
                            ('lsp_uptime', (YLeaf(YType.uint32, 'lsp-uptime'), ['int'])),
                            ('path_protection_lsp_id', (YLeaf(YType.uint32, 'path-protection-lsp-id'), ['int'])),
                            ('lsp_local_label', (YLeaf(YType.uint32, 'lsp-local-label'), ['int'])),
                            ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                            ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ('lsp_state', (YLeaf(YType.enumeration, 'lsp-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelState', '')])),
                        ])
                        self.lsp_uptime = None
                        self.path_protection_lsp_id = None
                        self.lsp_local_label = None
                        self.lsp_output_interface = None
                        self.lsp_output_label = None
                        self.lsp_state = None

                        self.srlsp_outgoing_info = YList(self)
                        self.lsp_hop = YList(self)
                        self._segment_path = lambda: "standby-lsp"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, ['lsp_uptime', 'path_protection_lsp_id', 'lsp_local_label', 'lsp_output_interface', 'lsp_output_label', 'lsp_state'], name, value)


                    class SrlspOutgoingInfo(_Entity_):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('lsp_output_interface', (YLeaf(YType.str, 'lsp-output-interface'), ['str'])),
                                ('lsp_output_label', (YLeaf(YType.uint32, 'lsp-output-label'), ['int'])),
                            ])
                            self.lsp_output_interface = None
                            self.lsp_output_label = None
                            self._segment_path = lambda: "srlsp-outgoing-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, ['lsp_output_interface', 'lsp_output_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo']['meta_info']


                    class LspHop(_Entity_):
                        """
                        Path used by LSP
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:  :py:class:`Ipv4eroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:  :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject>`
                        
                        	**config**\: False
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:  :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "standby-lsp"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("ipv4ero-sub-object", ("ipv4ero_sub_object", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject)), ("unnumbered-ero-sub-object", ("unnumbered_ero_sub_object", MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject))])
                            self._leafs = OrderedDict([
                                ('ero_type', (YLeaf(YType.enumeration, 'ero-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobj', '')])),
                            ])
                            self.ero_type = None

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._segment_path = lambda: "lsp-hop"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, ['ero_type'], name, value)


                        class Ipv4eroSubObject(_Entity_):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\: int
                            
                            	**range:** 0..255
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_address', (YLeaf(YType.str, 'ero-address'), ['str'])),
                                    ('prefix_length', (YLeaf(YType.uint8, 'prefix-length'), ['int'])),
                                ])
                                self.is_strict_route = None
                                self.ero_address = None
                                self.prefix_length = None
                                self._segment_path = lambda: "ipv4ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject, ['is_strict_route', 'ero_address', 'prefix_length'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4eroSubObject']['meta_info']


                        class UnnumberedEroSubObject(_Entity_):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:  :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_strict_route', (YLeaf(YType.boolean, 'is-strict-route'), ['bool'])),
                                    ('ero_interface_id', (YLeaf(YType.uint32, 'ero-interface-id'), ['int'])),
                                    ('ero_router_id', (YLeaf(YType.str, 'ero-router-id'), ['str'])),
                                    ('status', (YLeaf(YType.enumeration, 'status'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RsvpMgmtEroSubobjStatus', '')])),
                                ])
                                self.is_strict_route = None
                                self.ero_interface_id = None
                                self.ero_router_id = None
                                self.status = None
                                self._segment_path = lambda: "unnumbered-ero-sub-object"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, ['is_strict_route', 'ero_interface_id', 'ero_router_id', 'status'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Tunnels.TunnelPathProtections']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.Tunnels']['meta_info']


    class MaximumTunnels(_Entity_):
        """
        MPLS Traffic Engineering Tunnels
        
        .. attribute:: current_maximum_tunnels
        
        	Current Maximum Tunnels
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_destinations
        
        	Current Maximum Destinations
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_p2mp_tunnels
        
        	Current Maximum P2MP Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_p2mp_destnation_per_tunnel
        
        	Current Maximum P2MP Destinations Per Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: absolute_maximum
        
        	Absolute Maximum
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_autobackups
        
        	Current Maximum Autotunnel Backups Allowed
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_auto_mesh
        
        	Current Maximum Autotunnel Mesh Allowed
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_tunnel_count
        
        	Current tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_destination_count
        
        	Current Destination Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_p2mp_tunnel_count
        
        	Current P2MP tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_p2mp_destnation_per_tunnel_count
        
        	Current P2MP Destination per tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: is_autobackup_range_configured
        
        	TRUE if the autobackup range is configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: current_autobackups
        
        	Current Autotunnel Backup count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: is_auto_mesh_range_configured
        
        	TRUE if the automesh range is configured
        	**type**\: bool
        
        	**config**\: False
        
        .. attribute:: current_auto_mesh
        
        	Current Autotunnel Mesh count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_maximum_gmpls_unitunnels
        
        	Current Maximum GMPLS\-UNI Tunnel Count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        .. attribute:: current_gmpls_uni
        
        	Current GMPLS\-UNI tunnel count
        	**type**\: int
        
        	**range:** 0..4294967295
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.MaximumTunnels, self).__init__()

            self.yang_name = "maximum-tunnels"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([])
            self._leafs = OrderedDict([
                ('current_maximum_tunnels', (YLeaf(YType.uint32, 'current-maximum-tunnels'), ['int'])),
                ('current_maximum_destinations', (YLeaf(YType.uint32, 'current-maximum-destinations'), ['int'])),
                ('current_maximum_p2mp_tunnels', (YLeaf(YType.uint32, 'current-maximum-p2mp-tunnels'), ['int'])),
                ('current_maximum_p2mp_destnation_per_tunnel', (YLeaf(YType.uint32, 'current-maximum-p2mp-destnation-per-tunnel'), ['int'])),
                ('absolute_maximum', (YLeaf(YType.uint32, 'absolute-maximum'), ['int'])),
                ('current_maximum_autobackups', (YLeaf(YType.uint32, 'current-maximum-autobackups'), ['int'])),
                ('current_maximum_auto_mesh', (YLeaf(YType.uint32, 'current-maximum-auto-mesh'), ['int'])),
                ('current_tunnel_count', (YLeaf(YType.uint32, 'current-tunnel-count'), ['int'])),
                ('current_destination_count', (YLeaf(YType.uint32, 'current-destination-count'), ['int'])),
                ('current_p2mp_tunnel_count', (YLeaf(YType.uint32, 'current-p2mp-tunnel-count'), ['int'])),
                ('current_p2mp_destnation_per_tunnel_count', (YLeaf(YType.uint32, 'current-p2mp-destnation-per-tunnel-count'), ['int'])),
                ('is_autobackup_range_configured', (YLeaf(YType.boolean, 'is-autobackup-range-configured'), ['bool'])),
                ('current_autobackups', (YLeaf(YType.uint32, 'current-autobackups'), ['int'])),
                ('is_auto_mesh_range_configured', (YLeaf(YType.boolean, 'is-auto-mesh-range-configured'), ['bool'])),
                ('current_auto_mesh', (YLeaf(YType.uint32, 'current-auto-mesh'), ['int'])),
                ('current_maximum_gmpls_unitunnels', (YLeaf(YType.uint32, 'current-maximum-gmpls-unitunnels'), ['int'])),
                ('current_gmpls_uni', (YLeaf(YType.uint32, 'current-gmpls-uni'), ['int'])),
            ])
            self.current_maximum_tunnels = None
            self.current_maximum_destinations = None
            self.current_maximum_p2mp_tunnels = None
            self.current_maximum_p2mp_destnation_per_tunnel = None
            self.absolute_maximum = None
            self.current_maximum_autobackups = None
            self.current_maximum_auto_mesh = None
            self.current_tunnel_count = None
            self.current_destination_count = None
            self.current_p2mp_tunnel_count = None
            self.current_p2mp_destnation_per_tunnel_count = None
            self.is_autobackup_range_configured = None
            self.current_autobackups = None
            self.is_auto_mesh_range_configured = None
            self.current_auto_mesh = None
            self.current_maximum_gmpls_unitunnels = None
            self.current_gmpls_uni = None
            self._segment_path = lambda: "maximum-tunnels"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.MaximumTunnels, ['current_maximum_tunnels', 'current_maximum_destinations', 'current_maximum_p2mp_tunnels', 'current_maximum_p2mp_destnation_per_tunnel', 'absolute_maximum', 'current_maximum_autobackups', 'current_maximum_auto_mesh', 'current_tunnel_count', 'current_destination_count', 'current_p2mp_tunnel_count', 'current_p2mp_destnation_per_tunnel_count', 'is_autobackup_range_configured', 'current_autobackups', 'is_auto_mesh_range_configured', 'current_auto_mesh', 'current_maximum_gmpls_unitunnels', 'current_gmpls_uni'], name, value)

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.MaximumTunnels']['meta_info']


    class PathProtection(_Entity_):
        """
        MPLS TE path protection info
        
        .. attribute:: switchover_log
        
        	MPLS TE path protection info
        	**type**\:  :py:class:`SwitchoverLog <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection.SwitchoverLog>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.PathProtection, self).__init__()

            self.yang_name = "path-protection"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("switchover-log", ("switchover_log", MplsTeStandby.PathProtection.SwitchoverLog))])
            self._leafs = OrderedDict()

            self.switchover_log = MplsTeStandby.PathProtection.SwitchoverLog()
            self.switchover_log.parent = self
            self._children_name_map["switchover_log"] = "switchover-log"
            self._segment_path = lambda: "path-protection"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.PathProtection, [], name, value)


        class SwitchoverLog(_Entity_):
            """
            MPLS TE path protection info
            
            .. attribute:: path_protection_switchovers
            
            	Total number of path protection switchover events. This could be more than the entries in the array
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: maximum_switchover_millisec
            
            	The maximum delay for a switchover in milliseconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: millisecond
            
            .. attribute:: average_switchover_millisec
            
            	The average delay for a switchover in milliseconds
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: millisecond
            
            .. attribute:: path_protection_switchover_entry
            
            	The array of path protection switchover entries
            	**type**\: list of  		 :py:class:`PathProtectionSwitchoverEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.PathProtection.SwitchoverLog, self).__init__()

                self.yang_name = "switchover-log"
                self.yang_parent_name = "path-protection"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("path-protection-switchover-entry", ("path_protection_switchover_entry", MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry))])
                self._leafs = OrderedDict([
                    ('path_protection_switchovers', (YLeaf(YType.uint32, 'path-protection-switchovers'), ['int'])),
                    ('maximum_switchover_millisec', (YLeaf(YType.uint32, 'maximum-switchover-millisec'), ['int'])),
                    ('average_switchover_millisec', (YLeaf(YType.uint32, 'average-switchover-millisec'), ['int'])),
                ])
                self.path_protection_switchovers = None
                self.maximum_switchover_millisec = None
                self.average_switchover_millisec = None

                self.path_protection_switchover_entry = YList(self)
                self._segment_path = lambda: "switchover-log"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/path-protection/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.PathProtection.SwitchoverLog, ['path_protection_switchovers', 'maximum_switchover_millisec', 'average_switchover_millisec'], name, value)


            class PathProtectionSwitchoverEntry(_Entity_):
                """
                The array of path protection switchover entries
                
                .. attribute:: path_protection_switchover_event_index
                
                	The index number of the path protection switch over event
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: path_protection_tunnel_id
                
                	The ID of the tunnel that experienced switchover
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: from_lsp_id
                
                	The LSP ID from which the traffic was switched over
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: to_lsp_id
                
                	The LSP ID to which the traffic was switched over
                	**type**\: int
                
                	**range:** 0..65535
                
                	**config**\: False
                
                .. attribute:: date_of_error_detection
                
                	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: date_of_error_detection_millisec
                
                	The milliseconds offset of the date when the error that caused  the switchover was detected
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: millisecond
                
                .. attribute:: switchover_duration_millisec
                
                	The time in milliseconds between the detection of the error and switching the traffic
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: millisecond
                
                .. attribute:: path_protection_switchover_reason
                
                	The reason that caused the path protection switchover
                	**type**\:  :py:class:`TeP2mpS2lDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2mpS2lDeletionSubcause>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__init__()

                    self.yang_name = "path-protection-switchover-entry"
                    self.yang_parent_name = "switchover-log"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('path_protection_switchover_event_index', (YLeaf(YType.uint32, 'path-protection-switchover-event-index'), ['int'])),
                        ('path_protection_tunnel_id', (YLeaf(YType.uint16, 'path-protection-tunnel-id'), ['int'])),
                        ('from_lsp_id', (YLeaf(YType.uint16, 'from-lsp-id'), ['int'])),
                        ('to_lsp_id', (YLeaf(YType.uint16, 'to-lsp-id'), ['int'])),
                        ('date_of_error_detection', (YLeaf(YType.uint32, 'date-of-error-detection'), ['int'])),
                        ('date_of_error_detection_millisec', (YLeaf(YType.uint32, 'date-of-error-detection-millisec'), ['int'])),
                        ('switchover_duration_millisec', (YLeaf(YType.uint32, 'switchover-duration-millisec'), ['int'])),
                        ('path_protection_switchover_reason', (YLeaf(YType.enumeration, 'path-protection-switchover-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeP2mpS2lDeletionSubcause', '')])),
                    ])
                    self.path_protection_switchover_event_index = None
                    self.path_protection_tunnel_id = None
                    self.from_lsp_id = None
                    self.to_lsp_id = None
                    self.date_of_error_detection = None
                    self.date_of_error_detection_millisec = None
                    self.switchover_duration_millisec = None
                    self.path_protection_switchover_reason = None
                    self._segment_path = lambda: "path-protection-switchover-entry"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/path-protection/switchover-log/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, ['path_protection_switchover_event_index', 'path_protection_tunnel_id', 'from_lsp_id', 'to_lsp_id', 'date_of_error_detection', 'date_of_error_detection_millisec', 'switchover_duration_millisec', 'path_protection_switchover_reason'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.PathProtection.SwitchoverLog']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.PathProtection']['meta_info']


    class FibNextHopLabelRoutes(_Entity_):
        """
        MPLS TE FIB nexthop label route database
        
        .. attribute:: fib_next_hop_label_route
        
        	MPLS TE FIB nexthop label route
        	**type**\: list of  		 :py:class:`FibNextHopLabelRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.FibNextHopLabelRoutes, self).__init__()

            self.yang_name = "fib-next-hop-label-routes"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("fib-next-hop-label-route", ("fib_next_hop_label_route", MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute))])
            self._leafs = OrderedDict()

            self.fib_next_hop_label_route = YList(self)
            self._segment_path = lambda: "fib-next-hop-label-routes"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.FibNextHopLabelRoutes, [], name, value)


        class FibNextHopLabelRoute(_Entity_):
            """
            MPLS TE FIB nexthop label route
            
            .. attribute:: label  (key)
            
            	MPLS Label
            	**type**\: int
            
            	**range:** 0..1048575
            
            	**config**\: False
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:  :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress>`
            
            	**config**\: False
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: route_version
            
            	Route version
            	**type**\: int
            
            	**range:** 0..18446744073709551615
            
            	**config**\: False
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of  		 :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__init__()

                self.yang_name = "fib-next-hop-label-route"
                self.yang_parent_name = "fib-next-hop-label-routes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['label']
                self._child_classes = OrderedDict([("target-address", ("target_address", MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress)), ("next-hop-path", ("next_hop_path", MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath))])
                self._leafs = OrderedDict([
                    ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                    ('prefix_addr', (YLeaf(YType.str, 'prefix-addr'), ['str'])),
                    ('create_time', (YLeaf(YType.uint32, 'create-time'), ['int'])),
                    ('last_used_time', (YLeaf(YType.uint32, 'last-used-time'), ['int'])),
                    ('last_update_time', (YLeaf(YType.uint32, 'last-update-time'), ['int'])),
                    ('expire_time', (YLeaf(YType.uint32, 'expire-time'), ['int'])),
                    ('is_registered', (YLeaf(YType.boolean, 'is-registered'), ['bool'])),
                    ('is_notified', (YLeaf(YType.boolean, 'is-notified'), ['bool'])),
                    ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                    ('route_version', (YLeaf(YType.uint64, 'route-version'), ['int'])),
                ])
                self.label = None
                self.prefix_addr = None
                self.create_time = None
                self.last_used_time = None
                self.last_update_time = None
                self.expire_time = None
                self.is_registered = None
                self.is_notified = None
                self.is_stale = None
                self.route_version = None

                self.target_address = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"

                self.next_hop_path = YList(self)
                self._segment_path = lambda: "fib-next-hop-label-route" + "[label='" + str(self.label) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fib-next-hop-label-routes/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute, ['label', 'prefix_addr', 'create_time', 'last_used_time', 'last_update_time', 'expire_time', 'is_registered', 'is_notified', 'is_stale', 'route_version'], name, value)


            class TargetAddress(_Entity_):
                """
                Next Hop Target Address
                
                .. attribute:: type
                
                	type
                	**type**\:  :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                	**config**\: False
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-label-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeTargetAddr', '')])),
                        ('ip_address', (YLeaf(YType.str, 'ip-address'), ['str'])),
                        ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                    ])
                    self.type = None
                    self.ip_address = None
                    self.label = None
                    self._segment_path = lambda: "target-address"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, ['type', 'ip_address', 'label'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress']['meta_info']


            class NextHopPath(_Entity_):
                """
                Next Hop Paths
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of  		 :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-label-route"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("label-stack", ("label_stack", MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack))])
                    self._leafs = OrderedDict([
                        ('interface', (YLeaf(YType.str, 'interface'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                        ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                        ('pure_backup', (YLeaf(YType.boolean, 'pure-backup'), ['bool'])),
                    ])
                    self.interface = None
                    self.next_hop_address = None
                    self.path_id = None
                    self.backup_path_id = None
                    self.pure_backup = None

                    self.label_stack = YList(self)
                    self._segment_path = lambda: "next-hop-path"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, ['interface', 'next_hop_address', 'path_id', 'backup_path_id', 'pure_backup'], name, value)


                class LabelStack(_Entity_):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	Outgoing Label Stack
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "label-stack"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.FibNextHopLabelRoutes']['meta_info']


    class P2mp(_Entity_):
        """
        P2MP Information
        
        .. attribute:: tunnel_rewrites
        
        	forwarding\-adjacency P2MP Tunnel RW
        	**type**\:  :py:class:`TunnelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites>`
        
        	**config**\: False
        
        .. attribute:: collaborator_timers
        
        	TE Collaborator timer status
        	**type**\:  :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.CollaboratorTimers>`
        
        	**config**\: False
        
        .. attribute:: forwarding_output_label_rewrites
        
        	forwarding\-adjacency P2MP Information
        	**type**\:  :py:class:`ForwardingOutputLabelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.P2mp, self).__init__()

            self.yang_name = "p2mp"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("tunnel-rewrites", ("tunnel_rewrites", MplsTeStandby.P2mp.TunnelRewrites)), ("collaborator-timers", ("collaborator_timers", MplsTeStandby.P2mp.CollaboratorTimers)), ("forwarding-output-label-rewrites", ("forwarding_output_label_rewrites", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites))])
            self._leafs = OrderedDict()

            self.tunnel_rewrites = MplsTeStandby.P2mp.TunnelRewrites()
            self.tunnel_rewrites.parent = self
            self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"

            self.collaborator_timers = MplsTeStandby.P2mp.CollaboratorTimers()
            self.collaborator_timers.parent = self
            self._children_name_map["collaborator_timers"] = "collaborator-timers"

            self.forwarding_output_label_rewrites = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites()
            self.forwarding_output_label_rewrites.parent = self
            self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
            self._segment_path = lambda: "p2mp"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.P2mp, [], name, value)


        class TunnelRewrites(_Entity_):
            """
            forwarding\-adjacency P2MP Tunnel RW
            
            .. attribute:: tunnel_rewrite
            
            	Display only P2MP Information
            	**type**\: list of  		 :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2mp.TunnelRewrites, self).__init__()

                self.yang_name = "tunnel-rewrites"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite))])
                self._leafs = OrderedDict()

                self.tunnel_rewrite = YList(self)
                self._segment_path = lambda: "tunnel-rewrites"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites, [], name, value)


            class TunnelRewrite(_Entity_):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: successful_rewrite
                
                	Successful rewrite details
                	**type**\:  :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite>`
                
                	**config**\: False
                
                .. attribute:: failed_rewrite
                
                	Failed rewrite details
                	**type**\:  :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite>`
                
                	**config**\: False
                
                .. attribute:: pending_rewrite
                
                	Pending rewrite details
                	**type**\:  :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite>`
                
                	**config**\: False
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: tunnel_signal_name
                
                	Tunnel signaled\-name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite, self).__init__()

                    self.yang_name = "tunnel-rewrite"
                    self.yang_parent_name = "tunnel-rewrites"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','lsp_id','ctype']
                    self._child_classes = OrderedDict([("successful-rewrite", ("successful_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite)), ("failed-rewrite", ("failed_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite)), ("pending-rewrite", ("pending_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('tunnel_interface', (YLeaf(YType.str, 'tunnel-interface'), ['str'])),
                        ('tunnel_signal_name', (YLeaf(YType.str, 'tunnel-signal-name'), ['str'])),
                        ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.ctype = None
                    self.tunnel_interface = None
                    self.tunnel_signal_name = None
                    self.is_segment_routing = None

                    self.successful_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                    self.successful_rewrite.parent = self
                    self._children_name_map["successful_rewrite"] = "successful-rewrite"

                    self.failed_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                    self.failed_rewrite.parent = self
                    self._children_name_map["failed_rewrite"] = "failed-rewrite"

                    self.pending_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                    self.pending_rewrite.parent = self
                    self._children_name_map["pending_rewrite"] = "pending-rewrite"
                    self._segment_path = lambda: "tunnel-rewrite" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[ctype='" + str(self.ctype) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/tunnel-rewrites/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite, ['tunnel_id', 'lsp_id', 'ctype', 'tunnel_interface', 'tunnel_signal_name', 'is_segment_routing'], name, value)


                class SuccessfulRewrite(_Entity_):
                    """
                    Successful rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__init__()

                        self.yang_name = "successful-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "successful-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "successful-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite']['meta_info']


                class FailedRewrite(_Entity_):
                    """
                    Failed rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__init__()

                        self.yang_name = "failed-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "failed-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "failed-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.FailedRewrite']['meta_info']


                class PendingRewrite(_Entity_):
                    """
                    Pending rewrite details
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:  :py:class:`TunnelRewrite_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_>`
                    
                    	**config**\: False
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__init__()

                        self.yang_name = "pending-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-rewrite", ("tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_))])
                        self._leafs = OrderedDict([
                            ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                        ])
                        self.timestamp = None

                        self.tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._segment_path = lambda: "pending-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite, ['timestamp'], name, value)


                    class TunnelRewrite_(_Entity_):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:  :py:class:`P2pTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:  :py:class:`P2mpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "pending-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("p2p-tunnel-rewrite", ("p2p_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite)), ("p2mp-tunnel-rewrite", ("p2mp_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                            ])
                            self.fec_ctype = None

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._segment_path = lambda: "tunnel-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_, ['fec_ctype'], name, value)


                        class P2pTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l>`
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite>`
                            
                            	**config**\: False
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\: str
                            
                            	**config**\: False
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite))])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                    ('tunnel_id', (YLeaf(YType.uint16, 'tunnel-id'), ['int'])),
                                    ('source_pe', (YLeaf(YType.str, 'source-pe'), ['str'])),
                                    ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                                    ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                                    ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                    ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                                    ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                    ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                                    ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                                ])
                                self.local_label = None
                                self.tunnel_id = None
                                self.source_pe = None
                                self.destination_address = None
                                self.extended_tunnel_id = None
                                self.backup_active = None
                                self.original_input_interface = None
                                self.previous_hop_address = None
                                self.output_interface_name = None
                                self.backup_tunnel_name = None

                                self.primary_s2l = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"

                                self.backup_tunnel_rewrite = MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._segment_path = lambda: "p2p-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite, ['local_label', 'tunnel_id', 'source_pe', 'destination_address', 'extended_tunnel_id', 'backup_active', 'original_input_interface', 'previous_hop_address', 'output_interface_name', 'backup_tunnel_name'], name, value)


                            class PrimaryS2l(_Entity_):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "primary-s2l"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.PrimaryS2l']['meta_info']


                            class BackupTunnelRewrite(_Entity_):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\: str
                                
                                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                                
                                	**config**\: False
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack))])
                                    self._leafs = OrderedDict([
                                        ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                        ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                        ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                        ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                    ])
                                    self.physica_interface_name = None
                                    self.tunnel_interface_name = None
                                    self.parent_interface_name = None
                                    self.next_hop_address = None
                                    self.out_label = None

                                    self.sr_label_stack = YList(self)
                                    self._segment_path = lambda: "backup-tunnel-rewrite"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                                class SrLabelStack(_Entity_):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	Segment\-Routing labels stack
                                    	**type**\: int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**config**\: False
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2018-08-01'

                                    def __init__(self):
                                        if sys.version_info > (3,):
                                            super().__init__()
                                        else:
                                            super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self.ylist_key_names = []
                                        self._child_classes = OrderedDict([])
                                        self._leafs = OrderedDict([
                                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                        ])
                                        self.entry = None
                                        self._segment_path = lambda: "sr-label-stack"
                                        self._is_frozen = True

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                    @staticmethod
                                    def _meta_info():
                                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite.BackupTunnelRewrite']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2pTunnelRewrite']['meta_info']


                        class P2mpTunnelRewrite(_Entity_):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('local_label', (YLeaf(YType.uint32, 'local-label'), ['int'])),
                                ])
                                self.local_label = None
                                self._segment_path = lambda: "p2mp-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite, ['local_label'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_.P2mpTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite_']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite.PendingRewrite']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites.TunnelRewrite']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2mp.TunnelRewrites']['meta_info']


        class CollaboratorTimers(_Entity_):
            """
            TE Collaborator timer status
            
            .. attribute:: p2mp_timer
            
            	Description of all P2MP timers
            	**type**\: list of  		 :py:class:`P2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.CollaboratorTimers.P2mpTimer>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2mp.CollaboratorTimers, self).__init__()

                self.yang_name = "collaborator-timers"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("p2mp-timer", ("p2mp_timer", MplsTeStandby.P2mp.CollaboratorTimers.P2mpTimer))])
                self._leafs = OrderedDict()

                self.p2mp_timer = YList(self)
                self._segment_path = lambda: "collaborator-timers"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2mp.CollaboratorTimers, [], name, value)


            class P2mpTimer(_Entity_):
                """
                Description of all P2MP timers
                
                .. attribute:: timer_type
                
                	Timer Type
                	**type**\:  :py:class:`MplsTeP2mpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2mpTimer>`
                
                	**config**\: False
                
                .. attribute:: timer_name
                
                	Timer Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: start_time
                
                	Date when timer was last started in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: expiry_time
                
                	Date when the timer last expired in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: stop_time
                
                	Date when the timer was last stopped in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: duration
                
                	The expiry delay in seconds
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: second
                
                .. attribute:: is_running
                
                	True if the timer is running
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2mp.CollaboratorTimers.P2mpTimer, self).__init__()

                    self.yang_name = "p2mp-timer"
                    self.yang_parent_name = "collaborator-timers"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('timer_type', (YLeaf(YType.enumeration, 'timer-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeP2mpTimer', '')])),
                        ('timer_name', (YLeaf(YType.str, 'timer-name'), ['str'])),
                        ('start_time', (YLeaf(YType.uint32, 'start-time'), ['int'])),
                        ('expiry_time', (YLeaf(YType.uint32, 'expiry-time'), ['int'])),
                        ('stop_time', (YLeaf(YType.uint32, 'stop-time'), ['int'])),
                        ('duration', (YLeaf(YType.uint32, 'duration'), ['int'])),
                        ('is_running', (YLeaf(YType.boolean, 'is-running'), ['bool'])),
                    ])
                    self.timer_type = None
                    self.timer_name = None
                    self.start_time = None
                    self.expiry_time = None
                    self.stop_time = None
                    self.duration = None
                    self.is_running = None
                    self._segment_path = lambda: "p2mp-timer"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/collaborator-timers/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2mp.CollaboratorTimers.P2mpTimer, ['timer_type', 'timer_name', 'start_time', 'expiry_time', 'stop_time', 'duration', 'is_running'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2mp.CollaboratorTimers.P2mpTimer']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2mp.CollaboratorTimers']['meta_info']


        class ForwardingOutputLabelRewrites(_Entity_):
            """
            forwarding\-adjacency P2MP Information
            
            .. attribute:: forwarding_output_label_rewrite
            
            	Display only P2MP Information
            	**type**\: list of  		 :py:class:`ForwardingOutputLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites, self).__init__()

                self.yang_name = "forwarding-output-label-rewrites"
                self.yang_parent_name = "p2mp"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("forwarding-output-label-rewrite", ("forwarding_output_label_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite))])
                self._leafs = OrderedDict()

                self.forwarding_output_label_rewrite = YList(self)
                self._segment_path = lambda: "forwarding-output-label-rewrites"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites, [], name, value)


            class ForwardingOutputLabelRewrite(_Entity_):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  (key)
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id  (key)
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id  (key)
                
                	extended tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: source_address  (key)
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: p2mp_id  (key)
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address  (key)
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: next_hop_address  (key)
                
                	Next Hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: previous_hop_address  (key)
                
                	Prev Hop
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype  (key)
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: s2l_output_rewrite
                
                	Output rewrite shared between S2Ls
                	**type**\:  :py:class:`S2lOutputRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite>`
                
                	**config**\: False
                
                .. attribute:: original_input_interface
                
                	Input interface of the S2Ls
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: output_interface_name
                
                	The output interface of the S2Ls
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: backup_tunnel_name
                
                	Backup tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: s2l
                
                	Unique identifiers for the S2L sharing the rewrite
                	**type**\: list of  		 :py:class:`S2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l>`
                
                	**config**\: False
                
                .. attribute:: s2lsr_path
                
                	Segment\-Routing Paths
                	**type**\: list of  		 :py:class:`S2lsrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__init__()

                    self.yang_name = "forwarding-output-label-rewrite"
                    self.yang_parent_name = "forwarding-output-label-rewrites"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_id','lsp_id','extended_tunnel_id','source_address','p2mp_id','destination_address','next_hop_address','previous_hop_address','ctype']
                    self._child_classes = OrderedDict([("s2l-output-rewrite", ("s2l_output_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite)), ("s2l", ("s2l", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l)), ("s2lsr-path", ("s2lsr_path", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath))])
                    self._leafs = OrderedDict([
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                        ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('original_input_interface', (YLeaf(YType.str, 'original-input-interface'), ['str'])),
                        ('output_interface_name', (YLeaf(YType.str, 'output-interface-name'), ['str'])),
                        ('backup_tunnel_name', (YLeaf(YType.str, 'backup-tunnel-name'), ['str'])),
                        ('is_segment_routing', (YLeaf(YType.boolean, 'is-segment-routing'), ['bool'])),
                    ])
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.extended_tunnel_id = None
                    self.source_address = None
                    self.p2mp_id = None
                    self.destination_address = None
                    self.next_hop_address = None
                    self.previous_hop_address = None
                    self.ctype = None
                    self.original_input_interface = None
                    self.output_interface_name = None
                    self.backup_tunnel_name = None
                    self.is_segment_routing = None

                    self.s2l_output_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite()
                    self.s2l_output_rewrite.parent = self
                    self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"

                    self.s2l = YList(self)
                    self.s2lsr_path = YList(self)
                    self._segment_path = lambda: "forwarding-output-label-rewrite" + "[tunnel-id='" + str(self.tunnel_id) + "']" + "[lsp-id='" + str(self.lsp_id) + "']" + "[extended-tunnel-id='" + str(self.extended_tunnel_id) + "']" + "[source-address='" + str(self.source_address) + "']" + "[p2mp-id='" + str(self.p2mp_id) + "']" + "[destination-address='" + str(self.destination_address) + "']" + "[next-hop-address='" + str(self.next_hop_address) + "']" + "[previous-hop-address='" + str(self.previous_hop_address) + "']" + "[ctype='" + str(self.ctype) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/forwarding-output-label-rewrites/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, ['tunnel_id', 'lsp_id', 'extended_tunnel_id', 'source_address', 'p2mp_id', 'destination_address', 'next_hop_address', 'previous_hop_address', 'ctype', 'original_input_interface', 'output_interface_name', 'backup_tunnel_name', 'is_segment_routing'], name, value)


                class S2lOutputRewrite(_Entity_):
                    """
                    Output rewrite shared between S2Ls
                    
                    .. attribute:: subfamily
                    
                    	Subfamily identifiers
                    	**type**\:  :py:class:`Subfamily <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily>`
                    
                    	**config**\: False
                    
                    .. attribute:: successful_rewrite
                    
                    	Successful rewrite details
                    	**type**\:  :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite>`
                    
                    	**config**\: False
                    
                    .. attribute:: failed_rewrite
                    
                    	Failed rewrite details
                    	**type**\:  :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite>`
                    
                    	**config**\: False
                    
                    .. attribute:: pending_rewrite
                    
                    	Pending rewrite details
                    	**type**\:  :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite, self).__init__()

                        self.yang_name = "s2l-output-rewrite"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("subfamily", ("subfamily", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily)), ("successful-rewrite", ("successful_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite)), ("failed-rewrite", ("failed_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite)), ("pending-rewrite", ("pending_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite))])
                        self._leafs = OrderedDict()

                        self.subfamily = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily()
                        self.subfamily.parent = self
                        self._children_name_map["subfamily"] = "subfamily"

                        self.successful_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite()
                        self.successful_rewrite.parent = self
                        self._children_name_map["successful_rewrite"] = "successful-rewrite"

                        self.failed_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite()
                        self.failed_rewrite.parent = self
                        self._children_name_map["failed_rewrite"] = "failed-rewrite"

                        self.pending_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite()
                        self.pending_rewrite.parent = self
                        self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        self._segment_path = lambda: "s2l-output-rewrite"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite, [], name, value)


                    class Subfamily(_Entity_):
                        """
                        Subfamily identifiers
                        
                        .. attribute:: lsp_fec
                        
                        	LSP FEC
                        	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec>`
                        
                        	**config**\: False
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: next_next_hop_address
                        
                        	Next Next hop address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily, self).__init__()

                            self.yang_name = "subfamily"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec))])
                            self._leafs = OrderedDict([
                                ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                ('previous_hop_address', (YLeaf(YType.str, 'previous-hop-address'), ['str'])),
                                ('next_next_hop_address', (YLeaf(YType.str, 'next-next-hop-address'), ['str'])),
                            ])
                            self.next_hop_address = None
                            self.previous_hop_address = None
                            self.next_next_hop_address = None

                            self.lsp_fec = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                            self._segment_path = lambda: "subfamily"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily, ['next_hop_address', 'previous_hop_address', 'next_next_hop_address'], name, value)


                        class LspFec(_Entity_):
                            """
                            LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo>`
                            
                            	**config**\: False
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\: int
                            
                            	**range:** 0..65535
                            
                            	**config**\: False
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\: str
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec, self).__init__()

                                self.yang_name = "lsp-fec"
                                self.yang_parent_name = "subfamily"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo))])
                                self._leafs = OrderedDict([
                                    ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                                    ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                                    ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                                    ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                                    ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                                ])
                                self.fec_lsp_id = None
                                self.fec_tunnel_id = None
                                self.fec_extended_tunnel_id = None
                                self.fec_source = None
                                self.fec_vrf = None

                                self.fec_destination_info = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._segment_path = lambda: "lsp-fec"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                            class FecDestinationInfo(_Entity_):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                	**config**\: False
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\: str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                	**config**\: False
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "lsp-fec"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                        ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                        ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                                    ])
                                    self.fec_ctype = None
                                    self.p2p_lsp_destination = None
                                    self.fec_destination_p2mp_id = None
                                    self._segment_path = lambda: "fec-destination-info"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec.FecDestinationInfo']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily.LspFec']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.Subfamily']['meta_info']


                    class SuccessfulRewrite(_Entity_):
                        """
                        Successful rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite, self).__init__()

                            self.yang_name = "successful-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "successful-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "successful-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "successful-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.SuccessfulRewrite']['meta_info']


                    class FailedRewrite(_Entity_):
                        """
                        Failed rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite, self).__init__()

                            self.yang_name = "failed-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "failed-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "failed-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "failed-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.FailedRewrite']['meta_info']


                    class PendingRewrite(_Entity_):
                        """
                        Pending rewrite details
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:  :py:class:`PrimaryS2l <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l>`
                        
                        	**config**\: False
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:  :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite>`
                        
                        	**config**\: False
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        	**units**\: second
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:  :py:class:`TeS2lOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2lOutputRwExplicitNull>`
                        
                        	**config**\: False
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\: int
                        
                        	**range:** 0..65535
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite, self).__init__()

                            self.yang_name = "pending-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("primary-s2l", ("primary_s2l", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l)), ("backup-tunnel-rewrite", ("backup_tunnel_rewrite", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite))])
                            self._leafs = OrderedDict([
                                ('timestamp', (YLeaf(YType.uint32, 'timestamp'), ['int'])),
                                ('out_rewrite_role', (YLeaf(YType.enumeration, 'out-rewrite-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                                ('label', (YLeaf(YType.uint32, 'label'), ['int'])),
                                ('backup_active', (YLeaf(YType.boolean, 'backup-active'), ['bool'])),
                                ('s2l_source', (YLeaf(YType.str, 's2l-source'), ['str'])),
                                ('explicit_null', (YLeaf(YType.enumeration, 'explicit-null'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeS2lOutputRwExplicitNull', '')])),
                                ('protocol_transported', (YLeaf(YType.uint16, 'protocol-transported'), ['int'])),
                            ])
                            self.timestamp = None
                            self.out_rewrite_role = None
                            self.label = None
                            self.backup_active = None
                            self.s2l_source = None
                            self.explicit_null = None
                            self.protocol_transported = None

                            self.primary_s2l = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"

                            self.backup_tunnel_rewrite = MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._segment_path = lambda: "pending-rewrite"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite, ['timestamp', 'out_rewrite_role', 'label', 'backup_active', 's2l_source', 'explicit_null', 'protocol_transported'], name, value)


                        class PrimaryS2l(_Entity_):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "pending-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "primary-s2l"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.PrimaryS2l']['meta_info']


                        class BackupTunnelRewrite(_Entity_):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\: str
                            
                            	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                            
                            	**config**\: False
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\: str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            	**config**\: False
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of  		 :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "pending-rewrite"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("sr-label-stack", ("sr_label_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack))])
                                self._leafs = OrderedDict([
                                    ('physica_interface_name', (YLeaf(YType.str, 'physica-interface-name'), ['str'])),
                                    ('tunnel_interface_name', (YLeaf(YType.str, 'tunnel-interface-name'), ['str'])),
                                    ('parent_interface_name', (YLeaf(YType.str, 'parent-interface-name'), ['str'])),
                                    ('next_hop_address', (YLeaf(YType.str, 'next-hop-address'), ['str'])),
                                    ('out_label', (YLeaf(YType.uint32, 'out-label'), ['int'])),
                                ])
                                self.physica_interface_name = None
                                self.tunnel_interface_name = None
                                self.parent_interface_name = None
                                self.next_hop_address = None
                                self.out_label = None

                                self.sr_label_stack = YList(self)
                                self._segment_path = lambda: "backup-tunnel-rewrite"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite, ['physica_interface_name', 'tunnel_interface_name', 'parent_interface_name', 'next_hop_address', 'out_label'], name, value)


                            class SrLabelStack(_Entity_):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	Segment\-Routing labels stack
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "sr-label-stack"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite.BackupTunnelRewrite']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite.PendingRewrite']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lOutputRewrite']['meta_info']


                class S2l(_Entity_):
                    """
                    Unique identifiers for the S2L sharing the
                    rewrite
                    
                    .. attribute:: destination_address
                    
                    	Destination
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_id
                    
                    	S2L Sub\-Group ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: sub_group_original_id
                    
                    	S2L Sub\-Group Originator ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                            ('sub_group_id', (YLeaf(YType.uint16, 'sub-group-id'), ['int'])),
                            ('sub_group_original_id', (YLeaf(YType.str, 'sub-group-original-id'), ['str'])),
                        ])
                        self.destination_address = None
                        self.sub_group_id = None
                        self.sub_group_original_id = None
                        self._segment_path = lambda: "s2l"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l, ['destination_address', 'sub_group_id', 'sub_group_original_id'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2l']['meta_info']


                class S2lsrPath(_Entity_):
                    """
                    Segment\-Routing Paths
                    
                    .. attribute:: is_primary
                    
                    	True if path is primary
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_backup
                    
                    	True if path is backup
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing Interface Name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: path_id
                    
                    	Path Identifier
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: backup_path_id
                    
                    	Backup Path Identifier
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: next_hop
                    
                    	Next hop
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: outgoing_labels_stack
                    
                    	Outgoing Labels Stack
                    	**type**\: list of  		 :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath, self).__init__()

                        self.yang_name = "s2lsr-path"
                        self.yang_parent_name = "forwarding-output-label-rewrite"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("outgoing-labels-stack", ("outgoing_labels_stack", MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack))])
                        self._leafs = OrderedDict([
                            ('is_primary', (YLeaf(YType.boolean, 'is-primary'), ['bool'])),
                            ('is_backup', (YLeaf(YType.boolean, 'is-backup'), ['bool'])),
                            ('outgoing_interface', (YLeaf(YType.str, 'outgoing-interface'), ['str'])),
                            ('path_id', (YLeaf(YType.uint32, 'path-id'), ['int'])),
                            ('backup_path_id', (YLeaf(YType.uint32, 'backup-path-id'), ['int'])),
                            ('next_hop', (YLeaf(YType.str, 'next-hop'), ['str'])),
                        ])
                        self.is_primary = None
                        self.is_backup = None
                        self.outgoing_interface = None
                        self.path_id = None
                        self.backup_path_id = None
                        self.next_hop = None

                        self.outgoing_labels_stack = YList(self)
                        self._segment_path = lambda: "s2lsr-path"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath, ['is_primary', 'is_backup', 'outgoing_interface', 'path_id', 'backup_path_id', 'next_hop'], name, value)


                    class OutgoingLabelsStack(_Entity_):
                        """
                        Outgoing Labels Stack
                        
                        .. attribute:: entry
                        
                        	Outgoing Labels Stack
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack, self).__init__()

                            self.yang_name = "outgoing-labels-stack"
                            self.yang_parent_name = "s2lsr-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "outgoing-labels-stack"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath.OutgoingLabelsStack']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2lsrPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.P2mp.ForwardingOutputLabelRewrites']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.P2mp']['meta_info']


    class LspOutOfResources(_Entity_):
        """
        LSP OOR information
        
        .. attribute:: summary
        
        	LSP OOR Summary information
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.LspOutOfResources, self).__init__()

            self.yang_name = "lsp-out-of-resources"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("summary", ("summary", MplsTeStandby.LspOutOfResources.Summary))])
            self._leafs = OrderedDict()

            self.summary = MplsTeStandby.LspOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._segment_path = lambda: "lsp-out-of-resources"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.LspOutOfResources, [], name, value)


        class Summary(_Entity_):
            """
            LSP OOR Summary information
            
            .. attribute:: transit_lsp_total_count
            
            	Number of all transit LSPs on the router
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: transit_lsp_unprotected_count
            
            	Number of unprotected transit LSPs on the router
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: lsp_oor_state
            
            	The current LSP OOR state
            	**type**\:  :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
            
            	**config**\: False
            
            .. attribute:: lsp_oor_timestamp
            
            	Timestamp when the OOR state last changed
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: lsp_oor_green_recovery_time
            
            	Time Remaining in Green Recovery State (seconds)
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            	**units**\: second
            
            .. attribute:: lsp_oor_state_xr
            
            	Array of LSP OOR info per state
            	**type**\: list of  		 :py:class:`LspOorStateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.LspOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "lsp-out-of-resources"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("lsp-oor-state-xr", ("lsp_oor_state_xr", MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr))])
                self._leafs = OrderedDict([
                    ('transit_lsp_total_count', (YLeaf(YType.uint32, 'transit-lsp-total-count'), ['int'])),
                    ('transit_lsp_unprotected_count', (YLeaf(YType.uint32, 'transit-lsp-unprotected-count'), ['int'])),
                    ('lsp_oor_state', (YLeaf(YType.enumeration, 'lsp-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LspOorState', '')])),
                    ('lsp_oor_timestamp', (YLeaf(YType.uint32, 'lsp-oor-timestamp'), ['int'])),
                    ('lsp_oor_green_recovery_time', (YLeaf(YType.uint32, 'lsp-oor-green-recovery-time'), ['int'])),
                ])
                self.transit_lsp_total_count = None
                self.transit_lsp_unprotected_count = None
                self.lsp_oor_state = None
                self.lsp_oor_timestamp = None
                self.lsp_oor_green_recovery_time = None

                self.lsp_oor_state_xr = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.LspOutOfResources.Summary, ['transit_lsp_total_count', 'transit_lsp_unprotected_count', 'lsp_oor_state', 'lsp_oor_timestamp', 'lsp_oor_green_recovery_time'], name, value)


            class LspOorStateXr(_Entity_):
                """
                Array of LSP OOR info per state
                
                .. attribute:: statistics
                
                	LSP OOR Statistics
                	**type**\:  :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics>`
                
                	**config**\: False
                
                .. attribute:: lsp_oor_state
                
                	The LSP\-OOR state that this information belongs to
                	**type**\:  :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
                
                	**config**\: False
                
                .. attribute:: threshold_transit_all
                
                	The number of transit LSPs that triggers OOR state transition
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: threshold_transit_unprotected
                
                	The number of unprotected transit LSPs that triggers OOR state transition
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: percentage
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green LSP OOR state is entered
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: minute
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this LSP OOR state
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the LSP OOR state
                	**type**\: bool
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr, self).__init__()

                    self.yang_name = "lsp-oor-state-xr"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("statistics", ("statistics", MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics))])
                    self._leafs = OrderedDict([
                        ('lsp_oor_state', (YLeaf(YType.enumeration, 'lsp-oor-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'LspOorState', '')])),
                        ('threshold_transit_all', (YLeaf(YType.uint32, 'threshold-transit-all'), ['int'])),
                        ('threshold_transit_unprotected', (YLeaf(YType.uint32, 'threshold-transit-unprotected'), ['int'])),
                        ('te_metric_penalty', (YLeaf(YType.uint32, 'te-metric-penalty'), ['int'])),
                        ('available_bw_percentage', (YLeaf(YType.uint32, 'available-bw-percentage'), ['int'])),
                        ('transition_duration', (YLeaf(YType.uint32, 'transition-duration'), ['int'])),
                        ('minimum_lsp_bandwidth', (YLeaf(YType.uint32, 'minimum-lsp-bandwidth'), ['int'])),
                        ('accept_reopt', (YLeaf(YType.boolean, 'accept-reopt'), ['bool'])),
                    ])
                    self.lsp_oor_state = None
                    self.threshold_transit_all = None
                    self.threshold_transit_unprotected = None
                    self.te_metric_penalty = None
                    self.available_bw_percentage = None
                    self.transition_duration = None
                    self.minimum_lsp_bandwidth = None
                    self.accept_reopt = None

                    self.statistics = MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._segment_path = lambda: "lsp-oor-state-xr"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/summary/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr, ['lsp_oor_state', 'threshold_transit_all', 'threshold_transit_unprotected', 'te_metric_penalty', 'available_bw_percentage', 'transition_duration', 'minimum_lsp_bandwidth', 'accept_reopt'], name, value)


                class Statistics(_Entity_):
                    """
                    LSP OOR Statistics
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "lsp-oor-state-xr"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('transitions', (YLeaf(YType.uint32, 'transitions'), ['int'])),
                            ('rejected_ls_ps_number', (YLeaf(YType.uint32, 'rejected-ls-ps-number'), ['int'])),
                            ('accepted_ls_ps_number', (YLeaf(YType.uint32, 'accepted-ls-ps-number'), ['int'])),
                            ('accepted_reopt_ls_ps_number', (YLeaf(YType.uint32, 'accepted-reopt-ls-ps-number'), ['int'])),
                            ('rejected_reopt_ls_ps_number', (YLeaf(YType.uint32, 'rejected-reopt-ls-ps-number'), ['int'])),
                        ])
                        self.transitions = None
                        self.rejected_ls_ps_number = None
                        self.accepted_ls_ps_number = None
                        self.accepted_reopt_ls_ps_number = None
                        self.rejected_reopt_ls_ps_number = None
                        self._segment_path = lambda: "statistics"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/summary/lsp-oor-state-xr/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics, ['transitions', 'rejected_ls_ps_number', 'accepted_ls_ps_number', 'accepted_reopt_ls_ps_number', 'rejected_reopt_ls_ps_number'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.LspOutOfResources.Summary']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.LspOutOfResources']['meta_info']


    class Bfd(_Entity_):
        """
        MPLS TE BFD Oper Info
        
        .. attribute:: head_infos
        
        	MPLS TE Head BFD Over LSP Table
        	**type**\:  :py:class:`HeadInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos>`
        
        	**config**\: False
        
        .. attribute:: links
        
        	MPLS TE BFD Info
        	**type**\:  :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links>`
        
        	**config**\: False
        
        .. attribute:: tail_infos
        
        	MPLS TE Tail BFD Over LSP Table
        	**type**\:  :py:class:`TailInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos>`
        
        	**config**\: False
        
        .. attribute:: summary
        
        	MPLS TE BFD Summary
        	**type**\:  :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Summary>`
        
        	**config**\: False
        
        .. attribute:: counters
        
        	MPLS TE BFD Counters
        	**type**\:  :py:class:`Counters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.Bfd, self).__init__()

            self.yang_name = "bfd"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("head-infos", ("head_infos", MplsTeStandby.Bfd.HeadInfos)), ("links", ("links", MplsTeStandby.Bfd.Links)), ("tail-infos", ("tail_infos", MplsTeStandby.Bfd.TailInfos)), ("summary", ("summary", MplsTeStandby.Bfd.Summary)), ("counters", ("counters", MplsTeStandby.Bfd.Counters))])
            self._leafs = OrderedDict()

            self.head_infos = MplsTeStandby.Bfd.HeadInfos()
            self.head_infos.parent = self
            self._children_name_map["head_infos"] = "head-infos"

            self.links = MplsTeStandby.Bfd.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"

            self.tail_infos = MplsTeStandby.Bfd.TailInfos()
            self.tail_infos.parent = self
            self._children_name_map["tail_infos"] = "tail-infos"

            self.summary = MplsTeStandby.Bfd.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"

            self.counters = MplsTeStandby.Bfd.Counters()
            self.counters.parent = self
            self._children_name_map["counters"] = "counters"
            self._segment_path = lambda: "bfd"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.Bfd, [], name, value)


        class HeadInfos(_Entity_):
            """
            MPLS TE Head BFD Over LSP Table
            
            .. attribute:: head_info
            
            	MPLS TE Head End BFD Over LSP Info
            	**type**\: list of  		 :py:class:`HeadInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Bfd.HeadInfos, self).__init__()

                self.yang_name = "head-infos"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("head-info", ("head_info", MplsTeStandby.Bfd.HeadInfos.HeadInfo))])
                self._leafs = OrderedDict()

                self.head_info = YList(self)
                self._segment_path = lambda: "head-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Bfd.HeadInfos, [], name, value)


            class HeadInfo(_Entity_):
                """
                MPLS TE Head End BFD Over LSP Info
                
                .. attribute:: tunnel_name  (key)
                
                	Tunnel Name
                	**type**\: str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                	**config**\: False
                
                .. attribute:: current_lspbfd_info
                
                	Current LSP BFD Info
                	**type**\:  :py:class:`CurrentLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: standby_lspbfd_info
                
                	Standby LSP BFD Info
                	**type**\:  :py:class:`StandbyLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: reoptimized_lspbfd_info
                
                	Reoptimized LSP BFD Info
                	**type**\:  :py:class:`ReoptimizedLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo>`
                
                	**config**\: False
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: lspbfd_type
                
                	LSP BFD type
                	**type**\:  :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.HeadInfos.HeadInfo, self).__init__()

                    self.yang_name = "head-info"
                    self.yang_parent_name = "head-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['tunnel_name']
                    self._child_classes = OrderedDict([("current-lspbfd-info", ("current_lspbfd_info", MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo)), ("standby-lspbfd-info", ("standby_lspbfd_info", MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo)), ("reoptimized-lspbfd-info", ("reoptimized_lspbfd_info", MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo))])
                    self._leafs = OrderedDict([
                        ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                        ('tunnel_name_xr', (YLeaf(YType.str, 'tunnel-name-xr'), ['str'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('lspbfd_type', (YLeaf(YType.enumeration, 'lspbfd-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeVifBfd', '')])),
                    ])
                    self.tunnel_name = None
                    self.tunnel_name_xr = None
                    self.destination_address = None
                    self.lspbfd_type = None

                    self.current_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                    self.current_lspbfd_info.parent = self
                    self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"

                    self.standby_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                    self.standby_lspbfd_info.parent = self
                    self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"

                    self.reoptimized_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                    self.reoptimized_lspbfd_info.parent = self
                    self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                    self._segment_path = lambda: "head-info" + "[tunnel-name='" + str(self.tunnel_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/head-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.HeadInfos.HeadInfo, ['tunnel_name', 'tunnel_name_xr', 'destination_address', 'lspbfd_type'], name, value)


                class CurrentLspbfdInfo(_Entity_):
                    """
                    Current LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__init__()

                        self.yang_name = "current-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "current-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo']['meta_info']


                class StandbyLspbfdInfo(_Entity_):
                    """
                    Standby LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__init__()

                        self.yang_name = "standby-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "standby-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo']['meta_info']


                class ReoptimizedLspbfdInfo(_Entity_):
                    """
                    Reoptimized LSP BFD Info
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__init__()

                        self.yang_name = "reoptimized-lspbfd-info"
                        self.yang_parent_name = "head-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('lsp_id', (YLeaf(YType.uint16, 'lsp-id'), ['int'])),
                            ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                        ])
                        self.lsp_id = None
                        self.bfd_session_state = None
                        self._segment_path = lambda: "reoptimized-lspbfd-info"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, ['lsp_id', 'bfd_session_state'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.HeadInfos.HeadInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Bfd.HeadInfos']['meta_info']


        class Links(_Entity_):
            """
            MPLS TE BFD Info
            
            .. attribute:: link
            
            	MPLS TE BFD Info
            	**type**\: list of  		 :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links.Link>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Bfd.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("link", ("link", MplsTeStandby.Bfd.Links.Link))])
                self._leafs = OrderedDict()

                self.link = YList(self)
                self._segment_path = lambda: "links"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Bfd.Links, [], name, value)


            class Link(_Entity_):
                """
                MPLS TE BFD Info
                
                .. attribute:: interface_name  (key)
                
                	Interface name
                	**type**\: str
                
                	**pattern:** [a\-zA\-Z0\-9.\_/\-]+
                
                	**config**\: False
                
                .. attribute:: neighbor
                
                	Neighbors of the specified link id
                	**type**\: list of  		 :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links.Link.Neighbor>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['interface_name']
                    self._child_classes = OrderedDict([("neighbor", ("neighbor", MplsTeStandby.Bfd.Links.Link.Neighbor))])
                    self._leafs = OrderedDict([
                        ('interface_name', (YLeaf(YType.str, 'interface-name'), ['str'])),
                    ])
                    self.interface_name = None

                    self.neighbor = YList(self)
                    self._segment_path = lambda: "link" + "[interface-name='" + str(self.interface_name) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/links/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.Links.Link, ['interface_name'], name, value)


                class Neighbor(_Entity_):
                    """
                    Neighbors of the specified link id
                    
                    .. attribute:: neighbor_address
                    
                    	The neighbor's IP address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: is_bfd_up
                    
                    	TRUE if the BFD session is Up on this link
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Bfd.Links.Link.Neighbor, self).__init__()

                        self.yang_name = "neighbor"
                        self.yang_parent_name = "link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('neighbor_address', (YLeaf(YType.str, 'neighbor-address'), ['str'])),
                            ('is_bfd_up', (YLeaf(YType.boolean, 'is-bfd-up'), ['bool'])),
                        ])
                        self.neighbor_address = None
                        self.is_bfd_up = None
                        self._segment_path = lambda: "neighbor"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Bfd.Links.Link.Neighbor, ['neighbor_address', 'is_bfd_up'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Bfd.Links.Link.Neighbor']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.Links.Link']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Bfd.Links']['meta_info']


        class TailInfos(_Entity_):
            """
            MPLS TE Tail BFD Over LSP Table
            
            .. attribute:: tail_info
            
            	MPLS TE Tail End BFD Over LSP Info
            	**type**\: list of  		 :py:class:`TailInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Bfd.TailInfos, self).__init__()

                self.yang_name = "tail-infos"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("tail-info", ("tail_info", MplsTeStandby.Bfd.TailInfos.TailInfo))])
                self._leafs = OrderedDict()

                self.tail_info = YList(self)
                self._segment_path = lambda: "tail-infos"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Bfd.TailInfos, [], name, value)


            class TailInfo(_Entity_):
                """
                MPLS TE Tail End BFD Over LSP Info
                
                .. attribute:: source_address
                
                	Source Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:  :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                	**config**\: False
                
                .. attribute:: p2mp_id
                
                	P2MP ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:  :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec>`
                
                	**config**\: False
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: bfd_session_state
                
                	BFD Session State
                	**type**\:  :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.TailInfos.TailInfo, self).__init__()

                    self.yang_name = "tail-info"
                    self.yang_parent_name = "tail-infos"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("lsp-fec", ("lsp_fec", MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec))])
                    self._leafs = OrderedDict([
                        ('source_address', (YLeaf(YType.str, 'source-address'), ['str'])),
                        ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                        ('lsp_id', (YLeaf(YType.uint32, 'lsp-id'), ['int'])),
                        ('destination_address', (YLeaf(YType.str, 'destination-address'), ['str'])),
                        ('extended_tunnel_id', (YLeaf(YType.str, 'extended-tunnel-id'), ['str'])),
                        ('ctype', (YLeaf(YType.enumeration, 'ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'Ctype', '')])),
                        ('p2mp_id', (YLeaf(YType.uint32, 'p2mp-id'), ['int'])),
                        ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                        ('bfd_session_state', (YLeaf(YType.enumeration, 'bfd-session-state'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeBfdLspSessionState', '')])),
                    ])
                    self.source_address = None
                    self.tunnel_id = None
                    self.lsp_id = None
                    self.destination_address = None
                    self.extended_tunnel_id = None
                    self.ctype = None
                    self.p2mp_id = None
                    self.signaled_name = None
                    self.bfd_session_state = None

                    self.lsp_fec = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._segment_path = lambda: "tail-info"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.TailInfos.TailInfo, ['source_address', 'tunnel_id', 'lsp_id', 'destination_address', 'extended_tunnel_id', 'ctype', 'p2mp_id', 'signaled_name', 'bfd_session_state'], name, value)


                class LspFec(_Entity_):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:  :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\: int
                    
                    	**range:** 0..65535
                    
                    	**config**\: False
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tail-info"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("fec-destination-info", ("fec_destination_info", MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo))])
                        self._leafs = OrderedDict([
                            ('fec_lsp_id', (YLeaf(YType.uint16, 'fec-lsp-id'), ['int'])),
                            ('fec_tunnel_id', (YLeaf(YType.uint16, 'fec-tunnel-id'), ['int'])),
                            ('fec_extended_tunnel_id', (YLeaf(YType.str, 'fec-extended-tunnel-id'), ['str'])),
                            ('fec_source', (YLeaf(YType.str, 'fec-source'), ['str'])),
                            ('fec_vrf', (YLeaf(YType.str, 'fec-vrf'), ['str'])),
                        ])
                        self.fec_lsp_id = None
                        self.fec_tunnel_id = None
                        self.fec_extended_tunnel_id = None
                        self.fec_source = None
                        self.fec_vrf = None

                        self.fec_destination_info = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._segment_path = lambda: "lsp-fec"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/tail-info/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec, ['fec_lsp_id', 'fec_tunnel_id', 'fec_extended_tunnel_id', 'fec_source', 'fec_vrf'], name, value)


                    class FecDestinationInfo(_Entity_):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:  :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        	**config**\: False
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('fec_ctype', (YLeaf(YType.enumeration, 'fec-ctype'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsLibC', '')])),
                                ('p2p_lsp_destination', (YLeaf(YType.str, 'p2p-lsp-destination'), ['str'])),
                                ('fec_destination_p2mp_id', (YLeaf(YType.uint32, 'fec-destination-p2mp-id'), ['int'])),
                            ])
                            self.fec_ctype = None
                            self.p2p_lsp_destination = None
                            self.fec_destination_p2mp_id = None
                            self._segment_path = lambda: "fec-destination-info"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/tail-info/lsp-fec/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, ['fec_ctype', 'p2p_lsp_destination', 'fec_destination_p2mp_id'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.TailInfos.TailInfo']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Bfd.TailInfos']['meta_info']


        class Summary(_Entity_):
            """
            MPLS TE BFD Summary
            
            .. attribute:: tunnel_count_total
            
            	Total number of tunnel interface
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_bfd_enabled
            
            	Number of tunnel interface with BFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_session_up
            
            	Number of tunnel with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_sbfd_enabled
            
            	Number of tunnel interface with SBFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tunnel_count_sbfd_session_up
            
            	Number of tunnel with SBFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_session_created
            
            	Number of head end LSP with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_up
            
            	Number of head end LSP with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tail_lsp_count_session_created
            
            	Number of tail end LSP with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: tail_lsp_count_session_up
            
            	Number of tail end LSP with BFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_sbfd_session_created
            
            	Number of head end LSP with SBFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: head_lsp_count_sbfd_up
            
            	Number of head end LSP with SBFD session in up state
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_bfd_enabled
            
            	Number of link with BFD enabled
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_session_created
            
            	Number of link with BFD session created
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            .. attribute:: link_count_session_up
            
            	Number of link with BFD session in state Up
            	**type**\: int
            
            	**range:** 0..65535
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Bfd.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([])
                self._leafs = OrderedDict([
                    ('tunnel_count_total', (YLeaf(YType.uint16, 'tunnel-count-total'), ['int'])),
                    ('tunnel_count_bfd_enabled', (YLeaf(YType.uint16, 'tunnel-count-bfd-enabled'), ['int'])),
                    ('tunnel_count_session_up', (YLeaf(YType.uint16, 'tunnel-count-session-up'), ['int'])),
                    ('tunnel_count_sbfd_enabled', (YLeaf(YType.uint16, 'tunnel-count-sbfd-enabled'), ['int'])),
                    ('tunnel_count_sbfd_session_up', (YLeaf(YType.uint16, 'tunnel-count-sbfd-session-up'), ['int'])),
                    ('head_lsp_count_session_created', (YLeaf(YType.uint16, 'head-lsp-count-session-created'), ['int'])),
                    ('head_lsp_count_up', (YLeaf(YType.uint16, 'head-lsp-count-up'), ['int'])),
                    ('tail_lsp_count_session_created', (YLeaf(YType.uint16, 'tail-lsp-count-session-created'), ['int'])),
                    ('tail_lsp_count_session_up', (YLeaf(YType.uint16, 'tail-lsp-count-session-up'), ['int'])),
                    ('head_lsp_count_sbfd_session_created', (YLeaf(YType.uint16, 'head-lsp-count-sbfd-session-created'), ['int'])),
                    ('head_lsp_count_sbfd_up', (YLeaf(YType.uint16, 'head-lsp-count-sbfd-up'), ['int'])),
                    ('link_count_bfd_enabled', (YLeaf(YType.uint16, 'link-count-bfd-enabled'), ['int'])),
                    ('link_count_session_created', (YLeaf(YType.uint16, 'link-count-session-created'), ['int'])),
                    ('link_count_session_up', (YLeaf(YType.uint16, 'link-count-session-up'), ['int'])),
                ])
                self.tunnel_count_total = None
                self.tunnel_count_bfd_enabled = None
                self.tunnel_count_session_up = None
                self.tunnel_count_sbfd_enabled = None
                self.tunnel_count_sbfd_session_up = None
                self.head_lsp_count_session_created = None
                self.head_lsp_count_up = None
                self.tail_lsp_count_session_created = None
                self.tail_lsp_count_session_up = None
                self.head_lsp_count_sbfd_session_created = None
                self.head_lsp_count_sbfd_up = None
                self.link_count_bfd_enabled = None
                self.link_count_session_created = None
                self.link_count_session_up = None
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Bfd.Summary, ['tunnel_count_total', 'tunnel_count_bfd_enabled', 'tunnel_count_session_up', 'tunnel_count_sbfd_enabled', 'tunnel_count_sbfd_session_up', 'head_lsp_count_session_created', 'head_lsp_count_up', 'tail_lsp_count_session_created', 'tail_lsp_count_session_up', 'head_lsp_count_sbfd_session_created', 'head_lsp_count_sbfd_up', 'link_count_bfd_enabled', 'link_count_session_created', 'link_count_session_up'], name, value)

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Bfd.Summary']['meta_info']


        class Counters(_Entity_):
            """
            MPLS TE BFD Counters
            
            .. attribute:: bfd_over_lsp_head_counters
            
            	BFD over Head\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`BfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters>`
            
            	**config**\: False
            
            .. attribute:: sbfd_over_lsp_head_counters
            
            	SBFD over Head\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`SbfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters>`
            
            	**config**\: False
            
            .. attribute:: bfd_over_lsp_tail_counters
            
            	BFD over Tail\-end LSPs Cumulative Counters
            	**type**\:  :py:class:`BfdOverLspTailCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters>`
            
            	**config**\: False
            
            .. attribute:: bf_do_lm_counters
            
            	BFD over Links Cumulative Counters
            	**type**\:  :py:class:`BfDoLmCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfDoLmCounters>`
            
            	**config**\: False
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Bfd.Counters, self).__init__()

                self.yang_name = "counters"
                self.yang_parent_name = "bfd"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("bfd-over-lsp-head-counters", ("bfd_over_lsp_head_counters", MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters)), ("sbfd-over-lsp-head-counters", ("sbfd_over_lsp_head_counters", MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters)), ("bfd-over-lsp-tail-counters", ("bfd_over_lsp_tail_counters", MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters)), ("bf-do-lm-counters", ("bf_do_lm_counters", MplsTeStandby.Bfd.Counters.BfDoLmCounters))])
                self._leafs = OrderedDict([
                    ('last_cleared_timestamp', (YLeaf(YType.uint32, 'last-cleared-timestamp'), ['int'])),
                ])
                self.last_cleared_timestamp = None

                self.bfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters()
                self.bfd_over_lsp_head_counters.parent = self
                self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"

                self.sbfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters()
                self.sbfd_over_lsp_head_counters.parent = self
                self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"

                self.bfd_over_lsp_tail_counters = MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters()
                self.bfd_over_lsp_tail_counters.parent = self
                self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"

                self.bf_do_lm_counters = MplsTeStandby.Bfd.Counters.BfDoLmCounters()
                self.bf_do_lm_counters.parent = self
                self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                self._segment_path = lambda: "counters"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Bfd.Counters, ['last_cleared_timestamp'], name, value)


            class BfdOverLspHeadCounters(_Entity_):
                """
                BFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_create_timeout_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bfd-over-lsp-head-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters']['meta_info']


            class SbfdOverLspHeadCounters(_Entity_):
                """
                SBFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "sbfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_create_timeout_events', (YLeaf(YType.uint32, 'session-create-timeout-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_create_timeout_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "sbfd-over-lsp-head-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_create_timeout_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters']['meta_info']


            class BfdOverLspTailCounters(_Entity_):
                """
                BFD over Tail\-end LSPs Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-tail-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bfd-over-lsp-tail-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters']['meta_info']


            class BfDoLmCounters(_Entity_):
                """
                BFD over Links Cumulative Counters
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Bfd.Counters.BfDoLmCounters, self).__init__()

                    self.yang_name = "bf-do-lm-counters"
                    self.yang_parent_name = "counters"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('session_create_events', (YLeaf(YType.uint32, 'session-create-events'), ['int'])),
                        ('session_up_events', (YLeaf(YType.uint32, 'session-up-events'), ['int'])),
                        ('session_creation_failed_events', (YLeaf(YType.uint32, 'session-creation-failed-events'), ['int'])),
                        ('session_down_events', (YLeaf(YType.uint32, 'session-down-events'), ['int'])),
                        ('session_admin_down_events', (YLeaf(YType.uint32, 'session-admin-down-events'), ['int'])),
                        ('session_gracefully_delete_events', (YLeaf(YType.uint32, 'session-gracefully-delete-events'), ['int'])),
                        ('session_non_gracefully_delete_events', (YLeaf(YType.uint32, 'session-non-gracefully-delete-events'), ['int'])),
                        ('session_replay_events', (YLeaf(YType.uint32, 'session-replay-events'), ['int'])),
                    ])
                    self.session_create_events = None
                    self.session_up_events = None
                    self.session_creation_failed_events = None
                    self.session_down_events = None
                    self.session_admin_down_events = None
                    self.session_gracefully_delete_events = None
                    self.session_non_gracefully_delete_events = None
                    self.session_replay_events = None
                    self._segment_path = lambda: "bf-do-lm-counters"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Bfd.Counters.BfDoLmCounters, ['session_create_events', 'session_up_events', 'session_creation_failed_events', 'session_down_events', 'session_admin_down_events', 'session_gracefully_delete_events', 'session_non_gracefully_delete_events', 'session_replay_events'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Bfd.Counters.BfDoLmCounters']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Bfd.Counters']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.Bfd']['meta_info']


    class Nsr(_Entity_):
        """
        MPLS TE NSR information
        
        .. attribute:: status
        
        	MPLS TE NSR Status information
        	**type**\:  :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status>`
        
        	**config**\: False
        
        .. attribute:: detail
        
        	MPLS TE NSR Status information
        	**type**\:  :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.Nsr, self).__init__()

            self.yang_name = "nsr"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("status", ("status", MplsTeStandby.Nsr.Status)), ("detail", ("detail", MplsTeStandby.Nsr.Detail))])
            self._leafs = OrderedDict()

            self.status = MplsTeStandby.Nsr.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"

            self.detail = MplsTeStandby.Nsr.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._segment_path = lambda: "nsr"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.Nsr, [], name, value)


        class Status(_Entity_):
            """
            MPLS TE NSR Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Nsr.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "nsr"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTeStandby.Nsr.Status.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTeStandby.Nsr.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "status"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Nsr.Status, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Nsr.Status.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Nsr.Status']['meta_info']


        class Detail(_Entity_):
            """
            MPLS TE NSR Status information
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:  :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation>`
            
            	**config**\: False
            
            .. attribute:: role
            
            	Process role
            	**type**\:  :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.Nsr.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "nsr"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sync-status-information", ("sync_status_information", MplsTeStandby.Nsr.Detail.SyncStatusInformation))])
                self._leafs = OrderedDict([
                    ('role', (YLeaf(YType.enumeration, 'role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeProcRole', '')])),
                ])
                self.role = None

                self.sync_status_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._segment_path = lambda: "detail"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.Nsr.Detail, ['role'], name, value)


            class SyncStatusInformation(_Entity_):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:  :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:  :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                	**config**\: False
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:  :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("slave-sync-information", ("slave_sync_information", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation)), ("master-sync-information", ("master_sync_information", MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation))])
                    self._leafs = OrderedDict([
                        ('sync_show_type', (YLeaf(YType.enumeration, 'sync-show-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncStatusShow', '')])),
                    ])
                    self.sync_show_type = None

                    self.slave_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"

                    self.master_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._segment_path = lambda: "sync-status-information"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation, ['sync_show_type'], name, value)


                class SlaveSyncInformation(_Entity_):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of  		 :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    	**config**\: False
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of  		 :py:class:`S2lPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt)), ("vif-pending", ("vif_pending", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending)), ("s2l-pending", ("s2l_pending", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending))])
                        self._leafs = OrderedDict([
                            ('insync_tunnels', (YLeaf(YType.uint32, 'insync-tunnels'), ['int'])),
                            ('insync_sub_ls_ps', (YLeaf(YType.uint32, 'insync-sub-ls-ps'), ['int'])),
                            ('pending_tunnels', (YLeaf(YType.uint32, 'pending-tunnels'), ['int'])),
                            ('pending_sub_ls_ps', (YLeaf(YType.uint32, 'pending-sub-ls-ps'), ['int'])),
                        ])
                        self.insync_tunnels = None
                        self.insync_sub_ls_ps = None
                        self.pending_tunnels = None
                        self.pending_sub_ls_ps = None

                        self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"

                        self.vif_pending = YList(self)
                        self.s2l_pending = YList(self)
                        self._segment_path = lambda: "slave-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, ['insync_tunnels', 'insync_sub_ls_ps', 'pending_tunnels', 'pending_sub_ls_ps'], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt']['meta_info']


                    class VifPending(_Entity_):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('tunnel_name', (YLeaf(YType.str, 'tunnel-name'), ['str'])),
                            ])
                            self.pending_reason = None
                            self.tunnel_name = None
                            self._segment_path = lambda: "vif-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, ['pending_reason', 'tunnel_name'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending']['meta_info']


                    class S2lPending(_Entity_):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:  :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        	**config**\: False
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\: str
                        
                        	**config**\: False
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:  :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('pending_reason', (YLeaf(YType.enumeration, 'pending-reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncPendingReason', '')])),
                                ('signaled_name', (YLeaf(YType.str, 'signaled-name'), ['str'])),
                                ('s2l_role', (YLeaf(YType.enumeration, 's2l-role'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeTunnelRole', '')])),
                            ])
                            self.pending_reason = None
                            self.signaled_name = None
                            self.s2l_role = None
                            self._segment_path = lambda: "s2l-pending"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending, ['pending_reason', 'signaled_name', 's2l_role'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2lPending']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation']['meta_info']


                class MasterSyncInformation(_Entity_):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:  :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("idt", ("idt", MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt))])
                        self._leafs = OrderedDict()

                        self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._segment_path = lambda: "master-sync-information"
                        self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/%s" % self._segment_path()
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, [], name, value)


                    class Idt(_Entity_):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:  :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:  :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("current-idt-info", ("current_idt_info", MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo)), ("previous-idt-status", ("previous_idt_status", MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus))])
                            self._leafs = OrderedDict()

                            self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"

                            self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._segment_path = lambda: "idt"
                            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/%s" % self._segment_path()
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, [], name, value)


                        class CurrentIdtInfo(_Entity_):
                            """
                            Current IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "current-idt-info"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo']['meta_info']


                        class PreviousIdtStatus(_Entity_):
                            """
                            Previous IDT information
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\: bool
                            
                            	**config**\: False
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:  :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            	**config**\: False
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\: int
                            
                            	**range:** 0..4294967295
                            
                            	**config**\: False
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"
                                self.is_top_level_class = False
                                self.has_list_ancestor = False
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([])
                                self._leafs = OrderedDict([
                                    ('is_ready_status', (YLeaf(YType.boolean, 'is-ready-status'), ['bool'])),
                                    ('reason', (YLeaf(YType.enumeration, 'reason'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeSyncNotReadyReason', '')])),
                                    ('idt_start_time', (YLeaf(YType.uint32, 'idt-start-time'), ['int'])),
                                    ('idt_end_time', (YLeaf(YType.uint32, 'idt-end-time'), ['int'])),
                                    ('declare_time', (YLeaf(YType.uint32, 'declare-time'), ['int'])),
                                    ('withdraw_time', (YLeaf(YType.uint32, 'withdraw-time'), ['int'])),
                                ])
                                self.is_ready_status = None
                                self.reason = None
                                self.idt_start_time = None
                                self.idt_end_time = None
                                self.declare_time = None
                                self.withdraw_time = None
                                self._segment_path = lambda: "previous-idt-status"
                                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self._segment_path()
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, ['is_ready_status', 'reason', 'idt_start_time', 'idt_end_time', 'declare_time', 'withdraw_time'], name, value)

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.Nsr.Detail.SyncStatusInformation']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.Nsr.Detail']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.Nsr']['meta_info']


    class AutoTunnelServices(_Entity_):
        """
        MPLS TE Auto Tunnel Services
        
        .. attribute:: sr_policy_entries
        
        	MPLS TE SR Policy Context table 
        	**type**\:  :py:class:`SrPolicyEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AutoTunnelServices, self).__init__()

            self.yang_name = "auto-tunnel-services"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("sr-policy-entries", ("sr_policy_entries", MplsTeStandby.AutoTunnelServices.SrPolicyEntries))])
            self._leafs = OrderedDict()

            self.sr_policy_entries = MplsTeStandby.AutoTunnelServices.SrPolicyEntries()
            self.sr_policy_entries.parent = self
            self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
            self._segment_path = lambda: "auto-tunnel-services"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AutoTunnelServices, [], name, value)


        class SrPolicyEntries(_Entity_):
            """
            MPLS TE SR Policy Context table 
            
            .. attribute:: sr_policy_entry
            
            	MPLS TE SR Policy information
            	**type**\: list of  		 :py:class:`SrPolicyEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries, self).__init__()

                self.yang_name = "sr-policy-entries"
                self.yang_parent_name = "auto-tunnel-services"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("sr-policy-entry", ("sr_policy_entry", MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry))])
                self._leafs = OrderedDict()

                self.sr_policy_entry = YList(self)
                self._segment_path = lambda: "sr-policy-entries"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel-services/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries, [], name, value)


            class SrPolicyEntry(_Entity_):
                """
                MPLS TE SR Policy information
                
                .. attribute:: client_id  (key)
                
                	Client ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: color  (key)
                
                	Color
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_point  (key)
                
                	End Point
                	**type**\: union of the below types:
                
                		**type**\: str
                
                			**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                		**type**\: str
                
                			**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: distinguisher  (key)
                
                	SR Policy Distinguisher Value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: end_point_xr
                
                	End Point
                	**type**\:  :py:class:`EndPointXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr>`
                
                	**config**\: False
                
                .. attribute:: sr_policy_id
                
                	SR Policy ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: policy_active
                
                	Policy Active
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: client_id_xr
                
                	Client ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: client_name
                
                	Client Name
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: color_xr
                
                	Color
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: distinguisher_xr
                
                	SR Policy Distinguisher value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: ipv6_caps
                
                	IPv6 Capsulation
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: binding_sid_context_id
                
                	Binding SID Context ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: requested_binding_sid
                
                	Requested Binding SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: binding_sid_request_pending
                
                	Binding SID Request Pending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: allocated_binding_sid
                
                	Allocated Binding SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: rewrite_request_pending
                
                	Rewrite Requeste Pending
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: rewrite_done
                
                	Rewrite Done
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_stale
                
                	Is Stale
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: is_synced
                
                	Is Synced
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: notify_time
                
                	Notify Time
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: notify_state_is_active
                
                	Notify State Is Active
                	**type**\: bool
                
                	**config**\: False
                
                .. attribute:: creation_time
                
                	SR policy structure creation timestamp (clocktime in nsecs)
                	**type**\: int
                
                	**range:** 0..18446744073709551615
                
                	**config**\: False
                
                	**units**\: nanosecond
                
                .. attribute:: explicit_path
                
                	Explicit Paths
                	**type**\: list of  		 :py:class:`ExplicitPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__init__()

                    self.yang_name = "sr-policy-entry"
                    self.yang_parent_name = "sr-policy-entries"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = ['client_id','color','end_point','distinguisher']
                    self._child_classes = OrderedDict([("end-point-xr", ("end_point_xr", MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr)), ("explicit-path", ("explicit_path", MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath))])
                    self._leafs = OrderedDict([
                        ('client_id', (YLeaf(YType.uint32, 'client-id'), ['int'])),
                        ('color', (YLeaf(YType.uint32, 'color'), ['int'])),
                        ('end_point', (YLeaf(YType.str, 'end-point'), ['str','str'])),
                        ('distinguisher', (YLeaf(YType.uint32, 'distinguisher'), ['int'])),
                        ('sr_policy_id', (YLeaf(YType.uint32, 'sr-policy-id'), ['int'])),
                        ('policy_active', (YLeaf(YType.boolean, 'policy-active'), ['bool'])),
                        ('client_id_xr', (YLeaf(YType.uint32, 'client-id-xr'), ['int'])),
                        ('client_name', (YLeaf(YType.str, 'client-name'), ['str'])),
                        ('color_xr', (YLeaf(YType.uint32, 'color-xr'), ['int'])),
                        ('distinguisher_xr', (YLeaf(YType.uint32, 'distinguisher-xr'), ['int'])),
                        ('ipv6_caps', (YLeaf(YType.boolean, 'ipv6-caps'), ['bool'])),
                        ('binding_sid_context_id', (YLeaf(YType.uint32, 'binding-sid-context-id'), ['int'])),
                        ('requested_binding_sid', (YLeaf(YType.uint32, 'requested-binding-sid'), ['int'])),
                        ('binding_sid_request_pending', (YLeaf(YType.boolean, 'binding-sid-request-pending'), ['bool'])),
                        ('allocated_binding_sid', (YLeaf(YType.uint32, 'allocated-binding-sid'), ['int'])),
                        ('rewrite_request_pending', (YLeaf(YType.boolean, 'rewrite-request-pending'), ['bool'])),
                        ('rewrite_done', (YLeaf(YType.boolean, 'rewrite-done'), ['bool'])),
                        ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                        ('is_synced', (YLeaf(YType.boolean, 'is-synced'), ['bool'])),
                        ('notify_time', (YLeaf(YType.uint32, 'notify-time'), ['int'])),
                        ('notify_state_is_active', (YLeaf(YType.boolean, 'notify-state-is-active'), ['bool'])),
                        ('creation_time', (YLeaf(YType.uint64, 'creation-time'), ['int'])),
                    ])
                    self.client_id = None
                    self.color = None
                    self.end_point = None
                    self.distinguisher = None
                    self.sr_policy_id = None
                    self.policy_active = None
                    self.client_id_xr = None
                    self.client_name = None
                    self.color_xr = None
                    self.distinguisher_xr = None
                    self.ipv6_caps = None
                    self.binding_sid_context_id = None
                    self.requested_binding_sid = None
                    self.binding_sid_request_pending = None
                    self.allocated_binding_sid = None
                    self.rewrite_request_pending = None
                    self.rewrite_done = None
                    self.is_stale = None
                    self.is_synced = None
                    self.notify_time = None
                    self.notify_state_is_active = None
                    self.creation_time = None

                    self.end_point_xr = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                    self.end_point_xr.parent = self
                    self._children_name_map["end_point_xr"] = "end-point-xr"

                    self.explicit_path = YList(self)
                    self._segment_path = lambda: "sr-policy-entry" + "[client-id='" + str(self.client_id) + "']" + "[color='" + str(self.color) + "']" + "[end-point='" + str(self.end_point) + "']" + "[distinguisher='" + str(self.distinguisher) + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel-services/sr-policy-entries/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, ['client_id', 'color', 'end_point', 'distinguisher', 'sr_policy_id', 'policy_active', 'client_id_xr', 'client_name', 'color_xr', 'distinguisher_xr', 'ipv6_caps', 'binding_sid_context_id', 'requested_binding_sid', 'binding_sid_request_pending', 'allocated_binding_sid', 'rewrite_request_pending', 'rewrite_done', 'is_stale', 'is_synced', 'notify_time', 'notify_state_is_active', 'creation_time'], name, value)


                class EndPointXr(_Entity_):
                    """
                    End Point
                    
                    .. attribute:: address_family_type
                    
                    	AddressFamilyType
                    	**type**\:  :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    	**config**\: False
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: ipv6_address
                    
                    	IPv6 Address
                    	**type**\: str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__init__()

                        self.yang_name = "end-point-xr"
                        self.yang_parent_name = "sr-policy-entry"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('address_family_type', (YLeaf(YType.enumeration, 'address-family-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeAfi', '')])),
                            ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                            ('ipv6_address', (YLeaf(YType.str, 'ipv6-address'), ['str'])),
                        ])
                        self.address_family_type = None
                        self.ipv4_address = None
                        self.ipv6_address = None
                        self._segment_path = lambda: "end-point-xr"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, ['address_family_type', 'ipv4_address', 'ipv6_address'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr']['meta_info']


                class ExplicitPath(_Entity_):
                    """
                    Explicit Paths
                    
                    .. attribute:: tunnel_info
                    
                    	Auto tunnel info
                    	**type**\:  :py:class:`TunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo>`
                    
                    	**config**\: False
                    
                    .. attribute:: context_id
                    
                    	Explicit Path Context ID
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: path_weight
                    
                    	Path Weight
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: is_stale
                    
                    	Is Stale
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: is_synced
                    
                    	Is Synced
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: programmed_in_fib
                    
                    	Programmed in FIB
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: hops
                    
                    	Path Hops
                    	**type**\: list of  		 :py:class:`Hops <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__init__()

                        self.yang_name = "explicit-path"
                        self.yang_parent_name = "sr-policy-entry"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("tunnel-info", ("tunnel_info", MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo)), ("hops", ("hops", MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops))])
                        self._leafs = OrderedDict([
                            ('context_id', (YLeaf(YType.uint32, 'context-id'), ['int'])),
                            ('path_weight', (YLeaf(YType.uint32, 'path-weight'), ['int'])),
                            ('is_stale', (YLeaf(YType.boolean, 'is-stale'), ['bool'])),
                            ('is_synced', (YLeaf(YType.boolean, 'is-synced'), ['bool'])),
                            ('programmed_in_fib', (YLeaf(YType.boolean, 'programmed-in-fib'), ['bool'])),
                        ])
                        self.context_id = None
                        self.path_weight = None
                        self.is_stale = None
                        self.is_synced = None
                        self.programmed_in_fib = None

                        self.tunnel_info = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                        self.tunnel_info.parent = self
                        self._children_name_map["tunnel_info"] = "tunnel-info"

                        self.hops = YList(self)
                        self._segment_path = lambda: "explicit-path"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, ['context_id', 'path_weight', 'is_stale', 'is_synced', 'programmed_in_fib'], name, value)


                    class TunnelInfo(_Entity_):
                        """
                        Auto tunnel info
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: tunnel_up
                        
                        	Tunnel Up
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: ipv6_caps
                        
                        	IPv6 Capsulation
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__init__()

                            self.yang_name = "tunnel-info"
                            self.yang_parent_name = "explicit-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('tunnel_id', (YLeaf(YType.uint32, 'tunnel-id'), ['int'])),
                                ('tunnel_up', (YLeaf(YType.boolean, 'tunnel-up'), ['bool'])),
                                ('ipv6_caps', (YLeaf(YType.boolean, 'ipv6-caps'), ['bool'])),
                            ])
                            self.tunnel_id = None
                            self.tunnel_up = None
                            self.ipv6_caps = None
                            self._segment_path = lambda: "tunnel-info"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, ['tunnel_id', 'tunnel_up', 'ipv6_caps'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo']['meta_info']


                    class Hops(_Entity_):
                        """
                        Path Hops
                        
                        .. attribute:: hop_type
                        
                        	Hop Type
                        	**type**\:  :py:class:`TeAutoTunExpPathHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutoTunExpPathHop>`
                        
                        	**config**\: False
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 Address
                        	**type**\: str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        	**config**\: False
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__init__()

                            self.yang_name = "hops"
                            self.yang_parent_name = "explicit-path"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('hop_type', (YLeaf(YType.enumeration, 'hop-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAutoTunExpPathHop', '')])),
                                ('ipv4_address', (YLeaf(YType.str, 'ipv4-address'), ['str'])),
                                ('mpls_label', (YLeaf(YType.uint32, 'mpls-label'), ['int'])),
                            ])
                            self.hop_type = None
                            self.ipv4_address = None
                            self.mpls_label = None
                            self._segment_path = lambda: "hops"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, ['hop_type', 'ipv4_address', 'mpls_label'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AutoTunnelServices.SrPolicyEntries']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AutoTunnelServices']['meta_info']


    class AffinityMap(_Entity_):
        """
        Affinity name to value mapping
        
        .. attribute:: affinity_map_array
        
        	Affinity map array
        	**type**\: list of  		 :py:class:`AffinityMapArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap.AffinityMapArray>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.AffinityMap, self).__init__()

            self.yang_name = "affinity-map"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("affinity-map-array", ("affinity_map_array", MplsTeStandby.AffinityMap.AffinityMapArray))])
            self._leafs = OrderedDict()

            self.affinity_map_array = YList(self)
            self._segment_path = lambda: "affinity-map"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.AffinityMap, [], name, value)


        class AffinityMapArray(_Entity_):
            """
            Affinity map array
            
            .. attribute:: affinity_name
            
            	Affinity name
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: affinity_value
            
            	Affinity value
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: affinity_bit_position
            
            	Affinity bit position
            	**type**\: int
            
            	**range:** 0..255
            
            	**config**\: False
            
            .. attribute:: affinity_table_id
            
            	Affinity table id
            	**type**\:  :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
            
            	**config**\: False
            
            .. attribute:: affinity_extended_value
            
            	EAG value
            	**type**\: list of  		 :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.AffinityMap.AffinityMapArray, self).__init__()

                self.yang_name = "affinity-map-array"
                self.yang_parent_name = "affinity-map"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = []
                self._child_classes = OrderedDict([("affinity-extended-value", ("affinity_extended_value", MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue))])
                self._leafs = OrderedDict([
                    ('affinity_name', (YLeaf(YType.str, 'affinity-name'), ['str'])),
                    ('affinity_value', (YLeaf(YType.uint32, 'affinity-value'), ['int'])),
                    ('affinity_bit_position', (YLeaf(YType.uint8, 'affinity-bit-position'), ['int'])),
                    ('affinity_table_id', (YLeaf(YType.enumeration, 'affinity-table-id'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeAffinityTable', '')])),
                ])
                self.affinity_name = None
                self.affinity_value = None
                self.affinity_bit_position = None
                self.affinity_table_id = None

                self.affinity_extended_value = YList(self)
                self._segment_path = lambda: "affinity-map-array"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/affinity-map/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.AffinityMap.AffinityMapArray, ['affinity_name', 'affinity_value', 'affinity_bit_position', 'affinity_table_id'], name, value)


            class AffinityExtendedValue(_Entity_):
                """
                EAG value
                
                .. attribute:: entry
                
                	EAG value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__init__()

                    self.yang_name = "affinity-extended-value"
                    self.yang_parent_name = "affinity-map-array"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                    ])
                    self.entry = None
                    self._segment_path = lambda: "affinity-extended-value"
                    self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/affinity-map/affinity-map-array/%s" % self._segment_path()
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue, ['entry'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.AffinityMap.AffinityMapArray']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.AffinityMap']['meta_info']


    class TopologyBriefs(_Entity_):
        """
        MPLS\-TE topology brief table
        
        .. attribute:: topology_brief
        
        	A node in MPLS\-TE topoogy brief table
        	**type**\: list of  		 :py:class:`TopologyBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief>`
        
        	**config**\: False
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2018-08-01'

        def __init__(self):
            if sys.version_info > (3,):
                super().__init__()
            else:
                super(MplsTeStandby.TopologyBriefs, self).__init__()

            self.yang_name = "topology-briefs"
            self.yang_parent_name = "mpls-te-standby"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self.ylist_key_names = []
            self._child_classes = OrderedDict([("topology-brief", ("topology_brief", MplsTeStandby.TopologyBriefs.TopologyBrief))])
            self._leafs = OrderedDict()

            self.topology_brief = YList(self)
            self._segment_path = lambda: "topology-briefs"
            self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self._segment_path()
            self._is_frozen = True

        def __setattr__(self, name, value):
            self._perform_setattr(MplsTeStandby.TopologyBriefs, [], name, value)


        class TopologyBrief(_Entity_):
            """
            A node in MPLS\-TE topoogy brief table
            
            .. attribute:: protocol  (key)
            
            	IGP protocol type
            	**type**\:  :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            	**config**\: False
            
            .. attribute:: igp_id  (key)
            
            	IGP instance
            	**type**\: str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            	**config**\: False
            
            .. attribute:: area  (key)
            
            	IGP area
            	**type**\: int
            
            	**range:** 0..4294967295
            
            	**config**\: False
            
            .. attribute:: topology_node_type  (key)
            
            	Node type
            	**type**\:  :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            	**config**\: False
            
            .. attribute:: igp_node_id  (key)
            
            	IGP Node ID
            	**type**\: str
            
            	**config**\: False
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:  :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg>`
            
            	**config**\: False
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\: str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            	**config**\: False
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\: bool
            
            	**config**\: False
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of  		 :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink>`
            
            	**config**\: False
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2018-08-01'

            def __init__(self):
                if sys.version_info > (3,):
                    super().__init__()
                else:
                    super(MplsTeStandby.TopologyBriefs.TopologyBrief, self).__init__()

                self.yang_name = "topology-brief"
                self.yang_parent_name = "topology-briefs"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self.ylist_key_names = ['protocol','igp_id','area','topology_node_type','igp_node_id']
                self._child_classes = OrderedDict([("topology-node-sid-and-srbg", ("topology_node_sid_and_srbg", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg)), ("topology-node-link", ("topology_node_link", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink))])
                self._leafs = OrderedDict([
                    ('protocol', (YLeaf(YType.enumeration, 'protocol'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeIgpProtocol', '')])),
                    ('igp_id', (YLeaf(YType.str, 'igp-id'), ['str'])),
                    ('area', (YLeaf(YType.uint32, 'area'), ['int'])),
                    ('topology_node_type', (YLeaf(YType.enumeration, 'topology-node-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'MplsTeNode', '')])),
                    ('igp_node_id', (YLeaf(YType.str, 'igp-node-id'), ['str'])),
                    ('topology_node_te_router_id', (YLeaf(YType.str, 'topology-node-te-router-id'), ['str'])),
                    ('topology_node_overloaded', (YLeaf(YType.boolean, 'topology-node-overloaded'), ['bool'])),
                ])
                self.protocol = None
                self.igp_id = None
                self.area = None
                self.topology_node_type = None
                self.igp_node_id = None
                self.topology_node_te_router_id = None
                self.topology_node_overloaded = None

                self.topology_node_sid_and_srbg = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"

                self.topology_node_link = YList(self)
                self._segment_path = lambda: "topology-brief" + "[protocol='" + str(self.protocol) + "']" + "[igp-id='" + str(self.igp_id) + "']" + "[area='" + str(self.area) + "']" + "[topology-node-type='" + str(self.topology_node_type) + "']" + "[igp-node-id='" + str(self.igp_node_id) + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology-briefs/%s" % self._segment_path()
                self._is_frozen = True

            def __setattr__(self, name, value):
                self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief, ['protocol', 'igp_id', 'area', 'topology_node_type', 'igp_node_id', 'topology_node_te_router_id', 'topology_node_overloaded'], name, value)


            class TopologyNodeSidAndSrbg(_Entity_):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([])
                    self._leafs = OrderedDict([
                        ('segment_id', (YLeaf(YType.uint32, 'segment-id'), ['int'])),
                        ('segment_id_local_absolute_value', (YLeaf(YType.uint32, 'segment-id-local-absolute-value'), ['int'])),
                        ('srgb_start', (YLeaf(YType.uint32, 'srgb-start'), ['int'])),
                        ('srgb_size', (YLeaf(YType.uint32, 'srgb-size'), ['int'])),
                    ])
                    self.segment_id = None
                    self.segment_id_local_absolute_value = None
                    self.srgb_start = None
                    self.srgb_size = None
                    self._segment_path = lambda: "topology-node-sid-and-srbg"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, ['segment_id', 'segment_id_local_absolute_value', 'srgb_start', 'srgb_size'], name, value)

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg']['meta_info']


            class TopologyNodeLink(_Entity_):
                """
                This node's link information
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:  :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth>`
                
                	**config**\: False
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:  :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities>`
                
                	**config**\: False
                
                .. attribute:: min_max_delay
                
                	Minimum and maximum measured link delay
                	**type**\:  :py:class:`MinMaxDelay <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay>`
                
                	**config**\: False
                
                .. attribute:: loss
                
                	Link Loss
                	**type**\:  :py:class:`Loss <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss>`
                
                	**config**\: False
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\: str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\: str
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\: int
                
                	**range:** 0..255
                
                	**config**\: False
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:  :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                	**config**\: False
                
                .. attribute:: delay_variation
                
                	Delay Variation
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: residual_bandwidth
                
                	Residual Bandwidth (kbytes per seconds)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                .. attribute:: available_bandwidth
                
                	Available Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: utilized_bandwidth
                
                	Utilized Bandwidth (kbytes per second)
                	**type**\: int
                
                	**range:** 0..4294967295
                
                	**config**\: False
                
                	**units**\: byte/s
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of  		 :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                	**config**\: False
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of  		 :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup>`
                
                	**config**\: False
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of  		 :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid>`
                
                	**config**\: False
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2018-08-01'

                def __init__(self):
                    if sys.version_info > (3,):
                        super().__init__()
                    else:
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-brief"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self.ylist_key_names = []
                    self._child_classes = OrderedDict([("topology-link-bandwidth", ("topology_link_bandwidth", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth)), ("odu-link-capabilities", ("odu_link_capabilities", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities)), ("min-max-delay", ("min_max_delay", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay)), ("loss", ("loss", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss)), ("topology-link-extended-affinity-bit", ("topology_link_extended_affinity_bit", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit)), ("shared-risk-link-group", ("shared_risk_link_group", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup)), ("adjacency-sid", ("adjacency_sid", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid))])
                    self._leafs = OrderedDict([
                        ('topology_link_type', (YLeaf(YType.enumeration, 'topology-link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                        ('topology_link_interface_address', (YLeaf(YType.str, 'topology-link-interface-address'), ['str'])),
                        ('topology_link_interface_id', (YLeaf(YType.uint32, 'topology-link-interface-id'), ['int'])),
                        ('topology_link_neighbor_address', (YLeaf(YType.str, 'topology-link-neighbor-address'), ['str'])),
                        ('topology_link_neighbor_id', (YLeaf(YType.uint32, 'topology-link-neighbor-id'), ['int'])),
                        ('topology_link_neighbor_system_id', (YLeaf(YType.str, 'topology-link-neighbor-system-id'), ['str'])),
                        ('topology_link_neighbor_node_id', (YLeaf(YType.uint32, 'topology-link-neighbor-node-id'), ['int'])),
                        ('topology_link_neighbor_generation', (YLeaf(YType.uint32, 'topology-link-neighbor-generation'), ['int'])),
                        ('topology_link_fragment_id', (YLeaf(YType.uint32, 'topology-link-fragment-id'), ['int'])),
                        ('topology_link_te_metric', (YLeaf(YType.uint32, 'topology-link-te-metric'), ['int'])),
                        ('topology_link_igp_metric', (YLeaf(YType.uint32, 'topology-link-igp-metric'), ['int'])),
                        ('topology_link_uni_delay', (YLeaf(YType.uint32, 'topology-link-uni-delay'), ['int'])),
                        ('topology_link_affinity_bits', (YLeaf(YType.uint32, 'topology-link-affinity-bits'), ['int'])),
                        ('topology_link_switching_capability', (YLeaf(YType.uint8, 'topology-link-switching-capability'), ['int'])),
                        ('topology_link_encoding', (YLeaf(YType.uint8, 'topology-link-encoding'), ['int'])),
                        ('topology_link_bandwidth_model', (YLeaf(YType.enumeration, 'topology-link-bandwidth-model'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpteLibBwModel', '')])),
                        ('delay_variation', (YLeaf(YType.uint32, 'delay-variation'), ['int'])),
                        ('residual_bandwidth', (YLeaf(YType.uint32, 'residual-bandwidth'), ['int'])),
                        ('available_bandwidth', (YLeaf(YType.uint32, 'available-bandwidth'), ['int'])),
                        ('utilized_bandwidth', (YLeaf(YType.uint32, 'utilized-bandwidth'), ['int'])),
                    ])
                    self.topology_link_type = None
                    self.topology_link_interface_address = None
                    self.topology_link_interface_id = None
                    self.topology_link_neighbor_address = None
                    self.topology_link_neighbor_id = None
                    self.topology_link_neighbor_system_id = None
                    self.topology_link_neighbor_node_id = None
                    self.topology_link_neighbor_generation = None
                    self.topology_link_fragment_id = None
                    self.topology_link_te_metric = None
                    self.topology_link_igp_metric = None
                    self.topology_link_uni_delay = None
                    self.topology_link_affinity_bits = None
                    self.topology_link_switching_capability = None
                    self.topology_link_encoding = None
                    self.topology_link_bandwidth_model = None
                    self.delay_variation = None
                    self.residual_bandwidth = None
                    self.available_bandwidth = None
                    self.utilized_bandwidth = None

                    self.topology_link_bandwidth = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"

                    self.odu_link_capabilities = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"

                    self.min_max_delay = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay()
                    self.min_max_delay.parent = self
                    self._children_name_map["min_max_delay"] = "min-max-delay"

                    self.loss = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss()
                    self.loss.parent = self
                    self._children_name_map["loss"] = "loss"

                    self.topology_link_extended_affinity_bit = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.adjacency_sid = YList(self)
                    self._segment_path = lambda: "topology-node-link"
                    self._is_frozen = True

                def __setattr__(self, name, value):
                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink, ['topology_link_type', 'topology_link_interface_address', 'topology_link_interface_id', 'topology_link_neighbor_address', 'topology_link_neighbor_id', 'topology_link_neighbor_system_id', 'topology_link_neighbor_node_id', 'topology_link_neighbor_generation', 'topology_link_fragment_id', 'topology_link_te_metric', 'topology_link_igp_metric', 'topology_link_uni_delay', 'topology_link_affinity_bits', 'topology_link_switching_capability', 'topology_link_encoding', 'topology_link_bandwidth_model', 'delay_variation', 'residual_bandwidth', 'available_bandwidth', 'utilized_bandwidth'], name, value)


                class TopologyLinkBandwidth(_Entity_):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:  :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    	**config**\: False
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:  :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("topology-link-bandwidth-prestandard", ("topology_link_bandwidth_prestandard", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard)), ("topology-link-bandwidth-standard", ("topology_link_bandwidth_standard", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard))])
                        self._leafs = OrderedDict([
                            ('bandwidth_migration_mode', (YLeaf(YType.enumeration, 'bandwidth-migration-mode'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'RrrDsteMigrationMode', '')])),
                        ])
                        self.bandwidth_migration_mode = None

                        self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"

                        self.topology_link_bandwidth_standard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._segment_path = lambda: "topology-link-bandwidth"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, ['bandwidth_migration_mode'], name, value)


                    class TopologyLinkBandwidthPrestandard(_Entity_):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-detail", ("topology_link_prestandard_bandwidth_detail", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail))])
                            self._leafs = OrderedDict([
                                ('topology_link_prestandard_bandwidth_physical', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-physical'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_global', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-global'), ['int'])),
                                ('topology_link_prestandard_bandwidth_reservation_subpool', (YLeaf(YType.uint32, 'topology-link-prestandard-bandwidth-reservation-subpool'), ['int'])),
                            ])
                            self.topology_link_prestandard_bandwidth_physical = None
                            self.topology_link_prestandard_bandwidth_reservation_global = None
                            self.topology_link_prestandard_bandwidth_reservation_subpool = None

                            self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-prestandard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, ['topology_link_prestandard_bandwidth_physical', 'topology_link_prestandard_bandwidth_reservation_global', 'topology_link_prestandard_bandwidth_reservation_subpool'], name, value)


                        class TopologyLinkPrestandardBandwidthDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            	**config**\: False
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of  		 :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topology-link-prestandard-bandwidth-allocated", ("topology_link_prestandard_bandwidth_allocated", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated)), ("topology-link-prestandard-bandwidth-available-global", ("topology_link_prestandard_bandwidth_available_global", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal)), ("topology-link-prestandard-bandwidth-available-subpool", ("topology_link_prestandard_bandwidth_available_subpool", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool))])
                                self._leafs = OrderedDict()

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)
                                self._segment_path = lambda: "topology-link-prestandard-bandwidth-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, [], name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(_Entity_):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(_Entity_):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-global"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal']['meta_info']


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(_Entity_):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topology-link-prestandard-bandwidth-available-subpool"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard']['meta_info']


                    class TopologyLinkBandwidthStandard(_Entity_):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:  :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("topo-link-std-bw-detail", ("topo_link_std_bw_detail", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail))])
                            self._leafs = OrderedDict([
                                ('topo_link_std_bw_physical', (YLeaf(YType.uint32, 'topo-link-std-bw-physical'), ['int'])),
                                ('topo_link_std_bw_res_max', (YLeaf(YType.uint32, 'topo-link-std-bw-res-max'), ['int'])),
                                ('topo_link_std_bw_res_pool0', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool0'), ['int'])),
                                ('topo_link_std_bw_res_pool1', (YLeaf(YType.uint32, 'topo-link-std-bw-res-pool1'), ['int'])),
                            ])
                            self.topo_link_std_bw_physical = None
                            self.topo_link_std_bw_res_max = None
                            self.topo_link_std_bw_res_pool0 = None
                            self.topo_link_std_bw_res_pool1 = None

                            self.topo_link_std_bw_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._segment_path = lambda: "topology-link-bandwidth-standard"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, ['topo_link_std_bw_physical', 'topo_link_std_bw_res_max', 'topo_link_std_bw_res_pool0', 'topo_link_std_bw_res_pool1'], name, value)


                        class TopoLinkStdBwDetail(_Entity_):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            	**config**\: False
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of  		 :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("topo-link-std-bw-allocated", ("topo_link_std_bw_allocated", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated)), ("topo-link-std-bw-available", ("topo_link_std_bw_available", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable))])
                                self._leafs = OrderedDict()

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)
                                self._segment_path = lambda: "topo-link-std-bw-detail"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, [], name, value)


                            class TopoLinkStdBwAllocated(_Entity_):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's allocated bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-allocated"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated']['meta_info']


                            class TopoLinkStdBwAvailable(_Entity_):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	Link's available bandwidth per class
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                                    ])
                                    self.entry = None
                                    self._segment_path = lambda: "topo-link-std-bw-available"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, ['entry'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth']['meta_info']


                class OduLinkCapabilities(_Entity_):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of  		 :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    	**config**\: False
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of  		 :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([("max-lsp-bandwidth", ("max_lsp_bandwidth", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth)), ("odu-capability", ("odu_capability", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability))])
                        self._leafs = OrderedDict()

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)
                        self._segment_path = lambda: "odu-link-capabilities"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, [], name, value)


                    class MaxLspBandwidth(_Entity_):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	Max LSP Bandwidth per priority in kbit/s
                        	**type**\: int
                        
                        	**range:** 0..4294967295
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([])
                            self._leafs = OrderedDict([
                                ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                            ])
                            self.entry = None
                            self._segment_path = lambda: "max-lsp-bandwidth"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, ['entry'], name, value)

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth']['meta_info']


                    class OduCapability(_Entity_):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:  :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        	**config**\: False
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:  :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        	**config**\: False
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\: bool
                        
                        	**config**\: False
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2018-08-01'

                        def __init__(self):
                            if sys.version_info > (3,):
                                super().__init__()
                            else:
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self.ylist_key_names = []
                            self._child_classes = OrderedDict([("bandwidth-info", ("bandwidth_info", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo))])
                            self._leafs = OrderedDict([
                                ('signal_type', (YLeaf(YType.enumeration, 'signal-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage1', (YLeaf(YType.enumeration, 'stage1'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage2', (YLeaf(YType.enumeration, 'stage2'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage3', (YLeaf(YType.enumeration, 'stage3'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('stage4', (YLeaf(YType.enumeration, 'stage4'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduLevel', '')])),
                                ('terminable', (YLeaf(YType.boolean, 'terminable'), ['bool'])),
                                ('switchable', (YLeaf(YType.boolean, 'switchable'), ['bool'])),
                                ('tsg1p25', (YLeaf(YType.boolean, 'tsg1p25'), ['bool'])),
                                ('tsg2p5', (YLeaf(YType.boolean, 'tsg2p5'), ['bool'])),
                                ('vcat_capable', (YLeaf(YType.boolean, 'vcat-capable'), ['bool'])),
                                ('lcas_capable', (YLeaf(YType.boolean, 'lcas-capable'), ['bool'])),
                            ])
                            self.signal_type = None
                            self.stage1 = None
                            self.stage2 = None
                            self.stage3 = None
                            self.stage4 = None
                            self.terminable = None
                            self.switchable = None
                            self.tsg1p25 = None
                            self.tsg2p5 = None
                            self.vcat_capable = None
                            self.lcas_capable = None

                            self.bandwidth_info = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._segment_path = lambda: "odu-capability"
                            self._is_frozen = True

                        def __setattr__(self, name, value):
                            self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, ['signal_type', 'stage1', 'stage2', 'stage3', 'stage4', 'terminable', 'switchable', 'tsg1p25', 'tsg2p5', 'vcat_capable', 'lcas_capable'], name, value)


                        class BandwidthInfo(_Entity_):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:  :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            	**config**\: False
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:  :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            	**config**\: False
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:  :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            	**config**\: False
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2018-08-01'

                            def __init__(self):
                                if sys.version_info > (3,):
                                    super().__init__()
                                else:
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self.ylist_key_names = []
                                self._child_classes = OrderedDict([("fixed", ("fixed", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed)), ("flex", ("flex", MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex))])
                                self._leafs = OrderedDict([
                                    ('type', (YLeaf(YType.enumeration, 'type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'TeOduCapability', '')])),
                                ])
                                self.type = None

                                self.fixed = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"

                                self.flex = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._segment_path = lambda: "bandwidth-info"
                                self._is_frozen = True

                            def __setattr__(self, name, value):
                                self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, ['type'], name, value)


                            class Fixed(_Entity_):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..255
                                
                                	**config**\: False
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('maximum_od_us', (YLeaf(YType.uint8, 'maximum-od-us'), ['int'])),
                                        ('unreserved_od_us', (YLeaf(YType.uint8, 'unreserved-od-us'), ['int'])),
                                    ])
                                    self.maximum_od_us = None
                                    self.unreserved_od_us = None
                                    self._segment_path = lambda: "fixed"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, ['maximum_od_us', 'unreserved_od_us'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed']['meta_info']


                            class Flex(_Entity_):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\: int
                                
                                	**range:** 0..4294967295
                                
                                	**config**\: False
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2018-08-01'

                                def __init__(self):
                                    if sys.version_info > (3,):
                                        super().__init__()
                                    else:
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self.ylist_key_names = []
                                    self._child_classes = OrderedDict([])
                                    self._leafs = OrderedDict([
                                        ('max_bandwidth', (YLeaf(YType.uint32, 'max-bandwidth'), ['int'])),
                                        ('unreserved_bandwidth', (YLeaf(YType.uint32, 'unreserved-bandwidth'), ['int'])),
                                        ('max_lsp_bandwidth', (YLeaf(YType.uint32, 'max-lsp-bandwidth'), ['int'])),
                                    ])
                                    self.max_bandwidth = None
                                    self.unreserved_bandwidth = None
                                    self.max_lsp_bandwidth = None
                                    self._segment_path = lambda: "flex"
                                    self._is_frozen = True

                                def __setattr__(self, name, value):
                                    self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, ['max_bandwidth', 'unreserved_bandwidth', 'max_lsp_bandwidth'], name, value)

                                @staticmethod
                                def _meta_info():
                                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex']['meta_info']

                            @staticmethod
                            def _meta_info():
                                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                                return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo']['meta_info']

                        @staticmethod
                        def _meta_info():
                            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                            return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability']['meta_info']

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities']['meta_info']


                class MinMaxDelay(_Entity_):
                    """
                    Minimum and maximum measured link delay
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: minimum_delay
                    
                    	Mimimum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: maximum_delay
                    
                    	Maximum measured link delay value in usec
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay, self).__init__()

                        self.yang_name = "min-max-delay"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('minimum_delay', (YLeaf(YType.uint32, 'minimum-delay'), ['int'])),
                            ('maximum_delay', (YLeaf(YType.uint32, 'maximum-delay'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.minimum_delay = None
                        self.maximum_delay = None
                        self._segment_path = lambda: "min-max-delay"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay, ['anomalous_bit', 'minimum_delay', 'maximum_delay'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.MinMaxDelay']['meta_info']


                class Loss(_Entity_):
                    """
                    Link Loss
                    
                    .. attribute:: anomalous_bit
                    
                    	Anomalous (A) Bit
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: loss_value
                    
                    	Loss Value
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss, self).__init__()

                        self.yang_name = "loss"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('anomalous_bit', (YLeaf(YType.boolean, 'anomalous-bit'), ['bool'])),
                            ('loss_value', (YLeaf(YType.uint32, 'loss-value'), ['int'])),
                        ])
                        self.anomalous_bit = None
                        self.loss_value = None
                        self._segment_path = lambda: "loss"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss, ['anomalous_bit', 'loss_value'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.Loss']['meta_info']


                class TopologyLinkExtendedAffinityBit(_Entity_):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	The link's affinity bits (colors)
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('entry', (YLeaf(YType.uint32, 'entry'), ['int'])),
                        ])
                        self.entry = None
                        self._segment_path = lambda: "topology-link-extended-affinity-bit"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, ['entry'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit']['meta_info']


                class SharedRiskLinkGroup(_Entity_):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\: str
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('shared_risk_group', (YLeaf(YType.uint32, 'shared-risk-group'), ['int'])),
                            ('srlg_name', (YLeaf(YType.str, 'srlg-name'), ['str'])),
                        ])
                        self.shared_risk_group = None
                        self.srlg_name = None
                        self._segment_path = lambda: "shared-risk-link-group"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, ['shared_risk_group', 'srlg_name'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup']['meta_info']


                class AdjacencySid(_Entity_):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\: int
                    
                    	**range:** 0..4294967295
                    
                    	**config**\: False
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:  :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    	**config**\: False
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\: str
                    
                    	**config**\: False
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\: str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    	**config**\: False
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\: bool
                    
                    	**config**\: False
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2018-08-01'

                    def __init__(self):
                        if sys.version_info > (3,):
                            super().__init__()
                        else:
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self.ylist_key_names = []
                        self._child_classes = OrderedDict([])
                        self._leafs = OrderedDict([
                            ('adjacency_sid', (YLeaf(YType.uint32, 'adjacency-sid'), ['int'])),
                            ('link_type', (YLeaf(YType.enumeration, 'link-type'), [('ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper', 'IgpSubnet', '')])),
                            ('local_addr', (YLeaf(YType.str, 'local-addr'), ['str'])),
                            ('remote_addr', (YLeaf(YType.str, 'remote-addr'), ['str'])),
                            ('nbr_node_igpid', (YLeaf(YType.str, 'nbr-node-igpid'), ['str'])),
                            ('nbr_node_te_router_id', (YLeaf(YType.str, 'nbr-node-te-router-id'), ['str'])),
                            ('flag_f', (YLeaf(YType.boolean, 'flag-f'), ['bool'])),
                            ('flag_b', (YLeaf(YType.boolean, 'flag-b'), ['bool'])),
                            ('flag_v', (YLeaf(YType.boolean, 'flag-v'), ['bool'])),
                            ('flag_l', (YLeaf(YType.boolean, 'flag-l'), ['bool'])),
                            ('flag_s', (YLeaf(YType.boolean, 'flag-s'), ['bool'])),
                        ])
                        self.adjacency_sid = None
                        self.link_type = None
                        self.local_addr = None
                        self.remote_addr = None
                        self.nbr_node_igpid = None
                        self.nbr_node_te_router_id = None
                        self.flag_f = None
                        self.flag_b = None
                        self.flag_v = None
                        self.flag_l = None
                        self.flag_s = None
                        self._segment_path = lambda: "adjacency-sid"
                        self._is_frozen = True

                    def __setattr__(self, name, value):
                        self._perform_setattr(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, ['adjacency_sid', 'link_type', 'local_addr', 'remote_addr', 'nbr_node_igpid', 'nbr_node_te_router_id', 'flag_f', 'flag_b', 'flag_v', 'flag_l', 'flag_s'], name, value)

                    @staticmethod
                    def _meta_info():
                        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                        return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid']['meta_info']

                @staticmethod
                def _meta_info():
                    from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                    return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink']['meta_info']

            @staticmethod
            def _meta_info():
                from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
                return meta._meta_table['MplsTeStandby.TopologyBriefs.TopologyBrief']['meta_info']

        @staticmethod
        def _meta_info():
            from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
            return meta._meta_table['MplsTeStandby.TopologyBriefs']['meta_info']

    def clone_ptr(self):
        self._top_entity = MplsTeStandby()
        return self._top_entity

    @staticmethod
    def _meta_info():
        from ydk.models.cisco_ios_xr._meta import _Cisco_IOS_XR_mpls_te_oper as meta
        return meta._meta_table['MplsTeStandby']['meta_info']


